"use strict";
/*!
 * Copyright 2015 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.ResourceStream=exports.paginator=exports.Paginator=void 0;
/*!
 * @module common/paginator
 */
const arrify=require("arrify"),extend=require("extend"),resource_stream_1=require("./resource-stream");Object.defineProperty(exports,"ResourceStream",{enumerable:!0,get:function(){return resource_stream_1.ResourceStream}});
/*! Developer Documentation
 *
 * paginator is used to auto-paginate `nextQuery` methods as well as
 * streamifying them.
 *
 * Before:
 *
 *   search.query('done=true', function(err, results, nextQuery) {
 *     search.query(nextQuery, function(err, results, nextQuery) {});
 *   });
 *
 * After:
 *
 *   search.query('done=true', function(err, results) {});
 *
 * Methods to extend should be written to accept callbacks and return a
 * `nextQuery`.
 */
class Paginator{extend(e,t){(t=arrify(t)).forEach((t=>{const r=e.prototype[t];e.prototype[t+"_"]=r,e.prototype[t]=function(...e){const t=paginator.parseArguments_(e);return paginator.run_(t,r.bind(this))}}))}streamify(e){return function(...t){const r=paginator.parseArguments_(t),a=this[e+"_"]||this[e];return paginator.runAsStream_(r,a.bind(this))}}parseArguments_(e){let t,r,a=!0,n=-1,o=-1;const s=e[0],i=e[e.length-1];"function"==typeof s?r=s:t=s,"function"==typeof i&&(r=i),"object"==typeof t&&(t=extend(!0,{},t),t.maxResults&&"number"==typeof t.maxResults?o=t.maxResults:"number"==typeof t.pageSize&&(o=t.pageSize),t.maxApiCalls&&"number"==typeof t.maxApiCalls&&(n=t.maxApiCalls,delete t.maxApiCalls),-1===o&&!1!==t.autoPaginate||(a=!1));const u={query:t||{},autoPaginate:a,maxApiCalls:n,maxResults:o,callback:r};return u.streamOptions=extend(!0,{},u.query),delete u.streamOptions.autoPaginate,delete u.streamOptions.maxResults,delete u.streamOptions.pageSize,u}run_(e,t){const r=e.query,a=e.callback;if(!e.autoPaginate)return t(r,a);const n=new Array;let o=[];const s=new Promise(((r,a)=>{const s=paginator.runAsStream_(e,t);s.on("error",a).on("data",(e=>n.push(e))).on("end",(()=>{o=s._otherArgs||[],r(n)}))}));if(!a)return s.then((e=>[e,r,...o]));s.then((e=>a(null,e,r,...o)),(e=>a(e)))}runAsStream_(e,t){return new resource_stream_1.ResourceStream(e,t)}}exports.Paginator=Paginator;const paginator=new Paginator;exports.paginator=paginator;