"use strict";
/*!
 * Copyright 2019 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.PreciseDate=void 0;const FULL_ISO_REG=/\d{4}-[01]\d-[0-3]\dT[0-2]\d:[0-5]\d:[0-5]\d\.\d{4,9}Z/,NO_BIG_INT="BigInt only available in Node >= v10.7. Consider using getFullTimeString instead.";var Sign;!function(t){t[t.NEGATIVE=-1]="NEGATIVE",t[t.POSITIVE=1]="POSITIVE",t[t.ZERO=0]="ZERO"}(Sign||(Sign={}));class PreciseDate extends Date{constructor(t){if(super(),this._micros=0,this._nanos=0,t&&"number"!=typeof t&&!(t instanceof Date))return void this.setFullTime(PreciseDate.parseFull(t));const e=Array.from(arguments),s=e.slice(0,7),n=new Date(...s),i=9===e.length?e.pop():0,r=8===e.length?e.pop():0;this.setTime(n.getTime()),this.setMicroseconds(r),this.setNanoseconds(i)}getFullTime(){if("function"!=typeof BigInt)throw new Error(NO_BIG_INT);return BigInt(this.getFullTimeString())}getFullTimeString(){const t=this._getSeconds();let e=this._getNanos();return e&&Math.sign(t)===Sign.NEGATIVE&&(e=1e9-e),`${t}${padLeft(e,9)}`}getMicroseconds(){return this._micros}getNanoseconds(){return this._nanos}setMicroseconds(t){const e=Math.abs(t);let s=this.getUTCMilliseconds();return e>=1e3&&(s+=Math.floor(e/1e3)*Math.sign(t),t%=1e3),Math.sign(t)===Sign.NEGATIVE&&(s-=1,t+=1e3),this._micros=t,this.setUTCMilliseconds(s),this.getFullTimeString()}setNanoseconds(t){const e=Math.abs(t);let s=this._micros;return e>=1e3&&(s+=Math.floor(e/1e3)*Math.sign(t),t%=1e3),Math.sign(t)===Sign.NEGATIVE&&(s-=1,t+=1e3),this._nanos=t,this.setMicroseconds(s)}setFullTime(t){"string"!=typeof t&&(t=t.toString());const e=Math.sign(Number(t));t=t.replace(/^-/,"");const s=Number(t.substr(0,t.length-9))*e,n=Number(t.substr(-9))*e;return this.setTime(1e3*s),this.setNanoseconds(n)}setTime(t){return this._micros=0,this._nanos=0,super.setTime(t)}toISOString(){const t=padLeft(this._micros,3),e=padLeft(this._nanos,3);return super.toISOString().replace(/z$/i,`${t}${e}Z`)}toStruct(){let t=this._getSeconds();const e=this._getNanos();return Math.sign(t)===Sign.NEGATIVE&&e&&(t-=1),{seconds:t,nanos:e}}toTuple(){const{seconds:t,nanos:e}=this.toStruct();return[t,e]}_getSeconds(){const t=this.getTime(),e=Math.sign(t);return Math.floor(Math.abs(t)/1e3)*e}_getNanos(){const t=1e6*this.getUTCMilliseconds(),e=1e3*this._micros;return this._nanos+t+e}static parseFull(t){const e=new PreciseDate;if(Array.isArray(t)){const[e,s]=t;t={seconds:e,nanos:s}}if(isFullTime(t))e.setFullTime(t);else if(isStruct(t)){const{seconds:s,nanos:n}=parseProto(t);e.setTime(1e3*s),e.setNanoseconds(n)}else isFullISOString(t)?e.setFullTime(parseFullISO(t)):e.setTime(new Date(t).getTime());return e.getFullTimeString()}static fullUTC(...t){if("function"!=typeof BigInt)throw new Error(NO_BIG_INT);return BigInt(PreciseDate.fullUTCString(...t))}static fullUTCString(...t){const e=Date.UTC(...t.slice(0,7)),s=new PreciseDate(e);return 9===t.length&&s.setNanoseconds(t.pop()),8===t.length&&s.setMicroseconds(t.pop()),s.getFullTimeString()}}function parseFullISO(t){let e="0";t=t.replace(/\.(\d+)/,((t,s)=>(e=s,".000")));const s=Number(padRight(e,9));return new PreciseDate(t).setNanoseconds(s)}function parseProto({seconds:t=0,nanos:e=0}){return"function"==typeof t.toNumber&&(t=t.toNumber()),{seconds:t=Number(t),nanos:e=Number(e)}}function isFullTime(t){return"bigint"==typeof t||"string"==typeof t&&/^\d+$/.test(t)}function isStruct(t){return"object"==typeof t&&void 0!==t.seconds||"number"==typeof t.nanos}function isFullISOString(t){return"string"==typeof t&&FULL_ISO_REG.test(t)}function padLeft(t,e){return`${getPadding(t,e)}${t}`}function padRight(t,e){return`${t}${getPadding(t,e)}`}function getPadding(t,e){const s=Math.max(e-t.toString().length,0);return"0".repeat(s)}exports.PreciseDate=PreciseDate;