"use strict";
/*!
 * Copyright 2017 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.Histogram=void 0;
/*!
 * The Histogram class is used to capture the lifespan of messages within the
 * the client. These durations are then used to calculate the 99th percentile
 * of ack deadlines for future messages.
 *
 * @private
 * @class
 */
class Histogram{constructor(t){this.options=Object.assign({min:0,max:Number.MAX_SAFE_INTEGER},t),this.data=new Map,this.length=0}
/*!
     * Adds a value to the histogram.
     *
     * @private
     * @param {numnber} value - The value in milliseconds.
     */add(t){t=Math.ceil(t),t=Math.max(t,this.options.min),t=Math.min(t,this.options.max),this.data.has(t)||this.data.set(t,0);const s=this.data.get(t);this.data.set(t,s+1),this.length+=1}
/*!
     * Retrieves the nth percentile of recorded values.
     *
     * @private
     * @param {number} percent The requested percentage.
     * @return {number}
     */percentile(t){t=Math.min(t,100);let s=this.length-this.length*(t/100);const i=Array.from(this.data.keys());let e;for(let t=i.length-1;t>-1;t--)if(e=i[t],s-=this.data.get(e),s<=0)return e;return this.options.min}}exports.Histogram=Histogram;