"use strict";
/*!
 * Copyright 2018 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.LeaseManager=void 0;const events_1=require("events"),default_options_1=require("./default-options");class LeaseManager extends events_1.EventEmitter{constructor(s,e={}){super(),this.bytes=0,this._isLeasing=!1,this._messages=new Set,this._pending=[],this._subscriber=s,this.setOptions(e)}get pending(){return this._pending.length}get size(){return this._messages.size}add(s){const{allowExcessMessages:e}=this._options,t=this.isFull();this._messages.add(s),this.bytes+=s.length,e||!t?this._dispense(s):this._pending.push(s),this._isLeasing||(this._isLeasing=!0,this._scheduleExtension()),!t&&this.isFull()&&this.emit("full")}clear(){const s=this.isFull();this._pending=[],this._messages.clear(),this.bytes=0,s&&process.nextTick((()=>this.emit("free"))),this._cancelExtension()}isFull(){const{maxBytes:s,maxMessages:e}=this._options;return this.size>=e||this.bytes>=s}remove(s){if(!this._messages.has(s))return;const e=this.isFull();if(this._messages.delete(s),this.bytes-=s.length,e&&!this.isFull())process.nextTick((()=>this.emit("free")));else if(this._pending.includes(s)){const e=this._pending.indexOf(s);this._pending.splice(e,1)}else this.pending>0&&this._dispense(this._pending.shift());0===this.size&&this._isLeasing&&this._cancelExtension()}setOptions(s){if(void 0!==s.maxExtension&&void 0!==s.maxExtensionMinutes)throw new RangeError('Only one of "maxExtension" or "maxExtensionMinutes" may be set for subscriber lease management options');void 0!==s.maxExtension&&void 0===s.maxExtensionMinutes&&(s.maxExtensionMinutes=s.maxExtension/60,delete s.maxExtension);const e={allowExcessMessages:!0,maxBytes:default_options_1.defaultOptions.subscription.maxOutstandingBytes,maxExtensionMinutes:default_options_1.defaultOptions.subscription.maxExtensionMinutes,maxMessages:default_options_1.defaultOptions.subscription.maxOutstandingMessages};this._options=Object.assign(e,s)}_cancelExtension(){this._isLeasing=!1,this._timer&&(clearTimeout(this._timer),delete this._timer)}_dispense(s){this._subscriber.isOpen&&process.nextTick((()=>this._subscriber.emit("message",s)))}_extendDeadlines(){const s=this._subscriber.ackDeadline;for(const e of this._messages){(Date.now()-e.received)/6e4<this._options.maxExtensionMinutes?this._subscriber.isExactlyOnceDelivery?e.modAckWithResponse(s).catch((s=>{e.ackFailed(s),this.remove(e)})):e.modAck(s):this.remove(e)}this._isLeasing&&this._scheduleExtension()}_getNextExtensionTimeoutMs(){const s=Math.random();return(.9*(1e3*this._subscriber.ackDeadline)-this._subscriber.modAckLatency)*s}_scheduleExtension(){const s=this._getNextExtensionTimeoutMs();this._timer=setTimeout((()=>this._extendDeadlines()),s)}}exports.LeaseManager=LeaseManager;