"use strict";
/*!
 * Copyright 2019 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.OrderedQueue=exports.Queue=exports.MessageQueue=void 0;const events_1=require("events"),message_batch_1=require("./message-batch"),publish_error_1=require("./publish-error"),util_1=require("util");class MessageQueue extends events_1.EventEmitter{constructor(t){super(),this.publisher=t,this.batchOptions=t.settings.batching}updateOptions(){this.batchOptions=this.publisher.settings.batching}async _publish(t,s){const{topic:e,settings:i}=this.publisher,h={topic:e.name,messages:t};if(0===t.length)return;const a=e.request,n=(0,util_1.promisify)(a.bind(e));try{const t=await n({client:"PublisherClient",method:"publish",reqOpts:h,gaxOpts:i.gaxOpts});if(t){const e=t.messageIds||[];s.forEach(((t,s)=>t(null,e[s])))}}catch(t){const e=t;throw s.forEach((t=>t(e))),t}}}exports.MessageQueue=MessageQueue;class Queue extends MessageQueue{constructor(t){super(t),this.batch=new message_batch_1.MessageBatch(this.batchOptions)}updateOptions(){super.updateOptions(),this.batch.setOptions(this.batchOptions)}add(t,s){if(this.batch.canFit(t)||this.publish().catch((()=>{})),this.batch.add(t,s),this.batch.isFull())this.publish().catch((()=>{}));else if(!this.pending){const{maxMilliseconds:t}=this.batchOptions;this.pending=setTimeout((()=>{this.publish().catch((()=>{}))}),t)}}async publishDrain(){await this._publishInternal(!0)}async publish(){await this._publishInternal(!1)}async _publishInternal(t){const{messages:s,callbacks:e}=this.batch;this.batch=new message_batch_1.MessageBatch(this.batchOptions),this.pending&&(clearTimeout(this.pending),delete this.pending),await this._publish(s,e),this.batch.messages.length?t&&await this._publishInternal(!0):this.emit("drain")}}exports.Queue=Queue;class OrderedQueue extends MessageQueue{constructor(t,s){super(t),this.batches=[],this.inFlight=!1,this.key=s}updateOptions(){super.updateOptions(),this.batches.forEach((t=>t.setOptions(this.batchOptions)))}get currentBatch(){return this.batches.length||this.batches.push(this.createBatch()),this.batches[0]}add(t,s){if(this.error)s(this.error);else{if(this.inFlight)return this.currentBatch.isAtMax()&&this.batches.unshift(this.createBatch()),void this.currentBatch.add(t,s);this.currentBatch.canFit(t)||this.publish().catch((()=>{})),this.currentBatch.add(t,s),this.inFlight||(this.currentBatch.isFull()?this.publish().catch((()=>{})):this.pending||this.beginNextPublish())}}beginNextPublish(){const t=this.batchOptions.maxMilliseconds,s=Date.now()-this.currentBatch.created,e=Math.max(0,t-s);this.pending=setTimeout((()=>{this.publish().catch((()=>{}))}),e)}createBatch(){return new message_batch_1.MessageBatch(this.batchOptions)}handlePublishFailure(t){for(this.error=new publish_error_1.PublishError(this.key,t);this.batches.length;){const{callbacks:s}=this.batches.pop();s.forEach((s=>s(t)))}}async publish(){if(!this.batches.length)return void this.emit("drain");this.inFlight=!0,this.pending&&(clearTimeout(this.pending),delete this.pending);const{messages:t,callbacks:s}=this.batches.pop();try{await this._publish(t,s)}catch(t){const s=t;this.inFlight=!1,this.handlePublishFailure(s)}finally{this.inFlight=!1}this.batches.length?this.beginNextPublish():this.emit("drain")}async publishDrain(){await this.publish()}resumePublishing(){delete this.error,process.nextTick((()=>{this.batches.length||this.emit("drain")}))}}exports.OrderedQueue=OrderedQueue;