"use strict";
/*!
 * Copyright 2014 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.PubSub=void 0;const paginator_1=require("@google-cloud/paginator"),projectify_1=require("@google-cloud/projectify"),extend=require("extend"),google_auth_library_1=require("google-auth-library"),gax=require("google-gax"),PKG=require("../../package.json"),v1=require("./v1"),util_1=require("./util"),schema_1=require("./schema"),snapshot_1=require("./snapshot"),subscription_1=require("./subscription"),topic_1=require("./topic"),PROJECT_ID_PLACEHOLDER="{{projectId}}";class PubSub{constructor(t){this.getSubscriptionsStream=paginator_1.paginator.streamify("getSubscriptions"),this.getSnapshotsStream=paginator_1.paginator.streamify("getSnapshots"),this.getTopicsStream=paginator_1.paginator.streamify("getTopics"),this.isOpen=!0;t=Object.assign({"grpc.max_metadata_size":4194304,"grpc.keepalive_time_ms":3e5,"grpc.keepalive_timeout_ms":2e4},t||{});const e=[v1.SubscriberClient,v1.PublisherClient],i={};for(const t of e)for(const e of t.scopes)i[e]=!0;this.options=Object.assign({libName:"gccl",libVersion:PKG.version,scopes:Object.keys(i)},t),this.isEmulator=!1,this.determineBaseUrl_(),this.api={},this.auth=new google_auth_library_1.GoogleAuth(this.options),this.projectId=this.options.projectId||"{{projectId}}","{{projectId}}"!==this.projectId&&(this.name=PubSub.formatName_(this.projectId))}get isIdResolved(){return this.projectId.indexOf("{{projectId}}")<0}close(t){const e=t||(()=>{});this.isOpen?(this.isOpen=!1,this.closeAllClients_().then((()=>{var t;return null===(t=this.schemaClient)||void 0===t?void 0:t.close()})).then((()=>{e(null)})).catch(e)):e(null)}async createSchema(t,e,i,s){await this.getClientConfig();const o=schema_1.Schema.formatName_(this.projectId,t),n={parent:this.name,schemaId:t,schema:{name:o,type:e,definition:i}},a=await this.getSchemaClient();return await a.createSchema(n,s),new schema_1.Schema(this,o)}createSubscription(t,e,i,s){if("string"!=typeof t&&!(t instanceof topic_1.Topic))throw new Error("A Topic is required for a new subscription.");if("string"!=typeof e)throw new Error("A subscription name is required.");"string"==typeof t&&(t=this.topic(t));let o="object"==typeof i?i:{};s="function"==typeof i?i:s,o=extend(!0,{},o);const n=o.gaxOpts,a=o.flowControl;delete o.gaxOpts,delete o.flowControl;const r=subscription_1.Subscription.formatMetadata_(o);let c=a?{flowControl:a}:{};c=Object.assign(c,r);const p=this.subscription(e,c),h=Object.assign(r,{topic:t.name,name:p.name});this.request({client:"SubscriberClient",method:"createSubscription",reqOpts:h,gaxOpts:n},((t,e)=>{var i;t?s(t,null,e):(p.metadata=e,(null===(i=p.name)||void 0===i?void 0:i.includes("{{projectId}}"))&&p.metadata&&p.metadata.name&&(p.name=subscription_1.Subscription.formatName_(this.projectId,p.metadata.name)),s(null,p,e))}))}createTopic(t,e,i){const s="string"==typeof t?{name:t}:t,o=this.topic(s.name||"");s.name=o.name;const n="object"==typeof e?e:{};i="function"==typeof e?e:i,this.request({client:"PublisherClient",method:"createTopic",reqOpts:s,gaxOpts:n},((t,e)=>{var s;t?i(t,null,e):(o.metadata=e,(null===(s=o.name)||void 0===s?void 0:s.includes("{{projectId}}"))&&o.metadata&&o.metadata.name&&(o.name=topic_1.Topic.formatName_(this.projectId,o.metadata.name)),i(null,o,e))}))}detachSubscription(t,e,i){if("string"!=typeof t)throw new Error("A subscription name is required.");const s={subscription:this.subscription(t).name},o="object"==typeof e?e:{};i="function"==typeof e?e:i,this.request({client:"PublisherClient",method:"detachSubscription",reqOpts:s,gaxOpts:o},i)}determineBaseUrl_(){const t=this.options.apiEndpoint||process.env.PUBSUB_EMULATOR_HOST||process.env.CLOUDSDK_API_ENDPOINT_OVERRIDES_PUBSUB;if(!t)return;const e=new RegExp("^https?://"),i=new RegExp("/*$"),s=t.replace(e,"").replace(i,"").split(":");this.options.servicePath=s[0],s[1]?this.options.port=parseInt(s[1],10):t.startsWith("https")?this.options.port=443:t.startsWith("http")?this.options.port=80:this.options.port=void 0;if(!(this.options.servicePath.endsWith(".googleapis.com")||this.options.universeDomain)&&!1!==this.options.emulatorMode||!0===this.options.emulatorMode){const t=this.options.grpc||gax.grpc;this.options.sslCreds=t.credentials.createInsecure(),this.isEmulator=!0}!this.options.projectId&&process.env.PUBSUB_PROJECT_ID&&(this.options.projectId=process.env.PUBSUB_PROJECT_ID)}async*listSchemas(t=schema_1.SchemaViews.Basic,e){const i=await this.getSchemaClient(),s={parent:this.name,view:t};for await(const t of i.listSchemasAsync(s,e))yield t}getSnapshots(t,e){const i="object"==typeof t?t:{};e="function"==typeof t?t:e;const s=Object.assign({project:PubSub.formatName_(this.projectId)},i);delete s.gaxOpts,delete s.autoPaginate;const o=Object.assign({autoPaginate:i.autoPaginate},i.gaxOpts);this.request({client:"SubscriberClient",method:"listSnapshots",reqOpts:s,gaxOpts:o},((t,i,...s)=>{let o;i&&(o=i.map((t=>{const e=this.snapshot(t.name);return e.metadata=t,e}))),e(t,o,...s)}))}getSubscriptions(t,e){const i="object"==typeof t?t:{};e="function"==typeof t?t:e;let s=i.topic;if(s)return s instanceof topic_1.Topic||(s=this.topic(s)),s.getSubscriptions(i,e);const o=Object.assign({},i);o.project="projects/"+this.projectId,delete o.gaxOpts,delete o.autoPaginate;const n=Object.assign({autoPaginate:i.autoPaginate},i.gaxOpts);this.request({client:"SubscriberClient",method:"listSubscriptions",reqOpts:o,gaxOpts:n},((t,i,...s)=>{let o;i&&(o=i.map((t=>{const e=this.subscription(t.name);return e.metadata=t,e}))),e(t,o,...s)}))}getTopics(t,e){const i="object"==typeof t?t:{};e="function"==typeof t?t:e;const s=Object.assign({project:"projects/"+this.projectId},i);delete s.gaxOpts,delete s.autoPaginate;const o=Object.assign({autoPaginate:i.autoPaginate},i.gaxOpts);this.request({client:"PublisherClient",method:"listTopics",reqOpts:s,gaxOpts:o},((t,i,...s)=>{let o;i&&(o=i.map((t=>{const e=this.topic(t.name);return e.metadata=t,e}))),e(t,o,...s)}))}async getClientConfig(){if(!this.projectId||"{{projectId}}"===this.projectId){let t;try{t=await this.auth.getProjectId()}catch(e){if(!this.isEmulator)throw e;t=""}this.projectId=t,this.name=PubSub.formatName_(this.projectId),this.options.projectId=t}return this.options}async getSchemaClient(){if(!this.schemaClient){const t=await this.getClientConfig();this.schemaClient=new v1.SchemaServiceClient(t)}return this.schemaClient}getClient_(t,e){this.getClientAsync_(t).then((t=>e(null,t)),e)}async getClientAsync_(t){const e=await this.getClientConfig();let i=this.api[t.client];return i||(i=new v1[t.client](e),this.api[t.client]=i),i}async closeAllClients_(){const t=[];for(const e of Object.keys(this.api)){const i=this.api[e];t.push(i.close()),delete this.api[e]}await Promise.all(t)}request(t,e){if(!this.isOpen){const t={code:0,details:"Cannot use a closed PubSub object.",metadata:null},i=new Error(t.details);return Object.assign(i,t),void e(i)}this.getClient_(t,((i,s)=>{if(i)return void e(i);let o=extend(!0,{},t.reqOpts);o=(0,projectify_1.replaceProjectIdToken)(o,this.projectId),s[t.method](o,t.gaxOpts,e)}))}schema(t){return new schema_1.Schema(this,t)}snapshot(t){if("string"!=typeof t)throw new Error("You must supply a valid name for the snapshot.");return new snapshot_1.Snapshot(this,t)}subscription(t,e){if(!t)throw new Error("A name must be specified for a subscription.");return new subscription_1.Subscription(this,t,e)}topic(t,e){if(!t)throw new Error("A name must be specified for a topic.");return new topic_1.Topic(this,t,e)}async validateSchema(t,e){const i=await this.getSchemaClient();await i.validateSchema({parent:this.name,schema:t},e)}
/*!
     * Format the name of a project. A project's full name is in the
     * format of projects/{projectId}.
     *
     * The GAPIC client should do this for us, but since we maintain
     * names rather than IDs, this is simpler.
     *
     * @private
     */static formatName_(t){if("string"!=typeof t)throw new Error("A name is required to identify a project.");return t.indexOf("/")>-1?t:`projects/${t}`}}exports.PubSub=PubSub,
/*! Developer Documentation
 *
 * These methods can be auto-paginated.
 */
paginator_1.paginator.extend(PubSub,["getSnapshots","getSubscriptions","getTopics"]),
/*! Developer Documentation
 *
 * Existing async methods (except for streams) will return a Promise in the event
 * that a callback is omitted. Future methods will not allow for a callback.
 * (Use .then() on the returned Promise instead.)
 */
(0,util_1.promisifySome)(PubSub,PubSub.prototype,["close","createSubscription","createTopic","detachSubscription","getSnapshots","getSubscriptions","getTopics"]);