"use strict";
/*!
 * Copyright 2017 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.Topic=void 0;const paginator_1=require("@google-cloud/paginator"),iam_1=require("./iam"),publisher_1=require("./publisher"),flow_publisher_1=require("./publisher/flow-publisher"),util_1=require("./util"),snakeCase=require("lodash.snakecase");class Topic{constructor(t,e,s){this.getSubscriptionsStream=paginator_1.paginator.streamify("getSubscriptions"),this.name=Topic.formatName_(t.projectId,e),this.publisher=new publisher_1.Publisher(this,s),this.parent=this.pubsub=t,this.request=t.request.bind(t),this.iam=new iam_1.IAM(t,this.name)}flush(t){this.publisher.flush(t)}create(t,e){const s="object"==typeof t?t:{};e="function"==typeof t?t:e,this.pubsub.createTopic(this.name,s,e)}createSubscription(t,e,s){const i="object"==typeof e?e:{};s="function"==typeof e?e:s,this.pubsub.createSubscription(this,t,i,s)}delete(t,e){const s="object"==typeof t?t:{};e="function"==typeof t?t:e;const i={topic:this.name};this.request({client:"PublisherClient",method:"deleteTopic",reqOpts:i,gaxOpts:s},e)}exists(t){this.getMetadata((e=>{e?5!==e.code?t(e):t(null,!1):t(null,!0)}))}get(t,e){const s="object"==typeof t?t:{};e="function"==typeof t?t:e;const i=!!s.autoCreate;delete s.autoCreate,this.getMetadata(s,((t,o)=>{t?5===t.code&&i?this.create(s,e):e(t,null,o):e(null,this,o)}))}getMetadata(t,e){const s="object"==typeof t?t:{};e="function"==typeof t?t:e;const i={topic:this.name};this.request({client:"PublisherClient",method:"getTopic",reqOpts:i,gaxOpts:s},((t,s)=>{t||(this.metadata=s),e(t,s)}))}getSubscriptions(t,e){const s="object"==typeof t?t:{};e="function"==typeof t?t:e;const i=Object.assign({topic:this.name},s);delete i.gaxOpts,delete i.autoPaginate;const o=Object.assign({autoPaginate:s.autoPaginate},s.gaxOpts);this.request({client:"PublisherClient",method:"listTopicSubscriptions",reqOpts:i,gaxOpts:o},((t,s,...i)=>{let o;s&&(o=s.map((t=>this.subscription(t)))),e(t,o,...i)}))}publish(t,e,s){const i="object"==typeof e?e:{};return s="function"==typeof e?e:s,this.publishMessage({data:t,attributes:i},s)}publishJSON(t,e,s){if(!t||"object"!=typeof t)throw new Error("First parameter should be an object.");const i="object"==typeof e?e:{};return s="function"==typeof e?e:s,this.publishMessage({json:t,attributes:i},s)}publishMessage(t,e){return(t=Object.assign({},t)).json&&"object"==typeof t.json&&(t.data=Buffer.from(JSON.stringify(t.json)),delete t.json),this.publisher.publishMessage(t,e)}flowControlled(){return new flow_publisher_1.FlowControlledPublisher(this.publisher)}resumePublishing(t){this.publisher.resumePublishing(t)}setMetadata(t,e,s){const i="object"==typeof e?e:{};s="function"==typeof e?e:s;const o={topic:Object.assign({name:this.name},t),updateMask:{paths:Object.keys(t).map(snakeCase)}};this.request({client:"PublisherClient",method:"updateTopic",reqOpts:o,gaxOpts:i},s)}setPublishOptions(t){this.publisher.setOptions(t)}getPublishOptionDefaults(){return this.publisher.getOptionDefaults()}subscription(t,e){return(e=e||{}).topic=this,this.pubsub.subscription(t,e)}static formatName_(t,e){return e.indexOf("/")>-1?e:"projects/"+t+"/topics/"+e}}exports.Topic=Topic,
/*! Developer Documentation
 *
 * These methods can be agto-paginated.
 */
paginator_1.paginator.extend(Topic,["getSubscriptions"]),
/*! Developer Documentation
 *
 * Existing async methods (except for streams) will return a Promise in the event
 * that a callback is omitted. Future methods will not allow for a callback.
 * (Use .then() on the returned Promise instead.)
 */
(0,util_1.promisifySome)(Topic,Topic.prototype,["flush","create","createSubscription","delete","exists","get","getMetadata","getSubscriptions","setMetadata"]);