"use strict";
/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.teenyRequest=exports.RequestError=void 0;const node_fetch_1=require("node-fetch"),stream_1=require("stream"),uuid=require("uuid"),agents_1=require("./agents"),TeenyStatistics_1=require("./TeenyStatistics"),streamEvents=require("stream-events");class RequestError extends Error{}function requestToFetchOptions(e){const t={method:e.method||"GET",...e.timeout&&{timeout:e.timeout},..."boolean"==typeof e.gzip&&{compress:e.gzip}};"object"==typeof e.json?(e.headers=e.headers||{},e.headers["Content-Type"]="application/json",t.body=JSON.stringify(e.json)):Buffer.isBuffer(e.body)?t.body=e.body:"string"!=typeof e.body?t.body=JSON.stringify(e.body):t.body=e.body,t.headers=e.headers;let s=e.uri||e.url;if(!s)throw new Error("Missing uri or url in reqOpts.");if(!0===e.useQuerystring||"object"==typeof e.qs){s=s+"?"+require("querystring").stringify(e.qs)}return t.agent=agents_1.getAgent(s,e),{uri:s,options:t}}function fetchToRequestResponse(e,t){const s={};s.agent=e.agent||!1,s.headers=e.headers||{},s.href=t.url;const n={};t.headers.forEach(((e,t)=>n[t]=e));return Object.assign(t.body,{statusCode:t.status,statusMessage:t.statusText,request:s,body:t.body,headers:n,toJSON:()=>({headers:n})})}function createMultipartStream(e,t){const s=`--${e}--`,n=new stream_1.PassThrough;for(const r of t){const t=`--${e}\r\nContent-Type: ${r["Content-Type"]}\r\n\r\n`;n.write(t),"string"==typeof r.body?(n.write(r.body),n.write("\r\n")):(r.body.pipe(n,{end:!1}),r.body.on("end",(()=>{n.write("\r\n"),n.write(s),n.end()})))}return n}function teenyRequest(e,t){const{uri:s,options:n}=requestToFetchOptions(e),r=e.multipart;if(e.multipart&&2===r.length){if(!t)throw new Error("Multipart without callback is not implemented.");const e=uuid.v4();return n.headers["Content-Type"]=`multipart/related; boundary=${e}`,n.body=createMultipartStream(e,r),teenyRequest.stats.requestStarting(),void node_fetch_1.default(s,n).then((e=>{teenyRequest.stats.requestFinished();const s=e.headers.get("content-type"),r=fetchToRequestResponse(n,e),o=r.body;"application/json"!==s&&"application/json; charset=utf-8"!==s?e.text().then((e=>{r.body=e,t(null,r,e)}),(e=>{t(e,r,o)})):e.json().then((e=>{r.body=e,t(null,r,e)}),(e=>{t(e,r,o)}))}),(e=>{teenyRequest.stats.requestFinished(),t(e,null,null)}))}if(void 0===t){const e=streamEvents(new stream_1.PassThrough);let t;return e.once("reading",(()=>{t?t.pipe(e):e.once("response",(()=>{t.pipe(e)}))})),n.compress=!1,teenyRequest.stats.requestStarting(),node_fetch_1.default(s,n).then((s=>{teenyRequest.stats.requestFinished(),t=s.body,t.on("error",(t=>{e.emit("error",t)}));const r=fetchToRequestResponse(n,s);e.emit("response",r)}),(t=>{teenyRequest.stats.requestFinished(),e.emit("error",t)})),e}teenyRequest.stats.requestStarting(),node_fetch_1.default(s,n).then((e=>{teenyRequest.stats.requestFinished();const s=e.headers.get("content-type"),r=fetchToRequestResponse(n,e),o=r.body;if("application/json"===s||"application/json; charset=utf-8"===s)return 204===r.statusCode?void t(null,r,o):void e.json().then((e=>{r.body=e,t(null,r,e)}),(e=>{t(e,r,o)}));e.text().then((s=>{const r=fetchToRequestResponse(n,e);r.body=s,t(null,r,s)}),(e=>{t(e,r,o)}))}),(e=>{teenyRequest.stats.requestFinished(),t(e,null,null)}))}exports.RequestError=RequestError,exports.teenyRequest=teenyRequest,teenyRequest.defaults=e=>(t,s)=>{const n={...e,...t};if(void 0===s)return teenyRequest(n);teenyRequest(n,s)},teenyRequest.stats=new TeenyStatistics_1.TeenyStatistics,teenyRequest.resetStats=()=>{teenyRequest.stats=new TeenyStatistics_1.TeenyStatistics(teenyRequest.stats.getOptions())};