"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.HeaderMarshaller=void 0;const util_hex_encoding_1=require("@smithy/util-hex-encoding"),Int64_1=require("./Int64");class HeaderMarshaller{constructor(e,t){this.toUtf8=e,this.fromUtf8=t}format(e){const t=[];for(const r of Object.keys(e)){const n=this.fromUtf8(r);t.push(Uint8Array.from([n.byteLength]),n,this.formatHeaderValue(e[r]))}const r=new Uint8Array(t.reduce(((e,t)=>e+t.byteLength),0));let n=0;for(const e of t)r.set(e,n),n+=e.byteLength;return r}formatHeaderValue(e){switch(e.type){case"boolean":return Uint8Array.from([e.value?0:1]);case"byte":return Uint8Array.from([2,e.value]);case"short":const t=new DataView(new ArrayBuffer(3));return t.setUint8(0,3),t.setInt16(1,e.value,!1),new Uint8Array(t.buffer);case"integer":const r=new DataView(new ArrayBuffer(5));return r.setUint8(0,4),r.setInt32(1,e.value,!1),new Uint8Array(r.buffer);case"long":const n=new Uint8Array(9);return n[0]=5,n.set(e.value.bytes,1),n;case"binary":const a=new DataView(new ArrayBuffer(3+e.value.byteLength));a.setUint8(0,6),a.setUint16(1,e.value.byteLength,!1);const s=new Uint8Array(a.buffer);return s.set(e.value,3),s;case"string":const o=this.fromUtf8(e.value),u=new DataView(new ArrayBuffer(3+o.byteLength));u.setUint8(0,7),u.setUint16(1,o.byteLength,!1);const i=new Uint8Array(u.buffer);return i.set(o,3),i;case"timestamp":const f=new Uint8Array(9);return f[0]=8,f.set(Int64_1.Int64.fromNumber(e.value.valueOf()).bytes,1),f;case"uuid":if(!UUID_PATTERN.test(e.value))throw new Error(`Invalid UUID received: ${e.value}`);const y=new Uint8Array(17);return y[0]=9,y.set((0,util_hex_encoding_1.fromHex)(e.value.replace(/\-/g,"")),1),y}}parse(e){const t={};let r=0;for(;r<e.byteLength;){const n=e.getUint8(r++),a=this.toUtf8(new Uint8Array(e.buffer,e.byteOffset+r,n));switch(r+=n,e.getUint8(r++)){case 0:t[a]={type:BOOLEAN_TAG,value:!0};break;case 1:t[a]={type:BOOLEAN_TAG,value:!1};break;case 2:t[a]={type:BYTE_TAG,value:e.getInt8(r++)};break;case 3:t[a]={type:SHORT_TAG,value:e.getInt16(r,!1)},r+=2;break;case 4:t[a]={type:INT_TAG,value:e.getInt32(r,!1)},r+=4;break;case 5:t[a]={type:LONG_TAG,value:new Int64_1.Int64(new Uint8Array(e.buffer,e.byteOffset+r,8))},r+=8;break;case 6:const n=e.getUint16(r,!1);r+=2,t[a]={type:BINARY_TAG,value:new Uint8Array(e.buffer,e.byteOffset+r,n)},r+=n;break;case 7:const s=e.getUint16(r,!1);r+=2,t[a]={type:STRING_TAG,value:this.toUtf8(new Uint8Array(e.buffer,e.byteOffset+r,s))},r+=s;break;case 8:t[a]={type:TIMESTAMP_TAG,value:new Date(new Int64_1.Int64(new Uint8Array(e.buffer,e.byteOffset+r,8)).valueOf())},r+=8;break;case 9:const o=new Uint8Array(e.buffer,e.byteOffset+r,16);r+=16,t[a]={type:UUID_TAG,value:`${(0,util_hex_encoding_1.toHex)(o.subarray(0,4))}-${(0,util_hex_encoding_1.toHex)(o.subarray(4,6))}-${(0,util_hex_encoding_1.toHex)(o.subarray(6,8))}-${(0,util_hex_encoding_1.toHex)(o.subarray(8,10))}-${(0,util_hex_encoding_1.toHex)(o.subarray(10))}`};break;default:throw new Error("Unrecognized header type tag")}}return t}}var HEADER_VALUE_TYPE;exports.HeaderMarshaller=HeaderMarshaller,function(e){e[e.boolTrue=0]="boolTrue",e[e.boolFalse=1]="boolFalse",e[e.byte=2]="byte",e[e.short=3]="short",e[e.integer=4]="integer",e[e.long=5]="long",e[e.byteArray=6]="byteArray",e[e.string=7]="string",e[e.timestamp=8]="timestamp",e[e.uuid=9]="uuid"}(HEADER_VALUE_TYPE||(HEADER_VALUE_TYPE={}));const BOOLEAN_TAG="boolean",BYTE_TAG="byte",SHORT_TAG="short",INT_TAG="integer",LONG_TAG="long",BINARY_TAG="binary",STRING_TAG="string",TIMESTAMP_TAG="timestamp",UUID_TAG="uuid",UUID_PATTERN=/^[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}$/;