"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.SignatureV4=void 0;const eventstream_codec_1=require("@smithy/eventstream-codec"),util_hex_encoding_1=require("@smithy/util-hex-encoding"),util_middleware_1=require("@smithy/util-middleware"),util_utf8_1=require("@smithy/util-utf8"),constants_1=require("./constants"),credentialDerivation_1=require("./credentialDerivation"),getCanonicalHeaders_1=require("./getCanonicalHeaders"),getCanonicalQuery_1=require("./getCanonicalQuery"),getPayloadHash_1=require("./getPayloadHash"),headerUtil_1=require("./headerUtil"),moveHeadersToQuery_1=require("./moveHeadersToQuery"),prepareRequest_1=require("./prepareRequest"),utilDate_1=require("./utilDate");class SignatureV4{constructor({applyChecksum:e,credentials:t,region:i,service:n,sha256:a,uriEscapePath:s=!0}){this.headerMarshaller=new eventstream_codec_1.HeaderMarshaller(util_utf8_1.toUtf8,util_utf8_1.fromUtf8),this.service=n,this.sha256=a,this.uriEscapePath=s,this.applyChecksum="boolean"!=typeof e||e,this.regionProvider=(0,util_middleware_1.normalizeProvider)(i),this.credentialProvider=(0,util_middleware_1.normalizeProvider)(t)}async presign(e,t={}){const{signingDate:i=new Date,expiresIn:n=3600,unsignableHeaders:a,unhoistableHeaders:s,signableHeaders:r,signingRegion:o,signingService:g}=t,c=await this.credentialProvider();this.validateResolvedCredentials(c);const l=null!=o?o:await this.regionProvider(),{longDate:d,shortDate:u}=formatDate(i);if(n>constants_1.MAX_PRESIGNED_TTL)return Promise.reject("Signature version 4 presigned URLs must have an expiration date less than one week in the future");const h=(0,credentialDerivation_1.createScope)(u,l,null!=g?g:this.service),_=(0,moveHeadersToQuery_1.moveHeadersToQuery)((0,prepareRequest_1.prepareRequest)(e),{unhoistableHeaders:s});c.sessionToken&&(_.query[constants_1.TOKEN_QUERY_PARAM]=c.sessionToken),_.query[constants_1.ALGORITHM_QUERY_PARAM]=constants_1.ALGORITHM_IDENTIFIER,_.query[constants_1.CREDENTIAL_QUERY_PARAM]=`${c.accessKeyId}/${h}`,_.query[constants_1.AMZ_DATE_QUERY_PARAM]=d,_.query[constants_1.EXPIRES_QUERY_PARAM]=n.toString(10);const y=(0,getCanonicalHeaders_1.getCanonicalHeaders)(_,a,r);return _.query[constants_1.SIGNED_HEADERS_QUERY_PARAM]=getCanonicalHeaderList(y),_.query[constants_1.SIGNATURE_QUERY_PARAM]=await this.getSignature(d,h,this.getSigningKey(c,l,u,g),this.createCanonicalRequest(_,y,await(0,getPayloadHash_1.getPayloadHash)(e,this.sha256))),_}async sign(e,t){return"string"==typeof e?this.signString(e,t):e.headers&&e.payload?this.signEvent(e,t):e.message?this.signMessage(e,t):this.signRequest(e,t)}async signEvent({headers:e,payload:t},{signingDate:i=new Date,priorSignature:n,signingRegion:a,signingService:s}){const r=null!=a?a:await this.regionProvider(),{shortDate:o,longDate:g}=formatDate(i),c=(0,credentialDerivation_1.createScope)(o,r,null!=s?s:this.service),l=await(0,getPayloadHash_1.getPayloadHash)({headers:{},body:t},this.sha256),d=new this.sha256;d.update(e);const u=(0,util_hex_encoding_1.toHex)(await d.digest()),h=[constants_1.EVENT_ALGORITHM_IDENTIFIER,g,c,n,u,l].join("\n");return this.signString(h,{signingDate:i,signingRegion:r,signingService:s})}async signMessage(e,{signingDate:t=new Date,signingRegion:i,signingService:n}){return this.signEvent({headers:this.headerMarshaller.format(e.message.headers),payload:e.message.body},{signingDate:t,signingRegion:i,signingService:n,priorSignature:e.priorSignature}).then((t=>({message:e.message,signature:t})))}async signString(e,{signingDate:t=new Date,signingRegion:i,signingService:n}={}){const a=await this.credentialProvider();this.validateResolvedCredentials(a);const s=null!=i?i:await this.regionProvider(),{shortDate:r}=formatDate(t),o=new this.sha256(await this.getSigningKey(a,s,r,n));return o.update((0,util_utf8_1.toUint8Array)(e)),(0,util_hex_encoding_1.toHex)(await o.digest())}async signRequest(e,{signingDate:t=new Date,signableHeaders:i,unsignableHeaders:n,signingRegion:a,signingService:s}={}){const r=await this.credentialProvider();this.validateResolvedCredentials(r);const o=null!=a?a:await this.regionProvider(),g=(0,prepareRequest_1.prepareRequest)(e),{longDate:c,shortDate:l}=formatDate(t),d=(0,credentialDerivation_1.createScope)(l,o,null!=s?s:this.service);g.headers[constants_1.AMZ_DATE_HEADER]=c,r.sessionToken&&(g.headers[constants_1.TOKEN_HEADER]=r.sessionToken);const u=await(0,getPayloadHash_1.getPayloadHash)(g,this.sha256);!(0,headerUtil_1.hasHeader)(constants_1.SHA256_HEADER,g.headers)&&this.applyChecksum&&(g.headers[constants_1.SHA256_HEADER]=u);const h=(0,getCanonicalHeaders_1.getCanonicalHeaders)(g,n,i),_=await this.getSignature(c,d,this.getSigningKey(r,o,l,s),this.createCanonicalRequest(g,h,u));return g.headers[constants_1.AUTH_HEADER]=`${constants_1.ALGORITHM_IDENTIFIER} Credential=${r.accessKeyId}/${d}, SignedHeaders=${getCanonicalHeaderList(h)}, Signature=${_}`,g}createCanonicalRequest(e,t,i){const n=Object.keys(t).sort();return`${e.method}\n${this.getCanonicalPath(e)}\n${(0,getCanonicalQuery_1.getCanonicalQuery)(e)}\n${n.map((e=>`${e}:${t[e]}`)).join("\n")}\n\n${n.join(";")}\n${i}`}async createStringToSign(e,t,i){const n=new this.sha256;n.update((0,util_utf8_1.toUint8Array)(i));const a=await n.digest();return`${constants_1.ALGORITHM_IDENTIFIER}\n${e}\n${t}\n${(0,util_hex_encoding_1.toHex)(a)}`}getCanonicalPath({path:e}){if(this.uriEscapePath){const t=[];for(const i of e.split("/"))0!==(null==i?void 0:i.length)&&"."!==i&&(".."===i?t.pop():t.push(i));const i=`${(null==e?void 0:e.startsWith("/"))?"/":""}${t.join("/")}${t.length>0&&(null==e?void 0:e.endsWith("/"))?"/":""}`;return encodeURIComponent(i).replace(/%2F/g,"/")}return e}async getSignature(e,t,i,n){const a=await this.createStringToSign(e,t,n),s=new this.sha256(await i);return s.update((0,util_utf8_1.toUint8Array)(a)),(0,util_hex_encoding_1.toHex)(await s.digest())}getSigningKey(e,t,i,n){return(0,credentialDerivation_1.getSigningKey)(this.sha256,e,i,t,n||this.service)}validateResolvedCredentials(e){if("object"!=typeof e||"string"!=typeof e.accessKeyId||"string"!=typeof e.secretAccessKey)throw new Error("Resolved credential object is not valid")}}exports.SignatureV4=SignatureV4;const formatDate=e=>{const t=(0,utilDate_1.iso8601)(e).replace(/[\-:]/g,"");return{longDate:t,shortDate:t.slice(0,8)}},getCanonicalHeaderList=e=>Object.keys(e).sort().join(";");