import{HeaderMarshaller}from"@smithy/eventstream-codec";import{toHex}from"@smithy/util-hex-encoding";import{normalizeProvider}from"@smithy/util-middleware";import{fromUtf8,toUint8Array,toUtf8}from"@smithy/util-utf8";import{ALGORITHM_IDENTIFIER,ALGORITHM_QUERY_PARAM,AMZ_DATE_HEADER,AMZ_DATE_QUERY_PARAM,AUTH_HEADER,CREDENTIAL_QUERY_PARAM,EVENT_ALGORITHM_IDENTIFIER,EXPIRES_QUERY_PARAM,MAX_PRESIGNED_TTL,SHA256_HEADER,SIGNATURE_QUERY_PARAM,SIGNED_HEADERS_QUERY_PARAM,TOKEN_HEADER,TOKEN_QUERY_PARAM}from"./constants";import{createScope,getSigningKey}from"./credentialDerivation";import{getCanonicalHeaders}from"./getCanonicalHeaders";import{getCanonicalQuery}from"./getCanonicalQuery";import{getPayloadHash}from"./getPayloadHash";import{hasHeader}from"./headerUtil";import{moveHeadersToQuery}from"./moveHeadersToQuery";import{prepareRequest}from"./prepareRequest";import{iso8601}from"./utilDate";export class SignatureV4{constructor({applyChecksum:e,credentials:t,region:i,service:a,sha256:s,uriEscapePath:n=!0}){this.headerMarshaller=new HeaderMarshaller(toUtf8,fromUtf8),this.service=a,this.sha256=s,this.uriEscapePath=n,this.applyChecksum="boolean"!=typeof e||e,this.regionProvider=normalizeProvider(i),this.credentialProvider=normalizeProvider(t)}async presign(e,t={}){const{signingDate:i=new Date,expiresIn:a=3600,unsignableHeaders:s,unhoistableHeaders:n,signableHeaders:r,signingRegion:o,signingService:g}=t,h=await this.credentialProvider();this.validateResolvedCredentials(h);const c=o??await this.regionProvider(),{longDate:d,shortDate:l}=formatDate(i);if(a>MAX_PRESIGNED_TTL)return Promise.reject("Signature version 4 presigned URLs must have an expiration date less than one week in the future");const R=createScope(l,c,g??this.service),E=moveHeadersToQuery(prepareRequest(e),{unhoistableHeaders:n});h.sessionToken&&(E.query[TOKEN_QUERY_PARAM]=h.sessionToken),E.query[ALGORITHM_QUERY_PARAM]=ALGORITHM_IDENTIFIER,E.query[CREDENTIAL_QUERY_PARAM]=`${h.accessKeyId}/${R}`,E.query[AMZ_DATE_QUERY_PARAM]=d,E.query[EXPIRES_QUERY_PARAM]=a.toString(10);const A=getCanonicalHeaders(E,s,r);return E.query[SIGNED_HEADERS_QUERY_PARAM]=getCanonicalHeaderList(A),E.query[SIGNATURE_QUERY_PARAM]=await this.getSignature(d,R,this.getSigningKey(h,c,l,g),this.createCanonicalRequest(E,A,await getPayloadHash(e,this.sha256))),E}async sign(e,t){return"string"==typeof e?this.signString(e,t):e.headers&&e.payload?this.signEvent(e,t):e.message?this.signMessage(e,t):this.signRequest(e,t)}async signEvent({headers:e,payload:t},{signingDate:i=new Date,priorSignature:a,signingRegion:s,signingService:n}){const r=s??await this.regionProvider(),{shortDate:o,longDate:g}=formatDate(i),h=createScope(o,r,n??this.service),c=await getPayloadHash({headers:{},body:t},this.sha256),d=new this.sha256;d.update(e);const l=toHex(await d.digest()),R=[EVENT_ALGORITHM_IDENTIFIER,g,h,a,l,c].join("\n");return this.signString(R,{signingDate:i,signingRegion:r,signingService:n})}async signMessage(e,{signingDate:t=new Date,signingRegion:i,signingService:a}){return this.signEvent({headers:this.headerMarshaller.format(e.message.headers),payload:e.message.body},{signingDate:t,signingRegion:i,signingService:a,priorSignature:e.priorSignature}).then((t=>({message:e.message,signature:t})))}async signString(e,{signingDate:t=new Date,signingRegion:i,signingService:a}={}){const s=await this.credentialProvider();this.validateResolvedCredentials(s);const n=i??await this.regionProvider(),{shortDate:r}=formatDate(t),o=new this.sha256(await this.getSigningKey(s,n,r,a));return o.update(toUint8Array(e)),toHex(await o.digest())}async signRequest(e,{signingDate:t=new Date,signableHeaders:i,unsignableHeaders:a,signingRegion:s,signingService:n}={}){const r=await this.credentialProvider();this.validateResolvedCredentials(r);const o=s??await this.regionProvider(),g=prepareRequest(e),{longDate:h,shortDate:c}=formatDate(t),d=createScope(c,o,n??this.service);g.headers[AMZ_DATE_HEADER]=h,r.sessionToken&&(g.headers[TOKEN_HEADER]=r.sessionToken);const l=await getPayloadHash(g,this.sha256);!hasHeader(SHA256_HEADER,g.headers)&&this.applyChecksum&&(g.headers[SHA256_HEADER]=l);const R=getCanonicalHeaders(g,a,i),E=await this.getSignature(h,d,this.getSigningKey(r,o,c,n),this.createCanonicalRequest(g,R,l));return g.headers[AUTH_HEADER]=`${ALGORITHM_IDENTIFIER} Credential=${r.accessKeyId}/${d}, SignedHeaders=${getCanonicalHeaderList(R)}, Signature=${E}`,g}createCanonicalRequest(e,t,i){const a=Object.keys(t).sort();return`${e.method}\n${this.getCanonicalPath(e)}\n${getCanonicalQuery(e)}\n${a.map((e=>`${e}:${t[e]}`)).join("\n")}\n\n${a.join(";")}\n${i}`}async createStringToSign(e,t,i){const a=new this.sha256;a.update(toUint8Array(i));const s=await a.digest();return`${ALGORITHM_IDENTIFIER}\n${e}\n${t}\n${toHex(s)}`}getCanonicalPath({path:e}){if(this.uriEscapePath){const t=[];for(const i of e.split("/"))0!==i?.length&&"."!==i&&(".."===i?t.pop():t.push(i));const i=`${e?.startsWith("/")?"/":""}${t.join("/")}${t.length>0&&e?.endsWith("/")?"/":""}`;return encodeURIComponent(i).replace(/%2F/g,"/")}return e}async getSignature(e,t,i,a){const s=await this.createStringToSign(e,t,a),n=new this.sha256(await i);return n.update(toUint8Array(s)),toHex(await n.digest())}getSigningKey(e,t,i,a){return getSigningKey(this.sha256,e,i,t,a||this.service)}validateResolvedCredentials(e){if("object"!=typeof e||"string"!=typeof e.accessKeyId||"string"!=typeof e.secretAccessKey)throw new Error("Resolved credential object is not valid")}}const formatDate=e=>{const t=iso8601(e).replace(/[\-:]/g,"");return{longDate:t,shortDate:t.slice(0,8)}},getCanonicalHeaderList=e=>Object.keys(e).sort().join(";");