"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.MapperTypeNames=exports.createSerializer=void 0;const tslib_1=require("tslib"),base64=tslib_1.__importStar(require("./base64.js")),interfaces_js_1=require("./interfaces.js"),utils_js_1=require("./utils.js");class SerializerImpl{constructor(e={},t=!1){this.modelMappers=e,this.isXML=t}validateConstraints(e,t,i){const r=(e,r)=>{throw new Error(`"${i}" with value "${t}" should satisfy the constraint "${e}": ${r}.`)};if(e.constraints&&null!=t){const{ExclusiveMaximum:i,ExclusiveMinimum:n,InclusiveMaximum:a,InclusiveMinimum:o,MaxItems:s,MaxLength:l,MinItems:c,MinLength:m,MultipleOf:u,Pattern:f,UniqueItems:p}=e.constraints;if(void 0!==i&&t>=i&&r("ExclusiveMaximum",i),void 0!==n&&t<=n&&r("ExclusiveMinimum",n),void 0!==a&&t>a&&r("InclusiveMaximum",a),void 0!==o&&t<o&&r("InclusiveMinimum",o),void 0!==s&&t.length>s&&r("MaxItems",s),void 0!==l&&t.length>l&&r("MaxLength",l),void 0!==c&&t.length<c&&r("MinItems",c),void 0!==m&&t.length<m&&r("MinLength",m),void 0!==u&&t%u!=0&&r("MultipleOf",u),f){const e="string"==typeof f?new RegExp(f):f;"string"==typeof t&&null!==t.match(e)||r("Pattern",f)}p&&t.some(((e,t,i)=>i.indexOf(e)!==t))&&r("UniqueItems",p)}}serialize(e,t,i,r={xml:{}}){var n,a,o;const s={xml:{rootName:null!==(n=r.xml.rootName)&&void 0!==n?n:"",includeRoot:null!==(a=r.xml.includeRoot)&&void 0!==a&&a,xmlCharKey:null!==(o=r.xml.xmlCharKey)&&void 0!==o?o:interfaces_js_1.XML_CHARKEY}};let l={};const c=e.type.name;i||(i=e.serializedName),null!==c.match(/^Sequence$/i)&&(l=[]),e.isConstant&&(t=e.defaultValue);const{required:m,nullable:u}=e;if(m&&u&&void 0===t)throw new Error(`${i} cannot be undefined.`);if(m&&!u&&null==t)throw new Error(`${i} cannot be null or undefined.`);if(!m&&!1===u&&null===t)throw new Error(`${i} cannot be null.`);if(null==t)l=t;else if(null!==c.match(/^any$/i))l=t;else if(null!==c.match(/^(Number|String|Boolean|Object|Stream|Uuid)$/i))l=serializeBasicTypes(c,i,t);else if(null!==c.match(/^Enum$/i)){l=serializeEnumType(i,e.type.allowedValues,t)}else null!==c.match(/^(Date|DateTime|TimeSpan|DateTimeRfc1123|UnixTime)$/i)?l=serializeDateTypes(c,t,i):null!==c.match(/^ByteArray$/i)?l=serializeByteArrayType(i,t):null!==c.match(/^Base64Url$/i)?l=serializeBase64UrlType(i,t):null!==c.match(/^Sequence$/i)?l=serializeSequenceType(this,e,t,i,Boolean(this.isXML),s):null!==c.match(/^Dictionary$/i)?l=serializeDictionaryType(this,e,t,i,Boolean(this.isXML),s):null!==c.match(/^Composite$/i)&&(l=serializeCompositeType(this,e,t,i,Boolean(this.isXML),s));return l}deserialize(e,t,i,r={xml:{}}){var n,a,o,s;const l={xml:{rootName:null!==(n=r.xml.rootName)&&void 0!==n?n:"",includeRoot:null!==(a=r.xml.includeRoot)&&void 0!==a&&a,xmlCharKey:null!==(o=r.xml.xmlCharKey)&&void 0!==o?o:interfaces_js_1.XML_CHARKEY},ignoreUnknownProperties:null!==(s=r.ignoreUnknownProperties)&&void 0!==s&&s};if(null==t)return this.isXML&&"Sequence"===e.type.name&&!e.xmlIsWrapped&&(t=[]),void 0!==e.defaultValue&&(t=e.defaultValue),t;let c;const m=e.type.name;if(i||(i=e.serializedName),null!==m.match(/^Composite$/i))c=deserializeCompositeType(this,e,t,i,l);else{if(this.isXML){const e=l.xml.xmlCharKey;void 0!==t[interfaces_js_1.XML_ATTRKEY]&&void 0!==t[e]&&(t=t[e])}null!==m.match(/^Number$/i)?(c=parseFloat(t),isNaN(c)&&(c=t)):null!==m.match(/^Boolean$/i)?c="true"===t||"false"!==t&&t:null!==m.match(/^(String|Enum|Object|Stream|Uuid|TimeSpan|any)$/i)?c=t:null!==m.match(/^(Date|DateTime|DateTimeRfc1123)$/i)?c=new Date(t):null!==m.match(/^UnixTime$/i)?c=unixTimeToDate(t):null!==m.match(/^ByteArray$/i)?c=base64.decodeString(t):null!==m.match(/^Base64Url$/i)?c=base64UrlToByteArray(t):null!==m.match(/^Sequence$/i)?c=deserializeSequenceType(this,e,t,i,l):null!==m.match(/^Dictionary$/i)&&(c=deserializeDictionaryType(this,e,t,i,l))}return e.isConstant&&(c=e.defaultValue),c}}function createSerializer(e={},t=!1){return new SerializerImpl(e,t)}function trimEnd(e,t){let i=e.length;for(;i-1>=0&&e[i-1]===t;)--i;return e.substr(0,i)}function bufferToBase64Url(e){if(!e)return;if(!(e instanceof Uint8Array))throw new Error("Please provide an input of type Uint8Array for converting to Base64Url.");return trimEnd(base64.encodeByteArray(e),"=").replace(/\+/g,"-").replace(/\//g,"_")}function base64UrlToByteArray(e){if(e){if(e&&"string"!=typeof e.valueOf())throw new Error("Please provide an input of type string for converting to Uint8Array");return e=e.replace(/-/g,"+").replace(/_/g,"/"),base64.decodeString(e)}}function splitSerializeName(e){const t=[];let i="";if(e){const r=e.split(".");for(const e of r)"\\"===e.charAt(e.length-1)?i+=e.substr(0,e.length-1)+".":(i+=e,t.push(i),i="")}return t}function dateToUnixTime(e){if(e)return"string"==typeof e.valueOf()&&(e=new Date(e)),Math.floor(e.getTime()/1e3)}function unixTimeToDate(e){if(e)return new Date(1e3*e)}function serializeBasicTypes(e,t,i){if(null!=i)if(null!==e.match(/^Number$/i)){if("number"!=typeof i)throw new Error(`${t} with value ${i} must be of type number.`)}else if(null!==e.match(/^String$/i)){if("string"!=typeof i.valueOf())throw new Error(`${t} with value "${i}" must be of type string.`)}else if(null!==e.match(/^Uuid$/i)){if("string"!=typeof i.valueOf()||!(0,utils_js_1.isValidUuid)(i))throw new Error(`${t} with value "${i}" must be of type string and a valid uuid.`)}else if(null!==e.match(/^Boolean$/i)){if("boolean"!=typeof i)throw new Error(`${t} with value ${i} must be of type boolean.`)}else if(null!==e.match(/^Stream$/i)){const e=typeof i;if(!("string"===e||"function"==typeof i.pipe||"function"==typeof i.tee||i instanceof ArrayBuffer||ArrayBuffer.isView(i)||("function"==typeof Blob||"object"==typeof Blob)&&i instanceof Blob||"function"===e))throw new Error(`${t} must be a string, Blob, ArrayBuffer, ArrayBufferView, ReadableStream, or () => ReadableStream.`)}return i}function serializeEnumType(e,t,i){if(!t)throw new Error(`Please provide a set of allowedValues to validate ${e} as an Enum Type.`);if(!t.some((e=>"string"==typeof e.valueOf()?e.toLowerCase()===i.toLowerCase():e===i)))throw new Error(`${i} is not a valid value for ${e}. The valid values are: ${JSON.stringify(t)}.`);return i}function serializeByteArrayType(e,t){if(null!=t){if(!(t instanceof Uint8Array))throw new Error(`${e} must be of type Uint8Array.`);t=base64.encodeByteArray(t)}return t}function serializeBase64UrlType(e,t){if(null!=t){if(!(t instanceof Uint8Array))throw new Error(`${e} must be of type Uint8Array.`);t=bufferToBase64Url(t)}return t}function serializeDateTypes(e,t,i){if(null!=t)if(null!==e.match(/^Date$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in ISO8601 format.`);t=t instanceof Date?t.toISOString().substring(0,10):new Date(t).toISOString().substring(0,10)}else if(null!==e.match(/^DateTime$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in ISO8601 format.`);t=t instanceof Date?t.toISOString():new Date(t).toISOString()}else if(null!==e.match(/^DateTimeRfc1123$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in RFC-1123 format.`);t=t instanceof Date?t.toUTCString():new Date(t).toUTCString()}else if(null!==e.match(/^UnixTime$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in RFC-1123/ISO8601 format for it to be serialized in UnixTime/Epoch format.`);t=dateToUnixTime(t)}else if(null!==e.match(/^TimeSpan$/i)&&!(0,utils_js_1.isDuration)(t))throw new Error(`${i} must be a string in ISO 8601 format. Instead was "${t}".`);return t}function serializeSequenceType(e,t,i,r,n,a){var o;if(!Array.isArray(i))throw new Error(`${r} must be of type Array.`);let s=t.type.element;if(!s||"object"!=typeof s)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${r}.`);"Composite"===s.type.name&&s.type.className&&(s=null!==(o=e.modelMappers[s.type.className])&&void 0!==o?o:s);const l=[];for(let t=0;t<i.length;t++){const o=e.serialize(s,i[t],r,a);if(n&&s.xmlNamespace){const e=s.xmlNamespacePrefix?`xmlns:${s.xmlNamespacePrefix}`:"xmlns";"Composite"===s.type.name?(l[t]=Object.assign({},o),l[t][interfaces_js_1.XML_ATTRKEY]={[e]:s.xmlNamespace}):(l[t]={},l[t][a.xml.xmlCharKey]=o,l[t][interfaces_js_1.XML_ATTRKEY]={[e]:s.xmlNamespace})}else l[t]=o}return l}function serializeDictionaryType(e,t,i,r,n,a){if("object"!=typeof i)throw new Error(`${r} must be of type object.`);const o=t.type.value;if(!o||"object"!=typeof o)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${r}.`);const s={};for(const t of Object.keys(i)){const l=e.serialize(o,i[t],r,a);s[t]=getXmlObjectValue(o,l,n,a)}if(n&&t.xmlNamespace){const e=t.xmlNamespacePrefix?`xmlns:${t.xmlNamespacePrefix}`:"xmlns",i=s;return i[interfaces_js_1.XML_ATTRKEY]={[e]:t.xmlNamespace},i}return s}function resolveAdditionalProperties(e,t,i){const r=t.type.additionalProperties;if(!r&&t.type.className){const r=resolveReferencedMapper(e,t,i);return null==r?void 0:r.type.additionalProperties}return r}function resolveReferencedMapper(e,t,i){const r=t.type.className;if(!r)throw new Error(`Class name for model "${i}" is not provided in the mapper "${JSON.stringify(t,void 0,2)}".`);return e.modelMappers[r]}function resolveModelProperties(e,t,i){let r=t.type.modelProperties;if(!r){const n=resolveReferencedMapper(e,t,i);if(!n)throw new Error(`mapper() cannot be null or undefined for model "${t.type.className}".`);if(r=null==n?void 0:n.type.modelProperties,!r)throw new Error(`modelProperties cannot be null or undefined in the mapper "${JSON.stringify(n)}" of type "${t.type.className}" for object "${i}".`)}return r}function serializeCompositeType(e,t,i,r,n,a){if(getPolymorphicDiscriminatorRecursively(e,t)&&(t=getPolymorphicMapper(e,t,i,"clientName")),null!=i){const o={},s=resolveModelProperties(e,t,r);for(const l of Object.keys(s)){const c=s[l];if(c.readOnly)continue;let m,u=o;if(e.isXML)m=c.xmlIsWrapped?c.xmlName:c.xmlElementName||c.xmlName;else{const e=splitSerializeName(c.serializedName);m=e.pop();for(const t of e){const e=u[t];null==e&&(void 0!==i[l]&&null!==i[l]||void 0!==c.defaultValue)&&(u[t]={}),u=u[t]}}if(null!=u){if(n&&t.xmlNamespace){const e=t.xmlNamespacePrefix?`xmlns:${t.xmlNamespacePrefix}`:"xmlns";u[interfaces_js_1.XML_ATTRKEY]=Object.assign(Object.assign({},u[interfaces_js_1.XML_ATTRKEY]),{[e]:t.xmlNamespace})}const o=""!==c.serializedName?r+"."+c.serializedName:r;let s=i[l];const f=getPolymorphicDiscriminatorRecursively(e,t);f&&f.clientName===l&&null==s&&(s=t.serializedName);const p=e.serialize(c,s,o,a);if(void 0!==p&&null!=m){const e=getXmlObjectValue(c,p,n,a);n&&c.xmlIsAttribute?(u[interfaces_js_1.XML_ATTRKEY]=u[interfaces_js_1.XML_ATTRKEY]||{},u[interfaces_js_1.XML_ATTRKEY][m]=p):n&&c.xmlIsWrapped?u[m]={[c.xmlElementName]:e}:u[m]=e}}}const l=resolveAdditionalProperties(e,t,r);if(l){const t=Object.keys(s);for(const n in i){t.every((e=>e!==n))&&(o[n]=e.serialize(l,i[n],r+'["'+n+'"]',a))}}return o}return i}function getXmlObjectValue(e,t,i,r){if(!i||!e.xmlNamespace)return t;const n={[e.xmlNamespacePrefix?`xmlns:${e.xmlNamespacePrefix}`:"xmlns"]:e.xmlNamespace};if(["Composite"].includes(e.type.name)){if(t[interfaces_js_1.XML_ATTRKEY])return t;{const e=Object.assign({},t);return e[interfaces_js_1.XML_ATTRKEY]=n,e}}const a={};return a[r.xml.xmlCharKey]=t,a[interfaces_js_1.XML_ATTRKEY]=n,a}function isSpecialXmlProperty(e,t){return[interfaces_js_1.XML_ATTRKEY,t.xml.xmlCharKey].includes(e)}function deserializeCompositeType(e,t,i,r,n){var a,o;const s=null!==(a=n.xml.xmlCharKey)&&void 0!==a?a:interfaces_js_1.XML_CHARKEY;getPolymorphicDiscriminatorRecursively(e,t)&&(t=getPolymorphicMapper(e,t,i,"serializedName"));const l=resolveModelProperties(e,t,r);let c={};const m=[];for(const a of Object.keys(l)){const u=l[a],f=splitSerializeName(l[a].serializedName);m.push(f[0]);const{serializedName:p,xmlName:y,xmlElementName:d}=u;let h=r;""!==p&&void 0!==p&&(h=r+"."+p);const x=u.headerCollectionPrefix;if(x){const t={};for(const r of Object.keys(i))r.startsWith(x)&&(t[r.substring(x.length)]=e.deserialize(u.type.value,i[r],h,n)),m.push(r);c[a]=t}else if(e.isXML)if(u.xmlIsAttribute&&i[interfaces_js_1.XML_ATTRKEY])c[a]=e.deserialize(u,i[interfaces_js_1.XML_ATTRKEY][y],h,n);else if(u.xmlIsMsText)void 0!==i[s]?c[a]=i[s]:"string"==typeof i&&(c[a]=i);else{const t=d||y||p;if(u.xmlIsWrapped){const t=i[y],r=null!==(o=null==t?void 0:t[d])&&void 0!==o?o:[];c[a]=e.deserialize(u,r,h,n),m.push(y)}else{const r=i[t];c[a]=e.deserialize(u,r,h,n),m.push(t)}}else{let r,o=i,s=0;for(const e of f){if(!o)break;s++,o=o[e]}null===o&&s<f.length&&(o=void 0),r=o;const m=t.type.polymorphicDiscriminator;let p;if(m&&a===m.clientName&&null==r&&(r=t.serializedName),Array.isArray(i[a])&&""===l[a].serializedName){r=i[a];const t=e.deserialize(u,r,h,n);for(const[e,i]of Object.entries(c))Object.prototype.hasOwnProperty.call(t,e)||(t[e]=i);c=t}else void 0===r&&void 0===u.defaultValue||(p=e.deserialize(u,r,h,n),c[a]=p)}}const u=t.type.additionalProperties;if(u){const t=e=>{for(const t in l){if(splitSerializeName(l[t].serializedName)[0]===e)return!1}return!0};for(const a in i)t(a)&&(c[a]=e.deserialize(u,i[a],r+'["'+a+'"]',n))}else if(i&&!n.ignoreUnknownProperties)for(const e of Object.keys(i))void 0!==c[e]||m.includes(e)||isSpecialXmlProperty(e,n)||(c[e]=i[e]);return c}function deserializeDictionaryType(e,t,i,r,n){const a=t.type.value;if(!a||"object"!=typeof a)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${r}`);if(i){const t={};for(const o of Object.keys(i))t[o]=e.deserialize(a,i[o],r,n);return t}return i}function deserializeSequenceType(e,t,i,r,n){var a;let o=t.type.element;if(!o||"object"!=typeof o)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${r}`);if(i){Array.isArray(i)||(i=[i]),"Composite"===o.type.name&&o.type.className&&(o=null!==(a=e.modelMappers[o.type.className])&&void 0!==a?a:o);const t=[];for(let a=0;a<i.length;a++)t[a]=e.deserialize(o,i[a],`${r}[${a}]`,n);return t}return i}function getIndexDiscriminator(e,t,i){const r=[i];for(;r.length;){const i=r.shift(),n=t===i?t:i+"."+t;if(Object.prototype.hasOwnProperty.call(e,n))return e[n];for(const[t,n]of Object.entries(e))t.startsWith(i+".")&&n.type.uberParent===i&&n.type.className&&r.push(n.type.className)}}function getPolymorphicMapper(e,t,i,r){var n;const a=getPolymorphicDiscriminatorRecursively(e,t);if(a){let o=a[r];if(o){"serializedName"===r&&(o=o.replace(/\\/gi,""));const a=i[o],s=null!==(n=t.type.uberParent)&&void 0!==n?n:t.type.className;if("string"==typeof a&&s){const i=getIndexDiscriminator(e.modelMappers.discriminators,a,s);i&&(t=i)}}}return t}function getPolymorphicDiscriminatorRecursively(e,t){return t.type.polymorphicDiscriminator||getPolymorphicDiscriminatorSafely(e,t.type.uberParent)||getPolymorphicDiscriminatorSafely(e,t.type.className)}function getPolymorphicDiscriminatorSafely(e,t){return t&&e.modelMappers[t]&&e.modelMappers[t].type.polymorphicDiscriminator}exports.createSerializer=createSerializer,exports.MapperTypeNames={Base64Url:"Base64Url",Boolean:"Boolean",ByteArray:"ByteArray",Composite:"Composite",Date:"Date",DateTime:"DateTime",DateTimeRfc1123:"DateTimeRfc1123",Dictionary:"Dictionary",Enum:"Enum",Number:"Number",Object:"Object",Sequence:"Sequence",String:"String",Stream:"Stream",TimeSpan:"TimeSpan",UnixTime:"UnixTime"};