"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ServiceClient=void 0;const core_rest_pipeline_1=require("@azure/core-rest-pipeline"),pipeline_js_1=require("./pipeline.js"),utils_js_1=require("./utils.js"),httpClientCache_js_1=require("./httpClientCache.js"),operationHelpers_js_1=require("./operationHelpers.js"),urlHelpers_js_1=require("./urlHelpers.js"),interfaceHelpers_js_1=require("./interfaceHelpers.js"),log_js_1=require("./log.js");class ServiceClient{constructor(e={}){var t,n;if(this._requestContentType=e.requestContentType,this._endpoint=null!==(t=e.endpoint)&&void 0!==t?t:e.baseUri,e.baseUri&&log_js_1.logger.warning("The baseUri option for SDK Clients has been deprecated, please use endpoint instead."),this._allowInsecureConnection=e.allowInsecureConnection,this._httpClient=e.httpClient||(0,httpClientCache_js_1.getCachedDefaultHttpClient)(),this.pipeline=e.pipeline||createDefaultPipeline(e),null===(n=e.additionalPolicies)||void 0===n?void 0:n.length)for(const{policy:t,position:n}of e.additionalPolicies){const e="perRetry"===n?"Sign":void 0;this.pipeline.addPolicy(t,{afterPhase:e})}}async sendRequest(e){return this.pipeline.sendRequest(this._httpClient,e)}async sendOperationRequest(e,t){const n=t.baseUrl||this._endpoint;if(!n)throw new Error("If operationSpec.baseUrl is not specified, then the ServiceClient must have a endpoint string property that contains the base URL to use.");const s=(0,urlHelpers_js_1.getRequestUrl)(n,t,e,this),i=(0,core_rest_pipeline_1.createPipelineRequest)({url:s});i.method=t.httpMethod;const o=(0,operationHelpers_js_1.getOperationRequestInfo)(i);o.operationSpec=t,o.operationArguments=e;const r=t.contentType||this._requestContentType;r&&t.requestBody&&i.headers.set("Content-Type",r);const l=e.options;if(l){const e=l.requestOptions;e&&(e.timeout&&(i.timeout=e.timeout),e.onUploadProgress&&(i.onUploadProgress=e.onUploadProgress),e.onDownloadProgress&&(i.onDownloadProgress=e.onDownloadProgress),void 0!==e.shouldDeserialize&&(o.shouldDeserialize=e.shouldDeserialize),e.allowInsecureConnection&&(i.allowInsecureConnection=!0)),l.abortSignal&&(i.abortSignal=l.abortSignal),l.tracingOptions&&(i.tracingOptions=l.tracingOptions)}this._allowInsecureConnection&&(i.allowInsecureConnection=!0),void 0===i.streamResponseStatusCodes&&(i.streamResponseStatusCodes=(0,interfaceHelpers_js_1.getStreamingResponseStatusCodes)(t));try{const e=await this.sendRequest(i),n=(0,utils_js_1.flattenResponse)(e,t.responses[e.status]);return(null==l?void 0:l.onResponse)&&l.onResponse(e,n),n}catch(e){if("object"==typeof e&&(null==e?void 0:e.response)){const n=e.response,s=(0,utils_js_1.flattenResponse)(n,t.responses[e.statusCode]||t.responses.default);e.details=s,(null==l?void 0:l.onResponse)&&l.onResponse(n,s,e)}throw e}}}function createDefaultPipeline(e){const t=getCredentialScopes(e),n=e.credential&&t?{credentialScopes:t,credential:e.credential}:void 0;return(0,pipeline_js_1.createClientPipeline)(Object.assign(Object.assign({},e),{credentialOptions:n}))}function getCredentialScopes(e){if(e.credentialScopes)return e.credentialScopes;if(e.endpoint)return`${e.endpoint}/.default`;if(e.baseUri)return`${e.baseUri}/.default`;if(e.credential&&!e.credentialScopes)throw new Error("When using credentials, the ServiceClientOptions must contain either a endpoint or a credentialScopes. Unable to create a bearerTokenAuthenticationPolicy")}exports.ServiceClient=ServiceClient;