import*as base64 from"./base64.js";import{XML_ATTRKEY,XML_CHARKEY}from"./interfaces.js";import{isDuration,isValidUuid}from"./utils.js";class SerializerImpl{constructor(e={},t=!1){this.modelMappers=e,this.isXML=t}validateConstraints(e,t,i){const r=(e,r)=>{throw new Error(`"${i}" with value "${t}" should satisfy the constraint "${e}": ${r}.`)};if(e.constraints&&null!=t){const{ExclusiveMaximum:i,ExclusiveMinimum:n,InclusiveMaximum:o,InclusiveMinimum:a,MaxItems:l,MaxLength:s,MinItems:m,MinLength:c,MultipleOf:u,Pattern:f,UniqueItems:p}=e.constraints;if(void 0!==i&&t>=i&&r("ExclusiveMaximum",i),void 0!==n&&t<=n&&r("ExclusiveMinimum",n),void 0!==o&&t>o&&r("InclusiveMaximum",o),void 0!==a&&t<a&&r("InclusiveMinimum",a),void 0!==l&&t.length>l&&r("MaxItems",l),void 0!==s&&t.length>s&&r("MaxLength",s),void 0!==m&&t.length<m&&r("MinItems",m),void 0!==c&&t.length<c&&r("MinLength",c),void 0!==u&&t%u!=0&&r("MultipleOf",u),f){const e="string"==typeof f?new RegExp(f):f;"string"==typeof t&&null!==t.match(e)||r("Pattern",f)}p&&t.some(((e,t,i)=>i.indexOf(e)!==t))&&r("UniqueItems",p)}}serialize(e,t,i,r={xml:{}}){var n,o,a;const l={xml:{rootName:null!==(n=r.xml.rootName)&&void 0!==n?n:"",includeRoot:null!==(o=r.xml.includeRoot)&&void 0!==o&&o,xmlCharKey:null!==(a=r.xml.xmlCharKey)&&void 0!==a?a:XML_CHARKEY}};let s={};const m=e.type.name;i||(i=e.serializedName),null!==m.match(/^Sequence$/i)&&(s=[]),e.isConstant&&(t=e.defaultValue);const{required:c,nullable:u}=e;if(c&&u&&void 0===t)throw new Error(`${i} cannot be undefined.`);if(c&&!u&&null==t)throw new Error(`${i} cannot be null or undefined.`);if(!c&&!1===u&&null===t)throw new Error(`${i} cannot be null.`);if(null==t)s=t;else if(null!==m.match(/^any$/i))s=t;else if(null!==m.match(/^(Number|String|Boolean|Object|Stream|Uuid)$/i))s=serializeBasicTypes(m,i,t);else if(null!==m.match(/^Enum$/i)){s=serializeEnumType(i,e.type.allowedValues,t)}else null!==m.match(/^(Date|DateTime|TimeSpan|DateTimeRfc1123|UnixTime)$/i)?s=serializeDateTypes(m,t,i):null!==m.match(/^ByteArray$/i)?s=serializeByteArrayType(i,t):null!==m.match(/^Base64Url$/i)?s=serializeBase64UrlType(i,t):null!==m.match(/^Sequence$/i)?s=serializeSequenceType(this,e,t,i,Boolean(this.isXML),l):null!==m.match(/^Dictionary$/i)?s=serializeDictionaryType(this,e,t,i,Boolean(this.isXML),l):null!==m.match(/^Composite$/i)&&(s=serializeCompositeType(this,e,t,i,Boolean(this.isXML),l));return s}deserialize(e,t,i,r={xml:{}}){var n,o,a,l;const s={xml:{rootName:null!==(n=r.xml.rootName)&&void 0!==n?n:"",includeRoot:null!==(o=r.xml.includeRoot)&&void 0!==o&&o,xmlCharKey:null!==(a=r.xml.xmlCharKey)&&void 0!==a?a:XML_CHARKEY},ignoreUnknownProperties:null!==(l=r.ignoreUnknownProperties)&&void 0!==l&&l};if(null==t)return this.isXML&&"Sequence"===e.type.name&&!e.xmlIsWrapped&&(t=[]),void 0!==e.defaultValue&&(t=e.defaultValue),t;let m;const c=e.type.name;if(i||(i=e.serializedName),null!==c.match(/^Composite$/i))m=deserializeCompositeType(this,e,t,i,s);else{if(this.isXML){const e=s.xml.xmlCharKey;void 0!==t[XML_ATTRKEY]&&void 0!==t[e]&&(t=t[e])}null!==c.match(/^Number$/i)?(m=parseFloat(t),isNaN(m)&&(m=t)):null!==c.match(/^Boolean$/i)?m="true"===t||"false"!==t&&t:null!==c.match(/^(String|Enum|Object|Stream|Uuid|TimeSpan|any)$/i)?m=t:null!==c.match(/^(Date|DateTime|DateTimeRfc1123)$/i)?m=new Date(t):null!==c.match(/^UnixTime$/i)?m=unixTimeToDate(t):null!==c.match(/^ByteArray$/i)?m=base64.decodeString(t):null!==c.match(/^Base64Url$/i)?m=base64UrlToByteArray(t):null!==c.match(/^Sequence$/i)?m=deserializeSequenceType(this,e,t,i,s):null!==c.match(/^Dictionary$/i)&&(m=deserializeDictionaryType(this,e,t,i,s))}return e.isConstant&&(m=e.defaultValue),m}}export function createSerializer(e={},t=!1){return new SerializerImpl(e,t)}function trimEnd(e,t){let i=e.length;for(;i-1>=0&&e[i-1]===t;)--i;return e.substr(0,i)}function bufferToBase64Url(e){if(!e)return;if(!(e instanceof Uint8Array))throw new Error("Please provide an input of type Uint8Array for converting to Base64Url.");return trimEnd(base64.encodeByteArray(e),"=").replace(/\+/g,"-").replace(/\//g,"_")}function base64UrlToByteArray(e){if(e){if(e&&"string"!=typeof e.valueOf())throw new Error("Please provide an input of type string for converting to Uint8Array");return e=e.replace(/-/g,"+").replace(/_/g,"/"),base64.decodeString(e)}}function splitSerializeName(e){const t=[];let i="";if(e){const r=e.split(".");for(const e of r)"\\"===e.charAt(e.length-1)?i+=e.substr(0,e.length-1)+".":(i+=e,t.push(i),i="")}return t}function dateToUnixTime(e){if(e)return"string"==typeof e.valueOf()&&(e=new Date(e)),Math.floor(e.getTime()/1e3)}function unixTimeToDate(e){if(e)return new Date(1e3*e)}function serializeBasicTypes(e,t,i){if(null!=i)if(null!==e.match(/^Number$/i)){if("number"!=typeof i)throw new Error(`${t} with value ${i} must be of type number.`)}else if(null!==e.match(/^String$/i)){if("string"!=typeof i.valueOf())throw new Error(`${t} with value "${i}" must be of type string.`)}else if(null!==e.match(/^Uuid$/i)){if("string"!=typeof i.valueOf()||!isValidUuid(i))throw new Error(`${t} with value "${i}" must be of type string and a valid uuid.`)}else if(null!==e.match(/^Boolean$/i)){if("boolean"!=typeof i)throw new Error(`${t} with value ${i} must be of type boolean.`)}else if(null!==e.match(/^Stream$/i)){const e=typeof i;if(!("string"===e||"function"==typeof i.pipe||"function"==typeof i.tee||i instanceof ArrayBuffer||ArrayBuffer.isView(i)||("function"==typeof Blob||"object"==typeof Blob)&&i instanceof Blob||"function"===e))throw new Error(`${t} must be a string, Blob, ArrayBuffer, ArrayBufferView, ReadableStream, or () => ReadableStream.`)}return i}function serializeEnumType(e,t,i){if(!t)throw new Error(`Please provide a set of allowedValues to validate ${e} as an Enum Type.`);if(!t.some((e=>"string"==typeof e.valueOf()?e.toLowerCase()===i.toLowerCase():e===i)))throw new Error(`${i} is not a valid value for ${e}. The valid values are: ${JSON.stringify(t)}.`);return i}function serializeByteArrayType(e,t){if(null!=t){if(!(t instanceof Uint8Array))throw new Error(`${e} must be of type Uint8Array.`);t=base64.encodeByteArray(t)}return t}function serializeBase64UrlType(e,t){if(null!=t){if(!(t instanceof Uint8Array))throw new Error(`${e} must be of type Uint8Array.`);t=bufferToBase64Url(t)}return t}function serializeDateTypes(e,t,i){if(null!=t)if(null!==e.match(/^Date$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in ISO8601 format.`);t=t instanceof Date?t.toISOString().substring(0,10):new Date(t).toISOString().substring(0,10)}else if(null!==e.match(/^DateTime$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in ISO8601 format.`);t=t instanceof Date?t.toISOString():new Date(t).toISOString()}else if(null!==e.match(/^DateTimeRfc1123$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in RFC-1123 format.`);t=t instanceof Date?t.toUTCString():new Date(t).toUTCString()}else if(null!==e.match(/^UnixTime$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in RFC-1123/ISO8601 format for it to be serialized in UnixTime/Epoch format.`);t=dateToUnixTime(t)}else if(null!==e.match(/^TimeSpan$/i)&&!isDuration(t))throw new Error(`${i} must be a string in ISO 8601 format. Instead was "${t}".`);return t}function serializeSequenceType(e,t,i,r,n,o){var a;if(!Array.isArray(i))throw new Error(`${r} must be of type Array.`);let l=t.type.element;if(!l||"object"!=typeof l)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${r}.`);"Composite"===l.type.name&&l.type.className&&(l=null!==(a=e.modelMappers[l.type.className])&&void 0!==a?a:l);const s=[];for(let t=0;t<i.length;t++){const a=e.serialize(l,i[t],r,o);if(n&&l.xmlNamespace){const e=l.xmlNamespacePrefix?`xmlns:${l.xmlNamespacePrefix}`:"xmlns";"Composite"===l.type.name?(s[t]=Object.assign({},a),s[t][XML_ATTRKEY]={[e]:l.xmlNamespace}):(s[t]={},s[t][o.xml.xmlCharKey]=a,s[t][XML_ATTRKEY]={[e]:l.xmlNamespace})}else s[t]=a}return s}function serializeDictionaryType(e,t,i,r,n,o){if("object"!=typeof i)throw new Error(`${r} must be of type object.`);const a=t.type.value;if(!a||"object"!=typeof a)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${r}.`);const l={};for(const t of Object.keys(i)){const s=e.serialize(a,i[t],r,o);l[t]=getXmlObjectValue(a,s,n,o)}if(n&&t.xmlNamespace){const e=t.xmlNamespacePrefix?`xmlns:${t.xmlNamespacePrefix}`:"xmlns",i=l;return i[XML_ATTRKEY]={[e]:t.xmlNamespace},i}return l}function resolveAdditionalProperties(e,t,i){const r=t.type.additionalProperties;if(!r&&t.type.className){const r=resolveReferencedMapper(e,t,i);return null==r?void 0:r.type.additionalProperties}return r}function resolveReferencedMapper(e,t,i){const r=t.type.className;if(!r)throw new Error(`Class name for model "${i}" is not provided in the mapper "${JSON.stringify(t,void 0,2)}".`);return e.modelMappers[r]}function resolveModelProperties(e,t,i){let r=t.type.modelProperties;if(!r){const n=resolveReferencedMapper(e,t,i);if(!n)throw new Error(`mapper() cannot be null or undefined for model "${t.type.className}".`);if(r=null==n?void 0:n.type.modelProperties,!r)throw new Error(`modelProperties cannot be null or undefined in the mapper "${JSON.stringify(n)}" of type "${t.type.className}" for object "${i}".`)}return r}function serializeCompositeType(e,t,i,r,n,o){if(getPolymorphicDiscriminatorRecursively(e,t)&&(t=getPolymorphicMapper(e,t,i,"clientName")),null!=i){const a={},l=resolveModelProperties(e,t,r);for(const s of Object.keys(l)){const m=l[s];if(m.readOnly)continue;let c,u=a;if(e.isXML)c=m.xmlIsWrapped?m.xmlName:m.xmlElementName||m.xmlName;else{const e=splitSerializeName(m.serializedName);c=e.pop();for(const t of e){const e=u[t];null==e&&(void 0!==i[s]&&null!==i[s]||void 0!==m.defaultValue)&&(u[t]={}),u=u[t]}}if(null!=u){if(n&&t.xmlNamespace){const e=t.xmlNamespacePrefix?`xmlns:${t.xmlNamespacePrefix}`:"xmlns";u[XML_ATTRKEY]=Object.assign(Object.assign({},u[XML_ATTRKEY]),{[e]:t.xmlNamespace})}const a=""!==m.serializedName?r+"."+m.serializedName:r;let l=i[s];const f=getPolymorphicDiscriminatorRecursively(e,t);f&&f.clientName===s&&null==l&&(l=t.serializedName);const p=e.serialize(m,l,a,o);if(void 0!==p&&null!=c){const e=getXmlObjectValue(m,p,n,o);n&&m.xmlIsAttribute?(u[XML_ATTRKEY]=u[XML_ATTRKEY]||{},u[XML_ATTRKEY][c]=p):n&&m.xmlIsWrapped?u[c]={[m.xmlElementName]:e}:u[c]=e}}}const s=resolveAdditionalProperties(e,t,r);if(s){const t=Object.keys(l);for(const n in i){t.every((e=>e!==n))&&(a[n]=e.serialize(s,i[n],r+'["'+n+'"]',o))}}return a}return i}function getXmlObjectValue(e,t,i,r){if(!i||!e.xmlNamespace)return t;const n={[e.xmlNamespacePrefix?`xmlns:${e.xmlNamespacePrefix}`:"xmlns"]:e.xmlNamespace};if(["Composite"].includes(e.type.name)){if(t[XML_ATTRKEY])return t;{const e=Object.assign({},t);return e[XML_ATTRKEY]=n,e}}const o={};return o[r.xml.xmlCharKey]=t,o[XML_ATTRKEY]=n,o}function isSpecialXmlProperty(e,t){return[XML_ATTRKEY,t.xml.xmlCharKey].includes(e)}function deserializeCompositeType(e,t,i,r,n){var o,a;const l=null!==(o=n.xml.xmlCharKey)&&void 0!==o?o:XML_CHARKEY;getPolymorphicDiscriminatorRecursively(e,t)&&(t=getPolymorphicMapper(e,t,i,"serializedName"));const s=resolveModelProperties(e,t,r);let m={};const c=[];for(const o of Object.keys(s)){const u=s[o],f=splitSerializeName(s[o].serializedName);c.push(f[0]);const{serializedName:p,xmlName:y,xmlElementName:d}=u;let h=r;""!==p&&void 0!==p&&(h=r+"."+p);const x=u.headerCollectionPrefix;if(x){const t={};for(const r of Object.keys(i))r.startsWith(x)&&(t[r.substring(x.length)]=e.deserialize(u.type.value,i[r],h,n)),c.push(r);m[o]=t}else if(e.isXML)if(u.xmlIsAttribute&&i[XML_ATTRKEY])m[o]=e.deserialize(u,i[XML_ATTRKEY][y],h,n);else if(u.xmlIsMsText)void 0!==i[l]?m[o]=i[l]:"string"==typeof i&&(m[o]=i);else{const t=d||y||p;if(u.xmlIsWrapped){const t=i[y],r=null!==(a=null==t?void 0:t[d])&&void 0!==a?a:[];m[o]=e.deserialize(u,r,h,n),c.push(y)}else{const r=i[t];m[o]=e.deserialize(u,r,h,n),c.push(t)}}else{let r,a=i,l=0;for(const e of f){if(!a)break;l++,a=a[e]}null===a&&l<f.length&&(a=void 0),r=a;const c=t.type.polymorphicDiscriminator;let p;if(c&&o===c.clientName&&null==r&&(r=t.serializedName),Array.isArray(i[o])&&""===s[o].serializedName){r=i[o];const t=e.deserialize(u,r,h,n);for(const[e,i]of Object.entries(m))Object.prototype.hasOwnProperty.call(t,e)||(t[e]=i);m=t}else void 0===r&&void 0===u.defaultValue||(p=e.deserialize(u,r,h,n),m[o]=p)}}const u=t.type.additionalProperties;if(u){const t=e=>{for(const t in s){if(splitSerializeName(s[t].serializedName)[0]===e)return!1}return!0};for(const o in i)t(o)&&(m[o]=e.deserialize(u,i[o],r+'["'+o+'"]',n))}else if(i&&!n.ignoreUnknownProperties)for(const e of Object.keys(i))void 0!==m[e]||c.includes(e)||isSpecialXmlProperty(e,n)||(m[e]=i[e]);return m}function deserializeDictionaryType(e,t,i,r,n){const o=t.type.value;if(!o||"object"!=typeof o)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${r}`);if(i){const t={};for(const a of Object.keys(i))t[a]=e.deserialize(o,i[a],r,n);return t}return i}function deserializeSequenceType(e,t,i,r,n){var o;let a=t.type.element;if(!a||"object"!=typeof a)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${r}`);if(i){Array.isArray(i)||(i=[i]),"Composite"===a.type.name&&a.type.className&&(a=null!==(o=e.modelMappers[a.type.className])&&void 0!==o?o:a);const t=[];for(let o=0;o<i.length;o++)t[o]=e.deserialize(a,i[o],`${r}[${o}]`,n);return t}return i}function getIndexDiscriminator(e,t,i){const r=[i];for(;r.length;){const i=r.shift(),n=t===i?t:i+"."+t;if(Object.prototype.hasOwnProperty.call(e,n))return e[n];for(const[t,n]of Object.entries(e))t.startsWith(i+".")&&n.type.uberParent===i&&n.type.className&&r.push(n.type.className)}}function getPolymorphicMapper(e,t,i,r){var n;const o=getPolymorphicDiscriminatorRecursively(e,t);if(o){let a=o[r];if(a){"serializedName"===r&&(a=a.replace(/\\/gi,""));const o=i[a],l=null!==(n=t.type.uberParent)&&void 0!==n?n:t.type.className;if("string"==typeof o&&l){const i=getIndexDiscriminator(e.modelMappers.discriminators,o,l);i&&(t=i)}}}return t}function getPolymorphicDiscriminatorRecursively(e,t){return t.type.polymorphicDiscriminator||getPolymorphicDiscriminatorSafely(e,t.type.uberParent)||getPolymorphicDiscriminatorSafely(e,t.type.className)}function getPolymorphicDiscriminatorSafely(e,t){return t&&e.modelMappers[t]&&e.modelMappers[t].type.polymorphicDiscriminator}export const MapperTypeNames={Base64Url:"Base64Url",Boolean:"Boolean",ByteArray:"ByteArray",Composite:"Composite",Date:"Date",DateTime:"DateTime",DateTimeRfc1123:"DateTimeRfc1123",Dictionary:"Dictionary",Enum:"Enum",Number:"Number",Object:"Object",Sequence:"Sequence",String:"String",Stream:"Stream",TimeSpan:"TimeSpan",UnixTime:"UnixTime"};