import{createPipelineRequest}from"@azure/core-rest-pipeline";import{createClientPipeline}from"./pipeline.js";import{flattenResponse}from"./utils.js";import{getCachedDefaultHttpClient}from"./httpClientCache.js";import{getOperationRequestInfo}from"./operationHelpers.js";import{getRequestUrl}from"./urlHelpers.js";import{getStreamingResponseStatusCodes}from"./interfaceHelpers.js";import{logger}from"./log.js";export class ServiceClient{constructor(e={}){var t,n;if(this._requestContentType=e.requestContentType,this._endpoint=null!==(t=e.endpoint)&&void 0!==t?t:e.baseUri,e.baseUri&&logger.warning("The baseUri option for SDK Clients has been deprecated, please use endpoint instead."),this._allowInsecureConnection=e.allowInsecureConnection,this._httpClient=e.httpClient||getCachedDefaultHttpClient(),this.pipeline=e.pipeline||createDefaultPipeline(e),null===(n=e.additionalPolicies)||void 0===n?void 0:n.length)for(const{policy:t,position:n}of e.additionalPolicies){const e="perRetry"===n?"Sign":void 0;this.pipeline.addPolicy(t,{afterPhase:e})}}async sendRequest(e){return this.pipeline.sendRequest(this._httpClient,e)}async sendOperationRequest(e,t){const n=t.baseUrl||this._endpoint;if(!n)throw new Error("If operationSpec.baseUrl is not specified, then the ServiceClient must have a endpoint string property that contains the base URL to use.");const o=getRequestUrl(n,t,e,this),s=createPipelineRequest({url:o});s.method=t.httpMethod;const i=getOperationRequestInfo(s);i.operationSpec=t,i.operationArguments=e;const r=t.contentType||this._requestContentType;r&&t.requestBody&&s.headers.set("Content-Type",r);const a=e.options;if(a){const e=a.requestOptions;e&&(e.timeout&&(s.timeout=e.timeout),e.onUploadProgress&&(s.onUploadProgress=e.onUploadProgress),e.onDownloadProgress&&(s.onDownloadProgress=e.onDownloadProgress),void 0!==e.shouldDeserialize&&(i.shouldDeserialize=e.shouldDeserialize),e.allowInsecureConnection&&(s.allowInsecureConnection=!0)),a.abortSignal&&(s.abortSignal=a.abortSignal),a.tracingOptions&&(s.tracingOptions=a.tracingOptions)}this._allowInsecureConnection&&(s.allowInsecureConnection=!0),void 0===s.streamResponseStatusCodes&&(s.streamResponseStatusCodes=getStreamingResponseStatusCodes(t));try{const e=await this.sendRequest(s),n=flattenResponse(e,t.responses[e.status]);return(null==a?void 0:a.onResponse)&&a.onResponse(e,n),n}catch(e){if("object"==typeof e&&(null==e?void 0:e.response)){const n=e.response,o=flattenResponse(n,t.responses[e.statusCode]||t.responses.default);e.details=o,(null==a?void 0:a.onResponse)&&a.onResponse(n,o,e)}throw e}}}function createDefaultPipeline(e){const t=getCredentialScopes(e),n=e.credential&&t?{credentialScopes:t,credential:e.credential}:void 0;return createClientPipeline(Object.assign(Object.assign({},e),{credentialOptions:n}))}function getCredentialScopes(e){if(e.credentialScopes)return e.credentialScopes;if(e.endpoint)return`${e.endpoint}/.default`;if(e.baseUri)return`${e.baseUri}/.default`;if(e.credential&&!e.credentialScopes)throw new Error("When using credentials, the ServiceClientOptions must contain either a endpoint or a credentialScopes. Unable to create a bearerTokenAuthenticationPolicy")}