import{BaseRequestPolicy}from"./requestPolicy";import{XML_CHARKEY}from"../util/serializer.common";import{MapperType}from"../serializer";import{RestError}from"../restError";import{parseXML}from"../util/xml";export function deserializationPolicy(e,s){return{create:(r,t)=>new DeserializationPolicy(r,t,e,s)}}export const defaultJsonContentTypes=["application/json","text/json"];export const defaultXmlContentTypes=["application/xml","application/atom+xml"];export const DefaultDeserializationOptions={expectedContentTypes:{json:defaultJsonContentTypes,xml:defaultXmlContentTypes}};export class DeserializationPolicy extends BaseRequestPolicy{constructor(e,s,r,t={}){var o;super(e,s),this.jsonContentTypes=r&&r.json||defaultJsonContentTypes,this.xmlContentTypes=r&&r.xml||defaultXmlContentTypes,this.xmlCharKey=null!==(o=t.xmlCharKey)&&void 0!==o?o:XML_CHARKEY}async sendRequest(e){return this._nextPolicy.sendRequest(e).then((e=>deserializeResponseBody(this.jsonContentTypes,this.xmlContentTypes,e,{xmlCharKey:this.xmlCharKey})))}}function getOperationResponse(e){let s;const r=e.request,t=r.operationSpec;if(t){const o=r.operationResponseGetter;s=o?o(t,e):t.responses[e.status]}return s}function shouldDeserializeResponse(e){const s=e.request.shouldDeserialize;let r;return r=void 0===s||("boolean"==typeof s?s:s(e)),r}export function deserializeResponseBody(e,s,r,t={}){var o,n,a;const i={rootName:null!==(o=t.rootName)&&void 0!==o?o:"",includeRoot:null!==(n=t.includeRoot)&&void 0!==n&&n,xmlCharKey:null!==(a=t.xmlCharKey)&&void 0!==a?a:XML_CHARKEY};return parse(e,s,r,i).then((e=>{if(!shouldDeserializeResponse(e))return e;const s=e.request.operationSpec;if(!s||!s.responses)return e;const o=getOperationResponse(e),{error:n,shouldReturnResponse:a}=handleErrorResponse(e,s,o);if(n)throw n;if(a)return e;if(o){if(o.bodyMapper){let r=e.parsedBody;s.isXML&&o.bodyMapper.type.name===MapperType.Sequence&&(r="object"==typeof r?r[o.bodyMapper.xmlElementName]:[]);try{e.parsedBody=s.serializer.deserialize(o.bodyMapper,r,"operationRes.parsedBody",t)}catch(s){throw new RestError(`Error ${s} occurred in deserializing the responseBody - ${e.bodyAsText}`,void 0,e.status,e.request,e)}}else"HEAD"===s.httpMethod&&(e.parsedBody=r.status>=200&&r.status<300);o.headersMapper&&(e.parsedHeaders=s.serializer.deserialize(o.headersMapper,e.headers.toJson(),"operationRes.parsedHeaders",t))}return e}))}function isOperationSpecEmpty(e){const s=Object.keys(e.responses);return 0===s.length||1===s.length&&"default"===s[0]}function handleErrorResponse(e,s,r){var t;const o=200<=e.status&&e.status<300;if(isOperationSpecEmpty(s)?o:!!r){if(!r)return{error:null,shouldReturnResponse:!1};if(!r.isError)return{error:null,shouldReturnResponse:!1}}const n=null!=r?r:s.responses.default,a=(null===(t=e.request.streamResponseStatusCodes)||void 0===t?void 0:t.has(e.status))||e.request.streamResponseBody?`Unexpected status code: ${e.status}`:e.bodyAsText,i=new RestError(a,void 0,e.status,e.request,e);if(!n)throw i;const p=n.bodyMapper,d=n.headersMapper;try{if(e.parsedBody){const r=e.parsedBody;let t;if(p){let e=r;s.isXML&&p.type.name===MapperType.Sequence&&(e="object"==typeof r?r[p.xmlElementName]:[]),t=s.serializer.deserialize(p,e,"error.response.parsedBody")}const o=r.error||t||r;i.code=o.code,o.message&&(i.message=o.message),p&&(i.response.parsedBody=t)}e.headers&&d&&(i.response.parsedHeaders=s.serializer.deserialize(d,e.headers.toJson(),"operationRes.parsedHeaders"))}catch(s){i.message=`Error "${s.message}" occurred in deserializing the responseBody - "${e.bodyAsText}" for the default response.`}return{error:i,shouldReturnResponse:!1}}function parse(e,s,r,t){var o;const n=e=>{const s=`Error "${e}" occurred while parsing the response body - ${r.bodyAsText}.`,t=e.code||RestError.PARSE_ERROR,o=new RestError(s,t,r.status,r.request,r);return Promise.reject(o)};if(!((null===(o=r.request.streamResponseStatusCodes)||void 0===o?void 0:o.has(r.status))||r.request.streamResponseBody)&&r.bodyAsText){const o=r.bodyAsText,a=r.headers.get("Content-Type")||"",i=a?a.split(";").map((e=>e.toLowerCase())):[];if(0===i.length||i.some((s=>-1!==e.indexOf(s))))return new Promise((e=>{r.parsedBody=JSON.parse(o),e(r)})).catch(n);if(i.some((e=>-1!==s.indexOf(e))))return parseXML(o,t).then((e=>(r.parsedBody=e,r))).catch(n)}return Promise.resolve(r)}