import*as base64 from"./util/base64";import*as utils from"./util/utils";import{XML_ATTRKEY,XML_CHARKEY}from"./util/serializer.common";export class Serializer{constructor(e={},t){this.modelMappers=e,this.isXML=t}validateConstraints(e,t,i){const r=(e,r)=>{throw new Error(`"${i}" with value "${t}" should satisfy the constraint "${e}": ${r}.`)};if(e.constraints&&null!=t){const i=t,{ExclusiveMaximum:n,ExclusiveMinimum:o,InclusiveMaximum:a,InclusiveMinimum:l,MaxItems:s,MaxLength:c,MinItems:u,MinLength:m,MultipleOf:f,Pattern:p,UniqueItems:y}=e.constraints;null!=n&&i>=n&&r("ExclusiveMaximum",n),null!=o&&i<=o&&r("ExclusiveMinimum",o),null!=a&&i>a&&r("InclusiveMaximum",a),null!=l&&i<l&&r("InclusiveMinimum",l);const d=t;if(null!=s&&d.length>s&&r("MaxItems",s),null!=c&&d.length>c&&r("MaxLength",c),null!=u&&d.length<u&&r("MinItems",u),null!=m&&d.length<m&&r("MinLength",m),null!=f&&i%f!=0&&r("MultipleOf",f),p){const e="string"==typeof p?new RegExp(p):p;"string"==typeof t&&null!==t.match(e)||r("Pattern",p)}y&&d.some(((e,t,i)=>i.indexOf(e)!==t))&&r("UniqueItems",y)}}serialize(e,t,i,r={}){var n,o,a;const l={rootName:null!==(n=r.rootName)&&void 0!==n?n:"",includeRoot:null!==(o=r.includeRoot)&&void 0!==o&&o,xmlCharKey:null!==(a=r.xmlCharKey)&&void 0!==a?a:XML_CHARKEY};let s={};const c=e.type.name;i||(i=e.serializedName),null!==c.match(/^Sequence$/i)&&(s=[]),e.isConstant&&(t=e.defaultValue);const{required:u,nullable:m}=e;if(u&&m&&void 0===t)throw new Error(`${i} cannot be undefined.`);if(u&&!m&&null==t)throw new Error(`${i} cannot be null or undefined.`);if(!u&&!1===m&&null===t)throw new Error(`${i} cannot be null.`);if(null==t)s=t;else if(null!==c.match(/^any$/i))s=t;else if(null!==c.match(/^(Number|String|Boolean|Object|Stream|Uuid)$/i))s=serializeBasicTypes(c,i,t);else if(null!==c.match(/^Enum$/i)){s=serializeEnumType(i,e.type.allowedValues,t)}else null!==c.match(/^(Date|DateTime|TimeSpan|DateTimeRfc1123|UnixTime)$/i)?s=serializeDateTypes(c,t,i):null!==c.match(/^ByteArray$/i)?s=serializeByteArrayType(i,t):null!==c.match(/^Base64Url$/i)?s=serializeBase64UrlType(i,t):null!==c.match(/^Sequence$/i)?s=serializeSequenceType(this,e,t,i,Boolean(this.isXML),l):null!==c.match(/^Dictionary$/i)?s=serializeDictionaryType(this,e,t,i,Boolean(this.isXML),l):null!==c.match(/^Composite$/i)&&(s=serializeCompositeType(this,e,t,i,Boolean(this.isXML),l));return s}deserialize(e,t,i,r={}){var n,o,a;const l={rootName:null!==(n=r.rootName)&&void 0!==n?n:"",includeRoot:null!==(o=r.includeRoot)&&void 0!==o&&o,xmlCharKey:null!==(a=r.xmlCharKey)&&void 0!==a?a:XML_CHARKEY};if(null==t)return this.isXML&&"Sequence"===e.type.name&&!e.xmlIsWrapped&&(t=[]),void 0!==e.defaultValue&&(t=e.defaultValue),t;let s;const c=e.type.name;if(i||(i=e.serializedName),null!==c.match(/^Composite$/i))s=deserializeCompositeType(this,e,t,i,l);else{if(this.isXML){const e=l.xmlCharKey,i=t;null!=i[XML_ATTRKEY]&&null!=i[e]&&(t=i[e])}null!==c.match(/^Number$/i)?(s=parseFloat(t),isNaN(s)&&(s=t)):null!==c.match(/^Boolean$/i)?s="true"===t||"false"!==t&&t:null!==c.match(/^(String|Enum|Object|Stream|Uuid|TimeSpan|any)$/i)?s=t:null!==c.match(/^(Date|DateTime|DateTimeRfc1123)$/i)?s=new Date(t):null!==c.match(/^UnixTime$/i)?s=unixTimeToDate(t):null!==c.match(/^ByteArray$/i)?s=base64.decodeString(t):null!==c.match(/^Base64Url$/i)?s=base64UrlToByteArray(t):null!==c.match(/^Sequence$/i)?s=deserializeSequenceType(this,e,t,i,l):null!==c.match(/^Dictionary$/i)&&(s=deserializeDictionaryType(this,e,t,i,l))}return e.isConstant&&(s=e.defaultValue),s}}function trimEnd(e,t){let i=e.length;for(;i-1>=0&&e[i-1]===t;)--i;return e.substr(0,i)}function bufferToBase64Url(e){if(!e)return;if(!(e instanceof Uint8Array))throw new Error("Please provide an input of type Uint8Array for converting to Base64Url.");return trimEnd(base64.encodeByteArray(e),"=").replace(/\+/g,"-").replace(/\//g,"_")}function base64UrlToByteArray(e){if(e){if(e&&"string"!=typeof e.valueOf())throw new Error("Please provide an input of type string for converting to Uint8Array");return e=e.replace(/-/g,"+").replace(/_/g,"/"),base64.decodeString(e)}}function splitSerializeName(e){const t=[];let i="";if(e){const r=e.split(".");for(const e of r)"\\"===e.charAt(e.length-1)?i+=e.substr(0,e.length-1)+".":(i+=e,t.push(i),i="")}return t}function dateToUnixTime(e){if(e)return"string"==typeof e.valueOf()&&(e=new Date(e)),Math.floor(e.getTime()/1e3)}function unixTimeToDate(e){if(e)return new Date(1e3*e)}function serializeBasicTypes(e,t,i){if(null!=i)if(null!==e.match(/^Number$/i)){if("number"!=typeof i)throw new Error(`${t} with value ${i} must be of type number.`)}else if(null!==e.match(/^String$/i)){if("string"!=typeof i.valueOf())throw new Error(`${t} with value "${i}" must be of type string.`)}else if(null!==e.match(/^Uuid$/i)){if("string"!=typeof i.valueOf()||!utils.isValidUuid(i))throw new Error(`${t} with value "${i}" must be of type string and a valid uuid.`)}else if(null!==e.match(/^Boolean$/i)){if("boolean"!=typeof i)throw new Error(`${t} with value ${i} must be of type boolean.`)}else if(null!==e.match(/^Stream$/i)){const e=typeof i;if(!("string"===e||"function"===e||i instanceof ArrayBuffer||ArrayBuffer.isView(i)||("function"==typeof Blob||"object"==typeof Blob)&&i instanceof Blob))throw new Error(`${t} must be a string, Blob, ArrayBuffer, ArrayBufferView, or a function returning NodeJS.ReadableStream.`)}return i}function serializeEnumType(e,t,i){if(!t)throw new Error(`Please provide a set of allowedValues to validate ${e} as an Enum Type.`);if(!t.some((e=>"string"==typeof e.valueOf()?e.toLowerCase()===i.toLowerCase():e===i)))throw new Error(`${i} is not a valid value for ${e}. The valid values are: ${JSON.stringify(t)}.`);return i}function serializeByteArrayType(e,t){let i="";if(null!=t){if(!(t instanceof Uint8Array))throw new Error(`${e} must be of type Uint8Array.`);i=base64.encodeByteArray(t)}return i}function serializeBase64UrlType(e,t){let i="";if(null!=t){if(!(t instanceof Uint8Array))throw new Error(`${e} must be of type Uint8Array.`);i=bufferToBase64Url(t)||""}return i}function serializeDateTypes(e,t,i){if(null!=t)if(null!==e.match(/^Date$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in ISO8601 format.`);t=t instanceof Date?t.toISOString().substring(0,10):new Date(t).toISOString().substring(0,10)}else if(null!==e.match(/^DateTime$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in ISO8601 format.`);t=t instanceof Date?t.toISOString():new Date(t).toISOString()}else if(null!==e.match(/^DateTimeRfc1123$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in RFC-1123 format.`);t=t instanceof Date?t.toUTCString():new Date(t).toUTCString()}else if(null!==e.match(/^UnixTime$/i)){if(!(t instanceof Date||"string"==typeof t.valueOf()&&!isNaN(Date.parse(t))))throw new Error(`${i} must be an instanceof Date or a string in RFC-1123/ISO8601 format for it to be serialized in UnixTime/Epoch format.`);t=dateToUnixTime(t)}else if(null!==e.match(/^TimeSpan$/i)&&!utils.isDuration(t))throw new Error(`${i} must be a string in ISO 8601 format. Instead was "${t}".`);return t}function serializeSequenceType(e,t,i,r,n,o){if(!Array.isArray(i))throw new Error(`${r} must be of type Array.`);const a=t.type.element;if(!a||"object"!=typeof a)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${r}.`);const l=[];for(let t=0;t<i.length;t++){const s=e.serialize(a,i[t],r,o);if(n&&a.xmlNamespace){const e=a.xmlNamespacePrefix?`xmlns:${a.xmlNamespacePrefix}`:"xmlns";"Composite"===a.type.name?(l[t]=Object.assign({},s),l[t][XML_ATTRKEY]={[e]:a.xmlNamespace}):(l[t]={},l[t][o.xmlCharKey]=s,l[t][XML_ATTRKEY]={[e]:a.xmlNamespace})}else l[t]=s}return l}function serializeDictionaryType(e,t,i,r,n,o){if("object"!=typeof i)throw new Error(`${r} must be of type object.`);const a=t.type.value;if(!a||"object"!=typeof a)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${r}.`);const l={};for(const t of Object.keys(i)){const s=e.serialize(a,i[t],r,o);l[t]=getXmlObjectValue(a,s,n,o)}if(n&&t.xmlNamespace){const e=t.xmlNamespacePrefix?`xmlns:${t.xmlNamespacePrefix}`:"xmlns",i=l;return i[XML_ATTRKEY]={[e]:t.xmlNamespace},i}return l}function resolveAdditionalProperties(e,t,i){const r=t.type.additionalProperties;if(!r&&t.type.className){const r=resolveReferencedMapper(e,t,i);return null==r?void 0:r.type.additionalProperties}return r}function resolveReferencedMapper(e,t,i){const r=t.type.className;if(!r)throw new Error(`Class name for model "${i}" is not provided in the mapper "${JSON.stringify(t,void 0,2)}".`);return e.modelMappers[r]}function resolveModelProperties(e,t,i){let r=t.type.modelProperties;if(!r){const n=resolveReferencedMapper(e,t,i);if(!n)throw new Error(`mapper() cannot be null or undefined for model "${t.type.className}".`);if(r=null==n?void 0:n.type.modelProperties,!r)throw new Error(`modelProperties cannot be null or undefined in the mapper "${JSON.stringify(n)}" of type "${t.type.className}" for object "${i}".`)}return r}function serializeCompositeType(e,t,i,r,n,o){if(getPolymorphicDiscriminatorRecursively(e,t)&&(t=getPolymorphicMapper(e,t,i,"clientName")),null!=i){const a={},l=resolveModelProperties(e,t,r);for(const s of Object.keys(l)){const c=l[s];if(c.readOnly)continue;let u,m=a;if(e.isXML)u=c.xmlIsWrapped?c.xmlName:c.xmlElementName||c.xmlName;else{const e=splitSerializeName(c.serializedName);u=e.pop();for(const t of e){null!=m[t]||null==i[s]&&void 0===c.defaultValue||(m[t]={}),m=m[t]}}if(null!=m){if(n&&t.xmlNamespace){const e=t.xmlNamespacePrefix?`xmlns:${t.xmlNamespacePrefix}`:"xmlns";m[XML_ATTRKEY]=Object.assign(Object.assign({},m[XML_ATTRKEY]),{[e]:t.xmlNamespace})}const a=""!==c.serializedName?r+"."+c.serializedName:r;let l=i[s];const f=getPolymorphicDiscriminatorRecursively(e,t);f&&f.clientName===s&&null==l&&(l=t.serializedName);const p=e.serialize(c,l,a,o);if(void 0!==p&&null!=u){const e=getXmlObjectValue(c,p,n,o);n&&c.xmlIsAttribute?(m[XML_ATTRKEY]=m[XML_ATTRKEY]||{},m[XML_ATTRKEY][u]=p):n&&c.xmlIsWrapped?m[u]={[c.xmlElementName]:e}:m[u]=e}}}const s=resolveAdditionalProperties(e,t,r);if(s){const t=Object.keys(l);for(const n in i){t.every((e=>e!==n))&&(a[n]=e.serialize(s,i[n],r+'["'+n+'"]',o))}}return a}return i}function getXmlObjectValue(e,t,i,r){if(!i||!e.xmlNamespace)return t;const n={[e.xmlNamespacePrefix?`xmlns:${e.xmlNamespacePrefix}`:"xmlns"]:e.xmlNamespace};if(["Composite"].includes(e.type.name)){if(t[XML_ATTRKEY])return t;{const e=Object.assign({},t);return e[XML_ATTRKEY]=n,e}}const o={};return o[r.xmlCharKey]=t,o[XML_ATTRKEY]=n,o}function isSpecialXmlProperty(e,t){return[XML_ATTRKEY,t.xmlCharKey].includes(e)}function deserializeCompositeType(e,t,i,r,n){var o,a;const l=null!==(o=n.xmlCharKey)&&void 0!==o?o:XML_CHARKEY;getPolymorphicDiscriminatorRecursively(e,t)&&(t=getPolymorphicMapper(e,t,i,"serializedName"));const s=resolveModelProperties(e,t,r);let c={};const u=[];for(const o of Object.keys(s)){const m=s[o],f=splitSerializeName(s[o].serializedName);u.push(f[0]);const{serializedName:p,xmlName:y,xmlElementName:d}=m;let h=r;""!==p&&void 0!==p&&(h=r+"."+p);const b=m.headerCollectionPrefix;if(b){const t={};for(const r of Object.keys(i))r.startsWith(b)&&(t[r.substring(b.length)]=e.deserialize(m.type.value,i[r],h,n)),u.push(r);c[o]=t}else if(e.isXML)if(m.xmlIsAttribute&&i[XML_ATTRKEY])c[o]=e.deserialize(m,i[XML_ATTRKEY][y],h,n);else if(m.xmlIsMsText)void 0!==i[l]?c[o]=i[l]:"string"==typeof i&&(c[o]=i);else{const t=d||y||p;if(m.xmlIsWrapped){const t=i[y],r=null!==(a=null==t?void 0:t[d])&&void 0!==a?a:[];c[o]=e.deserialize(m,r,h,n)}else{const r=i[t];c[o]=e.deserialize(m,r,h,n)}}else{let r,a=i;for(const e of f){if(!a)break;a=a[e]}r=a;const l=t.type.polymorphicDiscriminator;let u;if(l&&o===l.clientName&&null==r&&(r=t.serializedName),Array.isArray(i[o])&&""===s[o].serializedName){r=i[o];const t=e.deserialize(m,r,h,n);for(const[e,i]of Object.entries(c))Object.prototype.hasOwnProperty.call(t,e)||(t[e]=i);c=t}else void 0===r&&void 0===m.defaultValue||(u=e.deserialize(m,r,h,n),c[o]=u)}}const m=t.type.additionalProperties;if(m){const t=e=>{for(const t in s){if(splitSerializeName(s[t].serializedName)[0]===e)return!1}return!0};for(const o in i)t(o)&&(c[o]=e.deserialize(m,i[o],r+'["'+o+'"]',n))}else if(i)for(const e of Object.keys(i))void 0!==c[e]||u.includes(e)||isSpecialXmlProperty(e,n)||(c[e]=i[e]);return c}function deserializeDictionaryType(e,t,i,r,n){const o=t.type.value;if(!o||"object"!=typeof o)throw new Error(`"value" metadata for a Dictionary must be defined in the mapper and it must of type "object" in ${r}`);if(i){const t={};for(const a of Object.keys(i))t[a]=e.deserialize(o,i[a],r,n);return t}return i}function deserializeSequenceType(e,t,i,r,n){const o=t.type.element;if(!o||"object"!=typeof o)throw new Error(`element" metadata for an Array must be defined in the mapper and it must of type "object" in ${r}`);if(i){Array.isArray(i)||(i=[i]);const t=[];for(let a=0;a<i.length;a++)t[a]=e.deserialize(o,i[a],`${r}[${a}]`,n);return t}return i}function getPolymorphicMapper(e,t,i,r){const n=getPolymorphicDiscriminatorRecursively(e,t);if(n){const o=n[r];if(null!=o){const r=i[o];if(null!=r){const i=t.type.uberParent||t.type.className,n=r===i?r:i+"."+r,o=e.modelMappers.discriminators[n];o&&(t=o)}}}return t}function getPolymorphicDiscriminatorRecursively(e,t){return t.type.polymorphicDiscriminator||getPolymorphicDiscriminatorSafely(e,t.type.uberParent)||getPolymorphicDiscriminatorSafely(e,t.type.className)}function getPolymorphicDiscriminatorSafely(e,t){return t&&e.modelMappers[t]&&e.modelMappers[t].type.polymorphicDiscriminator}export function serializeObject(e){const t=e;if(null!=e){if(e instanceof Uint8Array)return e=base64.encodeByteArray(e);if(e instanceof Date)return e.toISOString();if(Array.isArray(e)){const t=[];for(let i=0;i<e.length;i++)t.push(serializeObject(e[i]));return t}if("object"==typeof e){const i={};for(const r in e)i[r]=serializeObject(t[r]);return i}return e}}function strEnum(e){const t={};for(const i of e)t[i]=i;return t}export const MapperType=strEnum(["Base64Url","Boolean","ByteArray","Composite","Date","DateTime","DateTimeRfc1123","Dictionary","Enum","Number","Object","Sequence","String","Stream","TimeSpan","UnixTime"]);