import*as utils from"./util/utils";import{MapperType}from"./serializer";import{DefaultDeserializationOptions,deserializationPolicy}from"./policies/deserializationPolicy";import{DefaultKeepAliveOptions,keepAlivePolicy}from"./policies/keepAlivePolicy";import{DefaultRedirectOptions,redirectPolicy}from"./policies/redirectPolicy";import{DefaultRetryOptions,exponentialRetryPolicy}from"./policies/exponentialRetryPolicy";import{logPolicy}from"./policies/logPolicy";import{getPathStringFromParameter,getPathStringFromParameterPath}from"./operationParameter";import{getStreamResponseStatusCodes}from"./operationSpec";import{WebResource,isWebResourceLike}from"./webResource";import{RequestPolicyOptions}from"./policies/requestPolicy";import{XML_ATTRKEY,XML_CHARKEY}from"./util/serializer.common";import{isNode}from"./util/utils";import{isTokenCredential}from"@azure/core-auth";import{getDefaultUserAgentHeaderName,getDefaultUserAgentValue,userAgentPolicy}from"./policies/userAgentPolicy";import{QueryCollectionFormat}from"./queryCollectionFormat";import{URLBuilder}from"./url";import{bearerTokenAuthenticationPolicy}from"./policies/bearerTokenAuthenticationPolicy";import{disableResponseDecompressionPolicy}from"./policies/disableResponseDecompressionPolicy";import{generateClientRequestIdPolicy}from"./policies/generateClientRequestIdPolicy";import{getCachedDefaultHttpClient}from"./httpClientCache";import{logger}from"./log";import{ndJsonPolicy}from"./policies/ndJsonPolicy";import{proxyPolicy}from"./policies/proxyPolicy";import{rpRegistrationPolicy}from"./policies/rpRegistrationPolicy";import{signingPolicy}from"./policies/signingPolicy";import{stringifyXML}from"./util/xml";import{systemErrorRetryPolicy}from"./policies/systemErrorRetryPolicy";import{throttlingRetryPolicy}from"./policies/throttlingRetryPolicy";import{tracingPolicy}from"./policies/tracingPolicy";export class ServiceClient{constructor(e,t){let r;if(t||(t={}),this._withCredentials=t.withCredentials||!1,this._httpClient=t.httpClient||getCachedDefaultHttpClient(),this._requestPolicyOptions=new RequestPolicyOptions(t.httpPipelineLogger),Array.isArray(t.requestPolicyFactories))logger.info("ServiceClient: using custom request policies"),r=t.requestPolicyFactories;else{let o;if(isTokenCredential(e)){logger.info("ServiceClient: creating bearer token authentication policy from provided credentials");o=(()=>{let r;const o=this,i=t;return{create(t,s){const n=getCredentialScopes(i,o.baseUri);if(!n)throw new Error("When using credential, the ServiceClient must contain a baseUri or a credentialScopes in ServiceClientOptions. Unable to create a bearerTokenAuthenticationPolicy");return null==r&&(r=bearerTokenAuthenticationPolicy(e,n)),r.create(t,s)}}})()}else if(e&&"function"==typeof e.signRequest)logger.info("ServiceClient: creating signing policy from provided credentials"),o=signingPolicy(e);else if(null!=e)throw new Error("The credentials argument must implement the TokenCredential interface");if(logger.info("ServiceClient: using default request policies"),r=createDefaultRequestPolicyFactories(o,t),t.requestPolicyFactories){const e=t.requestPolicyFactories(r);e&&(r=e)}}this._requestPolicyFactories=r}sendRequest(e){if(null==e||"object"!=typeof e)throw new Error("options cannot be null or undefined and it must be of type object.");let t;try{isWebResourceLike(e)?(e.validateRequestProperties(),t=e):(t=new WebResource,t=t.prepare(e))}catch(e){return Promise.reject(e)}let r=this._httpClient;if(this._requestPolicyFactories&&this._requestPolicyFactories.length>0)for(let e=this._requestPolicyFactories.length-1;e>=0;--e)r=this._requestPolicyFactories[e].create(r,this._requestPolicyOptions);return r.sendRequest(t)}async sendOperationRequest(e,t,r){var o;"function"==typeof e.options&&(r=e.options,e.options=void 0);const i=null===(o=e.options)||void 0===o?void 0:o.serializerOptions,s=new WebResource;let n;try{const r=t.baseUrl||this.baseUri;if(!r)throw new Error("If operationSpec.baseUrl is not specified, then the ServiceClient must have a baseUri string property that contains the base URL to use.");s.method=t.httpMethod,s.operationSpec=t;const o=URLBuilder.parse(r);if(t.path&&o.appendPath(t.path),t.urlParameters&&t.urlParameters.length>0)for(const r of t.urlParameters){let s=getOperationArgumentValueFromParameter(this,e,r,t.serializer);s=t.serializer.serialize(r.mapper,s,getPathStringFromParameter(r),i),r.skipEncoding||(s=encodeURIComponent(s)),o.replaceAll(`{${r.mapper.serializedName||getPathStringFromParameter(r)}}`,s)}if(t.queryParameters&&t.queryParameters.length>0)for(const r of t.queryParameters){let s=getOperationArgumentValueFromParameter(this,e,r,t.serializer);if(null!=s){if(s=t.serializer.serialize(r.mapper,s,getPathStringFromParameter(r),i),void 0!==r.collectionFormat&&null!==r.collectionFormat)if(r.collectionFormat===QueryCollectionFormat.Multi){if(0===s.length)continue;for(const e in s){const t=s[e];s[e]=null==t?"":t.toString()}}else r.collectionFormat!==QueryCollectionFormat.Ssv&&r.collectionFormat!==QueryCollectionFormat.Tsv||(s=s.join(r.collectionFormat));if(!r.skipEncoding)if(Array.isArray(s))for(const e in s)void 0!==s[e]&&null!==s[e]&&(s[e]=encodeURIComponent(s[e]));else s=encodeURIComponent(s);void 0!==r.collectionFormat&&null!==r.collectionFormat&&r.collectionFormat!==QueryCollectionFormat.Multi&&r.collectionFormat!==QueryCollectionFormat.Ssv&&r.collectionFormat!==QueryCollectionFormat.Tsv&&(s=s.join(r.collectionFormat)),o.setQueryParameter(r.mapper.serializedName||getPathStringFromParameter(r),s)}}s.url=o.toString();const a=t.contentType||this.requestContentType;if(a&&t.requestBody&&s.headers.set("Content-Type",a),t.headerParameters)for(const r of t.headerParameters){let o=getOperationArgumentValueFromParameter(this,e,r,t.serializer);if(null!=o){o=t.serializer.serialize(r.mapper,o,getPathStringFromParameter(r),i);const e=r.mapper.headerCollectionPrefix;if(e)for(const t of Object.keys(o))s.headers.set(e+t,o[t]);else s.headers.set(r.mapper.serializedName||getPathStringFromParameter(r),o)}}const l=e.options;if(l){if(l.customHeaders)for(const e in l.customHeaders)s.headers.set(e,l.customHeaders[e]);l.abortSignal&&(s.abortSignal=l.abortSignal),l.timeout&&(s.timeout=l.timeout),l.onUploadProgress&&(s.onUploadProgress=l.onUploadProgress),l.onDownloadProgress&&(s.onDownloadProgress=l.onDownloadProgress),l.spanOptions&&(s.spanOptions=l.spanOptions),l.tracingContext&&(s.tracingContext=l.tracingContext),void 0!==l.shouldDeserialize&&null!==l.shouldDeserialize&&(s.shouldDeserialize=l.shouldDeserialize)}let c,p;s.withCredentials=this._withCredentials,serializeRequestBody(this,s,e,t),void 0===s.streamResponseStatusCodes&&(s.streamResponseStatusCodes=getStreamResponseStatusCodes(t));try{c=await this.sendRequest(s)}catch(e){p=e}p?(p.response&&(p.details=flattenResponse(p.response,t.responses[p.statusCode]||t.responses.default)),n=Promise.reject(p)):n=Promise.resolve(flattenResponse(c,t.responses[c.status]))}catch(e){n=Promise.reject(e)}const a=r;return a&&n.then((e=>a(null,e._response.parsedBody,e._response.request,e._response))).catch((e=>a(e))),n}}export function serializeRequestBody(e,t,r,o){var i,s,n,a,l,c;const p=null!==(s=null===(i=r.options)||void 0===i?void 0:i.serializerOptions)&&void 0!==s?s:{},u={rootName:null!==(n=p.rootName)&&void 0!==n?n:"",includeRoot:null!==(a=p.includeRoot)&&void 0!==a&&a,xmlCharKey:null!==(l=p.xmlCharKey)&&void 0!==l?l:XML_CHARKEY},m=p.xmlCharKey;if(o.requestBody&&o.requestBody.mapper){t.body=getOperationArgumentValueFromParameter(e,r,o.requestBody,o.serializer);const i=o.requestBody.mapper,{required:s,xmlName:n,xmlElementName:a,serializedName:l,xmlNamespace:p,xmlNamespacePrefix:y}=i,d=i.type.name;try{if(void 0!==t.body&&null!==t.body||s){const e=getPathStringFromParameter(o.requestBody);t.body=o.serializer.serialize(i,t.body,e,u);const r=d===MapperType.Stream;if(o.isXML){const e=y?`xmlns:${y}`:"xmlns",o=getXmlValueWithNamespace(p,e,d,t.body,u);d===MapperType.Sequence?t.body=stringifyXML(utils.prepareXMLRootList(o,a||n||l,e,p),{rootName:n||l,xmlCharKey:m}):r||(t.body=stringifyXML(o,{rootName:n||l,xmlCharKey:m}))}else{if(d===MapperType.String&&((null===(c=o.contentType)||void 0===c?void 0:c.match("text/plain"))||"text"===o.mediaType))return;r||(t.body=JSON.stringify(t.body))}}}catch(e){throw new Error(`Error "${e.message}" occurred in serializing the payload - ${JSON.stringify(l,void 0,"  ")}.`)}}else if(o.formDataParameters&&o.formDataParameters.length>0){t.formData={};for(const i of o.formDataParameters){const s=getOperationArgumentValueFromParameter(e,r,i,o.serializer);if(null!=s){const e=i.mapper.serializedName||getPathStringFromParameter(i);t.formData[e]=o.serializer.serialize(i.mapper,s,getPathStringFromParameter(i),u)}}}}function getXmlValueWithNamespace(e,t,r,o,i){if(e&&!["Composite","Sequence","Dictionary"].includes(r)){const r={};return r[i.xmlCharKey]=o,r[XML_ATTRKEY]={[t]:e},r}return o}function getValueOrFunctionResult(e,t){let r;return"string"==typeof e?r=e:(r=t(),"function"==typeof e&&(r=e(r))),r}function createDefaultRequestPolicyFactories(e,t){const r=[];t.generateClientRequestIdHeader&&r.push(generateClientRequestIdPolicy(t.clientRequestIdHeaderName)),e&&r.push(e);const o=getValueOrFunctionResult(t.userAgentHeaderName,getDefaultUserAgentHeaderName),i=getValueOrFunctionResult(t.userAgent,getDefaultUserAgentValue);return o&&i&&r.push(userAgentPolicy({key:o,value:i})),r.push(redirectPolicy()),r.push(rpRegistrationPolicy(t.rpRegistrationRetryTimeout)),t.noRetryPolicy||(r.push(exponentialRetryPolicy()),r.push(systemErrorRetryPolicy()),r.push(throttlingRetryPolicy())),r.push(deserializationPolicy(t.deserializationContentTypes)),isNode&&r.push(proxyPolicy(t.proxySettings)),r.push(logPolicy({logger:logger.info})),r}export function createPipelineFromOptions(e,t){const r=[];let o;if(e.sendStreamingJson&&r.push(ndJsonPolicy()),e.userAgentOptions&&e.userAgentOptions.userAgentPrefix){const t=[];t.push(e.userAgentOptions.userAgentPrefix);const r=getDefaultUserAgentValue();-1===t.indexOf(r)&&t.push(r),o=t.join(" ")}const i=Object.assign(Object.assign({},DefaultKeepAliveOptions),e.keepAliveOptions),s=Object.assign(Object.assign({},DefaultRetryOptions),e.retryOptions),n=Object.assign(Object.assign({},DefaultRedirectOptions),e.redirectOptions);isNode&&r.push(proxyPolicy(e.proxyOptions));const a=Object.assign(Object.assign({},DefaultDeserializationOptions),e.deserializationOptions),l=Object.assign({},e.loggingOptions);return r.push(tracingPolicy({userAgent:o}),keepAlivePolicy(i),userAgentPolicy({value:o}),generateClientRequestIdPolicy(),deserializationPolicy(a.expectedContentTypes),throttlingRetryPolicy(),systemErrorRetryPolicy(),exponentialRetryPolicy(s.maxRetries,s.retryDelayInMs,s.maxRetryDelayInMs)),n.handleRedirects&&r.push(redirectPolicy(n.maxRetries)),t&&r.push(t),r.push(logPolicy(l)),isNode&&!1===e.decompressResponse&&r.push(disableResponseDecompressionPolicy()),{httpClient:e.httpClient,requestPolicyFactories:r}}export function getPropertyParent(e,t){if(e&&t){const r=t.length;for(let o=0;o<r-1;++o){const r=t[o];e[r]||(e[r]={}),e=e[r]}}return e}function getOperationArgumentValueFromParameter(e,t,r,o){return getOperationArgumentValueFromParameterPath(e,t,r.parameterPath,r.mapper,o)}export function getOperationArgumentValueFromParameterPath(e,t,r,o,i){var s;let n;"string"==typeof r&&(r=[r]);const a=null===(s=t.options)||void 0===s?void 0:s.serializerOptions;if(Array.isArray(r)){if(r.length>0){if(o.isConstant)n=o.defaultValue;else{let i=getPropertyFromParameterPath(t,r);i.propertyFound||(i=getPropertyFromParameterPath(e,r));let s=!1;i.propertyFound||(s=o.required||"options"===r[0]&&2===r.length),n=s?o.defaultValue:i.propertyValue}const s=getPathStringFromParameterPath(r,o);i.serialize(o,n,s,a)}}else{o.required&&(n={});for(const s in r){const l=o.type.modelProperties[s],c=r[s],p=getOperationArgumentValueFromParameterPath(e,t,c,l,i),u=getPathStringFromParameterPath(c,l);i.serialize(l,p,u,a),null!=p&&(n||(n={}),n[s]=p)}}return n}function getPropertyFromParameterPath(e,t){const r={propertyFound:!1};let o=0;for(;o<t.length;++o){const r=t[o];if(null==e||!(r in e))break;e=e[r]}return o===t.length&&(r.propertyValue=e,r.propertyFound=!0),r}export function flattenResponse(e,t){const r=e.parsedHeaders,o=t&&t.bodyMapper,i=t=>Object.defineProperty(t,"_response",{value:e});if(o){const t=o.type.name;if("Stream"===t)return i(Object.assign(Object.assign({},r),{blobBody:e.blobBody,readableStreamBody:e.readableStreamBody}));const s="Composite"===t&&o.type.modelProperties||{},n=Object.keys(s).some((e=>""===s[e].serializedName));if("Sequence"===t||n){const t=[...e.parsedBody||[]];for(const r of Object.keys(s))s[r].serializedName&&(t[r]=e.parsedBody[r]);if(r)for(const e of Object.keys(r))t[e]=r[e];return i(t),t}if("Composite"===t||"Dictionary"===t)return i(Object.assign(Object.assign({},r),e.parsedBody))}return o||"HEAD"===e.request.method||utils.isPrimitiveType(e.parsedBody)?i(Object.assign(Object.assign({},r),{body:e.parsedBody})):i(Object.assign(Object.assign({},r),e.parsedBody))}function getCredentialScopes(e,t){if(null==e?void 0:e.credentialScopes){const t=e.credentialScopes;return Array.isArray(t)?t.map((e=>new URL(e).toString())):new URL(t).toString()}if(t)return`${t}/.default`}