import{HttpHeaders,isHttpHeadersLike}from"./httpHeaders";import{Serializer}from"./serializer";import{generateUuid}from"./util/utils";export function isWebResourceLike(e){if(e&&"object"==typeof e){const t=e;if("string"==typeof t.url&&"string"==typeof t.method&&"object"==typeof t.headers&&isHttpHeadersLike(t.headers)&&"function"==typeof t.validateRequestProperties&&"function"==typeof t.prepare&&"function"==typeof t.clone)return!0}return!1}export class WebResource{constructor(e,t,o,r,s,i,a,n,h,p,l,d,u,c,m){this.streamResponseBody=i,this.streamResponseStatusCodes=m,this.url=e||"",this.method=t||"GET",this.headers=isHttpHeadersLike(s)?s:new HttpHeaders(s),this.body=o,this.query=r,this.formData=void 0,this.withCredentials=a||!1,this.abortSignal=n,this.timeout=h||0,this.onUploadProgress=p,this.onDownloadProgress=l,this.proxySettings=d,this.keepAlive=u,this.decompressResponse=c,this.requestId=this.headers.get("x-ms-client-request-id")||generateUuid()}validateRequestProperties(){if(!this.method)throw new Error("WebResource.method is required.");if(!this.url)throw new Error("WebResource.url is required.")}prepare(e){if(!e)throw new Error("options object is required");if(void 0===e.method||null===e.method||"string"!=typeof e.method.valueOf())throw new Error("options.method must be a string.");if(e.url&&e.pathTemplate)throw new Error("options.url and options.pathTemplate are mutually exclusive. Please provide exactly one of them.");if(!(void 0!==e.pathTemplate&&null!==e.pathTemplate&&"string"==typeof e.pathTemplate.valueOf()||void 0!==e.url&&null!==e.url&&"string"==typeof e.url.valueOf()))throw new Error("Please provide exactly one of options.pathTemplate or options.url.");if(e.url){if("string"!=typeof e.url)throw new Error('options.url must be of type "string".');this.url=e.url}if(e.method){const t=["GET","PUT","HEAD","DELETE","OPTIONS","POST","PATCH","TRACE"];if(-1===t.indexOf(e.method.toUpperCase()))throw new Error('The provided method "'+e.method+'" is invalid. Supported HTTP methods are: '+JSON.stringify(t))}if(this.method=e.method.toUpperCase(),e.pathTemplate){const{pathTemplate:t,pathParameters:o}=e;if("string"!=typeof t)throw new Error('options.pathTemplate must be of type "string".');e.baseUrl||(e.baseUrl="https://management.azure.com");const r=e.baseUrl;let s=r+(r.endsWith("/")?"":"/")+(t.startsWith("/")?t.slice(1):t);const i=s.match(/({[\w-]*\s*[\w-]*})/gi);if(i&&i.length){if(!o)throw new Error(`pathTemplate: ${t} has been provided. Hence, options.pathParameters must also be provided.`);i.forEach((function(e){const r=e.slice(1,-1),i=o[r];if(null==i||"string"!=typeof i&&"object"!=typeof i){const e=JSON.stringify(o,void 0,2);throw new Error(`pathTemplate: ${t} contains the path parameter ${r} however, it is not present in parameters: ${e}.The value of the path parameter can either be a "string" of the form { ${r}: "some sample value" } or it can be an "object" of the form { "${r}": { value: "some sample value", skipUrlEncoding: true } }.`)}if("string"==typeof i.valueOf()&&(s=s.replace(e,encodeURIComponent(i))),"object"==typeof i.valueOf()){if(!i.value)throw new Error(`options.pathParameters[${r}] is of type "object" but it does not contain a "value" property.`);s=i.skipUrlEncoding?s.replace(e,i.value):s.replace(e,encodeURIComponent(i.value))}}))}this.url=s}if(e.queryParameters){const t=e.queryParameters;if("object"!=typeof t)throw new Error('options.queryParameters must be of type object. It should be a JSON object of "query-parameter-name" as the key and the "query-parameter-value" as the value. The "query-parameter-value" may be fo type "string" or an "object" of the form { value: "query-parameter-value", skipUrlEncoding: true }.');this.url&&-1===this.url.indexOf("?")&&(this.url+="?");const o=[];this.query={};for(const e in t){const r=t[e];if(r)if("string"==typeof r)o.push(e+"="+encodeURIComponent(r)),this.query[e]=encodeURIComponent(r);else if("object"==typeof r){if(!r.value)throw new Error(`options.queryParameters[${e}] is of type "object" but it does not contain a "value" property.`);r.skipUrlEncoding?(o.push(e+"="+r.value),this.query[e]=r.value):(o.push(e+"="+encodeURIComponent(r.value)),this.query[e]=encodeURIComponent(r.value))}}this.url+=o.join("&")}if(e.headers){const t=e.headers;for(const o of Object.keys(e.headers))this.headers.set(o,t[o])}return this.headers.get("accept-language")||this.headers.set("accept-language","en-US"),this.headers.get("x-ms-client-request-id")||e.disableClientRequestId||this.headers.set("x-ms-client-request-id",this.requestId),this.headers.get("Content-Type")||this.headers.set("Content-Type","application/json; charset=utf-8"),this.body=e.body,void 0!==e.body&&null!==e.body&&(e.bodyIsStream?(this.headers.get("Transfer-Encoding")||this.headers.set("Transfer-Encoding","chunked"),"application/octet-stream"!==this.headers.get("Content-Type")&&this.headers.set("Content-Type","application/octet-stream")):(e.serializationMapper&&(this.body=new Serializer(e.mappers).serialize(e.serializationMapper,e.body,"requestBody")),e.disableJsonStringifyOnBody||(this.body=JSON.stringify(e.body)))),e.spanOptions&&(this.spanOptions=e.spanOptions),e.tracingContext&&(this.tracingContext=e.tracingContext),this.abortSignal=e.abortSignal,this.onDownloadProgress=e.onDownloadProgress,this.onUploadProgress=e.onUploadProgress,this}clone(){const e=new WebResource(this.url,this.method,this.body,this.query,this.headers&&this.headers.clone(),this.streamResponseBody,this.withCredentials,this.abortSignal,this.timeout,this.onUploadProgress,this.onDownloadProgress,this.proxySettings,this.keepAlive,this.decompressResponse,this.streamResponseStatusCodes);return this.formData&&(e.formData=this.formData),this.operationSpec&&(e.operationSpec=this.operationSpec),this.shouldDeserialize&&(e.shouldDeserialize=this.shouldDeserialize),this.operationResponseGetter&&(e.operationResponseGetter=this.operationResponseGetter),e}}