"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var logger$1=require("@azure/logger"),abortController=require("@azure/abort-controller"),coreUtil=require("@azure/core-util");const logger=logger$1.createClientLogger("core-lro"),POLL_INTERVAL_IN_MS=2e3,terminalStates=["succeeded","canceled","failed"];function deserializeState(e){try{return JSON.parse(e).state}catch(t){throw new Error(`Unable to deserialize input state: ${e}`)}}function setStateError(e){const{state:t,stateProxy:o,isOperationError:r}=e;return e=>{throw r(e)&&(o.setError(t,e),o.setFailed(t)),e}}function appendReadableErrorMessage(e,t){let o=e;return"."!==o.slice(-1)&&(o+="."),o+" "+t}function simplifyError(e){let t=e.message,o=e.code,r=e;for(;r.innererror;)r=r.innererror,o=r.code,t=appendReadableErrorMessage(t,r.message);return{code:o,message:t}}function processOperationStatus(e){const{state:t,stateProxy:o,status:r,isDone:s,processResult:n,getError:a,response:i,setErrorAsResult:l}=e;switch(r){case"succeeded":o.setSucceeded(t);break;case"failed":{const e=null==a?void 0:a(i);let r="";if(e){const{code:t,message:o}=simplifyError(e);r=`. ${t}. ${o}`}const s=`The long-running operation has failed${r}`;o.setError(t,new Error(s)),o.setFailed(t),logger.warning(s);break}case"canceled":o.setCanceled(t)}((null==s?void 0:s(i,t))||void 0===s&&["succeeded","canceled"].concat(l?[]:["failed"]).includes(r))&&o.setResult(t,buildResult({response:i,state:t,processResult:n}))}function buildResult(e){const{processResult:t,response:o,state:r}=e;return t?t(o,r):o}async function initOperation(e){const{init:t,stateProxy:o,processResult:r,getOperationStatus:s,withOperationLocation:n,setErrorAsResult:a}=e,{operationLocation:i,resourceLocation:l,metadata:c,response:u}=await t();i&&(null==n||n(i,!1));const p={metadata:c,operationLocation:i,resourceLocation:l};logger.verbose("LRO: Operation description:",p);const d=o.initState(p);return processOperationStatus({state:d,status:s({response:u,state:d,operationLocation:i}),stateProxy:o,response:u,setErrorAsResult:a,processResult:r}),d}async function pollOperationHelper(e){const{poll:t,state:o,stateProxy:r,operationLocation:s,getOperationStatus:n,getResourceLocation:a,isOperationError:i,options:l}=e,c=await t(s,l).catch(setStateError({state:o,stateProxy:r,isOperationError:i})),u=n(c,o);if(logger.verbose(`LRO: Status:\n\tPolling from: ${o.config.operationLocation}\n\tOperation status: ${u}\n\tPolling status: ${terminalStates.includes(u)?"Stopped":"Running"}`),"succeeded"===u){const e=a(c,o);if(void 0!==e)return{response:await t(e).catch(setStateError({state:o,stateProxy:r,isOperationError:i})),status:u}}return{response:c,status:u}}async function pollOperation(e){const{poll:t,state:o,stateProxy:r,options:s,getOperationStatus:n,getResourceLocation:a,getOperationLocation:i,isOperationError:l,withOperationLocation:c,getPollingInterval:u,processResult:p,getError:d,updateState:g,setDelay:h,isDone:f,setErrorAsResult:R}=e,{operationLocation:O}=o.config;if(void 0!==O){const{response:e,status:S}=await pollOperationHelper({poll:t,getOperationStatus:n,state:o,stateProxy:r,operationLocation:O,getResourceLocation:a,isOperationError:l,options:s});if(processOperationStatus({status:S,response:e,state:o,stateProxy:r,isDone:f,processResult:p,getError:d,setErrorAsResult:R}),!terminalStates.includes(S)){const t=null==u?void 0:u(e);t&&h(t);const r=null==i?void 0:i(e,o);if(void 0!==r){const e=O!==r;o.config.operationLocation=r,null==c||c(r,e)}else null==c||c(O,!1)}null==g||g(o,e)}}function getOperationLocationPollingUrl(e){const{azureAsyncOperation:t,operationLocation:o}=e;return null!=o?o:t}function getLocationHeader(e){return e.headers.location}function getOperationLocationHeader(e){return e.headers["operation-location"]}function getAzureAsyncOperationHeader(e){return e.headers["azure-asyncoperation"]}function findResourceLocation(e){var t;const{location:o,requestMethod:r,requestPath:s,resourceLocationConfig:n}=e;switch(r){case"PUT":return s;case"DELETE":return;case"PATCH":return null!==(t=a())&&void 0!==t?t:s;default:return a()}function a(){switch(n){case"azure-async-operation":return;case"original-uri":return s;default:return o}}}function inferLroMode(e){const{rawResponse:t,requestMethod:o,requestPath:r,resourceLocationConfig:s}=e,n=getOperationLocationPollingUrl({operationLocation:getOperationLocationHeader(t),azureAsyncOperation:getAzureAsyncOperationHeader(t)}),a=getLocationHeader(t),i=null==o?void 0:o.toLocaleUpperCase();return void 0!==n?{mode:"OperationLocation",operationLocation:n,resourceLocation:findResourceLocation({requestMethod:i,location:a,requestPath:r,resourceLocationConfig:s})}:void 0!==a?{mode:"ResourceLocation",operationLocation:a}:"PUT"===i&&r?{mode:"Body",operationLocation:r}:void 0}function transformStatus(e){const{status:t,statusCode:o}=e;if("string"!=typeof t&&void 0!==t)throw new Error(`Polling was unsuccessful. Expected status to have a string value or no value but it has instead: ${t}. This doesn't necessarily indicate the operation has failed. Check your Azure subscription or resource status for more information.`);switch(null==t?void 0:t.toLocaleLowerCase()){case void 0:return toOperationStatus(o);case"succeeded":return"succeeded";case"failed":return"failed";case"running":case"accepted":case"started":case"canceling":case"cancelling":return"running";case"canceled":case"cancelled":return"canceled";default:return logger.verbose(`LRO: unrecognized operation status: ${t}`),t}}function getStatus(e){var t;const{status:o}=null!==(t=e.body)&&void 0!==t?t:{};return transformStatus({status:o,statusCode:e.statusCode})}function getProvisioningState(e){var t,o;const{properties:r,provisioningState:s}=null!==(t=e.body)&&void 0!==t?t:{};return transformStatus({status:null!==(o=null==r?void 0:r.provisioningState)&&void 0!==o?o:s,statusCode:e.statusCode})}function toOperationStatus(e){return 202===e?"running":e<300?"succeeded":"failed"}function parseRetryAfter({rawResponse:e}){const t=e.headers["retry-after"];if(void 0!==t){const e=parseInt(t);return isNaN(e)?calculatePollingIntervalFromDate(new Date(t)):1e3*e}}function getErrorFromResponse(e){const t=e.flatResponse.error;if(t){if(t.code&&t.message)return t;logger.warning("The long-running operation failed but the error property in the response's body doesn't contain code or message")}else logger.warning("The long-running operation failed but there is no error property in the response's body")}function calculatePollingIntervalFromDate(e){const t=Math.floor((new Date).getTime()),o=e.getTime();if(t<o)return o-t}function getStatusFromInitialResponse(e){const{response:t,state:o,operationLocation:r}=e;const s=function(){var e;switch(null===(e=o.config.metadata)||void 0===e?void 0:e.mode){case void 0:return toOperationStatus(t.rawResponse.statusCode);case"Body":return getOperationStatus(t,o);default:return"running"}}();return"running"===s&&void 0===r?"succeeded":s}async function initHttpOperation(e){const{stateProxy:t,resourceLocationConfig:o,processResult:r,lro:s,setErrorAsResult:n}=e;return initOperation({init:async()=>{const e=await s.sendInitialRequest(),t=inferLroMode({rawResponse:e.rawResponse,requestPath:s.requestPath,requestMethod:s.requestMethod,resourceLocationConfig:o});return Object.assign({response:e,operationLocation:null==t?void 0:t.operationLocation,resourceLocation:null==t?void 0:t.resourceLocation},(null==t?void 0:t.mode)?{metadata:{mode:t.mode}}:{})},stateProxy:t,processResult:r?({flatResponse:e},t)=>r(e,t):({flatResponse:e})=>e,getOperationStatus:getStatusFromInitialResponse,setErrorAsResult:n})}function getOperationLocation({rawResponse:e},t){var o;switch(null===(o=t.config.metadata)||void 0===o?void 0:o.mode){case"OperationLocation":return getOperationLocationPollingUrl({operationLocation:getOperationLocationHeader(e),azureAsyncOperation:getAzureAsyncOperationHeader(e)});case"ResourceLocation":return getLocationHeader(e);default:return}}function getOperationStatus({rawResponse:e},t){var o;const r=null===(o=t.config.metadata)||void 0===o?void 0:o.mode;switch(r){case"OperationLocation":return getStatus(e);case"ResourceLocation":return toOperationStatus(e.statusCode);case"Body":return getProvisioningState(e);default:throw new Error(`Internal error: Unexpected operation mode: ${r}`)}}function getResourceLocation({flatResponse:e},t){if("object"==typeof e){const o=e.resourceLocation;void 0!==o&&(t.config.resourceLocation=o)}return t.config.resourceLocation}function isOperationError(e){return"RestError"===e.name}async function pollHttpOperation(e){const{lro:t,stateProxy:o,options:r,processResult:s,updateState:n,setDelay:a,state:i,setErrorAsResult:l}=e;return pollOperation({state:i,stateProxy:o,setDelay:a,processResult:s?({flatResponse:e},t)=>s(e,t):({flatResponse:e})=>e,getError:getErrorFromResponse,updateState:n,getPollingInterval:parseRetryAfter,getOperationLocation:getOperationLocation,getOperationStatus:getOperationStatus,isOperationError:isOperationError,getResourceLocation:getResourceLocation,options:r,poll:async(e,o)=>t.sendPollRequest(e,o),setErrorAsResult:l})}const createStateProxy$1=()=>({initState:e=>({status:"running",config:e}),setCanceled:e=>e.status="canceled",setError:(e,t)=>e.error=t,setResult:(e,t)=>e.result=t,setRunning:e=>e.status="running",setSucceeded:e=>e.status="succeeded",setFailed:e=>e.status="failed",getError:e=>e.error,getResult:e=>e.result,isCanceled:e=>"canceled"===e.status,isFailed:e=>"failed"===e.status,isRunning:e=>"running"===e.status,isSucceeded:e=>"succeeded"===e.status});function buildCreatePoller(e){const{getOperationLocation:t,getStatusFromInitialResponse:o,getStatusFromPollResponse:r,isOperationError:s,getResourceLocation:n,getPollingInterval:a,getError:i,resolveOnUnsuccessful:l}=e;return async({init:e,poll:c},u)=>{const{processResult:p,updateState:d,withOperationLocation:g,intervalInMs:h=POLL_INTERVAL_IN_MS,restoreFrom:f}=u||{},R=createStateProxy$1(),O=g?(()=>{let e=!1;return(t,o)=>{o?g(t):e||g(t),e=!0}})():void 0,S=f?deserializeState(f):await initOperation({init:e,stateProxy:R,processResult:p,getOperationStatus:o,withOperationLocation:O,setErrorAsResult:!l});let P;const L=new abortController.AbortController,v=new Map,E="Operation was canceled";let w=h;const y={getOperationState:()=>S,getResult:()=>S.result,isDone:()=>["succeeded","failed","canceled"].includes(S.status),isStopped:()=>void 0===P,stopPolling:()=>{L.abort()},toString:()=>JSON.stringify({state:S}),onProgress:e=>{const t=Symbol();return v.set(t,e),()=>v.delete(t)},pollUntilDone:e=>null!=P?P:P=(async()=>{const{abortSignal:t}=e||{},{signal:o}=t?new abortController.AbortController([t,L.signal]):L;if(!y.isDone())for(await y.poll({abortSignal:o});!y.isDone();)await coreUtil.delay(w,{abortSignal:o}),await y.poll({abortSignal:o});if(l)return y.getResult();switch(S.status){case"succeeded":return y.getResult();case"canceled":throw new Error(E);case"failed":throw S.error;case"notStarted":case"running":throw new Error("Polling completed without succeeding or failing")}})().finally((()=>{P=void 0})),async poll(e){if(l){if(y.isDone())return}else switch(S.status){case"succeeded":return;case"canceled":throw new Error(E);case"failed":throw S.error}if(await pollOperation({poll:c,state:S,stateProxy:R,getOperationLocation:t,isOperationError:s,withOperationLocation:O,getPollingInterval:a,getOperationStatus:r,getResourceLocation:n,processResult:p,getError:i,updateState:d,options:e,setDelay:e=>{w=e},setErrorAsResult:!l}),await(async()=>v.forEach((e=>e(S))))(),!l)switch(S.status){case"canceled":throw new Error(E);case"failed":throw S.error}}};return y}}async function createHttpPoller(e,t){const{resourceLocationConfig:o,intervalInMs:r,processResult:s,restoreFrom:n,updateState:a,withOperationLocation:i,resolveOnUnsuccessful:l=!1}=t||{};return buildCreatePoller({getStatusFromInitialResponse:getStatusFromInitialResponse,getStatusFromPollResponse:getOperationStatus,isOperationError:isOperationError,getOperationLocation:getOperationLocation,getResourceLocation:getResourceLocation,getPollingInterval:parseRetryAfter,getError:getErrorFromResponse,resolveOnUnsuccessful:l})({init:async()=>{const t=await e.sendInitialRequest(),r=inferLroMode({rawResponse:t.rawResponse,requestPath:e.requestPath,requestMethod:e.requestMethod,resourceLocationConfig:o});return Object.assign({response:t,operationLocation:null==r?void 0:r.operationLocation,resourceLocation:null==r?void 0:r.resourceLocation},(null==r?void 0:r.mode)?{metadata:{mode:r.mode}}:{})},poll:e.sendPollRequest},{intervalInMs:r,withOperationLocation:i,restoreFrom:n,updateState:a,processResult:s?({flatResponse:e},t)=>s(e,t):({flatResponse:e})=>e})}const createStateProxy=()=>({initState:e=>({config:e,isStarted:!0}),setCanceled:e=>e.isCancelled=!0,setError:(e,t)=>e.error=t,setResult:(e,t)=>e.result=t,setRunning:e=>e.isStarted=!0,setSucceeded:e=>e.isCompleted=!0,setFailed:()=>{},getError:e=>e.error,getResult:e=>e.result,isCanceled:e=>!!e.isCancelled,isFailed:e=>!!e.error,isRunning:e=>!!e.isStarted,isSucceeded:e=>Boolean(e.isCompleted&&!e.isCancelled&&!e.error)});class GenericPollOperation{constructor(e,t,o,r,s,n,a){this.state=e,this.lro=t,this.setErrorAsResult=o,this.lroResourceLocationConfig=r,this.processResult=s,this.updateState=n,this.isDone=a}setPollerConfig(e){this.pollerConfig=e}async update(e){var t;const o={initState:e=>({config:e,isStarted:!0}),setCanceled:e=>e.isCancelled=!0,setError:(e,t)=>e.error=t,setResult:(e,t)=>e.result=t,setRunning:e=>e.isStarted=!0,setSucceeded:e=>e.isCompleted=!0,setFailed:()=>{},getError:e=>e.error,getResult:e=>e.result,isCanceled:e=>!!e.isCancelled,isFailed:e=>!!e.error,isRunning:e=>!!e.isStarted,isSucceeded:e=>Boolean(e.isCompleted&&!e.isCancelled&&!e.error)};this.state.isStarted||(this.state=Object.assign(Object.assign({},this.state),await initHttpOperation({lro:this.lro,stateProxy:o,resourceLocationConfig:this.lroResourceLocationConfig,processResult:this.processResult,setErrorAsResult:this.setErrorAsResult})));const r=this.updateState,s=this.isDone;return this.state.isCompleted||void 0!==this.state.error||await pollHttpOperation({lro:this.lro,state:this.state,stateProxy:o,processResult:this.processResult,updateState:r?(e,{rawResponse:t})=>r(e,t):void 0,isDone:s?({flatResponse:e},t)=>s(e,t):void 0,options:e,setDelay:e=>{this.pollerConfig.intervalInMs=e},setErrorAsResult:this.setErrorAsResult}),null===(t=null==e?void 0:e.fireProgress)||void 0===t||t.call(e,this.state),this}async cancel(){return logger.error("`cancelOperation` is deprecated because it wasn't implemented"),this}toString(){return JSON.stringify({state:this.state})}}class PollerStoppedError extends Error{constructor(e){super(e),this.name="PollerStoppedError",Object.setPrototypeOf(this,PollerStoppedError.prototype)}}class PollerCancelledError extends Error{constructor(e){super(e),this.name="PollerCancelledError",Object.setPrototypeOf(this,PollerCancelledError.prototype)}}class Poller{constructor(e){this.resolveOnUnsuccessful=!1,this.stopped=!0,this.pollProgressCallbacks=[],this.operation=e,this.promise=new Promise(((e,t)=>{this.resolve=e,this.reject=t})),this.promise.catch((()=>{}))}async startPolling(e={}){for(this.stopped&&(this.stopped=!1);!this.isStopped()&&!this.isDone();)await this.poll(e),await this.delay()}async pollOnce(e={}){this.isDone()||(this.operation=await this.operation.update({abortSignal:e.abortSignal,fireProgress:this.fireProgress.bind(this)})),this.processUpdatedState()}fireProgress(e){for(const t of this.pollProgressCallbacks)t(e)}async cancelOnce(e={}){this.operation=await this.operation.cancel(e)}poll(e={}){if(!this.pollOncePromise){this.pollOncePromise=this.pollOnce(e);const t=()=>{this.pollOncePromise=void 0};this.pollOncePromise.then(t,t).catch(this.reject)}return this.pollOncePromise}processUpdatedState(){if(this.operation.state.error&&(this.stopped=!0,!this.resolveOnUnsuccessful))throw this.reject(this.operation.state.error),this.operation.state.error;if(this.operation.state.isCancelled&&(this.stopped=!0,!this.resolveOnUnsuccessful)){const e=new PollerCancelledError("Operation was canceled");throw this.reject(e),e}this.isDone()&&this.resolve&&this.resolve(this.getResult())}async pollUntilDone(e={}){return this.stopped&&this.startPolling(e).catch(this.reject),this.processUpdatedState(),this.promise}onProgress(e){return this.pollProgressCallbacks.push(e),()=>{this.pollProgressCallbacks=this.pollProgressCallbacks.filter((t=>t!==e))}}isDone(){const e=this.operation.state;return Boolean(e.isCompleted||e.isCancelled||e.error)}stopPolling(){this.stopped||(this.stopped=!0,this.reject&&this.reject(new PollerStoppedError("This poller is already stopped")))}isStopped(){return this.stopped}cancelOperation(e={}){if(this.cancelPromise){if(e.abortSignal)throw new Error("A cancel request is currently pending")}else this.cancelPromise=this.cancelOnce(e);return this.cancelPromise}getOperationState(){return this.operation.state}getResult(){return this.operation.state.result}toString(){return this.operation.toString()}}class LroEngine extends Poller{constructor(e,t){const{intervalInMs:o=POLL_INTERVAL_IN_MS,resumeFrom:r,resolveOnUnsuccessful:s=!1,isDone:n,lroResourceLocationConfig:a,processResult:i,updateState:l}=t||{},c=r?deserializeState(r):{},u=new GenericPollOperation(c,e,!s,a,i,l,n);super(u),this.resolveOnUnsuccessful=s,this.config={intervalInMs:o},u.setPollerConfig(this.config)}delay(){return new Promise((e=>setTimeout((()=>e()),this.config.intervalInMs)))}}exports.LroEngine=LroEngine,exports.Poller=Poller,exports.PollerCancelledError=PollerCancelledError,exports.PollerStoppedError=PollerStoppedError,exports.createHttpPoller=createHttpPoller;