import*as http from"node:http";import*as https from"node:https";import*as zlib from"node:zlib";import{Transform}from"node:stream";import{AbortError}from"@azure/abort-controller";import{createHttpHeaders}from"./httpHeaders.js";import{RestError}from"./restError.js";import{logger}from"./log.js";const DEFAULT_TLS_SETTINGS={};function isReadableStream(e){return e&&"function"==typeof e.pipe}function isStreamComplete(e){return new Promise((t=>{e.on("close",t),e.on("end",t),e.on("error",t)}))}function isArrayBuffer(e){return e&&"number"==typeof e.byteLength}class ReportTransform extends Transform{_transform(e,t,r){this.push(e),this.loadedBytes+=e.length;try{this.progressCallback({loadedBytes:this.loadedBytes}),r()}catch(e){r(e)}}constructor(e){super(),this.loadedBytes=0,this.progressCallback=e}}class NodeHttpClient{constructor(){this.cachedHttpsAgents=new WeakMap}async sendRequest(e){var t,r,o;const n=new AbortController;let s;if(e.abortSignal){if(e.abortSignal.aborted)throw new AbortError("The operation was aborted.");s=e=>{"abort"===e.type&&n.abort()},e.abortSignal.addEventListener("abort",s)}e.timeout>0&&setTimeout((()=>{n.abort()}),e.timeout);const a=e.headers.get("Accept-Encoding"),i=(null==a?void 0:a.includes("gzip"))||(null==a?void 0:a.includes("deflate"));let l,d="function"==typeof e.body?e.body():e.body;if(d&&!e.headers.has("Content-Length")){const t=getBodyLength(d);null!==t&&e.headers.set("Content-Length",t)}try{if(d&&e.onUploadProgress){const t=e.onUploadProgress,r=new ReportTransform(t);r.on("error",(e=>{logger.error("Error in upload progress",e)})),isReadableStream(d)?d.pipe(r):r.end(d),d=r}const s=await this.makeRequest(e,n,d),a=getResponseHeaders(s),p={status:null!==(t=s.statusCode)&&void 0!==t?t:0,headers:a,request:e};if("HEAD"===e.method)return s.resume(),p;l=i?getDecodedResponseStream(s,a):s;const c=e.onDownloadProgress;if(c){const e=new ReportTransform(c);e.on("error",(e=>{logger.error("Error in download progress",e)})),l.pipe(e),l=e}return(null===(r=e.streamResponseStatusCodes)||void 0===r?void 0:r.has(Number.POSITIVE_INFINITY))||(null===(o=e.streamResponseStatusCodes)||void 0===o?void 0:o.has(p.status))?p.readableStreamBody=l:p.bodyAsText=await streamToText(l),p}finally{if(e.abortSignal&&s){let t=Promise.resolve();isReadableStream(d)&&(t=isStreamComplete(d));let r=Promise.resolve();isReadableStream(l)&&(r=isStreamComplete(l)),Promise.all([t,r]).then((()=>{var t;s&&(null===(t=e.abortSignal)||void 0===t||t.removeEventListener("abort",s))})).catch((e=>{logger.warning("Error when cleaning up abortListener on httpRequest",e)}))}}}makeRequest(e,t,r){var o;const n=new URL(e.url),s="https:"!==n.protocol;if(s&&!e.allowInsecureConnection)throw new Error(`Cannot connect to ${e.url} while allowInsecureConnection is false.`);const a={agent:null!==(o=e.agent)&&void 0!==o?o:this.getOrCreateAgent(e,s),hostname:n.hostname,path:`${n.pathname}${n.search}`,port:n.port,method:e.method,headers:e.headers.toJSON({preserveCase:!0})};return new Promise(((o,n)=>{const i=s?http.request(a,o):https.request(a,o);i.once("error",(t=>{var r;n(new RestError(t.message,{code:null!==(r=t.code)&&void 0!==r?r:RestError.REQUEST_SEND_ERROR,request:e}))})),t.signal.addEventListener("abort",(()=>{const e=new AbortError("The operation was aborted.");i.destroy(e),n(e)})),r&&isReadableStream(r)?r.pipe(i):r?"string"==typeof r||Buffer.isBuffer(r)?i.end(r):isArrayBuffer(r)?i.end(ArrayBuffer.isView(r)?Buffer.from(r.buffer):Buffer.from(r)):(logger.error("Unrecognized body type",r),n(new RestError("Unrecognized body type"))):i.end()}))}getOrCreateAgent(e,t){var r;const o=e.disableKeepAlive;if(t)return o?http.globalAgent:(this.cachedHttpAgent||(this.cachedHttpAgent=new http.Agent({keepAlive:!0})),this.cachedHttpAgent);{if(o&&!e.tlsSettings)return https.globalAgent;const t=null!==(r=e.tlsSettings)&&void 0!==r?r:DEFAULT_TLS_SETTINGS;let n=this.cachedHttpsAgents.get(t);return n&&n.options.keepAlive===!o||(logger.info("No cached TLS Agent exist, creating a new Agent"),n=new https.Agent(Object.assign({keepAlive:!o},t)),this.cachedHttpsAgents.set(t,n)),n}}}function getResponseHeaders(e){const t=createHttpHeaders();for(const r of Object.keys(e.headers)){const o=e.headers[r];Array.isArray(o)?o.length>0&&t.set(r,o[0]):o&&t.set(r,o)}return t}function getDecodedResponseStream(e,t){const r=t.get("Content-Encoding");if("gzip"===r){const t=zlib.createGunzip();return e.pipe(t),t}if("deflate"===r){const t=zlib.createInflate();return e.pipe(t),t}return e}function streamToText(e){return new Promise(((t,r)=>{const o=[];e.on("data",(e=>{Buffer.isBuffer(e)?o.push(e):o.push(Buffer.from(e))})),e.on("end",(()=>{t(Buffer.concat(o).toString("utf8"))})),e.on("error",(e=>{e&&"AbortError"===(null==e?void 0:e.name)?r(e):r(new RestError(`Error reading response as text: ${e.message}`,{code:RestError.PARSE_ERROR}))}))}))}export function getBodyLength(e){return e?Buffer.isBuffer(e)?e.length:isReadableStream(e)?null:isArrayBuffer(e)?e.byteLength:"string"==typeof e?Buffer.from(e).length:null:0}export function createNodeHttpClient(){return new NodeHttpClient}