import{createTracingClient}from"@azure/core-tracing";import{SDK_VERSION}from"../constants.js";import{getUserAgentValue}from"../util/userAgent.js";import{logger}from"../log.js";import{getErrorMessage,isError}from"@azure/core-util";import{isRestError}from"../restError.js";import{Sanitizer}from"../util/sanitizer.js";export const tracingPolicyName="tracingPolicy";export function tracingPolicy(t={}){const r=getUserAgentValue(t.userAgentPrefix),e=new Sanitizer({additionalAllowedQueryParameters:t.additionalAllowedQueryParameters}),n=tryCreateTracingClient();return{name:"tracingPolicy",async sendRequest(t,s){var i,a;if(!n||!(null===(i=t.tracingOptions)||void 0===i?void 0:i.tracingContext))return s(t);const o=await r,c={"http.url":e.sanitizeUrl(t.url),"http.method":t.method,"http.user_agent":o,requestId:t.requestId};o&&(c["http.user_agent"]=o);const{span:g,tracingContext:u}=null!==(a=tryCreateSpan(n,t,c))&&void 0!==a?a:{};if(!g||!u)return s(t);try{const r=await n.withContext(u,s,t);return tryProcessResponse(g,r),r}catch(t){throw tryProcessError(g,t),t}}}}function tryCreateTracingClient(){try{return createTracingClient({namespace:"",packageName:"@azure/core-rest-pipeline",packageVersion:SDK_VERSION})}catch(t){return void logger.warning(`Error when creating the TracingClient: ${getErrorMessage(t)}`)}}function tryCreateSpan(t,r,e){try{const{span:n,updatedOptions:s}=t.startSpan(`HTTP ${r.method}`,{tracingOptions:r.tracingOptions},{spanKind:"client",spanAttributes:e});if(!n.isRecording())return void n.end();const i=t.createRequestHeaders(s.tracingOptions.tracingContext);for(const[t,e]of Object.entries(i))r.headers.set(t,e);return{span:n,tracingContext:s.tracingOptions.tracingContext}}catch(t){return void logger.warning(`Skipping creating a tracing span due to an error: ${getErrorMessage(t)}`)}}function tryProcessError(t,r){try{t.setStatus({status:"error",error:isError(r)?r:void 0}),isRestError(r)&&r.statusCode&&t.setAttribute("http.status_code",r.statusCode),t.end()}catch(t){logger.warning(`Skipping tracing span processing due to an error: ${getErrorMessage(t)}`)}}function tryProcessResponse(t,r){try{t.setAttribute("http.status_code",r.status);const e=r.headers.get("x-ms-request-id");e&&t.setAttribute("serviceRequestId",e),t.setStatus({status:"success"}),t.end()}catch(t){logger.warning(`Skipping tracing span processing due to an error: ${getErrorMessage(t)}`)}}