"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.createFetchHttpClient=createFetchHttpClient;const abort_controller_1=require("@azure/abort-controller"),restError_js_1=require("./restError.js"),httpHeaders_js_1=require("./httpHeaders.js"),typeGuards_js_1=require("./util/typeGuards.js");function isBlob(e){return("function"==typeof Blob||"object"==typeof Blob)&&e instanceof Blob}class FetchHttpClient{async sendRequest(e){if("https:"!==new URL(e.url).protocol&&!e.allowInsecureConnection)throw new Error(`Cannot connect to ${e.url} while allowInsecureConnection is false.`);if(e.proxySettings)throw new Error("HTTP proxy is not supported in browser environment");try{return await makeRequest(e)}catch(r){throw getError(r,e)}}}async function makeRequest(e){const{abortController:r,abortControllerCleanup:t}=setupAbortSignal(e);try{const o=buildFetchHeaders(e.headers),{streaming:n,body:s}=buildRequestBody(e),a=Object.assign(Object.assign({body:s,method:e.method,headers:o,signal:r.signal},"credentials"in Request.prototype?{credentials:e.withCredentials?"include":"same-origin"}:{}),"cache"in Request.prototype?{cache:"no-store"}:{});n&&(a.duplex="half");const l=await fetch(e.url,a);return isBlob(e.body)&&e.onUploadProgress&&e.onUploadProgress({loadedBytes:e.body.size}),buildPipelineResponse(l,e,t)}catch(e){throw null==t||t(),e}}async function buildPipelineResponse(e,r,t){var o,n;const s={request:r,headers:buildPipelineHeaders(e),status:e.status},a=(0,typeGuards_js_1.isWebReadableStream)(e.body)?buildBodyStream(e.body,{onProgress:r.onDownloadProgress,onEnd:t}):e.body;if((null===(o=r.streamResponseStatusCodes)||void 0===o?void 0:o.has(Number.POSITIVE_INFINITY))||(null===(n=r.streamResponseStatusCodes)||void 0===n?void 0:n.has(s.status)))if(r.enableBrowserStreams)s.browserStreamBody=null!=a?a:void 0;else{const e=new Response(a);s.blobBody=e.blob(),null==t||t()}else{const e=new Response(a);s.bodyAsText=await e.text(),null==t||t()}return s}function setupAbortSignal(e){const r=new AbortController;let t,o;if(e.abortSignal){if(e.abortSignal.aborted)throw new abort_controller_1.AbortError("The operation was aborted.");o=e=>{"abort"===e.type&&r.abort()},e.abortSignal.addEventListener("abort",o),t=()=>{var r;o&&(null===(r=e.abortSignal)||void 0===r||r.removeEventListener("abort",o))}}return e.timeout>0&&setTimeout((()=>{r.abort()}),e.timeout),{abortController:r,abortControllerCleanup:t}}function getError(e,r){var t;return e&&"AbortError"===(null==e?void 0:e.name)?e:new restError_js_1.RestError(`Error sending request: ${e.message}`,{code:null!==(t=null==e?void 0:e.code)&&void 0!==t?t:restError_js_1.RestError.REQUEST_SEND_ERROR,request:r})}function buildFetchHeaders(e){const r=new Headers;for(const[t,o]of e)r.append(t,o);return r}function buildPipelineHeaders(e){const r=(0,httpHeaders_js_1.createHttpHeaders)();for(const[t,o]of e.headers)r.set(t,o);return r}function buildRequestBody(e){const r="function"==typeof e.body?e.body():e.body;if((0,typeGuards_js_1.isNodeReadableStream)(r))throw new Error("Node streams are not supported in browser environment.");return(0,typeGuards_js_1.isWebReadableStream)(r)?{streaming:!0,body:buildBodyStream(r,{onProgress:e.onUploadProgress})}:{streaming:!1,body:r}}function buildBodyStream(e,r={}){let t=0;const{onProgress:o,onEnd:n}=r;if(isTransformStreamSupported(e))return e.pipeThrough(new TransformStream({transform(e,r){null!==e?(r.enqueue(e),t+=e.length,o&&o({loadedBytes:t})):r.terminate()},flush(){null==n||n()}}));{const r=e.getReader();return new ReadableStream({async pull(e){var s;const{done:a,value:l}=await r.read();if(a||!l)return null==n||n(),e.close(),void r.releaseLock();t+=null!==(s=null==l?void 0:l.length)&&void 0!==s?s:0,e.enqueue(l),o&&o({loadedBytes:t})},cancel:e=>(null==n||n(),r.cancel(e))})}}function createFetchHttpClient(){return new FetchHttpClient}function isTransformStreamSupported(e){return void 0!==e.pipeThrough&&void 0!==self.TransformStream}