"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.getBodyLength=getBodyLength,exports.createNodeHttpClient=createNodeHttpClient;const tslib_1=require("tslib"),http=tslib_1.__importStar(require("node:http")),https=tslib_1.__importStar(require("node:https")),zlib=tslib_1.__importStar(require("node:zlib")),node_stream_1=require("node:stream"),abort_controller_1=require("@azure/abort-controller"),httpHeaders_js_1=require("./httpHeaders.js"),restError_js_1=require("./restError.js"),log_js_1=require("./log.js"),DEFAULT_TLS_SETTINGS={};function isReadableStream(e){return e&&"function"==typeof e.pipe}function isStreamComplete(e){return new Promise((t=>{e.on("close",t),e.on("end",t),e.on("error",t)}))}function isArrayBuffer(e){return e&&"number"==typeof e.byteLength}class ReportTransform extends node_stream_1.Transform{_transform(e,t,r){this.push(e),this.loadedBytes+=e.length;try{this.progressCallback({loadedBytes:this.loadedBytes}),r()}catch(e){r(e)}}constructor(e){super(),this.loadedBytes=0,this.progressCallback=e}}class NodeHttpClient{constructor(){this.cachedHttpsAgents=new WeakMap}async sendRequest(e){var t,r,o;const s=new AbortController;let n;if(e.abortSignal){if(e.abortSignal.aborted)throw new abort_controller_1.AbortError("The operation was aborted.");n=e=>{"abort"===e.type&&s.abort()},e.abortSignal.addEventListener("abort",n)}e.timeout>0&&setTimeout((()=>{s.abort()}),e.timeout);const a=e.headers.get("Accept-Encoding"),i=(null==a?void 0:a.includes("gzip"))||(null==a?void 0:a.includes("deflate"));let l,d="function"==typeof e.body?e.body():e.body;if(d&&!e.headers.has("Content-Length")){const t=getBodyLength(d);null!==t&&e.headers.set("Content-Length",t)}try{if(d&&e.onUploadProgress){const t=e.onUploadProgress,r=new ReportTransform(t);r.on("error",(e=>{log_js_1.logger.error("Error in upload progress",e)})),isReadableStream(d)?d.pipe(r):r.end(d),d=r}const n=await this.makeRequest(e,s,d),a=getResponseHeaders(n),u={status:null!==(t=n.statusCode)&&void 0!==t?t:0,headers:a,request:e};if("HEAD"===e.method)return n.resume(),u;l=i?getDecodedResponseStream(n,a):n;const c=e.onDownloadProgress;if(c){const e=new ReportTransform(c);e.on("error",(e=>{log_js_1.logger.error("Error in download progress",e)})),l.pipe(e),l=e}return(null===(r=e.streamResponseStatusCodes)||void 0===r?void 0:r.has(Number.POSITIVE_INFINITY))||(null===(o=e.streamResponseStatusCodes)||void 0===o?void 0:o.has(u.status))?u.readableStreamBody=l:u.bodyAsText=await streamToText(l),u}finally{if(e.abortSignal&&n){let t=Promise.resolve();isReadableStream(d)&&(t=isStreamComplete(d));let r=Promise.resolve();isReadableStream(l)&&(r=isStreamComplete(l)),Promise.all([t,r]).then((()=>{var t;n&&(null===(t=e.abortSignal)||void 0===t||t.removeEventListener("abort",n))})).catch((e=>{log_js_1.logger.warning("Error when cleaning up abortListener on httpRequest",e)}))}}}makeRequest(e,t,r){var o;const s=new URL(e.url),n="https:"!==s.protocol;if(n&&!e.allowInsecureConnection)throw new Error(`Cannot connect to ${e.url} while allowInsecureConnection is false.`);const a={agent:null!==(o=e.agent)&&void 0!==o?o:this.getOrCreateAgent(e,n),hostname:s.hostname,path:`${s.pathname}${s.search}`,port:s.port,method:e.method,headers:e.headers.toJSON({preserveCase:!0})};return new Promise(((o,s)=>{const i=n?http.request(a,o):https.request(a,o);i.once("error",(t=>{var r;s(new restError_js_1.RestError(t.message,{code:null!==(r=t.code)&&void 0!==r?r:restError_js_1.RestError.REQUEST_SEND_ERROR,request:e}))})),t.signal.addEventListener("abort",(()=>{const e=new abort_controller_1.AbortError("The operation was aborted.");i.destroy(e),s(e)})),r&&isReadableStream(r)?r.pipe(i):r?"string"==typeof r||Buffer.isBuffer(r)?i.end(r):isArrayBuffer(r)?i.end(ArrayBuffer.isView(r)?Buffer.from(r.buffer):Buffer.from(r)):(log_js_1.logger.error("Unrecognized body type",r),s(new restError_js_1.RestError("Unrecognized body type"))):i.end()}))}getOrCreateAgent(e,t){var r;const o=e.disableKeepAlive;if(t)return o?http.globalAgent:(this.cachedHttpAgent||(this.cachedHttpAgent=new http.Agent({keepAlive:!0})),this.cachedHttpAgent);{if(o&&!e.tlsSettings)return https.globalAgent;const t=null!==(r=e.tlsSettings)&&void 0!==r?r:DEFAULT_TLS_SETTINGS;let s=this.cachedHttpsAgents.get(t);return s&&s.options.keepAlive===!o||(log_js_1.logger.info("No cached TLS Agent exist, creating a new Agent"),s=new https.Agent(Object.assign({keepAlive:!o},t)),this.cachedHttpsAgents.set(t,s)),s}}}function getResponseHeaders(e){const t=(0,httpHeaders_js_1.createHttpHeaders)();for(const r of Object.keys(e.headers)){const o=e.headers[r];Array.isArray(o)?o.length>0&&t.set(r,o[0]):o&&t.set(r,o)}return t}function getDecodedResponseStream(e,t){const r=t.get("Content-Encoding");if("gzip"===r){const t=zlib.createGunzip();return e.pipe(t),t}if("deflate"===r){const t=zlib.createInflate();return e.pipe(t),t}return e}function streamToText(e){return new Promise(((t,r)=>{const o=[];e.on("data",(e=>{Buffer.isBuffer(e)?o.push(e):o.push(Buffer.from(e))})),e.on("end",(()=>{t(Buffer.concat(o).toString("utf8"))})),e.on("error",(e=>{e&&"AbortError"===(null==e?void 0:e.name)?r(e):r(new restError_js_1.RestError(`Error reading response as text: ${e.message}`,{code:restError_js_1.RestError.PARSE_ERROR}))}))}))}function getBodyLength(e){return e?Buffer.isBuffer(e)?e.length:isReadableStream(e)?null:isArrayBuffer(e)?e.byteLength:"string"==typeof e?Buffer.from(e).length:null:0}function createNodeHttpClient(){return new NodeHttpClient}