"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.retryPolicy=retryPolicy;const helpers_js_1=require("../util/helpers.js"),logger_1=require("@azure/logger"),abort_controller_1=require("@azure/abort-controller"),constants_js_1=require("../constants.js"),retryPolicyLogger=(0,logger_1.createClientLogger)("core-rest-pipeline retryPolicy"),retryPolicyName="retryPolicy";function retryPolicy(r,e={maxRetries:constants_js_1.DEFAULT_RETRY_POLICY_COUNT}){const t=e.logger||retryPolicyLogger;return{name:retryPolicyName,async sendRequest(o,i){var s,n;let a,y,c=-1;r:for(;;){c+=1,a=void 0,y=void 0;try{t.info(`Retry ${c}: Attempting to send request`,o.requestId),a=await i(o),t.info(`Retry ${c}: Received a response from request`,o.requestId)}catch(r){if(t.error(`Retry ${c}: Received an error from request`,o.requestId),y=r,!r||"RestError"!==y.name)throw r;a=y.response}if(null===(s=o.abortSignal)||void 0===s?void 0:s.aborted){t.error(`Retry ${c}: Request aborted.`);throw new abort_controller_1.AbortError}if(c>=(null!==(n=e.maxRetries)&&void 0!==n?n:constants_js_1.DEFAULT_RETRY_POLICY_COUNT)){if(t.info(`Retry ${c}: Maximum retries reached. Returning the last received response, or throwing the last received error.`),y)throw y;if(a)return a;throw new Error("Maximum retries reached with no response or error to throw")}t.info(`Retry ${c}: Processing ${r.length} retry strategies.`);e:for(const e of r){const r=e.logger||retryPolicyLogger;r.info(`Retry ${c}: Processing retry strategy ${e.name}.`);const t=e.retry({retryCount:c,response:a,responseError:y});if(t.skipStrategy){r.info(`Retry ${c}: Skipped.`);continue e}const{errorToThrow:i,retryAfterInMs:s,redirectTo:n}=t;if(i)throw r.error(`Retry ${c}: Retry strategy ${e.name} throws error:`,i),i;if(s||0===s){r.info(`Retry ${c}: Retry strategy ${e.name} retries after ${s}`),await(0,helpers_js_1.delay)(s,void 0,{abortSignal:o.abortSignal});continue r}if(n){r.info(`Retry ${c}: Retry strategy ${e.name} redirects to ${n}`),o.url=n;continue r}}if(y)throw t.info("None of the retry strategies could work with the received error. Throwing it."),y;if(a)return t.info("None of the retry strategies could work with the received response. Returning it."),a}}}}