"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.tracingPolicyName=void 0,exports.tracingPolicy=tracingPolicy;const core_tracing_1=require("@azure/core-tracing"),constants_js_1=require("../constants.js"),userAgent_js_1=require("../util/userAgent.js"),log_js_1=require("../log.js"),core_util_1=require("@azure/core-util"),restError_js_1=require("../restError.js"),sanitizer_js_1=require("../util/sanitizer.js");function tracingPolicy(t={}){const r=(0,userAgent_js_1.getUserAgentValue)(t.userAgentPrefix),e=new sanitizer_js_1.Sanitizer({additionalAllowedQueryParameters:t.additionalAllowedQueryParameters}),s=tryCreateTracingClient();return{name:exports.tracingPolicyName,async sendRequest(t,n){var i,a;if(!s||!(null===(i=t.tracingOptions)||void 0===i?void 0:i.tracingContext))return n(t);const o=await r,c={"http.url":e.sanitizeUrl(t.url),"http.method":t.method,"http.user_agent":o,requestId:t.requestId};o&&(c["http.user_agent"]=o);const{span:u,tracingContext:g}=null!==(a=tryCreateSpan(s,t,c))&&void 0!==a?a:{};if(!u||!g)return n(t);try{const r=await s.withContext(g,n,t);return tryProcessResponse(u,r),r}catch(t){throw tryProcessError(u,t),t}}}}function tryCreateTracingClient(){try{return(0,core_tracing_1.createTracingClient)({namespace:"",packageName:"@azure/core-rest-pipeline",packageVersion:constants_js_1.SDK_VERSION})}catch(t){return void log_js_1.logger.warning(`Error when creating the TracingClient: ${(0,core_util_1.getErrorMessage)(t)}`)}}function tryCreateSpan(t,r,e){try{const{span:s,updatedOptions:n}=t.startSpan(`HTTP ${r.method}`,{tracingOptions:r.tracingOptions},{spanKind:"client",spanAttributes:e});if(!s.isRecording())return void s.end();const i=t.createRequestHeaders(n.tracingOptions.tracingContext);for(const[t,e]of Object.entries(i))r.headers.set(t,e);return{span:s,tracingContext:n.tracingOptions.tracingContext}}catch(t){return void log_js_1.logger.warning(`Skipping creating a tracing span due to an error: ${(0,core_util_1.getErrorMessage)(t)}`)}}function tryProcessError(t,r){try{t.setStatus({status:"error",error:(0,core_util_1.isError)(r)?r:void 0}),(0,restError_js_1.isRestError)(r)&&r.statusCode&&t.setAttribute("http.status_code",r.statusCode),t.end()}catch(t){log_js_1.logger.warning(`Skipping tracing span processing due to an error: ${(0,core_util_1.getErrorMessage)(t)}`)}}function tryProcessResponse(t,r){try{t.setAttribute("http.status_code",r.status);const e=r.headers.get("x-ms-request-id");e&&t.setAttribute("serviceRequestId",e),t.setStatus({status:"success"}),t.end()}catch(t){log_js_1.logger.warning(`Skipping tracing span processing due to an error: ${(0,core_util_1.getErrorMessage)(t)}`)}}exports.tracingPolicyName="tracingPolicy";