import{AbortError}from"@azure/abort-controller";import{RestError}from"./restError.js";import{createHttpHeaders}from"./httpHeaders.js";import{isNodeReadableStream,isWebReadableStream}from"./util/typeGuards.js";function isBlob(e){return("function"==typeof Blob||"object"==typeof Blob)&&e instanceof Blob}class FetchHttpClient{async sendRequest(e){if("https:"!==new URL(e.url).protocol&&!e.allowInsecureConnection)throw new Error(`Cannot connect to ${e.url} while allowInsecureConnection is false.`);if(e.proxySettings)throw new Error("HTTP proxy is not supported in browser environment");try{return await makeRequest(e)}catch(r){throw getError(r,e)}}}async function makeRequest(e){const{abortController:r,abortControllerCleanup:o}=setupAbortSignal(e);try{const t=buildFetchHeaders(e.headers),{streaming:n,body:s}=buildRequestBody(e),a=Object.assign(Object.assign({body:s,method:e.method,headers:t,signal:r.signal},"credentials"in Request.prototype?{credentials:e.withCredentials?"include":"same-origin"}:{}),"cache"in Request.prototype?{cache:"no-store"}:{});n&&(a.duplex="half");const l=await fetch(e.url,a);return isBlob(e.body)&&e.onUploadProgress&&e.onUploadProgress({loadedBytes:e.body.size}),buildPipelineResponse(l,e,o)}catch(e){throw null==o||o(),e}}async function buildPipelineResponse(e,r,o){var t,n;const s={request:r,headers:buildPipelineHeaders(e),status:e.status},a=isWebReadableStream(e.body)?buildBodyStream(e.body,{onProgress:r.onDownloadProgress,onEnd:o}):e.body;if((null===(t=r.streamResponseStatusCodes)||void 0===t?void 0:t.has(Number.POSITIVE_INFINITY))||(null===(n=r.streamResponseStatusCodes)||void 0===n?void 0:n.has(s.status)))if(r.enableBrowserStreams)s.browserStreamBody=null!=a?a:void 0;else{const e=new Response(a);s.blobBody=e.blob(),null==o||o()}else{const e=new Response(a);s.bodyAsText=await e.text(),null==o||o()}return s}function setupAbortSignal(e){const r=new AbortController;let o,t;if(e.abortSignal){if(e.abortSignal.aborted)throw new AbortError("The operation was aborted.");t=e=>{"abort"===e.type&&r.abort()},e.abortSignal.addEventListener("abort",t),o=()=>{var r;t&&(null===(r=e.abortSignal)||void 0===r||r.removeEventListener("abort",t))}}return e.timeout>0&&setTimeout((()=>{r.abort()}),e.timeout),{abortController:r,abortControllerCleanup:o}}function getError(e,r){var o;return e&&"AbortError"===(null==e?void 0:e.name)?e:new RestError(`Error sending request: ${e.message}`,{code:null!==(o=null==e?void 0:e.code)&&void 0!==o?o:RestError.REQUEST_SEND_ERROR,request:r})}function buildFetchHeaders(e){const r=new Headers;for(const[o,t]of e)r.append(o,t);return r}function buildPipelineHeaders(e){const r=createHttpHeaders();for(const[o,t]of e.headers)r.set(o,t);return r}function buildRequestBody(e){const r="function"==typeof e.body?e.body():e.body;if(isNodeReadableStream(r))throw new Error("Node streams are not supported in browser environment.");return isWebReadableStream(r)?{streaming:!0,body:buildBodyStream(r,{onProgress:e.onUploadProgress})}:{streaming:!1,body:r}}function buildBodyStream(e,r={}){let o=0;const{onProgress:t,onEnd:n}=r;if(isTransformStreamSupported(e))return e.pipeThrough(new TransformStream({transform(e,r){null!==e?(r.enqueue(e),o+=e.length,t&&t({loadedBytes:o})):r.terminate()},flush(){null==n||n()}}));{const r=e.getReader();return new ReadableStream({async pull(e){var s;const{done:a,value:l}=await r.read();if(a||!l)return null==n||n(),e.close(),void r.releaseLock();o+=null!==(s=null==l?void 0:l.length)&&void 0!==s?s:0,e.enqueue(l),t&&t({loadedBytes:o})},cancel:e=>(null==n||n(),r.cancel(e))})}}export function createFetchHttpClient(){return new FetchHttpClient}function isTransformStreamSupported(e){return void 0!==e.pipeThrough&&void 0!==self.TransformStream}