import{ServiceClient}from"@azure/core-client";import{isNode}from"@azure/core-util";import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{AbortController}from"@azure/abort-controller";import{AuthenticationError,AuthenticationErrorName}from"../errors";import{getIdentityTokenEndpointSuffix}from"../util/identityTokenEndpoint";import{DefaultAuthorityHost,SDK_VERSION}from"../constants";import{tracingClient}from"../util/tracing";import{logger}from"../util/logging";import{parseExpirationTimestamp}from"../credentials/managedIdentityCredential/utils";const noCorrelationId="noCorrelationId";export function getIdentityClientAuthorityHost(e){let t=null==e?void 0:e.authorityHost;return isNode&&(t=null!=t?t:process.env.AZURE_AUTHORITY_HOST),null!=t?t:DefaultAuthorityHost}export class IdentityClient extends ServiceClient{constructor(e){var t,n;const o=`azsdk-js-identity/${SDK_VERSION}`,r=(null===(t=null==e?void 0:e.userAgentOptions)||void 0===t?void 0:t.userAgentPrefix)?`${e.userAgentOptions.userAgentPrefix} ${o}`:`${o}`,i=getIdentityClientAuthorityHost(e);if(!i.startsWith("https:"))throw new Error("The authorityHost address must use the 'https' protocol.");super(Object.assign(Object.assign({requestContentType:"application/json; charset=utf-8",retryOptions:{maxRetries:3}},e),{userAgentOptions:{userAgentPrefix:r},baseUri:i})),this.allowInsecureConnection=!1,this.authorityHost=i,this.abortControllers=new Map,this.allowLoggingAccountIdentifiers=null===(n=null==e?void 0:e.loggingOptions)||void 0===n?void 0:n.allowLoggingAccountIdentifiers,this.tokenCredentialOptions=Object.assign({},e),(null==e?void 0:e.allowInsecureConnection)&&(this.allowInsecureConnection=e.allowInsecureConnection)}async sendTokenRequest(e){logger.info(`IdentityClient: sending token request to [${e.url}]`);const t=await this.sendRequest(e);if(!t.bodyAsText||200!==t.status&&201!==t.status){const e=new AuthenticationError(t.status,t.bodyAsText);throw logger.warning(`IdentityClient: authentication error. HTTP status: ${t.status}, ${e.errorResponse.errorDescription}`),e}{const n=JSON.parse(t.bodyAsText);if(!n.access_token)return null;this.logIdentifiers(t);const o={accessToken:{token:n.access_token,expiresOnTimestamp:parseExpirationTimestamp(n)},refreshToken:n.refresh_token};return logger.info(`IdentityClient: [${e.url}] token acquired, expires on ${o.accessToken.expiresOnTimestamp}`),o}}async refreshAccessToken(e,t,n,o,r,i={}){if(void 0===o)return null;logger.info(`IdentityClient: refreshing access token with client ID: ${t}, scopes: ${n} started`);const s={grant_type:"refresh_token",client_id:t,refresh_token:o,scope:n};void 0!==r&&(s.client_secret=r);const a=new URLSearchParams(s);return tracingClient.withSpan("IdentityClient.refreshAccessToken",i,(async n=>{try{const o=getIdentityTokenEndpointSuffix(e),r=createPipelineRequest({url:`${this.authorityHost}/${e}/${o}`,method:"POST",body:a.toString(),abortSignal:i.abortSignal,headers:createHttpHeaders({Accept:"application/json","Content-Type":"application/x-www-form-urlencoded"}),tracingOptions:n.tracingOptions}),s=await this.sendTokenRequest(r);return logger.info(`IdentityClient: refreshed token for client ID: ${t}`),s}catch(e){if(e.name===AuthenticationErrorName&&"interaction_required"===e.errorResponse.error)return logger.info(`IdentityClient: interaction required for client ID: ${t}`),null;throw logger.warning(`IdentityClient: failed refreshing token for client ID: ${t}: ${e}`),e}}))}generateAbortSignal(e){const t=new AbortController,n=this.abortControllers.get(e)||[];n.push(t),this.abortControllers.set(e,n);const o=t.signal.onabort;return t.signal.onabort=(...t)=>{this.abortControllers.set(e,void 0),o&&o(...t)},t.signal}abortRequests(e){const t=e||noCorrelationId,n=[...this.abortControllers.get(t)||[],...this.abortControllers.get(noCorrelationId)||[]];if(n.length){for(const e of n)e.abort();this.abortControllers.set(t,void 0)}}getCorrelationId(e){var t;const n=null===(t=null==e?void 0:e.body)||void 0===t?void 0:t.split("&").map((e=>e.split("="))).find((([e])=>"client-request-id"===e));return n&&n.length&&n[1]||noCorrelationId}async sendGetRequestAsync(e,t){const n=createPipelineRequest({url:e,method:"GET",body:null==t?void 0:t.body,allowInsecureConnection:this.allowInsecureConnection,headers:createHttpHeaders(null==t?void 0:t.headers),abortSignal:this.generateAbortSignal(noCorrelationId)}),o=await this.sendRequest(n);return this.logIdentifiers(o),{body:o.bodyAsText?JSON.parse(o.bodyAsText):void 0,headers:o.headers.toJSON(),status:o.status}}async sendPostRequestAsync(e,t){const n=createPipelineRequest({url:e,method:"POST",body:null==t?void 0:t.body,headers:createHttpHeaders(null==t?void 0:t.headers),allowInsecureConnection:this.allowInsecureConnection,abortSignal:this.generateAbortSignal(this.getCorrelationId(t))}),o=await this.sendRequest(n);return this.logIdentifiers(o),{body:o.bodyAsText?JSON.parse(o.bodyAsText):void 0,headers:o.headers.toJSON(),status:o.status}}getTokenCredentialOptions(){return this.tokenCredentialOptions}logIdentifiers(e){if(!this.allowLoggingAccountIdentifiers||!e.bodyAsText)return;try{const t=(e.parsedBody||JSON.parse(e.bodyAsText)).access_token;if(!t)return;const n=t.split(".")[1],{appid:o,upn:r,tid:i,oid:s}=JSON.parse(Buffer.from(n,"base64").toString("utf8"));logger.info(`[Authenticated account] Client ID: ${o}. Tenant ID: ${i}. User Principal Name: ${r||"No User Principal Name available"}. Object ID (user): ${s}`)}catch(e){logger.warning("allowLoggingAccountIdentifiers was set, but we couldn't log the account information. Error:",e.message)}}}