import{checkTenantId,processMultiTenantRequest,resolveAdditionallyAllowedTenantIds}from"../util/tenantIdUtils";import{credentialLogger,formatError,formatSuccess}from"../util/logging";import{ensureValidScopeForDevTimeCreds,getScopeResource}from"../util/scopeUtils";import{CredentialUnavailableError}from"../errors";import child_process from"child_process";import{tracingClient}from"../util/tracing";export const cliCredentialInternals={getSafeWorkingDir(){if("win32"===process.platform){if(!process.env.SystemRoot)throw new Error("Azure CLI credential expects a 'SystemRoot' environment variable");return process.env.SystemRoot}return"/bin"},async getAzureCliAccessToken(e,t,r){let n=[];return t&&(n=["--tenant",t]),new Promise(((t,o)=>{try{child_process.execFile("az",["account","get-access-token","--output","json","--resource",e,...n],{cwd:cliCredentialInternals.getSafeWorkingDir(),shell:!0,timeout:r},((e,r,n)=>{t({stdout:r,stderr:n,error:e})}))}catch(e){o(e)}}))}};const logger=credentialLogger("AzureCliCredential");export class AzureCliCredential{constructor(e){(null==e?void 0:e.tenantId)&&(checkTenantId(logger,null==e?void 0:e.tenantId),this.tenantId=null==e?void 0:e.tenantId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.timeout=null==e?void 0:e.processTimeoutInMs}async getToken(e,t={}){const r=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds);r&&checkTenantId(logger,r);const n="string"==typeof e?e:e[0];return logger.getToken.info(`Using the scope ${n}`),tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async()=>{var t,o,i,a;try{ensureValidScopeForDevTimeCreds(n,logger);const s=getScopeResource(n),l=await cliCredentialInternals.getAzureCliAccessToken(s,r,this.timeout),c=null===(t=l.stderr)||void 0===t?void 0:t.match("(.*)az login --scope(.*)"),d=(null===(o=l.stderr)||void 0===o?void 0:o.match("(.*)az login(.*)"))&&!c;if((null===(i=l.stderr)||void 0===i?void 0:i.match("az:(.*)not found"))||(null===(a=l.stderr)||void 0===a?void 0:a.startsWith("'az' is not recognized"))){const t=new CredentialUnavailableError("Azure CLI could not be found. Please visit https://aka.ms/azure-cli for installation instructions and then, once installed, authenticate to your Azure account using 'az login'.");throw logger.getToken.info(formatError(e,t)),t}if(d){const t=new CredentialUnavailableError("Please run 'az login' from a command prompt to authenticate before using this credential.");throw logger.getToken.info(formatError(e,t)),t}try{const t=l.stdout,r=this.parseRawResponse(t);return logger.getToken.info(formatSuccess(e)),r}catch(e){if(l.stderr)throw new CredentialUnavailableError(l.stderr);throw e}}catch(t){const r="CredentialUnavailableError"===t.name?t:new CredentialUnavailableError(t.message||"Unknown error while trying to retrieve the access token");throw logger.getToken.info(formatError(e,r)),r}}))}parseRawResponse(e){const t=JSON.parse(e),r=t.accessToken;let n=1e3*Number.parseInt(t.expires_on,10);if(!isNaN(n))return logger.getToken.info("expires_on is available and is valid, using it"),{token:r,expiresOnTimestamp:n};if(n=new Date(t.expiresOn).getTime(),isNaN(n))throw new CredentialUnavailableError(`Unexpected response from Azure CLI when getting token. Expected "expiresOn" to be a RFC3339 date string. Got: "${t.expiresOn}"`);return{token:r,expiresOnTimestamp:n}}}