import{credentialLogger,formatError,formatSuccess}from"../util/logging";import{CredentialUnavailableError}from"../errors";import child_process from"child_process";import{checkTenantId,processMultiTenantRequest,resolveAdditionallyAllowedTenantIds}from"../util/tenantIdUtils";import{tracingClient}from"../util/tracing";import{ensureValidScopeForDevTimeCreds}from"../util/scopeUtils";export const developerCliCredentialInternals={getSafeWorkingDir(){if("win32"===process.platform){if(!process.env.SystemRoot)throw new Error("Azure Developer CLI credential expects a 'SystemRoot' environment variable");return process.env.SystemRoot}return"/bin"},async getAzdAccessToken(e,t,r){let o=[];return t&&(o=["--tenant-id",t]),new Promise(((t,n)=>{try{child_process.execFile("azd",["auth","token","--output","json",...e.reduce(((e,t)=>e.concat("--scope",t)),[]),...o],{cwd:developerCliCredentialInternals.getSafeWorkingDir(),timeout:r},((e,r,o)=>{t({stdout:r,stderr:o,error:e})}))}catch(e){n(e)}}))}};const logger=credentialLogger("AzureDeveloperCliCredential");export class AzureDeveloperCliCredential{constructor(e){(null==e?void 0:e.tenantId)&&(checkTenantId(logger,null==e?void 0:e.tenantId),this.tenantId=null==e?void 0:e.tenantId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.timeout=null==e?void 0:e.processTimeoutInMs}async getToken(e,t={}){const r=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds);let o;return r&&checkTenantId(logger,r),o="string"==typeof e?[e]:e,logger.getToken.info(`Using the scopes ${e}`),tracingClient.withSpan(`${this.constructor.name}.getToken`,t,(async()=>{var t,n,i,l;try{o.forEach((e=>{ensureValidScopeForDevTimeCreds(e,logger)}));const a=await developerCliCredentialInternals.getAzdAccessToken(o,r,this.timeout),s=(null===(t=a.stderr)||void 0===t?void 0:t.match("not logged in, run `azd login` to login"))||(null===(n=a.stderr)||void 0===n?void 0:n.match("not logged in, run `azd auth login` to login"));if((null===(i=a.stderr)||void 0===i?void 0:i.match("azd:(.*)not found"))||(null===(l=a.stderr)||void 0===l?void 0:l.startsWith("'azd' is not recognized"))||a.error&&"ENOENT"===a.error.code){const t=new CredentialUnavailableError("Azure Developer CLI couldn't be found. To mitigate this issue, see the troubleshooting guidelines at https://aka.ms/azsdk/js/identity/azdevclicredential/troubleshoot.");throw logger.getToken.info(formatError(e,t)),t}if(s){const t=new CredentialUnavailableError("Please run 'azd auth login' from a command prompt to authenticate before using this credential. For more information, see the troubleshooting guidelines at https://aka.ms/azsdk/js/identity/azdevclicredential/troubleshoot.");throw logger.getToken.info(formatError(e,t)),t}try{const t=JSON.parse(a.stdout);return logger.getToken.info(formatSuccess(e)),{token:t.token,expiresOnTimestamp:new Date(t.expiresOn).getTime()}}catch(e){if(a.stderr)throw new CredentialUnavailableError(a.stderr);throw e}}catch(t){const r="CredentialUnavailableError"===t.name?t:new CredentialUnavailableError(t.message||"Unknown error while trying to retrieve the access token");throw logger.getToken.info(formatError(e,r)),r}}))}}