import{ClientAssertionCredential}from"./clientAssertionCredential";import{AuthenticationError,CredentialUnavailableError}from"../errors";import{credentialLogger}from"../util/logging";import{checkTenantId}from"../util/tenantIdUtils";import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{IdentityClient}from"../client/identityClient";const credentialName="AzurePipelinesCredential",logger=credentialLogger(credentialName),OIDC_API_VERSION="7.1";export class AzurePipelinesCredential{constructor(e,t,n,i,r){if(!(t&&e&&n&&i))throw new CredentialUnavailableError(`${credentialName}: is unavailable. tenantId, clientId, serviceConnectionId, and systemAccessToken are required parameters.`);if(this.identityClient=new IdentityClient(r),checkTenantId(logger,e),logger.info(`Invoking AzurePipelinesCredential with tenant ID: ${e}, client ID: ${t}, and service connection ID: ${n}`),!process.env.SYSTEM_OIDCREQUESTURI)throw new CredentialUnavailableError(`${credentialName}: is unavailable. Ensure that you're running this task in an Azure Pipeline, so that following missing system variable(s) can be defined- "SYSTEM_OIDCREQUESTURI"`);const o=`${process.env.SYSTEM_OIDCREQUESTURI}?api-version=7.1&serviceConnectionId=${n}`;logger.info(`Invoking ClientAssertionCredential with tenant ID: ${e}, client ID: ${t} and service connection ID: ${n}`),this.clientAssertionCredential=new ClientAssertionCredential(e,t,this.requestOidcToken.bind(this,o,i),r)}async getToken(e,t){if(!this.clientAssertionCredential){const e=`${credentialName}: is unavailable. To use Federation Identity in Azure Pipelines, the following parameters are required - \n      tenantId,\n      clientId,\n      serviceConnectionId,\n      systemAccessToken,\n      "SYSTEM_OIDCREQUESTURI".      \n      See the troubleshooting guide for more information: https://aka.ms/azsdk/js/identity/azurepipelinescredential/troubleshoot`;throw logger.error(e),new CredentialUnavailableError(e)}return logger.info("Invoking getToken() of Client Assertion Credential"),this.clientAssertionCredential.getToken(e,t)}async requestOidcToken(e,t){logger.info("Requesting OIDC token from Azure Pipelines..."),logger.info(e);const n=createPipelineRequest({url:e,method:"POST",headers:createHttpHeaders({"Content-Type":"application/json",Authorization:`Bearer ${t}`})});return handleOidcResponse(await this.identityClient.sendRequest(n))}}export function handleOidcResponse(e){const t=e.bodyAsText;if(!t)throw logger.error(`${credentialName}: Authentication Failed. Received null token from OIDC request. Response status- ${e.status}. Complete response - ${JSON.stringify(e)}`),new AuthenticationError(e.status,{error:`${credentialName}: Authentication Failed. Received null token from OIDC request.`,error_description:`${JSON.stringify(e)}. See the troubleshooting guide for more information: https://aka.ms/azsdk/js/identity/azurepipelinescredential/troubleshoot`});try{const n=JSON.parse(t);if(null==n?void 0:n.oidcToken)return n.oidcToken;{const t=`${credentialName}: Authentication Failed. oidcToken field not detected in the response.`;let i="";throw 200!==e.status&&(i=`Complete response - ${JSON.stringify(n)}. See the troubleshooting guide for more information: https://aka.ms/azsdk/js/identity/azurepipelinescredential/troubleshoot`),logger.error(t),logger.error(i),new AuthenticationError(e.status,{error:t,error_description:i})}}catch(n){const i=`${credentialName}: Authentication Failed. oidcToken field not detected in the response.`;throw logger.error(`Response from service = ${t} and error message = ${n.message}`),logger.error(i),new AuthenticationError(e.status,{error:i,error_description:`Response = ${t}. See the troubleshooting guide for more information: https://aka.ms/azsdk/js/identity/azurepipelinescredential/troubleshoot`})}}