import{checkTenantId,processMultiTenantRequest,resolveAdditionallyAllowedTenantIds}from"../util/tenantIdUtils";import{credentialLogger,formatError,formatSuccess}from"../util/logging";import{ensureValidScopeForDevTimeCreds,getScopeResource}from"../util/scopeUtils";import{CredentialUnavailableError}from"../errors";import{processUtils}from"../util/processUtils";import{tracingClient}from"../util/tracing";const logger=credentialLogger("AzurePowerShellCredential"),isWindows="win32"===process.platform;export function formatCommand(e){return isWindows?`${e}.exe`:e}async function runCommands(e,o){const t=[];for(const r of e){const[e,...n]=r,s=await processUtils.execFile(e,n,{encoding:"utf8",timeout:o});t.push(s)}return t}export const powerShellErrors={login:"Run Connect-AzAccount to login",installed:"The specified module 'Az.Accounts' with version '2.2.0' was not loaded because no valid module file was found in any module directory"};export const powerShellPublicErrorMessages={login:"Please run 'Connect-AzAccount' from PowerShell to authenticate before using this credential.",installed:"The 'Az.Account' module >= 2.2.0 is not installed. Install the Azure Az PowerShell module with: \"Install-Module -Name Az -Scope CurrentUser -Repository PSGallery -Force\".",troubleshoot:"To troubleshoot, visit https://aka.ms/azsdk/js/identity/powershellcredential/troubleshoot."};const isLoginError=e=>e.message.match(`(.*)${powerShellErrors.login}(.*)`),isNotInstalledError=e=>e.message.match(powerShellErrors.installed);export const commandStack=[formatCommand("pwsh")];isWindows&&commandStack.push(formatCommand("powershell"));export class AzurePowerShellCredential{constructor(e){(null==e?void 0:e.tenantId)&&(checkTenantId(logger,null==e?void 0:e.tenantId),this.tenantId=null==e?void 0:e.tenantId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),this.timeout=null==e?void 0:e.processTimeoutInMs}async getAzurePowerShellAccessToken(e,o,t){for(const r of[...commandStack]){try{await runCommands([[r,"/?"]],t)}catch(e){commandStack.shift();continue}let n="";o&&(n=`-TenantId "${o}"`);return parseJsonToken((await runCommands([[r,"-NoProfile","-NonInteractive","-Command","Import-Module Az.Accounts -MinimumVersion 2.2.0 -PassThru"],[r,"-NoProfile","-NonInteractive","-Command",`Get-AzAccessToken ${n} -ResourceUrl "${e}" | ConvertTo-Json`]]))[1])}throw new Error("Unable to execute PowerShell. Ensure that it is installed in your system")}async getToken(e,o={}){return tracingClient.withSpan(`${this.constructor.name}.getToken`,o,(async()=>{const t=processMultiTenantRequest(this.tenantId,o,this.additionallyAllowedTenantIds),r="string"==typeof e?e:e[0];t&&checkTenantId(logger,t);try{ensureValidScopeForDevTimeCreds(r,logger),logger.getToken.info(`Using the scope ${r}`);const o=getScopeResource(r),n=await this.getAzurePowerShellAccessToken(o,t,this.timeout);return logger.getToken.info(formatSuccess(e)),{token:n.Token,expiresOnTimestamp:new Date(n.ExpiresOn).getTime()}}catch(e){if(isNotInstalledError(e)){const e=new CredentialUnavailableError(powerShellPublicErrorMessages.installed);throw logger.getToken.info(formatError(r,e)),e}if(isLoginError(e)){const e=new CredentialUnavailableError(powerShellPublicErrorMessages.login);throw logger.getToken.info(formatError(r,e)),e}const o=new CredentialUnavailableError(`${e}. ${powerShellPublicErrorMessages.troubleshoot}`);throw logger.getToken.info(formatError(r,o)),o}}))}}export async function parseJsonToken(e){const o=e.match(/{[^{}]*}/g);let t=e;if(o)try{for(const e of o)try{const o=JSON.parse(e);if(null==o?void 0:o.Token)return t=t.replace(e,""),t&&logger.getToken.warning(t),o}catch(e){continue}}catch(o){throw new Error(`Unable to parse the output of PowerShell. Received output: ${e}`)}throw new Error(`No access token found in the output. Received output: ${e}`)}