import{createMsalClient}from"../msal/nodeFlows/msalClient";import{createHash,createPrivateKey}from"crypto";import{processMultiTenantRequest,resolveAdditionallyAllowedTenantIds}from"../util/tenantIdUtils";import{credentialLogger}from"../util/logging";import{readFile}from"fs/promises";import{tracingClient}from"../util/tracing";const credentialName="ClientCertificateCredential",logger=credentialLogger(credentialName);export class ClientCertificateCredential{constructor(t,e,i,a={}){if(!t||!e)throw new Error(`${credentialName}: tenantId and clientId are required parameters.`);this.tenantId=t,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==a?void 0:a.additionallyAllowedTenants),this.sendCertificateChain=a.sendCertificateChain,this.certificateConfiguration=Object.assign({},"string"==typeof i?{certificatePath:i}:i);const r=this.certificateConfiguration.certificate,n=this.certificateConfiguration.certificatePath;if(!this.certificateConfiguration||!r&&!n)throw new Error(`${credentialName}: Provide either a PEM certificate in string form, or the path to that certificate in the filesystem. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.`);if(r&&n)throw new Error(`${credentialName}: To avoid unexpected behaviors, providing both the contents of a PEM certificate and the path to a PEM certificate is forbidden. To troubleshoot, visit https://aka.ms/azsdk/js/identity/serviceprincipalauthentication/troubleshoot.`);this.msalClient=createMsalClient(e,t,Object.assign(Object.assign({},a),{logger:logger,tokenCredentialOptions:a}))}async getToken(t,e={}){return tracingClient.withSpan(`${credentialName}.getToken`,e,(async e=>{e.tenantId=processMultiTenantRequest(this.tenantId,e,this.additionallyAllowedTenantIds,logger);const i=Array.isArray(t)?t:[t],a=await this.buildClientCertificate();return this.msalClient.getTokenByClientCertificate(i,a,e)}))}async buildClientCertificate(){const t=await this.parseCertificate();let e;return e=void 0!==this.certificateConfiguration.certificatePassword?createPrivateKey({key:t.certificateContents,passphrase:this.certificateConfiguration.certificatePassword,format:"pem"}).export({format:"pem",type:"pkcs8"}).toString():t.certificateContents,{thumbprint:t.thumbprint,privateKey:e,x5c:t.x5c}}async parseCertificate(){const t=this.certificateConfiguration.certificate,e=this.certificateConfiguration.certificatePath,i=t||await readFile(e,"utf8"),a=this.sendCertificateChain?i:void 0,r=/(-+BEGIN CERTIFICATE-+)(\n\r?|\r\n?)([A-Za-z0-9+/\n\r]+=*)(\n\r?|\r\n?)(-+END CERTIFICATE-+)/g,n=[];let o;do{o=r.exec(i),o&&n.push(o[3])}while(o);if(0===n.length)throw new Error("The file at the specified path does not contain a PEM-encoded certificate.");return{certificateContents:i,thumbprint:createHash("sha1").update(Buffer.from(n[0],"base64")).digest("hex").toUpperCase(),x5c:a}}}