import{ManagedIdentityCredential}from"./managedIdentityCredential";import{AzureCliCredential}from"./azureCliCredential";import{AzureDeveloperCliCredential}from"./azureDeveloperCliCredential";import{AzurePowerShellCredential}from"./azurePowerShellCredential";import{ChainedTokenCredential}from"./chainedTokenCredential";import{EnvironmentCredential}from"./environmentCredential";import{WorkloadIdentityCredential}from"./workloadIdentityCredential";import{credentialLogger}from"../util/logging";const logger=credentialLogger("DefaultAzureCredential");export function createDefaultManagedIdentityCredential(e={}){var n,t,r,i;null!==(n=e.retryOptions)&&void 0!==n||(e.retryOptions={maxRetries:5,retryDelayInMs:800});const a=null!==(t=null==e?void 0:e.managedIdentityClientId)&&void 0!==t?t:process.env.AZURE_CLIENT_ID,l=null!==(r=null==e?void 0:e.workloadIdentityClientId)&&void 0!==r?r:a,o=null==e?void 0:e.managedIdentityResourceId,d=process.env.AZURE_FEDERATED_TOKEN_FILE,s=null!==(i=null==e?void 0:e.tenantId)&&void 0!==i?i:process.env.AZURE_TENANT_ID;if(o){const n=Object.assign(Object.assign({},e),{resourceId:o});return new ManagedIdentityCredential(n)}if(d&&l){const n=Object.assign(Object.assign({},e),{tenantId:s});return new ManagedIdentityCredential(l,n)}if(a){const n=Object.assign(Object.assign({},e),{clientId:a});return new ManagedIdentityCredential(n)}return new ManagedIdentityCredential(e)}function createDefaultWorkloadIdentityCredential(e){var n,t,r;const i=null!==(n=null==e?void 0:e.managedIdentityClientId)&&void 0!==n?n:process.env.AZURE_CLIENT_ID,a=null!==(t=null==e?void 0:e.workloadIdentityClientId)&&void 0!==t?t:i,l=process.env.AZURE_FEDERATED_TOKEN_FILE,o=null!==(r=null==e?void 0:e.tenantId)&&void 0!==r?r:process.env.AZURE_TENANT_ID;if(l&&a){const n=Object.assign(Object.assign({},e),{tenantId:o,clientId:a,tokenFilePath:l});return new WorkloadIdentityCredential(n)}if(o){const n=Object.assign(Object.assign({},e),{tenantId:o});return new WorkloadIdentityCredential(n)}return new WorkloadIdentityCredential(e)}function createDefaultAzureDeveloperCliCredential(e={}){const n=e.processTimeoutInMs;return new AzureDeveloperCliCredential(Object.assign({processTimeoutInMs:n},e))}function createDefaultAzureCliCredential(e={}){const n=e.processTimeoutInMs;return new AzureCliCredential(Object.assign({processTimeoutInMs:n},e))}function createDefaultAzurePowershellCredential(e={}){const n=e.processTimeoutInMs;return new AzurePowerShellCredential(Object.assign({processTimeoutInMs:n},e))}export function createEnvironmentCredential(e={}){return new EnvironmentCredential(e)}export class UnavailableDefaultCredential{constructor(e,n){this.credentialName=e,this.credentialUnavailableErrorMessage=n}getToken(){return logger.getToken.info(`Skipping ${this.credentialName}, reason: ${this.credentialUnavailableErrorMessage}`),Promise.resolve(null)}}export class DefaultAzureCredential extends ChainedTokenCredential{constructor(e){super(...[createEnvironmentCredential,createDefaultWorkloadIdentityCredential,createDefaultManagedIdentityCredential,createDefaultAzureCliCredential,createDefaultAzurePowershellCredential,createDefaultAzureDeveloperCliCredential].map((n=>{try{return n(e)}catch(e){return logger.warning(`Skipped ${n.name} because of an error creating the credential: ${e}`),new UnavailableDefaultCredential(n.name,e.message)}})))}}