import{AuthenticationError,CredentialUnavailableError}from"../errors";import{credentialLogger,formatError,formatSuccess,processEnvVars}from"../util/logging";import{ClientCertificateCredential}from"./clientCertificateCredential";import{ClientSecretCredential}from"./clientSecretCredential";import{UsernamePasswordCredential}from"./usernamePasswordCredential";import{checkTenantId}from"../util/tenantIdUtils";import{tracingClient}from"../util/tracing";export const AllSupportedEnvironmentVariables=["AZURE_TENANT_ID","AZURE_CLIENT_ID","AZURE_CLIENT_SECRET","AZURE_CLIENT_CERTIFICATE_PATH","AZURE_CLIENT_CERTIFICATE_PASSWORD","AZURE_USERNAME","AZURE_PASSWORD","AZURE_ADDITIONALLY_ALLOWED_TENANTS"];function getAdditionallyAllowedTenants(){var e;return(null!==(e=process.env.AZURE_ADDITIONALLY_ALLOWED_TENANTS)&&void 0!==e?e:"").split(";")}const credentialName="EnvironmentCredential",logger=credentialLogger(credentialName);export class EnvironmentCredential{constructor(e){this._credential=void 0;const t=processEnvVars(AllSupportedEnvironmentVariables).assigned.join(", ");logger.info(`Found the following environment variables: ${t}`);const n=process.env.AZURE_TENANT_ID,r=process.env.AZURE_CLIENT_ID,i=process.env.AZURE_CLIENT_SECRET,o=getAdditionallyAllowedTenants(),a=Object.assign(Object.assign({},e),{additionallyAllowedTenantIds:o});if(n&&checkTenantId(logger,n),n&&r&&i)return logger.info(`Invoking ClientSecretCredential with tenant ID: ${n}, clientId: ${r} and clientSecret: [REDACTED]`),void(this._credential=new ClientSecretCredential(n,r,i,a));const l=process.env.AZURE_CLIENT_CERTIFICATE_PATH,s=process.env.AZURE_CLIENT_CERTIFICATE_PASSWORD;if(n&&r&&l)return logger.info(`Invoking ClientCertificateCredential with tenant ID: ${n}, clientId: ${r} and certificatePath: ${l}`),void(this._credential=new ClientCertificateCredential(n,r,{certificatePath:l,certificatePassword:s},a));const c=process.env.AZURE_USERNAME,d=process.env.AZURE_PASSWORD;n&&r&&c&&d&&(logger.info(`Invoking UsernamePasswordCredential with tenant ID: ${n}, clientId: ${r} and username: ${c}`),this._credential=new UsernamePasswordCredential(n,r,c,d,a))}async getToken(e,t={}){return tracingClient.withSpan(`${credentialName}.getToken`,t,(async t=>{if(this._credential)try{const n=await this._credential.getToken(e,t);return logger.getToken.info(formatSuccess(e)),n}catch(t){const n=new AuthenticationError(400,{error:`${credentialName} authentication failed. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`,error_description:t.message.toString().split("More details:").join("")});throw logger.getToken.info(formatError(e,n)),n}throw new CredentialUnavailableError(`${credentialName} is unavailable. No underlying credential could be used. To troubleshoot, visit https://aka.ms/azsdk/js/identity/environmentcredential/troubleshoot.`)}))}}