import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{AuthenticationError}from"../../errors";import{azureArcAPIVersion}from"./constants";import{credentialLogger}from"../../util/logging";import fs from"node:fs";import{mapScopesToResource}from"./utils";const msiName="ManagedIdentityCredential - Azure Arc MSI",logger=credentialLogger(msiName);function prepareRequestOptions(e,t,r){const s=mapScopesToResource(e);if(!s)throw new Error(`${msiName}: Multiple scopes are not supported.`);const n={resource:s,"api-version":azureArcAPIVersion};if(t&&(n.client_id=t),r&&(n.msi_res_id=r),!process.env.IDENTITY_ENDPOINT)throw new Error(`${msiName}: Missing environment variable: IDENTITY_ENDPOINT`);const i=new URLSearchParams(n);return createPipelineRequest({url:`${process.env.IDENTITY_ENDPOINT}?${i.toString()}`,method:"GET",headers:createHttpHeaders({Accept:"application/json",Metadata:"true"})})}async function filePathRequest(e,t){const r=await e.sendRequest(createPipelineRequest(t));if(401!==r.status){let e="";throw r.bodyAsText&&(e=` Response: ${r.bodyAsText}`),new AuthenticationError(r.status,`${msiName}: To authenticate with Azure Arc MSI, status code 401 is expected on the first request. ${e}`)}const s=r.headers.get("www-authenticate")||"";try{return s.split("=").slice(1)[0]}catch(e){throw Error(`Invalid www-authenticate header format: ${s}`)}}export function platformToFilePath(){switch(process.platform){case"win32":if(!process.env.PROGRAMDATA)throw new Error(`${msiName}: PROGRAMDATA environment variable has no value.`);return`${process.env.PROGRAMDATA}\\AzureConnectedMachineAgent\\Tokens`;case"linux":return"/var/opt/azcmagent/tokens";default:throw new Error(`${msiName}: Unsupported platform ${process.platform}.`)}}export function validateKeyFile(e){if(!e)throw new Error(`${msiName}: Failed to find the token file.`);if(!e.endsWith(".key"))throw new Error(`${msiName}: unexpected file path from HIMDS service: ${e}.`);const t=platformToFilePath();if(!e.startsWith(t))throw new Error(`${msiName}: unexpected file path from HIMDS service: ${e}.`);const r=fs.statSync(e);if(r.size>4096)throw new Error(`${msiName}: The file at ${e} is larger than expected at ${r.size} bytes.`)}export const arcMsi={name:"arc",async isAvailable({scopes:e}){if(!mapScopesToResource(e))return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;const t=Boolean(process.env.IMDS_ENDPOINT&&process.env.IDENTITY_ENDPOINT);return t||logger.info(`${msiName}: The environment variables needed are: IMDS_ENDPOINT and IDENTITY_ENDPOINT`),t},async getToken(e,t={}){var r;const{identityClient:s,scopes:n,clientId:i,resourceId:o}=e;i&&logger.warning(`${msiName}: user-assigned identities not supported. The argument clientId might be ignored by the service.`),o&&logger.warning(`${msiName}: user defined managed Identity by resource Id is not supported. Argument resourceId will be ignored.`),logger.info(`${msiName}: Authenticating.`);const a=Object.assign(Object.assign({disableJsonStringifyOnBody:!0,deserializationMapper:void 0,abortSignal:t.abortSignal},prepareRequestOptions(n,i,o)),{allowInsecureConnection:!0}),c=await filePathRequest(s,a);validateKeyFile(c);const l=await fs.promises.readFile(c,{encoding:"utf-8"});null===(r=a.headers)||void 0===r||r.set("Authorization",`Basic ${l}`);const p=createPipelineRequest(Object.assign(Object.assign({},a),{allowInsecureConnection:!0})),u=await s.sendTokenRequest(p);return u&&u.accessToken||null}};