import{createHttpHeaders,createPipelineRequest}from"@azure/core-rest-pipeline";import{delay,isError}from"@azure/core-util";import{imdsApiVersion,imdsEndpointPath,imdsHost}from"./constants";import{AuthenticationError}from"../../errors";import{credentialLogger}from"../../util/logging";import{mapScopesToResource}from"./utils";import{tracingClient}from"../../util/tracing";const msiName="ManagedIdentityCredential - IMDS",logger=credentialLogger(msiName);function prepareRequestOptions(e,t,i,r){var n;const o=mapScopesToResource(e);if(!o)throw new Error(`${msiName}: Multiple scopes are not supported.`);const{skipQuery:s,skipMetadataHeader:a}=r||{};let l="";if(!s){const e={resource:o,"api-version":imdsApiVersion};t&&(e.client_id=t),i&&(e.msi_res_id=i);l=`?${new URLSearchParams(e).toString()}`}const c=new URL(imdsEndpointPath,null!==(n=process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST)&&void 0!==n?n:imdsHost),p={Accept:"application/json",Metadata:"true"};return a&&delete p.Metadata,{url:`${c}${l}`,method:"GET",headers:createHttpHeaders(p)}}export const imdsMsi={name:"imdsMsi",async isAvailable({scopes:e,identityClient:t,clientId:i,resourceId:r,getTokenOptions:n={}}){const o=mapScopesToResource(e);if(!o)return logger.info(`${msiName}: Unavailable. Multiple scopes are not supported.`),!1;if(process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST)return!0;if(!t)throw new Error("Missing IdentityClient");const s=prepareRequestOptions(o,i,r,{skipMetadataHeader:!0,skipQuery:!0});return tracingClient.withSpan("ManagedIdentityCredential-pingImdsEndpoint",n,(async e=>{var i,r;s.tracingOptions=e.tracingOptions;const n=createPipelineRequest(s);let o;n.timeout=(null===(i=e.requestOptions)||void 0===i?void 0:i.timeout)||1e3,n.allowInsecureConnection=!0;try{logger.info(`${msiName}: Pinging the Azure IMDS endpoint`),o=await t.sendRequest(n)}catch(e){return isError(e)&&logger.verbose(`${msiName}: Caught error ${e.name}: ${e.message}`),logger.info(`${msiName}: The Azure IMDS endpoint is unavailable`),!1}return 403===o.status&&(null===(r=o.bodyAsText)||void 0===r?void 0:r.includes("unreachable"))?(logger.info(`${msiName}: The Azure IMDS endpoint is unavailable`),logger.info(`${msiName}: ${o.bodyAsText}`),!1):(logger.info(`${msiName}: The Azure IMDS endpoint is available`),!0)}))},async getToken(e,t={}){const{identityClient:i,scopes:r,clientId:n,resourceId:o}=e;process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST?logger.info(`${msiName}: Using the Azure IMDS endpoint coming from the environment variable AZURE_POD_IDENTITY_AUTHORITY_HOST=${process.env.AZURE_POD_IDENTITY_AUTHORITY_HOST}.`):logger.info(`${msiName}: Using the default Azure IMDS endpoint ${imdsHost}.`);let s=e.retryConfig.startDelayInMs;for(let a=0;a<e.retryConfig.maxRetries;a++)try{const e=createPipelineRequest(Object.assign(Object.assign({abortSignal:t.abortSignal},prepareRequestOptions(r,n,o)),{allowInsecureConnection:!0})),s=await i.sendTokenRequest(e);return s&&s.accessToken||null}catch(t){if(404===t.statusCode){await delay(s),s*=e.retryConfig.intervalIncrement;continue}throw t}throw new AuthenticationError(404,`${msiName}: Failed to retrieve IMDS token after ${e.retryConfig.maxRetries} retries.`)}};