import{ConfidentialClientApplication}from"@azure/msal-node";import{AuthenticationError,AuthenticationRequiredError,CredentialUnavailableError}from"../../errors";import{cloudShellMsi}from"./cloudShellMsi";import{credentialLogger,formatError,formatSuccess}from"../../util/logging";import{DeveloperSignOnClientId}from"../../constants";import{IdentityClient}from"../../client/identityClient";import{appServiceMsi2017}from"./appServiceMsi2017";import{appServiceMsi2019}from"./appServiceMsi2019";import{arcMsi}from"./arcMsi";import{fabricMsi}from"./fabricMsi";import{getLogLevel}from"@azure/logger";import{getMSALLogLevel}from"../../msal/utils";import{imdsMsi}from"./imdsMsi";import{tokenExchangeMsi}from"./tokenExchangeMsi";import{tracingClient}from"../../util/tracing";const logger=credentialLogger("ManagedIdentityCredential");export class LegacyMsiProvider{constructor(e,t){var i,n;let o;if(this.isEndpointUnavailable=null,this.isAppTokenProviderInitialized=!1,this.msiRetryConfig={maxRetries:5,startDelayInMs:800,intervalIncrement:2},"string"==typeof e?(this.clientId=e,o=t):(this.clientId=null==e?void 0:e.clientId,o=e),this.resourceId=null==o?void 0:o.resourceId,this.clientId&&this.resourceId)throw new Error("ManagedIdentityCredential - Client Id and Resource Id can't be provided at the same time.");void 0!==(null===(i=null==o?void 0:o.retryOptions)||void 0===i?void 0:i.maxRetries)&&(this.msiRetryConfig.maxRetries=o.retryOptions.maxRetries),this.identityClient=new IdentityClient(o),this.isAvailableIdentityClient=new IdentityClient(Object.assign(Object.assign({},o),{retryOptions:{maxRetries:0}})),this.confidentialApp=new ConfidentialClientApplication({auth:{authority:"https://login.microsoftonline.com/managed_identity",clientId:null!==(n=this.clientId)&&void 0!==n?n:DeveloperSignOnClientId,clientSecret:"dummy-secret",cloudDiscoveryMetadata:'{"tenant_discovery_endpoint":"https://login.microsoftonline.com/common/v2.0/.well-known/openid-configuration","api-version":"1.1","metadata":[{"preferred_network":"login.microsoftonline.com","preferred_cache":"login.windows.net","aliases":["login.microsoftonline.com","login.windows.net","login.microsoft.com","sts.windows.net"]},{"preferred_network":"login.partner.microsoftonline.cn","preferred_cache":"login.partner.microsoftonline.cn","aliases":["login.partner.microsoftonline.cn","login.chinacloudapi.cn"]},{"preferred_network":"login.microsoftonline.de","preferred_cache":"login.microsoftonline.de","aliases":["login.microsoftonline.de"]},{"preferred_network":"login.microsoftonline.us","preferred_cache":"login.microsoftonline.us","aliases":["login.microsoftonline.us","login.usgovcloudapi.net"]},{"preferred_network":"login-us.microsoftonline.com","preferred_cache":"login-us.microsoftonline.com","aliases":["login-us.microsoftonline.com"]}]}',authorityMetadata:'{"token_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/token","token_endpoint_auth_methods_supported":["client_secret_post","private_key_jwt","client_secret_basic"],"jwks_uri":"https://login.microsoftonline.com/common/discovery/v2.0/keys","response_modes_supported":["query","fragment","form_post"],"subject_types_supported":["pairwise"],"id_token_signing_alg_values_supported":["RS256"],"response_types_supported":["code","id_token","code id_token","id_token token"],"scopes_supported":["openid","profile","email","offline_access"],"issuer":"https://login.microsoftonline.com/{tenantid}/v2.0","request_uri_parameter_supported":false,"userinfo_endpoint":"https://graph.microsoft.com/oidc/userinfo","authorization_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/authorize","device_authorization_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/devicecode","http_logout_supported":true,"frontchannel_logout_supported":true,"end_session_endpoint":"https://login.microsoftonline.com/common/oauth2/v2.0/logout","claims_supported":["sub","iss","cloud_instance_name","cloud_instance_host_name","cloud_graph_host_name","msgraph_host","aud","exp","iat","auth_time","acr","nonce","preferred_username","name","tid","ver","at_hash","c_hash","email"],"kerberos_endpoint":"https://login.microsoftonline.com/common/kerberos","tenant_region_scope":null,"cloud_instance_name":"microsoftonline.com","cloud_graph_host_name":"graph.windows.net","msgraph_host":"graph.microsoft.com","rbac_url":"https://pas.windows.net"}',clientCapabilities:[]},system:{loggerOptions:{logLevel:getMSALLogLevel(getLogLevel())}}})}async cachedAvailableMSI(e,t){if(this.cachedMSI)return this.cachedMSI;const i=[arcMsi,fabricMsi,appServiceMsi2019,appServiceMsi2017,cloudShellMsi,tokenExchangeMsi,imdsMsi];for(const n of i)if(await n.isAvailable({scopes:e,identityClient:this.isAvailableIdentityClient,clientId:this.clientId,resourceId:this.resourceId,getTokenOptions:t}))return this.cachedMSI=n,n;throw new CredentialUnavailableError("ManagedIdentityCredential - No MSI credential available")}async authenticateManagedIdentity(e,t){const{span:i,updatedOptions:n}=tracingClient.startSpan("ManagedIdentityCredential.authenticateManagedIdentity",t);try{return(await this.cachedAvailableMSI(e,n)).getToken({identityClient:this.identityClient,scopes:e,clientId:this.clientId,resourceId:this.resourceId,retryConfig:this.msiRetryConfig},n)}catch(e){throw i.setStatus({status:"error",error:e}),e}finally{i.end()}}async getToken(e,t){let i=null;const{span:n,updatedOptions:o}=tracingClient.startSpan("ManagedIdentityCredential.getToken",t);try{if(!0===this.isEndpointUnavailable){const t=new CredentialUnavailableError("The managed identity endpoint is not currently available");throw logger.getToken.info(formatError(e,t)),t}if("tokenExchangeMsi"===(await this.cachedAvailableMSI(e,o)).name)i=await this.authenticateManagedIdentity(e,o);else{const n={correlationId:this.identityClient.getCorrelationId(),tenantId:(null==t?void 0:t.tenantId)||"managed_identity",scopes:Array.isArray(e)?e:[e],claims:null==t?void 0:t.claims};this.initializeSetAppTokenProvider();const o=await this.confidentialApp.acquireTokenByClientCredential(Object.assign({},n));i=this.handleResult(e,o||void 0)}if(null===i){this.isEndpointUnavailable=!0;const t=new CredentialUnavailableError("The managed identity endpoint was reached, yet no tokens were received.");throw logger.getToken.info(formatError(e,t)),t}this.isEndpointUnavailable=!1;return logger.getToken.info(formatSuccess(e)),i}catch(t){if("AuthenticationRequiredError"===t.name)throw t;if(n.setStatus({status:"error",error:t}),"ENETUNREACH"===t.code){const i=new CredentialUnavailableError(`ManagedIdentityCredential: Unavailable. Network unreachable. Message: ${t.message}`);throw logger.getToken.info(formatError(e,i)),i}if("EHOSTUNREACH"===t.code){const i=new CredentialUnavailableError(`ManagedIdentityCredential: Unavailable. No managed identity endpoint found. Message: ${t.message}`);throw logger.getToken.info(formatError(e,i)),i}if(400===t.statusCode)throw new CredentialUnavailableError(`ManagedIdentityCredential: The managed identity endpoint is indicating there's no available identity. Message: ${t.message}`);if((403===t.statusCode||403===t.code)&&t.message.includes("unreachable")){const i=new CredentialUnavailableError(`ManagedIdentityCredential: Unavailable. Network unreachable. Message: ${t.message}`);throw logger.getToken.info(formatError(e,i)),i}if(void 0===t.statusCode)throw new CredentialUnavailableError(`ManagedIdentityCredential: Authentication failed. Message ${t.message}`);throw new AuthenticationError(t.statusCode,{error:"ManagedIdentityCredential authentication failed.",error_description:t.message})}finally{n.end()}}handleResult(e,t,i){return this.ensureValidMsalToken(e,t,i),logger.getToken.info(formatSuccess(e)),{token:t.accessToken,expiresOnTimestamp:t.expiresOn.getTime()}}ensureValidMsalToken(e,t,i){const n=t=>(logger.getToken.info(t),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:i,message:t}));if(!t)throw n("No response");if(!t.expiresOn)throw n('Response had no "expiresOn" property.');if(!t.accessToken)throw n('Response had no "accessToken" property.')}initializeSetAppTokenProvider(){this.isAppTokenProviderInitialized||(this.confidentialApp.SetAppTokenProvider((async e=>{logger.info(`SetAppTokenProvider invoked with parameters- ${JSON.stringify(e)}`);const t=Object.assign({},e);logger.info(`authenticateManagedIdentity invoked with scopes- ${JSON.stringify(e.scopes)} and getTokenOptions - ${JSON.stringify(t)}`);const i=await this.authenticateManagedIdentity(e.scopes,t);if(i){logger.info("SetAppTokenProvider will save the token in cache");const e=(null==i?void 0:i.expiresOnTimestamp)?Math.floor((i.expiresOnTimestamp-Date.now())/1e3):0;return{accessToken:null==i?void 0:i.token,expiresInSeconds:e}}return logger.info('SetAppTokenProvider token has "no_access_token_returned" as the saved token'),{accessToken:"no_access_token_returned",expiresInSeconds:0}})),this.isAppTokenProviderInitialized=!0)}}