import{AuthenticationRequiredError,CredentialUnavailableError}from"../../errors";import{credentialLogger,formatError,formatSuccess}from"../../util/logging";import{defaultLoggerCallback,getMSALLogLevel}from"../../msal/utils";import{IdentityClient}from"../../client/identityClient";import{ManagedIdentityApplication}from"@azure/msal-node";import{getLogLevel}from"@azure/logger";import{imdsMsi}from"./imdsMsi";import{imdsRetryPolicy}from"./imdsRetryPolicy";import{mapScopesToResource}from"./utils";import{tokenExchangeMsi}from"./tokenExchangeMsi";import{tracingClient}from"../../util/tracing";const logger=credentialLogger("ManagedIdentityCredential(MSAL)");export class MsalMsiProvider{constructor(e,t={}){var i,n;this.msiRetryConfig={maxRetries:5,startDelayInMs:800,intervalIncrement:2};let r={};if("string"==typeof e?(this.clientId=e,r=t):(this.clientId=null==e?void 0:e.clientId,r=null!=e?e:{}),this.resourceId=null==r?void 0:r.resourceId,this.clientId&&this.resourceId)throw new Error("ManagedIdentityCredential - Client Id and Resource Id can't be provided at the same time.");r.allowInsecureConnection=!0,void 0!==(null===(i=null==r?void 0:r.retryOptions)||void 0===i?void 0:i.maxRetries)&&(this.msiRetryConfig.maxRetries=r.retryOptions.maxRetries),this.identityClient=new IdentityClient(Object.assign(Object.assign({},r),{additionalPolicies:[{policy:imdsRetryPolicy(this.msiRetryConfig),position:"perCall"}]})),this.managedIdentityApp=new ManagedIdentityApplication({managedIdentityIdParams:{userAssignedClientId:this.clientId,userAssignedResourceId:this.resourceId},system:{disableInternalRetries:!0,networkClient:this.identityClient,loggerOptions:{logLevel:getMSALLogLevel(getLogLevel()),piiLoggingEnabled:null===(n=t.loggingOptions)||void 0===n?void 0:n.enableUnsafeSupportLogging,loggerCallback:defaultLoggerCallback(logger)}}}),this.isAvailableIdentityClient=new IdentityClient(Object.assign(Object.assign({},r),{retryOptions:{maxRetries:0}}))}async getToken(e,t={}){logger.getToken.info("Using the MSAL provider for Managed Identity.");const i=mapScopesToResource(e);if(!i)throw new CredentialUnavailableError(`ManagedIdentityCredential: Multiple scopes are not supported. Scopes: ${JSON.stringify(e)}`);return tracingClient.withSpan("ManagedIdentityCredential.getToken",t,(async()=>{try{const n=await tokenExchangeMsi.isAvailable({scopes:e,clientId:this.clientId,getTokenOptions:t,identityClient:this.identityClient,resourceId:this.resourceId}),r=this.managedIdentityApp.getManagedIdentitySource(),o="DefaultToImds"===r||"Imds"===r;if(n){logger.getToken.info("Using the token exchange managed identity.");const t=await tokenExchangeMsi.getToken({scopes:e,clientId:this.clientId,identityClient:this.identityClient,retryConfig:this.msiRetryConfig,resourceId:this.resourceId});if(null===t)throw new CredentialUnavailableError("The managed identity endpoint was reached, yet no tokens were received.");return t}if(o){logger.getToken.info("Using the IMDS endpoint to probe for availability.");if(!await imdsMsi.isAvailable({scopes:e,clientId:this.clientId,getTokenOptions:t,identityClient:this.isAvailableIdentityClient,resourceId:this.resourceId}))throw new CredentialUnavailableError("ManagedIdentityCredential: The managed identity endpoint is not available.")}logger.getToken.info("Calling into MSAL for managed identity token.");const a=await this.managedIdentityApp.acquireToken({resource:i});return this.ensureValidMsalToken(e,a,t),logger.getToken.info(formatSuccess(e)),{expiresOnTimestamp:a.expiresOn.getTime(),token:a.accessToken}}catch(t){if(logger.getToken.error(formatError(e,t)),"AuthenticationRequiredError"===t.name)throw t;if(isNetworkError(t))throw new CredentialUnavailableError(`ManagedIdentityCredential: Network unreachable. Message: ${t.message}`);throw new CredentialUnavailableError(`ManagedIdentityCredential: Authentication failed. Message ${t.message}`)}}))}ensureValidMsalToken(e,t,i){const n=t=>(logger.getToken.info(t),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:i,message:t}));if(!t)throw n("No response");if(!t.expiresOn)throw n('Response had no "expiresOn" property.');if(!t.accessToken)throw n('Response had no "accessToken" property.')}}function isNetworkError(e){return"network_error"===e.errorCode||("ENETUNREACH"===e.code||"EHOSTUNREACH"===e.code||!(403!==e.statusCode&&403!==e.code||!e.message.includes("unreachable")))}