import{processMultiTenantRequest,resolveAdditionallyAllowedTenantIds}from"../util/tenantIdUtils";import{credentialLogger,formatError}from"../util/logging";import{ensureScopes}from"../util/scopeUtils";import{tracingClient}from"../util/tracing";import{createMsalClient}from"../msal/nodeFlows/msalClient";import{readFile}from"node:fs/promises";import{createHash}from"node:crypto";const credentialName="OnBehalfOfCredential",logger=credentialLogger(credentialName);export class OnBehalfOfCredential{constructor(e){const{clientSecret:t}=e,{certificatePath:i,sendCertificateChain:n}=e,{getAssertion:r}=e,{tenantId:s,clientId:a,userAssertionToken:o,additionallyAllowedTenants:c}=e;if(!(s&&a&&(t||i||r)&&o))throw new Error(`${credentialName}: tenantId, clientId, clientSecret (or certificatePath or getAssertion) and userAssertionToken are required parameters.`);this.certificatePath=i,this.clientSecret=t,this.userAssertionToken=o,this.sendCertificateChain=n,this.clientAssertion=r,this.tenantId=s,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(c),this.msalClient=createMsalClient(a,this.tenantId,Object.assign(Object.assign({},e),{logger:logger,tokenCredentialOptions:e}))}async getToken(e,t={}){return tracingClient.withSpan(`${credentialName}.getToken`,t,(async i=>{i.tenantId=processMultiTenantRequest(this.tenantId,i,this.additionallyAllowedTenantIds,logger);const n=ensureScopes(e);if(this.certificatePath){const e=await this.buildClientCertificate(this.certificatePath);return this.msalClient.getTokenOnBehalfOf(n,this.userAssertionToken,e,i)}if(this.clientSecret)return this.msalClient.getTokenOnBehalfOf(n,this.userAssertionToken,this.clientSecret,t);if(this.clientAssertion)return this.msalClient.getTokenOnBehalfOf(n,this.userAssertionToken,this.clientAssertion,t);throw new Error("Expected either clientSecret or certificatePath or clientAssertion to be defined.")}))}async buildClientCertificate(e){try{const t=await this.parseCertificate({certificatePath:e},this.sendCertificateChain);return{thumbprint:t.thumbprint,privateKey:t.certificateContents,x5c:t.x5c}}catch(e){throw logger.info(formatError("",e)),e}}async parseCertificate(e,t){const i=e.certificatePath,n=await readFile(i,"utf8"),r=t?n:void 0,s=/(-+BEGIN CERTIFICATE-+)(\n\r?|\r\n?)([A-Za-z0-9+/\n\r]+=*)(\n\r?|\r\n?)(-+END CERTIFICATE-+)/g,a=[];let o;do{o=s.exec(n),o&&a.push(o[3])}while(o);if(0===a.length)throw new Error("The file at the specified path does not contain a PEM-encoded certificate.");return{certificateContents:n,thumbprint:createHash("sha1").update(Buffer.from(a[0],"base64")).digest("hex").toUpperCase(),x5c:r}}}