import{credentialLogger,formatError,formatSuccess}from"../util/logging";import{processMultiTenantRequest,resolveAdditionallyAllowedTenantIds}from"../util/tenantIdUtils";import{AzureAuthorityHosts}from"../constants";import{CredentialUnavailableError}from"../errors";import{IdentityClient}from"../client/identityClient";import{checkTenantId}from"../util/tenantIdUtils";import fs from"fs";import os from"os";import path from"path";const CommonTenantId="common",AzureAccountClientId="aebc6443-996d-45c2-90f0-388ff96faa56",logger=credentialLogger("VisualStudioCodeCredential");let findCredentials;export const vsCodeCredentialControl={setVsCodeCredentialFinder(e){findCredentials=e}};const unsupportedTenantIds={adfs:"The VisualStudioCodeCredential does not support authentication with ADFS tenants."};function checkUnsupportedTenant(e){const t=unsupportedTenantIds[e];if(t)throw new CredentialUnavailableError(t)}const mapVSCodeAuthorityHosts={AzureCloud:AzureAuthorityHosts.AzurePublicCloud,AzureChina:AzureAuthorityHosts.AzureChina,AzureGermanCloud:AzureAuthorityHosts.AzureGermany,AzureUSGovernment:AzureAuthorityHosts.AzureGovernment};export function getPropertyFromVSCode(e){const t=["User","settings.json"],o=os.homedir();function n(...o){const n=path.join(...o,"Code",...t);return JSON.parse(fs.readFileSync(n,{encoding:"utf8"}))[e]}try{let e;switch(process.platform){case"win32":return e=process.env.APPDATA,e?n(e):void 0;case"darwin":return n(o,"Library","Application Support");case"linux":return n(o,".config");default:return}}catch(e){return void logger.info(`Failed to load the Visual Studio Code configuration file. Error: ${e.message}`)}}export class VisualStudioCodeCredential{constructor(e){this.cloudName=getPropertyFromVSCode("azure.cloud")||"AzureCloud";const t=mapVSCodeAuthorityHosts[this.cloudName];this.identityClient=new IdentityClient(Object.assign({authorityHost:t},e)),e&&e.tenantId?(checkTenantId(logger,e.tenantId),this.tenantId=e.tenantId):this.tenantId="common",this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null==e?void 0:e.additionallyAllowedTenants),checkUnsupportedTenant(this.tenantId)}async prepare(){const e=getPropertyFromVSCode("azure.tenant");e&&(this.tenantId=e),checkUnsupportedTenant(this.tenantId)}prepareOnce(){return this.preparePromise||(this.preparePromise=this.prepare()),this.preparePromise}async getToken(e,t){var o,n;await this.prepareOnce();const i=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds,logger)||this.tenantId;if(void 0===findCredentials)throw new CredentialUnavailableError(["No implementation of `VisualStudioCodeCredential` is available.","You must install the identity-vscode plugin package (`npm install --save-dev @azure/identity-vscode`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(vsCodePlugin)` before creating a `VisualStudioCodeCredential`.","To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot."].join(" "));let r="string"==typeof e?e:e.join(" ");if(!r.match(/^[0-9a-zA-Z-.:/]+$/)){const t=new Error("Invalid scope was specified by the user or calling client");throw logger.getToken.info(formatError(e,t)),t}r.indexOf("offline_access")<0&&(r+=" offline_access");const s=await findCredentials(),{password:a}=null!==(n=null!==(o=s.find((({account:e})=>e===this.cloudName)))&&void 0!==o?o:s[0])&&void 0!==n?n:{};if(a){const t=await this.identityClient.refreshAccessToken(i,AzureAccountClientId,r,a,void 0);if(t)return logger.getToken.info(formatSuccess(e)),t.accessToken;{const t=new CredentialUnavailableError("Could not retrieve the token associated with Visual Studio Code. Have you connected using the 'Azure Account' extension recently? To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot.");throw logger.getToken.info(formatError(e,t)),t}}{const t=new CredentialUnavailableError("Could not retrieve the token associated with Visual Studio Code. Did you connect using the 'Azure Account' extension? To troubleshoot, visit https://aka.ms/azsdk/js/identity/vscodecredential/troubleshoot.");throw logger.getToken.info(formatError(e,t)),t}}}