import{ClientAssertionCredential}from"./clientAssertionCredential";import{readFile}from"fs/promises";import{CredentialUnavailableError}from"../errors";import{credentialLogger,processEnvVars}from"../util/logging";import{checkTenantId}from"../util/tenantIdUtils";const credentialName="WorkloadIdentityCredential";export const SupportedWorkloadEnvironmentVariables=["AZURE_TENANT_ID","AZURE_CLIENT_ID","AZURE_FEDERATED_TOKEN_FILE"];const logger=credentialLogger(credentialName);export class WorkloadIdentityCredential{constructor(e){this.azureFederatedTokenFileContent=void 0,this.cacheDate=void 0;const t=processEnvVars(SupportedWorkloadEnvironmentVariables).assigned.join(", ");logger.info(`Found the following environment variables: ${t}`);const n=null!=e?e:{},i=n.tenantId||process.env.AZURE_TENANT_ID,a=n.clientId||process.env.AZURE_CLIENT_ID;this.federatedTokenFilePath=n.tokenFilePath||process.env.AZURE_FEDERATED_TOKEN_FILE,i&&checkTenantId(logger,i),a&&i&&this.federatedTokenFilePath&&(logger.info(`Invoking ClientAssertionCredential with tenant ID: ${i}, clientId: ${n.clientId} and federated token path: [REDACTED]`),this.client=new ClientAssertionCredential(i,a,this.readFileContents.bind(this),e))}async getToken(e,t){if(!this.client){const e=`${credentialName}: is unavailable. tenantId, clientId, and federatedTokenFilePath are required parameters. \n      In DefaultAzureCredential and ManagedIdentityCredential, these can be provided as environment variables - \n      "AZURE_TENANT_ID",\n      "AZURE_CLIENT_ID",\n      "AZURE_FEDERATED_TOKEN_FILE". See the troubleshooting guide for more information: https://aka.ms/azsdk/js/identity/workloadidentitycredential/troubleshoot  `;throw logger.info(e),new CredentialUnavailableError(e)}return logger.info("Invoking getToken() of Client Assertion Credential"),this.client.getToken(e,t)}async readFileContents(){if(void 0!==this.cacheDate&&Date.now()-this.cacheDate>=3e5&&(this.azureFederatedTokenFileContent=void 0),!this.federatedTokenFilePath)throw new CredentialUnavailableError(`${credentialName}: is unavailable. Invalid file path provided ${this.federatedTokenFilePath}.`);if(!this.azureFederatedTokenFileContent){const e=(await readFile(this.federatedTokenFilePath,"utf8")).trim();if(!e)throw new CredentialUnavailableError(`${credentialName}: is unavailable. No content on the file ${this.federatedTokenFilePath}.`);this.azureFederatedTokenFileContent=e,this.cacheDate=Date.now()}return this.azureFederatedTokenFileContent}}