import{AuthenticationRequiredError,CredentialUnavailableError}from"../../errors";import{formatSuccess}from"../../util/logging";import{ensureValidMsalToken,getAuthority,getKnownAuthorities,msalToPublic}from"../utils";import{processMultiTenantRequest,resolveAdditionallyAllowedTenantIds,resolveTenantId}from"../../util/tenantIdUtils";import{DefaultTenantId}from"../../constants";export function defaultBrowserMsalConfig(t){const e=t.tenantId||DefaultTenantId,i=getAuthority(e,t.authorityHost);return{auth:{clientId:t.clientId,authority:i,knownAuthorities:getKnownAuthorities(e,i,t.disableInstanceDiscovery),redirectUri:t.redirectUri||self.location.origin}}}export class MsalBrowser{constructor(t){var e;if(this.logger=t.logger,this.loginStyle=t.loginStyle,!t.clientId)throw new CredentialUnavailableError("A client ID is required in browsers");this.clientId=t.clientId,this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null===(e=null==t?void 0:t.tokenCredentialOptions)||void 0===e?void 0:e.additionallyAllowedTenants),this.tenantId=resolveTenantId(this.logger,t.tenantId,t.clientId),this.authorityHost=t.authorityHost,this.msalConfig=defaultBrowserMsalConfig(t),this.disableAutomaticAuthentication=t.disableAutomaticAuthentication,t.authenticationRecord&&(this.account=Object.assign(Object.assign({},t.authenticationRecord),{tenantId:this.tenantId}))}async init(){}async logout(){var t;null===(t=this.app)||void 0===t||t.logout()}async getToken(t,e={}){const i=processMultiTenantRequest(this.tenantId,e,this.additionallyAllowedTenantIds)||this.tenantId;return e.authority||(e.authority=getAuthority(i,this.authorityHost)),await this.handleRedirect(),await this.getActiveAccount()||this.disableAutomaticAuthentication||await this.login(t),this.getTokenSilent(t).catch((i=>{if("AuthenticationRequiredError"!==i.name)throw i;if(null==e?void 0:e.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:t,getTokenOptions:e,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info(`Silent authentication failed, falling back to interactive method ${this.loginStyle}`),this.doGetToken(t)}))}handleResult(t,e,i){return(null==e?void 0:e.account)&&(this.account=msalToPublic(this.clientId,e.account)),ensureValidMsalToken(t,e,i),this.logger.getToken.info(formatSuccess(t)),{token:e.accessToken,expiresOnTimestamp:e.expiresOn.getTime()}}}