import*as msal from"@azure/msal-node";import{credentialLogger,formatSuccess}from"../../util/logging";import{msalPlugins}from"./msalPlugins";import{defaultLoggerCallback,ensureValidMsalToken,getAuthority,getKnownAuthorities,getMSALLogLevel,handleMsalError,msalToPublic,publicToMsal}from"../utils";import{AuthenticationRequiredError}from"../../errors";import{IdentityClient}from"../../client/identityClient";import{calculateRegionalAuthority}from"../../regionalAuthority";import{getLogLevel}from"@azure/logger";import{resolveTenantId}from"../../util/tenantIdUtils";import{interactiveBrowserMockable}from"./msalOpenBrowser";const msalLogger=credentialLogger("MsalClient");export function generateMsalConfiguration(e,n,t={}){var o,i,a,r;const l=resolveTenantId(null!==(o=t.logger)&&void 0!==o?o:msalLogger,n,e),c=getAuthority(l,null!==(i=t.authorityHost)&&void 0!==i?i:process.env.AZURE_AUTHORITY_HOST),s=new IdentityClient(Object.assign(Object.assign({},t.tokenCredentialOptions),{authorityHost:c,loggingOptions:t.loggingOptions}));return{auth:{clientId:e,authority:c,knownAuthorities:getKnownAuthorities(l,c,t.disableInstanceDiscovery)},system:{networkClient:s,loggerOptions:{loggerCallback:defaultLoggerCallback(null!==(a=t.logger)&&void 0!==a?a:msalLogger),logLevel:getMSALLogLevel(getLogLevel()),piiLoggingEnabled:null===(r=t.loggingOptions)||void 0===r?void 0:r.enableUnsafeSupportLogging}}}}export function createMsalClient(e,n,t={}){var o;const i={msalConfig:generateMsalConfiguration(e,n,t),cachedAccount:t.authenticationRecord?publicToMsal(t.authenticationRecord):null,pluginConfiguration:msalPlugins.generatePluginConfiguration(t),logger:null!==(o=t.logger)&&void 0!==o?o:msalLogger},a=new Map;async function r(e={}){const n=e.enableCae?"CAE":"default";let t=a.get(n);if(t)return i.logger.getToken.info("Existing PublicClientApplication found in cache, returning it."),t;i.logger.getToken.info(`Creating new PublicClientApplication with CAE ${e.enableCae?"enabled":"disabled"}.`);const o=e.enableCae?i.pluginConfiguration.cache.cachePluginCae:i.pluginConfiguration.cache.cachePlugin;return i.msalConfig.auth.clientCapabilities=e.enableCae?["cp1"]:void 0,t=new msal.PublicClientApplication(Object.assign(Object.assign({},i.msalConfig),{broker:{nativeBrokerPlugin:i.pluginConfiguration.broker.nativeBrokerPlugin},cache:{cachePlugin:await o}})),a.set(n,t),t}const l=new Map;async function c(e={}){const n=e.enableCae?"CAE":"default";let t=l.get(n);if(t)return i.logger.getToken.info("Existing ConfidentialClientApplication found in cache, returning it."),t;i.logger.getToken.info(`Creating new ConfidentialClientApplication with CAE ${e.enableCae?"enabled":"disabled"}.`);const o=e.enableCae?i.pluginConfiguration.cache.cachePluginCae:i.pluginConfiguration.cache.cachePlugin;return i.msalConfig.auth.clientCapabilities=e.enableCae?["cp1"]:void 0,t=new msal.ConfidentialClientApplication(Object.assign(Object.assign({},i.msalConfig),{broker:{nativeBrokerPlugin:i.pluginConfiguration.broker.nativeBrokerPlugin},cache:{cachePlugin:await o}})),l.set(n,t),t}function s(e){return(null==e?void 0:e.tenantId)?getAuthority(e.tenantId,t.authorityHost):i.msalConfig.auth.authority}async function u(e,n,t,o){var a;let r=null;try{r=await async function(e,n,t={}){if(null===i.cachedAccount){i.logger.getToken.info("No cached account found in local state, attempting to load it from MSAL cache.");const t=e.getTokenCache(),o=await t.getAllAccounts();if(void 0===o||0===o.length)throw new AuthenticationRequiredError({scopes:n});if(o.length>1)throw i.logger.info('More than one account was found authenticated for this Client ID and Tenant ID.\nHowever, no "authenticationRecord" has been provided for this credential,\ntherefore we\'re unable to pick between these accounts.\nA new login attempt will be requested, to ensure the correct account is picked.\nTo work with multiple accounts for the same Client ID and Tenant ID, please provide an "authenticationRecord" when initializing a credential to prevent this from happening.'),new AuthenticationRequiredError({scopes:n});i.cachedAccount=o[0]}t.claims&&(i.cachedClaims=t.claims);const o={account:i.cachedAccount,scopes:n,claims:i.cachedClaims};return i.pluginConfiguration.broker.isEnabled&&(o.tokenQueryParameters||(o.tokenQueryParameters={}),i.pluginConfiguration.broker.enableMsaPassthrough&&(o.tokenQueryParameters.msal_request_type="consumer_passthrough")),i.logger.getToken.info("Attempting to acquire token silently"),e.acquireTokenSilent(o)}(e,n,t)}catch(e){if("AuthenticationRequiredError"!==e.name)throw e;if(t.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:n,getTokenOptions:t,message:"Automatic authentication has been disabled. You may call the authentication() method."})}if(null===r)try{r=await o()}catch(e){throw handleMsalError(n,e,t)}return ensureValidMsalToken(n,r,t),i.cachedAccount=null!==(a=null==r?void 0:r.account)&&void 0!==a?a:null,i.logger.getToken.info(formatSuccess(n)),{token:r.accessToken,expiresOnTimestamp:r.expiresOn.getTime()}}return{getActiveAccount:function(){if(i.cachedAccount)return msalToPublic(e,i.cachedAccount)},getTokenByClientSecret:async function(e,n,t={}){i.logger.getToken.info("Attempting to acquire token using client secret"),i.msalConfig.auth.clientSecret=n;const o=await c(t);try{const n=await o.acquireTokenByClientCredential({scopes:e,authority:s(t),azureRegion:calculateRegionalAuthority(),claims:null==t?void 0:t.claims});return ensureValidMsalToken(e,n,t),i.logger.getToken.info(formatSuccess(e)),{token:n.accessToken,expiresOnTimestamp:n.expiresOn.getTime()}}catch(n){throw handleMsalError(e,n,t)}},getTokenByClientAssertion:async function(e,n,t={}){i.logger.getToken.info("Attempting to acquire token using client assertion"),i.msalConfig.auth.clientAssertion=n;const o=await c(t);try{const a=await o.acquireTokenByClientCredential({scopes:e,authority:s(t),azureRegion:calculateRegionalAuthority(),claims:null==t?void 0:t.claims,clientAssertion:n});return ensureValidMsalToken(e,a,t),i.logger.getToken.info(formatSuccess(e)),{token:a.accessToken,expiresOnTimestamp:a.expiresOn.getTime()}}catch(n){throw handleMsalError(e,n,t)}},getTokenByClientCertificate:async function(e,n,t={}){i.logger.getToken.info("Attempting to acquire token using client certificate"),i.msalConfig.auth.clientCertificate=n;const o=await c(t);try{const n=await o.acquireTokenByClientCredential({scopes:e,authority:s(t),azureRegion:calculateRegionalAuthority(),claims:null==t?void 0:t.claims});return ensureValidMsalToken(e,n,t),i.logger.getToken.info(formatSuccess(e)),{token:n.accessToken,expiresOnTimestamp:n.expiresOn.getTime()}}catch(n){throw handleMsalError(e,n,t)}},getTokenByDeviceCode:async function(e,n,t={}){i.logger.getToken.info("Attempting to acquire token using device code");const o=await r(t);return u(o,e,t,(()=>{var i,a;const r={scopes:e,cancel:null!==(a=null===(i=null==t?void 0:t.abortSignal)||void 0===i?void 0:i.aborted)&&void 0!==a&&a,deviceCodeCallback:n,authority:s(t),claims:null==t?void 0:t.claims},l=o.acquireTokenByDeviceCode(r);return t.abortSignal&&t.abortSignal.addEventListener("abort",(()=>{r.cancel=!0})),l}))},getTokenByUsernamePassword:async function(e,n,t,o={}){i.logger.getToken.info("Attempting to acquire token using username and password");const a=await r(o);return u(a,e,o,(()=>{const i={scopes:e,username:n,password:t,authority:s(o),claims:null==o?void 0:o.claims};return a.acquireTokenByUsernamePassword(i)}))},getTokenByAuthorizationCode:async function(e,n,t,o,a={}){let l;return i.logger.getToken.info("Attempting to acquire token using authorization code"),o?(i.msalConfig.auth.clientSecret=o,l=await c(a)):l=await r(a),u(l,e,a,(()=>l.acquireTokenByCode({scopes:e,redirectUri:n,code:t,authority:s(a),claims:null==a?void 0:a.claims})))},getTokenOnBehalfOf:async function(e,n,t,o={}){msalLogger.getToken.info("Attempting to acquire token on behalf of another user"),"string"==typeof t?(msalLogger.getToken.info("Using client secret for on behalf of flow"),i.msalConfig.auth.clientSecret=t):"function"==typeof t?(msalLogger.getToken.info("Using client assertion callback for on behalf of flow"),i.msalConfig.auth.clientAssertion=t):(msalLogger.getToken.info("Using client certificate for on behalf of flow"),i.msalConfig.auth.clientCertificate=t);const a=await c(o);try{const t=await a.acquireTokenOnBehalfOf({scopes:e,authority:s(o),claims:o.claims,oboAssertion:n});return ensureValidMsalToken(e,t,o),msalLogger.getToken.info(formatSuccess(e)),{token:t.accessToken,expiresOnTimestamp:t.expiresOn.getTime()}}catch(n){throw handleMsalError(e,n,o)}},getTokenByInteractiveRequest:async function(e,n={}){msalLogger.getToken.info("Attempting to acquire token interactively");const t=await r(n);async function o(e){var n;msalLogger.verbose("Authentication will resume through the broker");const r=a();i.pluginConfiguration.broker.parentWindowHandle?r.windowHandle=Buffer.from(i.pluginConfiguration.broker.parentWindowHandle):msalLogger.warning("Parent window handle is not specified for the broker. This may cause unexpected behavior. Please provide the parentWindowHandle."),i.pluginConfiguration.broker.enableMsaPassthrough&&((null!==(n=r.tokenQueryParameters)&&void 0!==n?n:r.tokenQueryParameters={}).msal_request_type="consumer_passthrough"),e?(r.prompt="none",msalLogger.verbose("Attempting broker authentication using the default broker account")):msalLogger.verbose("Attempting broker authentication without the default broker account");try{return await t.acquireTokenInteractive(r)}catch(n){if(msalLogger.verbose(`Failed to authenticate through the broker: ${n.message}`),e)return o(!1);throw n}}function a(){var t,o;return{openBrowser:async e=>{await interactiveBrowserMockable.open(e,{wait:!0,newInstance:!0})},scopes:e,authority:s(n),claims:null==n?void 0:n.claims,loginHint:null==n?void 0:n.loginHint,errorTemplate:null===(t=null==n?void 0:n.browserCustomizationOptions)||void 0===t?void 0:t.errorMessage,successTemplate:null===(o=null==n?void 0:n.browserCustomizationOptions)||void 0===o?void 0:o.successMessage}}return u(t,e,n,(async()=>{var e;const n=a();return i.pluginConfiguration.broker.isEnabled?o(null!==(e=i.pluginConfiguration.broker.useDefaultBrokerAccount)&&void 0!==e&&e):t.acquireTokenInteractive(n)}))}}}