import*as msalNode from"@azure/msal-node";import{CACHE_CAE_SUFFIX,CACHE_NON_CAE_SUFFIX,DEFAULT_TOKEN_CACHE_NAME,DeveloperSignOnClientId}from"../../constants";import{formatSuccess}from"../../util/logging";import{defaultLoggerCallback,ensureValidMsalToken,getAuthority,getKnownAuthorities,getMSALLogLevel,handleMsalError,msalToPublic,publicToMsal,randomUUID}from"../utils";import{hasNativeBroker,nativeBrokerInfo,persistenceProvider}from"./msalPlugins";import{processMultiTenantRequest,resolveAdditionallyAllowedTenantIds,resolveTenantId}from"../../util/tenantIdUtils";import{AuthenticationRequiredError}from"../../errors";import{IdentityClient}from"../../client/identityClient";import{calculateRegionalAuthority}from"../../regionalAuthority";import{getLogLevel}from"@azure/logger";export class MsalNode{constructor(e){var t,i,n,o,a,l;if(this.app={},this.caeApp={},this.requiresConfidential=!1,this.logger=e.logger,this.msalConfig=this.defaultNodeMsalConfig(e),this.tenantId=resolveTenantId(e.logger,e.tenantId,e.clientId),this.additionallyAllowedTenantIds=resolveAdditionallyAllowedTenantIds(null===(t=null==e?void 0:e.tokenCredentialOptions)||void 0===t?void 0:t.additionallyAllowedTenants),this.clientId=this.msalConfig.auth.clientId,(null==e?void 0:e.getAssertion)&&(this.getAssertion=e.getAssertion),this.enableBroker=null===(i=null==e?void 0:e.brokerOptions)||void 0===i?void 0:i.enabled,this.enableMsaPassthrough=null===(n=null==e?void 0:e.brokerOptions)||void 0===n?void 0:n.legacyEnableMsaPassthrough,this.parentWindowHandle=null===(o=e.brokerOptions)||void 0===o?void 0:o.parentWindowHandle,void 0!==persistenceProvider&&(null===(a=e.tokenCachePersistenceOptions)||void 0===a?void 0:a.enabled)){const t=e.tokenCachePersistenceOptions.name||DEFAULT_TOKEN_CACHE_NAME,i=Object.assign({name:`${t}.${CACHE_NON_CAE_SUFFIX}`},e.tokenCachePersistenceOptions),n=Object.assign({name:`${t}.${CACHE_CAE_SUFFIX}`},e.tokenCachePersistenceOptions);this.createCachePlugin=()=>persistenceProvider(i),this.createCachePluginCae=()=>persistenceProvider(n)}else if(null===(l=e.tokenCachePersistenceOptions)||void 0===l?void 0:l.enabled)throw new Error(["Persistent token caching was requested, but no persistence provider was configured.","You must install the identity-cache-persistence plugin package (`npm install --save @azure/identity-cache-persistence`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(cachePersistencePlugin)` before using `tokenCachePersistenceOptions`."].join(" "));if(!hasNativeBroker()&&this.enableBroker)throw new Error(["Broker for WAM was requested to be enabled, but no native broker was configured.","You must install the identity-broker plugin package (`npm install --save @azure/identity-broker`)","and enable it by importing `useIdentityPlugin` from `@azure/identity` and calling","`useIdentityPlugin(createNativeBrokerPlugin())` before using `enableBroker`."].join(" "));this.azureRegion=calculateRegionalAuthority(e.regionalAuthority)}defaultNodeMsalConfig(e){var t;const i=e.clientId||DeveloperSignOnClientId,n=resolveTenantId(e.logger,e.tenantId,e.clientId);this.authorityHost=e.authorityHost||process.env.AZURE_AUTHORITY_HOST;const o=getAuthority(n,this.authorityHost);this.identityClient=new IdentityClient(Object.assign(Object.assign({},e.tokenCredentialOptions),{authorityHost:o,loggingOptions:e.loggingOptions}));return{auth:{clientId:i,authority:o,knownAuthorities:getKnownAuthorities(n,o,e.disableInstanceDiscovery),clientCapabilities:[]},system:{networkClient:this.identityClient,loggerOptions:{loggerCallback:defaultLoggerCallback(e.logger),logLevel:getMSALLogLevel(getLogLevel()),piiLoggingEnabled:null===(t=e.loggingOptions)||void 0===t?void 0:t.enableUnsafeSupportLogging}}}}getApp(e,t){const i=t?this.caeApp:this.app;return"publicFirst"===e?i.public||i.confidential:"confidentialFirst"===e?i.confidential||i.public:"confidential"===e?i.confidential:i.public}async init(e){(null==e?void 0:e.abortSignal)&&e.abortSignal.addEventListener("abort",(()=>{this.identityClient.abortRequests(e.correlationId)}));const t=(null==e?void 0:e.enableCae)?this.caeApp:this.app;if((null==e?void 0:e.enableCae)&&(this.msalConfig.auth.clientCapabilities=["cp1"]),!t.public&&!t.confidential)if((null==e?void 0:e.enableCae)&&void 0!==this.createCachePluginCae&&(this.msalConfig.cache={cachePlugin:await this.createCachePluginCae()}),void 0!==this.createCachePlugin&&(this.msalConfig.cache={cachePlugin:await this.createCachePlugin()}),hasNativeBroker()&&this.enableBroker&&(this.msalConfig.broker={nativeBrokerPlugin:nativeBrokerInfo.broker},this.parentWindowHandle||this.logger.warning("Parent window handle is not specified for the broker. This may cause unexpected behavior. Please provide the parentWindowHandle.")),(null==e?void 0:e.enableCae)?this.caeApp.public=new msalNode.PublicClientApplication(this.msalConfig):this.app.public=new msalNode.PublicClientApplication(this.msalConfig),void 0!==this.getAssertion&&(this.msalConfig.auth.clientAssertion=this.getAssertion),this.msalConfig.auth.clientSecret||this.msalConfig.auth.clientAssertion||this.msalConfig.auth.clientCertificate)(null==e?void 0:e.enableCae)?this.caeApp.confidential=new msalNode.ConfidentialClientApplication(this.msalConfig):this.app.confidential=new msalNode.ConfidentialClientApplication(this.msalConfig);else if(this.requiresConfidential)throw new Error("Unable to generate the MSAL confidential client. Missing either the client's secret, certificate or assertion.")}withCancellation(e,t,i){return new Promise(((n,o)=>{e.then((e=>n(e))).catch(o),t&&t.addEventListener("abort",(()=>{null==i||i()}))}))}async getActiveAccount(e=!1){if(this.account)return this.account;const t=this.getApp("confidentialFirst",e).getTokenCache(),i=await(null==t?void 0:t.getAllAccounts());if(i){if(1===i.length)return this.account=msalToPublic(this.clientId,i[0]),this.account;this.logger.info('More than one account was found authenticated for this Client ID and Tenant ID.\nHowever, no "authenticationRecord" has been provided for this credential,\ntherefore we\'re unable to pick between these accounts.\nA new login attempt will be requested, to ensure the correct account is picked.\nTo work with multiple accounts for the same Client ID and Tenant ID, please provide an "authenticationRecord" when initializing a credential to prevent this from happening.')}}async getTokenSilent(e,t){var i,n,o;if(await this.getActiveAccount(null==t?void 0:t.enableCae),!this.account)throw new AuthenticationRequiredError({scopes:e,getTokenOptions:t,message:"Silent authentication failed. We couldn't retrieve an active account from the cache."});const a={account:publicToMsal(this.account),correlationId:null==t?void 0:t.correlationId,scopes:e,authority:null==t?void 0:t.authority,claims:null==t?void 0:t.claims};hasNativeBroker()&&this.enableBroker&&(a.tokenQueryParameters||(a.tokenQueryParameters={}),this.parentWindowHandle||this.logger.warning("Parent window handle is not specified for the broker. This may cause unexpected behavior. Please provide the parentWindowHandle."),this.enableMsaPassthrough&&(a.tokenQueryParameters.msal_request_type="consumer_passthrough"));try{this.logger.info("Attempting to acquire token silently"),await(null===(i=this.getApp("publicFirst",null==t?void 0:t.enableCae))||void 0===i?void 0:i.getTokenCache().getAllAccounts());const l=null!==(o=await(null===(n=this.getApp("confidential",null==t?void 0:t.enableCae))||void 0===n?void 0:n.acquireTokenSilent(a)))&&void 0!==o?o:await this.getApp("public",null==t?void 0:t.enableCae).acquireTokenSilent(a);return this.handleResult(e,l||void 0)}catch(i){throw handleMsalError(e,i,t)}}async getToken(e,t={}){const i=processMultiTenantRequest(this.tenantId,t,this.additionallyAllowedTenantIds)||this.tenantId;t.authority=getAuthority(i,this.authorityHost),t.correlationId=(null==t?void 0:t.correlationId)||randomUUID(),await this.init(t);try{const i=t.claims;return i&&(this.cachedClaims=i),this.cachedClaims&&!i&&(t.claims=this.cachedClaims),await this.getTokenSilent(e,t)}catch(i){if("AuthenticationRequiredError"!==i.name)throw i;if(null==t?void 0:t.disableAutomaticAuthentication)throw new AuthenticationRequiredError({scopes:e,getTokenOptions:t,message:"Automatic authentication has been disabled. You may call the authentication() method."});return this.logger.info("Silent authentication failed, falling back to interactive method."),this.doGetToken(e,t)}}handleResult(e,t,i){return(null==t?void 0:t.account)&&(this.account=msalToPublic(this.clientId,t.account)),ensureValidMsalToken(e,t,i),this.logger.getToken.info(formatSuccess(e)),{token:t.accessToken,expiresOnTimestamp:t.expiresOn.getTime()}}}