import{AuthenticationRequiredError,CredentialUnavailableError}from"../errors";import{credentialLogger,formatError}from"../util/logging";import{DefaultAuthorityHost,DefaultTenantId}from"../constants";import{randomUUID as coreRandomUUID,isNode}from"@azure/core-util";import{AbortError}from"@azure/abort-controller";import{msalCommon}from"./msal";const logger=credentialLogger("IdentityUtils"),LatestAuthenticationRecordVersion="1.0";export function ensureValidMsalToken(e,r,o){const t=r=>(logger.getToken.info(r),new AuthenticationRequiredError({scopes:Array.isArray(e)?e:[e],getTokenOptions:o,message:r}));if(!r)throw t("No response");if(!r.expiresOn)throw t('Response had no "expiresOn" property.');if(!r.accessToken)throw t('Response had no "accessToken" property.')}export function getAuthority(e,r){return r||(r=DefaultAuthorityHost),new RegExp(`${e}/?$`).test(r)?r:r.endsWith("/")?r+e:`${r}/${e}`}export function getKnownAuthorities(e,r,o){return"adfs"===e&&r||o?[r]:[]}export const defaultLoggerCallback=(e,r=(isNode?"Node":"Browser"))=>(o,t,n)=>{if(!n)switch(o){case msalCommon.LogLevel.Error:return void e.info(`MSAL ${r} V2 error: ${t}`);case msalCommon.LogLevel.Info:return void e.info(`MSAL ${r} V2 info message: ${t}`);case msalCommon.LogLevel.Verbose:return void e.info(`MSAL ${r} V2 verbose message: ${t}`);case msalCommon.LogLevel.Warning:return void e.info(`MSAL ${r} V2 warning: ${t}`)}};export function getMSALLogLevel(e){switch(e){case"error":return msalCommon.LogLevel.Error;case"info":default:return msalCommon.LogLevel.Info;case"verbose":return msalCommon.LogLevel.Verbose;case"warning":return msalCommon.LogLevel.Warning}}export function randomUUID(){return coreRandomUUID()}export function handleMsalError(e,r,o){if("AuthError"===r.name||"ClientAuthError"===r.name||"BrowserAuthError"===r.name){const o=r;switch(o.errorCode){case"endpoints_resolution_error":return logger.info(formatError(e,r.message)),new CredentialUnavailableError(r.message);case"device_code_polling_cancelled":return new AbortError("The authentication has been aborted by the caller.");case"consent_required":case"interaction_required":case"login_required":logger.info(formatError(e,`Authentication returned errorCode ${o.errorCode}`));break;default:logger.info(formatError(e,`Failed to acquire token: ${r.message}`))}}return"ClientConfigurationError"===r.name||"BrowserConfigurationAuthError"===r.name||"AbortError"===r.name?r:"NativeAuthError"===r.name?(logger.info(formatError(e,`Error from the native broker: ${r.message} with status code: ${r.statusCode}`)),r):new AuthenticationRequiredError({scopes:e,getTokenOptions:o,message:r.message})}export function publicToMsal(e){const[r]=e.authority.match(/([a-z]*\.[a-z]*\.[a-z]*)/)||[""];return Object.assign(Object.assign({},e),{localAccountId:e.homeAccountId,environment:r})}export function msalToPublic(e,r){return{authority:getAuthority(r.tenantId,r.environment),homeAccountId:r.homeAccountId,tenantId:r.tenantId||DefaultTenantId,username:r.username,clientId:e,version:"1.0"}}export function serializeAuthenticationRecord(e){return JSON.stringify(e)}export function deserializeAuthenticationRecord(e){const r=JSON.parse(e);if(r.version&&"1.0"!==r.version)throw Error("Unsupported AuthenticationRecord version");return r}