import{__rest}from"tslib";import{bearerTokenAuthenticationPolicy}from"@azure/core-rest-pipeline";import{SDK_VERSION}from"../constants";import{KeyVaultClient}from"../generated";import{parseKeyVaultKeyIdentifier}from"../identifier";import{LATEST_API_VERSION}from"../keysModels";import{getKeyFromKeyBundle}from"../transformations";import{createHash}from"./crypto";import{logger}from"../log";import{createKeyVaultChallengeCallbacks}from"../../../keyvault-common/src";import{tracingClient}from"../tracing";export class RemoteCryptographyProvider{constructor(t,e,r={}){var i;let n;this.client=getOrInitializeClient(e,r),this.key=t,n="string"==typeof t?t:t.id;try{const t=parseKeyVaultKeyIdentifier(n);if(""===t.name)throw new Error("Could not find 'name' of key in key URL");if(!t.vaultUrl||""===t.vaultUrl)throw new Error("Could not find 'vaultUrl' of key in key URL");this.vaultUrl=t.vaultUrl,this.name=t.name,this.version=null!==(i=t.version)&&void 0!==i?i:""}catch(t){throw logger.error(t),new Error(`${n} is not a valid Key Vault key ID`)}}isSupported(t,e){return!0}encrypt(t,e={}){const{algorithm:r,plaintext:i}=t,n=__rest(t,["algorithm","plaintext"]),a=Object.assign(Object.assign({},e),n);return tracingClient.withSpan("RemoteCryptographyProvider.encrypt",a,(async e=>{const n=await this.client.encrypt(this.vaultUrl,this.name,this.version,r,i,e);return{algorithm:t.algorithm,result:n.result,keyID:this.getKeyID(),additionalAuthenticatedData:n.additionalAuthenticatedData,authenticationTag:n.authenticationTag,iv:n.iv}}))}decrypt(t,e={}){const{algorithm:r,ciphertext:i}=t,n=__rest(t,["algorithm","ciphertext"]),a=Object.assign(Object.assign({},e),n);return tracingClient.withSpan("RemoteCryptographyProvider.decrypt",a,(async t=>({result:(await this.client.decrypt(this.vaultUrl,this.name,this.version,r,i,t)).result,keyID:this.getKeyID(),algorithm:r})))}wrapKey(t,e,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.wrapKey",r,(async r=>({result:(await this.client.wrapKey(this.vaultUrl,this.name,this.version,t,e,r)).result,algorithm:t,keyID:this.getKeyID()})))}unwrapKey(t,e,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.unwrapKey",r,(async r=>({result:(await this.client.unwrapKey(this.vaultUrl,this.name,this.version,t,e,r)).result,algorithm:t,keyID:this.getKeyID()})))}sign(t,e,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.sign",r,(async r=>({result:(await this.client.sign(this.vaultUrl,this.name,this.version,t,e,r)).result,algorithm:t,keyID:this.getKeyID()})))}verifyData(t,e,r,i={}){return tracingClient.withSpan("RemoteCryptographyProvider.verifyData",i,(async i=>{const n=await createHash(t,e);return this.verify(t,n,r,i)}))}verify(t,e,r,i={}){return tracingClient.withSpan("RemoteCryptographyProvider.verify",i,(async i=>{const n=await this.client.verify(this.vaultUrl,this.name,this.version,t,e,r,i);return{result:!!n.value&&n.value,keyID:this.getKeyID()}}))}signData(t,e,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.signData",r,(async r=>{const i=await createHash(t,e);return{result:(await this.client.sign(this.vaultUrl,this.name,this.version,t,i,r)).result,algorithm:t,keyID:this.getKeyID()}}))}get keyId(){return this.getKeyID()}getKey(t={}){return tracingClient.withSpan("RemoteCryptographyProvider.getKey",t,(async e=>{if("string"==typeof this.key){if(!this.name||""===this.name)throw new Error("getKey requires a key with a name");const r=await this.client.getKey(this.vaultUrl,this.name,t&&t.version?t.version:this.version?this.version:"",e);this.key=getKeyFromKeyBundle(r)}return this.key}))}getKeyID(){let t;return t="string"!=typeof this.key?this.key.id:this.key,t}}function getOrInitializeClient(t,e){if(e.generatedClient)return e.generatedClient;const r=`azsdk-js-keyvault-keys/${SDK_VERSION}`,i=e.userAgentOptions;e.userAgentOptions={userAgentPrefix:i&&i.userAgentPrefix?`${i.userAgentPrefix} ${r}`:r};const n=bearerTokenAuthenticationPolicy({credential:t,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(e)}),a=Object.assign(Object.assign({},e),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}}),s=new KeyVaultClient(e.serviceVersion||LATEST_API_VERSION,a);return s.pipeline.addPolicy(n),s}