import{RSA_PKCS1_OAEP_PADDING,RSA_PKCS1_PADDING}from"constants";import{publicEncrypt}from"crypto";import{createVerify}from"./crypto";import{convertJWKtoPEM}from"./conversions";import{LocalCryptographyUnsupportedError}from"./models";export class RsaCryptographyProvider{constructor(r){this.applicableAlgorithms=["RSA1_5","RSA-OAEP","PS256","RS256","PS384","RS384","PS512","RS512"],this.applicableOperations=["encrypt","wrapKey","verifyData"],this.signatureAlgorithmToHashAlgorithm={PS256:"SHA256",RS256:"SHA256",PS384:"SHA384",RS384:"SHA384",PS512:"SHA512",RS512:"SHA512"},this.key=r}isSupported(r,e){return this.applicableAlgorithms.includes(r)&&this.applicableOperations.includes(e)}encrypt(r,e){this.ensureValid();const o=convertJWKtoPEM(this.key),t="RSA1_5"===r.algorithm?RSA_PKCS1_PADDING:RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:r.algorithm,keyID:this.key.kid,result:publicEncrypt({key:o,padding:t},Buffer.from(r.plaintext))})}decrypt(r,e){throw new LocalCryptographyUnsupportedError("Decrypting using a local JsonWebKey is not supported.")}wrapKey(r,e,o){this.ensureValid();const t=convertJWKtoPEM(this.key),i="RSA1_5"===r?RSA_PKCS1_PADDING:RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:r,result:publicEncrypt({key:t,padding:i},Buffer.from(e)),keyID:this.key.kid})}unwrapKey(r,e,o){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported.")}sign(r,e,o){throw new LocalCryptographyUnsupportedError("Signing a digest using a local JsonWebKey is not supported.")}signData(r,e,o){throw new LocalCryptographyUnsupportedError("Signing a block of data using a local JsonWebKey is not supported.")}async verify(r,e,o,t){throw new LocalCryptographyUnsupportedError("Verifying a digest using a local JsonWebKey is not supported.")}verifyData(r,e,o,t){this.ensureValid();const i=convertJWKtoPEM(this.key),s=createVerify(r,e);return Promise.resolve({result:s.verify(i,Buffer.from(o)),keyID:this.key.kid})}ensureValid(){var r,e;if(this.key&&"RSA"!==(null===(r=this.key.kty)||void 0===r?void 0:r.toUpperCase())&&"RSA-HSM"!==(null===(e=this.key.kty)||void 0===e?void 0:e.toUpperCase()))throw new Error("Key type does not match the algorithm RSA")}}