import{KnownKeyOperations}from"./keysModels";import{RemoteCryptographyProvider}from"./cryptography/remoteCryptographyProvider";import{randomBytes}from"./cryptography/crypto";import{RsaCryptographyProvider}from"./cryptography/rsaCryptographyProvider";import{AesCryptographyProvider}from"./cryptography/aesCryptographyProvider";import{tracingClient}from"./tracing";import{isRestError}from"@azure/core-rest-pipeline";import{logger}from"./log";export class CryptographyClient{constructor(e,r,t={}){"string"==typeof e?(this.key={kind:"identifier",value:e},this.remoteProvider=new RemoteCryptographyProvider(e,r,t)):"name"in e?(this.key={kind:"KeyVaultKey",value:e},this.remoteProvider=new RemoteCryptographyProvider(e,r,t)):this.key={kind:"JsonWebKey",value:e}}get vaultUrl(){var e;return(null===(e=this.remoteProvider)||void 0===e?void 0:e.vaultUrl)||""}get keyID(){return"identifier"===this.key.kind||"remoteOnlyIdentifier"===this.key.kind?this.key.value:"KeyVaultKey"===this.key.kind?this.key.value.id:this.key.value.kid}encrypt(...e){const[r,t]=this.disambiguateEncryptArguments(e);return tracingClient.withSpan("CryptographyClient.encrypt",t,(async e=>{this.ensureValid(await this.fetchKey(e),KnownKeyOperations.Encrypt),this.initializeIV(r);const t=await this.getProvider("encrypt",r.algorithm,e);try{return t.encrypt(r,e)}catch(t){if(this.remoteProvider)return this.remoteProvider.encrypt(r,e);throw t}}))}initializeIV(e){if(e.algorithm in["A128CBC","A128CBCPAD","A192CBC","A192CBCPAD","A256CBC","A256CBCPAD"])try{const r=e;r.iv||(r.iv=randomBytes(16))}catch(r){throw new Error(`Unable to initialize IV for algorithm ${e.algorithm}. You may pass a valid IV to avoid this error. Error: ${r.message}`)}}disambiguateEncryptArguments(e){return"string"==typeof e[0]?[{algorithm:e[0],plaintext:e[1]},e[2]||{}]:[e[0],e[1]||{}]}decrypt(...e){const[r,t]=this.disambiguateDecryptArguments(e);return tracingClient.withSpan("CryptographyClient.decrypt",t,(async e=>{this.ensureValid(await this.fetchKey(e),KnownKeyOperations.Decrypt);const t=await this.getProvider("decrypt",r.algorithm,e);try{return t.decrypt(r,e)}catch(t){if(this.remoteProvider)return this.remoteProvider.decrypt(r,e);throw t}}))}disambiguateDecryptArguments(e){return"string"==typeof e[0]?[{algorithm:e[0],ciphertext:e[1]},e[2]||{}]:[e[0],e[1]||{}]}wrapKey(e,r,t={}){return tracingClient.withSpan("CryptographyClient.wrapKey",t,(async i=>{this.ensureValid(await this.fetchKey(i),KnownKeyOperations.WrapKey);const n=await this.getProvider("wrapKey",e,i);try{return n.wrapKey(e,r,i)}catch(i){if(this.remoteProvider)return this.remoteProvider.wrapKey(e,r,t);throw i}}))}unwrapKey(e,r,t={}){return tracingClient.withSpan("CryptographyClient.unwrapKey",t,(async i=>{this.ensureValid(await this.fetchKey(i),KnownKeyOperations.UnwrapKey);const n=await this.getProvider("unwrapKey",e,i);try{return n.unwrapKey(e,r,i)}catch(i){if(this.remoteProvider)return this.remoteProvider.unwrapKey(e,r,t);throw i}}))}sign(e,r,t={}){return tracingClient.withSpan("CryptographyClient.sign",t,(async t=>{this.ensureValid(await this.fetchKey(t),KnownKeyOperations.Sign);const i=await this.getProvider("sign",e,t);try{return i.sign(e,r,t)}catch(i){if(this.remoteProvider)return this.remoteProvider.sign(e,r,t);throw i}}))}verify(e,r,t,i={}){return tracingClient.withSpan("CryptographyClient.verify",i,(async i=>{this.ensureValid(await this.fetchKey(i),KnownKeyOperations.Verify);const n=await this.getProvider("verify",e,i);try{return n.verify(e,r,t,i)}catch(n){if(this.remoteProvider)return this.remoteProvider.verify(e,r,t,i);throw n}}))}signData(e,r,t={}){return tracingClient.withSpan("CryptographyClient.signData",t,(async i=>{this.ensureValid(await this.fetchKey(i),KnownKeyOperations.Sign);const n=await this.getProvider("signData",e,i);try{return n.signData(e,r,i)}catch(i){if(this.remoteProvider)return this.remoteProvider.signData(e,r,t);throw i}}))}verifyData(e,r,t,i={}){return tracingClient.withSpan("CryptographyClient.verifyData",i,(async i=>{this.ensureValid(await this.fetchKey(i),KnownKeyOperations.Verify);const n=await this.getProvider("verifyData",e,i);try{return n.verifyData(e,r,t,i)}catch(n){if(this.remoteProvider)return this.remoteProvider.verifyData(e,r,t,i);throw n}}))}async getKeyMaterial(e){const r=await this.fetchKey(e);switch(r.kind){case"JsonWebKey":return r.value;case"KeyVaultKey":return r.value.key;default:return}}async fetchKey(e){if("identifier"===this.key.kind){let r;try{r=await this.remoteProvider.getKey(e)}catch(e){if(!isRestError(e)||403!==e.statusCode)throw e;logger.verbose(`Permission denied to get key ${this.key.value}. Falling back to remote operation.`),this.key={kind:"remoteOnlyIdentifier",value:this.key.value}}r&&(this.key={kind:"KeyVaultKey",value:r})}return this.key}async getProvider(e,r,t){if(!this.providers){const e=await this.getKeyMaterial(t);this.providers=[],e&&this.providers.push(new RsaCryptographyProvider(e),new AesCryptographyProvider(e)),this.remoteProvider&&this.providers.push(this.remoteProvider)}const i=this.providers.filter((t=>t.isSupported(r,e)));if(0===i.length)throw new Error(`Unable to support operation: "${e}" with algorithm: "${r}" ${"JsonWebKey"===this.key.kind?"using a local JsonWebKey":""}`);return i[0]}ensureValid(e,r){var t;if("KeyVaultKey"===e.kind){const t=e.value.keyOperations,{notBefore:i,expiresOn:n}=e.value.properties,o=new Date;if(i&&o<i)throw new Error(`Key ${e.value.id} can't be used before ${i.toISOString()}`);if(n&&o>n)throw new Error(`Key ${e.value.id} expired at ${n.toISOString()}`);if(r&&t&&!(null==t?void 0:t.includes(r)))throw new Error(`Operation ${r} is not supported on key ${e.value.id}`)}else if("JsonWebKey"===e.kind&&r&&e.value.keyOps&&!(null===(t=e.value.keyOps)||void 0===t?void 0:t.includes(r)))throw new Error(`Operation ${r} is not supported on key ${e.value.kid}`)}}