import{__asyncGenerator,__asyncValues,__await,__rest}from"tslib";import{bearerTokenAuthenticationPolicy}from"@azure/core-rest-pipeline";import{logger}from"./log";import{KnownDeletionRecoveryLevel,KnownJsonWebKeyType}from"./generated/models";import{KeyVaultClient}from"./generated/keyVaultClient";import{SDK_VERSION}from"./constants";import{createKeyVaultChallengeCallbacks}from"../../keyvault-common/src";import{DeleteKeyPoller}from"./lro/delete/poller";import{RecoverDeletedKeyPoller}from"./lro/recover/poller";import{KnownKeyExportEncryptionAlgorithm,KnownKeyOperations,KnownKeyTypes,LATEST_API_VERSION}from"./keysModels";import{CryptographyClient}from"./cryptographyClient";import{KnownEncryptionAlgorithms,KnownKeyCurveNames,KnownSignatureAlgorithms}from"./cryptographyClientModels";import{parseKeyVaultKeyIdentifier}from"./identifier";import{getDeletedKeyFromDeletedKeyItem,getKeyFromKeyBundle,getKeyPropertiesFromKeyItem,keyRotationTransformations}from"./transformations";import{tracingClient}from"./tracing";export{CryptographyClient,KnownDeletionRecoveryLevel,KnownKeyCurveNames,KnownKeyExportEncryptionAlgorithm,KnownEncryptionAlgorithms,KnownKeyOperations,KnownKeyTypes,KnownSignatureAlgorithms,parseKeyVaultKeyIdentifier,logger};export class KeyClient{constructor(e,t,n={}){this.vaultUrl=e;const i=`azsdk-js-keyvault-keys/${SDK_VERSION}`,r=n.userAgentOptions;n.userAgentOptions={userAgentPrefix:r&&r.userAgentPrefix?`${r.userAgentPrefix} ${i}`:i};const a=bearerTokenAuthenticationPolicy({credential:t,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(n)}),o=Object.assign(Object.assign({},n),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}});this.credential=t,this.client=new KeyVaultClient(n.serviceVersion||LATEST_API_VERSION,o),this.client.pipeline.addPolicy(a)}createKey(e,t,n){let i={};if(n){const{enabled:e,notBefore:t,expiresOn:r,exportable:a}=n,o=__rest(n,["enabled","notBefore","expiresOn","exportable"]);i=Object.assign(Object.assign({},o),{keyAttributes:{enabled:e,notBefore:t,expires:r,exportable:a}})}return tracingClient.withSpan("KeyClient.createKey",i,(async n=>{const i=await this.client.createKey(this.vaultUrl,e,t,n);return getKeyFromKeyBundle(i)}))}async createEcKey(e,t){const n=(null==t?void 0:t.hsm)?KnownJsonWebKeyType.ECHSM:KnownJsonWebKeyType.EC;return this.createKey(e,n,t)}async createRsaKey(e,t){const n=(null==t?void 0:t.hsm)?KnownJsonWebKeyType.RSAHSM:KnownJsonWebKeyType.RSA;return this.createKey(e,n,t)}async createOctKey(e,t){const n=(null==t?void 0:t.hsm)?KnownJsonWebKeyType.OctHSM:KnownJsonWebKeyType.Oct;return this.createKey(e,n,t)}importKey(e,t,n){let i={};if(n){const{enabled:e,notBefore:t,exportable:r,expiresOn:a,hardwareProtected:o}=n,l=__rest(n,["enabled","notBefore","exportable","expiresOn","hardwareProtected"]);i=Object.assign(Object.assign({},l),{keyAttributes:{enabled:e,notBefore:t,expires:a,hsm:o,exportable:r}})}return tracingClient.withSpan("KeyClient.importKey",i,(async n=>{const i=await this.client.importKey(this.vaultUrl,e,t,n);return getKeyFromKeyBundle(i)}))}getCryptographyClient(e,t){const n=new URL(["keys",e,null==t?void 0:t.keyVersion].filter(Boolean).join("/"),this.vaultUrl),i={generatedClient:this.client};return new CryptographyClient(n.toString(),this.credential,i)}async beginDeleteKey(e,t={}){const n=new DeleteKeyPoller({name:e,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:t.intervalInMs,resumeFrom:t.resumeFrom,operationOptions:t});return await n.poll(),n}updateKeyProperties(...e){const[t,n,i]=this.disambiguateUpdateKeyPropertiesArgs(e);return tracingClient.withSpan("KeyClient.updateKeyProperties",i,(async e=>{const{enabled:i,notBefore:r,expiresOn:a}=e,o=__rest(e,["enabled","notBefore","expiresOn"]),l=Object.assign(Object.assign({},o),{keyAttributes:{enabled:i,notBefore:r,expires:a}}),s=await this.client.updateKey(this.vaultUrl,t,n,l);return getKeyFromKeyBundle(s)}))}disambiguateUpdateKeyPropertiesArgs(e){return"string"==typeof e[1]?[e[0],e[1],e[2]||{}]:[e[0],"",e[1]||{}]}getKey(e,t={}){return tracingClient.withSpan("KeyClient.getKey",t,(async n=>{const i=await this.client.getKey(this.vaultUrl,e,t&&t.version?t.version:"",n);return getKeyFromKeyBundle(i)}))}getDeletedKey(e,t={}){return tracingClient.withSpan("KeyClient.getDeletedKey",t,(async t=>{const n=await this.client.getDeletedKey(this.vaultUrl,e,t);return getKeyFromKeyBundle(n)}))}purgeDeletedKey(e,t={}){return tracingClient.withSpan("KeyClient.purgeDeletedKey",t,(async t=>{await this.client.purgeDeletedKey(this.vaultUrl,e,t)}))}async beginRecoverDeletedKey(e,t={}){const n=new RecoverDeletedKeyPoller({name:e,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:t.intervalInMs,resumeFrom:t.resumeFrom,operationOptions:t});return await n.poll(),n}backupKey(e,t={}){return tracingClient.withSpan("KeyClient.backupKey",t,(async t=>(await this.client.backupKey(this.vaultUrl,e,t)).value))}async restoreKeyBackup(e,t={}){return tracingClient.withSpan("KeyClient.restoreKeyBackup",t,(async t=>{const n=await this.client.restoreKey(this.vaultUrl,e,t);return getKeyFromKeyBundle(n)}))}getRandomBytes(e,t={}){return tracingClient.withSpan("KeyClient.getRandomBytes",t,(async t=>(await this.client.getRandomBytes(this.vaultUrl,e,t)).value))}rotateKey(e,t={}){return tracingClient.withSpan("KeyClient.rotateKey",t,(async t=>{const n=await this.client.rotateKey(this.vaultUrl,e,t);return getKeyFromKeyBundle(n)}))}releaseKey(e,t,n={}){return tracingClient.withSpan("KeyClient.releaseKey",n,(async i=>{const{nonce:r,algorithm:a}=i,o=__rest(i,["nonce","algorithm"]);return{value:(await this.client.release(this.vaultUrl,e,(null==n?void 0:n.version)||"",t,Object.assign({enc:a,nonce:r},o))).value}}))}getKeyRotationPolicy(e,t={}){return tracingClient.withSpan("KeyClient.getKeyRotationPolicy",t,(async()=>{const t=await this.client.getKeyRotationPolicy(this.vaultUrl,e);return keyRotationTransformations.generatedToPublic(t)}))}updateKeyRotationPolicy(e,t,n={}){return tracingClient.withSpan("KeyClient.updateKeyRotationPolicy",n,(async n=>{const i=await this.client.updateKeyRotationPolicy(this.vaultUrl,e,keyRotationTransformations.propertiesToGenerated(t),n);return keyRotationTransformations.generatedToPublic(i)}))}listPropertiesOfKeyVersionsPage(e,t,n){return __asyncGenerator(this,arguments,(function*(){if(null==t.continuationToken){const i=Object.assign({maxresults:t.maxPageSize},n),r=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",i,(async t=>this.client.getKeyVersions(this.vaultUrl,e,t))));t.continuationToken=r.nextLink,r.value&&(yield yield __await(r.value.map(getKeyPropertiesFromKeyItem,this)))}for(;t.continuationToken;){const i=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",n||{},(async n=>this.client.getKeyVersionsNext(this.vaultUrl,e,t.continuationToken,n))));if(t.continuationToken=i.nextLink,!i.value)break;yield yield __await(i.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeyVersionsAll(e,t){return __asyncGenerator(this,arguments,(function*(){var n,i,r,a;const o={};try{for(var l,s=!0,y=__asyncValues(this.listPropertiesOfKeyVersionsPage(e,o,t));!(n=(l=yield __await(y.next())).done);s=!0){a=l.value,s=!1;const e=a;for(const t of e)yield yield __await(t)}}catch(e){i={error:e}}finally{try{s||n||!(r=y.return)||(yield __await(r.call(y)))}finally{if(i)throw i.error}}}))}listPropertiesOfKeyVersions(e,t={}){const n=this.listPropertiesOfKeyVersionsAll(e,t);return{next:()=>n.next(),[Symbol.asyncIterator](){return this},byPage:(n={})=>this.listPropertiesOfKeyVersionsPage(e,n,t)}}listPropertiesOfKeysPage(e,t){return __asyncGenerator(this,arguments,(function*(){if(null==e.continuationToken){const n=Object.assign({maxresults:e.maxPageSize},t),i=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",n,(async e=>this.client.getKeys(this.vaultUrl,e))));e.continuationToken=i.nextLink,i.value&&(yield yield __await(i.value.map(getKeyPropertiesFromKeyItem,this)))}for(;e.continuationToken;){const n=yield __await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",t||{},(async t=>this.client.getKeysNext(this.vaultUrl,e.continuationToken,t))));if(e.continuationToken=n.nextLink,!n.value)break;yield yield __await(n.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeysAll(e){return __asyncGenerator(this,arguments,(function*(){var t,n,i,r;const a={};try{for(var o,l=!0,s=__asyncValues(this.listPropertiesOfKeysPage(a,e));!(t=(o=yield __await(s.next())).done);l=!0){r=o.value,l=!1;const e=r;for(const t of e)yield yield __await(t)}}catch(e){n={error:e}}finally{try{l||t||!(i=s.return)||(yield __await(i.call(s)))}finally{if(n)throw n.error}}}))}listPropertiesOfKeys(e={}){const t=this.listPropertiesOfKeysAll(e);return{next:()=>t.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.listPropertiesOfKeysPage(t,e)}}listDeletedKeysPage(e,t){return __asyncGenerator(this,arguments,(function*(){if(null==e.continuationToken){const n=Object.assign({maxresults:e.maxPageSize},t),i=yield __await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",n,(async e=>this.client.getDeletedKeys(this.vaultUrl,e))));e.continuationToken=i.nextLink,i.value&&(yield yield __await(i.value.map(getDeletedKeyFromDeletedKeyItem,this)))}for(;e.continuationToken;){const n=yield __await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",t||{},(async t=>this.client.getDeletedKeysNext(this.vaultUrl,e.continuationToken,t))));if(e.continuationToken=n.nextLink,!n.value)break;yield yield __await(n.value.map(getDeletedKeyFromDeletedKeyItem,this))}}))}listDeletedKeysAll(e){return __asyncGenerator(this,arguments,(function*(){var t,n,i,r;const a={};try{for(var o,l=!0,s=__asyncValues(this.listDeletedKeysPage(a,e));!(t=(o=yield __await(s.next())).done);l=!0){r=o.value,l=!1;const e=r;for(const t of e)yield yield __await(t)}}catch(e){n={error:e}}finally{try{l||t||!(i=s.return)||(yield __await(i.call(s)))}finally{if(n)throw n.error}}}))}listDeletedKeys(e={}){const t=this.listDeletedKeysAll(e);return{next:()=>t.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.listDeletedKeysPage(t,e)}}}