"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var tslib=require("tslib"),coreRestPipeline=require("@azure/core-rest-pipeline"),logger$1=require("@azure/logger"),coreClient=require("@azure/core-client"),coreHttpCompat=require("@azure/core-http-compat"),coreTracing=require("@azure/core-tracing"),coreUtil=require("@azure/core-util"),coreLro=require("@azure/core-lro"),crypto=require("crypto"),constants=require("constants");function _interopNamespaceDefault(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(r){if("default"!==r){var a=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,a.get?a:{enumerable:!0,get:function(){return e[r]}})}})),t.default=e,Object.freeze(t)}var coreRestPipeline__namespace=_interopNamespaceDefault(coreRestPipeline),coreClient__namespace=_interopNamespaceDefault(coreClient),coreHttpCompat__namespace=_interopNamespaceDefault(coreHttpCompat),crypto__namespace=_interopNamespaceDefault(crypto);const logger=logger$1.createClientLogger("keyvault-keys");var KnownApiVersion75,KnownJsonWebKeyOperation,KnownJsonWebKeyEncryptionAlgorithm,KnownKeyEncryptionAlgorithm;!function(e){e.Seven5="7.5"}(KnownApiVersion75||(KnownApiVersion75={})),exports.KnownKeyTypes=void 0,function(e){e.EC="EC",e.ECHSM="EC-HSM",e.RSA="RSA",e.RSAHSM="RSA-HSM",e.Oct="oct",e.OctHSM="oct-HSM"}(exports.KnownKeyTypes||(exports.KnownKeyTypes={})),function(e){e.Encrypt="encrypt",e.Decrypt="decrypt",e.Sign="sign",e.Verify="verify",e.WrapKey="wrapKey",e.UnwrapKey="unwrapKey",e.Import="import",e.Export="export"}(KnownJsonWebKeyOperation||(KnownJsonWebKeyOperation={})),exports.KnownDeletionRecoveryLevel=void 0,function(e){e.Purgeable="Purgeable",e.RecoverablePurgeable="Recoverable+Purgeable",e.Recoverable="Recoverable",e.RecoverableProtectedSubscription="Recoverable+ProtectedSubscription",e.CustomizedRecoverablePurgeable="CustomizedRecoverable+Purgeable",e.CustomizedRecoverable="CustomizedRecoverable",e.CustomizedRecoverableProtectedSubscription="CustomizedRecoverable+ProtectedSubscription"}(exports.KnownDeletionRecoveryLevel||(exports.KnownDeletionRecoveryLevel={})),exports.KnownKeyCurveNames=void 0,function(e){e.P256="P-256",e.P384="P-384",e.P521="P-521",e.P256K="P-256K"}(exports.KnownKeyCurveNames||(exports.KnownKeyCurveNames={})),function(e){e.RSAOaep="RSA-OAEP",e.RSAOaep256="RSA-OAEP-256",e.RSA15="RSA1_5",e.A128GCM="A128GCM",e.A192GCM="A192GCM",e.A256GCM="A256GCM",e.A128KW="A128KW",e.A192KW="A192KW",e.A256KW="A256KW",e.A128CBC="A128CBC",e.A192CBC="A192CBC",e.A256CBC="A256CBC",e.A128Cbcpad="A128CBCPAD",e.A192Cbcpad="A192CBCPAD",e.A256Cbcpad="A256CBCPAD"}(KnownJsonWebKeyEncryptionAlgorithm||(KnownJsonWebKeyEncryptionAlgorithm={})),exports.KnownSignatureAlgorithms=void 0,function(e){e.PS256="PS256",e.PS384="PS384",e.PS512="PS512",e.RS256="RS256",e.RS384="RS384",e.RS512="RS512",e.Rsnull="RSNULL",e.ES256="ES256",e.ES384="ES384",e.ES512="ES512",e.ES256K="ES256K"}(exports.KnownSignatureAlgorithms||(exports.KnownSignatureAlgorithms={})),function(e){e.CKMRSAAESKEYWrap="CKM_RSA_AES_KEY_WRAP",e.RSAAESKEYWrap256="RSA_AES_KEY_WRAP_256",e.RSAAESKEYWrap384="RSA_AES_KEY_WRAP_384"}(KnownKeyEncryptionAlgorithm||(KnownKeyEncryptionAlgorithm={}));const KeyCreateParameters={type:{name:"Composite",className:"KeyCreateParameters",modelProperties:{kty:{serializedName:"kty",required:!0,type:{name:"String"}},keySize:{serializedName:"key_size",type:{name:"Number"}},publicExponent:{serializedName:"public_exponent",type:{name:"Number"}},keyOps:{serializedName:"key_ops",type:{name:"Sequence",element:{type:{name:"String"}}}},keyAttributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},curve:{serializedName:"crv",type:{name:"String"}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},Attributes={type:{name:"Composite",className:"Attributes",modelProperties:{enabled:{serializedName:"enabled",type:{name:"Boolean"}},notBefore:{serializedName:"nbf",type:{name:"UnixTime"}},expires:{serializedName:"exp",type:{name:"UnixTime"}},created:{serializedName:"created",readOnly:!0,type:{name:"UnixTime"}},updated:{serializedName:"updated",readOnly:!0,type:{name:"UnixTime"}}}}},KeyReleasePolicy={type:{name:"Composite",className:"KeyReleasePolicy",modelProperties:{contentType:{defaultValue:"application/json; charset=utf-8",serializedName:"contentType",type:{name:"String"}},immutable:{serializedName:"immutable",type:{name:"Boolean"}},encodedPolicy:{serializedName:"data",type:{name:"Base64Url"}}}}},KeyBundle={type:{name:"Composite",className:"KeyBundle",modelProperties:{key:{serializedName:"key",type:{name:"Composite",className:"JsonWebKey"}},attributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},managed:{serializedName:"managed",readOnly:!0,type:{name:"Boolean"}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},JsonWebKey={type:{name:"Composite",className:"JsonWebKey",modelProperties:{kid:{serializedName:"kid",type:{name:"String"}},kty:{serializedName:"kty",type:{name:"String"}},keyOps:{serializedName:"key_ops",type:{name:"Sequence",element:{type:{name:"String"}}}},n:{serializedName:"n",type:{name:"Base64Url"}},e:{serializedName:"e",type:{name:"Base64Url"}},d:{serializedName:"d",type:{name:"Base64Url"}},dp:{serializedName:"dp",type:{name:"Base64Url"}},dq:{serializedName:"dq",type:{name:"Base64Url"}},qi:{serializedName:"qi",type:{name:"Base64Url"}},p:{serializedName:"p",type:{name:"Base64Url"}},q:{serializedName:"q",type:{name:"Base64Url"}},k:{serializedName:"k",type:{name:"Base64Url"}},t:{serializedName:"key_hsm",type:{name:"Base64Url"}},crv:{serializedName:"crv",type:{name:"String"}},x:{serializedName:"x",type:{name:"Base64Url"}},y:{serializedName:"y",type:{name:"Base64Url"}}}}},KeyVaultError={type:{name:"Composite",className:"KeyVaultError",modelProperties:{error:{serializedName:"error",type:{name:"Composite",className:"ErrorModel"}}}}},ErrorModel={type:{name:"Composite",className:"ErrorModel",modelProperties:{code:{serializedName:"code",readOnly:!0,type:{name:"String"}},message:{serializedName:"message",readOnly:!0,type:{name:"String"}},innerError:{serializedName:"innererror",type:{name:"Composite",className:"ErrorModel"}}}}},KeyImportParameters={type:{name:"Composite",className:"KeyImportParameters",modelProperties:{hsm:{serializedName:"Hsm",type:{name:"Boolean"}},key:{serializedName:"key",type:{name:"Composite",className:"JsonWebKey"}},keyAttributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},KeyUpdateParameters={type:{name:"Composite",className:"KeyUpdateParameters",modelProperties:{keyOps:{serializedName:"key_ops",type:{name:"Sequence",element:{type:{name:"String"}}}},keyAttributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},releasePolicy:{serializedName:"release_policy",type:{name:"Composite",className:"KeyReleasePolicy"}}}}},KeyListResult={type:{name:"Composite",className:"KeyListResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Sequence",element:{type:{name:"Composite",className:"KeyItem"}}}},nextLink:{serializedName:"nextLink",readOnly:!0,type:{name:"String"}}}}},KeyItem={type:{name:"Composite",className:"KeyItem",modelProperties:{kid:{serializedName:"kid",type:{name:"String"}},attributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyAttributes"}},tags:{serializedName:"tags",type:{name:"Dictionary",value:{type:{name:"String"}}}},managed:{serializedName:"managed",readOnly:!0,type:{name:"Boolean"}}}}},BackupKeyResult={type:{name:"Composite",className:"BackupKeyResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Base64Url"}}}}},KeyRestoreParameters={type:{name:"Composite",className:"KeyRestoreParameters",modelProperties:{keyBundleBackup:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyOperationsParameters={type:{name:"Composite",className:"KeyOperationsParameters",modelProperties:{algorithm:{serializedName:"alg",required:!0,type:{name:"String"}},value:{serializedName:"value",required:!0,type:{name:"Base64Url"}},iv:{serializedName:"iv",type:{name:"Base64Url"}},additionalAuthenticatedData:{serializedName:"aad",type:{name:"Base64Url"}},authenticationTag:{serializedName:"tag",type:{name:"Base64Url"}}}}},KeyOperationResult={type:{name:"Composite",className:"KeyOperationResult",modelProperties:{kid:{serializedName:"kid",readOnly:!0,type:{name:"String"}},result:{serializedName:"value",readOnly:!0,type:{name:"Base64Url"}},iv:{serializedName:"iv",readOnly:!0,type:{name:"Base64Url"}},authenticationTag:{serializedName:"tag",readOnly:!0,type:{name:"Base64Url"}},additionalAuthenticatedData:{serializedName:"aad",readOnly:!0,type:{name:"Base64Url"}}}}},KeySignParameters={type:{name:"Composite",className:"KeySignParameters",modelProperties:{algorithm:{serializedName:"alg",required:!0,type:{name:"String"}},value:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyVerifyParameters={type:{name:"Composite",className:"KeyVerifyParameters",modelProperties:{algorithm:{serializedName:"alg",required:!0,type:{name:"String"}},digest:{serializedName:"digest",required:!0,type:{name:"Base64Url"}},signature:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyVerifyResult={type:{name:"Composite",className:"KeyVerifyResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Boolean"}}}}},KeyReleaseParameters={type:{name:"Composite",className:"KeyReleaseParameters",modelProperties:{targetAttestationToken:{constraints:{MinLength:1},serializedName:"target",required:!0,type:{name:"String"}},nonce:{serializedName:"nonce",type:{name:"String"}},enc:{serializedName:"enc",type:{name:"String"}}}}},KeyReleaseResult={type:{name:"Composite",className:"KeyReleaseResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"String"}}}}},DeletedKeyListResult={type:{name:"Composite",className:"DeletedKeyListResult",modelProperties:{value:{serializedName:"value",readOnly:!0,type:{name:"Sequence",element:{type:{name:"Composite",className:"DeletedKeyItem"}}}},nextLink:{serializedName:"nextLink",readOnly:!0,type:{name:"String"}}}}},KeyRotationPolicy={type:{name:"Composite",className:"KeyRotationPolicy",modelProperties:{id:{serializedName:"id",readOnly:!0,type:{name:"String"}},lifetimeActions:{serializedName:"lifetimeActions",type:{name:"Sequence",element:{type:{name:"Composite",className:"LifetimeActions"}}}},attributes:{serializedName:"attributes",type:{name:"Composite",className:"KeyRotationPolicyAttributes"}}}}},LifetimeActions={type:{name:"Composite",className:"LifetimeActions",modelProperties:{trigger:{serializedName:"trigger",type:{name:"Composite",className:"LifetimeActionsTrigger"}},action:{serializedName:"action",type:{name:"Composite",className:"LifetimeActionsType"}}}}},LifetimeActionsTrigger={type:{name:"Composite",className:"LifetimeActionsTrigger",modelProperties:{timeAfterCreate:{serializedName:"timeAfterCreate",type:{name:"String"}},timeBeforeExpiry:{serializedName:"timeBeforeExpiry",type:{name:"String"}}}}},LifetimeActionsType={type:{name:"Composite",className:"LifetimeActionsType",modelProperties:{type:{serializedName:"type",type:{name:"Enum",allowedValues:["Rotate","Notify"]}}}}},KeyRotationPolicyAttributes={type:{name:"Composite",className:"KeyRotationPolicyAttributes",modelProperties:{expiryTime:{serializedName:"expiryTime",type:{name:"String"}},created:{serializedName:"created",readOnly:!0,type:{name:"UnixTime"}},updated:{serializedName:"updated",readOnly:!0,type:{name:"UnixTime"}}}}},GetRandomBytesRequest={type:{name:"Composite",className:"GetRandomBytesRequest",modelProperties:{count:{constraints:{InclusiveMaximum:128,InclusiveMinimum:1},serializedName:"count",required:!0,type:{name:"Number"}}}}},RandomBytes={type:{name:"Composite",className:"RandomBytes",modelProperties:{value:{serializedName:"value",required:!0,type:{name:"Base64Url"}}}}},KeyProperties={type:{name:"Composite",className:"KeyProperties",modelProperties:{exportable:{serializedName:"exportable",type:{name:"Boolean"}},keyType:{serializedName:"kty",type:{name:"String"}},keySize:{serializedName:"key_size",type:{name:"Number"}},reuseKey:{serializedName:"reuse_key",type:{name:"Boolean"}},curve:{serializedName:"crv",type:{name:"String"}}}}},KeyExportParameters={type:{name:"Composite",className:"KeyExportParameters",modelProperties:{wrappingKey:{serializedName:"wrappingKey",type:{name:"Composite",className:"JsonWebKey"}},wrappingKid:{serializedName:"wrappingKid",type:{name:"String"}},enc:{serializedName:"enc",type:{name:"String"}}}}},KeyAttributes={type:{name:"Composite",className:"KeyAttributes",modelProperties:Object.assign(Object.assign({},Attributes.type.modelProperties),{recoverableDays:{serializedName:"recoverableDays",readOnly:!0,type:{name:"Number"}},recoveryLevel:{serializedName:"recoveryLevel",readOnly:!0,type:{name:"String"}},exportable:{serializedName:"exportable",type:{name:"Boolean"}},hsmPlatform:{serializedName:"hsmPlatform",readOnly:!0,type:{name:"String"}}})}},DeletedKeyBundle={type:{name:"Composite",className:"DeletedKeyBundle",modelProperties:Object.assign(Object.assign({},KeyBundle.type.modelProperties),{recoveryId:{serializedName:"recoveryId",type:{name:"String"}},scheduledPurgeDate:{serializedName:"scheduledPurgeDate",readOnly:!0,type:{name:"UnixTime"}},deletedDate:{serializedName:"deletedDate",readOnly:!0,type:{name:"UnixTime"}}})}},DeletedKeyItem={type:{name:"Composite",className:"DeletedKeyItem",modelProperties:Object.assign(Object.assign({},KeyItem.type.modelProperties),{recoveryId:{serializedName:"recoveryId",type:{name:"String"}},scheduledPurgeDate:{serializedName:"scheduledPurgeDate",readOnly:!0,type:{name:"UnixTime"}},deletedDate:{serializedName:"deletedDate",readOnly:!0,type:{name:"UnixTime"}}})}};var Mappers=Object.freeze({__proto__:null,Attributes:Attributes,BackupKeyResult:BackupKeyResult,DeletedKeyBundle:DeletedKeyBundle,DeletedKeyItem:DeletedKeyItem,DeletedKeyListResult:DeletedKeyListResult,ErrorModel:ErrorModel,GetRandomBytesRequest:GetRandomBytesRequest,JsonWebKey:JsonWebKey,KeyAttributes:KeyAttributes,KeyBundle:KeyBundle,KeyCreateParameters:KeyCreateParameters,KeyExportParameters:KeyExportParameters,KeyImportParameters:KeyImportParameters,KeyItem:KeyItem,KeyListResult:KeyListResult,KeyOperationResult:KeyOperationResult,KeyOperationsParameters:KeyOperationsParameters,KeyProperties:KeyProperties,KeyReleaseParameters:KeyReleaseParameters,KeyReleasePolicy:KeyReleasePolicy,KeyReleaseResult:KeyReleaseResult,KeyRestoreParameters:KeyRestoreParameters,KeyRotationPolicy:KeyRotationPolicy,KeyRotationPolicyAttributes:KeyRotationPolicyAttributes,KeySignParameters:KeySignParameters,KeyUpdateParameters:KeyUpdateParameters,KeyVaultError:KeyVaultError,KeyVerifyParameters:KeyVerifyParameters,KeyVerifyResult:KeyVerifyResult,LifetimeActions:LifetimeActions,LifetimeActionsTrigger:LifetimeActionsTrigger,LifetimeActionsType:LifetimeActionsType,RandomBytes:RandomBytes});const contentType={parameterPath:["options","contentType"],mapper:{defaultValue:"application/json",isConstant:!0,serializedName:"Content-Type",type:{name:"String"}}},accept={parameterPath:"accept",mapper:{defaultValue:"application/json",isConstant:!0,serializedName:"Accept",type:{name:"String"}}},vaultBaseUrl={parameterPath:"vaultBaseUrl",mapper:{serializedName:"vaultBaseUrl",required:!0,type:{name:"String"}},skipEncoding:!0},keyName={parameterPath:"keyName",mapper:{constraints:{Pattern:new RegExp("^[0-9a-zA-Z-]+$")},serializedName:"key-name",required:!0,type:{name:"String"}}},apiVersion={parameterPath:"apiVersion",mapper:{serializedName:"api-version",required:!0,type:{name:"String"}}},keyName1={parameterPath:"keyName",mapper:{serializedName:"key-name",required:!0,type:{name:"String"}}},keyVersion={parameterPath:"keyVersion",mapper:{serializedName:"key-version",required:!0,type:{name:"String"}}},maxresults={parameterPath:["options","maxresults"],mapper:{constraints:{InclusiveMaximum:25,InclusiveMinimum:1},serializedName:"maxresults",type:{name:"Number"}}},keyRotationPolicy={parameterPath:"keyRotationPolicy",mapper:KeyRotationPolicy},nextLink={parameterPath:"nextLink",mapper:{serializedName:"nextLink",required:!0,type:{name:"String"}},skipEncoding:!0};class KeyVaultClient extends coreHttpCompat__namespace.ExtendedServiceClient{constructor(e,t){var r,a;if(void 0===e)throw new Error("'apiVersion' cannot be null");t||(t={});const i="azsdk-js-keyvault-keys/4.8.0",s=t.userAgentOptions&&t.userAgentOptions.userAgentPrefix?`${t.userAgentOptions.userAgentPrefix} ${i}`:`${i}`,n=Object.assign(Object.assign(Object.assign({},{requestContentType:"application/json; charset=utf-8"}),t),{userAgentOptions:{userAgentPrefix:s},baseUri:null!==(a=null!==(r=t.endpoint)&&void 0!==r?r:t.baseUri)&&void 0!==a?a:"{vaultBaseUrl}"});if(super(n),(null==t?void 0:t.pipeline)&&t.pipeline.getOrderedPolicies().length>0){t.pipeline.getOrderedPolicies().some((e=>e.name===coreRestPipeline__namespace.bearerTokenAuthenticationPolicyName))||(this.pipeline.removePolicy({name:coreRestPipeline__namespace.bearerTokenAuthenticationPolicyName}),this.pipeline.addPolicy(coreRestPipeline__namespace.bearerTokenAuthenticationPolicy({scopes:`${n.baseUri}/.default`,challengeCallbacks:{authorizeRequestOnChallenge:coreClient__namespace.authorizeRequestOnClaimChallenge}})))}this.apiVersion=e}createKey(e,t,r,a){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,kty:r,options:a},createKeyOperationSpec)}rotateKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},rotateKeyOperationSpec)}importKey(e,t,r,a){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,key:r,options:a},importKeyOperationSpec)}deleteKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},deleteKeyOperationSpec)}updateKey(e,t,r,a){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,options:a},updateKeyOperationSpec)}getKey(e,t,r,a){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,options:a},getKeyOperationSpec)}getKeyVersions(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},getKeyVersionsOperationSpec)}getKeys(e,t){return this.sendOperationRequest({vaultBaseUrl:e,options:t},getKeysOperationSpec)}backupKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},backupKeyOperationSpec)}restoreKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyBundleBackup:t,options:r},restoreKeyOperationSpec)}encrypt(e,t,r,a,i,s){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,algorithm:a,value:i,options:s},encryptOperationSpec)}decrypt(e,t,r,a,i,s){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,algorithm:a,value:i,options:s},decryptOperationSpec)}sign(e,t,r,a,i,s){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,algorithm:a,value:i,options:s},signOperationSpec)}verify(e,t,r,a,i,s,n){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,algorithm:a,digest:i,signature:s,options:n},verifyOperationSpec)}wrapKey(e,t,r,a,i,s){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,algorithm:a,value:i,options:s},wrapKeyOperationSpec)}unwrapKey(e,t,r,a,i,s){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,algorithm:a,value:i,options:s},unwrapKeyOperationSpec)}release(e,t,r,a,i){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyVersion:r,targetAttestationToken:a,options:i},releaseOperationSpec)}getDeletedKeys(e,t){return this.sendOperationRequest({vaultBaseUrl:e,options:t},getDeletedKeysOperationSpec)}getDeletedKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},getDeletedKeyOperationSpec)}purgeDeletedKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},purgeDeletedKeyOperationSpec)}recoverDeletedKey(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},recoverDeletedKeyOperationSpec)}getKeyRotationPolicy(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,options:r},getKeyRotationPolicyOperationSpec)}updateKeyRotationPolicy(e,t,r,a){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,keyRotationPolicy:r,options:a},updateKeyRotationPolicyOperationSpec)}getRandomBytes(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,count:t,options:r},getRandomBytesOperationSpec)}getKeyVersionsNext(e,t,r,a){return this.sendOperationRequest({vaultBaseUrl:e,keyName:t,nextLink:r,options:a},getKeyVersionsNextOperationSpec)}getKeysNext(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,nextLink:t,options:r},getKeysNextOperationSpec)}getDeletedKeysNext(e,t,r){return this.sendOperationRequest({vaultBaseUrl:e,nextLink:t,options:r},getDeletedKeysNextOperationSpec)}}const serializer=coreClient__namespace.createSerializer(Mappers,!1),createKeyOperationSpec={path:"/keys/{key-name}/create",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{kty:["kty"],keySize:["options","keySize"],publicExponent:["options","publicExponent"],keyOps:["options","keyOps"],keyAttributes:["options","keyAttributes"],tags:["options","tags"],curve:["options","curve"],releasePolicy:["options","releasePolicy"]},mapper:Object.assign(Object.assign({},KeyCreateParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},rotateKeyOperationSpec={path:"/keys/{key-name}/rotate",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName],headerParameters:[accept],serializer:serializer},importKeyOperationSpec={path:"/keys/{key-name}",httpMethod:"PUT",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{hsm:["options","hsm"],key:["key"],keyAttributes:["options","keyAttributes"],tags:["options","tags"],releasePolicy:["options","releasePolicy"]},mapper:Object.assign(Object.assign({},KeyImportParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},deleteKeyOperationSpec={path:"/keys/{key-name}",httpMethod:"DELETE",responses:{200:{bodyMapper:DeletedKeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},updateKeyOperationSpec={path:"/keys/{key-name}/{key-version}",httpMethod:"PATCH",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{keyOps:["options","keyOps"],keyAttributes:["options","keyAttributes"],tags:["options","tags"],releasePolicy:["options","releasePolicy"]},mapper:Object.assign(Object.assign({},KeyUpdateParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getKeyOperationSpec={path:"/keys/{key-name}/{key-version}",httpMethod:"GET",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[accept],serializer:serializer},getKeyVersionsOperationSpec={path:"/keys/{key-name}/versions",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},getKeysOperationSpec={path:"/keys",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl],headerParameters:[accept],serializer:serializer},backupKeyOperationSpec={path:"/keys/{key-name}/backup",httpMethod:"POST",responses:{200:{bodyMapper:BackupKeyResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},restoreKeyOperationSpec={path:"/keys/restore",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{keyBundleBackup:["keyBundleBackup"]},mapper:Object.assign(Object.assign({},KeyRestoreParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},encryptOperationSpec={path:"/keys/{key-name}/{key-version}/encrypt",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},decryptOperationSpec={path:"/keys/{key-name}/{key-version}/decrypt",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},signOperationSpec={path:"/keys/{key-name}/{key-version}/sign",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"]},mapper:Object.assign(Object.assign({},KeySignParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},verifyOperationSpec={path:"/keys/{key-name}/{key-version}/verify",httpMethod:"POST",responses:{200:{bodyMapper:KeyVerifyResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],digest:["digest"],signature:["signature"]},mapper:Object.assign(Object.assign({},KeyVerifyParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},wrapKeyOperationSpec={path:"/keys/{key-name}/{key-version}/wrapkey",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},unwrapKeyOperationSpec={path:"/keys/{key-name}/{key-version}/unwrapkey",httpMethod:"POST",responses:{200:{bodyMapper:KeyOperationResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{algorithm:["algorithm"],value:["value"],iv:["options","iv"],additionalAuthenticatedData:["options","additionalAuthenticatedData"],authenticationTag:["options","authenticationTag"]},mapper:Object.assign(Object.assign({},KeyOperationsParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},releaseOperationSpec={path:"/keys/{key-name}/{key-version}/release",httpMethod:"POST",responses:{200:{bodyMapper:KeyReleaseResult},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{targetAttestationToken:["targetAttestationToken"],nonce:["options","nonce"],enc:["options","enc"]},mapper:Object.assign(Object.assign({},KeyReleaseParameters),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1,keyVersion],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getDeletedKeysOperationSpec={path:"/deletedkeys",httpMethod:"GET",responses:{200:{bodyMapper:DeletedKeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl],headerParameters:[accept],serializer:serializer},getDeletedKeyOperationSpec={path:"/deletedkeys/{key-name}",httpMethod:"GET",responses:{200:{bodyMapper:DeletedKeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},purgeDeletedKeyOperationSpec={path:"/deletedkeys/{key-name}",httpMethod:"DELETE",responses:{204:{},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},recoverDeletedKeyOperationSpec={path:"/deletedkeys/{key-name}/recover",httpMethod:"POST",responses:{200:{bodyMapper:KeyBundle},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},getKeyRotationPolicyOperationSpec={path:"/keys/{key-name}/rotationpolicy",httpMethod:"GET",responses:{200:{bodyMapper:KeyRotationPolicy},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[accept],serializer:serializer},updateKeyRotationPolicyOperationSpec={path:"/keys/{key-name}/rotationpolicy",httpMethod:"PUT",responses:{200:{bodyMapper:KeyRotationPolicy},default:{bodyMapper:KeyVaultError}},requestBody:keyRotationPolicy,queryParameters:[apiVersion],urlParameters:[vaultBaseUrl,keyName1],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getRandomBytesOperationSpec={path:"/rng",httpMethod:"POST",responses:{200:{bodyMapper:RandomBytes},default:{bodyMapper:KeyVaultError}},requestBody:{parameterPath:{count:["count"]},mapper:Object.assign(Object.assign({},GetRandomBytesRequest),{required:!0})},queryParameters:[apiVersion],urlParameters:[vaultBaseUrl],headerParameters:[contentType,accept],mediaType:"json",serializer:serializer},getKeyVersionsNextOperationSpec={path:"{nextLink}",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,keyName1,nextLink],headerParameters:[accept],serializer:serializer},getKeysNextOperationSpec={path:"{nextLink}",httpMethod:"GET",responses:{200:{bodyMapper:KeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,nextLink],headerParameters:[accept],serializer:serializer},getDeletedKeysNextOperationSpec={path:"{nextLink}",httpMethod:"GET",responses:{200:{bodyMapper:DeletedKeyListResult},default:{bodyMapper:KeyVaultError}},queryParameters:[apiVersion,maxresults],urlParameters:[vaultBaseUrl,nextLink],headerParameters:[accept],serializer:serializer},SDK_VERSION="4.8.0",validWWWAuthenticateProperties=["authorization","authorization_url","resource","scope","tenantId"];function parseWWWAuthenticateHeader(e){const t=e.split(/,? +/).reduce(((e,t)=>{if(t.match(/\w="/)){const[r,a]=t.split("=");if(validWWWAuthenticateProperties.includes(r))return Object.assign(Object.assign({},e),{[r]:a.slice(1,-1)})}return e}),{});if(t.authorization)try{const e=new URL(t.authorization).pathname.substring(1);e&&(t.tenantId=e)}catch(e){throw new Error(`The challenge authorization URI '${t.authorization}' is invalid.`)}return t}function verifyChallengeResource(e,t){let r;try{r=new URL(e)}catch(t){throw new Error(`The challenge contains invalid scope '${e}'`)}if(!new URL(t.url).hostname.endsWith(`.${r.hostname}`))throw new Error(`The challenge resource '${r.hostname}' does not match the requested domain. Set disableChallengeResourceVerification to true in your client options to disable. See https://aka.ms/azsdk/blog/vault-uri for more information.`)}function createKeyVaultChallengeCallbacks(e={}){const{disableChallengeResourceVerification:t}=e;let r={status:"none"};function a(e){return{abortSignal:e.abortSignal,requestOptions:{timeout:e.timeout>0?e.timeout:void 0},tracingOptions:e.tracingOptions}}return{authorizeRequest:async function({request:e,getAccessToken:t}){const i=a(e);switch(r.status){case"none":r={status:"started",originalBody:e.body},e.body=null;break;case"started":break;case"complete":{const a=await t(r.scopes,i);a&&e.headers.set("authorization",`Bearer ${a.token}`);break}}return Promise.resolve()},authorizeRequestOnChallenge:async function({request:e,response:i,getAccessToken:s}){null===e.body&&"started"===r.status&&(e.body=r.originalBody);const n=a(e),o=i.headers.get("WWW-Authenticate");if(!o)throw new Error("Missing challenge.");const l=parseWWWAuthenticateHeader(o)||{},y=l.resource?l.resource+"/.default":l.scope;if(!y)throw new Error("Missing scope.");t||verifyChallengeResource(y,e);const p=await s([y],Object.assign(Object.assign({},n),{tenantId:l.tenantId}));return!!p&&(e.headers.set("Authorization",`Bearer ${p.token}`),r={status:"complete",scopes:[y]},!0)}}}function parseKeyVaultIdentifier(e,t){if("string"!=typeof e||!(e=e.trim()))throw new Error("Invalid collection argument");if("string"!=typeof t||!(t=t.trim()))throw new Error("Invalid identifier argument");let r;try{r=new URL(t)}catch(r){throw new Error(`Invalid ${e} identifier: ${t}. Not a valid URI`)}const a=(r.pathname||"").split("/");if(3!==a.length&&4!==a.length)throw new Error(`Invalid ${e} identifier: ${t}. Bad number of segments: ${a.length}`);if(e!==a[1])throw new Error(`Invalid ${e} identifier: ${t}. segment [1] should be "${e}", found "${a[1]}"`);return{vaultUrl:`${r.protocol}//${r.host}`,name:a[2],version:4===a.length?a[3]:void 0}}const tracingClient=coreTracing.createTracingClient({namespace:"Microsoft.KeyVault",packageName:"@azure/keyvault-keys",packageVersion:"4.8.0"});function parseKeyVaultKeyIdentifier(e){const t=e.split("/")[3];return Object.assign({sourceId:e},parseKeyVaultIdentifier(t,e))}function getKeyFromKeyBundle(e){const t=e,r=e,a=parseKeyVaultKeyIdentifier(t.key.kid),i=t.attributes||{};delete t.attributes;const s={key:t.key,id:t.key?t.key.kid:void 0,name:a.name,keyOperations:t.key?t.key.keyOps:void 0,keyType:t.key?t.key.kty:void 0,properties:{tags:t.tags,enabled:i.enabled,notBefore:i.notBefore,expiresOn:i.expires,createdOn:i.created,updatedOn:i.updated,recoverableDays:i.recoverableDays,recoveryLevel:i.recoveryLevel,exportable:i.exportable,releasePolicy:t.releasePolicy,hsmPlatform:i.hsmPlatform,vaultUrl:a.vaultUrl,version:a.version,name:a.name,managed:t.managed,id:t.key?t.key.kid:void 0}};return r.recoveryId&&(s.properties.recoveryId=r.recoveryId,s.properties.scheduledPurgeDate=r.scheduledPurgeDate,s.properties.deletedOn=r.deletedDate),s}function getDeletedKeyFromDeletedKeyItem(e){const t=getKeyPropertiesFromKeyItem(e);return{key:{kid:e.kid},id:e.kid,name:t.name,properties:Object.assign(Object.assign({},t),{recoveryId:e.recoveryId,scheduledPurgeDate:e.scheduledPurgeDate,deletedOn:e.deletedDate})}}function getKeyPropertiesFromKeyItem(e){const t=parseKeyVaultKeyIdentifier(e.kid),r=e.attributes||{};return{createdOn:r.created,enabled:null==r?void 0:r.enabled,expiresOn:null==r?void 0:r.expires,id:e.kid,managed:e.managed,name:t.name,notBefore:null==r?void 0:r.notBefore,recoverableDays:null==r?void 0:r.recoverableDays,recoveryLevel:null==r?void 0:r.recoveryLevel,hsmPlatform:null==r?void 0:r.hsmPlatform,tags:e.tags,updatedOn:r.updated,vaultUrl:t.vaultUrl,version:t.version}}const actionTypeCaseInsensitiveMapping={rotate:"Rotate",notify:"Notify"};function getNormalizedActionType(e){const t=actionTypeCaseInsensitiveMapping[e.toLowerCase()];if(t)return t;throw new Error(`Unrecognized action type: ${e}`)}const keyRotationTransformations={propertiesToGenerated:function(e){var t;return{attributes:{expiryTime:e.expiresIn},lifetimeActions:null===(t=e.lifetimeActions)||void 0===t?void 0:t.map((e=>{const t={action:{type:e.action},trigger:{}};return e.timeAfterCreate&&(t.trigger.timeAfterCreate=e.timeAfterCreate),e.timeBeforeExpiry&&(t.trigger.timeBeforeExpiry=e.timeBeforeExpiry),t}))}},generatedToPublic(e){var t,r,a,i;return{id:e.id,createdOn:null===(t=e.attributes)||void 0===t?void 0:t.created,updatedOn:null===(r=e.attributes)||void 0===r?void 0:r.updated,expiresIn:null===(a=e.attributes)||void 0===a?void 0:a.expiryTime,lifetimeActions:null===(i=e.lifetimeActions)||void 0===i?void 0:i.map((e=>{var t,r;return{action:getNormalizedActionType(e.action.type),timeAfterCreate:null===(t=e.trigger)||void 0===t?void 0:t.timeAfterCreate,timeBeforeExpiry:null===(r=e.trigger)||void 0===r?void 0:r.timeBeforeExpiry}}))}}};class KeyVaultKeyPoller extends coreLro.Poller{constructor(){super(...arguments),this.intervalInMs=2e3}async delay(){return coreUtil.delay(this.intervalInMs)}}class KeyVaultKeyPollOperation{constructor(e,t={}){this.state=e,this.cancelMessage="",t.cancelMessage&&(this.cancelMessage=t.cancelMessage)}async update(){throw new Error("Operation not supported.")}async cancel(){throw new Error(this.cancelMessage)}toString(){return JSON.stringify({state:this.state})}}class DeleteKeyPollOperation extends KeyVaultKeyPollOperation{constructor(e,t,r,a={}){super(e,{cancelMessage:"Canceling the deletion of a key is not supported."}),this.state=e,this.vaultUrl=t,this.client=r,this.operationOptions=a}deleteKey(e,t={}){return tracingClient.withSpan("DeleteKeyPoller.deleteKey",t,(async t=>getKeyFromKeyBundle(await this.client.deleteKey(this.vaultUrl,e,t))))}getDeletedKey(e,t={}){return tracingClient.withSpan("DeleteKeyPoller.getDeletedKey",t,(async t=>getKeyFromKeyBundle(await this.client.getDeletedKey(this.vaultUrl,e,t))))}async update(e={}){const t=this.state,{name:r}=t;if(e.abortSignal&&(this.operationOptions.abortSignal=e.abortSignal),!t.isStarted){const e=await this.deleteKey(r,this.operationOptions);t.isStarted=!0,t.result=e,e.properties.recoveryId||(t.isCompleted=!0)}if(!t.isCompleted)try{t.result=await this.getDeletedKey(r,this.operationOptions),t.isCompleted=!0}catch(e){if(403===e.statusCode)t.isCompleted=!0;else if(404!==e.statusCode)throw t.error=e,t.isCompleted=!0,e}return this}}class DeleteKeyPoller extends KeyVaultKeyPoller{constructor(e){const{vaultUrl:t,client:r,name:a,operationOptions:i,intervalInMs:s=2e3,resumeFrom:n}=e;let o;n&&(o=JSON.parse(n).state);super(new DeleteKeyPollOperation(Object.assign(Object.assign({},o),{name:a}),t,r,i)),this.intervalInMs=s}}class RecoverDeletedKeyPollOperation extends KeyVaultKeyPollOperation{constructor(e,t,r,a={}){super(e,{cancelMessage:"Canceling the recovery of a deleted key is not supported."}),this.state=e,this.vaultUrl=t,this.client=r,this.operationOptions=a}getKey(e,t={}){return tracingClient.withSpan("RecoverDeleteKeyPoller.getKey",t,(async t=>getKeyFromKeyBundle(await this.client.getKey(this.vaultUrl,e,(null==t?void 0:t.version)||"",t))))}async recoverDeletedKey(e,t={}){return tracingClient.withSpan("RecoverDeletedKeyPoller.recoverDeleteKey",t,(async t=>getKeyFromKeyBundle(await this.client.recoverDeletedKey(this.vaultUrl,e,t))))}async update(e={}){const t=this.state,{name:r}=t,a=this.operationOptions;if(e.abortSignal&&(a.abortSignal=e.abortSignal),!t.isStarted){try{t.result=await this.getKey(r,a),t.isCompleted=!0}catch(e){}t.isCompleted||(t.result=await this.recoverDeletedKey(r,a),t.isStarted=!0)}if(!t.isCompleted)try{t.result=await this.getKey(r,a),t.isCompleted=!0}catch(e){if(403===e.statusCode)t.isCompleted=!0;else if(404!==e.statusCode)throw t.error=e,t.isCompleted=!0,e}return this}}class RecoverDeletedKeyPoller extends KeyVaultKeyPoller{constructor(e){const{vaultUrl:t,client:r,name:a,operationOptions:i,intervalInMs:s=2e3,resumeFrom:n}=e;let o;n&&(o=JSON.parse(n).state);super(new RecoverDeletedKeyPollOperation(Object.assign(Object.assign({},o),{name:a}),t,r,i)),this.intervalInMs=s}}const LATEST_API_VERSION="7.5";exports.KnownKeyOperations=void 0,function(e){e.Encrypt="encrypt",e.Decrypt="decrypt",e.Sign="sign",e.Verify="verify",e.WrapKey="wrapKey",e.UnwrapKey="unwrapKey",e.Import="import"}(exports.KnownKeyOperations||(exports.KnownKeyOperations={})),exports.KnownKeyExportEncryptionAlgorithm=void 0,function(e){e.CkmRsaAesKeyWrap="CKM_RSA_AES_KEY_WRAP",e.RsaAesKeyWrap256="RSA_AES_KEY_WRAP_256",e.RsaAesKeyWrap384="RSA_AES_KEY_WRAP_384"}(exports.KnownKeyExportEncryptionAlgorithm||(exports.KnownKeyExportEncryptionAlgorithm={}));const algorithmToHashAlgorithm={ES256:"SHA256",ES256K:"SHA256",PS256:"SHA256",RS256:"SHA256",ES384:"SHA384",PS384:"SHA384",RS384:"SHA384",ES512:"SHA512",PS512:"SHA512",RS512:"SHA512"};async function createHash(e,t){const r=algorithmToHashAlgorithm[e];if(!r)throw new Error(`Invalid algorithm ${e} passed to createHash. Supported algorithms: ${Object.keys(algorithmToHashAlgorithm).join(", ")}`);const a=crypto.createHash(r);a.update(Buffer.from(t));return a.digest()}function createVerify(e,t){const r=algorithmToHashAlgorithm[e];if(!r)throw new Error(`Invalid algorithm ${e} passed to createHash. Supported algorithms: ${Object.keys(algorithmToHashAlgorithm).join(", ")}`);const a=crypto.createVerify(r);return a.update(Buffer.from(t)),a.end(),a}function randomBytes(e){return crypto.randomBytes(e)}class RemoteCryptographyProvider{constructor(e,t,r={}){var a;let i;this.client=getOrInitializeClient(t,r),this.key=e,i="string"==typeof e?e:e.id;try{const e=parseKeyVaultKeyIdentifier(i);if(""===e.name)throw new Error("Could not find 'name' of key in key URL");if(!e.vaultUrl||""===e.vaultUrl)throw new Error("Could not find 'vaultUrl' of key in key URL");this.vaultUrl=e.vaultUrl,this.name=e.name,this.version=null!==(a=e.version)&&void 0!==a?a:""}catch(e){throw logger.error(e),new Error(`${i} is not a valid Key Vault key ID`)}}isSupported(e,t){return!0}encrypt(e,t={}){const{algorithm:r,plaintext:a}=e,i=tslib.__rest(e,["algorithm","plaintext"]),s=Object.assign(Object.assign({},t),i);return tracingClient.withSpan("RemoteCryptographyProvider.encrypt",s,(async t=>{const i=await this.client.encrypt(this.vaultUrl,this.name,this.version,r,a,t);return{algorithm:e.algorithm,result:i.result,keyID:this.getKeyID(),additionalAuthenticatedData:i.additionalAuthenticatedData,authenticationTag:i.authenticationTag,iv:i.iv}}))}decrypt(e,t={}){const{algorithm:r,ciphertext:a}=e,i=tslib.__rest(e,["algorithm","ciphertext"]),s=Object.assign(Object.assign({},t),i);return tracingClient.withSpan("RemoteCryptographyProvider.decrypt",s,(async e=>({result:(await this.client.decrypt(this.vaultUrl,this.name,this.version,r,a,e)).result,keyID:this.getKeyID(),algorithm:r})))}wrapKey(e,t,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.wrapKey",r,(async r=>({result:(await this.client.wrapKey(this.vaultUrl,this.name,this.version,e,t,r)).result,algorithm:e,keyID:this.getKeyID()})))}unwrapKey(e,t,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.unwrapKey",r,(async r=>({result:(await this.client.unwrapKey(this.vaultUrl,this.name,this.version,e,t,r)).result,algorithm:e,keyID:this.getKeyID()})))}sign(e,t,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.sign",r,(async r=>({result:(await this.client.sign(this.vaultUrl,this.name,this.version,e,t,r)).result,algorithm:e,keyID:this.getKeyID()})))}verifyData(e,t,r,a={}){return tracingClient.withSpan("RemoteCryptographyProvider.verifyData",a,(async a=>{const i=await createHash(e,t);return this.verify(e,i,r,a)}))}verify(e,t,r,a={}){return tracingClient.withSpan("RemoteCryptographyProvider.verify",a,(async a=>{const i=await this.client.verify(this.vaultUrl,this.name,this.version,e,t,r,a);return{result:!!i.value&&i.value,keyID:this.getKeyID()}}))}signData(e,t,r={}){return tracingClient.withSpan("RemoteCryptographyProvider.signData",r,(async r=>{const a=await createHash(e,t);return{result:(await this.client.sign(this.vaultUrl,this.name,this.version,e,a,r)).result,algorithm:e,keyID:this.getKeyID()}}))}get keyId(){return this.getKeyID()}getKey(e={}){return tracingClient.withSpan("RemoteCryptographyProvider.getKey",e,(async t=>{if("string"==typeof this.key){if(!this.name||""===this.name)throw new Error("getKey requires a key with a name");const r=await this.client.getKey(this.vaultUrl,this.name,e&&e.version?e.version:this.version?this.version:"",t);this.key=getKeyFromKeyBundle(r)}return this.key}))}getKeyID(){let e;return e="string"!=typeof this.key?this.key.id:this.key,e}}function getOrInitializeClient(e,t){if(t.generatedClient)return t.generatedClient;const r="azsdk-js-keyvault-keys/4.8.0",a=t.userAgentOptions;t.userAgentOptions={userAgentPrefix:a&&a.userAgentPrefix?`${a.userAgentPrefix} ${r}`:r};const i=coreRestPipeline.bearerTokenAuthenticationPolicy({credential:e,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(t)}),s=Object.assign(Object.assign({},t),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}}),n=new KeyVaultClient(t.serviceVersion||"7.5",s);return n.pipeline.addPolicy(i),n}function encodeLength(e){if(e<=127)return Uint8Array.of(e);if(e<256)return Uint8Array.of(129,e);if(e<65536)return Uint8Array.of(130,e>>8,255&e);throw new Error("Unsupported length to encode")}function encodeBuffer(e,t){if(0===e.length)return e;let r=new Uint8Array(e);if(128&r[0]){const e=new Uint8Array(r.length+1);e[0]=0,e.set(r,1),r=e}const a=encodeLength(r.length),i=1+a.length+r.length,s=new Uint8Array(i);return s[0]=t,s.set(a,1),s.set(r,1+a.length),s}function makeSequence(e){const t=e.reduce(((e,t)=>e+t.length),0),r=new Uint8Array(t);for(let t=0;t<e.length;t++){const a=t>0?e[t-1].length:0;r.set(e[t],a)}const a=encodeBuffer(r,48);return Buffer.from(a).toString("base64")}function formatBase64Sequence(e){const t=e.match(/.{1,64}/g);let r="";if(!t)throw new Error("Could not create correct PEM");for(const e of t)r+=e,r+="\n";return r}function convertJWKtoPEM(e){let t="";if(e.n&&e.e){t+="-----BEGIN RSA PUBLIC KEY-----\n",t+=formatBase64Sequence(makeSequence([e.n,e.e].map((e=>encodeBuffer(e,2))))),t+="-----END RSA PUBLIC KEY-----\n"}if(!t.length)throw new Error("Unsupported key format for local operations");return t.slice(0,-1)}class LocalCryptographyUnsupportedError extends Error{}class RsaCryptographyProvider{constructor(e){this.applicableAlgorithms=["RSA1_5","RSA-OAEP","PS256","RS256","PS384","RS384","PS512","RS512"],this.applicableOperations=["encrypt","wrapKey","verifyData"],this.signatureAlgorithmToHashAlgorithm={PS256:"SHA256",RS256:"SHA256",PS384:"SHA384",RS384:"SHA384",PS512:"SHA512",RS512:"SHA512"},this.key=e}isSupported(e,t){return this.applicableAlgorithms.includes(e)&&this.applicableOperations.includes(t)}encrypt(e,t){this.ensureValid();const r=convertJWKtoPEM(this.key),a="RSA1_5"===e.algorithm?constants.RSA_PKCS1_PADDING:constants.RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:e.algorithm,keyID:this.key.kid,result:crypto.publicEncrypt({key:r,padding:a},Buffer.from(e.plaintext))})}decrypt(e,t){throw new LocalCryptographyUnsupportedError("Decrypting using a local JsonWebKey is not supported.")}wrapKey(e,t,r){this.ensureValid();const a=convertJWKtoPEM(this.key),i="RSA1_5"===e?constants.RSA_PKCS1_PADDING:constants.RSA_PKCS1_OAEP_PADDING;return Promise.resolve({algorithm:e,result:crypto.publicEncrypt({key:a,padding:i},Buffer.from(t)),keyID:this.key.kid})}unwrapKey(e,t,r){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported.")}sign(e,t,r){throw new LocalCryptographyUnsupportedError("Signing a digest using a local JsonWebKey is not supported.")}signData(e,t,r){throw new LocalCryptographyUnsupportedError("Signing a block of data using a local JsonWebKey is not supported.")}async verify(e,t,r,a){throw new LocalCryptographyUnsupportedError("Verifying a digest using a local JsonWebKey is not supported.")}verifyData(e,t,r,a){this.ensureValid();const i=convertJWKtoPEM(this.key),s=createVerify(e,t);return Promise.resolve({result:s.verify(i,Buffer.from(r)),keyID:this.key.kid})}ensureValid(){var e,t;if(this.key&&"RSA"!==(null===(e=this.key.kty)||void 0===e?void 0:e.toUpperCase())&&"RSA-HSM"!==(null===(t=this.key.kty)||void 0===t?void 0:t.toUpperCase()))throw new Error("Key type does not match the algorithm RSA")}}class AesCryptographyProvider{constructor(e){this.supportedAlgorithms={A128CBCPAD:{algorithm:"aes-128-cbc",keySizeInBytes:16},A192CBCPAD:{algorithm:"aes-192-cbc",keySizeInBytes:24},A256CBCPAD:{algorithm:"aes-256-cbc",keySizeInBytes:32}},this.supportedOperations=["encrypt","decrypt"],this.key=e}encrypt(e,t){const{algorithm:r,keySizeInBytes:a}=this.supportedAlgorithms[e.algorithm],i=e.iv||crypto__namespace.randomBytes(16);this.ensureValid(a);const s=crypto__namespace.createCipheriv(r,this.key.k.subarray(0,a),i);let n=s.update(Buffer.from(e.plaintext));return n=Buffer.concat([n,s.final()]),Promise.resolve({algorithm:e.algorithm,result:n,iv:i})}decrypt(e,t){const{algorithm:r,keySizeInBytes:a}=this.supportedAlgorithms[e.algorithm];this.ensureValid(a);const i=crypto__namespace.createDecipheriv(r,this.key.k.subarray(0,a),e.iv);let s=i.update(Buffer.from(e.ciphertext));return s=Buffer.concat([s,i.final()]),Promise.resolve({algorithm:e.algorithm,result:s})}isSupported(e,t){return!!this.key.k&&(!!Object.keys(this.supportedAlgorithms).includes(e)&&!!this.supportedOperations.includes(t))}wrapKey(e,t,r){throw new LocalCryptographyUnsupportedError("Wrapping a key using a local JsonWebKey is not supported for AES.")}unwrapKey(e,t,r){throw new LocalCryptographyUnsupportedError("Unwrapping a key using a local JsonWebKey is not supported for AES.")}sign(e,t,r){throw new LocalCryptographyUnsupportedError("Signing using a local JsonWebKey is not supported for AES.")}signData(e,t,r){throw new LocalCryptographyUnsupportedError("Signing using a local JsonWebKey is not supported for AES.")}verify(e,t,r,a){throw new LocalCryptographyUnsupportedError("Verifying using a local JsonWebKey is not supported for AES.")}verifyData(e,t,r,a){throw new LocalCryptographyUnsupportedError("Verifying using a local JsonWebKey is not supported for AES.")}ensureValid(e){var t,r;if(this.key&&"OCT"!==(null===(t=this.key.kty)||void 0===t?void 0:t.toUpperCase())&&"OCT-HSM"!==(null===(r=this.key.kty)||void 0===r?void 0:r.toUpperCase()))throw new Error("Key type does not match the key type oct or oct-hsm");if(!this.key.k)throw new Error("Symmetric key is required");if(this.key.k.length<e)throw new Error(`Key must be at least ${e<<3} bits`)}}class CryptographyClient{constructor(e,t,r={}){"string"==typeof e?(this.key={kind:"identifier",value:e},this.remoteProvider=new RemoteCryptographyProvider(e,t,r)):"name"in e?(this.key={kind:"KeyVaultKey",value:e},this.remoteProvider=new RemoteCryptographyProvider(e,t,r)):this.key={kind:"JsonWebKey",value:e}}get vaultUrl(){var e;return(null===(e=this.remoteProvider)||void 0===e?void 0:e.vaultUrl)||""}get keyID(){return"identifier"===this.key.kind||"remoteOnlyIdentifier"===this.key.kind?this.key.value:"KeyVaultKey"===this.key.kind?this.key.value.id:this.key.value.kid}encrypt(...e){const[t,r]=this.disambiguateEncryptArguments(e);return tracingClient.withSpan("CryptographyClient.encrypt",r,(async e=>{this.ensureValid(await this.fetchKey(e),exports.KnownKeyOperations.Encrypt),this.initializeIV(t);const r=await this.getProvider("encrypt",t.algorithm,e);try{return r.encrypt(t,e)}catch(r){if(this.remoteProvider)return this.remoteProvider.encrypt(t,e);throw r}}))}initializeIV(e){if(e.algorithm in["A128CBC","A128CBCPAD","A192CBC","A192CBCPAD","A256CBC","A256CBCPAD"])try{const t=e;t.iv||(t.iv=randomBytes(16))}catch(t){throw new Error(`Unable to initialize IV for algorithm ${e.algorithm}. You may pass a valid IV to avoid this error. Error: ${t.message}`)}}disambiguateEncryptArguments(e){return"string"==typeof e[0]?[{algorithm:e[0],plaintext:e[1]},e[2]||{}]:[e[0],e[1]||{}]}decrypt(...e){const[t,r]=this.disambiguateDecryptArguments(e);return tracingClient.withSpan("CryptographyClient.decrypt",r,(async e=>{this.ensureValid(await this.fetchKey(e),exports.KnownKeyOperations.Decrypt);const r=await this.getProvider("decrypt",t.algorithm,e);try{return r.decrypt(t,e)}catch(r){if(this.remoteProvider)return this.remoteProvider.decrypt(t,e);throw r}}))}disambiguateDecryptArguments(e){return"string"==typeof e[0]?[{algorithm:e[0],ciphertext:e[1]},e[2]||{}]:[e[0],e[1]||{}]}wrapKey(e,t,r={}){return tracingClient.withSpan("CryptographyClient.wrapKey",r,(async a=>{this.ensureValid(await this.fetchKey(a),exports.KnownKeyOperations.WrapKey);const i=await this.getProvider("wrapKey",e,a);try{return i.wrapKey(e,t,a)}catch(a){if(this.remoteProvider)return this.remoteProvider.wrapKey(e,t,r);throw a}}))}unwrapKey(e,t,r={}){return tracingClient.withSpan("CryptographyClient.unwrapKey",r,(async a=>{this.ensureValid(await this.fetchKey(a),exports.KnownKeyOperations.UnwrapKey);const i=await this.getProvider("unwrapKey",e,a);try{return i.unwrapKey(e,t,a)}catch(a){if(this.remoteProvider)return this.remoteProvider.unwrapKey(e,t,r);throw a}}))}sign(e,t,r={}){return tracingClient.withSpan("CryptographyClient.sign",r,(async r=>{this.ensureValid(await this.fetchKey(r),exports.KnownKeyOperations.Sign);const a=await this.getProvider("sign",e,r);try{return a.sign(e,t,r)}catch(a){if(this.remoteProvider)return this.remoteProvider.sign(e,t,r);throw a}}))}verify(e,t,r,a={}){return tracingClient.withSpan("CryptographyClient.verify",a,(async a=>{this.ensureValid(await this.fetchKey(a),exports.KnownKeyOperations.Verify);const i=await this.getProvider("verify",e,a);try{return i.verify(e,t,r,a)}catch(i){if(this.remoteProvider)return this.remoteProvider.verify(e,t,r,a);throw i}}))}signData(e,t,r={}){return tracingClient.withSpan("CryptographyClient.signData",r,(async a=>{this.ensureValid(await this.fetchKey(a),exports.KnownKeyOperations.Sign);const i=await this.getProvider("signData",e,a);try{return i.signData(e,t,a)}catch(a){if(this.remoteProvider)return this.remoteProvider.signData(e,t,r);throw a}}))}verifyData(e,t,r,a={}){return tracingClient.withSpan("CryptographyClient.verifyData",a,(async a=>{this.ensureValid(await this.fetchKey(a),exports.KnownKeyOperations.Verify);const i=await this.getProvider("verifyData",e,a);try{return i.verifyData(e,t,r,a)}catch(i){if(this.remoteProvider)return this.remoteProvider.verifyData(e,t,r,a);throw i}}))}async getKeyMaterial(e){const t=await this.fetchKey(e);switch(t.kind){case"JsonWebKey":return t.value;case"KeyVaultKey":return t.value.key;default:return}}async fetchKey(e){if("identifier"===this.key.kind){let t;try{t=await this.remoteProvider.getKey(e)}catch(e){if(!coreRestPipeline.isRestError(e)||403!==e.statusCode)throw e;logger.verbose(`Permission denied to get key ${this.key.value}. Falling back to remote operation.`),this.key={kind:"remoteOnlyIdentifier",value:this.key.value}}t&&(this.key={kind:"KeyVaultKey",value:t})}return this.key}async getProvider(e,t,r){if(!this.providers){const e=await this.getKeyMaterial(r);this.providers=[],e&&this.providers.push(new RsaCryptographyProvider(e),new AesCryptographyProvider(e)),this.remoteProvider&&this.providers.push(this.remoteProvider)}const a=this.providers.filter((r=>r.isSupported(t,e)));if(0===a.length)throw new Error(`Unable to support operation: "${e}" with algorithm: "${t}" ${"JsonWebKey"===this.key.kind?"using a local JsonWebKey":""}`);return a[0]}ensureValid(e,t){var r;if("KeyVaultKey"===e.kind){const r=e.value.keyOperations,{notBefore:a,expiresOn:i}=e.value.properties,s=new Date;if(a&&s<a)throw new Error(`Key ${e.value.id} can't be used before ${a.toISOString()}`);if(i&&s>i)throw new Error(`Key ${e.value.id} expired at ${i.toISOString()}`);if(t&&r&&!(null==r?void 0:r.includes(t)))throw new Error(`Operation ${t} is not supported on key ${e.value.id}`)}else if("JsonWebKey"===e.kind&&t&&e.value.keyOps&&!(null===(r=e.value.keyOps)||void 0===r?void 0:r.includes(t)))throw new Error(`Operation ${t} is not supported on key ${e.value.kid}`)}}exports.KnownEncryptionAlgorithms=void 0,function(e){e.RSAOaep="RSA-OAEP",e.RSAOaep256="RSA-OAEP-256",e.RSA15="RSA1_5",e.A128GCM="A128GCM",e.A192GCM="A192GCM",e.A256GCM="A256GCM",e.A128KW="A128KW",e.A192KW="A192KW",e.A256KW="A256KW",e.A128CBC="A128CBC",e.A192CBC="A192CBC",e.A256CBC="A256CBC",e.A128Cbcpad="A128CBCPAD",e.A192Cbcpad="A192CBCPAD",e.A256Cbcpad="A256CBCPAD"}(exports.KnownEncryptionAlgorithms||(exports.KnownEncryptionAlgorithms={}));class KeyClient{constructor(e,t,r={}){this.vaultUrl=e;const a="azsdk-js-keyvault-keys/4.8.0",i=r.userAgentOptions;r.userAgentOptions={userAgentPrefix:i&&i.userAgentPrefix?`${i.userAgentPrefix} ${a}`:a};const s=coreRestPipeline.bearerTokenAuthenticationPolicy({credential:t,scopes:[],challengeCallbacks:createKeyVaultChallengeCallbacks(r)}),n=Object.assign(Object.assign({},r),{loggingOptions:{logger:logger.info,allowedHeaderNames:["x-ms-keyvault-region","x-ms-keyvault-network-info","x-ms-keyvault-service-version"]}});this.credential=t,this.client=new KeyVaultClient(r.serviceVersion||"7.5",n),this.client.pipeline.addPolicy(s)}createKey(e,t,r){let a={};if(r){const{enabled:e,notBefore:t,expiresOn:i,exportable:s}=r,n=tslib.__rest(r,["enabled","notBefore","expiresOn","exportable"]);a=Object.assign(Object.assign({},n),{keyAttributes:{enabled:e,notBefore:t,expires:i,exportable:s}})}return tracingClient.withSpan("KeyClient.createKey",a,(async r=>getKeyFromKeyBundle(await this.client.createKey(this.vaultUrl,e,t,r))))}async createEcKey(e,t){const r=(null==t?void 0:t.hsm)?exports.KnownKeyTypes.ECHSM:exports.KnownKeyTypes.EC;return this.createKey(e,r,t)}async createRsaKey(e,t){const r=(null==t?void 0:t.hsm)?exports.KnownKeyTypes.RSAHSM:exports.KnownKeyTypes.RSA;return this.createKey(e,r,t)}async createOctKey(e,t){const r=(null==t?void 0:t.hsm)?exports.KnownKeyTypes.OctHSM:exports.KnownKeyTypes.Oct;return this.createKey(e,r,t)}importKey(e,t,r){let a={};if(r){const{enabled:e,notBefore:t,exportable:i,expiresOn:s,hardwareProtected:n}=r,o=tslib.__rest(r,["enabled","notBefore","exportable","expiresOn","hardwareProtected"]);a=Object.assign(Object.assign({},o),{keyAttributes:{enabled:e,notBefore:t,expires:s,hsm:n,exportable:i}})}return tracingClient.withSpan("KeyClient.importKey",a,(async r=>getKeyFromKeyBundle(await this.client.importKey(this.vaultUrl,e,t,r))))}getCryptographyClient(e,t){const r=new URL(["keys",e,null==t?void 0:t.keyVersion].filter(Boolean).join("/"),this.vaultUrl),a={generatedClient:this.client};return new CryptographyClient(r.toString(),this.credential,a)}async beginDeleteKey(e,t={}){const r=new DeleteKeyPoller({name:e,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:t.intervalInMs,resumeFrom:t.resumeFrom,operationOptions:t});return await r.poll(),r}updateKeyProperties(...e){const[t,r,a]=this.disambiguateUpdateKeyPropertiesArgs(e);return tracingClient.withSpan("KeyClient.updateKeyProperties",a,(async e=>{const{enabled:a,notBefore:i,expiresOn:s}=e,n=tslib.__rest(e,["enabled","notBefore","expiresOn"]),o=Object.assign(Object.assign({},n),{keyAttributes:{enabled:a,notBefore:i,expires:s}});return getKeyFromKeyBundle(await this.client.updateKey(this.vaultUrl,t,r,o))}))}disambiguateUpdateKeyPropertiesArgs(e){return"string"==typeof e[1]?[e[0],e[1],e[2]||{}]:[e[0],"",e[1]||{}]}getKey(e,t={}){return tracingClient.withSpan("KeyClient.getKey",t,(async r=>getKeyFromKeyBundle(await this.client.getKey(this.vaultUrl,e,t&&t.version?t.version:"",r))))}getDeletedKey(e,t={}){return tracingClient.withSpan("KeyClient.getDeletedKey",t,(async t=>getKeyFromKeyBundle(await this.client.getDeletedKey(this.vaultUrl,e,t))))}purgeDeletedKey(e,t={}){return tracingClient.withSpan("KeyClient.purgeDeletedKey",t,(async t=>{await this.client.purgeDeletedKey(this.vaultUrl,e,t)}))}async beginRecoverDeletedKey(e,t={}){const r=new RecoverDeletedKeyPoller({name:e,vaultUrl:this.vaultUrl,client:this.client,intervalInMs:t.intervalInMs,resumeFrom:t.resumeFrom,operationOptions:t});return await r.poll(),r}backupKey(e,t={}){return tracingClient.withSpan("KeyClient.backupKey",t,(async t=>(await this.client.backupKey(this.vaultUrl,e,t)).value))}async restoreKeyBackup(e,t={}){return tracingClient.withSpan("KeyClient.restoreKeyBackup",t,(async t=>getKeyFromKeyBundle(await this.client.restoreKey(this.vaultUrl,e,t))))}getRandomBytes(e,t={}){return tracingClient.withSpan("KeyClient.getRandomBytes",t,(async t=>(await this.client.getRandomBytes(this.vaultUrl,e,t)).value))}rotateKey(e,t={}){return tracingClient.withSpan("KeyClient.rotateKey",t,(async t=>getKeyFromKeyBundle(await this.client.rotateKey(this.vaultUrl,e,t))))}releaseKey(e,t,r={}){return tracingClient.withSpan("KeyClient.releaseKey",r,(async a=>{const{nonce:i,algorithm:s}=a,n=tslib.__rest(a,["nonce","algorithm"]);return{value:(await this.client.release(this.vaultUrl,e,(null==r?void 0:r.version)||"",t,Object.assign({enc:s,nonce:i},n))).value}}))}getKeyRotationPolicy(e,t={}){return tracingClient.withSpan("KeyClient.getKeyRotationPolicy",t,(async()=>{const t=await this.client.getKeyRotationPolicy(this.vaultUrl,e);return keyRotationTransformations.generatedToPublic(t)}))}updateKeyRotationPolicy(e,t,r={}){return tracingClient.withSpan("KeyClient.updateKeyRotationPolicy",r,(async r=>{const a=await this.client.updateKeyRotationPolicy(this.vaultUrl,e,keyRotationTransformations.propertiesToGenerated(t),r);return keyRotationTransformations.generatedToPublic(a)}))}listPropertiesOfKeyVersionsPage(e,t,r){return tslib.__asyncGenerator(this,arguments,(function*(){if(null==t.continuationToken){const a=Object.assign({maxresults:t.maxPageSize},r),i=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",a,(async t=>this.client.getKeyVersions(this.vaultUrl,e,t))));t.continuationToken=i.nextLink,i.value&&(yield yield tslib.__await(i.value.map(getKeyPropertiesFromKeyItem,this)))}for(;t.continuationToken;){const a=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeyVersionsPage",r||{},(async r=>this.client.getKeyVersionsNext(this.vaultUrl,e,t.continuationToken,r))));if(t.continuationToken=a.nextLink,!a.value)break;yield yield tslib.__await(a.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeyVersionsAll(e,t){return tslib.__asyncGenerator(this,arguments,(function*(){var r,a,i,s;const n={};try{for(var o,l=!0,y=tslib.__asyncValues(this.listPropertiesOfKeyVersionsPage(e,n,t));!(r=(o=yield tslib.__await(y.next())).done);l=!0){s=o.value,l=!1;const e=s;for(const t of e)yield yield tslib.__await(t)}}catch(e){a={error:e}}finally{try{l||r||!(i=y.return)||(yield tslib.__await(i.call(y)))}finally{if(a)throw a.error}}}))}listPropertiesOfKeyVersions(e,t={}){const r=this.listPropertiesOfKeyVersionsAll(e,t);return{next:()=>r.next(),[Symbol.asyncIterator](){return this},byPage:(r={})=>this.listPropertiesOfKeyVersionsPage(e,r,t)}}listPropertiesOfKeysPage(e,t){return tslib.__asyncGenerator(this,arguments,(function*(){if(null==e.continuationToken){const r=Object.assign({maxresults:e.maxPageSize},t),a=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",r,(async e=>this.client.getKeys(this.vaultUrl,e))));e.continuationToken=a.nextLink,a.value&&(yield yield tslib.__await(a.value.map(getKeyPropertiesFromKeyItem,this)))}for(;e.continuationToken;){const r=yield tslib.__await(tracingClient.withSpan("KeyClient.listPropertiesOfKeysPage",t||{},(async t=>this.client.getKeysNext(this.vaultUrl,e.continuationToken,t))));if(e.continuationToken=r.nextLink,!r.value)break;yield yield tslib.__await(r.value.map(getKeyPropertiesFromKeyItem,this))}}))}listPropertiesOfKeysAll(e){return tslib.__asyncGenerator(this,arguments,(function*(){var t,r,a,i;const s={};try{for(var n,o=!0,l=tslib.__asyncValues(this.listPropertiesOfKeysPage(s,e));!(t=(n=yield tslib.__await(l.next())).done);o=!0){i=n.value,o=!1;const e=i;for(const t of e)yield yield tslib.__await(t)}}catch(e){r={error:e}}finally{try{o||t||!(a=l.return)||(yield tslib.__await(a.call(l)))}finally{if(r)throw r.error}}}))}listPropertiesOfKeys(e={}){const t=this.listPropertiesOfKeysAll(e);return{next:()=>t.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.listPropertiesOfKeysPage(t,e)}}listDeletedKeysPage(e,t){return tslib.__asyncGenerator(this,arguments,(function*(){if(null==e.continuationToken){const r=Object.assign({maxresults:e.maxPageSize},t),a=yield tslib.__await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",r,(async e=>this.client.getDeletedKeys(this.vaultUrl,e))));e.continuationToken=a.nextLink,a.value&&(yield yield tslib.__await(a.value.map(getDeletedKeyFromDeletedKeyItem,this)))}for(;e.continuationToken;){const r=yield tslib.__await(tracingClient.withSpan("KeyClient.listDeletedKeysPage",t||{},(async t=>this.client.getDeletedKeysNext(this.vaultUrl,e.continuationToken,t))));if(e.continuationToken=r.nextLink,!r.value)break;yield yield tslib.__await(r.value.map(getDeletedKeyFromDeletedKeyItem,this))}}))}listDeletedKeysAll(e){return tslib.__asyncGenerator(this,arguments,(function*(){var t,r,a,i;const s={};try{for(var n,o=!0,l=tslib.__asyncValues(this.listDeletedKeysPage(s,e));!(t=(n=yield tslib.__await(l.next())).done);o=!0){i=n.value,o=!1;const e=i;for(const t of e)yield yield tslib.__await(t)}}catch(e){r={error:e}}finally{try{o||t||!(a=l.return)||(yield tslib.__await(a.call(l)))}finally{if(r)throw r.error}}}))}listDeletedKeys(e={}){const t=this.listDeletedKeysAll(e);return{next:()=>t.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.listDeletedKeysPage(t,e)}}}exports.CryptographyClient=CryptographyClient,exports.KeyClient=KeyClient,exports.logger=logger,exports.parseKeyVaultKeyIdentifier=parseKeyVaultKeyIdentifier;