import{BaseRequestPolicy,deserializationPolicy,generateUuid,HttpHeaders,WebResource,isTokenCredential,bearerTokenAuthenticationPolicy,isNode}from"@azure/core-http";import{SpanStatusCode}from"@azure/core-tracing";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{BlobClient}from"./Clients";import{Mutex}from"./utils/Mutex";import{Pipeline}from"./Pipeline";import{attachCredential,getURLPath,getURLPathAndQuery,iEqual}from"./utils/utils.common";import{HeaderConstants,BATCH_MAX_REQUEST,HTTP_VERSION_1_1,HTTP_LINE_ENDING,StorageOAuthScopes}from"./utils/constants";import{StorageSharedKeyCredential}from"./credentials/StorageSharedKeyCredential";import{createSpan}from"./utils/tracing";export class BlobBatch{constructor(){this.batch="batch",this.batchRequest=new InnerBatchRequest}getMultiPartContentType(){return this.batchRequest.getMultipartContentType()}getHttpRequestBody(){return this.batchRequest.getHttpRequestBody()}getSubRequests(){return this.batchRequest.getSubRequests()}async addSubRequestInternal(e,t){await Mutex.lock(this.batch);try{this.batchRequest.preAddSubRequest(e),await t(),this.batchRequest.postAddSubRequest(e)}finally{await Mutex.unlock(this.batch)}}setBatchType(e){if(this.batchType||(this.batchType=e),this.batchType!==e)throw new RangeError(`BlobBatch only supports one operation type per batch and it already is being used for ${this.batchType} operations.`)}async deleteBlob(e,t,s){let a,n;if("string"==typeof e&&(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t)))a=e,n=t;else{if(!(e instanceof BlobClient))throw new RangeError("Invalid arguments. Either url and credential, or BlobClient need be provided.");a=e.url,n=e.credential,s=t}s||(s={});const{span:r,updatedOptions:i}=createSpan("BatchDeleteRequest-addSubRequest",s);try{this.setBatchType("delete"),await this.addSubRequestInternal({url:a,credential:n},(async()=>{await new BlobClient(a,this.batchRequest.createPipeline(n)).delete(i)}))}catch(e){throw r.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async setBlobAccessTier(e,t,s,a){let n,r,i;if("string"==typeof e&&(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t)))n=e,r=t,i=s;else{if(!(e instanceof BlobClient))throw new RangeError("Invalid arguments. Either url and credential, or BlobClient need be provided.");n=e.url,r=e.credential,i=t,a=s}a||(a={});const{span:o,updatedOptions:u}=createSpan("BatchSetTierRequest-addSubRequest",a);try{this.setBatchType("setAccessTier"),await this.addSubRequestInternal({url:n,credential:r},(async()=>{await new BlobClient(n,this.batchRequest.createPipeline(r)).setAccessTier(i,u)}))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}}class InnerBatchRequest{constructor(){this.operationCount=0,this.body="";const e=generateUuid();this.boundary=`batch_${e}`,this.subRequestPrefix=`--${this.boundary}${HTTP_LINE_ENDING}${HeaderConstants.CONTENT_TYPE}: application/http${HTTP_LINE_ENDING}${HeaderConstants.CONTENT_TRANSFER_ENCODING}: binary`,this.multipartContentType=`multipart/mixed; boundary=${this.boundary}`,this.batchRequestEnding=`--${this.boundary}--`,this.subRequests=new Map}createPipeline(e){const t=e instanceof AnonymousCredential,s=3+(t?0:1),a=new Array(s);return a[0]=deserializationPolicy(),a[1]=new BatchHeaderFilterPolicyFactory,t||(a[2]=isTokenCredential(e)?attachCredential(bearerTokenAuthenticationPolicy(e,StorageOAuthScopes),e):e),a[s-1]=new BatchRequestAssemblePolicyFactory(this),new Pipeline(a,{})}appendSubRequestToBody(e){this.body+=[this.subRequestPrefix,`${HeaderConstants.CONTENT_ID}: ${this.operationCount}`,"",`${e.method.toString()} ${getURLPathAndQuery(e.url)} ${HTTP_VERSION_1_1}${HTTP_LINE_ENDING}`].join(HTTP_LINE_ENDING);for(const t of e.headers.headersArray())this.body+=`${t.name}: ${t.value}${HTTP_LINE_ENDING}`;this.body+=HTTP_LINE_ENDING}preAddSubRequest(e){if(this.operationCount>=BATCH_MAX_REQUEST)throw new RangeError(`Cannot exceed ${BATCH_MAX_REQUEST} sub requests in a single batch`);const t=getURLPath(e.url);if(!t||""===t)throw new RangeError(`Invalid url for sub request: '${e.url}'`)}postAddSubRequest(e){this.subRequests.set(this.operationCount,e),this.operationCount++}getHttpRequestBody(){return`${this.body}${this.batchRequestEnding}${HTTP_LINE_ENDING}`}getMultipartContentType(){return this.multipartContentType}getSubRequests(){return this.subRequests}}class BatchRequestAssemblePolicy extends BaseRequestPolicy{constructor(e,t,s){super(t,s),this.dummyResponse={request:new WebResource,status:200,headers:new HttpHeaders},this.batchRequest=e}async sendRequest(e){return await this.batchRequest.appendSubRequestToBody(e),this.dummyResponse}}class BatchRequestAssemblePolicyFactory{constructor(e){this.batchRequest=e}create(e,t){return new BatchRequestAssemblePolicy(this.batchRequest,e,t)}}class BatchHeaderFilterPolicy extends BaseRequestPolicy{constructor(e,t){super(e,t)}async sendRequest(e){let t="";for(const s of e.headers.headersArray())iEqual(s.name,HeaderConstants.X_MS_VERSION)&&(t=s.name);return""!==t&&e.headers.remove(t),this._nextPolicy.sendRequest(e)}}class BatchHeaderFilterPolicyFactory{create(e,t){return new BatchHeaderFilterPolicy(e,t)}}