import{generateUuid}from"@azure/core-http";import{StorageClientContext}from"./generated/src/index";import{SpanStatusCode}from"@azure/core-tracing";import{Blob as StorageBlob,Container}from"./generated/src/operations";import{ETagNone}from"./utils/constants";import{convertTracingToRequestOptionsBase,createSpan}from"./utils/tracing";export class BlobLeaseClient{constructor(e,n){const i=new StorageClientContext(e.url,e.pipeline.toServiceClientOptions());this._url=e.url,void 0===e.name?(this._isContainer=!0,this._containerOrBlobOperation=new Container(i)):(this._isContainer=!1,this._containerOrBlobOperation=new StorageBlob(i)),n||(n=generateUuid()),this._leaseId=n}get leaseId(){return this._leaseId}get url(){return this._url}async acquireLease(e,n={}){var i,o,t,a,s,r;const{span:d,updatedOptions:c}=createSpan("BlobLeaseClient-acquireLease",n);if(this._isContainer&&((null===(i=n.conditions)||void 0===i?void 0:i.ifMatch)&&(null===(o=n.conditions)||void 0===o?void 0:o.ifMatch)!==ETagNone||(null===(t=n.conditions)||void 0===t?void 0:t.ifNoneMatch)&&(null===(a=n.conditions)||void 0===a?void 0:a.ifNoneMatch)!==ETagNone||(null===(s=n.conditions)||void 0===s?void 0:s.tagConditions)))throw new RangeError("The IfMatch, IfNoneMatch and tags access conditions are ignored by the service. Values other than undefined or their default values are not acceptable.");try{return await this._containerOrBlobOperation.acquireLease(Object.assign({abortSignal:n.abortSignal,duration:e,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(r=n.conditions)||void 0===r?void 0:r.tagConditions}),proposedLeaseId:this._leaseId},convertTracingToRequestOptionsBase(c)))}catch(e){throw d.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{d.end()}}async changeLease(e,n={}){var i,o,t,a,s,r;const{span:d,updatedOptions:c}=createSpan("BlobLeaseClient-changeLease",n);if(this._isContainer&&((null===(i=n.conditions)||void 0===i?void 0:i.ifMatch)&&(null===(o=n.conditions)||void 0===o?void 0:o.ifMatch)!==ETagNone||(null===(t=n.conditions)||void 0===t?void 0:t.ifNoneMatch)&&(null===(a=n.conditions)||void 0===a?void 0:a.ifNoneMatch)!==ETagNone||(null===(s=n.conditions)||void 0===s?void 0:s.tagConditions)))throw new RangeError("The IfMatch, IfNoneMatch and tags access conditions are ignored by the service. Values other than undefined or their default values are not acceptable.");try{const i=await this._containerOrBlobOperation.changeLease(this._leaseId,e,Object.assign({abortSignal:n.abortSignal,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(r=n.conditions)||void 0===r?void 0:r.tagConditions})},convertTracingToRequestOptionsBase(c)));return this._leaseId=e,i}catch(e){throw d.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{d.end()}}async releaseLease(e={}){var n,i,o,t,a,s;const{span:r,updatedOptions:d}=createSpan("BlobLeaseClient-releaseLease",e);if(this._isContainer&&((null===(n=e.conditions)||void 0===n?void 0:n.ifMatch)&&(null===(i=e.conditions)||void 0===i?void 0:i.ifMatch)!==ETagNone||(null===(o=e.conditions)||void 0===o?void 0:o.ifNoneMatch)&&(null===(t=e.conditions)||void 0===t?void 0:t.ifNoneMatch)!==ETagNone||(null===(a=e.conditions)||void 0===a?void 0:a.tagConditions)))throw new RangeError("The IfMatch, IfNoneMatch and tags access conditions are ignored by the service. Values other than undefined or their default values are not acceptable.");try{return await this._containerOrBlobOperation.releaseLease(this._leaseId,Object.assign({abortSignal:e.abortSignal,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(s=e.conditions)||void 0===s?void 0:s.tagConditions})},convertTracingToRequestOptionsBase(d)))}catch(e){throw r.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async renewLease(e={}){var n,i,o,t,a,s;const{span:r,updatedOptions:d}=createSpan("BlobLeaseClient-renewLease",e);if(this._isContainer&&((null===(n=e.conditions)||void 0===n?void 0:n.ifMatch)&&(null===(i=e.conditions)||void 0===i?void 0:i.ifMatch)!==ETagNone||(null===(o=e.conditions)||void 0===o?void 0:o.ifNoneMatch)&&(null===(t=e.conditions)||void 0===t?void 0:t.ifNoneMatch)!==ETagNone||(null===(a=e.conditions)||void 0===a?void 0:a.tagConditions)))throw new RangeError("The IfMatch, IfNoneMatch and tags access conditions are ignored by the service. Values other than undefined or their default values are not acceptable.");try{return await this._containerOrBlobOperation.renewLease(this._leaseId,Object.assign({abortSignal:e.abortSignal,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(s=e.conditions)||void 0===s?void 0:s.tagConditions})},convertTracingToRequestOptionsBase(d)))}catch(e){throw r.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async breakLease(e,n={}){var i,o,t,a,s,r;const{span:d,updatedOptions:c}=createSpan("BlobLeaseClient-breakLease",n);if(this._isContainer&&((null===(i=n.conditions)||void 0===i?void 0:i.ifMatch)&&(null===(o=n.conditions)||void 0===o?void 0:o.ifMatch)!==ETagNone||(null===(t=n.conditions)||void 0===t?void 0:t.ifNoneMatch)&&(null===(a=n.conditions)||void 0===a?void 0:a.ifNoneMatch)!==ETagNone||(null===(s=n.conditions)||void 0===s?void 0:s.tagConditions)))throw new RangeError("The IfMatch, IfNoneMatch and tags access conditions are ignored by the service. Values other than undefined or their default values are not acceptable.");try{const i=Object.assign({abortSignal:n.abortSignal,breakPeriod:e,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(r=n.conditions)||void 0===r?void 0:r.tagConditions})},convertTracingToRequestOptionsBase(c));return await this._containerOrBlobOperation.breakLease(i)}catch(e){throw d.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{d.end()}}}