import{__asyncDelegator,__asyncGenerator,__asyncValues,__await}from"tslib";import{isTokenCredential,isNode,getDefaultProxySettings}from"@azure/core-http";import{SpanStatusCode}from"@azure/core-tracing";import{Container,Service}from"./generated/src/operations";import{newPipeline,isPipelineLike}from"./Pipeline";import{ContainerClient}from"./ContainerClient";import{appendToURLPath,appendToURLQuery,extractConnectionStringParts,toTags}from"./utils/utils.common";import{StorageSharedKeyCredential}from"./credentials/StorageSharedKeyCredential";import{AnonymousCredential}from"./credentials/AnonymousCredential";import"@azure/core-paging";import{truncatedISO8061Date}from"./utils/utils.common";import{convertTracingToRequestOptionsBase,createSpan}from"./utils/tracing";import{BlobBatchClient}from"./BlobBatchClient";import{StorageClient}from"./StorageClient";import{AccountSASPermissions}from"./sas/AccountSASPermissions";import{generateAccountSASQueryParameters}from"./sas/AccountSASSignatureValues";import{AccountSASServices}from"./sas/AccountSASServices";export class BlobServiceClient extends StorageClient{constructor(e,t,n){let a;a=isPipelineLike(t)?t:isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t)?newPipeline(t,n):newPipeline(new AnonymousCredential,n),super(e,a),this.serviceContext=new Service(this.storageClientContext)}static fromConnectionString(e,t){t=t||{};const n=extractConnectionStringParts(e);if("AccountConnString"===n.kind){if(isNode){const e=new StorageSharedKeyCredential(n.accountName,n.accountKey);t.proxyOptions||(t.proxyOptions=getDefaultProxySettings(n.proxyUri));const a=newPipeline(e,t);return new BlobServiceClient(n.url,a)}throw new Error("Account connection string is only supported in Node.js environment")}if("SASConnString"===n.kind){const e=newPipeline(new AnonymousCredential,t);return new BlobServiceClient(n.url+"?"+n.accountSas,e)}throw new Error("Connection string must be either an Account connection string or a SAS connection string")}getContainerClient(e){return new ContainerClient(appendToURLPath(this.url,encodeURIComponent(e)),this.pipeline)}async createContainer(e,t={}){const{span:n,updatedOptions:a}=createSpan("BlobServiceClient-createContainer",t);try{const t=this.getContainerClient(e),n=await t.create(a);return{containerClient:t,containerCreateResponse:n}}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async deleteContainer(e,t={}){const{span:n,updatedOptions:a}=createSpan("BlobServiceClient-deleteContainer",t);try{const t=this.getContainerClient(e);return await t.delete(a)}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async undeleteContainer(e,t,n={}){const{span:a,updatedOptions:i}=createSpan("BlobServiceClient-undeleteContainer",n);try{const a=this.getContainerClient(n.destinationContainerName||e),s=new Container(a.storageClientContext);return{containerClient:a,containerUndeleteResponse:await s.restore(Object.assign({deletedContainerName:e,deletedContainerVersion:t},i))}}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}async renameContainer(e,t,n={}){var a;const{span:i,updatedOptions:s}=createSpan("BlobServiceClient-renameContainer",n);try{const i=this.getContainerClient(t),r=new Container(i.storageClientContext);return{containerClient:i,containerRenameResponse:await r.rename(e,Object.assign(Object.assign({},s),{sourceLeaseId:null===(a=n.sourceCondition)||void 0===a?void 0:a.leaseId}))}}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async getProperties(e={}){const{span:t,updatedOptions:n}=createSpan("BlobServiceClient-getProperties",e);try{return await this.serviceContext.getProperties(Object.assign({abortSignal:e.abortSignal},convertTracingToRequestOptionsBase(n)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setProperties(e,t={}){const{span:n,updatedOptions:a}=createSpan("BlobServiceClient-setProperties",t);try{return await this.serviceContext.setProperties(e,Object.assign({abortSignal:t.abortSignal},convertTracingToRequestOptionsBase(a)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async getStatistics(e={}){const{span:t,updatedOptions:n}=createSpan("BlobServiceClient-getStatistics",e);try{return await this.serviceContext.getStatistics(Object.assign({abortSignal:e.abortSignal},convertTracingToRequestOptionsBase(n)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async getAccountInfo(e={}){const{span:t,updatedOptions:n}=createSpan("BlobServiceClient-getAccountInfo",e);try{return await this.serviceContext.getAccountInfo(Object.assign({abortSignal:e.abortSignal},convertTracingToRequestOptionsBase(n)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async listContainersSegment(e,t={}){const{span:n,updatedOptions:a}=createSpan("BlobServiceClient-listContainersSegment",t);try{return await this.serviceContext.listContainersSegment(Object.assign(Object.assign(Object.assign({abortSignal:t.abortSignal,marker:e},t),{include:"string"==typeof t.include?[t.include]:t.include}),convertTracingToRequestOptionsBase(a)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async findBlobsByTagsSegment(e,t,n={}){const{span:a,updatedOptions:i}=createSpan("BlobServiceClient-findBlobsByTagsSegment",n);try{const a=await this.serviceContext.filterBlobs(Object.assign({abortSignal:n.abortSignal,where:e,marker:t,maxPageSize:n.maxPageSize},convertTracingToRequestOptionsBase(i)));return Object.assign(Object.assign({},a),{_response:a._response,blobs:a.blobs.map((e=>{var t;let n="";return 1===(null===(t=e.tags)||void 0===t?void 0:t.blobTagSet.length)&&(n=e.tags.blobTagSet[0].value),Object.assign(Object.assign({},e),{tags:toTags(e.tags),tagValue:n})}))})}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}findBlobsByTagsSegments(e,t,n={}){return __asyncGenerator(this,arguments,(function*(){let a;if(t||void 0===t)do{a=yield __await(this.findBlobsByTagsSegment(e,t,n)),a.blobs=a.blobs||[],t=a.continuationToken,yield yield __await(a)}while(t)}))}findBlobsByTagsItems(e,t={}){return __asyncGenerator(this,arguments,(function*(){var n,a;try{for(var i,s=__asyncValues(this.findBlobsByTagsSegments(e,undefined,t));!(i=yield __await(s.next())).done;){const e=i.value;yield __await(yield*__asyncDelegator(__asyncValues(e.blobs)))}}catch(e){n={error:e}}finally{try{i&&!i.done&&(a=s.return)&&(yield __await(a.call(s)))}finally{if(n)throw n.error}}}))}findBlobsByTags(e,t={}){const n=Object.assign({},t),a=this.findBlobsByTagsItems(e,n);return{next:()=>a.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.findBlobsByTagsSegments(e,t.continuationToken,Object.assign({maxPageSize:t.maxPageSize},n))}}listSegments(e,t={}){return __asyncGenerator(this,arguments,(function*(){let n;if(e||void 0===e)do{n=yield __await(this.listContainersSegment(e,t)),n.containerItems=n.containerItems||[],e=n.continuationToken,yield yield __await(yield __await(n))}while(e)}))}listItems(e={}){return __asyncGenerator(this,arguments,(function*(){var t,n;try{for(var a,i=__asyncValues(this.listSegments(undefined,e));!(a=yield __await(i.next())).done;){const e=a.value;yield __await(yield*__asyncDelegator(__asyncValues(e.containerItems)))}}catch(e){t={error:e}}finally{try{a&&!a.done&&(n=i.return)&&(yield __await(n.call(i)))}finally{if(t)throw t.error}}}))}listContainers(e={}){""===e.prefix&&(e.prefix=void 0);const t=[];e.includeDeleted&&t.push("deleted"),e.includeMetadata&&t.push("metadata"),e.includeSystem&&t.push("system");const n=Object.assign(Object.assign({},e),t.length>0?{include:t}:{}),a=this.listItems(n);return{next:()=>a.next(),[Symbol.asyncIterator](){return this},byPage:(e={})=>this.listSegments(e.continuationToken,Object.assign({maxPageSize:e.maxPageSize},n))}}async getUserDelegationKey(e,t,n={}){const{span:a,updatedOptions:i}=createSpan("BlobServiceClient-getUserDelegationKey",n);try{const a=await this.serviceContext.getUserDelegationKey({startsOn:truncatedISO8061Date(e,!1),expiresOn:truncatedISO8061Date(t,!1)},Object.assign({abortSignal:n.abortSignal},convertTracingToRequestOptionsBase(i))),s={signedObjectId:a.signedObjectId,signedTenantId:a.signedTenantId,signedStartsOn:new Date(a.signedStartsOn),signedExpiresOn:new Date(a.signedExpiresOn),signedService:a.signedService,signedVersion:a.signedVersion,value:a.value};return Object.assign({_response:a._response,requestId:a.requestId,clientRequestId:a.clientRequestId,version:a.version,date:a.date,errorCode:a.errorCode},s)}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}getBlobBatchClient(){return new BlobBatchClient(this.url,this.pipeline)}generateAccountSasUrl(e,t=AccountSASPermissions.parse("r"),n="sco",a={}){if(!(this.credential instanceof StorageSharedKeyCredential))throw RangeError("Can only generate the account SAS when the client is initialized with a shared key credential");if(void 0===e){const t=new Date;e=new Date(t.getTime()+36e5)}const i=generateAccountSASQueryParameters(Object.assign({permissions:t,expiresOn:e,resourceTypes:n,services:AccountSASServices.parse("b").toString()},a),this.credential).toString();return appendToURLQuery(this.url,i)}}