import{__asyncDelegator,__asyncGenerator,__asyncValues,__await}from"tslib";import{generateUuid,getDefaultProxySettings,isNode,isTokenCredential,URLBuilder}from"@azure/core-http";import{SpanStatusCode}from"@azure/core-tracing";import{BlobDownloadResponse}from"./BlobDownloadResponse";import{BlobQueryResponse}from"./BlobQueryResponse";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{StorageSharedKeyCredential}from"./credentials/StorageSharedKeyCredential";import{AppendBlob,Blob as StorageBlob,BlockBlob,PageBlob}from"./generated/src/operations";import{ensureCpkIfSpecified,toAccessTier}from"./models";import{rangeResponseFromModel}from"./PageBlobRangeResponse";import{newPipeline,isPipelineLike}from"./Pipeline";import{BlobBeginCopyFromUrlPoller}from"./pollers/BlobStartCopyFromUrlPoller";import{rangeToString}from"./Range";import{StorageClient}from"./StorageClient";import{Batch}from"./utils/Batch";import{BufferScheduler}from"../../storage-common/src";import{BlobDoesNotUseCustomerSpecifiedEncryption,BlobUsesCustomerSpecifiedEncryptionMsg,BLOCK_BLOB_MAX_BLOCKS,BLOCK_BLOB_MAX_STAGE_BLOCK_BYTES,BLOCK_BLOB_MAX_UPLOAD_BLOB_BYTES,DEFAULT_BLOB_DOWNLOAD_BLOCK_BYTES,DEFAULT_BLOCK_BUFFER_SIZE_BYTES,DEFAULT_MAX_DOWNLOAD_RETRY_REQUESTS,ETagAny,URLConstants}from"./utils/constants";import{createSpan,convertTracingToRequestOptionsBase}from"./utils/tracing";import{appendToURLPath,appendToURLQuery,extractConnectionStringParts,ExtractPageRangeInfoItems,generateBlockID,getURLParameter,httpAuthorizationToString,isIpEndpointStyle,parseObjectReplicationRecord,setURLParameter,toBlobTags,toBlobTagsString,toQuerySerialization,toTags}from"./utils/utils.common";import{fsCreateReadStream,fsStat,readStreamToLocalFile,streamToBuffer}from"./utils/utils.node";import{generateBlobSASQueryParameters}from"./sas/BlobSASSignatureValues";import{BlobLeaseClient}from"./BlobLeaseClient";export class BlobClient extends StorageClient{constructor(e,t,o,n){let i,s;if(n=n||{},isPipelineLike(t))s=e,i=t;else if(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t))s=e,i=newPipeline(t,n=o);else if(t||"string"==typeof t){if(!t||"string"!=typeof t||!o||"string"!=typeof o)throw new Error("Expecting non-empty strings for containerName and blobName parameters");{const a=t,r=o,c=extractConnectionStringParts(e);if("AccountConnString"===c.kind){if(!isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=new StorageSharedKeyCredential(c.accountName,c.accountKey);s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r)),n.proxyOptions||(n.proxyOptions=getDefaultProxySettings(c.proxyUri)),i=newPipeline(e,n)}}else{if("SASConnString"!==c.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r))+"?"+c.accountSas,i=newPipeline(new AnonymousCredential,n)}}}else s=e,i=newPipeline(new AnonymousCredential,n);super(s,i),({blobName:this._name,containerName:this._containerName}=this.getBlobAndContainerNamesFromUrl()),this.blobContext=new StorageBlob(this.storageClientContext),this._snapshot=getURLParameter(this.url,URLConstants.Parameters.SNAPSHOT),this._versionId=getURLParameter(this.url,URLConstants.Parameters.VERSIONID)}get name(){return this._name}get containerName(){return this._containerName}withSnapshot(e){return new BlobClient(setURLParameter(this.url,URLConstants.Parameters.SNAPSHOT,0===e.length?void 0:e),this.pipeline)}withVersion(e){return new BlobClient(setURLParameter(this.url,URLConstants.Parameters.VERSIONID,0===e.length?void 0:e),this.pipeline)}getAppendBlobClient(){return new AppendBlobClient(this.url,this.pipeline)}getBlockBlobClient(){return new BlockBlobClient(this.url,this.pipeline)}getPageBlobClient(){return new PageBlobClient(this.url,this.pipeline)}async download(e=0,t,o={}){var n;o.conditions=o.conditions||{},o.conditions=o.conditions||{},ensureCpkIfSpecified(o.customerProvidedKey,this.isHttps);const{span:i,updatedOptions:s}=createSpan("BlobClient-download",o);try{const i=await this.blobContext.download(Object.assign({abortSignal:o.abortSignal,leaseAccessConditions:o.conditions,modifiedAccessConditions:Object.assign(Object.assign({},o.conditions),{ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions}),requestOptions:{onDownloadProgress:isNode?void 0:o.onProgress},range:0!==e||t?rangeToString({offset:e,count:t}):void 0,rangeGetContentMD5:o.rangeGetContentMD5,rangeGetContentCRC64:o.rangeGetContentCrc64,snapshot:o.snapshot,cpkInfo:o.customerProvidedKey},convertTracingToRequestOptionsBase(s))),a=Object.assign(Object.assign({},i),{_response:i._response,objectReplicationDestinationPolicyId:i.objectReplicationPolicyId,objectReplicationSourceProperties:parseObjectReplicationRecord(i.objectReplicationRules)});if(!isNode)return a;if((void 0===o.maxRetryRequests||o.maxRetryRequests<0)&&(o.maxRetryRequests=DEFAULT_MAX_DOWNLOAD_RETRY_REQUESTS),void 0===i.contentLength)throw new RangeError("File download response doesn't contain valid content length header");if(!i.etag)throw new RangeError("File download response doesn't contain valid etag header");return new BlobDownloadResponse(a,(async t=>{var n;const s={leaseAccessConditions:o.conditions,modifiedAccessConditions:{ifMatch:o.conditions.ifMatch||i.etag,ifModifiedSince:o.conditions.ifModifiedSince,ifNoneMatch:o.conditions.ifNoneMatch,ifUnmodifiedSince:o.conditions.ifUnmodifiedSince,ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions},range:rangeToString({count:e+i.contentLength-t,offset:t}),rangeGetContentMD5:o.rangeGetContentMD5,rangeGetContentCRC64:o.rangeGetContentCrc64,snapshot:o.snapshot,cpkInfo:o.customerProvidedKey};return(await this.blobContext.download(Object.assign({abortSignal:o.abortSignal},s))).readableStreamBody}),e,i.contentLength,{maxRetryRequests:o.maxRetryRequests,onProgress:o.onProgress})}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async exists(e={}){const{span:t,updatedOptions:o}=createSpan("BlobClient-exists",e);try{return ensureCpkIfSpecified(e.customerProvidedKey,this.isHttps),await this.getProperties({abortSignal:e.abortSignal,customerProvidedKey:e.customerProvidedKey,conditions:e.conditions,tracingOptions:o.tracingOptions}),!0}catch(e){if(404===e.statusCode)return!1;if(409===e.statusCode&&(e.details.errorCode===BlobUsesCustomerSpecifiedEncryptionMsg||e.details.errorCode===BlobDoesNotUseCustomerSpecifiedEncryption))return!0;throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async getProperties(e={}){var t;const{span:o,updatedOptions:n}=createSpan("BlobClient-getProperties",e);try{e.conditions=e.conditions||{},ensureCpkIfSpecified(e.customerProvidedKey,this.isHttps);const o=await this.blobContext.getProperties(Object.assign({abortSignal:e.abortSignal,leaseAccessConditions:e.conditions,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(t=e.conditions)||void 0===t?void 0:t.tagConditions}),cpkInfo:e.customerProvidedKey},convertTracingToRequestOptionsBase(n)));return Object.assign(Object.assign({},o),{_response:o._response,objectReplicationDestinationPolicyId:o.objectReplicationPolicyId,objectReplicationSourceProperties:parseObjectReplicationRecord(o.objectReplicationRules)})}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async delete(e={}){var t;const{span:o,updatedOptions:n}=createSpan("BlobClient-delete",e);e.conditions=e.conditions||{};try{return await this.blobContext.delete(Object.assign({abortSignal:e.abortSignal,deleteSnapshots:e.deleteSnapshots,leaseAccessConditions:e.conditions,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(t=e.conditions)||void 0===t?void 0:t.tagConditions})},convertTracingToRequestOptionsBase(n)))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async deleteIfExists(e={}){var t,o;const{span:n,updatedOptions:i}=createSpan("BlobClient-deleteIfExists",e);try{const e=await this.delete(i);return Object.assign(Object.assign({succeeded:!0},e),{_response:e._response})}catch(e){if("BlobNotFound"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return n.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when deleting a blob or snapshot only if it exists."}),Object.assign(Object.assign({succeeded:!1},null===(o=e.response)||void 0===o?void 0:o.parsedHeaders),{_response:e.response});throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async undelete(e={}){const{span:t,updatedOptions:o}=createSpan("BlobClient-undelete",e);try{return await this.blobContext.undelete(Object.assign({abortSignal:e.abortSignal},convertTracingToRequestOptionsBase(o)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setHTTPHeaders(e,t={}){var o;const{span:n,updatedOptions:i}=createSpan("BlobClient-setHTTPHeaders",t);t.conditions=t.conditions||{};try{return ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps),await this.blobContext.setHttpHeaders(Object.assign({abortSignal:t.abortSignal,blobHttpHeaders:e,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions})},convertTracingToRequestOptionsBase(i)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async setMetadata(e,t={}){var o;const{span:n,updatedOptions:i}=createSpan("BlobClient-setMetadata",t);t.conditions=t.conditions||{};try{return ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps),await this.blobContext.setMetadata(Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,metadata:e,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),cpkInfo:t.customerProvidedKey,encryptionScope:t.encryptionScope},convertTracingToRequestOptionsBase(i)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async setTags(e,t={}){var o;const{span:n,updatedOptions:i}=createSpan("BlobClient-setTags",t);try{return await this.blobContext.setTags(Object.assign(Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions})},convertTracingToRequestOptionsBase(i)),{tags:toBlobTags(e)}))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async getTags(e={}){var t;const{span:o,updatedOptions:n}=createSpan("BlobClient-getTags",e);try{const o=await this.blobContext.getTags(Object.assign({abortSignal:e.abortSignal,leaseAccessConditions:e.conditions,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(t=e.conditions)||void 0===t?void 0:t.tagConditions})},convertTracingToRequestOptionsBase(n)));return Object.assign(Object.assign({},o),{_response:o._response,tags:toTags({blobTagSet:o.blobTagSet})||{}})}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}getBlobLeaseClient(e){return new BlobLeaseClient(this,e)}async createSnapshot(e={}){var t;const{span:o,updatedOptions:n}=createSpan("BlobClient-createSnapshot",e);e.conditions=e.conditions||{};try{return ensureCpkIfSpecified(e.customerProvidedKey,this.isHttps),await this.blobContext.createSnapshot(Object.assign({abortSignal:e.abortSignal,leaseAccessConditions:e.conditions,metadata:e.metadata,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(t=e.conditions)||void 0===t?void 0:t.tagConditions}),cpkInfo:e.customerProvidedKey,encryptionScope:e.encryptionScope},convertTracingToRequestOptionsBase(n)))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async beginCopyFromURL(e,t={}){const o=new BlobBeginCopyFromUrlPoller({blobClient:{abortCopyFromURL:(...e)=>this.abortCopyFromURL(...e),getProperties:(...e)=>this.getProperties(...e),startCopyFromURL:(...e)=>this.startCopyFromURL(...e)},copySource:e,intervalInMs:t.intervalInMs,onProgress:t.onProgress,resumeFrom:t.resumeFrom,startCopyFromURLOptions:t});return await o.poll(),o}async abortCopyFromURL(e,t={}){const{span:o,updatedOptions:n}=createSpan("BlobClient-abortCopyFromURL",t);try{return await this.blobContext.abortCopyFromURL(e,Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions},convertTracingToRequestOptionsBase(n)))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async syncCopyFromURL(e,t={}){var o,n,i;const{span:s,updatedOptions:a}=createSpan("BlobClient-syncCopyFromURL",t);t.conditions=t.conditions||{},t.sourceConditions=t.sourceConditions||{};try{return await this.blobContext.copyFromURL(e,Object.assign({abortSignal:t.abortSignal,metadata:t.metadata,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),sourceModifiedAccessConditions:{sourceIfMatch:t.sourceConditions.ifMatch,sourceIfModifiedSince:t.sourceConditions.ifModifiedSince,sourceIfNoneMatch:t.sourceConditions.ifNoneMatch,sourceIfUnmodifiedSince:t.sourceConditions.ifUnmodifiedSince},sourceContentMD5:t.sourceContentMD5,copySourceAuthorization:httpAuthorizationToString(t.sourceAuthorization),blobTagsString:toBlobTagsString(t.tags),immutabilityPolicyExpiry:null===(n=t.immutabilityPolicy)||void 0===n?void 0:n.expiriesOn,immutabilityPolicyMode:null===(i=t.immutabilityPolicy)||void 0===i?void 0:i.policyMode,legalHold:t.legalHold,encryptionScope:t.encryptionScope,copySourceTags:t.copySourceTags},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async setAccessTier(e,t={}){var o;const{span:n,updatedOptions:i}=createSpan("BlobClient-setAccessTier",t);try{return await this.blobContext.setTier(toAccessTier(e),Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),rehydratePriority:t.rehydratePriority},convertTracingToRequestOptionsBase(i)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async downloadToBuffer(e,t,o,n={}){let i,s=0,a=0,r=n;e instanceof Buffer?(i=e,s=t||0,a="number"==typeof o?o:0):(s="number"==typeof e?e:0,a="number"==typeof t?t:0,r=o||{});const{span:c,updatedOptions:d}=createSpan("BlobClient-downloadToBuffer",r);try{if(r.blockSize||(r.blockSize=0),r.blockSize<0)throw new RangeError("blockSize option must be >= 0");if(0===r.blockSize&&(r.blockSize=DEFAULT_BLOB_DOWNLOAD_BLOCK_BYTES),s<0)throw new RangeError("offset option must be >= 0");if(a&&a<=0)throw new RangeError("count option must be greater than 0");if(r.conditions||(r.conditions={}),!a){const e=await this.getProperties(Object.assign(Object.assign({},r),{tracingOptions:Object.assign(Object.assign({},r.tracingOptions),convertTracingToRequestOptionsBase(d))}));if(a=e.contentLength-s,a<0)throw new RangeError(`offset ${s} shouldn't be larger than blob size ${e.contentLength}`)}if(!i)try{i=Buffer.alloc(a)}catch(e){throw new Error(`Unable to allocate the buffer of size: ${a}(in bytes). Please try passing your own buffer to the "downloadToBuffer" method or try using other methods like "download" or "downloadToFile".\t ${e.message}`)}if(i.length<a)throw new RangeError(`The buffer's size should be equal to or larger than the request count of bytes: ${a}`);let e=0;const t=new Batch(r.concurrency);for(let o=s;o<s+a;o+=r.blockSize)t.addOperation((async()=>{let t=s+a;o+r.blockSize<t&&(t=o+r.blockSize);const n=(await this.download(o,t-o,{abortSignal:r.abortSignal,conditions:r.conditions,maxRetryRequests:r.maxRetryRequestsPerBlock,customerProvidedKey:r.customerProvidedKey,tracingOptions:Object.assign(Object.assign({},r.tracingOptions),convertTracingToRequestOptionsBase(d))})).readableStreamBody;await streamToBuffer(n,i,o-s,t-s),e+=t-o,r.onProgress&&r.onProgress({loadedBytes:e})}));return await t.do(),i}catch(e){throw c.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{c.end()}}async downloadToFile(e,t=0,o,n={}){const{span:i,updatedOptions:s}=createSpan("BlobClient-downloadToFile",n);try{const i=await this.download(t,o,Object.assign(Object.assign({},n),{tracingOptions:Object.assign(Object.assign({},n.tracingOptions),convertTracingToRequestOptionsBase(s))}));return i.readableStreamBody&&await readStreamToLocalFile(i.readableStreamBody,e),i.blobDownloadStream=void 0,i}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}getBlobAndContainerNamesFromUrl(){let e,t;try{const o=URLBuilder.parse(this.url);if("blob"===o.getHost().split(".")[1]){const n=o.getPath().match("/([^/]*)(/(.*))?");e=n[1],t=n[3]}else if(isIpEndpointStyle(o)){const n=o.getPath().match("/([^/]*)/([^/]*)(/(.*))?");e=n[2],t=n[4]}else{const n=o.getPath().match("/([^/]*)(/(.*))?");e=n[1],t=n[3]}if(e=decodeURIComponent(e),t=decodeURIComponent(t),t=t.replace(/\\/g,"/"),!e)throw new Error("Provided containerName is invalid.");return{blobName:t,containerName:e}}catch(e){throw new Error("Unable to extract blobName and containerName with provided information.")}}async startCopyFromURL(e,t={}){var o,n,i;const{span:s,updatedOptions:a}=createSpan("BlobClient-startCopyFromURL",t);t.conditions=t.conditions||{},t.sourceConditions=t.sourceConditions||{};try{return await this.blobContext.startCopyFromURL(e,Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,metadata:t.metadata,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),sourceModifiedAccessConditions:{sourceIfMatch:t.sourceConditions.ifMatch,sourceIfModifiedSince:t.sourceConditions.ifModifiedSince,sourceIfNoneMatch:t.sourceConditions.ifNoneMatch,sourceIfUnmodifiedSince:t.sourceConditions.ifUnmodifiedSince,sourceIfTags:t.sourceConditions.tagConditions},immutabilityPolicyExpiry:null===(n=t.immutabilityPolicy)||void 0===n?void 0:n.expiriesOn,immutabilityPolicyMode:null===(i=t.immutabilityPolicy)||void 0===i?void 0:i.policyMode,legalHold:t.legalHold,rehydratePriority:t.rehydratePriority,tier:toAccessTier(t.tier),blobTagsString:toBlobTagsString(t.tags),sealBlob:t.sealBlob},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}generateSasUrl(e){return new Promise((t=>{if(!(this.credential instanceof StorageSharedKeyCredential))throw new RangeError("Can only generate the SAS when the client is initialized with a shared key credential");const o=generateBlobSASQueryParameters(Object.assign({containerName:this._containerName,blobName:this._name,snapshotTime:this._snapshot,versionId:this._versionId},e),this.credential).toString();t(appendToURLQuery(this.url,o))}))}async deleteImmutabilityPolicy(e){const{span:t,updatedOptions:o}=createSpan("BlobClient-deleteImmutabilityPolicy",e);try{return await this.blobContext.deleteImmutabilityPolicy(Object.assign({abortSignal:null==e?void 0:e.abortSignal},convertTracingToRequestOptionsBase(o)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setImmutabilityPolicy(e,t){const{span:o,updatedOptions:n}=createSpan("BlobClient-setImmutabilityPolicy",t);try{return await this.blobContext.setImmutabilityPolicy(Object.assign({abortSignal:null==t?void 0:t.abortSignal,immutabilityPolicyExpiry:e.expiriesOn,immutabilityPolicyMode:e.policyMode,modifiedAccessConditions:null==t?void 0:t.modifiedAccessCondition},convertTracingToRequestOptionsBase(n)))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async setLegalHold(e,t){const{span:o,updatedOptions:n}=createSpan("BlobClient-setLegalHold",t);try{return await this.blobContext.setLegalHold(e,Object.assign({abortSignal:null==t?void 0:t.abortSignal},convertTracingToRequestOptionsBase(n)))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}}export class AppendBlobClient extends BlobClient{constructor(e,t,o,n){let i,s;if(n=n||{},isPipelineLike(t))s=e,i=t;else if(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t))s=e,i=newPipeline(t,n=o);else if(t||"string"==typeof t){if(!t||"string"!=typeof t||!o||"string"!=typeof o)throw new Error("Expecting non-empty strings for containerName and blobName parameters");{const a=t,r=o,c=extractConnectionStringParts(e);if("AccountConnString"===c.kind){if(!isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=new StorageSharedKeyCredential(c.accountName,c.accountKey);s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r)),n.proxyOptions||(n.proxyOptions=getDefaultProxySettings(c.proxyUri)),i=newPipeline(e,n)}}else{if("SASConnString"!==c.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r))+"?"+c.accountSas,i=newPipeline(new AnonymousCredential,n)}}}else s=e,i=newPipeline(new AnonymousCredential,n);super(s,i),this.appendBlobContext=new AppendBlob(this.storageClientContext)}withSnapshot(e){return new AppendBlobClient(setURLParameter(this.url,URLConstants.Parameters.SNAPSHOT,0===e.length?void 0:e),this.pipeline)}async create(e={}){var t,o,n;const{span:i,updatedOptions:s}=createSpan("AppendBlobClient-create",e);e.conditions=e.conditions||{};try{return ensureCpkIfSpecified(e.customerProvidedKey,this.isHttps),await this.appendBlobContext.create(0,Object.assign({abortSignal:e.abortSignal,blobHttpHeaders:e.blobHTTPHeaders,leaseAccessConditions:e.conditions,metadata:e.metadata,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(t=e.conditions)||void 0===t?void 0:t.tagConditions}),cpkInfo:e.customerProvidedKey,encryptionScope:e.encryptionScope,immutabilityPolicyExpiry:null===(o=e.immutabilityPolicy)||void 0===o?void 0:o.expiriesOn,immutabilityPolicyMode:null===(n=e.immutabilityPolicy)||void 0===n?void 0:n.policyMode,legalHold:e.legalHold,blobTagsString:toBlobTagsString(e.tags)},convertTracingToRequestOptionsBase(s)))}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async createIfNotExists(e={}){var t,o;const{span:n,updatedOptions:i}=createSpan("AppendBlobClient-createIfNotExists",e),s={ifNoneMatch:ETagAny};try{const e=await this.create(Object.assign(Object.assign({},i),{conditions:s}));return Object.assign(Object.assign({succeeded:!0},e),{_response:e._response})}catch(e){if("BlobAlreadyExists"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return n.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when creating a blob only if it does not already exist."}),Object.assign(Object.assign({succeeded:!1},null===(o=e.response)||void 0===o?void 0:o.parsedHeaders),{_response:e.response});throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async seal(e={}){var t;const{span:o,updatedOptions:n}=createSpan("AppendBlobClient-seal",e);e.conditions=e.conditions||{};try{return await this.appendBlobContext.seal(Object.assign({abortSignal:e.abortSignal,appendPositionAccessConditions:e.conditions,leaseAccessConditions:e.conditions,modifiedAccessConditions:Object.assign(Object.assign({},e.conditions),{ifTags:null===(t=e.conditions)||void 0===t?void 0:t.tagConditions})},convertTracingToRequestOptionsBase(n)))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async appendBlock(e,t,o={}){var n;const{span:i,updatedOptions:s}=createSpan("AppendBlobClient-appendBlock",o);o.conditions=o.conditions||{};try{return ensureCpkIfSpecified(o.customerProvidedKey,this.isHttps),await this.appendBlobContext.appendBlock(t,e,Object.assign({abortSignal:o.abortSignal,appendPositionAccessConditions:o.conditions,leaseAccessConditions:o.conditions,modifiedAccessConditions:Object.assign(Object.assign({},o.conditions),{ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions}),requestOptions:{onUploadProgress:o.onProgress},transactionalContentMD5:o.transactionalContentMD5,transactionalContentCrc64:o.transactionalContentCrc64,cpkInfo:o.customerProvidedKey,encryptionScope:o.encryptionScope},convertTracingToRequestOptionsBase(s)))}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async appendBlockFromURL(e,t,o,n={}){var i;const{span:s,updatedOptions:a}=createSpan("AppendBlobClient-appendBlockFromURL",n);n.conditions=n.conditions||{},n.sourceConditions=n.sourceConditions||{};try{return ensureCpkIfSpecified(n.customerProvidedKey,this.isHttps),await this.appendBlobContext.appendBlockFromUrl(e,0,Object.assign({abortSignal:n.abortSignal,sourceRange:rangeToString({offset:t,count:o}),sourceContentMD5:n.sourceContentMD5,sourceContentCrc64:n.sourceContentCrc64,leaseAccessConditions:n.conditions,appendPositionAccessConditions:n.conditions,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(i=n.conditions)||void 0===i?void 0:i.tagConditions}),sourceModifiedAccessConditions:{sourceIfMatch:n.sourceConditions.ifMatch,sourceIfModifiedSince:n.sourceConditions.ifModifiedSince,sourceIfNoneMatch:n.sourceConditions.ifNoneMatch,sourceIfUnmodifiedSince:n.sourceConditions.ifUnmodifiedSince},copySourceAuthorization:httpAuthorizationToString(n.sourceAuthorization),cpkInfo:n.customerProvidedKey,encryptionScope:n.encryptionScope},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}}export class BlockBlobClient extends BlobClient{constructor(e,t,o,n){let i,s;if(n=n||{},isPipelineLike(t))s=e,i=t;else if(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t))s=e,i=newPipeline(t,n=o);else if(t||"string"==typeof t){if(!t||"string"!=typeof t||!o||"string"!=typeof o)throw new Error("Expecting non-empty strings for containerName and blobName parameters");{const a=t,r=o,c=extractConnectionStringParts(e);if("AccountConnString"===c.kind){if(!isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=new StorageSharedKeyCredential(c.accountName,c.accountKey);s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r)),n.proxyOptions||(n.proxyOptions=getDefaultProxySettings(c.proxyUri)),i=newPipeline(e,n)}}else{if("SASConnString"!==c.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r))+"?"+c.accountSas,i=newPipeline(new AnonymousCredential,n)}}}else s=e,i=newPipeline(new AnonymousCredential,n);super(s,i),this.blockBlobContext=new BlockBlob(this.storageClientContext),this._blobContext=new StorageBlob(this.storageClientContext)}withSnapshot(e){return new BlockBlobClient(setURLParameter(this.url,URLConstants.Parameters.SNAPSHOT,0===e.length?void 0:e),this.pipeline)}async query(e,t={}){var o;ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps);const{span:n,updatedOptions:i}=createSpan("BlockBlobClient-query",t);try{if(!isNode)throw new Error("This operation currently is only supported in Node.js.");ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps);const n=await this._blobContext.query(Object.assign({abortSignal:t.abortSignal,queryRequest:{queryType:"SQL",expression:e,inputSerialization:toQuerySerialization(t.inputTextConfiguration),outputSerialization:toQuerySerialization(t.outputTextConfiguration)},leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),cpkInfo:t.customerProvidedKey},convertTracingToRequestOptionsBase(i)));return new BlobQueryResponse(n,{abortSignal:t.abortSignal,onProgress:t.onProgress,onError:t.onError})}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async upload(e,t,o={}){var n,i,s;o.conditions=o.conditions||{};const{span:a,updatedOptions:r}=createSpan("BlockBlobClient-upload",o);try{return ensureCpkIfSpecified(o.customerProvidedKey,this.isHttps),await this.blockBlobContext.upload(t,e,Object.assign({abortSignal:o.abortSignal,blobHttpHeaders:o.blobHTTPHeaders,leaseAccessConditions:o.conditions,metadata:o.metadata,modifiedAccessConditions:Object.assign(Object.assign({},o.conditions),{ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions}),requestOptions:{onUploadProgress:o.onProgress},cpkInfo:o.customerProvidedKey,encryptionScope:o.encryptionScope,immutabilityPolicyExpiry:null===(i=o.immutabilityPolicy)||void 0===i?void 0:i.expiriesOn,immutabilityPolicyMode:null===(s=o.immutabilityPolicy)||void 0===s?void 0:s.policyMode,legalHold:o.legalHold,tier:toAccessTier(o.tier),blobTagsString:toBlobTagsString(o.tags)},convertTracingToRequestOptionsBase(r)))}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}async syncUploadFromURL(e,t={}){var o,n,i,s,a;t.conditions=t.conditions||{};const{span:r,updatedOptions:c}=createSpan("BlockBlobClient-syncUploadFromURL",t);try{return ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps),await this.blockBlobContext.putBlobFromUrl(0,e,Object.assign(Object.assign(Object.assign({},t),{blobHttpHeaders:t.blobHTTPHeaders,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:t.conditions.tagConditions}),sourceModifiedAccessConditions:{sourceIfMatch:null===(o=t.sourceConditions)||void 0===o?void 0:o.ifMatch,sourceIfModifiedSince:null===(n=t.sourceConditions)||void 0===n?void 0:n.ifModifiedSince,sourceIfNoneMatch:null===(i=t.sourceConditions)||void 0===i?void 0:i.ifNoneMatch,sourceIfUnmodifiedSince:null===(s=t.sourceConditions)||void 0===s?void 0:s.ifUnmodifiedSince,sourceIfTags:null===(a=t.sourceConditions)||void 0===a?void 0:a.tagConditions},cpkInfo:t.customerProvidedKey,copySourceAuthorization:httpAuthorizationToString(t.sourceAuthorization),tier:toAccessTier(t.tier),blobTagsString:toBlobTagsString(t.tags),copySourceTags:t.copySourceTags}),convertTracingToRequestOptionsBase(c)))}catch(e){throw r.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async stageBlock(e,t,o,n={}){const{span:i,updatedOptions:s}=createSpan("BlockBlobClient-stageBlock",n);try{return ensureCpkIfSpecified(n.customerProvidedKey,this.isHttps),await this.blockBlobContext.stageBlock(e,o,t,Object.assign({abortSignal:n.abortSignal,leaseAccessConditions:n.conditions,requestOptions:{onUploadProgress:n.onProgress},transactionalContentMD5:n.transactionalContentMD5,transactionalContentCrc64:n.transactionalContentCrc64,cpkInfo:n.customerProvidedKey,encryptionScope:n.encryptionScope},convertTracingToRequestOptionsBase(s)))}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async stageBlockFromURL(e,t,o=0,n,i={}){const{span:s,updatedOptions:a}=createSpan("BlockBlobClient-stageBlockFromURL",i);try{return ensureCpkIfSpecified(i.customerProvidedKey,this.isHttps),await this.blockBlobContext.stageBlockFromURL(e,0,t,Object.assign({abortSignal:i.abortSignal,leaseAccessConditions:i.conditions,sourceContentMD5:i.sourceContentMD5,sourceContentCrc64:i.sourceContentCrc64,sourceRange:0!==o||n?rangeToString({offset:o,count:n}):void 0,cpkInfo:i.customerProvidedKey,encryptionScope:i.encryptionScope,copySourceAuthorization:httpAuthorizationToString(i.sourceAuthorization)},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async commitBlockList(e,t={}){var o,n,i;t.conditions=t.conditions||{};const{span:s,updatedOptions:a}=createSpan("BlockBlobClient-commitBlockList",t);try{return ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps),await this.blockBlobContext.commitBlockList({latest:e},Object.assign({abortSignal:t.abortSignal,blobHttpHeaders:t.blobHTTPHeaders,leaseAccessConditions:t.conditions,metadata:t.metadata,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),cpkInfo:t.customerProvidedKey,encryptionScope:t.encryptionScope,immutabilityPolicyExpiry:null===(n=t.immutabilityPolicy)||void 0===n?void 0:n.expiriesOn,immutabilityPolicyMode:null===(i=t.immutabilityPolicy)||void 0===i?void 0:i.policyMode,legalHold:t.legalHold,tier:toAccessTier(t.tier),blobTagsString:toBlobTagsString(t.tags)},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async getBlockList(e,t={}){var o;const{span:n,updatedOptions:i}=createSpan("BlockBlobClient-getBlockList",t);try{const n=await this.blockBlobContext.getBlockList(e,Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions})},convertTracingToRequestOptionsBase(i)));return n.committedBlocks||(n.committedBlocks=[]),n.uncommittedBlocks||(n.uncommittedBlocks=[]),n}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async uploadData(e,t={}){const{span:o,updatedOptions:n}=createSpan("BlockBlobClient-uploadData",t);try{if(isNode){let t;return t=e instanceof Buffer?e:e instanceof ArrayBuffer?Buffer.from(e):Buffer.from(e.buffer,e.byteOffset,e.byteLength),this.uploadSeekableInternal(((e,o)=>t.slice(e,e+o)),t.byteLength,n)}{const t=new Blob([e]);return this.uploadSeekableInternal(((e,o)=>t.slice(e,e+o)),t.size,n)}}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async uploadBrowserData(e,t={}){const{span:o,updatedOptions:n}=createSpan("BlockBlobClient-uploadBrowserData",t);try{const t=new Blob([e]);return await this.uploadSeekableInternal(((e,o)=>t.slice(e,e+o)),t.size,n)}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async uploadSeekableInternal(e,t,o={}){if(o.blockSize||(o.blockSize=0),o.blockSize<0||o.blockSize>BLOCK_BLOB_MAX_STAGE_BLOCK_BYTES)throw new RangeError(`blockSize option must be >= 0 and <= ${BLOCK_BLOB_MAX_STAGE_BLOCK_BYTES}`);if(0===o.maxSingleShotSize||o.maxSingleShotSize||(o.maxSingleShotSize=BLOCK_BLOB_MAX_UPLOAD_BLOB_BYTES),o.maxSingleShotSize<0||o.maxSingleShotSize>BLOCK_BLOB_MAX_UPLOAD_BLOB_BYTES)throw new RangeError(`maxSingleShotSize option must be >= 0 and <= ${BLOCK_BLOB_MAX_UPLOAD_BLOB_BYTES}`);if(0===o.blockSize){if(t>BLOCK_BLOB_MAX_STAGE_BLOCK_BYTES*BLOCK_BLOB_MAX_BLOCKS)throw new RangeError(`${t} is too larger to upload to a block blob.`);t>o.maxSingleShotSize&&(o.blockSize=Math.ceil(t/BLOCK_BLOB_MAX_BLOCKS),o.blockSize<DEFAULT_BLOB_DOWNLOAD_BLOCK_BYTES&&(o.blockSize=DEFAULT_BLOB_DOWNLOAD_BLOCK_BYTES))}o.blobHTTPHeaders||(o.blobHTTPHeaders={}),o.conditions||(o.conditions={});const{span:n,updatedOptions:i}=createSpan("BlockBlobClient-uploadSeekableInternal",o);try{if(t<=o.maxSingleShotSize)return await this.upload(e(0,t),t,i);const n=Math.floor((t-1)/o.blockSize)+1;if(n>BLOCK_BLOB_MAX_BLOCKS)throw new RangeError(`The buffer's size is too big or the BlockSize is too small;the number of blocks must be <= ${BLOCK_BLOB_MAX_BLOCKS}`);const s=[],a=generateUuid();let r=0;const c=new Batch(o.concurrency);for(let d=0;d<n;d++)c.addOperation((async()=>{const c=generateBlockID(a,d),l=o.blockSize*d,g=(d===n-1?t:l+o.blockSize)-l;s.push(c),await this.stageBlock(c,e(l,g),g,{abortSignal:o.abortSignal,conditions:o.conditions,encryptionScope:o.encryptionScope,tracingOptions:i.tracingOptions}),r+=g,o.onProgress&&o.onProgress({loadedBytes:r})}));return await c.do(),this.commitBlockList(s,i)}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async uploadFile(e,t={}){const{span:o,updatedOptions:n}=createSpan("BlockBlobClient-uploadFile",t);try{const o=(await fsStat(e)).size;return await this.uploadSeekableInternal(((t,o)=>()=>fsCreateReadStream(e,{autoClose:!0,end:o?t+o-1:1/0,start:t})),o,Object.assign(Object.assign({},t),{tracingOptions:Object.assign(Object.assign({},t.tracingOptions),convertTracingToRequestOptionsBase(n))}))}catch(e){throw o.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{o.end()}}async uploadStream(e,t=DEFAULT_BLOCK_BUFFER_SIZE_BYTES,o=5,n={}){n.blobHTTPHeaders||(n.blobHTTPHeaders={}),n.conditions||(n.conditions={});const{span:i,updatedOptions:s}=createSpan("BlockBlobClient-uploadStream",n);try{let i=0;const a=generateUuid();let r=0;const c=[],d=new BufferScheduler(e,t,o,(async(e,t)=>{const o=generateBlockID(a,i);c.push(o),i++,await this.stageBlock(o,e,t,{conditions:n.conditions,encryptionScope:n.encryptionScope,tracingOptions:s.tracingOptions}),r+=t,n.onProgress&&n.onProgress({loadedBytes:r})}),Math.ceil(o/4*3));return await d.do(),await this.commitBlockList(c,Object.assign(Object.assign({},n),{tracingOptions:Object.assign(Object.assign({},n.tracingOptions),convertTracingToRequestOptionsBase(s))}))}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}}export class PageBlobClient extends BlobClient{constructor(e,t,o,n){let i,s;if(n=n||{},isPipelineLike(t))s=e,i=t;else if(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t))s=e,i=newPipeline(t,n=o);else if(t||"string"==typeof t){if(!t||"string"!=typeof t||!o||"string"!=typeof o)throw new Error("Expecting non-empty strings for containerName and blobName parameters");{const a=t,r=o,c=extractConnectionStringParts(e);if("AccountConnString"===c.kind){if(!isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=new StorageSharedKeyCredential(c.accountName,c.accountKey);s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r)),n.proxyOptions||(n.proxyOptions=getDefaultProxySettings(c.proxyUri)),i=newPipeline(e,n)}}else{if("SASConnString"!==c.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");s=appendToURLPath(appendToURLPath(c.url,encodeURIComponent(a)),encodeURIComponent(r))+"?"+c.accountSas,i=newPipeline(new AnonymousCredential,n)}}}else s=e,i=newPipeline(new AnonymousCredential,n);super(s,i),this.pageBlobContext=new PageBlob(this.storageClientContext)}withSnapshot(e){return new PageBlobClient(setURLParameter(this.url,URLConstants.Parameters.SNAPSHOT,0===e.length?void 0:e),this.pipeline)}async create(e,t={}){var o,n,i;t.conditions=t.conditions||{};const{span:s,updatedOptions:a}=createSpan("PageBlobClient-create",t);try{return ensureCpkIfSpecified(t.customerProvidedKey,this.isHttps),await this.pageBlobContext.create(0,e,Object.assign({abortSignal:t.abortSignal,blobHttpHeaders:t.blobHTTPHeaders,blobSequenceNumber:t.blobSequenceNumber,leaseAccessConditions:t.conditions,metadata:t.metadata,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),cpkInfo:t.customerProvidedKey,encryptionScope:t.encryptionScope,immutabilityPolicyExpiry:null===(n=t.immutabilityPolicy)||void 0===n?void 0:n.expiriesOn,immutabilityPolicyMode:null===(i=t.immutabilityPolicy)||void 0===i?void 0:i.policyMode,legalHold:t.legalHold,tier:toAccessTier(t.tier),blobTagsString:toBlobTagsString(t.tags)},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async createIfNotExists(e,t={}){var o,n;const{span:i,updatedOptions:s}=createSpan("PageBlobClient-createIfNotExists",t);try{const o={ifNoneMatch:ETagAny},n=await this.create(e,Object.assign(Object.assign({},t),{conditions:o,tracingOptions:s.tracingOptions}));return Object.assign(Object.assign({succeeded:!0},n),{_response:n._response})}catch(e){if("BlobAlreadyExists"===(null===(o=e.details)||void 0===o?void 0:o.errorCode))return i.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when creating a blob only if it does not already exist."}),Object.assign(Object.assign({succeeded:!1},null===(n=e.response)||void 0===n?void 0:n.parsedHeaders),{_response:e.response});throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async uploadPages(e,t,o,n={}){var i;n.conditions=n.conditions||{};const{span:s,updatedOptions:a}=createSpan("PageBlobClient-uploadPages",n);try{return ensureCpkIfSpecified(n.customerProvidedKey,this.isHttps),await this.pageBlobContext.uploadPages(o,e,Object.assign({abortSignal:n.abortSignal,leaseAccessConditions:n.conditions,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(i=n.conditions)||void 0===i?void 0:i.tagConditions}),requestOptions:{onUploadProgress:n.onProgress},range:rangeToString({offset:t,count:o}),sequenceNumberAccessConditions:n.conditions,transactionalContentMD5:n.transactionalContentMD5,transactionalContentCrc64:n.transactionalContentCrc64,cpkInfo:n.customerProvidedKey,encryptionScope:n.encryptionScope},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async uploadPagesFromURL(e,t,o,n,i={}){var s;i.conditions=i.conditions||{},i.sourceConditions=i.sourceConditions||{};const{span:a,updatedOptions:r}=createSpan("PageBlobClient-uploadPagesFromURL",i);try{return ensureCpkIfSpecified(i.customerProvidedKey,this.isHttps),await this.pageBlobContext.uploadPagesFromURL(e,rangeToString({offset:t,count:n}),0,rangeToString({offset:o,count:n}),Object.assign({abortSignal:i.abortSignal,sourceContentMD5:i.sourceContentMD5,sourceContentCrc64:i.sourceContentCrc64,leaseAccessConditions:i.conditions,sequenceNumberAccessConditions:i.conditions,modifiedAccessConditions:Object.assign(Object.assign({},i.conditions),{ifTags:null===(s=i.conditions)||void 0===s?void 0:s.tagConditions}),sourceModifiedAccessConditions:{sourceIfMatch:i.sourceConditions.ifMatch,sourceIfModifiedSince:i.sourceConditions.ifModifiedSince,sourceIfNoneMatch:i.sourceConditions.ifNoneMatch,sourceIfUnmodifiedSince:i.sourceConditions.ifUnmodifiedSince},cpkInfo:i.customerProvidedKey,encryptionScope:i.encryptionScope,copySourceAuthorization:httpAuthorizationToString(i.sourceAuthorization)},convertTracingToRequestOptionsBase(r)))}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}async clearPages(e=0,t,o={}){var n;o.conditions=o.conditions||{};const{span:i,updatedOptions:s}=createSpan("PageBlobClient-clearPages",o);try{return await this.pageBlobContext.clearPages(0,Object.assign({abortSignal:o.abortSignal,leaseAccessConditions:o.conditions,modifiedAccessConditions:Object.assign(Object.assign({},o.conditions),{ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions}),range:rangeToString({offset:e,count:t}),sequenceNumberAccessConditions:o.conditions,cpkInfo:o.customerProvidedKey,encryptionScope:o.encryptionScope},convertTracingToRequestOptionsBase(s)))}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async getPageRanges(e=0,t,o={}){var n;o.conditions=o.conditions||{};const{span:i,updatedOptions:s}=createSpan("PageBlobClient-getPageRanges",o);try{return await this.pageBlobContext.getPageRanges(Object.assign({abortSignal:o.abortSignal,leaseAccessConditions:o.conditions,modifiedAccessConditions:Object.assign(Object.assign({},o.conditions),{ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions}),range:rangeToString({offset:e,count:t})},convertTracingToRequestOptionsBase(s))).then(rangeResponseFromModel)}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async listPageRangesSegment(e=0,t,o,n={}){var i;const{span:s,updatedOptions:a}=createSpan("PageBlobClient-getPageRangesSegment",n);try{return await this.pageBlobContext.getPageRanges(Object.assign({abortSignal:n.abortSignal,leaseAccessConditions:n.conditions,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(i=n.conditions)||void 0===i?void 0:i.tagConditions}),range:rangeToString({offset:e,count:t}),marker:o,maxPageSize:n.maxPageSize},convertTracingToRequestOptionsBase(a)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}listPageRangeItemSegments(e=0,t,o,n={}){return __asyncGenerator(this,arguments,(function*(){let i;if(o||void 0===o)do{i=yield __await(this.listPageRangesSegment(e,t,o,n)),o=i.continuationToken,yield yield __await(yield __await(i))}while(o)}))}listPageRangeItems(e=0,t,o={}){return __asyncGenerator(this,arguments,(function*(){var n,i;try{for(var s,a=__asyncValues(this.listPageRangeItemSegments(e,t,undefined,o));!(s=yield __await(a.next())).done;){const e=s.value;yield __await(yield*__asyncDelegator(__asyncValues(ExtractPageRangeInfoItems(e))))}}catch(e){n={error:e}}finally{try{s&&!s.done&&(i=a.return)&&(yield __await(i.call(a)))}finally{if(n)throw n.error}}}))}listPageRanges(e=0,t,o={}){o.conditions=o.conditions||{};const n=this.listPageRangeItems(e,t,o);return{next:()=>n.next(),[Symbol.asyncIterator](){return this},byPage:(n={})=>this.listPageRangeItemSegments(e,t,n.continuationToken,Object.assign({maxPageSize:n.maxPageSize},o))}}async getPageRangesDiff(e,t,o,n={}){var i;n.conditions=n.conditions||{};const{span:s,updatedOptions:a}=createSpan("PageBlobClient-getPageRangesDiff",n);try{return await this.pageBlobContext.getPageRangesDiff(Object.assign({abortSignal:n.abortSignal,leaseAccessConditions:n.conditions,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(i=n.conditions)||void 0===i?void 0:i.tagConditions}),prevsnapshot:o,range:rangeToString({offset:e,count:t})},convertTracingToRequestOptionsBase(a))).then(rangeResponseFromModel)}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async listPageRangesDiffSegment(e,t,o,n,i){var s;const{span:a,updatedOptions:r}=createSpan("PageBlobClient-getPageRangesDiffSegment",i);try{return await this.pageBlobContext.getPageRangesDiff(Object.assign({abortSignal:null==i?void 0:i.abortSignal,leaseAccessConditions:null==i?void 0:i.conditions,modifiedAccessConditions:Object.assign(Object.assign({},null==i?void 0:i.conditions),{ifTags:null===(s=null==i?void 0:i.conditions)||void 0===s?void 0:s.tagConditions}),prevsnapshot:o,range:rangeToString({offset:e,count:t}),marker:n,maxPageSize:null==i?void 0:i.maxPageSize},convertTracingToRequestOptionsBase(r)))}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}listPageRangeDiffItemSegments(e,t,o,n,i){return __asyncGenerator(this,arguments,(function*(){let s;if(n||void 0===n)do{s=yield __await(this.listPageRangesDiffSegment(e,t,o,n,i)),n=s.continuationToken,yield yield __await(yield __await(s))}while(n)}))}listPageRangeDiffItems(e,t,o,n){return __asyncGenerator(this,arguments,(function*(){var i,s;try{for(var a,r=__asyncValues(this.listPageRangeDiffItemSegments(e,t,o,undefined,n));!(a=yield __await(r.next())).done;){const e=a.value;yield __await(yield*__asyncDelegator(__asyncValues(ExtractPageRangeInfoItems(e))))}}catch(e){i={error:e}}finally{try{a&&!a.done&&(s=r.return)&&(yield __await(s.call(r)))}finally{if(i)throw i.error}}}))}listPageRangesDiff(e,t,o,n={}){n.conditions=n.conditions||{};const i=this.listPageRangeDiffItems(e,t,o,Object.assign({},n));return{next:()=>i.next(),[Symbol.asyncIterator](){return this},byPage:(i={})=>this.listPageRangeDiffItemSegments(e,t,o,i.continuationToken,Object.assign({maxPageSize:i.maxPageSize},n))}}async getPageRangesDiffForManagedDisks(e,t,o,n={}){var i;n.conditions=n.conditions||{};const{span:s,updatedOptions:a}=createSpan("PageBlobClient-GetPageRangesDiffForManagedDisks",n);try{return await this.pageBlobContext.getPageRangesDiff(Object.assign({abortSignal:n.abortSignal,leaseAccessConditions:n.conditions,modifiedAccessConditions:Object.assign(Object.assign({},n.conditions),{ifTags:null===(i=n.conditions)||void 0===i?void 0:i.tagConditions}),prevSnapshotUrl:o,range:rangeToString({offset:e,count:t})},convertTracingToRequestOptionsBase(a))).then(rangeResponseFromModel)}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async resize(e,t={}){var o;t.conditions=t.conditions||{};const{span:n,updatedOptions:i}=createSpan("PageBlobClient-resize",t);try{return await this.pageBlobContext.resize(e,Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions}),encryptionScope:t.encryptionScope},convertTracingToRequestOptionsBase(i)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async updateSequenceNumber(e,t,o={}){var n;o.conditions=o.conditions||{};const{span:i,updatedOptions:s}=createSpan("PageBlobClient-updateSequenceNumber",o);try{return await this.pageBlobContext.updateSequenceNumber(e,Object.assign({abortSignal:o.abortSignal,blobSequenceNumber:t,leaseAccessConditions:o.conditions,modifiedAccessConditions:Object.assign(Object.assign({},o.conditions),{ifTags:null===(n=o.conditions)||void 0===n?void 0:n.tagConditions})},convertTracingToRequestOptionsBase(s)))}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async startCopyIncremental(e,t={}){var o;const{span:n,updatedOptions:i}=createSpan("PageBlobClient-startCopyIncremental",t);try{return await this.pageBlobContext.copyIncremental(e,Object.assign({abortSignal:t.abortSignal,modifiedAccessConditions:Object.assign(Object.assign({},t.conditions),{ifTags:null===(o=t.conditions)||void 0===o?void 0:o.tagConditions})},convertTracingToRequestOptionsBase(i)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}}