import{__asyncDelegator,__asyncGenerator,__asyncValues,__await}from"tslib";import{getDefaultProxySettings,isNode,isTokenCredential,URLBuilder}from"@azure/core-http";import{SpanStatusCode}from"@azure/core-tracing";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{StorageSharedKeyCredential}from"./credentials/StorageSharedKeyCredential";import{Container}from"./generated/src/operations";import{newPipeline,isPipelineLike}from"./Pipeline";import{StorageClient}from"./StorageClient";import{convertTracingToRequestOptionsBase,createSpan}from"./utils/tracing";import{appendToURLPath,appendToURLQuery,BlobNameToString,ConvertInternalResponseOfListBlobFlat,ConvertInternalResponseOfListBlobHierarchy,extractConnectionStringParts,isIpEndpointStyle,parseObjectReplicationRecord,ProcessBlobItems,ProcessBlobPrefixes,toTags,truncatedISO8061Date}from"./utils/utils.common";import{generateBlobSASQueryParameters}from"./sas/BlobSASSignatureValues";import{BlobLeaseClient}from"./BlobLeaseClient";import{AppendBlobClient,BlobClient,BlockBlobClient,PageBlobClient}from"./Clients";import{BlobBatchClient}from"./BlobBatchClient";export class ContainerClient extends StorageClient{constructor(e,t,n){let s,i;if(n=n||{},isPipelineLike(t))i=e,s=t;else if(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t))i=e,s=newPipeline(t,n);else if(t||"string"==typeof t){if(!t||"string"!=typeof t)throw new Error("Expecting non-empty strings for containerName parameter");{const a=t,o=extractConnectionStringParts(e);if("AccountConnString"===o.kind){if(!isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=new StorageSharedKeyCredential(o.accountName,o.accountKey);i=appendToURLPath(o.url,encodeURIComponent(a)),n.proxyOptions||(n.proxyOptions=getDefaultProxySettings(o.proxyUri)),s=newPipeline(e,n)}}else{if("SASConnString"!==o.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");i=appendToURLPath(o.url,encodeURIComponent(a))+"?"+o.accountSas,s=newPipeline(new AnonymousCredential,n)}}}else i=e,s=newPipeline(new AnonymousCredential,n);super(i,s),this._containerName=this.getContainerNameFromUrl(),this.containerContext=new Container(this.storageClientContext)}get containerName(){return this._containerName}async create(e={}){const{span:t,updatedOptions:n}=createSpan("ContainerClient-create",e);try{return await this.containerContext.create(Object.assign(Object.assign({},e),convertTracingToRequestOptionsBase(n)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async createIfNotExists(e={}){var t,n;const{span:s,updatedOptions:i}=createSpan("ContainerClient-createIfNotExists",e);try{const e=await this.create(i);return Object.assign(Object.assign({succeeded:!0},e),{_response:e._response})}catch(e){if("ContainerAlreadyExists"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return s.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when creating a container only if it does not already exist."}),Object.assign(Object.assign({succeeded:!1},null===(n=e.response)||void 0===n?void 0:n.parsedHeaders),{_response:e.response});throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async exists(e={}){const{span:t,updatedOptions:n}=createSpan("ContainerClient-exists",e);try{return await this.getProperties({abortSignal:e.abortSignal,tracingOptions:n.tracingOptions}),!0}catch(e){if(404===e.statusCode)return t.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when checking container existence"}),!1;throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}getBlobClient(e){return new BlobClient(appendToURLPath(this.url,encodeURIComponent(e)),this.pipeline)}getAppendBlobClient(e){return new AppendBlobClient(appendToURLPath(this.url,encodeURIComponent(e)),this.pipeline)}getBlockBlobClient(e){return new BlockBlobClient(appendToURLPath(this.url,encodeURIComponent(e)),this.pipeline)}getPageBlobClient(e){return new PageBlobClient(appendToURLPath(this.url,encodeURIComponent(e)),this.pipeline)}async getProperties(e={}){e.conditions||(e.conditions={});const{span:t,updatedOptions:n}=createSpan("ContainerClient-getProperties",e);try{return await this.containerContext.getProperties(Object.assign(Object.assign({abortSignal:e.abortSignal},e.conditions),convertTracingToRequestOptionsBase(n)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async delete(e={}){e.conditions||(e.conditions={});const{span:t,updatedOptions:n}=createSpan("ContainerClient-delete",e);try{return await this.containerContext.delete(Object.assign({abortSignal:e.abortSignal,leaseAccessConditions:e.conditions,modifiedAccessConditions:e.conditions},convertTracingToRequestOptionsBase(n)))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async deleteIfExists(e={}){var t,n;const{span:s,updatedOptions:i}=createSpan("ContainerClient-deleteIfExists",e);try{const e=await this.delete(i);return Object.assign(Object.assign({succeeded:!0},e),{_response:e._response})}catch(e){if("ContainerNotFound"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return s.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when deleting a container only if it exists."}),Object.assign(Object.assign({succeeded:!1},null===(n=e.response)||void 0===n?void 0:n.parsedHeaders),{_response:e.response});throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async setMetadata(e,t={}){if(t.conditions||(t.conditions={}),t.conditions.ifUnmodifiedSince)throw new RangeError("the IfUnmodifiedSince must have their default values because they are ignored by the blob service");const{span:n,updatedOptions:s}=createSpan("ContainerClient-setMetadata",t);try{return await this.containerContext.setMetadata(Object.assign({abortSignal:t.abortSignal,leaseAccessConditions:t.conditions,metadata:e,modifiedAccessConditions:t.conditions},convertTracingToRequestOptionsBase(s)))}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async getAccessPolicy(e={}){e.conditions||(e.conditions={});const{span:t,updatedOptions:n}=createSpan("ContainerClient-getAccessPolicy",e);try{const t=await this.containerContext.getAccessPolicy(Object.assign({abortSignal:e.abortSignal,leaseAccessConditions:e.conditions},convertTracingToRequestOptionsBase(n))),s={_response:t._response,blobPublicAccess:t.blobPublicAccess,date:t.date,etag:t.etag,errorCode:t.errorCode,lastModified:t.lastModified,requestId:t.requestId,clientRequestId:t.clientRequestId,signedIdentifiers:[],version:t.version};for(const e of t){let t;e.accessPolicy&&(t={permissions:e.accessPolicy.permissions},e.accessPolicy.expiresOn&&(t.expiresOn=new Date(e.accessPolicy.expiresOn)),e.accessPolicy.startsOn&&(t.startsOn=new Date(e.accessPolicy.startsOn))),s.signedIdentifiers.push({accessPolicy:t,id:e.id})}return s}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setAccessPolicy(e,t,n={}){n.conditions=n.conditions||{};const{span:s,updatedOptions:i}=createSpan("ContainerClient-setAccessPolicy",n);try{const s=[];for(const e of t||[])s.push({accessPolicy:{expiresOn:e.accessPolicy.expiresOn?truncatedISO8061Date(e.accessPolicy.expiresOn):"",permissions:e.accessPolicy.permissions,startsOn:e.accessPolicy.startsOn?truncatedISO8061Date(e.accessPolicy.startsOn):""},id:e.id});return await this.containerContext.setAccessPolicy(Object.assign({abortSignal:n.abortSignal,access:e,containerAcl:s,leaseAccessConditions:n.conditions,modifiedAccessConditions:n.conditions},convertTracingToRequestOptionsBase(i)))}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}getBlobLeaseClient(e){return new BlobLeaseClient(this,e)}async uploadBlockBlob(e,t,n,s={}){const{span:i,updatedOptions:a}=createSpan("ContainerClient-uploadBlockBlob",s);try{const s=this.getBlockBlobClient(e),i=await s.upload(t,n,a);return{blockBlobClient:s,response:i}}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}async deleteBlob(e,t={}){const{span:n,updatedOptions:s}=createSpan("ContainerClient-deleteBlob",t);try{let n=this.getBlobClient(e);return t.versionId&&(n=n.withVersion(t.versionId)),await n.delete(s)}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async listBlobFlatSegment(e,t={}){const{span:n,updatedOptions:s}=createSpan("ContainerClient-listBlobFlatSegment",t);try{const n=await this.containerContext.listBlobFlatSegment(Object.assign(Object.assign({marker:e},t),convertTracingToRequestOptionsBase(s)));n.segment.blobItems=[],void 0!==n.segment.Blob&&(n.segment.blobItems=ProcessBlobItems(n.segment.Blob));return Object.assign(Object.assign({},n),{_response:Object.assign(Object.assign({},n._response),{parsedBody:ConvertInternalResponseOfListBlobFlat(n._response.parsedBody)}),segment:Object.assign(Object.assign({},n.segment),{blobItems:n.segment.blobItems.map((e=>Object.assign(Object.assign({},e),{name:BlobNameToString(e.name),tags:toTags(e.blobTags),objectReplicationSourceProperties:parseObjectReplicationRecord(e.objectReplicationMetadata)})))})})}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async listBlobHierarchySegment(e,t,n={}){var s;const{span:i,updatedOptions:a}=createSpan("ContainerClient-listBlobHierarchySegment",n);try{const i=await this.containerContext.listBlobHierarchySegment(e,Object.assign(Object.assign({marker:t},n),convertTracingToRequestOptionsBase(a)));i.segment.blobItems=[],void 0!==i.segment.Blob&&(i.segment.blobItems=ProcessBlobItems(i.segment.Blob)),i.segment.blobPrefixes=[],void 0!==i.segment.BlobPrefix&&(i.segment.blobPrefixes=ProcessBlobPrefixes(i.segment.BlobPrefix));return Object.assign(Object.assign({},i),{_response:Object.assign(Object.assign({},i._response),{parsedBody:ConvertInternalResponseOfListBlobHierarchy(i._response.parsedBody)}),segment:Object.assign(Object.assign({},i.segment),{blobItems:i.segment.blobItems.map((e=>Object.assign(Object.assign({},e),{name:BlobNameToString(e.name),tags:toTags(e.blobTags),objectReplicationSourceProperties:parseObjectReplicationRecord(e.objectReplicationMetadata)}))),blobPrefixes:null===(s=i.segment.blobPrefixes)||void 0===s?void 0:s.map((e=>({name:BlobNameToString(e.name)})))})})}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}listSegments(e,t={}){return __asyncGenerator(this,arguments,(function*(){let n;if(e||void 0===e)do{n=yield __await(this.listBlobFlatSegment(e,t)),e=n.continuationToken,yield yield __await(yield __await(n))}while(e)}))}listItems(e={}){return __asyncGenerator(this,arguments,(function*(){var t,n;try{for(var s,i=__asyncValues(this.listSegments(undefined,e));!(s=yield __await(i.next())).done;){const e=s.value;yield __await(yield*__asyncDelegator(__asyncValues(e.segment.blobItems)))}}catch(e){t={error:e}}finally{try{s&&!s.done&&(n=i.return)&&(yield __await(n.call(i)))}finally{if(t)throw t.error}}}))}listBlobsFlat(e={}){const t=[];e.includeCopy&&t.push("copy"),e.includeDeleted&&t.push("deleted"),e.includeMetadata&&t.push("metadata"),e.includeSnapshots&&t.push("snapshots"),e.includeVersions&&t.push("versions"),e.includeUncommitedBlobs&&t.push("uncommittedblobs"),e.includeTags&&t.push("tags"),e.includeDeletedWithVersions&&t.push("deletedwithversions"),e.includeImmutabilityPolicy&&t.push("immutabilitypolicy"),e.includeLegalHold&&t.push("legalhold"),""===e.prefix&&(e.prefix=void 0);const n=Object.assign(Object.assign({},e),t.length>0?{include:t}:{}),s=this.listItems(n);return{next:()=>s.next(),[Symbol.asyncIterator](){return this},byPage:(e={})=>this.listSegments(e.continuationToken,Object.assign({maxPageSize:e.maxPageSize},n))}}listHierarchySegments(e,t,n={}){return __asyncGenerator(this,arguments,(function*(){let s;if(t||void 0===t)do{s=yield __await(this.listBlobHierarchySegment(e,t,n)),t=s.continuationToken,yield yield __await(yield __await(s))}while(t)}))}listItemsByHierarchy(e,t={}){return __asyncGenerator(this,arguments,(function*(){var n,s;try{for(var i,a=__asyncValues(this.listHierarchySegments(e,undefined,t));!(i=yield __await(a.next())).done;){const e=i.value.segment;if(e.blobPrefixes)for(const t of e.blobPrefixes)yield yield __await(Object.assign({kind:"prefix"},t));for(const t of e.blobItems)yield yield __await(Object.assign({kind:"blob"},t))}}catch(e){n={error:e}}finally{try{i&&!i.done&&(s=a.return)&&(yield __await(s.call(a)))}finally{if(n)throw n.error}}}))}listBlobsByHierarchy(e,t={}){if(""===e)throw new RangeError("delimiter should contain one or more characters");const n=[];t.includeCopy&&n.push("copy"),t.includeDeleted&&n.push("deleted"),t.includeMetadata&&n.push("metadata"),t.includeSnapshots&&n.push("snapshots"),t.includeVersions&&n.push("versions"),t.includeUncommitedBlobs&&n.push("uncommittedblobs"),t.includeTags&&n.push("tags"),t.includeDeletedWithVersions&&n.push("deletedwithversions"),t.includeImmutabilityPolicy&&n.push("immutabilitypolicy"),t.includeLegalHold&&n.push("legalhold"),""===t.prefix&&(t.prefix=void 0);const s=Object.assign(Object.assign({},t),n.length>0?{include:n}:{}),i=this.listItemsByHierarchy(e,s);return{next:async()=>i.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.listHierarchySegments(e,t.continuationToken,Object.assign({maxPageSize:t.maxPageSize},s))}}async findBlobsByTagsSegment(e,t,n={}){const{span:s,updatedOptions:i}=createSpan("ContainerClient-findBlobsByTagsSegment",n);try{const s=await this.containerContext.filterBlobs(Object.assign({abortSignal:n.abortSignal,where:e,marker:t,maxPageSize:n.maxPageSize},convertTracingToRequestOptionsBase(i)));return Object.assign(Object.assign({},s),{_response:s._response,blobs:s.blobs.map((e=>{var t;let n="";return 1===(null===(t=e.tags)||void 0===t?void 0:t.blobTagSet.length)&&(n=e.tags.blobTagSet[0].value),Object.assign(Object.assign({},e),{tags:toTags(e.tags),tagValue:n})}))})}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}findBlobsByTagsSegments(e,t,n={}){return __asyncGenerator(this,arguments,(function*(){let s;if(t||void 0===t)do{s=yield __await(this.findBlobsByTagsSegment(e,t,n)),s.blobs=s.blobs||[],t=s.continuationToken,yield yield __await(s)}while(t)}))}findBlobsByTagsItems(e,t={}){return __asyncGenerator(this,arguments,(function*(){var n,s;try{for(var i,a=__asyncValues(this.findBlobsByTagsSegments(e,undefined,t));!(i=yield __await(a.next())).done;){const e=i.value;yield __await(yield*__asyncDelegator(__asyncValues(e.blobs)))}}catch(e){n={error:e}}finally{try{i&&!i.done&&(s=a.return)&&(yield __await(s.call(a)))}finally{if(n)throw n.error}}}))}findBlobsByTags(e,t={}){const n=Object.assign({},t),s=this.findBlobsByTagsItems(e,n);return{next:()=>s.next(),[Symbol.asyncIterator](){return this},byPage:(t={})=>this.findBlobsByTagsSegments(e,t.continuationToken,Object.assign({maxPageSize:t.maxPageSize},n))}}getContainerNameFromUrl(){let e;try{const t=URLBuilder.parse(this.url);if(e="blob"===t.getHost().split(".")[1]?t.getPath().split("/")[1]:isIpEndpointStyle(t)?t.getPath().split("/")[2]:t.getPath().split("/")[1],e=decodeURIComponent(e),!e)throw new Error("Provided containerName is invalid.");return e}catch(e){throw new Error("Unable to extract containerName with provided information.")}}generateSasUrl(e){return new Promise((t=>{if(!(this.credential instanceof StorageSharedKeyCredential))throw new RangeError("Can only generate the SAS when the client is initialized with a shared key credential");const n=generateBlobSASQueryParameters(Object.assign({containerName:this._containerName},e),this.credential).toString();t(appendToURLQuery(this.url,n))}))}getBlobBatchClient(){return new BlobBatchClient(this.url,this.pipeline)}}