import{BaseRequestPolicy,deserializationPolicy,disableResponseDecompressionPolicy,HttpHeaders,RequestPolicyOptions,WebResource,proxyPolicy,isNode,isTokenCredential,tracingPolicy,logPolicy,keepAlivePolicy,generateClientRequestIdPolicy}from"@azure/core-http";import{logger}from"./log";import{StorageBrowserPolicyFactory}from"./StorageBrowserPolicyFactory";import{StorageRetryPolicyFactory}from"./StorageRetryPolicyFactory";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{StorageOAuthScopes,StorageBlobLoggingAllowedHeaderNames,StorageBlobLoggingAllowedQueryParameters}from"./utils/constants";import{TelemetryPolicyFactory}from"./TelemetryPolicyFactory";import{getCachedDefaultHttpClient}from"./utils/cache";import{attachCredential}from"./utils/utils.common";import{storageBearerTokenChallengeAuthenticationPolicy}from"./policies/StorageBearerTokenChallengeAuthenticationPolicy";export{BaseRequestPolicy,StorageOAuthScopes,deserializationPolicy,HttpHeaders,WebResource,RequestPolicyOptions};export function isPipelineLike(e){if(!e||"object"!=typeof e)return!1;const o=e;return Array.isArray(o.factories)&&"object"==typeof o.options&&"function"==typeof o.toServiceClientOptions}export class Pipeline{constructor(e,o={}){this.factories=e,this.options=Object.assign(Object.assign({},o),{httpClient:o.httpClient||getCachedDefaultHttpClient()})}toServiceClientOptions(){return{httpClient:this.options.httpClient,requestPolicyFactories:this.factories}}}export function newPipeline(e,o={}){var t;void 0===e&&(e=new AnonymousCredential);const i=new TelemetryPolicyFactory(o.userAgentOptions),r=[tracingPolicy({userAgent:i.telemetryString}),keepAlivePolicy(o.keepAliveOptions),i,generateClientRequestIdPolicy(),new StorageBrowserPolicyFactory,new StorageRetryPolicyFactory(o.retryOptions),deserializationPolicy(void 0,{xmlCharKey:"#"}),logPolicy({logger:logger.info,allowedHeaderNames:StorageBlobLoggingAllowedHeaderNames,allowedQueryParameters:StorageBlobLoggingAllowedQueryParameters})];return isNode&&(r.push(proxyPolicy(o.proxyOptions)),r.push(disableResponseDecompressionPolicy())),r.push(isTokenCredential(e)?attachCredential(storageBearerTokenChallengeAuthenticationPolicy(e,null!==(t=o.audience)&&void 0!==t?t:StorageOAuthScopes),e):e),new Pipeline(r,o)}