import{AbortError}from"@azure/abort-controller";import{BaseRequestPolicy}from"@azure/core-http";import{URLConstants}from"../utils/constants";import{delay,setURLHost,setURLParameter}from"../utils/utils.common";import{logger}from"../log";export function NewRetryPolicyFactory(e){return{create:(t,r)=>new StorageRetryPolicy(t,r,e)}}export var StorageRetryPolicyType;!function(e){e[e.EXPONENTIAL=0]="EXPONENTIAL",e[e.FIXED=1]="FIXED"}(StorageRetryPolicyType||(StorageRetryPolicyType={}));const DEFAULT_RETRY_OPTIONS={maxRetryDelayInMs:12e4,maxTries:4,retryDelayInMs:4e3,retryPolicyType:StorageRetryPolicyType.EXPONENTIAL,secondaryHost:"",tryTimeoutInMs:void 0},RETRY_ABORT_ERROR=new AbortError("The operation was aborted.");export class StorageRetryPolicy extends BaseRequestPolicy{constructor(e,t,r=DEFAULT_RETRY_OPTIONS){super(e,t),this.retryOptions={retryPolicyType:r.retryPolicyType?r.retryPolicyType:DEFAULT_RETRY_OPTIONS.retryPolicyType,maxTries:r.maxTries&&r.maxTries>=1?Math.floor(r.maxTries):DEFAULT_RETRY_OPTIONS.maxTries,tryTimeoutInMs:r.tryTimeoutInMs&&r.tryTimeoutInMs>=0?r.tryTimeoutInMs:DEFAULT_RETRY_OPTIONS.tryTimeoutInMs,retryDelayInMs:r.retryDelayInMs&&r.retryDelayInMs>=0?Math.min(r.retryDelayInMs,r.maxRetryDelayInMs?r.maxRetryDelayInMs:DEFAULT_RETRY_OPTIONS.maxRetryDelayInMs):DEFAULT_RETRY_OPTIONS.retryDelayInMs,maxRetryDelayInMs:r.maxRetryDelayInMs&&r.maxRetryDelayInMs>=0?r.maxRetryDelayInMs:DEFAULT_RETRY_OPTIONS.maxRetryDelayInMs,secondaryHost:r.secondaryHost?r.secondaryHost:DEFAULT_RETRY_OPTIONS.secondaryHost}}async sendRequest(e){return this.attemptSendRequest(e,!1,1)}async attemptSendRequest(e,t,r){const o=e.clone(),s=t||!this.retryOptions.secondaryHost||!("GET"===e.method||"HEAD"===e.method||"OPTIONS"===e.method)||r%2==1;let y;s||(o.url=setURLHost(o.url,this.retryOptions.secondaryHost)),this.retryOptions.tryTimeoutInMs&&(o.url=setURLParameter(o.url,URLConstants.Parameters.TIMEOUT,Math.floor(this.retryOptions.tryTimeoutInMs/1e3).toString()));try{if(logger.info(`RetryPolicy: =====> Try=${r} ${s?"Primary":"Secondary"}`),y=await this._nextPolicy.sendRequest(o),!this.shouldRetry(s,r,y))return y;t=t||!s&&404===y.status}catch(e){if(logger.error(`RetryPolicy: Caught error, message: ${e.message}, code: ${e.code}`),!this.shouldRetry(s,r,y,e))throw e}return await this.delay(s,r,e.abortSignal),this.attemptSendRequest(e,t,++r)}shouldRetry(e,t,r,o){if(t>=this.retryOptions.maxTries)return logger.info(`RetryPolicy: Attempt(s) ${t} >= maxTries ${this.retryOptions.maxTries}, no further try.`),!1;const s=["ETIMEDOUT","ESOCKETTIMEDOUT","ECONNREFUSED","ECONNRESET","ENOENT","ENOTFOUND","TIMEOUT","EPIPE","REQUEST_SEND_ERROR"];if(o)for(const e of s)if(o.name.toUpperCase().includes(e)||o.message.toUpperCase().includes(e)||o.code&&o.code.toString().toUpperCase()===e)return logger.info(`RetryPolicy: Network error ${e} found, will retry.`),!0;if(r||o){const t=r?r.status:o?o.statusCode:0;if(!e&&404===t)return logger.info("RetryPolicy: Secondary access with 404, will retry."),!0;if(503===t||500===t)return logger.info(`RetryPolicy: Will retry for status code ${t}.`),!0}return!("PARSE_ERROR"!==(null==o?void 0:o.code)||!(null==o?void 0:o.message.startsWith('Error "Error: Unclosed root tag')))&&(logger.info("RetryPolicy: Incomplete XML response likely due to service timeout, will retry."),!0)}async delay(e,t,r){let o=0;if(e)switch(this.retryOptions.retryPolicyType){case StorageRetryPolicyType.EXPONENTIAL:o=Math.min((Math.pow(2,t-1)-1)*this.retryOptions.retryDelayInMs,this.retryOptions.maxRetryDelayInMs);break;case StorageRetryPolicyType.FIXED:o=this.retryOptions.retryDelayInMs}else o=1e3*Math.random();return logger.info(`RetryPolicy: Delay for ${o}ms`),delay(o,r,RETRY_ABORT_ERROR)}}