import{BlobSASPermissions}from"./BlobSASPermissions";import{ContainerSASPermissions}from"./ContainerSASPermissions";import{StorageSharedKeyCredential}from"../credentials/StorageSharedKeyCredential";import{UserDelegationKeyCredential}from"../credentials/UserDelegationKeyCredential";import{ipRangeToString}from"./SasIPRange";import{SASQueryParameters}from"./SASQueryParameters";import{SERVICE_VERSION}from"../utils/constants";import{truncatedISO8061Date}from"../utils/utils.common";export function generateBlobSASQueryParameters(e,n,o){const i=e.version?e.version:SERVICE_VERSION,t=n instanceof StorageSharedKeyCredential?n:void 0;let r;if(void 0===t&&void 0!==o&&(r=new UserDelegationKeyCredential(o,n)),void 0===t&&void 0===r)throw TypeError("Invalid sharedKeyCredential, userDelegationKey or accountName.");if(i>="2020-12-06")return void 0!==t?generateBlobSASQueryParameters20201206(e,t):generateBlobSASQueryParametersUDK20201206(e,r);if(i>="2018-11-09")return void 0!==t?generateBlobSASQueryParameters20181109(e,t):i>="2020-02-10"?generateBlobSASQueryParametersUDK20200210(e,r):generateBlobSASQueryParametersUDK20181109(e,r);if(i>="2015-04-05"){if(void 0!==t)return generateBlobSASQueryParameters20150405(e,t);throw new RangeError("'version' must be >= '2018-11-09' when generating user delegation SAS using user delegation key.")}throw new RangeError("'version' must be >= '2015-04-05'.")}function generateBlobSASQueryParameters20150405(e,n){if(!((e=SASSignatureValuesSanityCheckAndAutofill(e)).identifier||e.permissions&&e.expiresOn))throw new RangeError("Must provide 'permissions' and 'expiresOn' for Blob SAS generation when 'identifier' is not provided.");let o,i="c";e.blobName&&(i="b"),e.permissions&&(o=e.blobName?BlobSASPermissions.parse(e.permissions.toString()).toString():ContainerSASPermissions.parse(e.permissions.toString()).toString());const t=[o||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(n.accountName,e.containerName,e.blobName),e.identifier,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",e.version,e.cacheControl?e.cacheControl:"",e.contentDisposition?e.contentDisposition:"",e.contentEncoding?e.contentEncoding:"",e.contentLanguage?e.contentLanguage:"",e.contentType?e.contentType:""].join("\n"),r=n.computeHMACSHA256(t);return new SASQueryParameters(e.version,r,o,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier,i,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType)}function generateBlobSASQueryParameters20181109(e,n){if(!((e=SASSignatureValuesSanityCheckAndAutofill(e)).identifier||e.permissions&&e.expiresOn))throw new RangeError("Must provide 'permissions' and 'expiresOn' for Blob SAS generation when 'identifier' is not provided.");let o,i="c",t=e.snapshotTime;e.blobName&&(i="b",e.snapshotTime?i="bs":e.versionId&&(i="bv",t=e.versionId)),e.permissions&&(o=e.blobName?BlobSASPermissions.parse(e.permissions.toString()).toString():ContainerSASPermissions.parse(e.permissions.toString()).toString());const r=[o||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(n.accountName,e.containerName,e.blobName),e.identifier,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",e.version,i,t,e.cacheControl?e.cacheControl:"",e.contentDisposition?e.contentDisposition:"",e.contentEncoding?e.contentEncoding:"",e.contentLanguage?e.contentLanguage:"",e.contentType?e.contentType:""].join("\n"),s=n.computeHMACSHA256(r);return new SASQueryParameters(e.version,s,o,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier,i,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType)}function generateBlobSASQueryParameters20201206(e,n){if(!((e=SASSignatureValuesSanityCheckAndAutofill(e)).identifier||e.permissions&&e.expiresOn))throw new RangeError("Must provide 'permissions' and 'expiresOn' for Blob SAS generation when 'identifier' is not provided.");let o,i="c",t=e.snapshotTime;e.blobName&&(i="b",e.snapshotTime?i="bs":e.versionId&&(i="bv",t=e.versionId)),e.permissions&&(o=e.blobName?BlobSASPermissions.parse(e.permissions.toString()).toString():ContainerSASPermissions.parse(e.permissions.toString()).toString());const r=[o||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(n.accountName,e.containerName,e.blobName),e.identifier,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",e.version,i,t,e.encryptionScope,e.cacheControl?e.cacheControl:"",e.contentDisposition?e.contentDisposition:"",e.contentEncoding?e.contentEncoding:"",e.contentLanguage?e.contentLanguage:"",e.contentType?e.contentType:""].join("\n"),s=n.computeHMACSHA256(r);return new SASQueryParameters(e.version,s,o,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier,i,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType,void 0,void 0,void 0,e.encryptionScope)}function generateBlobSASQueryParametersUDK20181109(e,n){if(!(e=SASSignatureValuesSanityCheckAndAutofill(e)).permissions||!e.expiresOn)throw new RangeError("Must provide 'permissions' and 'expiresOn' for Blob SAS generation when generating user delegation SAS.");let o,i="c",t=e.snapshotTime;e.blobName&&(i="b",e.snapshotTime?i="bs":e.versionId&&(i="bv",t=e.versionId)),e.permissions&&(o=e.blobName?BlobSASPermissions.parse(e.permissions.toString()).toString():ContainerSASPermissions.parse(e.permissions.toString()).toString());const r=[o||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(n.accountName,e.containerName,e.blobName),n.userDelegationKey.signedObjectId,n.userDelegationKey.signedTenantId,n.userDelegationKey.signedStartsOn?truncatedISO8061Date(n.userDelegationKey.signedStartsOn,!1):"",n.userDelegationKey.signedExpiresOn?truncatedISO8061Date(n.userDelegationKey.signedExpiresOn,!1):"",n.userDelegationKey.signedService,n.userDelegationKey.signedVersion,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",e.version,i,t,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType].join("\n"),s=n.computeHMACSHA256(r);return new SASQueryParameters(e.version,s,o,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier,i,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType,n.userDelegationKey)}function generateBlobSASQueryParametersUDK20200210(e,n){if(!(e=SASSignatureValuesSanityCheckAndAutofill(e)).permissions||!e.expiresOn)throw new RangeError("Must provide 'permissions' and 'expiresOn' for Blob SAS generation when generating user delegation SAS.");let o,i="c",t=e.snapshotTime;e.blobName&&(i="b",e.snapshotTime?i="bs":e.versionId&&(i="bv",t=e.versionId)),e.permissions&&(o=e.blobName?BlobSASPermissions.parse(e.permissions.toString()).toString():ContainerSASPermissions.parse(e.permissions.toString()).toString());const r=[o||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(n.accountName,e.containerName,e.blobName),n.userDelegationKey.signedObjectId,n.userDelegationKey.signedTenantId,n.userDelegationKey.signedStartsOn?truncatedISO8061Date(n.userDelegationKey.signedStartsOn,!1):"",n.userDelegationKey.signedExpiresOn?truncatedISO8061Date(n.userDelegationKey.signedExpiresOn,!1):"",n.userDelegationKey.signedService,n.userDelegationKey.signedVersion,e.preauthorizedAgentObjectId,void 0,e.correlationId,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",e.version,i,t,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType].join("\n"),s=n.computeHMACSHA256(r);return new SASQueryParameters(e.version,s,o,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier,i,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType,n.userDelegationKey,e.preauthorizedAgentObjectId,e.correlationId)}function generateBlobSASQueryParametersUDK20201206(e,n){if(!(e=SASSignatureValuesSanityCheckAndAutofill(e)).permissions||!e.expiresOn)throw new RangeError("Must provide 'permissions' and 'expiresOn' for Blob SAS generation when generating user delegation SAS.");let o,i="c",t=e.snapshotTime;e.blobName&&(i="b",e.snapshotTime?i="bs":e.versionId&&(i="bv",t=e.versionId)),e.permissions&&(o=e.blobName?BlobSASPermissions.parse(e.permissions.toString()).toString():ContainerSASPermissions.parse(e.permissions.toString()).toString());const r=[o||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(n.accountName,e.containerName,e.blobName),n.userDelegationKey.signedObjectId,n.userDelegationKey.signedTenantId,n.userDelegationKey.signedStartsOn?truncatedISO8061Date(n.userDelegationKey.signedStartsOn,!1):"",n.userDelegationKey.signedExpiresOn?truncatedISO8061Date(n.userDelegationKey.signedExpiresOn,!1):"",n.userDelegationKey.signedService,n.userDelegationKey.signedVersion,e.preauthorizedAgentObjectId,void 0,e.correlationId,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",e.version,i,t,e.encryptionScope,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType].join("\n"),s=n.computeHMACSHA256(r);return new SASQueryParameters(e.version,s,o,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier,i,e.cacheControl,e.contentDisposition,e.contentEncoding,e.contentLanguage,e.contentType,n.userDelegationKey,e.preauthorizedAgentObjectId,e.correlationId,e.encryptionScope)}function getCanonicalName(e,n,o){const i=[`/blob/${e}/${n}`];return o&&i.push(`/${o}`),i.join("")}function SASSignatureValuesSanityCheckAndAutofill(e){const n=e.version?e.version:SERVICE_VERSION;if(e.snapshotTime&&n<"2018-11-09")throw RangeError("'version' must be >= '2018-11-09' when providing 'snapshotTime'.");if(void 0===e.blobName&&e.snapshotTime)throw RangeError("Must provide 'blobName' when providing 'snapshotTime'.");if(e.versionId&&n<"2019-10-10")throw RangeError("'version' must be >= '2019-10-10' when providing 'versionId'.");if(void 0===e.blobName&&e.versionId)throw RangeError("Must provide 'blobName' when providing 'versionId'.");if(e.permissions&&e.permissions.setImmutabilityPolicy&&n<"2020-08-04")throw RangeError("'version' must be >= '2020-08-04' when provided 'i' permission.");if(e.permissions&&e.permissions.deleteVersion&&n<"2019-10-10")throw RangeError("'version' must be >= '2019-10-10' when providing 'x' permission.");if(e.permissions&&e.permissions.permanentDelete&&n<"2019-10-10")throw RangeError("'version' must be >= '2019-10-10' when providing 'y' permission.");if(e.permissions&&e.permissions.tag&&n<"2019-12-12")throw RangeError("'version' must be >= '2019-12-12' when providing 't' permission.");if(n<"2020-02-10"&&e.permissions&&(e.permissions.move||e.permissions.execute))throw RangeError("'version' must be >= '2020-02-10' when providing the 'm' or 'e' permission.");if(n<"2021-04-10"&&e.permissions&&e.permissions.filterByTags)throw RangeError("'version' must be >= '2021-04-10' when providing the 'f' permission.");if(n<"2020-02-10"&&(e.preauthorizedAgentObjectId||e.correlationId))throw RangeError("'version' must be >= '2020-02-10' when providing 'preauthorizedAgentObjectId' or 'correlationId'.");if(e.encryptionScope&&n<"2020-12-06")throw RangeError("'version' must be >= '2020-12-06' when provided 'encryptionScope' in SAS.");return e.version=n,e}