import{HttpHeaders,isNode,URLBuilder}from"@azure/core-http";import{DevelopmentConnectionString,HeaderConstants,URLConstants}from"./constants";export function escapeURLPath(e){const t=URLBuilder.parse(e);let n=t.getPath();return n=n||"/",n=escape(n),t.setPath(n),t.toString()}function getProxyUriFromDevConnString(e){let t="";if(-1!==e.search("DevelopmentStorageProxyUri=")){const n=e.split(";");for(const e of n)e.trim().startsWith("DevelopmentStorageProxyUri=")&&(t=e.trim().match("DevelopmentStorageProxyUri=(.*)")[1])}return t}export function getValueInConnString(e,t){const n=e.split(";");for(const e of n)if(e.trim().startsWith(t))return e.trim().match(t+"=(.*)")[1];return""}export function extractConnectionStringParts(e){let t="";e.startsWith("UseDevelopmentStorage=true")&&(t=getProxyUriFromDevConnString(e),e=DevelopmentConnectionString);let n=getValueInConnString(e,"BlobEndpoint");if(n=n.endsWith("/")?n.slice(0,-1):n,-1!==e.search("DefaultEndpointsProtocol=")&&-1!==e.search("AccountKey=")){let o="",r="",a=Buffer.from("accountKey","base64"),i="";if(r=getValueInConnString(e,"AccountName"),a=Buffer.from(getValueInConnString(e,"AccountKey"),"base64"),!n){o=getValueInConnString(e,"DefaultEndpointsProtocol");const t=o.toLowerCase();if("https"!==t&&"http"!==t)throw new Error("Invalid DefaultEndpointsProtocol in the provided Connection String. Expecting 'https' or 'http'");if(i=getValueInConnString(e,"EndpointSuffix"),!i)throw new Error("Invalid EndpointSuffix in the provided Connection String");n=`${o}://${r}.blob.${i}`}if(!r)throw new Error("Invalid AccountName in the provided Connection String");if(0===a.length)throw new Error("Invalid AccountKey in the provided Connection String");return{kind:"AccountConnString",url:n,accountName:r,accountKey:a,proxyUri:t}}{const t=getValueInConnString(e,"SharedAccessSignature"),o=getAccountNameFromUrl(n);if(!n)throw new Error("Invalid BlobEndpoint in the provided SAS Connection String");if(!t)throw new Error("Invalid SharedAccessSignature in the provided SAS Connection String");return{kind:"SASConnString",url:n,accountName:o,accountSas:t}}}function escape(e){return encodeURIComponent(e).replace(/%2F/g,"/").replace(/'/g,"%27").replace(/\+/g,"%20").replace(/%25/g,"%")}export function appendToURLPath(e,t){const n=URLBuilder.parse(e);let o=n.getPath();return o=o?o.endsWith("/")?`${o}${t}`:`${o}/${t}`:t,n.setPath(o),n.toString()}export function setURLParameter(e,t,n){const o=URLBuilder.parse(e);return o.setQueryParameter(t,n),o.toString()}export function getURLParameter(e,t){return URLBuilder.parse(e).getQueryParameterValue(t)}export function setURLHost(e,t){const n=URLBuilder.parse(e);return n.setHost(t),n.toString()}export function getURLPath(e){return URLBuilder.parse(e).getPath()}export function getURLScheme(e){return URLBuilder.parse(e).getScheme()}export function getURLPathAndQuery(e){const t=URLBuilder.parse(e),n=t.getPath();if(!n)throw new RangeError("Invalid url without valid path.");let o=t.getQuery()||"";return o=o.trim(),""!==o&&(o=o.startsWith("?")?o:`?${o}`),`${n}${o}`}export function getURLQueries(e){let t=URLBuilder.parse(e).getQuery();if(!t)return{};t=t.trim(),t=t.startsWith("?")?t.substr(1):t;let n=t.split("&");n=n.filter((e=>{const t=e.indexOf("="),n=e.lastIndexOf("=");return t>0&&t===n&&n<e.length-1}));const o={};for(const e of n){const t=e.split("="),n=t[0],r=t[1];o[n]=r}return o}export function appendToURLQuery(e,t){const n=URLBuilder.parse(e);let o=n.getQuery();return o?o+="&"+t:o=t,n.setQuery(o),n.toString()}export function truncatedISO8061Date(e,t=!0){const n=e.toISOString();return t?n.substring(0,n.length-1)+"0000Z":n.substring(0,n.length-5)+"Z"}export function base64encode(e){return isNode?Buffer.from(e).toString("base64"):btoa(e)}export function base64decode(e){return isNode?Buffer.from(e,"base64").toString():atob(e)}export function generateBlockID(e,t){e.length>42&&(e=e.slice(0,42));return base64encode(e+padStart(t.toString(),48-e.length,"0"))}export async function delay(e,t,n){return new Promise(((o,r)=>{let a;const i=()=>{void 0!==a&&clearTimeout(a),r(n)};a=setTimeout((()=>{void 0!==t&&t.removeEventListener("abort",i),o()}),e),void 0!==t&&t.addEventListener("abort",i)}))}export function padStart(e,t,n=" "){return String.prototype.padStart?e.padStart(t,n):(n=n||" ",e.length>t?e:((t-=e.length)>n.length&&(n+=n.repeat(t/n.length)),n.slice(0,t)+e))}export function sanitizeURL(e){let t=e;return getURLParameter(t,URLConstants.Parameters.SIGNATURE)&&(t=setURLParameter(t,URLConstants.Parameters.SIGNATURE,"*****")),t}export function sanitizeHeaders(e){const t=new HttpHeaders;for(const n of e.headersArray())n.name.toLowerCase()===HeaderConstants.AUTHORIZATION.toLowerCase()?t.set(n.name,"*****"):n.name.toLowerCase()===HeaderConstants.X_MS_COPY_SOURCE?t.set(n.name,sanitizeURL(n.value)):t.set(n.name,n.value);return t}export function iEqual(e,t){return e.toLocaleLowerCase()===t.toLocaleLowerCase()}export function getAccountNameFromUrl(e){const t=URLBuilder.parse(e);let n;try{return n="blob"===t.getHost().split(".")[1]?t.getHost().split(".")[0]:isIpEndpointStyle(t)?t.getPath().split("/")[1]:"",n}catch(e){throw new Error("Unable to extract accountName with provided information.")}}export function isIpEndpointStyle(e){if(void 0===e.getHost())return!1;const t=e.getHost()+(void 0===e.getPort()?"":":"+e.getPort());return/^.*:.*:.*$|^localhost(:[0-9]+)?$|^(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])(\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])){3}(:[0-9]+)?$/.test(t)}export function toBlobTagsString(e){if(void 0===e)return;const t=[];for(const n in e)if(Object.prototype.hasOwnProperty.call(e,n)){const o=e[n];t.push(`${encodeURIComponent(n)}=${encodeURIComponent(o)}`)}return t.join("&")}export function toBlobTags(e){if(void 0===e)return;const t={blobTagSet:[]};for(const n in e)if(Object.prototype.hasOwnProperty.call(e,n)){const o=e[n];t.blobTagSet.push({key:n,value:o})}return t}export function toTags(e){if(void 0===e)return;const t={};for(const n of e.blobTagSet)t[n.key]=n.value;return t}export function toQuerySerialization(e){if(void 0!==e)switch(e.kind){case"csv":return{format:{type:"delimited",delimitedTextConfiguration:{columnSeparator:e.columnSeparator||",",fieldQuote:e.fieldQuote||"",recordSeparator:e.recordSeparator,escapeChar:e.escapeCharacter||"",headersPresent:e.hasHeaders||!1}}};case"json":return{format:{type:"json",jsonTextConfiguration:{recordSeparator:e.recordSeparator}}};case"arrow":return{format:{type:"arrow",arrowConfiguration:{schema:e.schema}}};case"parquet":return{format:{type:"parquet"}};default:throw Error("Invalid BlobQueryTextConfiguration.")}}export function parseObjectReplicationRecord(e){if(!e)return;if("policy-id"in e)return;const t=[];for(const n in e){const o=n.split("_"),r="or-";o[0].startsWith(r)&&(o[0]=o[0].substring(r.length));const a={ruleId:o[1],replicationStatus:e[n]},i=t.findIndex((e=>e.policyId===o[0]));i>-1?t[i].rules.push(a):t.push({policyId:o[0],rules:[a]})}return t}export function attachCredential(e,t){return e.credential=t,e}export function httpAuthorizationToString(e){return e?e.scheme+" "+e.value:void 0}export function BlobNameToString(e){return e.encoded?decodeURIComponent(e.content):e.content}export function ConvertInternalResponseOfListBlobFlat(e){return Object.assign(Object.assign({},e),{segment:{blobItems:e.segment.blobItems.map((e=>Object.assign(Object.assign({},e),{name:BlobNameToString(e.name)})))}})}export function ConvertInternalResponseOfListBlobHierarchy(e){var t;return Object.assign(Object.assign({},e),{segment:{blobPrefixes:null===(t=e.segment.blobPrefixes)||void 0===t?void 0:t.map((e=>({name:BlobNameToString(e.name)}))),blobItems:e.segment.blobItems.map((e=>Object.assign(Object.assign({},e),{name:BlobNameToString(e.name)})))}})}function decodeBase64String(e){if(isNode)return Buffer.from(e,"base64");{const t=atob(e),n=new Uint8Array(t.length);for(let e=0;e<t.length;e++)n[e]=t.charCodeAt(e);return n}}function ParseBoolean(e){if(void 0!==e)return"true"===e||"false"!==e&&void 0}function ParseBlobName(e){return void 0!==e.$&&void 0!==e["#"]?{encoded:ParseBoolean(e.$.Encoded),content:e["#"]}:{encoded:!1,content:e}}function ParseBlobProperties(e){const t=e;return e["Creation-Time"]&&(t.createdOn=new Date(e["Creation-Time"]),delete t["Creation-Time"]),e["Last-Modified"]&&(t.lastModified=new Date(e["Last-Modified"]),delete t["Last-Modified"]),e.Etag&&(t.etag=e.Etag,delete t.Etag),e["Content-Length"]&&(t.contentLength=parseFloat(e["Content-Length"]),delete t["Content-Length"]),e["Content-Type"]&&(t.contentType=e["Content-Type"],delete t["Content-Type"]),e["Content-Encoding"]&&(t.contentEncoding=e["Content-Encoding"],delete t["Content-Encoding"]),e["Content-Language"]&&(t.contentLanguage=e["Content-Language"],delete t["Content-Language"]),e["Content-MD5"]&&(t.contentMD5=decodeBase64String(e["Content-MD5"]),delete t["Content-MD5"]),e["Content-Disposition"]&&(t.contentDisposition=e["Content-Disposition"],delete t["Content-Disposition"]),e["Cache-Control"]&&(t.cacheControl=e["Cache-Control"],delete t["Cache-Control"]),e["x-ms-blob-sequence-number"]&&(t.blobSequenceNumber=parseFloat(e["x-ms-blob-sequence-number"]),delete t["x-ms-blob-sequence-number"]),e.BlobType&&(t.blobType=e.BlobType,delete t.BlobType),e.LeaseStatus&&(t.leaseStatus=e.LeaseStatus,delete t.LeaseStatus),e.LeaseState&&(t.leaseState=e.LeaseState,delete t.LeaseState),e.LeaseDuration&&(t.leaseDuration=e.LeaseDuration,delete t.LeaseDuration),e.CopyId&&(t.copyId=e.CopyId,delete t.CopyId),e.CopyStatus&&(t.copyStatus=e.CopyStatus,delete t.CopyStatus),e.CopySource&&(t.copySource=e.CopySource,delete t.CopySource),e.CopyProgress&&(t.copyProgress=e.CopyProgress,delete t.CopyProgress),e.CopyCompletionTime&&(t.copyCompletedOn=new Date(e.CopyCompletionTime),delete t.CopyCompletionTime),e.CopyStatusDescription&&(t.copyStatusDescription=e.CopyStatusDescription,delete t.CopyStatusDescription),e.ServerEncrypted&&(t.serverEncrypted=ParseBoolean(e.ServerEncrypted),delete t.ServerEncrypted),e.IncrementalCopy&&(t.incrementalCopy=ParseBoolean(e.IncrementalCopy),delete t.IncrementalCopy),e.DestinationSnapshot&&(t.destinationSnapshot=e.DestinationSnapshot,delete t.DestinationSnapshot),e.DeletedTime&&(t.deletedOn=new Date(e.DeletedTime),delete t.DeletedTime),e.RemainingRetentionDays&&(t.remainingRetentionDays=parseFloat(e.RemainingRetentionDays),delete t.RemainingRetentionDays),e.AccessTier&&(t.accessTier=e.AccessTier,delete t.AccessTier),e.AccessTierInferred&&(t.accessTierInferred=ParseBoolean(e.AccessTierInferred),delete t.AccessTierInferred),e.ArchiveStatus&&(t.archiveStatus=e.ArchiveStatus,delete t.ArchiveStatus),e.CustomerProvidedKeySha256&&(t.customerProvidedKeySha256=e.CustomerProvidedKeySha256,delete t.CustomerProvidedKeySha256),e.EncryptionScope&&(t.encryptionScope=e.EncryptionScope,delete t.EncryptionScope),e.AccessTierChangeTime&&(t.accessTierChangedOn=new Date(e.AccessTierChangeTime),delete t.AccessTierChangeTime),e.TagCount&&(t.tagCount=parseFloat(e.TagCount),delete t.TagCount),e["Expiry-Time"]&&(t.expiresOn=new Date(e["Expiry-Time"]),delete t["Expiry-Time"]),e.Sealed&&(t.isSealed=ParseBoolean(e.Sealed),delete t.Sealed),e.RehydratePriority&&(t.rehydratePriority=e.RehydratePriority,delete t.RehydratePriority),e.LastAccessTime&&(t.lastAccessedOn=new Date(e.LastAccessTime),delete t.LastAccessTime),e.ImmutabilityPolicyUntilDate&&(t.immutabilityPolicyExpiresOn=new Date(e.ImmutabilityPolicyUntilDate),delete t.ImmutabilityPolicyUntilDate),e.ImmutabilityPolicyMode&&(t.immutabilityPolicyMode=e.ImmutabilityPolicyMode,delete t.ImmutabilityPolicyMode),e.LegalHold&&(t.legalHold=ParseBoolean(e.LegalHold),delete t.LegalHold),t}function ParseBlobItem(e){const t=e;return t.properties=ParseBlobProperties(e.Properties),delete t.Properties,t.name=ParseBlobName(e.Name),delete t.Name,t.deleted=ParseBoolean(e.Deleted),delete t.Deleted,e.Snapshot&&(t.snapshot=e.Snapshot,delete t.Snapshot),e.VersionId&&(t.versionId=e.VersionId,delete t.VersionId),e.IsCurrentVersion&&(t.isCurrentVersion=ParseBoolean(e.IsCurrentVersion),delete t.IsCurrentVersion),e.Metadata&&(t.metadata=e.Metadata,delete t.Metadata),e.Tags&&(t.blobTags=ParseBlobTags(e.Tags),delete t.Tags),e.OrMetadata&&(t.objectReplicationMetadata=e.OrMetadata,delete t.OrMetadata),e.HasVersionsOnly&&(t.hasVersionsOnly=ParseBoolean(e.HasVersionsOnly),delete t.HasVersionsOnly),t}function ParseBlobPrefix(e){return{name:ParseBlobName(e.Name)}}function ParseBlobTag(e){return{key:e.Key,value:e.Value}}function ParseBlobTags(e){if(void 0===e||void 0===e.TagSet||void 0===e.TagSet.Tag)return;const t=[];return e.TagSet.Tag instanceof Array?e.TagSet.Tag.forEach((e=>{t.push(ParseBlobTag(e))})):t.push(ParseBlobTag(e.TagSet.Tag)),{blobTagSet:t}}export function ProcessBlobItems(e){const t=[];return e instanceof Array?e.forEach((e=>{t.push(ParseBlobItem(e))})):t.push(ParseBlobItem(e)),t}export function ProcessBlobPrefixes(e){const t=[];return e instanceof Array?e.forEach((e=>{t.push(ParseBlobPrefix(e))})):t.push(ParseBlobPrefix(e)),t}export function*ExtractPageRangeInfoItems(e){let t=[],n=[];e.pageRange&&(t=e.pageRange),e.clearRange&&(n=e.clearRange);let o=0,r=0;for(;o<t.length&&r<n.length;)t[o].start<n[r].start?(yield{start:t[o].start,end:t[o].end,isClear:!1},++o):(yield{start:n[r].start,end:n[r].end,isClear:!0},++r);for(;o<t.length;++o)yield{start:t[o].start,end:t[o].end,isClear:!1};for(;r<n.length;++r)yield{start:n[r].start,end:n[r].end,isClear:!0}}