export class AvroParser{static async readFixedBytes(r,e,t={}){const a=await r.read(e,{abortSignal:t.abortSignal});if(a.length!==e)throw new Error("Hit stream end.");return a}static async readByte(r,e={}){return(await AvroParser.readFixedBytes(r,1,e))[0]}static async readZigZagLong(r,e={}){let t,a,o,s=0,i=0;do{t=await AvroParser.readByte(r,e),a=128&t,s|=(127&t)<<i,i+=7}while(a&&i<28);if(a){o=268435456;do{t=await AvroParser.readByte(r,e),s+=(127&t)*o,o*=128}while(128&t);const a=(s%2?-(s+1):s)/2;if(a<Number.MIN_SAFE_INTEGER||a>Number.MAX_SAFE_INTEGER)throw new Error("Integer overflow.");return a}return s>>1^-(1&s)}static async readLong(r,e={}){return AvroParser.readZigZagLong(r,e)}static async readInt(r,e={}){return AvroParser.readZigZagLong(r,e)}static async readNull(){return null}static async readBoolean(r,e={}){const t=await AvroParser.readByte(r,e);if(1===t)return!0;if(0===t)return!1;throw new Error("Byte was not a boolean.")}static async readFloat(r,e={}){const t=await AvroParser.readFixedBytes(r,4,e);return new DataView(t.buffer,t.byteOffset,t.byteLength).getFloat32(0,!0)}static async readDouble(r,e={}){const t=await AvroParser.readFixedBytes(r,8,e);return new DataView(t.buffer,t.byteOffset,t.byteLength).getFloat64(0,!0)}static async readBytes(r,e={}){const t=await AvroParser.readLong(r,e);if(t<0)throw new Error("Bytes size was negative.");return r.read(t,{abortSignal:e.abortSignal})}static async readString(r,e={}){const t=await AvroParser.readBytes(r,e);return(new TextDecoder).decode(t)}static async readMapPair(r,e,t={}){return{key:await AvroParser.readString(r,t),value:await e(r,t)}}static async readMap(r,e,t={}){const a=await AvroParser.readArray(r,((r,t={})=>AvroParser.readMapPair(r,e,t)),t),o={};for(const r of a)o[r.key]=r.value;return o}static async readArray(r,e,t={}){const a=[];for(let o=await AvroParser.readLong(r,t);0!==o;o=await AvroParser.readLong(r,t))for(o<0&&(await AvroParser.readLong(r,t),o=-o);o--;){const o=await e(r,t);a.push(o)}return a}}var AvroComplex,AvroPrimitive;!function(r){r.RECORD="record",r.ENUM="enum",r.ARRAY="array",r.MAP="map",r.UNION="union",r.FIXED="fixed"}(AvroComplex||(AvroComplex={})),function(r){r.NULL="null",r.BOOLEAN="boolean",r.INT="int",r.LONG="long",r.FLOAT="float",r.DOUBLE="double",r.BYTES="bytes",r.STRING="string"}(AvroPrimitive||(AvroPrimitive={}));export class AvroType{static fromSchema(r){return"string"==typeof r?AvroType.fromStringSchema(r):Array.isArray(r)?AvroType.fromArraySchema(r):AvroType.fromObjectSchema(r)}static fromStringSchema(r){switch(r){case AvroPrimitive.NULL:case AvroPrimitive.BOOLEAN:case AvroPrimitive.INT:case AvroPrimitive.LONG:case AvroPrimitive.FLOAT:case AvroPrimitive.DOUBLE:case AvroPrimitive.BYTES:case AvroPrimitive.STRING:return new AvroPrimitiveType(r);default:throw new Error(`Unexpected Avro type ${r}`)}}static fromArraySchema(r){return new AvroUnionType(r.map(AvroType.fromSchema))}static fromObjectSchema(r){const e=r.type;try{return AvroType.fromStringSchema(e)}catch(r){}switch(e){case AvroComplex.RECORD:if(r.aliases)throw new Error(`aliases currently is not supported, schema: ${r}`);if(!r.name)throw new Error(`Required attribute 'name' doesn't exist on schema: ${r}`);const t={};if(!r.fields)throw new Error(`Required attribute 'fields' doesn't exist on schema: ${r}`);for(const e of r.fields)t[e.name]=AvroType.fromSchema(e.type);return new AvroRecordType(t,r.name);case AvroComplex.ENUM:if(r.aliases)throw new Error(`aliases currently is not supported, schema: ${r}`);if(!r.symbols)throw new Error(`Required attribute 'symbols' doesn't exist on schema: ${r}`);return new AvroEnumType(r.symbols);case AvroComplex.MAP:if(!r.values)throw new Error(`Required attribute 'values' doesn't exist on schema: ${r}`);return new AvroMapType(AvroType.fromSchema(r.values));case AvroComplex.ARRAY:case AvroComplex.FIXED:default:throw new Error(`Unexpected Avro type ${e} in ${r}`)}}}class AvroPrimitiveType extends AvroType{constructor(r){super(),this._primitive=r}read(r,e={}){switch(this._primitive){case AvroPrimitive.NULL:return AvroParser.readNull();case AvroPrimitive.BOOLEAN:return AvroParser.readBoolean(r,e);case AvroPrimitive.INT:return AvroParser.readInt(r,e);case AvroPrimitive.LONG:return AvroParser.readLong(r,e);case AvroPrimitive.FLOAT:return AvroParser.readFloat(r,e);case AvroPrimitive.DOUBLE:return AvroParser.readDouble(r,e);case AvroPrimitive.BYTES:return AvroParser.readBytes(r,e);case AvroPrimitive.STRING:return AvroParser.readString(r,e);default:throw new Error("Unknown Avro Primitive")}}}class AvroEnumType extends AvroType{constructor(r){super(),this._symbols=r}async read(r,e={}){const t=await AvroParser.readInt(r,e);return this._symbols[t]}}class AvroUnionType extends AvroType{constructor(r){super(),this._types=r}async read(r,e={}){const t=await AvroParser.readInt(r,e);return this._types[t].read(r,e)}}class AvroMapType extends AvroType{constructor(r){super(),this._itemType=r}read(r,e={}){return AvroParser.readMap(r,((r,e)=>this._itemType.read(r,e)),e)}}class AvroRecordType extends AvroType{constructor(r,e){super(),this._fields=r,this._name=e}async read(r,e={}){const t={};t.$schema=this._name;for(const a in this._fields)Object.prototype.hasOwnProperty.call(this._fields,a)&&(t[a]=await this._fields[a].read(r,e));return t}}