import{BaseRequestPolicy,deserializationPolicy,HttpHeaders,RequestPolicyOptions,WebResource,proxyPolicy,isNode,isTokenCredential,bearerTokenAuthenticationPolicy,tracingPolicy,logPolicy,generateClientRequestIdPolicy,keepAlivePolicy}from"@azure/core-http";import{logger}from"./log";import{StorageBrowserPolicyFactory}from"./StorageBrowserPolicyFactory";import{StorageRetryPolicyFactory}from"./StorageRetryPolicyFactory";import{TelemetryPolicyFactory}from"./TelemetryPolicyFactory";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{StorageOAuthScopes,StorageQueueLoggingAllowedHeaderNames,StorageQueueLoggingAllowedQueryParameters}from"./utils/constants";import{getCachedDefaultHttpClient}from"./utils/cache";export{BaseRequestPolicy,StorageOAuthScopes,deserializationPolicy,HttpHeaders,WebResource,RequestPolicyOptions};export class Pipeline{constructor(e,o={}){this.factories=e,this.options=Object.assign(Object.assign({},o),{httpClient:o.httpClient||getCachedDefaultHttpClient()})}toServiceClientOptions(){return{httpClient:this.options.httpClient,requestPolicyFactories:this.factories}}}export function newPipeline(e,o={}){void 0===e&&(e=new AnonymousCredential);const t=new TelemetryPolicyFactory(o.userAgentOptions),r=[tracingPolicy({userAgent:t.telemetryString}),keepAlivePolicy(o.keepAliveOptions),t,generateClientRequestIdPolicy(),new StorageBrowserPolicyFactory,new StorageRetryPolicyFactory(o.retryOptions),deserializationPolicy(),logPolicy({logger:logger.info,allowedHeaderNames:StorageQueueLoggingAllowedHeaderNames,allowedQueryParameters:StorageQueueLoggingAllowedQueryParameters})];return isNode&&r.push(proxyPolicy(o.proxyOptions)),r.push(isTokenCredential(e)?bearerTokenAuthenticationPolicy(e,StorageOAuthScopes):e),new Pipeline(r,o)}