import{isTokenCredential,isNode,getDefaultProxySettings,URLBuilder}from"@azure/core-http";import{SpanStatusCode}from"@azure/core-tracing";import{Messages,MessageId,Queue}from"./generated/src/operations";import{newPipeline,Pipeline}from"./Pipeline";import{StorageClient}from"./StorageClient";import{appendToURLPath,extractConnectionStringParts,isIpEndpointStyle,truncatedISO8061Date,getStorageClientContext,appendToURLQuery}from"./utils/utils.common";import{StorageSharedKeyCredential}from"./credentials/StorageSharedKeyCredential";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{createSpan}from"./utils/tracing";import{generateQueueSASQueryParameters}from"./QueueSASSignatureValues";export class QueueClient extends StorageClient{constructor(e,t,s){let a,n;if(s=s||{},t instanceof Pipeline)n=e,a=t;else if(isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t))n=e,a=newPipeline(t,s);else if(t||"string"==typeof t){if(!t||"string"!=typeof t)throw new Error("Expecting non-empty strings for queueName parameter");{const i=extractConnectionStringParts(e);if("AccountConnString"===i.kind){if(!isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=t,r=new StorageSharedKeyCredential(i.accountName,i.accountKey);n=appendToURLPath(i.url,e),s.proxyOptions||(s.proxyOptions=getDefaultProxySettings(i.proxyUri)),a=newPipeline(r,s)}}else{if("SASConnString"!==i.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");{const e=t;n=appendToURLPath(i.url,e)+"?"+i.accountSas,a=newPipeline(new AnonymousCredential,s)}}}}else n=e,a=newPipeline(new AnonymousCredential,s);super(n,a),this._name=this.getQueueNameFromUrl(),this.queueContext=new Queue(this.storageClientContext);const i=this.url.split("?");this._messagesUrl=i[1]?appendToURLPath(i[0],"messages")+"?"+i[1]:appendToURLPath(i[0],"messages"),this.messagesContext=new Messages(getStorageClientContext(this._messagesUrl,this.pipeline))}get name(){return this._name}getMessageIdContext(e){const t=this._messagesUrl.split("?"),s=t[1]?appendToURLPath(t[0],e)+"?"+t[1]:appendToURLPath(t[0],e);return new MessageId(getStorageClientContext(s,this.pipeline))}async create(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-create",e);try{return await this.queueContext.create(Object.assign(Object.assign({},s),{abortSignal:e.abortSignal}))}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async createIfNotExists(e={}){var t,s;const{span:a,updatedOptions:n}=createSpan("QueueClient-createIfNotExists",e);try{const e=await this.create(n);return 204===e._response.status?Object.assign({succeeded:!1},e):Object.assign({succeeded:!0},e)}catch(e){if("QueueAlreadyExists"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return a.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when creating a queue only if it does not already exist."}),Object.assign(Object.assign({succeeded:!1},null===(s=e.response)||void 0===s?void 0:s.parsedHeaders),{_response:e.response});throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}async deleteIfExists(e={}){var t,s;const{span:a,updatedOptions:n}=createSpan("QueueClient-deleteIfExists",e);try{const e=await this.delete(n);return Object.assign({succeeded:!0},e)}catch(e){if("QueueNotFound"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return a.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when deleting a queue only if it exists."}),Object.assign(Object.assign({succeeded:!1},null===(s=e.response)||void 0===s?void 0:s.parsedHeaders),{_response:e.response});throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}async delete(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-delete",e);try{return await this.queueContext.delete({abortSignal:e.abortSignal,tracingOptions:s.tracingOptions})}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async exists(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-exists",e);try{return await this.getProperties({abortSignal:e.abortSignal,tracingOptions:s.tracingOptions}),!0}catch(e){if(404===e.statusCode)return t.setStatus({code:SpanStatusCode.ERROR,message:"Expected exception when checking queue existence"}),!1;throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async getProperties(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-getProperties",e);try{return await this.queueContext.getProperties({abortSignal:e.abortSignal,tracingOptions:s.tracingOptions})}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setMetadata(e,t={}){const{span:s,updatedOptions:a}=createSpan("QueueClient-setMetadata",t);try{return await this.queueContext.setMetadata({abortSignal:t.abortSignal,metadata:e,tracingOptions:a.tracingOptions})}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async getAccessPolicy(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-getAccessPolicy",e);try{const t=await this.queueContext.getAccessPolicy({abortSignal:e.abortSignal,tracingOptions:s.tracingOptions}),a={_response:t._response,date:t.date,requestId:t.requestId,clientRequestId:t.clientRequestId,signedIdentifiers:[],version:t.version,errorCode:t.errorCode};for(const e of t){let t;e.accessPolicy&&(t={permissions:e.accessPolicy.permissions},e.accessPolicy.expiresOn&&(t.expiresOn=new Date(e.accessPolicy.expiresOn)),e.accessPolicy.startsOn&&(t.startsOn=new Date(e.accessPolicy.startsOn))),a.signedIdentifiers.push({accessPolicy:t,id:e.id})}return a}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setAccessPolicy(e,t={}){const{span:s,updatedOptions:a}=createSpan("QueueClient-setAccessPolicy",t);try{const s=[];for(const t of e||[])s.push({accessPolicy:{expiresOn:t.accessPolicy.expiresOn?truncatedISO8061Date(t.accessPolicy.expiresOn):void 0,permissions:t.accessPolicy.permissions,startsOn:t.accessPolicy.startsOn?truncatedISO8061Date(t.accessPolicy.startsOn):void 0},id:t.id});return await this.queueContext.setAccessPolicy({abortSignal:t.abortSignal,queueAcl:s,tracingOptions:a.tracingOptions})}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async clearMessages(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-clearMessages",e);try{return await this.messagesContext.clear({abortSignal:e.abortSignal,tracingOptions:s.tracingOptions})}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async sendMessage(e,t={}){const{span:s,updatedOptions:a}=createSpan("QueueClient-sendMessage",t);try{const t=await this.messagesContext.enqueue({messageText:e},a),s=t[0];return{_response:t._response,date:t.date,requestId:t.requestId,clientRequestId:t.clientRequestId,version:t.version,errorCode:t.errorCode,messageId:s.messageId,popReceipt:s.popReceipt,nextVisibleOn:s.nextVisibleOn,insertedOn:s.insertedOn,expiresOn:s.expiresOn}}catch(e){throw s.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async receiveMessages(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-receiveMessages",e);try{const e=await this.messagesContext.dequeue(s),t={_response:e._response,date:e.date,requestId:e.requestId,clientRequestId:e.clientRequestId,receivedMessageItems:[],version:e.version,errorCode:e.errorCode};for(const s of e)t.receivedMessageItems.push(s);return t}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async peekMessages(e={}){const{span:t,updatedOptions:s}=createSpan("QueueClient-peekMessages",e);try{const e=await this.messagesContext.peek(s),t={_response:e._response,date:e.date,requestId:e.requestId,clientRequestId:e.clientRequestId,peekedMessageItems:[],version:e.version,errorCode:e.errorCode};for(const s of e)t.peekedMessageItems.push(s);return t}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async deleteMessage(e,t,s={}){const{span:a,updatedOptions:n}=createSpan("QueueClient-deleteMessage",s);try{return await this.getMessageIdContext(e).delete(t,{abortSignal:s.abortSignal,tracingOptions:n.tracingOptions})}catch(e){throw a.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{a.end()}}async updateMessage(e,t,s,a,n={}){const{span:i,updatedOptions:r}=createSpan("QueueClient-updateMessage",n);let o;void 0!==s&&(o={messageText:s});try{return await this.getMessageIdContext(e).update(t,a||0,{abortSignal:n.abortSignal,tracingOptions:r.tracingOptions,queueMessage:o})}catch(e){throw i.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}getQueueNameFromUrl(){let e;try{const t=URLBuilder.parse(this.url);if(e="queue"===t.getHost().split(".")[1]?t.getPath().split("/")[1]:isIpEndpointStyle(t)?t.getPath().split("/")[2]:t.getPath().split("/")[1],!e)throw new Error("Provided queueName is invalid.");return e}catch(e){throw new Error("Unable to extract queueName with provided information.")}}generateSasUrl(e){if(!(this.credential instanceof StorageSharedKeyCredential))throw RangeError("Can only generate the SAS when the client is initialized with a shared key credential");const t=generateQueueSASQueryParameters(Object.assign({queueName:this.name},e),this.credential).toString();return appendToURLQuery(this.url,t)}}