import{__asyncDelegator,__asyncGenerator,__asyncValues,__await}from"tslib";import{isTokenCredential,isNode,getDefaultProxySettings}from"@azure/core-http";import{SpanStatusCode}from"@azure/core-tracing";import{Service}from"./generated/src/operations";import{newPipeline,Pipeline}from"./Pipeline";import{StorageClient}from"./StorageClient";import"@azure/core-paging";import{appendToURLPath,appendToURLQuery,extractConnectionStringParts}from"./utils/utils.common";import{StorageSharedKeyCredential}from"./credentials/StorageSharedKeyCredential";import{AnonymousCredential}from"./credentials/AnonymousCredential";import{createSpan}from"./utils/tracing";import{QueueClient}from"./QueueClient";import{AccountSASPermissions}from"./AccountSASPermissions";import{generateAccountSASQueryParameters}from"./AccountSASSignatureValues";import{AccountSASServices}from"./AccountSASServices";export class QueueServiceClient extends StorageClient{constructor(e,t,n){let i;i=t instanceof Pipeline?t:isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||isTokenCredential(t)?newPipeline(t,n):newPipeline(new AnonymousCredential,n),super(e,i),this.serviceContext=new Service(this.storageClientContext)}static fromConnectionString(e,t){t=t||{};const n=extractConnectionStringParts(e);if("AccountConnString"===n.kind){if(isNode){const e=new StorageSharedKeyCredential(n.accountName,n.accountKey);t.proxyOptions||(t.proxyOptions=getDefaultProxySettings(n.proxyUri));const i=newPipeline(e,t);return new QueueServiceClient(n.url,i)}throw new Error("Account connection string is only supported in Node.js environment")}if("SASConnString"===n.kind){const e=newPipeline(new AnonymousCredential,t);return new QueueServiceClient(n.url+"?"+n.accountSas,e)}throw new Error("Connection string must be either an Account connection string or a SAS connection string")}getQueueClient(e){return new QueueClient(appendToURLPath(this.url,e),this.pipeline)}async listQueuesSegment(e,t={}){const{span:n,updatedOptions:i}=createSpan("QueueServiceClient-listQueuesSegment",t);""===t.prefix&&(t.prefix=void 0);try{return await this.serviceContext.listQueuesSegment({abortSignal:t.abortSignal,marker:e,maxPageSize:t.maxPageSize,prefix:t.prefix,include:void 0===t.include?void 0:[t.include],tracingOptions:i.tracingOptions})}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}listSegments(e,t={}){return __asyncGenerator(this,arguments,(function*(){let n;""===t.prefix&&(t.prefix=void 0);do{n=yield __await(this.listQueuesSegment(e,t)),e=n.continuationToken,yield yield __await(yield __await(n))}while(e)}))}listItems(e={}){return __asyncGenerator(this,arguments,(function*(){var t,n;""===e.prefix&&(e.prefix=void 0);try{for(var i,r=__asyncValues(this.listSegments(undefined,e));!(i=yield __await(r.next())).done;){const e=i.value;e.queueItems&&(yield __await(yield*__asyncDelegator(__asyncValues(e.queueItems))))}}catch(e){t={error:e}}finally{try{i&&!i.done&&(n=r.return)&&(yield __await(n.call(r)))}finally{if(t)throw t.error}}}))}listQueues(e={}){""===e.prefix&&(e.prefix=void 0);const t=Object.assign(Object.assign({},e),e.includeMetadata?{include:"metadata"}:{}),n=this.listItems(t);return{next:()=>n.next(),[Symbol.asyncIterator](){return this},byPage:(e={})=>this.listSegments(e.continuationToken,Object.assign({maxPageSize:e.maxPageSize},t))}}async getProperties(e={}){const{span:t,updatedOptions:n}=createSpan("QueueServiceClient-getProperties",e);try{return await this.serviceContext.getProperties({abortSignal:e.abortSignal,tracingOptions:n.tracingOptions})}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setProperties(e,t={}){const{span:n,updatedOptions:i}=createSpan("QueueServiceClient-setProperties",t);try{return await this.serviceContext.setProperties(e,{abortSignal:t.abortSignal,tracingOptions:i.tracingOptions})}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async getStatistics(e={}){const{span:t,updatedOptions:n}=createSpan("QueueServiceClient-getStatistics",e);try{return await this.serviceContext.getStatistics({abortSignal:e.abortSignal,tracingOptions:n.tracingOptions})}catch(e){throw t.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async createQueue(e,t={}){const{span:n,updatedOptions:i}=createSpan("QueueServiceClient-createQueue",t);try{return await this.getQueueClient(e).create(i)}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}async deleteQueue(e,t={}){const{span:n,updatedOptions:i}=createSpan("QueueServiceClient-deleteQueue",t);try{return await this.getQueueClient(e).delete(i)}catch(e){throw n.setStatus({code:SpanStatusCode.ERROR,message:e.message}),e}finally{n.end()}}generateAccountSasUrl(e,t=AccountSASPermissions.parse("r"),n="sco",i={}){if(!(this.credential instanceof StorageSharedKeyCredential))throw RangeError("Can only generate the account SAS when the client is initialized with a shared key credential");if(void 0===e){const t=new Date;e=new Date(t.getTime()+36e5)}const r=generateAccountSASQueryParameters(Object.assign({permissions:t,expiresOn:e,resourceTypes:n,services:AccountSASServices.parse("q").toString()},i),this.credential).toString();return appendToURLQuery(this.url,r)}}