"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var coreHttp=require("@azure/core-http"),crypto=require("crypto"),logger$1=require("@azure/logger"),abortController=require("@azure/abort-controller"),os=require("os"),coreTracing=require("@azure/core-tracing"),tslib=require("tslib");function _interopNamespace(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(r){if("default"!==r){var s=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,s.get?s:{enumerable:!0,get:function(){return e[r]}})}})),t.default=e,Object.freeze(t)}require("@azure/core-paging");var coreHttp__namespace=_interopNamespace(coreHttp),os__namespace=_interopNamespace(os);class AccountSASPermissions{constructor(){this.read=!1,this.write=!1,this.delete=!1,this.list=!1,this.add=!1,this.create=!1,this.update=!1,this.process=!1}static parse(e){const t=new AccountSASPermissions;for(const r of e)switch(r){case"r":t.read=!0;break;case"w":t.write=!0;break;case"d":t.delete=!0;break;case"l":t.list=!0;break;case"a":t.add=!0;break;case"c":t.create=!0;break;case"u":t.update=!0;break;case"p":t.process=!0;break;default:throw new RangeError(`Invalid permission character: ${r}`)}return t}toString(){const e=[];return this.read&&e.push("r"),this.write&&e.push("w"),this.delete&&e.push("d"),this.list&&e.push("l"),this.add&&e.push("a"),this.create&&e.push("c"),this.update&&e.push("u"),this.process&&e.push("p"),e.join("")}}class AccountSASResourceTypes{constructor(){this.service=!1,this.container=!1,this.object=!1}static parse(e){const t=new AccountSASResourceTypes;for(const r of e)switch(r){case"s":t.service=!0;break;case"c":t.container=!0;break;case"o":t.object=!0;break;default:throw new RangeError(`Invalid resource type: ${r}`)}return t}toString(){const e=[];return this.service&&e.push("s"),this.container&&e.push("c"),this.object&&e.push("o"),e.join("")}}class AccountSASServices{constructor(){this.blob=!1,this.file=!1,this.queue=!1,this.table=!1}static parse(e){const t=new AccountSASServices;for(const r of e)switch(r){case"b":t.blob=!0;break;case"f":t.file=!0;break;case"q":t.queue=!0;break;case"t":t.table=!0;break;default:throw new RangeError(`Invalid service character: ${r}`)}return t}toString(){const e=[];return this.blob&&e.push("b"),this.table&&e.push("t"),this.queue&&e.push("q"),this.file&&e.push("f"),e.join("")}}function ipRangeToString(e){return e.end?`${e.start}-${e.end}`:e.start}const SDK_VERSION="12.10.0",SERVICE_VERSION="2021-08-06",StorageOAuthScopes="https://storage.azure.com/.default",URLConstants={Parameters:{FORCE_BROWSER_NO_CACHE:"_",SIGNATURE:"sig",TIMEOUT:"timeout"}},HeaderConstants={AUTHORIZATION:"authorization",AUTHORIZATION_SCHEME:"Bearer",CONTENT_ENCODING:"content-encoding",CONTENT_LANGUAGE:"content-language",CONTENT_LENGTH:"content-length",CONTENT_MD5:"content-md5",CONTENT_TYPE:"content-type",COOKIE:"Cookie",DATE:"date",IF_MATCH:"if-match",IF_MODIFIED_SINCE:"if-modified-since",IF_NONE_MATCH:"if-none-match",IF_UNMODIFIED_SINCE:"if-unmodified-since",PREFIX_FOR_STORAGE:"x-ms-",RANGE:"Range",USER_AGENT:"User-Agent",X_MS_CLIENT_REQUEST_ID:"x-ms-client-request-id",X_MS_COPY_SOURCE:"x-ms-copy-source",X_MS_DATE:"x-ms-date"},DevelopmentConnectionString="DefaultEndpointsProtocol=http;AccountName=devstoreaccount1;\n  AccountKey=Eby8vdM02xNOcqFlqUwJPLlmEtlCDXJ1OUzFT50uSRZ6IFsuFq2UVErCz4I6tq/K1SZFPTOtr/KBHBeksoGMGw==;\n  QueueEndpoint=http://127.0.0.1:10001/devstoreaccount1;",StorageQueueLoggingAllowedHeaderNames=["Access-Control-Allow-Origin","Cache-Control","Content-Length","Content-Type","Date","Request-Id","traceparent","Transfer-Encoding","User-Agent","x-ms-client-request-id","x-ms-date","x-ms-error-code","x-ms-request-id","x-ms-return-client-request-id","x-ms-version","x-ms-approximate-messages-count","x-ms-popreceipt","x-ms-time-next-visible"],StorageQueueLoggingAllowedQueryParameters=["comp","maxresults","rscc","rscd","rsce","rscl","rsct","se","si","sip","sp","spr","sr","srt","ss","st","sv","include","marker","prefix","messagettl","numofmessages","peekonly","popreceipt","visibilitytimeout"],packageName="azure-storage-queue",packageVersion="12.10.0";class StorageClientContext extends coreHttp__namespace.ServiceClient{constructor(e,t){if(void 0===e)throw new Error("'url' cannot be null");if(t||(t={}),!t.userAgent){const e=coreHttp__namespace.getDefaultUserAgentValue();t.userAgent=`${packageName}/12.10.0 ${e}`}super(void 0,t),this.requestContentType="application/json; charset=utf-8",this.baseUri=t.endpoint||"{url}",this.url=e,this.version=t.version||"2021-08-06"}}function appendToURLPath(e,t){const r=coreHttp.URLBuilder.parse(e);let s=r.getPath();return s=s?s.endsWith("/")?`${s}${t}`:`${s}/${t}`:t,r.setPath(s),r.toString()}function setURLParameter(e,t,r){const s=coreHttp.URLBuilder.parse(e);return s.setQueryParameter(t,r),s.toString()}function setURLHost(e,t){const r=coreHttp.URLBuilder.parse(e);return r.setHost(t),r.toString()}function getURLPath(e){return coreHttp.URLBuilder.parse(e).getPath()}function getURLQueries(e){let t=coreHttp.URLBuilder.parse(e).getQuery();if(!t)return{};t=t.trim(),t=t.startsWith("?")?t.substr(1):t;let r=t.split("&");r=r.filter((e=>{const t=e.indexOf("="),r=e.lastIndexOf("=");return t>0&&t===r&&r<e.length-1}));const s={};for(const e of r){const t=e.split("="),r=t[0],a=t[1];s[r]=a}return s}function getProxyUriFromDevConnString(e){let t="";if(-1!==e.search("DevelopmentStorageProxyUri=")){const r=e.split(";");for(const e of r)e.trim().startsWith("DevelopmentStorageProxyUri=")&&(t=e.trim().match("DevelopmentStorageProxyUri=(.*)")[1])}return t}function getValueInConnString(e,t){const r=e.split(";");for(const e of r)if(e.trim().startsWith(t))return e.trim().match(t+"=(.*)")[1];return""}function extractConnectionStringParts(e){let t="";e.startsWith("UseDevelopmentStorage=true")&&(t=getProxyUriFromDevConnString(e),e=DevelopmentConnectionString);let r=getValueInConnString(e,"QueueEndpoint");if(r=r.endsWith("/")?r.slice(0,-1):r,-1!==e.search("DefaultEndpointsProtocol=")&&-1!==e.search("AccountKey=")){let s="",a="",i=Buffer.from("accountKey","base64"),n="";if(a=getValueInConnString(e,"AccountName"),i=Buffer.from(getValueInConnString(e,"AccountKey"),"base64"),!r){s=getValueInConnString(e,"DefaultEndpointsProtocol");const t=s.toLowerCase();if("https"!==t&&"http"!==t)throw new Error("Invalid DefaultEndpointsProtocol in the provided Connection String. Expecting 'https' or 'http'");if(n=getValueInConnString(e,"EndpointSuffix"),!n)throw new Error("Invalid EndpointSuffix in the provided Connection String");r=`${s}://${a}.queue.${n}`}if(!a)throw new Error("Invalid AccountName in the provided Connection String");if(0===i.length)throw new Error("Invalid AccountKey in the provided Connection String");return{kind:"AccountConnString",url:r,accountName:a,accountKey:i,proxyUri:t}}{const t=getValueInConnString(e,"SharedAccessSignature"),s=getAccountNameFromUrl(r);if(!r)throw new Error("Invalid QueueEndpoint in the provided SAS Connection String");if(!t)throw new Error("Invalid SharedAccessSignature in the provided SAS Connection String");return{kind:"SASConnString",url:r,accountName:s,accountSas:t}}}function truncatedISO8061Date(e,t=!0){const r=e.toISOString();return t?r.substring(0,r.length-1)+"0000Z":r.substring(0,r.length-5)+"Z"}async function delay(e,t,r){return new Promise(((s,a)=>{let i;const n=()=>{void 0!==i&&clearTimeout(i),a(r)};i=setTimeout((()=>{void 0!==t&&t.removeEventListener("abort",n),s()}),e),void 0!==t&&t.addEventListener("abort",n)}))}function getAccountNameFromUrl(e){const t=coreHttp.URLBuilder.parse(e);let r;try{return r="queue"===t.getHost().split(".")[1]?t.getHost().split(".")[0]:isIpEndpointStyle(t)?t.getPath().split("/")[1]:"",r}catch(e){throw new Error("Unable to extract accountName with provided information.")}}function isIpEndpointStyle(e){if(void 0===e.getHost())return!1;const t=e.getHost()+(void 0===e.getPort()?"":":"+e.getPort());return/^.*:.*:.*$|^localhost(:[0-9]+)?$|^(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])(\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])){3}(:[0-9]+)?$/.test(t)}function getStorageClientContext(e,t){const r=new StorageClientContext(e,t.toServiceClientOptions());return r.requestContentType=void 0,r}function appendToURLQuery(e,t){const r=coreHttp.URLBuilder.parse(e);let s=r.getQuery();return s?s+="&"+t:s=t,r.setQuery(s),r.toString()}exports.SASProtocol=void 0,function(e){e.Https="https",e.HttpsAndHttp="https,http"}(exports.SASProtocol||(exports.SASProtocol={}));class SASQueryParameters{constructor(e,t,r,s,a,i,n,o,m,c,p){this.version=e,this.services=s,this.resourceTypes=a,this.expiresOn=o,this.permissions=r,this.protocol=i,this.startsOn=n,this.ipRangeInner=m,this.identifier=c,this.resource=p,this.signature=t}get ipRange(){if(this.ipRangeInner)return{end:this.ipRangeInner.end,start:this.ipRangeInner.start}}toString(){const e=["sv","ss","srt","spr","st","se","sip","si","sr","sp","sig"],t=[];for(const r of e)switch(r){case"sv":this.tryAppendQueryParameter(t,r,this.version);break;case"ss":this.tryAppendQueryParameter(t,r,this.services);break;case"srt":this.tryAppendQueryParameter(t,r,this.resourceTypes);break;case"spr":this.tryAppendQueryParameter(t,r,this.protocol);break;case"st":this.tryAppendQueryParameter(t,r,this.startsOn?truncatedISO8061Date(this.startsOn,!1):void 0);break;case"se":this.tryAppendQueryParameter(t,r,this.expiresOn?truncatedISO8061Date(this.expiresOn,!1):void 0);break;case"sip":this.tryAppendQueryParameter(t,r,this.ipRange?ipRangeToString(this.ipRange):void 0);break;case"si":this.tryAppendQueryParameter(t,r,this.identifier);break;case"sr":this.tryAppendQueryParameter(t,r,this.resource);break;case"sp":this.tryAppendQueryParameter(t,r,this.permissions);break;case"sig":this.tryAppendQueryParameter(t,r,this.signature)}return t.join("&")}tryAppendQueryParameter(e,t,r){r&&(t=encodeURIComponent(t),r=encodeURIComponent(r),t.length>0&&r.length>0&&e.push(`${t}=${r}`))}}function generateAccountSASQueryParameters(e,t){const r=e.version?e.version:"2021-08-06",s=AccountSASPermissions.parse(e.permissions.toString()).toString(),a=AccountSASServices.parse(e.services).toString(),i=AccountSASResourceTypes.parse(e.resourceTypes).toString();let n;n=r>="2020-12-06"?[t.accountName,s,a,i,e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",truncatedISO8061Date(e.expiresOn,!1),e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",r,"",""].join("\n"):[t.accountName,s,a,i,e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",truncatedISO8061Date(e.expiresOn,!1),e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",r,""].join("\n");const o=t.computeHMACSHA256(n);return new SASQueryParameters(r,o,s,a,i,e.protocol,e.startsOn,e.expiresOn,e.ipRange)}class CredentialPolicy extends coreHttp.BaseRequestPolicy{sendRequest(e){return this._nextPolicy.sendRequest(this.signRequest(e))}signRequest(e){return e}}class AnonymousCredentialPolicy extends CredentialPolicy{constructor(e,t){super(e,t)}}class Credential{create(e,t){throw new Error("Method should be implemented in children classes.")}}class AnonymousCredential extends Credential{create(e,t){return new AnonymousCredentialPolicy(e,t)}}class StorageSharedKeyCredentialPolicy extends CredentialPolicy{constructor(e,t,r){super(e,t),this.factory=r}signRequest(e){e.headers.set(HeaderConstants.X_MS_DATE,(new Date).toUTCString()),e.body&&"string"==typeof e.body&&e.body.length>0&&e.headers.set(HeaderConstants.CONTENT_LENGTH,Buffer.byteLength(e.body));const t=[e.method.toUpperCase(),this.getHeaderValueToSign(e,HeaderConstants.CONTENT_LANGUAGE),this.getHeaderValueToSign(e,HeaderConstants.CONTENT_ENCODING),this.getHeaderValueToSign(e,HeaderConstants.CONTENT_LENGTH),this.getHeaderValueToSign(e,HeaderConstants.CONTENT_MD5),this.getHeaderValueToSign(e,HeaderConstants.CONTENT_TYPE),this.getHeaderValueToSign(e,HeaderConstants.DATE),this.getHeaderValueToSign(e,HeaderConstants.IF_MODIFIED_SINCE),this.getHeaderValueToSign(e,HeaderConstants.IF_MATCH),this.getHeaderValueToSign(e,HeaderConstants.IF_NONE_MATCH),this.getHeaderValueToSign(e,HeaderConstants.IF_UNMODIFIED_SINCE),this.getHeaderValueToSign(e,HeaderConstants.RANGE)].join("\n")+"\n"+this.getCanonicalizedHeadersString(e)+this.getCanonicalizedResourceString(e),r=this.factory.computeHMACSHA256(t);return e.headers.set(HeaderConstants.AUTHORIZATION,`SharedKey ${this.factory.accountName}:${r}`),e}getHeaderValueToSign(e,t){const r=e.headers.get(t);return r?t===HeaderConstants.CONTENT_LENGTH&&"0"===r?"":r:""}getCanonicalizedHeadersString(e){let t=e.headers.headersArray().filter((e=>e.name.toLowerCase().startsWith(HeaderConstants.PREFIX_FOR_STORAGE)));t.sort(((e,t)=>e.name.toLowerCase().localeCompare(t.name.toLowerCase()))),t=t.filter(((e,t,r)=>!(t>0&&e.name.toLowerCase()===r[t-1].name.toLowerCase())));let r="";return t.forEach((e=>{r+=`${e.name.toLowerCase().trimRight()}:${e.value.trimLeft()}\n`})),r}getCanonicalizedResourceString(e){const t=encodeURI(getURLPath(e.url)||"/");let r="";r+=`/${this.factory.accountName}${t}`;const s=getURLQueries(e.url),a={};if(s){const e=[];for(const t in s)if(Object.prototype.hasOwnProperty.call(s,t)){const r=t.toLowerCase();a[r]=s[t],e.push(r)}e.sort();for(const t of e)r+=`\n${t}:${decodeURIComponent(a[t])}`}return r}}class StorageSharedKeyCredential extends Credential{constructor(e,t){super(),this.accountName=e,this.accountKey=Buffer.from(t,"base64")}create(e,t){return new StorageSharedKeyCredentialPolicy(e,t,this)}computeHMACSHA256(e){return crypto.createHmac("sha256",this.accountKey).update(e,"utf8").digest("base64")}}const logger=logger$1.createClientLogger("storage-queue");class StorageBrowserPolicy extends coreHttp.BaseRequestPolicy{constructor(e,t){super(e,t)}async sendRequest(e){return coreHttp.isNode||("GET"!==e.method.toUpperCase()&&"HEAD"!==e.method.toUpperCase()||(e.url=setURLParameter(e.url,URLConstants.Parameters.FORCE_BROWSER_NO_CACHE,(new Date).getTime().toString())),e.headers.remove(HeaderConstants.COOKIE),e.headers.remove(HeaderConstants.CONTENT_LENGTH)),this._nextPolicy.sendRequest(e)}}class StorageBrowserPolicyFactory{create(e,t){return new StorageBrowserPolicy(e,t)}}exports.StorageRetryPolicyType=void 0,function(e){e[e.EXPONENTIAL=0]="EXPONENTIAL",e[e.FIXED=1]="FIXED"}(exports.StorageRetryPolicyType||(exports.StorageRetryPolicyType={}));const DEFAULT_RETRY_OPTIONS={maxRetryDelayInMs:12e4,maxTries:4,retryDelayInMs:4e3,retryPolicyType:exports.StorageRetryPolicyType.EXPONENTIAL,secondaryHost:"",tryTimeoutInMs:3e4},RETRY_ABORT_ERROR=new abortController.AbortError("The operation was aborted.");class StorageRetryPolicy extends coreHttp.BaseRequestPolicy{constructor(e,t,r=DEFAULT_RETRY_OPTIONS){super(e,t),this.retryOptions={retryPolicyType:r.retryPolicyType?r.retryPolicyType:DEFAULT_RETRY_OPTIONS.retryPolicyType,maxTries:r.maxTries&&r.maxTries>=1?Math.floor(r.maxTries):DEFAULT_RETRY_OPTIONS.maxTries,tryTimeoutInMs:r.tryTimeoutInMs&&r.tryTimeoutInMs>=0?r.tryTimeoutInMs:DEFAULT_RETRY_OPTIONS.tryTimeoutInMs,retryDelayInMs:r.retryDelayInMs&&r.retryDelayInMs>=0?Math.min(r.retryDelayInMs,r.maxRetryDelayInMs?r.maxRetryDelayInMs:DEFAULT_RETRY_OPTIONS.maxRetryDelayInMs):DEFAULT_RETRY_OPTIONS.retryDelayInMs,maxRetryDelayInMs:r.maxRetryDelayInMs&&r.maxRetryDelayInMs>=0?r.maxRetryDelayInMs:DEFAULT_RETRY_OPTIONS.maxRetryDelayInMs,secondaryHost:r.secondaryHost?r.secondaryHost:DEFAULT_RETRY_OPTIONS.secondaryHost}}async sendRequest(e){return this.attemptSendRequest(e,!1,1)}async attemptSendRequest(e,t,r){const s=e.clone(),a=t||!this.retryOptions.secondaryHost||!("GET"===e.method||"HEAD"===e.method||"OPTIONS"===e.method)||r%2==1;let i;a||(s.url=setURLHost(s.url,this.retryOptions.secondaryHost)),s.url=setURLParameter(s.url,URLConstants.Parameters.TIMEOUT,Math.floor(this.retryOptions.tryTimeoutInMs/1e3).toString());try{if(logger.info(`RetryPolicy: =====> Try=${r} ${a?"Primary":"Secondary"}`),i=await this._nextPolicy.sendRequest(s),!this.shouldRetry(a,r,i))return i;t=t||!a&&404===i.status}catch(e){if(logger.error(`RetryPolicy: Caught error, message: ${e.message}, code: ${e.code}`),!this.shouldRetry(a,r,i,e))throw e}return await this.delay(a,r,e.abortSignal),this.attemptSendRequest(e,t,++r)}shouldRetry(e,t,r,s){if(t>=this.retryOptions.maxTries)return logger.info(`RetryPolicy: Attempt(s) ${t} >= maxTries ${this.retryOptions.maxTries}, no further try.`),!1;const a=["ETIMEDOUT","ESOCKETTIMEDOUT","ECONNREFUSED","ECONNRESET","ENOENT","ENOTFOUND","TIMEOUT","EPIPE","REQUEST_SEND_ERROR"];if(s)for(const e of a)if(s.name.toUpperCase().includes(e)||s.message.toUpperCase().includes(e)||s.code&&s.code.toString().toUpperCase()===e)return logger.info(`RetryPolicy: Network error ${e} found, will retry.`),!0;if(r||s){const t=r?r.status:s?s.statusCode:0;if(!e&&404===t)return logger.info("RetryPolicy: Secondary access with 404, will retry."),!0;if(503===t||500===t)return logger.info(`RetryPolicy: Will retry for status code ${t}.`),!0}return!("PARSE_ERROR"!==(null==s?void 0:s.code)||!(null==s?void 0:s.message.startsWith('Error "Error: Unclosed root tag')))&&(logger.info("RetryPolicy: Incomplete XML response likely due to service timeout, will retry."),!0)}async delay(e,t,r){let s=0;if(e)switch(this.retryOptions.retryPolicyType){case exports.StorageRetryPolicyType.EXPONENTIAL:s=Math.min((Math.pow(2,t-1)-1)*this.retryOptions.retryDelayInMs,this.retryOptions.maxRetryDelayInMs);break;case exports.StorageRetryPolicyType.FIXED:s=this.retryOptions.retryDelayInMs}else s=1e3*Math.random();return logger.info(`RetryPolicy: Delay for ${s}ms`),delay(s,r,RETRY_ABORT_ERROR)}}class StorageRetryPolicyFactory{constructor(e){this.retryOptions=e}create(e,t){return new StorageRetryPolicy(e,t,this.retryOptions)}}class TelemetryPolicy extends coreHttp.BaseRequestPolicy{constructor(e,t,r){super(e,t),this.telemetry=r}async sendRequest(e){return coreHttp.isNode&&(e.headers||(e.headers=new coreHttp.HttpHeaders),e.headers.get(HeaderConstants.USER_AGENT)||e.headers.set(HeaderConstants.USER_AGENT,this.telemetry)),this._nextPolicy.sendRequest(e)}}class TelemetryPolicyFactory{constructor(e){const t=[];if(coreHttp.isNode){if(e){const r=e.userAgentPrefix||"";r.length>0&&-1===t.indexOf(r)&&t.push(r)}const r="azsdk-js-storagequeue/12.10.0";-1===t.indexOf(r)&&t.push(r);let s=`(NODE-VERSION ${process.version})`;os__namespace&&(s=`(NODE-VERSION ${process.version}; ${os__namespace.type()} ${os__namespace.release()})`),-1===t.indexOf(s)&&t.push(s)}this.telemetryString=t.join(" ")}create(e,t){return new TelemetryPolicy(e,t,this.telemetryString)}}const _defaultHttpClient=new coreHttp.DefaultHttpClient;function getCachedDefaultHttpClient(){return _defaultHttpClient}class Pipeline{constructor(e,t={}){this.factories=e,this.options=Object.assign(Object.assign({},t),{httpClient:t.httpClient||getCachedDefaultHttpClient()})}toServiceClientOptions(){return{httpClient:this.options.httpClient,requestPolicyFactories:this.factories}}}function newPipeline(e,t={}){void 0===e&&(e=new AnonymousCredential);const r=new TelemetryPolicyFactory(t.userAgentOptions),s=[coreHttp.tracingPolicy({userAgent:r.telemetryString}),coreHttp.keepAlivePolicy(t.keepAliveOptions),r,coreHttp.generateClientRequestIdPolicy(),new StorageBrowserPolicyFactory,new StorageRetryPolicyFactory(t.retryOptions),coreHttp.deserializationPolicy(),coreHttp.logPolicy({logger:logger.info,allowedHeaderNames:StorageQueueLoggingAllowedHeaderNames,allowedQueryParameters:StorageQueueLoggingAllowedQueryParameters})];return coreHttp.isNode&&s.push(coreHttp.proxyPolicy(t.proxyOptions)),s.push(coreHttp.isTokenCredential(e)?coreHttp.bearerTokenAuthenticationPolicy(e,StorageOAuthScopes):e),new Pipeline(s,t)}const QueueServiceProperties={serializedName:"QueueServiceProperties",xmlName:"StorageServiceProperties",type:{name:"Composite",className:"QueueServiceProperties",modelProperties:{queueAnalyticsLogging:{serializedName:"Logging",xmlName:"Logging",type:{name:"Composite",className:"Logging"}},hourMetrics:{serializedName:"HourMetrics",xmlName:"HourMetrics",type:{name:"Composite",className:"Metrics"}},minuteMetrics:{serializedName:"MinuteMetrics",xmlName:"MinuteMetrics",type:{name:"Composite",className:"Metrics"}},cors:{serializedName:"Cors",xmlName:"Cors",xmlIsWrapped:!0,xmlElementName:"CorsRule",type:{name:"Sequence",element:{type:{name:"Composite",className:"CorsRule"}}}}}}},Logging={serializedName:"Logging",type:{name:"Composite",className:"Logging",modelProperties:{version:{serializedName:"Version",required:!0,xmlName:"Version",type:{name:"String"}},deleteProperty:{serializedName:"Delete",required:!0,xmlName:"Delete",type:{name:"Boolean"}},read:{serializedName:"Read",required:!0,xmlName:"Read",type:{name:"Boolean"}},write:{serializedName:"Write",required:!0,xmlName:"Write",type:{name:"Boolean"}},retentionPolicy:{serializedName:"RetentionPolicy",xmlName:"RetentionPolicy",type:{name:"Composite",className:"RetentionPolicy"}}}}},RetentionPolicy={serializedName:"RetentionPolicy",type:{name:"Composite",className:"RetentionPolicy",modelProperties:{enabled:{serializedName:"Enabled",required:!0,xmlName:"Enabled",type:{name:"Boolean"}},days:{constraints:{InclusiveMinimum:1},serializedName:"Days",xmlName:"Days",type:{name:"Number"}}}}},Metrics={serializedName:"Metrics",type:{name:"Composite",className:"Metrics",modelProperties:{version:{serializedName:"Version",xmlName:"Version",type:{name:"String"}},enabled:{serializedName:"Enabled",required:!0,xmlName:"Enabled",type:{name:"Boolean"}},includeAPIs:{serializedName:"IncludeAPIs",xmlName:"IncludeAPIs",type:{name:"Boolean"}},retentionPolicy:{serializedName:"RetentionPolicy",xmlName:"RetentionPolicy",type:{name:"Composite",className:"RetentionPolicy"}}}}},CorsRule={serializedName:"CorsRule",type:{name:"Composite",className:"CorsRule",modelProperties:{allowedOrigins:{serializedName:"AllowedOrigins",required:!0,xmlName:"AllowedOrigins",type:{name:"String"}},allowedMethods:{serializedName:"AllowedMethods",required:!0,xmlName:"AllowedMethods",type:{name:"String"}},allowedHeaders:{serializedName:"AllowedHeaders",required:!0,xmlName:"AllowedHeaders",type:{name:"String"}},exposedHeaders:{serializedName:"ExposedHeaders",required:!0,xmlName:"ExposedHeaders",type:{name:"String"}},maxAgeInSeconds:{constraints:{InclusiveMinimum:0},serializedName:"MaxAgeInSeconds",required:!0,xmlName:"MaxAgeInSeconds",type:{name:"Number"}}}}},StorageError={serializedName:"StorageError",type:{name:"Composite",className:"StorageError",modelProperties:{message:{serializedName:"Message",xmlName:"Message",type:{name:"String"}},code:{serializedName:"Code",xmlName:"Code",type:{name:"String"}}}}},QueueServiceStatistics={serializedName:"QueueServiceStatistics",xmlName:"StorageServiceStats",type:{name:"Composite",className:"QueueServiceStatistics",modelProperties:{geoReplication:{serializedName:"GeoReplication",xmlName:"GeoReplication",type:{name:"Composite",className:"GeoReplication"}}}}},GeoReplication={serializedName:"GeoReplication",type:{name:"Composite",className:"GeoReplication",modelProperties:{status:{serializedName:"Status",required:!0,xmlName:"Status",type:{name:"Enum",allowedValues:["live","bootstrap","unavailable"]}},lastSyncOn:{serializedName:"LastSyncTime",required:!0,xmlName:"LastSyncTime",type:{name:"DateTimeRfc1123"}}}}},ListQueuesSegmentResponse={serializedName:"ListQueuesSegmentResponse",xmlName:"EnumerationResults",type:{name:"Composite",className:"ListQueuesSegmentResponse",modelProperties:{serviceEndpoint:{serializedName:"ServiceEndpoint",required:!0,xmlName:"ServiceEndpoint",xmlIsAttribute:!0,type:{name:"String"}},prefix:{serializedName:"Prefix",required:!0,xmlName:"Prefix",type:{name:"String"}},marker:{serializedName:"Marker",xmlName:"Marker",type:{name:"String"}},maxPageSize:{serializedName:"MaxResults",required:!0,xmlName:"MaxResults",type:{name:"Number"}},queueItems:{serializedName:"QueueItems",xmlName:"Queues",xmlIsWrapped:!0,xmlElementName:"Queue",type:{name:"Sequence",element:{type:{name:"Composite",className:"QueueItem"}}}},continuationToken:{serializedName:"NextMarker",required:!0,xmlName:"NextMarker",type:{name:"String"}}}}},QueueItem={serializedName:"QueueItem",xmlName:"Queue",type:{name:"Composite",className:"QueueItem",modelProperties:{name:{serializedName:"Name",required:!0,xmlName:"Name",type:{name:"String"}},metadata:{serializedName:"Metadata",xmlName:"Metadata",type:{name:"Dictionary",value:{type:{name:"String"}}}}}}},SignedIdentifier={serializedName:"SignedIdentifier",type:{name:"Composite",className:"SignedIdentifier",modelProperties:{id:{serializedName:"Id",required:!0,xmlName:"Id",type:{name:"String"}},accessPolicy:{serializedName:"AccessPolicy",xmlName:"AccessPolicy",type:{name:"Composite",className:"AccessPolicy"}}}}},AccessPolicy={serializedName:"AccessPolicy",type:{name:"Composite",className:"AccessPolicy",modelProperties:{startsOn:{serializedName:"Start",xmlName:"Start",type:{name:"String"}},expiresOn:{serializedName:"Expiry",xmlName:"Expiry",type:{name:"String"}},permissions:{serializedName:"Permission",xmlName:"Permission",type:{name:"String"}}}}},DequeuedMessageItem={serializedName:"DequeuedMessageItem",xmlName:"QueueMessage",xmlIsWrapped:!0,type:{name:"Composite",className:"DequeuedMessageItem",modelProperties:{messageId:{serializedName:"MessageId",required:!0,xmlName:"MessageId",type:{name:"String"}},insertedOn:{serializedName:"InsertionTime",required:!0,xmlName:"InsertionTime",type:{name:"DateTimeRfc1123"}},expiresOn:{serializedName:"ExpirationTime",required:!0,xmlName:"ExpirationTime",type:{name:"DateTimeRfc1123"}},popReceipt:{serializedName:"PopReceipt",required:!0,xmlName:"PopReceipt",type:{name:"String"}},nextVisibleOn:{serializedName:"TimeNextVisible",required:!0,xmlName:"TimeNextVisible",type:{name:"DateTimeRfc1123"}},dequeueCount:{serializedName:"DequeueCount",required:!0,xmlName:"DequeueCount",type:{name:"Number"}},messageText:{serializedName:"MessageText",required:!0,xmlName:"MessageText",type:{name:"String"}}}}},QueueMessage={serializedName:"QueueMessage",type:{name:"Composite",className:"QueueMessage",modelProperties:{messageText:{serializedName:"MessageText",required:!0,xmlName:"MessageText",type:{name:"String"}}}}},EnqueuedMessage={serializedName:"EnqueuedMessage",xmlName:"QueueMessage",xmlIsWrapped:!0,type:{name:"Composite",className:"EnqueuedMessage",modelProperties:{messageId:{serializedName:"MessageId",required:!0,xmlName:"MessageId",type:{name:"String"}},insertedOn:{serializedName:"InsertionTime",required:!0,xmlName:"InsertionTime",type:{name:"DateTimeRfc1123"}},expiresOn:{serializedName:"ExpirationTime",required:!0,xmlName:"ExpirationTime",type:{name:"DateTimeRfc1123"}},popReceipt:{serializedName:"PopReceipt",required:!0,xmlName:"PopReceipt",type:{name:"String"}},nextVisibleOn:{serializedName:"TimeNextVisible",required:!0,xmlName:"TimeNextVisible",type:{name:"DateTimeRfc1123"}}}}},PeekedMessageItem={serializedName:"PeekedMessageItem",xmlName:"QueueMessage",xmlIsWrapped:!0,type:{name:"Composite",className:"PeekedMessageItem",modelProperties:{messageId:{serializedName:"MessageId",required:!0,xmlName:"MessageId",type:{name:"String"}},insertedOn:{serializedName:"InsertionTime",required:!0,xmlName:"InsertionTime",type:{name:"DateTimeRfc1123"}},expiresOn:{serializedName:"ExpirationTime",required:!0,xmlName:"ExpirationTime",type:{name:"DateTimeRfc1123"}},dequeueCount:{serializedName:"DequeueCount",required:!0,xmlName:"DequeueCount",type:{name:"Number"}},messageText:{serializedName:"MessageText",required:!0,xmlName:"MessageText",type:{name:"String"}}}}},ServiceSetPropertiesHeaders={serializedName:"Service_setPropertiesHeaders",type:{name:"Composite",className:"ServiceSetPropertiesHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},ServiceSetPropertiesExceptionHeaders={serializedName:"Service_setPropertiesExceptionHeaders",type:{name:"Composite",className:"ServiceSetPropertiesExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},ServiceGetPropertiesHeaders={serializedName:"Service_getPropertiesHeaders",type:{name:"Composite",className:"ServiceGetPropertiesHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},ServiceGetPropertiesExceptionHeaders={serializedName:"Service_getPropertiesExceptionHeaders",type:{name:"Composite",className:"ServiceGetPropertiesExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},ServiceGetStatisticsHeaders={serializedName:"Service_getStatisticsHeaders",type:{name:"Composite",className:"ServiceGetStatisticsHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},ServiceGetStatisticsExceptionHeaders={serializedName:"Service_getStatisticsExceptionHeaders",type:{name:"Composite",className:"ServiceGetStatisticsExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},ServiceListQueuesSegmentHeaders={serializedName:"Service_listQueuesSegmentHeaders",type:{name:"Composite",className:"ServiceListQueuesSegmentHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},ServiceListQueuesSegmentExceptionHeaders={serializedName:"Service_listQueuesSegmentExceptionHeaders",type:{name:"Composite",className:"ServiceListQueuesSegmentExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},QueueCreateHeaders={serializedName:"Queue_createHeaders",type:{name:"Composite",className:"QueueCreateHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},QueueCreateExceptionHeaders={serializedName:"Queue_createExceptionHeaders",type:{name:"Composite",className:"QueueCreateExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},QueueDeleteHeaders={serializedName:"Queue_deleteHeaders",type:{name:"Composite",className:"QueueDeleteHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},QueueDeleteExceptionHeaders={serializedName:"Queue_deleteExceptionHeaders",type:{name:"Composite",className:"QueueDeleteExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},QueueGetPropertiesHeaders={serializedName:"Queue_getPropertiesHeaders",type:{name:"Composite",className:"QueueGetPropertiesHeaders",modelProperties:{metadata:{serializedName:"x-ms-meta",xmlName:"x-ms-meta",type:{name:"Dictionary",value:{type:{name:"String"}}},headerCollectionPrefix:"x-ms-meta-"},approximateMessagesCount:{serializedName:"x-ms-approximate-messages-count",xmlName:"x-ms-approximate-messages-count",type:{name:"Number"}},requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},QueueGetPropertiesExceptionHeaders={serializedName:"Queue_getPropertiesExceptionHeaders",type:{name:"Composite",className:"QueueGetPropertiesExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},QueueSetMetadataHeaders={serializedName:"Queue_setMetadataHeaders",type:{name:"Composite",className:"QueueSetMetadataHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},QueueSetMetadataExceptionHeaders={serializedName:"Queue_setMetadataExceptionHeaders",type:{name:"Composite",className:"QueueSetMetadataExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},QueueGetAccessPolicyHeaders={serializedName:"Queue_getAccessPolicyHeaders",type:{name:"Composite",className:"QueueGetAccessPolicyHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},QueueGetAccessPolicyExceptionHeaders={serializedName:"Queue_getAccessPolicyExceptionHeaders",type:{name:"Composite",className:"QueueGetAccessPolicyExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},QueueSetAccessPolicyHeaders={serializedName:"Queue_setAccessPolicyHeaders",type:{name:"Composite",className:"QueueSetAccessPolicyHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},QueueSetAccessPolicyExceptionHeaders={serializedName:"Queue_setAccessPolicyExceptionHeaders",type:{name:"Composite",className:"QueueSetAccessPolicyExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},MessagesDequeueHeaders={serializedName:"Messages_dequeueHeaders",type:{name:"Composite",className:"MessagesDequeueHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},MessagesDequeueExceptionHeaders={serializedName:"Messages_dequeueExceptionHeaders",type:{name:"Composite",className:"MessagesDequeueExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},MessagesClearHeaders={serializedName:"Messages_clearHeaders",type:{name:"Composite",className:"MessagesClearHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},MessagesClearExceptionHeaders={serializedName:"Messages_clearExceptionHeaders",type:{name:"Composite",className:"MessagesClearExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},MessagesEnqueueHeaders={serializedName:"Messages_enqueueHeaders",type:{name:"Composite",className:"MessagesEnqueueHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},MessagesEnqueueExceptionHeaders={serializedName:"Messages_enqueueExceptionHeaders",type:{name:"Composite",className:"MessagesEnqueueExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},MessagesPeekHeaders={serializedName:"Messages_peekHeaders",type:{name:"Composite",className:"MessagesPeekHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},MessagesPeekExceptionHeaders={serializedName:"Messages_peekExceptionHeaders",type:{name:"Composite",className:"MessagesPeekExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},MessageIdUpdateHeaders={serializedName:"MessageId_updateHeaders",type:{name:"Composite",className:"MessageIdUpdateHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},popReceipt:{serializedName:"x-ms-popreceipt",xmlName:"x-ms-popreceipt",type:{name:"String"}},nextVisibleOn:{serializedName:"x-ms-time-next-visible",xmlName:"x-ms-time-next-visible",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},MessageIdUpdateExceptionHeaders={serializedName:"MessageId_updateExceptionHeaders",type:{name:"Composite",className:"MessageIdUpdateExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}},MessageIdDeleteHeaders={serializedName:"MessageId_deleteHeaders",type:{name:"Composite",className:"MessageIdDeleteHeaders",modelProperties:{requestId:{serializedName:"x-ms-request-id",xmlName:"x-ms-request-id",type:{name:"String"}},version:{serializedName:"x-ms-version",xmlName:"x-ms-version",type:{name:"String"}},date:{serializedName:"date",xmlName:"date",type:{name:"DateTimeRfc1123"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}},errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}}}}},MessageIdDeleteExceptionHeaders={serializedName:"MessageId_deleteExceptionHeaders",type:{name:"Composite",className:"MessageIdDeleteExceptionHeaders",modelProperties:{errorCode:{serializedName:"x-ms-error-code",xmlName:"x-ms-error-code",type:{name:"String"}},clientRequestId:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}}}};var Mappers=Object.freeze({__proto__:null,QueueServiceProperties:QueueServiceProperties,Logging:Logging,RetentionPolicy:RetentionPolicy,Metrics:Metrics,CorsRule:CorsRule,StorageError:StorageError,QueueServiceStatistics:QueueServiceStatistics,GeoReplication:GeoReplication,ListQueuesSegmentResponse:ListQueuesSegmentResponse,QueueItem:QueueItem,SignedIdentifier:SignedIdentifier,AccessPolicy:AccessPolicy,DequeuedMessageItem:DequeuedMessageItem,QueueMessage:QueueMessage,EnqueuedMessage:EnqueuedMessage,PeekedMessageItem:PeekedMessageItem,ServiceSetPropertiesHeaders:ServiceSetPropertiesHeaders,ServiceSetPropertiesExceptionHeaders:ServiceSetPropertiesExceptionHeaders,ServiceGetPropertiesHeaders:ServiceGetPropertiesHeaders,ServiceGetPropertiesExceptionHeaders:ServiceGetPropertiesExceptionHeaders,ServiceGetStatisticsHeaders:ServiceGetStatisticsHeaders,ServiceGetStatisticsExceptionHeaders:ServiceGetStatisticsExceptionHeaders,ServiceListQueuesSegmentHeaders:ServiceListQueuesSegmentHeaders,ServiceListQueuesSegmentExceptionHeaders:ServiceListQueuesSegmentExceptionHeaders,QueueCreateHeaders:QueueCreateHeaders,QueueCreateExceptionHeaders:QueueCreateExceptionHeaders,QueueDeleteHeaders:QueueDeleteHeaders,QueueDeleteExceptionHeaders:QueueDeleteExceptionHeaders,QueueGetPropertiesHeaders:QueueGetPropertiesHeaders,QueueGetPropertiesExceptionHeaders:QueueGetPropertiesExceptionHeaders,QueueSetMetadataHeaders:QueueSetMetadataHeaders,QueueSetMetadataExceptionHeaders:QueueSetMetadataExceptionHeaders,QueueGetAccessPolicyHeaders:QueueGetAccessPolicyHeaders,QueueGetAccessPolicyExceptionHeaders:QueueGetAccessPolicyExceptionHeaders,QueueSetAccessPolicyHeaders:QueueSetAccessPolicyHeaders,QueueSetAccessPolicyExceptionHeaders:QueueSetAccessPolicyExceptionHeaders,MessagesDequeueHeaders:MessagesDequeueHeaders,MessagesDequeueExceptionHeaders:MessagesDequeueExceptionHeaders,MessagesClearHeaders:MessagesClearHeaders,MessagesClearExceptionHeaders:MessagesClearExceptionHeaders,MessagesEnqueueHeaders:MessagesEnqueueHeaders,MessagesEnqueueExceptionHeaders:MessagesEnqueueExceptionHeaders,MessagesPeekHeaders:MessagesPeekHeaders,MessagesPeekExceptionHeaders:MessagesPeekExceptionHeaders,MessageIdUpdateHeaders:MessageIdUpdateHeaders,MessageIdUpdateExceptionHeaders:MessageIdUpdateExceptionHeaders,MessageIdDeleteHeaders:MessageIdDeleteHeaders,MessageIdDeleteExceptionHeaders:MessageIdDeleteExceptionHeaders});const contentType={parameterPath:["options","contentType"],mapper:{defaultValue:"application/xml",isConstant:!0,serializedName:"Content-Type",type:{name:"String"}}},properties={parameterPath:"properties",mapper:QueueServiceProperties},accept={parameterPath:"accept",mapper:{defaultValue:"application/xml",isConstant:!0,serializedName:"Accept",type:{name:"String"}}},url={parameterPath:"url",mapper:{serializedName:"url",required:!0,xmlName:"url",type:{name:"String"}},skipEncoding:!0},restype={parameterPath:"restype",mapper:{defaultValue:"service",isConstant:!0,serializedName:"restype",type:{name:"String"}}},comp={parameterPath:"comp",mapper:{defaultValue:"properties",isConstant:!0,serializedName:"comp",type:{name:"String"}}},timeoutInSeconds={parameterPath:["options","timeoutInSeconds"],mapper:{constraints:{InclusiveMinimum:0},serializedName:"timeout",xmlName:"timeout",type:{name:"Number"}}},version={parameterPath:"version",mapper:{defaultValue:"2021-08-06",isConstant:!0,serializedName:"x-ms-version",type:{name:"String"}}},requestId={parameterPath:["options","requestId"],mapper:{serializedName:"x-ms-client-request-id",xmlName:"x-ms-client-request-id",type:{name:"String"}}},accept1={parameterPath:"accept",mapper:{defaultValue:"application/xml",isConstant:!0,serializedName:"Accept",type:{name:"String"}}},comp1={parameterPath:"comp",mapper:{defaultValue:"stats",isConstant:!0,serializedName:"comp",type:{name:"String"}}},comp2={parameterPath:"comp",mapper:{defaultValue:"list",isConstant:!0,serializedName:"comp",type:{name:"String"}}},prefix={parameterPath:["options","prefix"],mapper:{serializedName:"prefix",xmlName:"prefix",type:{name:"String"}}},marker={parameterPath:["options","marker"],mapper:{serializedName:"marker",xmlName:"marker",type:{name:"String"}}},maxPageSize={parameterPath:["options","maxPageSize"],mapper:{constraints:{InclusiveMinimum:1},serializedName:"maxresults",xmlName:"maxresults",type:{name:"Number"}}},include={parameterPath:["options","include"],mapper:{serializedName:"include",xmlName:"include",xmlElementName:"ListQueuesIncludeType",type:{name:"Sequence",element:{defaultValue:"metadata",isConstant:!0,type:{name:"String"}}}},collectionFormat:coreHttp.QueryCollectionFormat.Csv},metadata={parameterPath:["options","metadata"],mapper:{serializedName:"x-ms-meta",xmlName:"x-ms-meta",type:{name:"Dictionary",value:{type:{name:"String"}}},headerCollectionPrefix:"x-ms-meta-"}},comp3={parameterPath:"comp",mapper:{defaultValue:"metadata",isConstant:!0,serializedName:"comp",type:{name:"String"}}},comp4={parameterPath:"comp",mapper:{defaultValue:"acl",isConstant:!0,serializedName:"comp",type:{name:"String"}}},queueAcl={parameterPath:["options","queueAcl"],mapper:{serializedName:"queueAcl",xmlName:"SignedIdentifiers",xmlIsWrapped:!0,xmlElementName:"SignedIdentifier",type:{name:"Sequence",element:{type:{name:"Composite",className:"SignedIdentifier"}}}}},numberOfMessages={parameterPath:["options","numberOfMessages"],mapper:{constraints:{InclusiveMinimum:1},serializedName:"numofmessages",xmlName:"numofmessages",type:{name:"Number"}}},visibilityTimeout={parameterPath:["options","visibilityTimeout"],mapper:{constraints:{InclusiveMaximum:604800,InclusiveMinimum:0},serializedName:"visibilitytimeout",xmlName:"visibilitytimeout",type:{name:"Number"}}},queueMessage={parameterPath:"queueMessage",mapper:QueueMessage},messageTimeToLive={parameterPath:["options","messageTimeToLive"],mapper:{constraints:{InclusiveMinimum:-1},serializedName:"messagettl",xmlName:"messagettl",type:{name:"Number"}}},peekonly={parameterPath:"peekonly",mapper:{defaultValue:"true",isConstant:!0,serializedName:"peekonly",type:{name:"String"}}},queueMessage1={parameterPath:["options","queueMessage"],mapper:QueueMessage},popReceipt={parameterPath:"popReceipt",mapper:{serializedName:"popreceipt",required:!0,xmlName:"popreceipt",type:{name:"String"}}},visibilityTimeout1={parameterPath:"visibilityTimeout",mapper:{constraints:{InclusiveMaximum:604800,InclusiveMinimum:0},serializedName:"visibilitytimeout",required:!0,xmlName:"visibilitytimeout",type:{name:"Number"}}};class Service{constructor(e){this.client=e}setProperties(e,t){const r={properties:e,options:coreHttp__namespace.operationOptionsToRequestOptionsBase(t||{})};return this.client.sendOperationRequest(r,setPropertiesOperationSpec)}getProperties(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,getPropertiesOperationSpec$1)}getStatistics(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,getStatisticsOperationSpec)}listQueuesSegment(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,listQueuesSegmentOperationSpec)}}const xmlSerializer$3=new coreHttp__namespace.Serializer(Mappers,!0),setPropertiesOperationSpec={path:"/",httpMethod:"PUT",responses:{202:{headersMapper:ServiceSetPropertiesHeaders},default:{bodyMapper:StorageError,headersMapper:ServiceSetPropertiesExceptionHeaders}},requestBody:properties,queryParameters:[restype,comp,timeoutInSeconds],urlParameters:[url],headerParameters:[contentType,accept,version,requestId],isXML:!0,contentType:"application/xml; charset=utf-8",mediaType:"xml",serializer:xmlSerializer$3},getPropertiesOperationSpec$1={path:"/",httpMethod:"GET",responses:{200:{bodyMapper:QueueServiceProperties,headersMapper:ServiceGetPropertiesHeaders},default:{bodyMapper:StorageError,headersMapper:ServiceGetPropertiesExceptionHeaders}},queryParameters:[restype,comp,timeoutInSeconds],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$3},getStatisticsOperationSpec={path:"/",httpMethod:"GET",responses:{200:{bodyMapper:QueueServiceStatistics,headersMapper:ServiceGetStatisticsHeaders},default:{bodyMapper:StorageError,headersMapper:ServiceGetStatisticsExceptionHeaders}},queryParameters:[restype,timeoutInSeconds,comp1],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$3},listQueuesSegmentOperationSpec={path:"/",httpMethod:"GET",responses:{200:{bodyMapper:ListQueuesSegmentResponse,headersMapper:ServiceListQueuesSegmentHeaders},default:{bodyMapper:StorageError,headersMapper:ServiceListQueuesSegmentExceptionHeaders}},queryParameters:[timeoutInSeconds,comp2,prefix,marker,maxPageSize,include],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$3};class Queue{constructor(e){this.client=e}create(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,createOperationSpec)}delete(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,deleteOperationSpec$1)}getProperties(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,getPropertiesOperationSpec)}setMetadata(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,setMetadataOperationSpec)}getAccessPolicy(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,getAccessPolicyOperationSpec)}setAccessPolicy(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,setAccessPolicyOperationSpec)}}const xmlSerializer$2=new coreHttp__namespace.Serializer(Mappers,!0),createOperationSpec={path:"/{queueName}",httpMethod:"PUT",responses:{201:{headersMapper:QueueCreateHeaders},204:{headersMapper:QueueCreateHeaders},default:{bodyMapper:StorageError,headersMapper:QueueCreateExceptionHeaders}},queryParameters:[timeoutInSeconds],urlParameters:[url],headerParameters:[version,requestId,accept1,metadata],isXML:!0,serializer:xmlSerializer$2},deleteOperationSpec$1={path:"/{queueName}",httpMethod:"DELETE",responses:{204:{headersMapper:QueueDeleteHeaders},default:{bodyMapper:StorageError,headersMapper:QueueDeleteExceptionHeaders}},queryParameters:[timeoutInSeconds],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$2},getPropertiesOperationSpec={path:"/{queueName}",httpMethod:"GET",responses:{200:{headersMapper:QueueGetPropertiesHeaders},default:{bodyMapper:StorageError,headersMapper:QueueGetPropertiesExceptionHeaders}},queryParameters:[timeoutInSeconds,comp3],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$2},setMetadataOperationSpec={path:"/{queueName}",httpMethod:"PUT",responses:{204:{headersMapper:QueueSetMetadataHeaders},default:{bodyMapper:StorageError,headersMapper:QueueSetMetadataExceptionHeaders}},queryParameters:[timeoutInSeconds,comp3],urlParameters:[url],headerParameters:[version,requestId,accept1,metadata],isXML:!0,serializer:xmlSerializer$2},getAccessPolicyOperationSpec={path:"/{queueName}",httpMethod:"GET",responses:{200:{bodyMapper:{type:{name:"Sequence",element:{type:{name:"Composite",className:"SignedIdentifier"}}},serializedName:"SignedIdentifiers",xmlName:"SignedIdentifiers",xmlIsWrapped:!0,xmlElementName:"SignedIdentifier"},headersMapper:QueueGetAccessPolicyHeaders},default:{bodyMapper:StorageError,headersMapper:QueueGetAccessPolicyExceptionHeaders}},queryParameters:[timeoutInSeconds,comp4],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$2},setAccessPolicyOperationSpec={path:"/{queueName}",httpMethod:"PUT",responses:{204:{headersMapper:QueueSetAccessPolicyHeaders},default:{bodyMapper:StorageError,headersMapper:QueueSetAccessPolicyExceptionHeaders}},requestBody:queueAcl,queryParameters:[timeoutInSeconds,comp4],urlParameters:[url],headerParameters:[contentType,accept,version,requestId],isXML:!0,contentType:"application/xml; charset=utf-8",mediaType:"xml",serializer:xmlSerializer$2};class Messages{constructor(e){this.client=e}dequeue(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,dequeueOperationSpec)}clear(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,clearOperationSpec)}enqueue(e,t){const r={queueMessage:e,options:coreHttp__namespace.operationOptionsToRequestOptionsBase(t||{})};return this.client.sendOperationRequest(r,enqueueOperationSpec)}peek(e){const t={options:coreHttp__namespace.operationOptionsToRequestOptionsBase(e||{})};return this.client.sendOperationRequest(t,peekOperationSpec)}}const xmlSerializer$1=new coreHttp__namespace.Serializer(Mappers,!0),dequeueOperationSpec={path:"/{queueName}/messages",httpMethod:"GET",responses:{200:{bodyMapper:{type:{name:"Sequence",element:{type:{name:"Composite",className:"DequeuedMessageItem"}}},serializedName:"DequeuedMessagesList",xmlName:"QueueMessagesList",xmlIsWrapped:!0,xmlElementName:"QueueMessage"},headersMapper:MessagesDequeueHeaders},default:{bodyMapper:StorageError,headersMapper:MessagesDequeueExceptionHeaders}},queryParameters:[timeoutInSeconds,numberOfMessages,visibilityTimeout],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$1},clearOperationSpec={path:"/{queueName}/messages",httpMethod:"DELETE",responses:{204:{headersMapper:MessagesClearHeaders},default:{bodyMapper:StorageError,headersMapper:MessagesClearExceptionHeaders}},queryParameters:[timeoutInSeconds],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$1},enqueueOperationSpec={path:"/{queueName}/messages",httpMethod:"POST",responses:{201:{bodyMapper:{type:{name:"Sequence",element:{type:{name:"Composite",className:"EnqueuedMessage"}}},serializedName:"EnqueuedMessageList",xmlName:"QueueMessagesList",xmlIsWrapped:!0,xmlElementName:"QueueMessage"},headersMapper:MessagesEnqueueHeaders},default:{bodyMapper:StorageError,headersMapper:MessagesEnqueueExceptionHeaders}},requestBody:queueMessage,queryParameters:[timeoutInSeconds,visibilityTimeout,messageTimeToLive],urlParameters:[url],headerParameters:[contentType,accept,version,requestId],isXML:!0,contentType:"application/xml; charset=utf-8",mediaType:"xml",serializer:xmlSerializer$1},peekOperationSpec={path:"/{queueName}/messages",httpMethod:"GET",responses:{200:{bodyMapper:{type:{name:"Sequence",element:{type:{name:"Composite",className:"PeekedMessageItem"}}},serializedName:"PeekedMessagesList",xmlName:"QueueMessagesList",xmlIsWrapped:!0,xmlElementName:"QueueMessage"},headersMapper:MessagesPeekHeaders},default:{bodyMapper:StorageError,headersMapper:MessagesPeekExceptionHeaders}},queryParameters:[timeoutInSeconds,numberOfMessages,peekonly],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer$1};class MessageId{constructor(e){this.client=e}update(e,t,r){const s={popReceipt:e,visibilityTimeout:t,options:coreHttp__namespace.operationOptionsToRequestOptionsBase(r||{})};return this.client.sendOperationRequest(s,updateOperationSpec)}delete(e,t){const r={popReceipt:e,options:coreHttp__namespace.operationOptionsToRequestOptionsBase(t||{})};return this.client.sendOperationRequest(r,deleteOperationSpec)}}const xmlSerializer=new coreHttp__namespace.Serializer(Mappers,!0),updateOperationSpec={path:"/{queueName}/messages/{messageid}",httpMethod:"PUT",responses:{204:{headersMapper:MessageIdUpdateHeaders},default:{bodyMapper:StorageError,headersMapper:MessageIdUpdateExceptionHeaders}},requestBody:queueMessage1,queryParameters:[timeoutInSeconds,popReceipt,visibilityTimeout1],urlParameters:[url],headerParameters:[contentType,accept,version,requestId],isXML:!0,contentType:"application/xml; charset=utf-8",mediaType:"xml",serializer:xmlSerializer},deleteOperationSpec={path:"/{queueName}/messages/{messageid}",httpMethod:"DELETE",responses:{204:{headersMapper:MessageIdDeleteHeaders},default:{bodyMapper:StorageError,headersMapper:MessageIdDeleteExceptionHeaders}},queryParameters:[timeoutInSeconds,popReceipt],urlParameters:[url],headerParameters:[version,requestId,accept1],isXML:!0,serializer:xmlSerializer};class StorageClient{constructor(e,t){this.url=e,this.accountName=getAccountNameFromUrl(e),this.pipeline=t,this.storageClientContext=getStorageClientContext(e,t),this.credential=new AnonymousCredential;for(const e of this.pipeline.factories){if(coreHttp.isNode&&e instanceof StorageSharedKeyCredential||e instanceof AnonymousCredential){this.credential=e;break}try{if("BearerTokenAuthenticationPolicy"===e.create().constructor.name){this.credential=e;break}}catch(e){}}}}const createSpan=coreTracing.createSpanFunction({packagePrefix:"Azure.Storage.Queue",namespace:"Microsoft.Storage"});class QueueSASPermissions{constructor(){this.read=!1,this.add=!1,this.update=!1,this.process=!1}static parse(e){const t=new QueueSASPermissions;for(const r of e)switch(r){case"r":t.read=!0;break;case"a":t.add=!0;break;case"u":t.update=!0;break;case"p":t.process=!0;break;default:throw new RangeError(`Invalid permission: ${r}`)}return t}toString(){const e=[];return this.read&&e.push("r"),this.add&&e.push("a"),this.update&&e.push("u"),this.process&&e.push("p"),e.join("")}}function generateQueueSASQueryParameters(e,t){if(!(e.identifier||e.permissions&&e.expiresOn))throw new RangeError("Must provide 'permissions' and 'expiresOn' for Queue SAS generation when 'identifier' is not provided.");const r=e.version?e.version:"2021-08-06";let s;e.permissions&&(s=QueueSASPermissions.parse(e.permissions.toString()).toString());const a=[s||"",e.startsOn?truncatedISO8061Date(e.startsOn,!1):"",e.expiresOn?truncatedISO8061Date(e.expiresOn,!1):"",getCanonicalName(t.accountName,e.queueName),e.identifier,e.ipRange?ipRangeToString(e.ipRange):"",e.protocol?e.protocol:"",r].join("\n"),i=t.computeHMACSHA256(a);return new SASQueryParameters(r,i,s,void 0,void 0,e.protocol,e.startsOn,e.expiresOn,e.ipRange,e.identifier)}function getCanonicalName(e,t){return`/queue/${e}/${t}`}class QueueClient extends StorageClient{constructor(e,t,r){let s,a;if(r=r||{},t instanceof Pipeline)a=e,s=t;else if(coreHttp.isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||coreHttp.isTokenCredential(t))a=e,s=newPipeline(t,r);else if(t||"string"==typeof t){if(!t||"string"!=typeof t)throw new Error("Expecting non-empty strings for queueName parameter");{const i=extractConnectionStringParts(e);if("AccountConnString"===i.kind){if(!coreHttp.isNode)throw new Error("Account connection string is only supported in Node.js environment");{const e=t,n=new StorageSharedKeyCredential(i.accountName,i.accountKey);a=appendToURLPath(i.url,e),r.proxyOptions||(r.proxyOptions=coreHttp.getDefaultProxySettings(i.proxyUri)),s=newPipeline(n,r)}}else{if("SASConnString"!==i.kind)throw new Error("Connection string must be either an Account connection string or a SAS connection string");{const e=t;a=appendToURLPath(i.url,e)+"?"+i.accountSas,s=newPipeline(new AnonymousCredential,r)}}}}else a=e,s=newPipeline(new AnonymousCredential,r);super(a,s),this._name=this.getQueueNameFromUrl(),this.queueContext=new Queue(this.storageClientContext);const i=this.url.split("?");this._messagesUrl=i[1]?appendToURLPath(i[0],"messages")+"?"+i[1]:appendToURLPath(i[0],"messages"),this.messagesContext=new Messages(getStorageClientContext(this._messagesUrl,this.pipeline))}get name(){return this._name}getMessageIdContext(e){const t=this._messagesUrl.split("?"),r=t[1]?appendToURLPath(t[0],e)+"?"+t[1]:appendToURLPath(t[0],e);return new MessageId(getStorageClientContext(r,this.pipeline))}async create(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-create",e);try{return await this.queueContext.create(Object.assign(Object.assign({},r),{abortSignal:e.abortSignal}))}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async createIfNotExists(e={}){var t,r;const{span:s,updatedOptions:a}=createSpan("QueueClient-createIfNotExists",e);try{const e=await this.create(a);return 204===e._response.status?Object.assign({succeeded:!1},e):Object.assign({succeeded:!0},e)}catch(e){if("QueueAlreadyExists"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return s.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:"Expected exception when creating a queue only if it does not already exist."}),Object.assign(Object.assign({succeeded:!1},null===(r=e.response)||void 0===r?void 0:r.parsedHeaders),{_response:e.response});throw s.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async deleteIfExists(e={}){var t,r;const{span:s,updatedOptions:a}=createSpan("QueueClient-deleteIfExists",e);try{const e=await this.delete(a);return Object.assign({succeeded:!0},e)}catch(e){if("QueueNotFound"===(null===(t=e.details)||void 0===t?void 0:t.errorCode))return s.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:"Expected exception when deleting a queue only if it exists."}),Object.assign(Object.assign({succeeded:!1},null===(r=e.response)||void 0===r?void 0:r.parsedHeaders),{_response:e.response});throw s.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async delete(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-delete",e);try{return await this.queueContext.delete({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions})}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async exists(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-exists",e);try{return await this.getProperties({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions}),!0}catch(e){if(404===e.statusCode)return t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:"Expected exception when checking queue existence"}),!1;throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async getProperties(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-getProperties",e);try{return await this.queueContext.getProperties({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions})}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setMetadata(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueClient-setMetadata",t);try{return await this.queueContext.setMetadata({abortSignal:t.abortSignal,metadata:e,tracingOptions:s.tracingOptions})}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async getAccessPolicy(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-getAccessPolicy",e);try{const t=await this.queueContext.getAccessPolicy({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions}),s={_response:t._response,date:t.date,requestId:t.requestId,clientRequestId:t.clientRequestId,signedIdentifiers:[],version:t.version,errorCode:t.errorCode};for(const e of t){let t;e.accessPolicy&&(t={permissions:e.accessPolicy.permissions},e.accessPolicy.expiresOn&&(t.expiresOn=new Date(e.accessPolicy.expiresOn)),e.accessPolicy.startsOn&&(t.startsOn=new Date(e.accessPolicy.startsOn))),s.signedIdentifiers.push({accessPolicy:t,id:e.id})}return s}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setAccessPolicy(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueClient-setAccessPolicy",t);try{const r=[];for(const t of e||[])r.push({accessPolicy:{expiresOn:t.accessPolicy.expiresOn?truncatedISO8061Date(t.accessPolicy.expiresOn):void 0,permissions:t.accessPolicy.permissions,startsOn:t.accessPolicy.startsOn?truncatedISO8061Date(t.accessPolicy.startsOn):void 0},id:t.id});return await this.queueContext.setAccessPolicy({abortSignal:t.abortSignal,queueAcl:r,tracingOptions:s.tracingOptions})}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async clearMessages(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-clearMessages",e);try{return await this.messagesContext.clear({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions})}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async sendMessage(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueClient-sendMessage",t);try{const t=await this.messagesContext.enqueue({messageText:e},s),r=t[0];return{_response:t._response,date:t.date,requestId:t.requestId,clientRequestId:t.clientRequestId,version:t.version,errorCode:t.errorCode,messageId:r.messageId,popReceipt:r.popReceipt,nextVisibleOn:r.nextVisibleOn,insertedOn:r.insertedOn,expiresOn:r.expiresOn}}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async receiveMessages(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-receiveMessages",e);try{const e=await this.messagesContext.dequeue(r),t={_response:e._response,date:e.date,requestId:e.requestId,clientRequestId:e.clientRequestId,receivedMessageItems:[],version:e.version,errorCode:e.errorCode};for(const r of e)t.receivedMessageItems.push(r);return t}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async peekMessages(e={}){const{span:t,updatedOptions:r}=createSpan("QueueClient-peekMessages",e);try{const e=await this.messagesContext.peek(r),t={_response:e._response,date:e.date,requestId:e.requestId,clientRequestId:e.clientRequestId,peekedMessageItems:[],version:e.version,errorCode:e.errorCode};for(const r of e)t.peekedMessageItems.push(r);return t}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async deleteMessage(e,t,r={}){const{span:s,updatedOptions:a}=createSpan("QueueClient-deleteMessage",r);try{return await this.getMessageIdContext(e).delete(t,{abortSignal:r.abortSignal,tracingOptions:a.tracingOptions})}catch(e){throw s.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{s.end()}}async updateMessage(e,t,r,s,a={}){const{span:i,updatedOptions:n}=createSpan("QueueClient-updateMessage",a);let o;void 0!==r&&(o={messageText:r});try{return await this.getMessageIdContext(e).update(t,s||0,{abortSignal:a.abortSignal,tracingOptions:n.tracingOptions,queueMessage:o})}catch(e){throw i.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{i.end()}}getQueueNameFromUrl(){let e;try{const t=coreHttp.URLBuilder.parse(this.url);if(e="queue"===t.getHost().split(".")[1]?t.getPath().split("/")[1]:isIpEndpointStyle(t)?t.getPath().split("/")[2]:t.getPath().split("/")[1],!e)throw new Error("Provided queueName is invalid.");return e}catch(e){throw new Error("Unable to extract queueName with provided information.")}}generateSasUrl(e){if(!(this.credential instanceof StorageSharedKeyCredential))throw RangeError("Can only generate the SAS when the client is initialized with a shared key credential");const t=generateQueueSASQueryParameters(Object.assign({queueName:this.name},e),this.credential).toString();return appendToURLQuery(this.url,t)}}class QueueServiceClient extends StorageClient{constructor(e,t,r){let s;s=t instanceof Pipeline?t:coreHttp.isNode&&t instanceof StorageSharedKeyCredential||t instanceof AnonymousCredential||coreHttp.isTokenCredential(t)?newPipeline(t,r):newPipeline(new AnonymousCredential,r),super(e,s),this.serviceContext=new Service(this.storageClientContext)}static fromConnectionString(e,t){t=t||{};const r=extractConnectionStringParts(e);if("AccountConnString"===r.kind){if(coreHttp.isNode){const e=new StorageSharedKeyCredential(r.accountName,r.accountKey);t.proxyOptions||(t.proxyOptions=coreHttp.getDefaultProxySettings(r.proxyUri));const s=newPipeline(e,t);return new QueueServiceClient(r.url,s)}throw new Error("Account connection string is only supported in Node.js environment")}if("SASConnString"===r.kind){const e=newPipeline(new AnonymousCredential,t);return new QueueServiceClient(r.url+"?"+r.accountSas,e)}throw new Error("Connection string must be either an Account connection string or a SAS connection string")}getQueueClient(e){return new QueueClient(appendToURLPath(this.url,e),this.pipeline)}async listQueuesSegment(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueServiceClient-listQueuesSegment",t);""===t.prefix&&(t.prefix=void 0);try{return await this.serviceContext.listQueuesSegment({abortSignal:t.abortSignal,marker:e,maxPageSize:t.maxPageSize,prefix:t.prefix,include:void 0===t.include?void 0:[t.include],tracingOptions:s.tracingOptions})}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}listSegments(e,t={}){return tslib.__asyncGenerator(this,arguments,(function*(){let r;""===t.prefix&&(t.prefix=void 0);do{r=yield tslib.__await(this.listQueuesSegment(e,t)),e=r.continuationToken,yield yield tslib.__await(yield tslib.__await(r))}while(e)}))}listItems(e={}){return tslib.__asyncGenerator(this,arguments,(function*(){var t,r;""===e.prefix&&(e.prefix=void 0);try{for(var s,a=tslib.__asyncValues(this.listSegments(undefined,e));!(s=yield tslib.__await(a.next())).done;){const e=s.value;e.queueItems&&(yield tslib.__await(yield*tslib.__asyncDelegator(tslib.__asyncValues(e.queueItems))))}}catch(e){t={error:e}}finally{try{s&&!s.done&&(r=a.return)&&(yield tslib.__await(r.call(a)))}finally{if(t)throw t.error}}}))}listQueues(e={}){""===e.prefix&&(e.prefix=void 0);const t=Object.assign(Object.assign({},e),e.includeMetadata?{include:"metadata"}:{}),r=this.listItems(t);return{next:()=>r.next(),[Symbol.asyncIterator](){return this},byPage:(e={})=>this.listSegments(e.continuationToken,Object.assign({maxPageSize:e.maxPageSize},t))}}async getProperties(e={}){const{span:t,updatedOptions:r}=createSpan("QueueServiceClient-getProperties",e);try{return await this.serviceContext.getProperties({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions})}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async setProperties(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueServiceClient-setProperties",t);try{return await this.serviceContext.setProperties(e,{abortSignal:t.abortSignal,tracingOptions:s.tracingOptions})}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async getStatistics(e={}){const{span:t,updatedOptions:r}=createSpan("QueueServiceClient-getStatistics",e);try{return await this.serviceContext.getStatistics({abortSignal:e.abortSignal,tracingOptions:r.tracingOptions})}catch(e){throw t.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{t.end()}}async createQueue(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueServiceClient-createQueue",t);try{return await this.getQueueClient(e).create(s)}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}async deleteQueue(e,t={}){const{span:r,updatedOptions:s}=createSpan("QueueServiceClient-deleteQueue",t);try{return await this.getQueueClient(e).delete(s)}catch(e){throw r.setStatus({code:coreTracing.SpanStatusCode.ERROR,message:e.message}),e}finally{r.end()}}generateAccountSasUrl(e,t=AccountSASPermissions.parse("r"),r="sco",s={}){if(!(this.credential instanceof StorageSharedKeyCredential))throw RangeError("Can only generate the account SAS when the client is initialized with a shared key credential");if(void 0===e){const t=new Date;e=new Date(t.getTime()+36e5)}const a=generateAccountSASQueryParameters(Object.assign({permissions:t,expiresOn:e,resourceTypes:r,services:AccountSASServices.parse("q").toString()},s),this.credential).toString();return appendToURLQuery(this.url,a)}}Object.defineProperty(exports,"BaseRequestPolicy",{enumerable:!0,get:function(){return coreHttp.BaseRequestPolicy}}),Object.defineProperty(exports,"HttpHeaders",{enumerable:!0,get:function(){return coreHttp.HttpHeaders}}),Object.defineProperty(exports,"RequestPolicyOptions",{enumerable:!0,get:function(){return coreHttp.RequestPolicyOptions}}),Object.defineProperty(exports,"RestError",{enumerable:!0,get:function(){return coreHttp.RestError}}),Object.defineProperty(exports,"WebResource",{enumerable:!0,get:function(){return coreHttp.WebResource}}),Object.defineProperty(exports,"deserializationPolicy",{enumerable:!0,get:function(){return coreHttp.deserializationPolicy}}),exports.AccountSASPermissions=AccountSASPermissions,exports.AccountSASResourceTypes=AccountSASResourceTypes,exports.AccountSASServices=AccountSASServices,exports.AnonymousCredential=AnonymousCredential,exports.AnonymousCredentialPolicy=AnonymousCredentialPolicy,exports.Credential=Credential,exports.CredentialPolicy=CredentialPolicy,exports.Pipeline=Pipeline,exports.QueueClient=QueueClient,exports.QueueSASPermissions=QueueSASPermissions,exports.QueueServiceClient=QueueServiceClient,exports.SASQueryParameters=SASQueryParameters,exports.StorageBrowserPolicy=StorageBrowserPolicy,exports.StorageBrowserPolicyFactory=StorageBrowserPolicyFactory,exports.StorageOAuthScopes=StorageOAuthScopes,exports.StorageRetryPolicy=StorageRetryPolicy,exports.StorageRetryPolicyFactory=StorageRetryPolicyFactory,exports.StorageSharedKeyCredential=StorageSharedKeyCredential,exports.StorageSharedKeyCredentialPolicy=StorageSharedKeyCredentialPolicy,exports.generateAccountSASQueryParameters=generateAccountSASQueryParameters,exports.generateQueueSASQueryParameters=generateQueueSASQueryParameters,exports.logger=logger,exports.newPipeline=newPipeline;