"use strict";Object.defineProperty(exports,"__esModule",{value:!0});
/*!
 * @module common/service-object
 */
const promisify_1=require("@google-cloud/promisify"),arrify=require("arrify"),events_1=require("events"),extend=require("extend"),util_1=require("./util");class ServiceObject extends events_1.EventEmitter{constructor(t){super(),this.metadata={},this.baseUrl=t.baseUrl,this.parent=t.parent,this.id=t.id,this.createMethod=t.createMethod,this.methods=t.methods||{},this.interceptors=[],this.pollIntervalMs=t.pollIntervalMs,this.projectId=t.projectId,t.methods&&Object.getOwnPropertyNames(ServiceObject.prototype).filter((e=>!/^request/.test(e)&&!/^getRequestInterceptors/.test(e)&&this[e]===ServiceObject.prototype[e]&&!t.methods[e])).forEach((t=>{this[t]=void 0}))}create(t,e){const s=this,r=[this.id];"function"==typeof t&&(e=t),"object"==typeof t&&r.push(t),r.push((function(...t){const[r,i]=t;r||(s.metadata=i.metadata,t[1]=s),e(...t)})),this.createMethod.apply(null,r)}delete(t,e){const[s,r]=util_1.util.maybeOptionsOrCallback(t,e),i=s.ignoreNotFound;delete s.ignoreNotFound;const o="object"==typeof this.methods.delete&&this.methods.delete||{},a=extend(!0,{method:"DELETE",uri:""},o.reqOpts,{qs:s});ServiceObject.prototype.request.call(this,a,((t,...e)=>{t&&404===t.code&&i&&(t=null),r(t,...e)}))}exists(t,e){const[s,r]=util_1.util.maybeOptionsOrCallback(t,e);this.get(s,(t=>{t?404===t.code?r(null,!1):r(t):r(null,!0)}))}get(t,e){const s=this,[r,i]=util_1.util.maybeOptionsOrCallback(t,e),o=Object.assign({},r),a=o.autoCreate&&"function"==typeof this.create;function c(t,e,r){if(t)return 409===t.code?void s.get(o,i):void i(t,null,r);i(null,e,r)}delete o.autoCreate,this.getMetadata(o,((t,e)=>{if(t){if(404===t.code&&a){const t=[];return Object.keys(o).length>0&&t.push(o),t.push(c),void s.create(...t)}i(t,null,e)}else i(null,s,e)}))}getMetadata(t,e){const[s,r]=util_1.util.maybeOptionsOrCallback(t,e),i="object"==typeof this.methods.getMetadata&&this.methods.getMetadata||{},o=extend(!0,{uri:""},i.reqOpts,{qs:s});ServiceObject.prototype.request.call(this,o,((t,e,s)=>{this.metadata=e,r(t,this.metadata,s)}))}getRequestInterceptors(){const t=this.interceptors.filter((t=>"function"==typeof t.request)).map((t=>t.request));return this.parent.getRequestInterceptors().concat(t)}setMetadata(t,e,s){const[r,i]=util_1.util.maybeOptionsOrCallback(e,s),o="object"==typeof this.methods.setMetadata&&this.methods.setMetadata||{},a=extend(!0,{},{method:"PATCH",uri:""},o.reqOpts,{json:t,qs:r});ServiceObject.prototype.request.call(this,a,((t,e,s)=>{this.metadata=e,i(t,this.metadata,s)}))}request_(t,e){t=extend(!0,{},t),this.projectId&&(t.projectId=this.projectId);const s=0===t.uri.indexOf("http"),r=[this.baseUrl,this.id||"",t.uri];s&&r.splice(0,r.indexOf(t.uri)),t.uri=r.filter((t=>t.trim())).map((t=>t.replace(/^\/*|\/*$/g,""))).join("/");const i=arrify(t.interceptors_),o=[].slice.call(this.interceptors);if(t.interceptors_=i.concat(o),t.shouldReturnStream)return this.parent.requestStream(t);this.parent.request(t,e)}request(t,e){this.request_(t,e)}requestStream(t){const e=extend(!0,t,{shouldReturnStream:!0});return this.request_(e)}}exports.ServiceObject=ServiceObject,promisify_1.promisifyAll(ServiceObject,{exclude:["getRequestInterceptors"]});