"use strict";Object.defineProperty(exports,"__esModule",{value:!0});
/*!
 * @module common/util
 */
const projectify_1=require("@google-cloud/projectify"),ent=require("ent"),extend=require("extend"),google_auth_library_1=require("google-auth-library"),retryRequest=require("retry-request"),stream_1=require("stream"),teeny_request_1=require("teeny-request"),duplexify=require("duplexify"),requestDefaults={timeout:6e4,gzip:!0,forever:!0,pool:{maxSockets:1/0}},AUTO_RETRY_DEFAULT=!0,MAX_RETRY_DEFAULT=3;class ApiError extends Error{constructor(e){if(super(),"object"!=typeof e)return void(this.message=e||"");const t=e;this.code=t.code,this.errors=t.errors,this.response=t.response;try{this.errors=JSON.parse(this.response.body).error.errors}catch(e){this.errors=t.errors}this.message=ApiError.createMultiErrorMessage(t,this.errors),Error.captureStackTrace(this)}static createMultiErrorMessage(e,t){const r=new Set;e.message&&r.add(e.message),t&&t.length?t.forEach((({message:e})=>r.add(e))):e.response&&e.response.body?r.add(ent.decode(e.response.body.toString())):e.message||r.add("A failure occurred during this request.");let o=Array.from(r);return o.length>1&&(o=o.map(((e,t)=>`    ${t+1}. ${e}`)),o.unshift("Multiple errors occurred during the request. Please see the `errors` array for complete details.\n"),o.push("\n")),o.join("\n")}}exports.ApiError=ApiError;class PartialFailureError extends Error{constructor(e){super();const t=e;this.errors=t.errors,this.name="PartialFailureError",this.response=t.response,this.message=ApiError.createMultiErrorMessage(t,this.errors)}}exports.PartialFailureError=PartialFailureError;class Util{constructor(){this.ApiError=ApiError,this.PartialFailureError=PartialFailureError}noop(){}handleResp(e,t,r,o){o=o||util.noop;const s=extend(!0,{err:e||null},t&&util.parseHttpRespMessage(t),r&&util.parseHttpRespBody(r));!s.err&&t&&"object"==typeof s.body&&(s.resp.body=s.body),s.err&&t&&(s.err.response=t),o(s.err,s.body,s.resp)}parseHttpRespMessage(e){const t={resp:e};return(e.statusCode<200||e.statusCode>299)&&(t.err=new ApiError({errors:new Array,code:e.statusCode,message:e.statusMessage,response:e})),t}parseHttpRespBody(e){const t={body:e};if("string"==typeof e)try{t.body=JSON.parse(e)}catch(r){t.body=e}return t.body&&t.body.error&&(t.err=new ApiError(t.body.error)),t}makeWritableStream(e,t,r){r=r||util.noop;const o=new ProgressStream;o.on("progress",(t=>e.emit("progress",t))),e.setWritable(o);const s=t.metadata||{},i=extend(!0,{method:"POST",qs:{uploadType:"multipart"},timeout:0,maxRetries:0},t.request,{multipart:[{"Content-Type":"application/json",body:JSON.stringify(s)},{"Content-Type":s.contentType||"application/octet-stream",body:o}]});t.makeAuthenticatedRequest(i,{onAuthenticated(t,o){if(t)return void e.destroy(t);teeny_request_1.teenyRequest.defaults(requestDefaults)(o,((t,o,s)=>{util.handleResp(t,o,s,((t,s)=>{t?e.destroy(t):(e.emit("response",o),r(s))}))}))}})}shouldRetryRequest(e){if(e){if(-1!==[408,429,500,502,503,504].indexOf(e.code))return!0;if(e.errors)for(const t of e.errors){const e=t.reason;if("rateLimitExceeded"===e)return!0;if("userRateLimitExceeded"===e)return!0;if(e&&e.includes("EAI_AGAIN"))return!0}}return!1}makeAuthenticatedRequestFactory(e){const t=extend({},e);let r;if("{{projectId}}"===t.projectId&&delete t.projectId,t.authClient instanceof google_auth_library_1.GoogleAuth)r=t.authClient;else{const e={...t,authClient:t.authClient};r=new google_auth_library_1.GoogleAuth(e)}const o=function(t,o){let s,i;const a=extend({},e);let n;o||(s=duplexify(),a.stream=s);const u="object"==typeof o?o:void 0,l="function"==typeof o?o:void 0,d=(e,r)=>{const o=e,d=e&&e.message.indexOf("Could not load the default credentials")>-1;if(d&&(r=t),!e||d)try{r=util.decorateRequest(r,i),e=null}catch(t){e=e||t}if(e)if(s)s.destroy(e);else{(u&&u.onAuthenticated?u.onAuthenticated:l)(e)}else u&&u.onAuthenticated?u.onAuthenticated(null,r):n=util.makeRequest(r,a,((e,...t)=>{e&&401===e.code&&o&&(e=o),l(e,...t)}))};return Promise.all([e.projectId&&"{{projectId}}"!==e.projectId?new Promise((t=>t(e.projectId))):r.getProjectId(),a.customEndpoint&&!0!==a.useAuthWithCustomEndpoint?new Promise((e=>e(t))):r.authorizeRequest(t)]).then((([e,t])=>{i=e,d(null,t)})).catch(d),s||{abort(){setImmediate((()=>{n&&(n.abort(),n=null)}))}}};return o.getCredentials=r.getCredentials.bind(r),o.authClient=r,o}makeRequest(e,t,r){var o,s,i,a,n,u,l;let d=true;if(void 0!==t.autoRetry&&void 0!==(null===(o=t.retryOptions)||void 0===o?void 0:o.autoRetry))throw new ApiError("autoRetry is deprecated. Use retryOptions.autoRetry instead.");void 0!==t.autoRetry?d=t.autoRetry:void 0!==(null===(s=t.retryOptions)||void 0===s?void 0:s.autoRetry)&&(d=t.retryOptions.autoRetry);let p=3;if(t.maxRetries&&(null===(i=t.retryOptions)||void 0===i?void 0:i.maxRetries))throw new ApiError("maxRetries is deprecated. Use retryOptions.maxRetries instead.");t.maxRetries?p=t.maxRetries:(null===(a=t.retryOptions)||void 0===a?void 0:a.maxRetries)&&(p=t.retryOptions.maxRetries);const c={request:teeny_request_1.teenyRequest.defaults(requestDefaults),retries:!1!==d?p:0,noResponseRetries:!1!==d?p:0,shouldRetryFn(e){var r,o;const s=util.parseHttpRespMessage(e).err;return(null===(r=t.retryOptions)||void 0===r?void 0:r.retryableErrorFn)?s&&(null===(o=t.retryOptions)||void 0===o?void 0:o.retryableErrorFn(s)):s&&util.shouldRetryRequest(s)},maxRetryDelay:null===(n=t.retryOptions)||void 0===n?void 0:n.maxRetryDelay,retryDelayMultiplier:null===(u=t.retryOptions)||void 0===u?void 0:u.retryDelayMultiplier,totalTimeout:null===(l=t.retryOptions)||void 0===l?void 0:l.totalTimeout};if("number"==typeof e.maxRetries&&(c.retries=e.maxRetries),!t.stream)return retryRequest(e,c,((e,t,o)=>{util.handleResp(e,t,o,r)}));const y=t.stream;let m;return"GET"===(e.method||"GET").toUpperCase()?(m=retryRequest(e,c),y.setReadable(m)):(m=c.request(e),y.setWritable(m)),m.on("error",y.destroy.bind(y)).on("response",y.emit.bind(y,"response")).on("complete",y.emit.bind(y,"complete")),y.abort=m.abort,y}decorateRequest(e,t){return delete e.autoPaginate,delete e.autoPaginateVal,delete e.objectMode,null!==e.qs&&"object"==typeof e.qs&&(delete e.qs.autoPaginate,delete e.qs.autoPaginateVal,e.qs=projectify_1.replaceProjectIdToken(e.qs,t)),Array.isArray(e.multipart)&&(e.multipart=e.multipart.map((e=>projectify_1.replaceProjectIdToken(e,t)))),null!==e.json&&"object"==typeof e.json&&(delete e.json.autoPaginate,delete e.json.autoPaginateVal,e.json=projectify_1.replaceProjectIdToken(e.json,t)),e.uri=projectify_1.replaceProjectIdToken(e.uri,t),e}isCustomType(e,t){function r(e){return e.constructor&&e.constructor.name.toLowerCase()}const o=t.split("/"),s=o[0]&&o[0].toLowerCase(),i=o[1]&&o[1].toLowerCase();if(i&&r(e)!==i)return!1;let a=e;for(;;){if(r(a)===s)return!0;if(a=a.parent,!a)return!1}}getUserAgentFromPackageJson(e){return e.name.replace("@google-cloud","gcloud-node").replace("/","-")+"/"+e.version}maybeOptionsOrCallback(e,t){return"function"==typeof e?[{},e]:[e,t]}}exports.Util=Util;class ProgressStream extends stream_1.Transform{constructor(){super(...arguments),this.bytesRead=0}_transform(e,t,r){this.bytesRead+=e.length,this.emit("progress",{bytesWritten:this.bytesRead,contentLength:"*"}),this.push(e),r()}}const util=new Util;exports.util=util;