"use strict";
/*!
 * Copyright 2018 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.ModAckQueue=exports.AckQueue=exports.MessageQueue=exports.BatchError=void 0;const google_gax_1=require("google-gax"),defer=require("p-defer"),ack_metadata_1=require("./ack-metadata"),exponential_retry_1=require("./exponential-retry"),subscriber_1=require("./subscriber"),temporal_1=require("./temporal"),util_1=require("./util"),debug_1=require("./debug");class BatchError extends debug_1.DebugMessage{constructor(e,s,r){super(`Failed to "${r}" for ${s.length} message(s). Reason: ${process.env.DEBUG_GRPC?e.stack:e.message}`,e),this.ackIds=s,this.code=e.code,this.details=e.message}}exports.BatchError=BatchError;class MessageQueue{constructor(e,s={}){this._closed=!1,this.numPendingRequests=0,this.numInFlightRequests=0,this.numInRetryRequests=0,this._requests=[],this._subscriber=e,this._retrier=new exponential_retry_1.ExponentialRetry(temporal_1.Duration.from({seconds:1}),temporal_1.Duration.from({seconds:64})),this.setOptions(s)}close(){let e=this._requests;this._requests=[],this.numInFlightRequests=this.numPendingRequests=0,e=e.concat(this._retrier.close());const s=this._subscriber.isExactlyOnceDelivery;e.forEach((e=>{e.responsePromise&&(s?e.responsePromise.reject(new subscriber_1.AckError(subscriber_1.AckResponses.Invalid,"Subscriber closed")):e.responsePromise.resolve())})),this._closed=!0}get maxMilliseconds(){return this._options.maxMilliseconds}add({ackId:e},s){if(this._closed){if(this._subscriber.isExactlyOnceDelivery)throw new subscriber_1.AckError(subscriber_1.AckResponses.Invalid,"Subscriber closed");return Promise.resolve()}const{maxMessages:r,maxMilliseconds:t}=this._options,i=defer();return this._requests.push({ackId:e,deadline:s,responsePromise:i,retryCount:0}),this.numPendingRequests++,this.numInFlightRequests++,this._requests.length>=r?this.flush():this._timer||(this._timer=setTimeout((()=>this.flush()),t)),i.promise}handleRetry(e,s){var r;s.totalOf("minute")>=10||this.shouldFailEarly(e)?null===(r=e.responsePromise)||void 0===r||r.reject(new subscriber_1.AckError(subscriber_1.AckResponses.Invalid,"Retried for too long")):(this._requests.push(e),this.numPendingRequests++,this.numInFlightRequests++,this.numInRetryRequests--,this._timer||(this._timer=setTimeout((()=>this.flush()),this._options.maxMilliseconds)))}shouldFailEarly(e){return!1}async flush(){this._timer&&(clearTimeout(this._timer),delete this._timer);const e=this._requests,s=e.length,r=this._onFlush;this._requests=[],this.numPendingRequests-=s,delete this._onFlush;try{const s=await this._sendBatch(e);for(const e of s)this.numInRetryRequests++,e.retryCount++,this._retrier.retryLater(e,this.handleRetry.bind(this))}catch(e){const s=e,r=new debug_1.DebugMessage(s.message,s);this._subscriber.emit("debug",r)}this.numInFlightRequests-=s,r&&r.resolve(),this.numInFlightRequests<=0&&this.numInRetryRequests<=0&&this._onDrain&&(this._onDrain.resolve(),delete this._onDrain)}onFlush(){return this._onFlush||(this._onFlush=defer()),this._onFlush.promise}onDrain(){return this._onDrain||(this._onDrain=defer()),this._onDrain.promise}setOptions(e){this._options=Object.assign({maxMessages:3e3,maxMilliseconds:100},e)}handleAckSuccesses(e){e.forEach((({responsePromise:e})=>{null==e||e.resolve()}))}handleAckFailures(e,s,r){const t=[],i=[],n=new Map([[subscriber_1.AckResponses.PermissionDenied,[]],[subscriber_1.AckResponses.FailedPrecondition,[]],[subscriber_1.AckResponses.Other,[]]]),o=r.code?(0,ack_metadata_1.processAckRpcError)(r.code):void 0,c=(0,ack_metadata_1.processAckErrorInfo)(r);for(const e of s)if(c.has(e.ackId)){const s=c.get(e.ackId);s.transient?i.push(e):(0,util_1.addToBucket)(n,s.response,e)}else void 0!==o?o.transient?i.push(e):(0,util_1.addToBucket)(n,o.response,e):t.push(e);const u=n.get(subscriber_1.AckResponses.Other);if(null==u?void 0:u.length){const s=u.map((e=>e.ackId)),t=new BatchError(r,s,e);this._subscriber.emit("debug",t)}t.forEach((e=>{var s;null===(s=e.responsePromise)||void 0===s||s.resolve()}));for(const e of n.entries())e[1].forEach((s=>{var t;const i=new subscriber_1.AckError(e[0],r.message);null===(t=s.responsePromise)||void 0===t||t.reject(i)}));return{toError:n,toRetry:i}}getCallOptions(){let e=this._options.callOptions;return this._subscriber.isExactlyOnceDelivery&&(e=Object.assign({},null!=e?e:{}),e.retry=new google_gax_1.RetryOptions([],{initialRetryDelayMillis:0,retryDelayMultiplier:0,maxRetryDelayMillis:0})),e}}exports.MessageQueue=MessageQueue;class AckQueue extends MessageQueue{async _sendBatch(e){const s=await this._subscriber.getClient(),r=e.map((({ackId:e})=>e)),t={subscription:this._subscriber.name,ackIds:r};try{return await s.acknowledge(t,this.getCallOptions()),this.handleAckSuccesses(e),[]}catch(s){if(!this._subscriber.isExactlyOnceDelivery)throw e.forEach((e=>{var s;null===(s=e.responsePromise)||void 0===s||s.resolve()})),new BatchError(s,r,"ack");{const r=s;try{return this.handleAckFailures("ack",e,r).toRetry}catch(s){const r=s;this._subscriber.emit("debug",new debug_1.DebugMessage(r.message,r));const t=new subscriber_1.AckError(subscriber_1.AckResponses.Other,"Code error");return e.forEach((e=>{var s;null===(s=e.responsePromise)||void 0===s||s.reject(t)})),[]}}}}}exports.AckQueue=AckQueue;class ModAckQueue extends MessageQueue{async _sendBatch(e){const s=await this._subscriber.getClient(),r=this._subscriber.name,t=e.reduce(((e,s)=>(e[s.deadline]||(e[s.deadline]=[]),e[s.deadline].push(s),e)),{}),i=this.getCallOptions(),n=Object.keys(t).map((async n=>{const o=t[n],c=o.map((e=>e.ackId)),u=Number(n),a={subscription:r,ackIds:c,ackDeadlineSeconds:u};try{return await s.modifyAckDeadline(a,i),this.handleAckSuccesses(o),[]}catch(s){if(this._subscriber.isExactlyOnceDelivery){const e=s;return this.handleAckFailures("modAck",o,e).toRetry}throw e.forEach((e=>{var s;null===(s=e.responsePromise)||void 0===s||s.resolve()})),new BatchError(s,c,"modAck")}}));return(await Promise.all(n)).reduce(((e,s)=>[...null!=e?e:[],...s]))}shouldFailEarly(e){return e.retryCount>=3}}exports.ModAckQueue=ModAckQueue;