"use strict";
/*!
 * Copyright 2019 Google Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */Object.defineProperty(exports,"__esModule",{value:!0}),exports.Publisher=exports.flowControlDefaults=exports.BATCH_LIMITS=void 0;const extend=require("extend"),semantic_conventions_1=require("@opentelemetry/semantic-conventions"),api_1=require("@opentelemetry/api"),message_queues_1=require("./message-queues"),default_options_1=require("../default-options"),opentelemetry_tracing_1=require("../opentelemetry-tracing"),flow_control_1=require("./flow-control"),util_1=require("../util");exports.BATCH_LIMITS={maxBytes:9*Math.pow(1024,2),maxMessages:1e3},exports.flowControlDefaults={maxOutstandingBytes:void 0,maxOutstandingMessages:void 0};class Publisher{constructor(e,t){this.flowControl=new flow_control_1.FlowControl((null==t?void 0:t.flowControlOptions)||exports.flowControlDefaults),this.setOptions(t),this.topic=e,this.queue=new message_queues_1.Queue(this),this.orderedQueues=new Map}flush(e){const t=e||(()=>{}),s=[this.queue,...Array.from(this.orderedQueues.values())],n=Promise.all(s.map((e=>new Promise((t=>{const s=()=>{t(),e.removeListener("drain",s)};e.on("drain",s)})))));Promise.all(s.map((e=>e.publishDrain()))).then((()=>n)).then((()=>{t(null)})).catch(t)}publish(e,t,s){const n="object"==typeof t?t:{};return s="function"==typeof t?t:s,this.publishMessage({data:e,attributes:n},s)}publishMessage(e,t){const{data:s,attributes:n={}}=e;if(s&&!(s instanceof Buffer))throw new TypeError("Data must be in the form of a Buffer.");const i=Object.keys(n);if(!s&&0===i.length)throw new TypeError("If data is undefined, at least one attribute must be present.");for(const e of i){const t=n[e];if("string"!=typeof t)throw new TypeError(`All attributes must be in the form of a string.\n\nInvalid value of type "${typeof t}" provided for "${e}".`)}const o=this.constructSpan(e);if(!e.orderingKey)return this.queue.add(e,t),void(o&&o.end());const r=e.orderingKey;if(!this.orderedQueues.has(r)){const e=new message_queues_1.OrderedQueue(this,r);this.orderedQueues.set(r,e),e.once("drain",(()=>this.orderedQueues.delete(r)))}this.orderedQueues.get(r).add(e,t),o&&o.end()}resumePublishing(e){const t=this.orderedQueues.get(e);t&&t.resumePublishing()}getOptionDefaults(){return{batching:{maxBytes:default_options_1.defaultOptions.publish.maxOutstandingBytes,maxMessages:default_options_1.defaultOptions.publish.maxOutstandingMessages,maxMilliseconds:default_options_1.defaultOptions.publish.maxDelayMillis},messageOrdering:!1,gaxOpts:{isBundling:!1},enableOpenTelemetryTracing:!1,flowControlOptions:Object.assign({},exports.flowControlDefaults)}}setOptions(e={}){const t=this.getOptionDefaults(),{batching:s,gaxOpts:n,messageOrdering:i,enableOpenTelemetryTracing:o,flowControlOptions:r}=extend(!0,t,e);if(this.settings={batching:{maxBytes:Math.min(s.maxBytes,exports.BATCH_LIMITS.maxBytes),maxMessages:Math.min(s.maxMessages,exports.BATCH_LIMITS.maxMessages),maxMilliseconds:s.maxMilliseconds},gaxOpts:n,messageOrdering:i,enableOpenTelemetryTracing:o,flowControlOptions:r},this.queue&&this.queue.updateOptions(),this.orderedQueues)for(const e of this.orderedQueues.values())e.updateOptions();this.flowControl.setOptions(this.settings.flowControlOptions)}constructSpan(e){var t;if(!this.settings.enableOpenTelemetryTracing)return;const s={[semantic_conventions_1.SemanticAttributes.MESSAGING_TEMP_DESTINATION]:!1,[semantic_conventions_1.SemanticAttributes.MESSAGING_SYSTEM]:"pubsub",[semantic_conventions_1.SemanticAttributes.MESSAGING_OPERATION]:"send",[semantic_conventions_1.SemanticAttributes.MESSAGING_DESTINATION]:this.topic.name,[semantic_conventions_1.SemanticAttributes.MESSAGING_DESTINATION_KIND]:"topic",[semantic_conventions_1.SemanticAttributes.MESSAGING_MESSAGE_ID]:e.messageId,[semantic_conventions_1.SemanticAttributes.MESSAGING_PROTOCOL]:"pubsub",[semantic_conventions_1.SemanticAttributes.MESSAGING_MESSAGE_PAYLOAD_SIZE_BYTES]:null===(t=e.data)||void 0===t?void 0:t.length,"messaging.pubsub.ordering_key":e.orderingKey},n=(0,opentelemetry_tracing_1.createSpan)(`${this.topic.name} send`,api_1.SpanKind.PRODUCER,s);return(0,api_1.isSpanContextValid)(n.spanContext())&&(e.attributes&&e.attributes.googclient_OpenTelemetrySpanContext&&console.warn("googclient_OpenTelemetrySpanContext key set as message attribute, but will be overridden."),e.attributes||(e.attributes={}),e.attributes.googclient_OpenTelemetrySpanContext=JSON.stringify(n.spanContext())),n}}exports.Publisher=Publisher,(0,util_1.promisifySome)(Publisher,Publisher.prototype,["flush","publishMessage"],{singular:!0});