"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.SubscriberClient=void 0;const stream_1=require("stream"),jsonProtos=require("../../protos/protos.json"),gapicConfig=require("./subscriber_client_config.json"),version=require("../../../package.json").version;class SubscriberClient{constructor(e,t){var s,r,i,o,a;this._terminated=!1,this.descriptors={page:{},stream:{},longrunning:{},batching:{}};const n=this.constructor;if((null==e?void 0:e.universe_domain)&&(null==e?void 0:e.universeDomain)&&(null==e?void 0:e.universe_domain)!==(null==e?void 0:e.universeDomain))throw new Error("Please set either universe_domain or universeDomain, but not both.");const h="object"==typeof process&&"object"==typeof process.env?process.env.GOOGLE_CLOUD_UNIVERSE_DOMAIN:void 0;this._universeDomain=null!==(i=null!==(r=null!==(s=null==e?void 0:e.universeDomain)&&void 0!==s?s:null==e?void 0:e.universe_domain)&&void 0!==r?r:h)&&void 0!==i?i:"googleapis.com",this._servicePath="pubsub."+this._universeDomain;const p=(null==e?void 0:e.servicePath)||(null==e?void 0:e.apiEndpoint)||this._servicePath;this._providedCustomServicePath=!(!(null==e?void 0:e.servicePath)&&!(null==e?void 0:e.apiEndpoint));const l=(null==e?void 0:e.port)||n.port,u=null!==(o=null==e?void 0:e.clientConfig)&&void 0!==o?o:{},c=null!==(a=null==e?void 0:e.fallback)&&void 0!==a?a:"undefined"!=typeof window&&"function"==typeof(null===window||void 0===window?void 0:window.fetch);(e=Object.assign({servicePath:p,port:l,clientConfig:u,fallback:c},e)).numericEnums=!0,p===this._servicePath||"scopes"in e||(e.scopes=n.scopes),t||(t=require("google-gax")),this._gaxModule=e.fallback?t.fallback:t,this._gaxGrpc=new this._gaxModule.GrpcClient(e),this._opts=e,this.auth=this._gaxGrpc.auth,this.auth.useJWTAccessWithScope=!0,this.auth.defaultServicePath=this._servicePath,p===this._servicePath&&(this.auth.defaultScopes=n.scopes),this.iamClient=new this._gaxModule.IamClient(this._gaxGrpc,e);const g=[`gax/${this._gaxModule.version}`,`gapic/${version}`];"object"==typeof process&&"versions"in process?g.push(`gl-node/${process.versions.node}`):g.push(`gl-web/${this._gaxModule.version}`),e.fallback?g.push(`rest/${this._gaxGrpc.grpcVersion}`):g.push(`grpc/${this._gaxGrpc.grpcVersion}`),e.libName&&e.libVersion&&g.push(`${e.libName}/${e.libVersion}`),this._protos=this._gaxGrpc.loadProtoJSON(jsonProtos),this.pathTemplates={projectPathTemplate:new this._gaxModule.PathTemplate("projects/{project}"),projectTopicPathTemplate:new this._gaxModule.PathTemplate("projects/{project}/topics/{topic}"),schemaPathTemplate:new this._gaxModule.PathTemplate("projects/{project}/schemas/{schema}"),snapshotPathTemplate:new this._gaxModule.PathTemplate("projects/{project}/snapshots/{snapshot}"),subscriptionPathTemplate:new this._gaxModule.PathTemplate("projects/{project}/subscriptions/{subscription}")},this.descriptors.page={listSubscriptions:new this._gaxModule.PageDescriptor("pageToken","nextPageToken","subscriptions"),listSnapshots:new this._gaxModule.PageDescriptor("pageToken","nextPageToken","snapshots")},this.descriptors.stream={streamingPull:new this._gaxModule.StreamDescriptor(this._gaxModule.StreamType.BIDI_STREAMING,!!e.fallback,!!e.gaxServerStreamingRetries)},this._defaults=this._gaxGrpc.constructSettings("google.pubsub.v1.Subscriber",gapicConfig,e.clientConfig||{},{"x-goog-api-client":g.join(" ")}),this.innerApiCalls={},this.warn=this._gaxModule.warn}initialize(){if(this.subscriberStub)return this.subscriberStub;this.subscriberStub=this._gaxGrpc.createStub(this._opts.fallback?this._protos.lookupService("google.pubsub.v1.Subscriber"):this._protos.google.pubsub.v1.Subscriber,this._opts,this._providedCustomServicePath);const e=["createSubscription","getSubscription","updateSubscription","listSubscriptions","deleteSubscription","modifyAckDeadline","acknowledge","pull","streamingPull","modifyPushConfig","getSnapshot","listSnapshots","createSnapshot","updateSnapshot","deleteSnapshot","seek"];for(const t of e){const e=this.subscriberStub.then((e=>(...s)=>{if(this._terminated){if(t in this.descriptors.stream){const e=new stream_1.PassThrough;return setImmediate((()=>{e.emit("error",new this._gaxModule.GoogleError("The client has already been closed."))})),e}return Promise.reject("The client has already been closed.")}return e[t].apply(e,s)}),(e=>()=>{throw e})),s=this.descriptors.page[t]||this.descriptors.stream[t]||void 0,r=this._gaxModule.createApiCall(e,this._defaults[t],s,this._opts.fallback);this.innerApiCalls[t]=r}return this.subscriberStub}static get servicePath(){return"object"==typeof process&&"function"==typeof process.emitWarning&&process.emitWarning("Static servicePath is deprecated, please use the instance method instead.","DeprecationWarning"),"pubsub.googleapis.com"}static get apiEndpoint(){return"object"==typeof process&&"function"==typeof process.emitWarning&&process.emitWarning("Static apiEndpoint is deprecated, please use the instance method instead.","DeprecationWarning"),"pubsub.googleapis.com"}get apiEndpoint(){return this._servicePath}get universeDomain(){return this._universeDomain}static get port(){return 443}static get scopes(){return["https://www.googleapis.com/auth/cloud-platform","https://www.googleapis.com/auth/pubsub"]}getProjectId(e){if(!e)return this.auth.getProjectId();this.auth.getProjectId(e)}createSubscription(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({name:null!==(r=e.name)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.createSubscription(e,i,s)}getSubscription(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.getSubscription(e,i,s)}updateSubscription(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({"subscription.name":null!==(r=e.subscription.name)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.updateSubscription(e,i,s)}deleteSubscription(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.deleteSubscription(e,i,s)}modifyAckDeadline(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.modifyAckDeadline(e,i,s)}acknowledge(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.acknowledge(e,i,s)}pull(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.pull(e,i,s)}modifyPushConfig(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.modifyPushConfig(e,i,s)}getSnapshot(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({snapshot:null!==(r=e.snapshot)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.getSnapshot(e,i,s)}createSnapshot(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({name:null!==(r=e.name)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.createSnapshot(e,i,s)}updateSnapshot(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({"snapshot.name":null!==(r=e.snapshot.name)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.updateSnapshot(e,i,s)}deleteSnapshot(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({snapshot:null!==(r=e.snapshot)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.deleteSnapshot(e,i,s)}seek(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({subscription:null!==(r=e.subscription)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.seek(e,i,s)}streamingPull(e){return this.initialize(),this.innerApiCalls.streamingPull(null,e)}listSubscriptions(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({project:null!==(r=e.project)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.listSubscriptions(e,i,s)}listSubscriptionsStream(e,t){var s;e=e||{},(t=t||{}).otherArgs=t.otherArgs||{},t.otherArgs.headers=t.otherArgs.headers||{},t.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({project:null!==(s=e.project)&&void 0!==s?s:""});const r=this._defaults.listSubscriptions.merge(t);return this.initialize(),this.descriptors.page.listSubscriptions.createStream(this.innerApiCalls.listSubscriptions,e,r)}listSubscriptionsAsync(e,t){var s;e=e||{},(t=t||{}).otherArgs=t.otherArgs||{},t.otherArgs.headers=t.otherArgs.headers||{},t.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({project:null!==(s=e.project)&&void 0!==s?s:""});const r=this._defaults.listSubscriptions.merge(t);return this.initialize(),this.descriptors.page.listSubscriptions.asyncIterate(this.innerApiCalls.listSubscriptions,e,r)}listSnapshots(e,t,s){var r;let i;return e=e||{},"function"==typeof t&&void 0===s?(s=t,i={}):i=t,i=i||{},i.otherArgs=i.otherArgs||{},i.otherArgs.headers=i.otherArgs.headers||{},i.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({project:null!==(r=e.project)&&void 0!==r?r:""}),this.initialize(),this.innerApiCalls.listSnapshots(e,i,s)}listSnapshotsStream(e,t){var s;e=e||{},(t=t||{}).otherArgs=t.otherArgs||{},t.otherArgs.headers=t.otherArgs.headers||{},t.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({project:null!==(s=e.project)&&void 0!==s?s:""});const r=this._defaults.listSnapshots.merge(t);return this.initialize(),this.descriptors.page.listSnapshots.createStream(this.innerApiCalls.listSnapshots,e,r)}listSnapshotsAsync(e,t){var s;e=e||{},(t=t||{}).otherArgs=t.otherArgs||{},t.otherArgs.headers=t.otherArgs.headers||{},t.otherArgs.headers["x-goog-request-params"]=this._gaxModule.routingHeader.fromParams({project:null!==(s=e.project)&&void 0!==s?s:""});const r=this._defaults.listSnapshots.merge(t);return this.initialize(),this.descriptors.page.listSnapshots.asyncIterate(this.innerApiCalls.listSnapshots,e,r)}getIamPolicy(e,t,s){return this.iamClient.getIamPolicy(e,t,s)}setIamPolicy(e,t,s){return this.iamClient.setIamPolicy(e,t,s)}testIamPermissions(e,t,s){return this.iamClient.testIamPermissions(e,t,s)}projectPath(e){return this.pathTemplates.projectPathTemplate.render({project:e})}matchProjectFromProjectName(e){return this.pathTemplates.projectPathTemplate.match(e).project}projectTopicPath(e,t){return this.pathTemplates.projectTopicPathTemplate.render({project:e,topic:t})}matchProjectFromProjectTopicName(e){return this.pathTemplates.projectTopicPathTemplate.match(e).project}matchTopicFromProjectTopicName(e){return this.pathTemplates.projectTopicPathTemplate.match(e).topic}schemaPath(e,t){return this.pathTemplates.schemaPathTemplate.render({project:e,schema:t})}matchProjectFromSchemaName(e){return this.pathTemplates.schemaPathTemplate.match(e).project}matchSchemaFromSchemaName(e){return this.pathTemplates.schemaPathTemplate.match(e).schema}snapshotPath(e,t){return this.pathTemplates.snapshotPathTemplate.render({project:e,snapshot:t})}matchProjectFromSnapshotName(e){return this.pathTemplates.snapshotPathTemplate.match(e).project}matchSnapshotFromSnapshotName(e){return this.pathTemplates.snapshotPathTemplate.match(e).snapshot}subscriptionPath(e,t){return this.pathTemplates.subscriptionPathTemplate.render({project:e,subscription:t})}matchProjectFromSubscriptionName(e){return this.pathTemplates.subscriptionPathTemplate.match(e).project}matchSubscriptionFromSubscriptionName(e){return this.pathTemplates.subscriptionPathTemplate.match(e).subscription}close(){return this.subscriberStub&&!this._terminated?this.subscriberStub.then((e=>{this._terminated=!0,e.close(),this.iamClient.close()})):Promise.resolve()}}exports.SubscriberClient=SubscriberClient;