"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Bucket=exports.BucketExceptionMessages=exports.AvailableServiceObjectMethods=exports.BucketActionToHTTPMethod=void 0;const common_1=require("@google-cloud/common"),paginator_1=require("@google-cloud/paginator"),promisify_1=require("@google-cloud/promisify"),arrify=require("arrify"),extend=require("extend"),fs=require("fs"),mime=require("mime-types"),path=require("path"),pLimit=require("p-limit"),util_1=require("util"),retry=require("async-retry"),snakeize=require("snakeize"),acl_1=require("./acl"),file_1=require("./file"),iam_1=require("./iam"),notification_1=require("./notification"),storage_1=require("./storage"),signer_1=require("./signer"),stream_1=require("stream");var BucketActionToHTTPMethod,AvailableServiceObjectMethods,BucketExceptionMessages;!function(e){e.list="GET"}(BucketActionToHTTPMethod=exports.BucketActionToHTTPMethod||(exports.BucketActionToHTTPMethod={})),function(e){e[e.setMetadata=0]="setMetadata",e[e.delete=1]="delete"}(AvailableServiceObjectMethods=exports.AvailableServiceObjectMethods||(exports.AvailableServiceObjectMethods={})),function(e){e.PROVIDE_SOURCE_FILE="You must provide at least one source file.",e.DESTINATION_FILE_NOT_SPECIFIED="A destination file must be specified.",e.CHANNEL_ID_REQUIRED="An ID is required to create a channel.",e.CHANNEL_ADDRESS_REQUIRED="An address is required to create a channel.",e.TOPIC_NAME_REQUIRED="A valid topic name is required.",e.CONFIGURATION_OBJECT_PREFIX_REQUIRED="A configuration object with a prefix is required.",e.SPECIFY_FILE_NAME="A file name must be specified.",e.METAGENERATION_NOT_PROVIDED="A metageneration must be provided.",e.SUPPLY_NOTIFICATION_ID="You must supply a notification ID."}(BucketExceptionMessages=exports.BucketExceptionMessages||(exports.BucketExceptionMessages={}));const RESUMABLE_THRESHOLD=5e6;class Bucket extends common_1.ServiceObject{constructor(e,t,i){var o,s,a,r;i=i||{},t=t.replace(/^gs:\/\//,"").replace(/\/+$/,"");const n={};(null===(o=null==i?void 0:i.preconditionOpts)||void 0===o?void 0:o.ifGenerationMatch)&&(n.ifGenerationMatch=i.preconditionOpts.ifGenerationMatch),(null===(s=null==i?void 0:i.preconditionOpts)||void 0===s?void 0:s.ifGenerationNotMatch)&&(n.ifGenerationNotMatch=i.preconditionOpts.ifGenerationNotMatch),(null===(a=null==i?void 0:i.preconditionOpts)||void 0===a?void 0:a.ifMetagenerationMatch)&&(n.ifMetagenerationMatch=i.preconditionOpts.ifMetagenerationMatch),(null===(r=null==i?void 0:i.preconditionOpts)||void 0===r?void 0:r.ifMetagenerationNotMatch)&&(n.ifMetagenerationNotMatch=i.preconditionOpts.ifMetagenerationNotMatch);const c=i.userProject;"string"==typeof c&&(n.userProject=c);const l={create:{reqOpts:{qs:n}},delete:{reqOpts:{qs:n}},exists:{reqOpts:{qs:n}},get:{reqOpts:{qs:n}},getMetadata:{reqOpts:{qs:n}},setMetadata:{reqOpts:{qs:n}}};super({parent:e,baseUrl:"/b",id:t,createMethod:e.createBucket.bind(e),methods:l}),this.name=t,this.storage=e,this.userProject=i.userProject,this.acl=new acl_1.Acl({request:this.request.bind(this),pathPrefix:"/acl"}),this.acl.default=new acl_1.Acl({request:this.request.bind(this),pathPrefix:"/defaultObjectAcl"}),this.iam=new iam_1.Iam(this),this.getFilesStream=paginator_1.paginator.streamify("getFiles"),this.instanceRetryValue=e.retryOptions.autoRetry,this.instancePreconditionOpts=null==i?void 0:i.preconditionOpts}getFilesStream(e){return new stream_1.Readable}addLifecycleRule(e,t,i){let o;"function"==typeof t?i=t:t&&(o=t),o=o||{};const s=arrify(e).map((e=>{if("object"==typeof e.action)return e;const t={condition:{}};t.action={type:e.action.charAt(0).toUpperCase()+e.action.slice(1)},e.storageClass&&(t.action.storageClass=e.storageClass);for(const i in e.condition)e.condition[i]instanceof Date?t.condition[i]=e.condition[i].toISOString().replace(/T.+$/,""):t.condition[i]=e.condition[i];return t}));if(this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),!1===o.append)return this.setMetadata({lifecycle:{rule:s}},i),void(this.storage.retryOptions.autoRetry=this.instanceRetryValue);this.getMetadata(((e,t)=>{if(e)return void i(e);const o=arrify(t.lifecycle&&t.lifecycle.rule);this.setMetadata({lifecycle:{rule:o.concat(s)}},i)})),this.storage.retryOptions.autoRetry=this.instanceRetryValue}combine(e,t,i,o){if(!Array.isArray(e)||0===e.length)throw new Error(BucketExceptionMessages.PROVIDE_SOURCE_FILE);if(!t)throw new Error(BucketExceptionMessages.DESTINATION_FILE_NOT_SPECIFIED);let s={};"function"==typeof i?o=i:i&&(s=i);const a=e=>e instanceof file_1.File?e:this.file(e);e=e.map(a);const r=a(t);if(o=o||common_1.util.noop,!r.metadata.contentType){const e=mime.contentType(r.name);e&&(r.metadata.contentType=e)}let n=this.storage.retryOptions.maxRetries;e.forEach((e=>{var t;(void 0===(null===(t=null==e?void 0:e.instancePreconditionOpts)||void 0===t?void 0:t.ifGenerationMatch)&&this.storage.retryOptions.idempotencyStrategy===storage_1.IdempotencyStrategy.RetryConditional||this.storage.retryOptions.idempotencyStrategy===storage_1.IdempotencyStrategy.RetryNever)&&(n=0)})),Object.assign(s,this.instancePreconditionOpts,s),r.request({method:"POST",uri:"/compose",maxRetries:n,json:{destination:{contentType:r.metadata.contentType},sourceObjects:e.map((e=>{var t,i,o,s;const a={name:e.name};return((null===(t=null==e?void 0:e.metadata)||void 0===t?void 0:t.generation)||(null===(i=null==e?void 0:e.instancePreconditionOpts)||void 0===i?void 0:i.ifGenerationMatch))&&(a.generation=(null===(o=null==e?void 0:e.metadata)||void 0===o?void 0:o.generation)||(null===(s=null==e?void 0:e.instancePreconditionOpts)||void 0===s?void 0:s.ifGenerationMatch)),a}))},qs:s},((e,t)=>{e?o(e,null,t):o(null,r,t)}))}createChannel(e,t,i,o){if("string"!=typeof e)throw new Error(BucketExceptionMessages.CHANNEL_ID_REQUIRED);if("string"!=typeof t.address)throw new Error(BucketExceptionMessages.CHANNEL_ADDRESS_REQUIRED);let s={};"function"==typeof i?o=i:i&&(s=i),this.request({method:"POST",uri:"/o/watch",json:Object.assign({id:e,type:"web_hook"},t),qs:s},((t,i)=>{if(t)return void o(t,null,i);const s=i.resourceId,a=this.storage.channel(e,s);a.metadata=i,o(null,a,i)}))}createNotification(e,t,i){let o={};"function"==typeof t?i=t:t&&(o=t);if(null!==e&&"object"==typeof e&&common_1.util.isCustomType(e,"pubsub/topic")&&(e=e.name),"string"!=typeof e)throw new Error(BucketExceptionMessages.TOPIC_NAME_REQUIRED);const s=Object.assign({topic:e},o);0!==s.topic.indexOf("projects")&&(s.topic="projects/{{projectId}}/topics/"+s.topic),s.topic="//pubsub.googleapis.com/"+s.topic,s.payloadFormat||(s.payloadFormat="JSON_API_V1");const a={};s.userProject&&(a.userProject=s.userProject,delete s.userProject),this.request({method:"POST",uri:"/notificationConfigs",json:snakeize(s),qs:a,maxRetries:0},((e,t)=>{if(e)return void i(e,null,t);const o=this.notification(t.id);o.metadata=t,i(null,o,t)}))}deleteFiles(e,t){let i={};"function"==typeof e?t=e:e&&(i=e);const o=[];this.getFiles(i).then((([e])=>{const t=pLimit(10),s=e.map((e=>t((()=>(e=>e.delete(i).catch((e=>{if(!i.force)throw e;o.push(e)})))(e)))));return Promise.all(s)})).then((()=>t(o.length>0?o:null)),t)}deleteLabels(e,t){let i=new Array;"function"==typeof e?t=e:e&&(i=arrify(e));const o=e=>{const i=e.reduce(((e,t)=>(e[t]=null,e)),{});this.setLabels(i,t)};0===i.length?this.getLabels(((e,i)=>{e?t(e):o(Object.keys(i))})):o(i)}disableRequesterPays(e){this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),this.setMetadata({billing:{requesterPays:!1}},e||common_1.util.noop),this.storage.retryOptions.autoRetry=this.instanceRetryValue}enableLogging(e,t){if(!e||"function"==typeof e||void 0===e.prefix)throw new Error(BucketExceptionMessages.CONFIGURATION_OBJECT_PREFIX_REQUIRED);const i=e.bucket?e.bucket.id||e.bucket:this.id;(async()=>{let o;try{const[t]=await this.iam.getPolicy();t.bindings.push({members:["group:cloud-storage-analytics@google.com"],role:"roles/storage.objectCreator"}),await this.iam.setPolicy(t),this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),[o]=await this.setMetadata({logging:{logBucket:i,logObjectPrefix:e.prefix}})}catch(e){return void t(e)}finally{this.storage.retryOptions.autoRetry=this.instanceRetryValue}t(null,o)})()}enableRequesterPays(e){this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),this.setMetadata({billing:{requesterPays:!0}},e||common_1.util.noop),this.storage.retryOptions.autoRetry=this.instanceRetryValue}file(e,t){if(!e)throw Error(BucketExceptionMessages.SPECIFY_FILE_NAME);return new file_1.File(this,e,t)}getFiles(e,t){let i="object"==typeof e?e:{};t||(t=e),i=Object.assign({},i),i.directory&&(i.prefix=`${i.directory}/`.replace(/\/*$/,"/"),delete i.directory),this.request({uri:"/o",qs:i},((e,o)=>{if(e)return void t(e,null,null,o);const s=arrify(o.items).map((e=>{const t={};i.versions&&(t.generation=e.generation),e.kmsKeyName&&(t.kmsKeyName=e.kmsKeyName);const o=this.file(e.name,t);return o.metadata=e,o}));let a=null;o.nextPageToken&&(a=Object.assign({},i,{pageToken:o.nextPageToken})),t(null,s,a,o)}))}getLabels(e,t){let i={};"function"==typeof e?t=e:e&&(i=e),this.getMetadata(i,((e,i)=>{e?t(e,null):t(null,i.labels||{})}))}getNotifications(e,t){let i={};"function"==typeof e?t=e:e&&(i=e),this.request({uri:"/notificationConfigs",qs:i},((e,i)=>{if(e)return void t(e,null,i);const o=arrify(i.items).map((e=>{const t=this.notification(e.id);return t.metadata=e,t}));t(null,o,i)}))}getSignedUrl(e,t){const i=BucketActionToHTTPMethod[e.action];if(!i)throw new Error(storage_1.ExceptionMessages.INVALID_ACTION);const o={method:i,expires:e.expires,version:e.version,cname:e.cname,extensionHeaders:e.extensionHeaders||{},queryParams:e.queryParams||{}};this.signer||(this.signer=new signer_1.URLSigner(this.storage.authClient,this)),this.signer.getSignedUrl(o).then((e=>t(null,e)),t)}lock(e,t){const i=typeof e;if("number"!==i&&"string"!==i)throw new Error(BucketExceptionMessages.METAGENERATION_NOT_PROVIDED);this.request({method:"POST",uri:"/lockRetentionPolicy",qs:{ifMetagenerationMatch:e}},t)}makePrivate(e,t){const i="object"==typeof e?e:{};t="function"==typeof e?e:t,i.private=!0;const o={predefinedAcl:"projectPrivate"};i.userProject&&(o.userProject=i.userProject),this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata);const s=extend({},i.metadata,{acl:null});this.setMetadata(s,o).then((()=>i.includeFiles?util_1.promisify(this.makeAllFilesPublicPrivate_).call(this,i):[])).then((e=>t(null,e)),t).finally((()=>{this.storage.retryOptions.autoRetry=this.instanceRetryValue}))}makePublic(e,t){t="function"==typeof e?e:t;const i=extend(!0,{public:!0},"object"==typeof e?e:{});this.acl.add({entity:"allUsers",role:"READER"}).then((()=>this.acl.default.add({entity:"allUsers",role:"READER"}))).then((()=>i.includeFiles?util_1.promisify(this.makeAllFilesPublicPrivate_).call(this,i):[])).then((e=>t(null,e)),t)}notification(e){if(!e)throw new Error(BucketExceptionMessages.SUPPLY_NOTIFICATION_ID);return new notification_1.Notification(this,e)}removeRetentionPeriod(e){this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),this.setMetadata({retentionPolicy:null},e),this.storage.retryOptions.autoRetry=this.instanceRetryValue}request(e,t){return!this.userProject||e.qs&&e.qs.userProject||(e.qs=extend(e.qs,{userProject:this.userProject})),super.request(e,t)}setLabels(e,t,i){const o="object"==typeof t?t:{};i=(i="function"==typeof t?t:i)||common_1.util.noop,this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),this.setMetadata({labels:e},o,i),this.storage.retryOptions.autoRetry=this.instanceRetryValue}setRetentionPeriod(e,t){this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),this.setMetadata({retentionPolicy:{retentionPeriod:e}},t),this.storage.retryOptions.autoRetry=this.instanceRetryValue}setCorsConfiguration(e,t){this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),this.setMetadata({cors:e},t),this.storage.retryOptions.autoRetry=this.instanceRetryValue}setStorageClass(e,t,i){const o="object"==typeof t?t:{};i="function"==typeof t?t:i,this.disableAutoRetryConditionallyIdempotent_(this.methods.setMetadata,AvailableServiceObjectMethods.setMetadata),e=e.replace(/-/g,"_").replace(/([a-z])([A-Z])/g,((e,t,i)=>t+"_"+i)).toUpperCase(),this.setMetadata({storageClass:e},o,i),this.storage.retryOptions.autoRetry=this.instanceRetryValue}setUserProject(e){this.userProject=e;["create","delete","exists","get","getMetadata","setMetadata"].forEach((t=>{const i=this.methods[t];"object"==typeof i&&("object"==typeof i.reqOpts?extend(i.reqOpts.qs,{userProject:e}):i.reqOpts={qs:{userProject:e}})}))}upload(e,t,i){var o,s;const a=t=>{const o=retry((async i=>{await new Promise(((o,s)=>{var a,c;0===t&&(null===(c=null===(a=null==n?void 0:n.storage)||void 0===a?void 0:a.retryOptions)||void 0===c?void 0:c.autoRetry)&&(n.storage.retryOptions.autoRetry=!1);const l=n.createWriteStream(r);r.onUploadProgress&&l.on("progress",r.onUploadProgress),fs.createReadStream(e).pipe(l).on("error",(e=>this.storage.retryOptions.autoRetry&&this.storage.retryOptions.retryableErrorFn(e)?s(e):i(e))).on("finish",(()=>o()))}))}),{retries:t,factor:this.storage.retryOptions.retryDelayMultiplier,maxTimeout:1e3*this.storage.retryOptions.maxRetryDelay,maxRetryTime:1e3*this.storage.retryOptions.totalTimeout});return i?o.then((()=>{if(i)return i(null,n,n.metadata)})).catch(i):o};if(global.GCLOUD_SANDBOX_ENV)return;let r="object"==typeof t?t:{};i="function"==typeof t?t:i,r=Object.assign({metadata:{}},r);let n,c=this.storage.retryOptions.maxRetries;if((void 0===(null===(o=null==r?void 0:r.preconditionOpts)||void 0===o?void 0:o.ifGenerationMatch)&&void 0===(null===(s=this.instancePreconditionOpts)||void 0===s?void 0:s.ifGenerationMatch)&&this.storage.retryOptions.idempotencyStrategy===storage_1.IdempotencyStrategy.RetryConditional||this.storage.retryOptions.idempotencyStrategy===storage_1.IdempotencyStrategy.RetryNever)&&(c=0),r.destination instanceof file_1.File)n=r.destination;else if(null!==r.destination&&"string"==typeof r.destination)n=this.file(r.destination,{encryptionKey:r.encryptionKey,kmsKeyName:r.kmsKeyName,preconditionOpts:this.instancePreconditionOpts});else{const t=path.basename(e);n=this.file(t,{encryptionKey:r.encryptionKey,kmsKeyName:r.kmsKeyName,preconditionOpts:this.instancePreconditionOpts})}null!==r.resumable&&"boolean"==typeof r.resumable?a(c):fs.stat(e,((e,t)=>{e?i(e):(t.size<=5e6&&(r.resumable=!1),a(c))}))}makeAllFilesPublicPrivate_(e,t){const i=[],o=[],s="object"==typeof e?e:{};t="function"==typeof e?e:t;this.getFiles(s).then((([e])=>{const t=pLimit(10),a=e.map((e=>t((()=>(async e=>{try{await(s.public?e.makePublic():e.makePrivate(s)),o.push(e)}catch(e){if(!s.force)throw e;i.push(e)}})(e)))));return Promise.all(a)})).then((()=>t(i.length>0?i:null,o)),(e=>t(e,o)))}getId(){return this.id}disableAutoRetryConditionallyIdempotent_(e,t){var i,o;"object"!=typeof e||void 0!==(null===(o=null===(i=null==e?void 0:e.reqOpts)||void 0===i?void 0:i.qs)||void 0===o?void 0:o.ifMetagenerationMatch)||t!==AvailableServiceObjectMethods.setMetadata&&t!==AvailableServiceObjectMethods.delete||this.storage.retryOptions.idempotencyStrategy!==storage_1.IdempotencyStrategy.RetryConditional?this.storage.retryOptions.idempotencyStrategy===storage_1.IdempotencyStrategy.RetryNever&&(this.storage.retryOptions.autoRetry=!1):this.storage.retryOptions.autoRetry=!1}}exports.Bucket=Bucket,
/*! Developer Documentation
 *
 * These methods can be auto-paginated.
 */
paginator_1.paginator.extend(Bucket,"getFiles"),
/*! Developer Documentation
 *
 * All async methods (except for streams) will return a Promise in the event
 * that a callback is omitted.
 */
promisify_1.promisifyAll(Bucket,{exclude:["request","file","notification"]});