"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.createURI=exports.upload=exports.Upload=exports.PROTOCOL_REGEX=void 0;const abort_controller_1=require("abort-controller"),ConfigStore=require("configstore"),crypto_1=require("crypto"),extend=require("extend"),gaxios=require("gaxios"),google_auth_library_1=require("google-auth-library"),Pumpify=require("pumpify"),stream_1=require("stream"),streamEvents=require("stream-events"),retry=require("async-retry"),NOT_FOUND_STATUS_CODE=404,TERMINATED_UPLOAD_STATUS_CODE=410,RESUMABLE_INCOMPLETE_STATUS_CODE=308,DEFAULT_API_ENDPOINT_REGEX=/.*\.googleapis\.com/;exports.PROTOCOL_REGEX=/^(\w*):\/\//;class Upload extends Pumpify{constructor(t){if(super(),this.numBytesWritten=0,this.numRetries=0,this.upstreamChunkBuffer=Buffer.alloc(0),this.chunkBufferEncoding=void 0,this.numChunksReadInRequest=0,this.lastChunkSent=Buffer.alloc(0),this.upstreamEnded=!1,this.upstream=new stream_1.Duplex({read:async()=>{this.once("prepareFinish",(()=>{this.upstream.push(null)}))},write:this.writeToChunkBuffer.bind(this)}),streamEvents(this),!(t=t||{}).bucket||!t.file)throw new Error("A bucket and file name are required");t.authConfig=t.authConfig||{},t.authConfig.scopes=["https://www.googleapis.com/auth/devstorage.full_control"],this.authClient=t.authClient||new google_auth_library_1.GoogleAuth(t.authConfig),this.apiEndpoint="https://storage.googleapis.com",t.apiEndpoint&&(this.apiEndpoint=this.sanitizeEndpoint(t.apiEndpoint),DEFAULT_API_ENDPOINT_REGEX.test(t.apiEndpoint)||(this.authClient=gaxios)),this.baseURI=`${this.apiEndpoint}/upload/storage/v1/b`,this.bucket=t.bucket;const e=[t.bucket,t.file];if("number"==typeof t.generation&&e.push(`${t.generation}`),this.cacheKey=e.join("/"),this.customRequestOptions=t.customRequestOptions||{},this.file=t.file,this.generation=t.generation,this.kmsKeyName=t.kmsKeyName,this.metadata=t.metadata||{},this.offset=t.offset,this.origin=t.origin,this.params=t.params||{},this.userProject=t.userProject,this.chunkSize=t.chunkSize,this.retryOptions=t.retryOptions,t.key){const e=Buffer.from(t.key).toString("base64");this.encryption={key:e,hash:crypto_1.createHash("sha256").update(t.key).digest("base64")}}this.predefinedAcl=t.predefinedAcl,t.private&&(this.predefinedAcl="private"),t.public&&(this.predefinedAcl="publicRead");const s=t.configPath;this.configStore=new ConfigStore("gcs-resumable-upload",null,{configPath:s});const i=t.retryOptions.autoRetry;this.uriProvidedManually=!!t.uri,this.uri=t.uri||this.get("uri"),this.numBytesWritten=0,this.numRetries=0,i||(t.retryOptions.maxRetries=0),this.timeOfFirstRequest=Date.now();const r=t.metadata?Number(t.metadata.contentLength):NaN;this.contentLength=isNaN(r)?"*":r,this.upstream.on("end",(()=>{this.upstreamEnded=!0})),this.on("prefinish",(()=>{this.upstreamEnded=!0})),this.once("writing",(()=>{this.setPipeline(this.upstream,new stream_1.PassThrough),this.uri?this.continueUploading():this.createURI(((t,e)=>{if(t)return this.destroy(t);this.set({uri:e}),this.startUploading()}))}))}writeToChunkBuffer(t,e,s){this.upstreamChunkBuffer=Buffer.concat([this.upstreamChunkBuffer,"string"==typeof t?Buffer.from(t,e):t]),this.chunkBufferEncoding=e,this.once("readFromChunkBuffer",s),process.nextTick((()=>this.emit("wroteToChunkBuffer")))}unshiftChunkBuffer(t){this.upstreamChunkBuffer=Buffer.concat([t,this.upstreamChunkBuffer])}pullFromChunkBuffer(t){const e=this.upstreamChunkBuffer.slice(0,t);return this.upstreamChunkBuffer=this.upstreamChunkBuffer.slice(t),process.nextTick((()=>this.emit("readFromChunkBuffer"))),e}async waitForNextChunk(){return await new Promise((t=>{if(this.upstreamChunkBuffer.byteLength)return t(!0);if(this.upstreamEnded)return t(!1);const e=()=>(i(),t(!0)),s=()=>(i(),this.upstreamChunkBuffer.length?t(!0):t(!1)),i=()=>{this.removeListener("wroteToChunkBuffer",e),this.upstream.removeListener("finish",s),this.removeListener("prefinish",s)};this.once("wroteToChunkBuffer",e),this.upstream.once("finish",s),this.once("prefinish",s)}))}async*upstreamIterator(t=1/0,e){let s=Buffer.alloc(0);for(;t&&await this.waitForNextChunk();){const i=this.pullFromChunkBuffer(t);t-=i.byteLength,e?s=Buffer.concat([s,i]):yield{chunk:i,encoding:this.chunkBufferEncoding}}e&&(yield{chunk:s,encoding:this.chunkBufferEncoding})}createURI(t){if(!t)return this.createURIAsync();this.createURIAsync().then((e=>t(null,e)),t)}async createURIAsync(){const t=this.metadata,e={method:"POST",url:[this.baseURI,this.bucket,"o"].join("/"),params:Object.assign({name:this.file,uploadType:"resumable"},this.params),data:t,headers:{}};t.contentLength&&(e.headers["X-Upload-Content-Length"]=t.contentLength.toString()),t.contentType&&(e.headers["X-Upload-Content-Type"]=t.contentType),void 0!==this.generation&&(e.params.ifGenerationMatch=this.generation),this.kmsKeyName&&(e.params.kmsKeyName=this.kmsKeyName),this.predefinedAcl&&(e.params.predefinedAcl=this.predefinedAcl),this.origin&&(e.headers.Origin=this.origin);const s=await retry((async t=>{var s,i,r;try{return(await this.makeRequest(e)).headers.location}catch(e){const n=e,a={code:null===(s=n.response)||void 0===s?void 0:s.status,name:null===(i=n.response)||void 0===i?void 0:i.statusText,message:null===(r=n.response)||void 0===r?void 0:r.statusText,errors:[{reason:n.code}]};if(this.retryOptions.maxRetries>0&&this.retryOptions.retryableErrorFn(a))throw n;return t(n)}}),{retries:this.retryOptions.maxRetries,factor:this.retryOptions.retryDelayMultiplier,maxTimeout:1e3*this.retryOptions.maxRetryDelay,maxRetryTime:1e3*this.retryOptions.totalTimeout});return this.uri=s,this.offset=0,s}async continueUploading(){"number"!=typeof this.offset?(await this.getAndSetOffset(),this.startUploading()):this.startUploading()}async startUploading(){const t=!!this.chunkSize;let e,s=!1;if(this.numChunksReadInRequest=0,this.offset||(this.offset=0),0===this.numBytesWritten){if(!await this.ensureUploadingSameObject())return}if(this.offset<this.numBytesWritten){const t=this.numBytesWritten-this.offset,e=`The offset is lower than the number of bytes written. The server has ${this.offset} bytes and while  ${this.numBytesWritten} bytes has been uploaded - thus ${t} bytes are missing. Stopping as this could result in data loss. Initiate a new upload to continue.`;return void this.emit("error",new RangeError(e))}if(this.numBytesWritten<this.offset){const t=this.offset-this.numBytesWritten;for await(const e of this.upstreamIterator(t));this.numBytesWritten=this.offset}"number"==typeof this.contentLength&&(e=this.contentLength-this.numBytesWritten),this.chunkSize&&(e=e?Math.min(this.chunkSize,e):this.chunkSize);const i=this.upstreamIterator(e,t),r=new stream_1.Readable({read:async()=>{s&&r.push(null);const t=await i.next();t.value&&(this.numChunksReadInRequest++,this.lastChunkSent=t.value.chunk,this.numBytesWritten+=t.value.chunk.byteLength,this.emit("progress",{bytesWritten:this.numBytesWritten,contentLength:this.contentLength}),r.push(t.value.chunk,t.value.encoding)),t.done&&r.push(null)}});let n={};if(t&&e){const t=e+this.numBytesWritten-1;n={"Content-Length":e,"Content-Range":`bytes ${this.offset}-${t}/${this.contentLength}`}}else n={"Content-Range":`bytes ${this.offset}-*/${this.contentLength}`};const a={method:"PUT",url:this.uri,headers:n,body:r};try{const t=await this.makeRequestStream(a);t&&(s=!0,this.responseHandler(t))}catch(t){const e=t;this.destroy(e)}}responseHandler(t){if(t.data.error)return void this.destroy(t.data.error);if(this.chunkSize&&308===t.status&&t.headers.range){const e=t.headers.range;this.offset=Number(e.split("-")[1])+1;const s=this.numBytesWritten-this.offset;if(s){const t=this.lastChunkSent.slice(-s);this.unshiftChunkBuffer(t),this.numBytesWritten-=s,this.lastChunkSent=Buffer.alloc(0)}this.continueUploading()}else if(this.isSuccessfulResponse(t.status))this.lastChunkSent=Buffer.alloc(0),t&&t.data&&(t.data.size=Number(t.data.size)),this.emit("metadata",t.data),this.deleteConfig(),this.emit("prepareFinish");else{const e={code:t.status,name:"Upload failed",message:"Upload failed"};this.destroy(e)}}async ensureUploadingSameObject(){const t=this.upstreamIterator(16,!0),e=await t.next(),s=e.value?e.value.chunk:Buffer.alloc(0);this.unshiftChunkBuffer(s);let i=this.get("firstChunk");const r=s.valueOf();if(i){i=Buffer.from(i);const t=Buffer.from(r);if(0!==Buffer.compare(i,t))return this.restart(),!1}else this.set({uri:this.uri,firstChunk:r});return!0}async getAndSetOffset(){const t={method:"PUT",url:this.uri,headers:{"Content-Length":0,"Content-Range":"bytes */*"}};try{const e=await this.makeRequest(t);if(308===e.status&&e.headers.range){const t=e.headers.range;return void(this.offset=Number(t.split("-")[1])+1)}this.offset=0}catch(t){const e=t,s=e.response;if(s&&404===s.status&&!this.uriProvidedManually)return void this.restart();if(s&&410===s.status)return void this.restart();this.destroy(e)}}async makeRequest(t){this.encryption&&(t.headers=t.headers||{},t.headers["x-goog-encryption-algorithm"]="AES256",t.headers["x-goog-encryption-key"]=this.encryption.key.toString(),t.headers["x-goog-encryption-key-sha256"]=this.encryption.hash.toString()),this.userProject&&(t.params=t.params||{},t.params.userProject=this.userProject),t.validateStatus=t=>this.isSuccessfulResponse(t)||308===t;const e=extend(!0,{},this.customRequestOptions,t),s=await this.authClient.request(e);if(s.data&&s.data.error)throw s.data.error;return s}async makeRequestStream(t){const e=new abort_controller_1.default,s=()=>e.abort();this.once("error",s),this.userProject&&(t.params=t.params||{},t.params.userProject=this.userProject),t.signal=e.signal,t.validateStatus=()=>!0;const i=extend(!0,{},this.customRequestOptions,t),r=await this.authClient.request(i),n=this.onResponse(r);return this.removeListener("error",s),n?r:null}restart(){if(this.numBytesWritten){const t="Attempting to restart an upload after unrecoverable bytes have been written from upstream. Stopping as this could result in data loss. Initiate a new upload to continue.";this.emit("error",new RangeError(t))}else this.lastChunkSent=Buffer.alloc(0),this.deleteConfig(),this.createURI(((t,e)=>{if(t)return this.destroy(t);this.set({uri:e}),this.startUploading()}))}get(t){const e=this.configStore.get(this.cacheKey);return e&&e[t]}set(t){this.configStore.set(this.cacheKey,t)}deleteConfig(){this.configStore.delete(this.cacheKey)}onResponse(t){return this.retryOptions.retryableErrorFn({code:t.status,message:t.statusText,name:t.statusText})?(this.attemptDelayedRetry(t),!1):(this.emit("response",t),!0)}attemptDelayedRetry(t){if(this.numRetries<this.retryOptions.maxRetries){if(404===t.status&&0===this.numChunksReadInRequest)this.startUploading();else{const e=this.getRetryDelay();if(e<=0)return void this.destroy(new Error(`Retry total time limit exceeded - ${t.data}`));this.numBytesWritten-=this.lastChunkSent.byteLength,this.unshiftChunkBuffer(this.lastChunkSent),this.lastChunkSent=Buffer.alloc(0),this.offset=void 0,setTimeout(this.continueUploading.bind(this),e)}this.numRetries++}else this.destroy(new Error("Retry limit exceeded - "+t.data))}getRetryDelay(){const t=Math.round(1e3*Math.random()),e=1e3*Math.pow(this.retryOptions.retryDelayMultiplier,this.numRetries)+t,s=1e3*this.retryOptions.totalTimeout-(Date.now()-this.timeOfFirstRequest),i=1e3*this.retryOptions.maxRetryDelay;return Math.min(e,i,s)}sanitizeEndpoint(t){return exports.PROTOCOL_REGEX.test(t)||(t=`https://${t}`),t.replace(/\/+$/,"")}isSuccessfulResponse(t){return t>=200&&t<300}}function upload(t){return new Upload(t)}function createURI(t,e){const s=new Upload(t);if(!e)return s.createURI();s.createURI().then((t=>e(null,t)),e)}exports.Upload=Upload,exports.upload=upload,exports.createURI=createURI;