"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.SigningError=exports.URLSigner=exports.PATH_STYLED_HOST=exports.SignerExceptionMessages=void 0;const crypto=require("crypto"),dateFormat=require("date-and-time"),url=require("url"),storage_1=require("./storage"),util_1=require("./util");var SignerExceptionMessages;!function(e){e.ACCESSIBLE_DATE_INVALID="The accessible at date provided was invalid.",e.EXPIRATION_BEFORE_ACCESSIBLE_DATE="An expiration date cannot be before accessible date.",e.X_GOOG_CONTENT_SHA256="The header X-Goog-Content-SHA256 must be a hexadecimal string."}(SignerExceptionMessages=exports.SignerExceptionMessages||(exports.SignerExceptionMessages={}));const DEFAULT_SIGNING_VERSION="v2",SEVEN_DAYS=604800;exports.PATH_STYLED_HOST="https://storage.googleapis.com";class URLSigner{constructor(e,t,s){this.bucket=t,this.file=s,this.authClient=e}getSignedUrl(e){const t=this.parseExpires(e.expires),s=e.method,r=this.parseAccessibleAt(e.accessibleAt);if(t<r)throw new Error(SignerExceptionMessages.EXPIRATION_BEFORE_ACCESSIBLE_DATE);let n;const i=e.virtualHostedStyle||!1;e.cname?n=e.cname:i&&(n=`https://${this.bucket.name}.storage.googleapis.com`);const o=Object.assign({},e,{method:s,expiration:t,accessibleAt:new Date(1e3*r),bucket:this.bucket.name,file:this.file?util_1.encodeURI(this.file.name,!1):void 0});n&&(o.cname=n);const a=e.version||"v2";let c;if("v2"===a)c=this.getSignedUrlV2(o);else{if("v4"!==a)throw new Error(`Invalid signed URL version: ${a}. Supported versions are 'v2' and 'v4'.`);c=this.getSignedUrlV4(o)}return c.then((t=>{t=Object.assign(t,e.queryParams);const s=new url.URL(o.cname||exports.PATH_STYLED_HOST);return s.pathname=this.getResourcePath(!!o.cname,this.bucket.name,o.file),s.search=util_1.qsStringify(t),s.href}))}getSignedUrlV2(e){const t=this.getCanonicalHeaders(e.extensionHeaders||{}),s=this.getResourcePath(!1,e.bucket,e.file),r=[e.method,e.contentMd5||"",e.contentType||"",e.expiration,t+s].join("\n");return(async()=>{const t=this.authClient;try{const s=await t.sign(r);return{GoogleAccessId:(await t.getCredentials()).client_email,Expires:e.expiration,Signature:s}}catch(e){const t=new SigningError(e.message);throw t.stack=e.stack,t}})()}getSignedUrlV4(e){e.accessibleAt=e.accessibleAt?e.accessibleAt:new Date;const t=e.expiration-.001*e.accessibleAt.valueOf();if(t>604800)throw new Error("Max allowed expiration is seven days (604800 seconds).");const s=Object.assign({},e.extensionHeaders),r=new url.URL(e.cname||exports.PATH_STYLED_HOST);let n;s.host=r.host,e.contentMd5&&(s["content-md5"]=e.contentMd5),e.contentType&&(s["content-type"]=e.contentType);const i=s["x-goog-content-sha256"];if(i){if("string"!=typeof i||!/[A-Fa-f0-9]{40}/.test(i))throw new Error(SignerExceptionMessages.X_GOOG_CONTENT_SHA256);n=i}const o=Object.keys(s).map((e=>e.toLowerCase())).sort().join(";"),a=this.getCanonicalHeaders(s),c=`${dateFormat.format(e.accessibleAt,"YYYYMMDD",!0)}/auto/storage/goog4_request`;return(async()=>{const s=`${(await this.authClient.getCredentials()).client_email}/${c}`,r=dateFormat.format(e.accessibleAt?e.accessibleAt:new Date,"YYYYMMDD[T]HHmmss[Z]",!0),i={"X-Goog-Algorithm":"GOOG4-RSA-SHA256","X-Goog-Credential":s,"X-Goog-Date":r,"X-Goog-Expires":t.toString(10),"X-Goog-SignedHeaders":o,...e.queryParams||{}},g=this.getCanonicalQueryParams(i),l=this.getCanonicalRequest(e.method,this.getResourcePath(!!e.cname,e.bucket,e.file),g,a,o,n),u=crypto.createHash("sha256").update(l).digest("hex"),h=["GOOG4-RSA-SHA256",r,c,u].join("\n");try{const e=await this.authClient.sign(h),t=Buffer.from(e,"base64").toString("hex");return Object.assign({},i,{"X-Goog-Signature":t})}catch(e){const t=new SigningError(e.message);throw t.stack=e.stack,t}})()}getCanonicalHeaders(e){return util_1.objectEntries(e).map((([e,t])=>[e.toLowerCase(),t])).sort(((e,t)=>e[0].localeCompare(t[0]))).filter((([,e])=>void 0!==e)).map((([e,t])=>`${e}:${`${t}`.trim().replace(/\s{2,}/g," ")}\n`)).join("")}getCanonicalRequest(e,t,s,r,n,i){return[e,t,s,r,n,i||"UNSIGNED-PAYLOAD"].join("\n")}getCanonicalQueryParams(e){return util_1.objectEntries(e).map((([e,t])=>[util_1.encodeURI(e,!0),util_1.encodeURI(t,!0)])).sort(((e,t)=>e[0]<t[0]?-1:1)).map((([e,t])=>`${e}=${t}`)).join("&")}getResourcePath(e,t,s){return e?"/"+(s||""):s?`/${t}/${s}`:`/${t}`}parseExpires(e,t=new Date){const s=new Date(e).valueOf();if(isNaN(s))throw new Error(storage_1.ExceptionMessages.EXPIRATION_DATE_INVALID);if(s<t.valueOf())throw new Error(storage_1.ExceptionMessages.EXPIRATION_DATE_PAST);return Math.round(s/1e3)}parseAccessibleAt(e){const t=new Date(e||new Date).valueOf();if(isNaN(t))throw new Error(SignerExceptionMessages.ACCESSIBLE_DATE_INVALID);return Math.floor(t/1e3)}}exports.URLSigner=URLSigner;class SigningError extends Error{constructor(){super(...arguments),this.name="SigningError"}}exports.SigningError=SigningError;