"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Storage=exports.RETRYABLE_ERR_FN_DEFAULT=exports.MAX_RETRY_DELAY_DEFAULT=exports.TOTAL_TIMEOUT_DEFAULT=exports.RETRY_DELAY_MULTIPLIER_DEFAULT=exports.MAX_RETRY_DEFAULT=exports.AUTO_RETRY_DEFAULT=exports.PROTOCOL_REGEX=exports.StorageExceptionMessages=exports.ExceptionMessages=exports.IdempotencyStrategy=void 0;const common_1=require("@google-cloud/common"),paginator_1=require("@google-cloud/paginator"),promisify_1=require("@google-cloud/promisify"),arrify=require("arrify"),stream_1=require("stream"),bucket_1=require("./bucket"),channel_1=require("./channel"),file_1=require("./file"),util_1=require("./util"),hmacKey_1=require("./hmacKey");var IdempotencyStrategy,ExceptionMessages,StorageExceptionMessages;!function(e){e[e.RetryAlways=0]="RetryAlways",e[e.RetryConditional=1]="RetryConditional",e[e.RetryNever=2]="RetryNever"}(IdempotencyStrategy=exports.IdempotencyStrategy||(exports.IdempotencyStrategy={})),function(e){e.EXPIRATION_DATE_INVALID="The expiration date provided was invalid.",e.EXPIRATION_DATE_PAST="An expiration date cannot be in the past.",e.INVALID_ACTION="The action is not provided or invalid."}(ExceptionMessages=exports.ExceptionMessages||(exports.ExceptionMessages={})),function(e){e.AUTO_RETRY_DEPRECATED="autoRetry is deprecated. Use retryOptions.autoRetry instead.",e.MAX_RETRIES_DEPRECATED="maxRetries is deprecated. Use retryOptions.maxRetries instead.",e.BUCKET_NAME_REQUIRED="A bucket name is needed to use Cloud Storage.",e.BUCKET_NAME_REQUIRED_CREATE="A name is required to create a bucket.",e.HMAC_SERVICE_ACCOUNT="The first argument must be a service account email to create an HMAC key.",e.HMAC_ACCESS_ID="An access ID is needed to create an HmacKey object."}(StorageExceptionMessages=exports.StorageExceptionMessages||(exports.StorageExceptionMessages={})),exports.PROTOCOL_REGEX=/^(\w*):\/\//,exports.AUTO_RETRY_DEFAULT=!0,exports.MAX_RETRY_DEFAULT=3,exports.RETRY_DELAY_MULTIPLIER_DEFAULT=2,exports.TOTAL_TIMEOUT_DEFAULT=600,exports.MAX_RETRY_DELAY_DEFAULT=64;const IDEMPOTENCY_STRATEGY_DEFAULT=IdempotencyStrategy.RetryConditional;exports.RETRYABLE_ERR_FN_DEFAULT=function(e){var t;if(e){if(-1!==[408,429,500,502,503,504].indexOf(e.code))return!0;if(e.errors)for(const r of e.errors){const e=null===(t=null==r?void 0:r.reason)||void 0===t?void 0:t.toString().toLowerCase();if(e&&e.includes("eai_again")||"econnreset"===e||"unexpected connection closure"===e)return!0}}return!1};
/*! Developer Documentation
 *
 * Invoke this method to create a new Storage object bound with pre-determined
 * configuration options. For each object that can be created (e.g., a bucket),
 * there is an equivalent static and instance method. While they are classes,
 * they can be instantiated without use of the `new` keyword.
 */
class Storage extends common_1.Service{constructor(e={}){var t,r,o,s,i,a,n,c,l,E,p,u,d,R;let _="https://storage.googleapis.com",g=!1;const y=process.env.STORAGE_EMULATOR_HOST;"string"==typeof y&&(_=Storage.sanitizeEndpoint(y),g=!0),e.apiEndpoint&&(_=Storage.sanitizeEndpoint(e.apiEndpoint),g=!0),e=Object.assign({},e,{apiEndpoint:_});const T=y||`${e.apiEndpoint}/storage/v1`;let m=exports.AUTO_RETRY_DEFAULT;if(void 0!==e.autoRetry&&void 0!==(null===(t=e.retryOptions)||void 0===t?void 0:t.autoRetry))throw new common_1.ApiError(StorageExceptionMessages.AUTO_RETRY_DEPRECATED);void 0!==e.autoRetry?m=e.autoRetry:void 0!==(null===(r=e.retryOptions)||void 0===r?void 0:r.autoRetry)&&(m=e.retryOptions.autoRetry);let A=exports.MAX_RETRY_DEFAULT;if(e.maxRetries&&(null===(o=e.retryOptions)||void 0===o?void 0:o.maxRetries))throw new common_1.ApiError(StorageExceptionMessages.MAX_RETRIES_DEPRECATED);e.maxRetries?A=e.maxRetries:(null===(s=e.retryOptions)||void 0===s?void 0:s.maxRetries)&&(A=e.retryOptions.maxRetries);const x={apiEndpoint:e.apiEndpoint,retryOptions:{autoRetry:m,maxRetries:A,retryDelayMultiplier:(null===(i=e.retryOptions)||void 0===i?void 0:i.retryDelayMultiplier)?null===(a=e.retryOptions)||void 0===a?void 0:a.retryDelayMultiplier:exports.RETRY_DELAY_MULTIPLIER_DEFAULT,totalTimeout:(null===(n=e.retryOptions)||void 0===n?void 0:n.totalTimeout)?null===(c=e.retryOptions)||void 0===c?void 0:c.totalTimeout:exports.TOTAL_TIMEOUT_DEFAULT,maxRetryDelay:(null===(l=e.retryOptions)||void 0===l?void 0:l.maxRetryDelay)?null===(E=e.retryOptions)||void 0===E?void 0:E.maxRetryDelay:exports.MAX_RETRY_DELAY_DEFAULT,retryableErrorFn:(null===(p=e.retryOptions)||void 0===p?void 0:p.retryableErrorFn)?null===(u=e.retryOptions)||void 0===u?void 0:u.retryableErrorFn:exports.RETRYABLE_ERR_FN_DEFAULT,idempotencyStrategy:void 0!==(null===(d=e.retryOptions)||void 0===d?void 0:d.idempotencyStrategy)?null===(R=e.retryOptions)||void 0===R?void 0:R.idempotencyStrategy:IDEMPOTENCY_STRATEGY_DEFAULT},baseUrl:T,customEndpoint:g,useAuthWithCustomEndpoint:null==e?void 0:e.useAuthWithCustomEndpoint,projectIdRequired:!1,scopes:["https://www.googleapis.com/auth/iam","https://www.googleapis.com/auth/cloud-platform","https://www.googleapis.com/auth/devstorage.full_control"],packageJson:require("../../package.json")};super(x,e),this.acl=Storage.acl,this.retryOptions=x.retryOptions,this.getBucketsStream=paginator_1.paginator.streamify("getBuckets"),this.getHmacKeysStream=paginator_1.paginator.streamify("getHmacKeys")}getBucketsStream(){return new stream_1.Readable}getHmacKeysStream(){return new stream_1.Readable}static sanitizeEndpoint(e){return exports.PROTOCOL_REGEX.test(e)||(e=`https://${e}`),e.replace(/\/+$/,"")}bucket(e,t){if(!e)throw new Error(StorageExceptionMessages.BUCKET_NAME_REQUIRED);return new bucket_1.Bucket(this,e,t)}channel(e,t){return new channel_1.Channel(this,e,t)}createBucket(e,t,r){if(!e)throw new Error(StorageExceptionMessages.BUCKET_NAME_REQUIRED_CREATE);let o;r?o=t:(r=t,o={});const s=Object.assign({},o,{name:e}),i={archive:"ARCHIVE",coldline:"COLDLINE",dra:"DURABLE_REDUCED_AVAILABILITY",multiRegional:"MULTI_REGIONAL",nearline:"NEARLINE",regional:"REGIONAL",standard:"STANDARD"};Object.keys(i).forEach((e=>{if(s[e]){if(o.storageClass&&o.storageClass!==e)throw new Error(`Both \`${e}\` and \`storageClass\` were provided.`);s.storageClass=i[e],delete s[e]}})),s.requesterPays&&(s.billing={requesterPays:s.requesterPays},delete s.requesterPays);const a={project:this.projectId};s.userProject&&(a.userProject=s.userProject,delete s.userProject),this.request({method:"POST",uri:"/b",qs:a,json:s},((t,o)=>{if(t)return void r(t,null,o);const s=this.bucket(e);s.metadata=o,r(null,s,o)}))}createHmacKey(e,t,r){if("string"!=typeof e)throw new Error(StorageExceptionMessages.HMAC_SERVICE_ACCOUNT);const{options:o,callback:s}=util_1.normalize(t,r),i=Object.assign({},o,{serviceAccountEmail:e}),a=i.projectId||this.projectId;delete i.projectId,this.request({method:"POST",uri:`/projects/${a}/hmacKeys`,qs:i,maxRetries:0},((e,t)=>{if(e)return void s(e,null,null,t);const r=t.metadata,o=this.hmacKey(r.accessId,{projectId:r.projectId});o.metadata=t.metadata,s(null,o,t.secret,t)}))}getBuckets(e,t){const{options:r,callback:o}=util_1.normalize(e,t);r.project=r.project||this.projectId,this.request({uri:"/b",qs:r},((e,t)=>{if(e)return void o(e,null,null,t);const s=arrify(t.items).map((e=>{const t=this.bucket(e.id);return t.metadata=e,t})),i=t.nextPageToken?Object.assign({},r,{pageToken:t.nextPageToken}):null;o(null,s,i,t)}))}getHmacKeys(e,t){const{options:r,callback:o}=util_1.normalize(e,t),s=Object.assign({},r),i=s.projectId||this.projectId;delete s.projectId,this.request({uri:`/projects/${i}/hmacKeys`,qs:s},((e,t)=>{if(e)return void o(e,null,null,t);const s=arrify(t.items).map((e=>{const t=this.hmacKey(e.accessId,{projectId:e.projectId});return t.metadata=e,t})),i=t.nextPageToken?Object.assign({},r,{pageToken:t.nextPageToken}):null;o(null,s,i,t)}))}getServiceAccount(e,t){const{options:r,callback:o}=util_1.normalize(e,t);this.request({uri:`/projects/${this.projectId}/serviceAccount`,qs:r},((e,t)=>{if(e)return void o(e,null,t);const r={};for(const e in t)if(t.hasOwnProperty(e)){r[e.replace(/_(\w)/g,((e,t)=>t.toUpperCase()))]=t[e]}o(null,r,t)}))}hmacKey(e,t){if(!e)throw new Error(StorageExceptionMessages.HMAC_ACCESS_ID);return new hmacKey_1.HmacKey(this,e,t)}}exports.Storage=Storage,Storage.Bucket=bucket_1.Bucket,Storage.Channel=channel_1.Channel,Storage.File=file_1.File,Storage.HmacKey=hmacKey_1.HmacKey,Storage.acl={OWNER_ROLE:"OWNER",READER_ROLE:"READER",WRITER_ROLE:"WRITER"},
/*! Developer Documentation
 *
 * These methods can be auto-paginated.
 */
paginator_1.paginator.extend(Storage,["getBuckets","getHmacKeys"]),
/*! Developer Documentation
 *
 * All async methods (except for streams) will return a Promise in the event
 * that a callback is omitted.
 */
promisify_1.promisifyAll(Storage,{exclude:["bucket","channel","hmacKey"]});