"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.BaseExternalAccountClient=exports.CLOUD_RESOURCE_MANAGER=exports.EXTERNAL_ACCOUNT_TYPE=exports.EXPIRATION_TIME_OFFSET=void 0;const stream=require("stream"),authclient_1=require("./authclient"),sts=require("./stscredentials"),STS_GRANT_TYPE="urn:ietf:params:oauth:grant-type:token-exchange",STS_REQUEST_TOKEN_TYPE="urn:ietf:params:oauth:token-type:access_token",DEFAULT_OAUTH_SCOPE="https://www.googleapis.com/auth/cloud-platform",GOOGLE_APIS_DOMAIN_PATTERN="\\.googleapis\\.com$",VARIABLE_PORTION_PATTERN="[^\\.\\s\\/\\\\]+";exports.EXPIRATION_TIME_OFFSET=3e5,exports.EXTERNAL_ACCOUNT_TYPE="external_account",exports.CLOUD_RESOURCE_MANAGER="https://cloudresourcemanager.googleapis.com/v1/projects/";const WORKFORCE_AUDIENCE_PATTERN="//iam.googleapis.com/locations/[^/]+/workforcePools/[^/]+/providers/.+";class BaseExternalAccountClient extends authclient_1.AuthClient{constructor(e,t){if(super(),e.type!==exports.EXTERNAL_ACCOUNT_TYPE)throw new Error(`Expected "${exports.EXTERNAL_ACCOUNT_TYPE}" type but received "${e.type}"`);if(this.clientAuth=e.client_id?{confidentialClientType:"basic",clientId:e.client_id,clientSecret:e.client_secret}:void 0,!this.validateGoogleAPIsUrl("sts",e.token_url))throw new Error(`"${e.token_url}" is not a valid token url.`);this.stsCredential=new sts.StsCredentials(e.token_url,this.clientAuth),this.scopes=[DEFAULT_OAUTH_SCOPE],this.cachedAccessToken=null,this.audience=e.audience,this.subjectTokenType=e.subject_token_type,this.quotaProjectId=e.quota_project_id,this.workforcePoolUserProject=e.workforce_pool_user_project;const s=new RegExp(WORKFORCE_AUDIENCE_PATTERN);if(this.workforcePoolUserProject&&!this.audience.match(s))throw new Error("workforcePoolUserProject should not be set for non-workforce pool credentials.");if(void 0!==e.service_account_impersonation_url&&!this.validateGoogleAPIsUrl("iamcredentials",e.service_account_impersonation_url))throw new Error(`"${e.service_account_impersonation_url}" is not a valid service account impersonation url.`);this.serviceAccountImpersonationUrl=e.service_account_impersonation_url,"number"!=typeof(null==t?void 0:t.eagerRefreshThresholdMillis)?this.eagerRefreshThresholdMillis=exports.EXPIRATION_TIME_OFFSET:this.eagerRefreshThresholdMillis=t.eagerRefreshThresholdMillis,this.forceRefreshOnFailure=!!(null==t?void 0:t.forceRefreshOnFailure),this.projectId=null,this.projectNumber=this.getProjectNumber(this.audience)}getServiceAccountEmail(){var e;if(this.serviceAccountImpersonationUrl){const t=/serviceAccounts\/(?<email>[^:]+):generateAccessToken$/.exec(this.serviceAccountImpersonationUrl);return(null===(e=null==t?void 0:t.groups)||void 0===e?void 0:e.email)||null}return null}setCredentials(e){super.setCredentials(e),this.cachedAccessToken=e}async getAccessToken(){return this.cachedAccessToken&&!this.isExpired(this.cachedAccessToken)||await this.refreshAccessTokenAsync(),{token:this.cachedAccessToken.access_token,res:this.cachedAccessToken.res}}async getRequestHeaders(){const e={Authorization:`Bearer ${(await this.getAccessToken()).token}`};return this.addSharedMetadataHeaders(e)}request(e,t){if(!t)return this.requestAsync(e);this.requestAsync(e).then((e=>t(null,e)),(e=>t(e,e.response)))}async getProjectId(){const e=this.projectNumber||this.workforcePoolUserProject;if(this.projectId)return this.projectId;if(e){const t=await this.getRequestHeaders(),s=await this.transporter.request({headers:t,url:`${exports.CLOUD_RESOURCE_MANAGER}${e}`,responseType:"json"});return this.projectId=s.data.projectId,this.projectId}return null}async requestAsync(e,t=!1){let s;try{const t=await this.getRequestHeaders();e.headers=e.headers||{},t&&t["x-goog-user-project"]&&(e.headers["x-goog-user-project"]=t["x-goog-user-project"]),t&&t.Authorization&&(e.headers.Authorization=t.Authorization),s=await this.transporter.request(e)}catch(s){const r=s.response;if(r){const s=r.status,o=r.config.data instanceof stream.Readable;if(!t&&(401===s||403===s)&&!o&&this.forceRefreshOnFailure)return await this.refreshAccessTokenAsync(),await this.requestAsync(e,!0)}throw s}return s}async refreshAccessTokenAsync(){const e=await this.retrieveSubjectToken(),t={grantType:STS_GRANT_TYPE,audience:this.audience,requestedTokenType:STS_REQUEST_TOKEN_TYPE,subjectToken:e,subjectTokenType:this.subjectTokenType,scope:this.serviceAccountImpersonationUrl?[DEFAULT_OAUTH_SCOPE]:this.getScopesArray()},s=!this.clientAuth&&this.workforcePoolUserProject?{userProject:this.workforcePoolUserProject}:void 0,r=await this.stsCredential.exchangeToken(t,void 0,s);return this.serviceAccountImpersonationUrl?this.cachedAccessToken=await this.getImpersonatedAccessToken(r.access_token):r.expires_in?this.cachedAccessToken={access_token:r.access_token,expiry_date:(new Date).getTime()+1e3*r.expires_in,res:r.res}:this.cachedAccessToken={access_token:r.access_token,res:r.res},this.credentials={},Object.assign(this.credentials,this.cachedAccessToken),delete this.credentials.res,this.emit("tokens",{refresh_token:null,expiry_date:this.cachedAccessToken.expiry_date,access_token:this.cachedAccessToken.access_token,token_type:"Bearer",id_token:null}),this.cachedAccessToken}getProjectNumber(e){const t=e.match(/\/projects\/([^/]+)/);return t?t[1]:null}async getImpersonatedAccessToken(e){const t={url:this.serviceAccountImpersonationUrl,method:"POST",headers:{"Content-Type":"application/json",Authorization:`Bearer ${e}`},data:{scope:this.getScopesArray()},responseType:"json"},s=await this.transporter.request(t),r=s.data;return{access_token:r.accessToken,expiry_date:new Date(r.expireTime).getTime(),res:s}}isExpired(e){const t=(new Date).getTime();return!!e.expiry_date&&t>=e.expiry_date-this.eagerRefreshThresholdMillis}getScopesArray(){return"string"==typeof this.scopes?[this.scopes]:void 0===this.scopes?[DEFAULT_OAUTH_SCOPE]:this.scopes}validateGoogleAPIsUrl(e,t){let s;try{s=new URL(t)}catch(e){return!1}const r=s.hostname;if("https:"!==s.protocol)return!1;const o=[new RegExp("^[^\\.\\s\\/\\\\]+\\."+e+"\\.googleapis\\.com$"),new RegExp("^"+e+"\\.googleapis\\.com$"),new RegExp("^"+e+"\\.[^\\.\\s\\/\\\\]+\\.googleapis\\.com$"),new RegExp("^[^\\.\\s\\/\\\\]+\\-"+e+"\\.googleapis\\.com$")];for(const e of o)if(r.match(e))return!0;return!1}}exports.BaseExternalAccountClient=BaseExternalAccountClient;