"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.OAuth2Client=exports.CertificateFormat=exports.CodeChallengeMethod=void 0;const querystring=require("querystring"),stream=require("stream"),formatEcdsa=require("ecdsa-sig-formatter"),crypto_1=require("../crypto/crypto"),authclient_1=require("./authclient"),loginticket_1=require("./loginticket");var CodeChallengeMethod,CertificateFormat;!function(e){e.Plain="plain",e.S256="S256"}(CodeChallengeMethod=exports.CodeChallengeMethod||(exports.CodeChallengeMethod={})),function(e){e.PEM="PEM",e.JWK="JWK"}(CertificateFormat=exports.CertificateFormat||(exports.CertificateFormat={}));class OAuth2Client extends authclient_1.AuthClient{constructor(e,t,r){super(),this.certificateCache={},this.certificateExpiry=null,this.certificateCacheFormat=CertificateFormat.PEM,this.refreshTokenPromises=new Map;const s=e&&"object"==typeof e?e:{clientId:e,clientSecret:t,redirectUri:r};this._clientId=s.clientId,this._clientSecret=s.clientSecret,this.redirectUri=s.redirectUri,this.eagerRefreshThresholdMillis=s.eagerRefreshThresholdMillis||3e5,this.forceRefreshOnFailure=!!s.forceRefreshOnFailure}generateAuthUrl(e={}){if(e.code_challenge_method&&!e.code_challenge)throw new Error("If a code_challenge_method is provided, code_challenge must be included.");e.response_type=e.response_type||"code",e.client_id=e.client_id||this._clientId,e.redirect_uri=e.redirect_uri||this.redirectUri,e.scope instanceof Array&&(e.scope=e.scope.join(" "));return OAuth2Client.GOOGLE_OAUTH2_AUTH_BASE_URL_+"?"+querystring.stringify(e)}generateCodeVerifier(){throw new Error("generateCodeVerifier is removed, please use generateCodeVerifierAsync instead.")}async generateCodeVerifierAsync(){const e=crypto_1.createCrypto(),t=e.randomBytesBase64(96).replace(/\+/g,"~").replace(/=/g,"_").replace(/\//g,"-");return{codeVerifier:t,codeChallenge:(await e.sha256DigestBase64(t)).split("=")[0].replace(/\+/g,"-").replace(/\//g,"_")}}getToken(e,t){const r="string"==typeof e?{code:e}:e;if(!t)return this.getTokenAsync(r);this.getTokenAsync(r).then((e=>t(null,e.tokens,e.res)),(e=>t(e,null,e.response)))}async getTokenAsync(e){const t=OAuth2Client.GOOGLE_OAUTH2_TOKEN_URL_,r={code:e.code,client_id:e.client_id||this._clientId,client_secret:this._clientSecret,redirect_uri:e.redirect_uri||this.redirectUri,grant_type:"authorization_code",code_verifier:e.codeVerifier},s=await this.transporter.request({method:"POST",url:t,data:querystring.stringify(r),headers:{"Content-Type":"application/x-www-form-urlencoded"}}),i=s.data;return s.data&&s.data.expires_in&&(i.expiry_date=(new Date).getTime()+1e3*s.data.expires_in,delete i.expires_in),this.emit("tokens",i),{tokens:i,res:s}}async refreshToken(e){if(!e)return this.refreshTokenNoCache(e);if(this.refreshTokenPromises.has(e))return this.refreshTokenPromises.get(e);const t=this.refreshTokenNoCache(e).then((t=>(this.refreshTokenPromises.delete(e),t)),(t=>{throw this.refreshTokenPromises.delete(e),t}));return this.refreshTokenPromises.set(e,t),t}async refreshTokenNoCache(e){if(!e)throw new Error("No refresh token is set.");const t=OAuth2Client.GOOGLE_OAUTH2_TOKEN_URL_,r={refresh_token:e,client_id:this._clientId,client_secret:this._clientSecret,grant_type:"refresh_token"},s=await this.transporter.request({method:"POST",url:t,data:querystring.stringify(r),headers:{"Content-Type":"application/x-www-form-urlencoded"}}),i=s.data;return s.data&&s.data.expires_in&&(i.expiry_date=(new Date).getTime()+1e3*s.data.expires_in,delete i.expires_in),this.emit("tokens",i),{tokens:i,res:s}}refreshAccessToken(e){if(!e)return this.refreshAccessTokenAsync();this.refreshAccessTokenAsync().then((t=>e(null,t.credentials,t.res)),e)}async refreshAccessTokenAsync(){const e=await this.refreshToken(this.credentials.refresh_token),t=e.tokens;return t.refresh_token=this.credentials.refresh_token,this.credentials=t,{credentials:this.credentials,res:e.res}}getAccessToken(e){if(!e)return this.getAccessTokenAsync();this.getAccessTokenAsync().then((t=>e(null,t.token,t.res)),e)}async getAccessTokenAsync(){if(!this.credentials.access_token||this.isTokenExpiring()){if(!this.credentials.refresh_token){if(!this.refreshHandler)throw new Error("No refresh token or refresh handler callback is set.");{const e=await this.processAndValidateRefreshHandler();if(null==e?void 0:e.access_token)return this.setCredentials(e),{token:this.credentials.access_token}}}const e=await this.refreshAccessTokenAsync();if(!e.credentials||e.credentials&&!e.credentials.access_token)throw new Error("Could not refresh access token.");return{token:e.credentials.access_token,res:e.res}}return{token:this.credentials.access_token}}async getRequestHeaders(e){return(await this.getRequestMetadataAsync(e)).headers}async getRequestMetadataAsync(e){const t=this.credentials;if(!(t.access_token||t.refresh_token||this.apiKey||this.refreshHandler))throw new Error("No access, refresh token, API key or refresh handler callback is set.");if(t.access_token&&!this.isTokenExpiring()){t.token_type=t.token_type||"Bearer";const e={Authorization:t.token_type+" "+t.access_token};return{headers:this.addSharedMetadataHeaders(e)}}if(this.refreshHandler){const e=await this.processAndValidateRefreshHandler();if(null==e?void 0:e.access_token){this.setCredentials(e);const t={Authorization:"Bearer "+this.credentials.access_token};return{headers:this.addSharedMetadataHeaders(t)}}}if(this.apiKey)return{headers:{"X-Goog-Api-Key":this.apiKey}};let r=null,s=null;try{r=await this.refreshToken(t.refresh_token),s=r.tokens}catch(e){const t=e;throw!t.response||403!==t.response.status&&404!==t.response.status||(t.message=`Could not refresh access token: ${t.message}`),t}const i=this.credentials;i.token_type=i.token_type||"Bearer",s.refresh_token=i.refresh_token,this.credentials=s;const n={Authorization:i.token_type+" "+s.access_token};return{headers:this.addSharedMetadataHeaders(n),res:r.res}}static getRevokeTokenUrl(e){const t=querystring.stringify({token:e});return`${OAuth2Client.GOOGLE_OAUTH2_REVOKE_URL_}?${t}`}revokeToken(e,t){const r={url:OAuth2Client.getRevokeTokenUrl(e),method:"POST"};if(!t)return this.transporter.request(r);this.transporter.request(r).then((e=>t(null,e)),t)}revokeCredentials(e){if(!e)return this.revokeCredentialsAsync();this.revokeCredentialsAsync().then((t=>e(null,t)),e)}async revokeCredentialsAsync(){const e=this.credentials.access_token;if(this.credentials={},e)return this.revokeToken(e);throw new Error("No access token to revoke.")}request(e,t){if(!t)return this.requestAsync(e);this.requestAsync(e).then((e=>t(null,e)),(e=>t(e,e.response)))}async requestAsync(e,t=!1){let r;try{const t=await this.getRequestMetadataAsync(e.url);e.headers=e.headers||{},t.headers&&t.headers["x-goog-user-project"]&&(e.headers["x-goog-user-project"]=t.headers["x-goog-user-project"]),t.headers&&t.headers.Authorization&&(e.headers.Authorization=t.headers.Authorization),this.apiKey&&(e.headers["X-Goog-Api-Key"]=this.apiKey),r=await this.transporter.request(e)}catch(r){const s=r.response;if(s){const r=s.status,i=this.credentials&&this.credentials.access_token&&this.credentials.refresh_token&&(!this.credentials.expiry_date||this.forceRefreshOnFailure),n=this.credentials&&this.credentials.access_token&&!this.credentials.refresh_token&&(!this.credentials.expiry_date||this.forceRefreshOnFailure)&&this.refreshHandler,o=s.config.data instanceof stream.Readable,a=401===r||403===r;if(!t&&a&&!o&&i)return await this.refreshAccessTokenAsync(),this.requestAsync(e,!0);if(!t&&a&&!o&&n){const t=await this.processAndValidateRefreshHandler();return(null==t?void 0:t.access_token)&&this.setCredentials(t),this.requestAsync(e,!0)}}throw r}return r}verifyIdToken(e,t){if(t&&"function"!=typeof t)throw new Error("This method accepts an options object as the first parameter, which includes the idToken, audience, and maxExpiry.");if(!t)return this.verifyIdTokenAsync(e);this.verifyIdTokenAsync(e).then((e=>t(null,e)),t)}async verifyIdTokenAsync(e){if(!e.idToken)throw new Error("The verifyIdToken method requires an ID Token");const t=await this.getFederatedSignonCertsAsync();return await this.verifySignedJwtWithCertsAsync(e.idToken,t.certs,e.audience,OAuth2Client.ISSUERS_,e.maxExpiry)}async getTokenInfo(e){const{data:t}=await this.transporter.request({method:"POST",headers:{"Content-Type":"application/x-www-form-urlencoded",Authorization:`Bearer ${e}`},url:OAuth2Client.GOOGLE_TOKEN_INFO_URL}),r=Object.assign({expiry_date:(new Date).getTime()+1e3*t.expires_in,scopes:t.scope.split(" ")},t);return delete r.expires_in,delete r.scope,r}getFederatedSignonCerts(e){if(!e)return this.getFederatedSignonCertsAsync();this.getFederatedSignonCertsAsync().then((t=>e(null,t.certs,t.res)),e)}async getFederatedSignonCertsAsync(){const e=(new Date).getTime(),t=crypto_1.hasBrowserCrypto()?CertificateFormat.JWK:CertificateFormat.PEM;if(this.certificateExpiry&&e<this.certificateExpiry.getTime()&&this.certificateCacheFormat===t)return{certs:this.certificateCache,format:t};let r,s;switch(t){case CertificateFormat.PEM:s=OAuth2Client.GOOGLE_OAUTH2_FEDERATED_SIGNON_PEM_CERTS_URL_;break;case CertificateFormat.JWK:s=OAuth2Client.GOOGLE_OAUTH2_FEDERATED_SIGNON_JWK_CERTS_URL_;break;default:throw new Error(`Unsupported certificate format ${t}`)}try{r=await this.transporter.request({url:s})}catch(e){throw e.message=`Failed to retrieve verification certificates: ${e.message}`,e}const i=r?r.headers["cache-control"]:void 0;let n=-1;if(i){const e=new RegExp("max-age=([0-9]*)").exec(i);e&&2===e.length&&(n=1e3*Number(e[1]))}let o={};switch(t){case CertificateFormat.PEM:o=r.data;break;case CertificateFormat.JWK:for(const e of r.data.keys)o[e.kid]=e;break;default:throw new Error(`Unsupported certificate format ${t}`)}const a=new Date;return this.certificateExpiry=-1===n?null:new Date(a.getTime()+n),this.certificateCache=o,this.certificateCacheFormat=t,{certs:o,format:t,res:r}}getIapPublicKeys(e){if(!e)return this.getIapPublicKeysAsync();this.getIapPublicKeysAsync().then((t=>e(null,t.pubkeys,t.res)),e)}async getIapPublicKeysAsync(){let e;const t=OAuth2Client.GOOGLE_OAUTH2_IAP_PUBLIC_KEY_URL_;try{e=await this.transporter.request({url:t})}catch(e){throw e.message=`Failed to retrieve verification certificates: ${e.message}`,e}return{pubkeys:e.data,res:e}}verifySignedJwtWithCerts(){throw new Error("verifySignedJwtWithCerts is removed, please use verifySignedJwtWithCertsAsync instead.")}async verifySignedJwtWithCertsAsync(e,t,r,s,i){const n=crypto_1.createCrypto();i||(i=OAuth2Client.MAX_TOKEN_LIFETIME_SECS_);const o=e.split(".");if(3!==o.length)throw new Error("Wrong number of segments in token: "+e);const a=o[0]+"."+o[1];let c,h,d=o[2];try{c=JSON.parse(n.decodeBase64StringUtf8(o[0]))}catch(e){throw e.message=`Can't parse token envelope: ${o[0]}': ${e.message}`,e}if(!c)throw new Error("Can't parse token envelope: "+o[0]);try{h=JSON.parse(n.decodeBase64StringUtf8(o[1]))}catch(e){throw e.message=`Can't parse token payload '${o[0]}`,e}if(!h)throw new Error("Can't parse token payload: "+o[1]);if(!Object.prototype.hasOwnProperty.call(t,c.kid))throw new Error("No pem found for envelope: "+JSON.stringify(c));const l=t[c.kid];"ES256"===c.alg&&(d=formatEcdsa.joseToDer(d,"ES256").toString("base64"));if(!await n.verify(l,a,d))throw new Error("Invalid token signature: "+e);if(!h.iat)throw new Error("No issue time in token: "+JSON.stringify(h));if(!h.exp)throw new Error("No expiration time in token: "+JSON.stringify(h));const u=Number(h.iat);if(isNaN(u))throw new Error("iat field using invalid format");const f=Number(h.exp);if(isNaN(f))throw new Error("exp field using invalid format");const _=(new Date).getTime()/1e3;if(f>=_+i)throw new Error("Expiration time too far in future: "+JSON.stringify(h));const p=u-OAuth2Client.CLOCK_SKEW_SECS_,y=f+OAuth2Client.CLOCK_SKEW_SECS_;if(_<p)throw new Error("Token used too early, "+_+" < "+p+": "+JSON.stringify(h));if(_>y)throw new Error("Token used too late, "+_+" > "+y+": "+JSON.stringify(h));if(s&&s.indexOf(h.iss)<0)throw new Error("Invalid issuer, expected one of ["+s+"], but got "+h.iss);if(null!=r){const e=h.aud;let t=!1;if(t=r.constructor===Array?r.indexOf(e)>-1:e===r,!t)throw new Error("Wrong recipient, payload audience != requiredAudience")}return new loginticket_1.LoginTicket(c,h)}async processAndValidateRefreshHandler(){if(this.refreshHandler){const e=await this.refreshHandler();if(!e.access_token)throw new Error("No access token is returned by the refreshHandler callback.");return e}}isTokenExpiring(){const e=this.credentials.expiry_date;return!!e&&e<=(new Date).getTime()+this.eagerRefreshThresholdMillis}}exports.OAuth2Client=OAuth2Client,OAuth2Client.GOOGLE_TOKEN_INFO_URL="https://oauth2.googleapis.com/tokeninfo",OAuth2Client.GOOGLE_OAUTH2_AUTH_BASE_URL_="https://accounts.google.com/o/oauth2/v2/auth",OAuth2Client.GOOGLE_OAUTH2_TOKEN_URL_="https://oauth2.googleapis.com/token",OAuth2Client.GOOGLE_OAUTH2_REVOKE_URL_="https://oauth2.googleapis.com/revoke",OAuth2Client.GOOGLE_OAUTH2_FEDERATED_SIGNON_PEM_CERTS_URL_="https://www.googleapis.com/oauth2/v1/certs",OAuth2Client.GOOGLE_OAUTH2_FEDERATED_SIGNON_JWK_CERTS_URL_="https://www.googleapis.com/oauth2/v3/certs",OAuth2Client.GOOGLE_OAUTH2_IAP_PUBLIC_KEY_URL_="https://www.gstatic.com/iap/verify/public_key",OAuth2Client.CLOCK_SKEW_SECS_=300,OAuth2Client.MAX_TOKEN_LIFETIME_SECS_=86400,OAuth2Client.ISSUERS_=["accounts.google.com","https://accounts.google.com"];