"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.FileWatcherCertificateProvider=void 0;const fs=require("fs"),logging=require("./logging"),constants_1=require("./constants"),util_1=require("util"),TRACER_NAME="certificate_provider";function trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,e)}const readFilePromise=(0,util_1.promisify)(fs.readFile);class FileWatcherCertificateProvider{constructor(e){if(this.config=e,this.refreshTimer=null,this.fileResultPromise=null,this.latestCaUpdate=null,this.caListeners=new Set,this.latestIdentityUpdate=null,this.identityListeners=new Set,this.lastUpdateTime=null,void 0===e.certificateFile!=(void 0===e.privateKeyFile))throw new Error("certificateFile and privateKeyFile must be set or unset together");if(void 0===e.certificateFile&&void 0===e.caCertificateFile)throw new Error("At least one of certificateFile and caCertificateFile must be set");trace("File watcher constructed with config "+JSON.stringify(e))}updateCertificates(){this.fileResultPromise||(this.fileResultPromise=Promise.allSettled([this.config.certificateFile?readFilePromise(this.config.certificateFile):Promise.reject(),this.config.privateKeyFile?readFilePromise(this.config.privateKeyFile):Promise.reject(),this.config.caCertificateFile?readFilePromise(this.config.caCertificateFile):Promise.reject()]),this.fileResultPromise.then((([e,t,i])=>{if(this.refreshTimer){trace("File watcher read certificates certificate"+(e?"!=":"==")+"null, privateKey"+(t?"!=":"==")+"null, CA certificate"+(i?"!=":"==")+"null"),this.lastUpdateTime=new Date,this.fileResultPromise=null,"fulfilled"===e.status&&"fulfilled"===t.status?this.latestIdentityUpdate={certificate:e.value,privateKey:t.value}:this.latestIdentityUpdate=null,"fulfilled"===i.status&&(this.latestCaUpdate={caCertificate:i.value});for(const e of this.identityListeners)e(this.latestIdentityUpdate);for(const e of this.caListeners)e(this.latestCaUpdate)}})),trace("File watcher initiated certificate update"))}maybeStartWatchingFiles(){if(!this.refreshTimer){const e=this.lastUpdateTime?(new Date).getTime()-this.lastUpdateTime.getTime():1/0;e>this.config.refreshIntervalMs&&this.updateCertificates(),e>2*this.config.refreshIntervalMs&&(this.latestCaUpdate=null,this.latestIdentityUpdate=null),this.refreshTimer=setInterval((()=>this.updateCertificates()),this.config.refreshIntervalMs),trace("File watcher started watching")}}maybeStopWatchingFiles(){0===this.caListeners.size&&0===this.identityListeners.size&&(this.fileResultPromise=null,this.refreshTimer&&(clearInterval(this.refreshTimer),this.refreshTimer=null))}addCaCertificateListener(e){this.caListeners.add(e),this.maybeStartWatchingFiles(),process.nextTick(e,this.latestCaUpdate)}removeCaCertificateListener(e){this.caListeners.delete(e),this.maybeStopWatchingFiles()}addIdentityCertificateListener(e){this.identityListeners.add(e),this.maybeStartWatchingFiles(),process.nextTick(e,this.latestIdentityUpdate)}removeIdentityCertificateListener(e){this.identityListeners.delete(e),this.maybeStopWatchingFiles()}}exports.FileWatcherCertificateProvider=FileWatcherCertificateProvider;