"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.createCertificateProviderChannelCredentials=exports.ChannelCredentials=void 0;const tls_1=require("tls"),call_credentials_1=require("./call-credentials"),tls_helpers_1=require("./tls-helpers");function verifyIsBufferOrNull(e,t){if(e&&!(e instanceof Buffer))throw new TypeError(`${t}, if provided, must be a Buffer.`)}class ChannelCredentials{constructor(e){this.callCredentials=e||call_credentials_1.CallCredentials.createEmpty()}_getCallCredentials(){return this.callCredentials}_ref(){}_unref(){}static createSsl(e,t,i,r){var n;if(verifyIsBufferOrNull(e,"Root certificate"),verifyIsBufferOrNull(t,"Private key"),verifyIsBufferOrNull(i,"Certificate chain"),t&&!i)throw new Error("Private key must be given with accompanying certificate chain");if(!t&&i)throw new Error("Certificate chain must be given with accompanying private key");const s=(0,tls_1.createSecureContext)({ca:null!==(n=null!=e?e:(0,tls_helpers_1.getDefaultRootsData)())&&void 0!==n?n:void 0,key:null!=t?t:void 0,cert:null!=i?i:void 0,ciphers:tls_helpers_1.CIPHER_SUITES});return new SecureChannelCredentialsImpl(s,null!=r?r:{})}static createFromSecureContext(e,t){return new SecureChannelCredentialsImpl(e,null!=t?t:{})}static createInsecure(){return new InsecureChannelCredentialsImpl}}exports.ChannelCredentials=ChannelCredentials;class InsecureChannelCredentialsImpl extends ChannelCredentials{constructor(){super()}compose(e){throw new Error("Cannot compose insecure credentials")}_getConnectionOptions(){return{}}_isSecure(){return!1}_equals(e){return e instanceof InsecureChannelCredentialsImpl}}class SecureChannelCredentialsImpl extends ChannelCredentials{constructor(e,t){super(),this.secureContext=e,this.verifyOptions=t,this.connectionOptions={secureContext:e},(null==t?void 0:t.checkServerIdentity)&&(this.connectionOptions.checkServerIdentity=t.checkServerIdentity),void 0!==(null==t?void 0:t.rejectUnauthorized)&&(this.connectionOptions.rejectUnauthorized=t.rejectUnauthorized)}compose(e){const t=this.callCredentials.compose(e);return new ComposedChannelCredentialsImpl(this,t)}_getConnectionOptions(){return Object.assign({},this.connectionOptions)}_isSecure(){return!0}_equals(e){return this===e||e instanceof SecureChannelCredentialsImpl&&(this.secureContext===e.secureContext&&this.verifyOptions.checkServerIdentity===e.verifyOptions.checkServerIdentity)}}class CertificateProviderChannelCredentialsImpl extends ChannelCredentials{constructor(e,t,i){super(),this.caCertificateProvider=e,this.identityCertificateProvider=t,this.verifyOptions=i,this.refcount=0,this.latestCaUpdate=null,this.latestIdentityUpdate=null,this.caCertificateUpdateListener=this.handleCaCertificateUpdate.bind(this),this.identityCertificateUpdateListener=this.handleIdentityCertitificateUpdate.bind(this)}compose(e){const t=this.callCredentials.compose(e);return new ComposedChannelCredentialsImpl(this,t)}_getConnectionOptions(){var e,t,i;if(null===this.latestCaUpdate)return null;if(null!==this.identityCertificateProvider&&null===this.latestIdentityUpdate)return null;const r={secureContext:(0,tls_1.createSecureContext)({ca:this.latestCaUpdate.caCertificate,key:null===(e=this.latestIdentityUpdate)||void 0===e?void 0:e.privateKey,cert:null===(t=this.latestIdentityUpdate)||void 0===t?void 0:t.certificate,ciphers:tls_helpers_1.CIPHER_SUITES})};return(null===(i=this.verifyOptions)||void 0===i?void 0:i.checkServerIdentity)&&(r.checkServerIdentity=this.verifyOptions.checkServerIdentity),r}_isSecure(){return!0}_equals(e){var t,i;return this===e||e instanceof CertificateProviderChannelCredentialsImpl&&(this.caCertificateProvider===e.caCertificateProvider&&this.identityCertificateProvider===e.identityCertificateProvider&&(null===(t=this.verifyOptions)||void 0===t?void 0:t.checkServerIdentity)===(null===(i=e.verifyOptions)||void 0===i?void 0:i.checkServerIdentity))}_ref(){var e;0===this.refcount&&(this.caCertificateProvider.addCaCertificateListener(this.caCertificateUpdateListener),null===(e=this.identityCertificateProvider)||void 0===e||e.addIdentityCertificateListener(this.identityCertificateUpdateListener)),this.refcount+=1}_unref(){var e;this.refcount-=1,0===this.refcount&&(this.caCertificateProvider.removeCaCertificateListener(this.caCertificateUpdateListener),null===(e=this.identityCertificateProvider)||void 0===e||e.removeIdentityCertificateListener(this.identityCertificateUpdateListener))}handleCaCertificateUpdate(e){this.latestCaUpdate=e}handleIdentityCertitificateUpdate(e){this.latestIdentityUpdate=e}}function createCertificateProviderChannelCredentials(e,t,i){return new CertificateProviderChannelCredentialsImpl(e,t,null!=i?i:null)}exports.createCertificateProviderChannelCredentials=createCertificateProviderChannelCredentials;class ComposedChannelCredentialsImpl extends ChannelCredentials{constructor(e,t){if(super(t),this.channelCredentials=e,!e._isSecure())throw new Error("Cannot compose insecure credentials")}compose(e){const t=this.callCredentials.compose(e);return new ComposedChannelCredentialsImpl(this.channelCredentials,t)}_getConnectionOptions(){return this.channelCredentials._getConnectionOptions()}_isSecure(){return!0}_equals(e){return this===e||e instanceof ComposedChannelCredentialsImpl&&(this.channelCredentials._equals(e.channelCredentials)&&this.callCredentials._equals(e.callCredentials))}}