"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.setup=exports.getChannelzServiceDefinition=exports.getChannelzHandlers=exports.unregisterChannelzRef=exports.registerChannelzSocket=exports.registerChannelzServer=exports.registerChannelzSubchannel=exports.registerChannelzChannel=exports.ChannelzCallTrackerStub=exports.ChannelzCallTracker=exports.ChannelzChildrenTrackerStub=exports.ChannelzChildrenTracker=exports.ChannelzTrace=exports.ChannelzTraceStub=void 0;const net_1=require("net"),ordered_map_1=require("@js-sdsl/ordered-map"),connectivity_state_1=require("./connectivity-state"),constants_1=require("./constants"),subchannel_address_1=require("./subchannel-address"),admin_1=require("./admin"),make_client_1=require("./make-client");function channelRefToMessage(e){return{channel_id:e.id,name:e.name}}function subchannelRefToMessage(e){return{subchannel_id:e.id,name:e.name}}function serverRefToMessage(e){return{server_id:e.id}}function socketRefToMessage(e){return{socket_id:e.id,name:e.name}}const TARGET_RETAINED_TRACES=32,DEFAULT_MAX_RESULTS=100;class ChannelzTraceStub{constructor(){this.events=[],this.creationTimestamp=new Date,this.eventsLogged=0}addTrace(){}getTraceMessage(){return{creation_timestamp:dateToProtoTimestamp(this.creationTimestamp),num_events_logged:this.eventsLogged,events:[]}}}exports.ChannelzTraceStub=ChannelzTraceStub;class ChannelzTrace{constructor(){this.events=[],this.eventsLogged=0,this.creationTimestamp=new Date}addTrace(e,t,n){const a=new Date;this.events.push({description:t,severity:e,timestamp:a,childChannel:"channel"===(null==n?void 0:n.kind)?n:void 0,childSubchannel:"subchannel"===(null==n?void 0:n.kind)?n:void 0}),this.events.length>=64&&(this.events=this.events.slice(32)),this.eventsLogged+=1}getTraceMessage(){return{creation_timestamp:dateToProtoTimestamp(this.creationTimestamp),num_events_logged:this.eventsLogged,events:this.events.map((e=>({description:e.description,severity:e.severity,timestamp:dateToProtoTimestamp(e.timestamp),channel_ref:e.childChannel?channelRefToMessage(e.childChannel):null,subchannel_ref:e.childSubchannel?subchannelRefToMessage(e.childSubchannel):null})))}}}exports.ChannelzTrace=ChannelzTrace;class ChannelzChildrenTracker{constructor(){this.channelChildren=new ordered_map_1.OrderedMap,this.subchannelChildren=new ordered_map_1.OrderedMap,this.socketChildren=new ordered_map_1.OrderedMap,this.trackerMap={channel:this.channelChildren,subchannel:this.subchannelChildren,socket:this.socketChildren}}refChild(e){const t=this.trackerMap[e.kind],n=t.find(e.id);n.equals(t.end())?t.setElement(e.id,{ref:e,count:1},n):n.pointer[1].count+=1}unrefChild(e){const t=this.trackerMap[e.kind],n=t.getElementByKey(e.id);void 0!==n&&(n.count-=1,0===n.count&&t.eraseElementByKey(e.id))}getChildLists(){return{channels:this.channelChildren,subchannels:this.subchannelChildren,sockets:this.socketChildren}}}exports.ChannelzChildrenTracker=ChannelzChildrenTracker;class ChannelzChildrenTrackerStub extends ChannelzChildrenTracker{refChild(){}unrefChild(){}}exports.ChannelzChildrenTrackerStub=ChannelzChildrenTrackerStub;class ChannelzCallTracker{constructor(){this.callsStarted=0,this.callsSucceeded=0,this.callsFailed=0,this.lastCallStartedTimestamp=null}addCallStarted(){this.callsStarted+=1,this.lastCallStartedTimestamp=new Date}addCallSucceeded(){this.callsSucceeded+=1}addCallFailed(){this.callsFailed+=1}}exports.ChannelzCallTracker=ChannelzCallTracker;class ChannelzCallTrackerStub extends ChannelzCallTracker{addCallStarted(){}addCallSucceeded(){}addCallFailed(){}}exports.ChannelzCallTrackerStub=ChannelzCallTrackerStub;const entityMaps={channel:new ordered_map_1.OrderedMap,subchannel:new ordered_map_1.OrderedMap,server:new ordered_map_1.OrderedMap,socket:new ordered_map_1.OrderedMap},generateRegisterFn=e=>{let t=1;const n=entityMaps[e];return(a,s,r)=>{const l=t++,i={id:l,name:a,kind:e};return r&&n.setElement(l,{ref:i,getInfo:s}),i}};function unregisterChannelzRef(e){entityMaps[e.kind].eraseElementByKey(e.id)}function parseIPv6Section(e){const t=Number.parseInt(e,16);return[t/256|0,t%256]}function parseIPv6Chunk(e){if(""===e)return[];const t=e.split(":").map((e=>parseIPv6Section(e)));return[].concat(...t)}function ipAddressStringToBuffer(e){if((0,net_1.isIPv4)(e))return Buffer.from(Uint8Array.from(e.split(".").map((e=>Number.parseInt(e)))));if((0,net_1.isIPv6)(e)){let t,n;const a=e.indexOf("::");-1===a?(t=e,n=""):(t=e.substring(0,a),n=e.substring(a+2));const s=Buffer.from(parseIPv6Chunk(t)),r=Buffer.from(parseIPv6Chunk(n)),l=Buffer.alloc(16-s.length-r.length,0);return Buffer.concat([s,l,r])}return null}function connectivityStateToMessage(e){switch(e){case connectivity_state_1.ConnectivityState.CONNECTING:return{state:"CONNECTING"};case connectivity_state_1.ConnectivityState.IDLE:return{state:"IDLE"};case connectivity_state_1.ConnectivityState.READY:return{state:"READY"};case connectivity_state_1.ConnectivityState.SHUTDOWN:return{state:"SHUTDOWN"};case connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE:return{state:"TRANSIENT_FAILURE"};default:return{state:"UNKNOWN"}}}function dateToProtoTimestamp(e){if(!e)return null;const t=e.getTime();return{seconds:t/1e3|0,nanos:t%1e3*1e6}}function getChannelMessage(e){const t=e.getInfo(),n=[],a=[];return t.children.channels.forEach((e=>{n.push(channelRefToMessage(e[1].ref))})),t.children.subchannels.forEach((e=>{a.push(subchannelRefToMessage(e[1].ref))})),{ref:channelRefToMessage(e.ref),data:{target:t.target,state:connectivityStateToMessage(t.state),calls_started:t.callTracker.callsStarted,calls_succeeded:t.callTracker.callsSucceeded,calls_failed:t.callTracker.callsFailed,last_call_started_timestamp:dateToProtoTimestamp(t.callTracker.lastCallStartedTimestamp),trace:t.trace.getTraceMessage()},channel_ref:n,subchannel_ref:a}}function GetChannel(e,t){const n=parseInt(e.request.channel_id,10),a=entityMaps.channel.getElementByKey(n);void 0!==a?t(null,{channel:getChannelMessage(a)}):t({code:constants_1.Status.NOT_FOUND,details:"No channel data found for id "+n})}function GetTopChannels(e,t){const n=parseInt(e.request.max_results,10)||DEFAULT_MAX_RESULTS,a=[],s=parseInt(e.request.start_channel_id,10),r=entityMaps.channel;let l;for(l=r.lowerBound(s);!l.equals(r.end())&&a.length<n;l=l.next())a.push(getChannelMessage(l.pointer[1]));t(null,{channel:a,end:l.equals(r.end())})}function getServerMessage(e){const t=e.getInfo(),n=[];return t.listenerChildren.sockets.forEach((e=>{n.push(socketRefToMessage(e[1].ref))})),{ref:serverRefToMessage(e.ref),data:{calls_started:t.callTracker.callsStarted,calls_succeeded:t.callTracker.callsSucceeded,calls_failed:t.callTracker.callsFailed,last_call_started_timestamp:dateToProtoTimestamp(t.callTracker.lastCallStartedTimestamp),trace:t.trace.getTraceMessage()},listen_socket:n}}function GetServer(e,t){const n=parseInt(e.request.server_id,10),a=entityMaps.server.getElementByKey(n);void 0!==a?t(null,{server:getServerMessage(a)}):t({code:constants_1.Status.NOT_FOUND,details:"No server data found for id "+n})}function GetServers(e,t){const n=parseInt(e.request.max_results,10)||DEFAULT_MAX_RESULTS,a=parseInt(e.request.start_server_id,10),s=entityMaps.server,r=[];let l;for(l=s.lowerBound(a);!l.equals(s.end())&&r.length<n;l=l.next())r.push(getServerMessage(l.pointer[1]));t(null,{server:r,end:l.equals(s.end())})}function GetSubchannel(e,t){const n=parseInt(e.request.subchannel_id,10),a=entityMaps.subchannel.getElementByKey(n);if(void 0===a)return void t({code:constants_1.Status.NOT_FOUND,details:"No subchannel data found for id "+n});const s=a.getInfo(),r=[];s.children.sockets.forEach((e=>{r.push(socketRefToMessage(e[1].ref))}));t(null,{subchannel:{ref:subchannelRefToMessage(a.ref),data:{target:s.target,state:connectivityStateToMessage(s.state),calls_started:s.callTracker.callsStarted,calls_succeeded:s.callTracker.callsSucceeded,calls_failed:s.callTracker.callsFailed,last_call_started_timestamp:dateToProtoTimestamp(s.callTracker.lastCallStartedTimestamp),trace:s.trace.getTraceMessage()},socket_ref:r}})}function subchannelAddressToAddressMessage(e){var t;return(0,subchannel_address_1.isTcpSubchannelAddress)(e)?{address:"tcpip_address",tcpip_address:{ip_address:null!==(t=ipAddressStringToBuffer(e.host))&&void 0!==t?t:void 0,port:e.port}}:{address:"uds_address",uds_address:{filename:e.path}}}function GetSocket(e,t){var n,a,s,r,l;const i=parseInt(e.request.socket_id,10),c=entityMaps.socket.getElementByKey(i);if(void 0===c)return void t({code:constants_1.Status.NOT_FOUND,details:"No socket data found for id "+i});const o=c.getInfo(),d=o.security?{model:"tls",tls:{cipher_suite:o.security.cipherSuiteStandardName?"standard_name":"other_name",standard_name:null!==(n=o.security.cipherSuiteStandardName)&&void 0!==n?n:void 0,other_name:null!==(a=o.security.cipherSuiteOtherName)&&void 0!==a?a:void 0,local_certificate:null!==(s=o.security.localCertificate)&&void 0!==s?s:void 0,remote_certificate:null!==(r=o.security.remoteCertificate)&&void 0!==r?r:void 0}}:null;t(null,{socket:{ref:socketRefToMessage(c.ref),local:o.localAddress?subchannelAddressToAddressMessage(o.localAddress):null,remote:o.remoteAddress?subchannelAddressToAddressMessage(o.remoteAddress):null,remote_name:null!==(l=o.remoteName)&&void 0!==l?l:void 0,security:d,data:{keep_alives_sent:o.keepAlivesSent,streams_started:o.streamsStarted,streams_succeeded:o.streamsSucceeded,streams_failed:o.streamsFailed,last_local_stream_created_timestamp:dateToProtoTimestamp(o.lastLocalStreamCreatedTimestamp),last_remote_stream_created_timestamp:dateToProtoTimestamp(o.lastRemoteStreamCreatedTimestamp),messages_received:o.messagesReceived,messages_sent:o.messagesSent,last_message_received_timestamp:dateToProtoTimestamp(o.lastMessageReceivedTimestamp),last_message_sent_timestamp:dateToProtoTimestamp(o.lastMessageSentTimestamp),local_flow_control_window:o.localFlowControlWindow?{value:o.localFlowControlWindow}:null,remote_flow_control_window:o.remoteFlowControlWindow?{value:o.remoteFlowControlWindow}:null}}})}function GetServerSockets(e,t){const n=parseInt(e.request.server_id,10),a=entityMaps.server.getElementByKey(n);if(void 0===a)return void t({code:constants_1.Status.NOT_FOUND,details:"No server data found for id "+n});const s=parseInt(e.request.start_socket_id,10),r=parseInt(e.request.max_results,10)||DEFAULT_MAX_RESULTS,l=a.getInfo().sessionChildren.sockets,i=[];let c;for(c=l.lowerBound(s);!c.equals(l.end())&&i.length<r;c=c.next())i.push(socketRefToMessage(c.pointer[1].ref));t(null,{socket_ref:i,end:c.equals(l.end())})}function getChannelzHandlers(){return{GetChannel:GetChannel,GetTopChannels:GetTopChannels,GetServer:GetServer,GetServers:GetServers,GetSubchannel:GetSubchannel,GetSocket:GetSocket,GetServerSockets:GetServerSockets}}exports.registerChannelzChannel=generateRegisterFn("channel"),exports.registerChannelzSubchannel=generateRegisterFn("subchannel"),exports.registerChannelzServer=generateRegisterFn("server"),exports.registerChannelzSocket=generateRegisterFn("socket"),exports.unregisterChannelzRef=unregisterChannelzRef,exports.getChannelzHandlers=getChannelzHandlers;let loadedChannelzDefinition=null;function getChannelzServiceDefinition(){if(loadedChannelzDefinition)return loadedChannelzDefinition;const e=(0,require("@grpc/proto-loader").loadSync)("channelz.proto",{keepCase:!0,longs:String,enums:String,defaults:!0,oneofs:!0,includeDirs:[`${__dirname}/../../proto`]}),t=(0,make_client_1.loadPackageDefinition)(e);return loadedChannelzDefinition=t.grpc.channelz.v1.Channelz.service,loadedChannelzDefinition}function setup(){(0,admin_1.registerAdminService)(getChannelzServiceDefinition,getChannelzHandlers)}exports.getChannelzServiceDefinition=getChannelzServiceDefinition,exports.setup=setup;