"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.getInterceptingCall=exports.InterceptingCall=exports.RequesterBuilder=exports.ListenerBuilder=exports.InterceptorConfigurationError=void 0;const metadata_1=require("./metadata"),call_interface_1=require("./call-interface"),constants_1=require("./constants"),error_1=require("./error");class InterceptorConfigurationError extends Error{constructor(e){super(e),this.name="InterceptorConfigurationError",Error.captureStackTrace(this,InterceptorConfigurationError)}}exports.InterceptorConfigurationError=InterceptorConfigurationError;class ListenerBuilder{constructor(){this.metadata=void 0,this.message=void 0,this.status=void 0}withOnReceiveMetadata(e){return this.metadata=e,this}withOnReceiveMessage(e){return this.message=e,this}withOnReceiveStatus(e){return this.status=e,this}build(){return{onReceiveMetadata:this.metadata,onReceiveMessage:this.message,onReceiveStatus:this.status}}}exports.ListenerBuilder=ListenerBuilder;class RequesterBuilder{constructor(){this.start=void 0,this.message=void 0,this.halfClose=void 0,this.cancel=void 0}withStart(e){return this.start=e,this}withSendMessage(e){return this.message=e,this}withHalfClose(e){return this.halfClose=e,this}withCancel(e){return this.cancel=e,this}build(){return{start:this.start,sendMessage:this.message,halfClose:this.halfClose,cancel:this.cancel}}}exports.RequesterBuilder=RequesterBuilder;const defaultListener={onReceiveMetadata:(e,t)=>{t(e)},onReceiveMessage:(e,t)=>{t(e)},onReceiveStatus:(e,t)=>{t(e)}},defaultRequester={start:(e,t,s)=>{s(e,t)},sendMessage:(e,t)=>{t(e)},halfClose:e=>{e()},cancel:e=>{e()}};class InterceptingCall{constructor(e,t){var s,n,a,i;this.nextCall=e,this.processingMetadata=!1,this.pendingMessageContext=null,this.processingMessage=!1,this.pendingHalfClose=!1,this.requester=t?{start:null!==(s=t.start)&&void 0!==s?s:defaultRequester.start,sendMessage:null!==(n=t.sendMessage)&&void 0!==n?n:defaultRequester.sendMessage,halfClose:null!==(a=t.halfClose)&&void 0!==a?a:defaultRequester.halfClose,cancel:null!==(i=t.cancel)&&void 0!==i?i:defaultRequester.cancel}:defaultRequester}cancelWithStatus(e,t){this.requester.cancel((()=>{this.nextCall.cancelWithStatus(e,t)}))}getPeer(){return this.nextCall.getPeer()}processPendingMessage(){this.pendingMessageContext&&(this.nextCall.sendMessageWithContext(this.pendingMessageContext,this.pendingMessage),this.pendingMessageContext=null,this.pendingMessage=null)}processPendingHalfClose(){this.pendingHalfClose&&this.nextCall.halfClose()}start(e,t){var s,n,a,i,r,l;const o={onReceiveMetadata:null!==(n=null===(s=null==t?void 0:t.onReceiveMetadata)||void 0===s?void 0:s.bind(t))&&void 0!==n?n:e=>{},onReceiveMessage:null!==(i=null===(a=null==t?void 0:t.onReceiveMessage)||void 0===a?void 0:a.bind(t))&&void 0!==i?i:e=>{},onReceiveStatus:null!==(l=null===(r=null==t?void 0:t.onReceiveStatus)||void 0===r?void 0:r.bind(t))&&void 0!==l?l:e=>{}};this.processingMetadata=!0,this.requester.start(e,o,((e,t)=>{var s,n,a;let i;if(this.processingMetadata=!1,(0,call_interface_1.isInterceptingListener)(t))i=t;else{const e={onReceiveMetadata:null!==(s=t.onReceiveMetadata)&&void 0!==s?s:defaultListener.onReceiveMetadata,onReceiveMessage:null!==(n=t.onReceiveMessage)&&void 0!==n?n:defaultListener.onReceiveMessage,onReceiveStatus:null!==(a=t.onReceiveStatus)&&void 0!==a?a:defaultListener.onReceiveStatus};i=new call_interface_1.InterceptingListenerImpl(e,o)}this.nextCall.start(e,i),this.processPendingMessage(),this.processPendingHalfClose()}))}sendMessageWithContext(e,t){this.processingMessage=!0,this.requester.sendMessage(t,(s=>{this.processingMessage=!1,this.processingMetadata?(this.pendingMessageContext=e,this.pendingMessage=t):(this.nextCall.sendMessageWithContext(e,s),this.processPendingHalfClose())}))}sendMessage(e){this.sendMessageWithContext({},e)}startRead(){this.nextCall.startRead()}halfClose(){this.requester.halfClose((()=>{this.processingMetadata||this.processingMessage?this.pendingHalfClose=!0:this.nextCall.halfClose()}))}}function getCall(e,t,s){var n,a;const i=null!==(n=s.deadline)&&void 0!==n?n:1/0,r=s.host,l=null!==(a=s.parent)&&void 0!==a?a:null,o=s.propagate_flags,c=s.credentials,d=e.createCall(t,i,r,l,o);return c&&d.setCredentials(c),d}exports.InterceptingCall=InterceptingCall;class BaseInterceptingCall{constructor(e,t){this.call=e,this.methodDefinition=t}cancelWithStatus(e,t){this.call.cancelWithStatus(e,t)}getPeer(){return this.call.getPeer()}sendMessageWithContext(e,t){let s;try{s=this.methodDefinition.requestSerialize(t)}catch(e){return void this.call.cancelWithStatus(constants_1.Status.INTERNAL,`Request message serialization failure: ${(0,error_1.getErrorMessage)(e)}`)}this.call.sendMessageWithContext(e,s)}sendMessage(e){this.sendMessageWithContext({},e)}start(e,t){let s=null;this.call.start(e,{onReceiveMetadata:e=>{var s;null===(s=null==t?void 0:t.onReceiveMetadata)||void 0===s||s.call(t,e)},onReceiveMessage:e=>{var n;let a;try{a=this.methodDefinition.responseDeserialize(e)}catch(e){return s={code:constants_1.Status.INTERNAL,details:`Response message parsing error: ${(0,error_1.getErrorMessage)(e)}`,metadata:new metadata_1.Metadata},void this.call.cancelWithStatus(s.code,s.details)}null===(n=null==t?void 0:t.onReceiveMessage)||void 0===n||n.call(t,a)},onReceiveStatus:e=>{var n,a;s?null===(n=null==t?void 0:t.onReceiveStatus)||void 0===n||n.call(t,s):null===(a=null==t?void 0:t.onReceiveStatus)||void 0===a||a.call(t,e)}})}startRead(){this.call.startRead()}halfClose(){this.call.halfClose()}}class BaseUnaryInterceptingCall extends BaseInterceptingCall{constructor(e,t){super(e,t)}start(e,t){var s,n;let a=!1;const i={onReceiveMetadata:null!==(n=null===(s=null==t?void 0:t.onReceiveMetadata)||void 0===s?void 0:s.bind(t))&&void 0!==n?n:e=>{},onReceiveMessage:e=>{var s;a=!0,null===(s=null==t?void 0:t.onReceiveMessage)||void 0===s||s.call(t,e)},onReceiveStatus:e=>{var s,n;a||null===(s=null==t?void 0:t.onReceiveMessage)||void 0===s||s.call(t,null),null===(n=null==t?void 0:t.onReceiveStatus)||void 0===n||n.call(t,e)}};super.start(e,i),this.call.startRead()}}class BaseStreamingInterceptingCall extends BaseInterceptingCall{}function getBottomInterceptingCall(e,t,s){const n=getCall(e,s.path,t);return s.responseStream?new BaseStreamingInterceptingCall(n,s):new BaseUnaryInterceptingCall(n,s)}function getInterceptingCall(e,t,s,n){if(e.clientInterceptors.length>0&&e.clientInterceptorProviders.length>0)throw new InterceptorConfigurationError("Both interceptors and interceptor_providers were passed as options to the client constructor. Only one of these is allowed.");if(e.callInterceptors.length>0&&e.callInterceptorProviders.length>0)throw new InterceptorConfigurationError("Both interceptors and interceptor_providers were passed as call options. Only one of these is allowed.");let a=[];a=e.callInterceptors.length>0||e.callInterceptorProviders.length>0?[].concat(e.callInterceptors,e.callInterceptorProviders.map((e=>e(t)))).filter((e=>e)):[].concat(e.clientInterceptors,e.clientInterceptorProviders.map((e=>e(t)))).filter((e=>e));const i=Object.assign({},s,{method_definition:t});return a.reduceRight(((e,t)=>s=>t(s,e)),(e=>getBottomInterceptingCall(n,e,t)))(i)}exports.getInterceptingCall=getInterceptingCall;