"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Client=void 0;const call_1=require("./call"),channel_1=require("./channel"),connectivity_state_1=require("./connectivity-state"),constants_1=require("./constants"),metadata_1=require("./metadata"),client_interceptors_1=require("./client-interceptors"),CHANNEL_SYMBOL=Symbol(),INTERCEPTOR_SYMBOL=Symbol(),INTERCEPTOR_PROVIDER_SYMBOL=Symbol(),CALL_INVOCATION_TRANSFORMER_SYMBOL=Symbol();function isFunction(e){return"function"==typeof e}function getErrorStackString(e){var t;return(null===(t=e.stack)||void 0===t?void 0:t.split("\n").slice(1).join("\n"))||"no stack trace available"}class Client{constructor(e,t,a={}){var n,r;if(a=Object.assign({},a),this[INTERCEPTOR_SYMBOL]=null!==(n=a.interceptors)&&void 0!==n?n:[],delete a.interceptors,this[INTERCEPTOR_PROVIDER_SYMBOL]=null!==(r=a.interceptor_providers)&&void 0!==r?r:[],delete a.interceptor_providers,this[INTERCEPTOR_SYMBOL].length>0&&this[INTERCEPTOR_PROVIDER_SYMBOL].length>0)throw new Error("Both interceptors and interceptor_providers were passed as options to the client constructor. Only one of these is allowed.");if(this[CALL_INVOCATION_TRANSFORMER_SYMBOL]=a.callInvocationTransformer,delete a.callInvocationTransformer,a.channelOverride)this[CHANNEL_SYMBOL]=a.channelOverride;else if(a.channelFactoryOverride){const n=a.channelFactoryOverride;delete a.channelFactoryOverride,this[CHANNEL_SYMBOL]=n(e,t,a)}else this[CHANNEL_SYMBOL]=new channel_1.ChannelImplementation(e,t,a)}close(){this[CHANNEL_SYMBOL].close()}getChannel(){return this[CHANNEL_SYMBOL]}waitForReady(e,t){const a=n=>{if(n)return void t(new Error("Failed to connect before the deadline"));let r;try{r=this[CHANNEL_SYMBOL].getConnectivityState(!0)}catch(e){return void t(new Error("The channel has been closed"))}if(r===connectivity_state_1.ConnectivityState.READY)t();else try{this[CHANNEL_SYMBOL].watchConnectivityState(r,e,a)}catch(e){t(new Error("The channel has been closed"))}};setImmediate(a)}checkOptionalUnaryResponseArguments(e,t,a){if(isFunction(e))return{metadata:new metadata_1.Metadata,options:{},callback:e};if(isFunction(t))return e instanceof metadata_1.Metadata?{metadata:e,options:{},callback:t}:{metadata:new metadata_1.Metadata,options:e,callback:t};if(!(e instanceof metadata_1.Metadata&&t instanceof Object&&isFunction(a)))throw new Error("Incorrect arguments passed");return{metadata:e,options:t,callback:a}}makeUnaryRequest(e,t,a,n,r,l,i){var s,c;const o=this.checkOptionalUnaryResponseArguments(r,l,i),d={path:e,requestStream:!1,responseStream:!1,requestSerialize:t,responseDeserialize:a};let O={argument:n,metadata:o.metadata,call:new call_1.ClientUnaryCallImpl,channel:this[CHANNEL_SYMBOL],methodDefinition:d,callOptions:o.options,callback:o.callback};this[CALL_INVOCATION_TRANSFORMER_SYMBOL]&&(O=this[CALL_INVOCATION_TRANSFORMER_SYMBOL](O));const _=O.call,p={clientInterceptors:this[INTERCEPTOR_SYMBOL],clientInterceptorProviders:this[INTERCEPTOR_PROVIDER_SYMBOL],callInterceptors:null!==(s=O.callOptions.interceptors)&&void 0!==s?s:[],callInterceptorProviders:null!==(c=O.callOptions.interceptor_providers)&&void 0!==c?c:[]},S=(0,client_interceptors_1.getInterceptingCall)(p,O.methodDefinition,O.callOptions,O.channel);_.call=S;let u=null,m=!1,h=new Error;return S.start(O.metadata,{onReceiveMetadata:e=>{_.emit("metadata",e)},onReceiveMessage(e){null!==u&&S.cancelWithStatus(constants_1.Status.UNIMPLEMENTED,"Too many responses received"),u=e},onReceiveStatus(e){if(!m){if(m=!0,e.code===constants_1.Status.OK)if(null===u){const t=getErrorStackString(h);O.callback((0,call_1.callErrorFromStatus)({code:constants_1.Status.UNIMPLEMENTED,details:"No message received",metadata:e.metadata},t))}else O.callback(null,u);else{const t=getErrorStackString(h);O.callback((0,call_1.callErrorFromStatus)(e,t))}h=null,_.emit("status",e)}}}),S.sendMessage(n),S.halfClose(),_}makeClientStreamRequest(e,t,a,n,r,l){var i,s;const c=this.checkOptionalUnaryResponseArguments(n,r,l),o={path:e,requestStream:!0,responseStream:!1,requestSerialize:t,responseDeserialize:a};let d={metadata:c.metadata,call:new call_1.ClientWritableStreamImpl(t),channel:this[CHANNEL_SYMBOL],methodDefinition:o,callOptions:c.options,callback:c.callback};this[CALL_INVOCATION_TRANSFORMER_SYMBOL]&&(d=this[CALL_INVOCATION_TRANSFORMER_SYMBOL](d));const O=d.call,_={clientInterceptors:this[INTERCEPTOR_SYMBOL],clientInterceptorProviders:this[INTERCEPTOR_PROVIDER_SYMBOL],callInterceptors:null!==(i=d.callOptions.interceptors)&&void 0!==i?i:[],callInterceptorProviders:null!==(s=d.callOptions.interceptor_providers)&&void 0!==s?s:[]},p=(0,client_interceptors_1.getInterceptingCall)(_,d.methodDefinition,d.callOptions,d.channel);O.call=p;let S=null,u=!1,m=new Error;return p.start(d.metadata,{onReceiveMetadata:e=>{O.emit("metadata",e)},onReceiveMessage(e){null!==S&&p.cancelWithStatus(constants_1.Status.UNIMPLEMENTED,"Too many responses received"),S=e,p.startRead()},onReceiveStatus(e){if(!u){if(u=!0,e.code===constants_1.Status.OK)if(null===S){const t=getErrorStackString(m);d.callback((0,call_1.callErrorFromStatus)({code:constants_1.Status.UNIMPLEMENTED,details:"No message received",metadata:e.metadata},t))}else d.callback(null,S);else{const t=getErrorStackString(m);d.callback((0,call_1.callErrorFromStatus)(e,t))}m=null,O.emit("status",e)}}}),O}checkMetadataAndOptions(e,t){let a,n;return e instanceof metadata_1.Metadata?(a=e,n=t||{}):(n=e||{},a=new metadata_1.Metadata),{metadata:a,options:n}}makeServerStreamRequest(e,t,a,n,r,l){var i,s;const c=this.checkMetadataAndOptions(r,l),o={path:e,requestStream:!1,responseStream:!0,requestSerialize:t,responseDeserialize:a};let d={argument:n,metadata:c.metadata,call:new call_1.ClientReadableStreamImpl(a),channel:this[CHANNEL_SYMBOL],methodDefinition:o,callOptions:c.options};this[CALL_INVOCATION_TRANSFORMER_SYMBOL]&&(d=this[CALL_INVOCATION_TRANSFORMER_SYMBOL](d));const O=d.call,_={clientInterceptors:this[INTERCEPTOR_SYMBOL],clientInterceptorProviders:this[INTERCEPTOR_PROVIDER_SYMBOL],callInterceptors:null!==(i=d.callOptions.interceptors)&&void 0!==i?i:[],callInterceptorProviders:null!==(s=d.callOptions.interceptor_providers)&&void 0!==s?s:[]},p=(0,client_interceptors_1.getInterceptingCall)(_,d.methodDefinition,d.callOptions,d.channel);O.call=p;let S=!1,u=new Error;return p.start(d.metadata,{onReceiveMetadata(e){O.emit("metadata",e)},onReceiveMessage(e){O.push(e)},onReceiveStatus(e){if(!S){if(S=!0,O.push(null),e.code!==constants_1.Status.OK){const t=getErrorStackString(u);O.emit("error",(0,call_1.callErrorFromStatus)(e,t))}u=null,O.emit("status",e)}}}),p.sendMessage(n),p.halfClose(),O}makeBidiStreamRequest(e,t,a,n,r){var l,i;const s=this.checkMetadataAndOptions(n,r),c={path:e,requestStream:!0,responseStream:!0,requestSerialize:t,responseDeserialize:a};let o={metadata:s.metadata,call:new call_1.ClientDuplexStreamImpl(t,a),channel:this[CHANNEL_SYMBOL],methodDefinition:c,callOptions:s.options};this[CALL_INVOCATION_TRANSFORMER_SYMBOL]&&(o=this[CALL_INVOCATION_TRANSFORMER_SYMBOL](o));const d=o.call,O={clientInterceptors:this[INTERCEPTOR_SYMBOL],clientInterceptorProviders:this[INTERCEPTOR_PROVIDER_SYMBOL],callInterceptors:null!==(l=o.callOptions.interceptors)&&void 0!==l?l:[],callInterceptorProviders:null!==(i=o.callOptions.interceptor_providers)&&void 0!==i?i:[]},_=(0,client_interceptors_1.getInterceptingCall)(O,o.methodDefinition,o.callOptions,o.channel);d.call=_;let p=!1,S=new Error;return _.start(o.metadata,{onReceiveMetadata(e){d.emit("metadata",e)},onReceiveMessage(e){d.push(e)},onReceiveStatus(e){if(!p){if(p=!0,d.push(null),e.code!==constants_1.Status.OK){const t=getErrorStackString(S);d.emit("error",(0,call_1.callErrorFromStatus)(e,t))}S=null,d.emit("status",e)}}}),d}}exports.Client=Client;