"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.CompressionFilterFactory=exports.CompressionFilter=void 0;const zlib=require("zlib"),compression_algorithms_1=require("./compression-algorithms"),constants_1=require("./constants"),filter_1=require("./filter"),logging=require("./logging"),isCompressionAlgorithmKey=e=>"number"==typeof e&&"string"==typeof compression_algorithms_1.CompressionAlgorithms[e];class CompressionHandler{async writeMessage(e,s){let t=e;s&&(t=await this.compressMessage(t));const r=Buffer.allocUnsafe(t.length+5);return r.writeUInt8(s?1:0,0),r.writeUInt32BE(t.length,1),t.copy(r,5),r}async readMessage(e){const s=1===e.readUInt8(0);let t=e.slice(5);return s&&(t=await this.decompressMessage(t)),t}}class IdentityHandler extends CompressionHandler{async compressMessage(e){return e}async writeMessage(e,s){const t=Buffer.allocUnsafe(e.length+5);return t.writeUInt8(0,0),t.writeUInt32BE(e.length,1),e.copy(t,5),t}decompressMessage(e){return Promise.reject(new Error('Received compressed message but "grpc-encoding" header was identity'))}}class DeflateHandler extends CompressionHandler{constructor(e){super(),this.maxRecvMessageLength=e}compressMessage(e){return new Promise(((s,t)=>{zlib.deflate(e,((e,r)=>{e?t(e):s(r)}))}))}decompressMessage(e){return new Promise(((s,t)=>{let r=0;const n=[],o=zlib.createInflate();o.on("data",(e=>{n.push(e),r+=e.byteLength,-1!==this.maxRecvMessageLength&&r>this.maxRecvMessageLength&&(o.destroy(),t({code:constants_1.Status.RESOURCE_EXHAUSTED,details:`Received message that decompresses to a size larger than ${this.maxRecvMessageLength}`}))})),o.on("end",(()=>{s(Buffer.concat(n))})),o.write(e),o.end()}))}}class GzipHandler extends CompressionHandler{constructor(e){super(),this.maxRecvMessageLength=e}compressMessage(e){return new Promise(((s,t)=>{zlib.gzip(e,((e,r)=>{e?t(e):s(r)}))}))}decompressMessage(e){return new Promise(((s,t)=>{let r=0;const n=[],o=zlib.createGunzip();o.on("data",(e=>{n.push(e),r+=e.byteLength,-1!==this.maxRecvMessageLength&&r>this.maxRecvMessageLength&&(o.destroy(),t({code:constants_1.Status.RESOURCE_EXHAUSTED,details:`Received message that decompresses to a size larger than ${this.maxRecvMessageLength}`}))})),o.on("end",(()=>{s(Buffer.concat(n))})),o.write(e),o.end()}))}}class UnknownHandler extends CompressionHandler{constructor(e){super(),this.compressionName=e}compressMessage(e){return Promise.reject(new Error(`Received message compressed with unsupported compression method ${this.compressionName}`))}decompressMessage(e){return Promise.reject(new Error(`Compression method not supported: ${this.compressionName}`))}}function getCompressionHandler(e,s){switch(e){case"identity":return new IdentityHandler;case"deflate":return new DeflateHandler(s);case"gzip":return new GzipHandler(s);default:return new UnknownHandler(e)}}class CompressionFilter extends filter_1.BaseFilter{constructor(e,s){var t,r,n;super(),this.sharedFilterConfig=s,this.sendCompression=new IdentityHandler,this.receiveCompression=new IdentityHandler,this.currentCompressionAlgorithm="identity";const o=e["grpc.default_compression_algorithm"];if(this.maxReceiveMessageLength=null!==(t=e["grpc.max_receive_message_length"])&&void 0!==t?t:constants_1.DEFAULT_MAX_RECEIVE_MESSAGE_LENGTH,this.maxSendMessageLength=null!==(r=e["grpc.max_send_message_length"])&&void 0!==r?r:constants_1.DEFAULT_MAX_SEND_MESSAGE_LENGTH,void 0!==o)if("number"==typeof(i=o)&&"string"==typeof compression_algorithms_1.CompressionAlgorithms[i]){const e=compression_algorithms_1.CompressionAlgorithms[o],t=null===(n=s.serverSupportedEncodingHeader)||void 0===n?void 0:n.split(",");t&&!t.includes(e)||(this.currentCompressionAlgorithm=e,this.sendCompression=getCompressionHandler(this.currentCompressionAlgorithm,-1))}else logging.log(constants_1.LogVerbosity.ERROR,`Invalid value provided for grpc.default_compression_algorithm option: ${o}`);var i}async sendMetadata(e){const s=await e;return s.set("grpc-accept-encoding","identity,deflate,gzip"),s.set("accept-encoding","identity"),"identity"===this.currentCompressionAlgorithm?s.remove("grpc-encoding"):s.set("grpc-encoding",this.currentCompressionAlgorithm),s}receiveMetadata(e){const s=e.get("grpc-encoding");if(s.length>0){const e=s[0];"string"==typeof e&&(this.receiveCompression=getCompressionHandler(e,this.maxReceiveMessageLength))}e.remove("grpc-encoding");const t=e.get("grpc-accept-encoding")[0];if(t){this.sharedFilterConfig.serverSupportedEncodingHeader=t;t.split(",").includes(this.currentCompressionAlgorithm)||(this.sendCompression=new IdentityHandler,this.currentCompressionAlgorithm="identity")}return e.remove("grpc-accept-encoding"),e}async sendMessage(e){var s;const t=await e;if(-1!==this.maxSendMessageLength&&t.message.length>this.maxSendMessageLength)throw{code:constants_1.Status.RESOURCE_EXHAUSTED,details:`Attempted to send message with a size larger than ${this.maxSendMessageLength}`};let r;return r=!(this.sendCompression instanceof IdentityHandler)&&0==(2&(null!==(s=t.flags)&&void 0!==s?s:0)),{message:await this.sendCompression.writeMessage(t.message,r),flags:t.flags}}async receiveMessage(e){return this.receiveCompression.readMessage(await e)}}exports.CompressionFilter=CompressionFilter;class CompressionFilterFactory{constructor(e,s){this.options=s,this.sharedFilterConfig={}}createFilter(){return new CompressionFilter(this.options,this.sharedFilterConfig)}}exports.CompressionFilterFactory=CompressionFilterFactory;