"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.getProxiedConnection=exports.mapProxyName=void 0;const logging_1=require("./logging"),constants_1=require("./constants"),resolver_1=require("./resolver"),http=require("http"),tls=require("tls"),logging=require("./logging"),subchannel_address_1=require("./subchannel-address"),uri_parser_1=require("./uri-parser"),url_1=require("url"),resolver_dns_1=require("./resolver-dns"),TRACER_NAME="proxy";function trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,e)}function getProxyInfo(){let e,r="",t="";if(process.env.grpc_proxy)t="grpc_proxy",r=process.env.grpc_proxy;else if(process.env.https_proxy)t="https_proxy",r=process.env.https_proxy;else{if(!process.env.http_proxy)return{};t="http_proxy",r=process.env.http_proxy}try{e=new url_1.URL(r)}catch(e){return(0,logging_1.log)(constants_1.LogVerbosity.ERROR,`cannot parse value of "${t}" env var`),{}}if("http:"!==e.protocol)return(0,logging_1.log)(constants_1.LogVerbosity.ERROR,`"${e.protocol}" scheme not supported in proxy URI`),{};let o=null;e.username&&(e.password?((0,logging_1.log)(constants_1.LogVerbosity.INFO,"userinfo found in proxy URI"),o=decodeURIComponent(`${e.username}:${e.password}`)):o=e.username);const s=e.hostname;let n=e.port;""===n&&(n="80");const c={address:`${s}:${n}`};return o&&(c.creds=o),trace("Proxy server "+c.address+" set by environment variable "+t),c}function getNoProxyHostList(){let e=process.env.no_grpc_proxy,r="no_grpc_proxy";return e||(e=process.env.no_proxy,r="no_proxy"),e?(trace("No proxy server list set by environment variable "+r),e.split(",")):[]}function mapProxyName(e,r){var t;const o={target:e,extraOptions:{}};if(0===(null!==(t=r["grpc.enable_http_proxy"])&&void 0!==t?t:1))return o;if("unix"===e.scheme)return o;const s=getProxyInfo();if(!s.address)return o;const n=(0,uri_parser_1.splitHostPort)(e.path);if(!n)return o;const c=n.host;for(const r of getNoProxyHostList())if(r===c)return trace("Not using proxy for target in no_proxy list: "+(0,uri_parser_1.uriToString)(e)),o;const i={"grpc.http_connect_target":(0,uri_parser_1.uriToString)(e)};return s.creds&&(i["grpc.http_connect_creds"]=s.creds),{target:{scheme:"dns",path:s.address},extraOptions:i}}function getProxiedConnection(e,r,t){var o;if(!("grpc.http_connect_target"in r))return Promise.resolve({});const s=r["grpc.http_connect_target"],n=(0,uri_parser_1.parseUri)(s);if(null===n)return Promise.resolve({});const c=(0,uri_parser_1.splitHostPort)(n.path);if(null===c)return Promise.resolve({});const i=`${c.host}:${null!==(o=c.port)&&void 0!==o?o:resolver_dns_1.DEFAULT_PORT}`,a={method:"CONNECT",path:i},p={Host:i};(0,subchannel_address_1.isTcpSubchannelAddress)(e)?(a.host=e.host,a.port=e.port):a.socketPath=e.path,"grpc.http_connect_creds"in r&&(p["Proxy-Authorization"]="Basic "+Buffer.from(r["grpc.http_connect_creds"]).toString("base64")),a.headers=p;const l=(0,subchannel_address_1.subchannelAddressToString)(e);return trace("Using proxy "+l+" to connect to "+a.path),new Promise(((e,r)=>{const o=http.request(a);o.once("connect",((s,c,i)=>{var p;if(o.removeAllListeners(),c.removeAllListeners(),200===s.statusCode)if(trace("Successfully connected to "+a.path+" through proxy "+l),i.length>0&&c.unshift(i),"secureContext"in t){const o=(0,resolver_1.getDefaultAuthority)(n),s=(0,uri_parser_1.splitHostPort)(o),i=null!==(p=null==s?void 0:s.host)&&void 0!==p?p:o,u=tls.connect(Object.assign({host:i,servername:i,socket:c},t),(()=>{trace("Successfully established a TLS connection to "+a.path+" through proxy "+l),e({socket:u,realTarget:n})}));u.on("error",(e=>{trace("Failed to establish a TLS connection to "+a.path+" through proxy "+l+" with error "+e.message),r()}))}else trace("Successfully established a plaintext connection to "+a.path+" through proxy "+l),e({socket:c,realTarget:n});else(0,logging_1.log)(constants_1.LogVerbosity.ERROR,"Failed to connect to "+a.path+" through proxy "+l+" with status "+s.statusCode),r()})),o.once("error",(e=>{o.removeAllListeners(),(0,logging_1.log)(constants_1.LogVerbosity.ERROR,"Failed to connect to proxy "+l+" with error "+e.message),r()})),o.end()}))}exports.mapProxyName=mapProxyName,exports.getProxiedConnection=getProxiedConnection;