"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.InternalChannel=void 0;const channel_credentials_1=require("./channel-credentials"),resolving_load_balancer_1=require("./resolving-load-balancer"),subchannel_pool_1=require("./subchannel-pool"),picker_1=require("./picker"),metadata_1=require("./metadata"),constants_1=require("./constants"),filter_stack_1=require("./filter-stack"),compression_filter_1=require("./compression-filter"),resolver_1=require("./resolver"),logging_1=require("./logging"),http_proxy_1=require("./http_proxy"),uri_parser_1=require("./uri-parser"),connectivity_state_1=require("./connectivity-state"),channelz_1=require("./channelz"),load_balancing_call_1=require("./load-balancing-call"),deadline_1=require("./deadline"),resolving_call_1=require("./resolving-call"),call_number_1=require("./call-number"),control_plane_status_1=require("./control-plane-status"),retrying_call_1=require("./retrying-call"),subchannel_interface_1=require("./subchannel-interface"),MAX_TIMEOUT_TIME=2147483647,MIN_IDLE_TIMEOUT_MS=1e3,DEFAULT_IDLE_TIMEOUT_MS=18e5,RETRY_THROTTLER_MAP=new Map,DEFAULT_RETRY_BUFFER_SIZE_BYTES=1<<24,DEFAULT_PER_RPC_RETRY_BUFFER_SIZE_BYTES=1<<20;class ChannelSubchannelWrapper extends subchannel_interface_1.BaseSubchannelWrapper{constructor(e,t){super(e),this.channel=t,this.refCount=0,this.subchannelStateListener=(e,n,i,a)=>{t.throttleKeepalive(a)},e.addConnectivityStateListener(this.subchannelStateListener)}ref(){this.child.ref(),this.refCount+=1}unref(){this.child.unref(),this.refCount-=1,this.refCount<=0&&(this.child.removeConnectivityStateListener(this.subchannelStateListener),this.channel.removeWrappedSubchannel(this))}}class ShutdownPicker{pick(e){return{pickResultType:picker_1.PickResultType.DROP,status:{code:constants_1.Status.UNAVAILABLE,details:"Channel closed before call started",metadata:new metadata_1.Metadata},subchannel:null,onCallStarted:null,onCallEnded:null}}}class InternalChannel{constructor(e,t,n){var i,a,r,l,s,c,o,h;if(this.credentials=t,this.options=n,this.connectivityState=connectivity_state_1.ConnectivityState.IDLE,this.currentPicker=new picker_1.UnavailablePicker,this.configSelectionQueue=[],this.pickQueue=[],this.connectivityStateWatchers=[],this.configSelector=null,this.currentResolutionError=null,this.wrappedSubchannels=new Set,this.callCount=0,this.idleTimer=null,this.channelzEnabled=!0,this.callTracker=new channelz_1.ChannelzCallTracker,this.childrenTracker=new channelz_1.ChannelzChildrenTracker,this.randomChannelId=Math.floor(Math.random()*Number.MAX_SAFE_INTEGER),"string"!=typeof e)throw new TypeError("Channel target must be a string");if(!(t instanceof channel_credentials_1.ChannelCredentials))throw new TypeError("Channel credentials must be a ChannelCredentials object");if(n&&"object"!=typeof n)throw new TypeError("Channel options must be an object");this.originalTarget=e;const u=(0,uri_parser_1.parseUri)(e);if(null===u)throw new Error(`Could not parse target name "${e}"`);const d=(0,resolver_1.mapUriDefaultScheme)(u);if(null===d)throw new Error(`Could not find a default scheme for target name "${e}"`);this.callRefTimer=setInterval((()=>{}),2147483647),null===(a=(i=this.callRefTimer).unref)||void 0===a||a.call(i),0===this.options["grpc.enable_channelz"]&&(this.channelzEnabled=!1),this.channelzTrace=new channelz_1.ChannelzTrace,this.channelzRef=(0,channelz_1.registerChannelzChannel)(e,(()=>this.getChannelzInfo()),this.channelzEnabled),this.channelzEnabled&&this.channelzTrace.addTrace("CT_INFO","Channel created"),this.options["grpc.default_authority"]?this.defaultAuthority=this.options["grpc.default_authority"]:this.defaultAuthority=(0,resolver_1.getDefaultAuthority)(d);const _=(0,http_proxy_1.mapProxyName)(d,n);this.target=_.target,this.options=Object.assign({},this.options,_.extraOptions),this.subchannelPool=(0,subchannel_pool_1.getSubchannelPool)(0===(null!==(r=n["grpc.use_local_subchannel_pool"])&&void 0!==r?r:0)),this.retryBufferTracker=new retrying_call_1.MessageBufferTracker(null!==(l=n["grpc.retry_buffer_size"])&&void 0!==l?l:16777216,null!==(s=n["grpc.per_rpc_retry_buffer_size"])&&void 0!==s?s:1048576),this.keepaliveTime=null!==(c=n["grpc.keepalive_time_ms"])&&void 0!==c?c:-1,this.idleTimeoutMs=Math.max(null!==(o=n["grpc.client_idle_timeout_ms"])&&void 0!==o?o:18e5,1e3);const g={createSubchannel:(e,t,n)=>{const i=this.subchannelPool.getOrCreateSubchannel(this.target,e,Object.assign({},this.options,t),null!=n?n:this.credentials);i.throttleKeepalive(this.keepaliveTime),this.channelzEnabled&&this.channelzTrace.addTrace("CT_INFO","Created subchannel or used existing subchannel",i.getChannelzRef());const a=new ChannelSubchannelWrapper(i,this);return this.wrappedSubchannels.add(a),a},updateState:(e,t)=>{this.currentPicker=t;const n=this.pickQueue.slice();this.pickQueue=[],n.length>0&&this.callRefTimerUnref();for(const e of n)e.doPick();this.updateState(e)},requestReresolution:()=>{throw new Error("Resolving load balancer should never call requestReresolution")},addChannelzChild:e=>{this.channelzEnabled&&this.childrenTracker.refChild(e)},removeChannelzChild:e=>{this.channelzEnabled&&this.childrenTracker.unrefChild(e)}};this.resolvingLoadBalancer=new resolving_load_balancer_1.ResolvingLoadBalancer(this.target,g,t,n,((e,t)=>{e.retryThrottling?RETRY_THROTTLER_MAP.set(this.getTarget(),new retrying_call_1.RetryThrottler(e.retryThrottling.maxTokens,e.retryThrottling.tokenRatio,RETRY_THROTTLER_MAP.get(this.getTarget()))):RETRY_THROTTLER_MAP.delete(this.getTarget()),this.channelzEnabled&&this.channelzTrace.addTrace("CT_INFO","Address resolution succeeded"),this.configSelector=t,this.currentResolutionError=null,process.nextTick((()=>{const e=this.configSelectionQueue;this.configSelectionQueue=[],e.length>0&&this.callRefTimerUnref();for(const t of e)t.getConfig()}))}),(e=>{this.channelzEnabled&&this.channelzTrace.addTrace("CT_WARNING","Address resolution failed with code "+e.code+' and details "'+e.details+'"'),this.configSelectionQueue.length>0&&this.trace("Name resolution failed with calls queued for config selection"),null===this.configSelector&&(this.currentResolutionError=Object.assign(Object.assign({},(0,control_plane_status_1.restrictControlPlaneStatusCode)(e.code,e.details)),{metadata:e.metadata}));const t=this.configSelectionQueue;this.configSelectionQueue=[],t.length>0&&this.callRefTimerUnref();for(const n of t)n.reportResolverError(e)})),this.filterStackFactory=new filter_stack_1.FilterStackFactory([new compression_filter_1.CompressionFilterFactory(this,this.options)]),this.trace("Channel constructed with options "+JSON.stringify(n,void 0,2));const f=new Error;(0,logging_1.isTracerEnabled)("channel_stacktrace")&&(0,logging_1.trace)(constants_1.LogVerbosity.DEBUG,"channel_stacktrace","("+this.channelzRef.id+") Channel constructed \n"+(null===(h=f.stack)||void 0===h?void 0:h.substring(f.stack.indexOf("\n")+1))),this.lastActivityTimestamp=new Date}getChannelzInfo(){return{target:this.originalTarget,state:this.connectivityState,trace:this.channelzTrace,callTracker:this.callTracker,children:this.childrenTracker.getChildLists()}}trace(e,t){(0,logging_1.trace)(null!=t?t:constants_1.LogVerbosity.DEBUG,"channel","("+this.channelzRef.id+") "+(0,uri_parser_1.uriToString)(this.target)+" "+e)}callRefTimerRef(){var e,t,n,i;(null===(t=(e=this.callRefTimer).hasRef)||void 0===t?void 0:t.call(e))||(this.trace("callRefTimer.ref | configSelectionQueue.length="+this.configSelectionQueue.length+" pickQueue.length="+this.pickQueue.length),null===(i=(n=this.callRefTimer).ref)||void 0===i||i.call(n))}callRefTimerUnref(){var e,t;this.callRefTimer.hasRef&&!this.callRefTimer.hasRef()||(this.trace("callRefTimer.unref | configSelectionQueue.length="+this.configSelectionQueue.length+" pickQueue.length="+this.pickQueue.length),null===(t=(e=this.callRefTimer).unref)||void 0===t||t.call(e))}removeConnectivityStateWatcher(e){const t=this.connectivityStateWatchers.findIndex((t=>t===e));t>=0&&this.connectivityStateWatchers.splice(t,1)}updateState(e){(0,logging_1.trace)(constants_1.LogVerbosity.DEBUG,"connectivity_state","("+this.channelzRef.id+") "+(0,uri_parser_1.uriToString)(this.target)+" "+connectivity_state_1.ConnectivityState[this.connectivityState]+" -> "+connectivity_state_1.ConnectivityState[e]),this.channelzEnabled&&this.channelzTrace.addTrace("CT_INFO","Connectivity state change to "+connectivity_state_1.ConnectivityState[e]),this.connectivityState=e;const t=this.connectivityStateWatchers.slice();for(const n of t)e!==n.currentState&&(n.timer&&clearTimeout(n.timer),this.removeConnectivityStateWatcher(n),n.callback());e!==connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE&&(this.currentResolutionError=null)}throttleKeepalive(e){if(e>this.keepaliveTime){this.keepaliveTime=e;for(const t of this.wrappedSubchannels)t.throttleKeepalive(e)}}removeWrappedSubchannel(e){this.wrappedSubchannels.delete(e)}doPick(e,t){return this.currentPicker.pick({metadata:e,extraPickInfo:t})}queueCallForPick(e){this.pickQueue.push(e),this.callRefTimerRef()}getConfig(e,t){return this.connectivityState!==connectivity_state_1.ConnectivityState.SHUTDOWN&&this.resolvingLoadBalancer.exitIdle(),this.configSelector?{type:"SUCCESS",config:this.configSelector(e,t,this.randomChannelId)}:this.currentResolutionError?{type:"ERROR",error:this.currentResolutionError}:{type:"NONE"}}queueCallForConfig(e){this.configSelectionQueue.push(e),this.callRefTimerRef()}enterIdle(){this.resolvingLoadBalancer.destroy(),this.updateState(connectivity_state_1.ConnectivityState.IDLE),this.currentPicker=new picker_1.QueuePicker(this.resolvingLoadBalancer),this.idleTimer&&(clearTimeout(this.idleTimer),this.idleTimer=null)}startIdleTimeout(e){var t,n;this.idleTimer=setTimeout((()=>{if(this.callCount>0)return void this.startIdleTimeout(this.idleTimeoutMs);const e=(new Date).valueOf()-this.lastActivityTimestamp.valueOf();e>=this.idleTimeoutMs?(this.trace("Idle timer triggered after "+this.idleTimeoutMs+"ms of inactivity"),this.enterIdle()):this.startIdleTimeout(this.idleTimeoutMs-e)}),e),null===(n=(t=this.idleTimer).unref)||void 0===n||n.call(t)}maybeStartIdleTimer(){this.connectivityState===connectivity_state_1.ConnectivityState.SHUTDOWN||this.idleTimer||this.startIdleTimeout(this.idleTimeoutMs)}onCallStart(){this.channelzEnabled&&this.callTracker.addCallStarted(),this.callCount+=1}onCallEnd(e){this.channelzEnabled&&(e.code===constants_1.Status.OK?this.callTracker.addCallSucceeded():this.callTracker.addCallFailed()),this.callCount-=1,this.lastActivityTimestamp=new Date,this.maybeStartIdleTimer()}createLoadBalancingCall(e,t,n,i,a){const r=(0,call_number_1.getNextCallNumber)();return this.trace("createLoadBalancingCall ["+r+'] method="'+t+'"'),new load_balancing_call_1.LoadBalancingCall(this,e,t,n,i,a,r)}createRetryingCall(e,t,n,i,a){const r=(0,call_number_1.getNextCallNumber)();return this.trace("createRetryingCall ["+r+'] method="'+t+'"'),new retrying_call_1.RetryingCall(this,e,t,n,i,a,r,this.retryBufferTracker,RETRY_THROTTLER_MAP.get(this.getTarget()))}createInnerCall(e,t,n,i,a){return 0===this.options["grpc.enable_retries"]?this.createLoadBalancingCall(e,t,n,i,a):this.createRetryingCall(e,t,n,i,a)}createResolvingCall(e,t,n,i,a){const r=(0,call_number_1.getNextCallNumber)();this.trace("createResolvingCall ["+r+'] method="'+e+'", deadline='+(0,deadline_1.deadlineToString)(t));const l={deadline:t,flags:null!=a?a:constants_1.Propagate.DEFAULTS,host:null!=n?n:this.defaultAuthority,parentCall:i},s=new resolving_call_1.ResolvingCall(this,e,l,this.filterStackFactory.clone(),this.credentials._getCallCredentials(),r);return this.onCallStart(),s.addStatusWatcher((e=>{this.onCallEnd(e)})),s}close(){this.resolvingLoadBalancer.destroy(),this.updateState(connectivity_state_1.ConnectivityState.SHUTDOWN),this.currentPicker=new ShutdownPicker;for(const e of this.configSelectionQueue)e.cancelWithStatus(constants_1.Status.UNAVAILABLE,"Channel closed before call started");this.configSelectionQueue=[];for(const e of this.pickQueue)e.cancelWithStatus(constants_1.Status.UNAVAILABLE,"Channel closed before call started");this.pickQueue=[],clearInterval(this.callRefTimer),this.idleTimer&&clearTimeout(this.idleTimer),this.channelzEnabled&&(0,channelz_1.unregisterChannelzRef)(this.channelzRef),this.subchannelPool.unrefUnusedSubchannels()}getTarget(){return(0,uri_parser_1.uriToString)(this.target)}getConnectivityState(e){const t=this.connectivityState;return e&&(this.resolvingLoadBalancer.exitIdle(),this.lastActivityTimestamp=new Date,this.maybeStartIdleTimer()),t}watchConnectivityState(e,t,n){if(this.connectivityState===connectivity_state_1.ConnectivityState.SHUTDOWN)throw new Error("Channel has been shut down");let i=null;if(t!==1/0){const e=t instanceof Date?t:new Date(t),r=new Date;if(t===-1/0||e<=r)return void process.nextTick(n,new Error("Deadline passed without connectivity state change"));i=setTimeout((()=>{this.removeConnectivityStateWatcher(a),n(new Error("Deadline passed without connectivity state change"))}),e.getTime()-r.getTime())}const a={currentState:e,callback:n,timer:i};this.connectivityStateWatchers.push(a)}getChannelzRef(){return this.channelzRef}createCall(e,t,n,i,a){if("string"!=typeof e)throw new TypeError("Channel#createCall: method must be a string");if(!("number"==typeof t||t instanceof Date))throw new TypeError("Channel#createCall: deadline must be a number or Date");if(this.connectivityState===connectivity_state_1.ConnectivityState.SHUTDOWN)throw new Error("Channel has been shut down");return this.createResolvingCall(e,t,n,i,a)}getOptions(){return this.options}}exports.InternalChannel=InternalChannel;