"use strict";var _a;Object.defineProperty(exports,"__esModule",{value:!0}),exports.setup=exports.OutlierDetectionLoadBalancer=exports.OutlierDetectionLoadBalancingConfig=void 0;const connectivity_state_1=require("./connectivity-state"),constants_1=require("./constants"),duration_1=require("./duration"),experimental_1=require("./experimental"),load_balancer_1=require("./load-balancer"),load_balancer_child_handler_1=require("./load-balancer-child-handler"),picker_1=require("./picker"),subchannel_address_1=require("./subchannel-address"),subchannel_interface_1=require("./subchannel-interface"),logging=require("./logging"),TRACER_NAME="outlier_detection";function trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,e)}const TYPE_NAME="outlier_detection",OUTLIER_DETECTION_ENABLED="true"===(null!==(_a=process.env.GRPC_EXPERIMENTAL_ENABLE_OUTLIER_DETECTION)&&void 0!==_a?_a:"true"),defaultSuccessRateEjectionConfig={stdev_factor:1900,enforcement_percentage:100,minimum_hosts:5,request_volume:100},defaultFailurePercentageEjectionConfig={threshold:85,enforcement_percentage:100,minimum_hosts:5,request_volume:50};function validateFieldType(e,t,i,n){if(t in e&&void 0!==e[t]&&typeof e[t]!==i){throw new Error(`outlier detection config ${n?`${n}.${t}`:t} parse error: expected ${i}, got ${typeof e[t]}`)}}function validatePositiveDuration(e,t,i){const n=i?`${i}.${t}`:t;if(t in e&&void 0!==e[t]){if(!(0,duration_1.isDuration)(e[t]))throw new Error(`outlier detection config ${n} parse error: expected Duration, got ${typeof e[t]}`);if(!(e[t].seconds>=0&&e[t].seconds<=315576e6&&e[t].nanos>=0&&e[t].nanos<=999999999))throw new Error(`outlier detection config ${n} parse error: values out of range for non-negative Duaration`)}}function validatePercentage(e,t,i){const n=i?`${i}.${t}`:t;if(validateFieldType(e,t,"number",i),t in e&&void 0!==e[t]&&!(e[t]>=0&&e[t]<=100))throw new Error(`outlier detection config ${n} parse error: value out of range for percentage (0-100)`)}class OutlierDetectionLoadBalancingConfig{constructor(e,t,i,n,r,c,a){if(this.childPolicy=a,"pick_first"===a.getLoadBalancerName())throw new Error("outlier_detection LB policy cannot have a pick_first child policy");this.intervalMs=null!=e?e:1e4,this.baseEjectionTimeMs=null!=t?t:3e4,this.maxEjectionTimeMs=null!=i?i:3e5,this.maxEjectionPercent=null!=n?n:10,this.successRateEjection=r?Object.assign(Object.assign({},defaultSuccessRateEjectionConfig),r):null,this.failurePercentageEjection=c?Object.assign(Object.assign({},defaultFailurePercentageEjectionConfig),c):null}getLoadBalancerName(){return TYPE_NAME}toJsonObject(){var e,t;return{outlier_detection:{interval:(0,duration_1.msToDuration)(this.intervalMs),base_ejection_time:(0,duration_1.msToDuration)(this.baseEjectionTimeMs),max_ejection_time:(0,duration_1.msToDuration)(this.maxEjectionTimeMs),max_ejection_percent:this.maxEjectionPercent,success_rate_ejection:null!==(e=this.successRateEjection)&&void 0!==e?e:void 0,failure_percentage_ejection:null!==(t=this.failurePercentageEjection)&&void 0!==t?t:void 0,child_policy:[this.childPolicy.toJsonObject()]}}}getIntervalMs(){return this.intervalMs}getBaseEjectionTimeMs(){return this.baseEjectionTimeMs}getMaxEjectionTimeMs(){return this.maxEjectionTimeMs}getMaxEjectionPercent(){return this.maxEjectionPercent}getSuccessRateEjectionConfig(){return this.successRateEjection}getFailurePercentageEjectionConfig(){return this.failurePercentageEjection}getChildPolicy(){return this.childPolicy}static createFromJson(e){var t;if(validatePositiveDuration(e,"interval"),validatePositiveDuration(e,"base_ejection_time"),validatePositiveDuration(e,"max_ejection_time"),validatePercentage(e,"max_ejection_percent"),"success_rate_ejection"in e&&void 0!==e.success_rate_ejection){if("object"!=typeof e.success_rate_ejection)throw new Error("outlier detection config success_rate_ejection must be an object");validateFieldType(e.success_rate_ejection,"stdev_factor","number","success_rate_ejection"),validatePercentage(e.success_rate_ejection,"enforcement_percentage","success_rate_ejection"),validateFieldType(e.success_rate_ejection,"minimum_hosts","number","success_rate_ejection"),validateFieldType(e.success_rate_ejection,"request_volume","number","success_rate_ejection")}if("failure_percentage_ejection"in e&&void 0!==e.failure_percentage_ejection){if("object"!=typeof e.failure_percentage_ejection)throw new Error("outlier detection config failure_percentage_ejection must be an object");validatePercentage(e.failure_percentage_ejection,"threshold","failure_percentage_ejection"),validatePercentage(e.failure_percentage_ejection,"enforcement_percentage","failure_percentage_ejection"),validateFieldType(e.failure_percentage_ejection,"minimum_hosts","number","failure_percentage_ejection"),validateFieldType(e.failure_percentage_ejection,"request_volume","number","failure_percentage_ejection")}if(!("child_policy"in e)||!Array.isArray(e.child_policy))throw new Error("outlier detection config child_policy must be an array");const i=(0,load_balancer_1.selectLbConfigFromList)(e.child_policy);if(!i)throw new Error("outlier detection config child_policy: no valid recognized policy found");return new OutlierDetectionLoadBalancingConfig(e.interval?(0,duration_1.durationToMs)(e.interval):null,e.base_ejection_time?(0,duration_1.durationToMs)(e.base_ejection_time):null,e.max_ejection_time?(0,duration_1.durationToMs)(e.max_ejection_time):null,null!==(t=e.max_ejection_percent)&&void 0!==t?t:null,e.success_rate_ejection,e.failure_percentage_ejection,i)}}exports.OutlierDetectionLoadBalancingConfig=OutlierDetectionLoadBalancingConfig;class OutlierDetectionSubchannelWrapper extends subchannel_interface_1.BaseSubchannelWrapper{constructor(e,t){super(e),this.mapEntry=t,this.refCount=0}ref(){this.child.ref(),this.refCount+=1}unref(){if(this.child.unref(),this.refCount-=1,this.refCount<=0&&this.mapEntry){const e=this.mapEntry.subchannelWrappers.indexOf(this);e>=0&&this.mapEntry.subchannelWrappers.splice(e,1)}}eject(){this.setHealthy(!1)}uneject(){this.setHealthy(!0)}getMapEntry(){return this.mapEntry}getWrappedSubchannel(){return this.child}}function createEmptyBucket(){return{success:0,failure:0}}class CallCounter{constructor(){this.activeBucket=createEmptyBucket(),this.inactiveBucket=createEmptyBucket()}addSuccess(){this.activeBucket.success+=1}addFailure(){this.activeBucket.failure+=1}switchBuckets(){this.inactiveBucket=this.activeBucket,this.activeBucket=createEmptyBucket()}getLastSuccesses(){return this.inactiveBucket.success}getLastFailures(){return this.inactiveBucket.failure}}class OutlierDetectionPicker{constructor(e,t){this.wrappedPicker=e,this.countCalls=t}pick(e){const t=this.wrappedPicker.pick(e);if(t.pickResultType===picker_1.PickResultType.COMPLETE){const e=t.subchannel,i=e.getMapEntry();if(i){let n=t.onCallEnded;return this.countCalls&&(n=e=>{var n;e===constants_1.Status.OK?i.counter.addSuccess():i.counter.addFailure(),null===(n=t.onCallEnded)||void 0===n||n.call(t,e)}),Object.assign(Object.assign({},t),{subchannel:e.getWrappedSubchannel(),onCallEnded:n})}return Object.assign(Object.assign({},t),{subchannel:e.getWrappedSubchannel()})}return t}}class OutlierDetectionLoadBalancer{constructor(e,t,i){this.entryMap=new subchannel_address_1.EndpointMap,this.latestConfig=null,this.timerStartTime=null,this.childBalancer=new load_balancer_child_handler_1.ChildLoadBalancerHandler((0,experimental_1.createChildChannelControlHelper)(e,{createSubchannel:(t,i,n)=>{const r=e.createSubchannel(t,i,n),c=this.entryMap.getForSubchannelAddress(t),a=new OutlierDetectionSubchannelWrapper(r,c);return null!==(null==c?void 0:c.currentEjectionTimestamp)&&a.eject(),null==c||c.subchannelWrappers.push(a),a},updateState:(t,i)=>{t===connectivity_state_1.ConnectivityState.READY?e.updateState(t,new OutlierDetectionPicker(i,this.isCountingEnabled())):e.updateState(t,i)}}),t,i),this.ejectionTimer=setInterval((()=>{}),0),clearInterval(this.ejectionTimer)}isCountingEnabled(){return null!==this.latestConfig&&(null!==this.latestConfig.getSuccessRateEjectionConfig()||null!==this.latestConfig.getFailurePercentageEjectionConfig())}getCurrentEjectionPercent(){let e=0;for(const t of this.entryMap.values())null!==t.currentEjectionTimestamp&&(e+=1);return 100*e/this.entryMap.size}runSuccessRateCheck(e){if(!this.latestConfig)return;const t=this.latestConfig.getSuccessRateEjectionConfig();if(!t)return;trace("Running success rate check");const i=t.request_volume;let n=0;const r=[];for(const[e,t]of this.entryMap.entries()){const c=t.counter.getLastSuccesses(),a=t.counter.getLastFailures();trace("Stats for "+(0,subchannel_address_1.endpointToString)(e)+": successes="+c+" failures="+a+" targetRequestVolume="+i),c+a>=i&&(n+=1,r.push(c/(c+a)))}if(trace("Found "+n+" success rate candidates; currentEjectionPercent="+this.getCurrentEjectionPercent()+" successRates=["+r+"]"),n<t.minimum_hosts)return;const c=r.reduce(((e,t)=>e+t))/r.length;let a=0;for(const e of r){const t=e-c;a+=t*t}const s=a/r.length,o=Math.sqrt(s),l=c-o*(t.stdev_factor/1e3);trace("stdev="+o+" ejectionThreshold="+l);for(const[n,r]of this.entryMap.entries()){if(this.getCurrentEjectionPercent()>=this.latestConfig.getMaxEjectionPercent())break;const c=r.counter.getLastSuccesses(),a=r.counter.getLastFailures();if(c+a<i)continue;const s=c/(c+a);if(trace("Checking candidate "+n+" successRate="+s),s<l){const i=100*Math.random();trace("Candidate "+n+" randomNumber="+i+" enforcement_percentage="+t.enforcement_percentage),i<t.enforcement_percentage&&(trace("Ejecting candidate "+n),this.eject(r,e))}}}runFailurePercentageCheck(e){if(!this.latestConfig)return;const t=this.latestConfig.getFailurePercentageEjectionConfig();if(!t)return;trace("Running failure percentage check. threshold="+t.threshold+" request volume threshold="+t.request_volume);let i=0;for(const e of this.entryMap.values()){e.counter.getLastSuccesses()+e.counter.getLastFailures()>=t.request_volume&&(i+=1)}if(!(i<t.minimum_hosts))for(const[i,n]of this.entryMap.entries()){if(this.getCurrentEjectionPercent()>=this.latestConfig.getMaxEjectionPercent())break;const r=n.counter.getLastSuccesses(),c=n.counter.getLastFailures();if(trace("Candidate successes="+r+" failures="+c),r+c<t.request_volume)continue;if(100*c/(c+r)>t.threshold){const r=100*Math.random();trace("Candidate "+i+" randomNumber="+r+" enforcement_percentage="+t.enforcement_percentage),r<t.enforcement_percentage&&(trace("Ejecting candidate "+i),this.eject(n,e))}}}eject(e,t){e.currentEjectionTimestamp=new Date,e.ejectionTimeMultiplier+=1;for(const t of e.subchannelWrappers)t.eject()}uneject(e){e.currentEjectionTimestamp=null;for(const t of e.subchannelWrappers)t.uneject()}switchAllBuckets(){for(const e of this.entryMap.values())e.counter.switchBuckets()}startTimer(e){var t,i;this.ejectionTimer=setTimeout((()=>this.runChecks()),e),null===(i=(t=this.ejectionTimer).unref)||void 0===i||i.call(t)}runChecks(){const e=new Date;if(trace("Ejection timer running"),this.switchAllBuckets(),this.latestConfig){this.timerStartTime=e,this.startTimer(this.latestConfig.getIntervalMs()),this.runSuccessRateCheck(e),this.runFailurePercentageCheck(e);for(const[e,t]of this.entryMap.entries())if(null===t.currentEjectionTimestamp)t.ejectionTimeMultiplier>0&&(t.ejectionTimeMultiplier-=1);else{const i=this.latestConfig.getBaseEjectionTimeMs(),n=this.latestConfig.getMaxEjectionTimeMs(),r=new Date(t.currentEjectionTimestamp.getTime());r.setMilliseconds(r.getMilliseconds()+Math.min(i*t.ejectionTimeMultiplier,Math.max(i,n))),r<new Date&&(trace("Unejecting "+e),this.uneject(t))}}}updateAddressList(e,t,i){if(!(t instanceof OutlierDetectionLoadBalancingConfig))return;for(const t of e)this.entryMap.has(t)||(trace("Adding map entry for "+(0,subchannel_address_1.endpointToString)(t)),this.entryMap.set(t,{counter:new CallCounter,currentEjectionTimestamp:null,ejectionTimeMultiplier:0,subchannelWrappers:[]}));this.entryMap.deleteMissing(e);const n=t.getChildPolicy();if(this.childBalancer.updateAddressList(e,n,i),t.getSuccessRateEjectionConfig()||t.getFailurePercentageEjectionConfig())if(this.timerStartTime){trace("Previous timer existed. Replacing timer"),clearTimeout(this.ejectionTimer);const e=t.getIntervalMs()-((new Date).getTime()-this.timerStartTime.getTime());this.startTimer(e)}else trace("Starting new timer"),this.timerStartTime=new Date,this.startTimer(t.getIntervalMs()),this.switchAllBuckets();else{trace("Counting disabled. Cancelling timer."),this.timerStartTime=null,clearTimeout(this.ejectionTimer);for(const e of this.entryMap.values())this.uneject(e),e.ejectionTimeMultiplier=0}this.latestConfig=t}exitIdle(){this.childBalancer.exitIdle()}resetBackoff(){this.childBalancer.resetBackoff()}destroy(){clearTimeout(this.ejectionTimer),this.childBalancer.destroy()}getTypeName(){return TYPE_NAME}}function setup(){OUTLIER_DETECTION_ENABLED&&(0,experimental_1.registerLoadBalancerType)(TYPE_NAME,OutlierDetectionLoadBalancer,OutlierDetectionLoadBalancingConfig)}exports.OutlierDetectionLoadBalancer=OutlierDetectionLoadBalancer,exports.setup=setup;