"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.setup=exports.LeafLoadBalancer=exports.PickFirstLoadBalancer=exports.shuffled=exports.PickFirstLoadBalancingConfig=void 0;const load_balancer_1=require("./load-balancer"),connectivity_state_1=require("./connectivity-state"),picker_1=require("./picker"),subchannel_address_1=require("./subchannel-address"),logging=require("./logging"),constants_1=require("./constants"),subchannel_address_2=require("./subchannel-address"),net_1=require("net"),TRACER_NAME="pick_first";function trace(t){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,t)}const TYPE_NAME="pick_first",CONNECTION_DELAY_INTERVAL_MS=250;class PickFirstLoadBalancingConfig{constructor(t){this.shuffleAddressList=t}getLoadBalancerName(){return TYPE_NAME}toJsonObject(){return{[TYPE_NAME]:{shuffleAddressList:this.shuffleAddressList}}}getShuffleAddressList(){return this.shuffleAddressList}static createFromJson(t){if("shuffleAddressList"in t&&"boolean"!=typeof t.shuffleAddressList)throw new Error("pick_first config field shuffleAddressList must be a boolean if provided");return new PickFirstLoadBalancingConfig(!0===t.shuffleAddressList)}}exports.PickFirstLoadBalancingConfig=PickFirstLoadBalancingConfig;class PickFirstPicker{constructor(t){this.subchannel=t}pick(t){return{pickResultType:picker_1.PickResultType.COMPLETE,subchannel:this.subchannel,status:null,onCallStarted:null,onCallEnded:null}}}function shuffled(t){const e=t.slice();for(let t=e.length-1;t>1;t--){const n=Math.floor(Math.random()*(t+1)),i=e[t];e[t]=e[n],e[n]=i}return e}function interleaveAddressFamilies(t){const e=[],n=[],i=[],s=(0,subchannel_address_2.isTcpSubchannelAddress)(t[0])&&(0,net_1.isIPv6)(t[0].host);for(const e of t)(0,subchannel_address_2.isTcpSubchannelAddress)(e)&&(0,net_1.isIPv6)(e.host)?n.push(e):i.push(e);const a=s?n:i,r=s?i:n;for(let t=0;t<Math.max(a.length,r.length);t++)t<a.length&&e.push(a[t]),t<r.length&&e.push(r[t]);return e}exports.shuffled=shuffled;const REPORT_HEALTH_STATUS_OPTION_NAME="grpc-node.internal.pick-first.report_health_status";class PickFirstLoadBalancer{constructor(t,e,n){this.channelControlHelper=t,this.children=[],this.currentState=connectivity_state_1.ConnectivityState.IDLE,this.currentSubchannelIndex=0,this.currentPick=null,this.subchannelStateListener=(t,e,n,i,s)=>{this.onSubchannelStateUpdate(t,e,n,s)},this.pickedSubchannelHealthListener=()=>this.calculateAndReportNewState(),this.stickyTransientFailureMode=!1,this.lastError=null,this.latestAddressList=null,this.connectionDelayTimeout=setTimeout((()=>{}),0),clearTimeout(this.connectionDelayTimeout),this.reportHealthStatus=n[REPORT_HEALTH_STATUS_OPTION_NAME]}allChildrenHaveReportedTF(){return this.children.every((t=>t.hasReportedTransientFailure))}resetChildrenReportedTF(){this.children.every((t=>t.hasReportedTransientFailure=!1))}calculateAndReportNewState(){this.currentPick?this.reportHealthStatus&&!this.currentPick.isHealthy()?this.updateState(connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE,new picker_1.UnavailablePicker({details:`Picked subchannel ${this.currentPick.getAddress()} is unhealthy`})):this.updateState(connectivity_state_1.ConnectivityState.READY,new PickFirstPicker(this.currentPick)):0===this.children.length?this.updateState(connectivity_state_1.ConnectivityState.IDLE,new picker_1.QueuePicker(this)):this.stickyTransientFailureMode?this.updateState(connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE,new picker_1.UnavailablePicker({details:`No connection established. Last error: ${this.lastError}`})):this.updateState(connectivity_state_1.ConnectivityState.CONNECTING,new picker_1.QueuePicker(this))}requestReresolution(){this.channelControlHelper.requestReresolution()}maybeEnterStickyTransientFailureMode(){if(this.allChildrenHaveReportedTF())if(this.requestReresolution(),this.resetChildrenReportedTF(),this.stickyTransientFailureMode)this.calculateAndReportNewState();else{this.stickyTransientFailureMode=!0;for(const{subchannel:t}of this.children)t.startConnecting();this.calculateAndReportNewState()}}removeCurrentPick(){null!==this.currentPick&&(this.currentPick.removeConnectivityStateListener(this.subchannelStateListener),this.channelControlHelper.removeChannelzChild(this.currentPick.getChannelzRef()),this.currentPick.removeHealthStateWatcher(this.pickedSubchannelHealthListener),this.currentPick.unref(),this.currentPick=null)}onSubchannelStateUpdate(t,e,n,i){var s;if(null===(s=this.currentPick)||void 0===s?void 0:s.realSubchannelEquals(t))n!==connectivity_state_1.ConnectivityState.READY&&(this.removeCurrentPick(),this.calculateAndReportNewState());else for(const[e,s]of this.children.entries())if(t.realSubchannelEquals(s.subchannel))return n===connectivity_state_1.ConnectivityState.READY&&this.pickSubchannel(s.subchannel),n===connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE&&(s.hasReportedTransientFailure=!0,i&&(this.lastError=i),this.maybeEnterStickyTransientFailureMode(),e===this.currentSubchannelIndex&&this.startNextSubchannelConnecting(e+1)),void s.subchannel.startConnecting()}startNextSubchannelConnecting(t){clearTimeout(this.connectionDelayTimeout);for(const[e,n]of this.children.entries())if(e>=t){const t=n.subchannel.getConnectivityState();if(t===connectivity_state_1.ConnectivityState.IDLE||t===connectivity_state_1.ConnectivityState.CONNECTING)return void this.startConnecting(e)}this.maybeEnterStickyTransientFailureMode()}startConnecting(t){var e,n;clearTimeout(this.connectionDelayTimeout),this.currentSubchannelIndex=t,this.children[t].subchannel.getConnectivityState()===connectivity_state_1.ConnectivityState.IDLE&&(trace("Start connecting to subchannel with address "+this.children[t].subchannel.getAddress()),process.nextTick((()=>{var e;null===(e=this.children[t])||void 0===e||e.subchannel.startConnecting()}))),this.connectionDelayTimeout=setTimeout((()=>{this.startNextSubchannelConnecting(t+1)}),250),null===(n=(e=this.connectionDelayTimeout).unref)||void 0===n||n.call(e)}pickSubchannel(t){trace("Pick subchannel with address "+t.getAddress()),this.stickyTransientFailureMode=!1,t.ref(),this.channelControlHelper.addChannelzChild(t.getChannelzRef()),this.removeCurrentPick(),this.resetSubchannelList(),t.addConnectivityStateListener(this.subchannelStateListener),t.addHealthStateWatcher(this.pickedSubchannelHealthListener),this.currentPick=t,clearTimeout(this.connectionDelayTimeout),this.calculateAndReportNewState()}updateState(t,e){trace(connectivity_state_1.ConnectivityState[this.currentState]+" -> "+connectivity_state_1.ConnectivityState[t]),this.currentState=t,this.channelControlHelper.updateState(t,e)}resetSubchannelList(){for(const t of this.children)t.subchannel.removeConnectivityStateListener(this.subchannelStateListener),t.subchannel.unref(),this.channelControlHelper.removeChannelzChild(t.subchannel.getChannelzRef());this.currentSubchannelIndex=0,this.children=[]}connectToAddressList(t){trace("connectToAddressList(["+t.map((t=>(0,subchannel_address_1.subchannelAddressToString)(t)))+"])");const e=t.map((t=>({subchannel:this.channelControlHelper.createSubchannel(t,{},null),hasReportedTransientFailure:!1})));for(const{subchannel:t}of e)if(t.getConnectivityState()===connectivity_state_1.ConnectivityState.READY)return void this.pickSubchannel(t);for(const{subchannel:t}of e)t.ref(),this.channelControlHelper.addChannelzChild(t.getChannelzRef());this.resetSubchannelList(),this.children=e;for(const{subchannel:t}of this.children)t.addConnectivityStateListener(this.subchannelStateListener);for(const t of this.children)t.subchannel.getConnectivityState()===connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE&&(t.hasReportedTransientFailure=!0);this.startNextSubchannelConnecting(0),this.calculateAndReportNewState()}updateAddressList(t,e){if(!(e instanceof PickFirstLoadBalancingConfig))return;e.getShuffleAddressList()&&(t=shuffled(t));const n=[].concat(...t.map((t=>t.addresses)));if(trace("updateAddressList(["+n.map((t=>(0,subchannel_address_1.subchannelAddressToString)(t)))+"])"),0===n.length)throw new Error("No addresses in endpoint list passed to pick_first");const i=interleaveAddressFamilies(n);this.latestAddressList=i,this.connectToAddressList(i)}exitIdle(){this.currentState===connectivity_state_1.ConnectivityState.IDLE&&this.latestAddressList&&this.connectToAddressList(this.latestAddressList)}resetBackoff(){}destroy(){this.resetSubchannelList(),this.removeCurrentPick()}getTypeName(){return TYPE_NAME}}exports.PickFirstLoadBalancer=PickFirstLoadBalancer;const LEAF_CONFIG=new PickFirstLoadBalancingConfig(!1);class LeafLoadBalancer{constructor(t,e,n,i){this.endpoint=t,this.latestState=connectivity_state_1.ConnectivityState.IDLE;const s=(0,load_balancer_1.createChildChannelControlHelper)(e,{updateState:(t,n)=>{this.latestState=t,this.latestPicker=n,e.updateState(t,n)}});this.pickFirstBalancer=new PickFirstLoadBalancer(s,n,Object.assign(Object.assign({},i),{[REPORT_HEALTH_STATUS_OPTION_NAME]:!0})),this.latestPicker=new picker_1.QueuePicker(this.pickFirstBalancer)}startConnecting(){this.pickFirstBalancer.updateAddressList([this.endpoint],LEAF_CONFIG)}updateEndpoint(t){this.endpoint=t,this.latestState!==connectivity_state_1.ConnectivityState.IDLE&&this.startConnecting()}getConnectivityState(){return this.latestState}getPicker(){return this.latestPicker}getEndpoint(){return this.endpoint}exitIdle(){this.pickFirstBalancer.exitIdle()}destroy(){this.pickFirstBalancer.destroy()}}function setup(){(0,load_balancer_1.registerLoadBalancerType)(TYPE_NAME,PickFirstLoadBalancer,PickFirstLoadBalancingConfig),(0,load_balancer_1.registerDefaultLoadBalancerType)(TYPE_NAME)}exports.LeafLoadBalancer=LeafLoadBalancer,exports.setup=setup;