"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.setup=exports.RoundRobinLoadBalancer=void 0;const load_balancer_1=require("./load-balancer"),connectivity_state_1=require("./connectivity-state"),picker_1=require("./picker"),logging=require("./logging"),constants_1=require("./constants"),subchannel_address_1=require("./subchannel-address"),load_balancer_pick_first_1=require("./load-balancer-pick-first"),TRACER_NAME="round_robin";function trace(t){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,t)}const TYPE_NAME="round_robin";class RoundRobinLoadBalancingConfig{getLoadBalancerName(){return TYPE_NAME}constructor(){}toJsonObject(){return{[TYPE_NAME]:{}}}static createFromJson(t){return new RoundRobinLoadBalancingConfig}}class RoundRobinPicker{constructor(t,e=0){this.children=t,this.nextIndex=e}pick(t){const e=this.children[this.nextIndex].picker;return this.nextIndex=(this.nextIndex+1)%this.children.length,e.pick(t)}peekNextEndpoint(){return this.children[this.nextIndex].endpoint}}class RoundRobinLoadBalancer{constructor(t,e,n){this.channelControlHelper=t,this.credentials=e,this.options=n,this.children=[],this.currentState=connectivity_state_1.ConnectivityState.IDLE,this.currentReadyPicker=null,this.updatesPaused=!1,this.lastError=null,this.childChannelControlHelper=(0,load_balancer_1.createChildChannelControlHelper)(t,{updateState:(t,e)=>{this.currentState===connectivity_state_1.ConnectivityState.READY&&t!==connectivity_state_1.ConnectivityState.READY&&this.channelControlHelper.requestReresolution(),this.calculateAndUpdateState()}})}countChildrenWithState(t){return this.children.filter((e=>e.getConnectivityState()===t)).length}calculateAndUpdateState(){if(!this.updatesPaused){if(this.countChildrenWithState(connectivity_state_1.ConnectivityState.READY)>0){const t=this.children.filter((t=>t.getConnectivityState()===connectivity_state_1.ConnectivityState.READY));let e=0;if(null!==this.currentReadyPicker){const n=this.currentReadyPicker.peekNextEndpoint();e=t.findIndex((t=>(0,subchannel_address_1.endpointEqual)(t.getEndpoint(),n))),e<0&&(e=0)}this.updateState(connectivity_state_1.ConnectivityState.READY,new RoundRobinPicker(t.map((t=>({endpoint:t.getEndpoint(),picker:t.getPicker()}))),e))}else this.countChildrenWithState(connectivity_state_1.ConnectivityState.CONNECTING)>0?this.updateState(connectivity_state_1.ConnectivityState.CONNECTING,new picker_1.QueuePicker(this)):this.countChildrenWithState(connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE)>0?this.updateState(connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE,new picker_1.UnavailablePicker({details:`No connection established. Last error: ${this.lastError}`})):this.updateState(connectivity_state_1.ConnectivityState.IDLE,new picker_1.QueuePicker(this));for(const t of this.children)t.getConnectivityState()===connectivity_state_1.ConnectivityState.IDLE&&t.exitIdle()}}updateState(t,e){trace(connectivity_state_1.ConnectivityState[this.currentState]+" -> "+connectivity_state_1.ConnectivityState[t]),t===connectivity_state_1.ConnectivityState.READY?this.currentReadyPicker=e:this.currentReadyPicker=null,this.currentState=t,this.channelControlHelper.updateState(t,e)}resetSubchannelList(){for(const t of this.children)t.destroy()}updateAddressList(t,e){this.resetSubchannelList(),trace("Connect to endpoint list "+t.map(subchannel_address_1.endpointToString)),this.updatesPaused=!0,this.children=t.map((t=>new load_balancer_pick_first_1.LeafLoadBalancer(t,this.childChannelControlHelper,this.credentials,this.options)));for(const t of this.children)t.startConnecting();this.updatesPaused=!1,this.calculateAndUpdateState()}exitIdle(){}resetBackoff(){}destroy(){this.resetSubchannelList()}getTypeName(){return TYPE_NAME}}function setup(){(0,load_balancer_1.registerLoadBalancerType)(TYPE_NAME,RoundRobinLoadBalancer,RoundRobinLoadBalancingConfig)}exports.RoundRobinLoadBalancer=RoundRobinLoadBalancer,exports.setup=setup;