"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.LoadBalancingCall=void 0;const connectivity_state_1=require("./connectivity-state"),constants_1=require("./constants"),deadline_1=require("./deadline"),metadata_1=require("./metadata"),picker_1=require("./picker"),uri_parser_1=require("./uri-parser"),logging=require("./logging"),control_plane_status_1=require("./control-plane-status"),http2=require("http2"),TRACER_NAME="load_balancing_call";class LoadBalancingCall{constructor(t,e,a,i,s,l,n){var d,c;this.channel=t,this.callConfig=e,this.methodName=a,this.host=i,this.credentials=s,this.deadline=l,this.callNumber=n,this.child=null,this.readPending=!1,this.pendingMessage=null,this.pendingHalfClose=!1,this.ended=!1,this.metadata=null,this.listener=null,this.onCallEnded=null,this.childStartTime=null;const o=this.methodName.split("/");let r="";o.length>=2&&(r=o[1]);const h=null!==(c=null===(d=(0,uri_parser_1.splitHostPort)(this.host))||void 0===d?void 0:d.host)&&void 0!==c?c:"localhost";this.serviceUrl=`https://${h}/${r}`,this.startTime=new Date}getDeadlineInfo(){var t,e;const a=[];return this.childStartTime?(this.childStartTime>this.startTime&&((null===(t=this.metadata)||void 0===t?void 0:t.getOptions().waitForReady)&&a.push("wait_for_ready"),a.push(`LB pick: ${(0,deadline_1.formatDateDifference)(this.startTime,this.childStartTime)}`)),a.push(...this.child.getDeadlineInfo()),a):((null===(e=this.metadata)||void 0===e?void 0:e.getOptions().waitForReady)&&a.push("wait_for_ready"),a.push("Waiting for LB pick"),a)}trace(t){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,"["+this.callNumber+"] "+t)}outputStatus(t,e){var a,i;if(!this.ended){this.ended=!0,this.trace("ended with status: code="+t.code+' details="'+t.details+'" start time='+this.startTime.toISOString());const s=Object.assign(Object.assign({},t),{progress:e});null===(a=this.listener)||void 0===a||a.onReceiveStatus(s),null===(i=this.onCallEnded)||void 0===i||i.call(this,s.code)}}doPick(){var t,e;if(this.ended)return;if(!this.metadata)throw new Error("doPick called before start");this.trace("Pick called");const a=this.metadata.clone(),i=this.channel.doPick(a,this.callConfig.pickInformation),s=i.subchannel?"("+i.subchannel.getChannelzRef().id+") "+i.subchannel.getAddress():""+i.subchannel;switch(this.trace("Pick result: "+picker_1.PickResultType[i.pickResultType]+" subchannel: "+s+" status: "+(null===(t=i.status)||void 0===t?void 0:t.code)+" "+(null===(e=i.status)||void 0===e?void 0:e.details)),i.pickResultType){case picker_1.PickResultType.COMPLETE:this.credentials.generateMetadata({method_name:this.methodName,service_url:this.serviceUrl}).then((t=>{var e,l,n;if(this.ended)this.trace("Credentials metadata generation finished after call ended");else{if(a.merge(t),a.get("authorization").length>1&&this.outputStatus({code:constants_1.Status.INTERNAL,details:'"authorization" metadata cannot have multiple values',metadata:new metadata_1.Metadata},"PROCESSED"),i.subchannel.getConnectivityState()!==connectivity_state_1.ConnectivityState.READY)return this.trace("Picked subchannel "+s+" has state "+connectivity_state_1.ConnectivityState[i.subchannel.getConnectivityState()]+" after getting credentials metadata. Retrying pick"),void this.doPick();this.deadline!==1/0&&a.set("grpc-timeout",(0,deadline_1.getDeadlineTimeoutString)(this.deadline));try{this.child=i.subchannel.getRealSubchannel().createCall(a,this.host,this.methodName,{onReceiveMetadata:t=>{this.trace("Received metadata"),this.listener.onReceiveMetadata(t)},onReceiveMessage:t=>{this.trace("Received message"),this.listener.onReceiveMessage(t)},onReceiveStatus:t=>{this.trace("Received status"),t.rstCode===http2.constants.NGHTTP2_REFUSED_STREAM?this.outputStatus(t,"REFUSED"):this.outputStatus(t,"PROCESSED")}}),this.childStartTime=new Date}catch(t){return this.trace("Failed to start call on picked subchannel "+s+" with error "+t.message),void this.outputStatus({code:constants_1.Status.INTERNAL,details:"Failed to start HTTP/2 stream with error "+t.message,metadata:new metadata_1.Metadata},"NOT_STARTED")}null===(l=(e=this.callConfig).onCommitted)||void 0===l||l.call(e),null===(n=i.onCallStarted)||void 0===n||n.call(i),this.onCallEnded=i.onCallEnded,this.trace("Created child call ["+this.child.getCallNumber()+"]"),this.readPending&&this.child.startRead(),this.pendingMessage&&this.child.sendMessageWithContext(this.pendingMessage.context,this.pendingMessage.message),this.pendingHalfClose&&this.child.halfClose()}}),(t=>{const{code:e,details:a}=(0,control_plane_status_1.restrictControlPlaneStatusCode)("number"==typeof t.code?t.code:constants_1.Status.UNKNOWN,`Getting metadata from plugin failed with error: ${t.message}`);this.outputStatus({code:e,details:a,metadata:new metadata_1.Metadata},"PROCESSED")}));break;case picker_1.PickResultType.DROP:const{code:t,details:e}=(0,control_plane_status_1.restrictControlPlaneStatusCode)(i.status.code,i.status.details);setImmediate((()=>{this.outputStatus({code:t,details:e,metadata:i.status.metadata},"DROP")}));break;case picker_1.PickResultType.TRANSIENT_FAILURE:if(this.metadata.getOptions().waitForReady)this.channel.queueCallForPick(this);else{const{code:t,details:e}=(0,control_plane_status_1.restrictControlPlaneStatusCode)(i.status.code,i.status.details);setImmediate((()=>{this.outputStatus({code:t,details:e,metadata:i.status.metadata},"PROCESSED")}))}break;case picker_1.PickResultType.QUEUE:this.channel.queueCallForPick(this)}}cancelWithStatus(t,e){var a;this.trace("cancelWithStatus code: "+t+' details: "'+e+'"'),null===(a=this.child)||void 0===a||a.cancelWithStatus(t,e),this.outputStatus({code:t,details:e,metadata:new metadata_1.Metadata},"PROCESSED")}getPeer(){var t,e;return null!==(e=null===(t=this.child)||void 0===t?void 0:t.getPeer())&&void 0!==e?e:this.channel.getTarget()}start(t,e){this.trace("start called"),this.listener=e,this.metadata=t,this.doPick()}sendMessageWithContext(t,e){this.trace("write() called with message of length "+e.length),this.child?this.child.sendMessageWithContext(t,e):this.pendingMessage={context:t,message:e}}startRead(){this.trace("startRead called"),this.child?this.child.startRead():this.readPending=!0}halfClose(){this.trace("halfClose called"),this.child?this.child.halfClose():this.pendingHalfClose=!0}setCredentials(t){throw new Error("Method not implemented.")}getCallNumber(){return this.callNumber}}exports.LoadBalancingCall=LoadBalancingCall;