"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Metadata=void 0;const logging_1=require("./logging"),constants_1=require("./constants"),error_1=require("./error"),LEGAL_KEY_REGEX=/^[0-9a-z_.-]+$/,LEGAL_NON_BINARY_VALUE_REGEX=/^[ -~]*$/;function isLegalKey(t){return LEGAL_KEY_REGEX.test(t)}function isLegalNonBinaryValue(t){return LEGAL_NON_BINARY_VALUE_REGEX.test(t)}function isBinaryKey(t){return t.endsWith("-bin")}function isCustomMetadata(t){return!t.startsWith("grpc-")}function normalizeKey(t){return t.toLowerCase()}function validate(t,e){if(!isLegalKey(t))throw new Error('Metadata key "'+t+'" contains illegal characters');if(null!=e)if(isBinaryKey(t)){if(!Buffer.isBuffer(e))throw new Error("keys that end with '-bin' must have Buffer values")}else{if(Buffer.isBuffer(e))throw new Error("keys that don't end with '-bin' must have String values");if(!isLegalNonBinaryValue(e))throw new Error('Metadata string value "'+e+'" contains illegal characters')}}class Metadata{constructor(t={}){this.internalRepr=new Map,this.options=t}set(t,e){validate(t=normalizeKey(t),e),this.internalRepr.set(t,[e])}add(t,e){validate(t=normalizeKey(t),e);const r=this.internalRepr.get(t);void 0===r?this.internalRepr.set(t,[e]):r.push(e)}remove(t){t=normalizeKey(t),this.internalRepr.delete(t)}get(t){return t=normalizeKey(t),this.internalRepr.get(t)||[]}getMap(){const t={};for(const[e,r]of this.internalRepr)if(r.length>0){const n=r[0];t[e]=Buffer.isBuffer(n)?Buffer.from(n):n}return t}clone(){const t=new Metadata(this.options),e=t.internalRepr;for(const[t,r]of this.internalRepr){const n=r.map((t=>Buffer.isBuffer(t)?Buffer.from(t):t));e.set(t,n)}return t}merge(t){for(const[e,r]of t.internalRepr){const t=(this.internalRepr.get(e)||[]).concat(r);this.internalRepr.set(e,t)}}setOptions(t){this.options=t}getOptions(){return this.options}toHttp2Headers(){const t={};for(const[e,r]of this.internalRepr)t[e]=r.map(bufToString);return t}toJSON(){const t={};for(const[e,r]of this.internalRepr)t[e]=r;return t}static fromHttp2Headers(t){const e=new Metadata;for(const r of Object.keys(t)){if(":"===r.charAt(0))continue;const n=t[r];try{isBinaryKey(r)?Array.isArray(n)?n.forEach((t=>{e.add(r,Buffer.from(t,"base64"))})):void 0!==n&&(isCustomMetadata(r)?n.split(",").forEach((t=>{e.add(r,Buffer.from(t.trim(),"base64"))})):e.add(r,Buffer.from(n,"base64"))):Array.isArray(n)?n.forEach((t=>{e.add(r,t)})):void 0!==n&&e.add(r,n)}catch(t){const e=`Failed to add metadata entry ${r}: ${n}. ${(0,error_1.getErrorMessage)(t)}. For more information see https://github.com/grpc/grpc-node/issues/1173`;(0,logging_1.log)(constants_1.LogVerbosity.ERROR,e)}}return e}}exports.Metadata=Metadata;const bufToString=t=>Buffer.isBuffer(t)?t.toString("base64"):t;