"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.setup=exports.DEFAULT_PORT=void 0;const resolver_1=require("./resolver"),dns_1=require("dns"),service_config_1=require("./service-config"),constants_1=require("./constants"),metadata_1=require("./metadata"),logging=require("./logging"),constants_2=require("./constants"),uri_parser_1=require("./uri-parser"),net_1=require("net"),backoff_timeout_1=require("./backoff-timeout"),environment_1=require("./environment"),TRACER_NAME="dns_resolver";function trace(t){logging.trace(constants_2.LogVerbosity.DEBUG,TRACER_NAME,t)}exports.DEFAULT_PORT=443;const DEFAULT_MIN_TIME_BETWEEN_RESOLUTIONS_MS=3e4;class DnsResolver{constructor(t,e,s){var i,o,r;this.target=t,this.listener=e,this.pendingLookupPromise=null,this.pendingTxtPromise=null,this.latestLookupResult=null,this.latestServiceConfig=null,this.latestServiceConfigError=null,this.continueResolving=!1,this.isNextResolutionTimerRunning=!1,this.isServiceConfigEnabled=!0,this.returnedIpResult=!1,this.alternativeResolver=new dns_1.promises.Resolver,trace("Resolver constructed for target "+(0,uri_parser_1.uriToString)(t)),t.authority&&this.alternativeResolver.setServers([t.authority]);const n=(0,uri_parser_1.splitHostPort)(t.path);null===n?(this.ipResult=null,this.dnsHostname=null,this.port=null):(0,net_1.isIPv4)(n.host)||(0,net_1.isIPv6)(n.host)?(this.ipResult=[{addresses:[{host:n.host,port:null!==(i=n.port)&&void 0!==i?i:exports.DEFAULT_PORT}]}],this.dnsHostname=null,this.port=null):(this.ipResult=null,this.dnsHostname=n.host,this.port=null!==(o=n.port)&&void 0!==o?o:exports.DEFAULT_PORT),this.percentage=100*Math.random(),1===s["grpc.service_config_disable_resolution"]&&(this.isServiceConfigEnabled=!1),this.defaultResolutionError={code:constants_1.Status.UNAVAILABLE,details:`Name resolution failed for target ${(0,uri_parser_1.uriToString)(this.target)}`,metadata:new metadata_1.Metadata};const l={initialDelay:s["grpc.initial_reconnect_backoff_ms"],maxDelay:s["grpc.max_reconnect_backoff_ms"]};this.backoff=new backoff_timeout_1.BackoffTimeout((()=>{this.continueResolving&&this.startResolutionWithBackoff()}),l),this.backoff.unref(),this.minTimeBetweenResolutionsMs=null!==(r=s["grpc.dns_min_time_between_resolutions_ms"])&&void 0!==r?r:3e4,this.nextResolutionTimer=setTimeout((()=>{}),0),clearTimeout(this.nextResolutionTimer)}startResolution(){if(null!==this.ipResult)return this.returnedIpResult||(trace("Returning IP address for target "+(0,uri_parser_1.uriToString)(this.target)),setImmediate((()=>{this.listener.onSuccessfulResolution(this.ipResult,null,null,null,{})})),this.returnedIpResult=!0),this.backoff.stop(),this.backoff.reset(),void this.stopNextResolutionTimer();if(null===this.dnsHostname)trace("Failed to parse DNS address "+(0,uri_parser_1.uriToString)(this.target)),setImmediate((()=>{this.listener.onError({code:constants_1.Status.UNAVAILABLE,details:`Failed to parse DNS address ${(0,uri_parser_1.uriToString)(this.target)}`,metadata:new metadata_1.Metadata})})),this.stopNextResolutionTimer();else{if(null!==this.pendingLookupPromise)return;trace("Looking up DNS hostname "+this.dnsHostname),this.latestLookupResult=null;const t=this.dnsHostname;this.pendingLookupPromise=this.lookup(t),this.pendingLookupPromise.then((t=>{if(null===this.pendingLookupPromise)return;this.pendingLookupPromise=null,this.backoff.reset(),this.backoff.stop(),this.latestLookupResult=t.map((t=>({addresses:[t]})));const e="["+t.map((t=>t.host+":"+t.port)).join(",")+"]";trace("Resolved addresses for target "+(0,uri_parser_1.uriToString)(this.target)+": "+e),0!==this.latestLookupResult.length?this.listener.onSuccessfulResolution(this.latestLookupResult,this.latestServiceConfig,this.latestServiceConfigError,null,{}):this.listener.onError(this.defaultResolutionError)}),(t=>{null!==this.pendingLookupPromise&&(trace("Resolution error for target "+(0,uri_parser_1.uriToString)(this.target)+": "+t.message),this.pendingLookupPromise=null,this.stopNextResolutionTimer(),this.listener.onError(this.defaultResolutionError))})),this.isServiceConfigEnabled&&null===this.pendingTxtPromise&&(this.pendingTxtPromise=this.resolveTxt(t),this.pendingTxtPromise.then((t=>{if(null!==this.pendingTxtPromise){this.pendingTxtPromise=null;try{this.latestServiceConfig=(0,service_config_1.extractAndSelectServiceConfig)(t,this.percentage)}catch(t){this.latestServiceConfigError={code:constants_1.Status.UNAVAILABLE,details:`Parsing service config failed with error ${t.message}`,metadata:new metadata_1.Metadata}}null!==this.latestLookupResult&&this.listener.onSuccessfulResolution(this.latestLookupResult,this.latestServiceConfig,this.latestServiceConfigError,null,{})}}),(t=>{})))}}async lookup(t){if(environment_1.GRPC_NODE_USE_ALTERNATIVE_RESOLVER){trace("Using alternative DNS resolver.");const e=await Promise.allSettled([this.alternativeResolver.resolve4(t),this.alternativeResolver.resolve6(t)]);if(e.every((t=>"rejected"===t.status)))throw new Error(e[0].reason);return e.reduce(((t,e)=>"fulfilled"===e.status?[...t,...e.value]:t),[]).map((t=>({host:t,port:+this.port})))}return(await dns_1.promises.lookup(t,{all:!0})).map((t=>({host:t.address,port:+this.port})))}async resolveTxt(t){return environment_1.GRPC_NODE_USE_ALTERNATIVE_RESOLVER?(trace("Using alternative DNS resolver."),this.alternativeResolver.resolveTxt(t)):dns_1.promises.resolveTxt(t)}startNextResolutionTimer(){var t,e;clearTimeout(this.nextResolutionTimer),this.nextResolutionTimer=setTimeout((()=>{this.stopNextResolutionTimer(),this.continueResolving&&this.startResolutionWithBackoff()}),this.minTimeBetweenResolutionsMs),null===(e=(t=this.nextResolutionTimer).unref)||void 0===e||e.call(t),this.isNextResolutionTimerRunning=!0}stopNextResolutionTimer(){clearTimeout(this.nextResolutionTimer),this.isNextResolutionTimerRunning=!1}startResolutionWithBackoff(){null===this.pendingLookupPromise&&(this.continueResolving=!1,this.backoff.runOnce(),this.startNextResolutionTimer(),this.startResolution())}updateResolution(){null===this.pendingLookupPromise&&(this.isNextResolutionTimerRunning||this.backoff.isRunning()?(this.isNextResolutionTimerRunning?trace('resolution update delayed by "min time between resolutions" rate limit'):trace("resolution update delayed by backoff timer until "+this.backoff.getEndTime().toISOString()),this.continueResolving=!0):this.startResolutionWithBackoff())}destroy(){this.continueResolving=!1,this.backoff.reset(),this.backoff.stop(),this.stopNextResolutionTimer(),this.pendingLookupPromise=null,this.pendingTxtPromise=null,this.latestLookupResult=null,this.latestServiceConfig=null,this.latestServiceConfigError=null,this.returnedIpResult=!1}static getDefaultAuthority(t){return t.path}}function setup(){(0,resolver_1.registerResolver)("dns",DnsResolver),(0,resolver_1.registerDefaultScheme)("dns")}exports.setup=setup;