"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.setup=void 0;const net_1=require("net"),constants_1=require("./constants"),metadata_1=require("./metadata"),resolver_1=require("./resolver"),uri_parser_1=require("./uri-parser"),logging=require("./logging"),TRACER_NAME="ip_resolver";function trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,e)}const IPV4_SCHEME="ipv4",IPV6_SCHEME="ipv6",DEFAULT_PORT=443;class IpResolver{constructor(e,t,s){var r;this.listener=t,this.endpoints=[],this.error=null,this.hasReturnedResult=!1,trace("Resolver constructed for target "+(0,uri_parser_1.uriToString)(e));const o=[];if("ipv4"!==e.scheme&&"ipv6"!==e.scheme)return void(this.error={code:constants_1.Status.UNAVAILABLE,details:`Unrecognized scheme ${e.scheme} in IP resolver`,metadata:new metadata_1.Metadata});const i=e.path.split(",");for(const t of i){const s=(0,uri_parser_1.splitHostPort)(t);if(null===s)return void(this.error={code:constants_1.Status.UNAVAILABLE,details:`Failed to parse ${e.scheme} address ${t}`,metadata:new metadata_1.Metadata});if("ipv4"===e.scheme&&!(0,net_1.isIPv4)(s.host)||"ipv6"===e.scheme&&!(0,net_1.isIPv6)(s.host))return void(this.error={code:constants_1.Status.UNAVAILABLE,details:`Failed to parse ${e.scheme} address ${t}`,metadata:new metadata_1.Metadata});o.push({host:s.host,port:null!==(r=s.port)&&void 0!==r?r:443})}this.endpoints=o.map((e=>({addresses:[e]}))),trace("Parsed "+e.scheme+" address list "+o)}updateResolution(){this.hasReturnedResult||(this.hasReturnedResult=!0,process.nextTick((()=>{this.error?this.listener.onError(this.error):this.listener.onSuccessfulResolution(this.endpoints,null,null,null,{})})))}destroy(){this.hasReturnedResult=!1}static getDefaultAuthority(e){return e.path.split(",")[0]}}function setup(){(0,resolver_1.registerResolver)("ipv4",IpResolver),(0,resolver_1.registerResolver)("ipv6",IpResolver)}exports.setup=setup;