"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ResolvingCall=void 0;const constants_1=require("./constants"),deadline_1=require("./deadline"),metadata_1=require("./metadata"),logging=require("./logging"),control_plane_status_1=require("./control-plane-status"),TRACER_NAME="resolving_call";class ResolvingCall{constructor(e,t,i,s,a,n){this.channel=e,this.method=t,this.filterStackFactory=s,this.credentials=a,this.callNumber=n,this.child=null,this.readPending=!1,this.pendingMessage=null,this.pendingHalfClose=!1,this.ended=!1,this.readFilterPending=!1,this.writeFilterPending=!1,this.pendingChildStatus=null,this.metadata=null,this.listener=null,this.statusWatchers=[],this.deadlineTimer=setTimeout((()=>{}),0),this.filterStack=null,this.deadlineStartTime=null,this.configReceivedTime=null,this.childStartTime=null,this.deadline=i.deadline,this.host=i.host,i.parentCall&&(i.flags&constants_1.Propagate.CANCELLATION&&i.parentCall.on("cancelled",(()=>{this.cancelWithStatus(constants_1.Status.CANCELLED,"Cancelled by parent call")})),i.flags&constants_1.Propagate.DEADLINE&&(this.trace("Propagating deadline from parent: "+i.parentCall.getDeadline()),this.deadline=(0,deadline_1.minDeadline)(this.deadline,i.parentCall.getDeadline()))),this.trace("Created"),this.runDeadlineTimer()}trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,"["+this.callNumber+"] "+e)}runDeadlineTimer(){clearTimeout(this.deadlineTimer),this.deadlineStartTime=new Date,this.trace("Deadline: "+(0,deadline_1.deadlineToString)(this.deadline));const e=(0,deadline_1.getRelativeTimeout)(this.deadline);if(e!==1/0){this.trace("Deadline will be reached in "+e+"ms");const t=()=>{if(!this.deadlineStartTime)return void this.cancelWithStatus(constants_1.Status.DEADLINE_EXCEEDED,"Deadline exceeded");const e=[],t=new Date;e.push(`Deadline exceeded after ${(0,deadline_1.formatDateDifference)(this.deadlineStartTime,t)}`),this.configReceivedTime?(this.configReceivedTime>this.deadlineStartTime&&e.push(`name resolution: ${(0,deadline_1.formatDateDifference)(this.deadlineStartTime,this.configReceivedTime)}`),this.childStartTime?this.childStartTime>this.configReceivedTime&&e.push(`metadata filters: ${(0,deadline_1.formatDateDifference)(this.configReceivedTime,this.childStartTime)}`):e.push("waiting for metadata filters")):e.push("waiting for name resolution"),this.child&&e.push(...this.child.getDeadlineInfo()),this.cancelWithStatus(constants_1.Status.DEADLINE_EXCEEDED,e.join(","))};e<=0?process.nextTick(t):this.deadlineTimer=setTimeout(t,e)}}outputStatus(e){if(!this.ended){this.ended=!0,this.filterStack||(this.filterStack=this.filterStackFactory.createFilter()),clearTimeout(this.deadlineTimer);const t=this.filterStack.receiveTrailers(e);this.trace("ended with status: code="+t.code+' details="'+t.details+'"'),this.statusWatchers.forEach((e=>e(t))),process.nextTick((()=>{var e;null===(e=this.listener)||void 0===e||e.onReceiveStatus(t)}))}}sendMessageOnChild(e,t){if(!this.child)throw new Error("sendMessageonChild called with child not populated");const i=this.child;this.writeFilterPending=!0,this.filterStack.sendMessage(Promise.resolve({message:t,flags:e.flags})).then((t=>{this.writeFilterPending=!1,i.sendMessageWithContext(e,t.message),this.pendingHalfClose&&i.halfClose()}),(e=>{this.cancelWithStatus(e.code,e.details)}))}getConfig(){if(this.ended)return;if(!this.metadata||!this.listener)throw new Error("getConfig called before start");const e=this.channel.getConfig(this.method,this.metadata);if("NONE"===e.type)return void this.channel.queueCallForConfig(this);if("ERROR"===e.type)return void(this.metadata.getOptions().waitForReady?this.channel.queueCallForConfig(this):this.outputStatus(e.error));this.configReceivedTime=new Date;const t=e.config;if(t.status===constants_1.Status.OK){if(t.methodConfig.timeout){const e=new Date;e.setSeconds(e.getSeconds()+t.methodConfig.timeout.seconds),e.setMilliseconds(e.getMilliseconds()+t.methodConfig.timeout.nanos/1e6),this.deadline=(0,deadline_1.minDeadline)(this.deadline,e),this.runDeadlineTimer()}this.filterStackFactory.push(t.dynamicFilterFactories),this.filterStack=this.filterStackFactory.createFilter(),this.filterStack.sendMetadata(Promise.resolve(this.metadata)).then((e=>{this.child=this.channel.createInnerCall(t,this.method,this.host,this.credentials,this.deadline),this.trace("Created child ["+this.child.getCallNumber()+"]"),this.childStartTime=new Date,this.child.start(e,{onReceiveMetadata:e=>{this.trace("Received metadata"),this.listener.onReceiveMetadata(this.filterStack.receiveMetadata(e))},onReceiveMessage:e=>{this.trace("Received message"),this.readFilterPending=!0,this.filterStack.receiveMessage(e).then((e=>{this.trace("Finished filtering received message"),this.readFilterPending=!1,this.listener.onReceiveMessage(e),this.pendingChildStatus&&this.outputStatus(this.pendingChildStatus)}),(e=>{this.cancelWithStatus(e.code,e.details)}))},onReceiveStatus:e=>{this.trace("Received status"),this.readFilterPending?this.pendingChildStatus=e:this.outputStatus(e)}}),this.readPending&&this.child.startRead(),this.pendingMessage?this.sendMessageOnChild(this.pendingMessage.context,this.pendingMessage.message):this.pendingHalfClose&&this.child.halfClose()}),(e=>{this.outputStatus(e)}))}else{const{code:e,details:i}=(0,control_plane_status_1.restrictControlPlaneStatusCode)(t.status,"Failed to route call to method "+this.method);this.outputStatus({code:e,details:i,metadata:new metadata_1.Metadata})}}reportResolverError(e){var t;(null===(t=this.metadata)||void 0===t?void 0:t.getOptions().waitForReady)?this.channel.queueCallForConfig(this):this.outputStatus(e)}cancelWithStatus(e,t){var i;this.trace("cancelWithStatus code: "+e+' details: "'+t+'"'),null===(i=this.child)||void 0===i||i.cancelWithStatus(e,t),this.outputStatus({code:e,details:t,metadata:new metadata_1.Metadata})}getPeer(){var e,t;return null!==(t=null===(e=this.child)||void 0===e?void 0:e.getPeer())&&void 0!==t?t:this.channel.getTarget()}start(e,t){this.trace("start called"),this.metadata=e.clone(),this.listener=t,this.getConfig()}sendMessageWithContext(e,t){this.trace("write() called with message of length "+t.length),this.child?this.sendMessageOnChild(e,t):this.pendingMessage={context:e,message:t}}startRead(){this.trace("startRead called"),this.child?this.child.startRead():this.readPending=!0}halfClose(){this.trace("halfClose called"),this.child&&!this.writeFilterPending?this.child.halfClose():this.pendingHalfClose=!0}setCredentials(e){this.credentials=this.credentials.compose(e)}addStatusWatcher(e){this.statusWatchers.push(e)}getCallNumber(){return this.callNumber}}exports.ResolvingCall=ResolvingCall;