"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ResolvingLoadBalancer=void 0;const load_balancer_1=require("./load-balancer"),service_config_1=require("./service-config"),connectivity_state_1=require("./connectivity-state"),resolver_1=require("./resolver"),picker_1=require("./picker"),backoff_timeout_1=require("./backoff-timeout"),constants_1=require("./constants"),metadata_1=require("./metadata"),logging=require("./logging"),constants_2=require("./constants"),uri_parser_1=require("./uri-parser"),load_balancer_child_handler_1=require("./load-balancer-child-handler"),TRACER_NAME="resolving_load_balancer";function trace(t){logging.trace(constants_2.LogVerbosity.DEBUG,TRACER_NAME,t)}const NAME_MATCH_LEVEL_ORDER=["SERVICE_AND_METHOD","SERVICE","EMPTY"];function hasMatchingName(t,e,i,n){for(const o of i.name)switch(n){case"EMPTY":if(!o.service&&!o.method)return!0;break;case"SERVICE":if(o.service===t&&!o.method)return!0;break;case"SERVICE_AND_METHOD":if(o.service===t&&o.method===e)return!0}return!1}function findMatchingConfig(t,e,i,n){for(const o of i)if(hasMatchingName(t,e,o,n))return o;return null}function getDefaultConfigSelector(t){return function(e,i){var n,o;const a=e.split("/").filter((t=>t.length>0)),s=null!==(n=a[0])&&void 0!==n?n:"",r=null!==(o=a[1])&&void 0!==o?o:"";if(t&&t.methodConfig)for(const e of NAME_MATCH_LEVEL_ORDER){const i=findMatchingConfig(s,r,t.methodConfig,e);if(i)return{methodConfig:i,pickInformation:{},status:constants_1.Status.OK,dynamicFilterFactories:[]}}return{methodConfig:{name:[]},pickInformation:{},status:constants_1.Status.OK,dynamicFilterFactories:[]}}}class ResolvingLoadBalancer{constructor(t,e,i,n,o,a){this.target=t,this.channelControlHelper=e,this.onSuccessfulResolution=o,this.onFailedResolution=a,this.latestChildState=connectivity_state_1.ConnectivityState.IDLE,this.latestChildPicker=new picker_1.QueuePicker(this),this.currentState=connectivity_state_1.ConnectivityState.IDLE,this.previousServiceConfig=null,this.continueResolving=!1,n["grpc.service_config"]?this.defaultServiceConfig=(0,service_config_1.validateServiceConfig)(JSON.parse(n["grpc.service_config"])):this.defaultServiceConfig={loadBalancingConfig:[],methodConfig:[]},this.updateState(connectivity_state_1.ConnectivityState.IDLE,new picker_1.QueuePicker(this)),this.childLoadBalancer=new load_balancer_child_handler_1.ChildLoadBalancerHandler({createSubchannel:e.createSubchannel.bind(e),requestReresolution:()=>{this.backoffTimeout.isRunning()?(trace("requestReresolution delayed by backoff timer until "+this.backoffTimeout.getEndTime().toISOString()),this.continueResolving=!0):this.updateResolution()},updateState:(t,e)=>{this.latestChildState=t,this.latestChildPicker=e,this.updateState(t,e)},addChannelzChild:e.addChannelzChild.bind(e),removeChannelzChild:e.removeChannelzChild.bind(e)},i,n),this.innerResolver=(0,resolver_1.createResolver)(t,{onSuccessfulResolution:(t,e,i,n,o)=>{var a;this.backoffTimeout.stop(),this.backoffTimeout.reset();let s=null;null===e?null===i?(this.previousServiceConfig=null,s=this.defaultServiceConfig):null===this.previousServiceConfig?this.handleResolutionFailure(i):s=this.previousServiceConfig:(s=e,this.previousServiceConfig=e);const r=null!==(a=null==s?void 0:s.loadBalancingConfig)&&void 0!==a?a:[],c=(0,load_balancer_1.selectLbConfigFromList)(r,!0);if(null===c)return void this.handleResolutionFailure({code:constants_1.Status.UNAVAILABLE,details:"All load balancer options in service config are not compatible",metadata:new metadata_1.Metadata});this.childLoadBalancer.updateAddressList(t,c,o);const l=null!=s?s:this.defaultServiceConfig;this.onSuccessfulResolution(l,null!=n?n:getDefaultConfigSelector(l))},onError:t=>{this.handleResolutionFailure(t)}},n);const s={initialDelay:n["grpc.initial_reconnect_backoff_ms"],maxDelay:n["grpc.max_reconnect_backoff_ms"]};this.backoffTimeout=new backoff_timeout_1.BackoffTimeout((()=>{this.continueResolving?(this.updateResolution(),this.continueResolving=!1):this.updateState(this.latestChildState,this.latestChildPicker)}),s),this.backoffTimeout.unref()}updateResolution(){this.innerResolver.updateResolution(),this.currentState===connectivity_state_1.ConnectivityState.IDLE&&this.updateState(connectivity_state_1.ConnectivityState.CONNECTING,this.latestChildPicker),this.backoffTimeout.runOnce()}updateState(t,e){trace((0,uri_parser_1.uriToString)(this.target)+" "+connectivity_state_1.ConnectivityState[this.currentState]+" -> "+connectivity_state_1.ConnectivityState[t]),t===connectivity_state_1.ConnectivityState.IDLE&&(e=new picker_1.QueuePicker(this,e)),this.currentState=t,this.channelControlHelper.updateState(t,e)}handleResolutionFailure(t){this.latestChildState===connectivity_state_1.ConnectivityState.IDLE&&(this.updateState(connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE,new picker_1.UnavailablePicker(t)),this.onFailedResolution(t))}exitIdle(){this.currentState!==connectivity_state_1.ConnectivityState.IDLE&&this.currentState!==connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE||(this.backoffTimeout.isRunning()?this.continueResolving=!0:this.updateResolution()),this.childLoadBalancer.exitIdle()}updateAddressList(t,e){throw new Error("updateAddressList not supported on ResolvingLoadBalancer")}resetBackoff(){this.backoffTimeout.reset(),this.childLoadBalancer.resetBackoff()}destroy(){this.childLoadBalancer.destroy(),this.innerResolver.destroy(),this.backoffTimeout.reset(),this.backoffTimeout.stop(),this.latestChildState=connectivity_state_1.ConnectivityState.IDLE,this.latestChildPicker=new picker_1.QueuePicker(this),this.currentState=connectivity_state_1.ConnectivityState.IDLE,this.previousServiceConfig=null,this.continueResolving=!1}getTypeName(){return"resolving_load_balancer"}}exports.ResolvingLoadBalancer=ResolvingLoadBalancer;