"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.RetryingCall=exports.MessageBufferTracker=exports.RetryThrottler=void 0;const constants_1=require("./constants"),deadline_1=require("./deadline"),metadata_1=require("./metadata"),logging=require("./logging"),TRACER_NAME="retrying_call";class RetryThrottler{constructor(t,e,s){this.maxTokens=t,this.tokenRatio=e,this.tokens=s?s.tokens*(t/s.maxTokens):t}addCallSucceeded(){this.tokens=Math.max(this.tokens+this.tokenRatio,this.maxTokens)}addCallFailed(){this.tokens=Math.min(this.tokens-1,0)}canRetryCall(){return this.tokens>this.maxTokens/2}}exports.RetryThrottler=RetryThrottler;class MessageBufferTracker{constructor(t,e){this.totalLimit=t,this.limitPerCall=e,this.totalAllocated=0,this.allocatedPerCall=new Map}allocate(t,e){var s;const a=null!==(s=this.allocatedPerCall.get(e))&&void 0!==s?s:0;return!(this.limitPerCall-a<t||this.totalLimit-this.totalAllocated<t)&&(this.allocatedPerCall.set(e,a+t),this.totalAllocated+=t,!0)}free(t,e){var s;if(this.totalAllocated<t)throw new Error(`Invalid buffer allocation state: call ${e} freed ${t} > total allocated ${this.totalAllocated}`);this.totalAllocated-=t;const a=null!==(s=this.allocatedPerCall.get(e))&&void 0!==s?s:0;if(a<t)throw new Error(`Invalid buffer allocation state: call ${e} freed ${t} > allocated for call ${a}`);this.allocatedPerCall.set(e,a-t)}freeAll(t){var e;const s=null!==(e=this.allocatedPerCall.get(t))&&void 0!==e?e:0;if(this.totalAllocated<s)throw new Error(`Invalid buffer allocation state: call ${t} allocated ${s} > total allocated ${this.totalAllocated}`);this.totalAllocated-=s,this.allocatedPerCall.delete(t)}}exports.MessageBufferTracker=MessageBufferTracker;const PREVIONS_RPC_ATTEMPTS_METADATA_KEY="grpc-previous-rpc-attempts",DEFAULT_MAX_ATTEMPTS_LIMIT=5;class RetryingCall{constructor(t,e,s,a,i,l,r,n,h){var o;this.channel=t,this.callConfig=e,this.methodName=s,this.host=a,this.credentials=i,this.deadline=l,this.callNumber=r,this.bufferTracker=n,this.retryThrottler=h,this.listener=null,this.initialMetadata=null,this.underlyingCalls=[],this.writeBuffer=[],this.writeBufferOffset=0,this.readStarted=!1,this.transparentRetryUsed=!1,this.attempts=0,this.hedgingTimer=null,this.committedCallIndex=null,this.initialRetryBackoffSec=0,this.nextRetryBackoffSec=0;const c=null!==(o=t.getOptions()["grpc-node.retry_max_attempts_limit"])&&void 0!==o?o:5;if(e.methodConfig.retryPolicy){this.state="RETRY";const t=e.methodConfig.retryPolicy;this.nextRetryBackoffSec=this.initialRetryBackoffSec=Number(t.initialBackoff.substring(0,t.initialBackoff.length-1)),this.maxAttempts=Math.min(t.maxAttempts,c)}else e.methodConfig.hedgingPolicy?(this.state="HEDGING",this.maxAttempts=Math.min(e.methodConfig.hedgingPolicy.maxAttempts,c)):(this.state="TRANSPARENT_ONLY",this.maxAttempts=1);this.startTime=new Date}getDeadlineInfo(){if(0===this.underlyingCalls.length)return[];const t=[],e=this.underlyingCalls[this.underlyingCalls.length-1];return this.underlyingCalls.length>1&&t.push("previous attempts: "+(this.underlyingCalls.length-1)),e.startTime>this.startTime&&t.push(`time to current attempt start: ${(0,deadline_1.formatDateDifference)(this.startTime,e.startTime)}`),t.push(...e.call.getDeadlineInfo()),t}getCallNumber(){return this.callNumber}trace(t){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,"["+this.callNumber+"] "+t)}reportStatus(t){this.trace("ended with status: code="+t.code+' details="'+t.details+'" start time='+this.startTime.toISOString()),this.bufferTracker.freeAll(this.callNumber),this.writeBufferOffset=this.writeBufferOffset+this.writeBuffer.length,this.writeBuffer=[],process.nextTick((()=>{var e;null===(e=this.listener)||void 0===e||e.onReceiveStatus({code:t.code,details:t.details,metadata:t.metadata})}))}cancelWithStatus(t,e){this.trace("cancelWithStatus code: "+t+' details: "'+e+'"'),this.reportStatus({code:t,details:e,metadata:new metadata_1.Metadata});for(const{call:s}of this.underlyingCalls)s.cancelWithStatus(t,e)}getPeer(){return null!==this.committedCallIndex?this.underlyingCalls[this.committedCallIndex].call.getPeer():"unknown"}getBufferEntry(t){var e;return null!==(e=this.writeBuffer[t-this.writeBufferOffset])&&void 0!==e?e:{entryType:"FREED",allocated:!1}}getNextBufferIndex(){return this.writeBufferOffset+this.writeBuffer.length}clearSentMessages(){if("COMMITTED"!==this.state)return;const t=this.underlyingCalls[this.committedCallIndex].nextMessageToSend;for(let e=this.writeBufferOffset;e<t;e++){const t=this.getBufferEntry(e);t.allocated&&this.bufferTracker.free(t.message.message.length,this.callNumber)}this.writeBuffer=this.writeBuffer.slice(t-this.writeBufferOffset),this.writeBufferOffset=t}commitCall(t){if("COMMITTED"!==this.state&&"COMPLETED"!==this.underlyingCalls[t].state){this.trace("Committing call ["+this.underlyingCalls[t].call.getCallNumber()+"] at index "+t),this.state="COMMITTED",this.committedCallIndex=t;for(let e=0;e<this.underlyingCalls.length;e++)e!==t&&"COMPLETED"!==this.underlyingCalls[e].state&&(this.underlyingCalls[e].state="COMPLETED",this.underlyingCalls[e].call.cancelWithStatus(constants_1.Status.CANCELLED,"Discarded in favor of other hedged attempt"));this.clearSentMessages()}}commitCallWithMostMessages(){if("COMMITTED"===this.state)return;let t=-1,e=-1;for(const[s,a]of this.underlyingCalls.entries())"ACTIVE"===a.state&&a.nextMessageToSend>t&&(t=a.nextMessageToSend,e=s);-1===e?this.state="TRANSPARENT_ONLY":this.commitCall(e)}isStatusCodeInList(t,e){return t.some((t=>{var s;return t===e||t.toString().toLowerCase()===(null===(s=constants_1.Status[e])||void 0===s?void 0:s.toLowerCase())}))}getNextRetryBackoffMs(){var t;const e=null===(t=this.callConfig)||void 0===t?void 0:t.methodConfig.retryPolicy;if(!e)return 0;const s=Math.random()*this.nextRetryBackoffSec*1e3,a=Number(e.maxBackoff.substring(0,e.maxBackoff.length-1));return this.nextRetryBackoffSec=Math.min(this.nextRetryBackoffSec*e.backoffMultiplier,a),s}maybeRetryCall(t,e){if("RETRY"!==this.state)return void e(!1);if(this.attempts>=this.maxAttempts)return void e(!1);let s;if(null===t)s=this.getNextRetryBackoffMs();else{if(t<0)return this.state="TRANSPARENT_ONLY",void e(!1);s=t,this.nextRetryBackoffSec=this.initialRetryBackoffSec}setTimeout((()=>{var t,s;"RETRY"===this.state?(null===(s=null===(t=this.retryThrottler)||void 0===t?void 0:t.canRetryCall())||void 0===s||s)&&(e(!0),this.attempts+=1,this.startNewAttempt()):e(!1)}),s)}countActiveCalls(){let t=0;for(const e of this.underlyingCalls)"ACTIVE"===(null==e?void 0:e.state)&&(t+=1);return t}handleProcessedStatus(t,e,s){var a,i,l;switch(this.state){case"COMMITTED":case"TRANSPARENT_ONLY":this.commitCall(e),this.reportStatus(t);break;case"HEDGING":if(this.isStatusCodeInList(null!==(a=this.callConfig.methodConfig.hedgingPolicy.nonFatalStatusCodes)&&void 0!==a?a:[],t.code)){let a;if(null===(i=this.retryThrottler)||void 0===i||i.addCallFailed(),null===s)a=0;else{if(s<0)return this.state="TRANSPARENT_ONLY",this.commitCall(e),void this.reportStatus(t);a=s}setTimeout((()=>{this.maybeStartHedgingAttempt(),0===this.countActiveCalls()&&(this.commitCall(e),this.reportStatus(t))}),a)}else this.commitCall(e),this.reportStatus(t);break;case"RETRY":this.isStatusCodeInList(this.callConfig.methodConfig.retryPolicy.retryableStatusCodes,t.code)?(null===(l=this.retryThrottler)||void 0===l||l.addCallFailed(),this.maybeRetryCall(s,(s=>{s||(this.commitCall(e),this.reportStatus(t))}))):(this.commitCall(e),this.reportStatus(t))}}getPushback(t){const e=t.get("grpc-retry-pushback-ms");if(0===e.length)return null;try{return parseInt(e[0])}catch(t){return-1}}handleChildStatus(t,e){var s;if("COMPLETED"===this.underlyingCalls[e].state)return;if(this.trace("state="+this.state+" handling status with progress "+t.progress+" from child ["+this.underlyingCalls[e].call.getCallNumber()+"] in state "+this.underlyingCalls[e].state),this.underlyingCalls[e].state="COMPLETED",t.code===constants_1.Status.OK)return null===(s=this.retryThrottler)||void 0===s||s.addCallSucceeded(),this.commitCall(e),void this.reportStatus(t);if("COMMITTED"===this.state)return void this.reportStatus(t);const a=this.getPushback(t.metadata);switch(t.progress){case"NOT_STARTED":this.startNewAttempt();break;case"REFUSED":this.transparentRetryUsed?this.handleProcessedStatus(t,e,a):(this.transparentRetryUsed=!0,this.startNewAttempt());break;case"DROP":this.commitCall(e),this.reportStatus(t);break;case"PROCESSED":this.handleProcessedStatus(t,e,a)}}maybeStartHedgingAttempt(){"HEDGING"===this.state&&this.callConfig.methodConfig.hedgingPolicy&&(this.attempts>=this.maxAttempts||(this.attempts+=1,this.startNewAttempt(),this.maybeStartHedgingTimer()))}maybeStartHedgingTimer(){var t,e,s;if(this.hedgingTimer&&clearTimeout(this.hedgingTimer),"HEDGING"!==this.state)return;if(!this.callConfig.methodConfig.hedgingPolicy)return;const a=this.callConfig.methodConfig.hedgingPolicy;if(this.attempts>=this.maxAttempts)return;const i=null!==(t=a.hedgingDelay)&&void 0!==t?t:"0s",l=Number(i.substring(0,i.length-1));this.hedgingTimer=setTimeout((()=>{this.maybeStartHedgingAttempt()}),1e3*l),null===(s=(e=this.hedgingTimer).unref)||void 0===s||s.call(e)}startNewAttempt(){const t=this.channel.createLoadBalancingCall(this.callConfig,this.methodName,this.host,this.credentials,this.deadline);this.trace("Created child call ["+t.getCallNumber()+"] for attempt "+this.attempts);const e=this.underlyingCalls.length;this.underlyingCalls.push({state:"ACTIVE",call:t,nextMessageToSend:0,startTime:new Date});const s=this.attempts-1,a=this.initialMetadata.clone();s>0&&a.set("grpc-previous-rpc-attempts",`${s}`);let i=!1;t.start(a,{onReceiveMetadata:a=>{this.trace("Received metadata from child ["+t.getCallNumber()+"]"),this.commitCall(e),i=!0,s>0&&a.set("grpc-previous-rpc-attempts",`${s}`),"ACTIVE"===this.underlyingCalls[e].state&&this.listener.onReceiveMetadata(a)},onReceiveMessage:s=>{this.trace("Received message from child ["+t.getCallNumber()+"]"),this.commitCall(e),"ACTIVE"===this.underlyingCalls[e].state&&this.listener.onReceiveMessage(s)},onReceiveStatus:a=>{this.trace("Received status from child ["+t.getCallNumber()+"]"),!i&&s>0&&a.metadata.set("grpc-previous-rpc-attempts",`${s}`),this.handleChildStatus(a,e)}}),this.sendNextChildMessage(e),this.readStarted&&t.startRead()}start(t,e){this.trace("start called"),this.listener=e,this.initialMetadata=t,this.attempts+=1,this.startNewAttempt(),this.maybeStartHedgingTimer()}handleChildWriteCompleted(t){var e,s;const a=this.underlyingCalls[t],i=a.nextMessageToSend;null===(s=(e=this.getBufferEntry(i)).callback)||void 0===s||s.call(e),this.clearSentMessages(),a.nextMessageToSend+=1,this.sendNextChildMessage(t)}sendNextChildMessage(t){const e=this.underlyingCalls[t];if("COMPLETED"!==e.state&&this.getBufferEntry(e.nextMessageToSend)){const s=this.getBufferEntry(e.nextMessageToSend);switch(s.entryType){case"MESSAGE":e.call.sendMessageWithContext({callback:e=>{this.handleChildWriteCompleted(t)}},s.message.message);break;case"HALF_CLOSE":e.nextMessageToSend+=1,e.call.halfClose()}}}sendMessageWithContext(t,e){var s;this.trace("write() called with message of length "+e.length);const a={message:e,flags:t.flags},i=this.getNextBufferIndex(),l={entryType:"MESSAGE",message:a,allocated:this.bufferTracker.allocate(e.length,this.callNumber)};if(this.writeBuffer.push(l),l.allocated){null===(s=t.callback)||void 0===s||s.call(t);for(const[t,s]of this.underlyingCalls.entries())"ACTIVE"===s.state&&s.nextMessageToSend===i&&s.call.sendMessageWithContext({callback:e=>{this.handleChildWriteCompleted(t)}},e)}else{if(this.commitCallWithMostMessages(),null===this.committedCallIndex)return;const s=this.underlyingCalls[this.committedCallIndex];l.callback=t.callback,"ACTIVE"===s.state&&s.nextMessageToSend===i&&s.call.sendMessageWithContext({callback:t=>{this.handleChildWriteCompleted(this.committedCallIndex)}},e)}}startRead(){this.trace("startRead called"),this.readStarted=!0;for(const t of this.underlyingCalls)"ACTIVE"===(null==t?void 0:t.state)&&t.call.startRead()}halfClose(){this.trace("halfClose called");const t=this.getNextBufferIndex();this.writeBuffer.push({entryType:"HALF_CLOSE",allocated:!1});for(const e of this.underlyingCalls)"ACTIVE"===(null==e?void 0:e.state)&&e.nextMessageToSend===t&&(e.nextMessageToSend+=1,e.call.halfClose())}setCredentials(t){throw new Error("Method not implemented.")}getMethod(){return this.methodName}getHost(){return this.host}}exports.RetryingCall=RetryingCall;