"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.createServerCredentialsWithInterceptors=exports.createCertificateProviderServerCredentials=exports.ServerCredentials=void 0;const tls_helpers_1=require("./tls-helpers");class ServerCredentials{constructor(){this.watchers=new Set,this.latestContextOptions=null}_addWatcher(e){this.watchers.add(e)}_removeWatcher(e){this.watchers.delete(e)}getWatcherCount(){return this.watchers.size}updateSecureContextOptions(e){this.latestContextOptions=e;for(const e of this.watchers)e(this.latestContextOptions)}_getSettings(){return this.latestContextOptions}_getInterceptors(){return[]}static createInsecure(){return new InsecureServerCredentials}static createSsl(e,t,r=!1){var i;if(null!==e&&!Buffer.isBuffer(e))throw new TypeError("rootCerts must be null or a Buffer");if(!Array.isArray(t))throw new TypeError("keyCertPairs must be an array");if("boolean"!=typeof r)throw new TypeError("checkClientCertificate must be a boolean");const s=[],n=[];for(let e=0;e<t.length;e++){const r=t[e];if(null===r||"object"!=typeof r)throw new TypeError(`keyCertPair[${e}] must be an object`);if(!Buffer.isBuffer(r.private_key))throw new TypeError(`keyCertPair[${e}].private_key must be a Buffer`);if(!Buffer.isBuffer(r.cert_chain))throw new TypeError(`keyCertPair[${e}].cert_chain must be a Buffer`);s.push(r.cert_chain),n.push(r.private_key)}return new SecureServerCredentials({ca:null!==(i=null!=e?e:(0,tls_helpers_1.getDefaultRootsData)())&&void 0!==i?i:void 0,cert:s,key:n,requestCert:r,ciphers:tls_helpers_1.CIPHER_SUITES})}}exports.ServerCredentials=ServerCredentials;class InsecureServerCredentials extends ServerCredentials{_isSecure(){return!1}_getSettings(){return null}_equals(e){return e instanceof InsecureServerCredentials}}class SecureServerCredentials extends ServerCredentials{constructor(e){super(),this.options=e}_isSecure(){return!0}_getSettings(){return this.options}_equals(e){if(this===e)return!0;if(!(e instanceof SecureServerCredentials))return!1;if(Buffer.isBuffer(this.options.ca)&&Buffer.isBuffer(e.options.ca)){if(!this.options.ca.equals(e.options.ca))return!1}else if(this.options.ca!==e.options.ca)return!1;if(Array.isArray(this.options.cert)&&Array.isArray(e.options.cert)){if(this.options.cert.length!==e.options.cert.length)return!1;for(let t=0;t<this.options.cert.length;t++){const r=this.options.cert[t],i=e.options.cert[t];if(Buffer.isBuffer(r)&&Buffer.isBuffer(i)){if(!r.equals(i))return!1}else if(r!==i)return!1}}else if(this.options.cert!==e.options.cert)return!1;if(Array.isArray(this.options.key)&&Array.isArray(e.options.key)){if(this.options.key.length!==e.options.key.length)return!1;for(let t=0;t<this.options.key.length;t++){const r=this.options.key[t],i=e.options.key[t];if(Buffer.isBuffer(r)&&Buffer.isBuffer(i)){if(!r.equals(i))return!1}else if(r!==i)return!1}}else if(this.options.key!==e.options.key)return!1;return this.options.requestCert===e.options.requestCert}}class CertificateProviderServerCredentials extends ServerCredentials{constructor(e,t,r){super(),this.identityCertificateProvider=e,this.caCertificateProvider=t,this.requireClientCertificate=r,this.latestCaUpdate=null,this.latestIdentityUpdate=null,this.caCertificateUpdateListener=this.handleCaCertificateUpdate.bind(this),this.identityCertificateUpdateListener=this.handleIdentityCertitificateUpdate.bind(this)}_addWatcher(e){var t;0===this.getWatcherCount()&&(null===(t=this.caCertificateProvider)||void 0===t||t.addCaCertificateListener(this.caCertificateUpdateListener),this.identityCertificateProvider.addIdentityCertificateListener(this.identityCertificateUpdateListener)),super._addWatcher(e)}_removeWatcher(e){var t;super._removeWatcher(e),0===this.getWatcherCount()&&(null===(t=this.caCertificateProvider)||void 0===t||t.removeCaCertificateListener(this.caCertificateUpdateListener),this.identityCertificateProvider.removeIdentityCertificateListener(this.identityCertificateUpdateListener))}_isSecure(){return!0}_equals(e){return this===e||e instanceof CertificateProviderServerCredentials&&(this.caCertificateProvider===e.caCertificateProvider&&this.identityCertificateProvider===e.identityCertificateProvider&&this.requireClientCertificate===e.requireClientCertificate)}calculateSecureContextOptions(){var e;return null===this.latestIdentityUpdate||null!==this.caCertificateProvider&&null===this.latestCaUpdate?null:{ca:null===(e=this.latestCaUpdate)||void 0===e?void 0:e.caCertificate,cert:this.latestIdentityUpdate.certificate,key:this.latestIdentityUpdate.privateKey,requestCert:null!==this.latestIdentityUpdate,rejectUnauthorized:this.requireClientCertificate}}finalizeUpdate(){this.updateSecureContextOptions(this.calculateSecureContextOptions())}handleCaCertificateUpdate(e){this.latestCaUpdate=e,this.finalizeUpdate()}handleIdentityCertitificateUpdate(e){this.latestIdentityUpdate=e,this.finalizeUpdate()}}function createCertificateProviderServerCredentials(e,t,r){return new CertificateProviderServerCredentials(e,t,r)}exports.createCertificateProviderServerCredentials=createCertificateProviderServerCredentials;class InterceptorServerCredentials extends ServerCredentials{constructor(e,t){super(),this.childCredentials=e,this.interceptors=t}_isSecure(){return this.childCredentials._isSecure()}_equals(e){if(!(e instanceof InterceptorServerCredentials))return!1;if(!this.childCredentials._equals(e.childCredentials))return!1;if(this.interceptors.length!==e.interceptors.length)return!1;for(let t=0;t<this.interceptors.length;t++)if(this.interceptors[t]!==e.interceptors[t])return!1;return!0}_getInterceptors(){return this.interceptors}_addWatcher(e){this.childCredentials._addWatcher(e)}_removeWatcher(e){this.childCredentials._removeWatcher(e)}}function createServerCredentialsWithInterceptors(e,t){return new InterceptorServerCredentials(e,t)}exports.createServerCredentialsWithInterceptors=createServerCredentialsWithInterceptors;