"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.getServerInterceptingCall=exports.BaseServerInterceptingCall=exports.ServerInterceptingCall=exports.ResponderBuilder=exports.isInterceptingServerListener=exports.ServerListenerBuilder=void 0;const metadata_1=require("./metadata"),constants_1=require("./constants"),http2=require("http2"),error_1=require("./error"),zlib=require("zlib"),stream_decoder_1=require("./stream-decoder"),logging=require("./logging"),TRACER_NAME="server_call";function trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,e)}class ServerListenerBuilder{constructor(){this.metadata=void 0,this.message=void 0,this.halfClose=void 0,this.cancel=void 0}withOnReceiveMetadata(e){return this.metadata=e,this}withOnReceiveMessage(e){return this.message=e,this}withOnReceiveHalfClose(e){return this.halfClose=e,this}withOnCancel(e){return this.cancel=e,this}build(){return{onReceiveMetadata:this.metadata,onReceiveMessage:this.message,onReceiveHalfClose:this.halfClose,onCancel:this.cancel}}}function isInterceptingServerListener(e){return void 0!==e.onReceiveMetadata&&1===e.onReceiveMetadata.length}exports.ServerListenerBuilder=ServerListenerBuilder,exports.isInterceptingServerListener=isInterceptingServerListener;class InterceptingServerListenerImpl{constructor(e,t){this.listener=e,this.nextListener=t,this.cancelled=!1,this.processingMetadata=!1,this.hasPendingMessage=!1,this.pendingMessage=null,this.processingMessage=!1,this.hasPendingHalfClose=!1}processPendingMessage(){this.hasPendingMessage&&(this.nextListener.onReceiveMessage(this.pendingMessage),this.pendingMessage=null,this.hasPendingMessage=!1)}processPendingHalfClose(){this.hasPendingHalfClose&&(this.nextListener.onReceiveHalfClose(),this.hasPendingHalfClose=!1)}onReceiveMetadata(e){this.cancelled||(this.processingMetadata=!0,this.listener.onReceiveMetadata(e,(e=>{this.processingMetadata=!1,this.cancelled||(this.nextListener.onReceiveMetadata(e),this.processPendingMessage(),this.processPendingHalfClose())})))}onReceiveMessage(e){this.cancelled||(this.processingMessage=!0,this.listener.onReceiveMessage(e,(e=>{this.processingMessage=!1,this.cancelled||(this.processingMetadata?(this.pendingMessage=e,this.hasPendingMessage=!0):(this.nextListener.onReceiveMessage(e),this.processPendingHalfClose()))})))}onReceiveHalfClose(){this.cancelled||this.listener.onReceiveHalfClose((()=>{this.cancelled||(this.processingMetadata||this.processingMessage?this.hasPendingHalfClose=!0:this.nextListener.onReceiveHalfClose())}))}onCancel(){this.cancelled=!0,this.listener.onCancel(),this.nextListener.onCancel()}}class ResponderBuilder{constructor(){this.start=void 0,this.metadata=void 0,this.message=void 0,this.status=void 0}withStart(e){return this.start=e,this}withSendMetadata(e){return this.metadata=e,this}withSendMessage(e){return this.message=e,this}withSendStatus(e){return this.status=e,this}build(){return{start:this.start,sendMetadata:this.metadata,sendMessage:this.message,sendStatus:this.status}}}exports.ResponderBuilder=ResponderBuilder;const defaultServerListener={onReceiveMetadata:(e,t)=>{t(e)},onReceiveMessage:(e,t)=>{t(e)},onReceiveHalfClose:e=>{e()},onCancel:()=>{}},defaultResponder={start:e=>{e()},sendMetadata:(e,t)=>{t(e)},sendMessage:(e,t)=>{t(e)},sendStatus:(e,t)=>{t(e)}};class ServerInterceptingCall{constructor(e,t){var s,a,n,i;this.nextCall=e,this.processingMetadata=!1,this.processingMessage=!1,this.pendingMessage=null,this.pendingMessageCallback=null,this.pendingStatus=null,this.responder={start:null!==(s=null==t?void 0:t.start)&&void 0!==s?s:defaultResponder.start,sendMetadata:null!==(a=null==t?void 0:t.sendMetadata)&&void 0!==a?a:defaultResponder.sendMetadata,sendMessage:null!==(n=null==t?void 0:t.sendMessage)&&void 0!==n?n:defaultResponder.sendMessage,sendStatus:null!==(i=null==t?void 0:t.sendStatus)&&void 0!==i?i:defaultResponder.sendStatus}}processPendingMessage(){this.pendingMessageCallback&&(this.nextCall.sendMessage(this.pendingMessage,this.pendingMessageCallback),this.pendingMessage=null,this.pendingMessageCallback=null)}processPendingStatus(){this.pendingStatus&&(this.nextCall.sendStatus(this.pendingStatus),this.pendingStatus=null)}start(e){this.responder.start((t=>{var s,a,n,i;const r={onReceiveMetadata:null!==(s=null==t?void 0:t.onReceiveMetadata)&&void 0!==s?s:defaultServerListener.onReceiveMetadata,onReceiveMessage:null!==(a=null==t?void 0:t.onReceiveMessage)&&void 0!==a?a:defaultServerListener.onReceiveMessage,onReceiveHalfClose:null!==(n=null==t?void 0:t.onReceiveHalfClose)&&void 0!==n?n:defaultServerListener.onReceiveHalfClose,onCancel:null!==(i=null==t?void 0:t.onCancel)&&void 0!==i?i:defaultServerListener.onCancel},d=new InterceptingServerListenerImpl(r,e);this.nextCall.start(d)}))}sendMetadata(e){this.processingMetadata=!0,this.responder.sendMetadata(e,(e=>{this.processingMetadata=!1,this.nextCall.sendMetadata(e),this.processPendingMessage(),this.processPendingStatus()}))}sendMessage(e,t){this.processingMessage=!0,this.responder.sendMessage(e,(e=>{this.processingMessage=!1,this.processingMetadata?(this.pendingMessage=e,this.pendingMessageCallback=t):this.nextCall.sendMessage(e,t)}))}sendStatus(e){this.responder.sendStatus(e,(e=>{this.processingMetadata||this.processingMessage?this.pendingStatus=e:this.nextCall.sendStatus(e)}))}startRead(){this.nextCall.startRead()}getPeer(){return this.nextCall.getPeer()}getDeadline(){return this.nextCall.getDeadline()}getHost(){return this.nextCall.getHost()}}exports.ServerInterceptingCall=ServerInterceptingCall;const GRPC_ACCEPT_ENCODING_HEADER="grpc-accept-encoding",GRPC_ENCODING_HEADER="grpc-encoding",GRPC_MESSAGE_HEADER="grpc-message",GRPC_STATUS_HEADER="grpc-status",GRPC_TIMEOUT_HEADER="grpc-timeout",DEADLINE_REGEX=/(\d{1,8})\s*([HMSmun])/,deadlineUnitsToMs={H:36e5,M:6e4,S:1e3,m:1,u:.001,n:1e-6},defaultCompressionHeaders={"grpc-accept-encoding":"identity,deflate,gzip","grpc-encoding":"identity"},defaultResponseHeaders={[http2.constants.HTTP2_HEADER_STATUS]:http2.constants.HTTP_STATUS_OK,[http2.constants.HTTP2_HEADER_CONTENT_TYPE]:"application/grpc+proto"},defaultResponseOptions={waitForTrailers:!0};class BaseServerInterceptingCall{constructor(e,t,s,a,n){var i;this.stream=e,this.callEventTracker=s,this.handler=a,this.listener=null,this.deadlineTimer=null,this.deadline=1/0,this.maxSendMessageSize=constants_1.DEFAULT_MAX_SEND_MESSAGE_LENGTH,this.maxReceiveMessageSize=constants_1.DEFAULT_MAX_RECEIVE_MESSAGE_LENGTH,this.cancelled=!1,this.metadataSent=!1,this.wantTrailers=!1,this.cancelNotified=!1,this.incomingEncoding="identity",this.readQueue=[],this.isReadPending=!1,this.receivedHalfClose=!1,this.streamEnded=!1,this.stream.once("error",(e=>{})),this.stream.once("close",(()=>{var e;trace("Request to method "+(null===(e=this.handler)||void 0===e?void 0:e.path)+" stream closed with rstCode "+this.stream.rstCode),this.callEventTracker&&!this.streamEnded&&(this.streamEnded=!0,this.callEventTracker.onStreamEnd(!1),this.callEventTracker.onCallEnd({code:constants_1.Status.CANCELLED,details:"Stream closed before sending status",metadata:null})),this.notifyOnCancel()})),this.stream.on("data",(e=>{this.handleDataFrame(e)})),this.stream.pause(),this.stream.on("end",(()=>{this.handleEndEvent()})),"grpc.max_send_message_length"in n&&(this.maxSendMessageSize=n["grpc.max_send_message_length"]),"grpc.max_receive_message_length"in n&&(this.maxReceiveMessageSize=n["grpc.max_receive_message_length"]),this.host=null!==(i=t[":authority"])&&void 0!==i?i:t.host,this.decoder=new stream_decoder_1.StreamDecoder(this.maxReceiveMessageSize);const r=metadata_1.Metadata.fromHttp2Headers(t);logging.isTracerEnabled(TRACER_NAME)&&trace("Request to "+this.handler.path+" received headers "+JSON.stringify(r.toJSON()));const d=r.get("grpc-timeout");d.length>0&&this.handleTimeoutHeader(d[0]);const l=r.get("grpc-encoding");l.length>0&&(this.incomingEncoding=l[0]),r.remove("grpc-timeout"),r.remove("grpc-encoding"),r.remove("grpc-accept-encoding"),r.remove(http2.constants.HTTP2_HEADER_ACCEPT_ENCODING),r.remove(http2.constants.HTTP2_HEADER_TE),r.remove(http2.constants.HTTP2_HEADER_CONTENT_TYPE),this.metadata=r}handleTimeoutHeader(e){const t=e.toString().match(DEADLINE_REGEX);if(null===t){const t={code:constants_1.Status.INTERNAL,details:`Invalid grpc-timeout value "${e}"`,metadata:null};return void process.nextTick((()=>{this.sendStatus(t)}))}const s=+t[1]*deadlineUnitsToMs[t[2]]|0,a=new Date;this.deadline=a.setMilliseconds(a.getMilliseconds()+s),this.deadlineTimer=setTimeout((()=>{const e={code:constants_1.Status.DEADLINE_EXCEEDED,details:"Deadline exceeded",metadata:null};this.sendStatus(e)}),s)}checkCancelled(){return this.cancelled||!this.stream.destroyed&&!this.stream.closed||(this.notifyOnCancel(),this.cancelled=!0),this.cancelled}notifyOnCancel(){this.cancelNotified||(this.cancelNotified=!0,this.cancelled=!0,process.nextTick((()=>{var e;null===(e=this.listener)||void 0===e||e.onCancel()})),this.deadlineTimer&&clearTimeout(this.deadlineTimer),this.stream.resume())}maybeSendMetadata(){this.metadataSent||this.sendMetadata(new metadata_1.Metadata)}serializeMessage(e){const t=this.handler.serialize(e),s=t.byteLength,a=Buffer.allocUnsafe(s+5);return a.writeUInt8(0,0),a.writeUInt32BE(s,1),t.copy(a,5),a}decompressMessage(e,t){const s=e.subarray(5);if("identity"===t)return s;if("deflate"===t||"gzip"===t){let e;return e="deflate"===t?zlib.createInflate():zlib.createGunzip(),new Promise(((t,a)=>{let n=0;const i=[];e.on("data",(t=>{i.push(t),n+=t.byteLength,-1!==this.maxReceiveMessageSize&&n>this.maxReceiveMessageSize&&(e.destroy(),a({code:constants_1.Status.RESOURCE_EXHAUSTED,details:`Received message that decompresses to a size larger than ${this.maxReceiveMessageSize}`}))})),e.on("end",(()=>{t(Buffer.concat(i))})),e.write(s),e.end()}))}return Promise.reject({code:constants_1.Status.UNIMPLEMENTED,details:`Received message compressed with unsupported encoding "${t}"`})}async decompressAndMaybePush(e){if("COMPRESSED"!==e.type)throw new Error(`Invalid queue entry type: ${e.type}`);const t=1===e.compressedMessage.readUInt8(0)?this.incomingEncoding:"identity";let s;try{s=await this.decompressMessage(e.compressedMessage,t)}catch(e){return void this.sendStatus(e)}try{e.parsedMessage=this.handler.deserialize(s)}catch(e){return void this.sendStatus({code:constants_1.Status.INTERNAL,details:`Error deserializing request: ${e.message}`})}e.type="READABLE",this.maybePushNextMessage()}maybePushNextMessage(){if(this.listener&&this.isReadPending&&this.readQueue.length>0&&"COMPRESSED"!==this.readQueue[0].type){this.isReadPending=!1;const e=this.readQueue.shift();"READABLE"===e.type?this.listener.onReceiveMessage(e.parsedMessage):this.listener.onReceiveHalfClose()}}handleDataFrame(e){var t;if(this.checkCancelled())return;let s;trace("Request to "+this.handler.path+" received data frame of size "+e.length);try{s=this.decoder.write(e)}catch(e){return void this.sendStatus({code:constants_1.Status.RESOURCE_EXHAUSTED,details:e.message})}for(const e of s){this.stream.pause();const s={type:"COMPRESSED",compressedMessage:e,parsedMessage:null};this.readQueue.push(s),this.decompressAndMaybePush(s),null===(t=this.callEventTracker)||void 0===t||t.addMessageReceived()}}handleEndEvent(){this.readQueue.push({type:"HALF_CLOSE",compressedMessage:null,parsedMessage:null}),this.receivedHalfClose=!0,this.maybePushNextMessage()}start(e){trace("Request to "+this.handler.path+" start called"),this.checkCancelled()||(this.listener=e,e.onReceiveMetadata(this.metadata))}sendMetadata(e){if(this.checkCancelled())return;if(this.metadataSent)return;this.metadataSent=!0;const t=e?e.toHttp2Headers():null,s=Object.assign(Object.assign(Object.assign({},defaultResponseHeaders),defaultCompressionHeaders),t);this.stream.respond(s,defaultResponseOptions)}sendMessage(e,t){if(this.checkCancelled())return;let s;try{s=this.serializeMessage(e)}catch(e){return void this.sendStatus({code:constants_1.Status.INTERNAL,details:`Error serializing response: ${(0,error_1.getErrorMessage)(e)}`,metadata:null})}-1!==this.maxSendMessageSize&&s.length-5>this.maxSendMessageSize?this.sendStatus({code:constants_1.Status.RESOURCE_EXHAUSTED,details:`Sent message larger than max (${s.length} vs. ${this.maxSendMessageSize})`,metadata:null}):(this.maybeSendMetadata(),trace("Request to "+this.handler.path+" sent data frame of size "+s.length),this.stream.write(s,(e=>{var s;e?this.sendStatus({code:constants_1.Status.INTERNAL,details:`Error writing message: ${(0,error_1.getErrorMessage)(e)}`,metadata:null}):(null===(s=this.callEventTracker)||void 0===s||s.addMessageSent(),t())})))}sendStatus(e){var t,s;if(!this.checkCancelled())if(trace("Request to method "+(null===(t=this.handler)||void 0===t?void 0:t.path)+" ended with status code: "+constants_1.Status[e.code]+" details: "+e.details),this.metadataSent)this.wantTrailers?this.notifyOnCancel():(this.wantTrailers=!0,this.stream.once("wantTrailers",(()=>{var t;this.callEventTracker&&!this.streamEnded&&(this.streamEnded=!0,this.callEventTracker.onStreamEnd(!0),this.callEventTracker.onCallEnd(e));const s=Object.assign({"grpc-status":e.code,"grpc-message":encodeURI(e.details)},null===(t=e.metadata)||void 0===t?void 0:t.toHttp2Headers());this.stream.sendTrailers(s),this.notifyOnCancel()})),this.stream.end());else{this.callEventTracker&&!this.streamEnded&&(this.streamEnded=!0,this.callEventTracker.onStreamEnd(!0),this.callEventTracker.onCallEnd(e));const t=Object.assign(Object.assign({"grpc-status":e.code,"grpc-message":encodeURI(e.details)},defaultResponseHeaders),null===(s=e.metadata)||void 0===s?void 0:s.toHttp2Headers());this.stream.respond(t,{endStream:!0}),this.notifyOnCancel()}}startRead(){trace("Request to "+this.handler.path+" startRead called"),this.checkCancelled()||(this.isReadPending=!0,0===this.readQueue.length?this.receivedHalfClose||this.stream.resume():this.maybePushNextMessage())}getPeer(){var e;const t=null===(e=this.stream.session)||void 0===e?void 0:e.socket;return(null==t?void 0:t.remoteAddress)?t.remotePort?`${t.remoteAddress}:${t.remotePort}`:t.remoteAddress:"unknown"}getDeadline(){return this.deadline}getHost(){return this.host}}function getServerInterceptingCall(e,t,s,a,n,i){const r={path:n.path,requestStream:"clientStream"===n.type||"bidi"===n.type,responseStream:"serverStream"===n.type||"bidi"===n.type,requestDeserialize:n.deserialize,responseSerialize:n.serialize},d=new BaseServerInterceptingCall(t,s,a,n,i);return e.reduce(((e,t)=>t(r,e)),d)}exports.BaseServerInterceptingCall=BaseServerInterceptingCall,exports.getServerInterceptingCall=getServerInterceptingCall;