"use strict";var __runInitializers=this&&this.__runInitializers||function(e,t,s){for(var r=arguments.length>2,n=0;n<t.length;n++)s=r?t[n].call(e,s):t[n].call(e);return r?s:void 0},__esDecorate=this&&this.__esDecorate||function(e,t,s,r,n,i){function a(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var o,l=r.kind,c="getter"===l?"get":"setter"===l?"set":"value",d=!t&&e?r.static?e:e.prototype:null,h=t||(d?Object.getOwnPropertyDescriptor(d,r.name):{}),u=!1,m=s.length-1;m>=0;m--){var p={};for(var v in r)p[v]="access"===v?{}:r[v];for(var v in r.access)p.access[v]=r.access[v];p.addInitializer=function(e){if(u)throw new TypeError("Cannot add initializers after decoration has completed");i.push(a(e||null))};var g=(0,s[m])("accessor"===l?{get:h.get,set:h.set}:h[c],p);if("accessor"===l){if(void 0===g)continue;if(null===g||"object"!=typeof g)throw new TypeError("Object expected");(o=a(g.get))&&(h.get=o),(o=a(g.set))&&(h.set=o),(o=a(g.init))&&n.unshift(o)}else(o=a(g))&&("field"===l?n.unshift(o):h[c]=o)}d&&Object.defineProperty(d,r.name,h),u=!0};Object.defineProperty(exports,"__esModule",{value:!0}),exports.Server=void 0;const http2=require("http2"),util=require("util"),constants_1=require("./constants"),server_call_1=require("./server-call"),server_credentials_1=require("./server-credentials"),resolver_1=require("./resolver"),logging=require("./logging"),subchannel_address_1=require("./subchannel-address"),uri_parser_1=require("./uri-parser"),channelz_1=require("./channelz"),server_interceptors_1=require("./server-interceptors"),UNLIMITED_CONNECTION_AGE_MS=~(1<<31),KEEPALIVE_MAX_TIME_MS=~(1<<31),KEEPALIVE_TIMEOUT_MS=2e4,MAX_CONNECTION_IDLE_MS=~(1<<31),{HTTP2_HEADER_PATH:HTTP2_HEADER_PATH}=http2.constants,TRACER_NAME="server",kMaxAge=Buffer.from("max_age");function noop(){}function deprecate(e){return function(t,s){return util.deprecate(t,e)}}function getUnimplementedStatusResponse(e){return{code:constants_1.Status.UNIMPLEMENTED,details:`The server does not implement the method ${e}`}}function getDefaultHandler(e,t){const s=getUnimplementedStatusResponse(t);switch(e){case"unary":case"clientStream":return(e,t)=>{t(s,null)};case"serverStream":case"bidi":return e=>{e.emit("error",s)};default:throw new Error(`Invalid handlerType ${e}`)}}let Server=(()=>{var e;let t,s=[];return e=class{constructor(e){var t,r,n,i,a,o;this.boundPorts=(__runInitializers(this,s),new Map),this.http2Servers=new Map,this.sessionIdleTimeouts=new Map,this.handlers=new Map,this.sessions=new Map,this.started=!1,this.shutdown=!1,this.serverAddressString="null",this.channelzEnabled=!0,this.options=null!=e?e:{},0===this.options["grpc.enable_channelz"]?(this.channelzEnabled=!1,this.channelzTrace=new channelz_1.ChannelzTraceStub,this.callTracker=new channelz_1.ChannelzCallTrackerStub,this.listenerChildrenTracker=new channelz_1.ChannelzChildrenTrackerStub,this.sessionChildrenTracker=new channelz_1.ChannelzChildrenTrackerStub):(this.channelzTrace=new channelz_1.ChannelzTrace,this.callTracker=new channelz_1.ChannelzCallTracker,this.listenerChildrenTracker=new channelz_1.ChannelzChildrenTracker,this.sessionChildrenTracker=new channelz_1.ChannelzChildrenTracker),this.channelzRef=(0,channelz_1.registerChannelzServer)("server",(()=>this.getChannelzInfo()),this.channelzEnabled),this.channelzTrace.addTrace("CT_INFO","Server created"),this.maxConnectionAgeMs=null!==(t=this.options["grpc.max_connection_age_ms"])&&void 0!==t?t:2147483647,this.maxConnectionAgeGraceMs=null!==(r=this.options["grpc.max_connection_age_grace_ms"])&&void 0!==r?r:2147483647,this.keepaliveTimeMs=null!==(n=this.options["grpc.keepalive_time_ms"])&&void 0!==n?n:2147483647,this.keepaliveTimeoutMs=null!==(i=this.options["grpc.keepalive_timeout_ms"])&&void 0!==i?i:2e4,this.sessionIdleTimeout=null!==(a=this.options["grpc.max_connection_idle_ms"])&&void 0!==a?a:2147483647,this.commonServerOptions={maxSendHeaderBlockLength:Number.MAX_SAFE_INTEGER},"grpc-node.max_session_memory"in this.options?this.commonServerOptions.maxSessionMemory=this.options["grpc-node.max_session_memory"]:this.commonServerOptions.maxSessionMemory=Number.MAX_SAFE_INTEGER,"grpc.max_concurrent_streams"in this.options&&(this.commonServerOptions.settings={maxConcurrentStreams:this.options["grpc.max_concurrent_streams"]}),this.interceptors=null!==(o=this.options.interceptors)&&void 0!==o?o:[],this.trace("Server constructed")}getChannelzInfo(){return{trace:this.channelzTrace,callTracker:this.callTracker,listenerChildren:this.listenerChildrenTracker.getChildLists(),sessionChildren:this.sessionChildrenTracker.getChildLists()}}getChannelzSessionInfo(e){var t,s,r;const n=this.sessions.get(e),i=e.socket,a=i.remoteAddress?(0,subchannel_address_1.stringToSubchannelAddress)(i.remoteAddress,i.remotePort):null,o=i.localAddress?(0,subchannel_address_1.stringToSubchannelAddress)(i.localAddress,i.localPort):null;let l;if(e.encrypted){const e=i,s=e.getCipher(),r=e.getCertificate(),n=e.getPeerCertificate();l={cipherSuiteStandardName:null!==(t=s.standardName)&&void 0!==t?t:null,cipherSuiteOtherName:s.standardName?null:s.name,localCertificate:r&&"raw"in r?r.raw:null,remoteCertificate:n&&"raw"in n?n.raw:null}}else l=null;return{remoteAddress:a,localAddress:o,security:l,remoteName:null,streamsStarted:n.streamTracker.callsStarted,streamsSucceeded:n.streamTracker.callsSucceeded,streamsFailed:n.streamTracker.callsFailed,messagesSent:n.messagesSent,messagesReceived:n.messagesReceived,keepAlivesSent:n.keepAlivesSent,lastLocalStreamCreatedTimestamp:null,lastRemoteStreamCreatedTimestamp:n.streamTracker.lastCallStartedTimestamp,lastMessageSentTimestamp:n.lastMessageSentTimestamp,lastMessageReceivedTimestamp:n.lastMessageReceivedTimestamp,localFlowControlWindow:null!==(s=e.state.localWindowSize)&&void 0!==s?s:null,remoteFlowControlWindow:null!==(r=e.state.remoteWindowSize)&&void 0!==r?r:null}}trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"server","("+this.channelzRef.id+") "+e)}keepaliveTrace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"keepalive","("+this.channelzRef.id+") "+e)}addProtoService(){throw new Error("Not implemented. Use addService() instead")}addService(e,t){if(null===e||"object"!=typeof e||null===t||"object"!=typeof t)throw new Error("addService() requires two objects as arguments");const s=Object.keys(e);if(0===s.length)throw new Error("Cannot add an empty service to a server");s.forEach((s=>{const r=e[s];let n;n=r.requestStream?r.responseStream?"bidi":"clientStream":r.responseStream?"serverStream":"unary";let i,a=t[s];void 0===a&&"string"==typeof r.originalName&&(a=t[r.originalName]),i=void 0!==a?a.bind(t):getDefaultHandler(n,s);if(!1===this.register(r.path,i,r.responseSerialize,r.requestDeserialize,n))throw new Error(`Method handler for ${r.path} already provided.`)}))}removeService(e){if(null===e||"object"!=typeof e)throw new Error("removeService() requires object as argument");Object.keys(e).forEach((t=>{const s=e[t];this.unregister(s.path)}))}bind(e,t){throw new Error("Not implemented. Use bindAsync() instead")}registerListenerToChannelz(e){return(0,channelz_1.registerChannelzSocket)((0,subchannel_address_1.subchannelAddressToString)(e),(()=>({localAddress:e,remoteAddress:null,security:null,remoteName:null,streamsStarted:0,streamsSucceeded:0,streamsFailed:0,messagesSent:0,messagesReceived:0,keepAlivesSent:0,lastLocalStreamCreatedTimestamp:null,lastRemoteStreamCreatedTimestamp:null,lastMessageSentTimestamp:null,lastMessageReceivedTimestamp:null,localFlowControlWindow:null,remoteFlowControlWindow:null})),this.channelzEnabled)}createHttp2Server(e){let t;if(e._isSecure()){const s=e._getSettings(),r=Object.assign(Object.assign(Object.assign({},this.commonServerOptions),s),{enableTrace:1===this.options["grpc-node.tls_enable_trace"]});let n=null!==s;t=http2.createSecureServer(r),t.on("connection",(e=>{n||e.destroy()})),t.on("secureConnection",(e=>{e.on("error",(e=>{this.trace("An incoming TLS connection closed with error: "+e.message)}))}));const i=e=>{e&&t.setSecureContext(e),n=null!==e};e._addWatcher(i),t.on("close",(()=>{e._removeWatcher(i)}))}else t=http2.createServer(this.commonServerOptions);return t.setTimeout(0,noop),this._setupHandlers(t,e._getInterceptors()),t}bindOneAddress(e,t){this.trace("Attempting to bind "+(0,subchannel_address_1.subchannelAddressToString)(e));const s=this.createHttp2Server(t.credentials);return new Promise(((r,n)=>{const i=t=>{this.trace("Failed to bind "+(0,subchannel_address_1.subchannelAddressToString)(e)+" with error "+t.message),r({port:"port"in e?e.port:1,error:t.message})};s.once("error",i),s.listen(e,(()=>{const e=s.address();let n;n="string"==typeof e?{path:e}:{host:e.address,port:e.port};const a=this.registerListenerToChannelz(n);this.listenerChildrenTracker.refChild(a),this.http2Servers.set(s,{channelzRef:a,sessions:new Set}),t.listeningServers.add(s),this.trace("Successfully bound "+(0,subchannel_address_1.subchannelAddressToString)(n)),r({port:"port"in n?n.port:1}),s.removeListener("error",i)}))}))}async bindManyPorts(e,t){if(0===e.length)return{count:0,port:0,errors:[]};if((0,subchannel_address_1.isTcpSubchannelAddress)(e[0])&&0===e[0].port){const s=await this.bindOneAddress(e[0],t);if(s.error){const r=await this.bindManyPorts(e.slice(1),t);return Object.assign(Object.assign({},r),{errors:[s.error,...r.errors]})}{const r=e.slice(1).map((e=>(0,subchannel_address_1.isTcpSubchannelAddress)(e)?{host:e.host,port:s.port}:e)),n=await Promise.all(r.map((e=>this.bindOneAddress(e,t)))),i=[s,...n];return{count:i.filter((e=>void 0===e.error)).length,port:s.port,errors:i.filter((e=>e.error)).map((e=>e.error))}}}{const s=await Promise.all(e.map((e=>this.bindOneAddress(e,t))));return{count:s.filter((e=>void 0===e.error)).length,port:s[0].port,errors:s.filter((e=>e.error)).map((e=>e.error))}}}async bindAddressList(e,t){const s=await this.bindManyPorts(e,t);if(s.count>0)return s.count<e.length&&logging.log(constants_1.LogVerbosity.INFO,`WARNING Only ${s.count} addresses added out of total ${e.length} resolved`),s.port;{const t=`No address added out of total ${e.length} resolved`;throw logging.log(constants_1.LogVerbosity.ERROR,t),new Error(`${t} errors: [${s.errors.join(",")}]`)}}resolvePort(e){return new Promise(((t,s)=>{const r={onSuccessfulResolution:(n,i,a)=>{r.onSuccessfulResolution=()=>{};const o=[].concat(...n.map((e=>e.addresses)));0!==o.length?t(o):s(new Error(`No addresses resolved for port ${e}`))},onError:e=>{s(new Error(e.details))}};(0,resolver_1.createResolver)(e,r,this.options).updateResolution()}))}async bindPort(e,t){const s=await this.resolvePort(e);if(t.cancelled)throw this.completeUnbind(t),new Error("bindAsync operation cancelled by unbind call");const r=await this.bindAddressList(s,t);if(t.cancelled)throw this.completeUnbind(t),new Error("bindAsync operation cancelled by unbind call");return r}normalizePort(e){const t=(0,uri_parser_1.parseUri)(e);if(null===t)throw new Error(`Could not parse port "${e}"`);const s=(0,resolver_1.mapUriDefaultScheme)(t);if(null===s)throw new Error(`Could not get a default scheme for port "${e}"`);return s}bindAsync(e,t,s){if(this.shutdown)throw new Error("bindAsync called after shutdown");if("string"!=typeof e)throw new TypeError("port must be a string");if(null===t||!(t instanceof server_credentials_1.ServerCredentials))throw new TypeError("creds must be a ServerCredentials object");if("function"!=typeof s)throw new TypeError("callback must be a function");this.trace("bindAsync port="+e);const r=this.normalizePort(e),n=(e,t)=>{process.nextTick((()=>s(e,t)))};let i=this.boundPorts.get((0,uri_parser_1.uriToString)(r));if(i)return t._equals(i.credentials)?(i.cancelled=!1,void(i.completionPromise?i.completionPromise.then((e=>s(null,e)),(e=>s(e,0))):n(null,i.portNumber))):void n(new Error(`${e} already bound with incompatible credentials`),0);i={mapKey:(0,uri_parser_1.uriToString)(r),originalUri:r,completionPromise:null,cancelled:!1,portNumber:0,credentials:t,listeningServers:new Set};const a=(0,uri_parser_1.splitHostPort)(r.path),o=this.bindPort(r,i);i.completionPromise=o,0===(null==a?void 0:a.port)?o.then((e=>{const t={scheme:r.scheme,authority:r.authority,path:(0,uri_parser_1.combineHostPort)({host:a.host,port:e})};i.mapKey=(0,uri_parser_1.uriToString)(t),i.completionPromise=null,i.portNumber=e,this.boundPorts.set(i.mapKey,i),s(null,e)}),(e=>{s(e,0)})):(this.boundPorts.set(i.mapKey,i),o.then((e=>{i.completionPromise=null,i.portNumber=e,s(null,e)}),(e=>{s(e,0)})))}registerInjectorToChannelz(){return(0,channelz_1.registerChannelzSocket)("injector",(()=>({localAddress:null,remoteAddress:null,security:null,remoteName:null,streamsStarted:0,streamsSucceeded:0,streamsFailed:0,messagesSent:0,messagesReceived:0,keepAlivesSent:0,lastLocalStreamCreatedTimestamp:null,lastRemoteStreamCreatedTimestamp:null,lastMessageSentTimestamp:null,lastMessageReceivedTimestamp:null,localFlowControlWindow:null,remoteFlowControlWindow:null})),this.channelzEnabled)}createConnectionInjector(e){if(null===e||!(e instanceof server_credentials_1.ServerCredentials))throw new TypeError("creds must be a ServerCredentials object");const t=this.createHttp2Server(e),s=this.registerInjectorToChannelz();this.channelzEnabled&&this.listenerChildrenTracker.refChild(s);const r=new Set;return this.http2Servers.set(t,{channelzRef:s,sessions:r}),{injectConnection:e=>{t.emit("connection",e)},drain:e=>{var t,s;for(const e of r)this.closeSession(e);null===(s=(t=setTimeout((()=>{for(const e of r)e.destroy(http2.constants.NGHTTP2_CANCEL)}),e)).unref)||void 0===s||s.call(t)},destroy:()=>{this.closeServer(t);for(const e of r)this.closeSession(e)}}}closeServer(e,t){this.trace("Closing server with address "+JSON.stringify(e.address()));const s=this.http2Servers.get(e);e.close((()=>{s&&(this.listenerChildrenTracker.unrefChild(s.channelzRef),(0,channelz_1.unregisterChannelzRef)(s.channelzRef)),this.http2Servers.delete(e),null==t||t()}))}closeSession(e,t){var s;this.trace("Closing session initiated by "+(null===(s=e.socket)||void 0===s?void 0:s.remoteAddress));const r=this.sessions.get(e),n=()=>{r&&(this.sessionChildrenTracker.unrefChild(r.ref),(0,channelz_1.unregisterChannelzRef)(r.ref)),null==t||t()};e.closed?queueMicrotask(n):e.close(n)}completeUnbind(e){for(const t of e.listeningServers){const s=this.http2Servers.get(t);if(this.closeServer(t,(()=>{e.listeningServers.delete(t)})),s)for(const e of s.sessions)this.closeSession(e)}this.boundPorts.delete(e.mapKey)}unbind(e){this.trace("unbind port="+e);const t=this.normalizePort(e),s=(0,uri_parser_1.splitHostPort)(t.path);if(0===(null==s?void 0:s.port))throw new Error("Cannot unbind port 0");const r=this.boundPorts.get((0,uri_parser_1.uriToString)(t));r&&(this.trace("unbinding "+r.mapKey+" originally bound as "+(0,uri_parser_1.uriToString)(r.originalUri)),r.completionPromise?r.cancelled=!0:this.completeUnbind(r))}drain(e,t){var s,r;this.trace("drain port="+e+" graceTimeMs="+t);const n=this.normalizePort(e),i=(0,uri_parser_1.splitHostPort)(n.path);if(0===(null==i?void 0:i.port))throw new Error("Cannot drain port 0");const a=this.boundPorts.get((0,uri_parser_1.uriToString)(n));if(!a)return;const o=new Set;for(const e of a.listeningServers){const t=this.http2Servers.get(e);if(t)for(const e of t.sessions)o.add(e),this.closeSession(e,(()=>{o.delete(e)}))}null===(r=(s=setTimeout((()=>{for(const e of o)e.destroy(http2.constants.NGHTTP2_CANCEL)}),t)).unref)||void 0===r||r.call(s)}forceShutdown(){for(const e of this.boundPorts.values())e.cancelled=!0;this.boundPorts.clear();for(const e of this.http2Servers.keys())this.closeServer(e);this.sessions.forEach(((e,t)=>{this.closeSession(t),t.destroy(http2.constants.NGHTTP2_CANCEL)})),this.sessions.clear(),(0,channelz_1.unregisterChannelzRef)(this.channelzRef),this.shutdown=!0}register(e,t,s,r,n){return!this.handlers.has(e)&&(this.handlers.set(e,{func:t,serialize:s,deserialize:r,type:n,path:e}),!0)}unregister(e){return this.handlers.delete(e)}start(){if(0===this.http2Servers.size||[...this.http2Servers.keys()].every((e=>!e.listening)))throw new Error("server must be bound in order to start");if(!0===this.started)throw new Error("server is already started");this.started=!0}tryShutdown(e){var t;const s=t=>{(0,channelz_1.unregisterChannelzRef)(this.channelzRef),e(t)};let r=0;function n(){r--,0===r&&s()}this.shutdown=!0;for(const[e,s]of this.http2Servers.entries()){r++;const i=s.channelzRef.name;this.trace("Waiting for server "+i+" to close"),this.closeServer(e,(()=>{this.trace("Server "+i+" finished closing"),n()}));for(const e of s.sessions.keys()){r++;const s=null===(t=e.socket)||void 0===t?void 0:t.remoteAddress;this.trace("Waiting for session "+s+" to close"),this.closeSession(e,(()=>{this.trace("Session "+s+" finished closing"),n()}))}}0===r&&s()}addHttp2Port(){throw new Error("Not yet implemented")}getChannelzRef(){return this.channelzRef}_verifyContentType(e,t){const s=t[http2.constants.HTTP2_HEADER_CONTENT_TYPE];return!("string"!=typeof s||!s.startsWith("application/grpc"))||(e.respond({[http2.constants.HTTP2_HEADER_STATUS]:http2.constants.HTTP_STATUS_UNSUPPORTED_MEDIA_TYPE},{endStream:!0}),!1)}_retrieveHandler(e){this.trace("Received call to method "+e+" at address "+this.serverAddressString);const t=this.handlers.get(e);return void 0===t?(this.trace("No handler registered for method "+e+". Sending UNIMPLEMENTED status."),null):t}_respondWithError(e,t,s=null){var r,n;const i=Object.assign({"grpc-status":null!==(r=e.code)&&void 0!==r?r:constants_1.Status.INTERNAL,"grpc-message":e.details,[http2.constants.HTTP2_HEADER_STATUS]:http2.constants.HTTP_STATUS_OK,[http2.constants.HTTP2_HEADER_CONTENT_TYPE]:"application/grpc+proto"},null===(n=e.metadata)||void 0===n?void 0:n.toHttp2Headers());t.respond(i,{endStream:!0}),this.callTracker.addCallFailed(),null==s||s.streamTracker.addCallFailed()}_channelzHandler(e,t,s){this.onStreamOpened(t);const r=this.sessions.get(t.session);if(this.callTracker.addCallStarted(),null==r||r.streamTracker.addCallStarted(),!this._verifyContentType(t,s))return this.callTracker.addCallFailed(),void(null==r||r.streamTracker.addCallFailed());const n=s[HTTP2_HEADER_PATH],i=this._retrieveHandler(n);if(!i)return void this._respondWithError(getUnimplementedStatusResponse(n),t,r);const a={addMessageSent:()=>{r&&(r.messagesSent+=1,r.lastMessageSentTimestamp=new Date)},addMessageReceived:()=>{r&&(r.messagesReceived+=1,r.lastMessageReceivedTimestamp=new Date)},onCallEnd:e=>{e.code===constants_1.Status.OK?this.callTracker.addCallSucceeded():this.callTracker.addCallFailed()},onStreamEnd:e=>{r&&(e?r.streamTracker.addCallSucceeded():r.streamTracker.addCallFailed())}},o=(0,server_interceptors_1.getServerInterceptingCall)([...e,...this.interceptors],t,s,a,i,this.options);this._runHandlerForCall(o,i)||(this.callTracker.addCallFailed(),null==r||r.streamTracker.addCallFailed(),o.sendStatus({code:constants_1.Status.INTERNAL,details:`Unknown handler type: ${i.type}`}))}_streamHandler(e,t,s){if(this.onStreamOpened(t),!0!==this._verifyContentType(t,s))return;const r=s[HTTP2_HEADER_PATH],n=this._retrieveHandler(r);if(!n)return void this._respondWithError(getUnimplementedStatusResponse(r),t,null);const i=(0,server_interceptors_1.getServerInterceptingCall)([...e,...this.interceptors],t,s,null,n,this.options);this._runHandlerForCall(i,n)||i.sendStatus({code:constants_1.Status.INTERNAL,details:`Unknown handler type: ${n.type}`})}_runHandlerForCall(e,t){const{type:s}=t;if("unary"===s)handleUnary(e,t);else if("clientStream"===s)handleClientStreaming(e,t);else if("serverStream"===s)handleServerStreaming(e,t);else{if("bidi"!==s)return!1;handleBidiStreaming(e,t)}return!0}_setupHandlers(e,t){if(null===e)return;const s=e.address();let r="null";s&&(r="string"==typeof s?s:s.address+":"+s.port),this.serverAddressString=r;const n=this.channelzEnabled?this._channelzHandler:this._streamHandler,i=this.channelzEnabled?this._channelzSessionHandler(e):this._sessionHandler(e);e.on("stream",n.bind(this,t)),e.on("session",i)}_sessionHandler(e){return t=>{var s,r;null===(s=this.http2Servers.get(e))||void 0===s||s.sessions.add(t);let n=null,i=null,a=null,o=!1;const l=this.enableIdleTimeout(t);if(2147483647!==this.maxConnectionAgeMs){const e=this.maxConnectionAgeMs/10,s=Math.random()*e*2-e;n=setTimeout((()=>{var e,s;o=!0,this.trace("Connection dropped by max connection age: "+(null===(e=t.socket)||void 0===e?void 0:e.remoteAddress));try{t.goaway(http2.constants.NGHTTP2_NO_ERROR,~(1<<31),kMaxAge)}catch(e){return void t.destroy()}t.close(),2147483647!==this.maxConnectionAgeGraceMs&&(i=setTimeout((()=>{t.destroy()}),this.maxConnectionAgeGraceMs),null===(s=i.unref)||void 0===s||s.call(i))}),this.maxConnectionAgeMs+s),null===(r=n.unref)||void 0===r||r.call(n)}const c=()=>{a&&(clearTimeout(a),a=null)},d=()=>!t.destroyed&&this.keepaliveTimeMs<2147483647&&this.keepaliveTimeMs>0;let h;const u=()=>{var e;d()&&(this.keepaliveTrace("Starting keepalive timer for "+this.keepaliveTimeMs+"ms"),a=setTimeout((()=>{c(),h()}),this.keepaliveTimeMs),null===(e=a.unref)||void 0===e||e.call(a))};h=()=>{var e;if(!d())return;this.keepaliveTrace("Sending ping with timeout "+this.keepaliveTimeoutMs+"ms");let s="";try{t.ping(((e,s,r)=>{c(),e?(this.keepaliveTrace("Ping failed with error: "+e.message),o=!0,t.close()):(this.keepaliveTrace("Received ping response"),u())}))||(s="Ping returned false")}catch(e){s=(e instanceof Error?e.message:"")||"Unknown error"}if(s)return this.keepaliveTrace("Ping send failed: "+s),this.trace("Connection dropped due to ping send error: "+s),o=!0,void t.close();a=setTimeout((()=>{c(),this.keepaliveTrace("Ping timeout passed without response"),this.trace("Connection dropped by keepalive timeout"),o=!0,t.close()}),this.keepaliveTimeoutMs),null===(e=a.unref)||void 0===e||e.call(a)},u(),t.on("close",(()=>{var s,r;o||this.trace(`Connection dropped by client ${null===(s=t.socket)||void 0===s?void 0:s.remoteAddress}`),n&&clearTimeout(n),i&&clearTimeout(i),c(),null!==l&&(clearTimeout(l.timeout),this.sessionIdleTimeouts.delete(t)),null===(r=this.http2Servers.get(e))||void 0===r||r.sessions.delete(t)}))}}_channelzSessionHandler(e){return t=>{var s,r,n,i;const a=(0,channelz_1.registerChannelzSocket)(null!==(r=null===(s=t.socket)||void 0===s?void 0:s.remoteAddress)&&void 0!==r?r:"unknown",this.getChannelzSessionInfo.bind(this,t),this.channelzEnabled),o={ref:a,streamTracker:new channelz_1.ChannelzCallTracker,messagesSent:0,messagesReceived:0,keepAlivesSent:0,lastMessageSentTimestamp:null,lastMessageReceivedTimestamp:null};null===(n=this.http2Servers.get(e))||void 0===n||n.sessions.add(t),this.sessions.set(t,o);const l=`${t.socket.remoteAddress}:${t.socket.remotePort}`;this.channelzTrace.addTrace("CT_INFO","Connection established by client "+l),this.trace("Connection established by client "+l),this.sessionChildrenTracker.refChild(a);let c=null,d=null,h=null,u=!1;const m=this.enableIdleTimeout(t);if(2147483647!==this.maxConnectionAgeMs){const e=this.maxConnectionAgeMs/10,s=Math.random()*e*2-e;c=setTimeout((()=>{var e;u=!0,this.channelzTrace.addTrace("CT_INFO","Connection dropped by max connection age from "+l);try{t.goaway(http2.constants.NGHTTP2_NO_ERROR,~(1<<31),kMaxAge)}catch(e){return void t.destroy()}t.close(),2147483647!==this.maxConnectionAgeGraceMs&&(d=setTimeout((()=>{t.destroy()}),this.maxConnectionAgeGraceMs),null===(e=d.unref)||void 0===e||e.call(d))}),this.maxConnectionAgeMs+s),null===(i=c.unref)||void 0===i||i.call(c)}const p=()=>{h&&(clearTimeout(h),h=null)},v=()=>!t.destroyed&&this.keepaliveTimeMs<2147483647&&this.keepaliveTimeMs>0;let g;const S=()=>{var e;v()&&(this.keepaliveTrace("Starting keepalive timer for "+this.keepaliveTimeMs+"ms"),h=setTimeout((()=>{p(),g()}),this.keepaliveTimeMs),null===(e=h.unref)||void 0===e||e.call(h))};g=()=>{var e;if(!v())return;this.keepaliveTrace("Sending ping with timeout "+this.keepaliveTimeoutMs+"ms");let s="";try{t.ping(((e,s,r)=>{p(),e?(this.keepaliveTrace("Ping failed with error: "+e.message),this.channelzTrace.addTrace("CT_INFO","Connection dropped due to error of a ping frame "+e.message+" return in "+s),u=!0,t.close()):(this.keepaliveTrace("Received ping response"),S())}))||(s="Ping returned false")}catch(e){s=(e instanceof Error?e.message:"")||"Unknown error"}if(s)return this.keepaliveTrace("Ping send failed: "+s),this.channelzTrace.addTrace("CT_INFO","Connection dropped due to ping send error: "+s),u=!0,void t.close();o.keepAlivesSent+=1,h=setTimeout((()=>{p(),this.keepaliveTrace("Ping timeout passed without response"),this.channelzTrace.addTrace("CT_INFO","Connection dropped by keepalive timeout from "+l),u=!0,t.close()}),this.keepaliveTimeoutMs),null===(e=h.unref)||void 0===e||e.call(h)},S(),t.on("close",(()=>{var s;u||this.channelzTrace.addTrace("CT_INFO","Connection dropped by client "+l),this.sessionChildrenTracker.unrefChild(a),(0,channelz_1.unregisterChannelzRef)(a),c&&clearTimeout(c),d&&clearTimeout(d),p(),null!==m&&(clearTimeout(m.timeout),this.sessionIdleTimeouts.delete(t)),null===(s=this.http2Servers.get(e))||void 0===s||s.sessions.delete(t),this.sessions.delete(t)}))}}enableIdleTimeout(e){var t,s;if(this.sessionIdleTimeout>=2147483647)return null;const r={activeStreams:0,lastIdle:Date.now(),onClose:this.onStreamClose.bind(this,e),timeout:setTimeout(this.onIdleTimeout,this.sessionIdleTimeout,this,e)};null===(s=(t=r.timeout).unref)||void 0===s||s.call(t),this.sessionIdleTimeouts.set(e,r);const{socket:n}=e;return this.trace("Enable idle timeout for "+n.remoteAddress+":"+n.remotePort),r}onIdleTimeout(e,t){const{socket:s}=t,r=e.sessionIdleTimeouts.get(t);void 0!==r&&0===r.activeStreams&&(Date.now()-r.lastIdle>=e.sessionIdleTimeout?(e.trace("Session idle timeout triggered for "+(null==s?void 0:s.remoteAddress)+":"+(null==s?void 0:s.remotePort)+" last idle at "+r.lastIdle),e.closeSession(t)):r.timeout.refresh())}onStreamOpened(e){const t=e.session,s=this.sessionIdleTimeouts.get(t);s&&(s.activeStreams+=1,e.once("close",s.onClose))}onStreamClose(e){var t,s;const r=this.sessionIdleTimeouts.get(e);r&&(r.activeStreams-=1,0===r.activeStreams&&(r.lastIdle=Date.now(),r.timeout.refresh(),this.trace("Session onStreamClose"+(null===(t=e.socket)||void 0===t?void 0:t.remoteAddress)+":"+(null===(s=e.socket)||void 0===s?void 0:s.remotePort)+" at "+r.lastIdle)))}},(()=>{const r="function"==typeof Symbol&&Symbol.metadata?Object.create(null):void 0;t=[deprecate("Calling start() is no longer necessary. It can be safely omitted.")],__esDecorate(e,null,t,{kind:"method",name:"start",static:!1,private:!1,access:{has:e=>"start"in e,get:e=>e.start},metadata:r},null,s),r&&Object.defineProperty(e,Symbol.metadata,{enumerable:!0,configurable:!0,writable:!0,value:r})})(),e})();async function handleUnary(e,t){let s,r;function n(t,s,r,n){t?e.sendStatus((0,server_call_1.serverErrorToStatus)(t,r)):e.sendMessage(s,(()=>{e.sendStatus({code:constants_1.Status.OK,details:"OK",metadata:null!=r?r:null})}))}let i=null;e.start({onReceiveMetadata(t){r=t,e.startRead()},onReceiveMessage(s){i?e.sendStatus({code:constants_1.Status.UNIMPLEMENTED,details:`Received a second request message for server streaming method ${t.path}`,metadata:null}):(i=s,e.startRead())},onReceiveHalfClose(){if(i){s=new server_call_1.ServerWritableStreamImpl(t.path,e,r,i);try{t.func(s,n)}catch(t){e.sendStatus({code:constants_1.Status.UNKNOWN,details:`Server method handler threw error ${t.message}`,metadata:null})}}else e.sendStatus({code:constants_1.Status.UNIMPLEMENTED,details:`Received no request message for server streaming method ${t.path}`,metadata:null})},onCancel(){s&&(s.cancelled=!0,s.emit("cancelled","cancelled"))}})}function handleClientStreaming(e,t){let s;function r(t,s,r,n){t?e.sendStatus((0,server_call_1.serverErrorToStatus)(t,r)):e.sendMessage(s,(()=>{e.sendStatus({code:constants_1.Status.OK,details:"OK",metadata:null!=r?r:null})}))}e.start({onReceiveMetadata(n){s=new server_call_1.ServerDuplexStreamImpl(t.path,e,n);try{t.func(s,r)}catch(t){e.sendStatus({code:constants_1.Status.UNKNOWN,details:`Server method handler threw error ${t.message}`,metadata:null})}},onReceiveMessage(e){s.push(e)},onReceiveHalfClose(){s.push(null)},onCancel(){s&&(s.cancelled=!0,s.emit("cancelled","cancelled"),s.destroy())}})}function handleServerStreaming(e,t){let s,r,n=null;e.start({onReceiveMetadata(t){r=t,e.startRead()},onReceiveMessage(s){n?e.sendStatus({code:constants_1.Status.UNIMPLEMENTED,details:`Received a second request message for server streaming method ${t.path}`,metadata:null}):(n=s,e.startRead())},onReceiveHalfClose(){if(n){s=new server_call_1.ServerWritableStreamImpl(t.path,e,r,n);try{t.func(s)}catch(t){e.sendStatus({code:constants_1.Status.UNKNOWN,details:`Server method handler threw error ${t.message}`,metadata:null})}}else e.sendStatus({code:constants_1.Status.UNIMPLEMENTED,details:`Received no request message for server streaming method ${t.path}`,metadata:null})},onCancel(){s&&(s.cancelled=!0,s.emit("cancelled","cancelled"),s.destroy())}})}function handleBidiStreaming(e,t){let s;e.start({onReceiveMetadata(r){s=new server_call_1.ServerDuplexStreamImpl(t.path,e,r);try{t.func(s)}catch(t){e.sendStatus({code:constants_1.Status.UNKNOWN,details:`Server method handler threw error ${t.message}`,metadata:null})}},onReceiveMessage(e){s.push(e)},onReceiveHalfClose(){s.push(null)},onCancel(){s&&(s.cancelled=!0,s.emit("cancelled","cancelled"),s.destroy())}})}exports.Server=Server;