"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.extractAndSelectServiceConfig=exports.validateServiceConfig=exports.validateRetryThrottling=void 0;const os=require("os"),constants_1=require("./constants"),DURATION_REGEX=/^\d+(\.\d{1,9})?s$/,CLIENT_LANGUAGE_STRING="node";function validateName(e){if("service"in e&&""!==e.service){if("string"!=typeof e.service)throw new Error("Invalid method config name: invalid service: expected type string, got "+typeof e.service);if("method"in e&&""!==e.method){if("string"!=typeof e.method)throw new Error("Invalid method config name: invalid method: expected type string, got "+typeof e.service);return{service:e.service,method:e.method}}return{service:e.service}}if("method"in e&&void 0!==e.method)throw new Error("Invalid method config name: method set with empty or unset service");return{}}function validateRetryPolicy(e){if(!("maxAttempts"in e)||!Number.isInteger(e.maxAttempts)||e.maxAttempts<2)throw new Error("Invalid method config retry policy: maxAttempts must be an integer at least 2");if(!("initialBackoff"in e)||"string"!=typeof e.initialBackoff||!DURATION_REGEX.test(e.initialBackoff))throw new Error("Invalid method config retry policy: initialBackoff must be a string consisting of a positive integer or decimal followed by s");if(!("maxBackoff"in e)||"string"!=typeof e.maxBackoff||!DURATION_REGEX.test(e.maxBackoff))throw new Error("Invalid method config retry policy: maxBackoff must be a string consisting of a positive integer or decimal followed by s");if(!("backoffMultiplier"in e)||"number"!=typeof e.backoffMultiplier||e.backoffMultiplier<=0)throw new Error("Invalid method config retry policy: backoffMultiplier must be a number greater than 0");if(!("retryableStatusCodes"in e)||!Array.isArray(e.retryableStatusCodes))throw new Error("Invalid method config retry policy: retryableStatusCodes is required");if(0===e.retryableStatusCodes.length)throw new Error("Invalid method config retry policy: retryableStatusCodes must be non-empty");for(const t of e.retryableStatusCodes)if("number"==typeof t){if(!Object.values(constants_1.Status).includes(t))throw new Error("Invalid method config retry policy: retryableStatusCodes value not in status code range")}else{if("string"!=typeof t)throw new Error("Invalid method config retry policy: retryableStatusCodes value must be a string or number");if(!Object.values(constants_1.Status).includes(t.toUpperCase()))throw new Error("Invalid method config retry policy: retryableStatusCodes value not a status code name")}return{maxAttempts:e.maxAttempts,initialBackoff:e.initialBackoff,maxBackoff:e.maxBackoff,backoffMultiplier:e.backoffMultiplier,retryableStatusCodes:e.retryableStatusCodes}}function validateHedgingPolicy(e){if(!("maxAttempts"in e)||!Number.isInteger(e.maxAttempts)||e.maxAttempts<2)throw new Error("Invalid method config hedging policy: maxAttempts must be an integer at least 2");if("hedgingDelay"in e&&("string"!=typeof e.hedgingDelay||!DURATION_REGEX.test(e.hedgingDelay)))throw new Error("Invalid method config hedging policy: hedgingDelay must be a string consisting of a positive integer followed by s");if("nonFatalStatusCodes"in e&&Array.isArray(e.nonFatalStatusCodes))for(const t of e.nonFatalStatusCodes)if("number"==typeof t){if(!Object.values(constants_1.Status).includes(t))throw new Error("Invalid method config hedging policy: nonFatalStatusCodes value not in status code range")}else{if("string"!=typeof t)throw new Error("Invalid method config hedging policy: nonFatalStatusCodes value must be a string or number");if(!Object.values(constants_1.Status).includes(t.toUpperCase()))throw new Error("Invalid method config hedging policy: nonFatalStatusCodes value not a status code name")}const t={maxAttempts:e.maxAttempts};return e.hedgingDelay&&(t.hedgingDelay=e.hedgingDelay),e.nonFatalStatusCodes&&(t.nonFatalStatusCodes=e.nonFatalStatusCodes),t}function validateMethodConfig(e){var t;const i={name:[]};if(!("name"in e)||!Array.isArray(e.name))throw new Error("Invalid method config: invalid name array");for(const t of e.name)i.name.push(validateName(t));if("waitForReady"in e){if("boolean"!=typeof e.waitForReady)throw new Error("Invalid method config: invalid waitForReady");i.waitForReady=e.waitForReady}if("timeout"in e)if("object"==typeof e.timeout){if(!("seconds"in e.timeout)||"number"!=typeof e.timeout.seconds)throw new Error("Invalid method config: invalid timeout.seconds");if(!("nanos"in e.timeout)||"number"!=typeof e.timeout.nanos)throw new Error("Invalid method config: invalid timeout.nanos");i.timeout=e.timeout}else{if("string"!=typeof e.timeout||!DURATION_REGEX.test(e.timeout))throw new Error("Invalid method config: invalid timeout");{const n=e.timeout.substring(0,e.timeout.length-1).split(".");i.timeout={seconds:0|n[0],nanos:0|(null!==(t=n[1])&&void 0!==t?t:0)}}}if("maxRequestBytes"in e){if("number"!=typeof e.maxRequestBytes)throw new Error("Invalid method config: invalid maxRequestBytes");i.maxRequestBytes=e.maxRequestBytes}if("maxResponseBytes"in e){if("number"!=typeof e.maxResponseBytes)throw new Error("Invalid method config: invalid maxRequestBytes");i.maxResponseBytes=e.maxResponseBytes}if("retryPolicy"in e){if("hedgingPolicy"in e)throw new Error("Invalid method config: retryPolicy and hedgingPolicy cannot both be specified");i.retryPolicy=validateRetryPolicy(e.retryPolicy)}else"hedgingPolicy"in e&&(i.hedgingPolicy=validateHedgingPolicy(e.hedgingPolicy));return i}function validateRetryThrottling(e){if(!("maxTokens"in e)||"number"!=typeof e.maxTokens||e.maxTokens<=0||e.maxTokens>1e3)throw new Error("Invalid retryThrottling: maxTokens must be a number in (0, 1000]");if(!("tokenRatio"in e)||"number"!=typeof e.tokenRatio||e.tokenRatio<=0)throw new Error("Invalid retryThrottling: tokenRatio must be a number greater than 0");return{maxTokens:+e.maxTokens.toFixed(3),tokenRatio:+e.tokenRatio.toFixed(3)}}function validateLoadBalancingConfig(e){if("object"!=typeof e||null===e)throw new Error("Invalid loadBalancingConfig: unexpected type "+typeof e);const t=Object.keys(e);if(t.length>1)throw new Error(`Invalid loadBalancingConfig: unexpected multiple keys ${t}`);if(0===t.length)throw new Error("Invalid loadBalancingConfig: load balancing policy name required");return{[t[0]]:e[t[0]]}}function validateServiceConfig(e){const t={loadBalancingConfig:[],methodConfig:[]};if("loadBalancingPolicy"in e){if("string"!=typeof e.loadBalancingPolicy)throw new Error("Invalid service config: invalid loadBalancingPolicy");t.loadBalancingPolicy=e.loadBalancingPolicy}if("loadBalancingConfig"in e){if(!Array.isArray(e.loadBalancingConfig))throw new Error("Invalid service config: invalid loadBalancingConfig");for(const i of e.loadBalancingConfig)t.loadBalancingConfig.push(validateLoadBalancingConfig(i))}if("methodConfig"in e&&Array.isArray(e.methodConfig))for(const i of e.methodConfig)t.methodConfig.push(validateMethodConfig(i));"retryThrottling"in e&&(t.retryThrottling=validateRetryThrottling(e.retryThrottling));const i=[];for(const e of t.methodConfig)for(const t of e.name){for(const e of i)if(t.service===e.service&&t.method===e.method)throw new Error(`Invalid service config: duplicate name ${t.service}/${t.method}`);i.push(t)}return t}function validateCanaryConfig(e){if(!("serviceConfig"in e))throw new Error("Invalid service config choice: missing service config");const t={serviceConfig:validateServiceConfig(e.serviceConfig)};if("clientLanguage"in e){if(!Array.isArray(e.clientLanguage))throw new Error("Invalid service config choice: invalid clientLanguage");t.clientLanguage=[];for(const i of e.clientLanguage){if("string"!=typeof i)throw new Error("Invalid service config choice: invalid clientLanguage");t.clientLanguage.push(i)}}if("clientHostname"in e){if(!Array.isArray(e.clientHostname))throw new Error("Invalid service config choice: invalid clientHostname");t.clientHostname=[];for(const i of e.clientHostname){if("string"!=typeof i)throw new Error("Invalid service config choice: invalid clientHostname");t.clientHostname.push(i)}}if("percentage"in e){if(!("number"==typeof e.percentage&&0<=e.percentage&&e.percentage<=100))throw new Error("Invalid service config choice: invalid percentage");t.percentage=e.percentage}const i=["clientLanguage","percentage","clientHostname","serviceConfig"];for(const t in e)if(!i.includes(t))throw new Error(`Invalid service config choice: unexpected field ${t}`);return t}function validateAndSelectCanaryConfig(e,t){if(!Array.isArray(e))throw new Error("Invalid service config list");for(const i of e){const e=validateCanaryConfig(i);if(!("number"==typeof e.percentage&&t>e.percentage)){if(Array.isArray(e.clientHostname)){let t=!1;for(const i of e.clientHostname)i===os.hostname()&&(t=!0);if(!t)continue}if(Array.isArray(e.clientLanguage)){let t=!1;for(const i of e.clientLanguage)i===CLIENT_LANGUAGE_STRING&&(t=!0);if(!t)continue}return e.serviceConfig}}throw new Error("No matching service config found")}function extractAndSelectServiceConfig(e,t){for(const i of e)if(i.length>0&&i[0].startsWith("grpc_config=")){const e=i.join("").substring(12);return validateAndSelectCanaryConfig(JSON.parse(e),t)}return null}exports.validateRetryThrottling=validateRetryThrottling,exports.validateServiceConfig=validateServiceConfig,exports.extractAndSelectServiceConfig=extractAndSelectServiceConfig;