"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Http2SubchannelCall=void 0;const http2=require("http2"),os=require("os"),constants_1=require("./constants"),metadata_1=require("./metadata"),stream_decoder_1=require("./stream-decoder"),logging=require("./logging"),constants_2=require("./constants"),TRACER_NAME="subchannel_call";function getSystemErrorName(t){for(const[e,s]of Object.entries(os.constants.errno))if(s===t)return e;return"Unknown system error "+t}function mapHttpStatusCode(t){const e=`Received HTTP status code ${t}`;let s;switch(t){case 400:s=constants_1.Status.INTERNAL;break;case 401:s=constants_1.Status.UNAUTHENTICATED;break;case 403:s=constants_1.Status.PERMISSION_DENIED;break;case 404:s=constants_1.Status.UNIMPLEMENTED;break;case 429:case 502:case 503:case 504:s=constants_1.Status.UNAVAILABLE;break;default:s=constants_1.Status.UNKNOWN}return{code:s,details:e,metadata:new metadata_1.Metadata}}class Http2SubchannelCall{constructor(t,e,s,a,n){var r;this.http2Stream=t,this.callEventTracker=e,this.listener=s,this.transport=a,this.callId=n,this.isReadFilterPending=!1,this.isPushPending=!1,this.canPush=!1,this.readsClosed=!1,this.statusOutput=!1,this.unpushedReadMessages=[],this.finalStatus=null,this.internalError=null,this.serverEndedCall=!1;const i=null!==(r=a.getOptions()["grpc.max_receive_message_length"])&&void 0!==r?r:constants_1.DEFAULT_MAX_RECEIVE_MESSAGE_LENGTH;this.decoder=new stream_decoder_1.StreamDecoder(i),t.on("response",((t,e)=>{let s="";for(const e of Object.keys(t))s+="\t\t"+e+": "+t[e]+"\n";if(this.trace("Received server headers:\n"+s),this.httpStatusCode=t[":status"],e&http2.constants.NGHTTP2_FLAG_END_STREAM)this.handleTrailers(t);else{let e;try{e=metadata_1.Metadata.fromHttp2Headers(t)}catch(t){return void this.endCall({code:constants_1.Status.UNKNOWN,details:t.message,metadata:new metadata_1.Metadata})}this.listener.onReceiveMetadata(e)}})),t.on("trailers",(t=>{this.handleTrailers(t)})),t.on("data",(t=>{if(this.statusOutput)return;let e;this.trace("receive HTTP/2 data frame of length "+t.length);try{e=this.decoder.write(t)}catch(t){return void this.cancelWithStatus(constants_1.Status.RESOURCE_EXHAUSTED,t.message)}for(const t of e)this.trace("parsed message of length "+t.length),this.callEventTracker.addMessageReceived(),this.tryPush(t)})),t.on("end",(()=>{this.readsClosed=!0,this.maybeOutputStatus()})),t.on("close",(()=>{this.serverEndedCall=!0,process.nextTick((()=>{var e;if(this.trace("HTTP/2 stream closed with code "+t.rstCode),(null===(e=this.finalStatus)||void 0===e?void 0:e.code)===constants_1.Status.OK)return;let s,a="";switch(t.rstCode){case http2.constants.NGHTTP2_NO_ERROR:if(null!==this.finalStatus)return;if(this.httpStatusCode&&200!==this.httpStatusCode){const t=mapHttpStatusCode(this.httpStatusCode);s=t.code,a=t.details}else s=constants_1.Status.INTERNAL,a=`Received RST_STREAM with code ${t.rstCode} (Call ended without gRPC status)`;break;case http2.constants.NGHTTP2_REFUSED_STREAM:s=constants_1.Status.UNAVAILABLE,a="Stream refused by server";break;case http2.constants.NGHTTP2_CANCEL:s=constants_1.Status.CANCELLED,a="Call cancelled";break;case http2.constants.NGHTTP2_ENHANCE_YOUR_CALM:s=constants_1.Status.RESOURCE_EXHAUSTED,a="Bandwidth exhausted or memory limit exceeded";break;case http2.constants.NGHTTP2_INADEQUATE_SECURITY:s=constants_1.Status.PERMISSION_DENIED,a="Protocol not secure enough";break;case http2.constants.NGHTTP2_INTERNAL_ERROR:s=constants_1.Status.INTERNAL,null===this.internalError?a=`Received RST_STREAM with code ${t.rstCode} (Internal server error)`:"ECONNRESET"===this.internalError.code||"ETIMEDOUT"===this.internalError.code?(s=constants_1.Status.UNAVAILABLE,a=this.internalError.message):a=`Received RST_STREAM with code ${t.rstCode} triggered by internal client error: ${this.internalError.message}`;break;default:s=constants_1.Status.INTERNAL,a=`Received RST_STREAM with code ${t.rstCode}`}this.endCall({code:s,details:a,metadata:new metadata_1.Metadata,rstCode:t.rstCode})}))})),t.on("error",(t=>{"ERR_HTTP2_STREAM_ERROR"!==t.code&&(this.trace("Node error event: message="+t.message+" code="+t.code+" errno="+getSystemErrorName(t.errno)+" syscall="+t.syscall),this.internalError=t),this.callEventTracker.onStreamEnd(!1)}))}getDeadlineInfo(){return[`remote_addr=${this.getPeer()}`]}onDisconnect(){this.endCall({code:constants_1.Status.UNAVAILABLE,details:"Connection dropped",metadata:new metadata_1.Metadata})}outputStatus(){this.statusOutput||(this.statusOutput=!0,this.trace("ended with status: code="+this.finalStatus.code+' details="'+this.finalStatus.details+'"'),this.callEventTracker.onCallEnd(this.finalStatus),process.nextTick((()=>{this.listener.onReceiveStatus(this.finalStatus)})),this.http2Stream.resume())}trace(t){logging.trace(constants_2.LogVerbosity.DEBUG,TRACER_NAME,"["+this.callId+"] "+t)}endCall(t){null!==this.finalStatus&&this.finalStatus.code!==constants_1.Status.OK||(this.finalStatus=t,this.maybeOutputStatus()),this.destroyHttp2Stream()}maybeOutputStatus(){null!==this.finalStatus&&(this.finalStatus.code!==constants_1.Status.OK||this.readsClosed&&0===this.unpushedReadMessages.length&&!this.isReadFilterPending&&!this.isPushPending)&&this.outputStatus()}push(t){this.trace("pushing to reader message of length "+(t instanceof Buffer?t.length:null)),this.canPush=!1,this.isPushPending=!0,process.nextTick((()=>{this.isPushPending=!1,this.statusOutput||(this.listener.onReceiveMessage(t),this.maybeOutputStatus())}))}tryPush(t){this.canPush?(this.http2Stream.pause(),this.push(t)):(this.trace("unpushedReadMessages.push message of length "+t.length),this.unpushedReadMessages.push(t))}handleTrailers(t){this.serverEndedCall=!0,this.callEventTracker.onStreamEnd(!0);let e,s="";for(const e of Object.keys(t))s+="\t\t"+e+": "+t[e]+"\n";this.trace("Received server trailers:\n"+s);try{e=metadata_1.Metadata.fromHttp2Headers(t)}catch(t){e=new metadata_1.Metadata}const a=e.getMap();let n;if("string"==typeof a["grpc-status"]){const t=Number(a["grpc-status"]);this.trace("received status code "+t+" from server"),e.remove("grpc-status");let s="";if("string"==typeof a["grpc-message"]){try{s=decodeURI(a["grpc-message"])}catch(t){s=a["grpc-message"]}e.remove("grpc-message"),this.trace('received status details string "'+s+'" from server')}n={code:t,details:s,metadata:e}}else this.httpStatusCode?(n=mapHttpStatusCode(this.httpStatusCode),n.metadata=e):n={code:constants_1.Status.UNKNOWN,details:"No status information received",metadata:e};this.endCall(n)}destroyHttp2Stream(){var t;if(!this.http2Stream.destroyed)if(this.serverEndedCall)this.http2Stream.end();else{let e;e=(null===(t=this.finalStatus)||void 0===t?void 0:t.code)===constants_1.Status.OK?http2.constants.NGHTTP2_NO_ERROR:http2.constants.NGHTTP2_CANCEL,this.trace("close http2 stream with code "+e),this.http2Stream.close(e)}}cancelWithStatus(t,e){this.trace("cancelWithStatus code: "+t+' details: "'+e+'"'),this.endCall({code:t,details:e,metadata:new metadata_1.Metadata})}getStatus(){return this.finalStatus}getPeer(){return this.transport.getPeerName()}getCallNumber(){return this.callId}startRead(){if(null!==this.finalStatus&&this.finalStatus.code!==constants_1.Status.OK)return this.readsClosed=!0,void this.maybeOutputStatus();if(this.canPush=!0,this.unpushedReadMessages.length>0){const t=this.unpushedReadMessages.shift();this.push(t)}else this.http2Stream.resume()}sendMessageWithContext(t,e){this.trace("write() called with message of length "+e.length);const s=e=>{process.nextTick((()=>{var s;let a=constants_1.Status.UNAVAILABLE;"ERR_STREAM_WRITE_AFTER_END"===(null==e?void 0:e.code)&&(a=constants_1.Status.INTERNAL),e&&this.cancelWithStatus(a,`Write error: ${e.message}`),null===(s=t.callback)||void 0===s||s.call(t)}))};this.trace("sending data chunk of length "+e.length),this.callEventTracker.addMessageSent();try{this.http2Stream.write(e,s)}catch(t){this.endCall({code:constants_1.Status.UNAVAILABLE,details:`Write failed with error ${t.message}`,metadata:new metadata_1.Metadata})}}halfClose(){this.trace("end() called"),this.trace("calling end() on HTTP/2 stream"),this.http2Stream.end()}}exports.Http2SubchannelCall=Http2SubchannelCall;