"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Subchannel=void 0;const connectivity_state_1=require("./connectivity-state"),backoff_timeout_1=require("./backoff-timeout"),logging=require("./logging"),constants_1=require("./constants"),uri_parser_1=require("./uri-parser"),subchannel_address_1=require("./subchannel-address"),channelz_1=require("./channelz"),TRACER_NAME="subchannel",KEEPALIVE_MAX_TIME_MS=~(1<<31);class Subchannel{constructor(t,e,n,i,a){var c;this.channelTarget=t,this.subchannelAddress=e,this.options=n,this.credentials=i,this.connector=a,this.connectivityState=connectivity_state_1.ConnectivityState.IDLE,this.transport=null,this.continueConnecting=!1,this.stateListeners=new Set,this.refcount=0,this.channelzEnabled=!0;const s={initialDelay:n["grpc.initial_reconnect_backoff_ms"],maxDelay:n["grpc.max_reconnect_backoff_ms"]};this.backoffTimeout=new backoff_timeout_1.BackoffTimeout((()=>{this.handleBackoffTimer()}),s),this.backoffTimeout.unref(),this.subchannelAddressString=(0,subchannel_address_1.subchannelAddressToString)(e),this.keepaliveTime=null!==(c=n["grpc.keepalive_time_ms"])&&void 0!==c?c:-1,0===n["grpc.enable_channelz"]?(this.channelzEnabled=!1,this.channelzTrace=new channelz_1.ChannelzTraceStub,this.callTracker=new channelz_1.ChannelzCallTrackerStub,this.childrenTracker=new channelz_1.ChannelzChildrenTrackerStub,this.streamTracker=new channelz_1.ChannelzCallTrackerStub):(this.channelzTrace=new channelz_1.ChannelzTrace,this.callTracker=new channelz_1.ChannelzCallTracker,this.childrenTracker=new channelz_1.ChannelzChildrenTracker,this.streamTracker=new channelz_1.ChannelzCallTracker),this.channelzRef=(0,channelz_1.registerChannelzSubchannel)(this.subchannelAddressString,(()=>this.getChannelzInfo()),this.channelzEnabled),this.channelzTrace.addTrace("CT_INFO","Subchannel created"),this.trace("Subchannel constructed with options "+JSON.stringify(n,void 0,2)),i._ref()}getChannelzInfo(){return{state:this.connectivityState,trace:this.channelzTrace,callTracker:this.callTracker,children:this.childrenTracker.getChildLists(),target:this.subchannelAddressString}}trace(t){logging.trace(constants_1.LogVerbosity.DEBUG,TRACER_NAME,"("+this.channelzRef.id+") "+this.subchannelAddressString+" "+t)}refTrace(t){logging.trace(constants_1.LogVerbosity.DEBUG,"subchannel_refcount","("+this.channelzRef.id+") "+this.subchannelAddressString+" "+t)}handleBackoffTimer(){this.continueConnecting?this.transitionToState([connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE],connectivity_state_1.ConnectivityState.CONNECTING):this.transitionToState([connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE],connectivity_state_1.ConnectivityState.IDLE)}startBackoff(){this.backoffTimeout.runOnce()}stopBackoff(){this.backoffTimeout.stop(),this.backoffTimeout.reset()}startConnectingInternal(){let t=this.options;if(t["grpc.keepalive_time_ms"]){const e=Math.min(this.keepaliveTime,2147483647);t=Object.assign(Object.assign({},t),{"grpc.keepalive_time_ms":e})}this.connector.connect(this.subchannelAddress,this.credentials,t).then((t=>{this.transitionToState([connectivity_state_1.ConnectivityState.CONNECTING],connectivity_state_1.ConnectivityState.READY)?(this.transport=t,this.channelzEnabled&&this.childrenTracker.refChild(t.getChannelzRef()),t.addDisconnectListener((t=>{this.transitionToState([connectivity_state_1.ConnectivityState.READY],connectivity_state_1.ConnectivityState.IDLE),t&&this.keepaliveTime>0&&(this.keepaliveTime*=2,logging.log(constants_1.LogVerbosity.ERROR,`Connection to ${(0,uri_parser_1.uriToString)(this.channelTarget)} at ${this.subchannelAddressString} rejected by server because of excess pings. Increasing ping interval to ${this.keepaliveTime} ms`))}))):t.shutdown()}),(t=>{this.transitionToState([connectivity_state_1.ConnectivityState.CONNECTING],connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE,`${t}`)}))}transitionToState(t,e,n){var i,a;if(-1===t.indexOf(this.connectivityState))return!1;n?this.trace(connectivity_state_1.ConnectivityState[this.connectivityState]+" -> "+connectivity_state_1.ConnectivityState[e]+' with error "'+n+'"'):this.trace(connectivity_state_1.ConnectivityState[this.connectivityState]+" -> "+connectivity_state_1.ConnectivityState[e]),this.channelzEnabled&&this.channelzTrace.addTrace("CT_INFO","Connectivity state change to "+connectivity_state_1.ConnectivityState[e]);const c=this.connectivityState;switch(this.connectivityState=e,e){case connectivity_state_1.ConnectivityState.READY:this.stopBackoff();break;case connectivity_state_1.ConnectivityState.CONNECTING:this.startBackoff(),this.startConnectingInternal(),this.continueConnecting=!1;break;case connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE:this.channelzEnabled&&this.transport&&this.childrenTracker.unrefChild(this.transport.getChannelzRef()),null===(i=this.transport)||void 0===i||i.shutdown(),this.transport=null,this.backoffTimeout.isRunning()||process.nextTick((()=>{this.handleBackoffTimer()}));break;case connectivity_state_1.ConnectivityState.IDLE:this.channelzEnabled&&this.transport&&this.childrenTracker.unrefChild(this.transport.getChannelzRef()),null===(a=this.transport)||void 0===a||a.shutdown(),this.transport=null;break;default:throw new Error(`Invalid state: unknown ConnectivityState ${e}`)}for(const t of this.stateListeners)t(this,c,e,this.keepaliveTime,n);return!0}ref(){this.refTrace("refcount "+this.refcount+" -> "+(this.refcount+1)),this.refcount+=1}unref(){this.refTrace("refcount "+this.refcount+" -> "+(this.refcount-1)),this.refcount-=1,0===this.refcount&&(this.channelzTrace.addTrace("CT_INFO","Shutting down"),(0,channelz_1.unregisterChannelzRef)(this.channelzRef),this.credentials._unref(),process.nextTick((()=>{this.transitionToState([connectivity_state_1.ConnectivityState.CONNECTING,connectivity_state_1.ConnectivityState.READY],connectivity_state_1.ConnectivityState.IDLE)})))}unrefIfOneRef(){return 1===this.refcount&&(this.unref(),!0)}createCall(t,e,n,i){if(!this.transport)throw new Error("Cannot create call, subchannel not READY");let a;return this.channelzEnabled?(this.callTracker.addCallStarted(),this.streamTracker.addCallStarted(),a={onCallEnd:t=>{t.code===constants_1.Status.OK?this.callTracker.addCallSucceeded():this.callTracker.addCallFailed()}}):a={},this.transport.createCall(t,e,n,i,a)}startConnecting(){process.nextTick((()=>{this.transitionToState([connectivity_state_1.ConnectivityState.IDLE],connectivity_state_1.ConnectivityState.CONNECTING)||this.connectivityState===connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE&&(this.continueConnecting=!0)}))}getConnectivityState(){return this.connectivityState}addConnectivityStateListener(t){this.stateListeners.add(t)}removeConnectivityStateListener(t){this.stateListeners.delete(t)}resetBackoff(){process.nextTick((()=>{this.backoffTimeout.reset(),this.transitionToState([connectivity_state_1.ConnectivityState.TRANSIENT_FAILURE],connectivity_state_1.ConnectivityState.CONNECTING)}))}getAddress(){return this.subchannelAddressString}getChannelzRef(){return this.channelzRef}isHealthy(){return!0}addHealthStateWatcher(t){}removeHealthStateWatcher(t){}getRealSubchannel(){return this}realSubchannelEquals(t){return t.getRealSubchannel()===this}throttleKeepalive(t){t>this.keepaliveTime&&(this.keepaliveTime=t)}}exports.Subchannel=Subchannel;