"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Http2SubchannelConnector=void 0;const http2=require("http2"),tls_1=require("tls"),channelz_1=require("./channelz"),constants_1=require("./constants"),http_proxy_1=require("./http_proxy"),logging=require("./logging"),resolver_1=require("./resolver"),subchannel_address_1=require("./subchannel-address"),uri_parser_1=require("./uri-parser"),net=require("net"),subchannel_call_1=require("./subchannel-call"),call_number_1=require("./call-number"),TRACER_NAME="transport",FLOW_CONTROL_TRACER_NAME="transport_flowctrl",clientVersion=require("../../package.json").version,{HTTP2_HEADER_AUTHORITY:HTTP2_HEADER_AUTHORITY,HTTP2_HEADER_CONTENT_TYPE:HTTP2_HEADER_CONTENT_TYPE,HTTP2_HEADER_METHOD:HTTP2_HEADER_METHOD,HTTP2_HEADER_PATH:HTTP2_HEADER_PATH,HTTP2_HEADER_TE:HTTP2_HEADER_TE,HTTP2_HEADER_USER_AGENT:HTTP2_HEADER_USER_AGENT}=http2.constants,KEEPALIVE_TIMEOUT_MS=2e4,tooManyPingsData=Buffer.from("too_many_pings","ascii");class Http2Transport{constructor(e,t,s,i){this.session=e,this.options=s,this.remoteName=i,this.keepaliveTimer=null,this.pendingSendKeepalivePing=!1,this.activeCalls=new Set,this.disconnectListeners=[],this.disconnectHandled=!1,this.channelzEnabled=!0,this.keepalivesSent=0,this.messagesSent=0,this.messagesReceived=0,this.lastMessageSentTimestamp=null,this.lastMessageReceivedTimestamp=null,this.subchannelAddressString=(0,subchannel_address_1.subchannelAddressToString)(t),0===s["grpc.enable_channelz"]?(this.channelzEnabled=!1,this.streamTracker=new channelz_1.ChannelzCallTrackerStub):this.streamTracker=new channelz_1.ChannelzCallTracker,this.channelzRef=(0,channelz_1.registerChannelzSocket)(this.subchannelAddressString,(()=>this.getChannelzInfo()),this.channelzEnabled),this.userAgent=[s["grpc.primary_user_agent"],`grpc-node-js/${clientVersion}`,s["grpc.secondary_user_agent"]].filter((e=>e)).join(" "),this.keepaliveTimeMs="grpc.keepalive_time_ms"in s?s["grpc.keepalive_time_ms"]:-1,this.keepaliveTimeoutMs="grpc.keepalive_timeout_ms"in s?s["grpc.keepalive_timeout_ms"]:2e4,this.keepaliveWithoutCalls="grpc.keepalive_permit_without_calls"in s&&1===s["grpc.keepalive_permit_without_calls"],e.once("close",(()=>{this.trace("session closed"),this.handleDisconnect()})),e.once("goaway",((e,t,s)=>{let i=!1;e===http2.constants.NGHTTP2_ENHANCE_YOUR_CALM&&s&&s.equals(tooManyPingsData)&&(i=!0),this.trace("connection closed by GOAWAY with code "+e+" and data "+(null==s?void 0:s.toString())),this.reportDisconnectToOwner(i)})),e.once("error",(e=>{this.trace("connection closed with error "+e.message),this.handleDisconnect()})),logging.isTracerEnabled("transport")&&(e.on("remoteSettings",(t=>{this.trace("new settings received"+(this.session!==e?" on the old connection":"")+": "+JSON.stringify(t))})),e.on("localSettings",(t=>{this.trace("local settings acknowledged by remote"+(this.session!==e?" on the old connection":"")+": "+JSON.stringify(t))}))),this.keepaliveWithoutCalls&&this.maybeStartKeepalivePingTimer()}getChannelzInfo(){var e,t,s;const i=this.session.socket,n=i.remoteAddress?(0,subchannel_address_1.stringToSubchannelAddress)(i.remoteAddress,i.remotePort):null,r=i.localAddress?(0,subchannel_address_1.stringToSubchannelAddress)(i.localAddress,i.localPort):null;let a;if(this.session.encrypted){const t=i,s=t.getCipher(),n=t.getCertificate(),r=t.getPeerCertificate();a={cipherSuiteStandardName:null!==(e=s.standardName)&&void 0!==e?e:null,cipherSuiteOtherName:s.standardName?null:s.name,localCertificate:n&&"raw"in n?n.raw:null,remoteCertificate:r&&"raw"in r?r.raw:null}}else a=null;return{remoteAddress:n,localAddress:r,security:a,remoteName:this.remoteName,streamsStarted:this.streamTracker.callsStarted,streamsSucceeded:this.streamTracker.callsSucceeded,streamsFailed:this.streamTracker.callsFailed,messagesSent:this.messagesSent,messagesReceived:this.messagesReceived,keepAlivesSent:this.keepalivesSent,lastLocalStreamCreatedTimestamp:this.streamTracker.lastCallStartedTimestamp,lastRemoteStreamCreatedTimestamp:null,lastMessageSentTimestamp:this.lastMessageSentTimestamp,lastMessageReceivedTimestamp:this.lastMessageReceivedTimestamp,localFlowControlWindow:null!==(t=this.session.state.localWindowSize)&&void 0!==t?t:null,remoteFlowControlWindow:null!==(s=this.session.state.remoteWindowSize)&&void 0!==s?s:null}}trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"transport","("+this.channelzRef.id+") "+this.subchannelAddressString+" "+e)}keepaliveTrace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"keepalive","("+this.channelzRef.id+") "+this.subchannelAddressString+" "+e)}flowControlTrace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"transport_flowctrl","("+this.channelzRef.id+") "+this.subchannelAddressString+" "+e)}internalsTrace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"transport_internals","("+this.channelzRef.id+") "+this.subchannelAddressString+" "+e)}reportDisconnectToOwner(e){this.disconnectHandled||(this.disconnectHandled=!0,this.disconnectListeners.forEach((t=>t(e))))}handleDisconnect(){this.disconnectHandled||(this.clearKeepaliveTimeout(),this.reportDisconnectToOwner(!1),setImmediate((()=>{for(const e of this.activeCalls)e.onDisconnect();this.session.destroy()})))}addDisconnectListener(e){this.disconnectListeners.push(e)}canSendPing(){return!this.session.destroyed&&this.keepaliveTimeMs>0&&(this.keepaliveWithoutCalls||this.activeCalls.size>0)}maybeSendPing(){var e,t;if(!this.canSendPing())return void(this.pendingSendKeepalivePing=!0);if(this.keepaliveTimer)return void console.error("keepaliveTimeout is not null");this.channelzEnabled&&(this.keepalivesSent+=1),this.keepaliveTrace("Sending ping with timeout "+this.keepaliveTimeoutMs+"ms"),this.keepaliveTimer=setTimeout((()=>{this.keepaliveTimer=null,this.keepaliveTrace("Ping timeout passed without response"),this.handleDisconnect()}),this.keepaliveTimeoutMs),null===(t=(e=this.keepaliveTimer).unref)||void 0===t||t.call(e);let s="";try{this.session.ping(((e,t,s)=>{this.clearKeepaliveTimeout(),e?(this.keepaliveTrace("Ping failed with error "+e.message),this.handleDisconnect()):(this.keepaliveTrace("Received ping response"),this.maybeStartKeepalivePingTimer())}))||(s="Ping returned false")}catch(e){s=(e instanceof Error?e.message:"")||"Unknown error"}s&&(this.keepaliveTrace("Ping send failed: "+s),this.handleDisconnect())}maybeStartKeepalivePingTimer(){var e,t;this.canSendPing()&&(this.pendingSendKeepalivePing?(this.pendingSendKeepalivePing=!1,this.maybeSendPing()):this.keepaliveTimer||(this.keepaliveTrace("Starting keepalive timer for "+this.keepaliveTimeMs+"ms"),this.keepaliveTimer=setTimeout((()=>{this.keepaliveTimer=null,this.maybeSendPing()}),this.keepaliveTimeMs),null===(t=(e=this.keepaliveTimer).unref)||void 0===t||t.call(e)))}clearKeepaliveTimeout(){this.keepaliveTimer&&(clearTimeout(this.keepaliveTimer),this.keepaliveTimer=null)}removeActiveCall(e){this.activeCalls.delete(e),0===this.activeCalls.size&&this.session.unref()}addActiveCall(e){this.activeCalls.add(e),1===this.activeCalls.size&&(this.session.ref(),this.keepaliveWithoutCalls||this.maybeStartKeepalivePingTimer())}createCall(e,t,s,i,n){const r=e.toHttp2Headers();let a,l,o;r[HTTP2_HEADER_AUTHORITY]=t,r[HTTP2_HEADER_USER_AGENT]=this.userAgent,r[HTTP2_HEADER_CONTENT_TYPE]="application/grpc",r[HTTP2_HEADER_METHOD]="POST",r[HTTP2_HEADER_PATH]=s,r[HTTP2_HEADER_TE]="trailers";try{a=this.session.request(r)}catch(e){throw this.handleDisconnect(),e}return this.flowControlTrace("local window size: "+this.session.state.localWindowSize+" remote window size: "+this.session.state.remoteWindowSize),this.internalsTrace("session.closed="+this.session.closed+" session.destroyed="+this.session.destroyed+" session.socket.destroyed="+this.session.socket.destroyed),this.channelzEnabled?(this.streamTracker.addCallStarted(),l={addMessageSent:()=>{var e;this.messagesSent+=1,this.lastMessageSentTimestamp=new Date,null===(e=n.addMessageSent)||void 0===e||e.call(n)},addMessageReceived:()=>{var e;this.messagesReceived+=1,this.lastMessageReceivedTimestamp=new Date,null===(e=n.addMessageReceived)||void 0===e||e.call(n)},onCallEnd:e=>{var t;null===(t=n.onCallEnd)||void 0===t||t.call(n,e),this.removeActiveCall(o)},onStreamEnd:e=>{var t;e?this.streamTracker.addCallSucceeded():this.streamTracker.addCallFailed(),null===(t=n.onStreamEnd)||void 0===t||t.call(n,e)}}):l={addMessageSent:()=>{var e;null===(e=n.addMessageSent)||void 0===e||e.call(n)},addMessageReceived:()=>{var e;null===(e=n.addMessageReceived)||void 0===e||e.call(n)},onCallEnd:e=>{var t;null===(t=n.onCallEnd)||void 0===t||t.call(n,e),this.removeActiveCall(o)},onStreamEnd:e=>{var t;null===(t=n.onStreamEnd)||void 0===t||t.call(n,e)}},o=new subchannel_call_1.Http2SubchannelCall(a,l,i,this,(0,call_number_1.getNextCallNumber)()),this.addActiveCall(o),o}getChannelzRef(){return this.channelzRef}getPeerName(){return this.subchannelAddressString}getOptions(){return this.options}shutdown(){this.session.close(),(0,channelz_1.unregisterChannelzRef)(this.channelzRef)}}class Http2SubchannelConnector{constructor(e){this.channelTarget=e,this.session=null,this.isShutdown=!1}trace(e){logging.trace(constants_1.LogVerbosity.DEBUG,"transport",(0,uri_parser_1.uriToString)(this.channelTarget)+" "+e)}createSession(e,t,s,i){return this.isShutdown?Promise.reject():new Promise(((n,r)=>{var a,l,o,c;let h;i.realTarget?(h=(0,uri_parser_1.uriToString)(i.realTarget),this.trace("creating HTTP/2 session through proxy to "+(0,uri_parser_1.uriToString)(i.realTarget))):(h=null,this.trace("creating HTTP/2 session to "+(0,subchannel_address_1.subchannelAddressToString)(e)));const d=(0,resolver_1.getDefaultAuthority)(null!==(a=i.realTarget)&&void 0!==a?a:this.channelTarget);let g=t._getConnectionOptions();if(!g)return void r("Credentials not loaded");g.maxSendHeaderBlockLength=Number.MAX_SAFE_INTEGER,g.maxSessionMemory="grpc-node.max_session_memory"in s?s["grpc-node.max_session_memory"]:Number.MAX_SAFE_INTEGER;let u="http://";if("secureContext"in g){if(u="https://",s["grpc.ssl_target_name_override"]){const e=s["grpc.ssl_target_name_override"],t=null!==(l=g.checkServerIdentity)&&void 0!==l?l:tls_1.checkServerIdentity;g.checkServerIdentity=(s,i)=>t(e,i),g.servername=e}else{const e=null!==(c=null===(o=(0,uri_parser_1.splitHostPort)(d))||void 0===o?void 0:o.host)&&void 0!==c?c:"localhost";g.servername=e}i.socket&&(g.createConnection=(e,t)=>i.socket)}else g.createConnection=(t,s)=>i.socket?i.socket:net.connect(e);g=Object.assign(Object.assign(Object.assign({},g),e),{enableTrace:1===s["grpc-node.tls_enable_trace"]});const m=http2.connect(u+d,g);this.session=m;let p="Failed to connect",T=!1;m.unref(),m.once("connect",(()=>{m.removeAllListeners(),n(new Http2Transport(m,e,s,h)),this.session=null})),m.once("close",(()=>{this.session=null,setImmediate((()=>{T||(T=!0,r(`${p} (${(new Date).toISOString()})`))}))})),m.once("error",(e=>{p=e.message,this.trace("connection failed with error "+p),T||(T=!0,r(`${p} (${(new Date).toISOString()})`))}))}))}connect(e,t,s){var i,n,r;if(this.isShutdown)return Promise.reject();const a=t._getConnectionOptions();if(!a)return Promise.reject("Credentials not loaded");if("secureContext"in a){if(a.ALPNProtocols=["h2"],s["grpc.ssl_target_name_override"]){const e=s["grpc.ssl_target_name_override"],t=null!==(i=a.checkServerIdentity)&&void 0!==i?i:tls_1.checkServerIdentity;a.checkServerIdentity=(s,i)=>t(e,i),a.servername=e}else if("grpc.http_connect_target"in s){const e=(0,resolver_1.getDefaultAuthority)(null!==(n=(0,uri_parser_1.parseUri)(s["grpc.http_connect_target"]))&&void 0!==n?n:{path:"localhost"}),t=(0,uri_parser_1.splitHostPort)(e);a.servername=null!==(r=null==t?void 0:t.host)&&void 0!==r?r:e}s["grpc-node.tls_enable_trace"]&&(a.enableTrace=!0)}return(0,http_proxy_1.getProxiedConnection)(e,s,a).then((i=>this.createSession(e,t,s,i)))}shutdown(){var e;this.isShutdown=!0,null===(e=this.session)||void 0===e||e.close(),this.session=null}}exports.Http2SubchannelConnector=Http2SubchannelConnector;