//! @version @js-joda/core - 5.6.3
//! @copyright (c) 2015-present, Philipp Thürwächter, Pattrick Hüper & js-joda contributors
//! @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
//! @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
"use strict";
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function createErrorType(t,e,n){function i(t){Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=(new Error).stack,this.message=t,e&&e.apply(this,arguments),this.toString=function(){return this.name+": "+this.message}}return void 0===n&&(n=Error),i.prototype=Object.create(n.prototype),i.prototype.name=t,i.prototype.constructor=i,i}var DateTimeException=createErrorType("DateTimeException",messageWithCause),DateTimeParseException=createErrorType("DateTimeParseException",messageForDateTimeParseException),UnsupportedTemporalTypeException=createErrorType("UnsupportedTemporalTypeException",null,DateTimeException),ArithmeticException=createErrorType("ArithmeticException"),IllegalArgumentException=createErrorType("IllegalArgumentException"),IllegalStateException=createErrorType("IllegalStateException"),NullPointerException=createErrorType("NullPointerException");function messageWithCause(t,e){void 0===e&&(e=null);var n=t||this.name;null!==e&&e instanceof Error&&(n+="\n-------\nCaused by: "+e.stack+"\n-------\n"),this.message=n}function messageForDateTimeParseException(t,e,n,i){void 0===e&&(e=""),void 0===n&&(n=0),void 0===i&&(i=null);var o=t||this.name;o+=": "+e+", at index: "+n,null!==i&&i instanceof Error&&(o+="\n-------\nCaused by: "+i.stack+"\n-------\n"),this.message=o,this.parsedString=function(){return e},this.errorIndex=function(){return n}}function _inheritsLoose(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,_setPrototypeOf(t,e)}function _setPrototypeOf(t,e){return _setPrototypeOf=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(t,e){return t.__proto__=e,t},_setPrototypeOf(t,e)}function _assertThisInitialized(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function assert(t,e,n){if(!t)throw n?new n(e):new Error(e)}function requireNonNull(t,e){if(null==t)throw new NullPointerException(e+" must not be null");return t}function requireInstance(t,e,n){if(!(t instanceof e))throw new IllegalArgumentException(n+" must be an instance of "+(e.name?e.name:e)+(t&&t.constructor&&t.constructor.name?", but is "+t.constructor.name:""));return t}function abstractMethodFail(t){throw new TypeError('abstract method "'+t+'" is not implemented')}var assert$1=Object.freeze({__proto__:null,assert:assert,requireNonNull:requireNonNull,requireInstance:requireInstance,abstractMethodFail:abstractMethodFail}),MAX_SAFE_INTEGER=9007199254740991,MIN_SAFE_INTEGER=-9007199254740991,MathUtil=function(){function t(){}return t.intDiv=function(e,n){var i=e/n;return i=t.roundDown(i),t.safeZero(i)},t.intMod=function(e,n){var i=e-t.intDiv(e,n)*n;return i=t.roundDown(i),t.safeZero(i)},t.roundDown=function(t){return t<0?Math.ceil(t):Math.floor(t)},t.floorDiv=function(e,n){var i=Math.floor(e/n);return t.safeZero(i)},t.floorMod=function(e,n){var i=e-t.floorDiv(e,n)*n;return t.safeZero(i)},t.safeAdd=function(e,n){if(t.verifyInt(e),t.verifyInt(n),0===e)return t.safeZero(n);if(0===n)return t.safeZero(e);var i=t.safeToInt(e+n);if(i===e||i===n)throw new ArithmeticException("Invalid addition beyond MAX_SAFE_INTEGER!");return i},t.safeSubtract=function(e,n){return t.verifyInt(e),t.verifyInt(n),0===e&&0===n?0:0===e?t.safeZero(-1*n):0===n?t.safeZero(e):t.safeToInt(e-n)},t.safeMultiply=function(e,n){if(t.verifyInt(e),t.verifyInt(n),1===e)return t.safeZero(n);if(1===n)return t.safeZero(e);if(0===e||0===n)return 0;var i=t.safeToInt(e*n);if(i/n!==e||e===MIN_SAFE_INTEGER&&-1===n||n===MIN_SAFE_INTEGER&&-1===e)throw new ArithmeticException("Multiplication overflows: "+e+" * "+n);return i},t.parseInt=function(t){function e(e){return t.apply(this,arguments)}return e.toString=function(){return t.toString()},e}((function(e){var n=parseInt(e);return t.safeToInt(n)})),t.safeToInt=function(e){return t.verifyInt(e),t.safeZero(e)},t.verifyInt=function(t){if(null==t)throw new ArithmeticException("Invalid value: '"+t+"', using null or undefined as argument");if(isNaN(t))throw new ArithmeticException("Invalid int value, using NaN as argument");if(t%1!=0)throw new ArithmeticException("Invalid value: '"+t+"' is a float");if(t>MAX_SAFE_INTEGER||t<MIN_SAFE_INTEGER)throw new ArithmeticException("Calculation overflows an int: "+t)},t.safeZero=function(t){return 0===t?0:+t},t.compareNumbers=function(t,e){return t<e?-1:t>e?1:0},t.smi=function(t){return t>>>1&1073741824|3221225471&t},t.hash=function(e){if(e!=e||e===1/0)return 0;for(var n=e;e>4294967295;)n^=e/=4294967295;return t.smi(n)},t.hashCode=function(){for(var e=17,n=arguments.length,i=new Array(n),o=0;o<n;o++)i[o]=arguments[o];for(var r=0,a=i;r<a.length;r++){var s=a[r];e=(e<<5)-e+t.hash(s)}return t.hash(e)},t}();
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */MathUtil.MAX_SAFE_INTEGER=MAX_SAFE_INTEGER,MathUtil.MIN_SAFE_INTEGER=MIN_SAFE_INTEGER;
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var Enum=function(){function t(t){this._name=t}var e=t.prototype;return e.equals=function(t){return this===t},e.toString=function(){return this._name},e.toJSON=function(){return this.toString()},t}(),TemporalAmount=function(){function t(){}var e=t.prototype;return e.get=function(t){abstractMethodFail("get")},e.units=function(){abstractMethodFail("units")},e.addTo=function(t){abstractMethodFail("addTo")},e.subtractFrom=function(t){abstractMethodFail("subtractFrom")},t}();
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */"undefined"!=typeof Symbol&&Symbol.toPrimitive&&(TemporalAmount.prototype[Symbol.toPrimitive]=function(t){if("number"!==t)return this.toString();throw new TypeError("A conversion from TemporalAmount to a number is not allowed. To compare use the methods .equals(), .compareTo(), .isBefore() or one that is more suitable to your use case.")})
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */;var TemporalUnit=function(){function t(){}var e=t.prototype;return e.duration=function(){abstractMethodFail("duration")},e.isDurationEstimated=function(){abstractMethodFail("isDurationEstimated")},e.isDateBased=function(){abstractMethodFail("isDateBased")},e.isTimeBased=function(){abstractMethodFail("isTimeBased")},e.isSupportedBy=function(t){abstractMethodFail("isSupportedBy")},e.addTo=function(t,e){abstractMethodFail("addTo")},e.between=function(t,e){abstractMethodFail("between")},t}(),Duration=function(t){function e(e,n){var i;return(i=t.call(this)||this)._seconds=MathUtil.safeToInt(e),i._nanos=MathUtil.safeToInt(n),i}_inheritsLoose(e,t),e.ofDays=function(t){return e._create(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_DAY),0)},e.ofHours=function(t){return e._create(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_HOUR),0)},e.ofMinutes=function(t){return e._create(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_MINUTE),0)},e.ofSeconds=function(t,n){void 0===n&&(n=0);var i=MathUtil.safeAdd(t,MathUtil.floorDiv(n,LocalTime.NANOS_PER_SECOND)),o=MathUtil.floorMod(n,LocalTime.NANOS_PER_SECOND);return e._create(i,o)},e.ofMillis=function(t){var n=MathUtil.intDiv(t,1e3),i=MathUtil.intMod(t,1e3);return i<0&&(i+=1e3,n--),e._create(n,1e6*i)},e.ofNanos=function(t){var e=MathUtil.intDiv(t,LocalTime.NANOS_PER_SECOND),n=MathUtil.intMod(t,LocalTime.NANOS_PER_SECOND);return n<0&&(n+=LocalTime.NANOS_PER_SECOND,e--),this._create(e,n)},e.of=function(t,n){return e.ZERO.plus(t,n)},e.from=function(t){requireNonNull(t,"amount"),requireInstance(t,TemporalAmount);var n=e.ZERO;return t.units().forEach((function(e){n=n.plus(t.get(e),e)})),n},e.between=function(t,e){requireNonNull(t,"startInclusive"),requireNonNull(e,"endExclusive");var n=t.until(e,ChronoUnit.SECONDS),i=0;if(t.isSupported(ChronoField.NANO_OF_SECOND)&&e.isSupported(ChronoField.NANO_OF_SECOND))try{var o=t.getLong(ChronoField.NANO_OF_SECOND);if(i=e.getLong(ChronoField.NANO_OF_SECOND)-o,n>0&&i<0)i+=LocalTime.NANOS_PER_SECOND;else if(n<0&&i>0)i-=LocalTime.NANOS_PER_SECOND;else if(0===n&&0!==i){var r=e.with(ChronoField.NANO_OF_SECOND,o);n=t.until(r,ChronoUnit.SECONDS)}}catch(t){}return this.ofSeconds(n,i)},e.parse=function(t){requireNonNull(t,"text");var n=new RegExp("([-+]?)P(?:([-+]?[0-9]+)D)?(T(?:([-+]?[0-9]+)H)?(?:([-+]?[0-9]+)M)?(?:([-+]?[0-9]+)(?:[.,]([0-9]{0,9}))?S)?)?","i").exec(t);if(null!==n&&"T"===n[3]==!1){var i="-"===n[1],o=n[2],r=n[4],a=n[5],s=n[6],u=n[7];if(null!=o||null!=r||null!=a||null!=s){var l=e._parseNumber(t,o,LocalTime.SECONDS_PER_DAY,"days"),h=e._parseNumber(t,r,LocalTime.SECONDS_PER_HOUR,"hours"),c=e._parseNumber(t,a,LocalTime.SECONDS_PER_MINUTE,"minutes"),f=e._parseNumber(t,s,1,"seconds"),_=null!=s&&"-"===s.charAt(0),d=e._parseFraction(t,u,_?-1:1);try{return e._create(i,l,h,c,f,d)}catch(e){throw new DateTimeParseException("Text cannot be parsed to a Duration: overflow",t,0,e)}}}throw new DateTimeParseException("Text cannot be parsed to a Duration",t,0)},e._parseNumber=function(t,e,n,i){if(null==e)return 0;try{return"+"===e[0]&&(e=e.substring(1)),MathUtil.safeMultiply(parseFloat(e),n)}catch(e){throw new DateTimeParseException("Text cannot be parsed to a Duration: "+i,t,0,e)}},e._parseFraction=function(t,e,n){return null==e||0===e.length?0:(e=(e+"000000000").substring(0,9),parseFloat(e)*n)},e._create=function(){return arguments.length<=2?e._createSecondsNanos(arguments[0],arguments[1]):e._createNegateDaysHoursMinutesSecondsNanos(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4],arguments[5])},e._createNegateDaysHoursMinutesSecondsNanos=function(t,n,i,o,r,a){var s=MathUtil.safeAdd(n,MathUtil.safeAdd(i,MathUtil.safeAdd(o,r)));return t?e.ofSeconds(s,a).negated():e.ofSeconds(s,a)},e._createSecondsNanos=function(t,n){return void 0===t&&(t=0),void 0===n&&(n=0),0===t&&0===n?e.ZERO:new e(t,n)};var n=e.prototype;return n.get=function(t){if(t===ChronoUnit.SECONDS)return this._seconds;if(t===ChronoUnit.NANOS)return this._nanos;throw new UnsupportedTemporalTypeException("Unsupported unit: "+t)},n.units=function(){return[ChronoUnit.SECONDS,ChronoUnit.NANOS]},n.isZero=function(){return 0===this._seconds&&0===this._nanos},n.isNegative=function(){return this._seconds<0},n.seconds=function(){return this._seconds},n.nano=function(){return this._nanos},n.withSeconds=function(t){return e._create(t,this._nanos)},n.withNanos=function(t){return ChronoField.NANO_OF_SECOND.checkValidIntValue(t),e._create(this._seconds,t)},n.plusDuration=function(t){return requireNonNull(t,"duration"),this.plus(t.seconds(),t.nano())},n.plus=function(t,e){return 1===arguments.length?this.plusDuration(t):2===arguments.length&&e instanceof TemporalUnit?this.plusAmountUnit(t,e):this.plusSecondsNanos(t,e)},n.plusAmountUnit=function(t,e){if(requireNonNull(t,"amountToAdd"),requireNonNull(e,"unit"),e===ChronoUnit.DAYS)return this.plusSecondsNanos(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_DAY),0);if(e.isDurationEstimated())throw new UnsupportedTemporalTypeException("Unit must not have an estimated duration");if(0===t)return this;if(e instanceof ChronoUnit){switch(e){case ChronoUnit.NANOS:return this.plusNanos(t);case ChronoUnit.MICROS:return this.plusSecondsNanos(1e3*MathUtil.intDiv(t,1e9),1e3*MathUtil.intMod(t,1e9));case ChronoUnit.MILLIS:return this.plusMillis(t);case ChronoUnit.SECONDS:return this.plusSeconds(t)}return this.plusSecondsNanos(MathUtil.safeMultiply(e.duration().seconds(),t),0)}var n=e.duration().multipliedBy(t);return this.plusSecondsNanos(n.seconds(),n.nano())},n.plusDays=function(t){return this.plusSecondsNanos(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_DAY),0)},n.plusHours=function(t){return this.plusSecondsNanos(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_HOUR),0)},n.plusMinutes=function(t){return this.plusSecondsNanos(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_MINUTE),0)},n.plusSeconds=function(t){return this.plusSecondsNanos(t,0)},n.plusMillis=function(t){return this.plusSecondsNanos(MathUtil.intDiv(t,1e3),1e6*MathUtil.intMod(t,1e3))},n.plusNanos=function(t){return this.plusSecondsNanos(0,t)},n.plusSecondsNanos=function(t,n){if(requireNonNull(t,"secondsToAdd"),requireNonNull(n,"nanosToAdd"),0===t&&0===n)return this;var i=MathUtil.safeAdd(this._seconds,t);i=MathUtil.safeAdd(i,MathUtil.intDiv(n,LocalTime.NANOS_PER_SECOND)),n=MathUtil.intMod(n,LocalTime.NANOS_PER_SECOND);var o=MathUtil.safeAdd(this._nanos,n);return e.ofSeconds(i,o)},n.minus=function(t,e){return 1===arguments.length?this.minusDuration(t):this.minusAmountUnit(t,e)},n.minusDuration=function(t){requireNonNull(t,"duration");var e=t.seconds(),n=t.nano();return e===MIN_SAFE_INTEGER?this.plus(MAX_SAFE_INTEGER,-n):this.plus(-e,-n)},n.minusAmountUnit=function(t,e){return requireNonNull(t,"amountToSubtract"),requireNonNull(e,"unit"),t===MIN_SAFE_INTEGER?this.plusAmountUnit(MAX_SAFE_INTEGER,e):this.plusAmountUnit(-t,e)},n.minusDays=function(t){return t===MIN_SAFE_INTEGER?this.plusDays(MAX_SAFE_INTEGER):this.plusDays(-t)},n.minusHours=function(t){return t===MIN_SAFE_INTEGER?this.plusHours(MAX_SAFE_INTEGER):this.plusHours(-t)},n.minusMinutes=function(t){return t===MIN_SAFE_INTEGER?this.plusMinutes(MAX_SAFE_INTEGER):this.plusMinutes(-t)},n.minusSeconds=function(t){return t===MIN_SAFE_INTEGER?this.plusSeconds(MAX_SAFE_INTEGER):this.plusSeconds(-t)},n.minusMillis=function(t){return t===MIN_SAFE_INTEGER?this.plusMillis(MAX_SAFE_INTEGER):this.plusMillis(-t)},n.minusNanos=function(t){return t===MIN_SAFE_INTEGER?this.plusNanos(MAX_SAFE_INTEGER):this.plusNanos(-t)},n.multipliedBy=function(t){if(0===t)return e.ZERO;if(1===t)return this;var n=MathUtil.safeMultiply(this._seconds,t),i=MathUtil.safeMultiply(this._nanos,t);return n+=MathUtil.intDiv(i,LocalTime.NANOS_PER_SECOND),i=MathUtil.intMod(i,LocalTime.NANOS_PER_SECOND),e.ofSeconds(n,i)},n.dividedBy=function(t){if(0===t)throw new ArithmeticException("Cannot divide by zero");if(1===t)return this;var n=MathUtil.intDiv(this._seconds,t),i=MathUtil.roundDown((this._seconds/t-n)*LocalTime.NANOS_PER_SECOND),o=MathUtil.intDiv(this._nanos,t);return o=i+o,e.ofSeconds(n,o)},n.negated=function(){return this.multipliedBy(-1)},n.abs=function(){return this.isNegative()?this.negated():this},n.addTo=function(t){return requireNonNull(t,"temporal"),0!==this._seconds&&(t=t.plus(this._seconds,ChronoUnit.SECONDS)),0!==this._nanos&&(t=t.plus(this._nanos,ChronoUnit.NANOS)),t},n.subtractFrom=function(t){return requireNonNull(t,"temporal"),0!==this._seconds&&(t=t.minus(this._seconds,ChronoUnit.SECONDS)),0!==this._nanos&&(t=t.minus(this._nanos,ChronoUnit.NANOS)),t},n.toDays=function(){return MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_DAY)},n.toHours=function(){return MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_HOUR)},n.toMinutes=function(){return MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_MINUTE)},n.toMillis=function(){var t=Math.round(MathUtil.safeMultiply(this._seconds,1e3));return t=MathUtil.safeAdd(t,MathUtil.intDiv(this._nanos,1e6))},n.toNanos=function(){var t=MathUtil.safeMultiply(this._seconds,LocalTime.NANOS_PER_SECOND);return t=MathUtil.safeAdd(t,this._nanos)},n.compareTo=function(t){requireNonNull(t,"otherDuration"),requireInstance(t,e,"otherDuration");var n=MathUtil.compareNumbers(this._seconds,t.seconds());return 0!==n?n:this._nanos-t.nano()},n.equals=function(t){return this===t||t instanceof e&&(this.seconds()===t.seconds()&&this.nano()===t.nano())},n.toString=function(){if(this===e.ZERO)return"PT0S";var t,n=MathUtil.intDiv(this._seconds,LocalTime.SECONDS_PER_HOUR),i=MathUtil.intDiv(MathUtil.intMod(this._seconds,LocalTime.SECONDS_PER_HOUR),LocalTime.SECONDS_PER_MINUTE),o=MathUtil.intMod(this._seconds,LocalTime.SECONDS_PER_MINUTE),r="PT";if(0!==n&&(r+=n+"H"),0!==i&&(r+=i+"M"),0===o&&0===this._nanos&&r.length>2)return r;if(o<0&&this._nanos>0?r+=-1===o?"-0":o+1:r+=o,this._nanos>0)for(r+=".",r+=t=(t=o<0?""+(2*LocalTime.NANOS_PER_SECOND-this._nanos):""+(LocalTime.NANOS_PER_SECOND+this._nanos)).slice(1,t.length);"0"===r.charAt(r.length-1);)r=r.slice(0,r.length-1);return r+="S"},n.toJSON=function(){return this.toString()},e}(TemporalAmount);function _init$n(){Duration.ZERO=new Duration(0,0)}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE.md in the root directory of this source tree)
 */var YearConstants=function(){};function _init$m(){YearConstants.MIN_VALUE=-999999,YearConstants.MAX_VALUE=999999}var ChronoUnit=function(t){function e(e,n){var i;return(i=t.call(this)||this)._name=e,i._duration=n,i}_inheritsLoose(e,t);var n=e.prototype;return n.duration=function(){return this._duration},n.isDurationEstimated=function(){return this.isDateBased()||this===e.FOREVER},n.isDateBased=function(){return this.compareTo(e.DAYS)>=0&&this!==e.FOREVER},n.isTimeBased=function(){return this.compareTo(e.DAYS)<0},n.isSupportedBy=function(t){if(this===e.FOREVER)return!1;try{return t.plus(1,this),!0}catch(e){try{return t.plus(-1,this),!0}catch(t){return!1}}},n.addTo=function(t,e){return t.plus(e,this)},n.between=function(t,e){return t.until(e,this)},n.toString=function(){return this._name},n.compareTo=function(t){return this.duration().compareTo(t.duration())},e}(TemporalUnit);function _init$l(){ChronoUnit.NANOS=new ChronoUnit("Nanos",Duration.ofNanos(1)),ChronoUnit.MICROS=new ChronoUnit("Micros",Duration.ofNanos(1e3)),ChronoUnit.MILLIS=new ChronoUnit("Millis",Duration.ofNanos(1e6)),ChronoUnit.SECONDS=new ChronoUnit("Seconds",Duration.ofSeconds(1)),ChronoUnit.MINUTES=new ChronoUnit("Minutes",Duration.ofSeconds(60)),ChronoUnit.HOURS=new ChronoUnit("Hours",Duration.ofSeconds(3600)),ChronoUnit.HALF_DAYS=new ChronoUnit("HalfDays",Duration.ofSeconds(43200)),ChronoUnit.DAYS=new ChronoUnit("Days",Duration.ofSeconds(86400)),ChronoUnit.WEEKS=new ChronoUnit("Weeks",Duration.ofSeconds(604800)),ChronoUnit.MONTHS=new ChronoUnit("Months",Duration.ofSeconds(2629746)),ChronoUnit.YEARS=new ChronoUnit("Years",Duration.ofSeconds(31556952)),ChronoUnit.DECADES=new ChronoUnit("Decades",Duration.ofSeconds(315569520)),ChronoUnit.CENTURIES=new ChronoUnit("Centuries",Duration.ofSeconds(3155695200)),ChronoUnit.MILLENNIA=new ChronoUnit("Millennia",Duration.ofSeconds(31556952e3)),ChronoUnit.ERAS=new ChronoUnit("Eras",Duration.ofSeconds(31556952*(YearConstants.MAX_VALUE+1))),ChronoUnit.FOREVER=new ChronoUnit("Forever",Duration.ofSeconds(MathUtil.MAX_SAFE_INTEGER,999999999))}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var TemporalField=function(){function t(){}var e=t.prototype;return e.isDateBased=function(){abstractMethodFail("isDateBased")},e.isTimeBased=function(){abstractMethodFail("isTimeBased")},e.baseUnit=function(){abstractMethodFail("baseUnit")},e.rangeUnit=function(){abstractMethodFail("rangeUnit")},e.range=function(){abstractMethodFail("range")},e.rangeRefinedBy=function(t){abstractMethodFail("rangeRefinedBy")},e.getFrom=function(t){abstractMethodFail("getFrom")},e.adjustInto=function(t,e){abstractMethodFail("adjustInto")},e.isSupportedBy=function(t){abstractMethodFail("isSupportedBy")},e.displayName=function(){abstractMethodFail("displayName")},e.equals=function(t){abstractMethodFail("equals")},e.name=function(){abstractMethodFail("name")},t}(),ValueRange=function(){function t(t,e,n,i){assert(!(t>e),"Smallest minimum value '"+t+"' must be less than largest minimum value '"+e+"'",IllegalArgumentException),assert(!(n>i),"Smallest maximum value '"+n+"' must be less than largest maximum value '"+i+"'",IllegalArgumentException),assert(!(e>i),"Minimum value '"+e+"' must be less than maximum value '"+i+"'",IllegalArgumentException),this._minSmallest=t,this._minLargest=e,this._maxLargest=i,this._maxSmallest=n}var e=t.prototype;return e.isFixed=function(){return this._minSmallest===this._minLargest&&this._maxSmallest===this._maxLargest},e.minimum=function(){return this._minSmallest},e.largestMinimum=function(){return this._minLargest},e.maximum=function(){return this._maxLargest},e.smallestMaximum=function(){return this._maxSmallest},e.isValidValue=function(t){return this.minimum()<=t&&t<=this.maximum()},e.checkValidValue=function(t,e){return this.isValidValue(t)?t:assert(!1,null!=e?"Invalid value for "+e+" (valid values "+this.toString()+"): "+t:"Invalid value (valid values "+this.toString()+"): "+t,DateTimeException)},e.checkValidIntValue=function(t,e){if(!1===this.isValidIntValue(t))throw new DateTimeException("Invalid int value for "+e+": "+t);return t},e.isValidIntValue=function(t){return this.isIntValue()&&this.isValidValue(t)},e.isIntValue=function(){return this.minimum()>=MathUtil.MIN_SAFE_INTEGER&&this.maximum()<=MathUtil.MAX_SAFE_INTEGER},e.equals=function(e){return e===this||e instanceof t&&(this._minSmallest===e._minSmallest&&this._minLargest===e._minLargest&&this._maxSmallest===e._maxSmallest&&this._maxLargest===e._maxLargest)},e.hashCode=function(){return MathUtil.hashCode(this._minSmallest,this._minLargest,this._maxSmallest,this._maxLargest)},e.toString=function(){var t=this.minimum()+(this.minimum()!==this.largestMinimum()?"/"+this.largestMinimum():"");return t+=" - ",t+=this.smallestMaximum()+(this.smallestMaximum()!==this.maximum()?"/"+this.maximum():"")},t.of=function(){return 2===arguments.length?new t(arguments[0],arguments[0],arguments[1],arguments[1]):3===arguments.length?new t(arguments[0],arguments[0],arguments[1],arguments[2]):4===arguments.length?new t(arguments[0],arguments[1],arguments[2],arguments[3]):assert(!1,"Invalid number of arguments "+arguments.length,IllegalArgumentException)},t}(),ChronoField=function(t){function e(e,n,i,o){var r;return(r=t.call(this)||this)._name=e,r._baseUnit=n,r._rangeUnit=i,r._range=o,r}_inheritsLoose(e,t),e.byName=function(t){for(var n in e)if(e[n]&&e[n]instanceof e&&e[n].name()===t)return e[n]};var n=e.prototype;return n.name=function(){return this._name},n.baseUnit=function(){return this._baseUnit},n.rangeUnit=function(){return this._rangeUnit},n.range=function(){return this._range},n.displayName=function(){return this.toString()},n.checkValidValue=function(t){return this.range().checkValidValue(t,this)},n.checkValidIntValue=function(t){return this.range().checkValidIntValue(t,this)},n.isDateBased=function(){return this===e.DAY_OF_WEEK||this===e.ALIGNED_DAY_OF_WEEK_IN_MONTH||this===e.ALIGNED_DAY_OF_WEEK_IN_YEAR||this===e.DAY_OF_MONTH||this===e.DAY_OF_YEAR||this===e.EPOCH_DAY||this===e.ALIGNED_WEEK_OF_MONTH||this===e.ALIGNED_WEEK_OF_YEAR||this===e.MONTH_OF_YEAR||this===e.PROLEPTIC_MONTH||this===e.YEAR_OF_ERA||this===e.YEAR||this===e.ERA},n.isTimeBased=function(){return this===e.NANO_OF_SECOND||this===e.NANO_OF_DAY||this===e.MICRO_OF_SECOND||this===e.MICRO_OF_DAY||this===e.MILLI_OF_SECOND||this===e.MILLI_OF_DAY||this===e.SECOND_OF_MINUTE||this===e.SECOND_OF_DAY||this===e.MINUTE_OF_HOUR||this===e.MINUTE_OF_DAY||this===e.HOUR_OF_AMPM||this===e.CLOCK_HOUR_OF_AMPM||this===e.HOUR_OF_DAY||this===e.CLOCK_HOUR_OF_DAY||this===e.AMPM_OF_DAY},n.rangeRefinedBy=function(t){return t.range(this)},n.getFrom=function(t){return t.getLong(this)},n.toString=function(){return this.name()},n.equals=function(t){return this===t},n.adjustInto=function(t,e){return t.with(this,e)},n.isSupportedBy=function(t){return t.isSupported(this)},e}(TemporalField);
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$k(){ChronoField.NANO_OF_SECOND=new ChronoField("NanoOfSecond",ChronoUnit.NANOS,ChronoUnit.SECONDS,ValueRange.of(0,999999999)),ChronoField.NANO_OF_DAY=new ChronoField("NanoOfDay",ChronoUnit.NANOS,ChronoUnit.DAYS,ValueRange.of(0,86399999999999)),ChronoField.MICRO_OF_SECOND=new ChronoField("MicroOfSecond",ChronoUnit.MICROS,ChronoUnit.SECONDS,ValueRange.of(0,999999)),ChronoField.MICRO_OF_DAY=new ChronoField("MicroOfDay",ChronoUnit.MICROS,ChronoUnit.DAYS,ValueRange.of(0,86399999999)),ChronoField.MILLI_OF_SECOND=new ChronoField("MilliOfSecond",ChronoUnit.MILLIS,ChronoUnit.SECONDS,ValueRange.of(0,999)),ChronoField.MILLI_OF_DAY=new ChronoField("MilliOfDay",ChronoUnit.MILLIS,ChronoUnit.DAYS,ValueRange.of(0,86399999)),ChronoField.SECOND_OF_MINUTE=new ChronoField("SecondOfMinute",ChronoUnit.SECONDS,ChronoUnit.MINUTES,ValueRange.of(0,59)),ChronoField.SECOND_OF_DAY=new ChronoField("SecondOfDay",ChronoUnit.SECONDS,ChronoUnit.DAYS,ValueRange.of(0,86399)),ChronoField.MINUTE_OF_HOUR=new ChronoField("MinuteOfHour",ChronoUnit.MINUTES,ChronoUnit.HOURS,ValueRange.of(0,59)),ChronoField.MINUTE_OF_DAY=new ChronoField("MinuteOfDay",ChronoUnit.MINUTES,ChronoUnit.DAYS,ValueRange.of(0,1439)),ChronoField.HOUR_OF_AMPM=new ChronoField("HourOfAmPm",ChronoUnit.HOURS,ChronoUnit.HALF_DAYS,ValueRange.of(0,11)),ChronoField.CLOCK_HOUR_OF_AMPM=new ChronoField("ClockHourOfAmPm",ChronoUnit.HOURS,ChronoUnit.HALF_DAYS,ValueRange.of(1,12)),ChronoField.HOUR_OF_DAY=new ChronoField("HourOfDay",ChronoUnit.HOURS,ChronoUnit.DAYS,ValueRange.of(0,23)),ChronoField.CLOCK_HOUR_OF_DAY=new ChronoField("ClockHourOfDay",ChronoUnit.HOURS,ChronoUnit.DAYS,ValueRange.of(1,24)),ChronoField.AMPM_OF_DAY=new ChronoField("AmPmOfDay",ChronoUnit.HALF_DAYS,ChronoUnit.DAYS,ValueRange.of(0,1)),ChronoField.DAY_OF_WEEK=new ChronoField("DayOfWeek",ChronoUnit.DAYS,ChronoUnit.WEEKS,ValueRange.of(1,7)),ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH=new ChronoField("AlignedDayOfWeekInMonth",ChronoUnit.DAYS,ChronoUnit.WEEKS,ValueRange.of(1,7)),ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR=new ChronoField("AlignedDayOfWeekInYear",ChronoUnit.DAYS,ChronoUnit.WEEKS,ValueRange.of(1,7)),ChronoField.DAY_OF_MONTH=new ChronoField("DayOfMonth",ChronoUnit.DAYS,ChronoUnit.MONTHS,ValueRange.of(1,28,31),"day"),ChronoField.DAY_OF_YEAR=new ChronoField("DayOfYear",ChronoUnit.DAYS,ChronoUnit.YEARS,ValueRange.of(1,365,366)),ChronoField.EPOCH_DAY=new ChronoField("EpochDay",ChronoUnit.DAYS,ChronoUnit.FOREVER,ValueRange.of(-365961662,364522971)),ChronoField.ALIGNED_WEEK_OF_MONTH=new ChronoField("AlignedWeekOfMonth",ChronoUnit.WEEKS,ChronoUnit.MONTHS,ValueRange.of(1,4,5)),ChronoField.ALIGNED_WEEK_OF_YEAR=new ChronoField("AlignedWeekOfYear",ChronoUnit.WEEKS,ChronoUnit.YEARS,ValueRange.of(1,53)),ChronoField.MONTH_OF_YEAR=new ChronoField("MonthOfYear",ChronoUnit.MONTHS,ChronoUnit.YEARS,ValueRange.of(1,12),"month"),ChronoField.PROLEPTIC_MONTH=new ChronoField("ProlepticMonth",ChronoUnit.MONTHS,ChronoUnit.FOREVER,ValueRange.of(12*YearConstants.MIN_VALUE,12*YearConstants.MAX_VALUE+11)),ChronoField.YEAR_OF_ERA=new ChronoField("YearOfEra",ChronoUnit.YEARS,ChronoUnit.FOREVER,ValueRange.of(1,YearConstants.MAX_VALUE,YearConstants.MAX_VALUE+1)),ChronoField.YEAR=new ChronoField("Year",ChronoUnit.YEARS,ChronoUnit.FOREVER,ValueRange.of(YearConstants.MIN_VALUE,YearConstants.MAX_VALUE),"year"),ChronoField.ERA=new ChronoField("Era",ChronoUnit.ERAS,ChronoUnit.FOREVER,ValueRange.of(0,1)),ChronoField.INSTANT_SECONDS=new ChronoField("InstantSeconds",ChronoUnit.SECONDS,ChronoUnit.FOREVER,ValueRange.of(MIN_SAFE_INTEGER,MAX_SAFE_INTEGER)),ChronoField.OFFSET_SECONDS=new ChronoField("OffsetSeconds",ChronoUnit.SECONDS,ChronoUnit.FOREVER,ValueRange.of(-64800,64800))}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var TemporalQueries=function(){function t(){}return t.zoneId=function(){return t.ZONE_ID},t.chronology=function(){return t.CHRONO},t.precision=function(){return t.PRECISION},t.zone=function(){return t.ZONE},t.offset=function(){return t.OFFSET},t.localDate=function(){return t.LOCAL_DATE},t.localTime=function(){return t.LOCAL_TIME},t}(),TemporalAccessor=function(){function t(){}var e=t.prototype;return e.query=function(t){return t===TemporalQueries.zoneId()||t===TemporalQueries.chronology()||t===TemporalQueries.precision()?null:t.queryFrom(this)},e.get=function(t){return this.range(t).checkValidIntValue(this.getLong(t),t)},e.getLong=function(t){abstractMethodFail("getLong")},e.range=function(t){if(t instanceof ChronoField){if(this.isSupported(t))return t.range();throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.rangeRefinedBy(this)},e.isSupported=function(t){abstractMethodFail("isSupported")},t}(),TemporalQuery=function(t){function e(){return t.apply(this,arguments)||this}return _inheritsLoose(e,t),e.prototype.queryFrom=function(t){abstractMethodFail("queryFrom")},e}(Enum);
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function createTemporalQuery(t,e){var n=function(t){function e(){return t.apply(this,arguments)||this}return _inheritsLoose(e,t),e}(TemporalQuery);return n.prototype.queryFrom=e,new n(t)}var ENUMS,DayOfWeek=function(t){function e(e,n){var i;return(i=t.call(this)||this)._ordinal=e,i._name=n,i}_inheritsLoose(e,t);var n=e.prototype;return n.ordinal=function(){return this._ordinal},n.name=function(){return this._name},e.values=function(){return ENUMS.slice()},e.valueOf=function(t){for(var n=0;n<ENUMS.length&&ENUMS[n].name()!==t;n++);return e.of(n+1)},e.of=function(t){if(t<1||t>7)throw new DateTimeException("Invalid value for DayOfWeek: "+t);return ENUMS[t-1]},e.from=function(t){if(assert(null!=t,"temporal",NullPointerException),t instanceof e)return t;try{return e.of(t.get(ChronoField.DAY_OF_WEEK))}catch(e){throw e instanceof DateTimeException?new DateTimeException("Unable to obtain DayOfWeek from TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""),e):e}},n.value=function(){return this._ordinal+1},n.displayName=function(t,e){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")},n.isSupported=function(t){return t instanceof ChronoField?t===ChronoField.DAY_OF_WEEK:null!=t&&t.isSupportedBy(this)},n.range=function(t){if(t===ChronoField.DAY_OF_WEEK)return t.range();if(t instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+t);return t.rangeRefinedBy(this)},n.get=function(t){return t===ChronoField.DAY_OF_WEEK?this.value():this.range(t).checkValidIntValue(this.getLong(t),t)},n.getLong=function(t){if(t===ChronoField.DAY_OF_WEEK)return this.value();if(t instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+t);return t.getFrom(this)},n.plus=function(t){var e=MathUtil.floorMod(t,7);return ENUMS[MathUtil.floorMod(this._ordinal+(e+7),7)]},n.minus=function(t){return this.plus(-1*MathUtil.floorMod(t,7))},n.query=function(t){return t===TemporalQueries.precision()?ChronoUnit.DAYS:t===TemporalQueries.localDate()||t===TemporalQueries.localTime()||t===TemporalQueries.chronology()||t===TemporalQueries.zone()||t===TemporalQueries.zoneId()||t===TemporalQueries.offset()?null:(assert(null!=t,"query",NullPointerException),t.queryFrom(this))},n.adjustInto=function(t){return requireNonNull(t,"temporal"),t.with(ChronoField.DAY_OF_WEEK,this.value())},n.equals=function(t){return this===t},n.toString=function(){return this._name},n.compareTo=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._ordinal-t._ordinal},n.toJSON=function(){return this.toString()},e}(TemporalAccessor);function _init$j(){DayOfWeek.MONDAY=new DayOfWeek(0,"MONDAY"),DayOfWeek.TUESDAY=new DayOfWeek(1,"TUESDAY"),DayOfWeek.WEDNESDAY=new DayOfWeek(2,"WEDNESDAY"),DayOfWeek.THURSDAY=new DayOfWeek(3,"THURSDAY"),DayOfWeek.FRIDAY=new DayOfWeek(4,"FRIDAY"),DayOfWeek.SATURDAY=new DayOfWeek(5,"SATURDAY"),DayOfWeek.SUNDAY=new DayOfWeek(6,"SUNDAY"),DayOfWeek.FROM=createTemporalQuery("DayOfWeek.FROM",(function(t){return DayOfWeek.from(t)})),ENUMS=[DayOfWeek.MONDAY,DayOfWeek.TUESDAY,DayOfWeek.WEDNESDAY,DayOfWeek.THURSDAY,DayOfWeek.FRIDAY,DayOfWeek.SATURDAY,DayOfWeek.SUNDAY]}var MONTHS,Month=function(t){function e(e,n){var i;return(i=t.call(this)||this)._value=MathUtil.safeToInt(e),i._name=n,i}_inheritsLoose(e,t);var n=e.prototype;return n.value=function(){return this._value},n.ordinal=function(){return this._value-1},n.name=function(){return this._name},n.displayName=function(t,e){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")},n.isSupported=function(t){return null!==t&&(t instanceof ChronoField?t===ChronoField.MONTH_OF_YEAR:null!=t&&t.isSupportedBy(this))},n.get=function(t){return t===ChronoField.MONTH_OF_YEAR?this.value():this.range(t).checkValidIntValue(this.getLong(t),t)},n.getLong=function(t){if(t===ChronoField.MONTH_OF_YEAR)return this.value();if(t instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+t);return t.getFrom(this)},n.plus=function(t){var n=MathUtil.intMod(t,12)+12,i=MathUtil.intMod(this.value()+n,12);return i=0===i?12:i,e.of(i)},n.minus=function(t){return this.plus(-1*MathUtil.intMod(t,12))},n.length=function(t){switch(this){case e.FEBRUARY:return t?29:28;case e.APRIL:case e.JUNE:case e.SEPTEMBER:case e.NOVEMBER:return 30;default:return 31}},n.minLength=function(){switch(this){case e.FEBRUARY:return 28;case e.APRIL:case e.JUNE:case e.SEPTEMBER:case e.NOVEMBER:return 30;default:return 31}},n.maxLength=function(){switch(this){case e.FEBRUARY:return 29;case e.APRIL:case e.JUNE:case e.SEPTEMBER:case e.NOVEMBER:return 30;default:return 31}},n.firstDayOfYear=function(t){var n=t?1:0;switch(this){case e.JANUARY:return 1;case e.FEBRUARY:return 32;case e.MARCH:return 60+n;case e.APRIL:return 91+n;case e.MAY:return 121+n;case e.JUNE:return 152+n;case e.JULY:return 182+n;case e.AUGUST:return 213+n;case e.SEPTEMBER:return 244+n;case e.OCTOBER:return 274+n;case e.NOVEMBER:return 305+n;case e.DECEMBER:default:return 335+n}},n.firstMonthOfQuarter=function(){switch(this){case e.JANUARY:case e.FEBRUARY:case e.MARCH:return e.JANUARY;case e.APRIL:case e.MAY:case e.JUNE:return e.APRIL;case e.JULY:case e.AUGUST:case e.SEPTEMBER:return e.JULY;case e.OCTOBER:case e.NOVEMBER:case e.DECEMBER:default:return e.OCTOBER}},n.query=function(e){return assert(null!=e,"query() parameter must not be null",DateTimeException),e===TemporalQueries.chronology()?IsoChronology.INSTANCE:e===TemporalQueries.precision()?ChronoUnit.MONTHS:t.prototype.query.call(this,e)},n.toString=function(){switch(this){case e.JANUARY:return"JANUARY";case e.FEBRUARY:return"FEBRUARY";case e.MARCH:return"MARCH";case e.APRIL:return"APRIL";case e.MAY:return"MAY";case e.JUNE:return"JUNE";case e.JULY:return"JULY";case e.AUGUST:return"AUGUST";case e.SEPTEMBER:return"SEPTEMBER";case e.OCTOBER:return"OCTOBER";case e.NOVEMBER:return"NOVEMBER";case e.DECEMBER:return"DECEMBER";default:return"unknown Month, value: "+this.value()}},n.toJSON=function(){return this.toString()},n.adjustInto=function(t){return t.with(ChronoField.MONTH_OF_YEAR,this.value())},n.compareTo=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._value-t._value},n.equals=function(t){return this===t},e.valueOf=function(t){for(var n=0;n<MONTHS.length&&MONTHS[n].name()!==t;n++);return e.of(n+1)},e.values=function(){return MONTHS.slice()},e.of=function(t){return(t<1||t>12)&&assert(!1,"Invalid value for MonthOfYear: "+t,DateTimeException),MONTHS[t-1]},e.from=function(t){if(t instanceof e)return t;try{return e.of(t.get(ChronoField.MONTH_OF_YEAR))}catch(e){throw new DateTimeException("Unable to obtain Month from TemporalAccessor: "+t+" of type "+(t&&null!=t.constructor?t.constructor.name:""),e)}},e}(TemporalAccessor);function _init$i(){Month.JANUARY=new Month(1,"JANUARY"),Month.FEBRUARY=new Month(2,"FEBRUARY"),Month.MARCH=new Month(3,"MARCH"),Month.APRIL=new Month(4,"APRIL"),Month.MAY=new Month(5,"MAY"),Month.JUNE=new Month(6,"JUNE"),Month.JULY=new Month(7,"JULY"),Month.AUGUST=new Month(8,"AUGUST"),Month.SEPTEMBER=new Month(9,"SEPTEMBER"),Month.OCTOBER=new Month(10,"OCTOBER"),Month.NOVEMBER=new Month(11,"NOVEMBER"),Month.DECEMBER=new Month(12,"DECEMBER"),MONTHS=[Month.JANUARY,Month.FEBRUARY,Month.MARCH,Month.APRIL,Month.MAY,Month.JUNE,Month.JULY,Month.AUGUST,Month.SEPTEMBER,Month.OCTOBER,Month.NOVEMBER,Month.DECEMBER]}var PATTERN=/([-+]?)P(?:([-+]?[0-9]+)Y)?(?:([-+]?[0-9]+)M)?(?:([-+]?[0-9]+)W)?(?:([-+]?[0-9]+)D)?/,Period=function(t){function e(n,i,o){var r;r=t.call(this)||this;var a=MathUtil.safeToInt(n),s=MathUtil.safeToInt(i),u=MathUtil.safeToInt(o);return 0===a&&0===s&&0===u?(e.ZERO||(r._years=a,r._months=s,r._days=u,e.ZERO=_assertThisInitialized(r)),e.ZERO||_assertThisInitialized(r)):(r._years=a,r._months=s,r._days=u,r)}_inheritsLoose(e,t),e.ofYears=function(t){return e.create(t,0,0)},e.ofMonths=function(t){return e.create(0,t,0)},e.ofWeeks=function(t){return e.create(0,0,MathUtil.safeMultiply(t,7))},e.ofDays=function(t){return e.create(0,0,t)},e.of=function(t,n,i){return e.create(t,n,i)},e.from=function(t){if(t instanceof e)return t;requireNonNull(t,"amount");for(var n=0,i=0,o=0,r=t.units(),a=0;a<r.length;a++){var s=r[a],u=t.get(s);if(s===ChronoUnit.YEARS)n=MathUtil.safeToInt(u);else if(s===ChronoUnit.MONTHS)i=MathUtil.safeToInt(u);else{if(s!==ChronoUnit.DAYS)throw new DateTimeException("Unit must be Years, Months or Days, but was "+s);o=MathUtil.safeToInt(u)}}return e.create(n,i,o)},e.between=function(t,e){return requireNonNull(t,"startDate"),requireNonNull(e,"endDate"),requireInstance(t,LocalDate,"startDate"),requireInstance(e,LocalDate,"endDate"),t.until(e)},e.parse=function(t){requireNonNull(t,"text");try{return e._parse(t)}catch(e){throw e instanceof ArithmeticException?new DateTimeParseException("Text cannot be parsed to a Period",t,0,e):e}},e._parse=function(t){var n=PATTERN.exec(t);if(null!=n){var i="-"===n[1]?-1:1,o=n[2],r=n[3],a=n[4],s=n[5];if(null!=o||null!=r||null!=a||null!=s){var u=e._parseNumber(t,o,i),l=e._parseNumber(t,r,i),h=e._parseNumber(t,a,i),c=e._parseNumber(t,s,i);return c=MathUtil.safeAdd(c,MathUtil.safeMultiply(h,7)),e.create(u,l,c)}}throw new DateTimeParseException("Text cannot be parsed to a Period",t,0)},e._parseNumber=function(t,e,n){if(null==e)return 0;var i=MathUtil.parseInt(e);return MathUtil.safeMultiply(i,n)},e.create=function(t,n,i){return new e(t,n,i)};var n=e.prototype;return n.units=function(){return[ChronoUnit.YEARS,ChronoUnit.MONTHS,ChronoUnit.DAYS]},n.chronology=function(){return IsoChronology.INSTANCE},n.get=function(t){if(t===ChronoUnit.YEARS)return this._years;if(t===ChronoUnit.MONTHS)return this._months;if(t===ChronoUnit.DAYS)return this._days;throw new UnsupportedTemporalTypeException("Unsupported unit: "+t)},n.isZero=function(){return this===e.ZERO},n.isNegative=function(){return this._years<0||this._months<0||this._days<0},n.years=function(){return this._years},n.months=function(){return this._months},n.days=function(){return this._days},n.withYears=function(t){return t===this._years?this:e.create(t,this._months,this._days)},n.withMonths=function(t){return t===this._months?this:e.create(this._years,t,this._days)},n.withDays=function(t){return t===this._days?this:e.create(this._years,this._months,t)},n.plus=function(t){var n=e.from(t);return e.create(MathUtil.safeAdd(this._years,n._years),MathUtil.safeAdd(this._months,n._months),MathUtil.safeAdd(this._days,n._days))},n.plusYears=function(t){return 0===t?this:e.create(MathUtil.safeToInt(MathUtil.safeAdd(this._years,t)),this._months,this._days)},n.plusMonths=function(t){return 0===t?this:e.create(this._years,MathUtil.safeToInt(MathUtil.safeAdd(this._months,t)),this._days)},n.plusDays=function(t){return 0===t?this:e.create(this._years,this._months,MathUtil.safeToInt(MathUtil.safeAdd(this._days,t)))},n.minus=function(t){var n=e.from(t);return e.create(MathUtil.safeSubtract(this._years,n._years),MathUtil.safeSubtract(this._months,n._months),MathUtil.safeSubtract(this._days,n._days))},n.minusYears=function(t){return this.plusYears(-1*t)},n.minusMonths=function(t){return this.plusMonths(-1*t)},n.minusDays=function(t){return this.plusDays(-1*t)},n.multipliedBy=function(t){return this===e.ZERO||1===t?this:e.create(MathUtil.safeMultiply(this._years,t),MathUtil.safeMultiply(this._months,t),MathUtil.safeMultiply(this._days,t))},n.negated=function(){return this.multipliedBy(-1)},n.normalized=function(){var t=this.toTotalMonths(),n=MathUtil.intDiv(t,12),i=MathUtil.intMod(t,12);return n===this._years&&i===this._months?this:e.create(MathUtil.safeToInt(n),i,this._days)},n.toTotalMonths=function(){return 12*this._years+this._months},n.addTo=function(t){return requireNonNull(t,"temporal"),0!==this._years?t=0!==this._months?t.plus(this.toTotalMonths(),ChronoUnit.MONTHS):t.plus(this._years,ChronoUnit.YEARS):0!==this._months&&(t=t.plus(this._months,ChronoUnit.MONTHS)),0!==this._days&&(t=t.plus(this._days,ChronoUnit.DAYS)),t},n.subtractFrom=function(t){return requireNonNull(t,"temporal"),0!==this._years?t=0!==this._months?t.minus(this.toTotalMonths(),ChronoUnit.MONTHS):t.minus(this._years,ChronoUnit.YEARS):0!==this._months&&(t=t.minus(this._months,ChronoUnit.MONTHS)),0!==this._days&&(t=t.minus(this._days,ChronoUnit.DAYS)),t},n.equals=function(t){if(this===t)return!0;if(t instanceof e){var n=t;return this._years===n._years&&this._months===n._months&&this._days===n._days}return!1},n.hashCode=function(){return MathUtil.hashCode(this._years,this._months,this._days)},n.toString=function(){if(this===e.ZERO)return"P0D";var t="P";return 0!==this._years&&(t+=this._years+"Y"),0!==this._months&&(t+=this._months+"M"),0!==this._days&&(t+=this._days+"D"),t},n.toJSON=function(){return this.toString()},e}(TemporalAmount);function _init$h(){Period.ofDays(0)}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var ParsePosition=function(){function t(t){this._index=t,this._errorIndex=-1}var e=t.prototype;return e.getIndex=function(){return this._index},e.setIndex=function(t){this._index=t},e.getErrorIndex=function(){return this._errorIndex},e.setErrorIndex=function(t){this._errorIndex=t},t}(),EnumMap=function(){function t(){this._map={}}var e=t.prototype;return e.putAll=function(t){for(var e in t._map)this._map[e]=t._map[e];return this},e.containsKey=function(t){return this._map.hasOwnProperty(t.name())&&void 0!==this.get(t)},e.get=function(t){return this._map[t.name()]},e.put=function(t,e){return this.set(t,e)},e.set=function(t,e){return this._map[t.name()]=e,this},e.retainAll=function(t){for(var e={},n=0;n<t.length;n++){var i=t[n].name();e[i]=this._map[i]}return this._map=e,this},e.remove=function(t){var e=t.name(),n=this._map[e];return this._map[e]=void 0,n},e.keySet=function(){return this._map},e.clear=function(){this._map={}},t}(),ResolverStyle=function(t){function e(){return t.apply(this,arguments)||this}return _inheritsLoose(e,t),e}(Enum);
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */ResolverStyle.STRICT=new ResolverStyle("STRICT"),ResolverStyle.SMART=new ResolverStyle("SMART"),ResolverStyle.LENIENT=new ResolverStyle("LENIENT");var Temporal=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.isSupported=function(t){abstractMethodFail("isSupported")},n.minus=function(t,e){return arguments.length<2?this._minusAmount(t):this._minusUnit(t,e)},n._minusAmount=function(t){return requireNonNull(t,"amount"),requireInstance(t,TemporalAmount,"amount"),t.subtractFrom(this)},n._minusUnit=function(t,e){return requireNonNull(t,"amountToSubtract"),requireNonNull(e,"unit"),requireInstance(e,TemporalUnit,"unit"),this._plusUnit(-t,e)},n.plus=function(t,e){return arguments.length<2?this._plusAmount(t):this._plusUnit(t,e)},n._plusAmount=function(t){return requireNonNull(t,"amount"),requireInstance(t,TemporalAmount,"amount"),t.addTo(this)},n._plusUnit=function(t,e){abstractMethodFail("_plusUnit")},n.until=function(t,e){abstractMethodFail("until")},n.with=function(t,e){return arguments.length<2?this._withAdjuster(t):this._withField(t,e)},n._withAdjuster=function(t){return requireNonNull(t,"adjuster"),assert("function"==typeof t.adjustInto,"adjuster must be a TemporalAdjuster",IllegalArgumentException),t.adjustInto(this)},n._withField=function(t,e){abstractMethodFail("_withField")},e}(TemporalAccessor);"undefined"!=typeof Symbol&&Symbol.toPrimitive&&(Temporal.prototype[Symbol.toPrimitive]=function(t){if("number"!==t)return this.toString();throw new TypeError("A conversion from Temporal to a number is not allowed. To compare use the methods .equals(), .compareTo(), .isBefore() or one that is more suitable to your use case.")});var ChronoLocalDate=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.isSupported=function(t){return t instanceof ChronoField||t instanceof ChronoUnit?t.isDateBased():null!=t&&t.isSupportedBy(this)},n.query=function(e){return e===TemporalQueries.chronology()?this.chronology():e===TemporalQueries.precision()?ChronoUnit.DAYS:e===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toEpochDay()):e===TemporalQueries.localTime()||e===TemporalQueries.zone()||e===TemporalQueries.zoneId()||e===TemporalQueries.offset()?null:t.prototype.query.call(this,e)},n.adjustInto=function(t){return t.with(ChronoField.EPOCH_DAY,this.toEpochDay())},n.format=function(t){return requireNonNull(t,"formatter"),requireInstance(t,DateTimeFormatter,"formatter"),t.format(this)},e}(Temporal),StringUtil=function(){function t(){}return t.startsWith=function(t,e){return 0===t.indexOf(e)},t.hashCode=function(t){var e=t.length;if(0===e)return 0;for(var n=0,i=0;i<e;i++){n=(n<<5)-n+t.charCodeAt(i),n|=0}return MathUtil.smi(n)},t}(),ZoneId=function(){function t(){}t.systemDefault=function(){throw new DateTimeException("not supported operation")},t.getAvailableZoneIds=function(){throw new DateTimeException("not supported operation")},t.of=function(t){throw new DateTimeException("not supported operation"+t)},t.ofOffset=function(t,e){throw new DateTimeException("not supported operation"+t+e)},t.from=function(t){throw new DateTimeException("not supported operation"+t)};var e=t.prototype;return e.id=function(){abstractMethodFail("ZoneId.id")},e.rules=function(){abstractMethodFail("ZoneId.rules")},e.normalized=function(){var t=this.rules();return t.isFixedOffset()?t.offset(Instant.EPOCH):this},e.equals=function(e){return this===e||e instanceof t&&this.id()===e.id()},e.hashCode=function(){return StringUtil.hashCode(this.id())},e.toString=function(){return this.id()},e.toJSON=function(){return this.toString()},t}(),ZoneRules=function(){function t(){}t.of=function(t){return requireNonNull(t,"offset"),new Fixed(t)};var e=t.prototype;return e.isFixedOffset=function(){abstractMethodFail("ZoneRules.isFixedOffset")},e.offset=function(t){return t instanceof Instant?this.offsetOfInstant(t):this.offsetOfLocalDateTime(t)},e.offsetOfInstant=function(t){abstractMethodFail("ZoneRules.offsetInstant")},e.offsetOfEpochMilli=function(t){abstractMethodFail("ZoneRules.offsetOfEpochMilli")},e.offsetOfLocalDateTime=function(t){abstractMethodFail("ZoneRules.offsetLocalDateTime")},e.validOffsets=function(t){abstractMethodFail("ZoneRules.validOffsets")},e.transition=function(t){abstractMethodFail("ZoneRules.transition")},e.standardOffset=function(t){abstractMethodFail("ZoneRules.standardOffset")},e.daylightSavings=function(t){abstractMethodFail("ZoneRules.daylightSavings")},e.isDaylightSavings=function(t){abstractMethodFail("ZoneRules.isDaylightSavings")},e.isValidOffset=function(t,e){abstractMethodFail("ZoneRules.isValidOffset")},e.nextTransition=function(t){abstractMethodFail("ZoneRules.nextTransition")},e.previousTransition=function(t){abstractMethodFail("ZoneRules.previousTransition")},e.transitions=function(){abstractMethodFail("ZoneRules.transitions")},e.transitionRules=function(){abstractMethodFail("ZoneRules.transitionRules")},e.toString=function(){abstractMethodFail("ZoneRules.toString")},e.toJSON=function(){return this.toString()},t}(),Fixed=function(t){function e(e){var n;return(n=t.call(this)||this)._offset=e,n}_inheritsLoose(e,t);var n=e.prototype;return n.isFixedOffset=function(){return!0},n.offsetOfInstant=function(){return this._offset},n.offsetOfEpochMilli=function(){return this._offset},n.offsetOfLocalDateTime=function(){return this._offset},n.validOffsets=function(){return[this._offset]},n.transition=function(){return null},n.standardOffset=function(){return this._offset},n.daylightSavings=function(){return Duration.ZERO},n.isDaylightSavings=function(){return!1},n.isValidOffset=function(t,e){return this._offset.equals(e)},n.nextTransition=function(){return null},n.previousTransition=function(){return null},n.transitions=function(){return[]},n.transitionRules=function(){return[]},n.equals=function(t){return this===t||t instanceof e&&this._offset.equals(t._offset)},n.toString=function(){return"FixedRules:"+this._offset.toString()},e}(ZoneRules),SECONDS_CACHE={},ID_CACHE={},ZoneOffset=function(t){function e(n){var i;return i=t.call(this)||this,e._validateTotalSeconds(n),i._totalSeconds=MathUtil.safeToInt(n),i._rules=ZoneRules.of(_assertThisInitialized(i)),i._id=e._buildId(n),i}_inheritsLoose(e,t);var n=e.prototype;return n.totalSeconds=function(){return this._totalSeconds},n.id=function(){return this._id},e._buildId=function(t){if(0===t)return"Z";var e=Math.abs(t),n=MathUtil.intDiv(e,LocalTime.SECONDS_PER_HOUR),i=MathUtil.intMod(MathUtil.intDiv(e,LocalTime.SECONDS_PER_MINUTE),LocalTime.MINUTES_PER_HOUR),o=(t<0?"-":"+")+(n<10?"0":"")+n+(i<10?":0":":")+i,r=MathUtil.intMod(e,LocalTime.SECONDS_PER_MINUTE);return 0!==r&&(o+=(r<10?":0":":")+r),o},e._validateTotalSeconds=function(t){if(Math.abs(t)>e.MAX_SECONDS)throw new DateTimeException("Zone offset not in valid range: -18:00 to +18:00")},e._validate=function(t,e,n){if(t<-18||t>18)throw new DateTimeException("Zone offset hours not in valid range: value "+t+" is not in the range -18 to 18");if(t>0){if(e<0||n<0)throw new DateTimeException("Zone offset minutes and seconds must be positive because hours is positive")}else if(t<0){if(e>0||n>0)throw new DateTimeException("Zone offset minutes and seconds must be negative because hours is negative")}else if(e>0&&n<0||e<0&&n>0)throw new DateTimeException("Zone offset minutes and seconds must have the same sign");if(Math.abs(e)>59)throw new DateTimeException("Zone offset minutes not in valid range: abs(value) "+Math.abs(e)+" is not in the range 0 to 59");if(Math.abs(n)>59)throw new DateTimeException("Zone offset seconds not in valid range: abs(value) "+Math.abs(n)+" is not in the range 0 to 59");if(18===Math.abs(t)&&(Math.abs(e)>0||Math.abs(n)>0))throw new DateTimeException("Zone offset not in valid range: -18:00 to +18:00")},e.of=function(t){requireNonNull(t,"offsetId");var n,i,o,r=ID_CACHE[t];if(null!=r)return r;switch(t.length){case 2:t=t[0]+"0"+t[1];case 3:n=e._parseNumber(t,1,!1),i=0,o=0;break;case 5:n=e._parseNumber(t,1,!1),i=e._parseNumber(t,3,!1),o=0;break;case 6:n=e._parseNumber(t,1,!1),i=e._parseNumber(t,4,!0),o=0;break;case 7:n=e._parseNumber(t,1,!1),i=e._parseNumber(t,3,!1),o=e._parseNumber(t,5,!1);break;case 9:n=e._parseNumber(t,1,!1),i=e._parseNumber(t,4,!0),o=e._parseNumber(t,7,!0);break;default:throw new DateTimeException("Invalid ID for ZoneOffset, invalid format: "+t)}var a=t[0];if("+"!==a&&"-"!==a)throw new DateTimeException("Invalid ID for ZoneOffset, plus/minus not found when expected: "+t);return"-"===a?e.ofHoursMinutesSeconds(-n,-i,-o):e.ofHoursMinutesSeconds(n,i,o)},e._parseNumber=function(t,e,n){if(n&&":"!==t[e-1])throw new DateTimeException("Invalid ID for ZoneOffset, colon not found when expected: "+t);var i=t[e],o=t[e+1];if(i<"0"||i>"9"||o<"0"||o>"9")throw new DateTimeException("Invalid ID for ZoneOffset, non numeric characters found: "+t);return 10*(i.charCodeAt(0)-48)+(o.charCodeAt(0)-48)},e.ofHours=function(t){return e.ofHoursMinutesSeconds(t,0,0)},e.ofHoursMinutes=function(t,n){return e.ofHoursMinutesSeconds(t,n,0)},e.ofHoursMinutesSeconds=function(t,n,i){e._validate(t,n,i);var o=t*LocalTime.SECONDS_PER_HOUR+n*LocalTime.SECONDS_PER_MINUTE+i;return e.ofTotalSeconds(o)},e.ofTotalMinutes=function(t){var n=t*LocalTime.SECONDS_PER_MINUTE;return e.ofTotalSeconds(n)},e.ofTotalSeconds=function(t){if(t%(15*LocalTime.SECONDS_PER_MINUTE)==0){var n=t,i=SECONDS_CACHE[n];return null==i&&(i=new e(t),SECONDS_CACHE[n]=i,ID_CACHE[i.id()]=i),i}return new e(t)},n.rules=function(){return this._rules},n.get=function(t){return this.getLong(t)},n.getLong=function(t){if(t===ChronoField.OFFSET_SECONDS)return this._totalSeconds;if(t instanceof ChronoField)throw new DateTimeException("Unsupported field: "+t);return t.getFrom(this)},n.query=function(t){return requireNonNull(t,"query"),t===TemporalQueries.offset()||t===TemporalQueries.zone()?this:t===TemporalQueries.localDate()||t===TemporalQueries.localTime()||t===TemporalQueries.precision()||t===TemporalQueries.chronology()||t===TemporalQueries.zoneId()?null:t.queryFrom(this)},n.adjustInto=function(t){return t.with(ChronoField.OFFSET_SECONDS,this._totalSeconds)},n.compareTo=function(t){return requireNonNull(t,"other"),t._totalSeconds-this._totalSeconds},n.equals=function(t){return this===t||t instanceof e&&this._totalSeconds===t._totalSeconds},n.hashCode=function(){return this._totalSeconds},n.toString=function(){return this._id},e}(ZoneId);
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$g(){ZoneOffset.MAX_SECONDS=18*LocalTime.SECONDS_PER_HOUR,ZoneOffset.UTC=ZoneOffset.ofTotalSeconds(0),ZoneOffset.MIN=ZoneOffset.ofTotalSeconds(-ZoneOffset.MAX_SECONDS),ZoneOffset.MAX=ZoneOffset.ofTotalSeconds(ZoneOffset.MAX_SECONDS)}var DateTimeBuilder=function(t){function e(){var e;return(e=t.call(this)||this).fieldValues=new EnumMap,e.chrono=null,e.zone=null,e.date=null,e.time=null,e.leapSecond=!1,e.excessDays=null,e}_inheritsLoose(e,t),e.create=function(t,n){var i=new e;return i._addFieldValue(t,n),i};var n=e.prototype;return n.getFieldValue0=function(t){return this.fieldValues.get(t)},n._addFieldValue=function(t,e){requireNonNull(t,"field");var n=this.getFieldValue0(t);if(null!=n&&n!==e)throw new DateTimeException("Conflict found: "+t+" "+n+" differs from "+t+" "+e+": "+this);return this._putFieldValue0(t,e)},n._putFieldValue0=function(t,e){return this.fieldValues.put(t,e),this},n.resolve=function(t,e){return null!=e&&this.fieldValues.retainAll(e),this._mergeDate(t),this._mergeTime(t),this._resolveTimeInferZeroes(t),null!=this.excessDays&&!1===this.excessDays.isZero()&&null!=this.date&&null!=this.time&&(this.date=this.date.plus(this.excessDays),this.excessDays=Period.ZERO),this._resolveInstant(),this},n._mergeDate=function(t){this._checkDate(IsoChronology.INSTANCE.resolveDate(this.fieldValues,t))},n._checkDate=function(t){if(null!=t)for(var e in this._addObject(t),this.fieldValues.keySet()){var n=ChronoField.byName(e);if(n&&void 0!==this.fieldValues.get(n)&&n.isDateBased()){var i=void 0;try{i=t.getLong(n)}catch(t){if(t instanceof DateTimeException)continue;throw t}var o=this.fieldValues.get(n);if(i!==o)throw new DateTimeException("Conflict found: Field "+n+" "+i+" differs from "+n+" "+o+" derived from "+t)}}},n._mergeTime=function(t){if(this.fieldValues.containsKey(ChronoField.CLOCK_HOUR_OF_DAY)){var e=this.fieldValues.remove(ChronoField.CLOCK_HOUR_OF_DAY);t!==ResolverStyle.LENIENT&&(t===ResolverStyle.SMART&&0===e||ChronoField.CLOCK_HOUR_OF_DAY.checkValidValue(e)),this._addFieldValue(ChronoField.HOUR_OF_DAY,24===e?0:e)}if(this.fieldValues.containsKey(ChronoField.CLOCK_HOUR_OF_AMPM)){var n=this.fieldValues.remove(ChronoField.CLOCK_HOUR_OF_AMPM);t!==ResolverStyle.LENIENT&&(t===ResolverStyle.SMART&&0===n||ChronoField.CLOCK_HOUR_OF_AMPM.checkValidValue(n)),this._addFieldValue(ChronoField.HOUR_OF_AMPM,12===n?0:n)}if(t!==ResolverStyle.LENIENT&&(this.fieldValues.containsKey(ChronoField.AMPM_OF_DAY)&&ChronoField.AMPM_OF_DAY.checkValidValue(this.fieldValues.get(ChronoField.AMPM_OF_DAY)),this.fieldValues.containsKey(ChronoField.HOUR_OF_AMPM)&&ChronoField.HOUR_OF_AMPM.checkValidValue(this.fieldValues.get(ChronoField.HOUR_OF_AMPM))),this.fieldValues.containsKey(ChronoField.AMPM_OF_DAY)&&this.fieldValues.containsKey(ChronoField.HOUR_OF_AMPM)){var i=this.fieldValues.remove(ChronoField.AMPM_OF_DAY),o=this.fieldValues.remove(ChronoField.HOUR_OF_AMPM);this._addFieldValue(ChronoField.HOUR_OF_DAY,12*i+o)}if(this.fieldValues.containsKey(ChronoField.NANO_OF_DAY)){var r=this.fieldValues.remove(ChronoField.NANO_OF_DAY);t!==ResolverStyle.LENIENT&&ChronoField.NANO_OF_DAY.checkValidValue(r),this._addFieldValue(ChronoField.SECOND_OF_DAY,MathUtil.intDiv(r,1e9)),this._addFieldValue(ChronoField.NANO_OF_SECOND,MathUtil.intMod(r,1e9))}if(this.fieldValues.containsKey(ChronoField.MICRO_OF_DAY)){var a=this.fieldValues.remove(ChronoField.MICRO_OF_DAY);t!==ResolverStyle.LENIENT&&ChronoField.MICRO_OF_DAY.checkValidValue(a),this._addFieldValue(ChronoField.SECOND_OF_DAY,MathUtil.intDiv(a,1e6)),this._addFieldValue(ChronoField.MICRO_OF_SECOND,MathUtil.intMod(a,1e6))}if(this.fieldValues.containsKey(ChronoField.MILLI_OF_DAY)){var s=this.fieldValues.remove(ChronoField.MILLI_OF_DAY);t!==ResolverStyle.LENIENT&&ChronoField.MILLI_OF_DAY.checkValidValue(s),this._addFieldValue(ChronoField.SECOND_OF_DAY,MathUtil.intDiv(s,1e3)),this._addFieldValue(ChronoField.MILLI_OF_SECOND,MathUtil.intMod(s,1e3))}if(this.fieldValues.containsKey(ChronoField.SECOND_OF_DAY)){var u=this.fieldValues.remove(ChronoField.SECOND_OF_DAY);t!==ResolverStyle.LENIENT&&ChronoField.SECOND_OF_DAY.checkValidValue(u),this._addFieldValue(ChronoField.HOUR_OF_DAY,MathUtil.intDiv(u,3600)),this._addFieldValue(ChronoField.MINUTE_OF_HOUR,MathUtil.intMod(MathUtil.intDiv(u,60),60)),this._addFieldValue(ChronoField.SECOND_OF_MINUTE,MathUtil.intMod(u,60))}if(this.fieldValues.containsKey(ChronoField.MINUTE_OF_DAY)){var l=this.fieldValues.remove(ChronoField.MINUTE_OF_DAY);t!==ResolverStyle.LENIENT&&ChronoField.MINUTE_OF_DAY.checkValidValue(l),this._addFieldValue(ChronoField.HOUR_OF_DAY,MathUtil.intDiv(l,60)),this._addFieldValue(ChronoField.MINUTE_OF_HOUR,MathUtil.intMod(l,60))}if(t!==ResolverStyle.LENIENT&&(this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)&&ChronoField.MILLI_OF_SECOND.checkValidValue(this.fieldValues.get(ChronoField.MILLI_OF_SECOND)),this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)&&ChronoField.MICRO_OF_SECOND.checkValidValue(this.fieldValues.get(ChronoField.MICRO_OF_SECOND))),this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)&&this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)){var h=this.fieldValues.remove(ChronoField.MILLI_OF_SECOND),c=this.fieldValues.get(ChronoField.MICRO_OF_SECOND);this._putFieldValue0(ChronoField.MICRO_OF_SECOND,1e3*h+MathUtil.intMod(c,1e3))}if(this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)&&this.fieldValues.containsKey(ChronoField.NANO_OF_SECOND)){var f=this.fieldValues.get(ChronoField.NANO_OF_SECOND);this._putFieldValue0(ChronoField.MICRO_OF_SECOND,MathUtil.intDiv(f,1e3)),this.fieldValues.remove(ChronoField.MICRO_OF_SECOND)}if(this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)&&this.fieldValues.containsKey(ChronoField.NANO_OF_SECOND)){var _=this.fieldValues.get(ChronoField.NANO_OF_SECOND);this._putFieldValue0(ChronoField.MILLI_OF_SECOND,MathUtil.intDiv(_,1e6)),this.fieldValues.remove(ChronoField.MILLI_OF_SECOND)}if(this.fieldValues.containsKey(ChronoField.MICRO_OF_SECOND)){var d=this.fieldValues.remove(ChronoField.MICRO_OF_SECOND);this._putFieldValue0(ChronoField.NANO_OF_SECOND,1e3*d)}else if(this.fieldValues.containsKey(ChronoField.MILLI_OF_SECOND)){var p=this.fieldValues.remove(ChronoField.MILLI_OF_SECOND);this._putFieldValue0(ChronoField.NANO_OF_SECOND,1e6*p)}},n._resolveTimeInferZeroes=function(t){var e=this.fieldValues.get(ChronoField.HOUR_OF_DAY),n=this.fieldValues.get(ChronoField.MINUTE_OF_HOUR),i=this.fieldValues.get(ChronoField.SECOND_OF_MINUTE),o=this.fieldValues.get(ChronoField.NANO_OF_SECOND);if(null!=e&&(null!=n||null==i&&null==o)&&(null==n||null!=i||null==o)){if(t!==ResolverStyle.LENIENT){if(null!=e){t!==ResolverStyle.SMART||24!==e||null!=n&&0!==n||null!=i&&0!==i||null!=o&&0!==o||(e=0,this.excessDays=Period.ofDays(1));var r=ChronoField.HOUR_OF_DAY.checkValidIntValue(e);if(null!=n){var a=ChronoField.MINUTE_OF_HOUR.checkValidIntValue(n);if(null!=i){var s=ChronoField.SECOND_OF_MINUTE.checkValidIntValue(i);if(null!=o){var u=ChronoField.NANO_OF_SECOND.checkValidIntValue(o);this._addObject(LocalTime.of(r,a,s,u))}else this._addObject(LocalTime.of(r,a,s))}else null==o&&this._addObject(LocalTime.of(r,a))}else null==i&&null==o&&this._addObject(LocalTime.of(r,0))}}else if(null!=e){var l=e;if(null!=n)if(null!=i){null==o&&(o=0);var h=MathUtil.safeMultiply(l,36e11);h=MathUtil.safeAdd(h,MathUtil.safeMultiply(n,6e10)),h=MathUtil.safeAdd(h,MathUtil.safeMultiply(i,1e9)),h=MathUtil.safeAdd(h,o);var c=MathUtil.floorDiv(h,864e11),f=MathUtil.floorMod(h,864e11);this._addObject(LocalTime.ofNanoOfDay(f)),this.excessDays=Period.ofDays(c)}else{var _=MathUtil.safeMultiply(l,3600);_=MathUtil.safeAdd(_,MathUtil.safeMultiply(n,60));var d=MathUtil.floorDiv(_,86400),p=MathUtil.floorMod(_,86400);this._addObject(LocalTime.ofSecondOfDay(p)),this.excessDays=Period.ofDays(d)}else{var m=MathUtil.safeToInt(MathUtil.floorDiv(l,24));l=MathUtil.floorMod(l,24),this._addObject(LocalTime.of(l,0)),this.excessDays=Period.ofDays(m)}}this.fieldValues.remove(ChronoField.HOUR_OF_DAY),this.fieldValues.remove(ChronoField.MINUTE_OF_HOUR),this.fieldValues.remove(ChronoField.SECOND_OF_MINUTE),this.fieldValues.remove(ChronoField.NANO_OF_SECOND)}},n._addObject=function(t){t instanceof ChronoLocalDate?this.date=t:t instanceof LocalTime&&(this.time=t)},n._resolveInstant=function(){if(null!=this.date&&null!=this.time){var t=this.fieldValues.get(ChronoField.OFFSET_SECONDS);if(null!=t){var e=ZoneOffset.ofTotalSeconds(t),n=this.date.atTime(this.time).atZone(e).getLong(ChronoField.INSTANT_SECONDS);this.fieldValues.put(ChronoField.INSTANT_SECONDS,n)}else if(null!=this.zone){var i=this.date.atTime(this.time).atZone(this.zone).getLong(ChronoField.INSTANT_SECONDS);this.fieldValues.put(ChronoField.INSTANT_SECONDS,i)}}},n.build=function(t){return t.queryFrom(this)},n.isSupported=function(t){return null!=t&&(this.fieldValues.containsKey(t)&&void 0!==this.fieldValues.get(t)||null!=this.date&&this.date.isSupported(t)||null!=this.time&&this.time.isSupported(t))},n.getLong=function(t){requireNonNull(t,"field");var e=this.getFieldValue0(t);if(null==e){if(null!=this.date&&this.date.isSupported(t))return this.date.getLong(t);if(null!=this.time&&this.time.isSupported(t))return this.time.getLong(t);throw new DateTimeException("Field not found: "+t)}return e},n.query=function(t){return t===TemporalQueries.zoneId()?this.zone:t===TemporalQueries.chronology()?this.chrono:t===TemporalQueries.localDate()?null!=this.date?LocalDate.from(this.date):null:t===TemporalQueries.localTime()?this.time:t===TemporalQueries.zone()||t===TemporalQueries.offset()?t.queryFrom(this):t===TemporalQueries.precision()?null:t.queryFrom(this)},e}(TemporalAccessor),DateTimeParseContext=function(){function t(){if(1===arguments.length){if(arguments[0]instanceof t)return void this._constructorSelf.apply(this,arguments);this._constructorFormatter.apply(this,arguments)}else this._constructorParam.apply(this,arguments);this._caseSensitive=!0,this._strict=!0,this._parsed=[new Parsed(this)]}var e=t.prototype;return e._constructorParam=function(t,e,n){this._locale=t,this._symbols=e,this._overrideChronology=n},e._constructorFormatter=function(t){this._locale=t.locale(),this._symbols=t.decimalStyle(),this._overrideChronology=t.chronology()},e._constructorSelf=function(t){this._locale=t._locale,this._symbols=t._symbols,this._overrideChronology=t._overrideChronology,this._overrideZone=t._overrideZone,this._caseSensitive=t._caseSensitive,this._strict=t._strict,this._parsed=[new Parsed(this)]},e.copy=function(){return new t(this)},e.symbols=function(){return this._symbols},e.isStrict=function(){return this._strict},e.setStrict=function(t){this._strict=t},e.locale=function(){return this._locale},e.setLocale=function(t){this._locale=t},e.startOptional=function(){this._parsed.push(this.currentParsed().copy())},e.endOptional=function(t){t?this._parsed.splice(this._parsed.length-2,1):this._parsed.splice(this._parsed.length-1,1)},e.isCaseSensitive=function(){return this._caseSensitive},e.setCaseSensitive=function(t){this._caseSensitive=t},e.subSequenceEquals=function(t,e,n,i,o){if(e+o>t.length||i+o>n.length)return!1;this.isCaseSensitive()||(t=t.toLowerCase(),n=n.toLowerCase());for(var r=0;r<o;r++){if(t[e+r]!==n[i+r])return!1}return!0},e.charEquals=function(t,e){return this.isCaseSensitive()?t===e:this.charEqualsIgnoreCase(t,e)},e.charEqualsIgnoreCase=function(t,e){return t===e||t.toLowerCase()===e.toLowerCase()},e.setParsedField=function(t,e,n,i){var o=this.currentParsed().fieldValues,r=o.get(t);return o.set(t,e),null!=r&&r!==e?~n:i},e.setParsedZone=function(t){requireNonNull(t,"zone"),this.currentParsed().zone=t},e.getParsed=function(t){return this.currentParsed().fieldValues.get(t)},e.toParsed=function(){return this.currentParsed()},e.currentParsed=function(){return this._parsed[this._parsed.length-1]},e.setParsedLeapSecond=function(){this.currentParsed().leapSecond=!0},e.getEffectiveChronology=function(){var t=this.currentParsed().chrono;return null==t&&null==(t=this._overrideChronology)&&(t=IsoChronology.INSTANCE),t},t}(),Parsed=function(t){function e(e){var n;return(n=t.call(this)||this).chrono=null,n.zone=null,n.fieldValues=new EnumMap,n.leapSecond=!1,n.dateTimeParseContext=e,n}_inheritsLoose(e,t);var n=e.prototype;return n.copy=function(){var t=new e;return t.chrono=this.chrono,t.zone=this.zone,t.fieldValues.putAll(this.fieldValues),t.leapSecond=this.leapSecond,t.dateTimeParseContext=this.dateTimeParseContext,t},n.toString=function(){return this.fieldValues+", "+this.chrono+", "+this.zone},n.isSupported=function(t){return this.fieldValues.containsKey(t)},n.get=function(t){var e=this.fieldValues.get(t);return assert(null!=e),e},n.query=function(e){return e===TemporalQueries.chronology()?this.chrono:e===TemporalQueries.zoneId()||e===TemporalQueries.zone()?this.zone:t.prototype.query.call(this,e)},n.toBuilder=function(){var t=new DateTimeBuilder;return t.fieldValues.putAll(this.fieldValues),t.chrono=this.dateTimeParseContext.getEffectiveChronology(),null!=this.zone?t.zone=this.zone:t.zone=this.overrideZone,t.leapSecond=this.leapSecond,t.excessDays=this.excessDays,t},e}(Temporal),DateTimePrintContext=function(){function t(e,n,i){2===arguments.length&&arguments[1]instanceof DateTimeFormatter?(this._temporal=t.adjust(e,n),this._locale=n.locale(),this._symbols=n.decimalStyle()):(this._temporal=e,this._locale=n,this._symbols=i),this._optional=0}t.adjust=function(t,e){return t};var e=t.prototype;return e.symbols=function(){return this._symbols},e.startOptional=function(){this._optional++},e.endOptional=function(){this._optional--},e.getValueQuery=function(t){var e=this._temporal.query(t);if(null==e&&0===this._optional)throw new DateTimeException("Unable to extract value: "+this._temporal);return e},e.getValue=function(t){try{return this._temporal.getLong(t)}catch(t){if(t instanceof DateTimeException&&this._optional>0)return null;throw t}},e.temporal=function(){return this._temporal},e.locale=function(){return this._locale},e.setDateTime=function(t){this._temporal=t},e.setLocale=function(t){this._locale=t},t}(),IsoFields={},QUARTER_DAYS=[0,90,181,273,0,91,182,274],Field=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.isDateBased=function(){return!0},n.isTimeBased=function(){return!1},n._isIso=function(){return!0},e._getWeekRangeByLocalDate=function(t){var n=e._getWeekBasedYear(t);return ValueRange.of(1,e._getWeekRangeByYear(n))},e._getWeekRangeByYear=function(t){var e=LocalDate.of(t,1,1);return e.dayOfWeek()===DayOfWeek.THURSDAY||e.dayOfWeek()===DayOfWeek.WEDNESDAY&&e.isLeapYear()?53:52},e._getWeek=function(t){var n=t.dayOfWeek().ordinal(),i=t.dayOfYear()-1,o=i+(3-n),r=o-7*MathUtil.intDiv(o,7)-3;if(r<-3&&(r+=7),i<r)return e._getWeekRangeByLocalDate(t.withDayOfYear(180).minusYears(1)).maximum();var a=MathUtil.intDiv(i-r,7)+1;return 53===a&&!1===(-3===r||-2===r&&t.isLeapYear())&&(a=1),a},e._getWeekBasedYear=function(t){var e=t.year(),n=t.dayOfYear();if(n<=3)n-t.dayOfWeek().ordinal()<-2&&e--;else if(n>=363){var i=t.dayOfWeek().ordinal();(n=n-363-(t.isLeapYear()?1:0))-i>=0&&e++}return e},n.displayName=function(){return this.toString()},n.resolve=function(){return null},n.name=function(){return this.toString()},e}(TemporalField),DAY_OF_QUARTER_FIELD=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.toString=function(){return"DayOfQuarter"},n.baseUnit=function(){return ChronoUnit.DAYS},n.rangeUnit=function(){return QUARTER_YEARS},n.range=function(){return ValueRange.of(1,90,92)},n.isSupportedBy=function(t){return t.isSupported(ChronoField.DAY_OF_YEAR)&&t.isSupported(ChronoField.MONTH_OF_YEAR)&&t.isSupported(ChronoField.YEAR)&&this._isIso(t)},n.rangeRefinedBy=function(t){if(!1===t.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: DayOfQuarter");var e=t.getLong(QUARTER_OF_YEAR);if(1===e){var n=t.getLong(ChronoField.YEAR);return IsoChronology.isLeapYear(n)?ValueRange.of(1,91):ValueRange.of(1,90)}return 2===e?ValueRange.of(1,91):3===e||4===e?ValueRange.of(1,92):this.range()},n.getFrom=function(t){if(!1===t.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: DayOfQuarter");var e=t.get(ChronoField.DAY_OF_YEAR),n=t.get(ChronoField.MONTH_OF_YEAR),i=t.getLong(ChronoField.YEAR);return e-QUARTER_DAYS[MathUtil.intDiv(n-1,3)+(IsoChronology.isLeapYear(i)?4:0)]},n.adjustInto=function(t,e){var n=this.getFrom(t);return this.range().checkValidValue(e,this),t.with(ChronoField.DAY_OF_YEAR,t.getLong(ChronoField.DAY_OF_YEAR)+(e-n))},n.resolve=function(t,e,n){var i=t.get(ChronoField.YEAR),o=t.get(QUARTER_OF_YEAR);if(null==i||null==o)return null;var r,a=ChronoField.YEAR.checkValidIntValue(i),s=t.get(DAY_OF_QUARTER);if(n===ResolverStyle.LENIENT){var u=o;r=(r=(r=LocalDate.of(a,1,1)).plusMonths(MathUtil.safeMultiply(MathUtil.safeSubtract(u,1),3))).plusDays(MathUtil.safeSubtract(s,1))}else{var l=QUARTER_OF_YEAR.range().checkValidIntValue(o,QUARTER_OF_YEAR);if(n===ResolverStyle.STRICT){var h=92;1===l?h=IsoChronology.isLeapYear(a)?91:90:2===l&&(h=91),ValueRange.of(1,h).checkValidValue(s,this)}else this.range().checkValidValue(s,this);r=LocalDate.of(a,3*(l-1)+1,1).plusDays(s-1)}return t.remove(this),t.remove(ChronoField.YEAR),t.remove(QUARTER_OF_YEAR),r},e}(Field),QUARTER_OF_YEAR_FIELD=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.toString=function(){return"QuarterOfYear"},n.baseUnit=function(){return QUARTER_YEARS},n.rangeUnit=function(){return ChronoUnit.YEARS},n.range=function(){return ValueRange.of(1,4)},n.isSupportedBy=function(t){return t.isSupported(ChronoField.MONTH_OF_YEAR)&&this._isIso(t)},n.rangeRefinedBy=function(t){return this.range()},n.getFrom=function(t){if(!1===t.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: QuarterOfYear");var e=t.getLong(ChronoField.MONTH_OF_YEAR);return MathUtil.intDiv(e+2,3)},n.adjustInto=function(t,e){var n=this.getFrom(t);return this.range().checkValidValue(e,this),t.with(ChronoField.MONTH_OF_YEAR,t.getLong(ChronoField.MONTH_OF_YEAR)+3*(e-n))},e}(Field),WEEK_OF_WEEK_BASED_YEAR_FIELD=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.toString=function(){return"WeekOfWeekBasedYear"},n.baseUnit=function(){return ChronoUnit.WEEKS},n.rangeUnit=function(){return WEEK_BASED_YEARS},n.range=function(){return ValueRange.of(1,52,53)},n.isSupportedBy=function(t){return t.isSupported(ChronoField.EPOCH_DAY)&&this._isIso(t)},n.rangeRefinedBy=function(t){if(!1===t.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: WeekOfWeekBasedYear");return Field._getWeekRangeByLocalDate(LocalDate.from(t))},n.getFrom=function(t){if(!1===t.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: WeekOfWeekBasedYear");return Field._getWeek(LocalDate.from(t))},n.adjustInto=function(t,e){return this.range().checkValidValue(e,this),t.plus(MathUtil.safeSubtract(e,this.getFrom(t)),ChronoUnit.WEEKS)},n.resolve=function(t,e,n){var i=t.get(WEEK_BASED_YEAR),o=t.get(ChronoField.DAY_OF_WEEK);if(null==i||null==o)return null;var r,a=WEEK_BASED_YEAR.range().checkValidIntValue(i,WEEK_BASED_YEAR),s=t.get(WEEK_OF_WEEK_BASED_YEAR);if(n===ResolverStyle.LENIENT){var u=o,l=0;u>7?(l=MathUtil.intDiv(u-1,7),u=MathUtil.intMod(u-1,7)+1):u<1&&(l=MathUtil.intDiv(u,7)-1,u=MathUtil.intMod(u,7)+7),r=LocalDate.of(a,1,4).plusWeeks(s-1).plusWeeks(l).with(ChronoField.DAY_OF_WEEK,u)}else{var h=ChronoField.DAY_OF_WEEK.checkValidIntValue(o);if(n===ResolverStyle.STRICT){var c=LocalDate.of(a,1,4);Field._getWeekRangeByLocalDate(c).checkValidValue(s,this)}else this.range().checkValidValue(s,this);r=LocalDate.of(a,1,4).plusWeeks(s-1).with(ChronoField.DAY_OF_WEEK,h)}return t.remove(this),t.remove(WEEK_BASED_YEAR),t.remove(ChronoField.DAY_OF_WEEK),r},n.displayName=function(){return"Week"},e}(Field),WEEK_BASED_YEAR_FIELD=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.toString=function(){return"WeekBasedYear"},n.baseUnit=function(){return WEEK_BASED_YEARS},n.rangeUnit=function(){return ChronoUnit.FOREVER},n.range=function(){return ChronoField.YEAR.range()},n.isSupportedBy=function(t){return t.isSupported(ChronoField.EPOCH_DAY)&&this._isIso(t)},n.rangeRefinedBy=function(t){return ChronoField.YEAR.range()},n.getFrom=function(t){if(!1===t.isSupported(this))throw new UnsupportedTemporalTypeException("Unsupported field: WeekBasedYear");return Field._getWeekBasedYear(LocalDate.from(t))},n.adjustInto=function(t,e){if(!1===this.isSupportedBy(t))throw new UnsupportedTemporalTypeException("Unsupported field: WeekBasedYear");var n=this.range().checkValidIntValue(e,WEEK_BASED_YEAR),i=LocalDate.from(t),o=i.get(ChronoField.DAY_OF_WEEK),r=Field._getWeek(i);53===r&&52===Field._getWeekRangeByYear(n)&&(r=52);var a=LocalDate.of(n,1,4),s=o-a.get(ChronoField.DAY_OF_WEEK)+7*(r-1);return a=a.plusDays(s),t.with(a)},e}(Field),Unit=function(t){function e(e,n){var i;return(i=t.call(this)||this)._name=e,i._duration=n,i}_inheritsLoose(e,t);var n=e.prototype;return n.duration=function(){return this._duration},n.isDurationEstimated=function(){return!0},n.isDateBased=function(){return!0},n.isTimeBased=function(){return!1},n.isSupportedBy=function(t){return t.isSupported(ChronoField.EPOCH_DAY)},n.addTo=function(t,e){switch(this){case WEEK_BASED_YEARS:var n=MathUtil.safeAdd(t.get(WEEK_BASED_YEAR),e);return t.with(WEEK_BASED_YEAR,n);case QUARTER_YEARS:return t.plus(MathUtil.intDiv(e,256),ChronoUnit.YEARS).plus(3*MathUtil.intMod(e,256),ChronoUnit.MONTHS);default:throw new IllegalStateException("Unreachable")}},n.between=function(t,e){switch(this){case WEEK_BASED_YEARS:return MathUtil.safeSubtract(e.getLong(WEEK_BASED_YEAR),t.getLong(WEEK_BASED_YEAR));case QUARTER_YEARS:return MathUtil.intDiv(t.until(e,ChronoUnit.MONTHS),3);default:throw new IllegalStateException("Unreachable")}},n.toString=function(){return this._name},e}(TemporalUnit),DAY_OF_QUARTER=null,QUARTER_OF_YEAR=null,WEEK_OF_WEEK_BASED_YEAR=null,WEEK_BASED_YEAR=null,WEEK_BASED_YEARS=null,QUARTER_YEARS=null;function _init$f(){DAY_OF_QUARTER=new DAY_OF_QUARTER_FIELD,QUARTER_OF_YEAR=new QUARTER_OF_YEAR_FIELD,WEEK_OF_WEEK_BASED_YEAR=new WEEK_OF_WEEK_BASED_YEAR_FIELD,WEEK_BASED_YEAR=new WEEK_BASED_YEAR_FIELD,WEEK_BASED_YEARS=new Unit("WeekBasedYears",Duration.ofSeconds(31556952)),QUARTER_YEARS=new Unit("QuarterYears",Duration.ofSeconds(7889238)),IsoFields.DAY_OF_QUARTER=DAY_OF_QUARTER,IsoFields.QUARTER_OF_YEAR=QUARTER_OF_YEAR,IsoFields.WEEK_OF_WEEK_BASED_YEAR=WEEK_OF_WEEK_BASED_YEAR,IsoFields.WEEK_BASED_YEAR=WEEK_BASED_YEAR,IsoFields.WEEK_BASED_YEARS=WEEK_BASED_YEARS,IsoFields.QUARTER_YEARS=QUARTER_YEARS,LocalDate.prototype.isoWeekOfWeekyear=function(){return this.get(IsoFields.WEEK_OF_WEEK_BASED_YEAR)},LocalDate.prototype.isoWeekyear=function(){return this.get(IsoFields.WEEK_BASED_YEAR)}}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var DecimalStyle=function(){function t(t,e,n,i){this._zeroDigit=t,this._zeroDigitCharCode=t.charCodeAt(0),this._positiveSign=e,this._negativeSign=n,this._decimalSeparator=i}var e=t.prototype;return e.positiveSign=function(){return this._positiveSign},e.withPositiveSign=function(e){return e===this._positiveSign?this:new t(this._zeroDigit,e,this._negativeSign,this._decimalSeparator)},e.negativeSign=function(){return this._negativeSign},e.withNegativeSign=function(e){return e===this._negativeSign?this:new t(this._zeroDigit,this._positiveSign,e,this._decimalSeparator)},e.zeroDigit=function(){return this._zeroDigit},e.withZeroDigit=function(e){return e===this._zeroDigit?this:new t(e,this._positiveSign,this._negativeSign,this._decimalSeparator)},e.decimalSeparator=function(){return this._decimalSeparator},e.withDecimalSeparator=function(e){return e===this._decimalSeparator?this:new t(this._zeroDigit,this._positiveSign,this._negativeSign,e)},e.convertToDigit=function(t){var e=t.charCodeAt(0)-this._zeroDigitCharCode;return e>=0&&e<=9?e:-1},e.convertNumberToI18N=function(t){if("0"===this._zeroDigit)return t;for(var e=this._zeroDigitCharCode-"0".charCodeAt(0),n="",i=0;i<t.length;i++)n+=String.fromCharCode(t.charCodeAt(i)+e);return n},e.equals=function(e){return this===e||e instanceof t&&(this._zeroDigit===e._zeroDigit&&this._positiveSign===e._positiveSign&&this._negativeSign===e._negativeSign&&this._decimalSeparator===e._decimalSeparator)},e.hashCode=function(){return this._zeroDigit+this._positiveSign+this._negativeSign+this._decimalSeparator},e.toString=function(){return"DecimalStyle["+this._zeroDigit+this._positiveSign+this._negativeSign+this._decimalSeparator+"]"},t.of=function(){throw new Error("not yet supported")},t.availableLocales=function(){throw new Error("not yet supported")},t}();DecimalStyle.STANDARD=new DecimalStyle("0","+","-",".");var SignStyle=function(t){function e(){return t.apply(this,arguments)||this}return _inheritsLoose(e,t),e.prototype.parse=function(t,n,i){switch(this){case e.NORMAL:return!t||!n;case e.ALWAYS:case e.EXCEEDS_PAD:return!0;default:return!n&&!i}},e}(Enum);SignStyle.NORMAL=new SignStyle("NORMAL"),SignStyle.NEVER=new SignStyle("NEVER"),SignStyle.ALWAYS=new SignStyle("ALWAYS"),SignStyle.EXCEEDS_PAD=new SignStyle("EXCEEDS_PAD"),SignStyle.NOT_NEGATIVE=new SignStyle("NOT_NEGATIVE");var TextStyle=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.isStandalone=function(){switch(this){case e.FULL_STANDALONE:case e.SHORT_STANDALONE:case e.NARROW_STANDALONE:return!0;default:return!1}},n.asStandalone=function(){switch(this){case e.FULL:return e.FULL_STANDALONE;case e.SHORT:return e.SHORT_STANDALONE;case e.NARROW:return e.NARROW_STANDALONE;default:return this}},n.asNormal=function(){switch(this){case e.FULL_STANDALONE:return e.FULL;case e.SHORT_STANDALONE:return e.SHORT;case e.NARROW_STANDALONE:return e.NARROW;default:return this}},e}(Enum);TextStyle.FULL=new TextStyle("FULL"),TextStyle.FULL_STANDALONE=new TextStyle("FULL_STANDALONE"),TextStyle.SHORT=new TextStyle("SHORT"),TextStyle.SHORT_STANDALONE=new TextStyle("SHORT_STANDALONE"),TextStyle.NARROW=new TextStyle("NARROW"),TextStyle.NARROW_STANDALONE=new TextStyle("NARROW_STANDALONE");
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var CharLiteralPrinterParser=function(){function t(t){if(t.length>1)throw new IllegalArgumentException('invalid literal, too long: "'+t+'"');this._literal=t}var e=t.prototype;return e.print=function(t,e){return e.append(this._literal),!0},e.parse=function(t,e,n){if(n===e.length)return~n;var i=e.charAt(n);return!1===t.charEquals(this._literal,i)?~n:n+this._literal.length},e.toString=function(){return"'"===this._literal?"''":"'"+this._literal+"'"},t}(),CompositePrinterParser=function(){function t(t,e){this._printerParsers=t,this._optional=e}var e=t.prototype;return e.withOptional=function(e){return e===this._optional?this:new t(this._printerParsers,e)},e.print=function(t,e){var n=e.length();this._optional&&t.startOptional();try{for(var i=0;i<this._printerParsers.length;i++){if(!1===this._printerParsers[i].print(t,e))return e.setLength(n),!0}}finally{this._optional&&t.endOptional()}return!0},e.parse=function(t,e,n){if(this._optional){t.startOptional();for(var i=n,o=0;o<this._printerParsers.length;o++){if((i=this._printerParsers[o].parse(t,e,i))<0)return t.endOptional(!1),n}return t.endOptional(!0),i}for(var r=0;r<this._printerParsers.length;r++){if((n=this._printerParsers[r].parse(t,e,n))<0)break}return n},e.toString=function(){var t="";if(null!=this._printerParsers){t+=this._optional?"[":"(";for(var e=0;e<this._printerParsers.length;e++){t+=this._printerParsers[e].toString()}t+=this._optional?"]":")"}return t},t}(),FractionPrinterParser=function(){function t(t,e,n,i){if(requireNonNull(t,"field"),!1===t.range().isFixed())throw new IllegalArgumentException("Field must have a fixed set of values: "+t);if(e<0||e>9)throw new IllegalArgumentException("Minimum width must be from 0 to 9 inclusive but was "+e);if(n<1||n>9)throw new IllegalArgumentException("Maximum width must be from 1 to 9 inclusive but was "+n);if(n<e)throw new IllegalArgumentException("Maximum width must exceed or equal the minimum width but "+n+" < "+e);this.field=t,this.minWidth=e,this.maxWidth=n,this.decimalPoint=i}var e=t.prototype;return e.print=function(t,e){var n=t.getValue(this.field);if(null===n)return!1;var i=t.symbols();if(0===n){if(this.minWidth>0){this.decimalPoint&&e.append(i.decimalSeparator());for(var o=0;o<this.minWidth;o++)e.append(i.zeroDigit())}}else{var r=this.convertToFraction(n,i.zeroDigit()),a=Math.min(Math.max(r.length,this.minWidth),this.maxWidth);if(1*(r=r.substr(0,a))>0)for(;r.length>this.minWidth&&"0"===r[r.length-1];)r=r.substr(0,r.length-1);var s=r;s=i.convertNumberToI18N(s),this.decimalPoint&&e.append(i.decimalSeparator()),e.append(s)}return!0},e.parse=function(t,e,n){var i=t.isStrict()?this.minWidth:0,o=t.isStrict()?this.maxWidth:9,r=e.length;if(n===r)return i>0?~n:n;if(this.decimalPoint){if(e[n]!==t.symbols().decimalSeparator())return i>0?~n:n;n++}var a=n+i;if(a>r)return~n;for(var s=Math.min(n+o,r),u=0,l=n;l<s;){var h=e.charAt(l++),c=t.symbols().convertToDigit(h);if(c<0){if(l<a)return~n;l--;break}u=10*u+c}var f=l-n,_=Math.pow(10,f),d=this.convertFromFraction(u,_);return t.setParsedField(this.field,d,n,l)},e.convertToFraction=function(t,e){var n=this.field.range();n.checkValidValue(t,this.field);for(var i=n.minimum(),o=n.maximum()-i+1,r=t-i,a=""+MathUtil.intDiv(1e9*r,o);a.length<9;)a=e+a;return a},e.convertFromFraction=function(t,e){var n=this.field.range(),i=n.minimum(),o=n.maximum()-i+1;return MathUtil.intDiv(t*o,e)},e.toString=function(){var t=this.decimalPoint?",DecimalPoint":"";return"Fraction("+this.field+","+this.minWidth+","+this.maxWidth+t+")"},t}(),MAX_WIDTH$1=15,EXCEED_POINTS=[0,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9],NumberPrinterParser=function(){function t(t,e,n,i,o){void 0===o&&(o=0),this._field=t,this._minWidth=e,this._maxWidth=n,this._signStyle=i,this._subsequentWidth=o}var e=t.prototype;return e.field=function(){return this._field},e.minWidth=function(){return this._minWidth},e.maxWidth=function(){return this._maxWidth},e.signStyle=function(){return this._signStyle},e.withFixedWidth=function(){return-1===this._subsequentWidth?this:new t(this._field,this._minWidth,this._maxWidth,this._signStyle,-1)},e.withSubsequentWidth=function(e){return new t(this._field,this._minWidth,this._maxWidth,this._signStyle,this._subsequentWidth+e)},e._isFixedWidth=function(){return-1===this._subsequentWidth||this._subsequentWidth>0&&this._minWidth===this._maxWidth&&this._signStyle===SignStyle.NOT_NEGATIVE},e.print=function(t,e){var n=t.getValue(this._field);if(null==n)return!1;var i=this._getValue(t,n),o=t.symbols(),r=""+Math.abs(i);if(r.length>this._maxWidth)throw new DateTimeException("Field "+this._field+" cannot be printed as the value "+i+" exceeds the maximum print width of "+this._maxWidth);if(r=o.convertNumberToI18N(r),i>=0)switch(this._signStyle){case SignStyle.EXCEEDS_PAD:this._minWidth<MAX_WIDTH$1&&i>=EXCEED_POINTS[this._minWidth]&&e.append(o.positiveSign());break;case SignStyle.ALWAYS:e.append(o.positiveSign())}else switch(this._signStyle){case SignStyle.NORMAL:case SignStyle.EXCEEDS_PAD:case SignStyle.ALWAYS:e.append(o.negativeSign());break;case SignStyle.NOT_NEGATIVE:throw new DateTimeException("Field "+this._field+" cannot be printed as the value "+i+" cannot be negative according to the SignStyle")}for(var a=0;a<this._minWidth-r.length;a++)e.append(o.zeroDigit());return e.append(r),!0},e.parse=function(t,e,n){var i=e.length;if(n===i)return~n;assert(n>=0&&n<i);var o=e.charAt(n),r=!1,a=!1;if(o===t.symbols().positiveSign()){if(!1===this._signStyle.parse(!0,t.isStrict(),this._minWidth===this._maxWidth))return~n;a=!0,n++}else if(o===t.symbols().negativeSign()){if(!1===this._signStyle.parse(!1,t.isStrict(),this._minWidth===this._maxWidth))return~n;r=!0,n++}else if(this._signStyle===SignStyle.ALWAYS&&t.isStrict())return~n;var s=t.isStrict()||this._isFixedWidth()?this._minWidth:1,u=n+s;if(u>i)return~n;for(var l=(t.isStrict()||this._isFixedWidth()?this._maxWidth:9)+Math.max(this._subsequentWidth,0),h=0,c=n,f=0;f<2;f++){for(var _=Math.min(c+l,i);c<_;){var d=e.charAt(c++),p=t.symbols().convertToDigit(d);if(p<0){if(--c<u)return~n;break}if(c-n>MAX_WIDTH$1)throw new ArithmeticException("number text exceeds length");h=10*h+p}if(!(this._subsequentWidth>0&&0===f))break;var m=c-n;l=Math.max(s,m-this._subsequentWidth),c=n,h=0}if(r){if(0===h&&t.isStrict())return~(n-1);0!==h&&(h=-h)}else if(this._signStyle===SignStyle.EXCEEDS_PAD&&t.isStrict()){var E=c-n;if(a){if(E<=this._minWidth)return~(n-1)}else if(E>this._minWidth)return~n}return this._setValue(t,h,n,c)},e._getValue=function(t,e){return e},e._setValue=function(t,e,n,i){return t.setParsedField(this._field,e,n,i)},e.toString=function(){return 1===this._minWidth&&this._maxWidth===MAX_WIDTH$1&&this._signStyle===SignStyle.NORMAL?"Value("+this._field+")":this._minWidth===this._maxWidth&&this._signStyle===SignStyle.NOT_NEGATIVE?"Value("+this._field+","+this._minWidth+")":"Value("+this._field+","+this._minWidth+","+this._maxWidth+","+this._signStyle+")"},t}(),ReducedPrinterParser=function(t){function e(e,n,i,o,r){var a;if(a=t.call(this,e,n,i,SignStyle.NOT_NEGATIVE)||this,n<1||n>10)throw new IllegalArgumentException("The width must be from 1 to 10 inclusive but was "+n);if(i<1||i>10)throw new IllegalArgumentException("The maxWidth must be from 1 to 10 inclusive but was "+i);if(i<n)throw new IllegalArgumentException("The maxWidth must be greater than the width");if(null===r){if(!1===e.range().isValidValue(o))throw new IllegalArgumentException("The base value must be within the range of the field");if(o+EXCEED_POINTS[n]>MathUtil.MAX_SAFE_INTEGER)throw new DateTimeException("Unable to add printer-parser as the range exceeds the capacity of an int")}return a._baseValue=o,a._baseDate=r,a}_inheritsLoose(e,t);var n=e.prototype;return n._getValue=function(t,e){var n=Math.abs(e),i=this._baseValue;null!==this._baseDate&&(t.temporal(),i=IsoChronology.INSTANCE.date(this._baseDate).get(this._field));return e>=i&&e<i+EXCEED_POINTS[this._minWidth]?n%EXCEED_POINTS[this._minWidth]:n%EXCEED_POINTS[this._maxWidth]},n._setValue=function(t,e,n,i){var o=this._baseValue;null!=this._baseDate&&(o=t.getEffectiveChronology().date(this._baseDate).get(this._field));if(i-n===this._minWidth&&e>=0){var r=EXCEED_POINTS[this._minWidth],a=o-o%r;(e=o>0?a+e:a-e)<o&&(e+=r)}return t.setParsedField(this._field,e,n,i)},n.withFixedWidth=function(){return-1===this._subsequentWidth?this:new e(this._field,this._minWidth,this._maxWidth,this._baseValue,this._baseDate)},n.withSubsequentWidth=function(t){return new e(this._field,this._minWidth,this._maxWidth,this._baseValue,this._baseDate,this._subsequentWidth+t)},n.isFixedWidth=function(e){return!1!==e.isStrict()&&t.prototype.isFixedWidth.call(this,e)},n.toString=function(){return"ReducedValue("+this._field+","+this._minWidth+","+this._maxWidth+","+(null!=this._baseDate?this._baseDate:this._baseValue)+")"},e}(NumberPrinterParser),PATTERNS=["+HH","+HHmm","+HH:mm","+HHMM","+HH:MM","+HHMMss","+HH:MM:ss","+HHMMSS","+HH:MM:SS"],OffsetIdPrinterParser=function(){function t(t,e){requireNonNull(t,"noOffsetText"),requireNonNull(e,"pattern"),this.noOffsetText=t,this.type=this._checkPattern(e)}var e=t.prototype;return e._checkPattern=function(t){for(var e=0;e<PATTERNS.length;e++)if(PATTERNS[e]===t)return e;throw new IllegalArgumentException("Invalid zone offset pattern: "+t)},e.print=function(t,e){var n=t.getValue(ChronoField.OFFSET_SECONDS);if(null==n)return!1;var i=MathUtil.safeToInt(n);if(0===i)e.append(this.noOffsetText);else{var o=Math.abs(MathUtil.intMod(MathUtil.intDiv(i,3600),100)),r=Math.abs(MathUtil.intMod(MathUtil.intDiv(i,60),60)),a=Math.abs(MathUtil.intMod(i,60)),s=e.length(),u=o;e.append(i<0?"-":"+").appendChar(MathUtil.intDiv(o,10)+"0").appendChar(MathUtil.intMod(o,10)+"0"),(this.type>=3||this.type>=1&&r>0)&&(e.append(this.type%2==0?":":"").appendChar(MathUtil.intDiv(r,10)+"0").appendChar(r%10+"0"),u+=r,(this.type>=7||this.type>=5&&a>0)&&(e.append(this.type%2==0?":":"").appendChar(MathUtil.intDiv(a,10)+"0").appendChar(a%10+"0"),u+=a)),0===u&&(e.setLength(s),e.append(this.noOffsetText))}return!0},e.parse=function(t,e,n){var i=e.length,o=this.noOffsetText.length;if(0===o){if(n===i)return t.setParsedField(ChronoField.OFFSET_SECONDS,0,n,n)}else{if(n===i)return~n;if(t.subSequenceEquals(e,n,this.noOffsetText,0,o))return t.setParsedField(ChronoField.OFFSET_SECONDS,0,n,n+o)}var r=e[n];if("+"===r||"-"===r){var a="-"===r?-1:1,s=[0,0,0,0];if(s[0]=n+1,!1===(this._parseNumber(s,1,e,!0)||this._parseNumber(s,2,e,this.type>=3)||this._parseNumber(s,3,e,!1))){var u=MathUtil.safeZero(a*(3600*s[1]+60*s[2]+s[3]));return t.setParsedField(ChronoField.OFFSET_SECONDS,u,n,s[0])}}return 0===o?t.setParsedField(ChronoField.OFFSET_SECONDS,0,n,n+o):~n},e._parseNumber=function(t,e,n,i){if((this.type+3)/2<e)return!1;var o=t[0];if(this.type%2==0&&e>1){if(o+1>n.length||":"!==n[o])return i;o++}if(o+2>n.length)return i;var r=n[o++],a=n[o++];if(r<"0"||r>"9"||a<"0"||a>"9")return i;var s=10*(r.charCodeAt(0)-48)+(a.charCodeAt(0)-48);return s<0||s>59?i:(t[e]=s,t[0]=o,!1)},e.toString=function(){var t=this.noOffsetText.replace("'","''");return"Offset("+PATTERNS[this.type]+",'"+t+"')"},t}();
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */OffsetIdPrinterParser.INSTANCE_ID=new OffsetIdPrinterParser("Z","+HH:MM:ss"),OffsetIdPrinterParser.PATTERNS=PATTERNS;
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var PadPrinterParserDecorator=function(){function t(t,e,n){this._printerParser=t,this._padWidth=e,this._padChar=n}var e=t.prototype;return e.print=function(t,e){var n=e.length();if(!1===this._printerParser.print(t,e))return!1;var i=e.length()-n;if(i>this._padWidth)throw new DateTimeException("Cannot print as output of "+i+" characters exceeds pad width of "+this._padWidth);for(var o=0;o<this._padWidth-i;o++)e.insert(n,this._padChar);return!0},e.parse=function(t,e,n){var i=t.isStrict(),o=t.isCaseSensitive();if(assert(!(n>e.length)),assert(n>=0),n===e.length)return~n;var r=n+this._padWidth;if(r>e.length){if(i)return~n;r=e.length}for(var a=n;a<r&&(o?e[a]===this._padChar:t.charEquals(e[a],this._padChar));)a++;e=e.substring(0,r);var s=this._printerParser.parse(t,e,a);return s!==r&&i?~(n+a):s},e.toString=function(){return"Pad("+this._printerParser+","+this._padWidth+(" "===this._padChar?")":",'"+this._padChar+"')")},t}(),SettingsParser=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.print=function(){return!0},n.parse=function(t,n,i){switch(this){case e.SENSITIVE:t.setCaseSensitive(!0);break;case e.INSENSITIVE:t.setCaseSensitive(!1);break;case e.STRICT:t.setStrict(!0);break;case e.LENIENT:t.setStrict(!1)}return i},n.toString=function(){switch(this){case e.SENSITIVE:return"ParseCaseSensitive(true)";case e.INSENSITIVE:return"ParseCaseSensitive(false)";case e.STRICT:return"ParseStrict(true)";case e.LENIENT:return"ParseStrict(false)"}},e}(Enum);SettingsParser.SENSITIVE=new SettingsParser("SENSITIVE"),SettingsParser.INSENSITIVE=new SettingsParser("INSENSITIVE"),SettingsParser.STRICT=new SettingsParser("STRICT"),SettingsParser.LENIENT=new SettingsParser("LENIENT");
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var StringLiteralPrinterParser=function(){function t(t){this._literal=t}var e=t.prototype;return e.print=function(t,e){return e.append(this._literal),!0},e.parse=function(t,e,n){return assert(!(n>e.length||n<0)),!1===t.subSequenceEquals(e,n,this._literal,0,this._literal.length)?~n:n+this._literal.length},e.toString=function(){return"'"+this._literal.replace("'","''")+"'"},t}(),ZoneRulesProvider=function(){function t(){}return t.getRules=function(t){throw new DateTimeException("unsupported ZoneId:"+t)},t.getAvailableZoneIds=function(){return[]},t}(),ZoneRegion=function(t){function e(e,n){var i;return(i=t.call(this)||this)._id=e,i._rules=n,i}_inheritsLoose(e,t),e.ofId=function(t){return new e(t,ZoneRulesProvider.getRules(t))};var n=e.prototype;return n.id=function(){return this._id},n.rules=function(){return this._rules},e}(ZoneId),ZoneIdPrinterParser=function(){function t(t,e){this.query=t,this.description=e}var e=t.prototype;return e.print=function(t,e){var n=t.getValueQuery(this.query);return null!=n&&(e.append(n.id()),!0)},e.parse=function(t,e,n){var i=e.length;if(n>i)return~n;if(n===i)return~n;var o=e.charAt(n);if("+"===o||"-"===o){var r=t.copy(),a=OffsetIdPrinterParser.INSTANCE_ID.parse(r,e,n);if(a<0)return a;var s=r.getParsed(ChronoField.OFFSET_SECONDS),u=ZoneOffset.ofTotalSeconds(s);return t.setParsedZone(u),a}if(i>=n+2){var l=e.charAt(n+1);if(t.charEquals(o,"U")&&t.charEquals(l,"T"))return i>=n+3&&t.charEquals(e.charAt(n+2),"C")?this._parsePrefixedOffset(t,e,n,n+3):this._parsePrefixedOffset(t,e,n,n+2);if(t.charEquals(o,"G")&&i>=n+3&&t.charEquals(l,"M")&&t.charEquals(e.charAt(n+2),"T"))return this._parsePrefixedOffset(t,e,n,n+3)}if("SYSTEM"===e.substr(n,6))return t.setParsedZone(ZoneId.systemDefault()),n+6;if(t.charEquals(o,"Z"))return t.setParsedZone(ZoneOffset.UTC),n+1;var h=ZoneRulesProvider.getAvailableZoneIds();zoneIdTree.size!==h.length&&(zoneIdTree=ZoneIdTree.createTreeMap(h));for(var c=i-n,f=zoneIdTree.treeMap,_=null,d=0;null!=f;){var p=e.substr(n,Math.min(f.length,c));null!=(f=f.get(p))&&f.isLeaf&&(_=p,d=f.length)}return null!=_?(t.setParsedZone(ZoneRegion.ofId(_)),n+d):~n},e._parsePrefixedOffset=function(t,e,n,i){var o=e.substring(n,i).toUpperCase(),r=t.copy();if(i<e.length&&t.charEquals(e.charAt(i),"Z"))return t.setParsedZone(ZoneId.ofOffset(o,ZoneOffset.UTC)),i;var a=OffsetIdPrinterParser.INSTANCE_ID.parse(r,e,i);if(a<0)return t.setParsedZone(ZoneId.ofOffset(o,ZoneOffset.UTC)),i;var s=r.getParsed(ChronoField.OFFSET_SECONDS),u=ZoneOffset.ofTotalSeconds(s);return t.setParsedZone(ZoneId.ofOffset(o,u)),a},e.toString=function(){return this.description},t}(),ZoneIdTree=function(){function t(t,e){this.size=t,this.treeMap=e}return t.createTreeMap=function(e){for(var n=e.sort((function(t,e){return t.length-e.length})),i=new ZoneIdTreeMap(n[0].length,!1),o=0;o<n.length;o++)i.add(n[o]);return new t(n.length,i)},t}(),ZoneIdTreeMap=function(){function t(t,e){void 0===t&&(t=0),void 0===e&&(e=!1),this.length=t,this.isLeaf=e,this._treeMap={}}var e=t.prototype;return e.add=function(e){var n=e.length;if(n===this.length)this._treeMap[e]=new t(n,!0);else if(n>this.length){var i=e.substr(0,this.length),o=this._treeMap[i];null==o&&(o=new t(n,!1),this._treeMap[i]=o),o.add(e)}},e.get=function(t){return this._treeMap[t]},t}(),zoneIdTree=new ZoneIdTree([]),MAX_WIDTH=15,DateTimeFormatterBuilder=function(){function t(){this._active=this,this._parent=null,this._printerParsers=[],this._optional=!1,this._padNextWidth=0,this._padNextChar=null,this._valueParserIndex=-1}t._of=function(e,n){requireNonNull(e,"parent"),requireNonNull(n,"optional");var i=new t;return i._parent=e,i._optional=n,i};var e=t.prototype;return e.parseCaseSensitive=function(){return this._appendInternalPrinterParser(SettingsParser.SENSITIVE),this},e.parseCaseInsensitive=function(){return this._appendInternalPrinterParser(SettingsParser.INSENSITIVE),this},e.parseStrict=function(){return this._appendInternalPrinterParser(SettingsParser.STRICT),this},e.parseLenient=function(){return this._appendInternalPrinterParser(SettingsParser.LENIENT),this},e.parseDefaulting=function(t,e){return requireNonNull(t),this._appendInternal(new DefaultingParser(t,e)),this},e.appendValue=function(){return 1===arguments.length?this._appendValue1.apply(this,arguments):2===arguments.length?this._appendValue2.apply(this,arguments):this._appendValue4.apply(this,arguments)},e._appendValue1=function(t){return requireNonNull(t),this._appendValuePrinterParser(new NumberPrinterParser(t,1,MAX_WIDTH,SignStyle.NORMAL)),this},e._appendValue2=function(t,e){if(requireNonNull(t),e<1||e>MAX_WIDTH)throw new IllegalArgumentException("The width must be from 1 to "+MAX_WIDTH+" inclusive but was "+e);var n=new NumberPrinterParser(t,e,e,SignStyle.NOT_NEGATIVE);return this._appendValuePrinterParser(n),this},e._appendValue4=function(t,e,n,i){if(requireNonNull(t),requireNonNull(i),e===n&&i===SignStyle.NOT_NEGATIVE)return this._appendValue2(t,n);if(e<1||e>MAX_WIDTH)throw new IllegalArgumentException("The minimum width must be from 1 to "+MAX_WIDTH+" inclusive but was "+e);if(n<1||n>MAX_WIDTH)throw new IllegalArgumentException("The minimum width must be from 1 to "+MAX_WIDTH+" inclusive but was "+n);if(n<e)throw new IllegalArgumentException("The maximum width must exceed or equal the minimum width but "+n+" < "+e);var o=new NumberPrinterParser(t,e,n,i);return this._appendValuePrinterParser(o),this},e.appendValueReduced=function(){return 4===arguments.length&&arguments[3]instanceof ChronoLocalDate?this._appendValueReducedFieldWidthMaxWidthBaseDate.apply(this,arguments):this._appendValueReducedFieldWidthMaxWidthBaseValue.apply(this,arguments)},e._appendValueReducedFieldWidthMaxWidthBaseValue=function(t,e,n,i){requireNonNull(t,"field");var o=new ReducedPrinterParser(t,e,n,i,null);return this._appendValuePrinterParser(o),this},e._appendValueReducedFieldWidthMaxWidthBaseDate=function(t,e,n,i){requireNonNull(t,"field"),requireNonNull(i,"baseDate"),requireInstance(i,ChronoLocalDate,"baseDate");var o=new ReducedPrinterParser(t,e,n,0,i);return this._appendValuePrinterParser(o),this},e._appendValuePrinterParser=function(t){if(assert(null!=t),this._active._valueParserIndex>=0&&this._active._printerParsers[this._active._valueParserIndex]instanceof NumberPrinterParser){var e=this._active._valueParserIndex,n=this._active._printerParsers[e];t.minWidth()===t.maxWidth()&&t.signStyle()===SignStyle.NOT_NEGATIVE?(n=n.withSubsequentWidth(t.maxWidth()),this._appendInternal(t.withFixedWidth()),this._active._valueParserIndex=e):(n=n.withFixedWidth(),this._active._valueParserIndex=this._appendInternal(t)),this._active._printerParsers[e]=n}else this._active._valueParserIndex=this._appendInternal(t);return this},e.appendFraction=function(t,e,n,i){return this._appendInternal(new FractionPrinterParser(t,e,n,i)),this},e.appendInstant=function(t){if(void 0===t&&(t=-2),t<-2||t>9)throw new IllegalArgumentException("Invalid fractional digits: "+t);return this._appendInternal(new InstantPrinterParser(t)),this},e.appendOffsetId=function(){return this._appendInternal(OffsetIdPrinterParser.INSTANCE_ID),this},e.appendOffset=function(t,e){return this._appendInternalPrinterParser(new OffsetIdPrinterParser(e,t)),this},e.appendZoneId=function(){return this._appendInternal(new ZoneIdPrinterParser(TemporalQueries.zoneId(),"ZoneId()")),this},e.appendPattern=function(t){return requireNonNull(t,"pattern"),this._parsePattern(t),this},e.appendZoneText=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},e.appendText=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},e.appendLocalizedOffset=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},e.appendWeekField=function(){throw new IllegalArgumentException("Pattern using (localized) text not implemented, use @js-joda/locale plugin!")},e._parsePattern=function(t){for(var e={G:ChronoField.ERA,y:ChronoField.YEAR_OF_ERA,u:ChronoField.YEAR,Q:IsoFields.QUARTER_OF_YEAR,q:IsoFields.QUARTER_OF_YEAR,M:ChronoField.MONTH_OF_YEAR,L:ChronoField.MONTH_OF_YEAR,D:ChronoField.DAY_OF_YEAR,d:ChronoField.DAY_OF_MONTH,F:ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH,E:ChronoField.DAY_OF_WEEK,c:ChronoField.DAY_OF_WEEK,e:ChronoField.DAY_OF_WEEK,a:ChronoField.AMPM_OF_DAY,H:ChronoField.HOUR_OF_DAY,k:ChronoField.CLOCK_HOUR_OF_DAY,K:ChronoField.HOUR_OF_AMPM,h:ChronoField.CLOCK_HOUR_OF_AMPM,m:ChronoField.MINUTE_OF_HOUR,s:ChronoField.SECOND_OF_MINUTE,S:ChronoField.NANO_OF_SECOND,A:ChronoField.MILLI_OF_DAY,n:ChronoField.NANO_OF_SECOND,N:ChronoField.NANO_OF_DAY},n=0;n<t.length;n++){var i=t.charAt(n);if(i>="A"&&i<="Z"||i>="a"&&i<="z"){for(var o=n++;n<t.length&&t.charAt(n)===i;n++);var r=n-o;if("p"===i){var a=0;if(n<t.length&&((i=t.charAt(n))>="A"&&i<="Z"||i>="a"&&i<="z")){for(a=r,o=n++;n<t.length&&t.charAt(n)===i;n++);r=n-o}if(0===a)throw new IllegalArgumentException("Pad letter 'p' must be followed by valid pad pattern: "+t);this.padNext(a)}var s=e[i];if(null!=s)this._parseField(i,r,s);else if("z"===i){if(r>4)throw new IllegalArgumentException("Too many pattern letters: "+i);4===r?this.appendZoneText(TextStyle.FULL):this.appendZoneText(TextStyle.SHORT)}else if("V"===i){if(2!==r)throw new IllegalArgumentException("Pattern letter count must be 2: "+i);this.appendZoneId()}else if("Z"===i)if(r<4)this.appendOffset("+HHMM","+0000");else if(4===r)this.appendLocalizedOffset(TextStyle.FULL);else{if(5!==r)throw new IllegalArgumentException("Too many pattern letters: "+i);this.appendOffset("+HH:MM:ss","Z")}else if("O"===i)if(1===r)this.appendLocalizedOffset(TextStyle.SHORT);else{if(4!==r)throw new IllegalArgumentException("Pattern letter count must be 1 or 4: "+i);this.appendLocalizedOffset(TextStyle.FULL)}else if("X"===i){if(r>5)throw new IllegalArgumentException("Too many pattern letters: "+i);this.appendOffset(OffsetIdPrinterParser.PATTERNS[r+(1===r?0:1)],"Z")}else if("x"===i){if(r>5)throw new IllegalArgumentException("Too many pattern letters: "+i);var u=1===r?"+00":r%2==0?"+0000":"+00:00";this.appendOffset(OffsetIdPrinterParser.PATTERNS[r+(1===r?0:1)],u)}else if("W"===i){if(r>1)throw new IllegalArgumentException("Too many pattern letters: "+i);this.appendWeekField("W",r)}else if("w"===i){if(r>2)throw new IllegalArgumentException("Too many pattern letters: "+i);this.appendWeekField("w",r)}else{if("Y"!==i)throw new IllegalArgumentException("Unknown pattern letter: "+i);this.appendWeekField("Y",r)}n--}else if("'"===i){for(var l=n++;n<t.length;n++)if("'"===t.charAt(n)){if(!(n+1<t.length&&"'"===t.charAt(n+1)))break;n++}if(n>=t.length)throw new IllegalArgumentException("Pattern ends with an incomplete string literal: "+t);var h=t.substring(l+1,n);0===h.length?this.appendLiteral("'"):this.appendLiteral(h.replace("''","'"))}else if("["===i)this.optionalStart();else if("]"===i){if(null===this._active._parent)throw new IllegalArgumentException("Pattern invalid as it contains ] without previous [");this.optionalEnd()}else{if("{"===i||"}"===i||"#"===i)throw new IllegalArgumentException("Pattern includes reserved character: '"+i+"'");this.appendLiteral(i)}}},e._parseField=function(t,e,n){switch(t){case"u":case"y":2===e?this.appendValueReduced(n,2,2,ReducedPrinterParser.BASE_DATE):e<4?this.appendValue(n,e,MAX_WIDTH,SignStyle.NORMAL):this.appendValue(n,e,MAX_WIDTH,SignStyle.EXCEEDS_PAD);break;case"M":case"Q":switch(e){case 1:this.appendValue(n);break;case 2:this.appendValue(n,2);break;case 3:this.appendText(n,TextStyle.SHORT);break;case 4:this.appendText(n,TextStyle.FULL);break;case 5:this.appendText(n,TextStyle.NARROW);break;default:throw new IllegalArgumentException("Too many pattern letters: "+t)}break;case"L":case"q":switch(e){case 1:this.appendValue(n);break;case 2:this.appendValue(n,2);break;case 3:this.appendText(n,TextStyle.SHORT_STANDALONE);break;case 4:this.appendText(n,TextStyle.FULL_STANDALONE);break;case 5:this.appendText(n,TextStyle.NARROW_STANDALONE);break;default:throw new IllegalArgumentException("Too many pattern letters: "+t)}break;case"e":switch(e){case 1:case 2:this.appendWeekField("e",e);break;case 3:this.appendText(n,TextStyle.SHORT);break;case 4:this.appendText(n,TextStyle.FULL);break;case 5:this.appendText(n,TextStyle.NARROW);break;default:throw new IllegalArgumentException("Too many pattern letters: "+t)}break;case"c":switch(e){case 1:this.appendWeekField("c",e);break;case 2:throw new IllegalArgumentException("Invalid number of pattern letters: "+t);case 3:this.appendText(n,TextStyle.SHORT_STANDALONE);break;case 4:this.appendText(n,TextStyle.FULL_STANDALONE);break;case 5:this.appendText(n,TextStyle.NARROW_STANDALONE);break;default:throw new IllegalArgumentException("Too many pattern letters: "+t)}break;case"a":if(1!==e)throw new IllegalArgumentException("Too many pattern letters: "+t);this.appendText(n,TextStyle.SHORT);break;case"E":case"G":switch(e){case 1:case 2:case 3:this.appendText(n,TextStyle.SHORT);break;case 4:this.appendText(n,TextStyle.FULL);break;case 5:this.appendText(n,TextStyle.NARROW);break;default:throw new IllegalArgumentException("Too many pattern letters: "+t)}break;case"S":this.appendFraction(ChronoField.NANO_OF_SECOND,e,e,!1);break;case"F":if(1!==e)throw new IllegalArgumentException("Too many pattern letters: "+t);this.appendValue(n);break;case"d":case"h":case"H":case"k":case"K":case"m":case"s":if(1===e)this.appendValue(n);else{if(2!==e)throw new IllegalArgumentException("Too many pattern letters: "+t);this.appendValue(n,e)}break;case"D":if(1===e)this.appendValue(n);else{if(!(e<=3))throw new IllegalArgumentException("Too many pattern letters: "+t);this.appendValue(n,e)}break;default:1===e?this.appendValue(n):this.appendValue(n,e)}},e.padNext=function(){return 1===arguments.length?this._padNext1.apply(this,arguments):this._padNext2.apply(this,arguments)},e._padNext1=function(t){return this._padNext2(t," ")},e._padNext2=function(t,e){if(t<1)throw new IllegalArgumentException("The pad width must be at least one but was "+t);return this._active._padNextWidth=t,this._active._padNextChar=e,this._active._valueParserIndex=-1,this},e.optionalStart=function(){return this._active._valueParserIndex=-1,this._active=t._of(this._active,!0),this},e.optionalEnd=function(){if(null==this._active._parent)throw new IllegalStateException("Cannot call optionalEnd() as there was no previous call to optionalStart()");if(this._active._printerParsers.length>0){var t=new CompositePrinterParser(this._active._printerParsers,this._active._optional);this._active=this._active._parent,this._appendInternal(t)}else this._active=this._active._parent;return this},e._appendInternal=function(t){return assert(null!=t),this._active._padNextWidth>0&&(null!=t&&(t=new PadPrinterParserDecorator(t,this._active._padNextWidth,this._active._padNextChar)),this._active._padNextWidth=0,this._active._padNextChar=0),this._active._printerParsers.push(t),this._active._valueParserIndex=-1,this._active._printerParsers.length-1},e.appendLiteral=function(t){return assert(null!=t),t.length>0&&(1===t.length?this._appendInternalPrinterParser(new CharLiteralPrinterParser(t.charAt(0))):this._appendInternalPrinterParser(new StringLiteralPrinterParser(t))),this},e._appendInternalPrinterParser=function(t){return assert(null!=t),this._active._padNextWidth>0&&(null!=t&&(t=new PadPrinterParserDecorator(t,this._active._padNextWidth,this._active._padNextChar)),this._active._padNextWidth=0,this._active._padNextChar=0),this._active._printerParsers.push(t),this._active._valueParserIndex=-1,this._active._printerParsers.length-1},e.append=function(t){return requireNonNull(t,"formatter"),this._appendInternal(t._toPrinterParser(!1)),this},e.toFormatter=function(t){for(void 0===t&&(t=ResolverStyle.SMART);null!=this._active._parent;)this.optionalEnd();var e=new CompositePrinterParser(this._printerParsers,!1);return new DateTimeFormatter(e,null,DecimalStyle.STANDARD,t,null,null,null)},t}(),SECONDS_PER_10000_YEARS=31556952e4,SECONDS_0000_TO_1970=62167219200,InstantPrinterParser=function(){function t(t){this.fractionalDigits=t}var e=t.prototype;return e.print=function(t,e){var n=t.getValue(ChronoField.INSTANT_SECONDS),i=0;if(t.temporal().isSupported(ChronoField.NANO_OF_SECOND)&&(i=t.temporal().getLong(ChronoField.NANO_OF_SECOND)),null==n)return!1;var o=n,r=ChronoField.NANO_OF_SECOND.checkValidIntValue(i);if(o>=-SECONDS_0000_TO_1970){var a=o-SECONDS_PER_10000_YEARS+SECONDS_0000_TO_1970,s=MathUtil.floorDiv(a,SECONDS_PER_10000_YEARS)+1,u=MathUtil.floorMod(a,SECONDS_PER_10000_YEARS),l=LocalDateTime.ofEpochSecond(u-SECONDS_0000_TO_1970,0,ZoneOffset.UTC);s>0&&e.append("+").append(s),e.append(l.toString()),0===l.second()&&e.append(":00")}else{var h=o+SECONDS_0000_TO_1970,c=MathUtil.intDiv(h,SECONDS_PER_10000_YEARS),f=MathUtil.intMod(h,SECONDS_PER_10000_YEARS),_=LocalDateTime.ofEpochSecond(f-SECONDS_0000_TO_1970,0,ZoneOffset.UTC),d=e.length();e.append(_.toString()),0===_.second()&&e.append(":00"),c<0&&(-1e4===_.year()?e.replace(d,d+2,""+(c-1)):0===f?e.insert(d,c):e.insert(d+1,Math.abs(c)))}if(-2===this.fractionalDigits)0!==r&&(e.append("."),0===MathUtil.intMod(r,1e6)?e.append((""+(MathUtil.intDiv(r,1e6)+1e3)).substring(1)):0===MathUtil.intMod(r,1e3)?e.append((""+(MathUtil.intDiv(r,1e3)+1e6)).substring(1)):e.append((""+(r+1e9)).substring(1)));else if(this.fractionalDigits>0||-1===this.fractionalDigits&&r>0){e.append(".");for(var p=1e8,m=0;-1===this.fractionalDigits&&r>0||m<this.fractionalDigits;m++){var E=MathUtil.intDiv(r,p);e.append(E),r-=E*p,p=MathUtil.intDiv(p,10)}}return e.append("Z"),!0},e.parse=function(t,e,n){var i=t.copy(),o=this.fractionalDigits<0?0:this.fractionalDigits,r=this.fractionalDigits<0?9:this.fractionalDigits,a=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_LOCAL_DATE).appendLiteral("T").appendValue(ChronoField.HOUR_OF_DAY,2).appendLiteral(":").appendValue(ChronoField.MINUTE_OF_HOUR,2).appendLiteral(":").appendValue(ChronoField.SECOND_OF_MINUTE,2).appendFraction(ChronoField.NANO_OF_SECOND,o,r,!0).appendLiteral("Z").toFormatter()._toPrinterParser(!1).parse(i,e,n);if(a<0)return a;var s,u=i.getParsed(ChronoField.YEAR),l=i.getParsed(ChronoField.MONTH_OF_YEAR),h=i.getParsed(ChronoField.DAY_OF_MONTH),c=i.getParsed(ChronoField.HOUR_OF_DAY),f=i.getParsed(ChronoField.MINUTE_OF_HOUR),_=i.getParsed(ChronoField.SECOND_OF_MINUTE),d=i.getParsed(ChronoField.NANO_OF_SECOND),p=null!=_?_:0,m=null!=d?d:0,E=MathUtil.intMod(u,1e4),T=0;24===c&&0===f&&0===p&&0===m?(c=0,T=1):23===c&&59===f&&60===p&&(t.setParsedLeapSecond(),p=59);try{s=LocalDateTime.of(E,l,h,c,f,p,0).plusDays(T).toEpochSecond(ZoneOffset.UTC),s+=MathUtil.safeMultiply(MathUtil.intDiv(u,1e4),SECONDS_PER_10000_YEARS)}catch(t){return~n}var S=a;return S=t.setParsedField(ChronoField.INSTANT_SECONDS,s,n,S),t.setParsedField(ChronoField.NANO_OF_SECOND,m,n,S)},e.toString=function(){return"Instant()"},t}(),DefaultingParser=function(){function t(t,e){this._field=t,this._value=e}var e=t.prototype;return e.print=function(){return!0},e.parse=function(t,e,n){return null==t.getParsed(this._field)&&t.setParsedField(this._field,this._value,n,n),n},t}();
/*
 * @copyright (c) 2016, Philipp Thürwächter, Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$e(){ReducedPrinterParser.BASE_DATE=LocalDate.of(2e3,1,1),DateTimeFormatterBuilder.CompositePrinterParser=CompositePrinterParser,DateTimeFormatterBuilder.PadPrinterParserDecorator=PadPrinterParserDecorator,DateTimeFormatterBuilder.SettingsParser=SettingsParser,DateTimeFormatterBuilder.CharLiteralPrinterParser=StringLiteralPrinterParser,DateTimeFormatterBuilder.StringLiteralPrinterParser=StringLiteralPrinterParser,DateTimeFormatterBuilder.CharLiteralPrinterParser=CharLiteralPrinterParser,DateTimeFormatterBuilder.NumberPrinterParser=NumberPrinterParser,DateTimeFormatterBuilder.ReducedPrinterParser=ReducedPrinterParser,DateTimeFormatterBuilder.FractionPrinterParser=FractionPrinterParser,DateTimeFormatterBuilder.OffsetIdPrinterParser=OffsetIdPrinterParser,DateTimeFormatterBuilder.ZoneIdPrinterParser=ZoneIdPrinterParser}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var StringBuilder=function(){function t(){this._str=""}var e=t.prototype;return e.append=function(t){return this._str+=t,this},e.appendChar=function(t){return this._str+=t[0],this},e.insert=function(t,e){return this._str=this._str.slice(0,t)+e+this._str.slice(t),this},e.replace=function(t,e,n){return this._str=this._str.slice(0,t)+n+this._str.slice(e),this},e.length=function(){return this._str.length},e.setLength=function(t){return this._str=this._str.slice(0,t),this},e.toString=function(){return this._str},t}(),DateTimeFormatter=function(){function t(t,e,n,i,o,r,a){void 0===r&&(r=IsoChronology.INSTANCE),assert(null!=t),assert(null!=n),assert(null!=i),this._printerParser=t,this._locale=e,this._decimalStyle=n,this._resolverStyle=i,this._resolverFields=o,this._chrono=r,this._zone=a}t.parsedExcessDays=function(){return t.PARSED_EXCESS_DAYS},t.parsedLeapSecond=function(){return t.PARSED_LEAP_SECOND},t.ofPattern=function(t){return(new DateTimeFormatterBuilder).appendPattern(t).toFormatter()};var e=t.prototype;return e.locale=function(){return this._locale},e.decimalStyle=function(){return this._decimalStyle},e.chronology=function(){return this._chrono},e.withChronology=function(e){return null!=this._chrono&&this._chrono.equals(e)?this:new t(this._printerParser,this._locale,this._decimalStyle,this._resolverStyle,this._resolverFields,e,this._zone)},e.withLocale=function(){return this},e.withResolverStyle=function(e){return requireNonNull(e,"resolverStyle"),e.equals(this._resolverStyle)?this:new t(this._printerParser,this._locale,this._decimalStyle,e,this._resolverFields,this._chrono,this._zone)},e.format=function(t){var e=new StringBuilder(32);return this._formatTo(t,e),e.toString()},e._formatTo=function(t,e){requireNonNull(t,"temporal"),requireNonNull(e,"appendable");var n=new DateTimePrintContext(t,this);this._printerParser.print(n,e)},e.parse=function(t,e){return 1===arguments.length?this.parse1(t):this.parse2(t,e)},e.parse1=function(t){requireNonNull(t,"text");try{return this._parseToBuilder(t,null).resolve(this._resolverStyle,this._resolverFields)}catch(e){throw e instanceof DateTimeParseException?e:this._createError(t,e)}},e.parse2=function(t,e){requireNonNull(t,"text"),requireNonNull(e,"type");try{return this._parseToBuilder(t,null).resolve(this._resolverStyle,this._resolverFields).build(e)}catch(e){throw e instanceof DateTimeParseException?e:this._createError(t,e)}},e._createError=function(t,e){var n="";return n=t.length>64?t.substring(0,64)+"...":t,new DateTimeParseException("Text '"+n+"' could not be parsed: "+e.message,t,0,e)},e._parseToBuilder=function(t,e){var n=null!=e?e:new ParsePosition(0),i=this._parseUnresolved0(t,n);if(null==i||n.getErrorIndex()>=0||null==e&&n.getIndex()<t.length){var o="";throw o=t.length>64?t.substr(0,64).toString()+"...":t,n.getErrorIndex()>=0?new DateTimeParseException("Text '"+o+"' could not be parsed at index "+n.getErrorIndex(),t,n.getErrorIndex()):new DateTimeParseException("Text '"+o+"' could not be parsed, unparsed text found at index "+n.getIndex(),t,n.getIndex())}return i.toBuilder()},e.parseUnresolved=function(t,e){return this._parseUnresolved0(t,e)},e._parseUnresolved0=function(t,e){assert(null!=t,"text",NullPointerException),assert(null!=e,"position",NullPointerException);var n=new DateTimeParseContext(this),i=e.getIndex();return(i=this._printerParser.parse(n,t,i))<0?(e.setErrorIndex(~i),null):(e.setIndex(i),n.toParsed())},e._toPrinterParser=function(t){return this._printerParser.withOptional(t)},e.toString=function(){var t=this._printerParser.toString();return 0===t.indexOf("[")?t:t.substring(1,t.length-1)},t}();
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function _init$d(){DateTimeFormatter.ISO_LOCAL_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.MONTH_OF_YEAR,2).appendLiteral("-").appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_LOCAL_TIME=(new DateTimeFormatterBuilder).appendValue(ChronoField.HOUR_OF_DAY,2).appendLiteral(":").appendValue(ChronoField.MINUTE_OF_HOUR,2).optionalStart().appendLiteral(":").appendValue(ChronoField.SECOND_OF_MINUTE,2).optionalStart().appendFraction(ChronoField.NANO_OF_SECOND,0,9,!0).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_LOCAL_DATE_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).appendLiteral("T").append(DateTimeFormatter.ISO_LOCAL_TIME).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_INSTANT=(new DateTimeFormatterBuilder).parseCaseInsensitive().appendInstant().toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_OFFSET_DATE_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE_TIME).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_ZONED_DATE_TIME=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_OFFSET_DATE_TIME).optionalStart().appendLiteral("[").parseCaseSensitive().appendZoneId().appendLiteral("]").toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.BASIC_ISO_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendValue(ChronoField.MONTH_OF_YEAR,2).appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_OFFSET_DATE=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_OFFSET_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_TIME).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_ORDINAL_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.DAY_OF_YEAR).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_WEEK_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-W").appendValue(ChronoField.ALIGNED_WEEK_OF_YEAR).appendLiteral("-").appendValue(ChronoField.DAY_OF_WEEK).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_DATE=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_TIME).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_DATE_TIME=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_LOCAL_DATE_TIME).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.PARSED_EXCESS_DAYS=createTemporalQuery("PARSED_EXCESS_DAYS",(function(t){return t instanceof DateTimeBuilder?t.excessDays:Period.ZERO})),DateTimeFormatter.PARSED_LEAP_SECOND=createTemporalQuery("PARSED_LEAP_SECOND",(function(t){return t instanceof DateTimeBuilder&&t.leapSecond}))}var PARSER$2,MonthDay=function(t){function e(e,n){var i;return(i=t.call(this)||this)._month=MathUtil.safeToInt(e),i._day=MathUtil.safeToInt(n),i}_inheritsLoose(e,t),e.now=function(t){return 0===arguments.length?e.now0():1===arguments.length&&t instanceof ZoneId?e.nowZoneId(t):e.nowClock(t)},e.now0=function(){return this.nowClock(Clock.systemDefaultZone())},e.nowZoneId=function(t){return requireNonNull(t,"zone"),this.nowClock(Clock.system(t))},e.nowClock=function(t){requireNonNull(t,"clock");var n=LocalDate.now(t);return e.of(n.month(),n.dayOfMonth())},e.of=function(t,n){return 2===arguments.length&&t instanceof Month?e.ofMonthNumber(t,n):e.ofNumberNumber(t,n)},e.ofMonthNumber=function(t,n){if(requireNonNull(t,"month"),ChronoField.DAY_OF_MONTH.checkValidValue(n),n>t.maxLength())throw new DateTimeException("Illegal value for DayOfMonth field, value "+n+" is not valid for month "+t.toString());return new e(t.value(),n)},e.ofNumberNumber=function(t,n){return requireNonNull(t,"month"),requireNonNull(n,"dayOfMonth"),e.of(Month.of(t),n)},e.from=function(t){if(requireNonNull(t,"temporal"),requireInstance(t,TemporalAccessor,"temporal"),t instanceof e)return t;try{return e.of(t.get(ChronoField.MONTH_OF_YEAR),t.get(ChronoField.DAY_OF_MONTH))}catch(e){throw new DateTimeException("Unable to obtain MonthDay from TemporalAccessor: "+t+", type "+(t&&null!=t.constructor?t.constructor.name:""))}},e.parse=function(t,n){return 1===arguments.length?e.parseString(t):e.parseStringFormatter(t,n)},e.parseString=function(t){return e.parseStringFormatter(t,PARSER$2)},e.parseStringFormatter=function(t,n){return requireNonNull(t,"text"),requireNonNull(n,"formatter"),requireInstance(n,DateTimeFormatter,"formatter"),n.parse(t,e.FROM)};var n=e.prototype;return n.monthValue=function(){return this._month},n.month=function(){return Month.of(this._month)},n.dayOfMonth=function(){return this._day},n.isSupported=function(t){return t instanceof ChronoField?t===ChronoField.MONTH_OF_YEAR||t===ChronoField.DAY_OF_MONTH:null!=t&&t.isSupportedBy(this)},n.range=function(e){return e===ChronoField.MONTH_OF_YEAR?e.range():e===ChronoField.DAY_OF_MONTH?ValueRange.of(1,this.month().minLength(),this.month().maxLength()):t.prototype.range.call(this,e)},n.get=function(t){return this.range(t).checkValidIntValue(this.getLong(t),t)},n.getLong=function(t){if(requireNonNull(t,"field"),t instanceof ChronoField){switch(t){case ChronoField.DAY_OF_MONTH:return this._day;case ChronoField.MONTH_OF_YEAR:return this._month}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.getFrom(this)},n.isValidYear=function(t){return!1==(29===this._day&&2===this._month&&!1===Year.isLeap(t))},n.withMonth=function(t){return this.with(Month.of(t))},n.with=function(t){if(requireNonNull(t,"month"),t.value()===this._month)return this;var n=Math.min(this._day,t.maxLength());return new e(t.value(),n)},n.withDayOfMonth=function(t){return t===this._day?this:e.of(this._month,t)},n.query=function(e){return requireNonNull(e,"query"),requireInstance(e,TemporalQuery,"query"),e===TemporalQueries.chronology()?IsoChronology.INSTANCE:t.prototype.query.call(this,e)},n.adjustInto=function(t){return requireNonNull(t,"temporal"),(t=t.with(ChronoField.MONTH_OF_YEAR,this._month)).with(ChronoField.DAY_OF_MONTH,Math.min(t.range(ChronoField.DAY_OF_MONTH).maximum(),this._day))},n.atYear=function(t){return LocalDate.of(t,this._month,this.isValidYear(t)?this._day:28)},n.compareTo=function(t){requireNonNull(t,"other"),requireInstance(t,e,"other");var n=this._month-t.monthValue();return 0===n&&(n=this._day-t.dayOfMonth()),n},n.isAfter=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this.compareTo(t)>0},n.isBefore=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this.compareTo(t)<0},n.equals=function(t){if(this===t)return!0;if(t instanceof e){var n=t;return this.monthValue()===n.monthValue()&&this.dayOfMonth()===n.dayOfMonth()}return!1},n.toString=function(){return"--"+(this._month<10?"0":"")+this._month+(this._day<10?"-0":"-")+this._day},n.toJSON=function(){return this.toString()},n.format=function(t){return requireNonNull(t,"formatter"),requireInstance(t,DateTimeFormatter,"formatter"),t.format(this)},e}(TemporalAccessor);function _init$c(){PARSER$2=(new DateTimeFormatterBuilder).appendLiteral("--").appendValue(ChronoField.MONTH_OF_YEAR,2).appendLiteral("-").appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(),MonthDay.FROM=createTemporalQuery("MonthDay.FROM",(function(t){return MonthDay.from(t)}))}var PARSER$1,YearMonth=function(t){function e(e,n){var i;return(i=t.call(this)||this)._year=MathUtil.safeToInt(e),i._month=MathUtil.safeToInt(n),i}_inheritsLoose(e,t),e.now=function(t){return 0===arguments.length?e.now0():1===arguments.length&&t instanceof ZoneId?e.nowZoneId(t):e.nowClock(t)},e.now0=function(){return e.nowClock(Clock.systemDefaultZone())},e.nowZoneId=function(t){return e.nowClock(Clock.system(t))},e.nowClock=function(t){var n=LocalDate.now(t);return e.of(n.year(),n.month())},e.of=function(t,n){return 2===arguments.length&&n instanceof Month?e.ofNumberMonth(t,n):e.ofNumberNumber(t,n)},e.ofNumberMonth=function(t,n){return requireNonNull(n,"month"),requireInstance(n,Month,"month"),e.ofNumberNumber(t,n.value())},e.ofNumberNumber=function(t,n){return requireNonNull(t,"year"),requireNonNull(n,"month"),ChronoField.YEAR.checkValidValue(t),ChronoField.MONTH_OF_YEAR.checkValidValue(n),new e(t,n)},e.from=function(t){if(requireNonNull(t,"temporal"),t instanceof e)return t;try{return e.of(t.get(ChronoField.YEAR),t.get(ChronoField.MONTH_OF_YEAR))}catch(e){throw new DateTimeException("Unable to obtain YearMonth from TemporalAccessor: "+t+", type "+(t&&null!=t.constructor?t.constructor.name:""))}},e.parse=function(t,n){return 1===arguments.length?e.parseString(t):e.parseStringFormatter(t,n)},e.parseString=function(t){return e.parseStringFormatter(t,PARSER$1)},e.parseStringFormatter=function(t,n){return requireNonNull(n,"formatter"),n.parse(t,e.FROM)};var n=e.prototype;return n.isSupported=function(t){return 1===arguments.length&&t instanceof TemporalField?this.isSupportedField(t):this.isSupportedUnit(t)},n.isSupportedField=function(t){return t instanceof ChronoField?t===ChronoField.YEAR||t===ChronoField.MONTH_OF_YEAR||t===ChronoField.PROLEPTIC_MONTH||t===ChronoField.YEAR_OF_ERA||t===ChronoField.ERA:null!=t&&t.isSupportedBy(this)},n.isSupportedUnit=function(t){return t instanceof ChronoUnit?t===ChronoUnit.MONTHS||t===ChronoUnit.YEARS||t===ChronoUnit.DECADES||t===ChronoUnit.CENTURIES||t===ChronoUnit.MILLENNIA||t===ChronoUnit.ERAS:null!=t&&t.isSupportedBy(this)},n.range=function(e){return e===ChronoField.YEAR_OF_ERA?this.year()<=0?ValueRange.of(1,Year.MAX_VALUE+1):ValueRange.of(1,Year.MAX_VALUE):t.prototype.range.call(this,e)},n.get=function(t){return requireNonNull(t,"field"),requireInstance(t,TemporalField,"field"),this.range(t).checkValidIntValue(this.getLong(t),t)},n.getLong=function(t){if(requireNonNull(t,"field"),requireInstance(t,TemporalField,"field"),t instanceof ChronoField){switch(t){case ChronoField.MONTH_OF_YEAR:return this._month;case ChronoField.PROLEPTIC_MONTH:return this._getProlepticMonth();case ChronoField.YEAR_OF_ERA:return this._year<1?1-this._year:this._year;case ChronoField.YEAR:return this._year;case ChronoField.ERA:return this._year<1?0:1}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.getFrom(this)},n._getProlepticMonth=function(){return MathUtil.safeAdd(MathUtil.safeMultiply(this._year,12),this._month-1)},n.year=function(){return this._year},n.monthValue=function(){return this._month},n.month=function(){return Month.of(this._month)},n.isLeapYear=function(){return IsoChronology.isLeapYear(this._year)},n.isValidDay=function(t){return t>=1&&t<=this.lengthOfMonth()},n.lengthOfMonth=function(){return this.month().length(this.isLeapYear())},n.lengthOfYear=function(){return this.isLeapYear()?366:365},n.with=function(t,e){return 1===arguments.length?this._withAdjuster(t):this._withField(t,e)},n._withField=function(t,e){if(requireNonNull(t,"field"),requireInstance(t,TemporalField,"field"),t instanceof ChronoField){var n=t;switch(n.checkValidValue(e),n){case ChronoField.MONTH_OF_YEAR:return this.withMonth(e);case ChronoField.PROLEPTIC_MONTH:return this.plusMonths(e-this.getLong(ChronoField.PROLEPTIC_MONTH));case ChronoField.YEAR_OF_ERA:return this.withYear(this._year<1?1-e:e);case ChronoField.YEAR:return this.withYear(e);case ChronoField.ERA:return this.getLong(ChronoField.ERA)===e?this:this.withYear(1-this._year)}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.adjustInto(this,e)},n.withYear=function(t){return ChronoField.YEAR.checkValidValue(t),new e(t,this._month)},n.withMonth=function(t){return ChronoField.MONTH_OF_YEAR.checkValidValue(t),new e(this._year,t)},n._plusUnit=function(t,e){if(requireNonNull(e,"unit"),requireInstance(e,TemporalUnit,"unit"),e instanceof ChronoUnit){switch(e){case ChronoUnit.MONTHS:return this.plusMonths(t);case ChronoUnit.YEARS:return this.plusYears(t);case ChronoUnit.DECADES:return this.plusYears(MathUtil.safeMultiply(t,10));case ChronoUnit.CENTURIES:return this.plusYears(MathUtil.safeMultiply(t,100));case ChronoUnit.MILLENNIA:return this.plusYears(MathUtil.safeMultiply(t,1e3));case ChronoUnit.ERAS:return this.with(ChronoField.ERA,MathUtil.safeAdd(this.getLong(ChronoField.ERA),t))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+e)}return e.addTo(this,t)},n.plusYears=function(t){if(0===t)return this;var e=ChronoField.YEAR.checkValidIntValue(this._year+t);return this.withYear(e)},n.plusMonths=function(t){if(0===t)return this;var n=12*this._year+(this._month-1)+t;return new e(ChronoField.YEAR.checkValidIntValue(MathUtil.floorDiv(n,12)),MathUtil.floorMod(n,12)+1)},n.minusYears=function(t){return t===MathUtil.MIN_SAFE_INTEGER?this.plusYears(MathUtil.MIN_SAFE_INTEGER).plusYears(1):this.plusYears(-t)},n.minusMonths=function(t){return t===MathUtil.MIN_SAFE_INTEGER?this.plusMonths(Math.MAX_SAFE_INTEGER).plusMonths(1):this.plusMonths(-t)},n.query=function(e){return requireNonNull(e,"query"),requireInstance(e,TemporalQuery,"query"),e===TemporalQueries.chronology()?IsoChronology.INSTANCE:e===TemporalQueries.precision()?ChronoUnit.MONTHS:e===TemporalQueries.localDate()||e===TemporalQueries.localTime()||e===TemporalQueries.zone()||e===TemporalQueries.zoneId()||e===TemporalQueries.offset()?null:t.prototype.query.call(this,e)},n.adjustInto=function(t){return requireNonNull(t,"temporal"),requireInstance(t,Temporal,"temporal"),t.with(ChronoField.PROLEPTIC_MONTH,this._getProlepticMonth())},n.until=function(t,n){requireNonNull(t,"endExclusive"),requireNonNull(n,"unit"),requireInstance(t,Temporal,"endExclusive"),requireInstance(n,TemporalUnit,"unit");var i=e.from(t);if(n instanceof ChronoUnit){var o=i._getProlepticMonth()-this._getProlepticMonth();switch(n){case ChronoUnit.MONTHS:return o;case ChronoUnit.YEARS:return MathUtil.intDiv(o,12);case ChronoUnit.DECADES:return MathUtil.intDiv(o,120);case ChronoUnit.CENTURIES:return MathUtil.intDiv(o,1200);case ChronoUnit.MILLENNIA:return MathUtil.intDiv(o,12e3);case ChronoUnit.ERAS:return i.getLong(ChronoField.ERA)-this.getLong(ChronoField.ERA)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.between(this,i)},n.atDay=function(t){return requireNonNull(t,"dayOfMonth"),LocalDate.of(this._year,this._month,t)},n.atEndOfMonth=function(){return LocalDate.of(this._year,this._month,this.lengthOfMonth())},n.compareTo=function(t){requireNonNull(t,"other"),requireInstance(t,e,"other");var n=this._year-t.year();return 0===n&&(n=this._month-t.monthValue()),n},n.isAfter=function(t){return this.compareTo(t)>0},n.isBefore=function(t){return this.compareTo(t)<0},n.equals=function(t){if(this===t)return!0;if(t instanceof e){var n=t;return this.year()===n.year()&&this.monthValue()===n.monthValue()}return!1},n.toString=function(){return PARSER$1.format(this)},n.toJSON=function(){return this.toString()},n.format=function(t){return requireNonNull(t,"formatter"),t.format(this)},e}(Temporal);function _init$b(){PARSER$1=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.MONTH_OF_YEAR,2).toFormatter(),YearMonth.FROM=createTemporalQuery("YearMonth.FROM",(function(t){return YearMonth.from(t)}))}var PARSER,Year=function(t){function e(e){var n;return(n=t.call(this)||this)._year=MathUtil.safeToInt(e),n}_inheritsLoose(e,t);var n=e.prototype;return n.value=function(){return this._year},e.now=function(t){return void 0===t&&(t=void 0),void 0===t?e.now0():t instanceof ZoneId?e.nowZoneId(t):e.nowClock(t)},e.now0=function(){return e.nowClock(Clock.systemDefaultZone())},e.nowZoneId=function(t){return requireNonNull(t,"zone"),requireInstance(t,ZoneId,"zone"),e.nowClock(Clock.system(t))},e.nowClock=function(t){requireNonNull(t,"clock"),requireInstance(t,Clock,"clock");var n=LocalDate.now(t);return e.of(n.year())},e.of=function(t){return requireNonNull(t,"isoYear"),ChronoField.YEAR.checkValidValue(t),new e(t)},e.from=function(t){if(requireNonNull(t,"temporal"),requireInstance(t,TemporalAccessor,"temporal"),t instanceof e)return t;try{return e.of(t.get(ChronoField.YEAR))}catch(e){throw new DateTimeException("Unable to obtain Year from TemporalAccessor: "+t+", type "+(t&&null!=t.constructor?t.constructor.name:""))}},e.parse=function(t,n){return arguments.length<=1?e.parseText(t):e.parseTextFormatter(t,n)},e.parseText=function(t){return requireNonNull(t,"text"),e.parse(t,PARSER)},e.parseTextFormatter=function(t,n){return void 0===n&&(n=PARSER),requireNonNull(t,"text"),requireNonNull(n,"formatter"),requireInstance(n,DateTimeFormatter,"formatter"),n.parse(t,e.FROM)},e.isLeap=function(t){return 0===MathUtil.intMod(t,4)&&(0!==MathUtil.intMod(t,100)||0===MathUtil.intMod(t,400))},n.isSupported=function(t){return 1===arguments.length&&t instanceof TemporalField?this.isSupportedField(t):this.isSupportedUnit(t)},n.isSupportedField=function(t){return t instanceof ChronoField?t===ChronoField.YEAR||t===ChronoField.YEAR_OF_ERA||t===ChronoField.ERA:null!=t&&t.isSupportedBy(this)},n.isSupportedUnit=function(t){return t instanceof ChronoUnit?t===ChronoUnit.YEARS||t===ChronoUnit.DECADES||t===ChronoUnit.CENTURIES||t===ChronoUnit.MILLENNIA||t===ChronoUnit.ERAS:null!=t&&t.isSupportedBy(this)},n.range=function(e){if(this.isSupported(e))return e.range();if(e instanceof ChronoField)throw new UnsupportedTemporalTypeException("Unsupported field: "+e);return t.prototype.range.call(this,e)},n.get=function(t){return this.range(t).checkValidIntValue(this.getLong(t),t)},n.getLong=function(t){if(requireNonNull(t,"field"),t instanceof ChronoField){switch(t){case ChronoField.YEAR_OF_ERA:return this._year<1?1-this._year:this._year;case ChronoField.YEAR:return this._year;case ChronoField.ERA:return this._year<1?0:1}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.getFrom(this)},n.isLeap=function(){return e.isLeap(this._year)},n._withField=function(t,n){if(requireNonNull(t,"field"),requireInstance(t,TemporalField,"field"),t instanceof ChronoField){switch(t.checkValidValue(n),t){case ChronoField.YEAR_OF_ERA:return e.of(this._year<1?1-n:n);case ChronoField.YEAR:return e.of(n);case ChronoField.ERA:return this.getLong(ChronoField.ERA)===n?this:e.of(1-this._year)}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.adjustInto(this,n)},n._plusUnit=function(t,e){if(requireNonNull(t,"amountToAdd"),requireNonNull(e,"unit"),requireInstance(e,TemporalUnit,"unit"),e instanceof ChronoUnit){switch(e){case ChronoUnit.YEARS:return this.plusYears(t);case ChronoUnit.DECADES:return this.plusYears(MathUtil.safeMultiply(t,10));case ChronoUnit.CENTURIES:return this.plusYears(MathUtil.safeMultiply(t,100));case ChronoUnit.MILLENNIA:return this.plusYears(MathUtil.safeMultiply(t,1e3));case ChronoUnit.ERAS:return this.with(ChronoField.ERA,MathUtil.safeAdd(this.getLong(ChronoField.ERA),t))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+e)}return e.addTo(this,t)},n.plusYears=function(t){return 0===t?this:e.of(ChronoField.YEAR.checkValidIntValue(MathUtil.safeAdd(this._year,t)))},n.minusYears=function(t){return t===MathUtil.MIN_SAFE_INTEGER?this.plusYears(MathUtil.MAX_SAFE_INTEGER).plusYears(1):this.plusYears(-t)},n.adjustInto=function(t){return requireNonNull(t,"temporal"),t.with(ChronoField.YEAR,this._year)},n.isValidMonthDay=function(t){return null!=t&&t.isValidYear(this._year)},n.length=function(){return this.isLeap()?366:365},n.atDay=function(t){return LocalDate.ofYearDay(this._year,t)},n.atMonth=function(t){return 1===arguments.length&&t instanceof Month?this.atMonthMonth(t):this.atMonthNumber(t)},n.atMonthMonth=function(t){return requireNonNull(t,"month"),requireInstance(t,Month,"month"),YearMonth.of(this._year,t)},n.atMonthNumber=function(t){return requireNonNull(t,"month"),YearMonth.of(this._year,t)},n.atMonthDay=function(t){return requireNonNull(t,"monthDay"),requireInstance(t,MonthDay,"monthDay"),t.atYear(this._year)},n.query=function(e){return requireNonNull(e,"query()"),requireInstance(e,TemporalQuery,"query()"),e===TemporalQueries.chronology()?IsoChronology.INSTANCE:e===TemporalQueries.precision()?ChronoUnit.YEARS:e===TemporalQueries.localDate()||e===TemporalQueries.localTime()||e===TemporalQueries.zone()||e===TemporalQueries.zoneId()||e===TemporalQueries.offset()?null:t.prototype.query.call(this,e)},n.compareTo=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._year-t._year},n.isAfter=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._year>t._year},n.isBefore=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._year<t._year},n.format=function(t){return requireNonNull(t,"formatter"),requireInstance(t,DateTimeFormatter,"formatter"),t.format(this)},n.equals=function(t){return this===t||t instanceof e&&this.value()===t.value()},n.toString=function(){return""+this._year},n.toJSON=function(){return this.toString()},n.until=function(t,n){var i=e.from(t);if(n instanceof ChronoUnit){var o=i.value()-this.value();switch(n){case ChronoUnit.YEARS:return o;case ChronoUnit.DECADES:return MathUtil.intDiv(o,10);case ChronoUnit.CENTURIES:return MathUtil.intDiv(o,100);case ChronoUnit.MILLENNIA:return MathUtil.intDiv(o,1e3);case ChronoUnit.ERAS:return i.getLong(ChronoField.ERA)-this.getLong(ChronoField.ERA)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.between(this,i)},e}(Temporal);function _init$a(){Year.MIN_VALUE=YearConstants.MIN_VALUE,Year.MAX_VALUE=YearConstants.MAX_VALUE,PARSER=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).toFormatter(),Year.FROM=createTemporalQuery("Year.FROM",(function(t){return Year.from(t)}))}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var TemporalAdjuster=function(){function t(){}return t.prototype.adjustInto=function(t){abstractMethodFail("adjustInto")},t}(),TemporalAdjusters=function(){function t(){}return t.firstDayOfMonth=function(){return Impl.FIRST_DAY_OF_MONTH},t.lastDayOfMonth=function(){return Impl.LAST_DAY_OF_MONTH},t.firstDayOfNextMonth=function(){return Impl.FIRST_DAY_OF_NEXT_MONTH},t.firstDayOfYear=function(){return Impl.FIRST_DAY_OF_YEAR},t.lastDayOfYear=function(){return Impl.LAST_DAY_OF_YEAR},t.firstDayOfNextYear=function(){return Impl.FIRST_DAY_OF_NEXT_YEAR},t.firstInMonth=function(t){return requireNonNull(t,"dayOfWeek"),new DayOfWeekInMonth(1,t)},t.lastInMonth=function(t){return requireNonNull(t,"dayOfWeek"),new DayOfWeekInMonth(-1,t)},t.dayOfWeekInMonth=function(t,e){return requireNonNull(e,"dayOfWeek"),new DayOfWeekInMonth(t,e)},t.next=function(t){return new RelativeDayOfWeek(2,t)},t.nextOrSame=function(t){return new RelativeDayOfWeek(0,t)},t.previous=function(t){return new RelativeDayOfWeek(3,t)},t.previousOrSame=function(t){return new RelativeDayOfWeek(1,t)},t}(),Impl=function(t){function e(e){var n;return(n=t.call(this)||this)._ordinal=e,n}return _inheritsLoose(e,t),e.prototype.adjustInto=function(t){switch(this._ordinal){case 0:return t.with(ChronoField.DAY_OF_MONTH,1);case 1:return t.with(ChronoField.DAY_OF_MONTH,t.range(ChronoField.DAY_OF_MONTH).maximum());case 2:return t.with(ChronoField.DAY_OF_MONTH,1).plus(1,ChronoUnit.MONTHS);case 3:return t.with(ChronoField.DAY_OF_YEAR,1);case 4:return t.with(ChronoField.DAY_OF_YEAR,t.range(ChronoField.DAY_OF_YEAR).maximum());case 5:return t.with(ChronoField.DAY_OF_YEAR,1).plus(1,ChronoUnit.YEARS)}throw new IllegalStateException("Unreachable")},e}(TemporalAdjuster);Impl.FIRST_DAY_OF_MONTH=new Impl(0),Impl.LAST_DAY_OF_MONTH=new Impl(1),Impl.FIRST_DAY_OF_NEXT_MONTH=new Impl(2),Impl.FIRST_DAY_OF_YEAR=new Impl(3),Impl.LAST_DAY_OF_YEAR=new Impl(4),Impl.FIRST_DAY_OF_NEXT_YEAR=new Impl(5);var DayOfWeekInMonth=function(t){function e(e,n){var i;return(i=t.call(this)||this)._ordinal=e,i._dowValue=n.value(),i}return _inheritsLoose(e,t),e.prototype.adjustInto=function(t){if(this._ordinal>=0){var e=t.with(ChronoField.DAY_OF_MONTH,1),n=e.get(ChronoField.DAY_OF_WEEK),i=MathUtil.intMod(this._dowValue-n+7,7);return i+=7*(this._ordinal-1),e.plus(i,ChronoUnit.DAYS)}var o=t.with(ChronoField.DAY_OF_MONTH,t.range(ChronoField.DAY_OF_MONTH).maximum()),r=o.get(ChronoField.DAY_OF_WEEK),a=this._dowValue-r;return a=0===a?0:a>0?a-7:a,a-=7*(-this._ordinal-1),o.plus(a,ChronoUnit.DAYS)},e}(TemporalAdjuster),RelativeDayOfWeek=function(t){function e(e,n){var i;return i=t.call(this)||this,requireNonNull(n,"dayOfWeek"),i._relative=e,i._dowValue=n.value(),i}return _inheritsLoose(e,t),e.prototype.adjustInto=function(t){var e=t.get(ChronoField.DAY_OF_WEEK);if(this._relative<2&&e===this._dowValue)return t;if(0==(1&this._relative)){var n=e-this._dowValue;return t.plus(n>=0?7-n:-n,ChronoUnit.DAYS)}var i=this._dowValue-e;return t.minus(i>=0?7-i:-i,ChronoUnit.DAYS)},e}(TemporalAdjuster),IsoChronology=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t),e.isLeapYear=function(t){return 0==(3&t)&&(t%100!=0||t%400==0)};var n=e.prototype;return n._updateResolveMap=function(t,e,n){requireNonNull(t,"fieldValues"),requireNonNull(e,"field");var i=t.get(e);if(null!=i&&i!==n)throw new DateTimeException("Invalid state, field: "+e+" "+i+" conflicts with "+e+" "+n);t.put(e,n)},n.resolveDate=function(t,e){if(t.containsKey(ChronoField.EPOCH_DAY))return LocalDate.ofEpochDay(t.remove(ChronoField.EPOCH_DAY));var n=t.remove(ChronoField.PROLEPTIC_MONTH);null!=n&&(e!==ResolverStyle.LENIENT&&ChronoField.PROLEPTIC_MONTH.checkValidValue(n),this._updateResolveMap(t,ChronoField.MONTH_OF_YEAR,MathUtil.floorMod(n,12)+1),this._updateResolveMap(t,ChronoField.YEAR,MathUtil.floorDiv(n,12)));var i=t.remove(ChronoField.YEAR_OF_ERA);if(null!=i){e!==ResolverStyle.LENIENT&&ChronoField.YEAR_OF_ERA.checkValidValue(i);var o=t.remove(ChronoField.ERA);if(null==o){var r=t.get(ChronoField.YEAR);e===ResolverStyle.STRICT?null!=r?this._updateResolveMap(t,ChronoField.YEAR,r>0?i:MathUtil.safeSubtract(1,i)):t.put(ChronoField.YEAR_OF_ERA,i):this._updateResolveMap(t,ChronoField.YEAR,null==r||r>0?i:MathUtil.safeSubtract(1,i))}else if(1===o)this._updateResolveMap(t,ChronoField.YEAR,i);else{if(0!==o)throw new DateTimeException("Invalid value for era: "+o);this._updateResolveMap(t,ChronoField.YEAR,MathUtil.safeSubtract(1,i))}}else t.containsKey(ChronoField.ERA)&&ChronoField.ERA.checkValidValue(t.get(ChronoField.ERA));if(t.containsKey(ChronoField.YEAR)){if(t.containsKey(ChronoField.MONTH_OF_YEAR)&&t.containsKey(ChronoField.DAY_OF_MONTH)){var a=ChronoField.YEAR.checkValidIntValue(t.remove(ChronoField.YEAR)),s=t.remove(ChronoField.MONTH_OF_YEAR),u=t.remove(ChronoField.DAY_OF_MONTH);if(e===ResolverStyle.LENIENT){var l=s-1,h=u-1;return LocalDate.of(a,1,1).plusMonths(l).plusDays(h)}return e===ResolverStyle.SMART?(ChronoField.DAY_OF_MONTH.checkValidValue(u),4===s||6===s||9===s||11===s?u=Math.min(u,30):2===s&&(u=Math.min(u,Month.FEBRUARY.length(Year.isLeap(a)))),LocalDate.of(a,s,u)):LocalDate.of(a,s,u)}if(t.containsKey(ChronoField.DAY_OF_YEAR)){var c=ChronoField.YEAR.checkValidIntValue(t.remove(ChronoField.YEAR));if(e===ResolverStyle.LENIENT){var f=MathUtil.safeSubtract(t.remove(ChronoField.DAY_OF_YEAR),1);return LocalDate.ofYearDay(c,1).plusDays(f)}var _=ChronoField.DAY_OF_YEAR.checkValidIntValue(t.remove(ChronoField.DAY_OF_YEAR));return LocalDate.ofYearDay(c,_)}if(t.containsKey(ChronoField.ALIGNED_WEEK_OF_YEAR)){if(t.containsKey(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR)){var d=ChronoField.YEAR.checkValidIntValue(t.remove(ChronoField.YEAR));if(e===ResolverStyle.LENIENT){var p=MathUtil.safeSubtract(t.remove(ChronoField.ALIGNED_WEEK_OF_YEAR),1),m=MathUtil.safeSubtract(t.remove(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR),1);return LocalDate.of(d,1,1).plusWeeks(p).plusDays(m)}var E=ChronoField.ALIGNED_WEEK_OF_YEAR.checkValidIntValue(t.remove(ChronoField.ALIGNED_WEEK_OF_YEAR)),T=ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR.checkValidIntValue(t.remove(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR)),S=LocalDate.of(d,1,1).plusDays(7*(E-1)+(T-1));if(e===ResolverStyle.STRICT&&S.get(ChronoField.YEAR)!==d)throw new DateTimeException("Strict mode rejected date parsed to a different year");return S}if(t.containsKey(ChronoField.DAY_OF_WEEK)){var N=ChronoField.YEAR.checkValidIntValue(t.remove(ChronoField.YEAR));if(e===ResolverStyle.LENIENT){var O=MathUtil.safeSubtract(t.remove(ChronoField.ALIGNED_WEEK_OF_YEAR),1),D=MathUtil.safeSubtract(t.remove(ChronoField.DAY_OF_WEEK),1);return LocalDate.of(N,1,1).plusWeeks(O).plusDays(D)}var C=ChronoField.ALIGNED_WEEK_OF_YEAR.checkValidIntValue(t.remove(ChronoField.ALIGNED_WEEK_OF_YEAR)),A=ChronoField.DAY_OF_WEEK.checkValidIntValue(t.remove(ChronoField.DAY_OF_WEEK)),M=LocalDate.of(N,1,1).plusWeeks(C-1).with(TemporalAdjusters.nextOrSame(DayOfWeek.of(A)));if(e===ResolverStyle.STRICT&&M.get(ChronoField.YEAR)!==N)throw new DateTimeException("Strict mode rejected date parsed to a different month");return M}}}return null},n.date=function(t){return LocalDate.from(t)},e}(Enum);function _init$9(){IsoChronology.INSTANCE=new IsoChronology("IsoChronology")}var OffsetTime=function(t){function e(e,n){var i;return i=t.call(this)||this,requireNonNull(e,"time"),requireInstance(e,LocalTime,"time"),requireNonNull(n,"offset"),requireInstance(n,ZoneOffset,"offset"),i._time=e,i._offset=n,i}_inheritsLoose(e,t),e.from=function(t){if(requireNonNull(t,"temporal"),t instanceof e)return t;if(t instanceof OffsetDateTime)return t.toOffsetTime();try{return new e(LocalTime.from(t),ZoneOffset.from(t))}catch(e){throw new DateTimeException("Unable to obtain OffsetTime TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""))}},e.now=function(t){return 0===arguments.length?e._now(Clock.systemDefaultZone()):t instanceof Clock?e._now(t):e._now(Clock.system(t))},e._now=function(t){requireNonNull(t,"clock");var n=t.instant();return e.ofInstant(n,t.zone().rules().offset(n))},e.of=function(){return arguments.length<=2?e.ofTimeAndOffset.apply(this,arguments):e.ofNumbers.apply(this,arguments)},e.ofNumbers=function(t,n,i,o,r){return new e(LocalTime.of(t,n,i,o),r)},e.ofTimeAndOffset=function(t,n){return new e(t,n)},e.ofInstant=function(t,n){requireNonNull(t,"instant"),requireInstance(t,Instant,"instant"),requireNonNull(n,"zone"),requireInstance(n,ZoneId,"zone");var i=n.rules().offset(t),o=t.epochSecond()%LocalTime.SECONDS_PER_DAY;return(o=(o+i.totalSeconds())%LocalTime.SECONDS_PER_DAY)<0&&(o+=LocalTime.SECONDS_PER_DAY),new e(LocalTime.ofSecondOfDay(o,t.nano()),i)},e.parse=function(t,n){return void 0===n&&(n=DateTimeFormatter.ISO_OFFSET_TIME),requireNonNull(n,"formatter"),n.parse(t,e.FROM)};var n=e.prototype;return n.adjustInto=function(t){return t.with(ChronoField.NANO_OF_DAY,this._time.toNanoOfDay()).with(ChronoField.OFFSET_SECONDS,this.offset().totalSeconds())},n.atDate=function(t){return OffsetDateTime.of(t,this._time,this._offset)},n.format=function(t){return requireNonNull(t,"formatter"),t.format(this,e.FROM)},n.get=function(e){return t.prototype.get.call(this,e)},n.getLong=function(t){return t instanceof ChronoField?t===ChronoField.OFFSET_SECONDS?this._offset.totalSeconds():this._time.getLong(t):t.getFrom(this)},n.hour=function(){return this._time.hour()},n.minute=function(){return this._time.minute()},n.second=function(){return this._time.second()},n.nano=function(){return this._time.nano()},n.offset=function(){return this._offset},n.isAfter=function(t){return requireNonNull(t,"other"),this._toEpochNano()>t._toEpochNano()},n.isBefore=function(t){return requireNonNull(t,"other"),this._toEpochNano()<t._toEpochNano()},n.isEqual=function(t){return requireNonNull(t,"other"),this._toEpochNano()===t._toEpochNano()},n.isSupported=function(t){return t instanceof ChronoField?t.isTimeBased()||t===ChronoField.OFFSET_SECONDS:t instanceof ChronoUnit?t.isTimeBased():null!=t&&t.isSupportedBy(this)},n.minusHours=function(t){return this._withLocalTimeOffset(this._time.minusHours(t),this._offset)},n.minusMinutes=function(t){return this._withLocalTimeOffset(this._time.minusMinutes(t),this._offset)},n.minusSeconds=function(t){return this._withLocalTimeOffset(this._time.minusSeconds(t),this._offset)},n.minusNanos=function(t){return this._withLocalTimeOffset(this._time.minusNanos(t),this._offset)},n._minusAmount=function(t){return requireNonNull(t),t.subtractFrom(this)},n._minusUnit=function(t,e){return this.plus(-1*t,e)},n._plusAmount=function(t){return requireNonNull(t),t.addTo(this)},n._plusUnit=function(t,e){return e instanceof ChronoUnit?this._withLocalTimeOffset(this._time.plus(t,e),this._offset):e.addTo(this,t)},n.plusHours=function(t){return this._withLocalTimeOffset(this._time.plusHours(t),this._offset)},n.plusMinutes=function(t){return this._withLocalTimeOffset(this._time.plusMinutes(t),this._offset)},n.plusSeconds=function(t){return this._withLocalTimeOffset(this._time.plusSeconds(t),this._offset)},n.plusNanos=function(t){return this._withLocalTimeOffset(this._time.plusNanos(t),this._offset)},n.query=function(e){return requireNonNull(e,"query"),e===TemporalQueries.precision()?ChronoUnit.NANOS:e===TemporalQueries.offset()||e===TemporalQueries.zone()?this.offset():e===TemporalQueries.localTime()?this._time:e===TemporalQueries.chronology()||e===TemporalQueries.localDate()||e===TemporalQueries.zoneId()?null:t.prototype.query.call(this,e)},n.range=function(t){return t instanceof ChronoField?t===ChronoField.OFFSET_SECONDS?t.range():this._time.range(t):t.rangeRefinedBy(this)},n.toLocalTime=function(){return this._time},n.truncatedTo=function(t){return this._withLocalTimeOffset(this._time.truncatedTo(t),this._offset)},n.until=function(t,n){requireNonNull(t,"endExclusive"),requireNonNull(n,"unit");var i=e.from(t);if(n instanceof ChronoUnit){var o=i._toEpochNano()-this._toEpochNano();switch(n){case ChronoUnit.NANOS:return o;case ChronoUnit.MICROS:return MathUtil.intDiv(o,1e3);case ChronoUnit.MILLIS:return MathUtil.intDiv(o,1e6);case ChronoUnit.SECONDS:return MathUtil.intDiv(o,LocalTime.NANOS_PER_SECOND);case ChronoUnit.MINUTES:return MathUtil.intDiv(o,LocalTime.NANOS_PER_MINUTE);case ChronoUnit.HOURS:return MathUtil.intDiv(o,LocalTime.NANOS_PER_HOUR);case ChronoUnit.HALF_DAYS:return MathUtil.intDiv(o,12*LocalTime.NANOS_PER_HOUR)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.between(this,i)},n.withHour=function(t){return this._withLocalTimeOffset(this._time.withHour(t),this._offset)},n.withMinute=function(t){return this._withLocalTimeOffset(this._time.withMinute(t),this._offset)},n.withSecond=function(t){return this._withLocalTimeOffset(this._time.withSecond(t),this._offset)},n.withNano=function(t){return this._withLocalTimeOffset(this._time.withNano(t),this._offset)},n.withOffsetSameInstant=function(t){if(requireNonNull(t,"offset"),t.equals(this._offset))return this;var n=t.totalSeconds()-this._offset.totalSeconds();return new e(this._time.plusSeconds(n),t)},n.withOffsetSameLocal=function(t){return null!=t&&t.equals(this._offset)?this:new e(this._time,t)},n._toEpochNano=function(){return this._time.toNanoOfDay()-this._offset.totalSeconds()*LocalTime.NANOS_PER_SECOND},n._withAdjuster=function(t){return requireNonNull(t,"adjuster"),t instanceof LocalTime?this._withLocalTimeOffset(t,this._offset):t instanceof ZoneOffset?this._withLocalTimeOffset(this._time,t):t instanceof e?t:t.adjustInto(this)},n._withField=function(t,e){return requireNonNull(t,"field"),t instanceof ChronoField?t===ChronoField.OFFSET_SECONDS?this._withLocalTimeOffset(this._time,ZoneOffset.ofTotalSeconds(t.checkValidIntValue(e))):this._withLocalTimeOffset(this._time.with(t,e),this._offset):t.adjustInto(this,e)},n._withLocalTimeOffset=function(t,n){return this._time===t&&this._offset.equals(n)?this:new e(t,n)},n.compareTo=function(t){if(requireNonNull(t,"other"),requireInstance(t,e,"other"),this._offset.equals(t._offset))return this._time.compareTo(t._time);var n=MathUtil.compareNumbers(this._toEpochNano(),t._toEpochNano());return 0===n?this._time.compareTo(t._time):n},n.equals=function(t){return this===t||t instanceof e&&(this._time.equals(t._time)&&this._offset.equals(t._offset))},n.hashCode=function(){return this._time.hashCode()^this._offset.hashCode()},n.toString=function(){return this._time.toString()+this._offset.toString()},n.toJSON=function(){return this.toString()},e}(Temporal);function _init$8(){OffsetTime.MIN=OffsetTime.ofNumbers(0,0,0,0,ZoneOffset.MAX),OffsetTime.MAX=OffsetTime.ofNumbers(23,59,59,999999999,ZoneOffset.MIN),OffsetTime.FROM=createTemporalQuery("OffsetTime.FROM",(function(t){return OffsetTime.from(t)}))}var ChronoZonedDateTime=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.query=function(e){return e===TemporalQueries.zoneId()||e===TemporalQueries.zone()?this.zone():e===TemporalQueries.chronology()?this.toLocalDate().chronology():e===TemporalQueries.precision()?ChronoUnit.NANOS:e===TemporalQueries.offset()?this.offset():e===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):e===TemporalQueries.localTime()?this.toLocalTime():t.prototype.query.call(this,e)},n.format=function(t){return requireNonNull(t,"formatter"),t.format(this)},n.toInstant=function(){return Instant.ofEpochSecond(this.toEpochSecond(),this.toLocalTime().nano())},n.toEpochSecond=function(){var t=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return t-=this.offset().totalSeconds()},n.compareTo=function(t){requireNonNull(t,"other");var e=MathUtil.compareNumbers(this.toEpochSecond(),t.toEpochSecond());return 0===e&&0===(e=this.toLocalTime().nano()-t.toLocalTime().nano())&&0===(e=this.toLocalDateTime().compareTo(t.toLocalDateTime()))&&(e=strcmp(this.zone().id(),t.zone().id())),e},n.isAfter=function(t){requireNonNull(t,"other");var e=this.toEpochSecond(),n=t.toEpochSecond();return e>n||e===n&&this.toLocalTime().nano()>t.toLocalTime().nano()},n.isBefore=function(t){requireNonNull(t,"other");var e=this.toEpochSecond(),n=t.toEpochSecond();return e<n||e===n&&this.toLocalTime().nano()<t.toLocalTime().nano()},n.isEqual=function(t){return requireNonNull(t,"other"),this.toEpochSecond()===t.toEpochSecond()&&this.toLocalTime().nano()===t.toLocalTime().nano()},n.equals=function(t){return this===t||t instanceof e&&0===this.compareTo(t)},e}(Temporal);function strcmp(t,e){return t<e?-1:t>e?1:0}var ZonedDateTime=function(t){function e(e,n,i){var o;return requireNonNull(e,"dateTime"),requireNonNull(n,"offset"),requireNonNull(i,"zone"),(o=t.call(this)||this)._dateTime=e,o._offset=n,o._zone=i,o}_inheritsLoose(e,t),e.now=function(t){var n;return n=t instanceof ZoneId?Clock.system(t):null==t?Clock.systemDefaultZone():t,e.ofInstant(n.instant(),n.zone())},e.of=function(){return arguments.length<=2?e.of2.apply(this,arguments):3===arguments.length&&arguments[0]instanceof LocalDate?e.of3.apply(this,arguments):e.of8.apply(this,arguments)},e.of3=function(t,n,i){return e.of2(LocalDateTime.of(t,n),i)},e.of2=function(t,n){return e.ofLocal(t,n,null)},e.of8=function(t,n,i,o,r,a,s,u){var l=LocalDateTime.of(t,n,i,o,r,a,s);return e.ofLocal(l,u,null)},e.ofLocal=function(t,n,i){if(requireNonNull(t,"localDateTime"),requireNonNull(n,"zone"),n instanceof ZoneOffset)return new e(t,n,n);var o=null,r=n.rules(),a=r.validOffsets(t);if(1===a.length)o=a[0];else if(0===a.length){var s=r.transition(t);t=t.plusSeconds(s.duration().seconds()),o=s.offsetAfter()}else o=null!=i&&a.some((function(t){return t.equals(i)}))?i:requireNonNull(a[0],"offset");return new e(t,o,n)},e.ofInstant=function(){return 2===arguments.length?e.ofInstant2.apply(this,arguments):e.ofInstant3.apply(this,arguments)},e.ofInstant2=function(t,n){return requireNonNull(t,"instant"),requireNonNull(n,"zone"),e._create(t.epochSecond(),t.nano(),n)},e.ofInstant3=function(t,n,i){return requireNonNull(t,"localDateTime"),requireNonNull(n,"offset"),requireNonNull(i,"zone"),e._create(t.toEpochSecond(n),t.nano(),i)},e._create=function(t,n,i){var o=i.rules(),r=Instant.ofEpochSecond(t,n),a=o.offset(r);return new e(LocalDateTime.ofEpochSecond(t,n,a),a,i)},e.ofStrict=function(t,n,i){requireNonNull(t,"localDateTime"),requireNonNull(n,"offset"),requireNonNull(i,"zone");var o=i.rules();if(!1===o.isValidOffset(t,n)){var r=o.transition(t);if(null!=r&&r.isGap())throw new DateTimeException("LocalDateTime "+t+" does not exist in zone "+i+" due to a gap in the local time-line, typically caused by daylight savings");throw new DateTimeException('ZoneOffset "'+n+'" is not valid for LocalDateTime "'+t+'" in zone "'+i+'"')}return new e(t,n,i)},e.ofLenient=function(t,n,i){if(requireNonNull(t,"localDateTime"),requireNonNull(n,"offset"),requireNonNull(i,"zone"),i instanceof ZoneOffset&&!1===n.equals(i))throw new IllegalArgumentException("ZoneId must match ZoneOffset");return new e(t,n,i)},e.from=function(t){if(requireNonNull(t,"temporal"),t instanceof e)return t;var n=ZoneId.from(t);if(t.isSupported(ChronoField.INSTANT_SECONDS)){var i=e._from(t,n);if(null!=i)return i}var o=LocalDateTime.from(t);return e.of2(o,n)},e._from=function(t,n){try{return e.__from(t,n)}catch(t){if(!(t instanceof DateTimeException))throw t}},e.__from=function(t,n){var i=t.getLong(ChronoField.INSTANT_SECONDS),o=t.get(ChronoField.NANO_OF_SECOND);return e._create(i,o,n)},e.parse=function(t,n){return void 0===n&&(n=DateTimeFormatter.ISO_ZONED_DATE_TIME),requireNonNull(n,"formatter"),n.parse(t,e.FROM)};var n=e.prototype;return n._resolveLocal=function(t){return requireNonNull(t,"newDateTime"),e.ofLocal(t,this._zone,this._offset)},n._resolveInstant=function(t){return e.ofInstant3(t,this._offset,this._zone)},n._resolveOffset=function(t){return!1===t.equals(this._offset)&&this._zone.rules().isValidOffset(this._dateTime,t)?new e(this._dateTime,t,this._zone):this},n.isSupported=function(t){return t instanceof ChronoField||(t instanceof ChronoUnit?t.isDateBased()||t.isTimeBased():null!=t&&t.isSupportedBy(this))},n.range=function(t){return t instanceof ChronoField?t===ChronoField.INSTANT_SECONDS||t===ChronoField.OFFSET_SECONDS?t.range():this._dateTime.range(t):t.rangeRefinedBy(this)},n.get=function(t){return this.getLong(t)},n.getLong=function(t){if(t instanceof ChronoField){switch(t){case ChronoField.INSTANT_SECONDS:return this.toEpochSecond();case ChronoField.OFFSET_SECONDS:return this._offset.totalSeconds()}return this._dateTime.getLong(t)}return requireNonNull(t,"field"),t.getFrom(this)},n.offset=function(){return this._offset},n.withEarlierOffsetAtOverlap=function(){var t=this._zone.rules().transition(this._dateTime);if(null!=t&&t.isOverlap()){var n=t.offsetBefore();if(!1===n.equals(this._offset))return new e(this._dateTime,n,this._zone)}return this},n.withLaterOffsetAtOverlap=function(){var t=this._zone.rules().transition(this.toLocalDateTime());if(null!=t){var n=t.offsetAfter();if(!1===n.equals(this._offset))return new e(this._dateTime,n,this._zone)}return this},n.zone=function(){return this._zone},n.withZoneSameLocal=function(t){return requireNonNull(t,"zone"),this._zone.equals(t)?this:e.ofLocal(this._dateTime,t,this._offset)},n.withZoneSameInstant=function(t){return requireNonNull(t,"zone"),this._zone.equals(t)?this:e._create(this._dateTime.toEpochSecond(this._offset),this._dateTime.nano(),t)},n.withFixedOffsetZone=function(){return this._zone.equals(this._offset)?this:new e(this._dateTime,this._offset,this._offset)},n.year=function(){return this._dateTime.year()},n.monthValue=function(){return this._dateTime.monthValue()},n.month=function(){return this._dateTime.month()},n.dayOfMonth=function(){return this._dateTime.dayOfMonth()},n.dayOfYear=function(){return this._dateTime.dayOfYear()},n.dayOfWeek=function(){return this._dateTime.dayOfWeek()},n.hour=function(){return this._dateTime.hour()},n.minute=function(){return this._dateTime.minute()},n.second=function(){return this._dateTime.second()},n.nano=function(){return this._dateTime.nano()},n._withAdjuster=function(n){if(n instanceof LocalDate)return this._resolveLocal(LocalDateTime.of(n,this._dateTime.toLocalTime()));if(n instanceof LocalTime)return this._resolveLocal(LocalDateTime.of(this._dateTime.toLocalDate(),n));if(n instanceof LocalDateTime)return this._resolveLocal(n);if(n instanceof Instant){var i=n;return e._create(i.epochSecond(),i.nano(),this._zone)}return n instanceof ZoneOffset?this._resolveOffset(n):t.prototype._withAdjuster.call(this,n)},n._withField=function(t,n){if(t instanceof ChronoField){switch(t){case ChronoField.INSTANT_SECONDS:return e._create(n,this.nano(),this._zone);case ChronoField.OFFSET_SECONDS:var i=ZoneOffset.ofTotalSeconds(t.checkValidIntValue(n));return this._resolveOffset(i)}return this._resolveLocal(this._dateTime.with(t,n))}return t.adjustInto(this,n)},n.withYear=function(t){return this._resolveLocal(this._dateTime.withYear(t))},n.withMonth=function(t){return this._resolveLocal(this._dateTime.withMonth(t))},n.withDayOfMonth=function(t){return this._resolveLocal(this._dateTime.withDayOfMonth(t))},n.withDayOfYear=function(t){return this._resolveLocal(this._dateTime.withDayOfYear(t))},n.withHour=function(t){return this._resolveLocal(this._dateTime.withHour(t))},n.withMinute=function(t){return this._resolveLocal(this._dateTime.withMinute(t))},n.withSecond=function(t){return this._resolveLocal(this._dateTime.withSecond(t))},n.withNano=function(t){return this._resolveLocal(this._dateTime.withNano(t))},n.truncatedTo=function(t){return this._resolveLocal(this._dateTime.truncatedTo(t))},n._plusUnit=function(t,e){return e instanceof ChronoUnit?e.isDateBased()?this._resolveLocal(this._dateTime.plus(t,e)):this._resolveInstant(this._dateTime.plus(t,e)):(requireNonNull(e,"unit"),e.addTo(this,t))},n.plusYears=function(t){return this._resolveLocal(this._dateTime.plusYears(t))},n.plusMonths=function(t){return this._resolveLocal(this._dateTime.plusMonths(t))},n.plusWeeks=function(t){return this._resolveLocal(this._dateTime.plusWeeks(t))},n.plusDays=function(t){return this._resolveLocal(this._dateTime.plusDays(t))},n.plusHours=function(t){return this._resolveInstant(this._dateTime.plusHours(t))},n.plusMinutes=function(t){return this._resolveInstant(this._dateTime.plusMinutes(t))},n.plusSeconds=function(t){return this._resolveInstant(this._dateTime.plusSeconds(t))},n.plusNanos=function(t){return this._resolveInstant(this._dateTime.plusNanos(t))},n._minusUnit=function(t,e){return this._plusUnit(-1*t,e)},n.minusYears=function(t){return this.plusYears(-1*t)},n.minusMonths=function(t){return this.plusMonths(-1*t)},n.minusWeeks=function(t){return this.plusWeeks(-1*t)},n.minusDays=function(t){return this.plusDays(-1*t)},n.minusHours=function(t){return this.plusHours(-1*t)},n.minusMinutes=function(t){return this.plusMinutes(-1*t)},n.minusSeconds=function(t){return this.plusSeconds(-1*t)},n.minusNanos=function(t){return this.plusNanos(-1*t)},n.query=function(e){return e===TemporalQueries.localDate()?this.toLocalDate():(requireNonNull(e,"query"),t.prototype.query.call(this,e))},n.until=function(t,n){var i=e.from(t);if(n instanceof ChronoUnit){if(i=i.withZoneSameInstant(this._zone),n.isDateBased())return this._dateTime.until(i._dateTime,n);var o=this._offset.totalSeconds()-i._offset.totalSeconds(),r=i._dateTime.plusSeconds(o);return this._dateTime.until(r,n)}return n.between(this,i)},n.toLocalDateTime=function(){return this._dateTime},n.toLocalDate=function(){return this._dateTime.toLocalDate()},n.toLocalTime=function(){return this._dateTime.toLocalTime()},n.toOffsetDateTime=function(){return OffsetDateTime.of(this._dateTime,this._offset)},n.equals=function(t){return this===t||t instanceof e&&(this._dateTime.equals(t._dateTime)&&this._offset.equals(t._offset)&&this._zone.equals(t._zone))},n.hashCode=function(){return MathUtil.hashCode(this._dateTime.hashCode(),this._offset.hashCode(),this._zone.hashCode())},n.toString=function(){var t=this._dateTime.toString()+this._offset.toString();return this._offset!==this._zone&&(t+="["+this._zone.toString()+"]"),t},n.toJSON=function(){return this.toString()},n.format=function(e){return t.prototype.format.call(this,e)},e}(ChronoZonedDateTime);function _init$7(){ZonedDateTime.FROM=createTemporalQuery("ZonedDateTime.FROM",(function(t){return ZonedDateTime.from(t)}))}var OffsetDateTime=function(t){function e(e,n){var i;return i=t.call(this)||this,requireNonNull(e,"dateTime"),requireInstance(e,LocalDateTime,"dateTime"),requireNonNull(n,"offset"),requireInstance(n,ZoneOffset,"offset"),i._dateTime=e,i._offset=n,i}_inheritsLoose(e,t),e.from=function(t){if(requireNonNull(t,"temporal"),t instanceof e)return t;try{var n=ZoneOffset.from(t);try{var i=LocalDateTime.from(t);return e.of(i,n)}catch(i){var o=Instant.from(t);return e.ofInstant(o,n)}}catch(e){throw new DateTimeException("Unable to obtain OffsetDateTime TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""))}},e.now=function(t){if(0===arguments.length)return e.now(Clock.systemDefaultZone());if(requireNonNull(t,"clockOrZone"),t instanceof ZoneId)return e.now(Clock.system(t));if(t instanceof Clock){var n=t.instant();return e.ofInstant(n,t.zone().rules().offset(n))}throw new IllegalArgumentException("clockOrZone must be an instance of ZoneId or Clock")},e.of=function(){return arguments.length<=2?e.ofDateTime.apply(this,arguments):3===arguments.length?e.ofDateAndTime.apply(this,arguments):e.ofNumbers.apply(this,arguments)},e.ofDateTime=function(t,n){return new e(t,n)},e.ofDateAndTime=function(t,n,i){return new e(LocalDateTime.of(t,n),i)},e.ofNumbers=function(t,n,i,o,r,a,s,u){return void 0===o&&(o=0),void 0===r&&(r=0),void 0===a&&(a=0),void 0===s&&(s=0),new e(LocalDateTime.of(t,n,i,o,r,a,s),u)},e.ofInstant=function(t,n){requireNonNull(t,"instant"),requireNonNull(n,"zone");var i=n.rules().offset(t);return new e(LocalDateTime.ofEpochSecond(t.epochSecond(),t.nano(),i),i)},e.parse=function(t,n){return void 0===n&&(n=DateTimeFormatter.ISO_OFFSET_DATE_TIME),requireNonNull(n,"formatter"),n.parse(t,e.FROM)};var n=e.prototype;return n.adjustInto=function(t){return t.with(ChronoField.EPOCH_DAY,this.toLocalDate().toEpochDay()).with(ChronoField.NANO_OF_DAY,this.toLocalTime().toNanoOfDay()).with(ChronoField.OFFSET_SECONDS,this.offset().totalSeconds())},n.until=function(t,n){var i=e.from(t);return n instanceof ChronoUnit?(i=i.withOffsetSameInstant(this._offset),this._dateTime.until(i._dateTime,n)):n.between(this,i)},n.atZoneSameInstant=function(t){return ZonedDateTime.ofInstant(this._dateTime,this._offset,t)},n.atZoneSimilarLocal=function(t){return ZonedDateTime.ofLocal(this._dateTime,t,this._offset)},n.query=function(e){return requireNonNull(e,"query"),e===TemporalQueries.chronology()?IsoChronology.INSTANCE:e===TemporalQueries.precision()?ChronoUnit.NANOS:e===TemporalQueries.offset()||e===TemporalQueries.zone()?this.offset():e===TemporalQueries.localDate()?this.toLocalDate():e===TemporalQueries.localTime()?this.toLocalTime():e===TemporalQueries.zoneId()?null:t.prototype.query.call(this,e)},n.get=function(e){if(e instanceof ChronoField){switch(e){case ChronoField.INSTANT_SECONDS:throw new DateTimeException("Field too large for an int: "+e);case ChronoField.OFFSET_SECONDS:return this.offset().totalSeconds()}return this._dateTime.get(e)}return t.prototype.get.call(this,e)},n.getLong=function(t){if(t instanceof ChronoField){switch(t){case ChronoField.INSTANT_SECONDS:return this.toEpochSecond();case ChronoField.OFFSET_SECONDS:return this.offset().totalSeconds()}return this._dateTime.getLong(t)}return t.getFrom(this)},n.offset=function(){return this._offset},n.year=function(){return this._dateTime.year()},n.monthValue=function(){return this._dateTime.monthValue()},n.month=function(){return this._dateTime.month()},n.dayOfMonth=function(){return this._dateTime.dayOfMonth()},n.dayOfYear=function(){return this._dateTime.dayOfYear()},n.dayOfWeek=function(){return this._dateTime.dayOfWeek()},n.hour=function(){return this._dateTime.hour()},n.minute=function(){return this._dateTime.minute()},n.second=function(){return this._dateTime.second()},n.nano=function(){return this._dateTime.nano()},n.toLocalDateTime=function(){return this._dateTime},n.toLocalDate=function(){return this._dateTime.toLocalDate()},n.toLocalTime=function(){return this._dateTime.toLocalTime()},n.toOffsetTime=function(){return OffsetTime.of(this._dateTime.toLocalTime(),this._offset)},n.toZonedDateTime=function(){return ZonedDateTime.of(this._dateTime,this._offset)},n.toInstant=function(){return this._dateTime.toInstant(this._offset)},n.toEpochSecond=function(){return this._dateTime.toEpochSecond(this._offset)},n.isSupported=function(t){return t instanceof ChronoField||t instanceof ChronoUnit?t.isDateBased()||t.isTimeBased():null!=t&&t.isSupportedBy(this)},n.range=function(t){return t instanceof ChronoField?t===ChronoField.INSTANT_SECONDS||t===ChronoField.OFFSET_SECONDS?t.range():this._dateTime.range(t):t.rangeRefinedBy(this)},n._withAdjuster=function(t){return requireNonNull(t),t instanceof LocalDate||t instanceof LocalTime||t instanceof LocalDateTime?this._withDateTimeOffset(this._dateTime.with(t),this._offset):t instanceof Instant?e.ofInstant(t,this._offset):t instanceof ZoneOffset?this._withDateTimeOffset(this._dateTime,t):t instanceof e?t:t.adjustInto(this)},n._withField=function(t,n){if(requireNonNull(t),t instanceof ChronoField){var i=t;switch(i){case ChronoField.INSTANT_SECONDS:return e.ofInstant(Instant.ofEpochSecond(n,this.nano()),this._offset);case ChronoField.OFFSET_SECONDS:return this._withDateTimeOffset(this._dateTime,ZoneOffset.ofTotalSeconds(i.checkValidIntValue(n)))}return this._withDateTimeOffset(this._dateTime.with(t,n),this._offset)}return t.adjustInto(this,n)},n._withDateTimeOffset=function(t,n){return this._dateTime===t&&this._offset.equals(n)?this:new e(t,n)},n.withYear=function(t){return this._withDateTimeOffset(this._dateTime.withYear(t),this._offset)},n.withMonth=function(t){return this._withDateTimeOffset(this._dateTime.withMonth(t),this._offset)},n.withDayOfMonth=function(t){return this._withDateTimeOffset(this._dateTime.withDayOfMonth(t),this._offset)},n.withDayOfYear=function(t){return this._withDateTimeOffset(this._dateTime.withDayOfYear(t),this._offset)},n.withHour=function(t){return this._withDateTimeOffset(this._dateTime.withHour(t),this._offset)},n.withMinute=function(t){return this._withDateTimeOffset(this._dateTime.withMinute(t),this._offset)},n.withSecond=function(t){return this._withDateTimeOffset(this._dateTime.withSecond(t),this._offset)},n.withNano=function(t){return this._withDateTimeOffset(this._dateTime.withNano(t),this._offset)},n.withOffsetSameLocal=function(t){return requireNonNull(t,"offset"),this._withDateTimeOffset(this._dateTime,t)},n.withOffsetSameInstant=function(t){if(requireNonNull(t,"offset"),t.equals(this._offset))return this;var n=t.totalSeconds()-this._offset.totalSeconds();return new e(this._dateTime.plusSeconds(n),t)},n.truncatedTo=function(t){return this._withDateTimeOffset(this._dateTime.truncatedTo(t),this._offset)},n._plusAmount=function(t){return requireNonNull(t,"amount"),t.addTo(this)},n._plusUnit=function(t,e){return e instanceof ChronoUnit?this._withDateTimeOffset(this._dateTime.plus(t,e),this._offset):e.addTo(this,t)},n.plusYears=function(t){return this._withDateTimeOffset(this._dateTime.plusYears(t),this._offset)},n.plusMonths=function(t){return this._withDateTimeOffset(this._dateTime.plusMonths(t),this._offset)},n.plusWeeks=function(t){return this._withDateTimeOffset(this._dateTime.plusWeeks(t),this._offset)},n.plusDays=function(t){return this._withDateTimeOffset(this._dateTime.plusDays(t),this._offset)},n.plusHours=function(t){return this._withDateTimeOffset(this._dateTime.plusHours(t),this._offset)},n.plusMinutes=function(t){return this._withDateTimeOffset(this._dateTime.plusMinutes(t),this._offset)},n.plusSeconds=function(t){return this._withDateTimeOffset(this._dateTime.plusSeconds(t),this._offset)},n.plusNanos=function(t){return this._withDateTimeOffset(this._dateTime.plusNanos(t),this._offset)},n._minusAmount=function(t){return requireNonNull(t),t.subtractFrom(this)},n._minusUnit=function(t,e){return this.plus(-1*t,e)},n.minusYears=function(t){return this._withDateTimeOffset(this._dateTime.minusYears(t),this._offset)},n.minusMonths=function(t){return this._withDateTimeOffset(this._dateTime.minusMonths(t),this._offset)},n.minusWeeks=function(t){return this._withDateTimeOffset(this._dateTime.minusWeeks(t),this._offset)},n.minusDays=function(t){return this._withDateTimeOffset(this._dateTime.minusDays(t),this._offset)},n.minusHours=function(t){return this._withDateTimeOffset(this._dateTime.minusHours(t),this._offset)},n.minusMinutes=function(t){return this._withDateTimeOffset(this._dateTime.minusMinutes(t),this._offset)},n.minusSeconds=function(t){return this._withDateTimeOffset(this._dateTime.minusSeconds(t),this._offset)},n.minusNanos=function(t){return this._withDateTimeOffset(this._dateTime.minusNanos(t),this._offset)},n.compareTo=function(t){if(requireNonNull(t,"other"),requireInstance(t,e,"other"),this.offset().equals(t.offset()))return this.toLocalDateTime().compareTo(t.toLocalDateTime());var n=MathUtil.compareNumbers(this.toEpochSecond(),t.toEpochSecond());return 0===n&&0===(n=this.toLocalTime().nano()-t.toLocalTime().nano())&&(n=this.toLocalDateTime().compareTo(t.toLocalDateTime())),n},n.isAfter=function(t){requireNonNull(t,"other");var e=this.toEpochSecond(),n=t.toEpochSecond();return e>n||e===n&&this.toLocalTime().nano()>t.toLocalTime().nano()},n.isBefore=function(t){requireNonNull(t,"other");var e=this.toEpochSecond(),n=t.toEpochSecond();return e<n||e===n&&this.toLocalTime().nano()<t.toLocalTime().nano()},n.isEqual=function(t){return requireNonNull(t,"other"),this.toEpochSecond()===t.toEpochSecond()&&this.toLocalTime().nano()===t.toLocalTime().nano()},n.equals=function(t){return this===t||t instanceof e&&(this._dateTime.equals(t._dateTime)&&this._offset.equals(t._offset))},n.hashCode=function(){return this._dateTime.hashCode()^this._offset.hashCode()},n.toString=function(){return this._dateTime.toString()+this._offset.toString()},n.toJSON=function(){return this.toString()},n.format=function(t){return requireNonNull(t,"formatter"),t.format(this)},e}(Temporal);function _init$6(){OffsetDateTime.MIN=LocalDateTime.MIN.atOffset(ZoneOffset.MAX),OffsetDateTime.MAX=LocalDateTime.MAX.atOffset(ZoneOffset.MIN),OffsetDateTime.FROM=createTemporalQuery("OffsetDateTime.FROM",(function(t){return OffsetDateTime.from(t)}))}var DAYS_PER_CYCLE=146097,DAYS_0000_TO_1970=5*DAYS_PER_CYCLE-10957,LocalDate=function(t){function e(n,i,o){var r;return r=t.call(this)||this,requireNonNull(n,"year"),requireNonNull(i,"month"),requireNonNull(o,"dayOfMonth"),i instanceof Month&&(i=i.value()),r._year=MathUtil.safeToInt(n),r._month=MathUtil.safeToInt(i),r._day=MathUtil.safeToInt(o),e._validate(r._year,r._month,r._day),r}_inheritsLoose(e,t),e.now=function(t){var n;return n=null==t?Clock.systemDefaultZone():t instanceof ZoneId?Clock.system(t):t,e.ofInstant(n.instant(),n.zone())},e.ofInstant=function(t,n){void 0===n&&(n=ZoneId.systemDefault()),requireNonNull(t,"instant");var i=n.rules().offset(t),o=t.epochSecond()+i.totalSeconds(),r=MathUtil.floorDiv(o,LocalTime.SECONDS_PER_DAY);return e.ofEpochDay(r)},e.of=function(t,n,i){return new e(t,n,i)},e.ofYearDay=function(t,n){ChronoField.YEAR.checkValidValue(t);var i=IsoChronology.isLeapYear(t);366===n&&!1===i&&assert(!1,"Invalid date 'DayOfYear 366' as '"+t+"' is not a leap year",DateTimeException);var o=Month.of(Math.floor((n-1)/31+1));n>o.firstDayOfYear(i)+o.length(i)-1&&(o=o.plus(1));var r=n-o.firstDayOfYear(i)+1;return new e(t,o.value(),r)},e.ofEpochDay=function(t){var n,i,o,r,a;void 0===t&&(t=0),a=t+DAYS_0000_TO_1970,n=0,(a-=60)<0&&(n=400*(i=MathUtil.intDiv(a+1,DAYS_PER_CYCLE)-1),a+=-i*DAYS_PER_CYCLE),(o=a-(365*(r=MathUtil.intDiv(400*a+591,DAYS_PER_CYCLE))+MathUtil.intDiv(r,4)-MathUtil.intDiv(r,100)+MathUtil.intDiv(r,400)))<0&&(o=a-(365*--r+MathUtil.intDiv(r,4)-MathUtil.intDiv(r,100)+MathUtil.intDiv(r,400))),r+=n;var s=o,u=MathUtil.intDiv(5*s+2,153),l=(u+2)%12+1,h=s-MathUtil.intDiv(306*u+5,10)+1;return new e(r+=MathUtil.intDiv(u,10),l,h)},e.from=function(t){requireNonNull(t,"temporal");var e=t.query(TemporalQueries.localDate());if(null==e)throw new DateTimeException("Unable to obtain LocalDate from TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""));return e},e.parse=function(t,n){return void 0===n&&(n=DateTimeFormatter.ISO_LOCAL_DATE),assert(null!=n,"formatter",NullPointerException),n.parse(t,e.FROM)},e._resolvePreviousValid=function(t,n,i){switch(n){case 2:i=Math.min(i,IsoChronology.isLeapYear(t)?29:28);break;case 4:case 6:case 9:case 11:i=Math.min(i,30)}return e.of(t,n,i)},e._validate=function(t,e,n){var i;if(ChronoField.YEAR.checkValidValue(t),ChronoField.MONTH_OF_YEAR.checkValidValue(e),ChronoField.DAY_OF_MONTH.checkValidValue(n),n>28){switch(i=31,e){case 2:i=IsoChronology.isLeapYear(t)?29:28;break;case 4:case 6:case 9:case 11:i=30}n>i&&assert(!1,29===n?"Invalid date 'February 29' as '"+t+"' is not a leap year":"Invalid date '"+t+"' '"+e+"' '"+n+"'",DateTimeException)}};var n=e.prototype;return n.isSupported=function(e){return t.prototype.isSupported.call(this,e)},n.range=function(t){if(t instanceof ChronoField){if(t.isDateBased()){switch(t){case ChronoField.DAY_OF_MONTH:return ValueRange.of(1,this.lengthOfMonth());case ChronoField.DAY_OF_YEAR:return ValueRange.of(1,this.lengthOfYear());case ChronoField.ALIGNED_WEEK_OF_MONTH:return ValueRange.of(1,this.month()===Month.FEBRUARY&&!1===this.isLeapYear()?4:5);case ChronoField.YEAR_OF_ERA:return this._year<=0?ValueRange.of(1,Year.MAX_VALUE+1):ValueRange.of(1,Year.MAX_VALUE)}return t.range()}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.rangeRefinedBy(this)},n.get=function(t){return this.getLong(t)},n.getLong=function(t){return assert(null!=t,"",NullPointerException),t instanceof ChronoField?this._get0(t):t.getFrom(this)},n._get0=function(t){switch(t){case ChronoField.DAY_OF_WEEK:return this.dayOfWeek().value();case ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH:return MathUtil.intMod(this._day-1,7)+1;case ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR:return MathUtil.intMod(this.dayOfYear()-1,7)+1;case ChronoField.DAY_OF_MONTH:return this._day;case ChronoField.DAY_OF_YEAR:return this.dayOfYear();case ChronoField.EPOCH_DAY:return this.toEpochDay();case ChronoField.ALIGNED_WEEK_OF_MONTH:return MathUtil.intDiv(this._day-1,7)+1;case ChronoField.ALIGNED_WEEK_OF_YEAR:return MathUtil.intDiv(this.dayOfYear()-1,7)+1;case ChronoField.MONTH_OF_YEAR:return this._month;case ChronoField.PROLEPTIC_MONTH:return this._prolepticMonth();case ChronoField.YEAR_OF_ERA:return this._year>=1?this._year:1-this._year;case ChronoField.YEAR:return this._year;case ChronoField.ERA:return this._year>=1?1:0}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)},n._prolepticMonth=function(){return 12*this._year+(this._month-1)},n.chronology=function(){return IsoChronology.INSTANCE},n.year=function(){return this._year},n.monthValue=function(){return this._month},n.month=function(){return Month.of(this._month)},n.dayOfMonth=function(){return this._day},n.dayOfYear=function(){return this.month().firstDayOfYear(this.isLeapYear())+this._day-1},n.dayOfWeek=function(){var t=MathUtil.floorMod(this.toEpochDay()+3,7);return DayOfWeek.of(t+1)},n.isLeapYear=function(){return IsoChronology.isLeapYear(this._year)},n.lengthOfMonth=function(){switch(this._month){case 2:return this.isLeapYear()?29:28;case 4:case 6:case 9:case 11:return 30;default:return 31}},n.lengthOfYear=function(){return this.isLeapYear()?366:365},n._withAdjuster=function(n){return requireNonNull(n,"adjuster"),n instanceof e?n:t.prototype._withAdjuster.call(this,n)},n._withField=function(t,n){if(assert(null!=t,"field",NullPointerException),t instanceof ChronoField){var i=t;switch(i.checkValidValue(n),i){case ChronoField.DAY_OF_WEEK:return this.plusDays(n-this.dayOfWeek().value());case ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH:return this.plusDays(n-this.getLong(ChronoField.ALIGNED_DAY_OF_WEEK_IN_MONTH));case ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR:return this.plusDays(n-this.getLong(ChronoField.ALIGNED_DAY_OF_WEEK_IN_YEAR));case ChronoField.DAY_OF_MONTH:return this.withDayOfMonth(n);case ChronoField.DAY_OF_YEAR:return this.withDayOfYear(n);case ChronoField.EPOCH_DAY:return e.ofEpochDay(n);case ChronoField.ALIGNED_WEEK_OF_MONTH:return this.plusWeeks(n-this.getLong(ChronoField.ALIGNED_WEEK_OF_MONTH));case ChronoField.ALIGNED_WEEK_OF_YEAR:return this.plusWeeks(n-this.getLong(ChronoField.ALIGNED_WEEK_OF_YEAR));case ChronoField.MONTH_OF_YEAR:return this.withMonth(n);case ChronoField.PROLEPTIC_MONTH:return this.plusMonths(n-this.getLong(ChronoField.PROLEPTIC_MONTH));case ChronoField.YEAR_OF_ERA:return this.withYear(this._year>=1?n:1-n);case ChronoField.YEAR:return this.withYear(n);case ChronoField.ERA:return this.getLong(ChronoField.ERA)===n?this:this.withYear(1-this._year)}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.adjustInto(this,n)},n.withYear=function(t){return this._year===t?this:(ChronoField.YEAR.checkValidValue(t),e._resolvePreviousValid(t,this._month,this._day))},n.withMonth=function(t){var n=t instanceof Month?t.value():t;return this._month===n?this:(ChronoField.MONTH_OF_YEAR.checkValidValue(n),e._resolvePreviousValid(this._year,n,this._day))},n.withDayOfMonth=function(t){return this._day===t?this:e.of(this._year,this._month,t)},n.withDayOfYear=function(t){return this.dayOfYear()===t?this:e.ofYearDay(this._year,t)},n._plusUnit=function(t,e){if(requireNonNull(t,"amountToAdd"),requireNonNull(e,"unit"),e instanceof ChronoUnit){switch(e){case ChronoUnit.DAYS:return this.plusDays(t);case ChronoUnit.WEEKS:return this.plusWeeks(t);case ChronoUnit.MONTHS:return this.plusMonths(t);case ChronoUnit.YEARS:return this.plusYears(t);case ChronoUnit.DECADES:return this.plusYears(MathUtil.safeMultiply(t,10));case ChronoUnit.CENTURIES:return this.plusYears(MathUtil.safeMultiply(t,100));case ChronoUnit.MILLENNIA:return this.plusYears(MathUtil.safeMultiply(t,1e3));case ChronoUnit.ERAS:return this.with(ChronoField.ERA,MathUtil.safeAdd(this.getLong(ChronoField.ERA),t))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+e)}return e.addTo(this,t)},n.plusYears=function(t){if(0===t)return this;var n=ChronoField.YEAR.checkValidIntValue(this._year+t);return e._resolvePreviousValid(n,this._month,this._day)},n.plusMonths=function(t){if(0===t)return this;var n=12*this._year+(this._month-1)+t,i=ChronoField.YEAR.checkValidIntValue(MathUtil.floorDiv(n,12)),o=MathUtil.floorMod(n,12)+1;return e._resolvePreviousValid(i,o,this._day)},n.plusWeeks=function(t){return this.plusDays(MathUtil.safeMultiply(t,7))},n.plusDays=function(t){if(0===t)return this;var n=MathUtil.safeAdd(this.toEpochDay(),t);return e.ofEpochDay(n)},n._minusUnit=function(t,e){return requireNonNull(t,"amountToSubtract"),requireNonNull(e,"unit"),this._plusUnit(-1*t,e)},n.minusYears=function(t){return this.plusYears(-1*t)},n.minusMonths=function(t){return this.plusMonths(-1*t)},n.minusWeeks=function(t){return this.plusWeeks(-1*t)},n.minusDays=function(t){return this.plusDays(-1*t)},n.query=function(e){return requireNonNull(e,"query"),e===TemporalQueries.localDate()?this:t.prototype.query.call(this,e)},n.adjustInto=function(e){return t.prototype.adjustInto.call(this,e)},n.until=function(t,e){return arguments.length<2?this.until1(t):this.until2(t,e)},n.until2=function(t,n){var i=e.from(t);if(n instanceof ChronoUnit){switch(n){case ChronoUnit.DAYS:return this.daysUntil(i);case ChronoUnit.WEEKS:return MathUtil.intDiv(this.daysUntil(i),7);case ChronoUnit.MONTHS:return this._monthsUntil(i);case ChronoUnit.YEARS:return MathUtil.intDiv(this._monthsUntil(i),12);case ChronoUnit.DECADES:return MathUtil.intDiv(this._monthsUntil(i),120);case ChronoUnit.CENTURIES:return MathUtil.intDiv(this._monthsUntil(i),1200);case ChronoUnit.MILLENNIA:return MathUtil.intDiv(this._monthsUntil(i),12e3);case ChronoUnit.ERAS:return i.getLong(ChronoField.ERA)-this.getLong(ChronoField.ERA)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.between(this,i)},n.daysUntil=function(t){return t.toEpochDay()-this.toEpochDay()},n._monthsUntil=function(t){var e=32*this._prolepticMonth()+this.dayOfMonth(),n=32*t._prolepticMonth()+t.dayOfMonth();return MathUtil.intDiv(n-e,32)},n.until1=function(t){var n=e.from(t),i=n._prolepticMonth()-this._prolepticMonth(),o=n._day-this._day;if(i>0&&o<0){i--;var r=this.plusMonths(i);o=n.toEpochDay()-r.toEpochDay()}else i<0&&o>0&&(i++,o-=n.lengthOfMonth());var a=MathUtil.intDiv(i,12),s=MathUtil.intMod(i,12);return Period.of(a,s,o)},n.atTime=function(){return 1===arguments.length?this.atTime1.apply(this,arguments):this.atTime4.apply(this,arguments)},n.atTime1=function(t){if(requireNonNull(t,"time"),t instanceof LocalTime)return LocalDateTime.of(this,t);if(t instanceof OffsetTime)return this._atTimeOffsetTime(t);throw new IllegalArgumentException("time must be an instance of LocalTime or OffsetTime"+(t&&t.constructor&&t.constructor.name?", but is "+t.constructor.name:""))},n.atTime4=function(t,e,n,i){return void 0===n&&(n=0),void 0===i&&(i=0),this.atTime1(LocalTime.of(t,e,n,i))},n._atTimeOffsetTime=function(t){return OffsetDateTime.of(LocalDateTime.of(this,t.toLocalTime()),t.offset())},n.atStartOfDay=function(t){return null!=t?this._atStartOfDayWithZone(t):LocalDateTime.of(this,LocalTime.MIDNIGHT)},n._atStartOfDayWithZone=function(t){requireNonNull(t,"zone");var e=this.atTime(LocalTime.MIDNIGHT);if(t instanceof ZoneOffset==!1){var n=t.rules().transition(e);null!=n&&n.isGap()&&(e=n.dateTimeAfter())}return ZonedDateTime.of(e,t)},n.toEpochDay=function(){var t=this._year,e=this._month,n=0;return n+=365*t,t>=0?n+=MathUtil.intDiv(t+3,4)-MathUtil.intDiv(t+99,100)+MathUtil.intDiv(t+399,400):n-=MathUtil.intDiv(t,-4)-MathUtil.intDiv(t,-100)+MathUtil.intDiv(t,-400),n+=MathUtil.intDiv(367*e-362,12),n+=this.dayOfMonth()-1,e>2&&(n--,IsoChronology.isLeapYear(t)||n--),n-DAYS_0000_TO_1970},n.compareTo=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._compareTo0(t)},n._compareTo0=function(t){var e=this._year-t._year;return 0===e&&0===(e=this._month-t._month)&&(e=this._day-t._day),e},n.isAfter=function(t){return this.compareTo(t)>0},n.isBefore=function(t){return this.compareTo(t)<0},n.isEqual=function(t){return 0===this.compareTo(t)},n.equals=function(t){return this===t||t instanceof e&&0===this._compareTo0(t)},n.hashCode=function(){var t=this._year,e=this._month,n=this._day;return MathUtil.hash(4294965248&t^(t<<11)+(e<<6)+n)},n.toString=function(){var t=this._year,e=this._month,n=this._day;return(Math.abs(t)<1e3?t<0?"-"+(""+(t-1e4)).slice(-4):(""+(t+1e4)).slice(-4):t>9999?"+"+t:""+t)+(e<10?"-0"+e:"-"+e)+(n<10?"-0"+n:"-"+n)},n.toJSON=function(){return this.toString()},n.format=function(e){return requireNonNull(e,"formatter"),requireInstance(e,DateTimeFormatter,"formatter"),t.prototype.format.call(this,e)},e}(ChronoLocalDate);function _init$5(){LocalDate.MIN=LocalDate.of(YearConstants.MIN_VALUE,1,1),LocalDate.MAX=LocalDate.of(YearConstants.MAX_VALUE,12,31),LocalDate.EPOCH_0=LocalDate.ofEpochDay(0),LocalDate.FROM=createTemporalQuery("LocalDate.FROM",(function(t){return LocalDate.from(t)}))}var ChronoLocalDateTime=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.chronology=function(){return this.toLocalDate().chronology()},n.query=function(e){return e===TemporalQueries.chronology()?this.chronology():e===TemporalQueries.precision()?ChronoUnit.NANOS:e===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):e===TemporalQueries.localTime()?this.toLocalTime():e===TemporalQueries.zone()||e===TemporalQueries.zoneId()||e===TemporalQueries.offset()?null:t.prototype.query.call(this,e)},n.adjustInto=function(t){return t.with(ChronoField.EPOCH_DAY,this.toLocalDate().toEpochDay()).with(ChronoField.NANO_OF_DAY,this.toLocalTime().toNanoOfDay())},n.toInstant=function(t){return requireInstance(t,ZoneOffset,"zoneId"),Instant.ofEpochSecond(this.toEpochSecond(t),this.toLocalTime().nano())},n.toEpochSecond=function(t){requireNonNull(t,"offset");var e=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return e-=t.totalSeconds(),MathUtil.safeToInt(e)},e}(Temporal),LocalDateTime=function(t){function e(e,n){var i;return i=t.call(this)||this,requireInstance(e,LocalDate,"date"),requireInstance(n,LocalTime,"time"),i._date=e,i._time=n,i}_inheritsLoose(e,t),e.now=function(t){return null==t?e._now(Clock.systemDefaultZone()):t instanceof Clock?e._now(t):e._now(Clock.system(t))},e._now=function(t){return requireNonNull(t,"clock"),e.ofInstant(t.instant(),t.zone())},e._ofEpochMillis=function(t,n){var i=MathUtil.floorDiv(t,1e3)+n.totalSeconds(),o=MathUtil.floorDiv(i,LocalTime.SECONDS_PER_DAY),r=MathUtil.floorMod(i,LocalTime.SECONDS_PER_DAY),a=1e6*MathUtil.floorMod(t,1e3);return new e(LocalDate.ofEpochDay(o),LocalTime.ofSecondOfDay(r,a))},e.of=function(){return arguments.length<=2?e.ofDateAndTime.apply(this,arguments):e.ofNumbers.apply(this,arguments)},e.ofNumbers=function(t,n,i,o,r,a,s){return void 0===o&&(o=0),void 0===r&&(r=0),void 0===a&&(a=0),void 0===s&&(s=0),new e(LocalDate.of(t,n,i),LocalTime.of(o,r,a,s))},e.ofDateAndTime=function(t,n){return requireNonNull(t,"date"),requireNonNull(n,"time"),new e(t,n)},e.ofInstant=function(t,n){void 0===n&&(n=ZoneId.systemDefault()),requireNonNull(t,"instant"),requireInstance(t,Instant,"instant"),requireNonNull(n,"zone");var i=n.rules().offset(t);return e.ofEpochSecond(t.epochSecond(),t.nano(),i)},e.ofEpochSecond=function(t,n,i){void 0===t&&(t=0),void 0===n&&(n=0),2===arguments.length&&n instanceof ZoneOffset&&(i=n,n=0),requireNonNull(i,"offset");var o=t+i.totalSeconds(),r=MathUtil.floorDiv(o,LocalTime.SECONDS_PER_DAY),a=MathUtil.floorMod(o,LocalTime.SECONDS_PER_DAY);return new e(LocalDate.ofEpochDay(r),LocalTime.ofSecondOfDay(a,n))},e.from=function(t){if(requireNonNull(t,"temporal"),t instanceof e)return t;if(t instanceof ZonedDateTime)return t.toLocalDateTime();try{return new e(LocalDate.from(t),LocalTime.from(t))}catch(e){throw new DateTimeException("Unable to obtain LocalDateTime TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""))}},e.parse=function(t,n){return void 0===n&&(n=DateTimeFormatter.ISO_LOCAL_DATE_TIME),requireNonNull(n,"formatter"),n.parse(t,e.FROM)};var n=e.prototype;return n._withDateTime=function(t,n){return this._date.equals(t)&&this._time.equals(n)?this:new e(t,n)},n.isSupported=function(t){return t instanceof ChronoField||t instanceof ChronoUnit?t.isDateBased()||t.isTimeBased():null!=t&&t.isSupportedBy(this)},n.range=function(t){return t instanceof ChronoField?t.isTimeBased()?this._time.range(t):this._date.range(t):t.rangeRefinedBy(this)},n.get=function(e){return e instanceof ChronoField?e.isTimeBased()?this._time.get(e):this._date.get(e):t.prototype.get.call(this,e)},n.getLong=function(t){return requireNonNull(t,"field"),t instanceof ChronoField?t.isTimeBased()?this._time.getLong(t):this._date.getLong(t):t.getFrom(this)},n.year=function(){return this._date.year()},n.monthValue=function(){return this._date.monthValue()},n.month=function(){return this._date.month()},n.dayOfMonth=function(){return this._date.dayOfMonth()},n.dayOfYear=function(){return this._date.dayOfYear()},n.dayOfWeek=function(){return this._date.dayOfWeek()},n.hour=function(){return this._time.hour()},n.minute=function(){return this._time.minute()},n.second=function(){return this._time.second()},n.nano=function(){return this._time.nano()},n._withAdjuster=function(n){return requireNonNull(n,"adjuster"),n instanceof LocalDate?this._withDateTime(n,this._time):n instanceof LocalTime?this._withDateTime(this._date,n):n instanceof e?n:t.prototype._withAdjuster.call(this,n)},n._withField=function(t,e){return requireNonNull(t,"field"),t instanceof ChronoField?t.isTimeBased()?this._withDateTime(this._date,this._time.with(t,e)):this._withDateTime(this._date.with(t,e),this._time):t.adjustInto(this,e)},n.withYear=function(t){return this._withDateTime(this._date.withYear(t),this._time)},n.withMonth=function(t){return this._withDateTime(this._date.withMonth(t),this._time)},n.withDayOfMonth=function(t){return this._withDateTime(this._date.withDayOfMonth(t),this._time)},n.withDayOfYear=function(t){return this._withDateTime(this._date.withDayOfYear(t),this._time)},n.withHour=function(t){var e=this._time.withHour(t);return this._withDateTime(this._date,e)},n.withMinute=function(t){var e=this._time.withMinute(t);return this._withDateTime(this._date,e)},n.withSecond=function(t){var e=this._time.withSecond(t);return this._withDateTime(this._date,e)},n.withNano=function(t){var e=this._time.withNano(t);return this._withDateTime(this._date,e)},n.truncatedTo=function(t){return this._withDateTime(this._date,this._time.truncatedTo(t))},n._plusUnit=function(t,e){if(requireNonNull(e,"unit"),e instanceof ChronoUnit){switch(e){case ChronoUnit.NANOS:return this.plusNanos(t);case ChronoUnit.MICROS:return this.plusDays(MathUtil.intDiv(t,LocalTime.MICROS_PER_DAY)).plusNanos(1e3*MathUtil.intMod(t,LocalTime.MICROS_PER_DAY));case ChronoUnit.MILLIS:return this.plusDays(MathUtil.intDiv(t,LocalTime.MILLIS_PER_DAY)).plusNanos(1e6*MathUtil.intMod(t,LocalTime.MILLIS_PER_DAY));case ChronoUnit.SECONDS:return this.plusSeconds(t);case ChronoUnit.MINUTES:return this.plusMinutes(t);case ChronoUnit.HOURS:return this.plusHours(t);case ChronoUnit.HALF_DAYS:return this.plusDays(MathUtil.intDiv(t,256)).plusHours(12*MathUtil.intMod(t,256))}return this._withDateTime(this._date.plus(t,e),this._time)}return e.addTo(this,t)},n.plusYears=function(t){var e=this._date.plusYears(t);return this._withDateTime(e,this._time)},n.plusMonths=function(t){var e=this._date.plusMonths(t);return this._withDateTime(e,this._time)},n.plusWeeks=function(t){var e=this._date.plusWeeks(t);return this._withDateTime(e,this._time)},n.plusDays=function(t){var e=this._date.plusDays(t);return this._withDateTime(e,this._time)},n.plusHours=function(t){return this._plusWithOverflow(this._date,t,0,0,0,1)},n.plusMinutes=function(t){return this._plusWithOverflow(this._date,0,t,0,0,1)},n.plusSeconds=function(t){return this._plusWithOverflow(this._date,0,0,t,0,1)},n.plusNanos=function(t){return this._plusWithOverflow(this._date,0,0,0,t,1)},n._minusUnit=function(t,e){return requireNonNull(e,"unit"),this._plusUnit(-1*t,e)},n.minusYears=function(t){return this.plusYears(-1*t)},n.minusMonths=function(t){return this.plusMonths(-1*t)},n.minusWeeks=function(t){return this.plusWeeks(-1*t)},n.minusDays=function(t){return this.plusDays(-1*t)},n.minusHours=function(t){return this._plusWithOverflow(this._date,t,0,0,0,-1)},n.minusMinutes=function(t){return this._plusWithOverflow(this._date,0,t,0,0,-1)},n.minusSeconds=function(t){return this._plusWithOverflow(this._date,0,0,t,0,-1)},n.minusNanos=function(t){return this._plusWithOverflow(this._date,0,0,0,t,-1)},n._plusWithOverflow=function(t,e,n,i,o,r){if(0===e&&0===n&&0===i&&0===o)return this._withDateTime(t,this._time);var a=MathUtil.intDiv(o,LocalTime.NANOS_PER_DAY)+MathUtil.intDiv(i,LocalTime.SECONDS_PER_DAY)+MathUtil.intDiv(n,LocalTime.MINUTES_PER_DAY)+MathUtil.intDiv(e,LocalTime.HOURS_PER_DAY);a*=r;var s=MathUtil.intMod(o,LocalTime.NANOS_PER_DAY)+MathUtil.intMod(i,LocalTime.SECONDS_PER_DAY)*LocalTime.NANOS_PER_SECOND+MathUtil.intMod(n,LocalTime.MINUTES_PER_DAY)*LocalTime.NANOS_PER_MINUTE+MathUtil.intMod(e,LocalTime.HOURS_PER_DAY)*LocalTime.NANOS_PER_HOUR,u=this._time.toNanoOfDay();s=s*r+u,a+=MathUtil.floorDiv(s,LocalTime.NANOS_PER_DAY);var l=MathUtil.floorMod(s,LocalTime.NANOS_PER_DAY),h=l===u?this._time:LocalTime.ofNanoOfDay(l);return this._withDateTime(t.plusDays(a),h)},n.query=function(e){return requireNonNull(e,"query"),e===TemporalQueries.localDate()?this.toLocalDate():t.prototype.query.call(this,e)},n.adjustInto=function(e){return t.prototype.adjustInto.call(this,e)},n.until=function(t,n){requireNonNull(t,"endExclusive"),requireNonNull(n,"unit");var i=e.from(t);if(n instanceof ChronoUnit){if(n.isTimeBased()){var o=this._date.daysUntil(i._date),r=i._time.toNanoOfDay()-this._time.toNanoOfDay();o>0&&r<0?(o--,r+=LocalTime.NANOS_PER_DAY):o<0&&r>0&&(o++,r-=LocalTime.NANOS_PER_DAY);var a=o;switch(n){case ChronoUnit.NANOS:return a=MathUtil.safeMultiply(a,LocalTime.NANOS_PER_DAY),MathUtil.safeAdd(a,r);case ChronoUnit.MICROS:return a=MathUtil.safeMultiply(a,LocalTime.MICROS_PER_DAY),MathUtil.safeAdd(a,MathUtil.intDiv(r,1e3));case ChronoUnit.MILLIS:return a=MathUtil.safeMultiply(a,LocalTime.MILLIS_PER_DAY),MathUtil.safeAdd(a,MathUtil.intDiv(r,1e6));case ChronoUnit.SECONDS:return a=MathUtil.safeMultiply(a,LocalTime.SECONDS_PER_DAY),MathUtil.safeAdd(a,MathUtil.intDiv(r,LocalTime.NANOS_PER_SECOND));case ChronoUnit.MINUTES:return a=MathUtil.safeMultiply(a,LocalTime.MINUTES_PER_DAY),MathUtil.safeAdd(a,MathUtil.intDiv(r,LocalTime.NANOS_PER_MINUTE));case ChronoUnit.HOURS:return a=MathUtil.safeMultiply(a,LocalTime.HOURS_PER_DAY),MathUtil.safeAdd(a,MathUtil.intDiv(r,LocalTime.NANOS_PER_HOUR));case ChronoUnit.HALF_DAYS:return a=MathUtil.safeMultiply(a,2),MathUtil.safeAdd(a,MathUtil.intDiv(r,12*LocalTime.NANOS_PER_HOUR))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}var s=i._date,u=i._time;return s.isAfter(this._date)&&u.isBefore(this._time)?s=s.minusDays(1):s.isBefore(this._date)&&u.isAfter(this._time)&&(s=s.plusDays(1)),this._date.until(s,n)}return n.between(this,i)},n.atOffset=function(t){return OffsetDateTime.of(this,t)},n.atZone=function(t){return ZonedDateTime.of(this,t)},n.toLocalDate=function(){return this._date},n.toLocalTime=function(){return this._time},n.compareTo=function(t){return requireNonNull(t,"other"),requireInstance(t,e,"other"),this._compareTo0(t)},n._compareTo0=function(t){var e=this._date.compareTo(t.toLocalDate());return 0===e&&(e=this._time.compareTo(t.toLocalTime())),e},n.isAfter=function(t){return this.compareTo(t)>0},n.isBefore=function(t){return this.compareTo(t)<0},n.isEqual=function(t){return 0===this.compareTo(t)},n.equals=function(t){return this===t||t instanceof e&&(this._date.equals(t._date)&&this._time.equals(t._time))},n.hashCode=function(){return this._date.hashCode()^this._time.hashCode()},n.toString=function(){return this._date.toString()+"T"+this._time.toString()},n.toJSON=function(){return this.toString()},n.format=function(t){return requireNonNull(t,"formatter"),t.format(this)},e}(ChronoLocalDateTime);function _init$4(){LocalDateTime.MIN=LocalDateTime.of(LocalDate.MIN,LocalTime.MIN),LocalDateTime.MAX=LocalDateTime.of(LocalDate.MAX,LocalTime.MAX),LocalDateTime.FROM=createTemporalQuery("LocalDateTime.FROM",(function(t){return LocalDateTime.from(t)}))}var LocalTime=function(t){function e(n,i,o,r){var a;void 0===n&&(n=0),void 0===i&&(i=0),void 0===o&&(o=0),void 0===r&&(r=0),a=t.call(this)||this;var s=MathUtil.safeToInt(n),u=MathUtil.safeToInt(i),l=MathUtil.safeToInt(o),h=MathUtil.safeToInt(r);return e._validate(s,u,l,h),0===u&&0===l&&0===h?(e.HOURS[s]||(a._hour=s,a._minute=u,a._second=l,a._nano=h,e.HOURS[s]=_assertThisInitialized(a)),e.HOURS[s]||_assertThisInitialized(a)):(a._hour=s,a._minute=u,a._second=l,a._nano=h,a)}_inheritsLoose(e,t),e.now=function(t){return null==t?e._now(Clock.systemDefaultZone()):t instanceof Clock?e._now(t):e._now(Clock.system(t))},e._now=function(t){return void 0===t&&(t=Clock.systemDefaultZone()),requireNonNull(t,"clock"),e.ofInstant(t.instant(),t.zone())},e.ofInstant=function(t,n){void 0===n&&(n=ZoneId.systemDefault());var i=n.rules().offset(t),o=MathUtil.intMod(t.epochSecond(),e.SECONDS_PER_DAY);return(o=MathUtil.intMod(o+i.totalSeconds(),e.SECONDS_PER_DAY))<0&&(o+=e.SECONDS_PER_DAY),e.ofSecondOfDay(o,t.nano())},e.of=function(t,n,i,o){return new e(t,n,i,o)},e.ofSecondOfDay=function(t,n){void 0===t&&(t=0),void 0===n&&(n=0),ChronoField.SECOND_OF_DAY.checkValidValue(t),ChronoField.NANO_OF_SECOND.checkValidValue(n);var i=MathUtil.intDiv(t,e.SECONDS_PER_HOUR);t-=i*e.SECONDS_PER_HOUR;var o=MathUtil.intDiv(t,e.SECONDS_PER_MINUTE);return new e(i,o,t-=o*e.SECONDS_PER_MINUTE,n)},e.ofNanoOfDay=function(t){void 0===t&&(t=0),ChronoField.NANO_OF_DAY.checkValidValue(t);var n=MathUtil.intDiv(t,e.NANOS_PER_HOUR);t-=n*e.NANOS_PER_HOUR;var i=MathUtil.intDiv(t,e.NANOS_PER_MINUTE);t-=i*e.NANOS_PER_MINUTE;var o=MathUtil.intDiv(t,e.NANOS_PER_SECOND);return new e(n,i,o,t-=o*e.NANOS_PER_SECOND)},e.from=function(t){requireNonNull(t,"temporal");var e=t.query(TemporalQueries.localTime());if(null==e)throw new DateTimeException("Unable to obtain LocalTime TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""));return e},e.parse=function(t,n){return void 0===n&&(n=DateTimeFormatter.ISO_LOCAL_TIME),requireNonNull(n,"formatter"),n.parse(t,e.FROM)},e._validate=function(t,e,n,i){ChronoField.HOUR_OF_DAY.checkValidValue(t),ChronoField.MINUTE_OF_HOUR.checkValidValue(e),ChronoField.SECOND_OF_MINUTE.checkValidValue(n),ChronoField.NANO_OF_SECOND.checkValidValue(i)};var n=e.prototype;return n.isSupported=function(t){return t instanceof ChronoField||t instanceof ChronoUnit?t.isTimeBased():null!=t&&t.isSupportedBy(this)},n.range=function(e){return requireNonNull(e),t.prototype.range.call(this,e)},n.get=function(t){return this.getLong(t)},n.getLong=function(t){return requireNonNull(t,"field"),t instanceof ChronoField?this._get0(t):t.getFrom(this)},n._get0=function(t){switch(t){case ChronoField.NANO_OF_SECOND:return this._nano;case ChronoField.NANO_OF_DAY:return this.toNanoOfDay();case ChronoField.MICRO_OF_SECOND:return MathUtil.intDiv(this._nano,1e3);case ChronoField.MICRO_OF_DAY:return MathUtil.intDiv(this.toNanoOfDay(),1e3);case ChronoField.MILLI_OF_SECOND:return MathUtil.intDiv(this._nano,1e6);case ChronoField.MILLI_OF_DAY:return MathUtil.intDiv(this.toNanoOfDay(),1e6);case ChronoField.SECOND_OF_MINUTE:return this._second;case ChronoField.SECOND_OF_DAY:return this.toSecondOfDay();case ChronoField.MINUTE_OF_HOUR:return this._minute;case ChronoField.MINUTE_OF_DAY:return 60*this._hour+this._minute;case ChronoField.HOUR_OF_AMPM:return MathUtil.intMod(this._hour,12);case ChronoField.CLOCK_HOUR_OF_AMPM:var e=MathUtil.intMod(this._hour,12);return e%12==0?12:e;case ChronoField.HOUR_OF_DAY:return this._hour;case ChronoField.CLOCK_HOUR_OF_DAY:return 0===this._hour?24:this._hour;case ChronoField.AMPM_OF_DAY:return MathUtil.intDiv(this._hour,12)}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)},n.hour=function(){return this._hour},n.minute=function(){return this._minute},n.second=function(){return this._second},n.nano=function(){return this._nano},n._withAdjuster=function(n){return requireNonNull(n,"adjuster"),n instanceof e?n:t.prototype._withAdjuster.call(this,n)},n._withField=function(t,n){if(requireNonNull(t,"field"),requireInstance(t,TemporalField,"field"),t instanceof ChronoField){switch(t.checkValidValue(n),t){case ChronoField.NANO_OF_SECOND:return this.withNano(n);case ChronoField.NANO_OF_DAY:return e.ofNanoOfDay(n);case ChronoField.MICRO_OF_SECOND:return this.withNano(1e3*n);case ChronoField.MICRO_OF_DAY:return e.ofNanoOfDay(1e3*n);case ChronoField.MILLI_OF_SECOND:return this.withNano(1e6*n);case ChronoField.MILLI_OF_DAY:return e.ofNanoOfDay(1e6*n);case ChronoField.SECOND_OF_MINUTE:return this.withSecond(n);case ChronoField.SECOND_OF_DAY:return this.plusSeconds(n-this.toSecondOfDay());case ChronoField.MINUTE_OF_HOUR:return this.withMinute(n);case ChronoField.MINUTE_OF_DAY:return this.plusMinutes(n-(60*this._hour+this._minute));case ChronoField.HOUR_OF_AMPM:return this.plusHours(n-MathUtil.intMod(this._hour,12));case ChronoField.CLOCK_HOUR_OF_AMPM:return this.plusHours((12===n?0:n)-MathUtil.intMod(this._hour,12));case ChronoField.HOUR_OF_DAY:return this.withHour(n);case ChronoField.CLOCK_HOUR_OF_DAY:return this.withHour(24===n?0:n);case ChronoField.AMPM_OF_DAY:return this.plusHours(12*(n-MathUtil.intDiv(this._hour,12)))}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.adjustInto(this,n)},n.withHour=function(t){return void 0===t&&(t=0),this._hour===t?this:new e(t,this._minute,this._second,this._nano)},n.withMinute=function(t){return void 0===t&&(t=0),this._minute===t?this:new e(this._hour,t,this._second,this._nano)},n.withSecond=function(t){return void 0===t&&(t=0),this._second===t?this:new e(this._hour,this._minute,t,this._nano)},n.withNano=function(t){return void 0===t&&(t=0),this._nano===t?this:new e(this._hour,this._minute,this._second,t)},n.truncatedTo=function(t){if(requireNonNull(t,"unit"),t===ChronoUnit.NANOS)return this;var n=t.duration();if(n.seconds()>e.SECONDS_PER_DAY)throw new DateTimeException("Unit is too large to be used for truncation");var i=n.toNanos();if(0!==MathUtil.intMod(e.NANOS_PER_DAY,i))throw new DateTimeException("Unit must divide into a standard day without remainder");var o=this.toNanoOfDay();return e.ofNanoOfDay(MathUtil.intDiv(o,i)*i)},n._plusUnit=function(t,n){if(requireNonNull(n,"unit"),n instanceof ChronoUnit){switch(n){case ChronoUnit.NANOS:return this.plusNanos(t);case ChronoUnit.MICROS:return this.plusNanos(1e3*MathUtil.intMod(t,e.MICROS_PER_DAY));case ChronoUnit.MILLIS:return this.plusNanos(1e6*MathUtil.intMod(t,e.MILLIS_PER_DAY));case ChronoUnit.SECONDS:return this.plusSeconds(t);case ChronoUnit.MINUTES:return this.plusMinutes(t);case ChronoUnit.HOURS:return this.plusHours(t);case ChronoUnit.HALF_DAYS:return this.plusHours(12*MathUtil.intMod(t,2))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.addTo(this,t)},n.plusHours=function(t){return 0===t?this:new e(MathUtil.intMod(MathUtil.intMod(t,e.HOURS_PER_DAY)+this._hour+e.HOURS_PER_DAY,e.HOURS_PER_DAY),this._minute,this._second,this._nano)},n.plusMinutes=function(t){if(0===t)return this;var n=this._hour*e.MINUTES_PER_HOUR+this._minute,i=MathUtil.intMod(MathUtil.intMod(t,e.MINUTES_PER_DAY)+n+e.MINUTES_PER_DAY,e.MINUTES_PER_DAY);return n===i?this:new e(MathUtil.intDiv(i,e.MINUTES_PER_HOUR),MathUtil.intMod(i,e.MINUTES_PER_HOUR),this._second,this._nano)},n.plusSeconds=function(t){if(0===t)return this;var n=this._hour*e.SECONDS_PER_HOUR+this._minute*e.SECONDS_PER_MINUTE+this._second,i=MathUtil.intMod(MathUtil.intMod(t,e.SECONDS_PER_DAY)+n+e.SECONDS_PER_DAY,e.SECONDS_PER_DAY);return n===i?this:new e(MathUtil.intDiv(i,e.SECONDS_PER_HOUR),MathUtil.intMod(MathUtil.intDiv(i,e.SECONDS_PER_MINUTE),e.MINUTES_PER_HOUR),MathUtil.intMod(i,e.SECONDS_PER_MINUTE),this._nano)},n.plusNanos=function(t){if(0===t)return this;var n=this.toNanoOfDay(),i=MathUtil.intMod(MathUtil.intMod(t,e.NANOS_PER_DAY)+n+e.NANOS_PER_DAY,e.NANOS_PER_DAY);return n===i?this:new e(MathUtil.intDiv(i,e.NANOS_PER_HOUR),MathUtil.intMod(MathUtil.intDiv(i,e.NANOS_PER_MINUTE),e.MINUTES_PER_HOUR),MathUtil.intMod(MathUtil.intDiv(i,e.NANOS_PER_SECOND),e.SECONDS_PER_MINUTE),MathUtil.intMod(i,e.NANOS_PER_SECOND))},n._minusUnit=function(t,e){return requireNonNull(e,"unit"),this._plusUnit(-1*t,e)},n.minusHours=function(t){return this.plusHours(-1*MathUtil.intMod(t,e.HOURS_PER_DAY))},n.minusMinutes=function(t){return this.plusMinutes(-1*MathUtil.intMod(t,e.MINUTES_PER_DAY))},n.minusSeconds=function(t){return this.plusSeconds(-1*MathUtil.intMod(t,e.SECONDS_PER_DAY))},n.minusNanos=function(t){return this.plusNanos(-1*MathUtil.intMod(t,e.NANOS_PER_DAY))},n.query=function(t){return requireNonNull(t,"query"),t===TemporalQueries.precision()?ChronoUnit.NANOS:t===TemporalQueries.localTime()?this:t===TemporalQueries.chronology()||t===TemporalQueries.zoneId()||t===TemporalQueries.zone()||t===TemporalQueries.offset()||t===TemporalQueries.localDate()?null:t.queryFrom(this)},n.adjustInto=function(t){return t.with(e.NANO_OF_DAY,this.toNanoOfDay())},n.until=function(t,n){requireNonNull(t,"endExclusive"),requireNonNull(n,"unit");var i=e.from(t);if(n instanceof ChronoUnit){var o=i.toNanoOfDay()-this.toNanoOfDay();switch(n){case ChronoUnit.NANOS:return o;case ChronoUnit.MICROS:return MathUtil.intDiv(o,1e3);case ChronoUnit.MILLIS:return MathUtil.intDiv(o,1e6);case ChronoUnit.SECONDS:return MathUtil.intDiv(o,e.NANOS_PER_SECOND);case ChronoUnit.MINUTES:return MathUtil.intDiv(o,e.NANOS_PER_MINUTE);case ChronoUnit.HOURS:return MathUtil.intDiv(o,e.NANOS_PER_HOUR);case ChronoUnit.HALF_DAYS:return MathUtil.intDiv(o,12*e.NANOS_PER_HOUR)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.between(this,i)},n.atDate=function(t){return LocalDateTime.of(t,this)},n.atOffset=function(t){return OffsetTime.of(this,t)},n.toSecondOfDay=function(){var t=this._hour*e.SECONDS_PER_HOUR;return t+=this._minute*e.SECONDS_PER_MINUTE,t+=this._second},n.toNanoOfDay=function(){var t=this._hour*e.NANOS_PER_HOUR;return t+=this._minute*e.NANOS_PER_MINUTE,t+=this._second*e.NANOS_PER_SECOND,t+=this._nano},n.compareTo=function(t){requireNonNull(t,"other"),requireInstance(t,e,"other");var n=MathUtil.compareNumbers(this._hour,t._hour);return 0===n&&0===(n=MathUtil.compareNumbers(this._minute,t._minute))&&0===(n=MathUtil.compareNumbers(this._second,t._second))&&(n=MathUtil.compareNumbers(this._nano,t._nano)),n},n.isAfter=function(t){return this.compareTo(t)>0},n.isBefore=function(t){return this.compareTo(t)<0},n.equals=function(t){return this===t||t instanceof e&&(this._hour===t._hour&&this._minute===t._minute&&this._second===t._second&&this._nano===t._nano)},n.hashCode=function(){var t=this.toNanoOfDay();return MathUtil.hash(t)},n.toString=function(){var t="",e=this._hour,n=this._minute,i=this._second,o=this._nano;return t+=e<10?"0":"",t+=e,t+=n<10?":0":":",t+=n,(i>0||o>0)&&(t+=i<10?":0":":",t+=i,o>0&&(t+=".",0===MathUtil.intMod(o,1e6)?t+=(""+(MathUtil.intDiv(o,1e6)+1e3)).substring(1):0===MathUtil.intMod(o,1e3)?t+=(""+(MathUtil.intDiv(o,1e3)+1e6)).substring(1):t+=(""+(o+1e9)).substring(1))),t},n.toJSON=function(){return this.toString()},n.format=function(t){return requireNonNull(t,"formatter"),t.format(this)},e}(Temporal);function _init$3(){LocalTime.HOURS=[];for(var t=0;t<24;t++)LocalTime.of(t,0,0,0);LocalTime.MIN=LocalTime.HOURS[0],LocalTime.MAX=new LocalTime(23,59,59,999999999),LocalTime.MIDNIGHT=LocalTime.HOURS[0],LocalTime.NOON=LocalTime.HOURS[12],LocalTime.FROM=createTemporalQuery("LocalTime.FROM",(function(t){return LocalTime.from(t)}))}LocalTime.HOURS_PER_DAY=24,LocalTime.MINUTES_PER_HOUR=60,LocalTime.MINUTES_PER_DAY=LocalTime.MINUTES_PER_HOUR*LocalTime.HOURS_PER_DAY,LocalTime.SECONDS_PER_MINUTE=60,LocalTime.SECONDS_PER_HOUR=LocalTime.SECONDS_PER_MINUTE*LocalTime.MINUTES_PER_HOUR,LocalTime.SECONDS_PER_DAY=LocalTime.SECONDS_PER_HOUR*LocalTime.HOURS_PER_DAY,LocalTime.MILLIS_PER_DAY=1e3*LocalTime.SECONDS_PER_DAY,LocalTime.MICROS_PER_DAY=1e6*LocalTime.SECONDS_PER_DAY,LocalTime.NANOS_PER_SECOND=1e9,LocalTime.NANOS_PER_MINUTE=LocalTime.NANOS_PER_SECOND*LocalTime.SECONDS_PER_MINUTE,LocalTime.NANOS_PER_HOUR=LocalTime.NANOS_PER_MINUTE*LocalTime.MINUTES_PER_HOUR,LocalTime.NANOS_PER_DAY=LocalTime.NANOS_PER_HOUR*LocalTime.HOURS_PER_DAY;var NANOS_PER_MILLI=1e6,Instant=function(t){function e(n,i){var o;return o=t.call(this)||this,e._validate(n,i),o._seconds=MathUtil.safeToInt(n),o._nanos=MathUtil.safeToInt(i),o}_inheritsLoose(e,t),e.now=function(t){return void 0===t&&(t=Clock.systemUTC()),t.instant()},e.ofEpochSecond=function(t,n){void 0===n&&(n=0);var i=t+MathUtil.floorDiv(n,LocalTime.NANOS_PER_SECOND),o=MathUtil.floorMod(n,LocalTime.NANOS_PER_SECOND);return e._create(i,o)},e.ofEpochMilli=function(t){var n=MathUtil.floorDiv(t,1e3),i=MathUtil.floorMod(t,1e3);return e._create(n,1e6*i)},e.ofEpochMicro=function(t){var n=MathUtil.floorDiv(t,1e6),i=MathUtil.floorMod(t,1e6);return e._create(n,1e3*i)},e.from=function(t){try{var n=t.getLong(ChronoField.INSTANT_SECONDS),i=t.get(ChronoField.NANO_OF_SECOND);return e.ofEpochSecond(n,i)}catch(e){throw new DateTimeException("Unable to obtain Instant from TemporalAccessor: "+t+", type "+typeof t,e)}},e.parse=function(t){return DateTimeFormatter.ISO_INSTANT.parse(t,e.FROM)},e._create=function(t,n){return 0===t&&0===n?e.EPOCH:new e(t,n)},e._validate=function(t,n){if(t<e.MIN_SECONDS||t>e.MAX_SECONDS)throw new DateTimeException("Instant exceeds minimum or maximum instant");if(n<0||n>LocalTime.NANOS_PER_SECOND)throw new DateTimeException("Instant exceeds minimum or maximum instant")};var n=e.prototype;return n.isSupported=function(t){return t instanceof ChronoField?t===ChronoField.INSTANT_SECONDS||t===ChronoField.NANO_OF_SECOND||t===ChronoField.MICRO_OF_SECOND||t===ChronoField.MILLI_OF_SECOND:t instanceof ChronoUnit?t.isTimeBased()||t===ChronoUnit.DAYS:null!=t&&t.isSupportedBy(this)},n.range=function(e){return t.prototype.range.call(this,e)},n.get=function(t){return this.getLong(t)},n.getLong=function(t){if(t instanceof ChronoField){switch(t){case ChronoField.NANO_OF_SECOND:return this._nanos;case ChronoField.MICRO_OF_SECOND:return MathUtil.intDiv(this._nanos,1e3);case ChronoField.MILLI_OF_SECOND:return MathUtil.intDiv(this._nanos,NANOS_PER_MILLI);case ChronoField.INSTANT_SECONDS:return this._seconds}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.getFrom(this)},n.epochSecond=function(){return this._seconds},n.nano=function(){return this._nanos},n._withField=function(t,n){if(requireNonNull(t,"field"),t instanceof ChronoField){switch(t.checkValidValue(n),t){case ChronoField.MILLI_OF_SECOND:var i=n*NANOS_PER_MILLI;return i!==this._nanos?e._create(this._seconds,i):this;case ChronoField.MICRO_OF_SECOND:var o=1e3*n;return o!==this._nanos?e._create(this._seconds,o):this;case ChronoField.NANO_OF_SECOND:return n!==this._nanos?e._create(this._seconds,n):this;case ChronoField.INSTANT_SECONDS:return n!==this._seconds?e._create(n,this._nanos):this}throw new UnsupportedTemporalTypeException("Unsupported field: "+t)}return t.adjustInto(this,n)},n.truncatedTo=function(t){if(requireNonNull(t,"unit"),t===ChronoUnit.NANOS)return this;var e=t.duration();if(e.seconds()>LocalTime.SECONDS_PER_DAY)throw new DateTimeException("Unit is too large to be used for truncation");var n=e.toNanos();if(0!==MathUtil.intMod(LocalTime.NANOS_PER_DAY,n))throw new DateTimeException("Unit must divide into a standard day without remainder");var i=MathUtil.intMod(this._seconds,LocalTime.SECONDS_PER_DAY)*LocalTime.NANOS_PER_SECOND+this._nanos,o=MathUtil.intDiv(i,n)*n;return this.plusNanos(o-i)},n._plusUnit=function(t,e){if(requireNonNull(t,"amountToAdd"),requireNonNull(e,"unit"),requireInstance(e,TemporalUnit),e instanceof ChronoUnit){switch(e){case ChronoUnit.NANOS:return this.plusNanos(t);case ChronoUnit.MICROS:return this.plusMicros(t);case ChronoUnit.MILLIS:return this.plusMillis(t);case ChronoUnit.SECONDS:return this.plusSeconds(t);case ChronoUnit.MINUTES:return this.plusSeconds(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_MINUTE));case ChronoUnit.HOURS:return this.plusSeconds(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_HOUR));case ChronoUnit.HALF_DAYS:return this.plusSeconds(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_DAY/2));case ChronoUnit.DAYS:return this.plusSeconds(MathUtil.safeMultiply(t,LocalTime.SECONDS_PER_DAY))}throw new UnsupportedTemporalTypeException("Unsupported unit: "+e)}return e.addTo(this,t)},n.plusSeconds=function(t){return this._plus(t,0)},n.plusMillis=function(t){return this._plus(MathUtil.intDiv(t,1e3),MathUtil.intMod(t,1e3)*NANOS_PER_MILLI)},n.plusNanos=function(t){return this._plus(0,t)},n.plusMicros=function(t){return this._plus(MathUtil.intDiv(t,1e6),1e3*MathUtil.intMod(t,1e6))},n._plus=function(t,n){if(0===t&&0===n)return this;var i=this._seconds+t;i+=MathUtil.intDiv(n,LocalTime.NANOS_PER_SECOND);var o=this._nanos+n%LocalTime.NANOS_PER_SECOND;return e.ofEpochSecond(i,o)},n._minusUnit=function(t,e){return this._plusUnit(-1*t,e)},n.minusSeconds=function(t){return this.plusSeconds(-1*t)},n.minusMillis=function(t){return this.plusMillis(-1*t)},n.minusNanos=function(t){return this.plusNanos(-1*t)},n.minusMicros=function(t){return this.plusMicros(-1*t)},n.query=function(t){return requireNonNull(t,"query"),t===TemporalQueries.precision()?ChronoUnit.NANOS:t===TemporalQueries.localDate()||t===TemporalQueries.localTime()||t===TemporalQueries.chronology()||t===TemporalQueries.zoneId()||t===TemporalQueries.zone()||t===TemporalQueries.offset()?null:t.queryFrom(this)},n.adjustInto=function(t){return requireNonNull(t,"temporal"),t.with(ChronoField.INSTANT_SECONDS,this._seconds).with(ChronoField.NANO_OF_SECOND,this._nanos)},n.until=function(t,n){requireNonNull(t,"endExclusive"),requireNonNull(n,"unit");var i=e.from(t);if(n instanceof ChronoUnit){switch(n){case ChronoUnit.NANOS:return this._nanosUntil(i);case ChronoUnit.MICROS:return this._microsUntil(i);case ChronoUnit.MILLIS:return MathUtil.safeSubtract(i.toEpochMilli(),this.toEpochMilli());case ChronoUnit.SECONDS:return this._secondsUntil(i);case ChronoUnit.MINUTES:return MathUtil.intDiv(this._secondsUntil(i),LocalTime.SECONDS_PER_MINUTE);case ChronoUnit.HOURS:return MathUtil.intDiv(this._secondsUntil(i),LocalTime.SECONDS_PER_HOUR);case ChronoUnit.HALF_DAYS:return MathUtil.intDiv(this._secondsUntil(i),12*LocalTime.SECONDS_PER_HOUR);case ChronoUnit.DAYS:return MathUtil.intDiv(this._secondsUntil(i),LocalTime.SECONDS_PER_DAY)}throw new UnsupportedTemporalTypeException("Unsupported unit: "+n)}return n.between(this,i)},n._microsUntil=function(t){var e=MathUtil.safeSubtract(t.epochSecond(),this.epochSecond()),n=MathUtil.safeMultiply(e,1e6);return MathUtil.safeAdd(n,MathUtil.intDiv(t.nano()-this.nano(),1e3))},n._nanosUntil=function(t){var e=MathUtil.safeSubtract(t.epochSecond(),this.epochSecond()),n=MathUtil.safeMultiply(e,LocalTime.NANOS_PER_SECOND);return MathUtil.safeAdd(n,t.nano()-this.nano())},n._secondsUntil=function(t){var e=MathUtil.safeSubtract(t.epochSecond(),this.epochSecond()),n=t.nano()-this.nano();return e>0&&n<0?e--:e<0&&n>0&&e++,e},n.atOffset=function(t){return OffsetDateTime.ofInstant(this,t)},n.atZone=function(t){return ZonedDateTime.ofInstant(this,t)},n.toEpochMilli=function(){return MathUtil.safeMultiply(this._seconds,1e3)+MathUtil.intDiv(this._nanos,NANOS_PER_MILLI)},n.compareTo=function(t){requireNonNull(t,"otherInstant"),requireInstance(t,e,"otherInstant");var n=MathUtil.compareNumbers(this._seconds,t._seconds);return 0!==n?n:this._nanos-t._nanos},n.isAfter=function(t){return this.compareTo(t)>0},n.isBefore=function(t){return this.compareTo(t)<0},n.equals=function(t){return this===t||t instanceof e&&(this.epochSecond()===t.epochSecond()&&this.nano()===t.nano())},n.hashCode=function(){return MathUtil.hashCode(this._seconds,this._nanos)},n.toString=function(){return DateTimeFormatter.ISO_INSTANT.format(this)},n.toJSON=function(){return this.toString()},e}(Temporal);function _init$2(){Instant.MIN_SECONDS=-31619119219200,Instant.MAX_SECONDS=31494816403199,Instant.EPOCH=new Instant(0,0),Instant.MIN=Instant.ofEpochSecond(Instant.MIN_SECONDS,0),Instant.MAX=Instant.ofEpochSecond(Instant.MAX_SECONDS,999999999),Instant.FROM=createTemporalQuery("Instant.FROM",(function(t){return Instant.from(t)}))}var Clock=function(){function t(){}t.systemUTC=function(){return new SystemClock(ZoneOffset.UTC)},t.systemDefaultZone=function(){return new SystemClock(ZoneId.systemDefault())},t.system=function(t){return new SystemClock(t)},t.fixed=function(t,e){return new FixedClock(t,e)},t.offset=function(t,e){return new OffsetClock(t,e)};var e=t.prototype;return e.millis=function(){abstractMethodFail("Clock.millis")},e.instant=function(){abstractMethodFail("Clock.instant")},e.zone=function(){abstractMethodFail("Clock.zone")},e.withZone=function(){abstractMethodFail("Clock.withZone")},t}(),SystemClock=function(t){function e(e){var n;return requireNonNull(e,"zone"),(n=t.call(this)||this)._zone=e,n}_inheritsLoose(e,t);var n=e.prototype;return n.zone=function(){return this._zone},n.millis=function(){return(new Date).getTime()},n.instant=function(){return Instant.ofEpochMilli(this.millis())},n.equals=function(t){return t instanceof e&&this._zone.equals(t._zone)},n.withZone=function(t){return t.equals(this._zone)?this:new e(t)},n.toString=function(){return"SystemClock["+this._zone.toString()+"]"},e}(Clock),FixedClock=function(t){function e(e,n){var i;return(i=t.call(this)||this)._instant=e,i._zoneId=n,i}_inheritsLoose(e,t);var n=e.prototype;return n.instant=function(){return this._instant},n.millis=function(){return this._instant.toEpochMilli()},n.zone=function(){return this._zoneId},n.toString=function(){return"FixedClock[]"},n.equals=function(t){return t instanceof e&&(this._instant.equals(t._instant)&&this._zoneId.equals(t._zoneId))},n.withZone=function(t){return t.equals(this._zoneId)?this:new e(this._instant,t)},e}(Clock),OffsetClock=function(t){function e(e,n){var i;return(i=t.call(this)||this)._baseClock=e,i._offset=n,i}_inheritsLoose(e,t);var n=e.prototype;return n.zone=function(){return this._baseClock.zone()},n.withZone=function(t){return t.equals(this._baseClock.zone())?this:new e(this._baseClock.withZone(t),this._offset)},n.millis=function(){return this._baseClock.millis()+this._offset.toMillis()},n.instant=function(){return this._baseClock.instant().plus(this._offset)},n.equals=function(t){return t instanceof e&&(this._baseClock.equals(t._baseClock)&&this._offset.equals(t._offset))},n.toString=function(){return"OffsetClock["+this._baseClock+","+this._offset+"]"},e}(Clock),ZoneOffsetTransition=function(){function t(t,e,n){if(requireNonNull(t,"transition"),requireNonNull(e,"offsetBefore"),requireNonNull(n,"offsetAfter"),e.equals(n))throw new IllegalArgumentException("Offsets must not be equal");if(0!==t.nano())throw new IllegalArgumentException("Nano-of-second must be zero");this._transition=t instanceof LocalDateTime?t:LocalDateTime.ofEpochSecond(t,0,e),this._offsetBefore=e,this._offsetAfter=n}t.of=function(e,n,i){return new t(e,n,i)};var e=t.prototype;return e.instant=function(){return this._transition.toInstant(this._offsetBefore)},e.toEpochSecond=function(){return this._transition.toEpochSecond(this._offsetBefore)},e.dateTimeBefore=function(){return this._transition},e.dateTimeAfter=function(){return this._transition.plusSeconds(this.durationSeconds())},e.offsetBefore=function(){return this._offsetBefore},e.offsetAfter=function(){return this._offsetAfter},e.duration=function(){return Duration.ofSeconds(this.durationSeconds())},e.durationSeconds=function(){return this._offsetAfter.totalSeconds()-this._offsetBefore.totalSeconds()},e.isGap=function(){return this._offsetAfter.totalSeconds()>this._offsetBefore.totalSeconds()},e.isOverlap=function(){return this._offsetAfter.totalSeconds()<this._offsetBefore.totalSeconds()},e.isValidOffset=function(t){return!this.isGap()&&(this._offsetBefore.equals(t)||this._offsetAfter.equals(t))},e.validOffsets=function(){return this.isGap()?[]:[this._offsetBefore,this._offsetAfter]},e.compareTo=function(t){return this.instant().compareTo(t.instant())},e.equals=function(e){if(e===this)return!0;if(e instanceof t){var n=e;return this._transition.equals(n._transition)&&this._offsetBefore.equals(n.offsetBefore())&&this._offsetAfter.equals(n.offsetAfter())}return!1},e.hashCode=function(){return this._transition.hashCode()^this._offsetBefore.hashCode()^this._offsetAfter.hashCode()>>>16},e.toString=function(){return"Transition["+(this.isGap()?"Gap":"Overlap")+" at "+this._transition.toString()+this._offsetBefore.toString()+" to "+this._offsetAfter+"]"},t}();
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
function _init$1(){TemporalQueries.ZONE_ID=createTemporalQuery("ZONE_ID",(function(t){return t.query(TemporalQueries.ZONE_ID)})),TemporalQueries.CHRONO=createTemporalQuery("CHRONO",(function(t){return t.query(TemporalQueries.CHRONO)})),TemporalQueries.PRECISION=createTemporalQuery("PRECISION",(function(t){return t.query(TemporalQueries.PRECISION)})),TemporalQueries.OFFSET=createTemporalQuery("OFFSET",(function(t){return t.isSupported(ChronoField.OFFSET_SECONDS)?ZoneOffset.ofTotalSeconds(t.get(ChronoField.OFFSET_SECONDS)):null})),TemporalQueries.ZONE=createTemporalQuery("ZONE",(function(t){var e=t.query(TemporalQueries.ZONE_ID);return null!=e?e:t.query(TemporalQueries.OFFSET)})),TemporalQueries.LOCAL_DATE=createTemporalQuery("LOCAL_DATE",(function(t){return t.isSupported(ChronoField.EPOCH_DAY)?LocalDate.ofEpochDay(t.getLong(ChronoField.EPOCH_DAY)):null})),TemporalQueries.LOCAL_TIME=createTemporalQuery("LOCAL_TIME",(function(t){return t.isSupported(ChronoField.NANO_OF_DAY)?LocalTime.ofNanoOfDay(t.getLong(ChronoField.NANO_OF_DAY)):null}))}var SystemDefaultZoneRules=function(t){function e(){return t.apply(this,arguments)||this}_inheritsLoose(e,t);var n=e.prototype;return n.isFixedOffset=function(){return!1},n.offsetOfInstant=function(t){var e=new Date(t.toEpochMilli()).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*e)},n.offsetOfEpochMilli=function(t){var e=new Date(t).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*e)},n.offsetOfLocalDateTime=function(t){var e=1e3*t.toEpochSecond(ZoneOffset.UTC),n=new Date(e).getTimezoneOffset(),i=new Date(e+6e4*n).getTimezoneOffset();return ZoneOffset.ofTotalMinutes(-1*i)},n.validOffsets=function(t){return[this.offsetOfLocalDateTime(t)]},n.transition=function(){return null},n.standardOffset=function(t){return this.offsetOfInstant(t)},n.daylightSavings=function(){this._throwNotSupported()},n.isDaylightSavings=function(){this._throwNotSupported()},n.isValidOffset=function(t,e){return this.offsetOfLocalDateTime(t).equals(e)},n.nextTransition=function(){this._throwNotSupported()},n.previousTransition=function(){this._throwNotSupported()},n.transitions=function(){this._throwNotSupported()},n.transitionRules=function(){this._throwNotSupported()},n._throwNotSupported=function(){throw new DateTimeException("not supported operation")},n.equals=function(t){return this===t||t instanceof e},n.toString=function(){return"SYSTEM"},e}(ZoneRules),SystemDefaultZoneId=function(t){function e(){var e;return(e=t.call(this)||this)._rules=new SystemDefaultZoneRules,e}_inheritsLoose(e,t);var n=e.prototype;return n.rules=function(){return this._rules},n.equals=function(t){return this===t},n.id=function(){return"SYSTEM"},e}(ZoneId),ZoneIdFactory=function(){function t(){}return t.systemDefault=function(){return SYSTEM_DEFAULT_ZONE_ID_INSTANCE},t.getAvailableZoneIds=function(){return ZoneRulesProvider.getAvailableZoneIds()},t.of=function(t){if(requireNonNull(t,"zoneId"),"Z"===t)return ZoneOffset.UTC;if(1===t.length)throw new DateTimeException("Invalid zone: "+t);if(StringUtil.startsWith(t,"+")||StringUtil.startsWith(t,"-"))return ZoneOffset.of(t);if("UTC"===t||"GMT"===t||"GMT0"===t||"UT"===t)return new ZoneRegion(t,ZoneOffset.UTC.rules());if(StringUtil.startsWith(t,"UTC+")||StringUtil.startsWith(t,"GMT+")||StringUtil.startsWith(t,"UTC-")||StringUtil.startsWith(t,"GMT-")){var e=ZoneOffset.of(t.substring(3));return 0===e.totalSeconds()?new ZoneRegion(t.substring(0,3),e.rules()):new ZoneRegion(t.substring(0,3)+e.id(),e.rules())}if(StringUtil.startsWith(t,"UT+")||StringUtil.startsWith(t,"UT-")){var n=ZoneOffset.of(t.substring(2));return 0===n.totalSeconds()?new ZoneRegion("UT",n.rules()):new ZoneRegion("UT"+n.id(),n.rules())}return"SYSTEM"===t?ZoneId.systemDefault():ZoneRegion.ofId(t)},t.ofOffset=function(t,e){if(requireNonNull(t,"prefix"),requireNonNull(e,"offset"),0===t.length)return e;if("GMT"===t||"UTC"===t||"UT"===t)return 0===e.totalSeconds()?new ZoneRegion(t,e.rules()):new ZoneRegion(t+e.id(),e.rules());throw new IllegalArgumentException("Invalid prefix, must be GMT, UTC or UT: "+t)},t.from=function(t){requireNonNull(t,"temporal");var e=t.query(TemporalQueries.zone());if(null==e)throw new DateTimeException("Unable to obtain ZoneId from TemporalAccessor: "+t+", type "+(null!=t.constructor?t.constructor.name:""));return e},t}(),SYSTEM_DEFAULT_ZONE_ID_INSTANCE=null;function _init(){SYSTEM_DEFAULT_ZONE_ID_INSTANCE=new SystemDefaultZoneId,ZoneId.systemDefault=ZoneIdFactory.systemDefault,ZoneId.getAvailableZoneIds=ZoneIdFactory.getAvailableZoneIds,ZoneId.of=ZoneIdFactory.of,ZoneId.ofOffset=ZoneIdFactory.ofOffset,ZoneId.from=ZoneIdFactory.from,ZoneOffset.from=ZoneIdFactory.from,ZoneId.SYSTEM=SYSTEM_DEFAULT_ZONE_ID_INSTANCE,ZoneId.UTC=ZoneOffset.ofTotalSeconds(0)}
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var isInit=!1;function init(){isInit||(isInit=!0,_init$m(),_init$n(),_init$l(),_init$k(),_init$3(),_init$f(),_init$1(),_init$j(),_init$2(),_init$5(),_init$4(),_init$a(),_init$i(),_init$b(),_init$c(),_init$h(),_init$g(),_init$7(),_init(),_init$9(),_init$d(),_init$e(),_init$6(),_init$8())}init();
/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
var ToNativeJsConverter=function(){function t(t,e){var n;if(t instanceof Instant)this.instant=t;else{if(t instanceof LocalDate)e=null==e?ZoneId.systemDefault():e,n=t.atStartOfDay(e);else if(t instanceof LocalDateTime)e=null==e?ZoneId.systemDefault():e,n=t.atZone(e);else{if(!(t instanceof ZonedDateTime))throw new IllegalArgumentException("unsupported instance for convert operation:"+t);n=null==e?t:t.withZoneSameInstant(e)}this.instant=n.toInstant()}}var e=t.prototype;return e.toDate=function(){return new Date(this.instant.toEpochMilli())},e.toEpochMilli=function(){return this.instant.toEpochMilli()},t}();function convert(t,e){return new ToNativeJsConverter(t,e)}
/*
 * @copyright (c) 2015-present, Philipp Thürwächter, Pattrick Hüper & js-joda contributors
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */function nativeJs(t,e){if(void 0===e&&(e=ZoneId.systemDefault()),requireNonNull(t,"date"),requireNonNull(e,"zone"),t instanceof Date)return Instant.ofEpochMilli(t.getTime()).atZone(e);if("function"==typeof t.toDate&&t.toDate()instanceof Date)return Instant.ofEpochMilli(t.toDate().getTime()).atZone(e);throw new IllegalArgumentException("date must be a javascript Date or a moment instance")}function bindUse(t){var e=[];return function(n){return~e.indexOf(n)||(n(t),e.push(n)),t}}
/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */var _={assert:assert$1,DateTimeBuilder:DateTimeBuilder,DateTimeParseContext:DateTimeParseContext,DateTimePrintContext:DateTimePrintContext,MathUtil:MathUtil,StringUtil:StringUtil,StringBuilder:StringBuilder},jsJodaExports={_:_,convert:convert,nativeJs:nativeJs,ArithmeticException:ArithmeticException,DateTimeException:DateTimeException,DateTimeParseException:DateTimeParseException,IllegalArgumentException:IllegalArgumentException,IllegalStateException:IllegalStateException,UnsupportedTemporalTypeException:UnsupportedTemporalTypeException,NullPointerException:NullPointerException,Clock:Clock,DayOfWeek:DayOfWeek,Duration:Duration,Instant:Instant,LocalDate:LocalDate,LocalTime:LocalTime,LocalDateTime:LocalDateTime,OffsetTime:OffsetTime,OffsetDateTime:OffsetDateTime,Month:Month,MonthDay:MonthDay,ParsePosition:ParsePosition,Period:Period,Year:Year,YearConstants:YearConstants,YearMonth:YearMonth,ZonedDateTime:ZonedDateTime,ZoneOffset:ZoneOffset,ZoneId:ZoneId,ZoneRegion:ZoneRegion,ZoneOffsetTransition:ZoneOffsetTransition,ZoneRules:ZoneRules,ZoneRulesProvider:ZoneRulesProvider,ChronoLocalDate:ChronoLocalDate,ChronoLocalDateTime:ChronoLocalDateTime,ChronoZonedDateTime:ChronoZonedDateTime,IsoChronology:IsoChronology,ChronoField:ChronoField,ChronoUnit:ChronoUnit,IsoFields:IsoFields,Temporal:Temporal,TemporalAccessor:TemporalAccessor,TemporalAdjuster:TemporalAdjuster,TemporalAdjusters:TemporalAdjusters,TemporalAmount:TemporalAmount,TemporalField:TemporalField,TemporalQueries:TemporalQueries,TemporalQuery:TemporalQuery,TemporalUnit:TemporalUnit,ValueRange:ValueRange,DateTimeFormatter:DateTimeFormatter,DateTimeFormatterBuilder:DateTimeFormatterBuilder,DecimalStyle:DecimalStyle,ResolverStyle:ResolverStyle,SignStyle:SignStyle,TextStyle:TextStyle},use=bindUse(jsJodaExports);jsJodaExports.use=use,exports.ArithmeticException=ArithmeticException,exports.ChronoField=ChronoField,exports.ChronoLocalDate=ChronoLocalDate,exports.ChronoLocalDateTime=ChronoLocalDateTime,exports.ChronoUnit=ChronoUnit,exports.ChronoZonedDateTime=ChronoZonedDateTime,exports.Clock=Clock,exports.DateTimeException=DateTimeException,exports.DateTimeFormatter=DateTimeFormatter,exports.DateTimeFormatterBuilder=DateTimeFormatterBuilder,exports.DateTimeParseException=DateTimeParseException,exports.DayOfWeek=DayOfWeek,exports.DecimalStyle=DecimalStyle,exports.Duration=Duration,exports.IllegalArgumentException=IllegalArgumentException,exports.IllegalStateException=IllegalStateException,exports.Instant=Instant,exports.IsoChronology=IsoChronology,exports.IsoFields=IsoFields,exports.LocalDate=LocalDate,exports.LocalDateTime=LocalDateTime,exports.LocalTime=LocalTime,exports.Month=Month,exports.MonthDay=MonthDay,exports.NullPointerException=NullPointerException,exports.OffsetDateTime=OffsetDateTime,exports.OffsetTime=OffsetTime,exports.ParsePosition=ParsePosition,exports.Period=Period,exports.ResolverStyle=ResolverStyle,exports.SignStyle=SignStyle,exports.Temporal=Temporal,exports.TemporalAccessor=TemporalAccessor,exports.TemporalAdjuster=TemporalAdjuster,exports.TemporalAdjusters=TemporalAdjusters,exports.TemporalAmount=TemporalAmount,exports.TemporalField=TemporalField,exports.TemporalQueries=TemporalQueries,exports.TemporalQuery=TemporalQuery,exports.TemporalUnit=TemporalUnit,exports.TextStyle=TextStyle,exports.UnsupportedTemporalTypeException=UnsupportedTemporalTypeException,exports.ValueRange=ValueRange,exports.Year=Year,exports.YearConstants=YearConstants,exports.YearMonth=YearMonth,exports.ZoneId=ZoneId,exports.ZoneOffset=ZoneOffset,exports.ZoneOffsetTransition=ZoneOffsetTransition,exports.ZoneRegion=ZoneRegion,exports.ZoneRules=ZoneRules,exports.ZoneRulesProvider=ZoneRulesProvider,exports.ZonedDateTime=ZonedDateTime,exports._=_,exports.convert=convert,exports.nativeJs=nativeJs,exports.use=use;