/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{abstractMethodFail,requireNonNull}from"./assert";import{Instant}from"./Instant";import{ZoneId}from"./ZoneId";import{ZoneOffset}from"./ZoneOffset";export class Clock{static systemUTC(){return new SystemClock(ZoneOffset.UTC)}static systemDefaultZone(){return new SystemClock(ZoneId.systemDefault())}static system(t){return new SystemClock(t)}static fixed(t,e){return new FixedClock(t,e)}static offset(t,e){return new OffsetClock(t,e)}millis(){abstractMethodFail("Clock.millis")}instant(){abstractMethodFail("Clock.instant")}zone(){abstractMethodFail("Clock.zone")}withZone(){abstractMethodFail("Clock.withZone")}}class SystemClock extends Clock{constructor(t){requireNonNull(t,"zone"),super(),this._zone=t}zone(){return this._zone}millis(){return(new Date).getTime()}instant(){return Instant.ofEpochMilli(this.millis())}equals(t){return t instanceof SystemClock&&this._zone.equals(t._zone)}withZone(t){return t.equals(this._zone)?this:new SystemClock(t)}toString(){return`SystemClock[${this._zone.toString()}]`}}class FixedClock extends Clock{constructor(t,e){super(),this._instant=t,this._zoneId=e}instant(){return this._instant}millis(){return this._instant.toEpochMilli()}zone(){return this._zoneId}toString(){return"FixedClock[]"}equals(t){return t instanceof FixedClock&&(this._instant.equals(t._instant)&&this._zoneId.equals(t._zoneId))}withZone(t){return t.equals(this._zoneId)?this:new FixedClock(this._instant,t)}}class OffsetClock extends Clock{constructor(t,e){super(),this._baseClock=t,this._offset=e}zone(){return this._baseClock.zone()}withZone(t){return t.equals(this._baseClock.zone())?this:new OffsetClock(this._baseClock.withZone(t),this._offset)}millis(){return this._baseClock.millis()+this._offset.toMillis()}instant(){return this._baseClock.instant().plus(this._offset)}equals(t){return t instanceof OffsetClock&&(this._baseClock.equals(t._baseClock)&&this._offset.equals(t._offset))}toString(){return`OffsetClock[${this._baseClock},${this._offset}]`}}