/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{DateTimeException,UnsupportedTemporalTypeException,NullPointerException}from"./errors";import{MathUtil}from"./MathUtil";import{assert,requireNonNull,requireInstance}from"./assert";import{ChronoField}from"./temporal/ChronoField";import{ChronoUnit}from"./temporal/ChronoUnit";import{IllegalArgumentException}from"./errors";import{TemporalAccessor}from"./temporal/TemporalAccessor";import{TemporalQueries}from"./temporal/TemporalQueries";import{createTemporalQuery}from"./temporal/TemporalQuery";export class DayOfWeek extends TemporalAccessor{constructor(e,r){super(),this._ordinal=e,this._name=r}ordinal(){return this._ordinal}name(){return this._name}static values(){return ENUMS.slice()}static valueOf(e){let r=0;for(;r<ENUMS.length&&ENUMS[r].name()!==e;r++);return DayOfWeek.of(r+1)}static of(e){if(e<1||e>7)throw new DateTimeException(`Invalid value for DayOfWeek: ${e}`);return ENUMS[e-1]}static from(e){if(assert(null!=e,"temporal",NullPointerException),e instanceof DayOfWeek)return e;try{return DayOfWeek.of(e.get(ChronoField.DAY_OF_WEEK))}catch(r){throw r instanceof DateTimeException?new DateTimeException(`Unable to obtain DayOfWeek from TemporalAccessor: ${e}, type ${null!=e.constructor?e.constructor.name:""}`,r):r}}value(){return this._ordinal+1}displayName(e,r){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")}isSupported(e){return e instanceof ChronoField?e===ChronoField.DAY_OF_WEEK:null!=e&&e.isSupportedBy(this)}range(e){if(e===ChronoField.DAY_OF_WEEK)return e.range();if(e instanceof ChronoField)throw new UnsupportedTemporalTypeException(`Unsupported field: ${e}`);return e.rangeRefinedBy(this)}get(e){return e===ChronoField.DAY_OF_WEEK?this.value():this.range(e).checkValidIntValue(this.getLong(e),e)}getLong(e){if(e===ChronoField.DAY_OF_WEEK)return this.value();if(e instanceof ChronoField)throw new UnsupportedTemporalTypeException(`Unsupported field: ${e}`);return e.getFrom(this)}plus(e){const r=MathUtil.floorMod(e,7);return ENUMS[MathUtil.floorMod(this._ordinal+(r+7),7)]}minus(e){return this.plus(-1*MathUtil.floorMod(e,7))}query(e){return e===TemporalQueries.precision()?ChronoUnit.DAYS:e===TemporalQueries.localDate()||e===TemporalQueries.localTime()||e===TemporalQueries.chronology()||e===TemporalQueries.zone()||e===TemporalQueries.zoneId()||e===TemporalQueries.offset()?null:(assert(null!=e,"query",NullPointerException),e.queryFrom(this))}adjustInto(e){return requireNonNull(e,"temporal"),e.with(ChronoField.DAY_OF_WEEK,this.value())}equals(e){return this===e}toString(){return this._name}compareTo(e){return requireNonNull(e,"other"),requireInstance(e,DayOfWeek,"other"),this._ordinal-e._ordinal}toJSON(){return this.toString()}}let ENUMS;export function _init(){DayOfWeek.MONDAY=new DayOfWeek(0,"MONDAY"),DayOfWeek.TUESDAY=new DayOfWeek(1,"TUESDAY"),DayOfWeek.WEDNESDAY=new DayOfWeek(2,"WEDNESDAY"),DayOfWeek.THURSDAY=new DayOfWeek(3,"THURSDAY"),DayOfWeek.FRIDAY=new DayOfWeek(4,"FRIDAY"),DayOfWeek.SATURDAY=new DayOfWeek(5,"SATURDAY"),DayOfWeek.SUNDAY=new DayOfWeek(6,"SUNDAY"),DayOfWeek.FROM=createTemporalQuery("DayOfWeek.FROM",(e=>DayOfWeek.from(e))),ENUMS=[DayOfWeek.MONDAY,DayOfWeek.TUESDAY,DayOfWeek.WEDNESDAY,DayOfWeek.THURSDAY,DayOfWeek.FRIDAY,DayOfWeek.SATURDAY,DayOfWeek.SUNDAY]}