/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{ArithmeticException}from"./errors";export const MAX_SAFE_INTEGER=9007199254740991;export const MIN_SAFE_INTEGER=-9007199254740991;export class MathUtil{static intDiv(t,i){let e=t/i;return e=MathUtil.roundDown(e),MathUtil.safeZero(e)}static intMod(t,i){let e=t-MathUtil.intDiv(t,i)*i;return e=MathUtil.roundDown(e),MathUtil.safeZero(e)}static roundDown(t){return t<0?Math.ceil(t):Math.floor(t)}static floorDiv(t,i){const e=Math.floor(t/i);return MathUtil.safeZero(e)}static floorMod(t,i){const e=t-MathUtil.floorDiv(t,i)*i;return MathUtil.safeZero(e)}static safeAdd(t,i){if(MathUtil.verifyInt(t),MathUtil.verifyInt(i),0===t)return MathUtil.safeZero(i);if(0===i)return MathUtil.safeZero(t);const e=MathUtil.safeToInt(t+i);if(e===t||e===i)throw new ArithmeticException("Invalid addition beyond MAX_SAFE_INTEGER!");return e}static safeSubtract(t,i){return MathUtil.verifyInt(t),MathUtil.verifyInt(i),0===t&&0===i?0:0===t?MathUtil.safeZero(-1*i):0===i?MathUtil.safeZero(t):MathUtil.safeToInt(t-i)}static safeMultiply(t,i){if(MathUtil.verifyInt(t),MathUtil.verifyInt(i),1===t)return MathUtil.safeZero(i);if(1===i)return MathUtil.safeZero(t);if(0===t||0===i)return 0;const e=MathUtil.safeToInt(t*i);if(e/i!==t||t===MIN_SAFE_INTEGER&&-1===i||i===MIN_SAFE_INTEGER&&-1===t)throw new ArithmeticException(`Multiplication overflows: ${t} * ${i}`);return e}static parseInt(t){const i=parseInt(t);return MathUtil.safeToInt(i)}static safeToInt(t){return MathUtil.verifyInt(t),MathUtil.safeZero(t)}static verifyInt(t){if(null==t)throw new ArithmeticException(`Invalid value: '${t}', using null or undefined as argument`);if(isNaN(t))throw new ArithmeticException("Invalid int value, using NaN as argument");if(t%1!=0)throw new ArithmeticException(`Invalid value: '${t}' is a float`);if(t>9007199254740991||t<MIN_SAFE_INTEGER)throw new ArithmeticException(`Calculation overflows an int: ${t}`)}static safeZero(t){return 0===t?0:+t}static compareNumbers(t,i){return t<i?-1:t>i?1:0}static smi(t){return t>>>1&1073741824|3221225471&t}static hash(t){if(t!=t||t===1/0)return 0;let i=t;for(;t>4294967295;)i^=t/=4294967295;return MathUtil.smi(i)}static hashCode(...t){let i=17;for(const e of t)i=(i<<5)-i+MathUtil.hash(e);return MathUtil.hash(i)}}MathUtil.MAX_SAFE_INTEGER=9007199254740991,MathUtil.MIN_SAFE_INTEGER=MIN_SAFE_INTEGER;