/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert,requireNonNull,requireInstance}from"./assert";import{MathUtil}from"./MathUtil";import{ChronoField}from"./temporal/ChronoField";import{ChronoUnit}from"./temporal/ChronoUnit";import{DateTimeException,IllegalArgumentException,UnsupportedTemporalTypeException}from"./errors";import{IsoChronology}from"./chrono/IsoChronology";import{TemporalAccessor}from"./temporal/TemporalAccessor";import{TemporalQueries}from"./temporal/TemporalQueries";export class Month extends TemporalAccessor{constructor(t,e){super(),this._value=MathUtil.safeToInt(t),this._name=e}value(){return this._value}ordinal(){return this._value-1}name(){return this._name}displayName(t,e){throw new IllegalArgumentException("Pattern using (localized) text not implemented yet!")}isSupported(t){return null!==t&&(t instanceof ChronoField?t===ChronoField.MONTH_OF_YEAR:null!=t&&t.isSupportedBy(this))}get(t){return t===ChronoField.MONTH_OF_YEAR?this.value():this.range(t).checkValidIntValue(this.getLong(t),t)}getLong(t){if(t===ChronoField.MONTH_OF_YEAR)return this.value();if(t instanceof ChronoField)throw new UnsupportedTemporalTypeException(`Unsupported field: ${t}`);return t.getFrom(this)}plus(t){const e=MathUtil.intMod(t,12)+12;let n=MathUtil.intMod(this.value()+e,12);return n=0===n?12:n,Month.of(n)}minus(t){return this.plus(-1*MathUtil.intMod(t,12))}length(t){switch(this){case Month.FEBRUARY:return t?29:28;case Month.APRIL:case Month.JUNE:case Month.SEPTEMBER:case Month.NOVEMBER:return 30;default:return 31}}minLength(){switch(this){case Month.FEBRUARY:return 28;case Month.APRIL:case Month.JUNE:case Month.SEPTEMBER:case Month.NOVEMBER:return 30;default:return 31}}maxLength(){switch(this){case Month.FEBRUARY:return 29;case Month.APRIL:case Month.JUNE:case Month.SEPTEMBER:case Month.NOVEMBER:return 30;default:return 31}}firstDayOfYear(t){const e=t?1:0;switch(this){case Month.JANUARY:return 1;case Month.FEBRUARY:return 32;case Month.MARCH:return 60+e;case Month.APRIL:return 91+e;case Month.MAY:return 121+e;case Month.JUNE:return 152+e;case Month.JULY:return 182+e;case Month.AUGUST:return 213+e;case Month.SEPTEMBER:return 244+e;case Month.OCTOBER:return 274+e;case Month.NOVEMBER:return 305+e;case Month.DECEMBER:default:return 335+e}}firstMonthOfQuarter(){switch(this){case Month.JANUARY:case Month.FEBRUARY:case Month.MARCH:return Month.JANUARY;case Month.APRIL:case Month.MAY:case Month.JUNE:return Month.APRIL;case Month.JULY:case Month.AUGUST:case Month.SEPTEMBER:return Month.JULY;case Month.OCTOBER:case Month.NOVEMBER:case Month.DECEMBER:default:return Month.OCTOBER}}query(t){return assert(null!=t,"query() parameter must not be null",DateTimeException),t===TemporalQueries.chronology()?IsoChronology.INSTANCE:t===TemporalQueries.precision()?ChronoUnit.MONTHS:super.query(t)}toString(){switch(this){case Month.JANUARY:return"JANUARY";case Month.FEBRUARY:return"FEBRUARY";case Month.MARCH:return"MARCH";case Month.APRIL:return"APRIL";case Month.MAY:return"MAY";case Month.JUNE:return"JUNE";case Month.JULY:return"JULY";case Month.AUGUST:return"AUGUST";case Month.SEPTEMBER:return"SEPTEMBER";case Month.OCTOBER:return"OCTOBER";case Month.NOVEMBER:return"NOVEMBER";case Month.DECEMBER:return"DECEMBER";default:return`unknown Month, value: ${this.value()}`}}toJSON(){return this.toString()}adjustInto(t){return t.with(ChronoField.MONTH_OF_YEAR,this.value())}compareTo(t){return requireNonNull(t,"other"),requireInstance(t,Month,"other"),this._value-t._value}equals(t){return this===t}static valueOf(t){let e=0;for(;e<MONTHS.length&&MONTHS[e].name()!==t;e++);return Month.of(e+1)}static values(){return MONTHS.slice()}static of(t){return(t<1||t>12)&&assert(!1,`Invalid value for MonthOfYear: ${t}`,DateTimeException),MONTHS[t-1]}static from(t){if(t instanceof Month)return t;try{return Month.of(t.get(ChronoField.MONTH_OF_YEAR))}catch(e){throw new DateTimeException(`Unable to obtain Month from TemporalAccessor: ${t} of type ${t&&null!=t.constructor?t.constructor.name:""}`,e)}}}let MONTHS;export function _init(){Month.JANUARY=new Month(1,"JANUARY"),Month.FEBRUARY=new Month(2,"FEBRUARY"),Month.MARCH=new Month(3,"MARCH"),Month.APRIL=new Month(4,"APRIL"),Month.MAY=new Month(5,"MAY"),Month.JUNE=new Month(6,"JUNE"),Month.JULY=new Month(7,"JULY"),Month.AUGUST=new Month(8,"AUGUST"),Month.SEPTEMBER=new Month(9,"SEPTEMBER"),Month.OCTOBER=new Month(10,"OCTOBER"),Month.NOVEMBER=new Month(11,"NOVEMBER"),Month.DECEMBER=new Month(12,"DECEMBER"),MONTHS=[Month.JANUARY,Month.FEBRUARY,Month.MARCH,Month.APRIL,Month.MAY,Month.JUNE,Month.JULY,Month.AUGUST,Month.SEPTEMBER,Month.OCTOBER,Month.NOVEMBER,Month.DECEMBER]}