/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"./assert";import{DateTimeException,IllegalArgumentException}from"./errors";import{StringUtil}from"./StringUtil";import{ZoneOffset}from"./ZoneOffset";import{ZoneRegion}from"./ZoneRegion";import{ZoneId}from"./ZoneId";import{TemporalQueries}from"./temporal/TemporalQueries";import{SystemDefaultZoneId}from"./zone/SystemDefaultZoneId";import{ZoneRulesProvider}from"./zone/ZoneRulesProvider";export class ZoneIdFactory{static systemDefault(){return SYSTEM_DEFAULT_ZONE_ID_INSTANCE}static getAvailableZoneIds(){return ZoneRulesProvider.getAvailableZoneIds()}static of(e){if(requireNonNull(e,"zoneId"),"Z"===e)return ZoneOffset.UTC;if(1===e.length)throw new DateTimeException(`Invalid zone: ${e}`);if(StringUtil.startsWith(e,"+")||StringUtil.startsWith(e,"-"))return ZoneOffset.of(e);if("UTC"===e||"GMT"===e||"GMT0"===e||"UT"===e)return new ZoneRegion(e,ZoneOffset.UTC.rules());if(StringUtil.startsWith(e,"UTC+")||StringUtil.startsWith(e,"GMT+")||StringUtil.startsWith(e,"UTC-")||StringUtil.startsWith(e,"GMT-")){const t=ZoneOffset.of(e.substring(3));return 0===t.totalSeconds()?new ZoneRegion(e.substring(0,3),t.rules()):new ZoneRegion(e.substring(0,3)+t.id(),t.rules())}if(StringUtil.startsWith(e,"UT+")||StringUtil.startsWith(e,"UT-")){const t=ZoneOffset.of(e.substring(2));return 0===t.totalSeconds()?new ZoneRegion("UT",t.rules()):new ZoneRegion(`UT${t.id()}`,t.rules())}return"SYSTEM"===e?ZoneId.systemDefault():ZoneRegion.ofId(e)}static ofOffset(e,t){if(requireNonNull(e,"prefix"),requireNonNull(t,"offset"),0===e.length)return t;if("GMT"===e||"UTC"===e||"UT"===e)return 0===t.totalSeconds()?new ZoneRegion(e,t.rules()):new ZoneRegion(e+t.id(),t.rules());throw new IllegalArgumentException(`Invalid prefix, must be GMT, UTC or UT: ${e}`)}static from(e){requireNonNull(e,"temporal");const t=e.query(TemporalQueries.zone());if(null==t)throw new DateTimeException(`Unable to obtain ZoneId from TemporalAccessor: ${e}, type ${null!=e.constructor?e.constructor.name:""}`);return t}}let SYSTEM_DEFAULT_ZONE_ID_INSTANCE=null;export function _init(){SYSTEM_DEFAULT_ZONE_ID_INSTANCE=new SystemDefaultZoneId,ZoneId.systemDefault=ZoneIdFactory.systemDefault,ZoneId.getAvailableZoneIds=ZoneIdFactory.getAvailableZoneIds,ZoneId.of=ZoneIdFactory.of,ZoneId.ofOffset=ZoneIdFactory.ofOffset,ZoneId.from=ZoneIdFactory.from,ZoneOffset.from=ZoneIdFactory.from,ZoneId.SYSTEM=SYSTEM_DEFAULT_ZONE_ID_INSTANCE,ZoneId.UTC=ZoneOffset.ofTotalSeconds(0)}