/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../assert";import{Instant}from"../Instant";import{LocalDate}from"../LocalDate";import{MathUtil}from"../MathUtil";import{ChronoUnit}from"../temporal/ChronoUnit";import{Temporal}from"../temporal/Temporal";import{TemporalQueries}from"../temporal/TemporalQueries";export class ChronoZonedDateTime extends Temporal{query(o){return o===TemporalQueries.zoneId()||o===TemporalQueries.zone()?this.zone():o===TemporalQueries.chronology()?this.toLocalDate().chronology():o===TemporalQueries.precision()?ChronoUnit.NANOS:o===TemporalQueries.offset()?this.offset():o===TemporalQueries.localDate()?LocalDate.ofEpochDay(this.toLocalDate().toEpochDay()):o===TemporalQueries.localTime()?this.toLocalTime():super.query(o)}format(o){return requireNonNull(o,"formatter"),o.format(this)}toInstant(){return Instant.ofEpochSecond(this.toEpochSecond(),this.toLocalTime().nano())}toEpochSecond(){let o=86400*this.toLocalDate().toEpochDay()+this.toLocalTime().toSecondOfDay();return o-=this.offset().totalSeconds(),o}compareTo(o){requireNonNull(o,"other");let e=MathUtil.compareNumbers(this.toEpochSecond(),o.toEpochSecond());return 0===e&&(e=this.toLocalTime().nano()-o.toLocalTime().nano(),0===e&&(e=this.toLocalDateTime().compareTo(o.toLocalDateTime()),0===e&&(e=strcmp(this.zone().id(),o.zone().id())))),e}isAfter(o){requireNonNull(o,"other");const e=this.toEpochSecond(),t=o.toEpochSecond();return e>t||e===t&&this.toLocalTime().nano()>o.toLocalTime().nano()}isBefore(o){requireNonNull(o,"other");const e=this.toEpochSecond(),t=o.toEpochSecond();return e<t||e===t&&this.toLocalTime().nano()<o.toLocalTime().nano()}isEqual(o){return requireNonNull(o,"other"),this.toEpochSecond()===o.toEpochSecond()&&this.toLocalTime().nano()===o.toLocalTime().nano()}equals(o){return this===o||o instanceof ChronoZonedDateTime&&0===this.compareTo(o)}}function strcmp(o,e){return o<e?-1:o>e?1:0}