/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert,requireNonNull}from"../assert";import{DateTimeParseException,NullPointerException}from"../errors";import{Period}from"../Period";import{ParsePosition}from"./ParsePosition";import{DateTimeBuilder}from"./DateTimeBuilder";import{DateTimeParseContext}from"./DateTimeParseContext";import{DateTimePrintContext}from"./DateTimePrintContext";import{DateTimeFormatterBuilder}from"./DateTimeFormatterBuilder";import{SignStyle}from"./SignStyle";import{StringBuilder}from"./StringBuilder";import{ResolverStyle}from"./ResolverStyle";import{IsoChronology}from"../chrono/IsoChronology";import{ChronoField}from"../temporal/ChronoField";import{createTemporalQuery}from"../temporal/TemporalQuery";export class DateTimeFormatter{static parsedExcessDays(){return DateTimeFormatter.PARSED_EXCESS_DAYS}static parsedLeapSecond(){return DateTimeFormatter.PARSED_LEAP_SECOND}static ofPattern(e){return(new DateTimeFormatterBuilder).appendPattern(e).toFormatter()}constructor(e,t,r,o,a,i=IsoChronology.INSTANCE,n){assert(null!=e),assert(null!=r),assert(null!=o),this._printerParser=e,this._locale=t,this._decimalStyle=r,this._resolverStyle=o,this._resolverFields=a,this._chrono=i,this._zone=n}locale(){return this._locale}decimalStyle(){return this._decimalStyle}chronology(){return this._chrono}withChronology(e){return null!=this._chrono&&this._chrono.equals(e)?this:new DateTimeFormatter(this._printerParser,this._locale,this._decimalStyle,this._resolverStyle,this._resolverFields,e,this._zone)}withLocale(){return this}withResolverStyle(e){return requireNonNull(e,"resolverStyle"),e.equals(this._resolverStyle)?this:new DateTimeFormatter(this._printerParser,this._locale,this._decimalStyle,e,this._resolverFields,this._chrono,this._zone)}format(e){const t=new StringBuilder(32);return this._formatTo(e,t),t.toString()}_formatTo(e,t){requireNonNull(e,"temporal"),requireNonNull(t,"appendable");const r=new DateTimePrintContext(e,this);this._printerParser.print(r,t)}parse(e,t){return 1===arguments.length?this.parse1(e):this.parse2(e,t)}parse1(e){requireNonNull(e,"text");try{return this._parseToBuilder(e,null).resolve(this._resolverStyle,this._resolverFields)}catch(t){throw t instanceof DateTimeParseException?t:this._createError(e,t)}}parse2(e,t){requireNonNull(e,"text"),requireNonNull(t,"type");try{return this._parseToBuilder(e,null).resolve(this._resolverStyle,this._resolverFields).build(t)}catch(t){throw t instanceof DateTimeParseException?t:this._createError(e,t)}}_createError(e,t){let r="";return r=e.length>64?`${e.substring(0,64)}...`:e,new DateTimeParseException(`Text '${r}' could not be parsed: ${t.message}`,e,0,t)}_parseToBuilder(e,t){const r=null!=t?t:new ParsePosition(0),o=this._parseUnresolved0(e,r);if(null==o||r.getErrorIndex()>=0||null==t&&r.getIndex()<e.length){let t="";throw t=e.length>64?`${e.substr(0,64).toString()}...`:e,r.getErrorIndex()>=0?new DateTimeParseException(`Text '${t}' could not be parsed at index ${r.getErrorIndex()}`,e,r.getErrorIndex()):new DateTimeParseException(`Text '${t}' could not be parsed, unparsed text found at index ${r.getIndex()}`,e,r.getIndex())}return o.toBuilder()}parseUnresolved(e,t){return this._parseUnresolved0(e,t)}_parseUnresolved0(e,t){assert(null!=e,"text",NullPointerException),assert(null!=t,"position",NullPointerException);const r=new DateTimeParseContext(this);let o=t.getIndex();return o=this._printerParser.parse(r,e,o),o<0?(t.setErrorIndex(~o),null):(t.setIndex(o),r.toParsed())}_toPrinterParser(e){return this._printerParser.withOptional(e)}toString(){const e=this._printerParser.toString();return 0===e.indexOf("[")?e:e.substring(1,e.length-1)}}export function _init(){DateTimeFormatter.ISO_LOCAL_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.MONTH_OF_YEAR,2).appendLiteral("-").appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_LOCAL_TIME=(new DateTimeFormatterBuilder).appendValue(ChronoField.HOUR_OF_DAY,2).appendLiteral(":").appendValue(ChronoField.MINUTE_OF_HOUR,2).optionalStart().appendLiteral(":").appendValue(ChronoField.SECOND_OF_MINUTE,2).optionalStart().appendFraction(ChronoField.NANO_OF_SECOND,0,9,!0).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_LOCAL_DATE_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).appendLiteral("T").append(DateTimeFormatter.ISO_LOCAL_TIME).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_INSTANT=(new DateTimeFormatterBuilder).parseCaseInsensitive().appendInstant().toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_OFFSET_DATE_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE_TIME).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_ZONED_DATE_TIME=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_OFFSET_DATE_TIME).optionalStart().appendLiteral("[").parseCaseSensitive().appendZoneId().appendLiteral("]").toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.BASIC_ISO_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendValue(ChronoField.MONTH_OF_YEAR,2).appendValue(ChronoField.DAY_OF_MONTH,2).toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_OFFSET_DATE=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_OFFSET_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_TIME).appendOffsetId().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_ORDINAL_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-").appendValue(ChronoField.DAY_OF_YEAR).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_WEEK_DATE=(new DateTimeFormatterBuilder).appendValue(ChronoField.YEAR,4,10,SignStyle.EXCEEDS_PAD).appendLiteral("-W").appendValue(ChronoField.ALIGNED_WEEK_OF_YEAR).appendLiteral("-").appendValue(ChronoField.DAY_OF_WEEK).toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_DATE=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_DATE).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.ISO_TIME=(new DateTimeFormatterBuilder).parseCaseInsensitive().append(DateTimeFormatter.ISO_LOCAL_TIME).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT),DateTimeFormatter.ISO_DATE_TIME=(new DateTimeFormatterBuilder).append(DateTimeFormatter.ISO_LOCAL_DATE_TIME).optionalStart().appendOffsetId().optionalEnd().toFormatter(ResolverStyle.STRICT).withChronology(IsoChronology.INSTANCE),DateTimeFormatter.PARSED_EXCESS_DAYS=createTemporalQuery("PARSED_EXCESS_DAYS",(e=>e instanceof DateTimeBuilder?e.excessDays:Period.ZERO)),DateTimeFormatter.PARSED_LEAP_SECOND=createTemporalQuery("PARSED_LEAP_SECOND",(e=>e instanceof DateTimeBuilder&&e.leapSecond))}