/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert,requireNonNull}from"../assert";import{DateTimeBuilder}from"./DateTimeBuilder";import{EnumMap}from"./EnumMap";import{IsoChronology}from"../chrono/IsoChronology";import{Temporal}from"../temporal/Temporal";import{TemporalQueries}from"../temporal/TemporalQueries";export class DateTimeParseContext{constructor(){if(1===arguments.length){if(arguments[0]instanceof DateTimeParseContext)return void this._constructorSelf.apply(this,arguments);this._constructorFormatter.apply(this,arguments)}else this._constructorParam.apply(this,arguments);this._caseSensitive=!0,this._strict=!0,this._parsed=[new Parsed(this)]}_constructorParam(e,t,s){this._locale=e,this._symbols=t,this._overrideChronology=s}_constructorFormatter(e){this._locale=e.locale(),this._symbols=e.decimalStyle(),this._overrideChronology=e.chronology()}_constructorSelf(e){this._locale=e._locale,this._symbols=e._symbols,this._overrideChronology=e._overrideChronology,this._overrideZone=e._overrideZone,this._caseSensitive=e._caseSensitive,this._strict=e._strict,this._parsed=[new Parsed(this)]}copy(){return new DateTimeParseContext(this)}symbols(){return this._symbols}isStrict(){return this._strict}setStrict(e){this._strict=e}locale(){return this._locale}setLocale(e){this._locale=e}startOptional(){this._parsed.push(this.currentParsed().copy())}endOptional(e){e?this._parsed.splice(this._parsed.length-2,1):this._parsed.splice(this._parsed.length-1,1)}isCaseSensitive(){return this._caseSensitive}setCaseSensitive(e){this._caseSensitive=e}subSequenceEquals(e,t,s,r,o){if(t+o>e.length||r+o>s.length)return!1;this.isCaseSensitive()||(e=e.toLowerCase(),s=s.toLowerCase());for(let i=0;i<o;i++){if(e[t+i]!==s[r+i])return!1}return!0}charEquals(e,t){return this.isCaseSensitive()?e===t:this.charEqualsIgnoreCase(e,t)}charEqualsIgnoreCase(e,t){return e===t||e.toLowerCase()===t.toLowerCase()}setParsedField(e,t,s,r){const o=this.currentParsed().fieldValues,i=o.get(e);return o.set(e,t),null!=i&&i!==t?~s:r}setParsedZone(e){requireNonNull(e,"zone"),this.currentParsed().zone=e}getParsed(e){return this.currentParsed().fieldValues.get(e)}toParsed(){return this.currentParsed()}currentParsed(){return this._parsed[this._parsed.length-1]}setParsedLeapSecond(){this.currentParsed().leapSecond=!0}getEffectiveChronology(){let e=this.currentParsed().chrono;return null==e&&(e=this._overrideChronology,null==e&&(e=IsoChronology.INSTANCE)),e}}class Parsed extends Temporal{constructor(e){super(),this.chrono=null,this.zone=null,this.fieldValues=new EnumMap,this.leapSecond=!1,this.dateTimeParseContext=e}copy(){const e=new Parsed;return e.chrono=this.chrono,e.zone=this.zone,e.fieldValues.putAll(this.fieldValues),e.leapSecond=this.leapSecond,e.dateTimeParseContext=this.dateTimeParseContext,e}toString(){return`${this.fieldValues}, ${this.chrono}, ${this.zone}`}isSupported(e){return this.fieldValues.containsKey(e)}get(e){const t=this.fieldValues.get(e);return assert(null!=t),t}query(e){return e===TemporalQueries.chronology()?this.chrono:e===TemporalQueries.zoneId()||e===TemporalQueries.zone()?this.zone:super.query(e)}toBuilder(){const e=new DateTimeBuilder;return e.fieldValues.putAll(this.fieldValues),e.chrono=this.dateTimeParseContext.getEffectiveChronology(),null!=this.zone?e.zone=this.zone:e.zone=this.overrideZone,e.leapSecond=this.leapSecond,e.excessDays=this.excessDays,e}}