/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../../assert";import{IllegalArgumentException}from"../../errors";import{MathUtil}from"../../MathUtil";export class FractionPrinterParser{constructor(t,i,e,r){if(requireNonNull(t,"field"),!1===t.range().isFixed())throw new IllegalArgumentException(`Field must have a fixed set of values: ${t}`);if(i<0||i>9)throw new IllegalArgumentException(`Minimum width must be from 0 to 9 inclusive but was ${i}`);if(e<1||e>9)throw new IllegalArgumentException(`Maximum width must be from 1 to 9 inclusive but was ${e}`);if(e<i)throw new IllegalArgumentException(`Maximum width must exceed or equal the minimum width but ${e} < ${i}`);this.field=t,this.minWidth=i,this.maxWidth=e,this.decimalPoint=r}print(t,i){const e=t.getValue(this.field);if(null===e)return!1;const r=t.symbols();if(0===e){if(this.minWidth>0){this.decimalPoint&&i.append(r.decimalSeparator());for(let t=0;t<this.minWidth;t++)i.append(r.zeroDigit())}}else{let t=this.convertToFraction(e,r.zeroDigit());const n=Math.min(Math.max(t.length,this.minWidth),this.maxWidth);if(t=t.substr(0,n),1*t>0)for(;t.length>this.minWidth&&"0"===t[t.length-1];)t=t.substr(0,t.length-1);let o=t;o=r.convertNumberToI18N(o),this.decimalPoint&&i.append(r.decimalSeparator()),i.append(o)}return!0}parse(t,i,e){const r=t.isStrict()?this.minWidth:0,n=t.isStrict()?this.maxWidth:9,o=i.length;if(e===o)return r>0?~e:e;if(this.decimalPoint){if(i[e]!==t.symbols().decimalSeparator())return r>0?~e:e;e++}const s=e+r;if(s>o)return~e;const l=Math.min(e+n,o);let m=0,a=e;for(;a<l;){const r=i.charAt(a++),n=t.symbols().convertToDigit(r);if(n<0){if(a<s)return~e;a--;break}m=10*m+n}const h=a-e,c=Math.pow(10,h),u=this.convertFromFraction(m,c);return t.setParsedField(this.field,u,e,a)}convertToFraction(t,i){const e=this.field.range();e.checkValidValue(t,this.field);const r=e.minimum(),n=e.maximum()-r+1,o=t-r;let s=`${MathUtil.intDiv(1e9*o,n)}`;for(;s.length<9;)s=i+s;return s}convertFromFraction(t,i){const e=this.field.range(),r=e.minimum(),n=e.maximum()-r+1;return MathUtil.intDiv(t*n,i)}toString(){const t=this.decimalPoint?",DecimalPoint":"";return`Fraction(${this.field},${this.minWidth},${this.maxWidth}${t})`}}