/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../../assert";import{IllegalArgumentException}from"../../errors";import{MathUtil}from"../../MathUtil";import{ChronoField}from"../../temporal/ChronoField";const PATTERNS=["+HH","+HHmm","+HH:mm","+HHMM","+HH:MM","+HHMMss","+HH:MM:ss","+HHMMSS","+HH:MM:SS"];export class OffsetIdPrinterParser{constructor(t,e){requireNonNull(t,"noOffsetText"),requireNonNull(e,"pattern"),this.noOffsetText=t,this.type=this._checkPattern(e)}_checkPattern(t){for(let e=0;e<PATTERNS.length;e++)if(PATTERNS[e]===t)return e;throw new IllegalArgumentException(`Invalid zone offset pattern: ${t}`)}print(t,e){const r=t.getValue(ChronoField.OFFSET_SECONDS);if(null==r)return!1;const n=MathUtil.safeToInt(r);if(0===n)e.append(this.noOffsetText);else{const t=Math.abs(MathUtil.intMod(MathUtil.intDiv(n,3600),100)),r=Math.abs(MathUtil.intMod(MathUtil.intDiv(n,60),60)),i=Math.abs(MathUtil.intMod(n,60)),s=e.length();let a=t;e.append(n<0?"-":"+").appendChar(`${MathUtil.intDiv(t,10)}0`).appendChar(`${MathUtil.intMod(t,10)}0`),(this.type>=3||this.type>=1&&r>0)&&(e.append(this.type%2==0?":":"").appendChar(`${MathUtil.intDiv(r,10)}0`).appendChar(r%10+"0"),a+=r,(this.type>=7||this.type>=5&&i>0)&&(e.append(this.type%2==0?":":"").appendChar(`${MathUtil.intDiv(i,10)}0`).appendChar(i%10+"0"),a+=i)),0===a&&(e.setLength(s),e.append(this.noOffsetText))}return!0}parse(t,e,r){const n=e.length,i=this.noOffsetText.length;if(0===i){if(r===n)return t.setParsedField(ChronoField.OFFSET_SECONDS,0,r,r)}else{if(r===n)return~r;if(t.subSequenceEquals(e,r,this.noOffsetText,0,i))return t.setParsedField(ChronoField.OFFSET_SECONDS,0,r,r+i)}const s=e[r];if("+"===s||"-"===s){const n="-"===s?-1:1,i=[0,0,0,0];if(i[0]=r+1,!1===(this._parseNumber(i,1,e,!0)||this._parseNumber(i,2,e,this.type>=3)||this._parseNumber(i,3,e,!1))){const e=MathUtil.safeZero(n*(3600*i[1]+60*i[2]+i[3]));return t.setParsedField(ChronoField.OFFSET_SECONDS,e,r,i[0])}}return 0===i?t.setParsedField(ChronoField.OFFSET_SECONDS,0,r,r+i):~r}_parseNumber(t,e,r,n){if((this.type+3)/2<e)return!1;let i=t[0];if(this.type%2==0&&e>1){if(i+1>r.length||":"!==r[i])return n;i++}if(i+2>r.length)return n;const s=r[i++],a=r[i++];if(s<"0"||s>"9"||a<"0"||a>"9")return n;const o=10*(s.charCodeAt(0)-48)+(a.charCodeAt(0)-48);return o<0||o>59?n:(t[e]=o,t[0]=i,!1)}toString(){const t=this.noOffsetText.replace("'","''");return`Offset(${PATTERNS[this.type]},'${t}')`}}OffsetIdPrinterParser.INSTANCE_ID=new OffsetIdPrinterParser("Z","+HH:MM:ss"),OffsetIdPrinterParser.PATTERNS=PATTERNS;