/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{ZoneOffset}from"../../ZoneOffset";import{ZoneId}from"../../ZoneId";import{ZoneRegion}from"../../ZoneRegion";import{ChronoField}from"../../temporal/ChronoField";import{ZoneRulesProvider}from"../../zone/ZoneRulesProvider";import{OffsetIdPrinterParser}from"./OffsetIdPrinterParser";export class ZoneIdPrinterParser{constructor(e,r){this.query=e,this.description=r}print(e,r){const t=e.getValueQuery(this.query);return null!=t&&(r.append(t.id()),!0)}parse(e,r,t){const s=r.length;if(t>s)return~t;if(t===s)return~t;const n=r.charAt(t);if("+"===n||"-"===n){const s=e.copy(),n=OffsetIdPrinterParser.INSTANCE_ID.parse(s,r,t);if(n<0)return n;const o=s.getParsed(ChronoField.OFFSET_SECONDS),a=ZoneOffset.ofTotalSeconds(o);return e.setParsedZone(a),n}if(s>=t+2){const o=r.charAt(t+1);if(e.charEquals(n,"U")&&e.charEquals(o,"T"))return s>=t+3&&e.charEquals(r.charAt(t+2),"C")?this._parsePrefixedOffset(e,r,t,t+3):this._parsePrefixedOffset(e,r,t,t+2);if(e.charEquals(n,"G")&&s>=t+3&&e.charEquals(o,"M")&&e.charEquals(r.charAt(t+2),"T"))return this._parsePrefixedOffset(e,r,t,t+3)}if("SYSTEM"===r.substr(t,6))return e.setParsedZone(ZoneId.systemDefault()),t+6;if(e.charEquals(n,"Z"))return e.setParsedZone(ZoneOffset.UTC),t+1;const o=ZoneRulesProvider.getAvailableZoneIds();zoneIdTree.size!==o.length&&(zoneIdTree=ZoneIdTree.createTreeMap(o));const a=s-t;let i=zoneIdTree.treeMap,f=null,d=0;for(;null!=i;){const e=r.substr(t,Math.min(i.length,a));i=i.get(e),null!=i&&i.isLeaf&&(f=e,d=i.length)}return null!=f?(e.setParsedZone(ZoneRegion.ofId(f)),t+d):~t}_parsePrefixedOffset(e,r,t,s){const n=r.substring(t,s).toUpperCase(),o=e.copy();if(s<r.length&&e.charEquals(r.charAt(s),"Z"))return e.setParsedZone(ZoneId.ofOffset(n,ZoneOffset.UTC)),s;const a=OffsetIdPrinterParser.INSTANCE_ID.parse(o,r,s);if(a<0)return e.setParsedZone(ZoneId.ofOffset(n,ZoneOffset.UTC)),s;const i=o.getParsed(ChronoField.OFFSET_SECONDS),f=ZoneOffset.ofTotalSeconds(i);return e.setParsedZone(ZoneId.ofOffset(n,f)),a}toString(){return this.description}}class ZoneIdTree{static createTreeMap(e){const r=e.sort(((e,r)=>e.length-r.length)),t=new ZoneIdTreeMap(r[0].length,!1);for(let e=0;e<r.length;e++)t.add(r[e]);return new ZoneIdTree(r.length,t)}constructor(e,r){this.size=e,this.treeMap=r}}class ZoneIdTreeMap{constructor(e=0,r=!1){this.length=e,this.isLeaf=r,this._treeMap={}}add(e){const r=e.length;if(r===this.length)this._treeMap[e]=new ZoneIdTreeMap(r,!0);else if(r>this.length){const t=e.substr(0,this.length);let s=this._treeMap[t];null==s&&(s=new ZoneIdTreeMap(r,!1),this._treeMap[t]=s),s.add(e)}}get(e){return this._treeMap[e]}}let zoneIdTree=new ZoneIdTree([]);