/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{MathUtil}from"../MathUtil";import{Duration}from"../Duration";import{YearConstants}from"../YearConstants";import{TemporalUnit}from"./TemporalUnit";export class ChronoUnit extends TemporalUnit{constructor(n,o){super(),this._name=n,this._duration=o}duration(){return this._duration}isDurationEstimated(){return this.isDateBased()||this===ChronoUnit.FOREVER}isDateBased(){return this.compareTo(ChronoUnit.DAYS)>=0&&this!==ChronoUnit.FOREVER}isTimeBased(){return this.compareTo(ChronoUnit.DAYS)<0}isSupportedBy(n){if(this===ChronoUnit.FOREVER)return!1;try{return n.plus(1,this),!0}catch(o){try{return n.plus(-1,this),!0}catch(n){return!1}}}addTo(n,o){return n.plus(o,this)}between(n,o){return n.until(o,this)}toString(){return this._name}compareTo(n){return this.duration().compareTo(n.duration())}}export function _init(){ChronoUnit.NANOS=new ChronoUnit("Nanos",Duration.ofNanos(1)),ChronoUnit.MICROS=new ChronoUnit("Micros",Duration.ofNanos(1e3)),ChronoUnit.MILLIS=new ChronoUnit("Millis",Duration.ofNanos(1e6)),ChronoUnit.SECONDS=new ChronoUnit("Seconds",Duration.ofSeconds(1)),ChronoUnit.MINUTES=new ChronoUnit("Minutes",Duration.ofSeconds(60)),ChronoUnit.HOURS=new ChronoUnit("Hours",Duration.ofSeconds(3600)),ChronoUnit.HALF_DAYS=new ChronoUnit("HalfDays",Duration.ofSeconds(43200)),ChronoUnit.DAYS=new ChronoUnit("Days",Duration.ofSeconds(86400)),ChronoUnit.WEEKS=new ChronoUnit("Weeks",Duration.ofSeconds(604800)),ChronoUnit.MONTHS=new ChronoUnit("Months",Duration.ofSeconds(2629746)),ChronoUnit.YEARS=new ChronoUnit("Years",Duration.ofSeconds(31556952)),ChronoUnit.DECADES=new ChronoUnit("Decades",Duration.ofSeconds(315569520)),ChronoUnit.CENTURIES=new ChronoUnit("Centuries",Duration.ofSeconds(3155695200)),ChronoUnit.MILLENNIA=new ChronoUnit("Millennia",Duration.ofSeconds(31556952e3)),ChronoUnit.ERAS=new ChronoUnit("Eras",Duration.ofSeconds(31556952*(YearConstants.MAX_VALUE+1))),ChronoUnit.FOREVER=new ChronoUnit("Forever",Duration.ofSeconds(MathUtil.MAX_SAFE_INTEGER,999999999))}