/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert,abstractMethodFail,requireInstance,requireNonNull}from"../assert";import{IllegalArgumentException}from"../errors";import{TemporalAccessor}from"./TemporalAccessor";import{TemporalAmount}from"./TemporalAmount";import{TemporalUnit}from"./TemporalUnit";export class Temporal extends TemporalAccessor{isSupported(t){abstractMethodFail("isSupported")}minus(t,e){return arguments.length<2?this._minusAmount(t):this._minusUnit(t,e)}_minusAmount(t){return requireNonNull(t,"amount"),requireInstance(t,TemporalAmount,"amount"),t.subtractFrom(this)}_minusUnit(t,e){return requireNonNull(t,"amountToSubtract"),requireNonNull(e,"unit"),requireInstance(e,TemporalUnit,"unit"),this._plusUnit(-t,e)}plus(t,e){return arguments.length<2?this._plusAmount(t):this._plusUnit(t,e)}_plusAmount(t){return requireNonNull(t,"amount"),requireInstance(t,TemporalAmount,"amount"),t.addTo(this)}_plusUnit(t,e){abstractMethodFail("_plusUnit")}until(t,e){abstractMethodFail("until")}with(t,e){return arguments.length<2?this._withAdjuster(t):this._withField(t,e)}_withAdjuster(t){return requireNonNull(t,"adjuster"),assert("function"==typeof t.adjustInto,"adjuster must be a TemporalAdjuster",IllegalArgumentException),t.adjustInto(this)}_withField(t,e){abstractMethodFail("_withField")}}"undefined"!=typeof Symbol&&Symbol.toPrimitive&&(Temporal.prototype[Symbol.toPrimitive]=function(t){if("number"!==t)return this.toString();throw new TypeError("A conversion from Temporal to a number is not allowed. To compare use the methods .equals(), .compareTo(), .isBefore() or one that is more suitable to your use case.")});