/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../assert";import{IllegalStateException}from"../errors";import{TemporalAdjuster}from"./TemporalAdjuster";import{ChronoField}from"../temporal/ChronoField";import{ChronoUnit}from"../temporal/ChronoUnit";import{MathUtil}from"../MathUtil";export class TemporalAdjusters{static firstDayOfMonth(){return Impl.FIRST_DAY_OF_MONTH}static lastDayOfMonth(){return Impl.LAST_DAY_OF_MONTH}static firstDayOfNextMonth(){return Impl.FIRST_DAY_OF_NEXT_MONTH}static firstDayOfYear(){return Impl.FIRST_DAY_OF_YEAR}static lastDayOfYear(){return Impl.LAST_DAY_OF_YEAR}static firstDayOfNextYear(){return Impl.FIRST_DAY_OF_NEXT_YEAR}static firstInMonth(e){return requireNonNull(e,"dayOfWeek"),new DayOfWeekInMonth(1,e)}static lastInMonth(e){return requireNonNull(e,"dayOfWeek"),new DayOfWeekInMonth(-1,e)}static dayOfWeekInMonth(e,t){return requireNonNull(t,"dayOfWeek"),new DayOfWeekInMonth(e,t)}static next(e){return new RelativeDayOfWeek(2,e)}static nextOrSame(e){return new RelativeDayOfWeek(0,e)}static previous(e){return new RelativeDayOfWeek(3,e)}static previousOrSame(e){return new RelativeDayOfWeek(1,e)}}class Impl extends TemporalAdjuster{constructor(e){super(),this._ordinal=e}adjustInto(e){switch(this._ordinal){case 0:return e.with(ChronoField.DAY_OF_MONTH,1);case 1:return e.with(ChronoField.DAY_OF_MONTH,e.range(ChronoField.DAY_OF_MONTH).maximum());case 2:return e.with(ChronoField.DAY_OF_MONTH,1).plus(1,ChronoUnit.MONTHS);case 3:return e.with(ChronoField.DAY_OF_YEAR,1);case 4:return e.with(ChronoField.DAY_OF_YEAR,e.range(ChronoField.DAY_OF_YEAR).maximum());case 5:return e.with(ChronoField.DAY_OF_YEAR,1).plus(1,ChronoUnit.YEARS)}throw new IllegalStateException("Unreachable")}}Impl.FIRST_DAY_OF_MONTH=new Impl(0),Impl.LAST_DAY_OF_MONTH=new Impl(1),Impl.FIRST_DAY_OF_NEXT_MONTH=new Impl(2),Impl.FIRST_DAY_OF_YEAR=new Impl(3),Impl.LAST_DAY_OF_YEAR=new Impl(4),Impl.FIRST_DAY_OF_NEXT_YEAR=new Impl(5);class DayOfWeekInMonth extends TemporalAdjuster{constructor(e,t){super(),this._ordinal=e,this._dowValue=t.value()}adjustInto(e){if(this._ordinal>=0){const t=e.with(ChronoField.DAY_OF_MONTH,1),r=t.get(ChronoField.DAY_OF_WEEK);let n=MathUtil.intMod(this._dowValue-r+7,7);return n+=7*(this._ordinal-1),t.plus(n,ChronoUnit.DAYS)}{const t=e.with(ChronoField.DAY_OF_MONTH,e.range(ChronoField.DAY_OF_MONTH).maximum()),r=t.get(ChronoField.DAY_OF_WEEK);let n=this._dowValue-r;return n=0===n?0:n>0?n-7:n,n-=7*(-this._ordinal-1),t.plus(n,ChronoUnit.DAYS)}}}class RelativeDayOfWeek extends TemporalAdjuster{constructor(e,t){super(),requireNonNull(t,"dayOfWeek"),this._relative=e,this._dowValue=t.value()}adjustInto(e){const t=e.get(ChronoField.DAY_OF_WEEK);if(this._relative<2&&t===this._dowValue)return e;if(0==(1&this._relative)){const r=t-this._dowValue;return e.plus(r>=0?7-r:-r,ChronoUnit.DAYS)}{const r=this._dowValue-t;return e.minus(r>=0?7-r:-r,ChronoUnit.DAYS)}}}