/**
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{assert}from"../assert";import{DateTimeException,IllegalArgumentException}from"../errors";import{MathUtil}from"../MathUtil";export class ValueRange{constructor(t,e,i,a){assert(!(t>e),`Smallest minimum value '${t}' must be less than largest minimum value '${e}'`,IllegalArgumentException),assert(!(i>a),`Smallest maximum value '${i}' must be less than largest maximum value '${a}'`,IllegalArgumentException),assert(!(e>a),`Minimum value '${e}' must be less than maximum value '${a}'`,IllegalArgumentException),this._minSmallest=t,this._minLargest=e,this._maxLargest=a,this._maxSmallest=i}isFixed(){return this._minSmallest===this._minLargest&&this._maxSmallest===this._maxLargest}minimum(){return this._minSmallest}largestMinimum(){return this._minLargest}maximum(){return this._maxLargest}smallestMaximum(){return this._maxSmallest}isValidValue(t){return this.minimum()<=t&&t<=this.maximum()}checkValidValue(t,e){let i;return this.isValidValue(t)?t:(i=null!=e?`Invalid value for ${e} (valid values ${this.toString()}): ${t}`:`Invalid value (valid values ${this.toString()}): ${t}`,assert(!1,i,DateTimeException))}checkValidIntValue(t,e){if(!1===this.isValidIntValue(t))throw new DateTimeException(`Invalid int value for ${e}: ${t}`);return t}isValidIntValue(t){return this.isIntValue()&&this.isValidValue(t)}isIntValue(){return this.minimum()>=MathUtil.MIN_SAFE_INTEGER&&this.maximum()<=MathUtil.MAX_SAFE_INTEGER}equals(t){return t===this||t instanceof ValueRange&&(this._minSmallest===t._minSmallest&&this._minLargest===t._minLargest&&this._maxSmallest===t._maxSmallest&&this._maxLargest===t._maxLargest)}hashCode(){return MathUtil.hashCode(this._minSmallest,this._minLargest,this._maxSmallest,this._maxLargest)}toString(){let t=this.minimum()+(this.minimum()!==this.largestMinimum()?`/${this.largestMinimum()}`:"");return t+=" - ",t+=this.smallestMaximum()+(this.smallestMaximum()!==this.maximum()?`/${this.maximum()}`:""),t}static of(){return 2===arguments.length?new ValueRange(arguments[0],arguments[0],arguments[1],arguments[1]):3===arguments.length?new ValueRange(arguments[0],arguments[0],arguments[1],arguments[2]):4===arguments.length?new ValueRange(arguments[0],arguments[1],arguments[2],arguments[3]):assert(!1,`Invalid number of arguments ${arguments.length}`,IllegalArgumentException)}}