/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull}from"../assert";import{IllegalArgumentException}from"../errors";import{Duration}from"../Duration";import{LocalDateTime}from"../LocalDateTime";export class ZoneOffsetTransition{static of(t,e,o){return new ZoneOffsetTransition(t,e,o)}constructor(t,e,o){if(requireNonNull(t,"transition"),requireNonNull(e,"offsetBefore"),requireNonNull(o,"offsetAfter"),e.equals(o))throw new IllegalArgumentException("Offsets must not be equal");if(0!==t.nano())throw new IllegalArgumentException("Nano-of-second must be zero");this._transition=t instanceof LocalDateTime?t:LocalDateTime.ofEpochSecond(t,0,e),this._offsetBefore=e,this._offsetAfter=o}instant(){return this._transition.toInstant(this._offsetBefore)}toEpochSecond(){return this._transition.toEpochSecond(this._offsetBefore)}dateTimeBefore(){return this._transition}dateTimeAfter(){return this._transition.plusSeconds(this.durationSeconds())}offsetBefore(){return this._offsetBefore}offsetAfter(){return this._offsetAfter}duration(){return Duration.ofSeconds(this.durationSeconds())}durationSeconds(){return this._offsetAfter.totalSeconds()-this._offsetBefore.totalSeconds()}isGap(){return this._offsetAfter.totalSeconds()>this._offsetBefore.totalSeconds()}isOverlap(){return this._offsetAfter.totalSeconds()<this._offsetBefore.totalSeconds()}isValidOffset(t){return!this.isGap()&&(this._offsetBefore.equals(t)||this._offsetAfter.equals(t))}validOffsets(){return this.isGap()?[]:[this._offsetBefore,this._offsetAfter]}compareTo(t){return this.instant().compareTo(t.instant())}equals(t){if(t===this)return!0;if(t instanceof ZoneOffsetTransition){const e=t;return this._transition.equals(e._transition)&&this._offsetBefore.equals(e.offsetBefore())&&this._offsetAfter.equals(e.offsetAfter())}return!1}hashCode(){return this._transition.hashCode()^this._offsetBefore.hashCode()^this._offsetAfter.hashCode()>>>16}toString(){return`Transition[${this.isGap()?"Gap":"Overlap"} at ${this._transition.toString()}${this._offsetBefore.toString()} to ${this._offsetAfter}]`}}