/*
 * @copyright (c) 2016, Philipp Thürwächter & Pattrick Hüper
 * @copyright (c) 2007-present, Stephen Colebourne & Michael Nascimento Santos
 * @license BSD-3-Clause (see LICENSE in the root directory of this source tree)
 */
import{requireNonNull,abstractMethodFail}from"../assert";import{Duration}from"../Duration";import{Instant}from"../Instant";export class ZoneRules{static of(t){return requireNonNull(t,"offset"),new Fixed(t)}isFixedOffset(){abstractMethodFail("ZoneRules.isFixedOffset")}offset(t){return t instanceof Instant?this.offsetOfInstant(t):this.offsetOfLocalDateTime(t)}offsetOfInstant(t){abstractMethodFail("ZoneRules.offsetInstant")}offsetOfEpochMilli(t){abstractMethodFail("ZoneRules.offsetOfEpochMilli")}offsetOfLocalDateTime(t){abstractMethodFail("ZoneRules.offsetLocalDateTime")}validOffsets(t){abstractMethodFail("ZoneRules.validOffsets")}transition(t){abstractMethodFail("ZoneRules.transition")}standardOffset(t){abstractMethodFail("ZoneRules.standardOffset")}daylightSavings(t){abstractMethodFail("ZoneRules.daylightSavings")}isDaylightSavings(t){abstractMethodFail("ZoneRules.isDaylightSavings")}isValidOffset(t,s){abstractMethodFail("ZoneRules.isValidOffset")}nextTransition(t){abstractMethodFail("ZoneRules.nextTransition")}previousTransition(t){abstractMethodFail("ZoneRules.previousTransition")}transitions(){abstractMethodFail("ZoneRules.transitions")}transitionRules(){abstractMethodFail("ZoneRules.transitionRules")}toString(){abstractMethodFail("ZoneRules.toString")}toJSON(){return this.toString()}}class Fixed extends ZoneRules{constructor(t){super(),this._offset=t}isFixedOffset(){return!0}offsetOfInstant(){return this._offset}offsetOfEpochMilli(){return this._offset}offsetOfLocalDateTime(){return this._offset}validOffsets(){return[this._offset]}transition(){return null}standardOffset(){return this._offset}daylightSavings(){return Duration.ZERO}isDaylightSavings(){return!1}isValidOffset(t,s){return this._offset.equals(s)}nextTransition(){return null}previousTransition(){return null}transitions(){return[]}transitionRules(){return[]}equals(t){return this===t||t instanceof Fixed&&this._offset.equals(t._offset)}toString(){return`FixedRules:${this._offset.toString()}`}}