import{toUtf8}from"@smithy/util-utf8";import{alloc,extendedFloat16,extendedFloat32,extendedFloat64,extendedOneByte,majorList,majorMap,majorNegativeInt64,majorTag,majorUint64,majorUnstructuredByteString,majorUtf8String,minorIndefinite,specialFalse,specialNull,specialTrue,specialUndefined}from"./cbor-types";const USE_TEXT_DECODER="undefined"!=typeof TextDecoder,USE_BUFFER="undefined"!=typeof Buffer;let payload=alloc(0),dataView=new DataView(payload.buffer,payload.byteOffset,payload.byteLength);const textDecoder=USE_TEXT_DECODER?new TextDecoder:null;let _offset=0;export function setPayload(e){payload=e,dataView=new DataView(payload.buffer,payload.byteOffset,payload.byteLength)}export function decode(e,t){if(e>=t)throw new Error("unexpected end of (decode) payload.");const n=(224&payload[e])>>5,o=31&payload[e];switch(n){case majorUint64:case majorNegativeInt64:case majorTag:let r,a;if(o<24)r=o,a=1;else switch(o){case extendedOneByte:case extendedFloat16:case extendedFloat32:case extendedFloat64:const n=minorValueToArgumentLength[o],d=n+1;if(a=d,t-e<d)throw new Error(`countLength ${n} greater than remaining buf len.`);const i=e+1;r=1===n?payload[i]:2===n?dataView.getUint16(i):4===n?dataView.getUint32(i):dataView.getBigUint64(i);break;default:throw new Error(`unexpected minor value ${o}.`)}if(n===majorUint64)return _offset=a,castBigInt(r);if(n===majorNegativeInt64){let e;return e="bigint"==typeof r?BigInt(-1)-r:-1-r,_offset=a,castBigInt(e)}{const n=decode(e+a,t);return _offset=a+_offset,{tag:castBigInt(r),value:n}}case majorUtf8String:case majorMap:case majorList:case majorUnstructuredByteString:if(o===minorIndefinite)switch(n){case majorUtf8String:return decodeUtf8StringIndefinite(e,t);case majorMap:return decodeMapIndefinite(e,t);case majorList:return decodeListIndefinite(e,t);case majorUnstructuredByteString:return decodeUnstructuredByteStringIndefinite(e,t)}else switch(n){case majorUtf8String:return decodeUtf8String(e,t);case majorMap:return decodeMap(e,t);case majorList:return decodeList(e,t);case majorUnstructuredByteString:return decodeUnstructuredByteString(e,t)}default:return decodeSpecial(e,t)}}function bytesToUtf8(e,t,n){return USE_BUFFER&&"Buffer"===e.constructor?.name?e.toString("utf-8",t,n):textDecoder?textDecoder.decode(e.subarray(t,n)):toUtf8(e.subarray(t,n))}function demote(e){const t=Number(e);return(t<Number.MIN_SAFE_INTEGER||Number.MAX_SAFE_INTEGER<t)&&console.warn(new Error(`@smithy/core/cbor - truncating BigInt(${e}) to ${t} with loss of precision.`)),t}const minorValueToArgumentLength={[extendedOneByte]:1,[extendedFloat16]:2,[extendedFloat32]:4,[extendedFloat64]:8};export function bytesToFloat16(e,t){const n=(124&e)>>2,o=(3&e)<<8|t,r=0===e>>7?1:-1;let a,d;if(0===n){if(0===o)return 0;a=Math.pow(2,-14),d=0}else{if(31===n)return 0===o?r*(1/0):NaN;a=Math.pow(2,n-15),d=1}return d+=o/1024,r*(a*d)}function decodeCount(e,t){const n=31&payload[e];if(n<24)return _offset=1,n;if(n===extendedOneByte||n===extendedFloat16||n===extendedFloat32||n===extendedFloat64){const o=minorValueToArgumentLength[n];if(_offset=o+1,t-e<_offset)throw new Error(`countLength ${o} greater than remaining buf len.`);const r=e+1;return 1===o?payload[r]:2===o?dataView.getUint16(r):4===o?dataView.getUint32(r):demote(dataView.getBigUint64(r))}throw new Error(`unexpected minor value ${n}.`)}function decodeUtf8String(e,t){const n=decodeCount(e,t),o=_offset;if(t-(e+=o)<n)throw new Error(`string len ${n} greater than remaining buf len.`);const r=bytesToUtf8(payload,e,e+n);return _offset=o+n,r}function decodeUtf8StringIndefinite(e,t){const n=[];for(const o=e+=1;e<t;){if(255===payload[e]){const t=alloc(n.length);return t.set(n,0),_offset=e-o+2,bytesToUtf8(t,0,t.length)}const r=(224&payload[e])>>5,a=31&payload[e];if(r!==majorUtf8String)throw new Error(`unexpected major type ${r} in indefinite string.`);if(a===minorIndefinite)throw new Error("nested indefinite string.");const d=decodeUnstructuredByteString(e,t);e+=_offset;for(let e=0;e<d.length;++e)n.push(d[e])}throw new Error("expected break marker.")}function decodeUnstructuredByteString(e,t){const n=decodeCount(e,t),o=_offset;if(t-(e+=o)<n)throw new Error(`unstructured byte string len ${n} greater than remaining buf len.`);const r=payload.subarray(e,e+n);return _offset=o+n,r}function decodeUnstructuredByteStringIndefinite(e,t){const n=[];for(const o=e+=1;e<t;){if(255===payload[e]){const t=alloc(n.length);return t.set(n,0),_offset=e-o+2,t}const r=(224&payload[e])>>5,a=31&payload[e];if(r!==majorUnstructuredByteString)throw new Error(`unexpected major type ${r} in indefinite string.`);if(a===minorIndefinite)throw new Error("nested indefinite string.");const d=decodeUnstructuredByteString(e,t);e+=_offset;for(let e=0;e<d.length;++e)n.push(d[e])}throw new Error("expected break marker.")}function decodeList(e,t){const n=decodeCount(e,t),o=_offset,r=e+=o,a=Array(n);for(let o=0;o<n;++o){const n=decode(e,t),r=_offset;a[o]=n,e+=r}return _offset=o+(e-r),a}function decodeListIndefinite(e,t){const n=[];for(const o=e+=1;e<t;){if(255===payload[e])return _offset=e-o+2,n;const r=decode(e,t);e+=_offset,n.push(r)}throw new Error("expected break marker.")}function decodeMap(e,t){const n=decodeCount(e,t),o=_offset,r=e+=o,a={};for(let o=0;o<n;++o){if(e>=t)throw new Error("unexpected end of map payload.");const n=(224&payload[e])>>5;if(n!==majorUtf8String)throw new Error(`unexpected major type ${n} for map key at index ${e}.`);const o=decode(e,t),r=decode(e+=_offset,t);e+=_offset,a[o]=r}return _offset=o+(e-r),a}function decodeMapIndefinite(e,t){const n=e+=1,o={};for(;e<t;){if(e>=t)throw new Error("unexpected end of map payload.");if(255===payload[e])return _offset=e-n+2,o;const r=(224&payload[e])>>5;if(r!==majorUtf8String)throw new Error(`unexpected major type ${r} for map key.`);const a=decode(e,t),d=decode(e+=_offset,t);e+=_offset,o[a]=d}throw new Error("expected break marker.")}function decodeSpecial(e,t){const n=31&payload[e];switch(n){case specialTrue:case specialFalse:return _offset=1,n===specialTrue;case specialNull:case specialUndefined:return _offset=1,null;case extendedFloat16:if(t-e<3)throw new Error("incomplete float16 at end of buf.");return _offset=3,bytesToFloat16(payload[e+1],payload[e+2]);case extendedFloat32:if(t-e<5)throw new Error("incomplete float32 at end of buf.");return _offset=5,dataView.getFloat32(e+1);case extendedFloat64:if(t-e<9)throw new Error("incomplete float64 at end of buf.");return _offset=9,dataView.getFloat64(e+1);default:throw new Error(`unexpected minor value ${n}.`)}}function castBigInt(e){if("number"==typeof e)return e;const t=Number(e);return Number.MIN_SAFE_INTEGER<=t&&t<=Number.MAX_SAFE_INTEGER?t:e}