import{loadConfig}from"@smithy/node-config-provider";import{CredentialsProviderError}from"@smithy/property-provider";import{InstanceMetadataV1FallbackError}from"./error/InstanceMetadataV1FallbackError";import{httpRequest}from"./remoteProvider/httpRequest";import{fromImdsCredentials,isImdsCredentials}from"./remoteProvider/ImdsCredentials";import{providerConfigFromInit}from"./remoteProvider/RemoteProviderInit";import{retry}from"./remoteProvider/retry";import{getInstanceMetadataEndpoint}from"./utils/getInstanceMetadataEndpoint";import{staticStabilityProvider}from"./utils/staticStabilityProvider";const IMDS_PATH="/latest/meta-data/iam/security-credentials/",IMDS_TOKEN_PATH="/latest/api/token",AWS_EC2_METADATA_V1_DISABLED="AWS_EC2_METADATA_V1_DISABLED",PROFILE_AWS_EC2_METADATA_V1_DISABLED="ec2_metadata_v1_disabled",X_AWS_EC2_METADATA_TOKEN="x-aws-ec2-metadata-token";export const fromInstanceMetadata=(t={})=>staticStabilityProvider(getInstanceMetadataProvider(t),{logger:t.logger});const getInstanceMetadataProvider=(t={})=>{let e=!1;const{logger:a,profile:r}=t,{timeout:o,maxRetries:i}=providerConfigFromInit(t),n=async(a,o)=>{if(e||null==o.headers?.[X_AWS_EC2_METADATA_TOKEN]){let e=!1,a=!1;const o=await loadConfig({environmentVariableSelector:e=>{const r=e[AWS_EC2_METADATA_V1_DISABLED];if(a=!!r&&"false"!==r,void 0===r)throw new CredentialsProviderError(`${AWS_EC2_METADATA_V1_DISABLED} not set in env, checking config file next.`,{logger:t.logger});return a},configFileSelector:t=>{const a=t.ec2_metadata_v1_disabled;return e=!!a&&"false"!==a,e},default:!1},{profile:r})();if(t.ec2MetadataV1Disabled||o){const r=[];throw t.ec2MetadataV1Disabled&&r.push("credential provider initialization (runtime option ec2MetadataV1Disabled)"),e&&r.push("config file profile (ec2_metadata_v1_disabled)"),a&&r.push(`process environment variable (${AWS_EC2_METADATA_V1_DISABLED})`),new InstanceMetadataV1FallbackError(`AWS EC2 Metadata v1 fallback has been blocked by AWS SDK configuration in the following: [${r.join(", ")}].`)}}const i=(await retry((async()=>{let t;try{t=await getProfile(o)}catch(t){throw 401===t.statusCode&&(e=!1),t}return t}),a)).trim();return retry((async()=>{let a;try{a=await getCredentialsFromProfile(i,o,t)}catch(t){throw 401===t.statusCode&&(e=!1),t}return a}),a)};return async()=>{const t=await getInstanceMetadataEndpoint();if(e)return a?.debug("AWS SDK Instance Metadata","using v1 fallback (no token fetch)"),n(i,{...t,timeout:o});{let r;try{r=(await getMetadataToken({...t,timeout:o})).toString()}catch(r){if(400===r?.statusCode)throw Object.assign(r,{message:"EC2 Metadata token request returned error"});return("TimeoutError"===r.message||[403,404,405].includes(r.statusCode))&&(e=!0),a?.debug("AWS SDK Instance Metadata","using v1 fallback (initial)"),n(i,{...t,timeout:o})}return n(i,{...t,headers:{[X_AWS_EC2_METADATA_TOKEN]:r},timeout:o})}}},getMetadataToken=async t=>httpRequest({...t,path:IMDS_TOKEN_PATH,method:"PUT",headers:{"x-aws-ec2-metadata-token-ttl-seconds":"21600"}}),getProfile=async t=>(await httpRequest({...t,path:IMDS_PATH})).toString(),getCredentialsFromProfile=async(t,e,a)=>{const r=JSON.parse((await httpRequest({...e,path:IMDS_PATH+t})).toString());if(!isImdsCredentials(r))throw new CredentialsProviderError("Invalid response received from instance metadata service.",{logger:a.logger});return fromImdsCredentials(r)};