import{HttpRequest,HttpResponse}from"@smithy/protocol-http";import{isThrottlingError}from"@smithy/service-error-classification";import{DEFAULT_MAX_ATTEMPTS,DEFAULT_RETRY_DELAY_BASE,INITIAL_RETRY_TOKENS,INVOCATION_ID_HEADER,REQUEST_HEADER,RETRY_MODES,THROTTLING_RETRY_DELAY_BASE}from"@smithy/util-retry";import{v4}from"uuid";import{getDefaultRetryQuota}from"./defaultRetryQuota";import{defaultDelayDecider}from"./delayDecider";import{defaultRetryDecider}from"./retryDecider";import{asSdkError}from"./util";export class StandardRetryStrategy{constructor(t,e){this.maxAttemptsProvider=t,this.mode=RETRY_MODES.STANDARD,this.retryDecider=e?.retryDecider??defaultRetryDecider,this.delayDecider=e?.delayDecider??defaultDelayDecider,this.retryQuota=e?.retryQuota??getDefaultRetryQuota(INITIAL_RETRY_TOKENS)}shouldRetry(t,e,r){return e<r&&this.retryDecider(t)&&this.retryQuota.hasRetryTokens(t)}async getMaxAttempts(){let t;try{t=await this.maxAttemptsProvider()}catch(e){t=DEFAULT_MAX_ATTEMPTS}return t}async retry(t,e,r){let a,s=0,o=0;const i=await this.getMaxAttempts(),{request:R}=e;for(HttpRequest.isInstance(R)&&(R.headers[INVOCATION_ID_HEADER]=v4());;)try{HttpRequest.isInstance(R)&&(R.headers[REQUEST_HEADER]=`attempt=${s+1}; max=${i}`),r?.beforeRequest&&await r.beforeRequest();const{response:y,output:u}=await t(e);return r?.afterRequest&&r.afterRequest(y),this.retryQuota.releaseRetryTokens(a),u.$metadata.attempts=s+1,u.$metadata.totalRetryDelay=o,{response:y,output:u}}catch(t){const e=asSdkError(t);if(s++,this.shouldRetry(e,s,i)){a=this.retryQuota.retrieveRetryTokens(e);const t=this.delayDecider(isThrottlingError(e)?THROTTLING_RETRY_DELAY_BASE:DEFAULT_RETRY_DELAY_BASE,s),r=getDelayFromRetryAfterHeader(e.$response),i=Math.max(r||0,t);o+=i,await new Promise((t=>setTimeout(t,i)));continue}throw e.$metadata||(e.$metadata={}),e.$metadata.attempts=s,e.$metadata.totalRetryDelay=o,e}}}const getDelayFromRetryAfterHeader=t=>{if(!HttpResponse.isInstance(t))return;const e=Object.keys(t.headers).find((t=>"retry-after"===t.toLowerCase()));if(!e)return;const r=t.headers[e],a=Number(r);if(!Number.isNaN(a))return 1e3*a;return new Date(r).getTime()-Date.now()};