import{HttpResponse}from"@smithy/protocol-http";import{buildQueryString}from"@smithy/querystring-builder";import{Agent as hAgent,request as hRequest}from"http";import{Agent as hsAgent,request as hsRequest}from"https";import{NODEJS_TIMEOUT_ERROR_CODES}from"./constants";import{getTransformedHeaders}from"./get-transformed-headers";import{setConnectionTimeout}from"./set-connection-timeout";import{setSocketKeepAlive}from"./set-socket-keep-alive";import{setSocketTimeout}from"./set-socket-timeout";import{writeRequestBody}from"./write-request-body";export const DEFAULT_REQUEST_TIMEOUT=0;export class NodeHttpHandler{static create(e){return"function"==typeof e?.handle?e:new NodeHttpHandler(e)}static checkSocketUsage(e,t,o=console){const{sockets:n,requests:s,maxSockets:i}=e;if("number"!=typeof i||i===1/0)return t;if(Date.now()-15e3<t)return t;if(n&&s)for(const e in n){const t=n[e]?.length??0,r=s[e]?.length??0;if(t>=i&&r>=2*i)return o?.warn?.(`@smithy/node-http-handler:WARN - socket usage at capacity=${t} and ${r} additional requests are enqueued.\nSee https://docs.aws.amazon.com/sdk-for-javascript/v3/developer-guide/node-configuring-maxsockets.html\nor increase socketAcquisitionWarningTimeout=(millis) in the NodeHttpHandler config.`),Date.now()}return t}constructor(e){this.socketWarningTimestamp=0,this.metadata={handlerProtocol:"http/1.1"},this.configProvider=new Promise(((t,o)=>{"function"==typeof e?e().then((e=>{t(this.resolveDefaultConfig(e))})).catch(o):t(this.resolveDefaultConfig(e))}))}resolveDefaultConfig(e){const{requestTimeout:t,connectionTimeout:o,socketTimeout:n,httpAgent:s,httpsAgent:i}=e||{};return{connectionTimeout:o,requestTimeout:t??n,httpAgent:s instanceof hAgent||"function"==typeof s?.destroy?s:new hAgent({keepAlive:!0,maxSockets:50,...s}),httpsAgent:i instanceof hsAgent||"function"==typeof i?.destroy?i:new hsAgent({keepAlive:!0,maxSockets:50,...i}),logger:console}}destroy(){this.config?.httpAgent?.destroy(),this.config?.httpsAgent?.destroy()}async handle(e,{abortSignal:t}={}){return this.config||(this.config=await this.configProvider),new Promise(((o,n)=>{let s;const i=[],r=async e=>{await s,i.forEach(clearTimeout),n(e)};if(!this.config)throw new Error("Node HTTP request handler config is not resolved");if(t?.aborted){const e=new Error("Request aborted");return e.name="AbortError",void r(e)}const c="https:"===e.protocol,a=c?this.config.httpsAgent:this.config.httpAgent;i.push(setTimeout((()=>{this.socketWarningTimestamp=NodeHttpHandler.checkSocketUsage(a,this.socketWarningTimestamp,this.config.logger)}),this.config.socketAcquisitionWarningTimeout??(this.config.requestTimeout??2e3)+(this.config.connectionTimeout??1e3)));const h=buildQueryString(e.query||{});let u;if(null!=e.username||null!=e.password){u=`${e.username??""}:${e.password??""}`}let m=e.path;h&&(m+=`?${h}`),e.fragment&&(m+=`#${e.fragment}`);let f=e.hostname??"";f="["===f[0]&&f.endsWith("]")?e.hostname.slice(1,-1):e.hostname;const p={headers:e.headers,host:f,method:e.method,path:m,port:e.port,agent:a,auth:u},d=(c?hsRequest:hRequest)(p,(e=>{(async e=>{await s,i.forEach(clearTimeout),o(e)})({response:new HttpResponse({statusCode:e.statusCode||-1,reason:e.statusMessage,headers:getTransformedHeaders(e.headers),body:e})})}));if(d.on("error",(e=>{NODEJS_TIMEOUT_ERROR_CODES.includes(e.code)?r(Object.assign(e,{name:"TimeoutError"})):r(e)})),t){const e=()=>{d.destroy();const e=new Error("Request aborted");e.name="AbortError",r(e)};if("function"==typeof t.addEventListener){const o=t;o.addEventListener("abort",e,{once:!0}),d.once("close",(()=>o.removeEventListener("abort",e)))}else t.onabort=e}i.push(setConnectionTimeout(d,r,this.config.connectionTimeout)),i.push(setSocketTimeout(d,r,this.config.requestTimeout));const g=p.agent;"object"==typeof g&&"keepAlive"in g&&i.push(setSocketKeepAlive(d,{keepAlive:g.keepAlive,keepAliveMsecs:g.keepAliveMsecs})),s=writeRequestBody(d,e,this.config.requestTimeout).catch((e=>(i.forEach(clearTimeout),n(e))))}))}updateHttpClientConfig(e,t){this.config=void 0,this.configProvider=this.configProvider.then((o=>({...o,[e]:t})))}httpHandlerConfigs(){return this.config??{}}}