import{strictParseByte,strictParseDouble,strictParseFloat32,strictParseShort}from"./parse-utils";const DAYS=["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],MONTHS=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];export function dateToUtcString(e){const t=e.getUTCFullYear(),r=e.getUTCMonth(),s=e.getUTCDay(),a=e.getUTCDate(),n=e.getUTCHours(),o=e.getUTCMinutes(),i=e.getUTCSeconds(),u=n<10?`0${n}`:`${n}`,d=o<10?`0${o}`:`${o}`,l=i<10?`0${i}`:`${i}`;return`${DAYS[s]}, ${a<10?`0${a}`:`${a}`} ${MONTHS[r]} ${t} ${u}:${d}:${l} GMT`}const RFC3339=new RegExp(/^(\d{4})-(\d{2})-(\d{2})[tT](\d{2}):(\d{2}):(\d{2})(?:\.(\d+))?[zZ]$/);export const parseRfc3339DateTime=e=>{if(null==e)return;if("string"!=typeof e)throw new TypeError("RFC-3339 date-times must be expressed as strings");const t=RFC3339.exec(e);if(!t)throw new TypeError("Invalid RFC-3339 date-time value");const[r,s,a,n,o,i,u,d]=t,l=strictParseShort(stripLeadingZeroes(s)),c=parseDateValue(a,"month",1,12),p=parseDateValue(n,"day",1,31);return buildDate(l,c,p,{hours:o,minutes:i,seconds:u,fractionalMilliseconds:d})};const RFC3339_WITH_OFFSET=new RegExp(/^(\d{4})-(\d{2})-(\d{2})[tT](\d{2}):(\d{2}):(\d{2})(?:\.(\d+))?(([-+]\d{2}\:\d{2})|[zZ])$/);export const parseRfc3339DateTimeWithOffset=e=>{if(null==e)return;if("string"!=typeof e)throw new TypeError("RFC-3339 date-times must be expressed as strings");const t=RFC3339_WITH_OFFSET.exec(e);if(!t)throw new TypeError("Invalid RFC-3339 date-time value");const[r,s,a,n,o,i,u,d,l]=t,c=strictParseShort(stripLeadingZeroes(s)),p=parseDateValue(a,"month",1,12),T=parseDateValue(n,"day",1,31),f=buildDate(c,p,T,{hours:o,minutes:i,seconds:u,fractionalMilliseconds:d});return"Z"!=l.toUpperCase()&&f.setTime(f.getTime()-parseOffsetToMilliseconds(l)),f};const IMF_FIXDATE=new RegExp(/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun), (\d{2}) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) (\d{4}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? GMT$/),RFC_850_DATE=new RegExp(/^(?:Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday), (\d{2})-(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)-(\d{2}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? GMT$/),ASC_TIME=new RegExp(/^(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun) (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec) ( [1-9]|\d{2}) (\d{1,2}):(\d{2}):(\d{2})(?:\.(\d+))? (\d{4})$/);export const parseRfc7231DateTime=e=>{if(null==e)return;if("string"!=typeof e)throw new TypeError("RFC-7231 date-times must be expressed as strings");let t=IMF_FIXDATE.exec(e);if(t){const[e,r,s,a,n,o,i,u]=t;return buildDate(strictParseShort(stripLeadingZeroes(a)),parseMonthByShortName(s),parseDateValue(r,"day",1,31),{hours:n,minutes:o,seconds:i,fractionalMilliseconds:u})}if(t=RFC_850_DATE.exec(e),t){const[e,r,s,a,n,o,i,u]=t;return adjustRfc850Year(buildDate(parseTwoDigitYear(a),parseMonthByShortName(s),parseDateValue(r,"day",1,31),{hours:n,minutes:o,seconds:i,fractionalMilliseconds:u}))}if(t=ASC_TIME.exec(e),t){const[e,r,s,a,n,o,i,u]=t;return buildDate(strictParseShort(stripLeadingZeroes(u)),parseMonthByShortName(r),parseDateValue(s.trimLeft(),"day",1,31),{hours:a,minutes:n,seconds:o,fractionalMilliseconds:i})}throw new TypeError("Invalid RFC-7231 date-time value")};export const parseEpochTimestamp=e=>{if(null==e)return;let t;if("number"==typeof e)t=e;else if("string"==typeof e)t=strictParseDouble(e);else{if("object"!=typeof e||1!==e.tag)throw new TypeError("Epoch timestamps must be expressed as floating point numbers or their string representation");t=e.value}if(Number.isNaN(t)||t===1/0||t===-1/0)throw new TypeError("Epoch timestamps must be valid, non-Infinite, non-NaN numerics");return new Date(Math.round(1e3*t))};const buildDate=(e,t,r,s)=>{const a=t-1;return validateDayOfMonth(e,a,r),new Date(Date.UTC(e,a,r,parseDateValue(s.hours,"hour",0,23),parseDateValue(s.minutes,"minute",0,59),parseDateValue(s.seconds,"seconds",0,60),parseMilliseconds(s.fractionalMilliseconds)))},parseTwoDigitYear=e=>{const t=(new Date).getUTCFullYear(),r=100*Math.floor(t/100)+strictParseShort(stripLeadingZeroes(e));return r<t?r+100:r},FIFTY_YEARS_IN_MILLIS=15768e8,adjustRfc850Year=e=>e.getTime()-(new Date).getTime()>15768e8?new Date(Date.UTC(e.getUTCFullYear()-100,e.getUTCMonth(),e.getUTCDate(),e.getUTCHours(),e.getUTCMinutes(),e.getUTCSeconds(),e.getUTCMilliseconds())):e,parseMonthByShortName=e=>{const t=MONTHS.indexOf(e);if(t<0)throw new TypeError(`Invalid month: ${e}`);return t+1},DAYS_IN_MONTH=[31,28,31,30,31,30,31,31,30,31,30,31],validateDayOfMonth=(e,t,r)=>{let s=DAYS_IN_MONTH[t];if(1===t&&isLeapYear(e)&&(s=29),r>s)throw new TypeError(`Invalid day for ${MONTHS[t]} in ${e}: ${r}`)},isLeapYear=e=>e%4==0&&(e%100!=0||e%400==0),parseDateValue=(e,t,r,s)=>{const a=strictParseByte(stripLeadingZeroes(e));if(a<r||a>s)throw new TypeError(`${t} must be between ${r} and ${s}, inclusive`);return a},parseMilliseconds=e=>null==e?0:1e3*strictParseFloat32("0."+e),parseOffsetToMilliseconds=e=>{const t=e[0];let r=1;if("+"==t)r=1;else{if("-"!=t)throw new TypeError(`Offset direction, ${t}, must be "+" or "-"`);r=-1}return r*(60*Number(e.substring(1,3))+Number(e.substring(4,6)))*60*1e3},stripLeadingZeroes=e=>{let t=0;for(;t<e.length-1&&"0"===e.charAt(t);)t++;return 0===t?e:e.slice(t)};