var fs=require("fs"),path=require("path");function ClientCreator(e){e=e||path.join(__dirname,".."),this._metadataPath=path.join(e,"apis","metadata.json"),this._apisFolderPath=path.join(e,"apis"),this._clientFolderPath=path.join(e,"clients"),this._serviceCustomizationsFolderPath=path.join(e,"lib","services"),this._packageJsonPath=path.join(e,"package.json"),this._apiFileNames=null,this._metadata=null}ClientCreator.prototype.loadMetadata=function(){if(this._metadata)return this._metadata;var e=fs.readFileSync(this._metadataPath);return this.metadata=JSON.parse(e),this.metadata},ClientCreator.prototype.getAllApiFilenames=function(){if(this._apiFileNames)return this._apiFileNames;var e=fs.readdirSync(this._apisFolderPath);return this._apiFileNames=e.filter((function(e){return"metadata.json"!==e})),this._apiFileNames},ClientCreator.prototype.getAllApiFilenamesForService=function(e){var t=new RegExp("(^"+e+"-([\\d]{4}-[\\d]{2}-[\\d]{2})\\.([\\w]+))\\.json$"),r={},a={};return this.getAllApiFilenames().filter((function(e){return 0===e.search(t)})).forEach((function(e){var r=e.match(t);if(r){var i=r[1],n=r[2],o=r[3];a.hasOwnProperty(n)||(a[n]={});var s=a[n];switch(o){case"min":s.api=i;break;case"paginators":s.paginators=i;break;case"waiters2":s.waiters=i;break;default:return}}})),r.versions=a,r},ClientCreator.prototype.customizationsExist=function(e){var t=this._serviceCustomizationsFolderPath;return fs.existsSync(path.join(t,e+".js"))},ClientCreator.prototype.generateClientFileSource=function(e,t){var r=this._clientFolderPath,a=e.name,i=a.toLowerCase(),n=e.prefix||i;t=t||"*";var o=this.getAllApiFilenamesForService(n),s=o&&o.versions;if(!s)throw new Error("Unable to get models for "+n);var l=e.versions||[],c=Object.keys(s),p="";return p+="require('../lib/node_loader');\n",p+="var AWS = require('../lib/core');\n",p+="var Service = AWS.Service;\n",p+="var apiLoader = AWS.apiLoader;\n\n",p+="apiLoader.services['"+i+"'] = {};\n",p+="AWS."+a+" = Service.defineService('"+i+"', ['"+[].concat(l,c).sort().join("', '")+"']);\n",this.customizationsExist(i)&&(p+="require('../lib/services/"+i+"');\n"),c.forEach((function(e){if("*"===t||t===e){var r=s[e];if(!r.hasOwnProperty("api"))throw new Error("No API model for "+i+"-"+e);p+="Object.defineProperty(apiLoader.services['"+i+"'], '"+e+"', {\n",p+="  get: function get() {\n",p+="    var model = require('../apis/"+r.api+".json');\n",r.hasOwnProperty("paginators")&&(p+="    model.paginators = require('../apis/"+r.paginators+".json').pagination;\n"),r.hasOwnProperty("waiters")&&(p+="    model.waiters = require('../apis/"+r.waiters+".json').waiters;\n"),p+="    return model;\n",p+="  },\n",p+="  enumerable: true,\n",p+="  configurable: true\n",p+="});\n"}})),p+="\n",{code:p+="module.exports = AWS."+a+";\n",path:path.join(r,i+".js"),service:i}},ClientCreator.prototype.tabs=function(e){for(var t="",r=0;r<e;r++)t+="  ";return t},ClientCreator.prototype.generateDefinePropertySource=function(e,t,r){var a=this.tabs,i="";return i+="var "+t+" = null;\n",i+="Object.defineProperty("+e+", '"+r+"', {\n",i+=a(1)+"get: function get() {\n",i+=a(2)+"return "+t+" || require('./"+t+"');\n",i+=a(1)+"},\n",i+=a(1)+"set: function set(svc) {\n",i+=a(2)+t+" = svc;\n",i+=a(1)+"},\n",i+=a(1)+"enumerable: true,\n",i+=a(1)+"configurable: true\n",i+="});\n"},ClientCreator.prototype.generateAllServicesSource=function(e,t){var r=this.loadMetadata(),a=this,i="";return i+="require('../lib/node_loader');\n",i+="module.exports = {\n",e.forEach((function(t,n){var o=r[t].name,s=n===e.length-1;i+=a.tabs(1)+o+": require('./"+t+"')"+(s?"":",")+"\n"})),{code:i+="};",path:path.join(this._clientFolderPath,t+".js"),service:t}},ClientCreator.prototype.getDefaultServices=function(){var e=this.loadMetadata(),t=[];for(var r in e)if(e.hasOwnProperty(r)){var a=e[r].name.toLowerCase();t.push(a)}return t},ClientCreator.prototype.writeClientServices=function(){var e=this.loadMetadata(),t=[],r=[];for(var a in e)if(e.hasOwnProperty(a)){var i=this.generateClientFileSource(e[a]);fs.writeFileSync(i.path,i.code),t.push(i.service),!0===e[a].cors&&r.push(i.service)}var n=this.generateAllServicesSource(t,"all");fs.writeFileSync(n.path,n.code);var o=this.generateAllServicesSource(r,"browser_default");fs.writeFileSync(o.path,o.code)},module.exports=ClientCreator;