var AWS=require("./core");AWS.ParamValidator=AWS.util.inherit({constructor:function(e){!0!==e&&void 0!==e||(e={min:!0}),this.validation=e},validate:function(e,t,r){if(this.errors=[],this.validateMember(e,t||{},r||"params"),this.errors.length>1){var i=this.errors.join("\n* ");throw i="There were "+this.errors.length+" validation errors:\n* "+i,AWS.util.error(new Error(i),{code:"MultipleValidationErrors",errors:this.errors})}if(1===this.errors.length)throw this.errors[0];return!0},fail:function(e,t){this.errors.push(AWS.util.error(new Error(t),{code:e}))},validateStructure:function(e,t,r){if(e.isDocument)return!0;var i;this.validateType(t,r,["object"],"structure");for(var a=0;e.required&&a<e.required.length;a++){var n=t[i=e.required[a]];null==n&&this.fail("MissingRequiredParameter","Missing required key '"+i+"' in "+r)}for(i in t)if(Object.prototype.hasOwnProperty.call(t,i)){var o=t[i],l=e.members[i];if(void 0!==l){var s=[r,i].join(".");this.validateMember(l,o,s)}else null!=o&&this.fail("UnexpectedParameter","Unexpected key '"+i+"' found in "+r)}return!0},validateMember:function(e,t,r){switch(e.type){case"structure":return this.validateStructure(e,t,r);case"list":return this.validateList(e,t,r);case"map":return this.validateMap(e,t,r);default:return this.validateScalar(e,t,r)}},validateList:function(e,t,r){if(this.validateType(t,r,[Array])){this.validateRange(e,t.length,r,"list member count");for(var i=0;i<t.length;i++)this.validateMember(e.member,t[i],r+"["+i+"]")}},validateMap:function(e,t,r){if(this.validateType(t,r,["object"],"map")){var i=0;for(var a in t)Object.prototype.hasOwnProperty.call(t,a)&&(this.validateMember(e.key,a,r+"[key='"+a+"']"),this.validateMember(e.value,t[a],r+"['"+a+"']"),i++);this.validateRange(e,i,r,"map member count")}},validateScalar:function(e,t,r){switch(e.type){case null:case void 0:case"string":return this.validateString(e,t,r);case"base64":case"binary":return this.validatePayload(t,r);case"integer":case"float":return this.validateNumber(e,t,r);case"boolean":return this.validateType(t,r,["boolean"]);case"timestamp":return this.validateType(t,r,[Date,/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d+)?Z$/,"number"],"Date object, ISO-8601 string, or a UNIX timestamp");default:return this.fail("UnkownType","Unhandled type "+e.type+" for "+r)}},validateString:function(e,t,r){var i=["string"];e.isJsonValue&&(i=i.concat(["number","object","boolean"])),null!==t&&this.validateType(t,r,i)&&(this.validateEnum(e,t,r),this.validateRange(e,t.length,r,"string length"),this.validatePattern(e,t,r),this.validateUri(e,t,r))},validateUri:function(e,t,r){"uri"===e.location&&0===t.length&&this.fail("UriParameterError",'Expected uri parameter to have length >= 1, but found "'+t+'" for '+r)},validatePattern:function(e,t,r){this.validation.pattern&&void 0!==e.pattern&&(new RegExp(e.pattern).test(t)||this.fail("PatternMatchError",'Provided value "'+t+'" does not match regex pattern /'+e.pattern+"/ for "+r))},validateRange:function(e,t,r,i){this.validation.min&&void 0!==e.min&&t<e.min&&this.fail("MinRangeError","Expected "+i+" >= "+e.min+", but found "+t+" for "+r),this.validation.max&&void 0!==e.max&&t>e.max&&this.fail("MaxRangeError","Expected "+i+" <= "+e.max+", but found "+t+" for "+r)},validateEnum:function(e,t,r){this.validation.enum&&void 0!==e.enum&&-1===e.enum.indexOf(t)&&this.fail("EnumError","Found string value of "+t+", but expected "+e.enum.join("|")+" for "+r)},validateType:function(e,t,r,i){if(null==e)return!1;for(var a=!1,n=0;n<r.length;n++){if("string"==typeof r[n]){if(typeof e===r[n])return!0}else if(r[n]instanceof RegExp){if((e||"").toString().match(r[n]))return!0}else{if(e instanceof r[n])return!0;if(AWS.util.isType(e,r[n]))return!0;i||a||(r=r.slice()),r[n]=AWS.util.typeName(r[n])}a=!0}var o=i;o||(o=r.join(", ").replace(/,([^,]+)$/,", or$1"));var l=o.match(/^[aeiou]/i)?"n":"";return this.fail("InvalidParameterType","Expected "+t+" to be a"+l+" "+o),!1},validateNumber:function(e,t,r){if(null!=t){if("string"==typeof t){var i=parseFloat(t);i.toString()===t&&(t=i)}this.validateType(t,r,["number"])&&this.validateRange(e,t,r,"numeric value")}},validatePayload:function(e,t){if(null!=e&&"string"!=typeof e&&(!e||"number"!=typeof e.byteLength)){if(AWS.util.isNode()){var r=AWS.util.stream.Stream;if(AWS.util.Buffer.isBuffer(e)||e instanceof r)return}else if(void 0!==typeof Blob&&e instanceof Blob)return;var i=["Buffer","Stream","File","Blob","ArrayBuffer","DataView"];if(e)for(var a=0;a<i.length;a++){if(AWS.util.isType(e,i[a]))return;if(AWS.util.typeName(e.constructor)===i[a])return}this.fail("InvalidParameterType","Expected "+t+" to be a string, Buffer, Stream, Blob, or typed array object")}}});