"use strict";const AbortController=globalThis.AbortController||require("abort-controller").AbortController,{codes:{ERR_INVALID_ARG_VALUE:ERR_INVALID_ARG_VALUE,ERR_INVALID_ARG_TYPE:ERR_INVALID_ARG_TYPE,ERR_MISSING_ARGS:ERR_MISSING_ARGS,ERR_OUT_OF_RANGE:ERR_OUT_OF_RANGE},AbortError:AbortError}=require("../../ours/errors"),{validateAbortSignal:validateAbortSignal,validateInteger:validateInteger,validateObject:validateObject}=require("../validators"),kWeakHandler=require("../../ours/primordials").Symbol("kWeak"),kResistStopPropagation=require("../../ours/primordials").Symbol("kResistStopPropagation"),{finished:finished}=require("./end-of-stream"),staticCompose=require("./compose"),{addAbortSignalNoValidate:addAbortSignalNoValidate}=require("./add-abort-signal"),{isWritable:isWritable,isNodeStream:isNodeStream}=require("./utils"),{deprecate:deprecate}=require("../../ours/util"),{ArrayPrototypePush:ArrayPrototypePush,Boolean:Boolean,MathFloor:MathFloor,Number:Number,NumberIsNaN:NumberIsNaN,Promise:Promise,PromiseReject:PromiseReject,PromiseResolve:PromiseResolve,PromisePrototypeThen:PromisePrototypeThen,Symbol:Symbol}=require("../../ours/primordials"),kEmpty=Symbol("kEmpty"),kEof=Symbol("kEof");function compose(t,o){if(null!=o&&validateObject(o,"options"),null!=(null==o?void 0:o.signal)&&validateAbortSignal(o.signal,"options.signal"),isNodeStream(t)&&!isWritable(t))throw new ERR_INVALID_ARG_VALUE("stream",t,"must be writable");const n=staticCompose(this,t);return null!=o&&o.signal&&addAbortSignalNoValidate(o.signal,n),n}function map(t,o){if("function"!=typeof t)throw new ERR_INVALID_ARG_TYPE("fn",["Function","AsyncFunction"],t);null!=o&&validateObject(o,"options"),null!=(null==o?void 0:o.signal)&&validateAbortSignal(o.signal,"options.signal");let n=1;null!=(null==o?void 0:o.concurrency)&&(n=MathFloor(o.concurrency));let r=n-1;return null!=(null==o?void 0:o.highWaterMark)&&(r=MathFloor(o.highWaterMark)),validateInteger(n,"options.concurrency",1),validateInteger(r,"options.highWaterMark",0),r+=n,async function*(){const i=require("../../ours/util").AbortSignalAny([null==o?void 0:o.signal].filter(Boolean)),e=this,a=[],l={signal:i};let s,u,c=!1,d=0;function f(){c=!0,g()}function g(){d-=1,b()}function b(){u&&!c&&d<n&&a.length<r&&(u(),u=null)}!async function(){try{for await(let o of e){if(c)return;if(i.aborted)throw new AbortError;try{if(o=t(o,l),o===kEmpty)continue;o=PromiseResolve(o)}catch(t){o=PromiseReject(t)}d+=1,PromisePrototypeThen(o,g,f),a.push(o),s&&(s(),s=null),!c&&(a.length>=r||d>=n)&&await new Promise((t=>{u=t}))}a.push(kEof)}catch(t){const o=PromiseReject(t);PromisePrototypeThen(o,g,f),a.push(o)}finally{c=!0,s&&(s(),s=null)}}();try{for(;;){for(;a.length>0;){const t=await a[0];if(t===kEof)return;if(i.aborted)throw new AbortError;t!==kEmpty&&(yield t),a.shift(),b()}await new Promise((t=>{s=t}))}}finally{c=!0,u&&(u(),u=null)}}.call(this)}function asIndexedPairs(t=void 0){return null!=t&&validateObject(t,"options"),null!=(null==t?void 0:t.signal)&&validateAbortSignal(t.signal,"options.signal"),async function*(){let o=0;for await(const r of this){var n;if(null!=t&&null!==(n=t.signal)&&void 0!==n&&n.aborted)throw new AbortError({cause:t.signal.reason});yield[o++,r]}}.call(this)}async function some(t,o=void 0){for await(const n of filter.call(this,t,o))return!0;return!1}async function every(t,o=void 0){if("function"!=typeof t)throw new ERR_INVALID_ARG_TYPE("fn",["Function","AsyncFunction"],t);return!await some.call(this,(async(...o)=>!await t(...o)),o)}async function find(t,o){for await(const n of filter.call(this,t,o))return n}async function forEach(t,o){if("function"!=typeof t)throw new ERR_INVALID_ARG_TYPE("fn",["Function","AsyncFunction"],t);for await(const n of map.call(this,(async function(o,n){return await t(o,n),kEmpty}),o));}function filter(t,o){if("function"!=typeof t)throw new ERR_INVALID_ARG_TYPE("fn",["Function","AsyncFunction"],t);return map.call(this,(async function(o,n){return await t(o,n)?o:kEmpty}),o)}class ReduceAwareErrMissingArgs extends ERR_MISSING_ARGS{constructor(){super("reduce"),this.message="Reduce of an empty stream requires an initial value"}}async function reduce(t,o,n){var r;if("function"!=typeof t)throw new ERR_INVALID_ARG_TYPE("reducer",["Function","AsyncFunction"],t);null!=n&&validateObject(n,"options"),null!=(null==n?void 0:n.signal)&&validateAbortSignal(n.signal,"options.signal");let i=arguments.length>1;if(null!=n&&null!==(r=n.signal)&&void 0!==r&&r.aborted){const t=new AbortError(void 0,{cause:n.signal.reason});throw this.once("error",(()=>{})),await finished(this.destroy(t)),t}const e=new AbortController,a=e.signal;if(null!=n&&n.signal){const t={once:!0,[kWeakHandler]:this,[kResistStopPropagation]:!0};n.signal.addEventListener("abort",(()=>e.abort()),t)}let l=!1;try{for await(const r of this){var s;if(l=!0,null!=n&&null!==(s=n.signal)&&void 0!==s&&s.aborted)throw new AbortError;i?o=await t(o,r,{signal:a}):(o=r,i=!0)}if(!l&&!i)throw new ReduceAwareErrMissingArgs}finally{e.abort()}return o}async function toArray(t){null!=t&&validateObject(t,"options"),null!=(null==t?void 0:t.signal)&&validateAbortSignal(t.signal,"options.signal");const o=[];for await(const r of this){var n;if(null!=t&&null!==(n=t.signal)&&void 0!==n&&n.aborted)throw new AbortError(void 0,{cause:t.signal.reason});ArrayPrototypePush(o,r)}return o}function flatMap(t,o){const n=map.call(this,t,o);return async function*(){for await(const t of n)yield*t}.call(this)}function toIntegerOrInfinity(t){if(t=Number(t),NumberIsNaN(t))return 0;if(t<0)throw new ERR_OUT_OF_RANGE("number",">= 0",t);return t}function drop(t,o=void 0){return null!=o&&validateObject(o,"options"),null!=(null==o?void 0:o.signal)&&validateAbortSignal(o.signal,"options.signal"),t=toIntegerOrInfinity(t),async function*(){var n;if(null!=o&&null!==(n=o.signal)&&void 0!==n&&n.aborted)throw new AbortError;for await(const n of this){var r;if(null!=o&&null!==(r=o.signal)&&void 0!==r&&r.aborted)throw new AbortError;t--<=0&&(yield n)}}.call(this)}function take(t,o=void 0){return null!=o&&validateObject(o,"options"),null!=(null==o?void 0:o.signal)&&validateAbortSignal(o.signal,"options.signal"),t=toIntegerOrInfinity(t),async function*(){var n;if(null!=o&&null!==(n=o.signal)&&void 0!==n&&n.aborted)throw new AbortError;for await(const n of this){var r;if(null!=o&&null!==(r=o.signal)&&void 0!==r&&r.aborted)throw new AbortError;if(t-- >0&&(yield n),t<=0)return}}.call(this)}module.exports.streamReturningOperators={asIndexedPairs:deprecate(asIndexedPairs,"readable.asIndexedPairs will be removed in a future version."),drop:drop,filter:filter,flatMap:flatMap,map:map,take:take,compose:compose},module.exports.promiseReturningOperators={every:every,forEach:forEach,reduce:reduce,toArray:toArray,some:some,find:find};