"use strict";const{format:format,inspect:inspect,AggregateError:CustomAggregateError}=require("./util"),AggregateError=globalThis.AggregateError||CustomAggregateError,kIsNodeError=Symbol("kIsNodeError"),kTypes=["string","function","number","object","Function","Object","boolean","bigint","symbol"],classRegExp=/^([A-Z][a-z0-9]*)+$/,nodeInternalPrefix="__node_internal_",codes={};function assert(e,r){if(!e)throw new codes.ERR_INTERNAL_ASSERTION(r)}function addNumericalSeparator(e){let r="",t=e.length;const o="-"===e[0]?1:0;for(;t>=o+4;t-=3)r=`_${e.slice(t-3,t)}${r}`;return`${e.slice(0,t)}${r}`}function getMessage(e,r,t){if("function"==typeof r)return assert(r.length<=t.length,`Code: ${e}; The provided arguments length (${t.length}) does not match the required ones (${r.length}).`),r(...t);const o=(r.match(/%[dfijoOs]/g)||[]).length;return assert(o===t.length,`Code: ${e}; The provided arguments length (${t.length}) does not match the required ones (${o}).`),0===t.length?r:format(r,...t)}function E(e,r,t){t||(t=Error);class o extends t{constructor(...t){super(getMessage(e,r,t))}toString(){return`${this.name} [${e}]: ${this.message}`}}Object.defineProperties(o.prototype,{name:{value:t.name,writable:!0,enumerable:!1,configurable:!0},toString:{value(){return`${this.name} [${e}]: ${this.message}`},writable:!0,enumerable:!1,configurable:!0}}),o.prototype.code=e,o.prototype[kIsNodeError]=!0,codes[e]=o}function hideStackFrames(e){const r="__node_internal_"+e.name;return Object.defineProperty(e,"name",{value:r}),e}function aggregateTwoErrors(e,r){if(e&&r&&e!==r){if(Array.isArray(r.errors))return r.errors.push(e),r;const t=new AggregateError([r,e],r.message);return t.code=r.code,t}return e||r}class AbortError extends Error{constructor(e="The operation was aborted",r=void 0){if(void 0!==r&&"object"!=typeof r)throw new codes.ERR_INVALID_ARG_TYPE("options","Object",r);super(e,r),this.code="ABORT_ERR",this.name="AbortError"}}E("ERR_ASSERTION","%s",Error),E("ERR_INVALID_ARG_TYPE",((e,r,t)=>{assert("string"==typeof e,"'name' must be a string"),Array.isArray(r)||(r=[r]);let o="The ";e.endsWith(" argument")?o+=`${e} `:o+=`"${e}" ${e.includes(".")?"property":"argument"} `,o+="must be ";const n=[],s=[],a=[];for(const e of r)assert("string"==typeof e,"All expected entries have to be of type string"),kTypes.includes(e)?n.push(e.toLowerCase()):classRegExp.test(e)?s.push(e):(assert("object"!==e,'The value "object" should be written as "Object"'),a.push(e));if(s.length>0){const e=n.indexOf("object");-1!==e&&(n.splice(n,e,1),s.push("Object"))}if(n.length>0){switch(n.length){case 1:o+=`of type ${n[0]}`;break;case 2:o+=`one of type ${n[0]} or ${n[1]}`;break;default:{const e=n.pop();o+=`one of type ${n.join(", ")}, or ${e}`}}(s.length>0||a.length>0)&&(o+=" or ")}if(s.length>0){switch(s.length){case 1:o+=`an instance of ${s[0]}`;break;case 2:o+=`an instance of ${s[0]} or ${s[1]}`;break;default:{const e=s.pop();o+=`an instance of ${s.join(", ")}, or ${e}`}}a.length>0&&(o+=" or ")}switch(a.length){case 0:break;case 1:a[0].toLowerCase()!==a[0]&&(o+="an "),o+=`${a[0]}`;break;case 2:o+=`one of ${a[0]} or ${a[1]}`;break;default:{const e=a.pop();o+=`one of ${a.join(", ")}, or ${e}`}}if(null==t)o+=`. Received ${t}`;else if("function"==typeof t&&t.name)o+=`. Received function ${t.name}`;else if("object"==typeof t){var i;if(null!==(i=t.constructor)&&void 0!==i&&i.name)o+=`. Received an instance of ${t.constructor.name}`;else{o+=`. Received ${inspect(t,{depth:-1})}`}}else{let e=inspect(t,{colors:!1});e.length>25&&(e=`${e.slice(0,25)}...`),o+=`. Received type ${typeof t} (${e})`}return o}),TypeError),E("ERR_INVALID_ARG_VALUE",((e,r,t="is invalid")=>{let o=inspect(r);o.length>128&&(o=o.slice(0,128)+"...");return`The ${e.includes(".")?"property":"argument"} '${e}' ${t}. Received ${o}`}),TypeError),E("ERR_INVALID_RETURN_VALUE",((e,r,t)=>{var o;return`Expected ${e} to be returned from the "${r}" function but got ${null!=t&&null!==(o=t.constructor)&&void 0!==o&&o.name?`instance of ${t.constructor.name}`:"type "+typeof t}.`}),TypeError),E("ERR_MISSING_ARGS",((...e)=>{let r;assert(e.length>0,"At least one arg needs to be specified");const t=e.length;switch(e=(Array.isArray(e)?e:[e]).map((e=>`"${e}"`)).join(" or "),t){case 1:r+=`The ${e[0]} argument`;break;case 2:r+=`The ${e[0]} and ${e[1]} arguments`;break;default:{const t=e.pop();r+=`The ${e.join(", ")}, and ${t} arguments`}}return`${r} must be specified`}),TypeError),E("ERR_OUT_OF_RANGE",((e,r,t)=>{let o;return assert(r,'Missing "range" argument'),Number.isInteger(t)&&Math.abs(t)>2**32?o=addNumericalSeparator(String(t)):"bigint"==typeof t?(o=String(t),(t>2n**32n||t<-(2n**32n))&&(o=addNumericalSeparator(o)),o+="n"):o=inspect(t),`The value of "${e}" is out of range. It must be ${r}. Received ${o}`}),RangeError),E("ERR_MULTIPLE_CALLBACK","Callback called multiple times",Error),E("ERR_METHOD_NOT_IMPLEMENTED","The %s method is not implemented",Error),E("ERR_STREAM_ALREADY_FINISHED","Cannot call %s after a stream was finished",Error),E("ERR_STREAM_CANNOT_PIPE","Cannot pipe, not readable",Error),E("ERR_STREAM_DESTROYED","Cannot call %s after a stream was destroyed",Error),E("ERR_STREAM_NULL_VALUES","May not write null values to stream",TypeError),E("ERR_STREAM_PREMATURE_CLOSE","Premature close",Error),E("ERR_STREAM_PUSH_AFTER_EOF","stream.push() after EOF",Error),E("ERR_STREAM_UNSHIFT_AFTER_END_EVENT","stream.unshift() after end event",Error),E("ERR_STREAM_WRITE_AFTER_END","write after end",Error),E("ERR_UNKNOWN_ENCODING","Unknown encoding: %s",TypeError),module.exports={AbortError:AbortError,aggregateTwoErrors:hideStackFrames(aggregateTwoErrors),hideStackFrames:hideStackFrames,codes:codes};