import{Buffer}from"buffer";
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */var _extendStatics=function(e,t){return _extendStatics=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r])},_extendStatics(e,t)};function __extends(e,t){function r(){this.constructor=e}_extendStatics(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var _assign=function(){return _assign=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var i in t=arguments[r])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e},_assign.apply(this,arguments)},BSONError=function(e){function t(r){var n=e.call(this,r)||this;return Object.setPrototypeOf(n,t.prototype),n}return __extends(t,e),Object.defineProperty(t.prototype,"name",{get:function(){return"BSONError"},enumerable:!1,configurable:!0}),t}(Error),BSONTypeError=function(e){function t(r){var n=e.call(this,r)||this;return Object.setPrototypeOf(n,t.prototype),n}return __extends(t,e),Object.defineProperty(t.prototype,"name",{get:function(){return"BSONTypeError"},enumerable:!1,configurable:!0}),t}(TypeError);function checkForMath(e){return e&&e.Math==Math&&e}function getGlobal(){return checkForMath("object"==typeof globalThis&&globalThis)||checkForMath("object"==typeof window&&window)||checkForMath("object"==typeof self&&self)||checkForMath("object"==typeof global&&global)||Function("return this")()}function normalizedFunctionString(e){return e.toString().replace("function(","function (")}function isReactNative(){var e=getGlobal();return"object"==typeof e.navigator&&"ReactNative"===e.navigator.product}var insecureRandomBytes=function(e){var t=isReactNative()?"BSON: For React Native please polyfill crypto.getRandomValues, e.g. using: https://www.npmjs.com/package/react-native-get-random-values.":"BSON: No cryptographic implementation for random bytes present, falling back to a less secure implementation.";console.warn(t);for(var r=Buffer.alloc(e),n=0;n<e;++n)r[n]=Math.floor(256*Math.random());return r},detectRandomBytes=function(){var e=void 0;try{e=require("crypto").randomBytes}catch(e){}return e||insecureRandomBytes},randomBytes=detectRandomBytes();function isAnyArrayBuffer(e){return["[object ArrayBuffer]","[object SharedArrayBuffer]"].includes(Object.prototype.toString.call(e))}function isUint8Array(e){return"[object Uint8Array]"===Object.prototype.toString.call(e)}function isBigInt64Array(e){return"[object BigInt64Array]"===Object.prototype.toString.call(e)}function isBigUInt64Array(e){return"[object BigUint64Array]"===Object.prototype.toString.call(e)}function isRegExp(e){return"[object RegExp]"===Object.prototype.toString.call(e)}function isMap(e){return"[object Map]"===Object.prototype.toString.call(e)}function isDate(e){return isObjectLike(e)&&"[object Date]"===Object.prototype.toString.call(e)}function isObjectLike(e){return"object"==typeof e&&null!==e}function deprecate(e,t){var r=!1;return function(){for(var n=[],i=0;i<arguments.length;i++)n[i]=arguments[i];return r||(console.warn(t),r=!0),e.apply(this,n)}}function ensureBuffer(e){if(ArrayBuffer.isView(e))return Buffer.from(e.buffer,e.byteOffset,e.byteLength);if(isAnyArrayBuffer(e))return Buffer.from(e);throw new BSONTypeError("Must use either Buffer or TypedArray")}var VALIDATION_REGEX=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-4[0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|[0-9a-f]{12}4[0-9a-f]{3}[89ab][0-9a-f]{15})$/i,uuidValidateString=function(e){return"string"==typeof e&&VALIDATION_REGEX.test(e)},uuidHexStringToBuffer=function(e){if(!uuidValidateString(e))throw new BSONTypeError('UUID string representations must be a 32 or 36 character hex string (dashes excluded/included). Format: "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx" or "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx".');var t=e.replace(/-/g,"");return Buffer.from(t,"hex")},bufferToUuidHexString=function(e,t){return void 0===t&&(t=!0),t?e.toString("hex",0,4)+"-"+e.toString("hex",4,6)+"-"+e.toString("hex",6,8)+"-"+e.toString("hex",8,10)+"-"+e.toString("hex",10,16):e.toString("hex")},BYTE_LENGTH=16,kId$1=Symbol("id"),UUID=function(){function e(t){if(void 0===t)this.id=e.generate();else if(t instanceof e)this[kId$1]=Buffer.from(t.id),this.__id=t.__id;else if(ArrayBuffer.isView(t)&&t.byteLength===BYTE_LENGTH)this.id=ensureBuffer(t);else{if("string"!=typeof t)throw new BSONTypeError("Argument passed in UUID constructor must be a UUID, a 16 byte Buffer or a 32/36 character hex string (dashes excluded/included, format: xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx).");this.id=uuidHexStringToBuffer(t)}}return Object.defineProperty(e.prototype,"id",{get:function(){return this[kId$1]},set:function(t){this[kId$1]=t,e.cacheHexString&&(this.__id=bufferToUuidHexString(t))},enumerable:!1,configurable:!0}),e.prototype.toHexString=function(t){if(void 0===t&&(t=!0),e.cacheHexString&&this.__id)return this.__id;var r=bufferToUuidHexString(this.id,t);return e.cacheHexString&&(this.__id=r),r},e.prototype.toString=function(e){return e?this.id.toString(e):this.toHexString()},e.prototype.toJSON=function(){return this.toHexString()},e.prototype.equals=function(t){if(!t)return!1;if(t instanceof e)return t.id.equals(this.id);try{return new e(t).id.equals(this.id)}catch(e){return!1}},e.prototype.toBinary=function(){return new Binary(this.id,Binary.SUBTYPE_UUID)},e.generate=function(){var e=randomBytes(BYTE_LENGTH);return e[6]=15&e[6]|64,e[8]=63&e[8]|128,Buffer.from(e)},e.isValid=function(t){if(!t)return!1;if(t instanceof e)return!0;if("string"==typeof t)return uuidValidateString(t);if(isUint8Array(t)){if(t.length!==BYTE_LENGTH)return!1;try{return parseInt(t[6].toString(16)[0],10)===Binary.SUBTYPE_UUID}catch(e){return!1}}return!1},e.createFromHexString=function(t){return new e(uuidHexStringToBuffer(t))},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return'new UUID("'.concat(this.toHexString(),'")')},e}();Object.defineProperty(UUID.prototype,"_bsontype",{value:"UUID"});var Binary=function(){function e(t,r){if(!(this instanceof e))return new e(t,r);if(!(null==t||"string"==typeof t||ArrayBuffer.isView(t)||t instanceof ArrayBuffer||Array.isArray(t)))throw new BSONTypeError("Binary can only be constructed from string, Buffer, TypedArray, or Array<number>");this.sub_type=null!=r?r:e.BSON_BINARY_SUBTYPE_DEFAULT,null==t?(this.buffer=Buffer.alloc(e.BUFFER_SIZE),this.position=0):("string"==typeof t?this.buffer=Buffer.from(t,"binary"):Array.isArray(t)?this.buffer=Buffer.from(t):this.buffer=ensureBuffer(t),this.position=this.buffer.byteLength)}return e.prototype.put=function(t){if("string"==typeof t&&1!==t.length)throw new BSONTypeError("only accepts single character String");if("number"!=typeof t&&1!==t.length)throw new BSONTypeError("only accepts single character Uint8Array or Array");var r;if((r="string"==typeof t?t.charCodeAt(0):"number"==typeof t?t:t[0])<0||r>255)throw new BSONTypeError("only accepts number in a valid unsigned byte range 0-255");if(this.buffer.length>this.position)this.buffer[this.position++]=r;else{var n=Buffer.alloc(e.BUFFER_SIZE+this.buffer.length);this.buffer.copy(n,0,0,this.buffer.length),this.buffer=n,this.buffer[this.position++]=r}},e.prototype.write=function(e,t){if(t="number"==typeof t?t:this.position,this.buffer.length<t+e.length){var r=Buffer.alloc(this.buffer.length+e.length);this.buffer.copy(r,0,0,this.buffer.length),this.buffer=r}ArrayBuffer.isView(e)?(this.buffer.set(ensureBuffer(e),t),this.position=t+e.byteLength>this.position?t+e.length:this.position):"string"==typeof e&&(this.buffer.write(e,t,e.length,"binary"),this.position=t+e.length>this.position?t+e.length:this.position)},e.prototype.read=function(e,t){return t=t&&t>0?t:this.position,this.buffer.slice(e,e+t)},e.prototype.value=function(e){return(e=!!e)&&this.buffer.length===this.position?this.buffer:e?this.buffer.slice(0,this.position):this.buffer.toString("binary",0,this.position)},e.prototype.length=function(){return this.position},e.prototype.toJSON=function(){return this.buffer.toString("base64")},e.prototype.toString=function(e){return this.buffer.toString(e)},e.prototype.toExtendedJSON=function(e){e=e||{};var t=this.buffer.toString("base64"),r=Number(this.sub_type).toString(16);return e.legacy?{$binary:t,$type:1===r.length?"0"+r:r}:{$binary:{base64:t,subType:1===r.length?"0"+r:r}}},e.prototype.toUUID=function(){if(this.sub_type===e.SUBTYPE_UUID)return new UUID(this.buffer.slice(0,this.position));throw new BSONError('Binary sub_type "'.concat(this.sub_type,'" is not supported for converting to UUID. Only "').concat(e.SUBTYPE_UUID,'" is currently supported.'))},e.fromExtendedJSON=function(t,r){var n,i;if(r=r||{},"$binary"in t?r.legacy&&"string"==typeof t.$binary&&"$type"in t?(i=t.$type?parseInt(t.$type,16):0,n=Buffer.from(t.$binary,"base64")):"string"!=typeof t.$binary&&(i=t.$binary.subType?parseInt(t.$binary.subType,16):0,n=Buffer.from(t.$binary.base64,"base64")):"$uuid"in t&&(i=4,n=uuidHexStringToBuffer(t.$uuid)),!n)throw new BSONTypeError("Unexpected Binary Extended JSON format ".concat(JSON.stringify(t)));return new e(n,i)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){var e=this.value(!0);return'new Binary(Buffer.from("'.concat(e.toString("hex"),'", "hex"), ').concat(this.sub_type,")")},e.BSON_BINARY_SUBTYPE_DEFAULT=0,e.BUFFER_SIZE=256,e.SUBTYPE_DEFAULT=0,e.SUBTYPE_FUNCTION=1,e.SUBTYPE_BYTE_ARRAY=2,e.SUBTYPE_UUID_OLD=3,e.SUBTYPE_UUID=4,e.SUBTYPE_MD5=5,e.SUBTYPE_ENCRYPTED=6,e.SUBTYPE_COLUMN=7,e.SUBTYPE_USER_DEFINED=128,e}();Object.defineProperty(Binary.prototype,"_bsontype",{value:"Binary"});var Code=function(){function e(t,r){if(!(this instanceof e))return new e(t,r);this.code=t,this.scope=r}return e.prototype.toJSON=function(){return{code:this.code,scope:this.scope}},e.prototype.toExtendedJSON=function(){return this.scope?{$code:this.code,$scope:this.scope}:{$code:this.code}},e.fromExtendedJSON=function(t){return new e(t.$code,t.$scope)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){var e=this.toJSON();return'new Code("'.concat(String(e.code),'"').concat(e.scope?", ".concat(JSON.stringify(e.scope)):"",")")},e}();function isDBRefLike(e){return isObjectLike(e)&&null!=e.$id&&"string"==typeof e.$ref&&(null==e.$db||"string"==typeof e.$db)}Object.defineProperty(Code.prototype,"_bsontype",{value:"Code"});var DBRef=function(){function e(t,r,n,i){if(!(this instanceof e))return new e(t,r,n,i);var o=t.split(".");2===o.length&&(n=o.shift(),t=o.shift()),this.collection=t,this.oid=r,this.db=n,this.fields=i||{}}return Object.defineProperty(e.prototype,"namespace",{get:function(){return this.collection},set:function(e){this.collection=e},enumerable:!1,configurable:!0}),e.prototype.toJSON=function(){var e=Object.assign({$ref:this.collection,$id:this.oid},this.fields);return null!=this.db&&(e.$db=this.db),e},e.prototype.toExtendedJSON=function(e){e=e||{};var t={$ref:this.collection,$id:this.oid};return e.legacy?t:(this.db&&(t.$db=this.db),t=Object.assign(t,this.fields))},e.fromExtendedJSON=function(t){var r=Object.assign({},t);return delete r.$ref,delete r.$id,delete r.$db,new e(t.$ref,t.$id,t.$db,r)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){var e=void 0===this.oid||void 0===this.oid.toString?this.oid:this.oid.toString();return'new DBRef("'.concat(this.namespace,'", new ObjectId("').concat(String(e),'")').concat(this.db?', "'.concat(this.db,'"'):"",")")},e}();Object.defineProperty(DBRef.prototype,"_bsontype",{value:"DBRef"});var wasm=void 0;try{wasm=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(e){}var TWO_PWR_16_DBL=65536,TWO_PWR_24_DBL=1<<24,TWO_PWR_32_DBL=TWO_PWR_16_DBL*TWO_PWR_16_DBL,TWO_PWR_64_DBL=TWO_PWR_32_DBL*TWO_PWR_32_DBL,TWO_PWR_63_DBL=TWO_PWR_64_DBL/2,INT_CACHE={},UINT_CACHE={},Long=function(){function e(t,r,n){if(void 0===t&&(t=0),!(this instanceof e))return new e(t,r,n);"bigint"==typeof t?Object.assign(this,e.fromBigInt(t,!!r)):"string"==typeof t?Object.assign(this,e.fromString(t,!!r)):(this.low=0|t,this.high=0|r,this.unsigned=!!n),Object.defineProperty(this,"__isLong__",{value:!0,configurable:!1,writable:!1,enumerable:!1})}return e.fromBits=function(t,r,n){return new e(t,r,n)},e.fromInt=function(t,r){var n,i,o;return r?(o=0<=(t>>>=0)&&t<256)&&(i=UINT_CACHE[t])?i:(n=e.fromBits(t,(0|t)<0?-1:0,!0),o&&(UINT_CACHE[t]=n),n):(o=-128<=(t|=0)&&t<128)&&(i=INT_CACHE[t])?i:(n=e.fromBits(t,t<0?-1:0,!1),o&&(INT_CACHE[t]=n),n)},e.fromNumber=function(t,r){if(isNaN(t))return r?e.UZERO:e.ZERO;if(r){if(t<0)return e.UZERO;if(t>=TWO_PWR_64_DBL)return e.MAX_UNSIGNED_VALUE}else{if(t<=-TWO_PWR_63_DBL)return e.MIN_VALUE;if(t+1>=TWO_PWR_63_DBL)return e.MAX_VALUE}return t<0?e.fromNumber(-t,r).neg():e.fromBits(t%TWO_PWR_32_DBL|0,t/TWO_PWR_32_DBL|0,r)},e.fromBigInt=function(t,r){return e.fromString(t.toString(),r)},e.fromString=function(t,r,n){if(0===t.length)throw Error("empty string");if("NaN"===t||"Infinity"===t||"+Infinity"===t||"-Infinity"===t)return e.ZERO;if("number"==typeof r?(n=r,r=!1):r=!!r,(n=n||10)<2||36<n)throw RangeError("radix");var i;if((i=t.indexOf("-"))>0)throw Error("interior hyphen");if(0===i)return e.fromString(t.substring(1),r,n).neg();for(var o=e.fromNumber(Math.pow(n,8)),s=e.ZERO,u=0;u<t.length;u+=8){var f=Math.min(8,t.length-u),a=parseInt(t.substring(u,u+f),n);if(f<8){var l=e.fromNumber(Math.pow(n,f));s=s.mul(l).add(e.fromNumber(a))}else s=(s=s.mul(o)).add(e.fromNumber(a))}return s.unsigned=r,s},e.fromBytes=function(t,r,n){return n?e.fromBytesLE(t,r):e.fromBytesBE(t,r)},e.fromBytesLE=function(t,r){return new e(t[0]|t[1]<<8|t[2]<<16|t[3]<<24,t[4]|t[5]<<8|t[6]<<16|t[7]<<24,r)},e.fromBytesBE=function(t,r){return new e(t[4]<<24|t[5]<<16|t[6]<<8|t[7],t[0]<<24|t[1]<<16|t[2]<<8|t[3],r)},e.isLong=function(e){return isObjectLike(e)&&!0===e.__isLong__},e.fromValue=function(t,r){return"number"==typeof t?e.fromNumber(t,r):"string"==typeof t?e.fromString(t,r):e.fromBits(t.low,t.high,"boolean"==typeof r?r:t.unsigned)},e.prototype.add=function(t){e.isLong(t)||(t=e.fromValue(t));var r=this.high>>>16,n=65535&this.high,i=this.low>>>16,o=65535&this.low,s=t.high>>>16,u=65535&t.high,f=t.low>>>16,a=0,l=0,c=0,h=0;return c+=(h+=o+(65535&t.low))>>>16,h&=65535,l+=(c+=i+f)>>>16,c&=65535,a+=(l+=n+u)>>>16,l&=65535,a+=r+s,a&=65535,e.fromBits(c<<16|h,a<<16|l,this.unsigned)},e.prototype.and=function(t){return e.isLong(t)||(t=e.fromValue(t)),e.fromBits(this.low&t.low,this.high&t.high,this.unsigned)},e.prototype.compare=function(t){if(e.isLong(t)||(t=e.fromValue(t)),this.eq(t))return 0;var r=this.isNegative(),n=t.isNegative();return r&&!n?-1:!r&&n?1:this.unsigned?t.high>>>0>this.high>>>0||t.high===this.high&&t.low>>>0>this.low>>>0?-1:1:this.sub(t).isNegative()?-1:1},e.prototype.comp=function(e){return this.compare(e)},e.prototype.divide=function(t){if(e.isLong(t)||(t=e.fromValue(t)),t.isZero())throw Error("division by zero");if(wasm){if(!this.unsigned&&-2147483648===this.high&&-1===t.low&&-1===t.high)return this;var r=(this.unsigned?wasm.div_u:wasm.div_s)(this.low,this.high,t.low,t.high);return e.fromBits(r,wasm.get_high(),this.unsigned)}if(this.isZero())return this.unsigned?e.UZERO:e.ZERO;var n,i,o;if(this.unsigned){if(t.unsigned||(t=t.toUnsigned()),t.gt(this))return e.UZERO;if(t.gt(this.shru(1)))return e.UONE;o=e.UZERO}else{if(this.eq(e.MIN_VALUE))return t.eq(e.ONE)||t.eq(e.NEG_ONE)?e.MIN_VALUE:t.eq(e.MIN_VALUE)?e.ONE:(n=this.shr(1).div(t).shl(1)).eq(e.ZERO)?t.isNegative()?e.ONE:e.NEG_ONE:(i=this.sub(t.mul(n)),o=n.add(i.div(t)));if(t.eq(e.MIN_VALUE))return this.unsigned?e.UZERO:e.ZERO;if(this.isNegative())return t.isNegative()?this.neg().div(t.neg()):this.neg().div(t).neg();if(t.isNegative())return this.div(t.neg()).neg();o=e.ZERO}for(i=this;i.gte(t);){n=Math.max(1,Math.floor(i.toNumber()/t.toNumber()));for(var s=Math.ceil(Math.log(n)/Math.LN2),u=s<=48?1:Math.pow(2,s-48),f=e.fromNumber(n),a=f.mul(t);a.isNegative()||a.gt(i);)n-=u,a=(f=e.fromNumber(n,this.unsigned)).mul(t);f.isZero()&&(f=e.ONE),o=o.add(f),i=i.sub(a)}return o},e.prototype.div=function(e){return this.divide(e)},e.prototype.equals=function(t){return e.isLong(t)||(t=e.fromValue(t)),(this.unsigned===t.unsigned||this.high>>>31!=1||t.high>>>31!=1)&&(this.high===t.high&&this.low===t.low)},e.prototype.eq=function(e){return this.equals(e)},e.prototype.getHighBits=function(){return this.high},e.prototype.getHighBitsUnsigned=function(){return this.high>>>0},e.prototype.getLowBits=function(){return this.low},e.prototype.getLowBitsUnsigned=function(){return this.low>>>0},e.prototype.getNumBitsAbs=function(){if(this.isNegative())return this.eq(e.MIN_VALUE)?64:this.neg().getNumBitsAbs();var t,r=0!==this.high?this.high:this.low;for(t=31;t>0&&0==(r&1<<t);t--);return 0!==this.high?t+33:t+1},e.prototype.greaterThan=function(e){return this.comp(e)>0},e.prototype.gt=function(e){return this.greaterThan(e)},e.prototype.greaterThanOrEqual=function(e){return this.comp(e)>=0},e.prototype.gte=function(e){return this.greaterThanOrEqual(e)},e.prototype.ge=function(e){return this.greaterThanOrEqual(e)},e.prototype.isEven=function(){return 0==(1&this.low)},e.prototype.isNegative=function(){return!this.unsigned&&this.high<0},e.prototype.isOdd=function(){return 1==(1&this.low)},e.prototype.isPositive=function(){return this.unsigned||this.high>=0},e.prototype.isZero=function(){return 0===this.high&&0===this.low},e.prototype.lessThan=function(e){return this.comp(e)<0},e.prototype.lt=function(e){return this.lessThan(e)},e.prototype.lessThanOrEqual=function(e){return this.comp(e)<=0},e.prototype.lte=function(e){return this.lessThanOrEqual(e)},e.prototype.modulo=function(t){if(e.isLong(t)||(t=e.fromValue(t)),wasm){var r=(this.unsigned?wasm.rem_u:wasm.rem_s)(this.low,this.high,t.low,t.high);return e.fromBits(r,wasm.get_high(),this.unsigned)}return this.sub(this.div(t).mul(t))},e.prototype.mod=function(e){return this.modulo(e)},e.prototype.rem=function(e){return this.modulo(e)},e.prototype.multiply=function(t){if(this.isZero())return e.ZERO;if(e.isLong(t)||(t=e.fromValue(t)),wasm){var r=wasm.mul(this.low,this.high,t.low,t.high);return e.fromBits(r,wasm.get_high(),this.unsigned)}if(t.isZero())return e.ZERO;if(this.eq(e.MIN_VALUE))return t.isOdd()?e.MIN_VALUE:e.ZERO;if(t.eq(e.MIN_VALUE))return this.isOdd()?e.MIN_VALUE:e.ZERO;if(this.isNegative())return t.isNegative()?this.neg().mul(t.neg()):this.neg().mul(t).neg();if(t.isNegative())return this.mul(t.neg()).neg();if(this.lt(e.TWO_PWR_24)&&t.lt(e.TWO_PWR_24))return e.fromNumber(this.toNumber()*t.toNumber(),this.unsigned);var n=this.high>>>16,i=65535&this.high,o=this.low>>>16,s=65535&this.low,u=t.high>>>16,f=65535&t.high,a=t.low>>>16,l=65535&t.low,c=0,h=0,p=0,g=0;return p+=(g+=s*l)>>>16,g&=65535,h+=(p+=o*l)>>>16,p&=65535,h+=(p+=s*a)>>>16,p&=65535,c+=(h+=i*l)>>>16,h&=65535,c+=(h+=o*a)>>>16,h&=65535,c+=(h+=s*f)>>>16,h&=65535,c+=n*l+i*a+o*f+s*u,c&=65535,e.fromBits(p<<16|g,c<<16|h,this.unsigned)},e.prototype.mul=function(e){return this.multiply(e)},e.prototype.negate=function(){return!this.unsigned&&this.eq(e.MIN_VALUE)?e.MIN_VALUE:this.not().add(e.ONE)},e.prototype.neg=function(){return this.negate()},e.prototype.not=function(){return e.fromBits(~this.low,~this.high,this.unsigned)},e.prototype.notEquals=function(e){return!this.equals(e)},e.prototype.neq=function(e){return this.notEquals(e)},e.prototype.ne=function(e){return this.notEquals(e)},e.prototype.or=function(t){return e.isLong(t)||(t=e.fromValue(t)),e.fromBits(this.low|t.low,this.high|t.high,this.unsigned)},e.prototype.shiftLeft=function(t){return e.isLong(t)&&(t=t.toInt()),0==(t&=63)?this:t<32?e.fromBits(this.low<<t,this.high<<t|this.low>>>32-t,this.unsigned):e.fromBits(0,this.low<<t-32,this.unsigned)},e.prototype.shl=function(e){return this.shiftLeft(e)},e.prototype.shiftRight=function(t){return e.isLong(t)&&(t=t.toInt()),0==(t&=63)?this:t<32?e.fromBits(this.low>>>t|this.high<<32-t,this.high>>t,this.unsigned):e.fromBits(this.high>>t-32,this.high>=0?0:-1,this.unsigned)},e.prototype.shr=function(e){return this.shiftRight(e)},e.prototype.shiftRightUnsigned=function(t){if(e.isLong(t)&&(t=t.toInt()),0===(t&=63))return this;var r=this.high;if(t<32){var n=this.low;return e.fromBits(n>>>t|r<<32-t,r>>>t,this.unsigned)}return 32===t?e.fromBits(r,0,this.unsigned):e.fromBits(r>>>t-32,0,this.unsigned)},e.prototype.shr_u=function(e){return this.shiftRightUnsigned(e)},e.prototype.shru=function(e){return this.shiftRightUnsigned(e)},e.prototype.subtract=function(t){return e.isLong(t)||(t=e.fromValue(t)),this.add(t.neg())},e.prototype.sub=function(e){return this.subtract(e)},e.prototype.toInt=function(){return this.unsigned?this.low>>>0:this.low},e.prototype.toNumber=function(){return this.unsigned?(this.high>>>0)*TWO_PWR_32_DBL+(this.low>>>0):this.high*TWO_PWR_32_DBL+(this.low>>>0)},e.prototype.toBigInt=function(){return BigInt(this.toString())},e.prototype.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},e.prototype.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},e.prototype.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},e.prototype.toSigned=function(){return this.unsigned?e.fromBits(this.low,this.high,!1):this},e.prototype.toString=function(t){if((t=t||10)<2||36<t)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(e.MIN_VALUE)){var r=e.fromNumber(t),n=this.div(r),i=n.mul(r).sub(this);return n.toString(t)+i.toInt().toString(t)}return"-"+this.neg().toString(t)}for(var o=e.fromNumber(Math.pow(t,6),this.unsigned),s=this,u="";;){var f=s.div(o),a=(s.sub(f.mul(o)).toInt()>>>0).toString(t);if((s=f).isZero())return a+u;for(;a.length<6;)a="0"+a;u=""+a+u}},e.prototype.toUnsigned=function(){return this.unsigned?this:e.fromBits(this.low,this.high,!0)},e.prototype.xor=function(t){return e.isLong(t)||(t=e.fromValue(t)),e.fromBits(this.low^t.low,this.high^t.high,this.unsigned)},e.prototype.eqz=function(){return this.isZero()},e.prototype.le=function(e){return this.lessThanOrEqual(e)},e.prototype.toExtendedJSON=function(e){return e&&e.relaxed?this.toNumber():{$numberLong:this.toString()}},e.fromExtendedJSON=function(t,r){var n=e.fromString(t.$numberLong);return r&&r.relaxed?n.toNumber():n},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return'new Long("'.concat(this.toString(),'"').concat(this.unsigned?", true":"",")")},e.TWO_PWR_24=e.fromInt(TWO_PWR_24_DBL),e.MAX_UNSIGNED_VALUE=e.fromBits(-1,-1,!0),e.ZERO=e.fromInt(0),e.UZERO=e.fromInt(0,!0),e.ONE=e.fromInt(1),e.UONE=e.fromInt(1,!0),e.NEG_ONE=e.fromInt(-1),e.MAX_VALUE=e.fromBits(-1,2147483647,!1),e.MIN_VALUE=e.fromBits(0,-2147483648,!1),e}();Object.defineProperty(Long.prototype,"__isLong__",{value:!0}),Object.defineProperty(Long.prototype,"_bsontype",{value:"Long"});var PARSE_STRING_REGEXP=/^(\+|-)?(\d+|(\d*\.\d*))?(E|e)?([-+])?(\d+)?$/,PARSE_INF_REGEXP=/^(\+|-)?(Infinity|inf)$/i,PARSE_NAN_REGEXP=/^(\+|-)?NaN$/i,EXPONENT_MAX=6111,EXPONENT_MIN=-6176,EXPONENT_BIAS=6176,MAX_DIGITS=34,NAN_BUFFER=[124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0].reverse(),INF_NEGATIVE_BUFFER=[248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0].reverse(),INF_POSITIVE_BUFFER=[120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0].reverse(),EXPONENT_REGEX=/^([-+])?(\d+)?$/,COMBINATION_MASK=31,EXPONENT_MASK=16383,COMBINATION_INFINITY=30,COMBINATION_NAN=31;function isDigit(e){return!isNaN(parseInt(e,10))}function divideu128(e){var t=Long.fromNumber(1e9),r=Long.fromNumber(0);if(!(e.parts[0]||e.parts[1]||e.parts[2]||e.parts[3]))return{quotient:e,rem:r};for(var n=0;n<=3;n++)r=(r=r.shiftLeft(32)).add(new Long(e.parts[n],0)),e.parts[n]=r.div(t).low,r=r.modulo(t);return{quotient:e,rem:r}}function multiply64x2(e,t){if(!e&&!t)return{high:Long.fromNumber(0),low:Long.fromNumber(0)};var r=e.shiftRightUnsigned(32),n=new Long(e.getLowBits(),0),i=t.shiftRightUnsigned(32),o=new Long(t.getLowBits(),0),s=r.multiply(i),u=r.multiply(o),f=n.multiply(i),a=n.multiply(o);return s=s.add(u.shiftRightUnsigned(32)),u=new Long(u.getLowBits(),0).add(f).add(a.shiftRightUnsigned(32)),{high:s=s.add(u.shiftRightUnsigned(32)),low:a=u.shiftLeft(32).add(new Long(a.getLowBits(),0))}}function lessThan(e,t){var r=e.high>>>0,n=t.high>>>0;return r<n||r===n&&e.low>>>0<t.low>>>0}function invalidErr(e,t){throw new BSONTypeError('"'.concat(e,'" is not a valid Decimal128 string - ').concat(t))}var Decimal128=function(){function e(t){if(!(this instanceof e))return new e(t);if("string"==typeof t)this.bytes=e.fromString(t).bytes;else{if(!isUint8Array(t))throw new BSONTypeError("Decimal128 must take a Buffer or string");if(16!==t.byteLength)throw new BSONTypeError("Decimal128 must take a Buffer of 16 bytes");this.bytes=t}}return e.fromString=function(t){var r,n=!1,i=!1,o=!1,s=0,u=0,f=0,a=0,l=0,c=[0],h=0,p=0,g=0,y=0,d=0,_=0,b=new Long(0,0),N=new Long(0,0),B=0;if(t.length>=7e3)throw new BSONTypeError(t+" not a valid Decimal128 string");var O=t.match(PARSE_STRING_REGEXP),S=t.match(PARSE_INF_REGEXP),m=t.match(PARSE_NAN_REGEXP);if(!O&&!S&&!m||0===t.length)throw new BSONTypeError(t+" not a valid Decimal128 string");if(O){var E=O[2],v=O[4],w=O[5],A=O[6];v&&void 0===A&&invalidErr(t,"missing exponent power"),v&&void 0===E&&invalidErr(t,"missing exponent base"),void 0===v&&(w||A)&&invalidErr(t,"missing e before exponent")}if("+"!==t[B]&&"-"!==t[B]||(n="-"===t[B++]),!isDigit(t[B])&&"."!==t[B]){if("i"===t[B]||"I"===t[B])return new e(Buffer.from(n?INF_NEGATIVE_BUFFER:INF_POSITIVE_BUFFER));if("N"===t[B])return new e(Buffer.from(NAN_BUFFER))}for(;isDigit(t[B])||"."===t[B];)"."!==t[B]?(h<34&&("0"!==t[B]||o)&&(o||(l=u),o=!0,c[p++]=parseInt(t[B],10),h+=1),o&&(f+=1),i&&(a+=1),u+=1,B+=1):(i&&invalidErr(t,"contains multiple periods"),i=!0,B+=1);if(i&&!u)throw new BSONTypeError(t+" not a valid Decimal128 string");if("e"===t[B]||"E"===t[B]){var T=t.substr(++B).match(EXPONENT_REGEX);if(!T||!T[2])return new e(Buffer.from(NAN_BUFFER));d=parseInt(T[0],10),B+=T[0].length}if(t[B])return new e(Buffer.from(NAN_BUFFER));if(g=0,h){if(y=h-1,1!==(s=f))for(;0===c[l+s-1];)s-=1}else g=0,y=0,c[0]=0,f=1,h=1,s=0;for(d<=a&&a-d>16384?d=EXPONENT_MIN:d-=a;d>EXPONENT_MAX;){if((y+=1)-g>MAX_DIGITS){if(c.join("").match(/^0+$/)){d=EXPONENT_MAX;break}invalidErr(t,"overflow")}d-=1}for(;d<EXPONENT_MIN||h<f;){if(0===y&&s<h){d=EXPONENT_MIN,s=0;break}if(h<f?f-=1:y-=1,d<EXPONENT_MAX)d+=1;else{if(c.join("").match(/^0+$/)){d=EXPONENT_MAX;break}invalidErr(t,"overflow")}}if(y-g+1<s){var I=u;i&&(l+=1,I+=1),n&&(l+=1,I+=1);var x=parseInt(t[l+y+1],10),D=0;if(x>=5&&(D=1,5===x))for(D=c[y]%2==1?1:0,_=l+y+2;_<I;_++)if(parseInt(t[_],10)){D=1;break}if(D)for(var R=y;R>=0;R--)if(++c[R]>9&&(c[R]=0,0===R)){if(!(d<EXPONENT_MAX))return new e(Buffer.from(n?INF_NEGATIVE_BUFFER:INF_POSITIVE_BUFFER));d+=1,c[R]=1}}if(b=Long.fromNumber(0),N=Long.fromNumber(0),0===s)b=Long.fromNumber(0),N=Long.fromNumber(0);else if(y-g<17){R=g;for(N=Long.fromNumber(c[R++]),b=new Long(0,0);R<=y;R++)N=(N=N.multiply(Long.fromNumber(10))).add(Long.fromNumber(c[R]))}else{R=g;for(b=Long.fromNumber(c[R++]);R<=y-17;R++)b=(b=b.multiply(Long.fromNumber(10))).add(Long.fromNumber(c[R]));for(N=Long.fromNumber(c[R++]);R<=y;R++)N=(N=N.multiply(Long.fromNumber(10))).add(Long.fromNumber(c[R]))}var L=multiply64x2(b,Long.fromString("100000000000000000"));L.low=L.low.add(N),lessThan(L.low,N)&&(L.high=L.high.add(Long.fromNumber(1))),r=d+EXPONENT_BIAS;var U={low:Long.fromNumber(0),high:Long.fromNumber(0)};L.high.shiftRightUnsigned(49).and(Long.fromNumber(1)).equals(Long.fromNumber(1))?(U.high=U.high.or(Long.fromNumber(3).shiftLeft(61)),U.high=U.high.or(Long.fromNumber(r).and(Long.fromNumber(16383).shiftLeft(47))),U.high=U.high.or(L.high.and(Long.fromNumber(0x7fffffffffff)))):(U.high=U.high.or(Long.fromNumber(16383&r).shiftLeft(49)),U.high=U.high.or(L.high.and(Long.fromNumber(562949953421311)))),U.low=L.low,n&&(U.high=U.high.or(Long.fromString("9223372036854775808")));var j=Buffer.alloc(16);return B=0,j[B++]=255&U.low.low,j[B++]=U.low.low>>8&255,j[B++]=U.low.low>>16&255,j[B++]=U.low.low>>24&255,j[B++]=255&U.low.high,j[B++]=U.low.high>>8&255,j[B++]=U.low.high>>16&255,j[B++]=U.low.high>>24&255,j[B++]=255&U.high.low,j[B++]=U.high.low>>8&255,j[B++]=U.high.low>>16&255,j[B++]=U.high.low>>24&255,j[B++]=255&U.high.high,j[B++]=U.high.high>>8&255,j[B++]=U.high.high>>16&255,j[B++]=U.high.high>>24&255,new e(j)},e.prototype.toString=function(){for(var e,t=0,r=new Array(36),n=0;n<r.length;n++)r[n]=0;var i,o,s,u=0,f=!1,a={parts:[0,0,0,0]},l=[];u=0;var c=this.bytes,h=c[u++]|c[u++]<<8|c[u++]<<16|c[u++]<<24,p=c[u++]|c[u++]<<8|c[u++]<<16|c[u++]<<24,g=c[u++]|c[u++]<<8|c[u++]<<16|c[u++]<<24,y=c[u++]|c[u++]<<8|c[u++]<<16|c[u++]<<24;u=0,{low:new Long(h,p),high:new Long(g,y)}.high.lessThan(Long.ZERO)&&l.push("-");var d=y>>26&COMBINATION_MASK;if(d>>3==3){if(d===COMBINATION_INFINITY)return l.join("")+"Infinity";if(d===COMBINATION_NAN)return"NaN";e=y>>15&EXPONENT_MASK,i=8+(y>>14&1)}else i=y>>14&7,e=y>>17&EXPONENT_MASK;var _=e-EXPONENT_BIAS;if(a.parts[0]=(16383&y)+((15&i)<<14),a.parts[1]=g,a.parts[2]=p,a.parts[3]=h,0===a.parts[0]&&0===a.parts[1]&&0===a.parts[2]&&0===a.parts[3])f=!0;else for(s=3;s>=0;s--){var b=0,N=divideu128(a);if(a=N.quotient,b=N.rem.low)for(o=8;o>=0;o--)r[9*s+o]=b%10,b=Math.floor(b/10)}if(f)t=1,r[u]=0;else for(t=36;!r[u];)t-=1,u+=1;var B=t-1+_;if(B>=34||B<=-7||_>0){if(t>34)return l.push("".concat(0)),_>0?l.push("E+".concat(_)):_<0&&l.push("E".concat(_)),l.join("");l.push("".concat(r[u++])),(t-=1)&&l.push(".");for(n=0;n<t;n++)l.push("".concat(r[u++]));l.push("E"),B>0?l.push("+".concat(B)):l.push("".concat(B))}else if(_>=0)for(n=0;n<t;n++)l.push("".concat(r[u++]));else{var O=t+_;if(O>0)for(n=0;n<O;n++)l.push("".concat(r[u++]));else l.push("0");for(l.push(".");O++<0;)l.push("0");for(n=0;n<t-Math.max(O-1,0);n++)l.push("".concat(r[u++]))}return l.join("")},e.prototype.toJSON=function(){return{$numberDecimal:this.toString()}},e.prototype.toExtendedJSON=function(){return{$numberDecimal:this.toString()}},e.fromExtendedJSON=function(t){return e.fromString(t.$numberDecimal)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return'new Decimal128("'.concat(this.toString(),'")')},e}();Object.defineProperty(Decimal128.prototype,"_bsontype",{value:"Decimal128"});var Double=function(){function e(t){if(!(this instanceof e))return new e(t);t instanceof Number&&(t=t.valueOf()),this.value=+t}return e.prototype.valueOf=function(){return this.value},e.prototype.toJSON=function(){return this.value},e.prototype.toString=function(e){return this.value.toString(e)},e.prototype.toExtendedJSON=function(e){return e&&(e.legacy||e.relaxed&&isFinite(this.value))?this.value:Object.is(Math.sign(this.value),-0)?{$numberDouble:"-".concat(this.value.toFixed(1))}:(Number.isInteger(this.value)?(t=this.value.toFixed(1)).length>=13&&(t=this.value.toExponential(13).toUpperCase()):t=this.value.toString(),{$numberDouble:t});var t},e.fromExtendedJSON=function(t,r){var n=parseFloat(t.$numberDouble);return r&&r.relaxed?n:new e(n)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){var e=this.toExtendedJSON();return"new Double(".concat(e.$numberDouble,")")},e}();Object.defineProperty(Double.prototype,"_bsontype",{value:"Double"});var Int32=function(){function e(t){if(!(this instanceof e))return new e(t);t instanceof Number&&(t=t.valueOf()),this.value=0|+t}return e.prototype.valueOf=function(){return this.value},e.prototype.toString=function(e){return this.value.toString(e)},e.prototype.toJSON=function(){return this.value},e.prototype.toExtendedJSON=function(e){return e&&(e.relaxed||e.legacy)?this.value:{$numberInt:this.value.toString()}},e.fromExtendedJSON=function(t,r){return r&&r.relaxed?parseInt(t.$numberInt,10):new e(t.$numberInt)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return"new Int32(".concat(this.valueOf(),")")},e}();Object.defineProperty(Int32.prototype,"_bsontype",{value:"Int32"});var MaxKey=function(){function e(){if(!(this instanceof e))return new e}return e.prototype.toExtendedJSON=function(){return{$maxKey:1}},e.fromExtendedJSON=function(){return new e},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return"new MaxKey()"},e}();Object.defineProperty(MaxKey.prototype,"_bsontype",{value:"MaxKey"});var MinKey=function(){function e(){if(!(this instanceof e))return new e}return e.prototype.toExtendedJSON=function(){return{$minKey:1}},e.fromExtendedJSON=function(){return new e},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return"new MinKey()"},e}();Object.defineProperty(MinKey.prototype,"_bsontype",{value:"MinKey"});var checkForHexRegExp=new RegExp("^[0-9a-fA-F]{24}$"),PROCESS_UNIQUE=null,kId=Symbol("id"),ObjectId=function(){function e(t){if(!(this instanceof e))return new e(t);var r;if("object"==typeof t&&t&&"id"in t){if("string"!=typeof t.id&&!ArrayBuffer.isView(t.id))throw new BSONTypeError("Argument passed in must have an id that is of type string or Buffer");r="toHexString"in t&&"function"==typeof t.toHexString?Buffer.from(t.toHexString(),"hex"):t.id}else r=t;if(null==r||"number"==typeof r)this[kId]=e.generate("number"==typeof r?r:void 0);else if(ArrayBuffer.isView(r)&&12===r.byteLength)this[kId]=r instanceof Buffer?r:ensureBuffer(r);else{if("string"!=typeof r)throw new BSONTypeError("Argument passed in does not match the accepted types");if(12===r.length){var n=Buffer.from(r);if(12!==n.byteLength)throw new BSONTypeError("Argument passed in must be a string of 12 bytes");this[kId]=n}else{if(24!==r.length||!checkForHexRegExp.test(r))throw new BSONTypeError("Argument passed in must be a string of 12 bytes or a string of 24 hex characters or an integer");this[kId]=Buffer.from(r,"hex")}}e.cacheHexString&&(this.__id=this.id.toString("hex"))}return Object.defineProperty(e.prototype,"id",{get:function(){return this[kId]},set:function(t){this[kId]=t,e.cacheHexString&&(this.__id=t.toString("hex"))},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"generationTime",{get:function(){return this.id.readInt32BE(0)},set:function(e){this.id.writeUInt32BE(e,0)},enumerable:!1,configurable:!0}),e.prototype.toHexString=function(){if(e.cacheHexString&&this.__id)return this.__id;var t=this.id.toString("hex");return e.cacheHexString&&!this.__id&&(this.__id=t),t},e.getInc=function(){return e.index=(e.index+1)%16777215},e.generate=function(t){"number"!=typeof t&&(t=Math.floor(Date.now()/1e3));var r=e.getInc(),n=Buffer.alloc(12);return n.writeUInt32BE(t,0),null===PROCESS_UNIQUE&&(PROCESS_UNIQUE=randomBytes(5)),n[4]=PROCESS_UNIQUE[0],n[5]=PROCESS_UNIQUE[1],n[6]=PROCESS_UNIQUE[2],n[7]=PROCESS_UNIQUE[3],n[8]=PROCESS_UNIQUE[4],n[11]=255&r,n[10]=r>>8&255,n[9]=r>>16&255,n},e.prototype.toString=function(e){return e?this.id.toString(e):this.toHexString()},e.prototype.toJSON=function(){return this.toHexString()},e.prototype.equals=function(t){if(null==t)return!1;if(t instanceof e)return this[kId][11]===t[kId][11]&&this[kId].equals(t[kId]);if("string"==typeof t&&e.isValid(t)&&12===t.length&&isUint8Array(this.id))return t===Buffer.prototype.toString.call(this.id,"latin1");if("string"==typeof t&&e.isValid(t)&&24===t.length)return t.toLowerCase()===this.toHexString();if("string"==typeof t&&e.isValid(t)&&12===t.length)return Buffer.from(t).equals(this.id);if("object"==typeof t&&"toHexString"in t&&"function"==typeof t.toHexString){var r=t.toHexString(),n=this.toHexString().toLowerCase();return"string"==typeof r&&r.toLowerCase()===n}return!1},e.prototype.getTimestamp=function(){var e=new Date,t=this.id.readUInt32BE(0);return e.setTime(1e3*Math.floor(t)),e},e.createPk=function(){return new e},e.createFromTime=function(t){var r=Buffer.from([0,0,0,0,0,0,0,0,0,0,0,0]);return r.writeUInt32BE(t,0),new e(r)},e.createFromHexString=function(t){if(void 0===t||null!=t&&24!==t.length)throw new BSONTypeError("Argument passed in must be a single String of 12 bytes or a string of 24 hex characters");return new e(Buffer.from(t,"hex"))},e.isValid=function(t){if(null==t)return!1;try{return new e(t),!0}catch(e){return!1}},e.prototype.toExtendedJSON=function(){return this.toHexString?{$oid:this.toHexString()}:{$oid:this.toString("hex")}},e.fromExtendedJSON=function(t){return new e(t.$oid)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return'new ObjectId("'.concat(this.toHexString(),'")')},e.index=Math.floor(16777215*Math.random()),e}();function alphabetize(e){return e.split("").sort().join("")}Object.defineProperty(ObjectId.prototype,"generate",{value:deprecate((function(e){return ObjectId.generate(e)}),"Please use the static `ObjectId.generate(time)` instead")}),Object.defineProperty(ObjectId.prototype,"getInc",{value:deprecate((function(){return ObjectId.getInc()}),"Please use the static `ObjectId.getInc()` instead")}),Object.defineProperty(ObjectId.prototype,"get_inc",{value:deprecate((function(){return ObjectId.getInc()}),"Please use the static `ObjectId.getInc()` instead")}),Object.defineProperty(ObjectId,"get_inc",{value:deprecate((function(){return ObjectId.getInc()}),"Please use the static `ObjectId.getInc()` instead")}),Object.defineProperty(ObjectId.prototype,"_bsontype",{value:"ObjectID"});var BSONRegExp=function(){function e(t,r){if(!(this instanceof e))return new e(t,r);if(this.pattern=t,this.options=alphabetize(null!=r?r:""),-1!==this.pattern.indexOf("\0"))throw new BSONError("BSON Regex patterns cannot contain null bytes, found: ".concat(JSON.stringify(this.pattern)));if(-1!==this.options.indexOf("\0"))throw new BSONError("BSON Regex options cannot contain null bytes, found: ".concat(JSON.stringify(this.options)));for(var n=0;n<this.options.length;n++)if("i"!==this.options[n]&&"m"!==this.options[n]&&"x"!==this.options[n]&&"l"!==this.options[n]&&"s"!==this.options[n]&&"u"!==this.options[n])throw new BSONError("The regular expression option [".concat(this.options[n],"] is not supported"))}return e.parseOptions=function(e){return e?e.split("").sort().join(""):""},e.prototype.toExtendedJSON=function(e){return(e=e||{}).legacy?{$regex:this.pattern,$options:this.options}:{$regularExpression:{pattern:this.pattern,options:this.options}}},e.fromExtendedJSON=function(t){if("$regex"in t){if("string"==typeof t.$regex)return new e(t.$regex,e.parseOptions(t.$options));if("BSONRegExp"===t.$regex._bsontype)return t}if("$regularExpression"in t)return new e(t.$regularExpression.pattern,e.parseOptions(t.$regularExpression.options));throw new BSONTypeError("Unexpected BSONRegExp EJSON object form: ".concat(JSON.stringify(t)))},e}();Object.defineProperty(BSONRegExp.prototype,"_bsontype",{value:"BSONRegExp"});var BSONSymbol=function(){function e(t){if(!(this instanceof e))return new e(t);this.value=t}return e.prototype.valueOf=function(){return this.value},e.prototype.toString=function(){return this.value},e.prototype.inspect=function(){return'new BSONSymbol("'.concat(this.value,'")')},e.prototype.toJSON=function(){return this.value},e.prototype.toExtendedJSON=function(){return{$symbol:this.value}},e.fromExtendedJSON=function(t){return new e(t.$symbol)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e}();Object.defineProperty(BSONSymbol.prototype,"_bsontype",{value:"Symbol"});var LongWithoutOverridesClass=Long,Timestamp=function(e){function t(r,n){var i=this;return i instanceof t?(i=Long.isLong(r)?e.call(this,r.low,r.high,!0)||this:isObjectLike(r)&&void 0!==r.t&&void 0!==r.i?e.call(this,r.i,r.t,!0)||this:e.call(this,r,n,!0)||this,Object.defineProperty(i,"_bsontype",{value:"Timestamp",writable:!1,configurable:!1,enumerable:!1}),i):new t(r,n)}return __extends(t,e),t.prototype.toJSON=function(){return{$timestamp:this.toString()}},t.fromInt=function(e){return new t(Long.fromInt(e,!0))},t.fromNumber=function(e){return new t(Long.fromNumber(e,!0))},t.fromBits=function(e,r){return new t(e,r)},t.fromString=function(e,r){return new t(Long.fromString(e,!0,r))},t.prototype.toExtendedJSON=function(){return{$timestamp:{t:this.high>>>0,i:this.low>>>0}}},t.fromExtendedJSON=function(e){return new t(e.$timestamp)},t.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},t.prototype.inspect=function(){return"new Timestamp({ t: ".concat(this.getHighBits(),", i: ").concat(this.getLowBits()," })")},t.MAX_VALUE=Long.MAX_UNSIGNED_VALUE,t}(LongWithoutOverridesClass);function isBSONType(e){return isObjectLike(e)&&Reflect.has(e,"_bsontype")&&"string"==typeof e._bsontype}var BSON_INT32_MAX$1=2147483647,BSON_INT32_MIN$1=-2147483648,BSON_INT64_MAX$1=0x8000000000000000,BSON_INT64_MIN$1=-0x8000000000000000,keysToCodecs={$oid:ObjectId,$binary:Binary,$uuid:Binary,$symbol:BSONSymbol,$numberInt:Int32,$numberDecimal:Decimal128,$numberDouble:Double,$numberLong:Long,$minKey:MinKey,$maxKey:MaxKey,$regex:BSONRegExp,$regularExpression:BSONRegExp,$timestamp:Timestamp};function deserializeValue(e,t){if(void 0===t&&(t={}),"number"==typeof e){if(t.relaxed||t.legacy)return e;if(Math.floor(e)===e){if(e>=BSON_INT32_MIN$1&&e<=BSON_INT32_MAX$1)return new Int32(e);if(e>=BSON_INT64_MIN$1&&e<=BSON_INT64_MAX$1)return Long.fromNumber(e)}return new Double(e)}if(null==e||"object"!=typeof e)return e;if(e.$undefined)return null;for(var r=Object.keys(e).filter((function(t){return t.startsWith("$")&&null!=e[t]})),n=0;n<r.length;n++){var i=keysToCodecs[r[n]];if(i)return i.fromExtendedJSON(e,t)}if(null!=e.$date){var o=e.$date,s=new Date;return t.legacy?"number"==typeof o?s.setTime(o):"string"==typeof o&&s.setTime(Date.parse(o)):"string"==typeof o?s.setTime(Date.parse(o)):Long.isLong(o)?s.setTime(o.toNumber()):"number"==typeof o&&t.relaxed&&s.setTime(o),s}if(null!=e.$code){var u=Object.assign({},e);return e.$scope&&(u.$scope=deserializeValue(e.$scope)),Code.fromExtendedJSON(e)}if(isDBRefLike(e)||e.$dbPointer){var f=e.$ref?e:e.$dbPointer;if(f instanceof DBRef)return f;var a=Object.keys(f).filter((function(e){return e.startsWith("$")})),l=!0;if(a.forEach((function(e){-1===["$ref","$id","$db"].indexOf(e)&&(l=!1)})),l)return DBRef.fromExtendedJSON(f)}return e}function serializeArray(e,t){return e.map((function(e,r){t.seenObjects.push({propertyName:"index ".concat(r),obj:null});try{return serializeValue(e,t)}finally{t.seenObjects.pop()}}))}function getISOString(e){var t=e.toISOString();return 0!==e.getUTCMilliseconds()?t:t.slice(0,-5)+"Z"}function serializeValue(e,t){if(("object"==typeof e||"function"==typeof e)&&null!==e){var r=t.seenObjects.findIndex((function(t){return t.obj===e}));if(-1!==r){var n=t.seenObjects.map((function(e){return e.propertyName})),i=n.slice(0,r).map((function(e){return"".concat(e," -> ")})).join(""),o=n[r],s=" -> "+n.slice(r+1,n.length-1).map((function(e){return"".concat(e," -> ")})).join(""),u=n[n.length-1],f=" ".repeat(i.length+o.length/2),a="-".repeat(s.length+(o.length+u.length)/2-1);throw new BSONTypeError("Converting circular structure to EJSON:\n"+"    ".concat(i).concat(o).concat(s).concat(u,"\n")+"    ".concat(f,"\\").concat(a,"/"))}t.seenObjects[t.seenObjects.length-1].obj=e}if(Array.isArray(e))return serializeArray(e,t);if(void 0===e)return null;if(e instanceof Date||isDate(e)){var l=e.getTime(),c=l>-1&&l<2534023188e5;return t.legacy?t.relaxed&&c?{$date:e.getTime()}:{$date:getISOString(e)}:t.relaxed&&c?{$date:getISOString(e)}:{$date:{$numberLong:e.getTime().toString()}}}if(!("number"!=typeof e||t.relaxed&&isFinite(e))){if(Math.floor(e)===e){var h=e>=BSON_INT64_MIN$1&&e<=BSON_INT64_MAX$1;if(e>=BSON_INT32_MIN$1&&e<=BSON_INT32_MAX$1)return{$numberInt:e.toString()};if(h)return{$numberLong:e.toString()}}return{$numberDouble:e.toString()}}if(e instanceof RegExp||isRegExp(e)){var p=e.flags;if(void 0===p){var g=e.toString().match(/[gimuy]*$/);g&&(p=g[0])}return new BSONRegExp(e.source,p).toExtendedJSON(t)}return null!=e&&"object"==typeof e?serializeDocument(e,t):e}var EJSON,bsonMap,BSON_TYPE_MAPPINGS={Binary:function(e){return new Binary(e.value(),e.sub_type)},Code:function(e){return new Code(e.code,e.scope)},DBRef:function(e){return new DBRef(e.collection||e.namespace,e.oid,e.db,e.fields)},Decimal128:function(e){return new Decimal128(e.bytes)},Double:function(e){return new Double(e.value)},Int32:function(e){return new Int32(e.value)},Long:function(e){return Long.fromBits(null!=e.low?e.low:e.low_,null!=e.low?e.high:e.high_,null!=e.low?e.unsigned:e.unsigned_)},MaxKey:function(){return new MaxKey},MinKey:function(){return new MinKey},ObjectID:function(e){return new ObjectId(e)},ObjectId:function(e){return new ObjectId(e)},BSONRegExp:function(e){return new BSONRegExp(e.pattern,e.options)},Symbol:function(e){return new BSONSymbol(e.value)},Timestamp:function(e){return Timestamp.fromBits(e.low,e.high)}};function serializeDocument(e,t){if(null==e||"object"!=typeof e)throw new BSONError("not an object instance");var r=e._bsontype;if(void 0===r){var n={};for(var i in e){t.seenObjects.push({propertyName:i,obj:null});try{var o=serializeValue(e[i],t);"__proto__"===i?Object.defineProperty(n,i,{value:o,writable:!0,enumerable:!0,configurable:!0}):n[i]=o}finally{t.seenObjects.pop()}}return n}if(isBSONType(e)){var s=e;if("function"!=typeof s.toExtendedJSON){var u=BSON_TYPE_MAPPINGS[e._bsontype];if(!u)throw new BSONTypeError("Unrecognized or invalid _bsontype: "+e._bsontype);s=u(s)}return"Code"===r&&s.scope?s=new Code(s.code,serializeValue(s.scope,t)):"DBRef"===r&&s.oid&&(s=new DBRef(serializeValue(s.collection,t),serializeValue(s.oid,t),serializeValue(s.db,t),serializeValue(s.fields,t))),s.toExtendedJSON(t)}throw new BSONError("_bsontype must be a string, but was: "+typeof r)}!function(e){function t(e,t){var r=Object.assign({},{relaxed:!0,legacy:!1},t);return"boolean"==typeof r.relaxed&&(r.strict=!r.relaxed),"boolean"==typeof r.strict&&(r.relaxed=!r.strict),JSON.parse(e,(function(e,t){if(-1!==e.indexOf("\0"))throw new BSONError("BSON Document field names cannot contain null bytes, found: ".concat(JSON.stringify(e)));return deserializeValue(t,r)}))}function r(e,t,r,n){null!=r&&"object"==typeof r&&(n=r,r=0),null==t||"object"!=typeof t||Array.isArray(t)||(n=t,t=void 0,r=0);var i=serializeValue(e,Object.assign({relaxed:!0,legacy:!1},n,{seenObjects:[{propertyName:"(root)",obj:null}]}));return JSON.stringify(i,t,r)}e.parse=t,e.stringify=r,e.serialize=function(e,t){return t=t||{},JSON.parse(r(e,t))},e.deserialize=function(e,r){return r=r||{},t(JSON.stringify(e),r)}}(EJSON||(EJSON={}));var bsonGlobal=getGlobal();bsonMap=bsonGlobal.Map?bsonGlobal.Map:function(){function e(e){void 0===e&&(e=[]),this._keys=[],this._values={};for(var t=0;t<e.length;t++)if(null!=e[t]){var r=e[t],n=r[0],i=r[1];this._keys.push(n),this._values[n]={v:i,i:this._keys.length-1}}}return e.prototype.clear=function(){this._keys=[],this._values={}},e.prototype.delete=function(e){var t=this._values[e];return null!=t&&(delete this._values[e],this._keys.splice(t.i,1),!0)},e.prototype.entries=function(){var e=this,t=0;return{next:function(){var r=e._keys[t++];return{value:void 0!==r?[r,e._values[r].v]:void 0,done:void 0===r}}}},e.prototype.forEach=function(e,t){t=t||this;for(var r=0;r<this._keys.length;r++){var n=this._keys[r];e.call(t,this._values[n].v,n,t)}},e.prototype.get=function(e){return this._values[e]?this._values[e].v:void 0},e.prototype.has=function(e){return null!=this._values[e]},e.prototype.keys=function(){var e=this,t=0;return{next:function(){var r=e._keys[t++];return{value:void 0!==r?r:void 0,done:void 0===r}}}},e.prototype.set=function(e,t){return this._values[e]?(this._values[e].v=t,this):(this._keys.push(e),this._values[e]={v:t,i:this._keys.length-1},this)},e.prototype.values=function(){var e=this,t=0;return{next:function(){var r=e._keys[t++];return{value:void 0!==r?e._values[r].v:void 0,done:void 0===r}}}},Object.defineProperty(e.prototype,"size",{get:function(){return this._keys.length},enumerable:!1,configurable:!0}),e}();var BSON_INT32_MAX=2147483647,BSON_INT32_MIN=-2147483648,BSON_INT64_MAX=Math.pow(2,63)-1,BSON_INT64_MIN=-Math.pow(2,63),JS_INT_MAX=Math.pow(2,53),JS_INT_MIN=-Math.pow(2,53),BSON_DATA_NUMBER=1,BSON_DATA_STRING=2,BSON_DATA_OBJECT=3,BSON_DATA_ARRAY=4,BSON_DATA_BINARY=5,BSON_DATA_UNDEFINED=6,BSON_DATA_OID=7,BSON_DATA_BOOLEAN=8,BSON_DATA_DATE=9,BSON_DATA_NULL=10,BSON_DATA_REGEXP=11,BSON_DATA_DBPOINTER=12,BSON_DATA_CODE=13,BSON_DATA_SYMBOL=14,BSON_DATA_CODE_W_SCOPE=15,BSON_DATA_INT=16,BSON_DATA_TIMESTAMP=17,BSON_DATA_LONG=18,BSON_DATA_DECIMAL128=19,BSON_DATA_MIN_KEY=255,BSON_DATA_MAX_KEY=127,BSON_BINARY_SUBTYPE_DEFAULT=0,BSON_BINARY_SUBTYPE_FUNCTION=1,BSON_BINARY_SUBTYPE_BYTE_ARRAY=2,BSON_BINARY_SUBTYPE_UUID=3,BSON_BINARY_SUBTYPE_UUID_NEW=4,BSON_BINARY_SUBTYPE_MD5=5,BSON_BINARY_SUBTYPE_ENCRYPTED=6,BSON_BINARY_SUBTYPE_COLUMN=7,BSON_BINARY_SUBTYPE_USER_DEFINED=128;function calculateObjectSize$1(e,t,r){var n=5;if(Array.isArray(e))for(var i=0;i<e.length;i++)n+=calculateElement(i.toString(),e[i],t,!0,r);else for(var o in"function"==typeof(null==e?void 0:e.toBSON)&&(e=e.toBSON()),e)n+=calculateElement(o,e[o],t,!1,r);return n}function calculateElement(e,t,r,n,i){switch(void 0===r&&(r=!1),void 0===n&&(n=!1),void 0===i&&(i=!1),"function"==typeof(null==t?void 0:t.toBSON)&&(t=t.toBSON()),typeof t){case"string":return 1+Buffer.byteLength(e,"utf8")+1+4+Buffer.byteLength(t,"utf8")+1;case"number":return Math.floor(t)===t&&t>=JS_INT_MIN&&t<=JS_INT_MAX&&t>=BSON_INT32_MIN&&t<=BSON_INT32_MAX?(null!=e?Buffer.byteLength(e,"utf8")+1:0)+5:(null!=e?Buffer.byteLength(e,"utf8")+1:0)+9;case"undefined":return n||!i?(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1:0;case"boolean":return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+2;case"object":if(null==t||"MinKey"===t._bsontype||"MaxKey"===t._bsontype)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1;if("ObjectId"===t._bsontype||"ObjectID"===t._bsontype)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+13;if(t instanceof Date||isDate(t))return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+9;if(ArrayBuffer.isView(t)||t instanceof ArrayBuffer||isAnyArrayBuffer(t))return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+6+t.byteLength;if("Long"===t._bsontype||"Double"===t._bsontype||"Timestamp"===t._bsontype)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+9;if("Decimal128"===t._bsontype)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+17;if("Code"===t._bsontype)return null!=t.scope&&Object.keys(t.scope).length>0?(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+4+4+Buffer.byteLength(t.code.toString(),"utf8")+1+calculateObjectSize$1(t.scope,r,i):(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+4+Buffer.byteLength(t.code.toString(),"utf8")+1;if("Binary"===t._bsontype){var o=t;return o.sub_type===Binary.SUBTYPE_BYTE_ARRAY?(null!=e?Buffer.byteLength(e,"utf8")+1:0)+(o.position+1+4+1+4):(null!=e?Buffer.byteLength(e,"utf8")+1:0)+(o.position+1+4+1)}if("Symbol"===t._bsontype)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+Buffer.byteLength(t.value,"utf8")+4+1+1;if("DBRef"===t._bsontype){var s=Object.assign({$ref:t.collection,$id:t.oid},t.fields);return null!=t.db&&(s.$db=t.db),(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+calculateObjectSize$1(s,r,i)}return t instanceof RegExp||isRegExp(t)?(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+Buffer.byteLength(t.source,"utf8")+1+(t.global?1:0)+(t.ignoreCase?1:0)+(t.multiline?1:0)+1:"BSONRegExp"===t._bsontype?(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+Buffer.byteLength(t.pattern,"utf8")+1+Buffer.byteLength(t.options,"utf8")+1:(null!=e?Buffer.byteLength(e,"utf8")+1:0)+calculateObjectSize$1(t,r,i)+1;case"function":if(t instanceof RegExp||isRegExp(t)||"[object RegExp]"===String.call(t))return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+Buffer.byteLength(t.source,"utf8")+1+(t.global?1:0)+(t.ignoreCase?1:0)+(t.multiline?1:0)+1;if(r&&null!=t.scope&&Object.keys(t.scope).length>0)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+4+4+Buffer.byteLength(normalizedFunctionString(t),"utf8")+1+calculateObjectSize$1(t.scope,r,i);if(r)return(null!=e?Buffer.byteLength(e,"utf8")+1:0)+1+4+Buffer.byteLength(normalizedFunctionString(t),"utf8")+1}return 0}var FIRST_BIT=128,FIRST_TWO_BITS=192,FIRST_THREE_BITS=224,FIRST_FOUR_BITS=240,FIRST_FIVE_BITS=248,TWO_BIT_CHAR=192,THREE_BIT_CHAR=224,FOUR_BIT_CHAR=240,CONTINUING_CHAR=128;function validateUtf8(e,t,r){for(var n=0,i=t;i<r;i+=1){var o=e[i];if(n){if((o&FIRST_TWO_BITS)!==CONTINUING_CHAR)return!1;n-=1}else if(o&FIRST_BIT)if((o&FIRST_THREE_BITS)===TWO_BIT_CHAR)n=1;else if((o&FIRST_FOUR_BITS)===THREE_BIT_CHAR)n=2;else{if((o&FIRST_FIVE_BITS)!==FOUR_BIT_CHAR)return!1;n=3}}return!n}var JS_INT_MAX_LONG=Long.fromNumber(JS_INT_MAX),JS_INT_MIN_LONG=Long.fromNumber(JS_INT_MIN),functionCache={};function deserialize$1(e,t,r){var n=(t=null==t?{}:t)&&t.index?t.index:0,i=e[n]|e[n+1]<<8|e[n+2]<<16|e[n+3]<<24;if(i<5)throw new BSONError("bson size must be >= 5, is ".concat(i));if(t.allowObjectSmallerThanBufferSize&&e.length<i)throw new BSONError("buffer length ".concat(e.length," must be >= bson size ").concat(i));if(!t.allowObjectSmallerThanBufferSize&&e.length!==i)throw new BSONError("buffer length ".concat(e.length," must === bson size ").concat(i));if(i+n>e.byteLength)throw new BSONError("(bson size ".concat(i," + options.index ").concat(n," must be <= buffer length ").concat(e.byteLength,")"));if(0!==e[n+i-1])throw new BSONError("One object, sized correctly, with a spot for an EOO, but the EOO isn't 0x00");return deserializeObject(e,n,t,r)}var allowedDBRefKeys=/^\$ref$|^\$id$|^\$db$/;function deserializeObject(e,t,r,n){void 0===n&&(n=!1);var i,o=null!=r.evalFunctions&&r.evalFunctions,s=null!=r.cacheFunctions&&r.cacheFunctions,u=null==r.fieldsAsRaw?null:r.fieldsAsRaw,f=null!=r.raw&&r.raw,a="boolean"==typeof r.bsonRegExp&&r.bsonRegExp,l=null!=r.promoteBuffers&&r.promoteBuffers,c=null==r.promoteLongs||r.promoteLongs,h=null==r.promoteValues||r.promoteValues,p=null==r.validation?{utf8:!0}:r.validation,g=!0,y=new Set,d=p.utf8;if("boolean"==typeof d)i=d;else{g=!1;var _=Object.keys(d).map((function(e){return d[e]}));if(0===_.length)throw new BSONError("UTF-8 validation setting cannot be empty");if("boolean"!=typeof _[0])throw new BSONError("Invalid UTF-8 validation option, must specify boolean values");if(i=_[0],!_.every((function(e){return e===i})))throw new BSONError("Invalid UTF-8 validation option - keys must be all true or all false")}if(!g)for(var b=0,N=Object.keys(d);b<N.length;b++){var B=N[b];y.add(B)}var O=t;if(e.length<5)throw new BSONError("corrupt bson message < 5 bytes long");var S=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24;if(S<5||S>e.length)throw new BSONError("corrupt bson message");for(var m=n?[]:{},E=0,v=!n&&null,w=new DataView(e.buffer,e.byteOffset,e.byteLength);;){var A=e[t++];if(0===A)break;for(var T=t;0!==e[T]&&T<e.length;)T++;if(T>=e.byteLength)throw new BSONError("Bad BSON Document: illegal CString");var I=n?E++:e.toString("utf8",t,T),x=!0;x=g||y.has(I)?i:!i,!1!==v&&"$"===I[0]&&(v=allowedDBRefKeys.test(I));var D=void 0;if(t=T+1,A===BSON_DATA_STRING){if((te=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<=0||te>e.length-t||0!==e[t+te-1])throw new BSONError("bad string length in bson");D=getValidatedString(e,t,t+te-1,x),t+=te}else if(A===BSON_DATA_OID){var R=Buffer.alloc(12);e.copy(R,0,t,t+12),D=new ObjectId(R),t+=12}else if(A===BSON_DATA_INT&&!1===h)D=new Int32(e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24);else if(A===BSON_DATA_INT)D=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24;else if(A===BSON_DATA_NUMBER&&!1===h)D=new Double(w.getFloat64(t,!0)),t+=8;else if(A===BSON_DATA_NUMBER)D=w.getFloat64(t,!0),t+=8;else if(A===BSON_DATA_DATE){var L=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24,U=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24;D=new Date(new Long(L,U).toNumber())}else if(A===BSON_DATA_BOOLEAN){if(0!==e[t]&&1!==e[t])throw new BSONError("illegal boolean type value");D=1===e[t++]}else if(A===BSON_DATA_OBJECT){var j=t;if((Q=e[t]|e[t+1]<<8|e[t+2]<<16|e[t+3]<<24)<=0||Q>e.length-t)throw new BSONError("bad embedded document length in bson");if(f)D=e.slice(t,t+Q);else{var M=r;g||(M=_assign(_assign({},r),{validation:{utf8:x}})),D=deserializeObject(e,j,M,!1)}t+=Q}else if(A===BSON_DATA_ARRAY){j=t;var z=r,P=t+(Q=e[t]|e[t+1]<<8|e[t+2]<<16|e[t+3]<<24);if(u&&u[I]){for(var $ in z={},r)z[$]=r[$];z.raw=!0}if(g||(z=_assign(_assign({},z),{validation:{utf8:x}})),D=deserializeObject(e,j,z,!0),0!==e[(t+=Q)-1])throw new BSONError("invalid array terminator byte");if(t!==P)throw new BSONError("corrupted array bson")}else if(A===BSON_DATA_UNDEFINED)D=void 0;else if(A===BSON_DATA_NULL)D=null;else if(A===BSON_DATA_LONG){L=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24,U=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24;var F=new Long(L,U);D=c&&!0===h&&F.lessThanOrEqual(JS_INT_MAX_LONG)&&F.greaterThanOrEqual(JS_INT_MIN_LONG)?F.toNumber():F}else if(A===BSON_DATA_DECIMAL128){var C=Buffer.alloc(16);e.copy(C,0,t,t+16),t+=16;var Y=new Decimal128(C);D="toObject"in Y&&"function"==typeof Y.toObject?Y.toObject():Y}else if(A===BSON_DATA_BINARY){var V=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24,J=V,k=e[t++];if(V<0)throw new BSONError("Negative binary type element size found");if(V>e.byteLength)throw new BSONError("Binary type size larger than document size");if(null!=e.slice){if(k===Binary.SUBTYPE_BYTE_ARRAY){if((V=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<0)throw new BSONError("Negative binary type element size found for subtype 0x02");if(V>J-4)throw new BSONError("Binary type with subtype 0x02 contains too long binary size");if(V<J-4)throw new BSONError("Binary type with subtype 0x02 contains too short binary size")}D=l&&h?e.slice(t,t+V):new Binary(e.slice(t,t+V),k)}else{var X=Buffer.alloc(V);if(k===Binary.SUBTYPE_BYTE_ARRAY){if((V=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<0)throw new BSONError("Negative binary type element size found for subtype 0x02");if(V>J-4)throw new BSONError("Binary type with subtype 0x02 contains too long binary size");if(V<J-4)throw new BSONError("Binary type with subtype 0x02 contains too short binary size")}for(T=0;T<V;T++)X[T]=e[t+T];D=l&&h?X:new Binary(X,k)}t+=V}else if(A===BSON_DATA_REGEXP&&!1===a){for(T=t;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new BSONError("Bad BSON Document: illegal CString");var H=e.toString("utf8",t,T);for(T=t=T+1;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new BSONError("Bad BSON Document: illegal CString");var W=e.toString("utf8",t,T);t=T+1;var K=new Array(W.length);for(T=0;T<W.length;T++)switch(W[T]){case"m":K[T]="m";break;case"s":K[T]="g";break;case"i":K[T]="i"}D=new RegExp(H,K.join(""))}else if(A===BSON_DATA_REGEXP&&!0===a){for(T=t;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new BSONError("Bad BSON Document: illegal CString");H=e.toString("utf8",t,T);for(T=t=T+1;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new BSONError("Bad BSON Document: illegal CString");W=e.toString("utf8",t,T);t=T+1,D=new BSONRegExp(H,W)}else if(A===BSON_DATA_SYMBOL){if((te=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<=0||te>e.length-t||0!==e[t+te-1])throw new BSONError("bad string length in bson");var G=getValidatedString(e,t,t+te-1,x);D=h?G:new BSONSymbol(G),t+=te}else if(A===BSON_DATA_TIMESTAMP){L=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24,U=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24;D=new Timestamp(L,U)}else if(A===BSON_DATA_MIN_KEY)D=new MinKey;else if(A===BSON_DATA_MAX_KEY)D=new MaxKey;else if(A===BSON_DATA_CODE){if((te=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<=0||te>e.length-t||0!==e[t+te-1])throw new BSONError("bad string length in bson");var q=getValidatedString(e,t,t+te-1,x);D=o?s?isolateEval(q,functionCache,m):isolateEval(q):new Code(q),t+=te}else if(A===BSON_DATA_CODE_W_SCOPE){var Z=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24;if(Z<13)throw new BSONError("code_w_scope total size shorter minimum expected length");if((te=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<=0||te>e.length-t||0!==e[t+te-1])throw new BSONError("bad string length in bson");q=getValidatedString(e,t,t+te-1,x),j=t+=te;var Q=e[t]|e[t+1]<<8|e[t+2]<<16|e[t+3]<<24,ee=deserializeObject(e,j,r,!1);if(t+=Q,Z<8+Q+te)throw new BSONError("code_w_scope total size is too short, truncating scope");if(Z>8+Q+te)throw new BSONError("code_w_scope total size is too long, clips outer document");o?(D=s?isolateEval(q,functionCache,m):isolateEval(q)).scope=ee:D=new Code(q,ee)}else{if(A!==BSON_DATA_DBPOINTER)throw new BSONError("Detected unknown BSON type ".concat(A.toString(16),' for fieldname "').concat(I,'"'));var te;if((te=e[t++]|e[t++]<<8|e[t++]<<16|e[t++]<<24)<=0||te>e.length-t||0!==e[t+te-1])throw new BSONError("bad string length in bson");if(null!=p&&p.utf8&&!validateUtf8(e,t,t+te-1))throw new BSONError("Invalid UTF-8 string in BSON document");var re=e.toString("utf8",t,t+te-1);t+=te;var ne=Buffer.alloc(12);e.copy(ne,0,t,t+12);R=new ObjectId(ne);t+=12,D=new DBRef(re,R)}"__proto__"===I?Object.defineProperty(m,I,{value:D,writable:!0,enumerable:!0,configurable:!0}):m[I]=D}if(S!==t-O){if(n)throw new BSONError("corrupt array bson");throw new BSONError("corrupt object bson")}if(!v)return m;if(isDBRefLike(m)){var ie=Object.assign({},m);return delete ie.$ref,delete ie.$id,delete ie.$db,new DBRef(m.$ref,m.$id,m.$db,ie)}return m}function isolateEval(e,t,r){return t?(null==t[e]&&(t[e]=new Function(e)),t[e].bind(r)):new Function(e)}function getValidatedString(e,t,r,n){var i=e.toString("utf8",t,r);if(n)for(var o=0;o<i.length;o++)if(65533===i.charCodeAt(o)){if(!validateUtf8(e,t,r))throw new BSONError("Invalid UTF-8 string in BSON document");break}return i}var regexp=/\x00/,ignoreKeys=new Set(["$db","$ref","$id","$clusterTime"]);function serializeString(e,t,r,n,i){e[n++]=BSON_DATA_STRING;var o=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8");e[(n=n+o+1)-1]=0;var s=e.write(r,n+4,void 0,"utf8");return e[n+3]=s+1>>24&255,e[n+2]=s+1>>16&255,e[n+1]=s+1>>8&255,e[n]=s+1&255,n=n+4+s,e[n++]=0,n}var SPACE_FOR_FLOAT64=new Uint8Array(8),DV_FOR_FLOAT64=new DataView(SPACE_FOR_FLOAT64.buffer,SPACE_FOR_FLOAT64.byteOffset,SPACE_FOR_FLOAT64.byteLength);function serializeNumber(e,t,r,n,i){Number.isInteger(r)&&r>=BSON_INT32_MIN&&r<=BSON_INT32_MAX?(e[n++]=BSON_DATA_INT,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,e[n++]=255&r,e[n++]=r>>8&255,e[n++]=r>>16&255,e[n++]=r>>24&255):(e[n++]=BSON_DATA_NUMBER,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,DV_FOR_FLOAT64.setFloat64(0,r,!0),e.set(SPACE_FOR_FLOAT64,n),n+=8);return n}function serializeNull(e,t,r,n,i){return e[n++]=BSON_DATA_NULL,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,n}function serializeBoolean(e,t,r,n,i){return e[n++]=BSON_DATA_BOOLEAN,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,e[n++]=r?1:0,n}function serializeDate(e,t,r,n,i){e[n++]=BSON_DATA_DATE,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var o=Long.fromNumber(r.getTime()),s=o.getLowBits(),u=o.getHighBits();return e[n++]=255&s,e[n++]=s>>8&255,e[n++]=s>>16&255,e[n++]=s>>24&255,e[n++]=255&u,e[n++]=u>>8&255,e[n++]=u>>16&255,e[n++]=u>>24&255,n}function serializeRegExp(e,t,r,n,i){if(e[n++]=BSON_DATA_REGEXP,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,r.source&&null!=r.source.match(regexp))throw Error("value "+r.source+" must not contain null bytes");return n+=e.write(r.source,n,void 0,"utf8"),e[n++]=0,r.ignoreCase&&(e[n++]=105),r.global&&(e[n++]=115),r.multiline&&(e[n++]=109),e[n++]=0,n}function serializeBSONRegExp(e,t,r,n,i){if(e[n++]=BSON_DATA_REGEXP,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,null!=r.pattern.match(regexp))throw Error("pattern "+r.pattern+" must not contain null bytes");return n+=e.write(r.pattern,n,void 0,"utf8"),e[n++]=0,n+=e.write(r.options.split("").sort().join(""),n,void 0,"utf8"),e[n++]=0,n}function serializeMinMax(e,t,r,n,i){return null===r?e[n++]=BSON_DATA_NULL:"MinKey"===r._bsontype?e[n++]=BSON_DATA_MIN_KEY:e[n++]=BSON_DATA_MAX_KEY,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,n}function serializeObjectId(e,t,r,n,i){if(e[n++]=BSON_DATA_OID,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,"string"==typeof r.id)e.write(r.id,n,void 0,"binary");else{if(!isUint8Array(r.id))throw new BSONTypeError("object ["+JSON.stringify(r)+"] is not a valid ObjectId");e.set(r.id.subarray(0,12),n)}return n+12}function serializeBuffer(e,t,r,n,i){e[n++]=BSON_DATA_BINARY,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var o=r.length;return e[n++]=255&o,e[n++]=o>>8&255,e[n++]=o>>16&255,e[n++]=o>>24&255,e[n++]=BSON_BINARY_SUBTYPE_DEFAULT,e.set(ensureBuffer(r),n),n+=o}function serializeObject(e,t,r,n,i,o,s,u,f,a){void 0===i&&(i=!1),void 0===o&&(o=0),void 0===s&&(s=!1),void 0===u&&(u=!0),void 0===f&&(f=!1),void 0===a&&(a=[]);for(var l=0;l<a.length;l++)if(a[l]===r)throw new BSONError("cyclic dependency detected");a.push(r),e[n++]=Array.isArray(r)?BSON_DATA_ARRAY:BSON_DATA_OBJECT,n+=f?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var c=serializeInto(e,r,i,n,o+1,s,u,a);return a.pop(),c}function serializeDecimal128(e,t,r,n,i){return e[n++]=BSON_DATA_DECIMAL128,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,e.set(r.bytes.subarray(0,16),n),n+16}function serializeLong(e,t,r,n,i){e[n++]="Long"===r._bsontype?BSON_DATA_LONG:BSON_DATA_TIMESTAMP,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var o=r.getLowBits(),s=r.getHighBits();return e[n++]=255&o,e[n++]=o>>8&255,e[n++]=o>>16&255,e[n++]=o>>24&255,e[n++]=255&s,e[n++]=s>>8&255,e[n++]=s>>16&255,e[n++]=s>>24&255,n}function serializeInt32(e,t,r,n,i){return r=r.valueOf(),e[n++]=BSON_DATA_INT,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,e[n++]=255&r,e[n++]=r>>8&255,e[n++]=r>>16&255,e[n++]=r>>24&255,n}function serializeDouble(e,t,r,n,i){return e[n++]=BSON_DATA_NUMBER,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0,DV_FOR_FLOAT64.setFloat64(0,r.value,!0),e.set(SPACE_FOR_FLOAT64,n),n+=8}function serializeFunction(e,t,r,n,i,o,s){e[n++]=BSON_DATA_CODE,n+=s?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var u=normalizedFunctionString(r),f=e.write(u,n+4,void 0,"utf8")+1;return e[n]=255&f,e[n+1]=f>>8&255,e[n+2]=f>>16&255,e[n+3]=f>>24&255,n=n+4+f-1,e[n++]=0,n}function serializeCode(e,t,r,n,i,o,s,u,f){if(void 0===i&&(i=!1),void 0===o&&(o=0),void 0===s&&(s=!1),void 0===u&&(u=!0),void 0===f&&(f=!1),r.scope&&"object"==typeof r.scope){e[n++]=BSON_DATA_CODE_W_SCOPE,n+=f?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var a=n,l="string"==typeof r.code?r.code:r.code.toString();n+=4;var c=e.write(l,n+4,void 0,"utf8")+1;e[n]=255&c,e[n+1]=c>>8&255,e[n+2]=c>>16&255,e[n+3]=c>>24&255,e[n+4+c-1]=0,n=n+c+4;var h=serializeInto(e,r.scope,i,n,o+1,s,u);n=h-1;var p=h-a;e[a++]=255&p,e[a++]=p>>8&255,e[a++]=p>>16&255,e[a++]=p>>24&255,e[n++]=0}else{e[n++]=BSON_DATA_CODE,n+=f?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;l=r.code.toString();var g=e.write(l,n+4,void 0,"utf8")+1;e[n]=255&g,e[n+1]=g>>8&255,e[n+2]=g>>16&255,e[n+3]=g>>24&255,n=n+4+g-1,e[n++]=0}return n}function serializeBinary(e,t,r,n,i){e[n++]=BSON_DATA_BINARY,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var o=r.value(!0),s=r.position;return r.sub_type===Binary.SUBTYPE_BYTE_ARRAY&&(s+=4),e[n++]=255&s,e[n++]=s>>8&255,e[n++]=s>>16&255,e[n++]=s>>24&255,e[n++]=r.sub_type,r.sub_type===Binary.SUBTYPE_BYTE_ARRAY&&(s-=4,e[n++]=255&s,e[n++]=s>>8&255,e[n++]=s>>16&255,e[n++]=s>>24&255),e.set(o,n),n+=r.position}function serializeSymbol(e,t,r,n,i){e[n++]=BSON_DATA_SYMBOL,n+=i?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var o=e.write(r.value,n+4,void 0,"utf8")+1;return e[n]=255&o,e[n+1]=o>>8&255,e[n+2]=o>>16&255,e[n+3]=o>>24&255,n=n+4+o-1,e[n++]=0,n}function serializeDBRef(e,t,r,n,i,o,s){e[n++]=BSON_DATA_OBJECT,n+=s?e.write(t,n,void 0,"ascii"):e.write(t,n,void 0,"utf8"),e[n++]=0;var u=n,f={$ref:r.collection||r.namespace,$id:r.oid};null!=r.db&&(f.$db=r.db);var a=serializeInto(e,f=Object.assign(f,r.fields),!1,n,i+1,o),l=a-u;return e[u++]=255&l,e[u++]=l>>8&255,e[u++]=l>>16&255,e[u++]=l>>24&255,a}function serializeInto(e,t,r,n,i,o,s,u){void 0===r&&(r=!1),void 0===n&&(n=0),void 0===i&&(i=0),void 0===o&&(o=!1),void 0===s&&(s=!0),void 0===u&&(u=[]),n=n||0,(u=u||[]).push(t);var f=n+4;if(Array.isArray(t))for(var a=0;a<t.length;a++){var l="".concat(a);if("function"==typeof(null==(y=t[a])?void 0:y.toBSON)&&(y=y.toBSON()),"string"==typeof y)f=serializeString(e,l,y,f,!0);else if("number"==typeof y)f=serializeNumber(e,l,y,f,!0);else{if("bigint"==typeof y)throw new BSONTypeError("Unsupported type BigInt, please use Decimal128");if("boolean"==typeof y)f=serializeBoolean(e,l,y,f,!0);else if(y instanceof Date||isDate(y))f=serializeDate(e,l,y,f,!0);else if(void 0===y)f=serializeNull(e,l,y,f,!0);else if(null===y)f=serializeNull(e,l,y,f,!0);else if("ObjectId"===y._bsontype||"ObjectID"===y._bsontype)f=serializeObjectId(e,l,y,f,!0);else if(isUint8Array(y))f=serializeBuffer(e,l,y,f,!0);else if(y instanceof RegExp||isRegExp(y))f=serializeRegExp(e,l,y,f,!0);else if("object"==typeof y&&null==y._bsontype)f=serializeObject(e,l,y,f,r,i,o,s,!0,u);else if("object"==typeof y&&isBSONType(y)&&"Decimal128"===y._bsontype)f=serializeDecimal128(e,l,y,f,!0);else if("Long"===y._bsontype||"Timestamp"===y._bsontype)f=serializeLong(e,l,y,f,!0);else if("Double"===y._bsontype)f=serializeDouble(e,l,y,f,!0);else if("function"==typeof y&&o)f=serializeFunction(e,l,y,f,r,i,!0);else if("Code"===y._bsontype)f=serializeCode(e,l,y,f,r,i,o,s,!0);else if("Binary"===y._bsontype)f=serializeBinary(e,l,y,f,!0);else if("Symbol"===y._bsontype)f=serializeSymbol(e,l,y,f,!0);else if("DBRef"===y._bsontype)f=serializeDBRef(e,l,y,f,i,o,!0);else if("BSONRegExp"===y._bsontype)f=serializeBSONRegExp(e,l,y,f,!0);else if("Int32"===y._bsontype)f=serializeInt32(e,l,y,f,!0);else if("MinKey"===y._bsontype||"MaxKey"===y._bsontype)f=serializeMinMax(e,l,y,f,!0);else if(void 0!==y._bsontype)throw new BSONTypeError("Unrecognized or invalid _bsontype: ".concat(String(y._bsontype)))}}else if(t instanceof bsonMap||isMap(t))for(var c=t.entries(),h=!1;!h;){var p=c.next();if(!(h=!!p.done)){l=p.value[0];var g=typeof(y=p.value[1]);if("string"==typeof l&&!ignoreKeys.has(l)){if(null!=l.match(regexp))throw Error("key "+l+" must not contain null bytes");if(r){if("$"===l[0])throw Error("key "+l+" must not start with '$'");if(~l.indexOf("."))throw Error("key "+l+" must not contain '.'")}}if("string"===g)f=serializeString(e,l,y,f);else if("number"===g)f=serializeNumber(e,l,y,f);else{if("bigint"===g||isBigInt64Array(y)||isBigUInt64Array(y))throw new BSONTypeError("Unsupported type BigInt, please use Decimal128");if("boolean"===g)f=serializeBoolean(e,l,y,f);else if(y instanceof Date||isDate(y))f=serializeDate(e,l,y,f);else if(null===y||void 0===y&&!1===s)f=serializeNull(e,l,y,f);else if("ObjectId"===y._bsontype||"ObjectID"===y._bsontype)f=serializeObjectId(e,l,y,f);else if(isUint8Array(y))f=serializeBuffer(e,l,y,f);else if(y instanceof RegExp||isRegExp(y))f=serializeRegExp(e,l,y,f);else if("object"===g&&null==y._bsontype)f=serializeObject(e,l,y,f,r,i,o,s,!1,u);else if("object"===g&&"Decimal128"===y._bsontype)f=serializeDecimal128(e,l,y,f);else if("Long"===y._bsontype||"Timestamp"===y._bsontype)f=serializeLong(e,l,y,f);else if("Double"===y._bsontype)f=serializeDouble(e,l,y,f);else if("Code"===y._bsontype)f=serializeCode(e,l,y,f,r,i,o,s);else if("function"==typeof y&&o)f=serializeFunction(e,l,y,f,r,i,o);else if("Binary"===y._bsontype)f=serializeBinary(e,l,y,f);else if("Symbol"===y._bsontype)f=serializeSymbol(e,l,y,f);else if("DBRef"===y._bsontype)f=serializeDBRef(e,l,y,f,i,o);else if("BSONRegExp"===y._bsontype)f=serializeBSONRegExp(e,l,y,f);else if("Int32"===y._bsontype)f=serializeInt32(e,l,y,f);else if("MinKey"===y._bsontype||"MaxKey"===y._bsontype)f=serializeMinMax(e,l,y,f);else if(void 0!==y._bsontype)throw new BSONTypeError("Unrecognized or invalid _bsontype: ".concat(String(y._bsontype)))}}}else{if("function"==typeof(null==t?void 0:t.toBSON)&&null!=(t=t.toBSON())&&"object"!=typeof t)throw new BSONTypeError("toBSON function did not return an object");for(var l in t){var y;"function"==typeof(null==(y=t[l])?void 0:y.toBSON)&&(y=y.toBSON());g=typeof y;if("string"==typeof l&&!ignoreKeys.has(l)){if(null!=l.match(regexp))throw Error("key "+l+" must not contain null bytes");if(r){if("$"===l[0])throw Error("key "+l+" must not start with '$'");if(~l.indexOf("."))throw Error("key "+l+" must not contain '.'")}}if("string"===g)f=serializeString(e,l,y,f);else if("number"===g)f=serializeNumber(e,l,y,f);else{if("bigint"===g)throw new BSONTypeError("Unsupported type BigInt, please use Decimal128");if("boolean"===g)f=serializeBoolean(e,l,y,f);else if(y instanceof Date||isDate(y))f=serializeDate(e,l,y,f);else if(void 0===y)!1===s&&(f=serializeNull(e,l,y,f));else if(null===y)f=serializeNull(e,l,y,f);else if("ObjectId"===y._bsontype||"ObjectID"===y._bsontype)f=serializeObjectId(e,l,y,f);else if(isUint8Array(y))f=serializeBuffer(e,l,y,f);else if(y instanceof RegExp||isRegExp(y))f=serializeRegExp(e,l,y,f);else if("object"===g&&null==y._bsontype)f=serializeObject(e,l,y,f,r,i,o,s,!1,u);else if("object"===g&&"Decimal128"===y._bsontype)f=serializeDecimal128(e,l,y,f);else if("Long"===y._bsontype||"Timestamp"===y._bsontype)f=serializeLong(e,l,y,f);else if("Double"===y._bsontype)f=serializeDouble(e,l,y,f);else if("Code"===y._bsontype)f=serializeCode(e,l,y,f,r,i,o,s);else if("function"==typeof y&&o)f=serializeFunction(e,l,y,f,r,i,o);else if("Binary"===y._bsontype)f=serializeBinary(e,l,y,f);else if("Symbol"===y._bsontype)f=serializeSymbol(e,l,y,f);else if("DBRef"===y._bsontype)f=serializeDBRef(e,l,y,f,i,o);else if("BSONRegExp"===y._bsontype)f=serializeBSONRegExp(e,l,y,f);else if("Int32"===y._bsontype)f=serializeInt32(e,l,y,f);else if("MinKey"===y._bsontype||"MaxKey"===y._bsontype)f=serializeMinMax(e,l,y,f);else if(void 0!==y._bsontype)throw new BSONTypeError("Unrecognized or invalid _bsontype: ".concat(String(y._bsontype)))}}}u.pop(),e[f++]=0;var d=f-n;return e[n++]=255&d,e[n++]=d>>8&255,e[n++]=d>>16&255,e[n++]=d>>24&255,f}var MAXSIZE=17825792,buffer=Buffer.alloc(MAXSIZE);function setInternalBufferSize(e){buffer.length<e&&(buffer=Buffer.alloc(e))}function serialize(e,t){void 0===t&&(t={});var r="boolean"==typeof t.checkKeys&&t.checkKeys,n="boolean"==typeof t.serializeFunctions&&t.serializeFunctions,i="boolean"!=typeof t.ignoreUndefined||t.ignoreUndefined,o="number"==typeof t.minInternalBufferSize?t.minInternalBufferSize:MAXSIZE;buffer.length<o&&(buffer=Buffer.alloc(o));var s=serializeInto(buffer,e,r,0,0,n,i,[]),u=Buffer.alloc(s);return buffer.copy(u,0,0,u.length),u}function serializeWithBufferAndIndex(e,t,r){void 0===r&&(r={});var n="boolean"==typeof r.checkKeys&&r.checkKeys,i="boolean"==typeof r.serializeFunctions&&r.serializeFunctions,o="boolean"!=typeof r.ignoreUndefined||r.ignoreUndefined,s="number"==typeof r.index?r.index:0,u=serializeInto(buffer,e,n,0,0,i,o);return buffer.copy(t,s,0,u),s+u-1}function deserialize(e,t){return void 0===t&&(t={}),deserialize$1(e instanceof Buffer?e:ensureBuffer(e),t)}function calculateObjectSize(e,t){return void 0===t&&(t={}),calculateObjectSize$1(e,"boolean"==typeof(t=t||{}).serializeFunctions&&t.serializeFunctions,"boolean"!=typeof t.ignoreUndefined||t.ignoreUndefined)}function deserializeStream(e,t,r,n,i,o){for(var s=Object.assign({allowObjectSmallerThanBufferSize:!0,index:0},o),u=ensureBuffer(e),f=t,a=0;a<r;a++){var l=u[f]|u[f+1]<<8|u[f+2]<<16|u[f+3]<<24;s.index=f,n[i+a]=deserialize$1(u,s),f+=l}return f}var BSON={Binary:Binary,Code:Code,DBRef:DBRef,Decimal128:Decimal128,Double:Double,Int32:Int32,Long:Long,UUID:UUID,Map:bsonMap,MaxKey:MaxKey,MinKey:MinKey,ObjectId:ObjectId,ObjectID:ObjectId,BSONRegExp:BSONRegExp,BSONSymbol:BSONSymbol,Timestamp:Timestamp,EJSON:EJSON,setInternalBufferSize:setInternalBufferSize,serialize:serialize,serializeWithBufferAndIndex:serializeWithBufferAndIndex,deserialize:deserialize,calculateObjectSize:calculateObjectSize,deserializeStream:deserializeStream,BSONError:BSONError,BSONTypeError:BSONTypeError};export default BSON;export{BSONError,BSONRegExp,BSONSymbol,BSONTypeError,BSON_BINARY_SUBTYPE_BYTE_ARRAY,BSON_BINARY_SUBTYPE_COLUMN,BSON_BINARY_SUBTYPE_DEFAULT,BSON_BINARY_SUBTYPE_ENCRYPTED,BSON_BINARY_SUBTYPE_FUNCTION,BSON_BINARY_SUBTYPE_MD5,BSON_BINARY_SUBTYPE_USER_DEFINED,BSON_BINARY_SUBTYPE_UUID,BSON_BINARY_SUBTYPE_UUID_NEW,BSON_DATA_ARRAY,BSON_DATA_BINARY,BSON_DATA_BOOLEAN,BSON_DATA_CODE,BSON_DATA_CODE_W_SCOPE,BSON_DATA_DATE,BSON_DATA_DBPOINTER,BSON_DATA_DECIMAL128,BSON_DATA_INT,BSON_DATA_LONG,BSON_DATA_MAX_KEY,BSON_DATA_MIN_KEY,BSON_DATA_NULL,BSON_DATA_NUMBER,BSON_DATA_OBJECT,BSON_DATA_OID,BSON_DATA_REGEXP,BSON_DATA_STRING,BSON_DATA_SYMBOL,BSON_DATA_TIMESTAMP,BSON_DATA_UNDEFINED,BSON_INT32_MAX,BSON_INT32_MIN,BSON_INT64_MAX,BSON_INT64_MIN,Binary,Code,DBRef,Decimal128,Double,EJSON,Int32,Long,LongWithoutOverridesClass,bsonMap as Map,MaxKey,MinKey,ObjectId as ObjectID,ObjectId,Timestamp,UUID,calculateObjectSize,deserialize,deserializeStream,serialize,serializeWithBufferAndIndex,setInternalBufferSize};