"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Binary=void 0;var buffer_1=require("buffer"),ensure_buffer_1=require("./ensure_buffer"),uuid_utils_1=require("./uuid_utils"),uuid_1=require("./uuid"),error_1=require("./error"),Binary=function(){function r(e,t){if(!(this instanceof r))return new r(e,t);if(!(null==e||"string"==typeof e||ArrayBuffer.isView(e)||e instanceof ArrayBuffer||Array.isArray(e)))throw new error_1.BSONTypeError("Binary can only be constructed from string, Buffer, TypedArray, or Array<number>");this.sub_type=null!=t?t:r.BSON_BINARY_SUBTYPE_DEFAULT,null==e?(this.buffer=buffer_1.Buffer.alloc(r.BUFFER_SIZE),this.position=0):("string"==typeof e?this.buffer=buffer_1.Buffer.from(e,"binary"):Array.isArray(e)?this.buffer=buffer_1.Buffer.from(e):this.buffer=(0,ensure_buffer_1.ensureBuffer)(e),this.position=this.buffer.byteLength)}return r.prototype.put=function(e){if("string"==typeof e&&1!==e.length)throw new error_1.BSONTypeError("only accepts single character String");if("number"!=typeof e&&1!==e.length)throw new error_1.BSONTypeError("only accepts single character Uint8Array or Array");var t;if((t="string"==typeof e?e.charCodeAt(0):"number"==typeof e?e:e[0])<0||t>255)throw new error_1.BSONTypeError("only accepts number in a valid unsigned byte range 0-255");if(this.buffer.length>this.position)this.buffer[this.position++]=t;else{var i=buffer_1.Buffer.alloc(r.BUFFER_SIZE+this.buffer.length);this.buffer.copy(i,0,0,this.buffer.length),this.buffer=i,this.buffer[this.position++]=t}},r.prototype.write=function(r,e){if(e="number"==typeof e?e:this.position,this.buffer.length<e+r.length){var t=buffer_1.Buffer.alloc(this.buffer.length+r.length);this.buffer.copy(t,0,0,this.buffer.length),this.buffer=t}ArrayBuffer.isView(r)?(this.buffer.set((0,ensure_buffer_1.ensureBuffer)(r),e),this.position=e+r.byteLength>this.position?e+r.length:this.position):"string"==typeof r&&(this.buffer.write(r,e,r.length,"binary"),this.position=e+r.length>this.position?e+r.length:this.position)},r.prototype.read=function(r,e){return e=e&&e>0?e:this.position,this.buffer.slice(r,r+e)},r.prototype.value=function(r){return(r=!!r)&&this.buffer.length===this.position?this.buffer:r?this.buffer.slice(0,this.position):this.buffer.toString("binary",0,this.position)},r.prototype.length=function(){return this.position},r.prototype.toJSON=function(){return this.buffer.toString("base64")},r.prototype.toString=function(r){return this.buffer.toString(r)},r.prototype.toExtendedJSON=function(r){r=r||{};var e=this.buffer.toString("base64"),t=Number(this.sub_type).toString(16);return r.legacy?{$binary:e,$type:1===t.length?"0"+t:t}:{$binary:{base64:e,subType:1===t.length?"0"+t:t}}},r.prototype.toUUID=function(){if(this.sub_type===r.SUBTYPE_UUID)return new uuid_1.UUID(this.buffer.slice(0,this.position));throw new error_1.BSONError('Binary sub_type "'.concat(this.sub_type,'" is not supported for converting to UUID. Only "').concat(r.SUBTYPE_UUID,'" is currently supported.'))},r.fromExtendedJSON=function(e,t){var i,n;if(t=t||{},"$binary"in e?t.legacy&&"string"==typeof e.$binary&&"$type"in e?(n=e.$type?parseInt(e.$type,16):0,i=buffer_1.Buffer.from(e.$binary,"base64")):"string"!=typeof e.$binary&&(n=e.$binary.subType?parseInt(e.$binary.subType,16):0,i=buffer_1.Buffer.from(e.$binary.base64,"base64")):"$uuid"in e&&(n=4,i=(0,uuid_utils_1.uuidHexStringToBuffer)(e.$uuid)),!i)throw new error_1.BSONTypeError("Unexpected Binary Extended JSON format ".concat(JSON.stringify(e)));return new r(i,n)},r.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},r.prototype.inspect=function(){var r=this.value(!0);return'new Binary(Buffer.from("'.concat(r.toString("hex"),'", "hex"), ').concat(this.sub_type,")")},r.BSON_BINARY_SUBTYPE_DEFAULT=0,r.BUFFER_SIZE=256,r.SUBTYPE_DEFAULT=0,r.SUBTYPE_FUNCTION=1,r.SUBTYPE_BYTE_ARRAY=2,r.SUBTYPE_UUID_OLD=3,r.SUBTYPE_UUID=4,r.SUBTYPE_MD5=5,r.SUBTYPE_ENCRYPTED=6,r.SUBTYPE_COLUMN=7,r.SUBTYPE_USER_DEFINED=128,r}();exports.Binary=Binary,Object.defineProperty(Binary.prototype,"_bsontype",{value:"Binary"});