"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Decimal128=void 0;var buffer_1=require("buffer"),error_1=require("./error"),long_1=require("./long"),utils_1=require("./parser/utils"),PARSE_STRING_REGEXP=/^(\+|-)?(\d+|(\d*\.\d*))?(E|e)?([-+])?(\d+)?$/,PARSE_INF_REGEXP=/^(\+|-)?(Infinity|inf)$/i,PARSE_NAN_REGEXP=/^(\+|-)?NaN$/i,EXPONENT_MAX=6111,EXPONENT_MIN=-6176,EXPONENT_BIAS=6176,MAX_DIGITS=34,NAN_BUFFER=[124,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0].reverse(),INF_NEGATIVE_BUFFER=[248,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0].reverse(),INF_POSITIVE_BUFFER=[120,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0].reverse(),EXPONENT_REGEX=/^([-+])?(\d+)?$/,COMBINATION_MASK=31,EXPONENT_MASK=16383,COMBINATION_INFINITY=30,COMBINATION_NAN=31;function isDigit(r){return!isNaN(parseInt(r,10))}function divideu128(r){var o=long_1.Long.fromNumber(1e9),n=long_1.Long.fromNumber(0);if(!(r.parts[0]||r.parts[1]||r.parts[2]||r.parts[3]))return{quotient:r,rem:n};for(var e=0;e<=3;e++)n=(n=n.shiftLeft(32)).add(new long_1.Long(r.parts[e],0)),r.parts[e]=n.div(o).low,n=n.modulo(o);return{quotient:r,rem:n}}function multiply64x2(r,o){if(!r&&!o)return{high:long_1.Long.fromNumber(0),low:long_1.Long.fromNumber(0)};var n=r.shiftRightUnsigned(32),e=new long_1.Long(r.getLowBits(),0),i=o.shiftRightUnsigned(32),t=new long_1.Long(o.getLowBits(),0),f=n.multiply(i),g=n.multiply(t),l=e.multiply(i),h=e.multiply(t);return f=f.add(g.shiftRightUnsigned(32)),g=new long_1.Long(g.getLowBits(),0).add(l).add(h.shiftRightUnsigned(32)),{high:f=f.add(g.shiftRightUnsigned(32)),low:h=g.shiftLeft(32).add(new long_1.Long(h.getLowBits(),0))}}function lessThan(r,o){var n=r.high>>>0,e=o.high>>>0;return n<e||n===e&&r.low>>>0<o.low>>>0}function invalidErr(r,o){throw new error_1.BSONTypeError('"'.concat(r,'" is not a valid Decimal128 string - ').concat(o))}var Decimal128=function(){function r(o){if(!(this instanceof r))return new r(o);if("string"==typeof o)this.bytes=r.fromString(o).bytes;else{if(!(0,utils_1.isUint8Array)(o))throw new error_1.BSONTypeError("Decimal128 must take a Buffer or string");if(16!==o.byteLength)throw new error_1.BSONTypeError("Decimal128 must take a Buffer of 16 bytes");this.bytes=o}}return r.fromString=function(o){var n,e=!1,i=!1,t=!1,f=0,g=0,l=0,h=0,a=0,s=[0],u=0,N=0,_=0,m=0,E=0,p=0,c=new long_1.Long(0,0),d=new long_1.Long(0,0),w=0;if(o.length>=7e3)throw new error_1.BSONTypeError(o+" not a valid Decimal128 string");var b=o.match(PARSE_STRING_REGEXP),I=o.match(PARSE_INF_REGEXP),L=o.match(PARSE_NAN_REGEXP);if(!b&&!I&&!L||0===o.length)throw new error_1.BSONTypeError(o+" not a valid Decimal128 string");if(b){var v=b[2],O=b[4],T=b[5],A=b[6];O&&void 0===A&&invalidErr(o,"missing exponent power"),O&&void 0===v&&invalidErr(o,"missing exponent base"),void 0===O&&(T||A)&&invalidErr(o,"missing e before exponent")}if("+"!==o[w]&&"-"!==o[w]||(e="-"===o[w++]),!isDigit(o[w])&&"."!==o[w]){if("i"===o[w]||"I"===o[w])return new r(buffer_1.Buffer.from(e?INF_NEGATIVE_BUFFER:INF_POSITIVE_BUFFER));if("N"===o[w])return new r(buffer_1.Buffer.from(NAN_BUFFER))}for(;isDigit(o[w])||"."===o[w];)"."!==o[w]?(u<34&&("0"!==o[w]||t)&&(t||(a=g),t=!0,s[N++]=parseInt(o[w],10),u+=1),t&&(l+=1),i&&(h+=1),g+=1,w+=1):(i&&invalidErr(o,"contains multiple periods"),i=!0,w+=1);if(i&&!g)throw new error_1.BSONTypeError(o+" not a valid Decimal128 string");if("e"===o[w]||"E"===o[w]){var S=o.substr(++w).match(EXPONENT_REGEX);if(!S||!S[2])return new r(buffer_1.Buffer.from(NAN_BUFFER));E=parseInt(S[0],10),w+=S[0].length}if(o[w])return new r(buffer_1.Buffer.from(NAN_BUFFER));if(_=0,u){if(m=u-1,1!==(f=l))for(;0===s[a+f-1];)f-=1}else _=0,m=0,s[0]=0,l=1,u=1,f=0;for(E<=h&&h-E>16384?E=EXPONENT_MIN:E-=h;E>EXPONENT_MAX;){if((m+=1)-_>MAX_DIGITS){if(s.join("").match(/^0+$/)){E=EXPONENT_MAX;break}invalidErr(o,"overflow")}E-=1}for(;E<EXPONENT_MIN||u<l;){if(0===m&&f<u){E=EXPONENT_MIN,f=0;break}if(u<l?l-=1:m-=1,E<EXPONENT_MAX)E+=1;else{if(s.join("").match(/^0+$/)){E=EXPONENT_MAX;break}invalidErr(o,"overflow")}}if(m-_+1<f){var B=g;i&&(a+=1,B+=1),e&&(a+=1,B+=1);var y=parseInt(o[a+m+1],10),P=0;if(y>=5&&(P=1,5===y))for(P=s[m]%2==1?1:0,p=a+m+2;p<B;p++)if(parseInt(o[p],10)){P=1;break}if(P)for(var X=m;X>=0;X--)if(++s[X]>9&&(s[X]=0,0===X)){if(!(E<EXPONENT_MAX))return new r(buffer_1.Buffer.from(e?INF_NEGATIVE_BUFFER:INF_POSITIVE_BUFFER));E+=1,s[X]=1}}if(c=long_1.Long.fromNumber(0),d=long_1.Long.fromNumber(0),0===f)c=long_1.Long.fromNumber(0),d=long_1.Long.fromNumber(0);else if(m-_<17){X=_;for(d=long_1.Long.fromNumber(s[X++]),c=new long_1.Long(0,0);X<=m;X++)d=(d=d.multiply(long_1.Long.fromNumber(10))).add(long_1.Long.fromNumber(s[X]))}else{X=_;for(c=long_1.Long.fromNumber(s[X++]);X<=m-17;X++)c=(c=c.multiply(long_1.Long.fromNumber(10))).add(long_1.Long.fromNumber(s[X]));for(d=long_1.Long.fromNumber(s[X++]);X<=m;X++)d=(d=d.multiply(long_1.Long.fromNumber(10))).add(long_1.Long.fromNumber(s[X]))}var R=multiply64x2(c,long_1.Long.fromString("100000000000000000"));R.low=R.low.add(d),lessThan(R.low,d)&&(R.high=R.high.add(long_1.Long.fromNumber(1))),n=E+EXPONENT_BIAS;var F={low:long_1.Long.fromNumber(0),high:long_1.Long.fromNumber(0)};R.high.shiftRightUnsigned(49).and(long_1.Long.fromNumber(1)).equals(long_1.Long.fromNumber(1))?(F.high=F.high.or(long_1.Long.fromNumber(3).shiftLeft(61)),F.high=F.high.or(long_1.Long.fromNumber(n).and(long_1.Long.fromNumber(16383).shiftLeft(47))),F.high=F.high.or(R.high.and(long_1.Long.fromNumber(0x7fffffffffff)))):(F.high=F.high.or(long_1.Long.fromNumber(16383&n).shiftLeft(49)),F.high=F.high.or(R.high.and(long_1.Long.fromNumber(562949953421311)))),F.low=R.low,e&&(F.high=F.high.or(long_1.Long.fromString("9223372036854775808")));var M=buffer_1.Buffer.alloc(16);return w=0,M[w++]=255&F.low.low,M[w++]=F.low.low>>8&255,M[w++]=F.low.low>>16&255,M[w++]=F.low.low>>24&255,M[w++]=255&F.low.high,M[w++]=F.low.high>>8&255,M[w++]=F.low.high>>16&255,M[w++]=F.low.high>>24&255,M[w++]=255&F.high.low,M[w++]=F.high.low>>8&255,M[w++]=F.high.low>>16&255,M[w++]=F.high.low>>24&255,M[w++]=255&F.high.high,M[w++]=F.high.high>>8&255,M[w++]=F.high.high>>16&255,M[w++]=F.high.high>>24&255,new r(M)},r.prototype.toString=function(){for(var r,o=0,n=new Array(36),e=0;e<n.length;e++)n[e]=0;var i,t,f,g=0,l=!1,h={parts:[0,0,0,0]},a=[];g=0;var s=this.bytes,u=s[g++]|s[g++]<<8|s[g++]<<16|s[g++]<<24,N=s[g++]|s[g++]<<8|s[g++]<<16|s[g++]<<24,_=s[g++]|s[g++]<<8|s[g++]<<16|s[g++]<<24,m=s[g++]|s[g++]<<8|s[g++]<<16|s[g++]<<24;g=0,{low:new long_1.Long(u,N),high:new long_1.Long(_,m)}.high.lessThan(long_1.Long.ZERO)&&a.push("-");var E=m>>26&COMBINATION_MASK;if(E>>3==3){if(E===COMBINATION_INFINITY)return a.join("")+"Infinity";if(E===COMBINATION_NAN)return"NaN";r=m>>15&EXPONENT_MASK,i=8+(m>>14&1)}else i=m>>14&7,r=m>>17&EXPONENT_MASK;var p=r-EXPONENT_BIAS;if(h.parts[0]=(16383&m)+((15&i)<<14),h.parts[1]=_,h.parts[2]=N,h.parts[3]=u,0===h.parts[0]&&0===h.parts[1]&&0===h.parts[2]&&0===h.parts[3])l=!0;else for(f=3;f>=0;f--){var c=0,d=divideu128(h);if(h=d.quotient,c=d.rem.low)for(t=8;t>=0;t--)n[9*f+t]=c%10,c=Math.floor(c/10)}if(l)o=1,n[g]=0;else for(o=36;!n[g];)o-=1,g+=1;var w=o-1+p;if(w>=34||w<=-7||p>0){if(o>34)return a.push("".concat(0)),p>0?a.push("E+".concat(p)):p<0&&a.push("E".concat(p)),a.join("");a.push("".concat(n[g++])),(o-=1)&&a.push(".");for(e=0;e<o;e++)a.push("".concat(n[g++]));a.push("E"),w>0?a.push("+".concat(w)):a.push("".concat(w))}else if(p>=0)for(e=0;e<o;e++)a.push("".concat(n[g++]));else{var b=o+p;if(b>0)for(e=0;e<b;e++)a.push("".concat(n[g++]));else a.push("0");for(a.push(".");b++<0;)a.push("0");for(e=0;e<o-Math.max(b-1,0);e++)a.push("".concat(n[g++]))}return a.join("")},r.prototype.toJSON=function(){return{$numberDecimal:this.toString()}},r.prototype.toExtendedJSON=function(){return{$numberDecimal:this.toString()}},r.fromExtendedJSON=function(o){return r.fromString(o.$numberDecimal)},r.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},r.prototype.inspect=function(){return'new Decimal128("'.concat(this.toString(),'")')},r}();exports.Decimal128=Decimal128,Object.defineProperty(Decimal128.prototype,"_bsontype",{value:"Decimal128"});