"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.EJSON=exports.isBSONType=void 0;var binary_1=require("./binary"),code_1=require("./code"),db_ref_1=require("./db_ref"),decimal128_1=require("./decimal128"),double_1=require("./double"),error_1=require("./error"),int_32_1=require("./int_32"),long_1=require("./long"),max_key_1=require("./max_key"),min_key_1=require("./min_key"),objectid_1=require("./objectid"),utils_1=require("./parser/utils"),regexp_1=require("./regexp"),symbol_1=require("./symbol"),timestamp_1=require("./timestamp");function isBSONType(e){return(0,utils_1.isObjectLike)(e)&&Reflect.has(e,"_bsontype")&&"string"==typeof e._bsontype}exports.isBSONType=isBSONType;var BSON_INT32_MAX=2147483647,BSON_INT32_MIN=-2147483648,BSON_INT64_MAX=0x8000000000000000,BSON_INT64_MIN=-0x8000000000000000,keysToCodecs={$oid:objectid_1.ObjectId,$binary:binary_1.Binary,$uuid:binary_1.Binary,$symbol:symbol_1.BSONSymbol,$numberInt:int_32_1.Int32,$numberDecimal:decimal128_1.Decimal128,$numberDouble:double_1.Double,$numberLong:long_1.Long,$minKey:min_key_1.MinKey,$maxKey:max_key_1.MaxKey,$regex:regexp_1.BSONRegExp,$regularExpression:regexp_1.BSONRegExp,$timestamp:timestamp_1.Timestamp};function deserializeValue(e,r){if(void 0===r&&(r={}),"number"==typeof e){if(r.relaxed||r.legacy)return e;if(Math.floor(e)===e){if(e>=BSON_INT32_MIN&&e<=BSON_INT32_MAX)return new int_32_1.Int32(e);if(e>=BSON_INT64_MIN&&e<=BSON_INT64_MAX)return long_1.Long.fromNumber(e)}return new double_1.Double(e)}if(null==e||"object"!=typeof e)return e;if(e.$undefined)return null;for(var n=Object.keys(e).filter((function(r){return r.startsWith("$")&&null!=e[r]})),t=0;t<n.length;t++){var i=keysToCodecs[n[t]];if(i)return i.fromExtendedJSON(e,r)}if(null!=e.$date){var o=e.$date,u=new Date;return r.legacy?"number"==typeof o?u.setTime(o):"string"==typeof o&&u.setTime(Date.parse(o)):"string"==typeof o?u.setTime(Date.parse(o)):long_1.Long.isLong(o)?u.setTime(o.toNumber()):"number"==typeof o&&r.relaxed&&u.setTime(o),u}if(null!=e.$code){var a=Object.assign({},e);return e.$scope&&(a.$scope=deserializeValue(e.$scope)),code_1.Code.fromExtendedJSON(e)}if((0,db_ref_1.isDBRefLike)(e)||e.$dbPointer){var l=e.$ref?e:e.$dbPointer;if(l instanceof db_ref_1.DBRef)return l;var s=Object.keys(l).filter((function(e){return e.startsWith("$")})),c=!0;if(s.forEach((function(e){-1===["$ref","$id","$db"].indexOf(e)&&(c=!1)})),c)return db_ref_1.DBRef.fromExtendedJSON(l)}return e}function serializeArray(e,r){return e.map((function(e,n){r.seenObjects.push({propertyName:"index ".concat(n),obj:null});try{return serializeValue(e,r)}finally{r.seenObjects.pop()}}))}function getISOString(e){var r=e.toISOString();return 0!==e.getUTCMilliseconds()?r:r.slice(0,-5)+"Z"}function serializeValue(e,r){if(("object"==typeof e||"function"==typeof e)&&null!==e){var n=r.seenObjects.findIndex((function(r){return r.obj===e}));if(-1!==n){var t=r.seenObjects.map((function(e){return e.propertyName})),i=t.slice(0,n).map((function(e){return"".concat(e," -> ")})).join(""),o=t[n],u=" -> "+t.slice(n+1,t.length-1).map((function(e){return"".concat(e," -> ")})).join(""),a=t[t.length-1],l=" ".repeat(i.length+o.length/2),s="-".repeat(u.length+(o.length+a.length)/2-1);throw new error_1.BSONTypeError("Converting circular structure to EJSON:\n"+"    ".concat(i).concat(o).concat(u).concat(a,"\n")+"    ".concat(l,"\\").concat(s,"/"))}r.seenObjects[r.seenObjects.length-1].obj=e}if(Array.isArray(e))return serializeArray(e,r);if(void 0===e)return null;if(e instanceof Date||(0,utils_1.isDate)(e)){var c=e.getTime(),f=c>-1&&c<2534023188e5;return r.legacy?r.relaxed&&f?{$date:e.getTime()}:{$date:getISOString(e)}:r.relaxed&&f?{$date:getISOString(e)}:{$date:{$numberLong:e.getTime().toString()}}}if(!("number"!=typeof e||r.relaxed&&isFinite(e))){if(Math.floor(e)===e){var _=e>=BSON_INT64_MIN&&e<=BSON_INT64_MAX;if(e>=BSON_INT32_MIN&&e<=BSON_INT32_MAX)return{$numberInt:e.toString()};if(_)return{$numberLong:e.toString()}}return{$numberDouble:e.toString()}}if(e instanceof RegExp||(0,utils_1.isRegExp)(e)){var d=e.flags;if(void 0===d){var b=e.toString().match(/[gimuy]*$/);b&&(d=b[0])}return new regexp_1.BSONRegExp(e.source,d).toExtendedJSON(r)}return null!=e&&"object"==typeof e?serializeDocument(e,r):e}var EJSON,BSON_TYPE_MAPPINGS={Binary:function(e){return new binary_1.Binary(e.value(),e.sub_type)},Code:function(e){return new code_1.Code(e.code,e.scope)},DBRef:function(e){return new db_ref_1.DBRef(e.collection||e.namespace,e.oid,e.db,e.fields)},Decimal128:function(e){return new decimal128_1.Decimal128(e.bytes)},Double:function(e){return new double_1.Double(e.value)},Int32:function(e){return new int_32_1.Int32(e.value)},Long:function(e){return long_1.Long.fromBits(null!=e.low?e.low:e.low_,null!=e.low?e.high:e.high_,null!=e.low?e.unsigned:e.unsigned_)},MaxKey:function(){return new max_key_1.MaxKey},MinKey:function(){return new min_key_1.MinKey},ObjectID:function(e){return new objectid_1.ObjectId(e)},ObjectId:function(e){return new objectid_1.ObjectId(e)},BSONRegExp:function(e){return new regexp_1.BSONRegExp(e.pattern,e.options)},Symbol:function(e){return new symbol_1.BSONSymbol(e.value)},Timestamp:function(e){return timestamp_1.Timestamp.fromBits(e.low,e.high)}};function serializeDocument(e,r){if(null==e||"object"!=typeof e)throw new error_1.BSONError("not an object instance");var n=e._bsontype;if(void 0===n){var t={};for(var i in e){r.seenObjects.push({propertyName:i,obj:null});try{var o=serializeValue(e[i],r);"__proto__"===i?Object.defineProperty(t,i,{value:o,writable:!0,enumerable:!0,configurable:!0}):t[i]=o}finally{r.seenObjects.pop()}}return t}if(isBSONType(e)){var u=e;if("function"!=typeof u.toExtendedJSON){var a=BSON_TYPE_MAPPINGS[e._bsontype];if(!a)throw new error_1.BSONTypeError("Unrecognized or invalid _bsontype: "+e._bsontype);u=a(u)}return"Code"===n&&u.scope?u=new code_1.Code(u.code,serializeValue(u.scope,r)):"DBRef"===n&&u.oid&&(u=new db_ref_1.DBRef(serializeValue(u.collection,r),serializeValue(u.oid,r),serializeValue(u.db,r),serializeValue(u.fields,r))),u.toExtendedJSON(r)}throw new error_1.BSONError("_bsontype must be a string, but was: "+typeof n)}!function(e){function r(e,r){var n=Object.assign({},{relaxed:!0,legacy:!1},r);return"boolean"==typeof n.relaxed&&(n.strict=!n.relaxed),"boolean"==typeof n.strict&&(n.relaxed=!n.strict),JSON.parse(e,(function(e,r){if(-1!==e.indexOf("\0"))throw new error_1.BSONError("BSON Document field names cannot contain null bytes, found: ".concat(JSON.stringify(e)));return deserializeValue(r,n)}))}function n(e,r,n,t){null!=n&&"object"==typeof n&&(t=n,n=0),null==r||"object"!=typeof r||Array.isArray(r)||(t=r,r=void 0,n=0);var i=serializeValue(e,Object.assign({relaxed:!0,legacy:!1},t,{seenObjects:[{propertyName:"(root)",obj:null}]}));return JSON.stringify(i,r,n)}e.parse=r,e.stringify=n,e.serialize=function(e,r){return r=r||{},JSON.parse(n(e,r))},e.deserialize=function(e,n){return n=n||{},r(JSON.stringify(e),n)}}(EJSON=exports.EJSON||(exports.EJSON={}));