"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ObjectId=void 0;var buffer_1=require("buffer"),ensure_buffer_1=require("./ensure_buffer"),error_1=require("./error"),utils_1=require("./parser/utils"),checkForHexRegExp=new RegExp("^[0-9a-fA-F]{24}$"),PROCESS_UNIQUE=null,kId=Symbol("id"),ObjectId=function(){function e(t){if(!(this instanceof e))return new e(t);var r;if("object"==typeof t&&t&&"id"in t){if("string"!=typeof t.id&&!ArrayBuffer.isView(t.id))throw new error_1.BSONTypeError("Argument passed in must have an id that is of type string or Buffer");r="toHexString"in t&&"function"==typeof t.toHexString?buffer_1.Buffer.from(t.toHexString(),"hex"):t.id}else r=t;if(null==r||"number"==typeof r)this[kId]=e.generate("number"==typeof r?r:void 0);else if(ArrayBuffer.isView(r)&&12===r.byteLength)this[kId]=r instanceof buffer_1.Buffer?r:(0,ensure_buffer_1.ensureBuffer)(r);else{if("string"!=typeof r)throw new error_1.BSONTypeError("Argument passed in does not match the accepted types");if(12===r.length){var n=buffer_1.Buffer.from(r);if(12!==n.byteLength)throw new error_1.BSONTypeError("Argument passed in must be a string of 12 bytes");this[kId]=n}else{if(24!==r.length||!checkForHexRegExp.test(r))throw new error_1.BSONTypeError("Argument passed in must be a string of 12 bytes or a string of 24 hex characters or an integer");this[kId]=buffer_1.Buffer.from(r,"hex")}}e.cacheHexString&&(this.__id=this.id.toString("hex"))}return Object.defineProperty(e.prototype,"id",{get:function(){return this[kId]},set:function(t){this[kId]=t,e.cacheHexString&&(this.__id=t.toString("hex"))},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"generationTime",{get:function(){return this.id.readInt32BE(0)},set:function(e){this.id.writeUInt32BE(e,0)},enumerable:!1,configurable:!0}),e.prototype.toHexString=function(){if(e.cacheHexString&&this.__id)return this.__id;var t=this.id.toString("hex");return e.cacheHexString&&!this.__id&&(this.__id=t),t},e.getInc=function(){return e.index=(e.index+1)%16777215},e.generate=function(t){"number"!=typeof t&&(t=Math.floor(Date.now()/1e3));var r=e.getInc(),n=buffer_1.Buffer.alloc(12);return n.writeUInt32BE(t,0),null===PROCESS_UNIQUE&&(PROCESS_UNIQUE=(0,utils_1.randomBytes)(5)),n[4]=PROCESS_UNIQUE[0],n[5]=PROCESS_UNIQUE[1],n[6]=PROCESS_UNIQUE[2],n[7]=PROCESS_UNIQUE[3],n[8]=PROCESS_UNIQUE[4],n[11]=255&r,n[10]=r>>8&255,n[9]=r>>16&255,n},e.prototype.toString=function(e){return e?this.id.toString(e):this.toHexString()},e.prototype.toJSON=function(){return this.toHexString()},e.prototype.equals=function(t){if(null==t)return!1;if(t instanceof e)return this[kId][11]===t[kId][11]&&this[kId].equals(t[kId]);if("string"==typeof t&&e.isValid(t)&&12===t.length&&(0,utils_1.isUint8Array)(this.id))return t===buffer_1.Buffer.prototype.toString.call(this.id,"latin1");if("string"==typeof t&&e.isValid(t)&&24===t.length)return t.toLowerCase()===this.toHexString();if("string"==typeof t&&e.isValid(t)&&12===t.length)return buffer_1.Buffer.from(t).equals(this.id);if("object"==typeof t&&"toHexString"in t&&"function"==typeof t.toHexString){var r=t.toHexString(),n=this.toHexString().toLowerCase();return"string"==typeof r&&r.toLowerCase()===n}return!1},e.prototype.getTimestamp=function(){var e=new Date,t=this.id.readUInt32BE(0);return e.setTime(1e3*Math.floor(t)),e},e.createPk=function(){return new e},e.createFromTime=function(t){var r=buffer_1.Buffer.from([0,0,0,0,0,0,0,0,0,0,0,0]);return r.writeUInt32BE(t,0),new e(r)},e.createFromHexString=function(t){if(void 0===t||null!=t&&24!==t.length)throw new error_1.BSONTypeError("Argument passed in must be a single String of 12 bytes or a string of 24 hex characters");return new e(buffer_1.Buffer.from(t,"hex"))},e.isValid=function(t){if(null==t)return!1;try{return new e(t),!0}catch(e){return!1}},e.prototype.toExtendedJSON=function(){return this.toHexString?{$oid:this.toHexString()}:{$oid:this.toString("hex")}},e.fromExtendedJSON=function(t){return new e(t.$oid)},e.prototype[Symbol.for("nodejs.util.inspect.custom")]=function(){return this.inspect()},e.prototype.inspect=function(){return'new ObjectId("'.concat(this.toHexString(),'")')},e.index=Math.floor(16777215*Math.random()),e}();exports.ObjectId=ObjectId,Object.defineProperty(ObjectId.prototype,"generate",{value:(0,utils_1.deprecate)((function(e){return ObjectId.generate(e)}),"Please use the static `ObjectId.generate(time)` instead")}),Object.defineProperty(ObjectId.prototype,"getInc",{value:(0,utils_1.deprecate)((function(){return ObjectId.getInc()}),"Please use the static `ObjectId.getInc()` instead")}),Object.defineProperty(ObjectId.prototype,"get_inc",{value:(0,utils_1.deprecate)((function(){return ObjectId.getInc()}),"Please use the static `ObjectId.getInc()` instead")}),Object.defineProperty(ObjectId,"get_inc",{value:(0,utils_1.deprecate)((function(){return ObjectId.getInc()}),"Please use the static `ObjectId.getInc()` instead")}),Object.defineProperty(ObjectId.prototype,"_bsontype",{value:"ObjectID"});