"use strict";var __assign=this&&this.__assign||function(){return __assign=Object.assign||function(e){for(var r,t=1,n=arguments.length;t<n;t++)for(var o in r=arguments[t])Object.prototype.hasOwnProperty.call(r,o)&&(e[o]=r[o]);return e},__assign.apply(this,arguments)};Object.defineProperty(exports,"__esModule",{value:!0}),exports.deserialize=void 0;var buffer_1=require("buffer"),binary_1=require("../binary"),code_1=require("../code"),constants=require("../constants"),db_ref_1=require("../db_ref"),decimal128_1=require("../decimal128"),double_1=require("../double"),error_1=require("../error"),int_32_1=require("../int_32"),long_1=require("../long"),max_key_1=require("../max_key"),min_key_1=require("../min_key"),objectid_1=require("../objectid"),regexp_1=require("../regexp"),symbol_1=require("../symbol"),timestamp_1=require("../timestamp"),validate_utf8_1=require("../validate_utf8"),JS_INT_MAX_LONG=long_1.Long.fromNumber(constants.JS_INT_MAX),JS_INT_MIN_LONG=long_1.Long.fromNumber(constants.JS_INT_MIN),functionCache={};function deserialize(e,r,t){var n=(r=null==r?{}:r)&&r.index?r.index:0,o=e[n]|e[n+1]<<8|e[n+2]<<16|e[n+3]<<24;if(o<5)throw new error_1.BSONError("bson size must be >= 5, is ".concat(o));if(r.allowObjectSmallerThanBufferSize&&e.length<o)throw new error_1.BSONError("buffer length ".concat(e.length," must be >= bson size ").concat(o));if(!r.allowObjectSmallerThanBufferSize&&e.length!==o)throw new error_1.BSONError("buffer length ".concat(e.length," must === bson size ").concat(o));if(o+n>e.byteLength)throw new error_1.BSONError("(bson size ".concat(o," + options.index ").concat(n," must be <= buffer length ").concat(e.byteLength,")"));if(0!==e[n+o-1])throw new error_1.BSONError("One object, sized correctly, with a spot for an EOO, but the EOO isn't 0x00");return deserializeObject(e,n,r,t)}exports.deserialize=deserialize;var allowedDBRefKeys=/^\$ref$|^\$id$|^\$db$/;function deserializeObject(e,r,t,n){void 0===n&&(n=!1);var o,i=null!=t.evalFunctions&&t.evalFunctions,a=null!=t.cacheFunctions&&t.cacheFunctions,s=null==t.fieldsAsRaw?null:t.fieldsAsRaw,l=null!=t.raw&&t.raw,_="boolean"==typeof t.bsonRegExp&&t.bsonRegExp,f=null!=t.promoteBuffers&&t.promoteBuffers,c=null==t.promoteLongs||t.promoteLongs,u=null==t.promoteValues||t.promoteValues,w=null==t.validation?{utf8:!0}:t.validation,b=!0,g=new Set,d=w.utf8;if("boolean"==typeof d)o=d;else{b=!1;var O=Object.keys(d).map((function(e){return d[e]}));if(0===O.length)throw new error_1.BSONError("UTF-8 validation setting cannot be empty");if("boolean"!=typeof O[0])throw new error_1.BSONError("Invalid UTF-8 validation option, must specify boolean values");if(o=O[0],!O.every((function(e){return e===o})))throw new error_1.BSONError("Invalid UTF-8 validation option - keys must be all true or all false")}if(!b)for(var B=0,S=Object.keys(d);B<S.length;B++){var h=S[B];g.add(h)}var N=r;if(e.length<5)throw new error_1.BSONError("corrupt bson message < 5 bytes long");var y=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24;if(y<5||y>e.length)throw new error_1.BSONError("corrupt bson message");for(var v=n?[]:{},E=0,p=!n&&null,m=new DataView(e.buffer,e.byteOffset,e.byteLength);;){var A=e[r++];if(0===A)break;for(var T=r;0!==e[T]&&T<e.length;)T++;if(T>=e.byteLength)throw new error_1.BSONError("Bad BSON Document: illegal CString");var D=n?E++:e.toString("utf8",r,T),z=!0;z=b||g.has(D)?o:!o,!1!==p&&"$"===D[0]&&(p=allowedDBRefKeys.test(D));var j=void 0;if(r=T+1,A===constants.BSON_DATA_STRING){if((re=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<=0||re>e.length-r||0!==e[r+re-1])throw new error_1.BSONError("bad string length in bson");j=getValidatedString(e,r,r+re-1,z),r+=re}else if(A===constants.BSON_DATA_OID){var I=buffer_1.Buffer.alloc(12);e.copy(I,0,r,r+12),j=new objectid_1.ObjectId(I),r+=12}else if(A===constants.BSON_DATA_INT&&!1===u)j=new int_32_1.Int32(e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24);else if(A===constants.BSON_DATA_INT)j=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24;else if(A===constants.BSON_DATA_NUMBER&&!1===u)j=new double_1.Double(m.getFloat64(r,!0)),r+=8;else if(A===constants.BSON_DATA_NUMBER)j=m.getFloat64(r,!0),r+=8;else if(A===constants.BSON_DATA_DATE){var x=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24,R=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24;j=new Date(new long_1.Long(x,R).toNumber())}else if(A===constants.BSON_DATA_BOOLEAN){if(0!==e[r]&&1!==e[r])throw new error_1.BSONError("illegal boolean type value");j=1===e[r++]}else if(A===constants.BSON_DATA_OBJECT){var L=r;if((Z=e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24)<=0||Z>e.length-r)throw new error_1.BSONError("bad embedded document length in bson");if(l)j=e.slice(r,r+Z);else{var q=t;b||(q=__assign(__assign({},t),{validation:{utf8:z}})),j=deserializeObject(e,L,q,!1)}r+=Z}else if(A===constants.BSON_DATA_ARRAY){L=r;var M=t,C=r+(Z=e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24);if(s&&s[D]){for(var k in M={},t)M[k]=t[k];M.raw=!0}if(b||(M=__assign(__assign({},M),{validation:{utf8:z}})),j=deserializeObject(e,L,M,!0),0!==e[(r+=Z)-1])throw new error_1.BSONError("invalid array terminator byte");if(r!==C)throw new error_1.BSONError("corrupted array bson")}else if(A===constants.BSON_DATA_UNDEFINED)j=void 0;else if(A===constants.BSON_DATA_NULL)j=null;else if(A===constants.BSON_DATA_LONG){x=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24,R=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24;var F=new long_1.Long(x,R);j=c&&!0===u&&F.lessThanOrEqual(JS_INT_MAX_LONG)&&F.greaterThanOrEqual(JS_INT_MIN_LONG)?F.toNumber():F}else if(A===constants.BSON_DATA_DECIMAL128){var U=buffer_1.Buffer.alloc(16);e.copy(U,0,r,r+16),r+=16;var $=new decimal128_1.Decimal128(U);j="toObject"in $&&"function"==typeof $.toObject?$.toObject():$}else if(A===constants.BSON_DATA_BINARY){var Y=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24,P=Y,G=e[r++];if(Y<0)throw new error_1.BSONError("Negative binary type element size found");if(Y>e.byteLength)throw new error_1.BSONError("Binary type size larger than document size");if(null!=e.slice){if(G===binary_1.Binary.SUBTYPE_BYTE_ARRAY){if((Y=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<0)throw new error_1.BSONError("Negative binary type element size found for subtype 0x02");if(Y>P-4)throw new error_1.BSONError("Binary type with subtype 0x02 contains too long binary size");if(Y<P-4)throw new error_1.BSONError("Binary type with subtype 0x02 contains too short binary size")}j=f&&u?e.slice(r,r+Y):new binary_1.Binary(e.slice(r,r+Y),G)}else{var V=buffer_1.Buffer.alloc(Y);if(G===binary_1.Binary.SUBTYPE_BYTE_ARRAY){if((Y=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<0)throw new error_1.BSONError("Negative binary type element size found for subtype 0x02");if(Y>P-4)throw new error_1.BSONError("Binary type with subtype 0x02 contains too long binary size");if(Y<P-4)throw new error_1.BSONError("Binary type with subtype 0x02 contains too short binary size")}for(T=0;T<Y;T++)V[T]=e[r+T];j=f&&u?V:new binary_1.Binary(V,G)}r+=Y}else if(A===constants.BSON_DATA_REGEXP&&!1===_){for(T=r;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new error_1.BSONError("Bad BSON Document: illegal CString");var J=e.toString("utf8",r,T);for(T=r=T+1;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new error_1.BSONError("Bad BSON Document: illegal CString");var K=e.toString("utf8",r,T);r=T+1;var X=new Array(K.length);for(T=0;T<K.length;T++)switch(K[T]){case"m":X[T]="m";break;case"s":X[T]="g";break;case"i":X[T]="i"}j=new RegExp(J,X.join(""))}else if(A===constants.BSON_DATA_REGEXP&&!0===_){for(T=r;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new error_1.BSONError("Bad BSON Document: illegal CString");J=e.toString("utf8",r,T);for(T=r=T+1;0!==e[T]&&T<e.length;)T++;if(T>=e.length)throw new error_1.BSONError("Bad BSON Document: illegal CString");K=e.toString("utf8",r,T);r=T+1,j=new regexp_1.BSONRegExp(J,K)}else if(A===constants.BSON_DATA_SYMBOL){if((re=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<=0||re>e.length-r||0!==e[r+re-1])throw new error_1.BSONError("bad string length in bson");var W=getValidatedString(e,r,r+re-1,z);j=u?W:new symbol_1.BSONSymbol(W),r+=re}else if(A===constants.BSON_DATA_TIMESTAMP){x=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24,R=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24;j=new timestamp_1.Timestamp(x,R)}else if(A===constants.BSON_DATA_MIN_KEY)j=new min_key_1.MinKey;else if(A===constants.BSON_DATA_MAX_KEY)j=new max_key_1.MaxKey;else if(A===constants.BSON_DATA_CODE){if((re=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<=0||re>e.length-r||0!==e[r+re-1])throw new error_1.BSONError("bad string length in bson");var H=getValidatedString(e,r,r+re-1,z);j=i?a?isolateEval(H,functionCache,v):isolateEval(H):new code_1.Code(H),r+=re}else if(A===constants.BSON_DATA_CODE_W_SCOPE){var Q=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24;if(Q<13)throw new error_1.BSONError("code_w_scope total size shorter minimum expected length");if((re=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<=0||re>e.length-r||0!==e[r+re-1])throw new error_1.BSONError("bad string length in bson");H=getValidatedString(e,r,r+re-1,z),L=r+=re;var Z=e[r]|e[r+1]<<8|e[r+2]<<16|e[r+3]<<24,ee=deserializeObject(e,L,t,!1);if(r+=Z,Q<8+Z+re)throw new error_1.BSONError("code_w_scope total size is too short, truncating scope");if(Q>8+Z+re)throw new error_1.BSONError("code_w_scope total size is too long, clips outer document");i?(j=a?isolateEval(H,functionCache,v):isolateEval(H)).scope=ee:j=new code_1.Code(H,ee)}else{if(A!==constants.BSON_DATA_DBPOINTER)throw new error_1.BSONError("Detected unknown BSON type ".concat(A.toString(16),' for fieldname "').concat(D,'"'));var re;if((re=e[r++]|e[r++]<<8|e[r++]<<16|e[r++]<<24)<=0||re>e.length-r||0!==e[r+re-1])throw new error_1.BSONError("bad string length in bson");if(null!=w&&w.utf8&&!(0,validate_utf8_1.validateUtf8)(e,r,r+re-1))throw new error_1.BSONError("Invalid UTF-8 string in BSON document");var te=e.toString("utf8",r,r+re-1);r+=re;var ne=buffer_1.Buffer.alloc(12);e.copy(ne,0,r,r+12);I=new objectid_1.ObjectId(ne);r+=12,j=new db_ref_1.DBRef(te,I)}"__proto__"===D?Object.defineProperty(v,D,{value:j,writable:!0,enumerable:!0,configurable:!0}):v[D]=j}if(y!==r-N){if(n)throw new error_1.BSONError("corrupt array bson");throw new error_1.BSONError("corrupt object bson")}if(!p)return v;if((0,db_ref_1.isDBRefLike)(v)){var oe=Object.assign({},v);return delete oe.$ref,delete oe.$id,delete oe.$db,new db_ref_1.DBRef(v.$ref,v.$id,v.$db,oe)}return v}function isolateEval(e,r,t){return r?(null==r[e]&&(r[e]=new Function(e)),r[e].bind(t)):new Function(e)}function getValidatedString(e,r,t,n){var o=e.toString("utf8",r,t);if(n)for(var i=0;i<o.length;i++)if(65533===o.charCodeAt(i)){if(!(0,validate_utf8_1.validateUtf8)(e,r,t))throw new error_1.BSONError("Invalid UTF-8 string in BSON document");break}return o}