"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.serializeInto=void 0;var binary_1=require("../binary"),constants=require("../constants"),ensure_buffer_1=require("../ensure_buffer"),error_1=require("../error"),extended_json_1=require("../extended_json"),long_1=require("../long"),map_1=require("../map"),utils_1=require("./utils"),regexp=/\x00/,ignoreKeys=new Set(["$db","$ref","$id","$clusterTime"]);function serializeString(e,i,t,r,s){e[r++]=constants.BSON_DATA_STRING;var o=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8");e[(r=r+o+1)-1]=0;var n=e.write(t,r+4,void 0,"utf8");return e[r+3]=n+1>>24&255,e[r+2]=n+1>>16&255,e[r+1]=n+1>>8&255,e[r]=n+1&255,r=r+4+n,e[r++]=0,r}var SPACE_FOR_FLOAT64=new Uint8Array(8),DV_FOR_FLOAT64=new DataView(SPACE_FOR_FLOAT64.buffer,SPACE_FOR_FLOAT64.byteOffset,SPACE_FOR_FLOAT64.byteLength);function serializeNumber(e,i,t,r,s){Number.isInteger(t)&&t>=constants.BSON_INT32_MIN&&t<=constants.BSON_INT32_MAX?(e[r++]=constants.BSON_DATA_INT,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,e[r++]=255&t,e[r++]=t>>8&255,e[r++]=t>>16&255,e[r++]=t>>24&255):(e[r++]=constants.BSON_DATA_NUMBER,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,DV_FOR_FLOAT64.setFloat64(0,t,!0),e.set(SPACE_FOR_FLOAT64,r),r+=8);return r}function serializeNull(e,i,t,r,s){return e[r++]=constants.BSON_DATA_NULL,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,r}function serializeBoolean(e,i,t,r,s){return e[r++]=constants.BSON_DATA_BOOLEAN,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,e[r++]=t?1:0,r}function serializeDate(e,i,t,r,s){e[r++]=constants.BSON_DATA_DATE,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var o=long_1.Long.fromNumber(t.getTime()),n=o.getLowBits(),a=o.getHighBits();return e[r++]=255&n,e[r++]=n>>8&255,e[r++]=n>>16&255,e[r++]=n>>24&255,e[r++]=255&a,e[r++]=a>>8&255,e[r++]=a>>16&255,e[r++]=a>>24&255,r}function serializeRegExp(e,i,t,r,s){if(e[r++]=constants.BSON_DATA_REGEXP,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,t.source&&null!=t.source.match(regexp))throw Error("value "+t.source+" must not contain null bytes");return r+=e.write(t.source,r,void 0,"utf8"),e[r++]=0,t.ignoreCase&&(e[r++]=105),t.global&&(e[r++]=115),t.multiline&&(e[r++]=109),e[r++]=0,r}function serializeBSONRegExp(e,i,t,r,s){if(e[r++]=constants.BSON_DATA_REGEXP,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,null!=t.pattern.match(regexp))throw Error("pattern "+t.pattern+" must not contain null bytes");return r+=e.write(t.pattern,r,void 0,"utf8"),e[r++]=0,r+=e.write(t.options.split("").sort().join(""),r,void 0,"utf8"),e[r++]=0,r}function serializeMinMax(e,i,t,r,s){return null===t?e[r++]=constants.BSON_DATA_NULL:"MinKey"===t._bsontype?e[r++]=constants.BSON_DATA_MIN_KEY:e[r++]=constants.BSON_DATA_MAX_KEY,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,r}function serializeObjectId(e,i,t,r,s){if(e[r++]=constants.BSON_DATA_OID,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,"string"==typeof t.id)e.write(t.id,r,void 0,"binary");else{if(!(0,utils_1.isUint8Array)(t.id))throw new error_1.BSONTypeError("object ["+JSON.stringify(t)+"] is not a valid ObjectId");e.set(t.id.subarray(0,12),r)}return r+12}function serializeBuffer(e,i,t,r,s){e[r++]=constants.BSON_DATA_BINARY,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var o=t.length;return e[r++]=255&o,e[r++]=o>>8&255,e[r++]=o>>16&255,e[r++]=o>>24&255,e[r++]=constants.BSON_BINARY_SUBTYPE_DEFAULT,e.set((0,ensure_buffer_1.ensureBuffer)(t),r),r+=o}function serializeObject(e,i,t,r,s,o,n,a,l,f){void 0===s&&(s=!1),void 0===o&&(o=0),void 0===n&&(n=!1),void 0===a&&(a=!0),void 0===l&&(l=!1),void 0===f&&(f=[]);for(var u=0;u<f.length;u++)if(f[u]===t)throw new error_1.BSONError("cyclic dependency detected");f.push(t),e[r++]=Array.isArray(t)?constants.BSON_DATA_ARRAY:constants.BSON_DATA_OBJECT,r+=l?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var _=serializeInto(e,t,s,r,o+1,n,a,f);return f.pop(),_}function serializeDecimal128(e,i,t,r,s){return e[r++]=constants.BSON_DATA_DECIMAL128,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,e.set(t.bytes.subarray(0,16),r),r+16}function serializeLong(e,i,t,r,s){e[r++]="Long"===t._bsontype?constants.BSON_DATA_LONG:constants.BSON_DATA_TIMESTAMP,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var o=t.getLowBits(),n=t.getHighBits();return e[r++]=255&o,e[r++]=o>>8&255,e[r++]=o>>16&255,e[r++]=o>>24&255,e[r++]=255&n,e[r++]=n>>8&255,e[r++]=n>>16&255,e[r++]=n>>24&255,r}function serializeInt32(e,i,t,r,s){return t=t.valueOf(),e[r++]=constants.BSON_DATA_INT,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,e[r++]=255&t,e[r++]=t>>8&255,e[r++]=t>>16&255,e[r++]=t>>24&255,r}function serializeDouble(e,i,t,r,s){return e[r++]=constants.BSON_DATA_NUMBER,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0,DV_FOR_FLOAT64.setFloat64(0,t.value,!0),e.set(SPACE_FOR_FLOAT64,r),r+=8}function serializeFunction(e,i,t,r,s,o,n){void 0===s&&(s=!1),void 0===o&&(o=0),e[r++]=constants.BSON_DATA_CODE,r+=n?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var a=(0,utils_1.normalizedFunctionString)(t),l=e.write(a,r+4,void 0,"utf8")+1;return e[r]=255&l,e[r+1]=l>>8&255,e[r+2]=l>>16&255,e[r+3]=l>>24&255,r=r+4+l-1,e[r++]=0,r}function serializeCode(e,i,t,r,s,o,n,a,l){if(void 0===s&&(s=!1),void 0===o&&(o=0),void 0===n&&(n=!1),void 0===a&&(a=!0),void 0===l&&(l=!1),t.scope&&"object"==typeof t.scope){e[r++]=constants.BSON_DATA_CODE_W_SCOPE,r+=l?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var f=r,u="string"==typeof t.code?t.code:t.code.toString();r+=4;var _=e.write(u,r+4,void 0,"utf8")+1;e[r]=255&_,e[r+1]=_>>8&255,e[r+2]=_>>16&255,e[r+3]=_>>24&255,e[r+4+_-1]=0,r=r+_+4;var c=serializeInto(e,t.scope,s,r,o+1,n,a);r=c-1;var p=c-f;e[f++]=255&p,e[f++]=p>>8&255,e[f++]=p>>16&255,e[f++]=p>>24&255,e[r++]=0}else{e[r++]=constants.BSON_DATA_CODE,r+=l?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;u=t.code.toString();var y=e.write(u,r+4,void 0,"utf8")+1;e[r]=255&y,e[r+1]=y>>8&255,e[r+2]=y>>16&255,e[r+3]=y>>24&255,r=r+4+y-1,e[r++]=0}return r}function serializeBinary(e,i,t,r,s){e[r++]=constants.BSON_DATA_BINARY,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var o=t.value(!0),n=t.position;return t.sub_type===binary_1.Binary.SUBTYPE_BYTE_ARRAY&&(n+=4),e[r++]=255&n,e[r++]=n>>8&255,e[r++]=n>>16&255,e[r++]=n>>24&255,e[r++]=t.sub_type,t.sub_type===binary_1.Binary.SUBTYPE_BYTE_ARRAY&&(n-=4,e[r++]=255&n,e[r++]=n>>8&255,e[r++]=n>>16&255,e[r++]=n>>24&255),e.set(o,r),r+=t.position}function serializeSymbol(e,i,t,r,s){e[r++]=constants.BSON_DATA_SYMBOL,r+=s?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var o=e.write(t.value,r+4,void 0,"utf8")+1;return e[r]=255&o,e[r+1]=o>>8&255,e[r+2]=o>>16&255,e[r+3]=o>>24&255,r=r+4+o-1,e[r++]=0,r}function serializeDBRef(e,i,t,r,s,o,n){e[r++]=constants.BSON_DATA_OBJECT,r+=n?e.write(i,r,void 0,"ascii"):e.write(i,r,void 0,"utf8"),e[r++]=0;var a=r,l={$ref:t.collection||t.namespace,$id:t.oid};null!=t.db&&(l.$db=t.db);var f=serializeInto(e,l=Object.assign(l,t.fields),!1,r,s+1,o),u=f-a;return e[a++]=255&u,e[a++]=u>>8&255,e[a++]=u>>16&255,e[a++]=u>>24&255,f}function serializeInto(e,i,t,r,s,o,n,a){void 0===t&&(t=!1),void 0===r&&(r=0),void 0===s&&(s=0),void 0===o&&(o=!1),void 0===n&&(n=!0),void 0===a&&(a=[]),r=r||0,(a=a||[]).push(i);var l=r+4;if(Array.isArray(i))for(var f=0;f<i.length;f++){var u="".concat(f);if("function"==typeof(null==(d=i[f])?void 0:d.toBSON)&&(d=d.toBSON()),"string"==typeof d)l=serializeString(e,u,d,l,!0);else if("number"==typeof d)l=serializeNumber(e,u,d,l,!0);else{if("bigint"==typeof d)throw new error_1.BSONTypeError("Unsupported type BigInt, please use Decimal128");if("boolean"==typeof d)l=serializeBoolean(e,u,d,l,!0);else if(d instanceof Date||(0,utils_1.isDate)(d))l=serializeDate(e,u,d,l,!0);else if(void 0===d)l=serializeNull(e,u,d,l,!0);else if(null===d)l=serializeNull(e,u,d,l,!0);else if("ObjectId"===d._bsontype||"ObjectID"===d._bsontype)l=serializeObjectId(e,u,d,l,!0);else if((0,utils_1.isUint8Array)(d))l=serializeBuffer(e,u,d,l,!0);else if(d instanceof RegExp||(0,utils_1.isRegExp)(d))l=serializeRegExp(e,u,d,l,!0);else if("object"==typeof d&&null==d._bsontype)l=serializeObject(e,u,d,l,t,s,o,n,!0,a);else if("object"==typeof d&&(0,extended_json_1.isBSONType)(d)&&"Decimal128"===d._bsontype)l=serializeDecimal128(e,u,d,l,!0);else if("Long"===d._bsontype||"Timestamp"===d._bsontype)l=serializeLong(e,u,d,l,!0);else if("Double"===d._bsontype)l=serializeDouble(e,u,d,l,!0);else if("function"==typeof d&&o)l=serializeFunction(e,u,d,l,t,s,!0);else if("Code"===d._bsontype)l=serializeCode(e,u,d,l,t,s,o,n,!0);else if("Binary"===d._bsontype)l=serializeBinary(e,u,d,l,!0);else if("Symbol"===d._bsontype)l=serializeSymbol(e,u,d,l,!0);else if("DBRef"===d._bsontype)l=serializeDBRef(e,u,d,l,s,o,!0);else if("BSONRegExp"===d._bsontype)l=serializeBSONRegExp(e,u,d,l,!0);else if("Int32"===d._bsontype)l=serializeInt32(e,u,d,l,!0);else if("MinKey"===d._bsontype||"MaxKey"===d._bsontype)l=serializeMinMax(e,u,d,l,!0);else if(void 0!==d._bsontype)throw new error_1.BSONTypeError("Unrecognized or invalid _bsontype: ".concat(String(d._bsontype)))}}else if(i instanceof map_1.Map||(0,utils_1.isMap)(i))for(var _=i.entries(),c=!1;!c;){var p=_.next();if(!(c=!!p.done)){u=p.value[0];var y=typeof(d=p.value[1]);if("string"==typeof u&&!ignoreKeys.has(u)){if(null!=u.match(regexp))throw Error("key "+u+" must not contain null bytes");if(t){if("$"===u[0])throw Error("key "+u+" must not start with '$'");if(~u.indexOf("."))throw Error("key "+u+" must not contain '.'")}}if("string"===y)l=serializeString(e,u,d,l);else if("number"===y)l=serializeNumber(e,u,d,l);else{if("bigint"===y||(0,utils_1.isBigInt64Array)(d)||(0,utils_1.isBigUInt64Array)(d))throw new error_1.BSONTypeError("Unsupported type BigInt, please use Decimal128");if("boolean"===y)l=serializeBoolean(e,u,d,l);else if(d instanceof Date||(0,utils_1.isDate)(d))l=serializeDate(e,u,d,l);else if(null===d||void 0===d&&!1===n)l=serializeNull(e,u,d,l);else if("ObjectId"===d._bsontype||"ObjectID"===d._bsontype)l=serializeObjectId(e,u,d,l);else if((0,utils_1.isUint8Array)(d))l=serializeBuffer(e,u,d,l);else if(d instanceof RegExp||(0,utils_1.isRegExp)(d))l=serializeRegExp(e,u,d,l);else if("object"===y&&null==d._bsontype)l=serializeObject(e,u,d,l,t,s,o,n,!1,a);else if("object"===y&&"Decimal128"===d._bsontype)l=serializeDecimal128(e,u,d,l);else if("Long"===d._bsontype||"Timestamp"===d._bsontype)l=serializeLong(e,u,d,l);else if("Double"===d._bsontype)l=serializeDouble(e,u,d,l);else if("Code"===d._bsontype)l=serializeCode(e,u,d,l,t,s,o,n);else if("function"==typeof d&&o)l=serializeFunction(e,u,d,l,t,s,o);else if("Binary"===d._bsontype)l=serializeBinary(e,u,d,l);else if("Symbol"===d._bsontype)l=serializeSymbol(e,u,d,l);else if("DBRef"===d._bsontype)l=serializeDBRef(e,u,d,l,s,o);else if("BSONRegExp"===d._bsontype)l=serializeBSONRegExp(e,u,d,l);else if("Int32"===d._bsontype)l=serializeInt32(e,u,d,l);else if("MinKey"===d._bsontype||"MaxKey"===d._bsontype)l=serializeMinMax(e,u,d,l);else if(void 0!==d._bsontype)throw new error_1.BSONTypeError("Unrecognized or invalid _bsontype: ".concat(String(d._bsontype)))}}}else{if("function"==typeof(null==i?void 0:i.toBSON)&&null!=(i=i.toBSON())&&"object"!=typeof i)throw new error_1.BSONTypeError("toBSON function did not return an object");for(var u in i){var d;"function"==typeof(null==(d=i[u])?void 0:d.toBSON)&&(d=d.toBSON());y=typeof d;if("string"==typeof u&&!ignoreKeys.has(u)){if(null!=u.match(regexp))throw Error("key "+u+" must not contain null bytes");if(t){if("$"===u[0])throw Error("key "+u+" must not start with '$'");if(~u.indexOf("."))throw Error("key "+u+" must not contain '.'")}}if("string"===y)l=serializeString(e,u,d,l);else if("number"===y)l=serializeNumber(e,u,d,l);else{if("bigint"===y)throw new error_1.BSONTypeError("Unsupported type BigInt, please use Decimal128");if("boolean"===y)l=serializeBoolean(e,u,d,l);else if(d instanceof Date||(0,utils_1.isDate)(d))l=serializeDate(e,u,d,l);else if(void 0===d)!1===n&&(l=serializeNull(e,u,d,l));else if(null===d)l=serializeNull(e,u,d,l);else if("ObjectId"===d._bsontype||"ObjectID"===d._bsontype)l=serializeObjectId(e,u,d,l);else if((0,utils_1.isUint8Array)(d))l=serializeBuffer(e,u,d,l);else if(d instanceof RegExp||(0,utils_1.isRegExp)(d))l=serializeRegExp(e,u,d,l);else if("object"===y&&null==d._bsontype)l=serializeObject(e,u,d,l,t,s,o,n,!1,a);else if("object"===y&&"Decimal128"===d._bsontype)l=serializeDecimal128(e,u,d,l);else if("Long"===d._bsontype||"Timestamp"===d._bsontype)l=serializeLong(e,u,d,l);else if("Double"===d._bsontype)l=serializeDouble(e,u,d,l);else if("Code"===d._bsontype)l=serializeCode(e,u,d,l,t,s,o,n);else if("function"==typeof d&&o)l=serializeFunction(e,u,d,l,t,s,o);else if("Binary"===d._bsontype)l=serializeBinary(e,u,d,l);else if("Symbol"===d._bsontype)l=serializeSymbol(e,u,d,l);else if("DBRef"===d._bsontype)l=serializeDBRef(e,u,d,l,s,o);else if("BSONRegExp"===d._bsontype)l=serializeBSONRegExp(e,u,d,l);else if("Int32"===d._bsontype)l=serializeInt32(e,u,d,l);else if("MinKey"===d._bsontype||"MaxKey"===d._bsontype)l=serializeMinMax(e,u,d,l);else if(void 0!==d._bsontype)throw new error_1.BSONTypeError("Unrecognized or invalid _bsontype: ".concat(String(d._bsontype)))}}}a.pop(),e[l++]=0;var b=l-r;return e[r++]=255&b,e[r++]=b>>8&255,e[r++]=b>>16&255,e[r++]=b>>24&255,l}exports.serializeInto=serializeInto;