"use strict";var Buffer=require("safe-buffer").Buffer,getParamBytesForAlg=require("./param-bytes-for-alg"),MAX_OCTET=128,CLASS_UNIVERSAL=0,PRIMITIVE_BIT=32,TAG_SEQ=16,TAG_INT=2,ENCODED_TAG_SEQ=TAG_SEQ|PRIMITIVE_BIT|CLASS_UNIVERSAL<<6,ENCODED_TAG_INT=TAG_INT|CLASS_UNIVERSAL<<6;function base64Url(r){return r.replace(/=/g,"").replace(/\+/g,"-").replace(/\//g,"_")}function signatureAsBuffer(r){if(Buffer.isBuffer(r))return r;if("string"==typeof r)return Buffer.from(r,"base64");throw new TypeError("ECDSA signature must be a Base64 string or a Buffer")}function derToJose(r,e){r=signatureAsBuffer(r);var o=getParamBytesForAlg(e),t=o+1,f=r.length,n=0;if(r[n++]!==ENCODED_TAG_SEQ)throw new Error('Could not find expected "seq"');var a=r[n++];if(a===(1|MAX_OCTET)&&(a=r[n++]),f-n<a)throw new Error('"seq" specified length of "'+a+'", only "'+(f-n)+'" remaining');if(r[n++]!==ENCODED_TAG_INT)throw new Error('Could not find expected "int" for "r"');var i=r[n++];if(f-n-2<i)throw new Error('"r" specified length of "'+i+'", only "'+(f-n-2)+'" available');if(t<i)throw new Error('"r" specified length of "'+i+'", max of "'+t+'" is acceptable');var s=n;if(n+=i,r[n++]!==ENCODED_TAG_INT)throw new Error('Could not find expected "int" for "s"');var E=r[n++];if(f-n!==E)throw new Error('"s" specified length of "'+E+'", expected "'+(f-n)+'"');if(t<E)throw new Error('"s" specified length of "'+E+'", max of "'+t+'" is acceptable');var u=n;if((n+=E)!==f)throw new Error('Expected to consume entire buffer, but "'+(f-n)+'" bytes remain');var T=o-i,c=o-E,l=Buffer.allocUnsafe(T+i+c+E);for(n=0;n<T;++n)l[n]=0;r.copy(l,n,s+Math.max(-T,0),s+i);for(var _=n=o;n<_+c;++n)l[n]=0;return r.copy(l,n,u+Math.max(-c,0),u+E),l=base64Url(l=l.toString("base64"))}function countPadding(r,e,o){for(var t=0;e+t<o&&0===r[e+t];)++t;return r[e+t]>=MAX_OCTET&&--t,t}function joseToDer(r,e){r=signatureAsBuffer(r);var o=getParamBytesForAlg(e),t=r.length;if(t!==2*o)throw new TypeError('"'+e+'" signatures must be "'+2*o+'" bytes, saw "'+t+'"');var f=countPadding(r,0,o),n=countPadding(r,o,r.length),a=o-f,i=o-n,s=2+a+1+1+i,E=s<MAX_OCTET,u=Buffer.allocUnsafe((E?2:3)+s),T=0;return u[T++]=ENCODED_TAG_SEQ,E?u[T++]=s:(u[T++]=1|MAX_OCTET,u[T++]=255&s),u[T++]=ENCODED_TAG_INT,u[T++]=a,f<0?(u[T++]=0,T+=r.copy(u,T,0,o)):T+=r.copy(u,T,f,o),u[T++]=ENCODED_TAG_INT,u[T++]=i,n<0?(u[T++]=0,r.copy(u,T,o)):r.copy(u,T,o+n),u}module.exports={derToJose:derToJose,joseToDer:joseToDer};