"use strict";const util=require("../util"),xmlNode=require("./xmlNode"),readDocType=require("./DocTypeReader"),toNumber=require("strnum");class OrderedObjParser{constructor(t){this.options=t,this.currentNode=null,this.tagsNodeStack=[],this.docTypeEntities={},this.lastEntities={apos:{regex:/&(apos|#39|#x27);/g,val:"'"},gt:{regex:/&(gt|#62|#x3E);/g,val:">"},lt:{regex:/&(lt|#60|#x3C);/g,val:"<"},quot:{regex:/&(quot|#34|#x22);/g,val:'"'}},this.ampEntity={regex:/&(amp|#38|#x26);/g,val:"&"},this.htmlEntities={space:{regex:/&(nbsp|#160);/g,val:" "},cent:{regex:/&(cent|#162);/g,val:"¢"},pound:{regex:/&(pound|#163);/g,val:"£"},yen:{regex:/&(yen|#165);/g,val:"¥"},euro:{regex:/&(euro|#8364);/g,val:"€"},copyright:{regex:/&(copy|#169);/g,val:"©"},reg:{regex:/&(reg|#174);/g,val:"®"},inr:{regex:/&(inr|#8377);/g,val:"₹"},num_dec:{regex:/&#([0-9]{1,7});/g,val:(t,e)=>String.fromCharCode(Number.parseInt(e,10))},num_hex:{regex:/&#x([0-9a-fA-F]{1,6});/g,val:(t,e)=>String.fromCharCode(Number.parseInt(e,16))}},this.addExternalEntities=addExternalEntities,this.parseXml=parseXml,this.parseTextData=parseTextData,this.resolveNameSpace=resolveNameSpace,this.buildAttributesMap=buildAttributesMap,this.isItStopNode=isItStopNode,this.replaceEntitiesValue=replaceEntitiesValue,this.readStopNodeData=readStopNodeData,this.saveTextToParentTag=saveTextToParentTag,this.addChild=addChild}}function addExternalEntities(t){const e=Object.keys(t);for(let s=0;s<e.length;s++){const i=e[s];this.lastEntities[i]={regex:new RegExp("&"+i+";","g"),val:t[i]}}}function parseTextData(t,e,s,i,n,o,a){if(void 0!==t&&(this.options.trimValues&&!i&&(t=t.trim()),t.length>0)){a||(t=this.replaceEntitiesValue(t));const i=this.options.tagValueProcessor(e,t,s,n,o);if(null==i)return t;if(typeof i!=typeof t||i!==t)return i;if(this.options.trimValues)return parseValue(t,this.options.parseTagValue,this.options.numberParseOptions);return t.trim()===t?parseValue(t,this.options.parseTagValue,this.options.numberParseOptions):t}}function resolveNameSpace(t){if(this.options.removeNSPrefix){const e=t.split(":"),s="/"===t.charAt(0)?"/":"";if("xmlns"===e[0])return"";2===e.length&&(t=s+e[1])}return t}const attrsRegx=new RegExp("([^\\s=]+)\\s*(=\\s*(['\"])([\\s\\S]*?)\\3)?","gm");function buildAttributesMap(t,e,s){if(!this.options.ignoreAttributes&&"string"==typeof t){const s=util.getAllMatches(t,attrsRegx),i=s.length,n={};for(let t=0;t<i;t++){const i=this.resolveNameSpace(s[t][1]);let o=s[t][4],a=this.options.attributeNamePrefix+i;if(i.length)if(this.options.transformAttributeName&&(a=this.options.transformAttributeName(a)),"__proto__"===a&&(a="#__proto__"),void 0!==o){this.options.trimValues&&(o=o.trim()),o=this.replaceEntitiesValue(o);const t=this.options.attributeValueProcessor(i,o,e);n[a]=null==t?o:typeof t!=typeof o||t!==o?t:parseValue(o,this.options.parseAttributeValue,this.options.numberParseOptions)}else this.options.allowBooleanAttributes&&(n[a]=!0)}if(!Object.keys(n).length)return;if(this.options.attributesGroupName){const t={};return t[this.options.attributesGroupName]=n,t}return n}}const parseXml=function(t){t=t.replace(/\r\n?/g,"\n");const e=new xmlNode("!xml");let s=e,i="",n="";for(let o=0;o<t.length;o++){if("<"===t[o])if("/"===t[o+1]){const e=findClosingIndex(t,">",o,"Closing Tag is not closed.");let a=t.substring(o+2,e).trim();if(this.options.removeNSPrefix){const t=a.indexOf(":");-1!==t&&(a=a.substr(t+1))}this.options.transformTagName&&(a=this.options.transformTagName(a)),s&&(i=this.saveTextToParentTag(i,s,n));const r=n.substring(n.lastIndexOf(".")+1);if(a&&-1!==this.options.unpairedTags.indexOf(a))throw new Error(`Unpaired tag can not be used as closing tag: </${a}>`);let l=0;r&&-1!==this.options.unpairedTags.indexOf(r)?(l=n.lastIndexOf(".",n.lastIndexOf(".")-1),this.tagsNodeStack.pop()):l=n.lastIndexOf("."),n=n.substring(0,l),s=this.tagsNodeStack.pop(),i="",o=e}else if("?"===t[o+1]){let e=readTagExp(t,o,!1,"?>");if(!e)throw new Error("Pi Tag is not closed.");if(i=this.saveTextToParentTag(i,s,n),this.options.ignoreDeclaration&&"?xml"===e.tagName||this.options.ignorePiTags);else{const t=new xmlNode(e.tagName);t.add(this.options.textNodeName,""),e.tagName!==e.tagExp&&e.attrExpPresent&&(t[":@"]=this.buildAttributesMap(e.tagExp,n,e.tagName)),this.addChild(s,t,n)}o=e.closeIndex+1}else if("!--"===t.substr(o+1,3)){const e=findClosingIndex(t,"--\x3e",o+4,"Comment is not closed.");if(this.options.commentPropName){const a=t.substring(o+4,e-2);i=this.saveTextToParentTag(i,s,n),s.add(this.options.commentPropName,[{[this.options.textNodeName]:a}])}o=e}else if("!D"===t.substr(o+1,2)){const e=readDocType(t,o);this.docTypeEntities=e.entities,o=e.i}else if("!["===t.substr(o+1,2)){const e=findClosingIndex(t,"]]>",o,"CDATA is not closed.")-2,a=t.substring(o+9,e);i=this.saveTextToParentTag(i,s,n);let r=this.parseTextData(a,s.tagname,n,!0,!1,!0,!0);null==r&&(r=""),this.options.cdataPropName?s.add(this.options.cdataPropName,[{[this.options.textNodeName]:a}]):s.add(this.options.textNodeName,r),o=e+2}else{let a=readTagExp(t,o,this.options.removeNSPrefix),r=a.tagName;const l=a.rawTagName;let d=a.tagExp,p=a.attrExpPresent,g=a.closeIndex;this.options.transformTagName&&(r=this.options.transformTagName(r)),s&&i&&"!xml"!==s.tagname&&(i=this.saveTextToParentTag(i,s,n,!1));const h=s;if(h&&-1!==this.options.unpairedTags.indexOf(h.tagname)&&(s=this.tagsNodeStack.pop(),n=n.substring(0,n.lastIndexOf("."))),r!==e.tagname&&(n+=n?"."+r:r),this.isItStopNode(this.options.stopNodes,n,r)){let e="";if(d.length>0&&d.lastIndexOf("/")===d.length-1)"/"===r[r.length-1]?(r=r.substr(0,r.length-1),n=n.substr(0,n.length-1),d=r):d=d.substr(0,d.length-1),o=a.closeIndex;else if(-1!==this.options.unpairedTags.indexOf(r))o=a.closeIndex;else{const s=this.readStopNodeData(t,l,g+1);if(!s)throw new Error(`Unexpected end of ${l}`);o=s.i,e=s.tagContent}const i=new xmlNode(r);r!==d&&p&&(i[":@"]=this.buildAttributesMap(d,n,r)),e&&(e=this.parseTextData(e,r,n,!0,p,!0,!0)),n=n.substr(0,n.lastIndexOf(".")),i.add(this.options.textNodeName,e),this.addChild(s,i,n)}else{if(d.length>0&&d.lastIndexOf("/")===d.length-1){"/"===r[r.length-1]?(r=r.substr(0,r.length-1),n=n.substr(0,n.length-1),d=r):d=d.substr(0,d.length-1),this.options.transformTagName&&(r=this.options.transformTagName(r));const t=new xmlNode(r);r!==d&&p&&(t[":@"]=this.buildAttributesMap(d,n,r)),this.addChild(s,t,n),n=n.substr(0,n.lastIndexOf("."))}else{const t=new xmlNode(r);this.tagsNodeStack.push(s),r!==d&&p&&(t[":@"]=this.buildAttributesMap(d,n,r)),this.addChild(s,t,n),s=t}i="",o=g}}else i+=t[o]}return e.child};function addChild(t,e,s){const i=this.options.updateTag(e.tagname,s,e[":@"]);!1===i||("string"==typeof i?(e.tagname=i,t.addChild(e)):t.addChild(e))}const replaceEntitiesValue=function(t){if(this.options.processEntities){for(let e in this.docTypeEntities){const s=this.docTypeEntities[e];t=t.replace(s.regx,s.val)}for(let e in this.lastEntities){const s=this.lastEntities[e];t=t.replace(s.regex,s.val)}if(this.options.htmlEntities)for(let e in this.htmlEntities){const s=this.htmlEntities[e];t=t.replace(s.regex,s.val)}t=t.replace(this.ampEntity.regex,this.ampEntity.val)}return t};function saveTextToParentTag(t,e,s,i){return t&&(void 0===i&&(i=0===Object.keys(e.child).length),void 0!==(t=this.parseTextData(t,e.tagname,s,!1,!!e[":@"]&&0!==Object.keys(e[":@"]).length,i))&&""!==t&&e.add(this.options.textNodeName,t),t=""),t}function isItStopNode(t,e,s){const i="*."+s;for(const s in t){const n=t[s];if(i===n||e===n)return!0}return!1}function tagExpWithClosingIndex(t,e,s=">"){let i,n="";for(let o=e;o<t.length;o++){let e=t[o];if(i)e===i&&(i="");else if('"'===e||"'"===e)i=e;else if(e===s[0]){if(!s[1])return{data:n,index:o};if(t[o+1]===s[1])return{data:n,index:o}}else"\t"===e&&(e=" ");n+=e}}function findClosingIndex(t,e,s,i){const n=t.indexOf(e,s);if(-1===n)throw new Error(i);return n+e.length-1}function readTagExp(t,e,s,i=">"){const n=tagExpWithClosingIndex(t,e+1,i);if(!n)return;let o=n.data;const a=n.index,r=o.search(/\s/);let l=o,d=!0;-1!==r&&(l=o.substring(0,r),o=o.substring(r+1).trimStart());const p=l;if(s){const t=l.indexOf(":");-1!==t&&(l=l.substr(t+1),d=l!==n.data.substr(t+1))}return{tagName:l,tagExp:o,closeIndex:a,attrExpPresent:d,rawTagName:p}}function readStopNodeData(t,e,s){const i=s;let n=1;for(;s<t.length;s++)if("<"===t[s])if("/"===t[s+1]){const o=findClosingIndex(t,">",s,`${e} is not closed`);if(t.substring(s+2,o).trim()===e&&(n--,0===n))return{tagContent:t.substring(i,s),i:o};s=o}else if("?"===t[s+1]){s=findClosingIndex(t,"?>",s+1,"StopNode is not closed.")}else if("!--"===t.substr(s+1,3)){s=findClosingIndex(t,"--\x3e",s+3,"StopNode is not closed.")}else if("!["===t.substr(s+1,2)){s=findClosingIndex(t,"]]>",s,"StopNode is not closed.")-2}else{const i=readTagExp(t,s,">");if(i){(i&&i.tagName)===e&&"/"!==i.tagExp[i.tagExp.length-1]&&n++,s=i.closeIndex}}}function parseValue(t,e,s){if(e&&"string"==typeof t){const e=t.trim();return"true"===e||"false"!==e&&toNumber(t,s)}return util.isExist(t)?t:""}module.exports=OrderedObjParser;