"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.Gaxios=void 0;const extend_1=__importDefault(require("extend")),https_1=require("https"),node_fetch_1=__importDefault(require("node-fetch")),querystring_1=__importDefault(require("querystring")),is_stream_1=__importDefault(require("is-stream")),url_1=require("url"),common_1=require("./common"),retry_1=require("./retry"),fetch=hasFetch()?window.fetch:node_fetch_1.default;function hasWindow(){return"undefined"!=typeof window&&!!window}function hasFetch(){return hasWindow()&&!!window.fetch}function hasBuffer(){return"undefined"!=typeof Buffer}function hasHeader(e,t){return!!getHeader(e,t)}function getHeader(e,t){t=t.toLowerCase();for(const r of Object.keys((null==e?void 0:e.headers)||{}))if(t===r.toLowerCase())return e.headers[r]}let HttpsProxyAgent;function loadProxy(){const e=process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy;return e&&(HttpsProxyAgent=require("https-proxy-agent")),e}function skipProxy(e){var t;const r=null!==(t=process.env.NO_PROXY)&&void 0!==t?t:process.env.no_proxy;if(!r)return!1;const a=r.split(","),s=new url_1.URL(e);return!!a.find((e=>e.startsWith("*.")||e.startsWith(".")?(e=e.replace(/^\*\./,"."),s.hostname.endsWith(e)):e===s.origin||e===s.hostname))}function getProxy(e){return skipProxy(e)?void 0:loadProxy()}loadProxy();class Gaxios{constructor(e){this.agentCache=new Map,this.defaults=e||{}}async request(e={}){return e=this.validateOpts(e),this._request(e)}async _defaultAdapter(e){const t=e.fetchImplementation||fetch,r=await t(e.url,e),a=await this.getResponseData(e,r);return this.translateResponse(e,r,a)}async _request(e={}){try{let t;if(t=e.adapter?await e.adapter(e,this._defaultAdapter.bind(this)):await this._defaultAdapter(e),!e.validateStatus(t.status))throw new common_1.GaxiosError(`Request failed with status code ${t.status}`,e,t);return t}catch(t){const r=t;r.config=e;const{shouldRetry:a,config:s}=await retry_1.getRetryConfig(t);if(a&&s)return r.config.retryConfig.currentRetryAttempt=s.retryConfig.currentRetryAttempt,this._request(r.config);throw r}}async getResponseData(e,t){switch(e.responseType){case"stream":return t.body;case"json":{let e=await t.text();try{e=JSON.parse(e)}catch(e){}return e}case"arraybuffer":return t.arrayBuffer();case"blob":return t.blob();default:return t.text()}}validateOpts(e){const t=extend_1.default(!0,{},this.defaults,e);if(!t.url)throw new Error("URL is required.");const r=t.baseUrl||t.baseURL;if(r&&(t.url=r+t.url),t.paramsSerializer=t.paramsSerializer||this.paramsSerializer,t.params&&Object.keys(t.params).length>0){let e=t.paramsSerializer(t.params);e.startsWith("?")&&(e=e.slice(1));const r=t.url.includes("?")?"&":"?";t.url=t.url+r+e}if("number"==typeof e.maxContentLength&&(t.size=e.maxContentLength),"number"==typeof e.maxRedirects&&(t.follow=e.maxRedirects),t.headers=t.headers||{},t.data){const e="undefined"!=typeof FormData&&(null==t?void 0:t.data)instanceof FormData;is_stream_1.default.readable(t.data)?t.body=t.data:hasBuffer()&&Buffer.isBuffer(t.data)?(t.body=t.data,hasHeader(t,"Content-Type")||(t.headers["Content-Type"]="application/json")):"object"==typeof t.data?e||("application/x-www-form-urlencoded"===getHeader(t,"content-type")?t.body=t.paramsSerializer(t.data):(hasHeader(t,"Content-Type")||(t.headers["Content-Type"]="application/json"),t.body=JSON.stringify(t.data))):t.body=t.data}t.validateStatus=t.validateStatus||this.validateStatus,t.responseType=t.responseType||"json",t.headers.Accept||"json"!==t.responseType||(t.headers.Accept="application/json"),t.method=t.method||"GET";const a=getProxy(t.url);if(a)if(this.agentCache.has(a))t.agent=this.agentCache.get(a);else{if(t.cert&&t.key){const e=new url_1.URL(a);t.agent=new HttpsProxyAgent({port:e.port,host:e.host,protocol:e.protocol,cert:t.cert,key:t.key})}else t.agent=new HttpsProxyAgent(a);this.agentCache.set(a,t.agent)}else t.cert&&t.key&&(this.agentCache.has(t.key)?t.agent=this.agentCache.get(t.key):(t.agent=new https_1.Agent({cert:t.cert,key:t.key}),this.agentCache.set(t.key,t.agent)));return t}validateStatus(e){return e>=200&&e<300}paramsSerializer(e){return querystring_1.default.stringify(e)}translateResponse(e,t,r){const a={};return t.headers.forEach(((e,t)=>{a[t]=e})),{config:e,data:r,headers:a,status:t.status,statusText:t.statusText,request:{responseURL:t.url}}}}exports.Gaxios=Gaxios;