"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.BaseExternalAccountClient=exports.DEFAULT_UNIVERSE=exports.CLOUD_RESOURCE_MANAGER=exports.EXTERNAL_ACCOUNT_TYPE=exports.EXPIRATION_TIME_OFFSET=void 0;const stream=require("stream"),authclient_1=require("./authclient"),sts=require("./stscredentials"),util_1=require("../util"),STS_GRANT_TYPE="urn:ietf:params:oauth:grant-type:token-exchange",STS_REQUEST_TOKEN_TYPE="urn:ietf:params:oauth:token-type:access_token",DEFAULT_OAUTH_SCOPE="https://www.googleapis.com/auth/cloud-platform",DEFAULT_TOKEN_LIFESPAN=3600;exports.EXPIRATION_TIME_OFFSET=3e5,exports.EXTERNAL_ACCOUNT_TYPE="external_account",exports.CLOUD_RESOURCE_MANAGER="https://cloudresourcemanager.googleapis.com/v1/projects/";const WORKFORCE_AUDIENCE_PATTERN="//iam\\.googleapis\\.com/locations/[^/]+/workforcePools/[^/]+/providers/.+",DEFAULT_TOKEN_URL="https://sts.{universeDomain}/v1/token",pkg=require("../../../package.json");var authclient_2=require("./authclient");Object.defineProperty(exports,"DEFAULT_UNIVERSE",{enumerable:!0,get:function(){return authclient_2.DEFAULT_UNIVERSE}});class BaseExternalAccountClient extends authclient_1.AuthClient{constructor(e,t){var s;super({...e,...t});const r=(0,util_1.originalOrCamelOptions)(e),o=r.get("type");if(o&&o!==exports.EXTERNAL_ACCOUNT_TYPE)throw new Error(`Expected "${exports.EXTERNAL_ACCOUNT_TYPE}" type but received "${e.type}"`);const c=r.get("client_id"),i=r.get("client_secret"),n=null!==(s=r.get("token_url"))&&void 0!==s?s:DEFAULT_TOKEN_URL.replace("{universeDomain}",this.universeDomain),a=r.get("subject_token_type"),u=r.get("workforce_pool_user_project"),h=r.get("service_account_impersonation_url"),l=r.get("service_account_impersonation"),p=(0,util_1.originalOrCamelOptions)(l).get("token_lifetime_seconds");this.cloudResourceManagerURL=new URL(r.get("cloud_resource_manager_url")||`https://cloudresourcemanager.${this.universeDomain}/v1/projects/`),c&&(this.clientAuth={confidentialClientType:"basic",clientId:c,clientSecret:i}),this.stsCredential=new sts.StsCredentials(n,this.clientAuth),this.scopes=r.get("scopes")||[DEFAULT_OAUTH_SCOPE],this.cachedAccessToken=null,this.audience=r.get("audience"),this.subjectTokenType=a,this.workforcePoolUserProject=u;const d=new RegExp(WORKFORCE_AUDIENCE_PATTERN);if(this.workforcePoolUserProject&&!this.audience.match(d))throw new Error("workforcePoolUserProject should not be set for non-workforce pool credentials.");this.serviceAccountImpersonationUrl=h,this.serviceAccountImpersonationLifetime=p,this.serviceAccountImpersonationLifetime?this.configLifetimeRequested=!0:(this.configLifetimeRequested=!1,this.serviceAccountImpersonationLifetime=3600),this.projectNumber=this.getProjectNumber(this.audience),this.supplierContext={audience:this.audience,subjectTokenType:this.subjectTokenType,transporter:this.transporter}}getServiceAccountEmail(){var e;if(this.serviceAccountImpersonationUrl){if(this.serviceAccountImpersonationUrl.length>256)throw new RangeError(`URL is too long: ${this.serviceAccountImpersonationUrl}`);const t=/serviceAccounts\/(?<email>[^:]+):generateAccessToken$/.exec(this.serviceAccountImpersonationUrl);return(null===(e=null==t?void 0:t.groups)||void 0===e?void 0:e.email)||null}return null}setCredentials(e){super.setCredentials(e),this.cachedAccessToken=e}async getAccessToken(){return this.cachedAccessToken&&!this.isExpired(this.cachedAccessToken)||await this.refreshAccessTokenAsync(),{token:this.cachedAccessToken.access_token,res:this.cachedAccessToken.res}}async getRequestHeaders(){const e={Authorization:`Bearer ${(await this.getAccessToken()).token}`};return this.addSharedMetadataHeaders(e)}request(e,t){if(!t)return this.requestAsync(e);this.requestAsync(e).then((e=>t(null,e)),(e=>t(e,e.response)))}async getProjectId(){const e=this.projectNumber||this.workforcePoolUserProject;if(this.projectId)return this.projectId;if(e){const t=await this.getRequestHeaders(),s=await this.transporter.request({...BaseExternalAccountClient.RETRY_CONFIG,headers:t,url:`${this.cloudResourceManagerURL.toString()}${e}`,responseType:"json"});return this.projectId=s.data.projectId,this.projectId}return null}async requestAsync(e,t=!1){let s;try{const t=await this.getRequestHeaders();e.headers=e.headers||{},t&&t["x-goog-user-project"]&&(e.headers["x-goog-user-project"]=t["x-goog-user-project"]),t&&t.Authorization&&(e.headers.Authorization=t.Authorization),s=await this.transporter.request(e)}catch(s){const r=s.response;if(r){const s=r.status,o=r.config.data instanceof stream.Readable;if(!t&&(401===s||403===s)&&!o&&this.forceRefreshOnFailure)return await this.refreshAccessTokenAsync(),await this.requestAsync(e,!0)}throw s}return s}async refreshAccessTokenAsync(){const e=await this.retrieveSubjectToken(),t={grantType:STS_GRANT_TYPE,audience:this.audience,requestedTokenType:STS_REQUEST_TOKEN_TYPE,subjectToken:e,subjectTokenType:this.subjectTokenType,scope:this.serviceAccountImpersonationUrl?[DEFAULT_OAUTH_SCOPE]:this.getScopesArray()},s=!this.clientAuth&&this.workforcePoolUserProject?{userProject:this.workforcePoolUserProject}:void 0,r={"x-goog-api-client":this.getMetricsHeaderValue()},o=await this.stsCredential.exchangeToken(t,r,s);return this.serviceAccountImpersonationUrl?this.cachedAccessToken=await this.getImpersonatedAccessToken(o.access_token):o.expires_in?this.cachedAccessToken={access_token:o.access_token,expiry_date:(new Date).getTime()+1e3*o.expires_in,res:o.res}:this.cachedAccessToken={access_token:o.access_token,res:o.res},this.credentials={},Object.assign(this.credentials,this.cachedAccessToken),delete this.credentials.res,this.emit("tokens",{refresh_token:null,expiry_date:this.cachedAccessToken.expiry_date,access_token:this.cachedAccessToken.access_token,token_type:"Bearer",id_token:null}),this.cachedAccessToken}getProjectNumber(e){const t=e.match(/\/projects\/([^/]+)/);return t?t[1]:null}async getImpersonatedAccessToken(e){const t={...BaseExternalAccountClient.RETRY_CONFIG,url:this.serviceAccountImpersonationUrl,method:"POST",headers:{"Content-Type":"application/json",Authorization:`Bearer ${e}`},data:{scope:this.getScopesArray(),lifetime:this.serviceAccountImpersonationLifetime+"s"},responseType:"json"},s=await this.transporter.request(t),r=s.data;return{access_token:r.accessToken,expiry_date:new Date(r.expireTime).getTime(),res:s}}isExpired(e){const t=(new Date).getTime();return!!e.expiry_date&&t>=e.expiry_date-this.eagerRefreshThresholdMillis}getScopesArray(){return"string"==typeof this.scopes?[this.scopes]:this.scopes||[DEFAULT_OAUTH_SCOPE]}getMetricsHeaderValue(){const e=process.version.replace(/^v/,""),t=void 0!==this.serviceAccountImpersonationUrl,s=this.credentialSourceType?this.credentialSourceType:"unknown";return`gl-node/${e} auth/${pkg.version} google-byoid-sdk source/${s} sa-impersonation/${t} config-lifetime/${this.configLifetimeRequested}`}}exports.BaseExternalAccountClient=BaseExternalAccountClient;