"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.DownscopedClient=exports.EXPIRATION_TIME_OFFSET=exports.MAX_ACCESS_BOUNDARY_RULES_COUNT=void 0;const stream=require("stream"),authclient_1=require("./authclient"),sts=require("./stscredentials"),STS_GRANT_TYPE="urn:ietf:params:oauth:grant-type:token-exchange",STS_REQUEST_TOKEN_TYPE="urn:ietf:params:oauth:token-type:access_token",STS_SUBJECT_TOKEN_TYPE="urn:ietf:params:oauth:token-type:access_token";exports.MAX_ACCESS_BOUNDARY_RULES_COUNT=10,exports.EXPIRATION_TIME_OFFSET=3e5;class DownscopedClient extends authclient_1.AuthClient{constructor(e,s,t,n){if(super({...t,quotaProjectId:n}),this.authClient=e,this.credentialAccessBoundary=s,0===s.accessBoundary.accessBoundaryRules.length)throw new Error("At least one access boundary rule needs to be defined.");if(s.accessBoundary.accessBoundaryRules.length>exports.MAX_ACCESS_BOUNDARY_RULES_COUNT)throw new Error(`The provided access boundary has more than ${exports.MAX_ACCESS_BOUNDARY_RULES_COUNT} access boundary rules.`);for(const e of s.accessBoundary.accessBoundaryRules)if(0===e.availablePermissions.length)throw new Error("At least one permission should be defined in access boundary rules.");this.stsCredential=new sts.StsCredentials(`https://sts.${this.universeDomain}/v1/token`),this.cachedDownscopedAccessToken=null}setCredentials(e){if(!e.expiry_date)throw new Error("The access token expiry_date field is missing in the provided credentials.");super.setCredentials(e),this.cachedDownscopedAccessToken=e}async getAccessToken(){return this.cachedDownscopedAccessToken&&!this.isExpired(this.cachedDownscopedAccessToken)||await this.refreshAccessTokenAsync(),{token:this.cachedDownscopedAccessToken.access_token,expirationTime:this.cachedDownscopedAccessToken.expiry_date,res:this.cachedDownscopedAccessToken.res}}async getRequestHeaders(){const e={Authorization:`Bearer ${(await this.getAccessToken()).token}`};return this.addSharedMetadataHeaders(e)}request(e,s){if(!s)return this.requestAsync(e);this.requestAsync(e).then((e=>s(null,e)),(e=>s(e,e.response)))}async requestAsync(e,s=!1){let t;try{const s=await this.getRequestHeaders();e.headers=e.headers||{},s&&s["x-goog-user-project"]&&(e.headers["x-goog-user-project"]=s["x-goog-user-project"]),s&&s.Authorization&&(e.headers.Authorization=s.Authorization),t=await this.transporter.request(e)}catch(t){const n=t.response;if(n){const t=n.status,r=n.config.data instanceof stream.Readable;if(!s&&(401===t||403===t)&&!r&&this.forceRefreshOnFailure)return await this.refreshAccessTokenAsync(),await this.requestAsync(e,!0)}throw t}return t}async refreshAccessTokenAsync(){var e;const s=(await this.authClient.getAccessToken()).token,t={grantType:STS_GRANT_TYPE,requestedTokenType:STS_REQUEST_TOKEN_TYPE,subjectToken:s,subjectTokenType:STS_SUBJECT_TOKEN_TYPE},n=await this.stsCredential.exchangeToken(t,void 0,this.credentialAccessBoundary),r=(null===(e=this.authClient.credentials)||void 0===e?void 0:e.expiry_date)||null,c=n.expires_in?(new Date).getTime()+1e3*n.expires_in:r;return this.cachedDownscopedAccessToken={access_token:n.access_token,expiry_date:c,res:n.res},this.credentials={},Object.assign(this.credentials,this.cachedDownscopedAccessToken),delete this.credentials.res,this.emit("tokens",{refresh_token:null,expiry_date:this.cachedDownscopedAccessToken.expiry_date,access_token:this.cachedDownscopedAccessToken.access_token,token_type:"Bearer",id_token:null}),this.cachedDownscopedAccessToken}isExpired(e){const s=(new Date).getTime();return!!e.expiry_date&&s>=e.expiry_date-this.eagerRefreshThresholdMillis}}exports.DownscopedClient=DownscopedClient;