"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.PluggableAuthClient=exports.ExecutableError=void 0;const baseexternalclient_1=require("./baseexternalclient"),executable_response_1=require("./executable-response"),pluggable_auth_handler_1=require("./pluggable-auth-handler");class ExecutableError extends Error{constructor(e,t){super(`The executable failed with exit code: ${t} and error message: ${e}.`),this.code=t,Object.setPrototypeOf(this,new.target.prototype)}}exports.ExecutableError=ExecutableError;const DEFAULT_EXECUTABLE_TIMEOUT_MILLIS=3e4,MINIMUM_EXECUTABLE_TIMEOUT_MILLIS=5e3,MAXIMUM_EXECUTABLE_TIMEOUT_MILLIS=12e4,GOOGLE_EXTERNAL_ACCOUNT_ALLOW_EXECUTABLES="GOOGLE_EXTERNAL_ACCOUNT_ALLOW_EXECUTABLES",MAXIMUM_EXECUTABLE_VERSION=1;class PluggableAuthClient extends baseexternalclient_1.BaseExternalAccountClient{constructor(e,t){if(super(e,t),!e.credential_source.executable)throw new Error('No valid Pluggable Auth "credential_source" provided.');if(this.command=e.credential_source.executable.command,!this.command)throw new Error('No valid Pluggable Auth "credential_source" provided.');if(void 0===e.credential_source.executable.timeout_millis)this.timeoutMillis=3e4;else if(this.timeoutMillis=e.credential_source.executable.timeout_millis,this.timeoutMillis<5e3||this.timeoutMillis>12e4)throw new Error("Timeout must be between 5000 and 120000 milliseconds.");this.outputFile=e.credential_source.executable.output_file,this.handler=new pluggable_auth_handler_1.PluggableAuthHandler({command:this.command,timeoutMillis:this.timeoutMillis,outputFile:this.outputFile}),this.credentialSourceType="executable"}async retrieveSubjectToken(){if("1"!==process.env[GOOGLE_EXTERNAL_ACCOUNT_ALLOW_EXECUTABLES])throw new Error("Pluggable Auth executables need to be explicitly allowed to run by setting the GOOGLE_EXTERNAL_ACCOUNT_ALLOW_EXECUTABLES environment Variable to 1.");let e;if(this.outputFile&&(e=await this.handler.retrieveCachedResponse()),!e){const t=new Map;t.set("GOOGLE_EXTERNAL_ACCOUNT_AUDIENCE",this.audience),t.set("GOOGLE_EXTERNAL_ACCOUNT_TOKEN_TYPE",this.subjectTokenType),t.set("GOOGLE_EXTERNAL_ACCOUNT_INTERACTIVE","0"),this.outputFile&&t.set("GOOGLE_EXTERNAL_ACCOUNT_OUTPUT_FILE",this.outputFile);const r=this.getServiceAccountEmail();r&&t.set("GOOGLE_EXTERNAL_ACCOUNT_IMPERSONATED_EMAIL",r),e=await this.handler.retrieveResponseFromExecutable(t)}if(e.version>1)throw new Error("Version of executable is not currently supported, maximum supported version is 1.");if(!e.success)throw new ExecutableError(e.errorMessage,e.errorCode);if(this.outputFile&&!e.expirationTime)throw new executable_response_1.InvalidExpirationTimeFieldError("The executable response must contain the `expiration_time` field for successful responses when an output_file has been specified in the configuration.");if(e.isExpired())throw new Error("Executable response is expired.");return e.subjectToken}}exports.PluggableAuthClient=PluggableAuthClient;