"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.CallSettings=exports.RetryOptions=void 0,exports.convertRetryOptions=convertRetryOptions,exports.createRetryOptions=createRetryOptions,exports.createBackoffSettings=createBackoffSettings,exports.createDefaultBackoffSettings=createDefaultBackoffSettings,exports.createMaxRetriesBackoffSettings=createMaxRetriesBackoffSettings,exports.createBundleOptions=createBundleOptions,exports.constructSettings=constructSettings,exports.createByteLengthFunction=createByteLengthFunction;const warnings_1=require("./warnings"),util_1=require("./util"),status_1=require("./status");class RetryOptions{constructor(t,e,r,i){this.retryCodes=t,this.backoffSettings=e,this.shouldRetryFn=r,this.getResumptionRequestFn=i}}exports.RetryOptions=RetryOptions;class CallSettings{constructor(t){var e;t=t||{},this.timeout=t.timeout||3e4,this.retry=t.retry,this.autoPaginate=!("autoPaginate"in t)||t.autoPaginate,this.maxResults=t.maxResults,this.otherArgs=t.otherArgs||{},this.bundleOptions=t.bundleOptions,this.isBundling=!("isBundling"in t)||t.isBundling,this.longrunning="longrunning"in t?t.longrunning:void 0,this.apiName=null!==(e=t.apiName)&&void 0!==e?e:void 0,this.retryRequestOptions=t.retryRequestOptions}merge(t){if(!t)return new CallSettings(this);let e=this.timeout,r=this.retry,i=this.autoPaginate,n=this.maxResults,s=this.otherArgs,o=this.isBundling,l=this.longrunning,u=this.apiName,a=this.retryRequestOptions;if("timeout"in t&&(e=t.timeout),(null==r?void 0:r.retryCodes)&&(r.backoffSettings.initialRpcTimeoutMillis=e,r.backoffSettings.maxRpcTimeoutMillis=e,r.backoffSettings.totalTimeoutMillis=e),"retry"in t&&(r=mergeRetryOptions(r||{},t.retry)),"autoPaginate"in t&&!t.autoPaginate&&(i=!1),"maxResults"in t&&(n=t.maxResults),"otherArgs"in t){s={};for(const t in this.otherArgs)s[t]=this.otherArgs[t];for(const e in t.otherArgs)s[e]=t.otherArgs[e]}return"isBundling"in t&&(o=t.isBundling),"maxRetries"in t&&void 0!==t.maxRetries&&(r.backoffSettings.maxRetries=t.maxRetries,delete r.backoffSettings.totalTimeoutMillis),"longrunning"in t&&(l=t.longrunning),"apiName"in t&&(u=t.apiName),"retryRequestOptions"in t&&(a=t.retryRequestOptions),new CallSettings({timeout:e,retry:r,bundleOptions:this.bundleOptions,longrunning:l,autoPaginate:i,maxResults:n,otherArgs:s,isBundling:o,apiName:u,retryRequestOptions:a})}}function convertRetryOptions(t,e){var r,i,n,s;if(!t)return t;if(!e)return t;if(t.retry&&t.retryRequestOptions)throw new Error("Only one of retry or retryRequestOptions may be set");if(t.retryRequestOptions){void 0!==t.retryRequestOptions.objectMode&&(0,warnings_1.warn)("retry_request_options","objectMode override is not supported. It is set to true internally by default in gax.","UnsupportedParameterWarning"),void 0!==t.retryRequestOptions.noResponseRetries&&(0,warnings_1.warn)("retry_request_options","noResponseRetries override is not supported. Please specify retry codes or a function to determine retry eligibility.","UnsupportedParameterWarning"),void 0!==t.retryRequestOptions.currentRetryAttempt&&(0,warnings_1.warn)("retry_request_options","currentRetryAttempt override is not supported. Retry attempts are tracked internally.","UnsupportedParameterWarning");let e,o=[status_1.Status.UNAVAILABLE];t.retryRequestOptions.shouldRetryFn&&(o=[],e=t.retryRequestOptions.shouldRetryFn),t.maxRetries=null!==(i=null===(r=null==t?void 0:t.retryRequestOptions)||void 0===r?void 0:r.retries)&&void 0!==i?i:t.maxRetries;const l=createDefaultBackoffSettings();let u,a;void 0!==t.retryRequestOptions.maxRetryDelay&&(u=1e3*t.retryRequestOptions.maxRetryDelay);const y=null!==(s=null===(n=null==t?void 0:t.retryRequestOptions)||void 0===n?void 0:n.retryDelayMultiplier)&&void 0!==s?s:l.retryDelayMultiplier;void 0!==t.retryRequestOptions.totalTimeout&&(a=1e3*t.retryRequestOptions.totalTimeout),l.maxRetryDelayMillis=null!=u?u:l.maxRetryDelayMillis,l.retryDelayMultiplier=null!=y?y:l.retryDelayMultiplier,l.totalTimeoutMillis=null!=a?a:l.totalTimeoutMillis;const c=createRetryOptions(o,l,e);t.retry=c,delete t.retryRequestOptions,(0,warnings_1.warn)("retry_request_options","retryRequestOptions will be deprecated in a future release. Please use retryOptions to pass retry options at call time","DeprecationWarning")}return t}function createRetryOptions(t,e,r,i){return{retryCodes:t,backoffSettings:e,shouldRetryFn:r,getResumptionRequestFn:i}}function createBackoffSettings(t,e,r,i,n,s,o){return{initialRetryDelayMillis:t,retryDelayMultiplier:e,maxRetryDelayMillis:r,initialRpcTimeoutMillis:i,rpcTimeoutMultiplier:n,maxRpcTimeoutMillis:s,totalTimeoutMillis:o}}function createDefaultBackoffSettings(){return createBackoffSettings(100,1.3,6e4,null,null,null,null)}function createMaxRetriesBackoffSettings(t,e,r,i,n,s,o){return{initialRetryDelayMillis:t,retryDelayMultiplier:e,maxRetryDelayMillis:r,initialRpcTimeoutMillis:i,rpcTimeoutMultiplier:n,maxRpcTimeoutMillis:s,maxRetries:o}}function createBundleOptions(t){["element_count_threshold","element_count_limit","request_byte_threshold","request_byte_limit","delay_threshold_millis"].forEach((e=>{if(e in t&&"number"!=typeof t[e])throw new Error(`${e} should be a number`)}));const e=t.element_count_threshold||0,r=t.element_count_limit||0,i=t.request_byte_threshold||0,n=t.request_byte_limit||0,s=t.delay_threshold_millis||0;if(0===e&&0===i&&0===s)throw new Error("one threshold should be > 0");return{elementCountThreshold:e,elementCountLimit:r,requestByteThreshold:i,requestByteLimit:n,delayThreshold:s}}function constructRetry(t,e,r,i){if(!t)return null;let n=null;if(e&&"retry_codes_name"in t){n=(e[t.retry_codes_name]||[]).map((t=>Number(i[t])))}let s=null;if(r&&"retry_params_name"in t){const e=r[t.retry_params_name];s=createBackoffSettings(e.initial_retry_delay_millis,e.retry_delay_multiplier,e.max_retry_delay_millis,e.initial_rpc_timeout_millis,e.rpc_timeout_multiplier,e.max_rpc_timeout_millis,e.total_timeout_millis)}return createRetryOptions(n,s)}function mergeRetryOptions(t,e){if(!e)return null;if(!(e.retryCodes||e.backoffSettings||e.shouldRetryFn||e.getResumptionRequestFn))return t;return createRetryOptions(e.retryCodes?e.retryCodes:t.retryCodes,e.backoffSettings?e.backoffSettings:t.backoffSettings,e.shouldRetryFn?e.shouldRetryFn:t.shouldRetryFn,e.getResumptionRequestFn?e.getResumptionRequestFn:t.getResumptionRequestFn)}function constructSettings(t,e,r,i,n){n=n||{};const s={},o=(e.interfaces||{})[t];if(!o)return null;const l=(r.interfaces||{})[t]||{},u=o.methods,a=l.methods||{};for(const e in u){const r=u[e],y=(0,util_1.toLowerCamelCase)(e);let c=constructRetry(r,o.retry_codes,o.retry_params,i),p=r.bundling,m=r.timeout_millis;if(e in a){const t=a[e];t&&("bundling"in t&&(p=t.bundling),"timeout_millis"in t&&(m=t.timeout_millis)),c=mergeRetryOptions(c,constructRetry(t,l.retry_codes,l.retry_params,i))}const g=t;s[y]=new CallSettings({timeout:m,retry:c,bundleOptions:p?createBundleOptions(p):null,otherArgs:n,apiName:g})}return s}function createByteLengthFunction(t){return function(e){try{return t.encode(e).finish().length}catch(t){const r=JSON.stringify(e);return(0,warnings_1.warn)("error_encoding_protobufjs_object",`Cannot encode protobuf.js object: ${r}: ${t}`),r.length}}}exports.CallSettings=CallSettings;