"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.StreamProxy=exports.StreamType=void 0;const googleError_1=require("../googleError"),streamingRetryRequest_1=require("../streamingRetryRequest"),status_1=require("../status"),duplexify=require("duplexify"),retryRequest=require("retry-request");var StreamType;!function(e){e[e.SERVER_STREAMING=1]="SERVER_STREAMING",e[e.CLIENT_STREAMING=2]="CLIENT_STREAMING",e[e.BIDI_STREAMING=3]="BIDI_STREAMING"}(StreamType||(exports.StreamType=StreamType={}));class StreamProxy extends duplexify{constructor(e,t,r,s){super(void 0,void 0,{objectMode:!0,readable:e!==StreamType.CLIENT_STREAMING,writable:e!==StreamType.SERVER_STREAMING}),this.retries=0,this.type=e,this._callback=t,this._isCancelCalled=!1,this._responseHasSent=!1,this.rest=r,this.gaxServerStreamingRetries=s}cancel(){this.stream?this.stream.cancel():this._isCancelCalled=!0}retry(e,t){let r=this.argument;if("function"==typeof t.getResumptionRequestFn){const e=t.getResumptionRequestFn(r);void 0!==e&&(r=e)}this.resetStreams(e);const s=this.apiCall(r,this._callback);return this.stream=s,this.streamHandoffHelper(s,t),s}throwIfMaxRetriesOrTotalTimeoutExceeded(e,t,r){const s=new Date;if(void 0!==this.prevDeadline&&e&&s.getTime()>=this.prevDeadline){const e=new googleError_1.GoogleError(`Total timeout of API exceeded ${r} milliseconds before any response was received.`);throw e.code=status_1.Status.DEADLINE_EXCEEDED,this.emit("error",e),this.destroy(),e}if(this.retries&&this.retries>=t){const e=new googleError_1.GoogleError("Exceeded maximum number of retries before any response was received");throw e.code=status_1.Status.DEADLINE_EXCEEDED,this.emit("error",e),this.destroy(),e}}streamHandoffErrorHandler(e,t,r){let s=this.stream;const i=t.backoffSettings.retryDelayMultiplier,o=t.backoffSettings.maxRetryDelayMillis,a=t.backoffSettings.rpcTimeoutMultiplier,n=t.backoffSettings.maxRpcTimeoutMillis;let l=t.backoffSettings.initialRetryDelayMillis,h=t.backoffSettings.initialRpcTimeoutMillis,d=new Date,c=0;t.backoffSettings.totalTimeoutMillis&&(c=d.getTime()+t.backoffSettings.totalTimeoutMillis);const u=t.backoffSettings.maxRetries;try{this.throwIfMaxRetriesOrTotalTimeoutExceeded(c,u,t.backoffSettings.totalTimeoutMillis)}catch(r){return}this.retries++;const m=googleError_1.GoogleError.parseGRPCStatusDetails(r);let f=this.defaultShouldRetry(m,t);if(t.shouldRetryFn&&(f=t.shouldRetryFn(m)),!f)return m.note="Exception occurred in retry method that was not classified as transient",this.emit("error",m),void this.destroy();{const e=Math.random()*l;setTimeout((()=>{d=new Date,l=Math.min(l*i,o);const e=h&&a?h*a:0,t=n||0;this.prevDeadline=c;const r=c?c-d.getTime():0;h=Math.min(e,t,r)}),e)}s=this.retry(e,t),this.stream=s}streamHandoffHelper(e,t){let r=!1;this.eventForwardHelper(e),e.on("error",(s=>{r=!0,this.streamHandoffErrorHandler(e,t,s)})),e.on("data",(e=>{this.retries=0,this.emit.bind(this,"data")(e)})),e.on("end",(()=>{r||(r=!0,this.emit("end"),this.cancel())}))}eventForwardHelper(e){["metadata","response","status"].forEach((t=>{e.on(t,this.emit.bind(this,t))}))}statusMetadataHelper(e){e.on("status",(()=>{this._responseHasSent||e.emit("response",{code:200,details:"",message:"OK"})})),e.on("metadata",(t=>{e.emit("response",{code:200,details:"",message:"OK",metadata:t}),this._responseHasSent=!0}))}forwardEvents(e){this.eventForwardHelper(e),this.statusMetadataHelper(e),e.on("error",(e=>{googleError_1.GoogleError.parseGRPCStatusDetails(e)}))}defaultShouldRetry(e,t){return!(t.retryCodes.length>0&&t.retryCodes.indexOf(e.code)<0||0===t.retryCodes.length)}forwardEventsWithRetries(e,t){let r=this.stream;return this.eventForwardHelper(e),this.statusMetadataHelper(e),e.on("error",(s=>{const i=t.backoffSettings.totalTimeoutMillis,o=t.backoffSettings.maxRetries;if(o&&o>0||i&&i>0){const a=googleError_1.GoogleError.parseGRPCStatusDetails(s);let n=this.defaultShouldRetry(a,t);if(t.shouldRetryFn&&(n=t.shouldRetryFn(a)),n){if(o&&i){const e=new googleError_1.GoogleError("Cannot set both totalTimeoutMillis and maxRetries in backoffSettings.");return e.code=status_1.Status.INVALID_ARGUMENT,this.emit("error",e),void this.destroy()}return this.retries++,r=this.retry(e,t),this.stream=r,r}{const e=googleError_1.GoogleError.parseGRPCStatusDetails(s);return e.note="Exception occurred in retry method that was not classified as transient",void this.destroy(e)}}if(0===o){const e=googleError_1.GoogleError.parseGRPCStatusDetails(s);return e.note="Max retries is set to zero.",void this.destroy(e)}return googleError_1.GoogleError.parseGRPCStatusDetails(s)})),r}resetStreams(e){e&&(e.cancel&&e.cancel(),e.destroy?e.destroy():e.end&&e.end())}setStream(e,t,r={},s){if(this.apiCall=e,this.argument=t,this.type===StreamType.SERVER_STREAMING){if(this.rest){const r=e(t,this._callback);this.stream=r,this.setReadable(r)}else if(this.gaxServerStreamingRetries){const r=(0,streamingRetryRequest_1.streamingRetryRequest)({request:()=>{if(this._isCancelCalled)return void(this.stream&&this.stream.cancel());const r=e(t,this._callback);return this.stream=r,this.stream=this.forwardEventsWithRetries(r,s),this.stream}});this.setReadable(r)}else{const s=retryRequest(null,{objectMode:!0,request:()=>{if(this._isCancelCalled)return void(this.stream&&this.stream.cancel());const r=e(t,this._callback);return this.stream=r,this.forwardEvents(r),r},retries:r.retries,currentRetryAttempt:r.currentRetryAttempt,noResponseRetries:r.noResponseRetries,shouldRetryFn:r.shouldRetryFn});this.setReadable(s)}return}const i=e(t,this._callback);this.stream=i,this.forwardEvents(i),this.type===StreamType.CLIENT_STREAMING&&this.setWritable(i),this.type===StreamType.BIDI_STREAMING&&(this.setReadable(i),this.setWritable(i)),this._isCancelCalled&&this.stream&&this.stream.cancel()}}exports.StreamProxy=StreamProxy;