"use strict";var Buffer=require("safer-buffer").Buffer;exports._dbcs=DBCSCodec;for(var UNASSIGNED=-1,GB18030_CODE=-2,SEQ_START=-10,NODE_START=-1e3,UNASSIGNED_NODE=new Array(256),DEF_CHAR=-1,i=0;i<256;i++)UNASSIGNED_NODE[i]=UNASSIGNED;function DBCSCodec(e,t){if(this.encodingName=e.encodingName,!e)throw new Error("DBCS codec is called without the data.");if(!e.table)throw new Error("Encoding '"+this.encodingName+"' has no data.");var o=e.table();this.decodeTables=[],this.decodeTables[0]=UNASSIGNED_NODE.slice(0),this.decodeTableSeq=[];for(var r=0;r<o.length;r++)this._addDecodeChunk(o[r]);if("function"==typeof e.gb18030){this.gb18030=e.gb18030();var i=this.decodeTables.length;this.decodeTables.push(UNASSIGNED_NODE.slice(0));var d=this.decodeTables.length;this.decodeTables.push(UNASSIGNED_NODE.slice(0));var a=this.decodeTables[0];for(r=129;r<=254;r++)for(var s=this.decodeTables[NODE_START-a[r]],n=48;n<=57;n++){if(s[n]===UNASSIGNED)s[n]=NODE_START-i;else if(s[n]>NODE_START)throw new Error("gb18030 decode tables conflict at byte 2");for(var h=this.decodeTables[NODE_START-s[n]],c=129;c<=254;c++){if(h[c]===UNASSIGNED)h[c]=NODE_START-d;else{if(h[c]===NODE_START-d)continue;if(h[c]>NODE_START)throw new Error("gb18030 decode tables conflict at byte 3")}for(var l=this.decodeTables[NODE_START-h[c]],S=48;S<=57;S++)l[S]===UNASSIGNED&&(l[S]=GB18030_CODE)}}}this.defaultCharUnicode=t.defaultCharUnicode,this.encodeTable=[],this.encodeTableSeq=[];var f={};if(e.encodeSkipVals)for(r=0;r<e.encodeSkipVals.length;r++){var T=e.encodeSkipVals[r];if("number"==typeof T)f[T]=!0;else for(n=T.from;n<=T.to;n++)f[n]=!0}if(this._fillEncodeTable(0,0,f),e.encodeAdd)for(var E in e.encodeAdd)Object.prototype.hasOwnProperty.call(e.encodeAdd,E)&&this._setEncodeChar(E.charCodeAt(0),e.encodeAdd[E]);this.defCharSB=this.encodeTable[0][t.defaultCharSingleByte.charCodeAt(0)],this.defCharSB===UNASSIGNED&&(this.defCharSB=this.encodeTable[0]["?"]),this.defCharSB===UNASSIGNED&&(this.defCharSB="?".charCodeAt(0))}function DBCSEncoder(e,t){this.leadSurrogate=-1,this.seqObj=void 0,this.encodeTable=t.encodeTable,this.encodeTableSeq=t.encodeTableSeq,this.defaultCharSingleByte=t.defCharSB,this.gb18030=t.gb18030}function DBCSDecoder(e,t){this.nodeIdx=0,this.prevBytes=[],this.decodeTables=t.decodeTables,this.decodeTableSeq=t.decodeTableSeq,this.defaultCharUnicode=t.defaultCharUnicode,this.gb18030=t.gb18030}function findIdx(e,t){if(e[0]>t)return-1;for(var o=0,r=e.length;o<r-1;){var i=o+(r-o+1>>1);e[i]<=t?o=i:r=i}return o}DBCSCodec.prototype.encoder=DBCSEncoder,DBCSCodec.prototype.decoder=DBCSDecoder,DBCSCodec.prototype._getDecodeTrieNode=function(e){for(var t=[];e>0;e>>>=8)t.push(255&e);0==t.length&&t.push(0);for(var o=this.decodeTables[0],r=t.length-1;r>0;r--){var i=o[t[r]];if(i==UNASSIGNED)o[t[r]]=NODE_START-this.decodeTables.length,this.decodeTables.push(o=UNASSIGNED_NODE.slice(0));else{if(!(i<=NODE_START))throw new Error("Overwrite byte in "+this.encodingName+", addr: "+e.toString(16));o=this.decodeTables[NODE_START-i]}}return o},DBCSCodec.prototype._addDecodeChunk=function(e){var t=parseInt(e[0],16),o=this._getDecodeTrieNode(t);t&=255;for(var r=1;r<e.length;r++){var i=e[r];if("string"==typeof i)for(var d=0;d<i.length;){var a=i.charCodeAt(d++);if(55296<=a&&a<56320){var s=i.charCodeAt(d++);if(!(56320<=s&&s<57344))throw new Error("Incorrect surrogate pair in "+this.encodingName+" at chunk "+e[0]);o[t++]=65536+1024*(a-55296)+(s-56320)}else if(4080<a&&a<=4095){for(var n=4095-a+2,h=[],c=0;c<n;c++)h.push(i.charCodeAt(d++));o[t++]=SEQ_START-this.decodeTableSeq.length,this.decodeTableSeq.push(h)}else o[t++]=a}else{if("number"!=typeof i)throw new Error("Incorrect type '"+typeof i+"' given in "+this.encodingName+" at chunk "+e[0]);var l=o[t-1]+1;for(d=0;d<i;d++)o[t++]=l++}}if(t>255)throw new Error("Incorrect chunk in "+this.encodingName+" at addr "+e[0]+": too long"+t)},DBCSCodec.prototype._getEncodeBucket=function(e){var t=e>>8;return void 0===this.encodeTable[t]&&(this.encodeTable[t]=UNASSIGNED_NODE.slice(0)),this.encodeTable[t]},DBCSCodec.prototype._setEncodeChar=function(e,t){var o=this._getEncodeBucket(e),r=255&e;o[r]<=SEQ_START?this.encodeTableSeq[SEQ_START-o[r]][DEF_CHAR]=t:o[r]==UNASSIGNED&&(o[r]=t)},DBCSCodec.prototype._setEncodeSequence=function(e,t){var o,r=e[0],i=this._getEncodeBucket(r),d=255&r;i[d]<=SEQ_START?o=this.encodeTableSeq[SEQ_START-i[d]]:(o={},i[d]!==UNASSIGNED&&(o[DEF_CHAR]=i[d]),i[d]=SEQ_START-this.encodeTableSeq.length,this.encodeTableSeq.push(o));for(var a=1;a<e.length-1;a++){var s=o[r];"object"==typeof s?o=s:(o=o[r]={},void 0!==s&&(o[DEF_CHAR]=s))}o[r=e[e.length-1]]=t},DBCSCodec.prototype._fillEncodeTable=function(e,t,o){for(var r=this.decodeTables[e],i=!1,d={},a=0;a<256;a++){var s=r[a],n=t+a;if(!o[n])if(s>=0)this._setEncodeChar(s,n),i=!0;else if(s<=NODE_START){var h=NODE_START-s;if(!d[h]){var c=n<<8>>>0;this._fillEncodeTable(h,c,o)?i=!0:d[h]=!0}}else s<=SEQ_START&&(this._setEncodeSequence(this.decodeTableSeq[SEQ_START-s],n),i=!0)}return i},DBCSEncoder.prototype.write=function(e){for(var t=Buffer.alloc(e.length*(this.gb18030?4:3)),o=this.leadSurrogate,r=this.seqObj,i=-1,d=0,a=0;;){if(-1===i){if(d==e.length)break;var s=e.charCodeAt(d++)}else{s=i;i=-1}if(55296<=s&&s<57344)if(s<56320){if(-1===o){o=s;continue}o=s,s=UNASSIGNED}else-1!==o?(s=65536+1024*(o-55296)+(s-56320),o=-1):s=UNASSIGNED;else-1!==o&&(i=s,s=UNASSIGNED,o=-1);var n=UNASSIGNED;if(void 0!==r&&s!=UNASSIGNED){var h=r[s];if("object"==typeof h){r=h;continue}"number"==typeof h?n=h:null==h&&void 0!==(h=r[DEF_CHAR])&&(n=h,i=s),r=void 0}else if(s>=0){var c=this.encodeTable[s>>8];if(void 0!==c&&(n=c[255&s]),n<=SEQ_START){r=this.encodeTableSeq[SEQ_START-n];continue}if(n==UNASSIGNED&&this.gb18030){var l=findIdx(this.gb18030.uChars,s);if(-1!=l){n=this.gb18030.gbChars[l]+(s-this.gb18030.uChars[l]);t[a++]=129+Math.floor(n/12600),n%=12600,t[a++]=48+Math.floor(n/1260),n%=1260,t[a++]=129+Math.floor(n/10),n%=10,t[a++]=48+n;continue}}}n===UNASSIGNED&&(n=this.defaultCharSingleByte),n<256?t[a++]=n:n<65536?(t[a++]=n>>8,t[a++]=255&n):n<16777216?(t[a++]=n>>16,t[a++]=n>>8&255,t[a++]=255&n):(t[a++]=n>>>24,t[a++]=n>>>16&255,t[a++]=n>>>8&255,t[a++]=255&n)}return this.seqObj=r,this.leadSurrogate=o,t.slice(0,a)},DBCSEncoder.prototype.end=function(){if(-1!==this.leadSurrogate||void 0!==this.seqObj){var e=Buffer.alloc(10),t=0;if(this.seqObj){var o=this.seqObj[DEF_CHAR];void 0!==o&&(o<256?e[t++]=o:(e[t++]=o>>8,e[t++]=255&o)),this.seqObj=void 0}return-1!==this.leadSurrogate&&(e[t++]=this.defaultCharSingleByte,this.leadSurrogate=-1),e.slice(0,t)}},DBCSEncoder.prototype.findIdx=findIdx,DBCSDecoder.prototype.write=function(e){for(var t=Buffer.alloc(2*e.length),o=this.nodeIdx,r=this.prevBytes,i=this.prevBytes.length,d=-this.prevBytes.length,a=0,s=0;a<e.length;a++){var n,h=a>=0?e[a]:r[a+i];if((n=this.decodeTables[o][h])>=0);else if(n===UNASSIGNED)n=this.defaultCharUnicode.charCodeAt(0),a=d;else if(n===GB18030_CODE){if(a>=3)var c=12600*(e[a-3]-129)+1260*(e[a-2]-48)+10*(e[a-1]-129)+(h-48);else c=12600*(r[a-3+i]-129)+1260*((a-2>=0?e[a-2]:r[a-2+i])-48)+10*((a-1>=0?e[a-1]:r[a-1+i])-129)+(h-48);var l=findIdx(this.gb18030.gbChars,c);n=this.gb18030.uChars[l]+c-this.gb18030.gbChars[l]}else{if(n<=NODE_START){o=NODE_START-n;continue}if(!(n<=SEQ_START))throw new Error("iconv-lite internal error: invalid decoding table value "+n+" at "+o+"/"+h);for(var S=this.decodeTableSeq[SEQ_START-n],f=0;f<S.length-1;f++)n=S[f],t[s++]=255&n,t[s++]=n>>8;n=S[S.length-1]}if(n>=65536){var T=55296|(n-=65536)>>10;t[s++]=255&T,t[s++]=T>>8,n=56320|1023&n}t[s++]=255&n,t[s++]=n>>8,o=0,d=a+1}return this.nodeIdx=o,this.prevBytes=d>=0?Array.prototype.slice.call(e,d):r.slice(d+i).concat(Array.prototype.slice.call(e)),t.slice(0,s).toString("ucs2")},DBCSDecoder.prototype.end=function(){for(var e="";this.prevBytes.length>0;){e+=this.defaultCharUnicode;var t=this.prevBytes.slice(1);this.prevBytes=[],this.nodeIdx=0,t.length>0&&(e+=this.write(t))}return this.prevBytes=[],this.nodeIdx=0,e};