const timespan=require("./lib/timespan"),PS_SUPPORTED=require("./lib/psSupported"),validateAsymmetricKey=require("./lib/validateAsymmetricKey"),jws=require("jws"),includes=require("lodash.includes"),isBoolean=require("lodash.isboolean"),isInteger=require("lodash.isinteger"),isNumber=require("lodash.isnumber"),isPlainObject=require("lodash.isplainobject"),isString=require("lodash.isstring"),once=require("lodash.once"),{KeyObject:KeyObject,createSecretKey:createSecretKey,createPrivateKey:createPrivateKey}=require("crypto"),SUPPORTED_ALGS=["RS256","RS384","RS512","ES256","ES384","ES512","HS256","HS384","HS512","none"];PS_SUPPORTED&&SUPPORTED_ALGS.splice(3,0,"PS256","PS384","PS512");const sign_options_schema={expiresIn:{isValid:function(e){return isInteger(e)||isString(e)&&e},message:'"expiresIn" should be a number of seconds or string representing a timespan'},notBefore:{isValid:function(e){return isInteger(e)||isString(e)&&e},message:'"notBefore" should be a number of seconds or string representing a timespan'},audience:{isValid:function(e){return isString(e)||Array.isArray(e)},message:'"audience" must be a string or array'},algorithm:{isValid:includes.bind(null,SUPPORTED_ALGS),message:'"algorithm" must be a valid string enum value'},header:{isValid:isPlainObject,message:'"header" must be an object'},encoding:{isValid:isString,message:'"encoding" must be a string'},issuer:{isValid:isString,message:'"issuer" must be a string'},subject:{isValid:isString,message:'"subject" must be a string'},jwtid:{isValid:isString,message:'"jwtid" must be a string'},noTimestamp:{isValid:isBoolean,message:'"noTimestamp" must be a boolean'},keyid:{isValid:isString,message:'"keyid" must be a string'},mutatePayload:{isValid:isBoolean,message:'"mutatePayload" must be a boolean'},allowInsecureKeySizes:{isValid:isBoolean,message:'"allowInsecureKeySizes" must be a boolean'},allowInvalidAsymmetricKeyTypes:{isValid:isBoolean,message:'"allowInvalidAsymmetricKeyTypes" must be a boolean'}},registered_claims_schema={iat:{isValid:isNumber,message:'"iat" should be a number of seconds'},exp:{isValid:isNumber,message:'"exp" should be a number of seconds'},nbf:{isValid:isNumber,message:'"nbf" should be a number of seconds'}};function validate(e,i,r,t){if(!isPlainObject(r))throw new Error('Expected "'+t+'" to be a plain object.');Object.keys(r).forEach((function(s){const a=e[s];if(a){if(!a.isValid(r[s]))throw new Error(a.message)}else if(!i)throw new Error('"'+s+'" is not allowed in "'+t+'"')}))}function validateOptions(e){return validate(sign_options_schema,!1,e,"options")}function validatePayload(e){return validate(registered_claims_schema,!0,e,"payload")}const options_to_payload={audience:"aud",issuer:"iss",subject:"sub",jwtid:"jti"},options_for_objects=["expiresIn","notBefore","noTimestamp","audience","issuer","subject","jwtid"];module.exports=function(e,i,r,t){"function"==typeof r?(t=r,r={}):r=r||{};const s="object"==typeof e&&!Buffer.isBuffer(e),a=Object.assign({alg:r.algorithm||"HS256",typ:s?"JWT":void 0,kid:r.keyid},r.header);function n(e){if(t)return t(e);throw e}if(!i&&"none"!==r.algorithm)return n(new Error("secretOrPrivateKey must have a value"));if(null!=i&&!(i instanceof KeyObject))try{i=createPrivateKey(i)}catch(e){try{i=createSecretKey("string"==typeof i?Buffer.from(i):i)}catch(e){return n(new Error("secretOrPrivateKey is not valid key material"))}}if(a.alg.startsWith("HS")&&"secret"!==i.type)return n(new Error(`secretOrPrivateKey must be a symmetric key when using ${a.alg}`));if(/^(?:RS|PS|ES)/.test(a.alg)){if("private"!==i.type)return n(new Error(`secretOrPrivateKey must be an asymmetric key when using ${a.alg}`));if(!r.allowInsecureKeySizes&&!a.alg.startsWith("ES")&&void 0!==i.asymmetricKeyDetails&&i.asymmetricKeyDetails.modulusLength<2048)return n(new Error(`secretOrPrivateKey has a minimum key size of 2048 bits for ${a.alg}`))}if(void 0===e)return n(new Error("payload is required"));if(s){try{validatePayload(e)}catch(e){return n(e)}r.mutatePayload||(e=Object.assign({},e))}else{const i=options_for_objects.filter((function(e){return void 0!==r[e]}));if(i.length>0)return n(new Error("invalid "+i.join(",")+" option for "+typeof e+" payload"))}if(void 0!==e.exp&&void 0!==r.expiresIn)return n(new Error('Bad "options.expiresIn" option the payload already has an "exp" property.'));if(void 0!==e.nbf&&void 0!==r.notBefore)return n(new Error('Bad "options.notBefore" option the payload already has an "nbf" property.'));try{validateOptions(r)}catch(e){return n(e)}if(!r.allowInvalidAsymmetricKeyTypes)try{validateAsymmetricKey(a.alg,i)}catch(e){return n(e)}const o=e.iat||Math.floor(Date.now()/1e3);if(r.noTimestamp?delete e.iat:s&&(e.iat=o),void 0!==r.notBefore){try{e.nbf=timespan(r.notBefore,o)}catch(e){return n(e)}if(void 0===e.nbf)return n(new Error('"notBefore" should be a number of seconds or string representing a timespan eg: "1d", "20h", 60'))}if(void 0!==r.expiresIn&&"object"==typeof e){try{e.exp=timespan(r.expiresIn,o)}catch(e){return n(e)}if(void 0===e.exp)return n(new Error('"expiresIn" should be a number of seconds or string representing a timespan eg: "1d", "20h", 60'))}Object.keys(options_to_payload).forEach((function(i){const t=options_to_payload[i];if(void 0!==r[i]){if(void 0!==e[t])return n(new Error('Bad "options.'+i+'" option. The payload already has an "'+t+'" property.'));e[t]=r[i]}}));const l=r.encoding||"utf8";if("function"!=typeof t){let t=jws.sign({header:a,payload:e,secret:i,encoding:l});if(!r.allowInsecureKeySizes&&/^(?:RS|PS)/.test(a.alg)&&t.length<256)throw new Error(`secretOrPrivateKey has a minimum key size of 2048 bits for ${a.alg}`);return t}t=t&&once(t),jws.createSign({header:a,privateKey:i,payload:e,encoding:l}).once("error",t).once("done",(function(e){if(!r.allowInsecureKeySizes&&/^(?:RS|PS)/.test(a.alg)&&e.length<256)return t(new Error(`secretOrPrivateKey has a minimum key size of 2048 bits for ${a.alg}`));t(null,e)}))};