const JsonWebTokenError=require("./lib/JsonWebTokenError"),NotBeforeError=require("./lib/NotBeforeError"),TokenExpiredError=require("./lib/TokenExpiredError"),decode=require("./decode"),timespan=require("./lib/timespan"),validateAsymmetricKey=require("./lib/validateAsymmetricKey"),PS_SUPPORTED=require("./lib/psSupported"),jws=require("jws"),{KeyObject:KeyObject,createSecretKey:createSecretKey,createPublicKey:createPublicKey}=require("crypto"),PUB_KEY_ALGS=["RS256","RS384","RS512"],EC_KEY_ALGS=["ES256","ES384","ES512"],RSA_KEY_ALGS=["RS256","RS384","RS512"],HS_ALGS=["HS256","HS384","HS512"];PS_SUPPORTED&&(PUB_KEY_ALGS.splice(PUB_KEY_ALGS.length,0,"PS256","PS384","PS512"),RSA_KEY_ALGS.splice(RSA_KEY_ALGS.length,0,"PS256","PS384","PS512")),module.exports=function(e,r,n,t){let o;if("function"!=typeof n||t||(t=n,n={}),n||(n={}),n=Object.assign({},n),o=t||function(e,r){if(e)throw e;return r},n.clockTimestamp&&"number"!=typeof n.clockTimestamp)return o(new JsonWebTokenError("clockTimestamp must be a number"));if(void 0!==n.nonce&&("string"!=typeof n.nonce||""===n.nonce.trim()))return o(new JsonWebTokenError("nonce must be a non-empty string"));if(void 0!==n.allowInvalidAsymmetricKeyTypes&&"boolean"!=typeof n.allowInvalidAsymmetricKeyTypes)return o(new JsonWebTokenError("allowInvalidAsymmetricKeyTypes must be a boolean"));const i=n.clockTimestamp||Math.floor(Date.now()/1e3);if(!e)return o(new JsonWebTokenError("jwt must be provided"));if("string"!=typeof e)return o(new JsonWebTokenError("jwt must be a string"));const s=e.split(".");if(3!==s.length)return o(new JsonWebTokenError("jwt malformed"));let a;try{a=decode(e,{complete:!0})}catch(e){return o(e)}if(!a)return o(new JsonWebTokenError("invalid token"));const c=a.header;let u;if("function"==typeof r){if(!t)return o(new JsonWebTokenError("verify must be called asynchronous if secret or public key is provided as a callback"));u=r}else u=function(e,n){return n(null,r)};return u(c,(function(r,t){if(r)return o(new JsonWebTokenError("error in secret or public key callback: "+r.message));const u=""!==s[2].trim();if(!u&&t)return o(new JsonWebTokenError("jwt signature is required"));if(u&&!t)return o(new JsonWebTokenError("secret or public key must be provided"));if(!u&&!n.algorithms)return o(new JsonWebTokenError('please specify "none" in "algorithms" to verify unsigned tokens'));if(null!=t&&!(t instanceof KeyObject))try{t=createPublicKey(t)}catch(e){try{t=createSecretKey("string"==typeof t?Buffer.from(t):t)}catch(e){return o(new JsonWebTokenError("secretOrPublicKey is not valid key material"))}}if(n.algorithms||("secret"===t.type?n.algorithms=HS_ALGS:["rsa","rsa-pss"].includes(t.asymmetricKeyType)?n.algorithms=RSA_KEY_ALGS:"ec"===t.asymmetricKeyType?n.algorithms=EC_KEY_ALGS:n.algorithms=PUB_KEY_ALGS),-1===n.algorithms.indexOf(a.header.alg))return o(new JsonWebTokenError("invalid algorithm"));if(c.alg.startsWith("HS")&&"secret"!==t.type)return o(new JsonWebTokenError(`secretOrPublicKey must be a symmetric key when using ${c.alg}`));if(/^(?:RS|PS|ES)/.test(c.alg)&&"public"!==t.type)return o(new JsonWebTokenError(`secretOrPublicKey must be an asymmetric key when using ${c.alg}`));if(!n.allowInvalidAsymmetricKeyTypes)try{validateAsymmetricKey(c.alg,t)}catch(e){return o(e)}let l;try{l=jws.verify(e,a.header.alg,t)}catch(e){return o(e)}if(!l)return o(new JsonWebTokenError("invalid signature"));const f=a.payload;if(void 0!==f.nbf&&!n.ignoreNotBefore){if("number"!=typeof f.nbf)return o(new JsonWebTokenError("invalid nbf value"));if(f.nbf>i+(n.clockTolerance||0))return o(new NotBeforeError("jwt not active",new Date(1e3*f.nbf)))}if(void 0!==f.exp&&!n.ignoreExpiration){if("number"!=typeof f.exp)return o(new JsonWebTokenError("invalid exp value"));if(i>=f.exp+(n.clockTolerance||0))return o(new TokenExpiredError("jwt expired",new Date(1e3*f.exp)))}if(n.audience){const e=Array.isArray(n.audience)?n.audience:[n.audience];if(!(Array.isArray(f.aud)?f.aud:[f.aud]).some((function(r){return e.some((function(e){return e instanceof RegExp?e.test(r):e===r}))})))return o(new JsonWebTokenError("jwt audience invalid. expected: "+e.join(" or ")))}if(n.issuer){if("string"==typeof n.issuer&&f.iss!==n.issuer||Array.isArray(n.issuer)&&-1===n.issuer.indexOf(f.iss))return o(new JsonWebTokenError("jwt issuer invalid. expected: "+n.issuer))}if(n.subject&&f.sub!==n.subject)return o(new JsonWebTokenError("jwt subject invalid. expected: "+n.subject));if(n.jwtid&&f.jti!==n.jwtid)return o(new JsonWebTokenError("jwt jwtid invalid. expected: "+n.jwtid));if(n.nonce&&f.nonce!==n.nonce)return o(new JsonWebTokenError("jwt nonce invalid. expected: "+n.nonce));if(n.maxAge){if("number"!=typeof f.iat)return o(new JsonWebTokenError("iat required when maxAge is specified"));const e=timespan(n.maxAge,f.iat);if(void 0===e)return o(new JsonWebTokenError('"maxAge" should be a number of seconds or string representing a timespan eg: "1d", "20h", 60'));if(i>=e+(n.clockTolerance||0))return o(new TokenExpiredError("maxAge exceeded",new Date(1e3*e)))}if(!0===n.complete){const e=a.signature;return o(null,{header:c,payload:f,signature:e})}return o(null,f)}))};