var bufferEqual=require("buffer-equal-constant-time"),Buffer=require("safe-buffer").Buffer,crypto=require("crypto"),formatEcdsa=require("ecdsa-sig-formatter"),util=require("util"),MSG_INVALID_ALGORITHM='"%s" is not a valid algorithm.\n  Supported algorithms are:\n  "HS256", "HS384", "HS512", "RS256", "RS384", "RS512", "PS256", "PS384", "PS512", "ES256", "ES384", "ES512" and "none".',MSG_INVALID_SECRET="secret must be a string or buffer",MSG_INVALID_VERIFIER_KEY="key must be a string or a buffer",MSG_INVALID_SIGNER_KEY="key must be a string, a buffer or an object",supportsKeyObjects="function"==typeof crypto.createPublicKey;function checkIsPublicKey(e){if(!Buffer.isBuffer(e)&&"string"!=typeof e){if(!supportsKeyObjects)throw typeError(MSG_INVALID_VERIFIER_KEY);if("object"!=typeof e)throw typeError(MSG_INVALID_VERIFIER_KEY);if("string"!=typeof e.type)throw typeError(MSG_INVALID_VERIFIER_KEY);if("string"!=typeof e.asymmetricKeyType)throw typeError(MSG_INVALID_VERIFIER_KEY);if("function"!=typeof e.export)throw typeError(MSG_INVALID_VERIFIER_KEY)}}function checkIsPrivateKey(e){if(!Buffer.isBuffer(e)&&"string"!=typeof e&&"object"!=typeof e)throw typeError(MSG_INVALID_SIGNER_KEY)}function checkIsSecretKey(e){if(!Buffer.isBuffer(e)){if("string"==typeof e)return e;if(!supportsKeyObjects)throw typeError(MSG_INVALID_SECRET);if("object"!=typeof e)throw typeError(MSG_INVALID_SECRET);if("secret"!==e.type)throw typeError(MSG_INVALID_SECRET);if("function"!=typeof e.export)throw typeError(MSG_INVALID_SECRET)}}function fromBase64(e){return e.replace(/=/g,"").replace(/\+/g,"-").replace(/\//g,"_")}function toBase64(e){var r=4-(e=e.toString()).length%4;if(4!==r)for(var t=0;t<r;++t)e+="=";return e.replace(/\-/g,"+").replace(/_/g,"/")}function typeError(e){var r=[].slice.call(arguments,1),t=util.format.bind(util,e).apply(null,r);return new TypeError(t)}function bufferOrString(e){return Buffer.isBuffer(e)||"string"==typeof e}function normalizeInput(e){return bufferOrString(e)||(e=JSON.stringify(e)),e}function createHmacSigner(e){return function(r,t){checkIsSecretKey(t),r=normalizeInput(r);var n=crypto.createHmac("sha"+e,t);return fromBase64((n.update(r),n.digest("base64")))}}function createHmacVerifier(e){return function(r,t,n){var o=createHmacSigner(e)(r,n);return bufferEqual(Buffer.from(t),Buffer.from(o))}}function createKeySigner(e){return function(r,t){checkIsPrivateKey(t),r=normalizeInput(r);var n=crypto.createSign("RSA-SHA"+e);return fromBase64((n.update(r),n.sign(t,"base64")))}}function createKeyVerifier(e){return function(r,t,n){checkIsPublicKey(n),r=normalizeInput(r),t=toBase64(t);var o=crypto.createVerify("RSA-SHA"+e);return o.update(r),o.verify(n,t,"base64")}}function createPSSKeySigner(e){return function(r,t){checkIsPrivateKey(t),r=normalizeInput(r);var n=crypto.createSign("RSA-SHA"+e);return fromBase64((n.update(r),n.sign({key:t,padding:crypto.constants.RSA_PKCS1_PSS_PADDING,saltLength:crypto.constants.RSA_PSS_SALTLEN_DIGEST},"base64")))}}function createPSSKeyVerifier(e){return function(r,t,n){checkIsPublicKey(n),r=normalizeInput(r),t=toBase64(t);var o=crypto.createVerify("RSA-SHA"+e);return o.update(r),o.verify({key:n,padding:crypto.constants.RSA_PKCS1_PSS_PADDING,saltLength:crypto.constants.RSA_PSS_SALTLEN_DIGEST},t,"base64")}}function createECDSASigner(e){var r=createKeySigner(e);return function(){var t=r.apply(null,arguments);return t=formatEcdsa.derToJose(t,"ES"+e)}}function createECDSAVerifer(e){var r=createKeyVerifier(e);return function(t,n,o){return n=formatEcdsa.joseToDer(n,"ES"+e).toString("base64"),r(t,n,o)}}function createNoneSigner(){return function(){return""}}function createNoneVerifier(){return function(e,r){return""===r}}supportsKeyObjects&&(MSG_INVALID_VERIFIER_KEY+=" or a KeyObject",MSG_INVALID_SECRET+="or a KeyObject"),module.exports=function(e){var r={hs:createHmacSigner,rs:createKeySigner,ps:createPSSKeySigner,es:createECDSASigner,none:createNoneSigner},t={hs:createHmacVerifier,rs:createKeyVerifier,ps:createPSSKeyVerifier,es:createECDSAVerifer,none:createNoneVerifier},n=e.match(/^(RS|PS|ES|HS)(256|384|512)$|^(none)$/);if(!n)throw typeError(MSG_INVALID_ALGORITHM,e);var o=(n[1]||n[3]).toLowerCase(),i=n[2];return{sign:r[o](i),verify:t[o](i)}};