"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.LRUCache=void 0;const perf="object"==typeof performance&&performance&&"function"==typeof performance.now?performance:Date,warned=new Set,emitWarning=(t,e,i,s)=>{"object"==typeof process&&process&&"function"==typeof process.emitWarning?process.emitWarning(t,e,i,s):console.error(`[${i}] ${e}: ${t}`)},shouldWarn=t=>!warned.has(t),TYPE=Symbol("type"),isPosInt=t=>t&&t===Math.floor(t)&&t>0&&isFinite(t),getUintArray=t=>isPosInt(t)?t<=Math.pow(2,8)?Uint8Array:t<=Math.pow(2,16)?Uint16Array:t<=Math.pow(2,32)?Uint32Array:t<=Number.MAX_SAFE_INTEGER?ZeroArray:null:null;class ZeroArray extends Array{constructor(t){super(t),this.fill(0)}}class Stack{heap;length;static#t=!1;static create(t){const e=getUintArray(t);if(!e)return[];Stack.#t=!0;const i=new Stack(t,e);return Stack.#t=!1,i}constructor(t,e){if(!Stack.#t)throw new TypeError("instantiate Stack using Stack.create(n)");this.heap=new e(t),this.length=0}push(t){this.heap[this.length++]=t}pop(){return this.heap[--this.length]}}class LRUCache{#e;#i;#s;#h;#o;ttl;ttlResolution;ttlAutopurge;updateAgeOnGet;updateAgeOnHas;allowStale;noDisposeOnSet;noUpdateTTL;maxEntrySize;sizeCalculation;noDeleteOnFetchRejection;noDeleteOnStaleGet;allowStaleOnFetchAbort;allowStaleOnFetchRejection;ignoreFetchAbort;#a;#n;#r;#l;#c;#d;#u;#f;#p;#g;#v;#S;#y;#z;#m;#w;#L;static unsafeExposeInternals(t){return{starts:t.#y,ttls:t.#z,sizes:t.#S,keyMap:t.#r,keyList:t.#l,valList:t.#c,next:t.#d,prev:t.#u,get head(){return t.#f},get tail(){return t.#p},free:t.#g,isBackgroundFetch:e=>t.#F(e),backgroundFetch:(e,i,s,h)=>t.#x(e,i,s,h),moveToTail:e=>t.#k(e),indexes:e=>t.#A(e),rindexes:e=>t.#T(e),isStale:e=>t.#_(e)}}get max(){return this.#e}get maxSize(){return this.#i}get calculatedSize(){return this.#n}get size(){return this.#a}get fetchMethod(){return this.#o}get dispose(){return this.#s}get disposeAfter(){return this.#h}constructor(t){const{max:e=0,ttl:i,ttlResolution:s=1,ttlAutopurge:h,updateAgeOnGet:o,updateAgeOnHas:a,allowStale:n,dispose:r,disposeAfter:l,noDisposeOnSet:c,noUpdateTTL:d,maxSize:u=0,maxEntrySize:f=0,sizeCalculation:p,fetchMethod:g,noDeleteOnFetchRejection:v,noDeleteOnStaleGet:S,allowStaleOnFetchRejection:y,allowStaleOnFetchAbort:z,ignoreFetchAbort:m}=t;if(0!==e&&!isPosInt(e))throw new TypeError("max option must be a nonnegative integer");const w=e?getUintArray(e):Array;if(!w)throw new Error("invalid max value: "+e);if(this.#e=e,this.#i=u,this.maxEntrySize=f||this.#i,this.sizeCalculation=p,this.sizeCalculation){if(!this.#i&&!this.maxEntrySize)throw new TypeError("cannot set sizeCalculation without setting maxSize or maxEntrySize");if("function"!=typeof this.sizeCalculation)throw new TypeError("sizeCalculation set to non-function")}if(void 0!==g&&"function"!=typeof g)throw new TypeError("fetchMethod must be a function if specified");if(this.#o=g,this.#w=!!g,this.#r=new Map,this.#l=new Array(e).fill(void 0),this.#c=new Array(e).fill(void 0),this.#d=new w(e),this.#u=new w(e),this.#f=0,this.#p=0,this.#g=Stack.create(e),this.#a=0,this.#n=0,"function"==typeof r&&(this.#s=r),"function"==typeof l?(this.#h=l,this.#v=[]):(this.#h=void 0,this.#v=void 0),this.#m=!!this.#s,this.#L=!!this.#h,this.noDisposeOnSet=!!c,this.noUpdateTTL=!!d,this.noDeleteOnFetchRejection=!!v,this.allowStaleOnFetchRejection=!!y,this.allowStaleOnFetchAbort=!!z,this.ignoreFetchAbort=!!m,0!==this.maxEntrySize){if(0!==this.#i&&!isPosInt(this.#i))throw new TypeError("maxSize must be a positive integer if specified");if(!isPosInt(this.maxEntrySize))throw new TypeError("maxEntrySize must be a positive integer if specified");this.#b()}if(this.allowStale=!!n,this.noDeleteOnStaleGet=!!S,this.updateAgeOnGet=!!o,this.updateAgeOnHas=!!a,this.ttlResolution=isPosInt(s)||0===s?s:1,this.ttlAutopurge=!!h,this.ttl=i||0,this.ttl){if(!isPosInt(this.ttl))throw new TypeError("ttl must be a positive integer if specified");this.#O()}if(0===this.#e&&0===this.ttl&&0===this.#i)throw new TypeError("At least one of max, maxSize, or ttl is required");if(!this.ttlAutopurge&&!this.#e&&!this.#i){const t="LRU_CACHE_UNBOUNDED";if(shouldWarn(t)){warned.add(t);emitWarning("TTL caching without ttlAutopurge, max, or maxSize can result in unbounded memory consumption.","UnboundedCacheWarning",t,LRUCache)}}}getRemainingTTL(t){return this.#r.has(t)?1/0:0}#O(){const t=new ZeroArray(this.#e),e=new ZeroArray(this.#e);this.#z=t,this.#y=e,this.#D=(i,s,h=perf.now())=>{if(e[i]=0!==s?h:0,t[i]=s,0!==s&&this.ttlAutopurge){const t=setTimeout((()=>{this.#_(i)&&this.delete(this.#l[i])}),s+1);t.unref&&t.unref()}},this.#E=i=>{e[i]=0!==t[i]?perf.now():0},this.#M=(h,o)=>{if(t[o]){const a=t[o],n=e[o];h.ttl=a,h.start=n,h.now=i||s(),h.remainingTTL=h.now+a-n}};let i=0;const s=()=>{const t=perf.now();if(this.ttlResolution>0){i=t;const e=setTimeout((()=>i=0),this.ttlResolution);e.unref&&e.unref()}return t};this.getRemainingTTL=h=>{const o=this.#r.get(h);return void 0===o?0:0===t[o]||0===e[o]?1/0:e[o]+t[o]-(i||s())},this.#_=h=>0!==t[h]&&0!==e[h]&&(i||s())-e[h]>t[h]}#E=()=>{};#M=()=>{};#D=()=>{};#_=()=>!1;#b(){const t=new ZeroArray(this.#e);this.#n=0,this.#S=t,this.#C=e=>{this.#n-=t[e],t[e]=0},this.#I=(t,e,i,s)=>{if(this.#F(e))return 0;if(!isPosInt(i)){if(!s)throw new TypeError("invalid size value (must be positive integer). When maxSize or maxEntrySize is used, sizeCalculation or size must be set.");if("function"!=typeof s)throw new TypeError("sizeCalculation must be a function");if(i=s(e,t),!isPosInt(i))throw new TypeError("sizeCalculation return invalid (expect positive integer)")}return i},this.#R=(e,i,s)=>{if(t[e]=i,this.#i){const i=this.#i-t[e];for(;this.#n>i;)this.#W(!0)}this.#n+=t[e],s&&(s.entrySize=i,s.totalCalculatedSize=this.#n)}}#C=t=>{};#R=(t,e,i)=>{};#I=(t,e,i,s)=>{if(i||s)throw new TypeError("cannot set size without setting maxSize or maxEntrySize on cache");return 0};*#A({allowStale:t=this.allowStale}={}){if(this.#a)for(let e=this.#p;this.#B(e)&&(!t&&this.#_(e)||(yield e),e!==this.#f);)e=this.#u[e]}*#T({allowStale:t=this.allowStale}={}){if(this.#a)for(let e=this.#f;this.#B(e)&&(!t&&this.#_(e)||(yield e),e!==this.#p);)e=this.#d[e]}#B(t){return void 0!==t&&this.#r.get(this.#l[t])===t}*entries(){for(const t of this.#A())void 0===this.#c[t]||void 0===this.#l[t]||this.#F(this.#c[t])||(yield[this.#l[t],this.#c[t]])}*rentries(){for(const t of this.#T())void 0===this.#c[t]||void 0===this.#l[t]||this.#F(this.#c[t])||(yield[this.#l[t],this.#c[t]])}*keys(){for(const t of this.#A()){const e=this.#l[t];void 0===e||this.#F(this.#c[t])||(yield e)}}*rkeys(){for(const t of this.#T()){const e=this.#l[t];void 0===e||this.#F(this.#c[t])||(yield e)}}*values(){for(const t of this.#A()){void 0===this.#c[t]||this.#F(this.#c[t])||(yield this.#c[t])}}*rvalues(){for(const t of this.#T()){void 0===this.#c[t]||this.#F(this.#c[t])||(yield this.#c[t])}}[Symbol.iterator](){return this.entries()}find(t,e={}){for(const i of this.#A()){const s=this.#c[i],h=this.#F(s)?s.__staleWhileFetching:s;if(void 0!==h&&t(h,this.#l[i],this))return this.get(this.#l[i],e)}}forEach(t,e=this){for(const i of this.#A()){const s=this.#c[i],h=this.#F(s)?s.__staleWhileFetching:s;void 0!==h&&t.call(e,h,this.#l[i],this)}}rforEach(t,e=this){for(const i of this.#T()){const s=this.#c[i],h=this.#F(s)?s.__staleWhileFetching:s;void 0!==h&&t.call(e,h,this.#l[i],this)}}purgeStale(){let t=!1;for(const e of this.#T({allowStale:!0}))this.#_(e)&&(this.delete(this.#l[e]),t=!0);return t}dump(){const t=[];for(const e of this.#A({allowStale:!0})){const i=this.#l[e],s=this.#c[e],h=this.#F(s)?s.__staleWhileFetching:s;if(void 0===h||void 0===i)continue;const o={value:h};if(this.#z&&this.#y){o.ttl=this.#z[e];const t=perf.now()-this.#y[e];o.start=Math.floor(Date.now()-t)}this.#S&&(o.size=this.#S[e]),t.unshift([i,o])}return t}load(t){this.clear();for(const[e,i]of t){if(i.start){const t=Date.now()-i.start;i.start=perf.now()-t}this.set(e,i.value,i)}}set(t,e,i={}){const{ttl:s=this.ttl,start:h,noDisposeOnSet:o=this.noDisposeOnSet,sizeCalculation:a=this.sizeCalculation,status:n}=i;let{noUpdateTTL:r=this.noUpdateTTL}=i;const l=this.#I(t,e,i.size||0,a);if(this.maxEntrySize&&l>this.maxEntrySize)return n&&(n.set="miss",n.maxEntrySizeExceeded=!0),this.delete(t),this;let c=0===this.#a?void 0:this.#r.get(t);if(void 0===c)c=0===this.#a?this.#p:0!==this.#g.length?this.#g.pop():this.#a===this.#e?this.#W(!1):this.#a,this.#l[c]=t,this.#c[c]=e,this.#r.set(t,c),this.#d[this.#p]=c,this.#u[c]=this.#p,this.#p=c,this.#a++,this.#R(c,l,n),n&&(n.set="add"),r=!1;else{this.#k(c);const i=this.#c[c];if(e!==i){if(this.#w&&this.#F(i)?i.__abortController.abort(new Error("replaced")):o||(this.#m&&this.#s?.(i,t,"set"),this.#L&&this.#v?.push([i,t,"set"])),this.#C(c),this.#R(c,l,n),this.#c[c]=e,n){n.set="replace";const t=i&&this.#F(i)?i.__staleWhileFetching:i;void 0!==t&&(n.oldValue=t)}}else n&&(n.set="update")}if(0===s||this.#z||this.#O(),this.#z&&(r||this.#D(c,s,h),n&&this.#M(n,c)),!o&&this.#L&&this.#v){const t=this.#v;let e;for(;e=t?.shift();)this.#h?.(...e)}return this}pop(){try{for(;this.#a;){const t=this.#c[this.#f];if(this.#W(!0),this.#F(t)){if(t.__staleWhileFetching)return t.__staleWhileFetching}else if(void 0!==t)return t}}finally{if(this.#L&&this.#v){const t=this.#v;let e;for(;e=t?.shift();)this.#h?.(...e)}}}#W(t){const e=this.#f,i=this.#l[e],s=this.#c[e];return this.#w&&this.#F(s)?s.__abortController.abort(new Error("evicted")):(this.#m||this.#L)&&(this.#m&&this.#s?.(s,i,"evict"),this.#L&&this.#v?.push([s,i,"evict"])),this.#C(e),t&&(this.#l[e]=void 0,this.#c[e]=void 0,this.#g.push(e)),1===this.#a?(this.#f=this.#p=0,this.#g.length=0):this.#f=this.#d[e],this.#r.delete(i),this.#a--,e}has(t,e={}){const{updateAgeOnHas:i=this.updateAgeOnHas,status:s}=e,h=this.#r.get(t);if(void 0!==h){const t=this.#c[h];if(this.#F(t)&&void 0===t.__staleWhileFetching)return!1;if(!this.#_(h))return i&&this.#E(h),s&&(s.has="hit",this.#M(s,h)),!0;s&&(s.has="stale",this.#M(s,h))}else s&&(s.has="miss");return!1}peek(t,e={}){const{allowStale:i=this.allowStale}=e,s=this.#r.get(t);if(void 0!==s&&(i||!this.#_(s))){const t=this.#c[s];return this.#F(t)?t.__staleWhileFetching:t}}#x(t,e,i,s){const h=void 0===e?void 0:this.#c[e];if(this.#F(h))return h;const o=new AbortController,{signal:a}=i;a?.addEventListener("abort",(()=>o.abort(a.reason)),{signal:o.signal});const n={signal:o.signal,options:i,context:s},r=(s,h=!1)=>{const{aborted:a}=o.signal,r=i.ignoreFetchAbort&&void 0!==s;if(i.status&&(a&&!h?(i.status.fetchAborted=!0,i.status.fetchError=o.signal.reason,r&&(i.status.fetchAbortIgnored=!0)):i.status.fetchResolved=!0),a&&!r&&!h)return l(o.signal.reason);const d=c;return this.#c[e]===c&&(void 0===s?d.__staleWhileFetching?this.#c[e]=d.__staleWhileFetching:this.delete(t):(i.status&&(i.status.fetchUpdated=!0),this.set(t,s,n.options))),s},l=s=>{const{aborted:h}=o.signal,a=h&&i.allowStaleOnFetchAbort,n=a||i.allowStaleOnFetchRejection,r=n||i.noDeleteOnFetchRejection,l=c;if(this.#c[e]===c){!r||void 0===l.__staleWhileFetching?this.delete(t):a||(this.#c[e]=l.__staleWhileFetching)}if(n)return i.status&&void 0!==l.__staleWhileFetching&&(i.status.returnedStale=!0),l.__staleWhileFetching;if(l.__returned===l)throw s};i.status&&(i.status.fetchDispatched=!0);const c=new Promise(((e,s)=>{const a=this.#o?.(t,h,n);a&&a instanceof Promise&&a.then((t=>e(t)),s),o.signal.addEventListener("abort",(()=>{i.ignoreFetchAbort&&!i.allowStaleOnFetchAbort||(e(),i.allowStaleOnFetchAbort&&(e=t=>r(t,!0)))}))})).then(r,(t=>(i.status&&(i.status.fetchRejected=!0,i.status.fetchError=t),l(t)))),d=Object.assign(c,{__abortController:o,__staleWhileFetching:h,__returned:void 0});return void 0===e?(this.set(t,d,{...n.options,status:void 0}),e=this.#r.get(t)):this.#c[e]=d,d}#F(t){if(!this.#w)return!1;const e=t;return!!e&&e instanceof Promise&&e.hasOwnProperty("__staleWhileFetching")&&e.__abortController instanceof AbortController}async fetch(t,e={}){const{allowStale:i=this.allowStale,updateAgeOnGet:s=this.updateAgeOnGet,noDeleteOnStaleGet:h=this.noDeleteOnStaleGet,ttl:o=this.ttl,noDisposeOnSet:a=this.noDisposeOnSet,size:n=0,sizeCalculation:r=this.sizeCalculation,noUpdateTTL:l=this.noUpdateTTL,noDeleteOnFetchRejection:c=this.noDeleteOnFetchRejection,allowStaleOnFetchRejection:d=this.allowStaleOnFetchRejection,ignoreFetchAbort:u=this.ignoreFetchAbort,allowStaleOnFetchAbort:f=this.allowStaleOnFetchAbort,context:p,forceRefresh:g=!1,status:v,signal:S}=e;if(!this.#w)return v&&(v.fetch="get"),this.get(t,{allowStale:i,updateAgeOnGet:s,noDeleteOnStaleGet:h,status:v});const y={allowStale:i,updateAgeOnGet:s,noDeleteOnStaleGet:h,ttl:o,noDisposeOnSet:a,size:n,sizeCalculation:r,noUpdateTTL:l,noDeleteOnFetchRejection:c,allowStaleOnFetchRejection:d,allowStaleOnFetchAbort:f,ignoreFetchAbort:u,status:v,signal:S};let z=this.#r.get(t);if(void 0===z){v&&(v.fetch="miss");const e=this.#x(t,z,y,p);return e.__returned=e}{const e=this.#c[z];if(this.#F(e)){const t=i&&void 0!==e.__staleWhileFetching;return v&&(v.fetch="inflight",t&&(v.returnedStale=!0)),t?e.__staleWhileFetching:e.__returned=e}const h=this.#_(z);if(!g&&!h)return v&&(v.fetch="hit"),this.#k(z),s&&this.#E(z),v&&this.#M(v,z),e;const o=this.#x(t,z,y,p),a=void 0!==o.__staleWhileFetching&&i;return v&&(v.fetch=h?"stale":"refresh",a&&h&&(v.returnedStale=!0)),a?o.__staleWhileFetching:o.__returned=o}}get(t,e={}){const{allowStale:i=this.allowStale,updateAgeOnGet:s=this.updateAgeOnGet,noDeleteOnStaleGet:h=this.noDeleteOnStaleGet,status:o}=e,a=this.#r.get(t);if(void 0!==a){const e=this.#c[a],n=this.#F(e);return o&&this.#M(o,a),this.#_(a)?(o&&(o.get="stale"),n?(o&&i&&void 0!==e.__staleWhileFetching&&(o.returnedStale=!0),i?e.__staleWhileFetching:void 0):(h||this.delete(t),o&&i&&(o.returnedStale=!0),i?e:void 0)):(o&&(o.get="hit"),n?e.__staleWhileFetching:(this.#k(a),s&&this.#E(a),e))}o&&(o.get="miss")}#U(t,e){this.#u[e]=t,this.#d[t]=e}#k(t){t!==this.#p&&(t===this.#f?this.#f=this.#d[t]:this.#U(this.#u[t],this.#d[t]),this.#U(this.#p,t),this.#p=t)}delete(t){let e=!1;if(0!==this.#a){const i=this.#r.get(t);if(void 0!==i)if(e=!0,1===this.#a)this.clear();else{this.#C(i);const e=this.#c[i];this.#F(e)?e.__abortController.abort(new Error("deleted")):(this.#m||this.#L)&&(this.#m&&this.#s?.(e,t,"delete"),this.#L&&this.#v?.push([e,t,"delete"])),this.#r.delete(t),this.#l[i]=void 0,this.#c[i]=void 0,i===this.#p?this.#p=this.#u[i]:i===this.#f?this.#f=this.#d[i]:(this.#d[this.#u[i]]=this.#d[i],this.#u[this.#d[i]]=this.#u[i]),this.#a--,this.#g.push(i)}}if(this.#L&&this.#v?.length){const t=this.#v;let e;for(;e=t?.shift();)this.#h?.(...e)}return e}clear(){for(const t of this.#T({allowStale:!0})){const e=this.#c[t];if(this.#F(e))e.__abortController.abort(new Error("deleted"));else{const i=this.#l[t];this.#m&&this.#s?.(e,i,"delete"),this.#L&&this.#v?.push([e,i,"delete"])}}if(this.#r.clear(),this.#c.fill(void 0),this.#l.fill(void 0),this.#z&&this.#y&&(this.#z.fill(0),this.#y.fill(0)),this.#S&&this.#S.fill(0),this.#f=0,this.#p=0,this.#g.length=0,this.#n=0,this.#a=0,this.#L&&this.#v){const t=this.#v;let e;for(;e=t?.shift();)this.#h?.(...e)}}}exports.LRUCache=LRUCache,exports.default=LRUCache;