"use strict";const{EventEmitter:EventEmitter}=require("node:events"),debug=require("debug")("mssql:base"),{parseSqlConnectionString:parseSqlConnectionString}=require("@tediousjs/connection-string"),tarn=require("tarn"),{IDS:IDS}=require("../utils"),ConnectionError=require("../error/connection-error"),shared=require("../shared"),clone=require("rfdc/default"),{MSSQLError:MSSQLError}=require("../error");class ConnectionPool extends EventEmitter{constructor(e,t){if(super(),IDS.add(this,"ConnectionPool"),debug("pool(%d): created",IDS.get(this)),this._connectStack=[],this._closeStack=[],this._connected=!1,this._connecting=!1,this._healthy=!1,"string"==typeof e)try{this.config=this.constructor.parseConnectionString(e)}catch(e){if("function"==typeof t)return setImmediate(t,e);throw e}else this.config=clone(e);this.config.port=this.config.port||1433,this.config.options=this.config.options||{},this.config.stream=this.config.stream||!1,this.config.parseJSON=this.config.parseJSON||!1,this.config.arrayRowMode=this.config.arrayRowMode||!1,this.config.validateConnection=!("validateConnection"in this.config)||this.config.validateConnection;const n=/^(.*)\\(.*)$/.exec(this.config.server);if(n&&(this.config.server=n[1],this.config.options.instanceName=n[2]),void 0!==this.config.options.useColumnNames&&!0!==this.config.options.useColumnNames){const e=new MSSQLError("Invalid options `useColumnNames`, use `arrayRowMode` instead");if("function"==typeof t)return setImmediate(t,e);throw e}"function"==typeof t&&this.connect(t)}get connected(){return this._connected}get connecting(){return this._connecting}get healthy(){return this._healthy}static parseConnectionString(e){return this._parseConnectionString(e)}static _parseAuthenticationType(e,t){switch(e.toLowerCase()){case"active directory integrated":return t.includes("token")?"azure-active-directory-access-token":["client id","client secret","tenant id"].every((e=>t.includes(e)))?"azure-active-directory-service-principal-secret":["client id","msi endpoint","msi secret"].every((e=>t.includes(e)))?"azure-active-directory-msi-app-service":["client id","msi endpoint"].every((e=>t.includes(e)))?"azure-active-directory-msi-vm":"azure-active-directory-default";case"active directory password":return"azure-active-directory-password";case"ntlm":return"ntlm";default:return"default"}}static _parseConnectionString(e){const t=parseSqlConnectionString(e,!0,!0);return Object.entries(t).reduce(((e,[n,i])=>{switch(n){case"application name":case"asynchronous processing":case"attachdbfilename":case"column encryption setting":case"connection lifetime":case"connectretrycount":case"context connection":case"enlist":case"failover partner":case"integrated security":case"multipleactiveresultsets":case"network library":case"persist security info":case"poolblockingperiod":case"pooling":case"replication":case"transparentnetworkipresolution":case"type system version":case"user instance":break;case"applicationintent":Object.assign(e.options,{readOnlyIntent:"readonly"===i});break;case"authentication":Object.assign(e,{authentication_type:this._parseAuthenticationType(i,Object.keys(t))});break;case"connection timeout":Object.assign(e,{connectionTimeout:1e3*i});break;case"connectretryinterval":Object.assign(e.options,{connectionRetryInterval:1e3*i});break;case"client id":Object.assign(e,{clientId:i});break;case"client secret":Object.assign(e,{clientSecret:i});break;case"current language":Object.assign(e.options,{language:i});break;case"data source":{let t,n=i,s=1433;if(/^np:/i.test(n))throw new Error("Connection via Named Pipes is not supported.");/^tcp:/i.test(n)&&(n=n.substr(4));const o=/^(.*)\\(.*)$/.exec(n);o&&(n=o[1].trim(),t=o[2].trim());const r=/^(.*),(.*)$/.exec(n);if(r)n=r[1].trim(),s=parseInt(r[2].trim(),10);else{const e=/^(.*),(.*)$/.exec(t);e&&(t=e[1].trim(),s=parseInt(e[2].trim(),10))}"."!==n&&"(.)"!==n&&"(localdb)"!==n.toLowerCase()&&"(local)"!==n.toLowerCase()||(n="localhost"),Object.assign(e,{port:s,server:n}),t&&Object.assign(e.options,{instanceName:t});break}case"encrypt":Object.assign(e.options,{encrypt:!!i});break;case"initial catalog":Object.assign(e,{database:i});break;case"max pool size":Object.assign(e.pool,{max:i});break;case"min pool size":Object.assign(e.pool,{min:i});break;case"msi endpoint":Object.assign(e,{msiEndpoint:i});break;case"msi secret":Object.assign(e,{msiSecret:i});break;case"multisubnetfailover":Object.assign(e.options,{multiSubnetFailover:i});break;case"packet size":Object.assign(e.options,{packetSize:i});break;case"password":Object.assign(e,{password:i});break;case"tenant id":Object.assign(e,{tenantId:i});break;case"token":Object.assign(e,{token:i});break;case"transaction binding":Object.assign(e.options,{enableImplicitTransactions:"implicit unbind"===i.toLowerCase()});break;case"trustservercertificate":Object.assign(e.options,{trustServerCertificate:i});break;case"user id":{let t,n=i;const s=/^(.*)\\(.*)$/.exec(n);s&&(t=s[1],n=s[2]),t&&Object.assign(e,{domain:t}),n&&Object.assign(e,{user:n});break}case"workstation id":Object.assign(e.options,{workstationId:i});break;case"request timeout":Object.assign(e,{requestTimeout:parseInt(i,10)});break;case"stream":Object.assign(e,{stream:!!i});break;case"useutc":Object.assign(e.options,{useUTC:!!i});break;case"parsejson":Object.assign(e,{parseJSON:!!i})}return e}),{options:{},pool:{}})}acquire(e,t){const n=shared.Promise.resolve(this._acquire()).catch((e=>{throw this.emit("error",e),e}));return"function"==typeof t?(n.then((e=>t(null,e,this.config))).catch(t),this):n}_acquire(){return this.pool?this.pool.destroyed?shared.Promise.reject(new ConnectionError("Connection is closing","ENOTOPEN")):this.pool.acquire().promise:shared.Promise.reject(new ConnectionError("Connection not yet open.","ENOTOPEN"))}release(e){return debug("connection(%d): released",IDS.get(e)),this.pool&&this.pool.release(e),this}connect(e){return"function"==typeof e?(this._connect(e),this):new shared.Promise(((e,t)=>this._connect((n=>{if(n)return t(n);e(this)}))))}_connect(e){if(this._connected)return debug("pool(%d): already connected, executing connect callback immediately",IDS.get(this)),setImmediate(e,null,this);this._connectStack.push(e),this._connecting||(this._connecting=!0,debug("pool(%d): connecting",IDS.get(this)),this._poolCreate().then((e=>(debug("pool(%d): connected",IDS.get(this)),this._healthy=!0,this._poolDestroy(e).then((()=>{this.pool=new tarn.Pool(Object.assign({create:()=>this._poolCreate().then((e=>(this._healthy=!0,e))).catch((e=>{throw this.pool.numUsed()+this.pool.numFree()<=0&&(this._healthy=!1),e})),validate:this._poolValidate.bind(this),destroy:this._poolDestroy.bind(this),max:10,min:0,idleTimeoutMillis:3e4,propagateCreateError:!0},this.config.pool)),this._connecting=!1,this._connected=!0}))))).then((()=>{this._connectStack.forEach((e=>{setImmediate(e,null,this)}))})).catch((e=>{this._connecting=!1,this._connectStack.forEach((t=>{setImmediate(t,e)}))})).then((()=>{this._connectStack=[]})))}get size(){return this.pool.numFree()+this.pool.numUsed()+this.pool.numPendingCreates()}get available(){return this.pool.numFree()}get pending(){return this.pool.numPendingAcquires()}get borrowed(){return this.pool.numUsed()}close(e){return"function"==typeof e?(this._close(e),this):new shared.Promise(((e,t)=>{this._close((n=>{if(n)return t(n);e(this)}))}))}_close(e){if(this._connecting&&(debug("pool(%d): close called while connecting",IDS.get(this)),setImmediate(e,new ConnectionError("Cannot close a pool while it is connecting"))),!this.pool)return debug("pool(%d): already closed, executing close callback immediately",IDS.get(this)),setImmediate(e,null);this._closeStack.push(e),this.pool.destroyed||(this._connecting=this._connected=this._healthy=!1,this.pool.destroy().then((()=>{debug("pool(%d): pool closed, removing pool reference and executing close callbacks",IDS.get(this)),this.pool=null,this._closeStack.forEach((e=>{setImmediate(e,null)}))})).catch((e=>{this.pool=null,this._closeStack.forEach((t=>{setImmediate(t,e)}))})).then((()=>{this._closeStack=[]})))}request(){return new shared.driver.Request(this)}transaction(){return new shared.driver.Transaction(this)}query(){if("string"==typeof arguments[0])return new shared.driver.Request(this).query(arguments[0],arguments[1]);const e=Array.prototype.slice.call(arguments),t=e.shift();return new shared.driver.Request(this)._template(t,e,"query")}batch(){if("string"==typeof arguments[0])return new shared.driver.Request(this).batch(arguments[0],arguments[1]);const e=Array.prototype.slice.call(arguments),t=e.shift();return new shared.driver.Request(this)._template(t,e,"batch")}}module.exports=ConnectionPool;