"use strict";const debug=require("debug")("mssql:base"),{EventEmitter:EventEmitter}=require("node:events"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),globalConnection=require("../global-connection"),{TransactionError:TransactionError,PreparedStatementError:PreparedStatementError}=require("../error"),shared=require("../shared"),{TYPES:TYPES,declare:declare}=require("../datatypes");class PreparedStatement extends EventEmitter{constructor(e){super(),IDS.add(this,"PreparedStatement"),debug("ps(%d): created",IDS.get(this)),this.parent=e||globalConnection.pool,this._handle=0,this.prepared=!1,this.parameters={}}get config(){return this.parent.config}get connected(){return this.parent.connected}acquire(e,t){return this._acquiredConnection?this._activeRequest?(setImmediate(t,new TransactionError("Can't acquire connection for the request. There is another request in progress.","EREQINPROG")),this):(this._activeRequest=e,setImmediate(t,null,this._acquiredConnection,this._acquiredConfig),this):(setImmediate(t,new PreparedStatementError("Statement is not prepared. Call prepare() first.","ENOTPREPARED")),this)}release(e){return e===this._acquiredConnection&&(this._activeRequest=null),this}input(e,t){if(/--| |\/\*|\*\/|'/.test(e))throw new PreparedStatementError(`SQL injection warning for param '${e}'`,"EINJECT");if(arguments.length<2)throw new PreparedStatementError("Invalid number of arguments. 2 arguments expected.","EARGS");if(t instanceof Function&&(t=t()),objectHasProperty(this.parameters,e))throw new PreparedStatementError(`The parameter name ${e} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[e]={name:e,type:t.type,io:1,length:t.length,scale:t.scale,precision:t.precision,tvpType:t.tvpType},this}replaceInput(e,t,r){return delete this.parameters[e],this.input(e,t,r)}output(e,t){if(/--| |\/\*|\*\/|'/.test(e))throw new PreparedStatementError(`SQL injection warning for param '${e}'`,"EINJECT");if(arguments.length<2)throw new PreparedStatementError("Invalid number of arguments. 2 arguments expected.","EARGS");if(t instanceof Function&&(t=t()),objectHasProperty(this.parameters,e))throw new PreparedStatementError(`The parameter name ${e} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[e]={name:e,type:t.type,io:2,length:t.length,scale:t.scale,precision:t.precision},this}replaceOutput(e,t){return delete this.parameters[e],this.output(e,t)}prepare(e,t){return"function"==typeof t?(this._prepare(e,t),this):new shared.Promise(((t,r)=>{this._prepare(e,(e=>{if(e)return r(e);t(this)}))}))}_prepare(e,t){if(debug("ps(%d): prepare",IDS.get(this)),"function"==typeof e&&(t=e,e=void 0),this.prepared)return setImmediate(t,new PreparedStatementError("Statement is already prepared.","EALREADYPREPARED"));this.statement=e||this.statement,this.parent.acquire(this,((e,r,n)=>{if(e)return t(e);this._acquiredConnection=r,this._acquiredConfig=n;const a=new shared.driver.Request(this);a.stream=!1,a.output("handle",TYPES.Int),a.input("params",TYPES.NVarChar,(()=>{const e=[];for(const t in this.parameters){if(!objectHasProperty(this.parameters,t))continue;const r=this.parameters[t];e.push(`@${t} ${declare(r.type,r)}${2===r.io?" output":""}`)}return e})().join(",")),a.input("stmt",TYPES.NVarChar,this.statement),a.execute("sp_prepare",((e,r)=>{if(e)return this.parent.release(this._acquiredConnection),this._acquiredConnection=null,this._acquiredConfig=null,t(e);debug("ps(%d): prepared",IDS.get(this)),this._handle=r.output.handle,this.prepared=!0,t(null)}))}))}execute(e,t){return this.stream||"function"==typeof t?this._execute(e,t):new shared.Promise(((t,r)=>{this._execute(e,((e,n)=>{if(e)return r(e);t(n)}))}))}_execute(e,t){const r=new shared.driver.Request(this);r.stream=this.stream,r.arrayRowMode=this.arrayRowMode,r.input("handle",TYPES.Int,this._handle);for(const t in this.parameters){if(!objectHasProperty(this.parameters,t))continue;const n=this.parameters[t];r.parameters[t]={name:t,type:n.type,io:n.io,value:e[t],length:n.length,scale:n.scale,precision:n.precision}}return r.execute("sp_execute",((e,r)=>{if(e)return t(e);t(null,r)})),r}unprepare(e){return"function"==typeof e?(this._unprepare(e),this):new shared.Promise(((e,t)=>{this._unprepare((r=>{if(r)return t(r);e()}))}))}_unprepare(e){if(debug("ps(%d): unprepare",IDS.get(this)),!this.prepared)return setImmediate(e,new PreparedStatementError("Statement is not prepared. Call prepare() first.","ENOTPREPARED"));if(this._activeRequest)return setImmediate(e,new TransactionError("Can't unprepare the statement. There is a request in progress.","EREQINPROG"));const t=new shared.driver.Request(this);t.stream=!1,t.input("handle",TYPES.Int,this._handle),t.execute("sp_unprepare",(t=>t?e(t):(this.parent.release(this._acquiredConnection),this._acquiredConnection=null,this._acquiredConfig=null,this._handle=0,this.prepared=!1,debug("ps(%d): unprepared",IDS.get(this)),e(null))))}}module.exports=PreparedStatement;