"use strict";const debug=require("debug")("mssql:base"),{EventEmitter:EventEmitter}=require("node:events"),{Readable:Readable}=require("node:stream"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),globalConnection=require("../global-connection"),{RequestError:RequestError,ConnectionError:ConnectionError}=require("../error"),{TYPES:TYPES}=require("../datatypes"),shared=require("../shared");class Request extends EventEmitter{constructor(e){super(),IDS.add(this,"Request"),debug("request(%d): created",IDS.get(this)),this.canceled=!1,this._paused=!1,this.parent=e||globalConnection.pool,this.parameters={},this.stream=null,this.arrayRowMode=null}get paused(){return this._paused}template(){const e=Array.prototype.slice.call(arguments),t=e.shift();return this._template(t,e)}_template(e,t,r){const s=[e[0]];for(let r=0;r<t.length;r++){const i=t[r];if(Array.isArray(i)){for(let e=0;e<i.length;e++)this.input(`param${r+1}_${e}`,i[e]),s.push(`@param${r+1}_${e}`),e<i.length-1&&s.push(", ");s.push(e[r+1])}else this.input(`param${r+1}`,i),s.push(`@param${r+1}`,e[r+1])}return r?this[r](s.join("")):s.join("")}input(e,t,r){if(/--| |\/\*|\*\/|'/.test(e))throw new RequestError(`SQL injection warning for param '${e}'`,"EINJECT");if(arguments.length<2)throw new RequestError("Invalid number of arguments. At least 2 arguments expected.","EARGS");if(2===arguments.length&&(r=t,t=shared.getTypeByValue(r)),!r||"function"!=typeof r.valueOf||r instanceof Date||(r=r.valueOf()),void 0===r&&(r=null),"number"==typeof r&&isNaN(r)&&(r=null),t instanceof Function&&(t=t()),objectHasProperty(this.parameters,e))throw new RequestError(`The parameter name ${e} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[e]={name:e,type:t.type,io:1,value:r,length:t.length,scale:t.scale,precision:t.precision,tvpType:t.tvpType},this}replaceInput(e,t,r){return delete this.parameters[e],this.input(e,t,r)}output(e,t,r){if(t||(t=TYPES.NVarChar),/--| |\/\*|\*\/|'/.test(e))throw new RequestError(`SQL injection warning for param '${e}'`,"EINJECT");if(t===TYPES.Text||t===TYPES.NText||t===TYPES.Image)throw new RequestError("Deprecated types (Text, NText, Image) are not supported as OUTPUT parameters.","EDEPRECATED");if(!r||"function"!=typeof r.valueOf||r instanceof Date||(r=r.valueOf()),void 0===r&&(r=null),"number"==typeof r&&isNaN(r)&&(r=null),t instanceof Function&&(t=t()),objectHasProperty(this.parameters,e))throw new RequestError(`The parameter name ${e} has already been declared. Parameter names must be unique`,"EDUPEPARAM");return this.parameters[e]={name:e,type:t.type,io:2,value:r,length:t.length,scale:t.scale,precision:t.precision},this}replaceOutput(e,t,r){return delete this.parameters[e],this.output(e,t,r)}batch(e,t){if(null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.rowsAffected=0,"function"==typeof t)return this._batch(e,((e,r,s,i)=>{if(this.stream&&(e&&this.emit("error",e),e=null,this.emit("done",{output:s,rowsAffected:i})),e)return t(e);t(null,{recordsets:r,recordset:r&&r[0],output:s,rowsAffected:i})})),this;if("object"==typeof e){const t=Array.prototype.slice.call(arguments),r=t.shift();e=this._template(r,t)}return new shared.Promise(((t,r)=>{this._batch(e,((e,s,i,n)=>{if(this.stream&&(e&&this.emit("error",e),e=null,this.emit("done",{output:i,rowsAffected:n})),e)return r(e);t({recordsets:s,recordset:s&&s[0],output:i,rowsAffected:n})}))}))}_batch(e,t){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(t)):setImmediate(t,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(t,new RequestError("No connection is specified for that request.","ENOCONN"))}bulk(e,t,r){return"function"==typeof t?(r=t,t={}):void 0===t&&(t={}),null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.stream||"function"==typeof r?(this._bulk(e,t,((e,t)=>this.stream?(e&&this.emit("error",e),this.emit("done",{rowsAffected:t})):e?r(e):void r(null,{rowsAffected:t}))),this):new shared.Promise(((r,s)=>{this._bulk(e,t,((e,t)=>{if(e)return s(e);r({rowsAffected:t})}))}))}_bulk(e,t,r){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(r)):setImmediate(r,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(r,new RequestError("No connection is specified for that request.","ENOCONN"))}toReadableStream(e={}){this.stream=!0,this.pause();const t=new Readable({...e,objectMode:!0,read:()=>{this.resume()}});return this.on("row",(e=>{t.push(e)||this.pause()})),this.on("error",(e=>{t.emit("error",e)})),this.on("done",(()=>{t.push(null)})),t}pipe(e){return this.toReadableStream().pipe(e)}query(e,t){if(null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.rowsAffected=0,"function"==typeof t)return this._query(e,((e,r,s,i,n)=>{if(this.stream&&(e&&this.emit("error",e),e=null,this.emit("done",{output:s,rowsAffected:i})),e)return t(e);const o={recordsets:r,recordset:r&&r[0],output:s,rowsAffected:i};this.arrayRowMode&&(o.columns=n),t(null,o)})),this;if("object"==typeof e){const t=Array.prototype.slice.call(arguments),r=t.shift();e=this._template(r,t)}return new shared.Promise(((t,r)=>{this._query(e,((e,s,i,n,o)=>{if(this.stream&&(e&&this.emit("error",e),e=null,this.emit("done",{output:i,rowsAffected:n})),e)return r(e);const a={recordsets:s,recordset:s&&s[0],output:i,rowsAffected:n};this.arrayRowMode&&(a.columns=o),t(a)}))}))}_query(e,t){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(t)):setImmediate(t,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(t,new RequestError("No connection is specified for that request.","ENOCONN"))}execute(e,t){return null===this.stream&&this.parent&&(this.stream=this.parent.config.stream),null===this.arrayRowMode&&this.parent&&(this.arrayRowMode=this.parent.config.arrayRowMode),this.rowsAffected=0,"function"==typeof t?(this._execute(e,((e,r,s,i,n,o)=>{if(this.stream&&(e&&this.emit("error",e),e=null,this.emit("done",{output:s,rowsAffected:n,returnValue:i})),e)return t(e);const a={recordsets:r,recordset:r&&r[0],output:s,rowsAffected:n,returnValue:i};this.arrayRowMode&&(a.columns=o),t(null,a)})),this):new shared.Promise(((t,r)=>{this._execute(e,((e,s,i,n,o,a)=>{if(this.stream&&(e&&this.emit("error",e),e=null,this.emit("done",{output:i,rowsAffected:o,returnValue:n})),e)return r(e);const u={recordsets:s,recordset:s&&s[0],output:i,rowsAffected:o,returnValue:n};this.arrayRowMode&&(u.columns=a),t(u)}))}))}_execute(e,t){return this.parent?this.parent.connected?(this.canceled=!1,void setImmediate(t)):setImmediate(t,new ConnectionError("Connection is closed.","ECONNCLOSED")):setImmediate(t,new RequestError("No connection is specified for that request.","ENOCONN"))}cancel(){return this._cancel(),!0}_cancel(){this.canceled=!0}pause(){return!!this.stream&&(this._pause(),!0)}_pause(){this._paused=!0}resume(){return!!this.stream&&(this._resume(),!0)}_resume(){this._paused=!1}_setCurrentRequest(e){return this._currentRequest=e,this._paused&&this.pause(),this}}module.exports=Request;