"use strict";const debug=require("debug")("mssql:base"),{EventEmitter:EventEmitter}=require("node:events"),{IDS:IDS}=require("../utils"),globalConnection=require("../global-connection"),{TransactionError:TransactionError}=require("../error"),shared=require("../shared"),ISOLATION_LEVEL=require("../isolationlevel");class Transaction extends EventEmitter{constructor(e){super(),IDS.add(this,"Transaction"),debug("transaction(%d): created",IDS.get(this)),this.parent=e||globalConnection.pool,this.isolationLevel=Transaction.defaultIsolationLevel,this.name=""}get config(){return this.parent.config}get connected(){return this.parent.connected}acquire(e,t){return this._acquiredConnection?this._activeRequest?(setImmediate(t,new TransactionError("Can't acquire connection for the request. There is another request in progress.","EREQINPROG")),this):(this._activeRequest=e,setImmediate(t,null,this._acquiredConnection,this._acquiredConfig),this):(setImmediate(t,new TransactionError("Transaction has not begun. Call begin() first.","ENOTBEGUN")),this)}release(e){return e===this._acquiredConnection&&(this._activeRequest=null),this}begin(e,t){return e instanceof Function&&(t=e,e=void 0),"function"==typeof t?(this._begin(e,(e=>{e||this.emit("begin"),t(e)})),this):new shared.Promise(((t,i)=>{this._begin(e,(e=>{if(e)return i(e);this.emit("begin"),t(this)}))}))}_begin(e,t){if(this._acquiredConnection)return setImmediate(t,new TransactionError("Transaction has already begun.","EALREADYBEGUN"));if(this._aborted=!1,this._rollbackRequested=!1,e){if(!Object.keys(ISOLATION_LEVEL).some((t=>ISOLATION_LEVEL[t]===e)))throw new TransactionError("Invalid isolation level.");this.isolationLevel=e}setImmediate(t)}commit(e){return"function"==typeof e?(this._commit((t=>{t||this.emit("commit"),e(t)})),this):new shared.Promise(((e,t)=>{this._commit((i=>{if(i)return t(i);this.emit("commit"),e()}))}))}_commit(e){return this._aborted?setImmediate(e,new TransactionError("Transaction has been aborted.","EABORT")):this._acquiredConnection?this._activeRequest?setImmediate(e,new TransactionError("Can't commit transaction. There is a request in progress.","EREQINPROG")):void setImmediate(e):setImmediate(e,new TransactionError("Transaction has not begun. Call begin() first.","ENOTBEGUN"))}request(){return new shared.driver.Request(this)}rollback(e){return"function"==typeof e?(this._rollback((t=>{t||this.emit("rollback",this._aborted),e(t)})),this):new shared.Promise(((e,t)=>this._rollback((i=>{if(i)return t(i);this.emit("rollback",this._aborted),e()}))))}_rollback(e){return this._aborted?setImmediate(e,new TransactionError("Transaction has been aborted.","EABORT")):this._acquiredConnection?this._activeRequest?setImmediate(e,new TransactionError("Can't rollback transaction. There is a request in progress.","EREQINPROG")):(this._rollbackRequested=!0,void setImmediate(e)):setImmediate(e,new TransactionError("Transaction has not begun. Call begin() first.","ENOTBEGUN"))}}Transaction.defaultIsolationLevel=ISOLATION_LEVEL.READ_COMMITTED,module.exports=Transaction;