"use strict";const msnodesql=require("msnodesqlv8"),debug=require("debug")("mssql:msv8"),BaseRequest=require("../base/request"),RequestError=require("../error/request-error"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),{TYPES:TYPES,DECLARATIONS:DECLARATIONS,declare:declare}=require("../datatypes"),{PARSERS:UDT}=require("../udt"),Table=require("../table"),{valueHandler:valueHandler}=require("../shared"),JSON_COLUMN_ID="JSON_F52E2B61-18A1-11d1-B105-00805F49916B",XML_COLUMN_ID="XML_F52E2B61-18A1-11d1-B105-00805F49916B",EMPTY_BUFFER=Buffer.alloc(0),castParameter=function(e,t){if(null==e)return t===TYPES.Binary||t===TYPES.VarBinary||t===TYPES.Image?EMPTY_BUFFER:null;switch(t){case TYPES.VarChar:case TYPES.NVarChar:case TYPES.Char:case TYPES.NChar:case TYPES.Xml:case TYPES.Text:case TYPES.NText:"string"==typeof e||e instanceof String||(e=e.toString());break;case TYPES.Int:case TYPES.TinyInt:case TYPES.BigInt:case TYPES.SmallInt:"number"==typeof e||e instanceof Number||(e=parseInt(e),isNaN(e)&&(e=null));break;case TYPES.Float:case TYPES.Real:case TYPES.Decimal:case TYPES.Numeric:case TYPES.SmallMoney:case TYPES.Money:"number"==typeof e||e instanceof Number||(e=parseFloat(e),isNaN(e)&&(e=null));break;case TYPES.Bit:"boolean"==typeof e||e instanceof Boolean||(e=Boolean(e));break;case TYPES.DateTime:case TYPES.SmallDateTime:case TYPES.DateTimeOffset:case TYPES.Date:e instanceof Date||(e=new Date(e));break;case TYPES.Binary:case TYPES.VarBinary:case TYPES.Image:e instanceof Buffer||(e=Buffer.from(e.toString()));break;case TYPES.TVP:e=msnodesql.TvpFromTable(e)}return e},createColumns=function(e,t){let r={};t&&(r=[]);for(let s=0,n=e.length;s<n;s++){const n=e[s],a=n.name,o={index:s,name:n.name,length:n.size,type:DECLARATIONS[n.sqlType],nullable:n.nullable};null!=n.udtType&&(o.udt={name:n.udtType},DECLARATIONS[n.udtType]&&(o.type=DECLARATIONS[n.udtType])),t?r.push(o):r[a]=o}return r},valueCorrection=function(e,t){const r=t&&objectHasProperty(t,"sqlType")&&objectHasProperty(DECLARATIONS,t.sqlType)?DECLARATIONS[t.sqlType]:null;return r&&valueHandler.has(r)?valueHandler.get(r)(e):"time"===t.sqlType&&null!=e?(e.setFullYear(1970),e):"udt"===t.sqlType&&null!=e&&UDT[t.udtType]?UDT[t.udtType](e):e};class Request extends BaseRequest{_batch(e,t){this._isBatch=!0,this._query(e,t)}_bulk(e,t,r){super._bulk(e,t,(t=>{if(t)return r(t);try{e._makeBulk()}catch(e){return r(new RequestError(e,"EREQUEST"))}e.name||setImmediate(r,new RequestError("Table name must be specified for bulk insert.","ENAME")),"@"===e.name.charAt(0)&&setImmediate(r,new RequestError("You can't use table variables for bulk insert.","ENAME")),this.parent.acquire(this,((t,s)=>{let n=!1;if(!t){if(debug("connection(%d): borrowed to request #%d",IDS.get(s),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(s),r(new RequestError("Canceled.","ECANCEL"));const t=(t,a)=>{n||(n=!0,t&&("string"==typeof t.sqlstate&&"08s01"===t.sqlstate.toLowerCase()&&(s.hasError=!0),(t=new RequestError(t)).code="EREQUEST"),this.parent.release(s),t?r(t):r(null,e.rows.length))},a=()=>s.tableMgr().bind(e.path.replace(/\[|\]/g,""),(r=>{if(0===r.columns.length)return t(new RequestError("Table was not found on the server.","ENAME"));const s=[];for(const t of Array.from(e.rows)){const r={};for(let s=0;s<e.columns.length;s++){r[e.columns[s].name]=t[s]}s.push(r)}r.insertRows(s,t)}));if(e.create){let r;return r=e.temporary?`tempdb..[${e.name}]`:e.path,s.queryRaw(`if object_id('${r.replace(/'/g,"''")}') is null ${e.declare()}`,(function(e){if(e)return t(e);a()}))}a()}}))}))}_query(e,t){super._query(e,(r=>{if(r)return t(r);if(0===e.length)return t(null,[]);const s=[],n=[],a=[],o={},i={},u=[];let l=!1,c=null,m=null,h=null,p=!1,_=!1,f=null;const d=(e,r,s,n)=>{const i=!n;"string"==typeof s.sqlstate&&"08s01"===s.sqlstate.toLowerCase()&&(r.hasError=!0);const u=new RequestError(s,"EREQUEST");if(u.code="EREQUEST",this.stream)this.emit("error",u);else if(i&&!l){if(e)for(const t in o)e.removeListener(t,o[t]);let s;r&&(this.parent.release(r),delete this._cancel,debug("request(%d): failed",IDS.get(this),u)),a.length&&(s=a.pop(),u.precedingErrors||(u.precedingErrors=[]),u.precedingErrors.push(s)),l=!0,t(u)}a.push(u)};if(!this._nested){const t=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const r=this.parameters[e];t.push(`@${r.name} ${declare(r.type,r)}`)}const r=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];1===t.io&&r.push(`set @${t.name}=?`)}const s=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];2===t.io&&s.push(`@${t.name} as '${t.name}'`)}t.length&&(e=`declare ${t.join(",")};${r.join(";")};${e};`),s.length&&(e+=`select ${s.join(",")};`,p=!0)}this.parent.acquire(this,((r,E,S)=>{if(r)return t(r);if(debug("connection(%d): borrowed to request #%d",IDS.get(E),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(E),t(new RequestError("Canceled.","ECANCEL"));const y=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];(1===t.io||2===t.io&&t.value)&&y.push(castParameter(t.value,t.type))}debug("request(%d): query",IDS.get(this),e);const b=E.queryRaw({query_str:e,query_timeout:S.requestTimeout/1e3},y);this._setCurrentRequest(b),this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),b.cancelQuery((e=>{e&&debug("request(%d): failed to cancel",IDS.get(this),e);try{b.isPaused()&&b.emit("done")}catch(e){}}))},b.on("meta",(e=>{if(c&&_){const e=f.join("");if(m[0].name===JSON_COLUMN_ID&&!0===S.parseJSON)try{c=""===e?null:JSON.parse(e),this.stream||(s[s.length-1][0]=c)}catch(e){c=null;const t=new RequestError(`Failed to parse incoming JSON. ${e.message}`,"EJSON");this.stream?this.emit("error",t):console.error(t)}else c[m[0].name]=e;f=null,c&&null==c.___return___&&this.stream&&!this.paused&&this.emit("row",c)}c=null,m=e,h=[],Object.defineProperty(h,"columns",{enumerable:!1,configurable:!0,value:createColumns(e,this.arrayRowMode)}),Object.defineProperty(h,"toTable",{enumerable:!1,configurable:!0,value(e){return Table.fromRecordset(this,e)}}),_=!1,1!==e.length||e[0].name!==JSON_COLUMN_ID&&e[0].name!==XML_COLUMN_ID||(_=!0,f=[]);let t=!1;if(null!=h.columns.___return___)t=!0;else if(this.arrayRowMode)for(let e=0;e<m.length;e++)if("___return___"===m[e].name){t=!0;break}this.stream?t||this.emit("recordset",h.columns):s.push(h),this.arrayRowMode&&n.push(h.columns)})),b.on("row",(e=>{c&&_||(c=this.arrayRowMode?[]:{},this.stream||h.push(c))})),b.on("column",((e,t,r)=>{if(_)f.push(t);else{if(t=valueCorrection(t,m[e]),this.arrayRowMode)c.push(t);else{const r=c[m[e].name];null!=r?r instanceof Array?r.push(t):c[m[e].name]=[r,t]:c[m[e].name]=t}let r=!1;if(c&&null!=c.___return___)r=!0;else if(this.arrayRowMode)for(let e=0;e<m.length;e++)if("___return___"===m[e].name){r=!0;break}r||this.stream&&!this.paused&&e===m.length-1&&this.emit("row",c)}})),b.on("rowcount",(e=>{u.push(e),this.stream&&this.emit("rowsaffected",e)})),b.on("info",(e=>{const t=/^\[Microsoft\]\[SQL Server Native Client 11\.0\](?:\[SQL Server\])?([\s\S]*)$/.exec(e.message);if(t&&(e.message=t[1]),this.emit("info",{message:e.message,number:e.code,state:e.sqlstate,class:e.class||0,lineNumber:e.lineNumber||0,serverName:e.serverName,procName:e.procName}),3621===e.code&&!l){const t=a.length>0?a.pop():e;d(b,E,t.originalError||t,!1)}})),b.on("error",o.error=d.bind(null,b,E)),b.once("done",(()=>{if(!l){if(l=!0,!this._nested){if(c&&_){const e=f.join("");if(m[0].name===JSON_COLUMN_ID&&!0===S.parseJSON)try{c=""===e?null:JSON.parse(e),this.stream||(s[s.length-1][0]=c)}catch(e){c=null;const t=new RequestError(`Failed to parse incoming JSON. ${e.message}`,"EJSON");this.stream?this.emit("error",t):console.error(t)}else c[m[0].name]=e;f=null,c&&null==c.___return___&&this.stream&&!this.paused&&this.emit("row",c)}if(p&&s.length){const e=s.pop()[0];for(const t in this.parameters){if(!objectHasProperty(this.parameters,t))continue;const r=this.parameters[t];2===r.io&&(i[r.name]=e[r.name])}}}delete this._cancel,this.parent.release(E),debug("request(%d): completed",IDS.get(this)),this.stream?t(null,this._nested?c:null,i,u,n):t(null,s,i,u,n)}}))}))}))}_execute(e,t){super._execute(e,(r=>{if(r)return t(r);const s=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];2===t.io&&s.push(`@${t.name} ${declare(t.type,t)}`)}const n=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];2===t.io&&t.value&&n.push(`set @${t.name}=?`)}let a=`declare ${["@___return___ int"].concat(s).join(", ")};${n.join(";")};`;a+=`exec @___return___ = ${e} `;const o=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];2===t.io?o.push(`@${t.name}=@${t.name} output`):o.push(`@${t.name}=?`)}const i=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];2===t.io&&i.push(`@${t.name} as '${t.name}'`)}a+=`${o.join(", ")};`,a+=`select ${["@___return___ as '___return___'"].concat(i).join(", ")};`,this._nested=!0,this._query(a,((e,r,s,n,a)=>{if(this._nested=!1,e)return t(e);let o,i;this.stream?o=r:(o=r.pop(),o&&(o=o[0]));const u=a.pop();if(o&&this.arrayRowMode&&u){let e=null;const t={};for(let r=0;r<u.length;r++)"___return___"===u[r].name?e=r:objectHasProperty(this.parameters,u[r].name)&&(t[u[r].name]=r);null!=e&&(i=o[e]);for(const e in t){if(!objectHasProperty(t,e))continue;const r=this.parameters[e];2===r.io&&(s[r.name]=o[t[e]])}}else if(o&&null!=o.___return___){i=o.___return___;for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];2===t.io&&(s[t.name]=o[t.name])}}this.stream?t(null,null,s,i,n,a):t(null,r,s,i,n,a)}))}))}_pause(){super._pause(),this._currentRequest&&this._currentRequest.pauseQuery()}_resume(){super._resume(),this._currentRequest&&this._currentRequest.resumeQuery()}}module.exports=Request;