"use strict";const tds=require("tedious"),debug=require("debug")("mssql:tedi"),BaseRequest=require("../base/request"),RequestError=require("../error/request-error"),{IDS:IDS,objectHasProperty:objectHasProperty}=require("../utils"),{TYPES:TYPES,DECLARATIONS:DECLARATIONS,declare:declare,cast:cast}=require("../datatypes"),Table=require("../table"),{PARSERS:UDT}=require("../udt"),{valueHandler:valueHandler}=require("../shared"),JSON_COLUMN_ID="JSON_F52E2B61-18A1-11d1-B105-00805F49916B",XML_COLUMN_ID="XML_F52E2B61-18A1-11d1-B105-00805F49916B",N_TYPES={BitN:104,DateTimeN:111,DecimalN:106,FloatN:109,IntN:38,MoneyN:110,NumericN:108},getTediousType=function(e){switch(e){case TYPES.VarChar:return tds.TYPES.VarChar;case TYPES.NVarChar:return tds.TYPES.NVarChar;case TYPES.Text:return tds.TYPES.Text;case TYPES.Int:return tds.TYPES.Int;case TYPES.BigInt:return tds.TYPES.BigInt;case TYPES.TinyInt:return tds.TYPES.TinyInt;case TYPES.SmallInt:return tds.TYPES.SmallInt;case TYPES.Bit:return tds.TYPES.Bit;case TYPES.Float:return tds.TYPES.Float;case TYPES.Decimal:return tds.TYPES.Decimal;case TYPES.Numeric:return tds.TYPES.Numeric;case TYPES.Real:return tds.TYPES.Real;case TYPES.Money:return tds.TYPES.Money;case TYPES.SmallMoney:return tds.TYPES.SmallMoney;case TYPES.Time:return tds.TYPES.Time;case TYPES.Date:return tds.TYPES.Date;case TYPES.DateTime:return tds.TYPES.DateTime;case TYPES.DateTime2:return tds.TYPES.DateTime2;case TYPES.DateTimeOffset:return tds.TYPES.DateTimeOffset;case TYPES.SmallDateTime:return tds.TYPES.SmallDateTime;case TYPES.UniqueIdentifier:return tds.TYPES.UniqueIdentifier;case TYPES.Xml:return tds.TYPES.NVarChar;case TYPES.Char:return tds.TYPES.Char;case TYPES.NChar:return tds.TYPES.NChar;case TYPES.NText:return tds.TYPES.NVarChar;case TYPES.Image:return tds.TYPES.Image;case TYPES.Binary:return tds.TYPES.Binary;case TYPES.VarBinary:return tds.TYPES.VarBinary;case TYPES.UDT:case TYPES.Geography:case TYPES.Geometry:return tds.TYPES.UDT;case TYPES.TVP:return tds.TYPES.TVP;case TYPES.Variant:return tds.TYPES.Variant;default:return e}},getMssqlType=function(e,t){if("object"==typeof e)switch(e){case tds.TYPES.Char:return TYPES.Char;case tds.TYPES.NChar:return TYPES.NChar;case tds.TYPES.VarChar:return TYPES.VarChar;case tds.TYPES.NVarChar:return TYPES.NVarChar;case tds.TYPES.Text:return TYPES.Text;case tds.TYPES.NText:return TYPES.NText;case tds.TYPES.Int:return TYPES.Int;case tds.TYPES.BigInt:return TYPES.BigInt;case tds.TYPES.TinyInt:return TYPES.TinyInt;case tds.TYPES.SmallInt:return TYPES.SmallInt;case tds.TYPES.Bit:return TYPES.Bit;case tds.TYPES.Float:return TYPES.Float;case tds.TYPES.Real:return TYPES.Real;case tds.TYPES.Money:return TYPES.Money;case tds.TYPES.SmallMoney:return TYPES.SmallMoney;case tds.TYPES.Numeric:return TYPES.Numeric;case tds.TYPES.Decimal:return TYPES.Decimal;case tds.TYPES.DateTime:return TYPES.DateTime;case tds.TYPES.Time:return TYPES.Time;case tds.TYPES.Date:return TYPES.Date;case tds.TYPES.DateTime2:return TYPES.DateTime2;case tds.TYPES.DateTimeOffset:return TYPES.DateTimeOffset;case tds.TYPES.SmallDateTime:return TYPES.SmallDateTime;case tds.TYPES.UniqueIdentifier:return TYPES.UniqueIdentifier;case tds.TYPES.Image:return TYPES.Image;case tds.TYPES.Binary:return TYPES.Binary;case tds.TYPES.VarBinary:return TYPES.VarBinary;case tds.TYPES.Xml:return TYPES.Xml;case tds.TYPES.UDT:return TYPES.UDT;case tds.TYPES.TVP:return TYPES.TVP;case tds.TYPES.Variant:return TYPES.Variant;default:switch(e.id){case N_TYPES.BitN:return TYPES.Bit;case N_TYPES.NumericN:return TYPES.Numeric;case N_TYPES.DecimalN:return TYPES.Decimal;case N_TYPES.IntN:return 8===t?TYPES.BigInt:4===t?TYPES.Int:2===t?TYPES.SmallInt:TYPES.TinyInt;case N_TYPES.FloatN:return 8===t?TYPES.Float:TYPES.Real;case N_TYPES.MoneyN:return 8===t?TYPES.Money:TYPES.SmallMoney;case N_TYPES.DateTimeN:return 8===t?TYPES.DateTime:TYPES.SmallDateTime}}},createColumns=function(e,t){let r={};t&&(r=[]);for(let s=0,a=e.length;s<a;s++){const a=e[s],n={index:s,name:a.colName,length:a.dataLength,type:getMssqlType(a.type,a.dataLength),scale:a.scale,precision:a.precision,nullable:!!(1&a.flags),caseSensitive:!!(2&a.flags),identity:!!(16&a.flags),readOnly:!(12&a.flags)};a.udtInfo&&(n.udt={name:a.udtInfo.typeName,database:a.udtInfo.dbname,schema:a.udtInfo.owningSchema,assembly:a.udtInfo.assemblyName},DECLARATIONS[a.udtInfo.typeName]&&(n.type=DECLARATIONS[a.udtInfo.typeName])),t?r.push(n):r[a.colName]=n}return r},valueCorrection=function(e,t){const r=getMssqlType(t.type);return valueHandler.has(r)?valueHandler.get(r)(e):t.type===tds.TYPES.UDT&&null!=e&&UDT[t.udtInfo.typeName]?UDT[t.udtInfo.typeName](e):e},parameterCorrection=function(e){if(e instanceof Table){const t={name:e.name,schema:e.schema,columns:[],rows:e.rows};for(const r of e.columns)t.columns.push({name:r.name,type:getTediousType(r.type),length:r.length,scale:r.scale,precision:r.precision});return t}return e};class Request extends BaseRequest{_batch(e,t){this._isBatch=!0,this._query(e,t)}_bulk(e,t,r){super._bulk(e,t,(s=>{if(s)return r(s);try{e._makeBulk()}catch(e){return r(new RequestError(e,"EREQUEST"))}if(!e.name)return r(new RequestError("Table name must be specified for bulk insert.","ENAME"));if("@"===e.name.charAt(0))return r(new RequestError("You can't use table variables for bulk insert.","ENAME"));const a=[],n={};let i=!1;const o=(e,t,s)=>{let o=new Error(s.message);if(o.info=s,o=new RequestError(o,"EREQUEST"),this.stream)this.emit("error",o);else if(e&&!i){if(t){for(const e in n)t.removeListener(e,n[e]);this.parent.release(t)}i=!0,r(o)}a.push(o)},u=e=>{this.emit("info",{message:e.message,number:e.number,state:e.state,class:e.class,lineNumber:e.lineNumber,serverName:e.serverName,procName:e.procName})};this.parent.acquire(this,((s,c)=>{const l=(e,...t)=>{try{this.parent.release(c)}catch(e){}r(e,...t)};if(s)return l(s);if(debug("connection(%d): borrowed to request #%d",IDS.get(c),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),l(new RequestError("Canceled.","ECANCEL"));this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),c.cancel()},c.on("infoMessage",n.infoMessage=u),c.on("errorMessage",n.errorMessage=o.bind(null,!1,c)),c.on("error",n.error=o.bind(null,!0,c));const m=(e,t)=>{let r;if(e&&(!a.length||a.length&&e.message!==a[a.length-1].message)&&(e=new RequestError(e,"EREQUEST"),this.stream&&this.emit("error",e),a.push(e)),delete this._cancel,a.length&&!this.stream&&(r=a.pop(),r.precedingErrors=a),!i){for(const e in n)c.removeListener(e,n[e]);i=!0,this.stream?l(null,t):l(r,t)}},h=c.newBulkLoad(e.path,t,m);for(const t of e.columns)h.addColumn(t.name,getTediousType(t.type),{nullable:t.nullable,length:t.length,scale:t.scale,precision:t.precision});if(e.create){const t=e.temporary?`tempdb..[${e.name}]`:e.path,r=new tds.Request(`if object_id('${t.replace(/'/g,"''")}') is null ${e.declare()}`,(t=>{if(t)return m(t);c.execBulkLoad(h,e.rows)}));this._setCurrentRequest(r),c.execSqlBatch(r)}else c.execBulkLoad(h,e.rows)}))}))}_query(e,t){super._query(e,(r=>{if(r)return t(r);const s=[],a=[],n=[],i={},o={},u=[];let c={},l=[],m=null,h=!1,d=!1,T=null,E=!1;const S=(e,r,s)=>{let a=new Error(s.message);if(a.info=s,a=new RequestError(a,"EREQUEST"),this.stream)this.emit("error",a);else if(e&&!E){if(r){for(const e in i)r.removeListener(e,i[e]);this.parent.release(r)}E=!0,t(a)}n.push(a)},P=e=>{this.emit("info",{message:e.message,number:e.number,state:e.state,class:e.class,lineNumber:e.lineNumber,serverName:e.serverName,procName:e.procName})};this.parent.acquire(this,((r,p,Y)=>{if(r)return t(r);let g;if(debug("connection(%d): borrowed to request #%d",IDS.get(p),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(p),t(new RequestError("Canceled.","ECANCEL"));this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),p.cancel()},p.on("infoMessage",i.infoMessage=P),p.on("errorMessage",i.errorMessage=S.bind(null,!1,p)),p.on("error",i.error=S.bind(null,!0,p)),debug("request(%d): query",IDS.get(this),e);const f=new tds.Request(e,(e=>{if((e?.errors?e.errors:[e]).forEach(((e,t,{length:r})=>{e&&(!n.length||n.length&&n.length>=r&&e.message!==n[n.length-r+t].message)&&(e=new RequestError(e,"EREQUEST"),this.stream&&this.emit("error",e),n.push(e))})),h){this.stream||(m=s.pop()[0]);for(const e in m){const t=m[e];"___return___"!==e&&(o[e]=t)}}let r;if(delete this._cancel,n.length&&!this.stream&&(r=n.pop(),r.precedingErrors=n),!E){for(const e in i)p.removeListener(e,i[e]);this.parent.release(p),E=!0,r?debug("request(%d): failed",IDS.get(this),r):debug("request(%d): completed",IDS.get(this)),this.stream?t(null,null,o,u,a):t(r,s,o,u,a)}}));this._setCurrentRequest(f),f.on("columnMetadata",(e=>{c=createColumns(e,this.arrayRowMode),d=!1,1!==e.length||e[0].colName!==JSON_COLUMN_ID&&e[0].colName!==XML_COLUMN_ID||(d=!0,T=[]),this.stream&&(this._isBatch&&c.___return___||this.emit("recordset",c)),this.arrayRowMode&&a.push(c)}));const N=(e,t)=>{if(null!=e&&(u.push(e),this.stream&&this.emit("rowsaffected",e)),0!==Object.keys(c).length){if(d){const e=T.join("");if(c[JSON_COLUMN_ID]&&!0===Y.parseJSON)try{g=""===e?null:JSON.parse(e)}catch(e){g=null;const t=new RequestError(new Error(`Failed to parse incoming JSON. ${e.message}`),"EJSON");this.stream&&this.emit("error",t),n.push(t)}else g={},g[Object.keys(c)[0]]=e;T=null,this.stream?this.emit("row",g):l.push(g)}this.stream||(Object.defineProperty(l,"columns",{enumerable:!1,configurable:!0,value:c}),Object.defineProperty(l,"toTable",{enumerable:!1,configurable:!0,value(e){return Table.fromRecordset(this,e)}}),s.push(l)),l=[],c={}}};if(f.on("doneInProc",N),f.on("done",N),f.on("returnValue",((e,t,r)=>{o[e]=t})),f.on("row",(e=>{if(l||(l=[]),d)return T.push(e[0].value);g=this.arrayRowMode?[]:{};for(const t of e)if(t.value=valueCorrection(t.value,t.metadata),this.arrayRowMode)g.push(t.value);else{const e=g[t.metadata.colName];void 0!==e?e instanceof Array?e.push(t.value):g[t.metadata.colName]=[e,t.value]:g[t.metadata.colName]=t.value}this.stream?this._isBatch&&g.___return___?m=g:this.emit("row",g):l.push(g)})),this._isBatch){if(Object.keys(this.parameters).length){for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const r=this.parameters[e];try{r.value=getTediousType(r.type).validate(r.value,this.parent.collation)}catch(r){r.message=`Validation failed for parameter '${e}'. ${r.message}`;const s=new RequestError(r,"EPARAM");return this.parent.release(p),t(s)}}const e=[];for(const t in this.parameters){if(!objectHasProperty(this.parameters,t))continue;const r=this.parameters[t];e.push(`@${t} ${declare(r.type,r)}`)}const r=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];r.push(`@${e} = ${cast(t.value,t.type,t)}`)}const s=[];for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;2===this.parameters[e].io&&s.push(`@${e} as [${e}]`)}h=s.length>0,f.sqlTextOrProcedure=`declare ${e.join(", ")};select ${r.join(", ")};${f.sqlTextOrProcedure};${h?`select 1 as [___return___], ${s.join(", ")}`:""}`}}else for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];1===t.io?f.addParameter(t.name,getTediousType(t.type),parameterCorrection(t.value),{length:t.length,scale:t.scale,precision:t.precision}):f.addOutputParameter(t.name,getTediousType(t.type),parameterCorrection(t.value),{length:t.length,scale:t.scale,precision:t.precision})}try{p[this._isBatch?"execSqlBatch":"execSql"](f)}catch(e){S(!0,p,e)}}))}))}_execute(e,t){super._execute(e,(r=>{if(r)return t(r);const s=[],a=[],n=[],i={},o={},u=[];let c={},l=[],m=0,h=!1,d=null,T=!1;const E=(e,r,s)=>{let a=new Error(s.message);if(a.info=s,a=new RequestError(a,"EREQUEST"),this.stream)this.emit("error",a);else if(e&&!T){if(r){for(const e in i)r.removeListener(e,i[e]);this.parent.release(r)}T=!0,t(a)}n.push(a)},S=e=>{this.emit("info",{message:e.message,number:e.number,state:e.state,class:e.class,lineNumber:e.lineNumber,serverName:e.serverName,procName:e.procName})};this.parent.acquire(this,((r,P,p)=>{if(r)return t(r);let Y;if(debug("connection(%d): borrowed to request #%d",IDS.get(P),IDS.get(this)),this.canceled)return debug("request(%d): canceled",IDS.get(this)),this.parent.release(P),t(new RequestError("Canceled.","ECANCEL"));if(this._cancel=()=>{debug("request(%d): cancel",IDS.get(this)),P.cancel()},P.on("infoMessage",i.infoMessage=S),P.on("errorMessage",i.errorMessage=E.bind(null,!1,P)),P.on("error",i.error=E.bind(null,!0,P)),debug.enabled){const t=Object.keys(this.parameters).map((e=>this.parameters[e])),r=e=>"string"==typeof e&&e.length>50?e.substring(0,47)+"...":e,s=e=>e.name+" [sql."+e.type.name+"]",a={};t.forEach((e=>{a[s(e)]=r(e.value)})),debug("request(%d): execute %s %O",IDS.get(this),e,a)}const g=new tds.Request(e,(e=>{let r;if(e&&(!n.length||n.length&&e.message!==n[n.length-1].message)&&(e=new RequestError(e,"EREQUEST"),this.stream&&this.emit("error",e),n.push(e)),delete this._cancel,n.length&&!this.stream&&(r=n.pop(),r.precedingErrors=n),!T){for(const e in i)P.removeListener(e,i[e]);this.parent.release(P),T=!0,r?debug("request(%d): failed",IDS.get(this),r):debug("request(%d): complete",IDS.get(this)),this.stream?t(null,null,o,m,u,a):t(r,s,o,m,u,a)}}));this._setCurrentRequest(g),g.on("columnMetadata",(e=>{c=createColumns(e,this.arrayRowMode),h=!1,1!==e.length||e[0].colName!==JSON_COLUMN_ID&&e[0].colName!==XML_COLUMN_ID||(h=!0,d=[]),this.stream&&this.emit("recordset",c),this.arrayRowMode&&a.push(c)})),g.on("row",(e=>{if(l||(l=[]),h)return d.push(e[0].value);Y=this.arrayRowMode?[]:{};for(const t of e)if(t.value=valueCorrection(t.value,t.metadata),this.arrayRowMode)Y.push(t.value);else{const e=Y[t.metadata.colName];null!=e?e instanceof Array?e.push(t.value):Y[t.metadata.colName]=[e,t.value]:Y[t.metadata.colName]=t.value}this.stream?this.emit("row",Y):l.push(Y)})),g.on("doneInProc",((e,t)=>{if(null!=e&&(u.push(e),this.stream&&this.emit("rowsaffected",e)),0!==Object.keys(c).length){if(h){if(c[JSON_COLUMN_ID]&&!0===p.parseJSON)try{Y=0===d.length?null:JSON.parse(d.join(""))}catch(e){Y=null;const t=new RequestError(new Error(`Failed to parse incoming JSON. ${e.message}`),"EJSON");this.stream&&this.emit("error",t),n.push(t)}else Y={},Y[Object.keys(c)[0]]=d.join("");d=null,this.stream?this.emit("row",Y):l.push(Y)}this.stream||(Object.defineProperty(l,"columns",{enumerable:!1,configurable:!0,value:c}),Object.defineProperty(l,"toTable",{enumerable:!1,configurable:!0,value(e){return Table.fromRecordset(this,e)}}),s.push(l)),l=[],c={}}})),g.on("doneProc",((e,t,r)=>{m=r})),g.on("returnValue",((e,t,r)=>{o[e]=t}));for(const e in this.parameters){if(!objectHasProperty(this.parameters,e))continue;const t=this.parameters[e];1===t.io?g.addParameter(t.name,getTediousType(t.type),parameterCorrection(t.value),{length:t.length,scale:t.scale,precision:t.precision}):g.addOutputParameter(t.name,getTediousType(t.type),parameterCorrection(t.value),{length:t.length,scale:t.scale,precision:t.precision})}P.callProcedure(g)}))}))}_pause(){super._pause(),this._currentRequest&&this._currentRequest.pause()}_resume(){super._resume(),this._currentRequest&&this._currentRequest.resume()}}module.exports=Request;