"use strict";const Command=require("./command.js"),Packets=require("../packets/index.js"),ClientConstants=require("../constants/client.js"),CharsetToEncoding=require("../constants/charset_encodings.js"),auth41=require("../auth_41.js");function flagNames(s){const t=[];for(const a in ClientConstants)s&ClientConstants[a]&&t.push(a.replace(/_/g," ").toLowerCase());return t}class ClientHandshake extends Command{constructor(s){super(),this.handshake=null,this.clientFlags=s,this.authenticationFactor=0}start(){return ClientHandshake.prototype.handshakeInit}sendSSLRequest(s){const t=new Packets.SSLRequest(this.clientFlags,s.config.charsetNumber);s.writePacket(t.toPacket())}sendCredentials(s){s.config.debug&&console.log("Sending handshake packet: flags:%d=(%s)",this.clientFlags,flagNames(this.clientFlags).join(", ")),this.user=s.config.user,this.password=s.config.password,this.password1=s.config.password,this.password2=s.config.password2,this.password3=s.config.password3,this.passwordSha1=s.config.passwordSha1,this.database=s.config.database,this.autPluginName=this.handshake.autPluginName;const t=new Packets.HandshakeResponse({flags:this.clientFlags,user:this.user,database:this.database,password:this.password,passwordSha1:this.passwordSha1,charsetNumber:s.config.charsetNumber,authPluginData1:this.handshake.authPluginData1,authPluginData2:this.handshake.authPluginData2,compress:s.config.compress,connectAttributes:s.config.connectAttributes});s.writePacket(t.toPacket())}calculateNativePasswordAuthToken(s){const t=s.slice(0,8),a=s.slice(8,20);let e;return e=this.passwordSha1?auth41.calculateTokenFromPasswordSha(this.passwordSha1,t,a):auth41.calculateToken(this.password,t,a),e}handshakeInit(s,t){this.on("error",(s=>{t._fatalError=s,t._protocolError=s})),this.handshake=Packets.Handshake.fromPacket(s),t.config.debug&&console.log("Server hello packet: capability flags:%d=(%s)",this.handshake.capabilityFlags,flagNames(this.handshake.capabilityFlags).join(", ")),t.serverCapabilityFlags=this.handshake.capabilityFlags,t.serverEncoding=CharsetToEncoding[this.handshake.characterSet],t.connectionId=this.handshake.connectionId;const a=this.handshake.capabilityFlags&ClientConstants.SSL,e=this.handshake.capabilityFlags&ClientConstants.MULTI_FACTOR_AUTHENTICATION;if(this.clientFlags=this.clientFlags|e,t.config.compress=t.config.compress&&this.handshake.capabilityFlags&ClientConstants.COMPRESS,this.clientFlags=this.clientFlags|t.config.compress,t.config.ssl){if(!a){const s=new Error("Server does not support secure connection");return s.code="HANDSHAKE_NO_SSL_SUPPORT",s.fatal=!0,this.emit("error",s),!1}this.clientFlags|=ClientConstants.SSL,this.sendSSLRequest(t),t.startTLS((s=>{if(s)return s.code="HANDSHAKE_SSL_ERROR",s.fatal=!0,void this.emit("error",s);this.sendCredentials(t)}))}else this.sendCredentials(t);return e&&(this.authenticationFactor=1),ClientHandshake.prototype.handshakeResult}handshakeResult(s,t){const a=s.peekByte();if(254===a||1===a||2===a){const e=require("./auth_switch");try{return 1===a?e.authSwitchRequestMoreData(s,t,this):(0!==this.authenticationFactor&&(t.config.password=this[`password${this.authenticationFactor}`],this.authenticationFactor+=1),e.authSwitchRequest(s,t,this)),ClientHandshake.prototype.handshakeResult}catch(s){return s.code="AUTH_SWITCH_PLUGIN_ERROR",s.fatal=!0,this.onResult?this.onResult(s):this.emit("error",s),null}}if(0!==a){const s=new Error("Unexpected packet during handshake phase");return s.code="HANDSHAKE_UNKNOWN_ERROR",s.fatal=!0,this.onResult?this.onResult(s):this.emit("error",s),null}if(!t.authorized&&(t.authorized=!0,t.config.compress)){(0,require("../compressed_protocol.js").enableCompression)(t)}return this.onResult&&this.onResult(null),null}}module.exports=ClientHandshake;