"use strict";const process=require("process"),Timers=require("timers"),Readable=require("stream").Readable,Command=require("./command.js"),Packets=require("../packets/index.js"),getTextParser=require("../parsers/text_parser.js"),ServerStatus=require("../constants/server_status.js"),EmptyPacket=new Packets.Packet(0,Buffer.allocUnsafe(4),0,4);class Query extends Command{constructor(e,t){super(),this.sql=e.sql,this.values=e.values,this._queryOptions=e,this.namedPlaceholders=e.namedPlaceholders||!1,this.onResult=t,this.timeout=e.timeout,this.queryTimeout=null,this._fieldCount=0,this._rowParser=null,this._fields=[],this._rows=[],this._receivedFieldsCount=0,this._resultIndex=0,this._localStream=null,this._unpipeStream=function(){},this._streamFactory=e.infileStreamFactory,this._connection=null}then(){const e="You have tried to call .then(), .catch(), or invoked await on the result of query that is not a promise, which is a programming error. Try calling con.promise().query(), or require('mysql2/promise') instead of 'mysql2' for a promise-compatible version of the query interface. To learn how to use async/await or Promises check out documentation at https://sidorares.github.io/node-mysql2/docs#using-promise-wrapper, or the mysql2 documentation at https://sidorares.github.io/node-mysql2/docs/documentation/promise-wrapper";throw console.log(e),new Error(e)}start(e,t){t.config.debug&&console.log("        Sending query command: %s",this.sql),this._connection=t,this.options=Object.assign({},t.config,this._queryOptions),this._setTimeout();const s=new Packets.Query(this.sql,t.config.charsetNumber);return t.writePacket(s.toPacket(1)),Query.prototype.resultsetHeader}done(){if(this._unpipeStream(),this.timeout&&!this.queryTimeout)return null;if(this.queryTimeout&&(Timers.clearTimeout(this.queryTimeout),this.queryTimeout=null),this.onResult){let e,t;0===this._resultIndex?(e=this._rows[0],t=this._fields[0]):(e=this._rows,t=this._fields),t?process.nextTick((()=>{this.onResult(null,e,t)})):process.nextTick((()=>{this.onResult(null,e)}))}return null}doneInsert(e){return this._localStreamError?(this.onResult?this.onResult(this._localStreamError,e):this.emit("error",this._localStreamError),null):(this._rows.push(e),this._fields.push(void 0),this.emit("fields",void 0),this.emit("result",e),e.serverStatus&ServerStatus.SERVER_MORE_RESULTS_EXISTS?(this._resultIndex++,this.resultsetHeader):this.done())}resultsetHeader(e,t){const s=new Packets.ResultSetHeader(e,t);return this._fieldCount=s.fieldCount,t.config.debug&&console.log(`        Resultset header received, expecting ${s.fieldCount} column definition packets`),0===this._fieldCount?this.doneInsert(s):null===this._fieldCount?this._streamLocalInfile(t,s.infileName):(this._receivedFieldsCount=0,this._rows.push([]),this._fields.push([]),this.readField)}_streamLocalInfile(e,t){if(!this._streamFactory)return this._localStreamError=new Error(`As a result of LOCAL INFILE command server wants to read ${t} file, but as of v2.0 you must provide streamFactory option returning ReadStream.`),e.writePacket(EmptyPacket),this.infileOk;this._localStream=this._streamFactory(t);const s=()=>{this._unpipeStream()},r=()=>{this._localStream.resume()},i=()=>{this._localStream.pause()},o=function(t){const s=Buffer.allocUnsafe(t.length+4);t.copy(s,4),e.writePacket(new Packets.Packet(0,s,0,s.length))},n=()=>{e.removeListener("error",s),e.writePacket(EmptyPacket)},l=t=>{this._localStreamError=t,e.removeListener("error",s),e.writePacket(EmptyPacket)};return this._unpipeStream=()=>{e.stream.removeListener("pause",i),e.stream.removeListener("drain",r),this._localStream.removeListener("data",o),this._localStream.removeListener("end",n),this._localStream.removeListener("error",l)},e.stream.on("pause",i),e.stream.on("drain",r),this._localStream.on("data",o),this._localStream.on("end",n),this._localStream.on("error",l),e.once("error",s),this.infileOk}readField(e,t){if(this._receivedFieldsCount++,this._fields[this._resultIndex].length!==this._fieldCount){const s=new Packets.ColumnDefinition(e,t.clientEncoding);this._fields[this._resultIndex].push(s),t.config.debug&&(console.log("        Column definition:"),console.log(`          name: ${s.name}`),console.log(`          type: ${s.columnType}`),console.log(`         flags: ${s.flags}`))}if(this._receivedFieldsCount===this._fieldCount){const e=this._fields[this._resultIndex];return this.emit("fields",e),this._rowParser=new(getTextParser(e,this.options,t.config))(e),Query.prototype.fieldsEOF}return Query.prototype.readField}fieldsEOF(e,t){return e.isEOF()?this.row:t.protocolError("Expected EOF packet")}row(e,t){if(e.isEOF()){return e.eofStatusFlags()&ServerStatus.SERVER_MORE_RESULTS_EXISTS?(this._resultIndex++,Query.prototype.resultsetHeader):this.done()}let s;try{s=this._rowParser.next(e,this._fields[this._resultIndex],this.options)}catch(e){return this._localStreamError=e,this.doneInsert(null)}return this.onResult?this._rows[this._resultIndex].push(s):this.emit("result",s,this._resultIndex),Query.prototype.row}infileOk(e,t){const s=new Packets.ResultSetHeader(e,t);return this.doneInsert(s)}stream(e){(e=e||{}).objectMode=!0;const t=new Readable(e);return t._read=()=>{this._connection&&this._connection.resume()},this.on("result",((e,s)=>{t.push(e)||this._connection.pause(),t.emit("result",e,s)})),this.on("error",(e=>{t.emit("error",e)})),this.on("end",(()=>{t.push(null)})),this.on("fields",(e=>{t.emit("fields",e)})),t.on("end",(()=>{t.emit("close")})),t}_setTimeout(){if(this.timeout){const e=this._handleTimeoutError.bind(this);this.queryTimeout=Timers.setTimeout(e,this.timeout)}}_handleTimeoutError(){this.queryTimeout&&(Timers.clearTimeout(this.queryTimeout),this.queryTimeout=null);const e=new Error("Query inactivity timeout");e.errorno="PROTOCOL_SEQUENCE_TIMEOUT",e.code="PROTOCOL_SEQUENCE_TIMEOUT",e.syscall="query",this.onResult?this.onResult(e):this.emit("error",e)}}Query.prototype.catch=Query.prototype.then,module.exports=Query;