"use strict";const Net=require("net"),Tls=require("tls"),Timers=require("timers"),EventEmitter=require("events").EventEmitter,Readable=require("stream").Readable,Queue=require("denque"),SqlString=require("sqlstring"),LRU=require("lru-cache").default,PacketParser=require("./packet_parser.js"),Packets=require("./packets/index.js"),Commands=require("./commands/index.js"),ConnectionConfig=require("./connection_config.js"),CharsetToEncoding=require("./constants/charset_encodings.js");let _connectionId=0,convertNamedPlaceholders=null;class Connection extends EventEmitter{constructor(e){let t;if(super(),this.config=e.config,e.config.stream?"function"==typeof e.config.stream?this.stream=e.config.stream(e):this.stream=e.config.stream:e.config.socketPath?this.stream=Net.connect(e.config.socketPath):(this.stream=Net.connect(e.config.port,e.config.host),this.config.enableKeepAlive&&this.stream.on("connect",(()=>{this.stream.setKeepAlive(!0,this.config.keepAliveInitialDelay)})),this.stream.setNoDelay(!0)),this._internalId=_connectionId++,this._commands=new Queue,this._command=null,this._paused=!1,this._paused_packets=new Queue,this._statements=new LRU({max:this.config.maxPreparedStatements,dispose:function(e){e.close()}}),this.serverCapabilityFlags=0,this.authorized=!1,this.sequenceId=0,this.compressedSequenceId=0,this.threadId=null,this._handshakePacket=null,this._fatalError=null,this._protocolError=null,this._outOfOrderPackets=[],this.clientEncoding=CharsetToEncoding[this.config.charsetNumber],this.stream.on("error",this._handleNetworkError.bind(this)),this.packetParser=new PacketParser((e=>{this.handlePacket(e)})),this.stream.on("data",(e=>{this.connectTimeout&&(Timers.clearTimeout(this.connectTimeout),this.connectTimeout=null),this.packetParser.execute(e)})),this.stream.on("end",(()=>{this.emit("end")})),this.stream.on("close",(()=>{this._closing||(this._protocolError||(this._protocolError=new Error("Connection lost: The server closed the connection."),this._protocolError.fatal=!0,this._protocolError.code="PROTOCOL_CONNECTION_LOST"),this._notifyError(this._protocolError))})),this.config.isServer||(t=new Commands.ClientHandshake(this.config.clientFlags),t.on("end",(()=>{!t.handshake||this._fatalError||this._protocolError||(this._handshakePacket=t.handshake,this.threadId=t.handshake.connectionId,this.emit("connect",t.handshake))})),t.on("error",(e=>{this._closing=!0,this._notifyError(e)})),this.addCommand(t)),this.serverEncoding="utf8",this.config.connectTimeout){const e=this._handleTimeoutError.bind(this);this.connectTimeout=Timers.setTimeout(e,this.config.connectTimeout)}}promise(e){return new(0,require("../promise").PromiseConnection)(this,e)}_addCommandClosedState(e){const t=new Error("Can't add new command when connection is in closed state");t.fatal=!0,e.onResult?e.onResult(t):this.emit("error",t)}_handleFatalError(e){e.fatal=!0,this.stream.removeAllListeners("data"),this.addCommand=this._addCommandClosedState,this.write=()=>{this.emit("error",new Error("Can't write in closed state"))},this._notifyError(e),this._fatalError=e}_handleNetworkError(e){this.connectTimeout&&(Timers.clearTimeout(this.connectTimeout),this.connectTimeout=null),"ECONNRESET"===e.code&&this._closing||this._handleFatalError(e)}_handleTimeoutError(){this.connectTimeout&&(Timers.clearTimeout(this.connectTimeout),this.connectTimeout=null),this.stream.destroy&&this.stream.destroy();const e=new Error("connect ETIMEDOUT");e.errorno="ETIMEDOUT",e.code="ETIMEDOUT",e.syscall="connect",this._handleNetworkError(e)}_notifyError(e){if(this.connectTimeout&&(Timers.clearTimeout(this.connectTimeout),this.connectTimeout=null),this._fatalError)return;let t,s=!this._command;for(this._command&&this._command.onResult?(this._command.onResult(e),this._command=null):this._command&&this._command.constructor===Commands.ClientHandshake&&this._commands.length>0||(s=!0);t=this._commands.shift();)t.onResult?t.onResult(e):s=!0;(s||this._pool)&&this.emit("error",e),e.fatal&&this.close()}write(e){this.stream.write(e,(e=>{e&&this._handleNetworkError(e)}))||this.stream.emit("pause")}_resetSequenceId(){this.sequenceId=0,this.compressedSequenceId=0}_bumpCompressedSequenceId(e){this.compressedSequenceId+=e,this.compressedSequenceId%=256}_bumpSequenceId(e){this.sequenceId+=e,this.sequenceId%=256}writePacket(e){const t=16777215,s=e.length();let r,n,i;if(s<t)e.writeHeader(this.sequenceId),this.config.debug&&(console.log(`${this._internalId} ${this.connectionId} <== ${this._command._commandName}#${this._command.stateName()}(${[this.sequenceId,e._name,e.length()].join(",")})`),console.log(`${this._internalId} ${this.connectionId} <== ${e.buffer.toString("hex")}`)),this._bumpSequenceId(1),this.write(e.buffer);else for(this.config.debug&&(console.log(`${this._internalId} ${this.connectionId} <== Writing large packet, raw content not written:`),console.log(`${this._internalId} ${this.connectionId} <== ${this._command._commandName}#${this._command.stateName()}(${[this.sequenceId,e._name,e.length()].join(",")})`)),n=4;n<4+s;n+=t)r=e.buffer.slice(n,n+t),i=r.length===t?Buffer.from([255,255,255,this.sequenceId]):Buffer.from([255&r.length,r.length>>8&255,r.length>>16&255,this.sequenceId]),this._bumpSequenceId(1),this.write(i),this.write(r)}startTLS(e){this.config.debug&&console.log("Upgrading connection to TLS");const t=Tls.createSecureContext({ca:this.config.ssl.ca,cert:this.config.ssl.cert,ciphers:this.config.ssl.ciphers,key:this.config.ssl.key,passphrase:this.config.ssl.passphrase,minVersion:this.config.ssl.minVersion,maxVersion:this.config.ssl.maxVersion}),s=this.config.ssl.rejectUnauthorized,r=this.config.ssl.verifyIdentity,n=this.config.host;let i=!1;this.stream.removeAllListeners("data");const o=Tls.connect({rejectUnauthorized:s,requestCert:s,checkServerIdentity:r?Tls.checkServerIdentity:function(){},secureContext:t,isServer:!1,socket:this.stream,servername:n},(()=>{if(i=!0,s&&"string"==typeof n&&r){const t=o.getPeerCertificate(!0),s=Tls.checkServerIdentity(n,t);if(s)return void e(s)}e()}));o.on("error",(t=>{i?this._handleNetworkError(t):e(t)})),o.on("data",(e=>{this.packetParser.execute(e)})),this.write=e=>o.write(e)}protocolError(e,t){if(this._closing)return;const s=new Error(e);s.fatal=!0,s.code=t||"PROTOCOL_ERROR",this.emit("error",s)}get fatalError(){return this._fatalError}handlePacket(e){if(this._paused)this._paused_packets.push(e);else{if(this.config.debug&&e){console.log(` raw: ${e.buffer.slice(e.offset,e.offset+e.length()).toString("hex")}`),console.trace();const t=this._command?this._command._commandName:"(no command)",s=this._command?this._command.stateName():"(no command)";console.log(`${this._internalId} ${this.connectionId} ==> ${t}#${s}(${[e.sequenceId,e.type(),e.length()].join(",")})`)}if(this._command){if(e){if(this.sequenceId!==e.sequenceId){const t=new Error(`Warning: got packets out of order. Expected ${this.sequenceId} but received ${e.sequenceId}`);t.expected=this.sequenceId,t.received=e.sequenceId,this.emit("warn",t),console.error(t.message)}this._bumpSequenceId(e.numPackets)}try{if(this._fatalError)return;this._command.execute(e,this)&&(this._command=this._commands.shift(),this._command&&(this.sequenceId=0,this.compressedSequenceId=0,this.handlePacket()))}catch(e){this._handleFatalError(e),this.stream.destroy()}}else{if(255===e.peekByte()){const t=Packets.Error.fromPacket(e);this.protocolError(t.message,t.code)}else this.protocolError("Unexpected packet while no commands in the queue","PROTOCOL_UNEXPECTED_PACKET");this.close()}}}addCommand(e){if(this.config.debug){const t=e.constructor.name;console.log(`Add command: ${t}`),e._commandName=t}return this._command?this._commands.push(e):(this._command=e,this.handlePacket()),e}format(e,t){if("function"==typeof this.config.queryFormat)return this.config.queryFormat.call(this,e,t,this.config.timezone);const s={sql:e,values:t};return this._resolveNamedPlaceholders(s),SqlString.format(s.sql,s.values,this.config.stringifyObjects,this.config.timezone)}escape(e){return SqlString.escape(e,!1,this.config.timezone)}escapeId(e){return SqlString.escapeId(e,!1)}raw(e){return SqlString.raw(e)}_resolveNamedPlaceholders(e){let t;if(this.config.namedPlaceholders||e.namedPlaceholders){if(Array.isArray(e.values))return;null===convertNamedPlaceholders&&(convertNamedPlaceholders=require("named-placeholders")()),t=convertNamedPlaceholders(e.sql,e.values),e.sql=t[0],e.values=t[1]}}query(e,t,s){let r;r=e.constructor===Commands.Query?e:Connection.createQuery(e,t,s,this.config),this._resolveNamedPlaceholders(r);const n=this.format(r.sql,void 0!==r.values?r.values:[]);return r.sql=n,this.addCommand(r)}pause(){this._paused=!0,this.stream.pause()}resume(){let e;for(this._paused=!1;e=this._paused_packets.shift();)if(this.handlePacket(e),this._paused)return;this.stream.resume()}prepare(e,t){return"string"==typeof e&&(e={sql:e}),this.addCommand(new Commands.Prepare(e,t))}unprepare(e){let t={};"object"==typeof e?t=e:t.sql=e;const s=Connection.statementKey(t),r=this._statements.get(s);return r&&(this._statements.delete(s),r.close()),r}execute(e,t,s){let r={infileStreamFactory:this.config.infileStreamFactory};if("object"==typeof e?(r={...r,...e,sql:e.sql,values:e.values},"function"==typeof t?s=t:r.values=r.values||t):"function"==typeof t?(s=t,r.sql=e,r.values=void 0):(r.sql=e,r.values=t),this._resolveNamedPlaceholders(r),r.values){if(!Array.isArray(r.values))throw new TypeError("Bind parameters must be array if namedPlaceholders parameter is not enabled");r.values.forEach((e=>{if(!Array.isArray(r.values))throw new TypeError("Bind parameters must be array if namedPlaceholders parameter is not enabled");if(void 0===e)throw new TypeError("Bind parameters must not contain undefined. To pass SQL NULL specify JS null");if("function"==typeof e)throw new TypeError("Bind parameters must not contain function(s). To pass the body of a function as a string call .toString() first")}))}const n=new Commands.Execute(r,s),i=new Commands.Prepare(r,((e,t)=>{if(e)return n.start=function(){return null},s?s(e):n.emit("error",e),void n.emit("end");n.statement=t}));return this.addCommand(i),this.addCommand(n),n}changeUser(e,t){t||"function"!=typeof e||(t=e,e={});const s=e.charset?ConnectionConfig.getCharsetNumber(e.charset):this.config.charsetNumber;return this.addCommand(new Commands.ChangeUser({user:e.user||this.config.user,password:e.password||e.password1||this.config.password||this.config.password1,password2:e.password2||this.config.password2,password3:e.password3||this.config.password3,passwordSha1:e.passwordSha1||this.config.passwordSha1,database:e.database||this.config.database,timeout:e.timeout,charsetNumber:s,currentConfig:this.config},(e=>{e&&(e.fatal=!0),t&&t(e)})))}beginTransaction(e){return this.query("START TRANSACTION",e)}commit(e){return this.query("COMMIT",e)}rollback(e){return this.query("ROLLBACK",e)}ping(e){return this.addCommand(new Commands.Ping(e))}_registerSlave(e,t){return this.addCommand(new Commands.RegisterSlave(e,t))}_binlogDump(e,t){return this.addCommand(new Commands.BinlogDump(e,t))}destroy(){this.close()}close(){this.connectTimeout&&(Timers.clearTimeout(this.connectTimeout),this.connectTimeout=null),this._closing=!0,this.stream.end(),this.addCommand=this._addCommandClosedState}createBinlogStream(e){let t=1;const s=new Readable({objectMode:!0});return s._read=function(){return{data:t++}},this._registerSlave(e,(()=>{const t=this._binlogDump(e);t.on("event",(e=>{s.push(e)})),t.on("eof",(()=>{s.push(null),e.flags&&1&e.flags&&this.close()}))})),s}connect(e){if(!e)return;if(this._fatalError||this._protocolError)return e(this._fatalError||this._protocolError);if(this._handshakePacket)return e(null,this);let t=0;function s(s){return function(r){t||(s?e(r):e(null,r)),t=1}}this.once("error",s(!0)),this.once("connect",s(!1))}writeColumns(e){this.writePacket(Packets.ResultSetHeader.toPacket(e.length)),e.forEach((e=>{this.writePacket(Packets.ColumnDefinition.toPacket(e,this.serverConfig.encoding))})),this.writeEof()}writeTextRow(e){this.writePacket(Packets.TextRow.toPacket(e,this.serverConfig.encoding))}writeBinaryRow(e){this.writePacket(Packets.BinaryRow.toPacket(e,this.serverConfig.encoding))}writeTextResult(e,t,s=!1){this.writeColumns(t),e.forEach((e=>{const r=new Array(t.length);t.forEach((t=>{r.push(e[t.name])})),s?this.writeBinaryRow(r):this.writeTextRow(r)})),this.writeEof()}writeEof(e,t){this.writePacket(Packets.EOF.toPacket(e,t))}writeOk(e){e||(e={affectedRows:0}),this.writePacket(Packets.OK.toPacket(e,this.serverConfig.encoding))}writeError(e){const t=this.serverConfig?this.serverConfig.encoding:"cesu8";this.writePacket(Packets.Error.toPacket(e,t))}serverHandshake(e){return this.serverConfig=e,this.serverConfig.encoding=CharsetToEncoding[this.serverConfig.characterSet],this.addCommand(new Commands.ServerHandshake(e))}end(e){if(this.config.isServer){this._closing=!0;const e=new EventEmitter;return setImmediate((()=>{this.stream.end(),e.emit("end")})),e}const t=this.addCommand(new Commands.Quit(e));return this.addCommand=this._addCommandClosedState,t}static createQuery(e,t,s,r){let n={rowsAsArray:r.rowsAsArray,infileStreamFactory:r.infileStreamFactory};return"object"==typeof e?(n={...n,...e,sql:e.sql,values:e.values},"function"==typeof t?s=t:void 0!==t&&(n.values=t)):"function"==typeof t?(s=t,n.sql=e,n.values=void 0):(n.sql=e,n.values=t),new Commands.Query(n,s)}static statementKey(e){return`${typeof e.nestTables}/${e.nestTables}/${e.rowsAsArray}${e.sql}`}}module.exports=Connection;