"use strict";const{URL:URL}=require("url"),ClientConstants=require("./constants/client"),Charsets=require("./constants/charsets"),{version:version}=require("../package.json");let SSLProfiles=null;const validOptions={authPlugins:1,authSwitchHandler:1,bigNumberStrings:1,charset:1,charsetNumber:1,compress:1,connectAttributes:1,connectTimeout:1,database:1,dateStrings:1,debug:1,decimalNumbers:1,enableKeepAlive:1,flags:1,host:1,insecureAuth:1,infileStreamFactory:1,isServer:1,keepAliveInitialDelay:1,localAddress:1,maxPreparedStatements:1,multipleStatements:1,namedPlaceholders:1,nestTables:1,password:1,password1:1,password2:1,password3:1,passwordSha1:1,pool:1,port:1,queryFormat:1,rowsAsArray:1,socketPath:1,ssl:1,stream:1,stringifyObjects:1,supportBigNumbers:1,timezone:1,trace:1,typeCast:1,uri:1,user:1,connectionLimit:1,maxIdle:1,idleTimeout:1,Promise:1,queueLimit:1,waitForConnections:1,jsonStrings:1};class ConnectionConfig{constructor(e){if("string"==typeof e)e=ConnectionConfig.parseUrl(e);else if(e&&e.uri){const t=ConnectionConfig.parseUrl(e.uri);for(const s in t)Object.prototype.hasOwnProperty.call(t,s)&&(e[s]||(e[s]=t[s]))}for(const t in e)Object.prototype.hasOwnProperty.call(e,t)&&1!==validOptions[t]&&console.error(`Ignoring invalid configuration option passed to Connection: ${t}. This is currently a warning, but in future versions of MySQL2, an error will be thrown if you pass an invalid configuration option to a Connection`);if(this.isServer=e.isServer,this.stream=e.stream,this.host=e.host||"localhost",this.port=("string"==typeof e.port?parseInt(e.port,10):e.port)||3306,this.localAddress=e.localAddress,this.socketPath=e.socketPath,this.user=e.user||void 0,this.password=e.password||e.password1||void 0,this.password2=e.password2||void 0,this.password3=e.password3||void 0,this.passwordSha1=e.passwordSha1||void 0,this.database=e.database,this.connectTimeout=isNaN(e.connectTimeout)?1e4:e.connectTimeout,this.insecureAuth=e.insecureAuth||!1,this.infileStreamFactory=e.infileStreamFactory||void 0,this.supportBigNumbers=e.supportBigNumbers||!1,this.bigNumberStrings=e.bigNumberStrings||!1,this.decimalNumbers=e.decimalNumbers||!1,this.dateStrings=e.dateStrings||!1,this.debug=e.debug,this.trace=!1!==e.trace,this.stringifyObjects=e.stringifyObjects||!1,this.enableKeepAlive=!1!==e.enableKeepAlive,this.keepAliveInitialDelay=e.keepAliveInitialDelay,e.timezone&&!/^(?:local|Z|[ +-]\d\d:\d\d)$/.test(e.timezone)?(console.error(`Ignoring invalid timezone passed to Connection: ${e.timezone}. This is currently a warning, but in future versions of MySQL2, an error will be thrown if you pass an invalid configuration option to a Connection`),this.timezone="Z"):this.timezone=e.timezone||"local",this.queryFormat=e.queryFormat,this.pool=e.pool||void 0,this.ssl="string"==typeof e.ssl?ConnectionConfig.getSSLProfile(e.ssl):e.ssl||!1,this.multipleStatements=e.multipleStatements||!1,this.rowsAsArray=e.rowsAsArray||!1,this.namedPlaceholders=e.namedPlaceholders||!1,this.nestTables=void 0===e.nestTables?void 0:e.nestTables,this.typeCast=void 0===e.typeCast||e.typeCast," "===this.timezone[0]&&(this.timezone=`+${this.timezone.slice(1)}`),this.ssl){if("object"!=typeof this.ssl)throw new TypeError("SSL profile must be an object, instead it's a "+typeof this.ssl);this.ssl.rejectUnauthorized=!1!==this.ssl.rejectUnauthorized}this.maxPacketSize=0,this.charsetNumber=e.charset?ConnectionConfig.getCharsetNumber(e.charset):e.charsetNumber||Charsets.UTF8MB4_UNICODE_CI,this.compress=e.compress||!1,this.authPlugins=e.authPlugins,this.authSwitchHandler=e.authSwitchHandler,this.clientFlags=ConnectionConfig.mergeFlags(ConnectionConfig.getDefaultFlags(e),e.flags||"");const t={_client_name:"Node-MySQL-2",_client_version:version};this.connectAttributes={...t,...e.connectAttributes||{}},this.maxPreparedStatements=e.maxPreparedStatements||16e3,this.jsonStrings=e.jsonStrings||!1}static mergeFlags(e,t){let s,i=0;for(s in Array.isArray(t)||(t=String(t||"").toUpperCase().split(/\s*,+\s*/)),e)t.indexOf(`-${e[s]}`)>=0||(i|=ClientConstants[e[s]]||0);for(s in t)"-"!==t[s][0]&&(e.indexOf(t[s])>=0||(i|=ClientConstants[t[s]]||0));return i}static getDefaultFlags(e){const t=["LONG_PASSWORD","FOUND_ROWS","LONG_FLAG","CONNECT_WITH_DB","ODBC","LOCAL_FILES","IGNORE_SPACE","PROTOCOL_41","IGNORE_SIGPIPE","TRANSACTIONS","RESERVED","SECURE_CONNECTION","MULTI_RESULTS","TRANSACTIONS","SESSION_TRACK","CONNECT_ATTRS"];return e&&e.multipleStatements&&t.push("MULTI_STATEMENTS"),t.push("PLUGIN_AUTH"),t.push("PLUGIN_AUTH_LENENC_CLIENT_DATA"),t}static getCharsetNumber(e){const t=Charsets[e.toUpperCase()];if(void 0===t)throw new TypeError(`Unknown charset '${e}'`);return t}static getSSLProfile(e){SSLProfiles||(SSLProfiles=require("./constants/ssl_profiles.js"));const t=SSLProfiles[e];if(void 0===t)throw new TypeError(`Unknown SSL profile '${e}'`);return t}static parseUrl(e){const t=new URL(e),s={host:decodeURIComponent(t.hostname),port:parseInt(t.port,10),database:decodeURIComponent(t.pathname.slice(1)),user:decodeURIComponent(t.username),password:decodeURIComponent(t.password)};return t.searchParams.forEach(((e,t)=>{try{s[t]=JSON.parse(e)}catch(i){s[t]=e}})),s}}module.exports=ConnectionConfig;