"use strict";const Packet=require("../packets/packet"),StringParser=require("../parsers/string"),CharsetToEncoding=require("../constants/charset_encodings.js"),fields=["catalog","schema","table","orgTable","name","orgName"];class ColumnDefinition{constructor(t,e){this._buf=t.buffer,this._clientEncoding=e,this._catalogLength=t.readLengthCodedNumber(),this._catalogStart=t.offset,t.offset+=this._catalogLength,this._schemaLength=t.readLengthCodedNumber(),this._schemaStart=t.offset,t.offset+=this._schemaLength,this._tableLength=t.readLengthCodedNumber(),this._tableStart=t.offset,t.offset+=this._tableLength,this._orgTableLength=t.readLengthCodedNumber(),this._orgTableStart=t.offset,t.offset+=this._orgTableLength;const n=t.readLengthCodedNumber(),s=t.offset;t.offset+=n,this._orgNameLength=t.readLengthCodedNumber(),this._orgNameStart=t.offset,t.offset+=this._orgNameLength,t.skip(1),this.characterSet=t.readInt16(),this.encoding=CharsetToEncoding[this.characterSet],this.name=StringParser.decode(this._buf,"binary"===this.encoding?this._clientEncoding:this.encoding,s,s+n),this.columnLength=t.readInt32(),this.columnType=t.readInt8(),this.type=this.columnType,this.flags=t.readInt16(),this.decimals=t.readInt8()}inspect(){return{catalog:this.catalog,schema:this.schema,name:this.name,orgName:this.orgName,table:this.table,orgTable:this.orgTable,characterSet:this.characterSet,encoding:this.encoding,columnLength:this.columnLength,type:this.columnType,flags:this.flags,decimals:this.decimals}}[Symbol.for("nodejs.util.inspect.custom")](t,e,n){const s=require("../constants/types.js"),i=[];for(const t in s)i[s[t]]=t;const h=require("../constants/field_flags.js"),o=[],c=this.flags;for(const t in h)c&h[t]&&("PRI_KEY"===t?o.push("PRIMARY KEY"):"NOT_NULL"===t?o.push("NOT NULL"):"BINARY"===t||"MULTIPLE_KEY"===t||"NO_DEFAULT_VALUE"===t||"BLOB"===t||"UNSIGNED"===t||"TIMESTAMP"===t||("ON_UPDATE_NOW"===t?o.push("ON UPDATE CURRENT_TIMESTAMP"):o.push(t)));if(t>1)return n({...this.inspect(),typeName:i[this.columnType],flags:o});const a=this.flags&h.UNSIGNED;let r=i[this.columnType];return r="BLOB"===r?4294967295===this.columnLength?"LONGTEXT":67108860===this.columnLength?"MEDIUMTEXT":262140===this.columnLength?"TEXT":1020===this.columnLength?"TINYTEXT":`BLOB(${this.columnLength})`:"VAR_STRING"===r?`VARCHAR(${Math.ceil(this.columnLength/4)})`:"TINY"===r?3===this.columnLength&&a||4===this.columnLength&&!a?"TINYINT":`TINYINT(${this.columnLength})`:"LONGLONG"===r?20===this.columnLength?"BIGINT":`BIGINT(${this.columnLength})`:"SHORT"===r?a&&5===this.columnLength?"SMALLINT":a||6!==this.columnLength?`SMALLINT(${this.columnLength})`:"SMALLINT":"LONG"===r?a&&10===this.columnLength?"INT":a||11!==this.columnLength?`INT(${this.columnLength})`:"INT":"INT24"===r?a&&8===this.columnLength?"MEDIUMINT":a||9!==this.columnLength?`MEDIUMINT(${this.columnLength})`:"MEDIUMINT":"DOUBLE"===r?22===this.columnLength&&31===this.decimals?"DOUBLE":`DOUBLE(${this.columnLength},${this.decimals})`:"FLOAT"===r?12===this.columnLength&&31===this.decimals?"FLOAT":`FLOAT(${this.columnLength},${this.decimals})`:"NEWDECIMAL"===r?11===this.columnLength&&0===this.decimals?"DECIMAL":0===this.decimals?a?`DECIMAL(${this.columnLength})`:`DECIMAL(${this.columnLength-1})`:`DECIMAL(${this.columnLength-2},${this.decimals})`:`${i[this.columnType]}(${this.columnLength})`,a&&(r+=" UNSIGNED"),`\`${this.name}\` ${[r,...o].join(" ")}`}static toPacket(t,e){let n=17;fields.forEach((e=>{n+=Packet.lengthCodedStringLength(t[e],CharsetToEncoding[t.characterSet])}));const s=Buffer.allocUnsafe(n),i=new Packet(e,s,0,n);return i.offset=4,fields.forEach((function(e){i.writeLengthCodedString(t[e],CharsetToEncoding[t.characterSet])})),i.writeInt8(12),i.writeInt16(t.characterSet),i.writeInt32(t.columnLength),i.writeInt8(t.columnType),i.writeInt16(t.flags),i.writeInt8(t.decimals),i.writeInt16(0),i}get db(){return this.schema}}const addString=function(t){Object.defineProperty(ColumnDefinition.prototype,t,{get:function(){const e=this[`_${t}Start`],n=e+this[`_${t}Length`],s=StringParser.decode(this._buf,"binary"===this.encoding?this._clientEncoding:this.encoding,e,n);return Object.defineProperty(this,t,{value:s,writable:!1,configurable:!1,enumerable:!1}),s}})};addString("catalog"),addString("schema"),addString("table"),addString("orgTable"),addString("orgName"),module.exports=ColumnDefinition;