"use strict";const ErrorCodeToName=require("../constants/errors.js"),NativeBuffer=require("buffer").Buffer,Long=require("long"),StringParser=require("../parsers/string.js"),INVALID_DATE=new Date(NaN),pad="000000000000";function leftPad(t,e){const r=e.toString();return r.length>=t?r:(pad+r).slice(-t)}const minus="-".charCodeAt(0),plus="+".charCodeAt(0),dot=".".charCodeAt(0),exponent="e".charCodeAt(0),exponentCapital="E".charCodeAt(0);class Packet{constructor(t,e,r,s){this.sequenceId=t,this.numPackets=1,this.buffer=e,this.start=r,this.offset=r+4,this.end=s}reset(){this.offset=this.start+4}length(){return this.end-this.start}slice(){return this.buffer.slice(this.start,this.end)}dump(){console.log([this.buffer.asciiSlice(this.start,this.end)],this.buffer.slice(this.start,this.end),this.length(),this.sequenceId)}haveMoreData(){return this.end>this.offset}skip(t){this.offset+=t}readInt8(){return this.buffer[this.offset++]}readInt16(){return this.offset+=2,this.buffer.readUInt16LE(this.offset-2)}readInt24(){return this.readInt16()+(this.readInt8()<<16)}readInt32(){return this.offset+=4,this.buffer.readUInt32LE(this.offset-4)}readSInt8(){return this.buffer.readInt8(this.offset++)}readSInt16(){return this.offset+=2,this.buffer.readInt16LE(this.offset-2)}readSInt32(){return this.offset+=4,this.buffer.readInt32LE(this.offset-4)}readInt64JSNumber(){const t=this.readInt32(),e=this.readInt32();return new Long(t,e,!0).toNumber()}readSInt64JSNumber(){const t=this.readInt32(),e=this.readInt32();if(!(2147483648&e))return t+4294967296*e;return new Long(t,e,!1).toNumber()}readInt64String(){const t=this.readInt32(),e=this.readInt32();return new Long(t,e,!0).toString()}readSInt64String(){const t=this.readInt32(),e=this.readInt32();return new Long(t,e,!1).toString()}readInt64(){const t=this.readInt32(),e=this.readInt32();let r=new Long(t,e,!0);const s=r.toNumber(),i=r.toString();return r=s.toString()===i?s:i,r}readSInt64(){const t=this.readInt32(),e=this.readInt32();let r=new Long(t,e,!1);const s=r.toNumber(),i=r.toString();return r=s.toString()===i?s:i,r}isEOF(){return 254===this.buffer[this.offset]&&this.length()<13}eofStatusFlags(){return this.buffer.readInt16LE(this.offset+3)}eofWarningCount(){return this.buffer.readInt16LE(this.offset+1)}readLengthCodedNumber(t,e){const r=this.buffer[this.offset++];return r<251?r:this.readLengthCodedNumberExt(r,t,e)}readLengthCodedNumberSigned(t){return this.readLengthCodedNumber(t,!0)}readLengthCodedNumberExt(t,e,r){let s,i,n;if(251===t)return null;if(252===t)return this.readInt8()+(this.readInt8()<<8);if(253===t)return this.readInt8()+(this.readInt8()<<8)+(this.readInt8()<<16);if(254===t){if(s=this.readInt32(),i=this.readInt32(),0===i)return s;if(i<2097152)return 4294967296*i+s;n=new Long(s,i,!r);const t=n.toNumber(),f=n.toString();return n=t.toString()===f?t:f,e?f:n}throw console.trace(),new Error(`Should not reach here: ${t}`)}readFloat(){const t=this.buffer.readFloatLE(this.offset);return this.offset+=4,t}readDouble(){const t=this.buffer.readDoubleLE(this.offset);return this.offset+=8,t}readBuffer(t){return void 0===t&&(t=this.end-this.offset),this.offset+=t,this.buffer.slice(this.offset-t,this.offset)}readDateTime(t){if(!t||"Z"===t||"local"===t){const e=this.readInt8();if(251===e)return null;let r=0,s=0,i=0,n=0,f=0,h=0,o=0;return e>3&&(r=this.readInt16(),s=this.readInt8(),i=this.readInt8()),e>6&&(n=this.readInt8(),f=this.readInt8(),h=this.readInt8()),e>10&&(o=this.readInt32()/1e3),r+s+i+n+f+h+o===0?INVALID_DATE:"Z"===t?new Date(Date.UTC(r,s-1,i,n,f,h,o)):new Date(r,s-1,i,n,f,h,o)}let e=this.readDateTimeString(6,"T");return 10===e.length&&(e+="T00:00:00"),new Date(e+t)}readDateTimeString(t,e){const r=this.readInt8();let s,i=0,n=0,f=0,h=0,o=0,a=0,u=0;return r>3&&(i=this.readInt16(),n=this.readInt8(),f=this.readInt8(),s=[leftPad(4,i),leftPad(2,n),leftPad(2,f)].join("-")),r>6&&(h=this.readInt8(),o=this.readInt8(),a=this.readInt8(),s+=`${e||" "}${[leftPad(2,h),leftPad(2,o),leftPad(2,a)].join(":")}`),r>10&&(u=this.readInt32(),s+=".",t&&(u=leftPad(6,u),u.length>t&&(u=u.substring(0,t))),s+=u),s}readTimeString(t){const e=this.readInt8();if(0===e)return"00:00:00";const r=this.readInt8()?-1:1;let s=0,i=0,n=0,f=0,h=0;return e>6&&(s=this.readInt32(),i=this.readInt8(),n=this.readInt8(),f=this.readInt8()),e>10&&(h=this.readInt32()),t?(i+=24*s,n+=60*i,f+=60*n,h+=1e3*f,h*=r,h):(-1===r?"-":"")+[leftPad(2,24*s+i),leftPad(2,n),leftPad(2,f)].join(":")+(h?`.${h}`.replace(/0+$/,""):"")}readLengthCodedString(t){const e=this.readLengthCodedNumber();return null===e?null:(this.offset+=e,StringParser.decode(this.buffer,t,this.offset-e,this.offset))}readLengthCodedBuffer(){const t=this.readLengthCodedNumber();return null===t?null:this.readBuffer(t)}readNullTerminatedString(t){const e=this.offset;let r=this.offset;for(;this.buffer[r];)r+=1;return this.offset=r+1,StringParser.decode(this.buffer,t,e,r)}readString(t,e){return"string"==typeof t&&void 0===e&&(e=t,t=void 0),void 0===t&&(t=this.end-this.offset),this.offset+=t,StringParser.decode(this.buffer,e,this.offset-t,this.offset)}parseInt(t,e){if(null===t)return null;if(t>=14&&!e){const e=this.buffer.toString("ascii",this.offset,this.offset+t);return this.offset+=t,Number(e)}let r=0;const s=this.offset,i=this.offset+t;let n,f=1;if(0===t)return 0;this.buffer[this.offset]===minus&&(this.offset++,f=-1);const h=i-this.offset;if(e){if(h>=15)return n=this.readString(i-this.offset,"binary"),r=parseInt(n,10),r.toString()===n?f*r:-1===f?`-${n}`:n;if(h>16)return n=this.readString(i-this.offset),-1===f?`-${n}`:n}for(this.buffer[this.offset]===plus&&this.offset++;this.offset<i;)r*=10,r+=this.buffer[this.offset]-48,this.offset++;const o=r*f;return e?(n=this.buffer.toString("ascii",s,i),o.toString()===n?o:n):o}parseIntNoBigCheck(t){if(null===t)return null;let e=0;const r=this.offset+t;let s=1;if(0===t)return 0;for(this.buffer[this.offset]===minus&&(this.offset++,s=-1),this.buffer[this.offset]===plus&&this.offset++;this.offset<r;)e*=10,e+=this.buffer[this.offset]-48,this.offset++;return e*s}parseGeometryValue(){const t=this.readLengthCodedBuffer();let e=4;if(null===t||!t.length)return null;return function r(){let s,i,n,f,h,o,a=null;const u=t.readUInt8(e);e+=1;const d=u?t.readUInt32LE(e):t.readUInt32BE(e);switch(e+=4,d){case 1:s=u?t.readDoubleLE(e):t.readDoubleBE(e),e+=8,i=u?t.readDoubleLE(e):t.readDoubleBE(e),e+=8,a={x:s,y:i};break;case 2:for(h=u?t.readUInt32LE(e):t.readUInt32BE(e),e+=4,a=[],n=h;n>0;n--)s=u?t.readDoubleLE(e):t.readDoubleBE(e),e+=8,i=u?t.readDoubleLE(e):t.readDoubleBE(e),e+=8,a.push({x:s,y:i});break;case 3:const d=u?t.readUInt32LE(e):t.readUInt32BE(e);for(e+=4,a=[],n=d;n>0;n--){for(h=u?t.readUInt32LE(e):t.readUInt32BE(e),e+=4,o=[],f=h;f>0;f--)s=u?t.readDoubleLE(e):t.readDoubleBE(e),e+=8,i=u?t.readDoubleLE(e):t.readDoubleBE(e),e+=8,o.push({x:s,y:i});a.push(o)}break;case 4:case 5:case 6:case 7:const l=u?t.readUInt32LE(e):t.readUInt32BE(e);for(e+=4,a=[],n=l;n>0;n--)a.push(r())}return a}()}parseDate(t){const e=this.readLengthCodedNumber();if(null===e)return null;if(10!==e)return new Date(NaN);const r=this.parseInt(4);this.offset++;const s=this.parseInt(2);this.offset++;const i=this.parseInt(2);return t&&"local"!==t?"Z"===t?new Date(Date.UTC(r,s-1,i)):new Date(`${leftPad(4,r)}-${leftPad(2,s)}-${leftPad(2,i)}T00:00:00${t}`):new Date(r,s-1,i)}parseDateTime(t){const e=this.readLengthCodedString("binary");return null===e?null:t&&"local"!==t?new Date(`${e}${t}`):new Date(e)}parseFloat(t){if(null===t)return null;let e=0;const r=this.offset+t;let s=1,i=!1,n=0;if(0===t)return 0;for(this.buffer[this.offset]===minus&&(this.offset++,s=-1),this.buffer[this.offset]===plus&&this.offset++;this.offset<r;)if(n=this.buffer[this.offset],n===dot)i=!0,this.offset++;else{if(n===exponent||n===exponentCapital){this.offset++;const t=this.parseInt(r-this.offset);return e/s*Math.pow(10,t)}e*=10,e+=this.buffer[this.offset]-48,this.offset++,i&&(s*=10)}return e/s}parseLengthCodedIntNoBigCheck(){return this.parseIntNoBigCheck(this.readLengthCodedNumber())}parseLengthCodedInt(t){return this.parseInt(this.readLengthCodedNumber(),t)}parseLengthCodedIntString(){return this.readLengthCodedString("binary")}parseLengthCodedFloat(){return this.parseFloat(this.readLengthCodedNumber())}peekByte(){return this.buffer[this.offset]}isAlt(){return 254===this.peekByte()}isError(){return 255===this.peekByte()}asError(t){this.reset(),this.readInt8();const e=this.readInt16();let r="";35===this.buffer[this.offset]&&(this.skip(1),r=this.readBuffer(5).toString());const s=this.readString(void 0,t),i=new Error(s);return i.code=ErrorCodeToName[e],i.errno=e,i.sqlState=r,i.sqlMessage=s,i}writeInt32(t){this.buffer.writeUInt32LE(t,this.offset),this.offset+=4}writeInt24(t){this.writeInt8(255&t),this.writeInt16(t>>8)}writeInt16(t){this.buffer.writeUInt16LE(t,this.offset),this.offset+=2}writeInt8(t){this.buffer.writeUInt8(t,this.offset),this.offset++}writeDouble(t){this.buffer.writeDoubleLE(t,this.offset),this.offset+=8}writeBuffer(t){t.copy(this.buffer,this.offset),this.offset+=t.length}writeNull(){this.buffer[this.offset]=251,this.offset++}writeNullTerminatedString(t,e){const r=StringParser.encode(t,e);this.buffer.length&&r.copy(this.buffer,this.offset),this.offset+=r.length,this.writeInt8(0)}writeString(t,e){if(null===t)return void this.writeInt8(251);if(0===t.length)return;const r=StringParser.encode(t,e);this.buffer.length&&r.copy(this.buffer,this.offset),this.offset+=r.length}writeLengthCodedString(t,e){const r=StringParser.encode(t,e);this.writeLengthCodedNumber(r.length),this.buffer.length&&r.copy(this.buffer,this.offset),this.offset+=r.length}writeLengthCodedBuffer(t){this.writeLengthCodedNumber(t.length),t.copy(this.buffer,this.offset),this.offset+=t.length}writeLengthCodedNumber(t){return t<251?this.writeInt8(t):t<65535?(this.writeInt8(252),this.writeInt16(t)):t<16777215?(this.writeInt8(253),this.writeInt24(t)):null===t?this.writeInt8(251):(this.writeInt8(254),this.buffer.writeUInt32LE(t,this.offset),this.offset+=4,this.buffer.writeUInt32LE(t>>32,this.offset),this.offset+=4,this.offset)}writeDate(t,e){if(this.buffer.writeUInt8(11,this.offset),e&&"local"!==e){if("Z"!==e){const r=("-"===e[0]?-1:1)*(60*parseInt(e.substring(1,3),10)+parseInt(e.substring(4),10));0!==r&&(t=new Date(t.getTime()+6e4*r))}this.buffer.writeUInt16LE(t.getUTCFullYear(),this.offset+1),this.buffer.writeUInt8(t.getUTCMonth()+1,this.offset+3),this.buffer.writeUInt8(t.getUTCDate(),this.offset+4),this.buffer.writeUInt8(t.getUTCHours(),this.offset+5),this.buffer.writeUInt8(t.getUTCMinutes(),this.offset+6),this.buffer.writeUInt8(t.getUTCSeconds(),this.offset+7),this.buffer.writeUInt32LE(1e3*t.getUTCMilliseconds(),this.offset+8)}else this.buffer.writeUInt16LE(t.getFullYear(),this.offset+1),this.buffer.writeUInt8(t.getMonth()+1,this.offset+3),this.buffer.writeUInt8(t.getDate(),this.offset+4),this.buffer.writeUInt8(t.getHours(),this.offset+5),this.buffer.writeUInt8(t.getMinutes(),this.offset+6),this.buffer.writeUInt8(t.getSeconds(),this.offset+7),this.buffer.writeUInt32LE(1e3*t.getMilliseconds(),this.offset+8);this.offset+=12}writeHeader(t){const e=this.offset;this.offset=0,this.writeInt24(this.buffer.length-4),this.writeInt8(t),this.offset=e}clone(){return new Packet(this.sequenceId,this.buffer,this.start,this.end)}type(){return this.isEOF()?"EOF":this.isError()?"Error":0===this.buffer[this.offset]?"maybeOK":""}static lengthCodedNumberLength(t){return t<251?1:t<65535?3:t<16777215?5:9}static lengthCodedStringLength(t,e){const r=StringParser.encode(t,e).length;return Packet.lengthCodedNumberLength(r)+r}static MockBuffer(){const t=function(){},e=Buffer.alloc(0);for(const r in NativeBuffer.prototype)"function"==typeof e[r]&&(e[r]=t);return e}}module.exports=Packet;