"use strict";const FieldFlags=require("../constants/field_flags.js"),Charsets=require("../constants/charsets.js"),Types=require("../constants/types.js"),helpers=require("../helpers"),genFunc=require("generate-function"),parserCache=require("./parser_cache.js"),typeNames=[];for(const e in Types)typeNames[Types[e]]=e;function readCodeFor(e,t,r,a){const n=Boolean(r.supportBigNumbers||t.supportBigNumbers),s=Boolean(r.bigNumberStrings||t.bigNumberStrings),c=r.timezone||t.timezone,p=r.dateStrings||t.dateStrings,o=e.flags&FieldFlags.UNSIGNED;switch(e.columnType){case Types.TINY:return o?"packet.readInt8();":"packet.readSInt8();";case Types.SHORT:return o?"packet.readInt16();":"packet.readSInt16();";case Types.LONG:case Types.INT24:return o?"packet.readInt32();":"packet.readSInt32();";case Types.YEAR:return"packet.readInt16()";case Types.FLOAT:return"packet.readFloat();";case Types.DOUBLE:return"packet.readDouble();";case Types.NULL:return"null;";case Types.DATE:case Types.DATETIME:case Types.TIMESTAMP:case Types.NEWDATE:return helpers.typeMatch(e.columnType,p,Types)?`packet.readDateTimeString(${parseInt(e.decimals,10)});`:`packet.readDateTime(${helpers.srcEscape(c)});`;case Types.TIME:return"packet.readTimeString()";case Types.DECIMAL:case Types.NEWDECIMAL:return t.decimalNumbers?"packet.parseLengthCodedFloat();":'packet.readLengthCodedString("ascii");';case Types.GEOMETRY:return"packet.parseGeometryValue();";case Types.JSON:return t.jsonStrings?'packet.readLengthCodedString("utf8")':'JSON.parse(packet.readLengthCodedString("utf8"));';case Types.LONGLONG:return n?s?o?"packet.readInt64String();":"packet.readSInt64String();":o?"packet.readInt64();":"packet.readSInt64();":o?"packet.readInt64JSNumber();":"packet.readSInt64JSNumber();";default:return e.characterSet===Charsets.BINARY?"packet.readLengthCodedBuffer();":`packet.readLengthCodedString(fields[${a}].encoding)`}}function compile(e,t,r){const a=genFunc(),n=Math.floor((e.length+7+2)/8);a("(function(){"),a("return class BinaryRow {"),a("constructor() {"),a("}"),a("next(packet, fields, options) {"),t.rowsAsArray?a(`const result = new Array(${e.length});`):a("const result = {};"),"function"==typeof r.typeCast&&"function"!=typeof t.typeCast&&(t.typeCast=r.typeCast),a("packet.readInt8();");for(let e=0;e<n;++e)a(`const nullBitmaskByte${e} = packet.readInt8();`);let s="",c=4,p=0,o="",u="";for(let n=0;n<e.length;n++){if(o=helpers.fieldEscape(e[n].name),"string"==typeof t.nestTables?s=`result[${helpers.fieldEscape(e[n].table+t.nestTables+e[n].name)}]`:!0===t.nestTables?(u=helpers.fieldEscape(e[n].table),a(`if (!result[${u}]) result[${u}] = {};`),s=`result[${u}][${o}]`):s=t.rowsAsArray?`result[${n.toString(10)}]`:`result[${o}]`,a(`if (nullBitmaskByte${p} & ${c}) `),a(`${s} = null;`),a("else {"),!1===t.typeCast)a(`${s} = packet.readLengthCodedBuffer();`);else{const c=`fieldWrapper${n}`;a(`const ${c} = wrap(fields[${n}], packet);`);const p=readCodeFor(e[n],r,t,n);"function"==typeof t.typeCast?a(`${s} = options.typeCast(${c}, function() { return ${p} });`):a(`${s} = ${p};`)}a("}"),c*=2,256===c&&(c=1,p++)}return a("return result;"),a("}"),a("};")("})()"),r.debug&&helpers.printDebugWithCode("Compiled binary protocol row parser",a.toString()),a.toFunction({wrap:function(e,t){return{type:typeNames[e.columnType],length:e.columnLength,db:e.schema,table:e.table,name:e.name,string:function(r=e.encoding){return e.columnType===Types.JSON&&r===e.encoding&&console.warn(`typeCast: JSON column "${e.name}" is interpreted as BINARY by default, recommended to manually set utf8 encoding: \`field.string("utf8")\``),t.readLengthCodedString(r)},buffer:function(){return t.readLengthCodedBuffer()},geometry:function(){return t.parseGeometryValue()}}}})}function getBinaryParser(e,t,r){return parserCache.getParser("binary",e,t,r,compile)}module.exports=getBinaryParser;