"use strict";const Types=require("../constants/types.js"),Charsets=require("../constants/charsets.js"),helpers=require("../helpers"),genFunc=require("generate-function"),parserCache=require("./parser_cache.js"),typeNames=[];for(const e in Types)typeNames[Types[e]]=e;function readCodeFor(e,t,r,s,n){const a=Boolean(n.supportBigNumbers||s.supportBigNumbers),p=Boolean(n.bigNumberStrings||s.bigNumberStrings),c=n.timezone||s.timezone,o=n.dateStrings||s.dateStrings;switch(e){case Types.TINY:case Types.SHORT:case Types.LONG:case Types.INT24:case Types.YEAR:return"packet.parseLengthCodedIntNoBigCheck()";case Types.LONGLONG:return a&&p?"packet.parseLengthCodedIntString()":`packet.parseLengthCodedInt(${a})`;case Types.FLOAT:case Types.DOUBLE:return"packet.parseLengthCodedFloat()";case Types.NULL:return"packet.readLengthCodedNumber()";case Types.DECIMAL:case Types.NEWDECIMAL:return s.decimalNumbers?"packet.parseLengthCodedFloat()":'packet.readLengthCodedString("ascii")';case Types.DATE:return helpers.typeMatch(e,o,Types)?'packet.readLengthCodedString("ascii")':`packet.parseDate(${helpers.srcEscape(c)})`;case Types.DATETIME:case Types.TIMESTAMP:return helpers.typeMatch(e,o,Types)?'packet.readLengthCodedString("ascii")':`packet.parseDateTime(${helpers.srcEscape(c)})`;case Types.TIME:return'packet.readLengthCodedString("ascii")';case Types.GEOMETRY:return"packet.parseGeometryValue()";case Types.JSON:return s.jsonStrings?'packet.readLengthCodedString("utf8")':'JSON.parse(packet.readLengthCodedString("utf8"))';default:return t===Charsets.BINARY?"packet.readLengthCodedBuffer()":`packet.readLengthCodedString(${r})`}}function compile(e,t,r){"function"==typeof r.typeCast&&"function"!=typeof t.typeCast&&(t.typeCast=r.typeCast);const s=genFunc();s("(function () {")("return class TextRow {"),s("constructor(fields) {"),"function"==typeof t.typeCast&&(s("const _this = this;"),s("for(let i=0; i<fields.length; ++i) {"),s("this[`wrap${i}`] = wrap(fields[i], _this);"),s("}")),s("}"),s("next(packet, fields, options) {"),s("this.packet = packet;"),t.rowsAsArray?s(`const result = new Array(${e.length});`):s("const result = {};");const n={};let a=[];if(!0===t.nestTables){for(let t=0;t<e.length;t++)n[e[t].table]=1;a=Object.keys(n);for(let e=0;e<a.length;e++)s(`result[${helpers.fieldEscape(a[e])}] = {};`)}let p="",c="",o="";for(let n=0;n<e.length;n++)if(c=helpers.fieldEscape(e[n].name),"string"==typeof t.nestTables?p=`result[${helpers.fieldEscape(e[n].table+t.nestTables+e[n].name)}]`:!0===t.nestTables?(o=helpers.fieldEscape(e[n].table),s(`if (!result[${o}]) result[${o}] = {};`),p=`result[${o}][${c}]`):p=t.rowsAsArray?`result[${n.toString(10)}]`:`result[${c}]`,!1===t.typeCast)s(`${p} = packet.readLengthCodedBuffer();`);else{const a=`fields[${n}].encoding`,c=readCodeFor(e[n].columnType,e[n].characterSet,a,r,t);"function"==typeof t.typeCast?s(`${p} = options.typeCast(this.wrap${n}, function() { return ${c} });`):s(`${p} = ${c};`)}return s("return result;"),s("}"),s("};")("})()"),r.debug&&helpers.printDebugWithCode("Compiled text protocol row parser",s.toString()),"function"==typeof t.typeCast?s.toFunction({wrap:function(e,t){return{type:typeNames[e.columnType],length:e.columnLength,db:e.schema,table:e.table,name:e.name,string:function(r=e.encoding){return e.columnType===Types.JSON&&r===e.encoding&&console.warn(`typeCast: JSON column "${e.name}" is interpreted as BINARY by default, recommended to manually set utf8 encoding: \`field.string("utf8")\``),t.packet.readLengthCodedString(r)},buffer:function(){return t.packet.readLengthCodedBuffer()},geometry:function(){return t.packet.parseGeometryValue()}}}}):s.toFunction()}function getTextParser(e,t,r){return parserCache.getParser("text",e,t,r,compile)}module.exports=getTextParser;