"use strict";const core=require("./index.js"),EventEmitter=require("events").EventEmitter,parserCache=require("./lib/parsers/parser_cache.js");function makeDoneCb(e,o,t){return function(r,n,s){r?(t.message=r.message,t.code=r.code,t.errno=r.errno,t.sql=r.sql,t.sqlState=r.sqlState,t.sqlMessage=r.sqlMessage,o(t)):e([n,s])}}function inheritEvents(e,o,t){const r={};o.on("newListener",(n=>{t.indexOf(n)>=0&&!o.listenerCount(n)&&e.on(n,r[n]=function(){const e=[].slice.call(arguments);e.unshift(n),o.emit.apply(o,e)})})).on("removeListener",(n=>{t.indexOf(n)>=0&&!o.listenerCount(n)&&(e.removeListener(n,r[n]),delete r[n])}))}class PromisePreparedStatementInfo{constructor(e,o){this.statement=e,this.Promise=o}execute(e){const o=this.statement,t=new Error;return new this.Promise(((r,n)=>{const s=makeDoneCb(r,n,t);e?o.execute(e,s):o.execute(s)}))}close(){return new this.Promise((e=>{this.statement.close(),e()}))}}class PromiseConnection extends EventEmitter{constructor(e,o){super(),this.connection=e,this.Promise=o||Promise,inheritEvents(e,this,["error","drain","connect","end","enqueue"])}release(){this.connection.release()}query(e,o){const t=this.connection,r=new Error;if("function"==typeof o)throw new Error("Callback function is not available with promise clients.");return new this.Promise(((n,s)=>{const i=makeDoneCb(n,s,r);void 0!==o?t.query(e,o,i):t.query(e,i)}))}execute(e,o){const t=this.connection,r=new Error;if("function"==typeof o)throw new Error("Callback function is not available with promise clients.");return new this.Promise(((n,s)=>{const i=makeDoneCb(n,s,r);void 0!==o?t.execute(e,o,i):t.execute(e,i)}))}end(){return new this.Promise((e=>{this.connection.end(e)}))}beginTransaction(){const e=this.connection,o=new Error;return new this.Promise(((t,r)=>{const n=makeDoneCb(t,r,o);e.beginTransaction(n)}))}commit(){const e=this.connection,o=new Error;return new this.Promise(((t,r)=>{const n=makeDoneCb(t,r,o);e.commit(n)}))}rollback(){const e=this.connection,o=new Error;return new this.Promise(((t,r)=>{const n=makeDoneCb(t,r,o);e.rollback(n)}))}ping(){const e=this.connection,o=new Error;return new this.Promise(((t,r)=>{e.ping((e=>{e?(o.message=e.message,o.code=e.code,o.errno=e.errno,o.sqlState=e.sqlState,o.sqlMessage=e.sqlMessage,r(o)):t(!0)}))}))}connect(){const e=this.connection,o=new Error;return new this.Promise(((t,r)=>{e.connect(((e,n)=>{e?(o.message=e.message,o.code=e.code,o.errno=e.errno,o.sqlState=e.sqlState,o.sqlMessage=e.sqlMessage,r(o)):t(n)}))}))}prepare(e){const o=this.connection,t=this.Promise,r=new Error;return new this.Promise(((n,s)=>{o.prepare(e,((e,o)=>{if(e)r.message=e.message,r.code=e.code,r.errno=e.errno,r.sqlState=e.sqlState,r.sqlMessage=e.sqlMessage,s(r);else{const e=new PromisePreparedStatementInfo(o,t);n(e)}}))}))}changeUser(e){const o=this.connection,t=new Error;return new this.Promise(((r,n)=>{o.changeUser(e,(e=>{e?(t.message=e.message,t.code=e.code,t.errno=e.errno,t.sqlState=e.sqlState,t.sqlMessage=e.sqlMessage,n(t)):r()}))}))}get config(){return this.connection.config}get threadId(){return this.connection.threadId}}function createConnection(e){const o=core.createConnection(e),t=new Error,r=e.Promise||Promise;if(!r)throw new Error("no Promise implementation available.Use promise-enabled node version or pass userland Promise implementation as parameter, for example: { Promise: require('bluebird') }");return new r(((e,n)=>{o.once("connect",(()=>{e(new PromiseConnection(o,r))})),o.once("error",(e=>{t.message=e.message,t.code=e.code,t.errno=e.errno,t.sqlState=e.sqlState,n(t)}))}))}!function(e){for(let o=0;e&&o<e.length;o++){const t=e[o];"function"==typeof core.Connection.prototype[t]&&void 0===PromiseConnection.prototype[t]&&(PromiseConnection.prototype[t]=function(e){return function(){return core.Connection.prototype[e].apply(this.connection,arguments)}}(t))}}(["close","createBinlogStream","destroy","escape","escapeId","format","pause","pipe","resume","unprepare"]);class PromisePoolConnection extends PromiseConnection{constructor(e,o){super(e,o)}destroy(){return core.PoolConnection.prototype.destroy.apply(this.connection,arguments)}}class PromisePool extends EventEmitter{constructor(e,o){super(),this.pool=e,this.Promise=o||Promise,inheritEvents(e,this,["acquire","connection","enqueue","release"])}getConnection(){const e=this.pool;return new this.Promise(((o,t)=>{e.getConnection(((e,r)=>{e?t(e):o(new PromisePoolConnection(r,this.Promise))}))}))}releaseConnection(e){e instanceof PromisePoolConnection&&e.release()}query(e,o){const t=this.pool,r=new Error;if("function"==typeof o)throw new Error("Callback function is not available with promise clients.");return new this.Promise(((n,s)=>{const i=makeDoneCb(n,s,r);void 0!==o?t.query(e,o,i):t.query(e,i)}))}execute(e,o){const t=this.pool,r=new Error;if("function"==typeof o)throw new Error("Callback function is not available with promise clients.");return new this.Promise(((n,s)=>{const i=makeDoneCb(n,s,r);o?t.execute(e,o,i):t.execute(e,i)}))}end(){const e=this.pool,o=new Error;return new this.Promise(((t,r)=>{e.end((e=>{e?(o.message=e.message,o.code=e.code,o.errno=e.errno,o.sqlState=e.sqlState,o.sqlMessage=e.sqlMessage,r(o)):t()}))}))}}function createPool(e){const o=core.createPool(e),t=e.Promise||Promise;if(!t)throw new Error("no Promise implementation available.Use promise-enabled node version or pass userland Promise implementation as parameter, for example: { Promise: require('bluebird') }");return new PromisePool(o,t)}!function(e){for(let o=0;e&&o<e.length;o++){const t=e[o];"function"==typeof core.Pool.prototype[t]&&void 0===PromisePool.prototype[t]&&(PromisePool.prototype[t]=function(e){return function(){return core.Pool.prototype[e].apply(this.pool,arguments)}}(t))}}(["escape","escapeId","format"]);class PromisePoolCluster extends EventEmitter{constructor(e,o){super(),this.poolCluster=e,this.Promise=o||Promise,inheritEvents(e,this,["warn","remove"])}getConnection(){const e=this.poolCluster;return new this.Promise(((o,t)=>{e.getConnection(((e,r)=>{e?t(e):o(new PromisePoolConnection(r,this.Promise))}))}))}query(e,o){const t=this.poolCluster,r=new Error;if("function"==typeof o)throw new Error("Callback function is not available with promise clients.");return new this.Promise(((n,s)=>{const i=makeDoneCb(n,s,r);t.query(e,o,i)}))}execute(e,o){const t=this.poolCluster,r=new Error;if("function"==typeof o)throw new Error("Callback function is not available with promise clients.");return new this.Promise(((n,s)=>{const i=makeDoneCb(n,s,r);t.execute(e,o,i)}))}of(e,o){return new PromisePoolCluster(this.poolCluster.of(e,o),this.Promise)}end(){const e=this.poolCluster,o=new Error;return new this.Promise(((t,r)=>{e.end((e=>{e?(o.message=e.message,o.code=e.code,o.errno=e.errno,o.sqlState=e.sqlState,o.sqlMessage=e.sqlMessage,r(o)):t()}))}))}}function createPoolCluster(e){const o=core.createPoolCluster(e),t=e&&e.Promise||Promise;if(!t)throw new Error("no Promise implementation available.Use promise-enabled node version or pass userland Promise implementation as parameter, for example: { Promise: require('bluebird') }");return new PromisePoolCluster(o,t)}!function(e){for(let o=0;e&&o<e.length;o++){const t=e[o];"function"==typeof core.PoolCluster.prototype[t]&&void 0===PromisePoolCluster.prototype[t]&&(PromisePoolCluster.prototype[t]=function(e){return function(){return core.PoolCluster.prototype[e].apply(this.poolCluster,arguments)}}(t))}}(["add"]),exports.createConnection=createConnection,exports.createPool=createPool,exports.createPoolCluster=createPoolCluster,exports.escape=core.escape,exports.escapeId=core.escapeId,exports.format=core.format,exports.raw=core.raw,exports.PromisePool=PromisePool,exports.PromiseConnection=PromiseConnection,exports.PromisePoolConnection=PromisePoolConnection,exports.__defineGetter__("Types",(()=>require("./lib/constants/types.js"))),exports.__defineGetter__("Charsets",(()=>require("./lib/constants/charsets.js"))),exports.__defineGetter__("CharsetToEncoding",(()=>require("./lib/constants/charset_encodings.js"))),exports.setMaxParserCache=function(e){parserCache.setMaxCache(e)},exports.clearParserCache=function(){parserCache.clearCache()};