var forge=require("./forge");require("./asn1"),require("./hmac"),require("./oids"),require("./pkcs7asn1"),require("./pbe"),require("./random"),require("./rsa"),require("./sha1"),require("./util"),require("./x509");var asn1=forge.asn1,pki=forge.pki,p12=module.exports=forge.pkcs12=forge.pkcs12||{},contentInfoValidator={name:"ContentInfo",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.contentType",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:asn1.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"content"}]},pfxValidator={name:"PFX",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.version",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"version"},contentInfoValidator,{name:"PFX.macData",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"mac",value:[{name:"PFX.macData.mac",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm.algorithm",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"macAlgorithm"},{name:"PFX.macData.mac.digestAlgorithm.parameters",tagClass:asn1.Class.UNIVERSAL,captureAsn1:"macAlgorithmParameters"}]},{name:"PFX.macData.mac.digest",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OCTETSTRING,constructed:!1,capture:"macDigest"}]},{name:"PFX.macData.macSalt",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OCTETSTRING,constructed:!1,capture:"macSalt"},{name:"PFX.macData.iterations",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,optional:!0,capture:"macIterations"}]}]},safeBagValidator={name:"SafeBag",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"SafeBag.bagId",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"bagId"},{name:"SafeBag.bagValue",tagClass:asn1.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"bagValue"},{name:"SafeBag.bagAttributes",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SET,constructed:!0,optional:!0,capture:"bagAttributes"}]},attributeValidator={name:"Attribute",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"Attribute.attrId",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"oid"},{name:"Attribute.attrValues",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SET,constructed:!0,capture:"values"}]},certBagValidator={name:"CertBag",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"CertBag.certId",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"certId"},{name:"CertBag.certValue",tagClass:asn1.Class.CONTEXT_SPECIFIC,constructed:!0,value:[{name:"CertBag.certValue[0]",tagClass:asn1.Class.UNIVERSAL,type:asn1.Class.OCTETSTRING,constructed:!1,capture:"cert"}]}]};function _getBagsByAttribute(e,a,s,t){for(var n=[],r=0;r<e.length;r++)for(var o=0;o<e[r].safeBags.length;o++){var i=e[r].safeBags[o];void 0!==t&&i.type!==t||(null!==a?void 0!==i.attributes[a]&&i.attributes[a].indexOf(s)>=0&&n.push(i):n.push(i))}return n}function _decodePkcs7Data(e){if(e.composed||e.constructed){for(var a=forge.util.createBuffer(),s=0;s<e.value.length;++s)a.putBytes(e.value[s].value);e.composed=e.constructed=!1,e.value=a.getBytes()}return e}function _decodeAuthenticatedSafe(e,a,s,t){if((a=asn1.fromDer(a,s)).tagClass!==asn1.Class.UNIVERSAL||a.type!==asn1.Type.SEQUENCE||!0!==a.constructed)throw new Error("PKCS#12 AuthenticatedSafe expected to be a SEQUENCE OF ContentInfo");for(var n=0;n<a.value.length;n++){var r=a.value[n],o={},i=[];if(!asn1.validate(r,contentInfoValidator,o,i))throw(p=new Error("Cannot read ContentInfo.")).errors=i,p;var c={encrypted:!1},l=null,d=o.content.value[0];switch(asn1.derToOid(o.contentType)){case pki.oids.data:if(d.tagClass!==asn1.Class.UNIVERSAL||d.type!==asn1.Type.OCTETSTRING)throw new Error("PKCS#12 SafeContents Data is not an OCTET STRING.");l=_decodePkcs7Data(d).value;break;case pki.oids.encryptedData:l=_decryptSafeContents(d,t),c.encrypted=!0;break;default:var p;throw(p=new Error("Unsupported PKCS#12 contentType.")).contentType=asn1.derToOid(o.contentType),p}c.safeBags=_decodeSafeContents(l,s,t),e.safeContents.push(c)}}function _decryptSafeContents(e,a){var s={},t=[];if(!asn1.validate(e,forge.pkcs7.asn1.encryptedDataValidator,s,t))throw(n=new Error("Cannot read EncryptedContentInfo.")).errors=t,n;var n,r=asn1.derToOid(s.contentType);if(r!==pki.oids.data)throw(n=new Error("PKCS#12 EncryptedContentInfo ContentType is not Data.")).oid=r,n;r=asn1.derToOid(s.encAlgorithm);var o=pki.pbe.getCipher(r,s.encParameter,a),i=_decodePkcs7Data(s.encryptedContentAsn1),c=forge.util.createBuffer(i.value);if(o.update(c),!o.finish())throw new Error("Failed to decrypt PKCS#12 SafeContents.");return o.output.getBytes()}function _decodeSafeContents(e,a,s){if(!a&&0===e.length)return[];if((e=asn1.fromDer(e,a)).tagClass!==asn1.Class.UNIVERSAL||e.type!==asn1.Type.SEQUENCE||!0!==e.constructed)throw new Error("PKCS#12 SafeContents expected to be a SEQUENCE OF SafeBag.");for(var t=[],n=0;n<e.value.length;n++){var r=e.value[n],o={},i=[];if(!asn1.validate(r,safeBagValidator,o,i))throw(C=new Error("Cannot read SafeBag.")).errors=i,C;var c,l,d={type:asn1.derToOid(o.bagId),attributes:_decodeBagAttributes(o.bagAttributes)};t.push(d);var p=o.bagValue.value[0];switch(d.type){case pki.oids.pkcs8ShroudedKeyBag:if(null===(p=pki.decryptPrivateKeyInfo(p,s)))throw new Error("Unable to decrypt PKCS#8 ShroudedKeyBag, wrong password?");case pki.oids.keyBag:try{d.key=pki.privateKeyFromAsn1(p)}catch(e){d.key=null,d.asn1=p}continue;case pki.oids.certBag:c=certBagValidator,l=function(){if(asn1.derToOid(o.certId)!==pki.oids.x509Certificate){var e=new Error("Unsupported certificate type, only X.509 supported.");throw e.oid=asn1.derToOid(o.certId),e}var s=asn1.fromDer(o.cert,a);try{d.cert=pki.certificateFromAsn1(s,!0)}catch(e){d.cert=null,d.asn1=s}};break;default:var C;throw(C=new Error("Unsupported PKCS#12 SafeBag type.")).oid=d.type,C}if(void 0!==c&&!asn1.validate(p,c,o,i))throw(C=new Error("Cannot read PKCS#12 "+c.name)).errors=i,C;l()}return t}function _decodeBagAttributes(e){var a={};if(void 0!==e)for(var s=0;s<e.length;++s){var t={},n=[];if(!asn1.validate(e[s],attributeValidator,t,n)){var r=new Error("Cannot read PKCS#12 BagAttribute.");throw r.errors=n,r}var o=asn1.derToOid(t.oid);if(void 0!==pki.oids[o]){a[pki.oids[o]]=[];for(var i=0;i<t.values.length;++i)a[pki.oids[o]].push(t.values[i].value)}}return a}p12.pkcs12FromAsn1=function(e,a,s){"string"==typeof a?(s=a,a=!0):void 0===a&&(a=!0);var t={};if(!asn1.validate(e,pfxValidator,t,[]))throw(n=new Error("Cannot read PKCS#12 PFX. ASN.1 object is not an PKCS#12 PFX.")).errors=n,n;var n,r={version:t.version.charCodeAt(0),safeContents:[],getBags:function(e){var a,s={};return"localKeyId"in e?a=e.localKeyId:"localKeyIdHex"in e&&(a=forge.util.hexToBytes(e.localKeyIdHex)),void 0===a&&!("friendlyName"in e)&&"bagType"in e&&(s[e.bagType]=_getBagsByAttribute(r.safeContents,null,null,e.bagType)),void 0!==a&&(s.localKeyId=_getBagsByAttribute(r.safeContents,"localKeyId",a,e.bagType)),"friendlyName"in e&&(s.friendlyName=_getBagsByAttribute(r.safeContents,"friendlyName",e.friendlyName,e.bagType)),s},getBagsByFriendlyName:function(e,a){return _getBagsByAttribute(r.safeContents,"friendlyName",e,a)},getBagsByLocalKeyId:function(e,a){return _getBagsByAttribute(r.safeContents,"localKeyId",e,a)}};if(3!==t.version.charCodeAt(0))throw(n=new Error("PKCS#12 PFX of version other than 3 not supported.")).version=t.version.charCodeAt(0),n;if(asn1.derToOid(t.contentType)!==pki.oids.data)throw(n=new Error("Only PKCS#12 PFX in password integrity mode supported.")).oid=asn1.derToOid(t.contentType),n;var o=t.content.value[0];if(o.tagClass!==asn1.Class.UNIVERSAL||o.type!==asn1.Type.OCTETSTRING)throw new Error("PKCS#12 authSafe content data is not an OCTET STRING.");if(o=_decodePkcs7Data(o),t.mac){var i=null,c=0,l=asn1.derToOid(t.macAlgorithm);switch(l){case pki.oids.sha1:i=forge.md.sha1.create(),c=20;break;case pki.oids.sha256:i=forge.md.sha256.create(),c=32;break;case pki.oids.sha384:i=forge.md.sha384.create(),c=48;break;case pki.oids.sha512:i=forge.md.sha512.create(),c=64;break;case pki.oids.md5:i=forge.md.md5.create(),c=16}if(null===i)throw new Error("PKCS#12 uses unsupported MAC algorithm: "+l);var d=new forge.util.ByteBuffer(t.macSalt),p="macIterations"in t?parseInt(forge.util.bytesToHex(t.macIterations),16):1,C=p12.generateKey(s,d,3,p,c,i),E=forge.hmac.create();if(E.start(i,C),E.update(o.value),E.getMac().getBytes()!==t.macDigest)throw new Error("PKCS#12 MAC could not be verified. Invalid password?")}return _decodeAuthenticatedSafe(r,o.value,a,s),r},p12.toPkcs12Asn1=function(e,a,s,t){(t=t||{}).saltSize=t.saltSize||8,t.count=t.count||2048,t.algorithm=t.algorithm||t.encAlgorithm||"aes128","useMac"in t||(t.useMac=!0),"localKeyId"in t||(t.localKeyId=null),"generateLocalKeyId"in t||(t.generateLocalKeyId=!0);var n,r=t.localKeyId;if(null!==r)r=forge.util.hexToBytes(r);else if(t.generateLocalKeyId)if(a){var o=forge.util.isArray(a)?a[0]:a;"string"==typeof o&&(o=pki.certificateFromPem(o)),(m=forge.md.sha1.create()).update(asn1.toDer(pki.certificateToAsn1(o)).getBytes()),r=m.digest().getBytes()}else r=forge.random.getBytes(20);var i=[];null!==r&&i.push(asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.localKeyId).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SET,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,r)])])),"friendlyName"in t&&i.push(asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.friendlyName).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SET,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.BMPSTRING,!1,t.friendlyName)])])),i.length>0&&(n=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SET,!0,i));var c=[],l=[];null!==a&&(l=forge.util.isArray(a)?a:[a]);for(var d=[],p=0;p<l.length;++p){"string"==typeof(a=l[p])&&(a=pki.certificateFromPem(a));var C=0===p?n:void 0,E=pki.certificateToAsn1(a),y=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.certBag).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.x509Certificate).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,asn1.toDer(E).getBytes())])])]),C]);d.push(y)}if(d.length>0){var u=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,d),g=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.data).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,asn1.toDer(u).getBytes())])]);c.push(g)}var T=null;if(null!==e){var S=pki.wrapRsaPrivateKey(pki.privateKeyToAsn1(e));T=null===s?asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.keyBag).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[S]),n]):asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.pkcs8ShroudedKeyBag).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[pki.encryptPrivateKeyInfo(S,s,t)]),n]);var I=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[T]),f=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.data).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,asn1.toDer(I).getBytes())])]);c.push(f)}var N,A=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,c);if(t.useMac){var m=forge.md.sha1.create(),v=new forge.util.ByteBuffer(forge.random.getBytes(t.saltSize)),U=t.count,h=(e=p12.generateKey(s,v,3,U,20),forge.hmac.create());h.start(m,e),h.update(asn1.toDer(A).getBytes());var R=h.getMac();N=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.sha1).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.NULL,!1,"")]),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,R.getBytes())]),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,v.getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,asn1.integerToDer(U).getBytes())])}return asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,asn1.integerToDer(3).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.data).getBytes()),asn1.create(asn1.Class.CONTEXT_SPECIFIC,0,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,asn1.toDer(A).getBytes())])]),N])},p12.generateKey=forge.pbe.generatePkcs12Key;