var forge=require("./forge");if(require("./asn1"),require("./jsbn"),require("./oids"),require("./pkcs1"),require("./prime"),require("./random"),require("./util"),void 0===BigInteger)var BigInteger=forge.jsbn.BigInteger;var _crypto=forge.util.isNodejs?require("crypto"):null,asn1=forge.asn1,util=forge.util;forge.pki=forge.pki||{},module.exports=forge.pki.rsa=forge.rsa=forge.rsa||{};var pki=forge.pki,GCD_30_DELTA=[6,4,2,4,2,4,6,2],privateKeyValidator={name:"PrivateKeyInfo",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"PrivateKeyInfo.version",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"PrivateKeyInfo.privateKeyAlgorithm",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"privateKeyOid"}]},{name:"PrivateKeyInfo",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OCTETSTRING,constructed:!1,capture:"privateKey"}]},rsaPrivateKeyValidator={name:"RSAPrivateKey",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPrivateKey.version",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"RSAPrivateKey.modulus",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyModulus"},{name:"RSAPrivateKey.publicExponent",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyPublicExponent"},{name:"RSAPrivateKey.privateExponent",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyPrivateExponent"},{name:"RSAPrivateKey.prime1",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyPrime1"},{name:"RSAPrivateKey.prime2",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyPrime2"},{name:"RSAPrivateKey.exponent1",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyExponent1"},{name:"RSAPrivateKey.exponent2",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyExponent2"},{name:"RSAPrivateKey.coefficient",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"privateKeyCoefficient"}]},rsaPublicKeyValidator={name:"RSAPublicKey",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPublicKey.modulus",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"publicKeyModulus"},{name:"RSAPublicKey.exponent",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.INTEGER,constructed:!1,capture:"publicKeyExponent"}]},publicKeyValidator=forge.pki.rsa.publicKeyValidator={name:"SubjectPublicKeyInfo",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,captureAsn1:"subjectPublicKeyInfo",value:[{name:"SubjectPublicKeyInfo.AlgorithmIdentifier",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"publicKeyOid"}]},{name:"SubjectPublicKeyInfo.subjectPublicKey",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.BITSTRING,constructed:!1,value:[{name:"SubjectPublicKeyInfo.subjectPublicKey.RSAPublicKey",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"rsaPublicKey"}]}]},digestInfoValidator={name:"DigestInfo",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"DigestInfo.DigestAlgorithm",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.SEQUENCE,constructed:!0,value:[{name:"DigestInfo.DigestAlgorithm.algorithmIdentifier",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OID,constructed:!1,capture:"algorithmIdentifier"},{name:"DigestInfo.DigestAlgorithm.parameters",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.NULL,capture:"parameters",optional:!0,constructed:!1}]},{name:"DigestInfo.digest",tagClass:asn1.Class.UNIVERSAL,type:asn1.Type.OCTETSTRING,constructed:!1,capture:"digest"}]},emsaPkcs1v15encode=function(e){var t;if(!(e.algorithm in pki.oids)){var r=new Error("Unknown message digest algorithm.");throw r.algorithm=e.algorithm,r}t=pki.oids[e.algorithm];var n=asn1.oidToDer(t).getBytes(),a=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[]),s=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[]);s.value.push(asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,n)),s.value.push(asn1.create(asn1.Class.UNIVERSAL,asn1.Type.NULL,!1,""));var i=asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,e.digest().getBytes());return a.value.push(s),a.value.push(i),asn1.toDer(a).getBytes()},_modPow=function(e,t,r){if(r)return e.modPow(t.e,t.n);if(!t.p||!t.q)return e.modPow(t.d,t.n);var n;t.dP||(t.dP=t.d.mod(t.p.subtract(BigInteger.ONE))),t.dQ||(t.dQ=t.d.mod(t.q.subtract(BigInteger.ONE))),t.qInv||(t.qInv=t.q.modInverse(t.p));do{n=new BigInteger(forge.util.bytesToHex(forge.random.getBytes(t.n.bitLength()/8)),16)}while(n.compareTo(t.n)>=0||!n.gcd(t.n).equals(BigInteger.ONE));for(var a=(e=e.multiply(n.modPow(t.e,t.n)).mod(t.n)).mod(t.p).modPow(t.dP,t.p),s=e.mod(t.q).modPow(t.dQ,t.q);a.compareTo(s)<0;)a=a.add(t.p);var i=a.subtract(s).multiply(t.qInv).mod(t.p).multiply(t.q).add(s);return i=i.multiply(n.modInverse(t.n)).mod(t.n)};function _encodePkcs1_v1_5(e,t,r){var n=forge.util.createBuffer(),a=Math.ceil(t.n.bitLength()/8);if(e.length>a-11){var s=new Error("Message is too long for PKCS#1 v1.5 padding.");throw s.length=e.length,s.max=a-11,s}n.putByte(0),n.putByte(r);var i,o=a-3-e.length;if(0===r||1===r){i=0===r?0:255;for(var p=0;p<o;++p)n.putByte(i)}else for(;o>0;){var l=0,u=forge.random.getBytes(o);for(p=0;p<o;++p)0===(i=u.charCodeAt(p))?++l:n.putByte(i);o=l}return n.putByte(0),n.putBytes(e),n}function _decodePkcs1_v1_5(e,t,r,n){var a=Math.ceil(t.n.bitLength()/8),s=forge.util.createBuffer(e),i=s.getByte(),o=s.getByte();if(0!==i||r&&0!==o&&1!==o||!r&&2!=o||r&&0===o&&void 0===n)throw new Error("Encryption block is invalid.");var p=0;if(0===o){p=a-3-n;for(var l=0;l<p;++l)if(0!==s.getByte())throw new Error("Encryption block is invalid.")}else if(1===o)for(p=0;s.length()>1;){if(255!==s.getByte()){--s.read;break}++p}else if(2===o)for(p=0;s.length()>1;){if(0===s.getByte()){--s.read;break}++p}if(0!==s.getByte()||p!==a-3-s.length())throw new Error("Encryption block is invalid.");return s.getBytes()}function _generateKeyPair(e,t,r){"function"==typeof t&&(r=t,t={});var n={algorithm:{name:(t=t||{}).algorithm||"PRIMEINC",options:{workers:t.workers||2,workLoad:t.workLoad||100,workerScript:t.workerScript}}};function a(){s(e.pBits,(function(t,n){return t?r(t):(e.p=n,null!==e.q?i(t,e.q):void s(e.qBits,i))}))}function s(e,t){forge.prime.generateProbablePrime(e,n,t)}function i(t,n){if(t)return r(t);if(e.q=n,e.p.compareTo(e.q)<0){var o=e.p;e.p=e.q,e.q=o}if(0!==e.p.subtract(BigInteger.ONE).gcd(e.e).compareTo(BigInteger.ONE))return e.p=null,void a();if(0!==e.q.subtract(BigInteger.ONE).gcd(e.e).compareTo(BigInteger.ONE))return e.q=null,void s(e.qBits,i);if(e.p1=e.p.subtract(BigInteger.ONE),e.q1=e.q.subtract(BigInteger.ONE),e.phi=e.p1.multiply(e.q1),0!==e.phi.gcd(e.e).compareTo(BigInteger.ONE))return e.p=e.q=null,void a();if(e.n=e.p.multiply(e.q),e.n.bitLength()!==e.bits)return e.q=null,void s(e.qBits,i);var p=e.e.modInverse(e.phi);e.keys={privateKey:pki.rsa.setPrivateKey(e.n,e.e,p,e.p,e.q,p.mod(e.p1),p.mod(e.q1),e.q.modInverse(e.p)),publicKey:pki.rsa.setPublicKey(e.n,e.e)},r(null,e.keys)}"prng"in t&&(n.prng=t.prng),a()}function _bnToBytes(e){var t=e.toString(16);t[0]>="8"&&(t="00"+t);var r=forge.util.hexToBytes(t);return r.length>1&&(0===r.charCodeAt(0)&&0==(128&r.charCodeAt(1))||255===r.charCodeAt(0)&&128==(128&r.charCodeAt(1)))?r.substr(1):r}function _getMillerRabinTests(e){return e<=100?27:e<=150?18:e<=200?15:e<=250?12:e<=300?9:e<=350?8:e<=400?7:e<=500?6:e<=600?5:e<=800?4:e<=1250?3:2}function _detectNodeCrypto(e){return forge.util.isNodejs&&"function"==typeof _crypto[e]}function _detectSubtleCrypto(e){return void 0!==util.globalScope&&"object"==typeof util.globalScope.crypto&&"object"==typeof util.globalScope.crypto.subtle&&"function"==typeof util.globalScope.crypto.subtle[e]}function _detectSubtleMsCrypto(e){return void 0!==util.globalScope&&"object"==typeof util.globalScope.msCrypto&&"object"==typeof util.globalScope.msCrypto.subtle&&"function"==typeof util.globalScope.msCrypto.subtle[e]}function _intToUint8Array(e){for(var t=forge.util.hexToBytes(e.toString(16)),r=new Uint8Array(t.length),n=0;n<t.length;++n)r[n]=t.charCodeAt(n);return r}function _privateKeyFromJwk(e){if("RSA"!==e.kty)throw new Error('Unsupported key algorithm "'+e.kty+'"; algorithm must be "RSA".');return pki.setRsaPrivateKey(_base64ToBigInt(e.n),_base64ToBigInt(e.e),_base64ToBigInt(e.d),_base64ToBigInt(e.p),_base64ToBigInt(e.q),_base64ToBigInt(e.dp),_base64ToBigInt(e.dq),_base64ToBigInt(e.qi))}function _publicKeyFromJwk(e){if("RSA"!==e.kty)throw new Error('Key algorithm must be "RSA".');return pki.setRsaPublicKey(_base64ToBigInt(e.n),_base64ToBigInt(e.e))}function _base64ToBigInt(e){return new BigInteger(forge.util.bytesToHex(forge.util.decode64(e)),16)}pki.rsa.encrypt=function(e,t,r){var n,a=r,s=Math.ceil(t.n.bitLength()/8);!1!==r&&!0!==r?(a=2===r,n=_encodePkcs1_v1_5(e,t,r)):(n=forge.util.createBuffer()).putBytes(e);for(var i=new BigInteger(n.toHex(),16),o=_modPow(i,t,a).toString(16),p=forge.util.createBuffer(),l=s-Math.ceil(o.length/2);l>0;)p.putByte(0),--l;return p.putBytes(forge.util.hexToBytes(o)),p.getBytes()},pki.rsa.decrypt=function(e,t,r,n){var a=Math.ceil(t.n.bitLength()/8);if(e.length!==a){var s=new Error("Encrypted message length is invalid.");throw s.length=e.length,s.expected=a,s}var i=new BigInteger(forge.util.createBuffer(e).toHex(),16);if(i.compareTo(t.n)>=0)throw new Error("Encrypted message is invalid.");for(var o=_modPow(i,t,r).toString(16),p=forge.util.createBuffer(),l=a-Math.ceil(o.length/2);l>0;)p.putByte(0),--l;return p.putBytes(forge.util.hexToBytes(o)),!1!==n?_decodePkcs1_v1_5(p.getBytes(),t,r):p.getBytes()},pki.rsa.createKeyPairGenerationState=function(e,t,r){"string"==typeof e&&(e=parseInt(e,10)),e=e||2048;var n,a=(r=r||{}).prng||forge.random,s={nextBytes:function(e){for(var t=a.getBytesSync(e.length),r=0;r<e.length;++r)e[r]=t.charCodeAt(r)}},i=r.algorithm||"PRIMEINC";if("PRIMEINC"!==i)throw new Error("Invalid key generation algorithm: "+i);return(n={algorithm:i,state:0,bits:e,rng:s,eInt:t||65537,e:new BigInteger(null),p:null,q:null,qBits:e>>1,pBits:e-(e>>1),pqState:0,num:null,keys:null}).e.fromInt(n.eInt),n},pki.rsa.stepKeyPairGenerationState=function(e,t){"algorithm"in e||(e.algorithm="PRIMEINC");var r=new BigInteger(null);r.fromInt(30);for(var n,a=0,s=function(e,t){return e|t},i=+new Date,o=0;null===e.keys&&(t<=0||o<t);){if(0===e.state){var p=null===e.p?e.pBits:e.qBits,l=p-1;0===e.pqState?(e.num=new BigInteger(p,e.rng),e.num.testBit(l)||e.num.bitwiseTo(BigInteger.ONE.shiftLeft(l),s,e.num),e.num.dAddOffset(31-e.num.mod(r).byteValue(),0),a=0,++e.pqState):1===e.pqState?e.num.bitLength()>p?e.pqState=0:e.num.isProbablePrime(_getMillerRabinTests(e.num.bitLength()))?++e.pqState:e.num.dAddOffset(GCD_30_DELTA[a++%8],0):2===e.pqState?e.pqState=0===e.num.subtract(BigInteger.ONE).gcd(e.e).compareTo(BigInteger.ONE)?3:0:3===e.pqState&&(e.pqState=0,null===e.p?e.p=e.num:e.q=e.num,null!==e.p&&null!==e.q&&++e.state,e.num=null)}else if(1===e.state)e.p.compareTo(e.q)<0&&(e.num=e.p,e.p=e.q,e.q=e.num),++e.state;else if(2===e.state)e.p1=e.p.subtract(BigInteger.ONE),e.q1=e.q.subtract(BigInteger.ONE),e.phi=e.p1.multiply(e.q1),++e.state;else if(3===e.state)0===e.phi.gcd(e.e).compareTo(BigInteger.ONE)?++e.state:(e.p=null,e.q=null,e.state=0);else if(4===e.state)e.n=e.p.multiply(e.q),e.n.bitLength()===e.bits?++e.state:(e.q=null,e.state=0);else if(5===e.state){var u=e.e.modInverse(e.phi);e.keys={privateKey:pki.rsa.setPrivateKey(e.n,e.e,u,e.p,e.q,u.mod(e.p1),u.mod(e.q1),e.q.modInverse(e.p)),publicKey:pki.rsa.setPublicKey(e.n,e.e)}}o+=(n=+new Date)-i,i=n}return null!==e.keys},pki.rsa.generateKeyPair=function(e,t,r,n){if(1===arguments.length?"object"==typeof e?(r=e,e=void 0):"function"==typeof e&&(n=e,e=void 0):2===arguments.length?"number"==typeof e?"function"==typeof t?(n=t,t=void 0):"number"!=typeof t&&(r=t,t=void 0):(r=e,n=t,e=void 0,t=void 0):3===arguments.length&&("number"==typeof t?"function"==typeof r&&(n=r,r=void 0):(n=r,r=t,t=void 0)),r=r||{},void 0===e&&(e=r.bits||2048),void 0===t&&(t=r.e||65537),!forge.options.usePureJavaScript&&!r.prng&&e>=256&&e<=16384&&(65537===t||3===t))if(n){if(_detectNodeCrypto("generateKeyPair"))return _crypto.generateKeyPair("rsa",{modulusLength:e,publicExponent:t,publicKeyEncoding:{type:"spki",format:"pem"},privateKeyEncoding:{type:"pkcs8",format:"pem"}},(function(e,t,r){if(e)return n(e);n(null,{privateKey:pki.privateKeyFromPem(r),publicKey:pki.publicKeyFromPem(t)})}));if(_detectSubtleCrypto("generateKey")&&_detectSubtleCrypto("exportKey"))return util.globalScope.crypto.subtle.generateKey({name:"RSASSA-PKCS1-v1_5",modulusLength:e,publicExponent:_intToUint8Array(t),hash:{name:"SHA-256"}},!0,["sign","verify"]).then((function(e){return util.globalScope.crypto.subtle.exportKey("pkcs8",e.privateKey)})).then(void 0,(function(e){n(e)})).then((function(e){if(e){var t=pki.privateKeyFromAsn1(asn1.fromDer(forge.util.createBuffer(e)));n(null,{privateKey:t,publicKey:pki.setRsaPublicKey(t.n,t.e)})}}));if(_detectSubtleMsCrypto("generateKey")&&_detectSubtleMsCrypto("exportKey")){var a=util.globalScope.msCrypto.subtle.generateKey({name:"RSASSA-PKCS1-v1_5",modulusLength:e,publicExponent:_intToUint8Array(t),hash:{name:"SHA-256"}},!0,["sign","verify"]);return a.oncomplete=function(e){var t=e.target.result,r=util.globalScope.msCrypto.subtle.exportKey("pkcs8",t.privateKey);r.oncomplete=function(e){var t=e.target.result,r=pki.privateKeyFromAsn1(asn1.fromDer(forge.util.createBuffer(t)));n(null,{privateKey:r,publicKey:pki.setRsaPublicKey(r.n,r.e)})},r.onerror=function(e){n(e)}},void(a.onerror=function(e){n(e)})}}else if(_detectNodeCrypto("generateKeyPairSync")){var s=_crypto.generateKeyPairSync("rsa",{modulusLength:e,publicExponent:t,publicKeyEncoding:{type:"spki",format:"pem"},privateKeyEncoding:{type:"pkcs8",format:"pem"}});return{privateKey:pki.privateKeyFromPem(s.privateKey),publicKey:pki.publicKeyFromPem(s.publicKey)}}var i=pki.rsa.createKeyPairGenerationState(e,t,r);if(!n)return pki.rsa.stepKeyPairGenerationState(i,0),i.keys;_generateKeyPair(i,r,n)},pki.setRsaPublicKey=pki.rsa.setPublicKey=function(e,t){var r={n:e,e:t,encrypt:function(e,t,n){if("string"==typeof t?t=t.toUpperCase():void 0===t&&(t="RSAES-PKCS1-V1_5"),"RSAES-PKCS1-V1_5"===t)t={encode:function(e,t,r){return _encodePkcs1_v1_5(e,t,2).getBytes()}};else if("RSA-OAEP"===t||"RSAES-OAEP"===t)t={encode:function(e,t){return forge.pkcs1.encode_rsa_oaep(t,e,n)}};else if(-1!==["RAW","NONE","NULL",null].indexOf(t))t={encode:function(e){return e}};else if("string"==typeof t)throw new Error('Unsupported encryption scheme: "'+t+'".');var a=t.encode(e,r,!0);return pki.rsa.encrypt(a,r,!0)},verify:function(e,t,n,a){"string"==typeof n?n=n.toUpperCase():void 0===n&&(n="RSASSA-PKCS1-V1_5"),void 0===a&&(a={_parseAllDigestBytes:!0}),"_parseAllDigestBytes"in a||(a._parseAllDigestBytes=!0),"RSASSA-PKCS1-V1_5"===n?n={verify:function(e,t){t=_decodePkcs1_v1_5(t,r,!0);var n=asn1.fromDer(t,{parseAllBytes:a._parseAllDigestBytes}),s={},i=[];if(!asn1.validate(n,digestInfoValidator,s,i))throw(o=new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 DigestInfo value.")).errors=i,o;var o,p=asn1.derToOid(s.algorithmIdentifier);if(p!==forge.oids.md2&&p!==forge.oids.md5&&p!==forge.oids.sha1&&p!==forge.oids.sha224&&p!==forge.oids.sha256&&p!==forge.oids.sha384&&p!==forge.oids.sha512&&p!==forge.oids["sha512-224"]&&p!==forge.oids["sha512-256"])throw(o=new Error("Unknown RSASSA-PKCS1-v1_5 DigestAlgorithm identifier.")).oid=p,o;if((p===forge.oids.md2||p===forge.oids.md5)&&!("parameters"in s))throw new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 DigestInfo value. Missing algorithm identifer NULL parameters.");return e===s.digest}}:"NONE"!==n&&"NULL"!==n&&null!==n||(n={verify:function(e,t){return e===(t=_decodePkcs1_v1_5(t,r,!0))}});var s=pki.rsa.decrypt(t,r,!0,!1);return n.verify(e,s,r.n.bitLength())}};return r},pki.setRsaPrivateKey=pki.rsa.setPrivateKey=function(e,t,r,n,a,s,i,o){var p={n:e,e:t,d:r,p:n,q:a,dP:s,dQ:i,qInv:o,decrypt:function(e,t,r){"string"==typeof t?t=t.toUpperCase():void 0===t&&(t="RSAES-PKCS1-V1_5");var n=pki.rsa.decrypt(e,p,!1,!1);if("RSAES-PKCS1-V1_5"===t)t={decode:_decodePkcs1_v1_5};else if("RSA-OAEP"===t||"RSAES-OAEP"===t)t={decode:function(e,t){return forge.pkcs1.decode_rsa_oaep(t,e,r)}};else{if(-1===["RAW","NONE","NULL",null].indexOf(t))throw new Error('Unsupported encryption scheme: "'+t+'".');t={decode:function(e){return e}}}return t.decode(n,p,!1)},sign:function(e,t){var r=!1;"string"==typeof t&&(t=t.toUpperCase()),void 0===t||"RSASSA-PKCS1-V1_5"===t?(t={encode:emsaPkcs1v15encode},r=1):"NONE"!==t&&"NULL"!==t&&null!==t||(t={encode:function(){return e}},r=1);var n=t.encode(e,p.n.bitLength());return pki.rsa.encrypt(n,p,r)}};return p},pki.wrapRsaPrivateKey=function(e){return asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,asn1.integerToDer(0).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.rsaEncryption).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.NULL,!1,"")]),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OCTETSTRING,!1,asn1.toDer(e).getBytes())])},pki.privateKeyFromAsn1=function(e){var t,r,n,a,s,i,o,p,l={},u=[];if(asn1.validate(e,privateKeyValidator,l,u)&&(e=asn1.fromDer(forge.util.createBuffer(l.privateKey))),l={},u=[],!asn1.validate(e,rsaPrivateKeyValidator,l,u)){var c=new Error("Cannot read private key. ASN.1 object does not contain an RSAPrivateKey.");throw c.errors=u,c}return t=forge.util.createBuffer(l.privateKeyModulus).toHex(),r=forge.util.createBuffer(l.privateKeyPublicExponent).toHex(),n=forge.util.createBuffer(l.privateKeyPrivateExponent).toHex(),a=forge.util.createBuffer(l.privateKeyPrime1).toHex(),s=forge.util.createBuffer(l.privateKeyPrime2).toHex(),i=forge.util.createBuffer(l.privateKeyExponent1).toHex(),o=forge.util.createBuffer(l.privateKeyExponent2).toHex(),p=forge.util.createBuffer(l.privateKeyCoefficient).toHex(),pki.setRsaPrivateKey(new BigInteger(t,16),new BigInteger(r,16),new BigInteger(n,16),new BigInteger(a,16),new BigInteger(s,16),new BigInteger(i,16),new BigInteger(o,16),new BigInteger(p,16))},pki.privateKeyToAsn1=pki.privateKeyToRSAPrivateKey=function(e){return asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,asn1.integerToDer(0).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.n)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.e)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.d)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.p)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.q)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.dP)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.dQ)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.qInv))])},pki.publicKeyFromAsn1=function(e){var t={},r=[];if(asn1.validate(e,publicKeyValidator,t,r)){var n,a=asn1.derToOid(t.publicKeyOid);if(a!==pki.oids.rsaEncryption)throw(n=new Error("Cannot read public key. Unknown OID.")).oid=a,n;e=t.rsaPublicKey}if(r=[],!asn1.validate(e,rsaPublicKeyValidator,t,r))throw(n=new Error("Cannot read public key. ASN.1 object does not contain an RSAPublicKey.")).errors=r,n;var s=forge.util.createBuffer(t.publicKeyModulus).toHex(),i=forge.util.createBuffer(t.publicKeyExponent).toHex();return pki.setRsaPublicKey(new BigInteger(s,16),new BigInteger(i,16))},pki.publicKeyToAsn1=pki.publicKeyToSubjectPublicKeyInfo=function(e){return asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.OID,!1,asn1.oidToDer(pki.oids.rsaEncryption).getBytes()),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.NULL,!1,"")]),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.BITSTRING,!1,[pki.publicKeyToRSAPublicKey(e)])])},pki.publicKeyToRSAPublicKey=function(e){return asn1.create(asn1.Class.UNIVERSAL,asn1.Type.SEQUENCE,!0,[asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.n)),asn1.create(asn1.Class.UNIVERSAL,asn1.Type.INTEGER,!1,_bnToBytes(e.e))])};