"use strict";const MessageParser=require("./message-parser"),RelaxedBody=require("./relaxed-body"),sign=require("./sign"),PassThrough=require("stream").PassThrough,fs=require("fs"),path=require("path"),crypto=require("crypto"),DKIM_ALGO="sha256",MAX_MESSAGE_SIZE=131072;class DKIMSigner{constructor(e,t,s,h){this.options=e||{},this.keys=t,this.cacheTreshold=Number(this.options.cacheTreshold)||131072,this.hashAlgo=this.options.hashAlgo||"sha256",this.cacheDir=this.options.cacheDir||!1,this.chunks=[],this.chunklen=0,this.readPos=0,this.cachePath=!!this.cacheDir&&path.join(this.cacheDir,"message."+Date.now()+"-"+crypto.randomBytes(14).toString("hex")),this.cache=!1,this.headers=!1,this.bodyHash=!1,this.parser=!1,this.relaxedBody=!1,this.input=s,this.output=h,this.output.usingCache=!1,this.hasErrored=!1,this.input.on("error",(e=>{this.hasErrored=!0,this.cleanup(),h.emit("error",e)}))}cleanup(){this.cache&&this.cachePath&&fs.unlink(this.cachePath,(()=>!1))}createReadCache(){this.cache=fs.createReadStream(this.cachePath),this.cache.once("error",(e=>{this.cleanup(),this.output.emit("error",e)})),this.cache.once("close",(()=>{this.cleanup()})),this.cache.pipe(this.output)}sendNextChunk(){if(this.hasErrored)return;if(this.readPos>=this.chunks.length)return this.cache?this.createReadCache():this.output.end();let e=this.chunks[this.readPos++];if(!1===this.output.write(e))return this.output.once("drain",(()=>{this.sendNextChunk()}));setImmediate((()=>this.sendNextChunk()))}sendSignedOutput(){let e=0,t=()=>{if(e>=this.keys.length)return this.output.write(this.parser.rawHeaders),setImmediate((()=>this.sendNextChunk()));let s=this.keys[e++],h=sign(this.headers,this.hashAlgo,this.bodyHash,{domainName:s.domainName,keySelector:s.keySelector,privateKey:s.privateKey,headerFieldNames:this.options.headerFieldNames,skipFields:this.options.skipFields});return h&&this.output.write(Buffer.from(h+"\r\n")),setImmediate(t)};if(this.bodyHash&&this.headers)return t();this.output.write(this.parser.rawHeaders),this.sendNextChunk()}createWriteCache(){this.output.usingCache=!0,this.cache=fs.createWriteStream(this.cachePath),this.cache.once("error",(e=>{this.cleanup(),this.relaxedBody.unpipe(this.cache),this.relaxedBody.on("readable",(()=>{for(;null!==this.relaxedBody.read(););})),this.hasErrored=!0,this.output.emit("error",e)})),this.cache.once("close",(()=>{this.sendSignedOutput()})),this.relaxedBody.removeAllListeners("readable"),this.relaxedBody.pipe(this.cache)}signStream(){this.parser=new MessageParser,this.relaxedBody=new RelaxedBody({hashAlgo:this.hashAlgo}),this.parser.on("headers",(e=>{this.headers=e})),this.relaxedBody.on("hash",(e=>{this.bodyHash=e})),this.relaxedBody.on("readable",(()=>{let e;if(!this.cache)for(;null!==(e=this.relaxedBody.read());)if(this.chunks.push(e),this.chunklen+=e.length,this.chunklen>=this.cacheTreshold&&this.cachePath)return this.createWriteCache()})),this.relaxedBody.on("end",(()=>{this.cache||this.sendSignedOutput()})),this.parser.pipe(this.relaxedBody),setImmediate((()=>this.input.pipe(this.parser)))}}class DKIM{constructor(e){this.options=e||{},this.keys=[].concat(this.options.keys||{domainName:e.domainName,keySelector:e.keySelector,privateKey:e.privateKey})}sign(e,t){let s=new PassThrough,h=e,i=!1;Buffer.isBuffer(e)?(i=e,h=new PassThrough):"string"==typeof e&&(i=Buffer.from(e),h=new PassThrough);let r=this.options;t&&Object.keys(t).length&&(r={},Object.keys(this.options||{}).forEach((e=>{r[e]=this.options[e]})),Object.keys(t||{}).forEach((e=>{e in r||(r[e]=t[e])})));let a=new DKIMSigner(r,this.keys,h,s);return setImmediate((()=>{a.signStream(),i&&setImmediate((()=>{h.end(i)}))})),s}}module.exports=DKIM;