"use strict";const EventEmitter=require("events"),shared=require("../shared"),mimeTypes=require("../mime-funcs/mime-types"),MailComposer=require("../mail-composer"),DKIM=require("../dkim"),httpProxyClient=require("../smtp-connection/http-proxy-client"),util=require("util"),urllib=require("url"),packageData=require("../../package.json"),MailMessage=require("./mail-message"),net=require("net"),dns=require("dns"),crypto=require("crypto");class Mail extends EventEmitter{constructor(t,e,s){super(),this.options=e||{},this._defaults=s||{},this._defaultPlugins={compile:[(...t)=>this._convertDataImages(...t)],stream:[]},this._userPlugins={compile:[],stream:[]},this.meta=new Map,this.dkim=!!this.options.dkim&&new DKIM(this.options.dkim),this.transporter=t,this.transporter.mailer=this,this.logger=shared.getLogger(this.options,{component:this.options.component||"mail"}),this.logger.debug({tnx:"create"},"Creating transport: %s",this.getVersionString()),"function"==typeof this.transporter.on&&(this.transporter.on("log",(t=>{this.logger.debug({tnx:"transport"},"%s: %s",t.type,t.message)})),this.transporter.on("error",(t=>{this.logger.error({err:t,tnx:"transport"},"Transport Error: %s",t.message),this.emit("error",t)})),this.transporter.on("idle",((...t)=>{this.emit("idle",...t)}))),["close","isIdle","verify"].forEach((t=>{this[t]=(...e)=>"function"==typeof this.transporter[t]?("verify"===t&&"function"==typeof this.getSocket&&(this.transporter.getSocket=this.getSocket,this.getSocket=!1),this.transporter[t](...e)):(this.logger.warn({tnx:"transport",methodName:t},"Non existing method %s called for transport",t),!1)})),this.options.proxy&&"string"==typeof this.options.proxy&&this.setupProxy(this.options.proxy)}use(t,e){return t=(t||"").toString(),this._userPlugins.hasOwnProperty(t)?this._userPlugins[t].push(e):this._userPlugins[t]=[e],this}sendMail(t,e=null){let s;e||(s=new Promise(((t,s)=>{e=shared.callbackPromise(t,s)}))),"function"==typeof this.getSocket&&(this.transporter.getSocket=this.getSocket,this.getSocket=!1);let r=new MailMessage(this,t);return this.logger.debug({tnx:"transport",name:this.transporter.name,version:this.transporter.version,action:"send"},"Sending mail using %s/%s",this.transporter.name,this.transporter.version),this._processPlugins("compile",r,(t=>{if(t)return this.logger.error({err:t,tnx:"plugin",action:"compile"},"PluginCompile Error: %s",t.message),e(t);r.message=new MailComposer(r.data).compile(),r.setMailerHeader(),r.setPriorityHeaders(),r.setListHeaders(),this._processPlugins("stream",r,(t=>{if(t)return this.logger.error({err:t,tnx:"plugin",action:"stream"},"PluginStream Error: %s",t.message),e(t);(r.data.dkim||this.dkim)&&r.message.processFunc((t=>{let e=r.data.dkim?new DKIM(r.data.dkim):this.dkim;return this.logger.debug({tnx:"DKIM",messageId:r.message.messageId(),dkimDomains:e.keys.map((t=>t.keySelector+"."+t.domainName)).join(", ")},"Signing outgoing message with %s keys",e.keys.length),e.sign(t,r.data._dkim)})),this.transporter.send(r,((...t)=>{t[0]&&this.logger.error({err:t[0],tnx:"transport",action:"send"},"Send Error: %s",t[0].message),e(...t)}))}))})),s}getVersionString(){return util.format("%s (%s; +%s; %s/%s)",packageData.name,packageData.version,packageData.homepage,this.transporter.name,this.transporter.version)}_processPlugins(t,e,s){if(t=(t||"").toString(),!this._userPlugins.hasOwnProperty(t))return s();let r=this._userPlugins[t]||[],i=this._defaultPlugins[t]||[];if(r.length&&this.logger.debug({tnx:"transaction",pluginCount:r.length,step:t},"Using %s plugins for %s",r.length,t),r.length+i.length===0)return s();let o=0,n="default",a=()=>{let t="default"===n?i:r;if(o>=t.length){if("default"!==n||!r.length)return s();n="user",o=0,t=r}(0,t[o++])(e,(t=>{if(t)return s(t);a()}))};a()}setupProxy(t){let e=urllib.parse(t);this.getSocket=(t,s)=>{let r=e.protocol.replace(/:$/,"").toLowerCase();if(this.meta.has("proxy_handler_"+r))return this.meta.get("proxy_handler_"+r)(e,t,s);switch(r){case"http":case"https":return void httpProxyClient(e.href,t.port,t.host,((t,e)=>t?s(t):s(null,{connection:e})));case"socks":case"socks5":case"socks4":case"socks4a":{if(!this.meta.has("proxy_socks_module"))return s(new Error("Socks module not loaded"));let r=r=>{let i=!!this.meta.get("proxy_socks_module").SocksClient,o=i?this.meta.get("proxy_socks_module").SocksClient:this.meta.get("proxy_socks_module"),n=Number(e.protocol.replace(/\D/g,""))||5,a={proxy:{ipaddress:r,port:Number(e.port),type:n},[i?"destination":"target"]:{host:t.host,port:t.port},command:"connect"};if(e.auth){let t=decodeURIComponent(e.auth.split(":").shift()),s=decodeURIComponent(e.auth.split(":").pop());i?(a.proxy.userId=t,a.proxy.password=s):4===n?a.userid=t:a.authentication={username:t,password:s}}o.createConnection(a,((t,e)=>t?s(t):s(null,{connection:e.socket||e})))};return net.isIP(e.hostname)?r(e.hostname):dns.resolve(e.hostname,((t,e)=>{if(t)return s(t);r(Array.isArray(e)?e[0]:e)}))}}s(new Error("Unknown proxy configuration"))}}_convertDataImages(t,e){if(!this.options.attachDataUrls&&!t.data.attachDataUrls||!t.data.html)return e();t.resolveContent(t.data,"html",((s,r)=>{if(s)return e(s);let i=0;r=(r||"").toString().replace(/(<img\b[^<>]{0,1024} src\s{0,20}=[\s"']{0,20})(data:([^;]+);[^"'>\s]+)/gi,((e,s,r,o)=>{let n=crypto.randomBytes(10).toString("hex")+"@localhost";return t.data.attachments||(t.data.attachments=[]),Array.isArray(t.data.attachments)||(t.data.attachments=[].concat(t.data.attachments||[])),t.data.attachments.push({path:r,cid:n,filename:"image-"+ ++i+"."+mimeTypes.detectExtension(o)}),s+"cid:"+n})),t.data.html=r,e()}))}set(t,e){return this.meta.set(t,e)}get(t){return this.meta.get(t)}}module.exports=Mail;