"use strict";const crypto=require("crypto"),fs=require("fs"),punycode=require("../punycode"),PassThrough=require("stream").PassThrough,shared=require("../shared"),mimeFuncs=require("../mime-funcs"),qp=require("../qp"),base64=require("../base64"),addressparser=require("../addressparser"),nmfetch=require("../fetch"),LastNewline=require("./last-newline"),LeWindows=require("./le-windows"),LeUnix=require("./le-unix");class MimeNode{constructor(e,t){this.nodeCounter=0,t=t||{},this.baseBoundary=t.baseBoundary||crypto.randomBytes(8).toString("hex"),this.boundaryPrefix=t.boundaryPrefix||"--_NmP",this.disableFileAccess=!!t.disableFileAccess,this.disableUrlAccess=!!t.disableUrlAccess,this.normalizeHeaderKey=t.normalizeHeaderKey,this.date=new Date,this.rootNode=t.rootNode||this,this.keepBcc=!!t.keepBcc,t.filename&&(this.filename=t.filename,e||(e=mimeFuncs.detectMimeType(this.filename.split(".").pop()))),this.textEncoding=(t.textEncoding||"").toString().trim().charAt(0).toUpperCase(),this.parentNode=t.parentNode,this.hostname=t.hostname,this.newline=t.newline,this.childNodes=[],this._nodeId=++this.rootNode.nodeCounter,this._headers=[],this._isPlainText=!1,this._hasLongLines=!1,this._envelope=!1,this._raw=!1,this._transforms=[],this._processFuncs=[],e&&this.setHeader("Content-Type",e)}createChild(e,t){t||"object"!=typeof e||(t=e,e=void 0);let r=new MimeNode(e,t);return this.appendChild(r),r}appendChild(e){return e.rootNode!==this.rootNode&&(e.rootNode=this.rootNode,e._nodeId=++this.rootNode.nodeCounter),e.parentNode=this,this.childNodes.push(e),e}replace(e){return e===this?this:(this.parentNode.childNodes.forEach(((t,r)=>{t===this&&(e.rootNode=this.rootNode,e.parentNode=this.parentNode,e._nodeId=this._nodeId,this.rootNode=this,this.parentNode=void 0,e.parentNode.childNodes[r]=e)})),e)}remove(){if(!this.parentNode)return this;for(let e=this.parentNode.childNodes.length-1;e>=0;e--)if(this.parentNode.childNodes[e]===this)return this.parentNode.childNodes.splice(e,1),this.parentNode=void 0,this.rootNode=this,this}setHeader(e,t){let r,s=!1;if(!t&&e&&"object"==typeof e)return e.key&&"value"in e?this.setHeader(e.key,e.value):Array.isArray(e)?e.forEach((e=>{this.setHeader(e.key,e.value)})):Object.keys(e).forEach((t=>{this.setHeader(t,e[t])})),this;r={key:e=this._normalizeHeaderKey(e),value:t};for(let t=0,n=this._headers.length;t<n;t++)this._headers[t].key===e&&(s?(this._headers.splice(t,1),t--,n--):(this._headers[t]=r,s=!0));return s||this._headers.push(r),this}addHeader(e,t){return!t&&e&&"object"==typeof e?(e.key&&e.value?this.addHeader(e.key,e.value):Array.isArray(e)?e.forEach((e=>{this.addHeader(e.key,e.value)})):Object.keys(e).forEach((t=>{this.addHeader(t,e[t])})),this):Array.isArray(t)?(t.forEach((t=>{this.addHeader(e,t)})),this):(this._headers.push({key:this._normalizeHeaderKey(e),value:t}),this)}getHeader(e){e=this._normalizeHeaderKey(e);for(let t=0,r=this._headers.length;t<r;t++)if(this._headers[t].key===e)return this._headers[t].value}setContent(e){return this.content=e,"function"==typeof this.content.pipe?(this._contentErrorHandler=e=>{this.content.removeListener("error",this._contentErrorHandler),this.content=e},this.content.once("error",this._contentErrorHandler)):"string"==typeof this.content&&(this._isPlainText=mimeFuncs.isPlainText(this.content),this._isPlainText&&mimeFuncs.hasLongerLines(this.content,76)&&(this._hasLongLines=!0)),this}build(e){let t;e||(t=new Promise(((t,r)=>{e=shared.callbackPromise(t,r)})));let r=this.createReadStream(),s=[],n=0,i=!1;return r.on("readable",(()=>{let e;for(;null!==(e=r.read());)s.push(e),n+=e.length})),r.once("error",(t=>{if(!i)return i=!0,e(t)})),r.once("end",(t=>{if(!i)return i=!0,t&&t.length&&(s.push(t),n+=t.length),e(null,Buffer.concat(s,n))})),t}getTransferEncoding(){let e=!1,t=(this.getHeader("Content-Type")||"").toString().toLowerCase().trim();return this.content&&(e=(this.getHeader("Content-Transfer-Encoding")||"").toString().toLowerCase().trim(),e&&["base64","quoted-printable"].includes(e)||(/^text\//i.test(t)?e=this._isPlainText&&!this._hasLongLines?"7bit":"string"==typeof this.content||this.content instanceof Buffer?"Q"===this._getTextEncoding(this.content)?"quoted-printable":"base64":"B"===this.textEncoding?"base64":"quoted-printable":/^(multipart|message)\//i.test(t)||(e=e||"base64"))),e}buildHeaders(){let e=this.getTransferEncoding(),t=[];if(e&&this.setHeader("Content-Transfer-Encoding",e),this.filename&&!this.getHeader("Content-Disposition")&&this.setHeader("Content-Disposition","attachment"),this.rootNode===this){this.getHeader("Date")||this.setHeader("Date",this.date.toUTCString().replace(/GMT/,"+0000")),this.messageId(),this.getHeader("MIME-Version")||this.setHeader("MIME-Version","1.0");for(let e=this._headers.length-2;e>=0;e--){let t=this._headers[e];"Content-Type"===t.key&&(this._headers.splice(e,1),this._headers.push(t))}}return this._headers.forEach((e=>{let r,s,n=e.key,i=e.value,o={};if(!i||"object"!=typeof i||["From","Sender","To","Cc","Bcc","Reply-To","Date","References"].includes(n)||(Object.keys(i).forEach((e=>{"value"!==e&&(o[e]=i[e])})),i=(i.value||"").toString(),i.trim()))if(o.prepared)o.foldLines?t.push(mimeFuncs.foldLines(n+": "+i)):t.push(n+": "+i);else{switch(e.key){case"Content-Disposition":r=mimeFuncs.parseHeaderValue(i),this.filename&&(r.params.filename=this.filename),i=mimeFuncs.buildHeaderValue(r);break;case"Content-Type":r=mimeFuncs.parseHeaderValue(i),this._handleContentType(r),r.value.match(/^text\/plain\b/)&&"string"==typeof this.content&&/[\u0080-\uFFFF]/.test(this.content)&&(r.params.charset="utf-8"),i=mimeFuncs.buildHeaderValue(r),this.filename&&(s=this._encodeWords(this.filename),(s!==this.filename||/[\s'"\\;:/=(),<>@[\]?]|^-/.test(s))&&(s='"'+s+'"'),i+="; name="+s);break;case"Bcc":if(!this.keepBcc)return}if(i=this._encodeHeaderValue(n,i),(i||"").toString().trim()){if("function"==typeof this.normalizeHeaderKey){let e=this.normalizeHeaderKey(n,i);e&&"string"==typeof e&&e.length&&(n=e)}t.push(mimeFuncs.foldLines(n+": "+i,76))}}})),t.join("\r\n")}createReadStream(e){let t,r=new PassThrough(e=e||{}),s=r;this.stream(r,e,(e=>{e?s.emit("error",e):r.end()}));for(let e=0,r=this._transforms.length;e<r;e++)t="function"==typeof this._transforms[e]?this._transforms[e]():this._transforms[e],s.once("error",(e=>{t.emit("error",e)})),s=s.pipe(t);t=new LastNewline,s.once("error",(e=>{t.emit("error",e)})),s=s.pipe(t);for(let e=0,r=this._processFuncs.length;e<r;e++)t=this._processFuncs[e],s=t(s);if(this.newline){const e=["win","windows","dos","\r\n"].includes(this.newline.toString().toLowerCase())?new LeWindows:new LeUnix,t=s.pipe(e);return s.on("error",(e=>t.emit("error",e))),t}return s}transform(e){this._transforms.push(e)}processFunc(e){this._processFuncs.push(e)}stream(e,t,r){let s,n,i=this.getTransferEncoding(),o=!1,a=e=>{o||(o=!0,r(e))},h=()=>{let r=0,s=()=>{if(r>=this.childNodes.length)return e.write("\r\n--"+this.boundary+"--\r\n"),a();let n=this.childNodes[r++];e.write((r>1?"\r\n":"")+"--"+this.boundary+"\r\n"),n.stream(e,t,(e=>{if(e)return a(e);setImmediate(s)}))};if(!this.multipart)return a();setImmediate(s)},d=()=>{if(!this.content)return setImmediate(h);{if("[object Error]"===Object.prototype.toString.call(this.content))return a(this.content);"function"==typeof this.content.pipe&&(this.content.removeListener("error",this._contentErrorHandler),this._contentErrorHandler=e=>a(e),this.content.once("error",this._contentErrorHandler));let r=()=>{["quoted-printable","base64"].includes(i)?(s=new("base64"===i?base64:qp).Encoder(t),s.pipe(e,{end:!1}),s.once("end",h),s.once("error",(e=>a(e))),n=this._getStream(this.content),n.pipe(s)):(n=this._getStream(this.content),n.pipe(e,{end:!1}),n.once("end",h)),n.once("error",(e=>a(e)))};if(this.content._resolve){let e=[],t=0,s=!1,n=this._getStream(this.content);n.on("error",(e=>{s||(s=!0,a(e))})),n.on("readable",(()=>{let r;for(;null!==(r=n.read());)e.push(r),t+=r.length})),n.on("end",(()=>{s||(s=!0,this.content._resolve=!1,this.content._resolvedValue=Buffer.concat(e,t),setImmediate(r))}))}else setImmediate(r)}};this._raw?setImmediate((()=>{if("[object Error]"===Object.prototype.toString.call(this._raw))return a(this._raw);"function"==typeof this._raw.pipe&&this._raw.removeListener("error",this._contentErrorHandler);let t=this._getStream(this._raw);t.pipe(e,{end:!1}),t.on("error",(t=>e.emit("error",t))),t.on("end",h)})):(e.write(this.buildHeaders()+"\r\n\r\n"),setImmediate(d))}setEnvelope(e){let t;this._envelope={from:!1,to:[]},e.from&&(t=[],this._convertAddresses(this._parseAddresses(e.from),t),t=t.filter((e=>e&&e.address)),t.length&&t[0]&&(this._envelope.from=t[0].address)),["to","cc","bcc"].forEach((t=>{e[t]&&this._convertAddresses(this._parseAddresses(e[t]),this._envelope.to)})),this._envelope.to=this._envelope.to.map((e=>e.address)).filter((e=>e));let r=["to","cc","bcc","from"];return Object.keys(e).forEach((t=>{r.includes(t)||(this._envelope[t]=e[t])})),this}getAddresses(){let e={};return this._headers.forEach((t=>{let r=t.key.toLowerCase();["from","sender","reply-to","to","cc","bcc"].includes(r)&&(Array.isArray(e[r])||(e[r]=[]),this._convertAddresses(this._parseAddresses(t.value),e[r]))})),e}getEnvelope(){if(this._envelope)return this._envelope;let e={from:!1,to:[]};return this._headers.forEach((t=>{let r=[];"From"===t.key||!e.from&&["Reply-To","Sender"].includes(t.key)?(this._convertAddresses(this._parseAddresses(t.value),r),r.length&&r[0]&&(e.from=r[0].address)):["To","Cc","Bcc"].includes(t.key)&&this._convertAddresses(this._parseAddresses(t.value),e.to)})),e.to=e.to.map((e=>e.address)),e}messageId(){let e=this.getHeader("Message-ID");return e||(e=this._generateMessageId(),this.setHeader("Message-ID",e)),e}setRaw(e){return this._raw=e,this._raw&&"function"==typeof this._raw.pipe&&(this._contentErrorHandler=e=>{this._raw.removeListener("error",this._contentErrorHandler),this._raw=e},this._raw.once("error",this._contentErrorHandler)),this}_getStream(e){let t;return e._resolvedValue?(t=new PassThrough,setImmediate((()=>{try{t.end(e._resolvedValue)}catch(e){t.emit("error",e)}})),t):"function"==typeof e.pipe?e:e&&"string"==typeof e.path&&!e.href?this.disableFileAccess?(t=new PassThrough,setImmediate((()=>t.emit("error",new Error("File access rejected for "+e.path)))),t):fs.createReadStream(e.path):e&&"string"==typeof e.href?this.disableUrlAccess?(t=new PassThrough,setImmediate((()=>t.emit("error",new Error("Url access rejected for "+e.href)))),t):nmfetch(e.href,{headers:e.httpHeaders}):(t=new PassThrough,setImmediate((()=>{try{t.end(e||"")}catch(e){t.emit("error",e)}})),t)}_parseAddresses(e){return[].concat.apply([],[].concat(e).map((e=>e&&e.address?(e.address=this._normalizeAddress(e.address),e.name=e.name||"",[e]):addressparser(e))))}_normalizeHeaderKey(e){return e=(e||"").toString().replace(/\r?\n|\r/g," ").trim().toLowerCase().replace(/^X-SMTPAPI$|^(MIME|DKIM|ARC|BIMI)\b|^[a-z]|-(SPF|FBL|ID|MD5)$|-[a-z]/gi,(e=>e.toUpperCase())).replace(/^Content-Features$/i,"Content-features")}_handleContentType(e){this.contentType=e.value.trim().toLowerCase(),this.multipart=!!/^multipart\//i.test(this.contentType)&&this.contentType.substr(this.contentType.indexOf("/")+1),this.multipart?this.boundary=e.params.boundary=e.params.boundary||this.boundary||this._generateBoundary():this.boundary=!1}_generateBoundary(){return this.rootNode.boundaryPrefix+"-"+this.rootNode.baseBoundary+"-Part_"+this._nodeId}_encodeHeaderValue(e,t){switch(e=this._normalizeHeaderKey(e)){case"From":case"Sender":case"To":case"Cc":case"Bcc":case"Reply-To":return this._convertAddresses(this._parseAddresses(t));case"Message-ID":case"In-Reply-To":case"Content-Id":return"<"!==(t=(t||"").toString().replace(/\r?\n|\r/g," ")).charAt(0)&&(t="<"+t),">"!==t.charAt(t.length-1)&&(t+=">"),t;case"References":return(t=[].concat.apply([],[].concat(t||"").map((e=>(e=(e||"").toString().replace(/\r?\n|\r/g," ").trim()).replace(/<[^>]*>/g,(e=>e.replace(/\s/g,""))).split(/\s+/)))).map((e=>("<"!==e.charAt(0)&&(e="<"+e),">"!==e.charAt(e.length-1)&&(e+=">"),e)))).join(" ").trim();case"Date":return"[object Date]"===Object.prototype.toString.call(t)?t.toUTCString().replace(/GMT/,"+0000"):(t=(t||"").toString().replace(/\r?\n|\r/g," "),this._encodeWords(t));case"Content-Type":case"Content-Disposition":return(t||"").toString().replace(/\r?\n|\r/g," ");default:return t=(t||"").toString().replace(/\r?\n|\r/g," "),this._encodeWords(t)}}_convertAddresses(e,t){let r=[];return t=t||[],[].concat(e||[]).forEach((e=>{if(e.address)e.address=this._normalizeAddress(e.address),e.name?e.name&&r.push(`${this._encodeAddressName(e.name)} <${e.address}>`):r.push(e.address.indexOf(" ")>=0?`<${e.address}>`:`${e.address}`),e.address&&(t.filter((t=>t.address===e.address)).length||t.push(e));else if(e.group){let s=(e.group.length?this._convertAddresses(e.group,t):"").trim();r.push(`${this._encodeAddressName(e.name)}:${s};`)}})),r.join(", ")}_normalizeAddress(e){let t=(e=(e||"").toString().replace(/[\x00-\x1F<>]+/g," ").trim()).lastIndexOf("@");if(t<0)return e;let r,s=e.substr(0,t),n=e.substr(t+1);try{r=punycode.toASCII(n.toLowerCase())}catch(e){}return s.indexOf(" ")>=0&&('"'!==s.charAt(0)&&(s='"'+s),'"'!==s.substr(-1)&&(s+='"')),`${s}@${r}`}_encodeAddressName(e){return/^[\w ]*$/.test(e)?e:/^[\x20-\x7e]*$/.test(e)?'"'+e.replace(/([\\"])/g,"\\$1")+'"':mimeFuncs.encodeWord(e,this._getTextEncoding(e),52)}_encodeWords(e){return mimeFuncs.encodeWords(e,this._getTextEncoding(e),52,!0)}_getTextEncoding(e){e=(e||"").toString();let t,r,s=this.textEncoding;return s||(r=(e.match(/[\x00-\x08\x0B\x0C\x0E-\x1F\u0080-\uFFFF]/g)||[]).length,t=(e.match(/[a-z]/gi)||[]).length,s=r<t?"Q":"B"),s}_generateMessageId(){return"<"+[2,2,2,6].reduce(((e,t)=>e+"-"+crypto.randomBytes(t).toString("hex")),crypto.randomBytes(4).toString("hex"))+"@"+(this.getEnvelope().from||this.hostname||"localhost").split("@").pop()+">"}}module.exports=MimeNode;