"use strict";const EventEmitter=require("events"),packageData=require("../../package.json"),shared=require("../shared"),LeWindows=require("../mime-node/le-windows");class SESTransport extends EventEmitter{constructor(e){super(),e=e||{},this.options=e||{},this.ses=this.options.SES,this.name="SESTransport",this.version=packageData.version,this.logger=shared.getLogger(this.options,{component:this.options.component||"ses-transport"}),this.maxConnections=Number(this.options.maxConnections)||1/0,this.connections=0,this.sendingRate=Number(this.options.sendingRate)||1/0,this.sendingRateTTL=null,this.rateInterval=1e3,this.rateMessages=[],this.pending=[],this.idling=!0,setImmediate((()=>{this.idling&&this.emit("idle")}))}send(e,s){return this.connections>=this.maxConnections?(this.idling=!1,this.pending.push({mail:e,callback:s})):this._checkSendingRate()?void this._send(e,((...e)=>{setImmediate((()=>s(...e))),this._sent()})):(this.idling=!1,this.pending.push({mail:e,callback:s}))}_checkRatedQueue(){if(this.connections>=this.maxConnections||!this._checkSendingRate())return;if(!this.pending.length)return void(this.idling||(this.idling=!0,this.emit("idle")));let e=this.pending.shift();this._send(e.mail,((...s)=>{setImmediate((()=>e.callback(...s))),this._sent()}))}_checkSendingRate(){clearTimeout(this.sendingRateTTL);let e=Date.now(),s=!1;for(let t=this.rateMessages.length-1;t>=0;t--)this.rateMessages[t].ts>=e-this.rateInterval&&(!s||this.rateMessages[t].ts<s)&&(s=this.rateMessages[t].ts),this.rateMessages[t].ts<e-this.rateInterval&&!this.rateMessages[t].pending&&this.rateMessages.splice(t,1);if(this.rateMessages.length<this.sendingRate)return!0;let t=Math.max(s+1001,e+20);this.sendingRateTTL=setTimeout((()=>this._checkRatedQueue()),e-t);try{this.sendingRateTTL.unref()}catch(e){}return!1}_sent(){this.connections--,this._checkRatedQueue()}isIdle(){return this.idling}_send(e,s){let t={ts:Date.now(),pending:!0};this.connections++,this.rateMessages.push(t);let i=e.data.envelope||e.message.getEnvelope(),n=e.message.messageId(),a=[].concat(i.to||[]);a.length>3&&a.push("...and "+a.splice(2).length+" more"),this.logger.info({tnx:"send",messageId:n},"Sending message %s to <%s>",n,a.join(", "));setImmediate((()=>(s=>{e.data._dkim||(e.data._dkim={}),e.data._dkim.skipFields&&"string"==typeof e.data._dkim.skipFields?e.data._dkim.skipFields+=":date:message-id":e.data._dkim.skipFields="date:message-id";let t=e.message.createReadStream(),i=t.pipe(new LeWindows),n=[],a=0;i.on("readable",(()=>{let e;for(;null!==(e=i.read());)n.push(e),a+=e.length})),t.once("error",(e=>i.emit("error",e))),i.once("error",(e=>{s(e)})),i.once("end",(()=>s(null,Buffer.concat(n,a))))})(((a,r)=>{if(a)return this.logger.error({err:a,tnx:"send",messageId:n},"Failed creating message for %s. %s",n,a.message),t.pending=!1,s(a);let o={RawMessage:{Data:r},Source:i.from,Destinations:i.to};Object.keys(e.data.ses||{}).forEach((s=>{o[s]=e.data.ses[s]}));let d=(this.ses.aws?this.ses.ses:this.ses)||{},h=this.ses.aws||{};var l;l=(e,a)=>{let l;!e&&a||(a="us-east-1"),l="function"==typeof d.send&&h.SendRawEmailCommand?d.send(new h.SendRawEmailCommand(o)):d.sendRawEmail(o).promise(),l.then((e=>{"us-east-1"===a&&(a="email"),t.pending=!1,s(null,{envelope:{from:i.from,to:i.to},messageId:"<"+e.MessageId+(/@/.test(e.MessageId)?"":"@"+a+".amazonses.com")+">",response:e.MessageId,raw:r})})).catch((e=>{this.logger.error({err:e,tnx:"send"},"Send error for %s: %s",n,e.message),t.pending=!1,s(e)}))},d.config&&"function"==typeof d.config.region?d.config.region().then((e=>l(null,e))).catch((e=>l(e))):l(null,d.config&&d.config.region||"us-east-1")}))))}verify(e){let s,t=(this.ses.aws?this.ses.ses:this.ses)||{},i=this.ses.aws||{};const n={RawMessage:{Data:"From: invalid@invalid\r\nTo: invalid@invalid\r\n Subject: Invalid\r\n\r\nInvalid"},Source:"invalid@invalid",Destinations:["invalid@invalid"]};e||(s=new Promise(((s,t)=>{e=shared.callbackPromise(s,t)})));const a=s=>s&&"InvalidParameterValue"!==(s.code||s.Code)?e(s):e(null,!0);return"function"==typeof t.send&&i.SendRawEmailCommand?(n.RawMessage.Data=Buffer.from(n.RawMessage.Data),t.send(new i.SendRawEmailCommand(n),a)):t.sendRawEmail(n,a),s}}module.exports=SESTransport;