"use strict";const packageInfo=require("../../package.json"),EventEmitter=require("events").EventEmitter,net=require("net"),tls=require("tls"),os=require("os"),crypto=require("crypto"),DataStream=require("./data-stream"),PassThrough=require("stream").PassThrough,shared=require("../shared"),CONNECTION_TIMEOUT=12e4,SOCKET_TIMEOUT=6e5,GREETING_TIMEOUT=3e4,DNS_TIMEOUT=3e4;class SMTPConnection extends EventEmitter{constructor(t){super(t),this.id=crypto.randomBytes(8).toString("base64").replace(/\W/g,""),this.stage="init",this.options=t||{},this.secureConnection=!!this.options.secure,this.alreadySecured=!!this.options.secured,this.port=Number(this.options.port)||(this.secureConnection?465:587),this.host=this.options.host||"localhost",this.allowInternalNetworkInterfaces=this.options.allowInternalNetworkInterfaces||!1,void 0===this.options.secure&&465===this.port&&(this.secureConnection=!0),this.name=this.options.name||this._getHostname(),this.logger=shared.getLogger(this.options,{component:this.options.component||"smtp-connection",sid:this.id}),this.customAuth=new Map,Object.keys(this.options.customAuth||{}).forEach((t=>{let e=(t||"").toString().trim().toUpperCase();e&&this.customAuth.set(e,this.options.customAuth[t])})),this.version=packageInfo.version,this.authenticated=!1,this.destroyed=!1,this.secure=!!this.secureConnection,this._remainder="",this._responseQueue=[],this.lastServerResponse=!1,this._socket=!1,this._supportedAuth=[],this.allowsAuth=!1,this._envelope=!1,this._supportedExtensions=[],this._maxAllowedSize=0,this._responseActions=[],this._recipientQueue=[],this._greetingTimeout=!1,this._connectionTimeout=!1,this._destroyed=!1,this._closing=!1,this._onSocketData=t=>this._onData(t),this._onSocketError=t=>this._onError(t,"ESOCKET",!1,"CONN"),this._onSocketClose=()=>this._onClose(),this._onSocketEnd=()=>this._onEnd(),this._onSocketTimeout=()=>this._onTimeout()}connect(t){if("function"==typeof t){this.once("connect",(()=>{this.logger.debug({tnx:"smtp"},"SMTP handshake finished"),t()}));const e=this._isDestroyedMessage("connect");if(e)return t(this._formatError(e,"ECONNECTION",!1,"CONN"))}let e={port:this.port,host:this.host,allowInternalNetworkInterfaces:this.allowInternalNetworkInterfaces,timeout:this.options.dnsTimeout||3e4};this.options.localAddress&&(e.localAddress=this.options.localAddress);let s=()=>{this._connectionTimeout=setTimeout((()=>{this._onError("Connection timeout","ETIMEDOUT",!1,"CONN")}),this.options.connectionTimeout||12e4),this._socket.on("error",this._onSocketError)};return this.options.connection?(this._socket=this.options.connection,void(this.secureConnection&&!this.alreadySecured?setImmediate((()=>this._upgradeConnection((t=>{t?this._onError(new Error("Error initiating TLS - "+(t.message||t)),"ETLS",!1,"CONN"):this._onConnect()})))):setImmediate((()=>this._onConnect())))):this.options.socket?(this._socket=this.options.socket,shared.resolveHostname(e,((t,i)=>{if(t)return setImmediate((()=>this._onError(t,"EDNS",!1,"CONN")));this.logger.debug({tnx:"dns",source:e.host,resolved:i.host,cached:!!i.cached},"Resolved %s as %s [cache %s]",e.host,i.host,i.cached?"hit":"miss"),Object.keys(i).forEach((t=>{"_"!==t.charAt(0)&&i[t]&&(e[t]=i[t])}));try{this._socket.connect(this.port,this.host,(()=>{this._socket.setKeepAlive(!0),this._onConnect()})),s()}catch(t){return setImmediate((()=>this._onError(t,"ECONNECTION",!1,"CONN")))}}))):this.secureConnection?(this.options.tls&&Object.keys(this.options.tls).forEach((t=>{e[t]=this.options.tls[t]})),shared.resolveHostname(e,((t,i)=>{if(t)return setImmediate((()=>this._onError(t,"EDNS",!1,"CONN")));this.logger.debug({tnx:"dns",source:e.host,resolved:i.host,cached:!!i.cached},"Resolved %s as %s [cache %s]",e.host,i.host,i.cached?"hit":"miss"),Object.keys(i).forEach((t=>{"_"!==t.charAt(0)&&i[t]&&(e[t]=i[t])}));try{this._socket=tls.connect(e,(()=>{this._socket.setKeepAlive(!0),this._onConnect()})),s()}catch(t){return setImmediate((()=>this._onError(t,"ECONNECTION",!1,"CONN")))}}))):shared.resolveHostname(e,((t,i)=>{if(t)return setImmediate((()=>this._onError(t,"EDNS",!1,"CONN")));this.logger.debug({tnx:"dns",source:e.host,resolved:i.host,cached:!!i.cached},"Resolved %s as %s [cache %s]",e.host,i.host,i.cached?"hit":"miss"),Object.keys(i).forEach((t=>{"_"!==t.charAt(0)&&i[t]&&(e[t]=i[t])}));try{this._socket=net.connect(e,(()=>{this._socket.setKeepAlive(!0),this._onConnect()})),s()}catch(t){return setImmediate((()=>this._onError(t,"ECONNECTION",!1,"CONN")))}}))}quit(){this._sendCommand("QUIT"),this._responseActions.push(this.close)}close(){if(clearTimeout(this._connectionTimeout),clearTimeout(this._greetingTimeout),this._responseActions=[],this._closing)return;this._closing=!0;let t="end";"init"===this.stage&&(t="destroy"),this.logger.debug({tnx:"smtp"},'Closing connection to the server using "%s"',t);let e=this._socket&&this._socket.socket||this._socket;if(e&&!e.destroyed)try{this._socket[t]()}catch(t){}this._destroy()}login(t,e){const s=this._isDestroyedMessage("login");if(s)return e(this._formatError(s,"ECONNECTION",!1,"API"));if(this._auth=t||{},this._authMethod=(this._auth.method||"").toString().trim().toUpperCase()||!1,this._authMethod||!this._auth.oauth2||this._auth.credentials?this._authMethod&&("XOAUTH2"!==this._authMethod||this._auth.oauth2)||(this._authMethod=(this._supportedAuth[0]||"PLAIN").toUpperCase().trim()):this._authMethod="XOAUTH2",!("XOAUTH2"===this._authMethod||this._auth.credentials&&this._auth.credentials.user&&this._auth.credentials.pass)){if(!(this._auth.user&&this._auth.pass||this.customAuth.has(this._authMethod)))return e(this._formatError('Missing credentials for "'+this._authMethod+'"',"EAUTH",!1,"API"));this._auth.credentials={user:this._auth.user,pass:this._auth.pass,options:this._auth.options}}if(!this.customAuth.has(this._authMethod)){switch(this._authMethod){case"XOAUTH2":return void this._handleXOauth2Token(!1,e);case"LOGIN":return this._responseActions.push((t=>{this._actionAUTH_LOGIN_USER(t,e)})),void this._sendCommand("AUTH LOGIN");case"PLAIN":return this._responseActions.push((t=>{this._actionAUTHComplete(t,e)})),void this._sendCommand("AUTH PLAIN "+Buffer.from("\0"+this._auth.credentials.user+"\0"+this._auth.credentials.pass,"utf-8").toString("base64"),"AUTH PLAIN "+Buffer.from("\0"+this._auth.credentials.user+"\0/* secret */","utf-8").toString("base64"));case"CRAM-MD5":return this._responseActions.push((t=>{this._actionAUTH_CRAM_MD5(t,e)})),void this._sendCommand("AUTH CRAM-MD5")}return e(this._formatError('Unknown authentication method "'+this._authMethod+'"',"EAUTH",!1,"API"))}{let t,s=this.customAuth.get(this._authMethod),i=!1,o=()=>{i||(i=!0,this.logger.info({tnx:"smtp",username:this._auth.user,action:"authenticated",method:this._authMethod},"User %s authenticated",JSON.stringify(this._auth.user)),this.authenticated=!0,e(null,!0))},n=s=>{i||(i=!0,e(this._formatError(s,"EAUTH",t,"AUTH "+this._authMethod)))},r=s({auth:this._auth,method:this._authMethod,extensions:[].concat(this._supportedExtensions),authMethods:[].concat(this._supportedAuth),maxAllowedSize:this._maxAllowedSize||!1,sendCommand:(e,s)=>{let i;return s||(i=new Promise(((t,e)=>{s=shared.callbackPromise(t,e)}))),this._responseActions.push((i=>{t=i;let o=i.match(/^(\d+)(?:\s(\d+\.\d+\.\d+))?\s/),n={command:e,response:i};o?(n.status=Number(o[1])||0,o[2]&&(n.code=o[2]),n.text=i.substr(o[0].length)):(n.text=i,n.status=0),s(null,n)})),setImmediate((()=>this._sendCommand(e))),i},resolve:o,reject:n});r&&"function"==typeof r.catch&&r.then(o).catch(n)}}send(t,e,s){if(!e)return s(this._formatError("Empty message","EMESSAGE",!1,"API"));const i=this._isDestroyedMessage("send message");if(i)return s(this._formatError(i,"ECONNECTION",!1,"API"));if(this._maxAllowedSize&&t.size>this._maxAllowedSize)return setImmediate((()=>{s(this._formatError("Message size larger than allowed "+this._maxAllowedSize,"EMESSAGE",!1,"MAIL FROM"))}));let o=!1,n=function(){o||(o=!0,s(...arguments))};"function"==typeof e.on&&e.on("error",(t=>n(this._formatError(t,"ESTREAM",!1,"API"))));let r=Date.now();this._setEnvelope(t,((t,s)=>{if(t)return n(t);let i=Date.now(),o=this._createSendStream(((t,e)=>t?n(t):(s.envelopeTime=i-r,s.messageTime=Date.now()-i,s.messageSize=o.outByteCount,s.response=e,n(null,s))));"function"==typeof e.pipe?e.pipe(o):(o.write(e),o.end())}))}reset(t){this._sendCommand("RSET"),this._responseActions.push((e=>"2"!==e.charAt(0)?t(this._formatError("Could not reset session state. response="+e,"EPROTOCOL",e,"RSET")):(this._envelope=!1,t(null,!0))))}_onConnect(){clearTimeout(this._connectionTimeout),this.logger.info({tnx:"network",localAddress:this._socket.localAddress,localPort:this._socket.localPort,remoteAddress:this._socket.remoteAddress,remotePort:this._socket.remotePort},"%s established to %s:%s",this.secure?"Secure connection":"Connection",this._socket.remoteAddress,this._socket.remotePort),this._destroyed?this.close():(this.stage="connected",this._socket.removeListener("data",this._onSocketData),this._socket.removeListener("timeout",this._onSocketTimeout),this._socket.removeListener("close",this._onSocketClose),this._socket.removeListener("end",this._onSocketEnd),this._socket.on("data",this._onSocketData),this._socket.once("close",this._onSocketClose),this._socket.once("end",this._onSocketEnd),this._socket.setTimeout(this.options.socketTimeout||6e5),this._socket.on("timeout",this._onSocketTimeout),this._greetingTimeout=setTimeout((()=>{this._socket&&!this._destroyed&&this._responseActions[0]===this._actionGreeting&&this._onError("Greeting never received","ETIMEDOUT",!1,"CONN")}),this.options.greetingTimeout||3e4),this._responseActions.push(this._actionGreeting),this._socket.resume())}_onData(t){if(this._destroyed||!t||!t.length)return;let e,s=(t||"").toString("binary"),i=(this._remainder+s).split(/\r?\n/);this._remainder=i.pop();for(let t=0,s=i.length;t<s;t++)this._responseQueue.length&&(e=this._responseQueue[this._responseQueue.length-1],/^\d+-/.test(e.split("\n").pop()))?this._responseQueue[this._responseQueue.length-1]+="\n"+i[t]:this._responseQueue.push(i[t]);this._responseQueue.length&&(e=this._responseQueue[this._responseQueue.length-1],/^\d+-/.test(e.split("\n").pop()))||this._processResponse()}_onError(t,e,s,i){clearTimeout(this._connectionTimeout),clearTimeout(this._greetingTimeout),this._destroyed||(t=this._formatError(t,e,s,i),this.logger.error(s,t.message),this.emit("error",t),this.close())}_formatError(t,e,s,i){let o;o=/Error\]$/i.test(Object.prototype.toString.call(t))?t:new Error(t),e&&"Error"!==e&&(o.code=e),s&&(o.response=s,o.message+=": "+s);let n="string"==typeof s&&Number((s.match(/^\d+/)||[])[0])||!1;return n&&(o.responseCode=n),i&&(o.command=i),o}_onClose(){let t=!1;return this._remainder&&this._remainder.trim()&&((this.options.debug||this.options.transactionLog)&&this.logger.debug({tnx:"server"},this._remainder.replace(/\r?\n$/,"")),this.lastServerResponse=t=this._remainder.trim()),this.logger.info({tnx:"network"},"Connection closed"),this.upgrading&&!this._destroyed?this._onError(new Error("Connection closed unexpectedly"),"ETLS",t,"CONN"):[this._actionGreeting,this.close].includes(this._responseActions[0])||this._destroyed?/^[45]\d{2}\b/.test(t)?this._onError(new Error("Connection closed unexpectedly"),"ECONNECTION",t,"CONN"):void this._destroy():this._onError(new Error("Connection closed unexpectedly"),"ECONNECTION",t,"CONN")}_onEnd(){this._socket&&!this._socket.destroyed&&this._socket.destroy()}_onTimeout(){return this._onError(new Error("Timeout"),"ETIMEDOUT",!1,"CONN")}_destroy(){this._destroyed||(this._destroyed=!0,this.emit("end"))}_upgradeConnection(t){this._socket.removeListener("data",this._onSocketData),this._socket.removeListener("timeout",this._onSocketTimeout);let e=this._socket,s={socket:this._socket,host:this.host};Object.keys(this.options.tls||{}).forEach((t=>{s[t]=this.options.tls[t]})),this.upgrading=!0;try{this._socket=tls.connect(s,(()=>(this.secure=!0,this.upgrading=!1,this._socket.on("data",this._onSocketData),e.removeListener("close",this._onSocketClose),e.removeListener("end",this._onSocketEnd),t(null,!0))))}catch(e){return t(e)}this._socket.on("error",this._onSocketError),this._socket.once("close",this._onSocketClose),this._socket.once("end",this._onSocketEnd),this._socket.setTimeout(this.options.socketTimeout||6e5),this._socket.on("timeout",this._onSocketTimeout),e.resume()}_processResponse(){if(!this._responseQueue.length)return!1;let t=this.lastServerResponse=(this._responseQueue.shift()||"").toString();if(/^\d+-/.test(t.split("\n").pop()))return;(this.options.debug||this.options.transactionLog)&&this.logger.debug({tnx:"server"},t.replace(/\r?\n$/,"")),t.trim()||setImmediate((()=>this._processResponse()));let e=this._responseActions.shift();if("function"!=typeof e)return this._onError(new Error("Unexpected Response"),"EPROTOCOL",t,"CONN");e.call(this,t),setImmediate((()=>this._processResponse()))}_sendCommand(t,e){if(!this._destroyed){if(this._socket.destroyed)return this.close();(this.options.debug||this.options.transactionLog)&&this.logger.debug({tnx:"client"},(e||t||"").toString().replace(/\r?\n$/,"")),this._socket.write(Buffer.from(t+"\r\n","utf-8"))}}_setEnvelope(t,e){let s=[],i=!1;if(this._envelope=t||{},this._envelope.from=(this._envelope.from&&this._envelope.from.address||this._envelope.from||"").toString().trim(),this._envelope.to=[].concat(this._envelope.to||[]).map((t=>(t&&t.address||t||"").toString().trim())),!this._envelope.to.length)return e(this._formatError("No recipients defined","EENVELOPE",!1,"API"));if(this._envelope.from&&/[\r\n<>]/.test(this._envelope.from))return e(this._formatError("Invalid sender "+JSON.stringify(this._envelope.from),"EENVELOPE",!1,"API"));/[\x80-\uFFFF]/.test(this._envelope.from)&&(i=!0);for(let t=0,s=this._envelope.to.length;t<s;t++){if(!this._envelope.to[t]||/[\r\n<>]/.test(this._envelope.to[t]))return e(this._formatError("Invalid recipient "+JSON.stringify(this._envelope.to[t]),"EENVELOPE",!1,"API"));/[\x80-\uFFFF]/.test(this._envelope.to[t])&&(i=!0)}if(this._envelope.rcptQueue=JSON.parse(JSON.stringify(this._envelope.to||[])),this._envelope.rejected=[],this._envelope.rejectedErrors=[],this._envelope.accepted=[],this._envelope.dsn)try{this._envelope.dsn=this._setDsnEnvelope(this._envelope.dsn)}catch(t){return e(this._formatError("Invalid DSN "+t.message,"EENVELOPE",!1,"API"))}this._responseActions.push((t=>{this._actionMAIL(t,e)})),i&&this._supportedExtensions.includes("SMTPUTF8")&&(s.push("SMTPUTF8"),this._usingSmtpUtf8=!0),this._envelope.use8BitMime&&this._supportedExtensions.includes("8BITMIME")&&(s.push("BODY=8BITMIME"),this._using8BitMime=!0),this._envelope.size&&this._supportedExtensions.includes("SIZE")&&s.push("SIZE="+this._envelope.size),this._envelope.dsn&&this._supportedExtensions.includes("DSN")&&(this._envelope.dsn.ret&&s.push("RET="+shared.encodeXText(this._envelope.dsn.ret)),this._envelope.dsn.envid&&s.push("ENVID="+shared.encodeXText(this._envelope.dsn.envid))),this._sendCommand("MAIL FROM:<"+this._envelope.from+">"+(s.length?" "+s.join(" "):""))}_setDsnEnvelope(t){let e=(t.ret||t.return||"").toString().toUpperCase()||null;if(e)switch(e){case"HDRS":case"HEADERS":e="HDRS";break;case"FULL":case"BODY":e="FULL"}if(e&&!["FULL","HDRS"].includes(e))throw new Error("ret: "+JSON.stringify(e));let s=(t.envid||t.id||"").toString()||null,i=t.notify||null;if(i){"string"==typeof i&&(i=i.split(",")),i=i.map((t=>t.trim().toUpperCase()));let t=["NEVER","SUCCESS","FAILURE","DELAY"];if(i.filter((e=>!t.includes(e))).length||i.length>1&&i.includes("NEVER"))throw new Error("notify: "+JSON.stringify(i.join(",")));i=i.join(",")}let o=(t.recipient||t.orcpt||"").toString()||null;return o&&o.indexOf(";")<0&&(o="rfc822;"+o),{ret:e,envid:s,notify:i,orcpt:o}}_getDsnRcptToArgs(){let t=[];return this._envelope.dsn&&this._supportedExtensions.includes("DSN")&&(this._envelope.dsn.notify&&t.push("NOTIFY="+shared.encodeXText(this._envelope.dsn.notify)),this._envelope.dsn.orcpt&&t.push("ORCPT="+shared.encodeXText(this._envelope.dsn.orcpt))),t.length?" "+t.join(" "):""}_createSendStream(t){let e,s=new DataStream;return this.options.lmtp?this._envelope.accepted.forEach(((e,s)=>{let i=s===this._envelope.accepted.length-1;this._responseActions.push((s=>{this._actionLMTPStream(e,i,s,t)}))})):this._responseActions.push((e=>{this._actionSMTPStream(e,t)})),s.pipe(this._socket,{end:!1}),this.options.debug&&(e=new PassThrough,e.on("readable",(()=>{let t;for(;t=e.read();)this.logger.debug({tnx:"message"},t.toString("binary").replace(/\r?\n$/,""))})),s.pipe(e)),s.once("end",(()=>{this.logger.info({tnx:"message",inByteCount:s.inByteCount,outByteCount:s.outByteCount},"<%s bytes encoded mime message (source size %s bytes)>",s.outByteCount,s.inByteCount)})),s}_actionGreeting(t){clearTimeout(this._greetingTimeout),"220"===t.substr(0,3)?this.options.lmtp?(this._responseActions.push(this._actionLHLO),this._sendCommand("LHLO "+this.name)):(this._responseActions.push(this._actionEHLO),this._sendCommand("EHLO "+this.name)):this._onError(new Error("Invalid greeting. response="+t),"EPROTOCOL",t,"CONN")}_actionLHLO(t){"2"===t.charAt(0)?this._actionEHLO(t):this._onError(new Error("Invalid LHLO. response="+t),"EPROTOCOL",t,"LHLO")}_actionEHLO(t){let e;if("421"!==t.substr(0,3)){if("2"!==t.charAt(0))return this.options.requireTLS?void this._onError(new Error("EHLO failed but HELO does not support required STARTTLS. response="+t),"ECONNECTION",t,"EHLO"):(this._responseActions.push(this._actionHELO),void this._sendCommand("HELO "+this.name));if(this._ehloLines=t.split(/\r?\n/).map((t=>t.replace(/^\d+[ -]/,"").trim())).filter((t=>t)).slice(1),!this.secure&&!this.options.ignoreTLS&&(/[ -]STARTTLS\b/im.test(t)||this.options.requireTLS))return this._sendCommand("STARTTLS"),void this._responseActions.push(this._actionSTARTTLS);/[ -]SMTPUTF8\b/im.test(t)&&this._supportedExtensions.push("SMTPUTF8"),/[ -]DSN\b/im.test(t)&&this._supportedExtensions.push("DSN"),/[ -]8BITMIME\b/im.test(t)&&this._supportedExtensions.push("8BITMIME"),/[ -]PIPELINING\b/im.test(t)&&this._supportedExtensions.push("PIPELINING"),/[ -]AUTH\b/i.test(t)&&(this.allowsAuth=!0),/[ -]AUTH(?:(\s+|=)[^\n]*\s+|\s+|=)PLAIN/i.test(t)&&this._supportedAuth.push("PLAIN"),/[ -]AUTH(?:(\s+|=)[^\n]*\s+|\s+|=)LOGIN/i.test(t)&&this._supportedAuth.push("LOGIN"),/[ -]AUTH(?:(\s+|=)[^\n]*\s+|\s+|=)CRAM-MD5/i.test(t)&&this._supportedAuth.push("CRAM-MD5"),/[ -]AUTH(?:(\s+|=)[^\n]*\s+|\s+|=)XOAUTH2/i.test(t)&&this._supportedAuth.push("XOAUTH2"),(e=t.match(/[ -]SIZE(?:[ \t]+(\d+))?/im))&&(this._supportedExtensions.push("SIZE"),this._maxAllowedSize=Number(e[1])||0),this.emit("connect")}else this._onError(new Error("Server terminates connection. response="+t),"ECONNECTION",t,"EHLO")}_actionHELO(t){"2"===t.charAt(0)?(this.allowsAuth=!0,this.emit("connect")):this._onError(new Error("Invalid HELO. response="+t),"EPROTOCOL",t,"HELO")}_actionSTARTTLS(t){if("2"!==t.charAt(0))return this.options.opportunisticTLS?(this.logger.info({tnx:"smtp"},"Failed STARTTLS upgrade, continuing unencrypted"),this.emit("connect")):void this._onError(new Error("Error upgrading connection with STARTTLS"),"ETLS",t,"STARTTLS");this._upgradeConnection(((t,e)=>{t?this._onError(new Error("Error initiating TLS - "+(t.message||t)),"ETLS",!1,"STARTTLS"):(this.logger.info({tnx:"smtp"},"Connection upgraded with STARTTLS"),e?this.options.lmtp?(this._responseActions.push(this._actionLHLO),this._sendCommand("LHLO "+this.name)):(this._responseActions.push(this._actionEHLO),this._sendCommand("EHLO "+this.name)):this.emit("connect"))}))}_actionAUTH_LOGIN_USER(t,e){/^334[ -]/.test(t)?(this._responseActions.push((t=>{this._actionAUTH_LOGIN_PASS(t,e)})),this._sendCommand(Buffer.from(this._auth.credentials.user+"","utf-8").toString("base64"))):e(this._formatError('Invalid login sequence while waiting for "334 VXNlcm5hbWU6"',"EAUTH",t,"AUTH LOGIN"))}_actionAUTH_CRAM_MD5(t,e){let s=t.match(/^334\s+(.+)$/),i="";if(!s)return e(this._formatError("Invalid login sequence while waiting for server challenge string","EAUTH",t,"AUTH CRAM-MD5"));i=s[1];let o=Buffer.from(i,"base64").toString("ascii"),n=crypto.createHmac("md5",this._auth.credentials.pass);n.update(o);let r=this._auth.credentials.user+" "+n.digest("hex");this._responseActions.push((t=>{this._actionAUTH_CRAM_MD5_PASS(t,e)})),this._sendCommand(Buffer.from(r).toString("base64"),Buffer.from(this._auth.credentials.user+" /* secret */").toString("base64"))}_actionAUTH_CRAM_MD5_PASS(t,e){if(!t.match(/^235\s+/))return e(this._formatError('Invalid login sequence while waiting for "235"',"EAUTH",t,"AUTH CRAM-MD5"));this.logger.info({tnx:"smtp",username:this._auth.user,action:"authenticated",method:this._authMethod},"User %s authenticated",JSON.stringify(this._auth.user)),this.authenticated=!0,e(null,!0)}_actionAUTH_LOGIN_PASS(t,e){if(!/^334[ -]/.test(t))return e(this._formatError('Invalid login sequence while waiting for "334 UGFzc3dvcmQ6"',"EAUTH",t,"AUTH LOGIN"));this._responseActions.push((t=>{this._actionAUTHComplete(t,e)})),this._sendCommand(Buffer.from((this._auth.credentials.pass||"").toString(),"utf-8").toString("base64"),Buffer.from("/* secret */","utf-8").toString("base64"))}_actionAUTHComplete(t,e,s){return s||"function"!=typeof e||(s=e,e=!1),"334"===t.substr(0,3)?(this._responseActions.push((t=>{e||"XOAUTH2"!==this._authMethod?this._actionAUTHComplete(t,!0,s):setImmediate((()=>this._handleXOauth2Token(!0,s)))})),void this._sendCommand("")):"2"!==t.charAt(0)?(this.logger.info({tnx:"smtp",username:this._auth.user,action:"authfail",method:this._authMethod},"User %s failed to authenticate",JSON.stringify(this._auth.user)),s(this._formatError("Invalid login","EAUTH",t,"AUTH "+this._authMethod))):(this.logger.info({tnx:"smtp",username:this._auth.user,action:"authenticated",method:this._authMethod},"User %s authenticated",JSON.stringify(this._auth.user)),this.authenticated=!0,void s(null,!0))}_actionMAIL(t,e){let s,i;if(2!==Number(t.charAt(0)))return s=this._usingSmtpUtf8&&/^550 /.test(t)&&/[\x80-\uFFFF]/.test(this._envelope.from)?"Internationalized mailbox name not allowed":"Mail command failed",e(this._formatError(s,"EENVELOPE",t,"MAIL FROM"));if(!this._envelope.rcptQueue.length)return e(this._formatError("Can't send mail - no recipients defined","EENVELOPE",!1,"API"));if(this._recipientQueue=[],this._supportedExtensions.includes("PIPELINING"))for(;this._envelope.rcptQueue.length;)i=this._envelope.rcptQueue.shift(),this._recipientQueue.push(i),this._responseActions.push((t=>{this._actionRCPT(t,e)})),this._sendCommand("RCPT TO:<"+i+">"+this._getDsnRcptToArgs());else i=this._envelope.rcptQueue.shift(),this._recipientQueue.push(i),this._responseActions.push((t=>{this._actionRCPT(t,e)})),this._sendCommand("RCPT TO:<"+i+">"+this._getDsnRcptToArgs())}_actionRCPT(t,e){let s,i,o=this._recipientQueue.shift();if(2!==Number(t.charAt(0))?(s=this._usingSmtpUtf8&&/^553 /.test(t)&&/[\x80-\uFFFF]/.test(o)?"Internationalized mailbox name not allowed":"Recipient command failed",this._envelope.rejected.push(o),i=this._formatError(s,"EENVELOPE",t,"RCPT TO"),i.recipient=o,this._envelope.rejectedErrors.push(i)):this._envelope.accepted.push(o),this._envelope.rcptQueue.length||this._recipientQueue.length)this._envelope.rcptQueue.length&&(o=this._envelope.rcptQueue.shift(),this._recipientQueue.push(o),this._responseActions.push((t=>{this._actionRCPT(t,e)})),this._sendCommand("RCPT TO:<"+o+">"+this._getDsnRcptToArgs()));else{if(!(this._envelope.rejected.length<this._envelope.to.length))return i=this._formatError("Can't send mail - all recipients were rejected","EENVELOPE",t,"RCPT TO"),i.rejected=this._envelope.rejected,i.rejectedErrors=this._envelope.rejectedErrors,e(i);this._responseActions.push((t=>{this._actionDATA(t,e)})),this._sendCommand("DATA")}}_actionDATA(t,e){if(!/^[23]/.test(t))return e(this._formatError("Data command failed","EENVELOPE",t,"DATA"));let s={accepted:this._envelope.accepted,rejected:this._envelope.rejected};this._ehloLines&&this._ehloLines.length&&(s.ehlo=this._ehloLines),this._envelope.rejectedErrors.length&&(s.rejectedErrors=this._envelope.rejectedErrors),e(null,s)}_actionSMTPStream(t,e){return 2!==Number(t.charAt(0))?e(this._formatError("Message failed","EMESSAGE",t,"DATA")):e(null,t)}_actionLMTPStream(t,e,s,i){let o;if(2!==Number(s.charAt(0))){o=this._formatError("Message failed for recipient "+t,"EMESSAGE",s,"DATA"),o.recipient=t,this._envelope.rejected.push(t),this._envelope.rejectedErrors.push(o);for(let e=0,s=this._envelope.accepted.length;e<s;e++)this._envelope.accepted[e]===t&&this._envelope.accepted.splice(e,1)}if(e)return i(null,s)}_handleXOauth2Token(t,e){this._auth.oauth2.getToken(t,((s,i)=>{if(s)return this.logger.info({tnx:"smtp",username:this._auth.user,action:"authfail",method:this._authMethod},"User %s failed to authenticate",JSON.stringify(this._auth.user)),e(this._formatError(s,"EAUTH",!1,"AUTH XOAUTH2"));this._responseActions.push((s=>{this._actionAUTHComplete(s,t,e)})),this._sendCommand("AUTH XOAUTH2 "+this._auth.oauth2.buildXOAuth2Token(i),"AUTH XOAUTH2 "+this._auth.oauth2.buildXOAuth2Token("/* secret */"))}))}_isDestroyedMessage(t){if(this._destroyed)return"Cannot "+t+" - smtp connection is already destroyed.";if(this._socket){if(this._socket.destroyed)return"Cannot "+t+" - smtp connection socket is already destroyed.";if(!this._socket.writable)return"Cannot "+t+" - smtp connection socket is already half-closed."}}_getHostname(){let t;try{t=os.hostname()||""}catch(e){t="localhost"}return(!t||t.indexOf(".")<0)&&(t="[127.0.0.1]"),t.match(/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/)&&(t="["+t+"]"),t}}module.exports=SMTPConnection;