"use strict";const Stream=require("stream").Stream,nmfetch=require("../fetch"),crypto=require("crypto"),shared=require("../shared");class XOAuth2 extends Stream{constructor(e,t){if(super(),this.options=e||{},e&&e.serviceClient){if(!e.privateKey||!e.user)return void setImmediate((()=>this.emit("error",new Error('Options "privateKey" and "user" are required for service account!'))));let t=Math.min(Math.max(Number(this.options.serviceRequestTimeout)||0,0),3600);this.options.serviceRequestTimeout=t||300}if(this.logger=shared.getLogger({logger:t},{component:this.options.component||"OAuth2"}),this.provisionCallback="function"==typeof this.options.provisionCallback&&this.options.provisionCallback,this.options.accessUrl=this.options.accessUrl||"https://accounts.google.com/o/oauth2/token",this.options.customHeaders=this.options.customHeaders||{},this.options.customParams=this.options.customParams||{},this.accessToken=this.options.accessToken||!1,this.options.expires&&Number(this.options.expires))this.expires=this.options.expires;else{let e=Math.max(Number(this.options.timeout)||0,0);this.expires=e&&Date.now()+1e3*e||0}}getToken(e,t){if(!e&&this.accessToken&&(!this.expires||this.expires>Date.now()))return t(null,this.accessToken);let s=(...e)=>{e[0]?this.logger.error({err:e[0],tnx:"OAUTH2",user:this.options.user,action:"renew"},"Failed generating new Access Token for %s",this.options.user):this.logger.info({tnx:"OAUTH2",user:this.options.user,action:"renew"},"Generated new Access Token for %s",this.options.user),t(...e)};this.provisionCallback?this.provisionCallback(this.options.user,!!e,((e,t,r)=>{!e&&t&&(this.accessToken=t,this.expires=r||0),s(e,t)})):this.generateToken(s)}updateToken(e,t){this.accessToken=e,t=Math.max(Number(t)||0,0),this.expires=t&&Date.now()+1e3*t||0,this.emit("token",{user:this.options.user,accessToken:e||"",expires:this.expires})}generateToken(e){let t,s;if(this.options.serviceClient){let r,o=Math.floor(Date.now()/1e3),i={iss:this.options.serviceClient,scope:this.options.scope||"https://mail.google.com/",sub:this.options.user,aud:this.options.accessUrl,iat:o,exp:o+this.options.serviceRequestTimeout};try{r=this.jwtSignRS256(i)}catch(t){return e(new Error("Can't generate token. Check your auth options"))}t={grant_type:"urn:ietf:params:oauth:grant-type:jwt-bearer",assertion:r},s={grant_type:"urn:ietf:params:oauth:grant-type:jwt-bearer",assertion:i}}else{if(!this.options.refreshToken)return e(new Error("Can't create new access token for user"));t={client_id:this.options.clientId||"",client_secret:this.options.clientSecret||"",refresh_token:this.options.refreshToken,grant_type:"refresh_token"},s={client_id:this.options.clientId||"",client_secret:(this.options.clientSecret||"").substr(0,6)+"...",refresh_token:(this.options.refreshToken||"").substr(0,6)+"...",grant_type:"refresh_token"}}Object.keys(this.options.customParams).forEach((e=>{t[e]=this.options.customParams[e],s[e]=this.options.customParams[e]})),this.logger.debug({tnx:"OAUTH2",user:this.options.user,action:"generate"},"Requesting token using: %s",JSON.stringify(s)),this.postRequest(this.options.accessUrl,t,this.options,((t,s)=>{let r;if(t)return e(t);try{r=JSON.parse(s.toString())}catch(t){return e(t)}if(!r||"object"!=typeof r)return this.logger.debug({tnx:"OAUTH2",user:this.options.user,action:"post"},"Response: %s",(s||"").toString()),e(new Error("Invalid authentication response"));let o={};if(Object.keys(r).forEach((e=>{o[e]="access_token"!==e?r[e]:(r[e]||"").toString().substr(0,6)+"..."})),this.logger.debug({tnx:"OAUTH2",user:this.options.user,action:"post"},"Response: %s",JSON.stringify(o)),r.error){let t=r.error;return r.error_description&&(t+=": "+r.error_description),r.error_uri&&(t+=" ("+r.error_uri+")"),e(new Error(t))}return r.access_token?(this.updateToken(r.access_token,r.expires_in),e(null,this.accessToken)):e(new Error("No access token"))}))}buildXOAuth2Token(e){let t=["user="+(this.options.user||""),"auth=Bearer "+(e||this.accessToken),"",""];return Buffer.from(t.join(""),"utf-8").toString("base64")}postRequest(e,t,s,r){let o=!1,i=[],n=0,a=nmfetch(e,{method:"post",headers:s.customHeaders,body:t,allowErrorResponse:!0});a.on("readable",(()=>{let e;for(;null!==(e=a.read());)i.push(e),n+=e.length})),a.once("error",(e=>{if(!o)return o=!0,r(e)})),a.once("end",(()=>{if(!o)return o=!0,r(null,Buffer.concat(i,n))}))}toBase64URL(e){return"string"==typeof e&&(e=Buffer.from(e)),e.toString("base64").replace(/[=]+/g,"").replace(/\+/g,"-").replace(/\//g,"_")}jwtSignRS256(e){e=['{"alg":"RS256","typ":"JWT"}',JSON.stringify(e)].map((e=>this.toBase64URL(e))).join(".");let t=crypto.createSign("RSA-SHA256").update(e).sign(this.options.privateKey);return e+"."+this.toBase64URL(t)}}module.exports=XOAuth2;