"use strict";var crypto=require("crypto");function objectHash(t,r){return hash(t,r=applyDefaults(t,r))}exports=module.exports=objectHash,exports.sha1=function(t){return objectHash(t)},exports.keys=function(t){return objectHash(t,{excludeValues:!0,algorithm:"sha1",encoding:"hex"})},exports.MD5=function(t){return objectHash(t,{algorithm:"md5",encoding:"hex"})},exports.keysMD5=function(t){return objectHash(t,{algorithm:"md5",encoding:"hex",excludeValues:!0})};var hashes=crypto.getHashes?crypto.getHashes().slice():["sha1","md5"];hashes.push("passthrough");var encodings=["buffer","hex","binary","base64"];function applyDefaults(t,r){r=r||{};var e={};if(e.algorithm=r.algorithm||"sha1",e.encoding=r.encoding||"hex",e.excludeValues=!!r.excludeValues,e.algorithm=e.algorithm.toLowerCase(),e.encoding=e.encoding.toLowerCase(),e.ignoreUnknown=!0===r.ignoreUnknown,e.respectType=!1!==r.respectType,e.respectFunctionNames=!1!==r.respectFunctionNames,e.respectFunctionProperties=!1!==r.respectFunctionProperties,e.unorderedArrays=!0===r.unorderedArrays,e.unorderedSets=!1!==r.unorderedSets,e.unorderedObjects=!1!==r.unorderedObjects,e.replacer=r.replacer||void 0,e.excludeKeys=r.excludeKeys||void 0,void 0===t)throw new Error("Object argument required.");for(var n=0;n<hashes.length;++n)hashes[n].toLowerCase()===e.algorithm.toLowerCase()&&(e.algorithm=hashes[n]);if(-1===hashes.indexOf(e.algorithm))throw new Error('Algorithm "'+e.algorithm+'"  not supported. supported values: '+hashes.join(", "));if(-1===encodings.indexOf(e.encoding)&&"passthrough"!==e.algorithm)throw new Error('Encoding "'+e.encoding+'"  not supported. supported values: '+encodings.join(", "));return e}function isNativeFunction(t){if("function"!=typeof t)return!1;return null!=/^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i.exec(Function.prototype.toString.call(t))}function hash(t,r){var e;if(void 0===(e="passthrough"!==r.algorithm?crypto.createHash(r.algorithm):new PassThrough).write&&(e.write=e.update,e.end=e.update),typeHasher(r,e).dispatch(t),e.update||e.end(""),e.digest)return e.digest("buffer"===r.encoding?void 0:r.encoding);var n=e.read();return"buffer"===r.encoding?n:n.toString(r.encoding)}function typeHasher(t,r,e){e=e||[];var n=function(t){return r.update?r.update(t,"utf8"):r.write(t,"utf8")};return{dispatch:function(r){t.replacer&&(r=t.replacer(r));var e=typeof r;return null===r&&(e="null"),this["_"+e](r)},_object:function(r){var o=Object.prototype.toString.call(r),i=/\[object (.*)\]/i.exec(o);i=(i=i?i[1]:"unknown:["+o+"]").toLowerCase();var u;if((u=e.indexOf(r))>=0)return this.dispatch("[CIRCULAR:"+u+"]");if(e.push(r),"undefined"!=typeof Buffer&&Buffer.isBuffer&&Buffer.isBuffer(r))return n("buffer:"),n(r);if("object"===i||"function"===i||"asyncfunction"===i){var a=Object.keys(r);t.unorderedObjects&&(a=a.sort()),!1===t.respectType||isNativeFunction(r)||a.splice(0,0,"prototype","__proto__","constructor"),t.excludeKeys&&(a=a.filter((function(r){return!t.excludeKeys(r)}))),n("object:"+a.length+":");var s=this;return a.forEach((function(e){s.dispatch(e),n(":"),t.excludeValues||s.dispatch(r[e]),n(",")}))}if(!this["_"+i]){if(t.ignoreUnknown)return n("["+i+"]");throw new Error('Unknown object type "'+i+'"')}this["_"+i](r)},_array:function(r,o){o=void 0!==o?o:!1!==t.unorderedArrays;var i=this;if(n("array:"+r.length+":"),!o||r.length<=1)return r.forEach((function(t){return i.dispatch(t)}));var u=[],a=r.map((function(r){var n=new PassThrough,o=e.slice();return typeHasher(t,n,o).dispatch(r),u=u.concat(o.slice(e.length)),n.read().toString()}));return e=e.concat(u),a.sort(),this._array(a,!1)},_date:function(t){return n("date:"+t.toJSON())},_symbol:function(t){return n("symbol:"+t.toString())},_error:function(t){return n("error:"+t.toString())},_boolean:function(t){return n("bool:"+t.toString())},_string:function(t){n("string:"+t.length+":"),n(t.toString())},_function:function(r){n("fn:"),isNativeFunction(r)?this.dispatch("[native]"):this.dispatch(r.toString()),!1!==t.respectFunctionNames&&this.dispatch("function-name:"+String(r.name)),t.respectFunctionProperties&&this._object(r)},_number:function(t){return n("number:"+t.toString())},_xml:function(t){return n("xml:"+t.toString())},_null:function(){return n("Null")},_undefined:function(){return n("Undefined")},_regexp:function(t){return n("regex:"+t.toString())},_uint8array:function(t){return n("uint8array:"),this.dispatch(Array.prototype.slice.call(t))},_uint8clampedarray:function(t){return n("uint8clampedarray:"),this.dispatch(Array.prototype.slice.call(t))},_int8array:function(t){return n("int8array:"),this.dispatch(Array.prototype.slice.call(t))},_uint16array:function(t){return n("uint16array:"),this.dispatch(Array.prototype.slice.call(t))},_int16array:function(t){return n("int16array:"),this.dispatch(Array.prototype.slice.call(t))},_uint32array:function(t){return n("uint32array:"),this.dispatch(Array.prototype.slice.call(t))},_int32array:function(t){return n("int32array:"),this.dispatch(Array.prototype.slice.call(t))},_float32array:function(t){return n("float32array:"),this.dispatch(Array.prototype.slice.call(t))},_float64array:function(t){return n("float64array:"),this.dispatch(Array.prototype.slice.call(t))},_arraybuffer:function(t){return n("arraybuffer:"),this.dispatch(new Uint8Array(t))},_url:function(t){return n("url:"+t.toString())},_map:function(r){n("map:");var e=Array.from(r);return this._array(e,!1!==t.unorderedSets)},_set:function(r){n("set:");var e=Array.from(r);return this._array(e,!1!==t.unorderedSets)},_file:function(t){return n("file:"),this.dispatch([t.name,t.size,t.type,t.lastModfied])},_blob:function(){if(t.ignoreUnknown)return n("[blob]");throw Error('Hashing Blob objects is currently not supported\n(see https://github.com/puleos/object-hash/issues/26)\nUse "options.replacer" or "options.ignoreUnknown"\n')},_domwindow:function(){return n("domwindow")},_bigint:function(t){return n("bigint:"+t.toString())},_process:function(){return n("process")},_timer:function(){return n("timer")},_pipe:function(){return n("pipe")},_tcp:function(){return n("tcp")},_udp:function(){return n("udp")},_tty:function(){return n("tty")},_statwatcher:function(){return n("statwatcher")},_securecontext:function(){return n("securecontext")},_connection:function(){return n("connection")},_zlib:function(){return n("zlib")},_context:function(){return n("context")},_nodescript:function(){return n("nodescript")},_httpparser:function(){return n("httpparser")},_dataview:function(){return n("dataview")},_signal:function(){return n("signal")},_fsevent:function(){return n("fsevent")},_tlswrap:function(){return n("tlswrap")}}}function PassThrough(){return{buf:"",write:function(t){this.buf+=t},end:function(t){this.buf+=t},read:function(){return this.buf}}}exports.writeToStream=function(t,r,e){return void 0===e&&(e=r,r={}),typeHasher(r=applyDefaults(t,r),e).dispatch(t)};