"use strict";const EventEmitter=require("events").EventEmitter,NOOP=function(){},removeWhere=(e,t)=>{const i=e.findIndex(t);return-1===i?void 0:e.splice(i,1)[0]};class IdleItem{constructor(e,t,i){this.client=e,this.idleListener=t,this.timeoutId=i}}class PendingItem{constructor(e){this.callback=e}}function throwOnDoubleRelease(){throw new Error("Release called on client which has already been released to the pool.")}function promisify(e,t){if(t)return{callback:t,result:void 0};let i,n;return{callback:function(e,t){e?i(e):n(t)},result:new e((function(e,t){n=e,i=t})).catch((e=>{throw Error.captureStackTrace(e),e}))}}function makeIdleListener(e,t){return function i(n){n.client=t,t.removeListener("error",i),t.on("error",(()=>{e.log("additional client error after disconnection due to error",n)})),e._remove(t),e.emit("error",n,t)}}class Pool extends EventEmitter{constructor(e,t){super(),this.options=Object.assign({},e),null!=e&&"password"in e&&Object.defineProperty(this.options,"password",{configurable:!0,enumerable:!1,writable:!0,value:e.password}),null!=e&&e.ssl&&e.ssl.key&&Object.defineProperty(this.options.ssl,"key",{enumerable:!1}),this.options.max=this.options.max||this.options.poolSize||10,this.options.maxUses=this.options.maxUses||1/0,this.options.allowExitOnIdle=this.options.allowExitOnIdle||!1,this.options.maxLifetimeSeconds=this.options.maxLifetimeSeconds||0,this.log=this.options.log||function(){},this.Client=this.options.Client||t||require("pg").Client,this.Promise=this.options.Promise||global.Promise,void 0===this.options.idleTimeoutMillis&&(this.options.idleTimeoutMillis=1e4),this._clients=[],this._idle=[],this._expired=new WeakSet,this._pendingQueue=[],this._endCallback=void 0,this.ending=!1,this.ended=!1}_isFull(){return this._clients.length>=this.options.max}_pulseQueue(){if(this.log("pulse queue"),this.ended)return void this.log("pulse queue ended");if(this.ending)return this.log("pulse queue on ending"),this._idle.length&&this._idle.slice().map((e=>{this._remove(e.client)})),void(this._clients.length||(this.ended=!0,this._endCallback()));if(!this._pendingQueue.length)return void this.log("no queued requests");if(!this._idle.length&&this._isFull())return;const e=this._pendingQueue.shift();if(this._idle.length){const t=this._idle.pop();clearTimeout(t.timeoutId);const i=t.client;i.ref&&i.ref();const n=t.idleListener;return this._acquireClient(i,e,n,!1)}if(!this._isFull())return this.newClient(e);throw new Error("unexpected condition")}_remove(e){const t=removeWhere(this._idle,(t=>t.client===e));void 0!==t&&clearTimeout(t.timeoutId),this._clients=this._clients.filter((t=>t!==e)),e.end(),this.emit("remove",e)}connect(e){if(this.ending){const t=new Error("Cannot use a pool after calling end on the pool");return e?e(t):this.Promise.reject(t)}const t=promisify(this.Promise,e),i=t.result;if(this._isFull()||this._idle.length){if(this._idle.length&&process.nextTick((()=>this._pulseQueue())),!this.options.connectionTimeoutMillis)return this._pendingQueue.push(new PendingItem(t.callback)),i;const e=(e,i,n)=>{clearTimeout(s),t.callback(e,i,n)},n=new PendingItem(e),s=setTimeout((()=>{removeWhere(this._pendingQueue,(t=>t.callback===e)),n.timedOut=!0,t.callback(new Error("timeout exceeded when trying to connect"))}),this.options.connectionTimeoutMillis);return this._pendingQueue.push(n),i}return this.newClient(new PendingItem(t.callback)),i}newClient(e){const t=new this.Client(this.options);this._clients.push(t);const i=makeIdleListener(this,t);let n;this.log("checking client timeout");let s=!1;this.options.connectionTimeoutMillis&&(n=setTimeout((()=>{this.log("ending client due to timeout"),s=!0,t.connection?t.connection.stream.destroy():t.end()}),this.options.connectionTimeoutMillis)),this.log("connecting new client"),t.connect((o=>{if(n&&clearTimeout(n),t.on("error",i),!o){if(this.log("new client connected"),0!==this.options.maxLifetimeSeconds){const e=setTimeout((()=>{this.log("ending client due to expired lifetime"),this._expired.add(t);-1!==this._idle.findIndex((e=>e.client===t))&&this._acquireClient(t,new PendingItem(((e,t,i)=>i())),i,!1)}),1e3*this.options.maxLifetimeSeconds);e.unref(),t.once("end",(()=>clearTimeout(e)))}return this._acquireClient(t,e,i,!0)}this.log("client failed to connect",o),this._clients=this._clients.filter((e=>e!==t)),s&&(o.message="Connection terminated due to connection timeout"),this._pulseQueue(),e.timedOut||e.callback(o,void 0,NOOP)}))}_acquireClient(e,t,i,n){n&&this.emit("connect",e),this.emit("acquire",e),e.release=this._releaseOnce(e,i),e.removeListener("error",i),t.timedOut?n&&this.options.verify?this.options.verify(e,e.release):e.release():n&&this.options.verify?this.options.verify(e,(i=>{if(i)return e.release(i),t.callback(i,void 0,NOOP);t.callback(void 0,e,e.release)})):t.callback(void 0,e,e.release)}_releaseOnce(e,t){let i=!1;return n=>{i&&throwOnDoubleRelease(),i=!0,this._release(e,t,n)}}_release(e,t,i){if(e.on("error",t),e._poolUseCount=(e._poolUseCount||0)+1,this.emit("release",i,e),i||this.ending||!e._queryable||e._ending||e._poolUseCount>=this.options.maxUses)return e._poolUseCount>=this.options.maxUses&&this.log("remove expended client"),this._remove(e),void this._pulseQueue();if(this._expired.has(e))return this.log("remove expired client"),this._expired.delete(e),this._remove(e),void this._pulseQueue();let n;this.options.idleTimeoutMillis&&(n=setTimeout((()=>{this.log("remove idle client"),this._remove(e)}),this.options.idleTimeoutMillis),this.options.allowExitOnIdle&&n.unref()),this.options.allowExitOnIdle&&e.unref(),this._idle.push(new IdleItem(e,t,n)),this._pulseQueue()}query(e,t,i){if("function"==typeof e){const t=promisify(this.Promise,e);return setImmediate((function(){return t.callback(new Error("Passing a function as the first parameter to pool.query is not supported"))})),t.result}"function"==typeof t&&(i=t,t=void 0);const n=promisify(this.Promise,i);return i=n.callback,this.connect(((n,s)=>{if(n)return i(n);let o=!1;const r=e=>{o||(o=!0,s.release(e),i(e))};s.once("error",r),this.log("dispatching query");try{s.query(e,t,((e,t)=>{if(this.log("query dispatched"),s.removeListener("error",r),!o)return o=!0,s.release(e),e?i(e):i(void 0,t)}))}catch(n){return s.release(n),i(n)}})),n.result}end(e){if(this.log("ending"),this.ending){const t=new Error("Called end on pool more than once");return e?e(t):this.Promise.reject(t)}this.ending=!0;const t=promisify(this.Promise,e);return this._endCallback=t.callback,this._pulseQueue(),t.result}get waitingCount(){return this._pendingQueue.length}get idleCount(){return this._idle.length}get expiredCount(){return this._clients.reduce(((e,t)=>e+(this._expired.has(t)?1:0)),0)}get totalCount(){return this._clients.length}}module.exports=Pool;