"use strict";var __awaiter=this&&this.__awaiter||function(e,t,a,s){return new(a||(a=Promise))((function(r,n){function o(e){try{i(s.next(e))}catch(e){n(e)}}function f(e){try{i(s.throw(e))}catch(e){n(e)}}function i(e){var t;e.done?r(e.value):(t=e.value,t instanceof a?t:new a((function(e){e(t)}))).then(o,f)}i((s=s.apply(e,t||[])).next())}))},__importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0});const test_buffers_1=__importDefault(require("./testing/test-buffers")),buffer_list_1=__importDefault(require("./testing/buffer-list")),_1=require("."),assert_1=__importDefault(require("assert")),stream_1=require("stream");var authOkBuffer=test_buffers_1.default.authenticationOk(),paramStatusBuffer=test_buffers_1.default.parameterStatus("client_encoding","UTF8"),readyForQueryBuffer=test_buffers_1.default.readyForQuery(),backendKeyDataBuffer=test_buffers_1.default.backendKeyData(1,2),commandCompleteBuffer=test_buffers_1.default.commandComplete("SELECT 3"),parseCompleteBuffer=test_buffers_1.default.parseComplete(),bindCompleteBuffer=test_buffers_1.default.bindComplete(),portalSuspendedBuffer=test_buffers_1.default.portalSuspended(),row1={name:"id",tableID:1,attributeNumber:2,dataTypeID:3,dataTypeSize:4,typeModifier:5,formatCode:0},oneRowDescBuff=test_buffers_1.default.rowDescription([row1]);row1.name="bang";var twoRowBuf=test_buffers_1.default.rowDescription([row1,{name:"whoah",tableID:10,attributeNumber:11,dataTypeID:12,dataTypeSize:13,typeModifier:14,formatCode:0}]),emptyRowFieldBuf=(new buffer_list_1.default).addInt16(0).join(!0,"D"),oneFieldBuf=(emptyRowFieldBuf=test_buffers_1.default.dataRow([]),(new buffer_list_1.default).addInt16(1).addInt32(5).addCString("test").join(!0,"D")),expectedAuthenticationOkayMessage=(oneFieldBuf=test_buffers_1.default.dataRow(["test"]),{name:"authenticationOk",length:8}),expectedParameterStatusMessage={name:"parameterStatus",parameterName:"client_encoding",parameterValue:"UTF8",length:25},expectedBackendKeyDataMessage={name:"backendKeyData",processID:1,secretKey:2},expectedReadyForQueryMessage={name:"readyForQuery",length:5,status:"I"},expectedCommandCompleteMessage={name:"commandComplete",length:13,text:"SELECT 3"},emptyRowDescriptionBuffer=(new buffer_list_1.default).addInt16(0).join(!0,"T"),expectedEmptyRowDescriptionMessage={name:"rowDescription",length:6,fieldCount:0,fields:[]},expectedOneRowMessage={name:"rowDescription",length:27,fieldCount:1,fields:[{name:"id",tableID:1,columnID:2,dataTypeID:3,dataTypeSize:4,dataTypeModifier:5,format:"text"}]},expectedTwoRowMessage={name:"rowDescription",length:53,fieldCount:2,fields:[{name:"bang",tableID:1,columnID:2,dataTypeID:3,dataTypeSize:4,dataTypeModifier:5,format:"text"},{name:"whoah",tableID:10,columnID:11,dataTypeID:12,dataTypeSize:13,dataTypeModifier:14,format:"text"}]},emptyParameterDescriptionBuffer=(new buffer_list_1.default).addInt16(0).join(!0,"t"),oneParameterDescBuf=test_buffers_1.default.parameterDescription([1111]),twoParameterDescBuf=test_buffers_1.default.parameterDescription([2222,3333]),expectedEmptyParameterDescriptionMessage={name:"parameterDescription",length:6,parameterCount:0,dataTypeIDs:[]},expectedOneParameterMessage={name:"parameterDescription",length:10,parameterCount:1,dataTypeIDs:[1111]},expectedTwoParameterMessage={name:"parameterDescription",length:14,parameterCount:2,dataTypeIDs:[2222,3333]},testForMessage=function(e,t){it("recieves and parses "+t.name,(()=>__awaiter(this,void 0,void 0,(function*(){const a=yield parseBuffers([e]),[s]=a;for(const e in t)assert_1.default.deepEqual(s[e],t[e])}))))},plainPasswordBuffer=test_buffers_1.default.authenticationCleartextPassword(),md5PasswordBuffer=test_buffers_1.default.authenticationMD5Password(),SASLBuffer=test_buffers_1.default.authenticationSASL(),SASLContinueBuffer=test_buffers_1.default.authenticationSASLContinue(),SASLFinalBuffer=test_buffers_1.default.authenticationSASLFinal(),expectedPlainPasswordMessage={name:"authenticationCleartextPassword"},expectedMD5PasswordMessage={name:"authenticationMD5Password",salt:Buffer.from([1,2,3,4])},expectedSASLMessage={name:"authenticationSASL",mechanisms:["SCRAM-SHA-256"]},expectedSASLContinueMessage={name:"authenticationSASLContinue",data:"data"},expectedSASLFinalMessage={name:"authenticationSASLFinal",data:"data"},notificationResponseBuffer=test_buffers_1.default.notification(4,"hi","boom"),expectedNotificationResponseMessage={name:"notification",processId:4,channel:"hi",payload:"boom"};const parseBuffers=e=>__awaiter(void 0,void 0,void 0,(function*(){const t=new stream_1.PassThrough;for(const a of e)t.write(a);t.end();const a=[];return yield(0,_1.parse)(t,(e=>a.push(e))),a}));describe("PgPacketStream",(function(){testForMessage(authOkBuffer,expectedAuthenticationOkayMessage),testForMessage(plainPasswordBuffer,expectedPlainPasswordMessage),testForMessage(md5PasswordBuffer,expectedMD5PasswordMessage),testForMessage(SASLBuffer,expectedSASLMessage),testForMessage(SASLContinueBuffer,expectedSASLContinueMessage);const e=Buffer.concat([SASLContinueBuffer,Buffer.from([1,2,3,4])]);testForMessage(e,expectedSASLContinueMessage),testForMessage(SASLFinalBuffer,expectedSASLFinalMessage);const t=Buffer.concat([SASLFinalBuffer,Buffer.from([1,2,4,5])]);testForMessage(t,expectedSASLFinalMessage),testForMessage(paramStatusBuffer,expectedParameterStatusMessage),testForMessage(backendKeyDataBuffer,expectedBackendKeyDataMessage),testForMessage(readyForQueryBuffer,expectedReadyForQueryMessage),testForMessage(commandCompleteBuffer,expectedCommandCompleteMessage),testForMessage(notificationResponseBuffer,expectedNotificationResponseMessage),testForMessage(test_buffers_1.default.emptyQuery(),{name:"emptyQuery",length:4}),testForMessage(Buffer.from([110,0,0,0,4]),{name:"noData"}),describe("rowDescription messages",(function(){testForMessage(emptyRowDescriptionBuffer,expectedEmptyRowDescriptionMessage),testForMessage(oneRowDescBuff,expectedOneRowMessage),testForMessage(twoRowBuf,expectedTwoRowMessage)})),describe("parameterDescription messages",(function(){testForMessage(emptyParameterDescriptionBuffer,expectedEmptyParameterDescriptionMessage),testForMessage(oneParameterDescBuf,expectedOneParameterMessage),testForMessage(twoParameterDescBuf,expectedTwoParameterMessage)})),describe("parsing rows",(function(){describe("parsing empty row",(function(){testForMessage(emptyRowFieldBuf,{name:"dataRow",fieldCount:0})})),describe("parsing data row with fields",(function(){testForMessage(oneFieldBuf,{name:"dataRow",fieldCount:1,fields:["test"]})}))})),describe("notice message",(function(){var e=test_buffers_1.default.notice([{type:"C",value:"code"}]);testForMessage(e,{name:"notice",code:"code"})})),testForMessage(test_buffers_1.default.error([]),{name:"error"}),describe("with all the fields",(function(){var e=test_buffers_1.default.error([{type:"S",value:"ERROR"},{type:"C",value:"code"},{type:"M",value:"message"},{type:"D",value:"details"},{type:"H",value:"hint"},{type:"P",value:"100"},{type:"p",value:"101"},{type:"q",value:"query"},{type:"W",value:"where"},{type:"F",value:"file"},{type:"L",value:"line"},{type:"R",value:"routine"},{type:"Z",value:"alsdkf"}]);testForMessage(e,{name:"error",severity:"ERROR",code:"code",message:"message",detail:"details",hint:"hint",position:"100",internalPosition:"101",internalQuery:"query",where:"where",file:"file",line:"line",routine:"routine"})})),testForMessage(parseCompleteBuffer,{name:"parseComplete"}),testForMessage(bindCompleteBuffer,{name:"bindComplete"}),testForMessage(bindCompleteBuffer,{name:"bindComplete"}),testForMessage(test_buffers_1.default.closeComplete(),{name:"closeComplete"}),describe("parses portal suspended message",(function(){testForMessage(portalSuspendedBuffer,{name:"portalSuspended"})})),describe("parses replication start message",(function(){testForMessage(Buffer.from([87,0,0,0,4]),{name:"replicationStart",length:4})})),describe("copy",(()=>{testForMessage(test_buffers_1.default.copyIn(0),{name:"copyInResponse",length:7,binary:!1,columnTypes:[]}),testForMessage(test_buffers_1.default.copyIn(2),{name:"copyInResponse",length:11,binary:!1,columnTypes:[0,1]}),testForMessage(test_buffers_1.default.copyOut(0),{name:"copyOutResponse",length:7,binary:!1,columnTypes:[]}),testForMessage(test_buffers_1.default.copyOut(3),{name:"copyOutResponse",length:13,binary:!1,columnTypes:[0,1,2]}),testForMessage(test_buffers_1.default.copyDone(),{name:"copyDone",length:4}),testForMessage(test_buffers_1.default.copyData(Buffer.from([5,6,7])),{name:"copyData",length:7,chunk:Buffer.from([5,6,7])})})),describe("split buffer, single message parsing",(function(){var e=test_buffers_1.default.dataRow([null,"bang","zug zug",null,"!"]);it("parses when full buffer comes in",(function(){return __awaiter(this,void 0,void 0,(function*(){const t=(yield parseBuffers([e]))[0];assert_1.default.equal(t.fields.length,5),assert_1.default.equal(t.fields[0],null),assert_1.default.equal(t.fields[1],"bang"),assert_1.default.equal(t.fields[2],"zug zug"),assert_1.default.equal(t.fields[3],null),assert_1.default.equal(t.fields[4],"!")}))}));var t=function(t){return __awaiter(this,void 0,void 0,(function*(){var a=Buffer.alloc(e.length-t),s=Buffer.alloc(e.length-a.length);e.copy(a,0,0),e.copy(s,0,a.length);const r=(yield parseBuffers([e]))[0];assert_1.default.equal(r.fields.length,5),assert_1.default.equal(r.fields[0],null),assert_1.default.equal(r.fields[1],"bang"),assert_1.default.equal(r.fields[2],"zug zug"),assert_1.default.equal(r.fields[3],null),assert_1.default.equal(r.fields[4],"!")}))};it("parses when split in the middle",(function(){t(6)})),it("parses when split at end",(function(){t(2)})),it("parses when split at beginning",(function(){t(e.length-2),t(e.length-1),t(e.length-5)}))})),describe("split buffer, multiple message parsing",(function(){var e=test_buffers_1.default.dataRow(["!"]),t=test_buffers_1.default.readyForQuery(),a=Buffer.alloc(e.length+t.length);e.copy(a,0,0),t.copy(a,e.length,0);var s=function(e){assert_1.default.strictEqual(e.length,2),assert_1.default.deepEqual(e[0],{name:"dataRow",fieldCount:1,length:11,fields:["!"]}),assert_1.default.equal(e[0].fields[0],"!"),assert_1.default.deepEqual(e[1],{name:"readyForQuery",length:5,status:"I"})};it("recieves both messages when packet is not split",(function(){return __awaiter(this,void 0,void 0,(function*(){const e=yield parseBuffers([a]);s(e)}))}));var r=function(e){return __awaiter(this,void 0,void 0,(function*(){var t=Buffer.alloc(a.length-e),r=Buffer.alloc(a.length-t.length);a.copy(t,0,0),a.copy(r,0,t.length);const n=yield parseBuffers([t,r]);s(n)}))};describe("recieves both messages when packet is split",(function(){it("in the middle",(function(){return r(11)})),it("at the front",(function(){return Promise.all([r(a.length-1),r(a.length-4),r(a.length-6)])})),it("at the end",(function(){return Promise.all([r(8),r(1)])}))}))}))}));