"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Parser=void 0;const messages_1=require("./messages"),buffer_reader_1=require("./buffer-reader"),CODE_LENGTH=1,LEN_LENGTH=4,HEADER_LENGTH=5,emptyBuffer=Buffer.allocUnsafe(0);class Parser{constructor(e){if(this.buffer=emptyBuffer,this.bufferLength=0,this.bufferOffset=0,this.reader=new buffer_reader_1.BufferReader,"binary"===(null==e?void 0:e.mode))throw new Error("Binary mode not supported yet");this.mode=(null==e?void 0:e.mode)||"text"}parse(e,s){this.mergeBuffer(e);const r=this.bufferOffset+this.bufferLength;let t=this.bufferOffset;for(;t+5<=r;){const e=this.buffer[t],a=this.buffer.readUInt32BE(t+1),i=1+a;if(!(i+t<=r))break;s(this.handlePacket(t+5,e,a,this.buffer)),t+=i}t===r?(this.buffer=emptyBuffer,this.bufferLength=0,this.bufferOffset=0):(this.bufferLength=r-t,this.bufferOffset=t)}mergeBuffer(e){if(this.bufferLength>0){const s=this.bufferLength+e.byteLength;if(s+this.bufferOffset>this.buffer.byteLength){let e;if(s<=this.buffer.byteLength&&this.bufferOffset>=this.bufferLength)e=this.buffer;else{let r=2*this.buffer.byteLength;for(;s>=r;)r*=2;e=Buffer.allocUnsafe(r)}this.buffer.copy(e,0,this.bufferOffset,this.bufferOffset+this.bufferLength),this.buffer=e,this.bufferOffset=0}e.copy(this.buffer,this.bufferOffset+this.bufferLength),this.bufferLength=s}else this.buffer=e,this.bufferOffset=0,this.bufferLength=e.byteLength}handlePacket(e,s,r,t){switch(s){case 50:return messages_1.bindComplete;case 49:return messages_1.parseComplete;case 51:return messages_1.closeComplete;case 110:return messages_1.noData;case 115:return messages_1.portalSuspended;case 99:return messages_1.copyDone;case 87:return messages_1.replicationStart;case 73:return messages_1.emptyQuery;case 68:return this.parseDataRowMessage(e,r,t);case 67:return this.parseCommandCompleteMessage(e,r,t);case 90:return this.parseReadyForQueryMessage(e,r,t);case 65:return this.parseNotificationMessage(e,r,t);case 82:return this.parseAuthenticationResponse(e,r,t);case 83:return this.parseParameterStatusMessage(e,r,t);case 75:return this.parseBackendKeyData(e,r,t);case 69:return this.parseErrorMessage(e,r,t,"error");case 78:return this.parseErrorMessage(e,r,t,"notice");case 84:return this.parseRowDescriptionMessage(e,r,t);case 116:return this.parseParameterDescriptionMessage(e,r,t);case 71:return this.parseCopyInMessage(e,r,t);case 72:return this.parseCopyOutMessage(e,r,t);case 100:return this.parseCopyData(e,r,t);default:return new messages_1.DatabaseError("received invalid response: "+s.toString(16),r,"error")}}parseReadyForQueryMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.string(1);return new messages_1.ReadyForQueryMessage(s,t)}parseCommandCompleteMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.cstring();return new messages_1.CommandCompleteMessage(s,t)}parseCopyData(e,s,r){const t=r.slice(e,e+(s-4));return new messages_1.CopyDataMessage(s,t)}parseCopyInMessage(e,s,r){return this.parseCopyMessage(e,s,r,"copyInResponse")}parseCopyOutMessage(e,s,r){return this.parseCopyMessage(e,s,r,"copyOutResponse")}parseCopyMessage(e,s,r,t){this.reader.setBuffer(e,r);const a=0!==this.reader.byte(),i=this.reader.int16(),n=new messages_1.CopyResponse(s,t,a,i);for(let e=0;e<i;e++)n.columnTypes[e]=this.reader.int16();return n}parseNotificationMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.int32(),a=this.reader.cstring(),i=this.reader.cstring();return new messages_1.NotificationResponseMessage(s,t,a,i)}parseRowDescriptionMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.int16(),a=new messages_1.RowDescriptionMessage(s,t);for(let e=0;e<t;e++)a.fields[e]=this.parseField();return a}parseField(){const e=this.reader.cstring(),s=this.reader.int32(),r=this.reader.int16(),t=this.reader.int32(),a=this.reader.int16(),i=this.reader.int32(),n=0===this.reader.int16()?"text":"binary";return new messages_1.Field(e,s,r,t,a,i,n)}parseParameterDescriptionMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.int16(),a=new messages_1.ParameterDescriptionMessage(s,t);for(let e=0;e<t;e++)a.dataTypeIDs[e]=this.reader.int32();return a}parseDataRowMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.int16(),a=new Array(t);for(let e=0;e<t;e++){const s=this.reader.int32();a[e]=-1===s?null:this.reader.string(s)}return new messages_1.DataRowMessage(s,a)}parseParameterStatusMessage(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.cstring(),a=this.reader.cstring();return new messages_1.ParameterStatusMessage(s,t,a)}parseBackendKeyData(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.int32(),a=this.reader.int32();return new messages_1.BackendKeyDataMessage(s,t,a)}parseAuthenticationResponse(e,s,r){this.reader.setBuffer(e,r);const t=this.reader.int32(),a={name:"authenticationOk",length:s};switch(t){case 0:break;case 3:8===a.length&&(a.name="authenticationCleartextPassword");break;case 5:if(12===a.length){a.name="authenticationMD5Password";const e=this.reader.bytes(4);return new messages_1.AuthenticationMD5Password(s,e)}break;case 10:let e;a.name="authenticationSASL",a.mechanisms=[];do{e=this.reader.cstring(),e&&a.mechanisms.push(e)}while(e);break;case 11:a.name="authenticationSASLContinue",a.data=this.reader.string(s-8);break;case 12:a.name="authenticationSASLFinal",a.data=this.reader.string(s-8);break;default:throw new Error("Unknown authenticationOk message type "+t)}return a}parseErrorMessage(e,s,r,t){this.reader.setBuffer(e,r);const a={};let i=this.reader.string(1);for(;"\0"!==i;)a[i]=this.reader.cstring(),i=this.reader.string(1);const n=a.M,f="notice"===t?new messages_1.NoticeMessage(s,n):new messages_1.DatabaseError(n,s,t);return f.severity=a.S,f.code=a.C,f.detail=a.D,f.hint=a.H,f.position=a.P,f.internalPosition=a.p,f.internalQuery=a.q,f.where=a.W,f.schema=a.s,f.table=a.t,f.column=a.c,f.dataType=a.d,f.constraint=a.n,f.file=a.F,f.line=a.L,f.routine=a.R,f}}exports.Parser=Parser;