"use strict";var EventEmitter=require("events").EventEmitter,util=require("util"),utils=require("./utils"),sasl=require("./sasl"),pgPass=require("pgpass"),TypeOverrides=require("./type-overrides"),ConnectionParameters=require("./connection-parameters"),Query=require("./query"),defaults=require("./defaults"),Connection=require("./connection");class Client extends EventEmitter{constructor(e){super(),this.connectionParameters=new ConnectionParameters(e),this.user=this.connectionParameters.user,this.database=this.connectionParameters.database,this.port=this.connectionParameters.port,this.host=this.connectionParameters.host,Object.defineProperty(this,"password",{configurable:!0,enumerable:!1,writable:!0,value:this.connectionParameters.password}),this.replication=this.connectionParameters.replication;var t=e||{};this._Promise=t.Promise||global.Promise,this._types=new TypeOverrides(t.types),this._ending=!1,this._connecting=!1,this._connected=!1,this._connectionError=!1,this._queryable=!0,this.connection=t.connection||new Connection({stream:t.stream,ssl:this.connectionParameters.ssl,keepAlive:t.keepAlive||!1,keepAliveInitialDelayMillis:t.keepAliveInitialDelayMillis||0,encoding:this.connectionParameters.client_encoding||"utf8"}),this.queryQueue=[],this.binary=t.binary||defaults.binary,this.processID=null,this.secretKey=null,this.ssl=this.connectionParameters.ssl||!1,this.ssl&&this.ssl.key&&Object.defineProperty(this.ssl,"key",{enumerable:!1}),this._connectionTimeoutMillis=t.connectionTimeoutMillis||0}_errorAllQueries(e){const t=t=>{process.nextTick((()=>{t.handleError(e,this.connection)}))};this.activeQuery&&(t(this.activeQuery),this.activeQuery=null),this.queryQueue.forEach(t),this.queryQueue.length=0}_connect(e){var t=this,n=this.connection;if(this._connectionCallback=e,this._connecting||this._connected){const t=new Error("Client has already been connected. You cannot reuse a client.");process.nextTick((()=>{e(t)}))}else this._connecting=!0,this.connectionTimeoutHandle,this._connectionTimeoutMillis>0&&(this.connectionTimeoutHandle=setTimeout((()=>{n._ending=!0,n.stream.destroy(new Error("timeout expired"))}),this._connectionTimeoutMillis)),this.host&&0===this.host.indexOf("/")?n.connect(this.host+"/.s.PGSQL."+this.port):n.connect(this.port,this.host),n.on("connect",(function(){t.ssl?n.requestSsl():n.startup(t.getStartupConf())})),n.on("sslconnect",(function(){n.startup(t.getStartupConf())})),this._attachListeners(n),n.once("end",(()=>{const e=this._ending?new Error("Connection terminated"):new Error("Connection terminated unexpectedly");clearTimeout(this.connectionTimeoutHandle),this._errorAllQueries(e),this._ending||(this._connecting&&!this._connectionError?this._connectionCallback?this._connectionCallback(e):this._handleErrorEvent(e):this._connectionError||this._handleErrorEvent(e)),process.nextTick((()=>{this.emit("end")}))}))}connect(e){if(!e)return new this._Promise(((e,t)=>{this._connect((n=>{n?t(n):e()}))}));this._connect(e)}_attachListeners(e){e.on("authenticationCleartextPassword",this._handleAuthCleartextPassword.bind(this)),e.on("authenticationMD5Password",this._handleAuthMD5Password.bind(this)),e.on("authenticationSASL",this._handleAuthSASL.bind(this)),e.on("authenticationSASLContinue",this._handleAuthSASLContinue.bind(this)),e.on("authenticationSASLFinal",this._handleAuthSASLFinal.bind(this)),e.on("backendKeyData",this._handleBackendKeyData.bind(this)),e.on("error",this._handleErrorEvent.bind(this)),e.on("errorMessage",this._handleErrorMessage.bind(this)),e.on("readyForQuery",this._handleReadyForQuery.bind(this)),e.on("notice",this._handleNotice.bind(this)),e.on("rowDescription",this._handleRowDescription.bind(this)),e.on("dataRow",this._handleDataRow.bind(this)),e.on("portalSuspended",this._handlePortalSuspended.bind(this)),e.on("emptyQuery",this._handleEmptyQuery.bind(this)),e.on("commandComplete",this._handleCommandComplete.bind(this)),e.on("parseComplete",this._handleParseComplete.bind(this)),e.on("copyInResponse",this._handleCopyInResponse.bind(this)),e.on("copyData",this._handleCopyData.bind(this)),e.on("notification",this._handleNotification.bind(this))}_checkPgPass(e){const t=this.connection;"function"==typeof this.password?this._Promise.resolve().then((()=>this.password())).then((n=>{if(void 0!==n){if("string"!=typeof n)return void t.emit("error",new TypeError("Password must be a string"));this.connectionParameters.password=this.password=n}else this.connectionParameters.password=this.password=null;e()})).catch((e=>{t.emit("error",e)})):null!==this.password?e():pgPass(this.connectionParameters,(t=>{void 0!==t&&(this.connectionParameters.password=this.password=t),e()}))}_handleAuthCleartextPassword(e){this._checkPgPass((()=>{this.connection.password(this.password)}))}_handleAuthMD5Password(e){this._checkPgPass((()=>{const t=utils.postgresMd5PasswordHash(this.user,this.password,e.salt);this.connection.password(t)}))}_handleAuthSASL(e){this._checkPgPass((()=>{this.saslSession=sasl.startSession(e.mechanisms),this.connection.sendSASLInitialResponseMessage(this.saslSession.mechanism,this.saslSession.response)}))}_handleAuthSASLContinue(e){sasl.continueSession(this.saslSession,this.password,e.data),this.connection.sendSCRAMClientFinalMessage(this.saslSession.response)}_handleAuthSASLFinal(e){sasl.finalizeSession(this.saslSession,e.data),this.saslSession=null}_handleBackendKeyData(e){this.processID=e.processID,this.secretKey=e.secretKey}_handleReadyForQuery(e){this._connecting&&(this._connecting=!1,this._connected=!0,clearTimeout(this.connectionTimeoutHandle),this._connectionCallback&&(this._connectionCallback(null,this),this._connectionCallback=null),this.emit("connect"));const{activeQuery:t}=this;this.activeQuery=null,this.readyForQuery=!0,t&&t.handleReadyForQuery(this.connection),this._pulseQueryQueue()}_handleErrorWhileConnecting(e){if(!this._connectionError){if(this._connectionError=!0,clearTimeout(this.connectionTimeoutHandle),this._connectionCallback)return this._connectionCallback(e);this.emit("error",e)}}_handleErrorEvent(e){if(this._connecting)return this._handleErrorWhileConnecting(e);this._queryable=!1,this._errorAllQueries(e),this.emit("error",e)}_handleErrorMessage(e){if(this._connecting)return this._handleErrorWhileConnecting(e);const t=this.activeQuery;t?(this.activeQuery=null,t.handleError(e,this.connection)):this._handleErrorEvent(e)}_handleRowDescription(e){this.activeQuery.handleRowDescription(e)}_handleDataRow(e){this.activeQuery.handleDataRow(e)}_handlePortalSuspended(e){this.activeQuery.handlePortalSuspended(this.connection)}_handleEmptyQuery(e){this.activeQuery.handleEmptyQuery(this.connection)}_handleCommandComplete(e){this.activeQuery.handleCommandComplete(e,this.connection)}_handleParseComplete(e){this.activeQuery.name&&(this.connection.parsedStatements[this.activeQuery.name]=this.activeQuery.text)}_handleCopyInResponse(e){this.activeQuery.handleCopyInResponse(this.connection)}_handleCopyData(e){this.activeQuery.handleCopyData(e,this.connection)}_handleNotification(e){this.emit("notification",e)}_handleNotice(e){this.emit("notice",e)}getStartupConf(){var e=this.connectionParameters,t={user:e.user,database:e.database},n=e.application_name||e.fallback_application_name;return n&&(t.application_name=n),e.replication&&(t.replication=""+e.replication),e.statement_timeout&&(t.statement_timeout=String(parseInt(e.statement_timeout,10))),e.lock_timeout&&(t.lock_timeout=String(parseInt(e.lock_timeout,10))),e.idle_in_transaction_session_timeout&&(t.idle_in_transaction_session_timeout=String(parseInt(e.idle_in_transaction_session_timeout,10))),e.options&&(t.options=e.options),t}cancel(e,t){if(e.activeQuery===t){var n=this.connection;this.host&&0===this.host.indexOf("/")?n.connect(this.host+"/.s.PGSQL."+this.port):n.connect(this.port,this.host),n.on("connect",(function(){n.cancel(e.processID,e.secretKey)}))}else-1!==e.queryQueue.indexOf(t)&&e.queryQueue.splice(e.queryQueue.indexOf(t),1)}setTypeParser(e,t,n){return this._types.setTypeParser(e,t,n)}getTypeParser(e,t){return this._types.getTypeParser(e,t)}escapeIdentifier(e){return'"'+e.replace(/"/g,'""')+'"'}escapeLiteral(e){for(var t=!1,n="'",i=0;i<e.length;i++){var s=e[i];"'"===s?n+=s+s:"\\"===s?(n+=s+s,t=!0):n+=s}return n+="'",!0===t&&(n=" E"+n),n}_pulseQueryQueue(){if(!0===this.readyForQuery)if(this.activeQuery=this.queryQueue.shift(),this.activeQuery){this.readyForQuery=!1,this.hasExecuted=!0;const e=this.activeQuery.submit(this.connection);e&&process.nextTick((()=>{this.activeQuery.handleError(e,this.connection),this.readyForQuery=!0,this._pulseQueryQueue()}))}else this.hasExecuted&&(this.activeQuery=null,this.emit("drain"))}query(e,t,n){var i,s,o,r,a;if(null==e)throw new TypeError("Client was passed a null or undefined query");return"function"==typeof e.submit?(o=e.query_timeout||this.connectionParameters.query_timeout,s=i=e,"function"==typeof t&&(i.callback=i.callback||t)):(o=this.connectionParameters.query_timeout,(i=new Query(e,t,n)).callback||(s=new this._Promise(((e,t)=>{i.callback=(n,i)=>n?t(n):e(i)})))),o&&(a=i.callback,r=setTimeout((()=>{var e=new Error("Query read timeout");process.nextTick((()=>{i.handleError(e,this.connection)})),a(e),i.callback=()=>{};var t=this.queryQueue.indexOf(i);t>-1&&this.queryQueue.splice(t,1),this._pulseQueryQueue()}),o),i.callback=(e,t)=>{clearTimeout(r),a(e,t)}),this.binary&&!i.binary&&(i.binary=!0),i._result&&!i._result._types&&(i._result._types=this._types),this._queryable?this._ending?(process.nextTick((()=>{i.handleError(new Error("Client was closed and is not queryable"),this.connection)})),s):(this.queryQueue.push(i),this._pulseQueryQueue(),s):(process.nextTick((()=>{i.handleError(new Error("Client has encountered a connection error and is not queryable"),this.connection)})),s)}ref(){this.connection.ref()}unref(){this.connection.unref()}end(e){if(this._ending=!0,!this.connection._connecting){if(!e)return this._Promise.resolve();e()}if(this.activeQuery||!this._queryable?this.connection.stream.destroy():this.connection.end(),!e)return new this._Promise((e=>{this.connection.once("end",e)}));this.connection.once("end",e)}}Client.Query=Query,module.exports=Client;