"use strict";const crypto=require("crypto");function startSession(r){if(-1===r.indexOf("SCRAM-SHA-256"))throw new Error("SASL: Only mechanism SCRAM-SHA-256 is currently supported");const e=crypto.randomBytes(18).toString("base64");return{mechanism:"SCRAM-SHA-256",clientNonce:e,response:"n,,n=*,r="+e,message:"SASLInitialResponse"}}function continueSession(r,e,t){if("SASLInitialResponse"!==r.message)throw new Error("SASL: Last message was not SASLInitialResponse");if("string"!=typeof e)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: client password must be a string");if("string"!=typeof t)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: serverData must be a string");const n=parseServerFirstMessage(t);if(!n.nonce.startsWith(r.clientNonce))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: server nonce does not start with client nonce");if(n.nonce.length===r.clientNonce.length)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: server nonce is too short");var s=Hi(e,Buffer.from(n.salt,"base64"),n.iteration),i=hmacSha256(s,"Client Key"),S=sha256(i),o="n=*,r="+r.clientNonce,a="r="+n.nonce+",s="+n.salt+",i="+n.iteration,f="c=biws,r="+n.nonce,E=o+","+a+","+f,u=xorBuffers(i,hmacSha256(S,E)).toString("base64"),c=hmacSha256(s,"Server Key"),A=hmacSha256(c,E);r.message="SASLResponse",r.serverSignature=A.toString("base64"),r.response=f+",p="+u}function finalizeSession(r,e){if("SASLResponse"!==r.message)throw new Error("SASL: Last message was not SASLResponse");if("string"!=typeof e)throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: serverData must be a string");const{serverSignature:t}=parseServerFinalMessage(e);if(t!==r.serverSignature)throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature does not match")}function isPrintableChars(r){if("string"!=typeof r)throw new TypeError("SASL: text must be a string");return r.split("").map(((e,t)=>r.charCodeAt(t))).every((r=>r>=33&&r<=43||r>=45&&r<=126))}function isBase64(r){return/^(?:[a-zA-Z0-9+/]{4})*(?:[a-zA-Z0-9+/]{2}==|[a-zA-Z0-9+/]{3}=)?$/.test(r)}function parseAttributePairs(r){if("string"!=typeof r)throw new TypeError("SASL: attribute pairs text must be a string");return new Map(r.split(",").map((r=>{if(!/^.=/.test(r))throw new Error("SASL: Invalid attribute pair entry");return[r[0],r.substring(2)]})))}function parseServerFirstMessage(r){const e=parseAttributePairs(r),t=e.get("r");if(!t)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: nonce missing");if(!isPrintableChars(t))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: nonce must only contain printable characters");const n=e.get("s");if(!n)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: salt missing");if(!isBase64(n))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: salt must be base64");const s=e.get("i");if(!s)throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: iteration missing");if(!/^[1-9][0-9]*$/.test(s))throw new Error("SASL: SCRAM-SERVER-FIRST-MESSAGE: invalid iteration count");return{nonce:t,salt:n,iteration:parseInt(s,10)}}function parseServerFinalMessage(r){const e=parseAttributePairs(r).get("v");if(!e)throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature is missing");if(!isBase64(e))throw new Error("SASL: SCRAM-SERVER-FINAL-MESSAGE: server signature must be base64");return{serverSignature:e}}function xorBuffers(r,e){if(!Buffer.isBuffer(r))throw new TypeError("first argument must be a Buffer");if(!Buffer.isBuffer(e))throw new TypeError("second argument must be a Buffer");if(r.length!==e.length)throw new Error("Buffer lengths must match");if(0===r.length)throw new Error("Buffers cannot be empty");return Buffer.from(r.map(((t,n)=>r[n]^e[n])))}function sha256(r){return crypto.createHash("sha256").update(r).digest()}function hmacSha256(r,e){return crypto.createHmac("sha256",r).update(e).digest()}function Hi(r,e,t){for(var n=hmacSha256(r,Buffer.concat([e,Buffer.from([0,0,0,1])])),s=n,i=0;i<t-1;i++)s=xorBuffers(s,n=hmacSha256(r,n));return s}module.exports={startSession:startSession,continueSession:continueSession,finalizeSession:finalizeSession};