"use strict";const test=require("tape"),split=require("./"),callback=require("callback-stream"),strcb=callback.bind(null,{decodeStrings:!1}),objcb=callback.bind(null,{objectMode:!0});test("split two lines on end",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello\nworld")})),test("split two lines on two writes",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.write("hello"),e.write("\nworld"),e.end()})),test("split four lines on three writes",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world","bye","world"])}))),e.write("hello\nwor"),e.write("ld\nbye\nwo"),e.write("rld"),e.end()})),test("accumulate multiple writes",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["helloworld"])}))),e.write("hello"),e.write("world"),e.end()})),test("split using a custom string matcher",(function(t){t.plan(2);const e=split("~");e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello~world")})),test("split using a custom regexp matcher",(function(t){t.plan(2);const e=split(/~/);e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello~world")})),test("support an option argument",(function(t){t.plan(2);const e=split({highWaterMark:2});e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello\nworld")})),test("support a mapper function",(function(t){t.plan(2);const e={a:"42"},n={b:"24"},r=split(JSON.parse);r.pipe(objcb((function(r,o){t.error(r),t.deepEqual(o,[e,n])}))),r.write(JSON.stringify(e)),r.write("\n"),r.end(JSON.stringify(n))})),test("split lines windows-style",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello\r\nworld")})),test("splits a buffer",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end(Buffer.from("hello\nworld"))})),test("do not end on undefined",(function(t){t.plan(2);const e=split((function(t){}));e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,[])}))),e.end(Buffer.from("hello\nworld"))})),test("has destroy method",(function(t){t.plan(1);const e=split((function(t){}));e.on("close",(function(){t.ok(!0,"close emitted"),t.end()})),e.destroy()})),test("support custom matcher and mapper",(function(t){t.plan(4);const e={a:"42"},n={b:"24"},r=split("~",JSON.parse);t.equal(r.matcher,"~"),t.equal(typeof r.mapper,"function"),r.pipe(objcb((function(r,o){t.notOk(r,"no errors"),t.deepEqual(o,[e,n])}))),r.write(JSON.stringify(e)),r.write("~"),r.end(JSON.stringify(n))})),test("support custom matcher and options",(function(t){t.plan(6);const e=split("~",{highWaterMark:1024});t.equal(e.matcher,"~"),t.equal(typeof e.mapper,"function"),t.equal(e._readableState.highWaterMark,1024),t.equal(e._writableState.highWaterMark,1024),e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello~world")})),test("support mapper and options",(function(t){t.plan(6);const e={a:"42"},n={b:"24"},r=split(JSON.parse,{highWaterMark:1024});t.ok(r.matcher instanceof RegExp,"matcher is RegExp"),t.equal(typeof r.mapper,"function"),t.equal(r._readableState.highWaterMark,1024),t.equal(r._writableState.highWaterMark,1024),r.pipe(objcb((function(r,o){t.error(r),t.deepEqual(o,[e,n])}))),r.write(JSON.stringify(e)),r.write("\n"),r.end(JSON.stringify(n))})),test("split utf8 chars",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["烫烫烫","锟斤拷"])})));const n=Buffer.from("烫烫烫\r\n锟斤拷","utf8");for(let t=0;t<n.length;++t)e.write(n.slice(t,t+1));e.end()})),test("split utf8 chars 2by2",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["烫烫烫","烫烫烫"])})));const n=Buffer.from("烫烫烫\r\n烫烫烫","utf8");for(let t=0;t<n.length;t+=2)e.write(n.slice(t,t+2));e.end()})),test("split lines when the \n comes at the end of a chunk",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.write("hello\n"),e.end("world")})),test("truncated utf-8 char",(function(t){t.plan(2);const e=split();e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["烫"+Buffer.from("e7","hex").toString()])})));const n=Buffer.from("烫烫","utf8");e.write(n.slice(0,3)),e.end(n.slice(3,4))})),test("maximum buffer limit",(function(t){t.plan(1);const e=split({maxLength:2});e.on("error",(function(e){t.ok(e)})),e.resume(),e.write("hey")})),test("readable highWaterMark",(function(t){const e=split();t.equal(e._readableState.highWaterMark,16),t.end()})),test("maxLength < chunk size",(function(t){t.plan(2);const e=split({maxLength:2});e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["a","b"])}))),e.end("a\nb")})),test("maximum buffer limit w/skip",(function(t){t.plan(2);const e=split({maxLength:2,skipOverflow:!0});e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["a","b","c"])}))),e.write("a\n123"),e.write("456"),e.write("789\nb\nc"),e.end()})),test("don't modify the options object",(function(t){t.plan(2);const e={},n=split(e);n.pipe(strcb((function(n,r){t.error(n),t.same(e,{})}))),n.end()})),test("mapper throws flush",(function(t){t.plan(1);const e=new Error,n=split((function(){throw e}));n.on("error",((n,r)=>{t.same(n,e)})),n.end("hello")})),test("mapper throws on transform",(function(t){t.plan(1);const e=new Error,n=split((function(t){throw e}));n.on("error",(n=>{t.same(n,e)})),n.write("a"),n.write("\n"),n.end("b")})),test("supports Symbol.split",(function(t){t.plan(2);const e=split({[Symbol.split]:t=>t.split("~")});e.pipe(strcb((function(e,n){t.error(e),t.deepEqual(n,["hello","world"])}))),e.end("hello~world")}));