"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const PendingOperation_1=require("./PendingOperation"),Resource_1=require("./Resource"),utils_1=require("./utils"),events_1=require("events"),timers_1=require("timers");class Pool{constructor(e){if(this.destroyed=!1,this.emitter=new events_1.EventEmitter,!(e=e||{}).create)throw new Error("Tarn: opt.create function most be provided");if(!e.destroy)throw new Error("Tarn: opt.destroy function most be provided");if("number"!=typeof e.min||e.min<0||e.min!==Math.round(e.min))throw new Error("Tarn: opt.min must be an integer >= 0");if("number"!=typeof e.max||e.max<=0||e.max!==Math.round(e.max))throw new Error("Tarn: opt.max must be an integer > 0");if(e.min>e.max)throw new Error("Tarn: opt.max is smaller than opt.min");if(!utils_1.checkOptionalTime(e.acquireTimeoutMillis))throw new Error("Tarn: invalid opt.acquireTimeoutMillis "+JSON.stringify(e.acquireTimeoutMillis));if(!utils_1.checkOptionalTime(e.createTimeoutMillis))throw new Error("Tarn: invalid opt.createTimeoutMillis "+JSON.stringify(e.createTimeoutMillis));if(!utils_1.checkOptionalTime(e.destroyTimeoutMillis))throw new Error("Tarn: invalid opt.destroyTimeoutMillis "+JSON.stringify(e.destroyTimeoutMillis));if(!utils_1.checkOptionalTime(e.idleTimeoutMillis))throw new Error("Tarn: invalid opt.idleTimeoutMillis "+JSON.stringify(e.idleTimeoutMillis));if(!utils_1.checkOptionalTime(e.reapIntervalMillis))throw new Error("Tarn: invalid opt.reapIntervalMillis "+JSON.stringify(e.reapIntervalMillis));if(!utils_1.checkOptionalTime(e.createRetryIntervalMillis))throw new Error("Tarn: invalid opt.createRetryIntervalMillis "+JSON.stringify(e.createRetryIntervalMillis));const t={create:!0,validate:!0,destroy:!0,log:!0,min:!0,max:!0,acquireTimeoutMillis:!0,createTimeoutMillis:!0,destroyTimeoutMillis:!0,idleTimeoutMillis:!0,reapIntervalMillis:!0,createRetryIntervalMillis:!0,propagateCreateError:!0};for(const i of Object.keys(e))if(!t[i])throw new Error(`Tarn: unsupported option opt.${i}`);this.creator=e.create,this.destroyer=e.destroy,this.validate="function"==typeof e.validate?e.validate:()=>!0,this.log=e.log||(()=>{}),this.acquireTimeoutMillis=e.acquireTimeoutMillis||3e4,this.createTimeoutMillis=e.createTimeoutMillis||3e4,this.destroyTimeoutMillis=e.destroyTimeoutMillis||5e3,this.idleTimeoutMillis=e.idleTimeoutMillis||3e4,this.reapIntervalMillis=e.reapIntervalMillis||1e3,this.createRetryIntervalMillis=e.createRetryIntervalMillis||200,this.propagateCreateError=!!e.propagateCreateError,this.min=e.min,this.max=e.max,this.used=[],this.free=[],this.pendingCreates=[],this.pendingAcquires=[],this.pendingDestroys=[],this.pendingValidations=[],this.destroyed=!1,this.interval=null,this.eventId=1}numUsed(){return this.used.length}numFree(){return this.free.length}numPendingAcquires(){return this.pendingAcquires.length}numPendingValidations(){return this.pendingValidations.length}numPendingCreates(){return this.pendingCreates.length}acquire(){const e=this.eventId++;this._executeEventHandlers("acquireRequest",e);const t=new PendingOperation_1.PendingOperation(this.acquireTimeoutMillis);return this.pendingAcquires.push(t),t.promise=t.promise.then((t=>(this._executeEventHandlers("acquireSuccess",e,t),t))).catch((i=>(this._executeEventHandlers("acquireFail",e,i),remove(this.pendingAcquires,t),Promise.reject(i)))),this._tryAcquireOrCreate(),t}release(e){this._executeEventHandlers("release",e);for(let t=0,i=this.used.length;t<i;++t){const i=this.used[t];if(i.resource===e)return this.used.splice(t,1),this.free.push(i.resolve()),this._tryAcquireOrCreate(),!0}return!1}isEmpty(){return 0===[this.numFree(),this.numUsed(),this.numPendingAcquires(),this.numPendingValidations(),this.numPendingCreates()].reduce(((e,t)=>e+t))}check(){const e=utils_1.now(),t=[],i=this.min-this.used.length,r=this.free.length-i;let s=0;this.free.forEach((i=>{utils_1.duration(e,i.timestamp)>=this.idleTimeoutMillis&&s<r?(s++,this._destroy(i.resource)):t.push(i)})),this.free=t,this.isEmpty()&&this._stopReaping()}destroy(){const e=this.eventId++;return this._executeEventHandlers("poolDestroyRequest",e),this._stopReaping(),this.destroyed=!0,utils_1.reflect(Promise.all(this.pendingCreates.map((e=>utils_1.reflect(e.promise)))).then((()=>new Promise(((e,t)=>{if(0===this.numPendingValidations())return void e();const i=setInterval((()=>{0===this.numPendingValidations()&&(timers_1.clearInterval(i),e())}),100)})))).then((()=>Promise.all(this.used.map((e=>utils_1.reflect(e.promise)))))).then((()=>Promise.all(this.pendingAcquires.map((e=>(e.abort(),utils_1.reflect(e.promise))))))).then((()=>Promise.all(this.free.map((e=>utils_1.reflect(this._destroy(e.resource))))))).then((()=>Promise.all(this.pendingDestroys.map((e=>e.promise))))).then((()=>{this.free=[],this.pendingAcquires=[]}))).then((t=>(this._executeEventHandlers("poolDestroySuccess",e),this.emitter.removeAllListeners(),t)))}on(e,t){this.emitter.on(e,t)}removeListener(e,t){this.emitter.removeListener(e,t)}removeAllListeners(e){this.emitter.removeAllListeners(e)}_tryAcquireOrCreate(){this.destroyed||(this._hasFreeResources()?this._doAcquire():this._shouldCreateMoreResources()&&this._doCreate())}_hasFreeResources(){return this.free.length>0}_doAcquire(){for(;this._canAcquire();){const e=this.pendingAcquires.shift(),t=this.free.pop();if(void 0===t||void 0===e){const e="this.free was empty while trying to acquire resource";throw this.log(`Tarn: ${e}`,"warn"),new Error(`Internal error, should never happen. ${e}`)}this.pendingValidations.push(e),this.used.push(t);const i=new PendingOperation_1.PendingOperation(this.acquireTimeoutMillis);e.promise.catch((e=>{i.abort()})),i.promise.catch((e=>(this.log("Tarn: resource validator threw an exception "+e.stack,"warn"),!1))).then((i=>{try{i&&!e.isRejected?(this._startReaping(),e.resolve(t.resource)):(remove(this.used,t),i?this.free.push(t):(this._destroy(t.resource),setTimeout((()=>{this._tryAcquireOrCreate()}),0)),e.isRejected||this.pendingAcquires.unshift(e))}finally{remove(this.pendingValidations,e)}})),this._validateResource(t.resource).then((e=>{i.resolve(e)})).catch((e=>{i.reject(e)}))}}_canAcquire(){return this.free.length>0&&this.pendingAcquires.length>0}_validateResource(e){try{return Promise.resolve(this.validate(e))}catch(e){return Promise.reject(e)}}_shouldCreateMoreResources(){return this.used.length+this.pendingCreates.length<this.max&&this.pendingCreates.length<this.pendingAcquires.length}_doCreate(){const e=this.pendingAcquires.slice();this._create().promise.then((()=>(this._tryAcquireOrCreate(),null))).catch((t=>{this.propagateCreateError&&0!==this.pendingAcquires.length&&this.pendingAcquires[0].reject(t),e.forEach((e=>{e.possibleTimeoutCause=t})),utils_1.delay(this.createRetryIntervalMillis).then((()=>this._tryAcquireOrCreate()))}))}_create(){const e=this.eventId++;this._executeEventHandlers("createRequest",e);const t=new PendingOperation_1.PendingOperation(this.createTimeoutMillis);return t.promise=t.promise.catch((i=>{throw remove(this.pendingCreates,t)&&this._executeEventHandlers("createFail",e,i),i})),this.pendingCreates.push(t),callbackOrPromise(this.creator).then((i=>t.isRejected?(this.destroyer(i),null):(remove(this.pendingCreates,t),this.free.push(new Resource_1.Resource(i)),t.resolve(i),this._executeEventHandlers("createSuccess",e,i),null))).catch((i=>(t.isRejected||(remove(this.pendingCreates,t)&&this._executeEventHandlers("createFail",e,i),t.reject(i)),null))),t}_destroy(e){const t=this.eventId++;this._executeEventHandlers("destroyRequest",t,e);const i=new PendingOperation_1.PendingOperation(this.destroyTimeoutMillis);return Promise.resolve().then((()=>this.destroyer(e))).then((()=>{i.resolve(e)})).catch((e=>{i.reject(e)})),this.pendingDestroys.push(i),i.promise.then((i=>(this._executeEventHandlers("destroySuccess",t,e),i))).catch((i=>this._logDestroyerError(t,e,i))).then((e=>{const t=this.pendingDestroys.findIndex((e=>e===i));return this.pendingDestroys.splice(t,1),e}))}_logDestroyerError(e,t,i){this._executeEventHandlers("destroyFail",e,t,i),this.log("Tarn: resource destroyer threw an exception "+i.stack,"warn")}_startReaping(){this.interval||(this._executeEventHandlers("startReaping"),this.interval=setInterval((()=>this.check()),this.reapIntervalMillis))}_stopReaping(){null!==this.interval&&(this._executeEventHandlers("stopReaping"),timers_1.clearInterval(this.interval)),this.interval=null}_executeEventHandlers(e,...t){this.emitter.listeners(e).forEach((i=>{try{i(...t)}catch(t){this.log(`Tarn: event handler "${e}" threw an exception ${t.stack}`,"warn")}}))}}function remove(e,t){const i=e.indexOf(t);return-1!==i&&(e.splice(i,1),!0)}function callbackOrPromise(e){return new Promise(((t,i)=>{const r=(e,r)=>{e?i(e):t(r)};utils_1.tryPromise((()=>e(r))).then((e=>{e&&t(e)})).catch((e=>{i(e)}))}))}exports.Pool=Pool;