"use strict";const fs=require("fs"),child_process=require("child_process"),{PerformanceObserver:PerformanceObserver,constants:{NODE_PERFORMANCE_GC_INCREMENTAL:NODE_PERFORMANCE_GC_INCREMENTAL,NODE_PERFORMANCE_GC_MAJOR:NODE_PERFORMANCE_GC_MAJOR,NODE_PERFORMANCE_GC_MINOR:NODE_PERFORMANCE_GC_MINOR}}=require("perf_hooks"),{Connection:Connection}=require("tedious");function Benchmark(e,t,n){this.name=require.main.filename.slice(__dirname.length+1);const o=this._parseArgs(process.argv.slice(2),t);if(this.options=o.cli,this.extra_options=o.extra,this.queue=this._queue(this.options),this.config=this.queue[0],this.flags=[],n&&n.flags&&(this.flags=this.flags.concat(n.flags)),process.env.NODE_BENCHMARK_FLAGS){const e=process.env.NODE_BENCHMARK_FLAGS.split(/\s+/);this.flags=this.flags.concat(e)}this._time=[0,0],this._started=!1,this._gcStats={[NODE_PERFORMANCE_GC_INCREMENTAL]:{count:0,totalDuration:0},[NODE_PERFORMANCE_GC_MINOR]:{count:0,totalDuration:0},[NODE_PERFORMANCE_GC_MAJOR]:{count:0,totalDuration:0}},this._observer=new PerformanceObserver((e=>{const t=e.getEntries(),n=t.length;for(let e=0;e<n;e++){const n=t[e],o=this._gcStats[n.detail.kind];o&&(o.count+=1,o.totalDuration+=n.duration)}})),process.env.hasOwnProperty("NODE_RUN_BENCHMARK_FN")?process.nextTick((()=>e(this.config))):process.nextTick((()=>this._run()))}function formatResult(e){let t="";for(const n of Object.keys(e.conf))t+=` ${n}=${JSON.stringify(e.conf[n])}`;var n,o=e.rate.toString().split(".");return o[0]=o[0].replace(/(\d)(?=(?:\d\d\d)+(?!\d))/g,"$1,"),o=o[1]?o.join("."):o[0],n=`(minor: ${e.gcStats[NODE_PERFORMANCE_GC_MINOR].count} - ${e.gcStats[NODE_PERFORMANCE_GC_MINOR].totalDuration}ms,`,n+=` major: ${e.gcStats[NODE_PERFORMANCE_GC_MAJOR].count} - ${e.gcStats[NODE_PERFORMANCE_GC_MAJOR].totalDuration}ms,`,n+=` incremental: ${e.gcStats[NODE_PERFORMANCE_GC_INCREMENTAL].count} - ${e.gcStats[NODE_PERFORMANCE_GC_INCREMENTAL].totalDuration}ms)`,`${e.name}${t}: ${o} ${n}`}function sendResult(e){process.send?process.send(e):console.log(formatResult(e))}function createBenchmark(e,t,n){return new Benchmark(e,t,n)}function createConnection(e){var t=JSON.parse(fs.readFileSync(require("os").homedir()+"/.tedious/test-connection.json","utf8")).config,n=new Connection(t);n.connect((function(){e(n)}))}Benchmark.prototype._parseArgs=function(e,t){const n={},o={},s=/^(.+?)=([\s\S]*)$/;for(const r of e){const e=r.match(s);e||(console.error(`bad argument: ${r}`),process.exit(1));const c=e[1];if(t[c]){const o="number"==typeof t[c][0]?+e[2]:e[2];n[c]||(n[c]=[]),n[c].push(o)}else o[c]=e[2]}return{cli:Object.assign({},t,n),extra:o}},Benchmark.prototype._queue=function(e){const t=[],n=Object.keys(e);return n.length>0?function o(s,r){const c=n[s],i=e[c],a=typeof i[0];for(const e of i){if("number"!=typeof e&&"string"!=typeof e)throw new TypeError(`configuration "${c}" had type ${typeof e}`);if(typeof e!==a)throw new TypeError(`configuration "${c}" has mixed types`);const i=Object.assign({[c]:e},r);s+1<n.length?o(s+1,i):t.push(i)}}(0,{}):t.push({}),t},Benchmark.prototype._run=function(){const e=this;process.send&&process.send({type:"config",name:this.name,queueLength:this.queue.length}),function t(n){const o=e.queue[n],s=Object.assign({},process.env);s.NODE_RUN_BENCHMARK_FN="";const r=[];for(const e of Object.keys(o))r.push(`${e}=${o[e]}`);for(const t of Object.keys(e.extra_options))r.push(`${t}=${e.extra_options[t]}`);const c=child_process.fork(require.main.filename,r,{env:s,execArgv:e.flags.concat(process.execArgv)});c.on("message",sendResult),c.on("close",(o=>{o&&process.exit(o),n+1<e.queue.length&&t(n+1)}))}(0)},Benchmark.prototype.start=function(){if(this._started)throw new Error("Called start more than once in a single benchmark");this._started=!0,this._observer.observe({entryTypes:["gc"],buffered:!1}),this._time=process.hrtime()},Benchmark.prototype.end=function(e){const t=process.hrtime(this._time);if(!this._started)throw new Error("called end without start");if("number"!=typeof e)throw new Error("called end() without specifying operation count");if(!process.env.NODEJS_BENCHMARK_ZERO_ALLOWED&&e<=0)throw new Error("called end() with operation count <= 0");if(0===t[0]&&0===t[1]){if(!process.env.NODEJS_BENCHMARK_ZERO_ALLOWED)throw new Error("insufficient clock precision for short benchmark");t[1]=1}this._observer.disconnect();const n=e/(t[0]+t[1]/1e9);this.report(n,t)},Benchmark.prototype.report=function(e,t){sendResult({name:this.name,conf:this.config,rate:e,time:t[0]+t[1]/1e9,type:"report",gcStats:this._gcStats})},module.exports.createBenchmark=createBenchmark,module.exports.createConnection=createConnection;