"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ColumnEncryptionAzureKeyVaultProvider=void 0;var _identity=require("@azure/identity"),_keyvaultKeys=require("@azure/keyvault-keys"),_crypto=require("crypto"),_url=require("url");class ColumnEncryptionAzureKeyVaultProvider{constructor(e,t,r){this.name="AZURE_KEY_VAULT",this.azureKeyVaultDomainName="vault.azure.net",this.rsaEncryptionAlgorithmWithOAEPForAKV="RSA-OAEP",this.firstVersion=Buffer.from([1]),this.credentials=new _identity.ClientSecretCredential(r,e,t)}async decryptColumnEncryptionKey(e,t,r){if(!r)throw new Error("Internal error. Encrypted column encryption key cannot be null.");if(0===r.length)throw new Error("Internal error. Empty encrypted column encryption key specified.");t=this.validateEncryptionAlgorithm(t);const n=await this.getMasterKey(e),o=this.getAKVKeySize(n),i=this.createCryptoClient(n);if(r[0]!==this.firstVersion[0])throw new Error(`Specified encrypted column encryption key contains an invalid encryption algorithm version ${Buffer.from([r[0]]).toString("hex")}. Expected version is ${Buffer.from([this.firstVersion[0]]).toString("hex")}.`);let l=this.firstVersion.length;const a=r.readInt16LE(l);l+=2;const h=r.readInt16LE(l);if(l+=2,l+=a,h!==o)throw new Error(`The specified encrypted column encryption key's ciphertext length: ${h} does not match the ciphertext length: ${o} when using column master key (Azure Key Vault key) in ${e}. The encrypted column encryption key may be corrupt, or the specified Azure Key Vault key path may be incorrect.`);const y=r.length-l-h;if(y!==o)throw new Error(`The specified encrypted column encryption key's signature length: ${y} does not match the signature length: ${o} when using column master key (Azure Key Vault key) in ${e}. The encrypted column encryption key may be corrupt, or the specified Azure Key Vault key path may be incorrect.`);const c=Buffer.alloc(h);r.copy(c,0,l,l+h),l+=h;const s=Buffer.alloc(y);r.copy(s,0,l,l+y);const u=Buffer.alloc(r.length-s.length);r.copy(u,0,0,r.length-s.length);const p=(0,_crypto.createHash)("sha256");p.update(u);const f=p.digest();if(!f)throw new Error("Hash should not be null while decrypting encrypted column encryption key.");if(!(await i.verify("RS256",f,s)).result)throw new Error(`The specified encrypted column encryption key signature does not match the signature computed with the column master key (Asymmetric key in Azure Key Vault) in ${e}. The encrypted column encryption key may be corrupt, or the specified path may be incorrect.`);return await this.azureKeyVaultUnWrap(i,t,c)}async encryptColumnEncryptionKey(e,t,r){if(!r)throw new Error("Column encryption key cannot be null.");if(0===r.length)throw new Error("Empty column encryption key specified.");t=this.validateEncryptionAlgorithm(t);const n=await this.getMasterKey(e),o=this.getAKVKeySize(n),i=this.createCryptoClient(n),l=Buffer.from([this.firstVersion[0]]),a=Buffer.from(e.toLowerCase(),"utf8"),h=Buffer.alloc(2);h[0]=255&a.length,h[1]=a.length>>8&255;const y=await this.azureKeyVaultWrap(i,t,r),c=Buffer.alloc(2);if(c[0]=255&y.length,c[1]=y.length>>8&255,y.length!==o)throw new Error("CipherText length does not match the RSA key size.");const s=Buffer.alloc(l.length+h.length+c.length+a.length+y.length);let u=l.length;l.copy(s,0,0,l.length),h.copy(s,u,0,h.length),u+=h.length,c.copy(s,u,0,c.length),u+=c.length,a.copy(s,u,0,a.length),u+=a.length,y.copy(s,u,0,y.length);const p=(0,_crypto.createHash)("sha256");p.update(s);const f=p.digest(),d=await this.azureKeyVaultSignedHashedData(i,f);if(d.length!==o)throw new Error("Signed hash length does not match the RSA key size.");if(!(await i.verify("RS256",f,d)).result)throw new Error("Invalid signature of the encrypted column encryption key computed.");const g=l.length+c.length+h.length+y.length+a.length+d.length,w=Buffer.alloc(g);let m=0;return l.copy(w,m,0,l.length),m+=l.length,h.copy(w,m,0,h.length),m+=h.length,c.copy(w,m,0,c.length),m+=c.length,a.copy(w,m,0,a.length),m+=a.length,y.copy(w,m,0,y.length),m+=y.length,d.copy(w,m,0,d.length),w}async getMasterKey(e){if(!e)throw new Error("Master key path cannot be null or undefined");const t=this.parsePath(e);return this.createKeyClient(t.vaultUrl),await this.keyClient.getKey(t.name,t.version?{version:t.version}:{})}createKeyClient(e){if(!e)throw new Error("Cannot create key client with null or undefined keyVaultUrl");this.keyClient||(this.url=e,this.keyClient=new _keyvaultKeys.KeyClient(e,this.credentials))}createCryptoClient(e){if(!e)throw new Error("Cannot create CryptographyClient with null or undefined masterKey");return new _keyvaultKeys.CryptographyClient(e,this.credentials)}parsePath(e){if(!e||""===e.trim())throw new Error("Azure Key Vault key path cannot be null.");let t;try{t=(0,_url.parse)(e,!0,!0)}catch{throw new Error(`Invalid keys identifier: ${e}. Not a valid URI`)}if(!t.hostname||!t.hostname.toLowerCase().endsWith(this.azureKeyVaultDomainName))throw new Error(`Invalid Azure Key Vault key path specified: ${e}.`);const r=(t.pathname||"").split("/");if(3!==r.length&&4!==r.length)throw new Error(`Invalid keys identifier: ${e}. Bad number of segments: ${r.length}`);if("keys"!==r[1])throw new Error(`Invalid keys identifier: ${e}. segment [1] should be "keys", found "${r[1]}"`);return{vaultUrl:`${t.protocol}//${t.host}`,name:r[2],version:4===r.length?r[3]:void 0}}async azureKeyVaultSignedHashedData(e,t){if(!e)throw new Error("Azure KVS Crypto Client is not defined.");const r=await e.sign("RS256",t);return Buffer.from(r.result)}async azureKeyVaultWrap(e,t,r){if(!e)throw new Error("Azure KVS Crypto Client is not defined.");if(!r)throw new Error("Column encryption key cannot be null.");const n=await e.wrapKey(t,r);return Buffer.from(n.result)}async azureKeyVaultUnWrap(e,t,r){if(!e)throw new Error("Azure KVS Crypto Client is not defined.");if(!t)throw new Error("Encryption Algorithm cannot be null or undefined");if(!r)throw new Error("Encrypted column encryption key cannot be null.");if(0===r.length)throw new Error("Encrypted Column Encryption Key length should not be zero.");const n=await e.unwrapKey(t,r);return Buffer.from(n.result)}getAKVKeySize(e){if(!e)throw new Error("Retrieved key cannot be null or undefined");const t=e.key;if(!t)throw new Error(`Key does not exist ${e.name}`);const r=t&&t.kty&&t.kty.toString().toUpperCase();if(!r||0!=="RSA".localeCompare(r,"en"))throw new Error(`Cannot use a non-RSA key: ${r}.`);return t&&t.n&&t.n.length||0}validateEncryptionAlgorithm(e){if(!e)throw new Error("Key encryption algorithm cannot be null.");if(0==="RSA_OAEP".localeCompare(e.toUpperCase(),"en")&&(e="RSA-OAEP"),0!==this.rsaEncryptionAlgorithmWithOAEPForAKV.localeCompare(e.trim().toUpperCase(),"en"))throw new Error(`Invalid key encryption algorithm specified: ${e}. Expected value: ${this.rsaEncryptionAlgorithmWithOAEPForAKV}.`);return e}}exports.ColumnEncryptionAzureKeyVaultProvider=ColumnEncryptionAzureKeyVaultProvider;