"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _events=require("events"),_writableTrackingBuffer=_interopRequireDefault(require("./tracking-buffer/writable-tracking-buffer")),_stream=require("stream"),_token=require("./token/token");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const FLAGS={nullable:1,caseSen:2,updateableReadWrite:4,updateableUnknown:8,identity:16,computed:32,fixedLenCLRType:256,sparseColumnSet:1024,hidden:8192,key:16384,nullableUnknown:32768},DONE_STATUS={FINAL:0,MORE:1,ERROR:2,INXACT:4,COUNT:16,ATTN:32,SRVERROR:256},rowTokenBuffer=Buffer.from([_token.TYPE.ROW]),textPointerAndTimestampBuffer=Buffer.from([16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]),textPointerNullBuffer=Buffer.from([0]);class RowTransform extends _stream.Transform{constructor(e){super({writableObjectMode:!0}),this.bulkLoad=e,this.mainOptions=e.options,this.columns=e.columns,this.columnMetadataWritten=!1}_transform(e,t,o){this.columnMetadataWritten||(this.push(this.bulkLoad.getColMetaData()),this.columnMetadataWritten=!0),this.push(rowTokenBuffer);for(let t=0;t<this.columns.length;t++){const n=this.columns[t];let r=Array.isArray(e)?e[t]:e[n.objName];if(!this.bulkLoad.firstRowWritten)try{r=n.type.validate(r,n.collation)}catch(e){return o(e)}const s={length:n.length,scale:n.scale,precision:n.precision,value:r};if("Text"===n.type.name||"Image"===n.type.name||"NText"===n.type.name){if(null==r){this.push(textPointerNullBuffer);continue}this.push(textPointerAndTimestampBuffer)}try{this.push(n.type.generateParameterLength(s,this.mainOptions));for(const e of n.type.generateParameterData(s,this.mainOptions))this.push(e)}catch(e){return o(e)}}process.nextTick(o)}_flush(e){this.push(this.bulkLoad.createDoneToken()),process.nextTick(e)}}class BulkLoad extends _events.EventEmitter{constructor(e,t,o,{checkConstraints:n=!1,fireTriggers:r=!1,keepNulls:s=!1,lockTable:i=!1,order:l={}},a){if("boolean"!=typeof n)throw new TypeError('The "options.checkConstraints" property must be of type boolean.');if("boolean"!=typeof r)throw new TypeError('The "options.fireTriggers" property must be of type boolean.');if("boolean"!=typeof s)throw new TypeError('The "options.keepNulls" property must be of type boolean.');if("boolean"!=typeof i)throw new TypeError('The "options.lockTable" property must be of type boolean.');if("object"!=typeof l||null===l)throw new TypeError('The "options.order" property must be of type object.');for(const[e,t]of Object.entries(l))if("ASC"!==t&&"DESC"!==t)throw new TypeError('The value of the "'+e+'" key in the "options.order" object must be either "ASC" or "DESC".');super(),this.error=void 0,this.canceled=!1,this.executionStarted=!1,this.collation=t,this.table=e,this.options=o,this.callback=a,this.columns=[],this.columnsByName={},this.firstRowWritten=!1,this.streamingMode=!1,this.rowToPacketTransform=new RowTransform(this),this.bulkOptions={checkConstraints:n,fireTriggers:r,keepNulls:s,lockTable:i,order:l}}addColumn(e,t,{output:o=!1,length:n,precision:r,scale:s,objName:i=e,nullable:l=!0}){if(this.firstRowWritten)throw new Error("Columns cannot be added to bulk insert after the first row has been written.");if(this.executionStarted)throw new Error("Columns cannot be added to bulk insert after execution has started.");const a={type:t,name:e,value:null,output:o,length:n,precision:r,scale:s,objName:i,nullable:l,collation:this.collation};32==(48&t.id)&&null==a.length&&t.resolveLength&&(a.length=t.resolveLength(a)),t.resolvePrecision&&null==a.precision&&(a.precision=t.resolvePrecision(a)),t.resolveScale&&null==a.scale&&(a.scale=t.resolveScale(a)),this.columns.push(a),this.columnsByName[e]=a}getOptionsSql(){const e=[];if(this.bulkOptions.checkConstraints&&e.push("CHECK_CONSTRAINTS"),this.bulkOptions.fireTriggers&&e.push("FIRE_TRIGGERS"),this.bulkOptions.keepNulls&&e.push("KEEP_NULLS"),this.bulkOptions.lockTable&&e.push("TABLOCK"),this.bulkOptions.order){const t=[];for(const[e,o]of Object.entries(this.bulkOptions.order))t.push(`${e} ${o}`);t.length&&e.push(`ORDER (${t.join(", ")})`)}return e.length>0?` WITH (${e.join(",")})`:""}getBulkInsertSql(){let e="insert bulk "+this.table+"(";for(let t=0,o=this.columns.length;t<o;t++){const o=this.columns[t];0!==t&&(e+=", "),e+="["+o.name+"] "+o.type.declaration(o)}return e+=")",e+=this.getOptionsSql(),e}getTableCreationSql(){let e="CREATE TABLE "+this.table+"(\n";for(let t=0,o=this.columns.length;t<o;t++){const o=this.columns[t];0!==t&&(e+=",\n"),e+="["+o.name+"] "+o.type.declaration(o),void 0!==o.nullable&&(e+=" "+(o.nullable?"NULL":"NOT NULL"))}return e+="\n)",e}getColMetaData(){const e=new _writableTrackingBuffer.default(100,null,!0);e.writeUInt8(_token.TYPE.COLMETADATA),e.writeUInt16LE(this.columns.length);for(let t=0,o=this.columns.length;t<o;t++){const o=this.columns[t];this.options.tdsVersion<"7_2"?e.writeUInt16LE(0):e.writeUInt32LE(0);let n=FLAGS.updateableReadWrite;o.nullable?n|=FLAGS.nullable:void 0===o.nullable&&this.options.tdsVersion>="7_2"&&(n|=FLAGS.nullableUnknown),e.writeUInt16LE(n),e.writeBuffer(o.type.generateTypeInfo(o,this.options)),o.type.hasTableName&&e.writeUsVarchar(this.table,"ucs2"),e.writeBVarchar(o.name,"ucs2")}return e.data}setTimeout(e){this.timeout=e}createDoneToken(){const e=new _writableTrackingBuffer.default(this.options.tdsVersion<"7_2"?9:13);e.writeUInt8(_token.TYPE.DONE);const t=DONE_STATUS.FINAL;return e.writeUInt16LE(t),e.writeUInt16LE(0),e.writeUInt32LE(0),this.options.tdsVersion>="7_2"&&e.writeUInt32LE(0),e.data}cancel(){this.canceled||(this.canceled=!0,this.emit("cancel"))}}var _default=exports.default=BulkLoad;module.exports=BulkLoad;