"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _crypto=_interopRequireDefault(require("crypto")),_os=_interopRequireDefault(require("os")),tls=_interopRequireWildcard(require("tls")),net=_interopRequireWildcard(require("net")),_dns=_interopRequireDefault(require("dns")),_constants=_interopRequireDefault(require("constants")),_stream=require("stream"),_identity=require("@azure/identity"),_coreAuth=require("@azure/core-auth"),_bulkLoad=_interopRequireDefault(require("./bulk-load")),_debug=_interopRequireDefault(require("./debug")),_events=require("events"),_instanceLookup=require("./instance-lookup"),_transientErrorLookup=require("./transient-error-lookup"),_packet=require("./packet"),_preloginPayload=_interopRequireDefault(require("./prelogin-payload")),_login7Payload=_interopRequireDefault(require("./login7-payload")),_ntlmPayload=_interopRequireDefault(require("./ntlm-payload")),_request=_interopRequireDefault(require("./request")),_rpcrequestPayload=_interopRequireDefault(require("./rpcrequest-payload")),_sqlbatchPayload=_interopRequireDefault(require("./sqlbatch-payload")),_messageIo=_interopRequireDefault(require("./message-io")),_tokenStreamParser=require("./token/token-stream-parser"),_transaction=require("./transaction"),_errors=require("./errors"),_connector=require("./connector"),_library=require("./library"),_tdsVersions=require("./tds-versions"),_message=_interopRequireDefault(require("./message")),_ntlm=require("./ntlm"),_dataType=require("./data-type"),_bulkLoadPayload=require("./bulk-load-payload"),_specialStoredProcedure=_interopRequireDefault(require("./special-stored-procedure")),_package=require("../package.json"),_url=require("url"),_handler=require("./token/handler");function _getRequireWildcardCache(e){if("function"!=typeof WeakMap)return null;var t=new WeakMap,o=new WeakMap;return(_getRequireWildcardCache=function(e){return e?o:t})(e)}function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var o=_getRequireWildcardCache(t);if(o&&o.has(e))return o.get(e);var i={__proto__:null},n=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var r in e)if("default"!==r&&Object.prototype.hasOwnProperty.call(e,r)){var s=n?Object.getOwnPropertyDescriptor(e,r):null;s&&(s.get||s.set)?Object.defineProperty(i,r,s):i[r]=e[r]}return i.default=e,o&&o.set(e,i),i}function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const KEEP_ALIVE_INITIAL_DELAY=3e4,DEFAULT_CONNECT_TIMEOUT=15e3,DEFAULT_CLIENT_REQUEST_TIMEOUT=15e3,DEFAULT_CANCEL_TIMEOUT=5e3,DEFAULT_CONNECT_RETRY_INTERVAL=500,DEFAULT_PACKET_SIZE=4096,DEFAULT_TEXTSIZE=2147483647,DEFAULT_DATEFIRST=7,DEFAULT_PORT=1433,DEFAULT_TDS_VERSION="7_4",DEFAULT_LANGUAGE="us_english",DEFAULT_DATEFORMAT="mdy",CLEANUP_TYPE={NORMAL:0,REDIRECT:1,RETRY:2};class Connection extends _events.EventEmitter{_cancelAfterRequestSent;constructor(e){if(super(),"object"!=typeof e||null===e)throw new TypeError('The "config" argument is required and must be of type Object.');if("string"!=typeof e.server)throw new TypeError('The "config.server" property is required and must be of type string.');let t;if(this.fedAuthRequired=!1,void 0!==e.authentication){if("object"!=typeof e.authentication||null===e.authentication)throw new TypeError('The "config.authentication" property must be of type Object.');const o=e.authentication.type,i=void 0===e.authentication.options?{}:e.authentication.options;if("string"!=typeof o)throw new TypeError('The "config.authentication.type" property must be of type string.');if("default"!==o&&"ntlm"!==o&&"token-credential"!==o&&"azure-active-directory-password"!==o&&"azure-active-directory-access-token"!==o&&"azure-active-directory-msi-vm"!==o&&"azure-active-directory-msi-app-service"!==o&&"azure-active-directory-service-principal-secret"!==o&&"azure-active-directory-default"!==o)throw new TypeError('The "type" property must one of "default", "ntlm", "token-credential", "azure-active-directory-password", "azure-active-directory-access-token", "azure-active-directory-default", "azure-active-directory-msi-vm" or "azure-active-directory-msi-app-service" or "azure-active-directory-service-principal-secret".');if("object"!=typeof i||null===i)throw new TypeError('The "config.authentication.options" property must be of type object.');if("ntlm"===o){if("string"!=typeof i.domain)throw new TypeError('The "config.authentication.options.domain" property must be of type string.');if(void 0!==i.userName&&"string"!=typeof i.userName)throw new TypeError('The "config.authentication.options.userName" property must be of type string.');if(void 0!==i.password&&"string"!=typeof i.password)throw new TypeError('The "config.authentication.options.password" property must be of type string.');t={type:"ntlm",options:{userName:i.userName,password:i.password,domain:i.domain&&i.domain.toUpperCase()}}}else if("token-credential"===o){if(!(0,_coreAuth.isTokenCredential)(i.credential))throw new TypeError('The "config.authentication.options.credential" property must be an instance of the token credential class.');t={type:"token-credential",options:{credential:i.credential}}}else if("azure-active-directory-password"===o){if("string"!=typeof i.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');if(void 0!==i.userName&&"string"!=typeof i.userName)throw new TypeError('The "config.authentication.options.userName" property must be of type string.');if(void 0!==i.password&&"string"!=typeof i.password)throw new TypeError('The "config.authentication.options.password" property must be of type string.');if(void 0!==i.tenantId&&"string"!=typeof i.tenantId)throw new TypeError('The "config.authentication.options.tenantId" property must be of type string.');t={type:"azure-active-directory-password",options:{userName:i.userName,password:i.password,tenantId:i.tenantId,clientId:i.clientId}}}else if("azure-active-directory-access-token"===o){if("string"!=typeof i.token)throw new TypeError('The "config.authentication.options.token" property must be of type string.');t={type:"azure-active-directory-access-token",options:{token:i.token}}}else if("azure-active-directory-msi-vm"===o){if(void 0!==i.clientId&&"string"!=typeof i.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');t={type:"azure-active-directory-msi-vm",options:{clientId:i.clientId}}}else if("azure-active-directory-default"===o){if(void 0!==i.clientId&&"string"!=typeof i.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');t={type:"azure-active-directory-default",options:{clientId:i.clientId}}}else if("azure-active-directory-msi-app-service"===o){if(void 0!==i.clientId&&"string"!=typeof i.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');t={type:"azure-active-directory-msi-app-service",options:{clientId:i.clientId}}}else if("azure-active-directory-service-principal-secret"===o){if("string"!=typeof i.clientId)throw new TypeError('The "config.authentication.options.clientId" property must be of type string.');if("string"!=typeof i.clientSecret)throw new TypeError('The "config.authentication.options.clientSecret" property must be of type string.');if("string"!=typeof i.tenantId)throw new TypeError('The "config.authentication.options.tenantId" property must be of type string.');t={type:"azure-active-directory-service-principal-secret",options:{clientId:i.clientId,clientSecret:i.clientSecret,tenantId:i.tenantId}}}else{if(void 0!==i.userName&&"string"!=typeof i.userName)throw new TypeError('The "config.authentication.options.userName" property must be of type string.');if(void 0!==i.password&&"string"!=typeof i.password)throw new TypeError('The "config.authentication.options.password" property must be of type string.');t={type:"default",options:{userName:i.userName,password:i.password}}}}else t={type:"default",options:{userName:void 0,password:void 0}};if(this.config={server:e.server,authentication:t,options:{abortTransactionOnError:!1,appName:void 0,camelCaseColumns:!1,cancelTimeout:5e3,columnEncryptionKeyCacheTTL:72e5,columnEncryptionSetting:!1,columnNameReplacer:void 0,connectionRetryInterval:500,connectTimeout:15e3,connector:void 0,connectionIsolationLevel:_transaction.ISOLATION_LEVEL.READ_COMMITTED,cryptoCredentialsDetails:{},database:void 0,datefirst:7,dateFormat:"mdy",debug:{data:!1,packet:!1,payload:!1,token:!1},enableAnsiNull:!0,enableAnsiNullDefault:!0,enableAnsiPadding:!0,enableAnsiWarnings:!0,enableArithAbort:!0,enableConcatNullYieldsNull:!0,enableCursorCloseOnCommit:null,enableImplicitTransactions:!1,enableNumericRoundabort:!1,enableQuotedIdentifier:!0,encrypt:!0,fallbackToDefaultDb:!1,encryptionKeyStoreProviders:void 0,instanceName:void 0,isolationLevel:_transaction.ISOLATION_LEVEL.READ_COMMITTED,language:"us_english",localAddress:void 0,maxRetriesOnTransientErrors:3,multiSubnetFailover:!1,packetSize:4096,port:1433,readOnlyIntent:!1,requestTimeout:15e3,rowCollectionOnDone:!1,rowCollectionOnRequestCompletion:!1,serverName:void 0,serverSupportsColumnEncryption:!1,tdsVersion:"7_4",textsize:2147483647,trustedServerNameAE:void 0,trustServerCertificate:!1,useColumnNames:!1,useUTC:!0,workstationId:void 0,lowerCaseGuids:!1}},e.options){if(e.options.port&&e.options.instanceName)throw new Error("Port and instanceName are mutually exclusive, but "+e.options.port+" and "+e.options.instanceName+" provided");if(void 0!==e.options.abortTransactionOnError){if("boolean"!=typeof e.options.abortTransactionOnError&&null!==e.options.abortTransactionOnError)throw new TypeError('The "config.options.abortTransactionOnError" property must be of type string or null.');this.config.options.abortTransactionOnError=e.options.abortTransactionOnError}if(void 0!==e.options.appName){if("string"!=typeof e.options.appName)throw new TypeError('The "config.options.appName" property must be of type string.');this.config.options.appName=e.options.appName}if(void 0!==e.options.camelCaseColumns){if("boolean"!=typeof e.options.camelCaseColumns)throw new TypeError('The "config.options.camelCaseColumns" property must be of type boolean.');this.config.options.camelCaseColumns=e.options.camelCaseColumns}if(void 0!==e.options.cancelTimeout){if("number"!=typeof e.options.cancelTimeout)throw new TypeError('The "config.options.cancelTimeout" property must be of type number.');this.config.options.cancelTimeout=e.options.cancelTimeout}if(e.options.columnNameReplacer){if("function"!=typeof e.options.columnNameReplacer)throw new TypeError('The "config.options.cancelTimeout" property must be of type function.');this.config.options.columnNameReplacer=e.options.columnNameReplacer}if(void 0!==e.options.connectionIsolationLevel&&((0,_transaction.assertValidIsolationLevel)(e.options.connectionIsolationLevel,"config.options.connectionIsolationLevel"),this.config.options.connectionIsolationLevel=e.options.connectionIsolationLevel),void 0!==e.options.connectTimeout){if("number"!=typeof e.options.connectTimeout)throw new TypeError('The "config.options.connectTimeout" property must be of type number.');this.config.options.connectTimeout=e.options.connectTimeout}if(void 0!==e.options.connector){if("function"!=typeof e.options.connector)throw new TypeError('The "config.options.connector" property must be a function.');this.config.options.connector=e.options.connector}if(void 0!==e.options.cryptoCredentialsDetails){if("object"!=typeof e.options.cryptoCredentialsDetails||null===e.options.cryptoCredentialsDetails)throw new TypeError('The "config.options.cryptoCredentialsDetails" property must be of type Object.');this.config.options.cryptoCredentialsDetails=e.options.cryptoCredentialsDetails}if(void 0!==e.options.database){if("string"!=typeof e.options.database)throw new TypeError('The "config.options.database" property must be of type string.');this.config.options.database=e.options.database}if(void 0!==e.options.datefirst){if("number"!=typeof e.options.datefirst&&null!==e.options.datefirst)throw new TypeError('The "config.options.datefirst" property must be of type number.');if(null!==e.options.datefirst&&(e.options.datefirst<1||e.options.datefirst>7))throw new RangeError('The "config.options.datefirst" property must be >= 1 and <= 7');this.config.options.datefirst=e.options.datefirst}if(void 0!==e.options.dateFormat){if("string"!=typeof e.options.dateFormat&&null!==e.options.dateFormat)throw new TypeError('The "config.options.dateFormat" property must be of type string or null.');this.config.options.dateFormat=e.options.dateFormat}if(e.options.debug){if(void 0!==e.options.debug.data){if("boolean"!=typeof e.options.debug.data)throw new TypeError('The "config.options.debug.data" property must be of type boolean.');this.config.options.debug.data=e.options.debug.data}if(void 0!==e.options.debug.packet){if("boolean"!=typeof e.options.debug.packet)throw new TypeError('The "config.options.debug.packet" property must be of type boolean.');this.config.options.debug.packet=e.options.debug.packet}if(void 0!==e.options.debug.payload){if("boolean"!=typeof e.options.debug.payload)throw new TypeError('The "config.options.debug.payload" property must be of type boolean.');this.config.options.debug.payload=e.options.debug.payload}if(void 0!==e.options.debug.token){if("boolean"!=typeof e.options.debug.token)throw new TypeError('The "config.options.debug.token" property must be of type boolean.');this.config.options.debug.token=e.options.debug.token}}if(void 0!==e.options.enableAnsiNull){if("boolean"!=typeof e.options.enableAnsiNull&&null!==e.options.enableAnsiNull)throw new TypeError('The "config.options.enableAnsiNull" property must be of type boolean or null.');this.config.options.enableAnsiNull=e.options.enableAnsiNull}if(void 0!==e.options.enableAnsiNullDefault){if("boolean"!=typeof e.options.enableAnsiNullDefault&&null!==e.options.enableAnsiNullDefault)throw new TypeError('The "config.options.enableAnsiNullDefault" property must be of type boolean or null.');this.config.options.enableAnsiNullDefault=e.options.enableAnsiNullDefault}if(void 0!==e.options.enableAnsiPadding){if("boolean"!=typeof e.options.enableAnsiPadding&&null!==e.options.enableAnsiPadding)throw new TypeError('The "config.options.enableAnsiPadding" property must be of type boolean or null.');this.config.options.enableAnsiPadding=e.options.enableAnsiPadding}if(void 0!==e.options.enableAnsiWarnings){if("boolean"!=typeof e.options.enableAnsiWarnings&&null!==e.options.enableAnsiWarnings)throw new TypeError('The "config.options.enableAnsiWarnings" property must be of type boolean or null.');this.config.options.enableAnsiWarnings=e.options.enableAnsiWarnings}if(void 0!==e.options.enableArithAbort){if("boolean"!=typeof e.options.enableArithAbort&&null!==e.options.enableArithAbort)throw new TypeError('The "config.options.enableArithAbort" property must be of type boolean or null.');this.config.options.enableArithAbort=e.options.enableArithAbort}if(void 0!==e.options.enableConcatNullYieldsNull){if("boolean"!=typeof e.options.enableConcatNullYieldsNull&&null!==e.options.enableConcatNullYieldsNull)throw new TypeError('The "config.options.enableConcatNullYieldsNull" property must be of type boolean or null.');this.config.options.enableConcatNullYieldsNull=e.options.enableConcatNullYieldsNull}if(void 0!==e.options.enableCursorCloseOnCommit){if("boolean"!=typeof e.options.enableCursorCloseOnCommit&&null!==e.options.enableCursorCloseOnCommit)throw new TypeError('The "config.options.enableCursorCloseOnCommit" property must be of type boolean or null.');this.config.options.enableCursorCloseOnCommit=e.options.enableCursorCloseOnCommit}if(void 0!==e.options.enableImplicitTransactions){if("boolean"!=typeof e.options.enableImplicitTransactions&&null!==e.options.enableImplicitTransactions)throw new TypeError('The "config.options.enableImplicitTransactions" property must be of type boolean or null.');this.config.options.enableImplicitTransactions=e.options.enableImplicitTransactions}if(void 0!==e.options.enableNumericRoundabort){if("boolean"!=typeof e.options.enableNumericRoundabort&&null!==e.options.enableNumericRoundabort)throw new TypeError('The "config.options.enableNumericRoundabort" property must be of type boolean or null.');this.config.options.enableNumericRoundabort=e.options.enableNumericRoundabort}if(void 0!==e.options.enableQuotedIdentifier){if("boolean"!=typeof e.options.enableQuotedIdentifier&&null!==e.options.enableQuotedIdentifier)throw new TypeError('The "config.options.enableQuotedIdentifier" property must be of type boolean or null.');this.config.options.enableQuotedIdentifier=e.options.enableQuotedIdentifier}if(void 0!==e.options.encrypt){if("boolean"!=typeof e.options.encrypt&&"strict"!==e.options.encrypt)throw new TypeError('The "encrypt" property must be set to "strict", or of type boolean.');this.config.options.encrypt=e.options.encrypt}if(void 0!==e.options.fallbackToDefaultDb){if("boolean"!=typeof e.options.fallbackToDefaultDb)throw new TypeError('The "config.options.fallbackToDefaultDb" property must be of type boolean.');this.config.options.fallbackToDefaultDb=e.options.fallbackToDefaultDb}if(void 0!==e.options.instanceName){if("string"!=typeof e.options.instanceName)throw new TypeError('The "config.options.instanceName" property must be of type string.');this.config.options.instanceName=e.options.instanceName,this.config.options.port=void 0}if(void 0!==e.options.isolationLevel&&((0,_transaction.assertValidIsolationLevel)(e.options.isolationLevel,"config.options.isolationLevel"),this.config.options.isolationLevel=e.options.isolationLevel),void 0!==e.options.language){if("string"!=typeof e.options.language&&null!==e.options.language)throw new TypeError('The "config.options.language" property must be of type string or null.');this.config.options.language=e.options.language}if(void 0!==e.options.localAddress){if("string"!=typeof e.options.localAddress)throw new TypeError('The "config.options.localAddress" property must be of type string.');this.config.options.localAddress=e.options.localAddress}if(void 0!==e.options.multiSubnetFailover){if("boolean"!=typeof e.options.multiSubnetFailover)throw new TypeError('The "config.options.multiSubnetFailover" property must be of type boolean.');this.config.options.multiSubnetFailover=e.options.multiSubnetFailover}if(void 0!==e.options.packetSize){if("number"!=typeof e.options.packetSize)throw new TypeError('The "config.options.packetSize" property must be of type number.');this.config.options.packetSize=e.options.packetSize}if(void 0!==e.options.port){if("number"!=typeof e.options.port)throw new TypeError('The "config.options.port" property must be of type number.');if(e.options.port<=0||e.options.port>=65536)throw new RangeError('The "config.options.port" property must be > 0 and < 65536');this.config.options.port=e.options.port,this.config.options.instanceName=void 0}if(void 0!==e.options.readOnlyIntent){if("boolean"!=typeof e.options.readOnlyIntent)throw new TypeError('The "config.options.readOnlyIntent" property must be of type boolean.');this.config.options.readOnlyIntent=e.options.readOnlyIntent}if(void 0!==e.options.requestTimeout){if("number"!=typeof e.options.requestTimeout)throw new TypeError('The "config.options.requestTimeout" property must be of type number.');this.config.options.requestTimeout=e.options.requestTimeout}if(void 0!==e.options.maxRetriesOnTransientErrors){if("number"!=typeof e.options.maxRetriesOnTransientErrors)throw new TypeError('The "config.options.maxRetriesOnTransientErrors" property must be of type number.');if(e.options.maxRetriesOnTransientErrors<0)throw new TypeError('The "config.options.maxRetriesOnTransientErrors" property must be equal or greater than 0.');this.config.options.maxRetriesOnTransientErrors=e.options.maxRetriesOnTransientErrors}if(void 0!==e.options.connectionRetryInterval){if("number"!=typeof e.options.connectionRetryInterval)throw new TypeError('The "config.options.connectionRetryInterval" property must be of type number.');if(e.options.connectionRetryInterval<=0)throw new TypeError('The "config.options.connectionRetryInterval" property must be greater than 0.');this.config.options.connectionRetryInterval=e.options.connectionRetryInterval}if(void 0!==e.options.rowCollectionOnDone){if("boolean"!=typeof e.options.rowCollectionOnDone)throw new TypeError('The "config.options.rowCollectionOnDone" property must be of type boolean.');this.config.options.rowCollectionOnDone=e.options.rowCollectionOnDone}if(void 0!==e.options.rowCollectionOnRequestCompletion){if("boolean"!=typeof e.options.rowCollectionOnRequestCompletion)throw new TypeError('The "config.options.rowCollectionOnRequestCompletion" property must be of type boolean.');this.config.options.rowCollectionOnRequestCompletion=e.options.rowCollectionOnRequestCompletion}if(void 0!==e.options.tdsVersion){if("string"!=typeof e.options.tdsVersion)throw new TypeError('The "config.options.tdsVersion" property must be of type string.');this.config.options.tdsVersion=e.options.tdsVersion}if(void 0!==e.options.textsize){if("number"!=typeof e.options.textsize&&null!==e.options.textsize)throw new TypeError('The "config.options.textsize" property must be of type number or null.');if(e.options.textsize>2147483647)throw new TypeError('The "config.options.textsize" can\'t be greater than 2147483647.');if(e.options.textsize<-1)throw new TypeError('The "config.options.textsize" can\'t be smaller than -1.');this.config.options.textsize=0|e.options.textsize}if(void 0!==e.options.trustServerCertificate){if("boolean"!=typeof e.options.trustServerCertificate)throw new TypeError('The "config.options.trustServerCertificate" property must be of type boolean.');this.config.options.trustServerCertificate=e.options.trustServerCertificate}if(void 0!==e.options.serverName){if("string"!=typeof e.options.serverName)throw new TypeError('The "config.options.serverName" property must be of type string.');this.config.options.serverName=e.options.serverName}if(void 0!==e.options.useColumnNames){if("boolean"!=typeof e.options.useColumnNames)throw new TypeError('The "config.options.useColumnNames" property must be of type boolean.');this.config.options.useColumnNames=e.options.useColumnNames}if(void 0!==e.options.useUTC){if("boolean"!=typeof e.options.useUTC)throw new TypeError('The "config.options.useUTC" property must be of type boolean.');this.config.options.useUTC=e.options.useUTC}if(void 0!==e.options.workstationId){if("string"!=typeof e.options.workstationId)throw new TypeError('The "config.options.workstationId" property must be of type string.');this.config.options.workstationId=e.options.workstationId}if(void 0!==e.options.lowerCaseGuids){if("boolean"!=typeof e.options.lowerCaseGuids)throw new TypeError('The "config.options.lowerCaseGuids" property must be of type boolean.');this.config.options.lowerCaseGuids=e.options.lowerCaseGuids}}this.secureContextOptions=this.config.options.cryptoCredentialsDetails,void 0===this.secureContextOptions.secureOptions&&(this.secureContextOptions=Object.create(this.secureContextOptions,{secureOptions:{value:_constants.default.SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS}})),this.debug=this.createDebug(),this.inTransaction=!1,this.transactionDescriptors=[Buffer.from([0,0,0,0,0,0,0,0])],this.transactionDepth=0,this.isSqlBatch=!1,this.closed=!1,this.messageBuffer=Buffer.alloc(0),this.curTransientRetryCount=0,this.transientErrorLookup=new _transientErrorLookup.TransientErrorLookup,this.state=this.STATE.INITIALIZED,this._cancelAfterRequestSent=()=>{this.messageIo.sendMessage(_packet.TYPE.ATTENTION),this.createCancelTimer()}}connect(e){if(this.state!==this.STATE.INITIALIZED)throw new _errors.ConnectionError("`.connect` can not be called on a Connection in `"+this.state.name+"` state.");if(e){const t=t=>{this.removeListener("error",o),e(t)},o=o=>{this.removeListener("connect",t),e(o)};this.once("connect",t),this.once("error",o)}this.transitionTo(this.STATE.CONNECTING)}on(e,t){return super.on(e,t)}emit(e,...t){return super.emit(e,...t)}close(){this.transitionTo(this.STATE.FINAL)}initialiseConnection(){const e=this.createConnectTimer();return this.config.options.port?this.connectOnPort(this.config.options.port,this.config.options.multiSubnetFailover,e,this.config.options.connector):(0,_instanceLookup.instanceLookup)({server:this.config.server,instanceName:this.config.options.instanceName,timeout:this.config.options.connectTimeout,signal:e}).then((t=>{process.nextTick((()=>{this.connectOnPort(t,this.config.options.multiSubnetFailover,e,this.config.options.connector)}))}),(t=>{this.clearConnectTimer(),e.aborted||process.nextTick((()=>{this.emit("connect",new _errors.ConnectionError(t.message,"EINSTLOOKUP",{cause:t}))}))}))}cleanupConnection(e){if(!this.closed){this.clearConnectTimer(),this.clearRequestTimer(),this.clearRetryTimer(),this.closeConnection(),e===CLEANUP_TYPE.REDIRECT?this.emit("rerouting"):e!==CLEANUP_TYPE.RETRY&&process.nextTick((()=>{this.emit("end")}));const t=this.request;if(t){const e=new _errors.RequestError("Connection closed before request completed.","ECLOSE");t.callback(e),this.request=void 0}this.closed=!0,this.loginError=void 0}}createDebug(){const e=new _debug.default(this.config.options.debug);return e.on("debug",(e=>{this.emit("debug",e)})),e}createTokenStreamParser(e,t){return new _tokenStreamParser.Parser(e,this.debug,t,this.config.options)}socketHandlingForSendPreLogin(e){e.on("error",(e=>{this.socketError(e)})),e.on("close",(()=>{this.socketClose()})),e.on("end",(()=>{this.socketEnd()})),e.setKeepAlive(!0,3e4),this.messageIo=new _messageIo.default(e,this.config.options.packetSize,this.debug),this.messageIo.on("secure",(e=>{this.emit("secure",e)})),this.socket=e,this.closed=!1,this.debug.log("connected to "+this.config.server+":"+this.config.options.port),this.sendPreLogin(),this.transitionTo(this.STATE.SENT_PRELOGIN)}wrapWithTls(e,t){return t.throwIfAborted(),new Promise(((o,i)=>{const n=tls.createSecureContext(this.secureContextOptions),r=net.isIP(this.config.server)?"":this.config.server,s={host:this.config.server,socket:e,ALPNProtocols:["tds/8.0"],secureContext:n,servername:this.config.options.serverName?this.config.options.serverName:r},a=tls.connect(s),c=()=>{a.removeListener("error",p),a.removeListener("connect",l),a.destroy(),i(t.reason)},p=e=>{t.removeEventListener("abort",c),a.removeListener("error",p),a.removeListener("connect",l),a.destroy(),i(e)},l=()=>{t.removeEventListener("abort",c),a.removeListener("error",p),a.removeListener("connect",l),o(a)};t.addEventListener("abort",c,{once:!0}),a.on("error",p),a.on("secureConnect",l)}))}connectOnPort(e,t,o,i){const n={host:this.routingData?this.routingData.server:this.config.server,port:this.routingData?this.routingData.port:e,localAddress:this.config.options.localAddress},r=i||(t?_connector.connectInParallel:_connector.connectInSequence);(async()=>{let e=await r(n,_dns.default.lookup,o);if("strict"===this.config.options.encrypt)try{e=await this.wrapWithTls(e,o)}catch(t){throw e.end(),t}this.socketHandlingForSendPreLogin(e)})().catch((e=>{this.clearConnectTimer(),o.aborted||process.nextTick((()=>{this.socketError(e)}))}))}closeConnection(){this.socket&&this.socket.destroy()}createConnectTimer(){const e=new AbortController;return this.connectTimer=setTimeout((()=>{e.abort(),this.connectTimeout()}),this.config.options.connectTimeout),e.signal}createCancelTimer(){this.clearCancelTimer();const e=this.config.options.cancelTimeout;e>0&&(this.cancelTimer=setTimeout((()=>{this.cancelTimeout()}),e))}createRequestTimer(){this.clearRequestTimer();const e=this.request,t=void 0!==e.timeout?e.timeout:this.config.options.requestTimeout;t&&(this.requestTimer=setTimeout((()=>{this.requestTimeout()}),t))}createRetryTimer(){this.clearRetryTimer(),this.retryTimer=setTimeout((()=>{this.retryTimeout()}),this.config.options.connectionRetryInterval)}connectTimeout(){const e=this.config.options.port?`:${this.config.options.port}`:`\\${this.config.options.instanceName}`,t=`Failed to connect to ${this.routingData?this.routingData.server:this.config.server}${this.routingData?`:${this.routingData.port}`:e}${this.routingData?` (redirected from ${this.config.server}${e})`:""} in ${this.config.options.connectTimeout}ms`;this.debug.log(t),this.emit("connect",new _errors.ConnectionError(t,"ETIMEOUT")),this.connectTimer=void 0,this.dispatchEvent("connectTimeout")}cancelTimeout(){const e=`Failed to cancel request in ${this.config.options.cancelTimeout}ms`;this.debug.log(e),this.dispatchEvent("socketError",new _errors.ConnectionError(e,"ETIMEOUT"))}requestTimeout(){this.requestTimer=void 0;const e=this.request;e.cancel();const t="Timeout: Request failed to complete in "+(void 0!==e.timeout?e.timeout:this.config.options.requestTimeout)+"ms";e.error=new _errors.RequestError(t,"ETIMEOUT")}retryTimeout(){this.retryTimer=void 0,this.emit("retry"),this.transitionTo(this.STATE.CONNECTING)}clearConnectTimer(){this.connectTimer&&(clearTimeout(this.connectTimer),this.connectTimer=void 0)}clearCancelTimer(){this.cancelTimer&&(clearTimeout(this.cancelTimer),this.cancelTimer=void 0)}clearRequestTimer(){this.requestTimer&&(clearTimeout(this.requestTimer),this.requestTimer=void 0)}clearRetryTimer(){this.retryTimer&&(clearTimeout(this.retryTimer),this.retryTimer=void 0)}transitionTo(e){this.state!==e?(this.state&&this.state.exit&&this.state.exit.call(this,e),this.debug.log("State change: "+(this.state?this.state.name:"undefined")+" -> "+e.name),this.state=e,this.state.enter&&this.state.enter.apply(this)):this.debug.log("State is already "+e.name)}getEventHandler(e){const t=this.state.events[e];if(!t)throw new Error(`No event '${e}' in state '${this.state.name}'`);return t}dispatchEvent(e,...t){const o=this.state.events[e];o?o.apply(this,t):(this.emit("error",new Error(`No event '${e}' in state '${this.state.name}'`)),this.close())}socketError(e){if(this.state===this.STATE.CONNECTING||this.state===this.STATE.SENT_TLSSSLNEGOTIATION){const t=this.config.options.port?`:${this.config.options.port}`:`\\${this.config.options.instanceName}`,o=`Failed to connect to ${this.routingData?this.routingData.server:this.config.server}${this.routingData?`:${this.routingData.port}`:t}${this.routingData?` (redirected from ${this.config.server}${t})`:""} - ${e.message}`;this.debug.log(o),this.emit("connect",new _errors.ConnectionError(o,"ESOCKET",{cause:e}))}else{const t=`Connection lost - ${e.message}`;this.debug.log(t),this.emit("error",new _errors.ConnectionError(t,"ESOCKET",{cause:e}))}this.dispatchEvent("socketError",e)}socketEnd(){if(this.debug.log("socket ended"),this.state!==this.STATE.FINAL){const e=new Error("socket hang up");e.code="ECONNRESET",this.socketError(e)}}socketClose(){if(this.debug.log("connection to "+this.config.server+":"+this.config.options.port+" closed"),this.state===this.STATE.REROUTING)this.debug.log("Rerouting to "+this.routingData.server+":"+this.routingData.port),this.dispatchEvent("reconnect");else if(this.state===this.STATE.TRANSIENT_FAILURE_RETRY){const e=this.routingData?this.routingData.server:this.config.server,t=this.routingData?this.routingData.port:this.config.options.port;this.debug.log("Retry after transient failure connecting to "+e+":"+t),this.dispatchEvent("retry")}else this.transitionTo(this.STATE.FINAL)}sendPreLogin(){const[,e,t,o]=/^(\d+)\.(\d+)\.(\d+)/.exec(_package.version)??["0.0.0","0","0","0"],i=new _preloginPayload.default({encrypt:"boolean"==typeof this.config.options.encrypt&&this.config.options.encrypt,version:{major:Number(e),minor:Number(t),build:Number(o),subbuild:0}});this.messageIo.sendMessage(_packet.TYPE.PRELOGIN,i.data),this.debug.payload((function(){return i.toString("  ")}))}sendLogin7Packet(){const e=new _login7Payload.default({tdsVersion:_tdsVersions.versions[this.config.options.tdsVersion],packetSize:this.config.options.packetSize,clientProgVer:0,clientPid:process.pid,connectionId:0,clientTimeZone:(new Date).getTimezoneOffset(),clientLcid:1033}),{authentication:t}=this.config;switch(t.type){case"azure-active-directory-password":e.fedAuth={type:"ADAL",echo:this.fedAuthRequired,workflow:"default"};break;case"azure-active-directory-access-token":e.fedAuth={type:"SECURITYTOKEN",echo:this.fedAuthRequired,fedAuthToken:t.options.token};break;case"token-credential":case"azure-active-directory-msi-vm":case"azure-active-directory-default":case"azure-active-directory-msi-app-service":case"azure-active-directory-service-principal-secret":e.fedAuth={type:"ADAL",echo:this.fedAuthRequired,workflow:"integrated"};break;case"ntlm":e.sspi=(0,_ntlm.createNTLMRequest)({domain:t.options.domain});break;default:e.userName=t.options.userName,e.password=t.options.password}e.hostname=this.config.options.workstationId||_os.default.hostname(),e.serverName=this.routingData?this.routingData.server:this.config.server,e.appName=this.config.options.appName||"Tedious",e.libraryName=_library.name,e.language=this.config.options.language,e.database=this.config.options.database,e.clientId=Buffer.from([1,2,3,4,5,6]),e.readOnlyIntent=this.config.options.readOnlyIntent,e.initDbFatal=!this.config.options.fallbackToDefaultDb,this.routingData=void 0,this.messageIo.sendMessage(_packet.TYPE.LOGIN7,e.toBuffer()),this.debug.payload((function(){return e.toString("  ")}))}sendFedAuthTokenMessage(e){const t=Buffer.byteLength(e,"ucs2"),o=Buffer.alloc(8+t);let i=0;i=o.writeUInt32LE(t+4,i),i=o.writeUInt32LE(t,i),o.write(e,i,"ucs2"),this.messageIo.sendMessage(_packet.TYPE.FEDAUTH_TOKEN,o),this.transitionTo(this.STATE.SENT_LOGIN7_WITH_STANDARD_LOGIN)}sendInitialSql(){const e=new _sqlbatchPayload.default(this.getInitialSql(),this.currentTransactionDescriptor(),this.config.options),t=new _message.default({type:_packet.TYPE.SQL_BATCH});this.messageIo.outgoingMessageStream.write(t),_stream.Readable.from(e).pipe(t)}getInitialSql(){const e=[];return!0===this.config.options.enableAnsiNull?e.push("set ansi_nulls on"):!1===this.config.options.enableAnsiNull&&e.push("set ansi_nulls off"),!0===this.config.options.enableAnsiNullDefault?e.push("set ansi_null_dflt_on on"):!1===this.config.options.enableAnsiNullDefault&&e.push("set ansi_null_dflt_on off"),!0===this.config.options.enableAnsiPadding?e.push("set ansi_padding on"):!1===this.config.options.enableAnsiPadding&&e.push("set ansi_padding off"),!0===this.config.options.enableAnsiWarnings?e.push("set ansi_warnings on"):!1===this.config.options.enableAnsiWarnings&&e.push("set ansi_warnings off"),!0===this.config.options.enableArithAbort?e.push("set arithabort on"):!1===this.config.options.enableArithAbort&&e.push("set arithabort off"),!0===this.config.options.enableConcatNullYieldsNull?e.push("set concat_null_yields_null on"):!1===this.config.options.enableConcatNullYieldsNull&&e.push("set concat_null_yields_null off"),!0===this.config.options.enableCursorCloseOnCommit?e.push("set cursor_close_on_commit on"):!1===this.config.options.enableCursorCloseOnCommit&&e.push("set cursor_close_on_commit off"),null!==this.config.options.datefirst&&e.push(`set datefirst ${this.config.options.datefirst}`),null!==this.config.options.dateFormat&&e.push(`set dateformat ${this.config.options.dateFormat}`),!0===this.config.options.enableImplicitTransactions?e.push("set implicit_transactions on"):!1===this.config.options.enableImplicitTransactions&&e.push("set implicit_transactions off"),null!==this.config.options.language&&e.push(`set language ${this.config.options.language}`),!0===this.config.options.enableNumericRoundabort?e.push("set numeric_roundabort on"):!1===this.config.options.enableNumericRoundabort&&e.push("set numeric_roundabort off"),!0===this.config.options.enableQuotedIdentifier?e.push("set quoted_identifier on"):!1===this.config.options.enableQuotedIdentifier&&e.push("set quoted_identifier off"),null!==this.config.options.textsize&&e.push(`set textsize ${this.config.options.textsize}`),null!==this.config.options.connectionIsolationLevel&&e.push(`set transaction isolation level ${this.getIsolationLevelText(this.config.options.connectionIsolationLevel)}`),!0===this.config.options.abortTransactionOnError?e.push("set xact_abort on"):!1===this.config.options.abortTransactionOnError&&e.push("set xact_abort off"),e.join("\n")}processedInitialSql(){this.clearConnectTimer(),this.emit("connect")}execSqlBatch(e){this.makeRequest(e,_packet.TYPE.SQL_BATCH,new _sqlbatchPayload.default(e.sqlTextOrProcedure,this.currentTransactionDescriptor(),this.config.options))}execSql(e){try{e.validateParameters(this.databaseCollation)}catch(t){return e.error=t,void process.nextTick((()=>{this.debug.log(t.message),e.callback(t)}))}const t=[];t.push({type:_dataType.TYPES.NVarChar,name:"statement",value:e.sqlTextOrProcedure,output:!1,length:void 0,precision:void 0,scale:void 0}),e.parameters.length&&(t.push({type:_dataType.TYPES.NVarChar,name:"params",value:e.makeParamsParameter(e.parameters),output:!1,length:void 0,precision:void 0,scale:void 0}),t.push(...e.parameters)),this.makeRequest(e,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default(_specialStoredProcedure.default.Sp_ExecuteSql,t,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}newBulkLoad(e,t,o){let i;if(void 0===o?(o=t,i={}):i=t,"object"!=typeof i)throw new TypeError('"options" argument must be an object');return new _bulkLoad.default(e,this.databaseCollation,this.config.options,i,o)}execBulkLoad(e,t){if(e.executionStarted=!0,t){if(e.streamingMode)throw new Error("Connection.execBulkLoad can't be called with a BulkLoad that was put in streaming mode.");if(e.firstRowWritten)throw new Error("Connection.execBulkLoad can't be called with a BulkLoad that already has rows written to it.");const o=_stream.Readable.from(t);o.on("error",(t=>{e.rowToPacketTransform.destroy(t)})),e.rowToPacketTransform.on("error",(e=>{o.destroy(e)})),o.pipe(e.rowToPacketTransform)}else e.streamingMode||e.rowToPacketTransform.end();const o=()=>{n.cancel()},i=new _bulkLoadPayload.BulkLoadPayload(e),n=new _request.default(e.getBulkInsertSql(),(t=>{if(e.removeListener("cancel",o),t)return"UNKNOWN"===t.code&&(t.message+=" This is likely because the schema of the BulkLoad does not match the schema of the table you are attempting to insert into."),e.error=t,void e.callback(t);this.makeRequest(e,_packet.TYPE.BULK_LOAD,i)}));e.once("cancel",o),this.execSqlBatch(n)}prepare(e){const t=[];t.push({type:_dataType.TYPES.Int,name:"handle",value:void 0,output:!0,length:void 0,precision:void 0,scale:void 0}),t.push({type:_dataType.TYPES.NVarChar,name:"params",value:e.parameters.length?e.makeParamsParameter(e.parameters):null,output:!1,length:void 0,precision:void 0,scale:void 0}),t.push({type:_dataType.TYPES.NVarChar,name:"stmt",value:e.sqlTextOrProcedure,output:!1,length:void 0,precision:void 0,scale:void 0}),e.preparing=!0,e.on("returnValue",((t,o)=>{"handle"===t?e.handle=o:e.error=new _errors.RequestError(`Tedious > Unexpected output parameter ${t} from sp_prepare`)})),this.makeRequest(e,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default(_specialStoredProcedure.default.Sp_Prepare,t,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}unprepare(e){const t=[];t.push({type:_dataType.TYPES.Int,name:"handle",value:e.handle,output:!1,length:void 0,precision:void 0,scale:void 0}),this.makeRequest(e,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default(_specialStoredProcedure.default.Sp_Unprepare,t,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}execute(e,t){const o=[];o.push({type:_dataType.TYPES.Int,name:"",value:e.handle,output:!1,length:void 0,precision:void 0,scale:void 0});try{for(let i=0,n=e.parameters.length;i<n;i++){const n=e.parameters[i];o.push({...n,value:n.type.validate(t?t[n.name]:null,this.databaseCollation)})}}catch(t){return e.error=t,void process.nextTick((()=>{this.debug.log(t.message),e.callback(t)}))}this.makeRequest(e,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default(_specialStoredProcedure.default.Sp_Execute,o,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}callProcedure(e){try{e.validateParameters(this.databaseCollation)}catch(t){return e.error=t,void process.nextTick((()=>{this.debug.log(t.message),e.callback(t)}))}this.makeRequest(e,_packet.TYPE.RPC_REQUEST,new _rpcrequestPayload.default(e.sqlTextOrProcedure,e.parameters,this.currentTransactionDescriptor(),this.config.options,this.databaseCollation))}beginTransaction(e,t="",o=this.config.options.isolationLevel){(0,_transaction.assertValidIsolationLevel)(o,"isolationLevel");const i=new _transaction.Transaction(t,o);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("SET TRANSACTION ISOLATION LEVEL "+i.isolationLevelToTSQL()+";BEGIN TRAN "+i.name,(t=>{this.transactionDepth++,1===this.transactionDepth&&(this.inTransaction=!0),e(t)})));const n=new _request.default(void 0,(t=>e(t,this.currentTransactionDescriptor())));return this.makeRequest(n,_packet.TYPE.TRANSACTION_MANAGER,i.beginPayload(this.currentTransactionDescriptor()))}commitTransaction(e,t=""){const o=new _transaction.Transaction(t);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("COMMIT TRAN "+o.name,(t=>{this.transactionDepth--,0===this.transactionDepth&&(this.inTransaction=!1),e(t)})));const i=new _request.default(void 0,e);return this.makeRequest(i,_packet.TYPE.TRANSACTION_MANAGER,o.commitPayload(this.currentTransactionDescriptor()))}rollbackTransaction(e,t=""){const o=new _transaction.Transaction(t);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("ROLLBACK TRAN "+o.name,(t=>{this.transactionDepth--,0===this.transactionDepth&&(this.inTransaction=!1),e(t)})));const i=new _request.default(void 0,e);return this.makeRequest(i,_packet.TYPE.TRANSACTION_MANAGER,o.rollbackPayload(this.currentTransactionDescriptor()))}saveTransaction(e,t){const o=new _transaction.Transaction(t);if(this.config.options.tdsVersion<"7_2")return this.execSqlBatch(new _request.default("SAVE TRAN "+o.name,(t=>{this.transactionDepth++,e(t)})));const i=new _request.default(void 0,e);return this.makeRequest(i,_packet.TYPE.TRANSACTION_MANAGER,o.savePayload(this.currentTransactionDescriptor()))}transaction(e,t){if("function"!=typeof e)throw new TypeError("`cb` must be a function");const o=this.inTransaction,i="_tedious_"+_crypto.default.randomBytes(10).toString("hex"),n=(e,t,...n)=>{e?this.inTransaction&&this.state===this.STATE.LOGGED_IN?this.rollbackTransaction((o=>{t(o||e,...n)}),i):t(e,...n):o?(this.config.options.tdsVersion<"7_2"&&this.transactionDepth--,t(null,...n)):this.commitTransaction((e=>{t(e,...n)}),i)};return o?this.saveTransaction((o=>o?e(o):t?this.execSqlBatch(new _request.default("SET transaction isolation level "+this.getIsolationLevelText(t),(t=>e(t,n)))):e(null,n)),i):this.beginTransaction((t=>t?e(t):e(null,n)),i,t)}makeRequest(e,t,o){if(this.state!==this.STATE.LOGGED_IN){const t="Requests can only be made in the "+this.STATE.LOGGED_IN.name+" state, not the "+this.state.name+" state";this.debug.log(t),e.callback(new _errors.RequestError(t,"EINVALIDSTATE"))}else if(e.canceled)process.nextTick((()=>{e.callback(new _errors.RequestError("Canceled.","ECANCEL"))}));else{t===_packet.TYPE.SQL_BATCH?this.isSqlBatch=!0:this.isSqlBatch=!1,this.request=e,e.connection=this,e.rowCount=0,e.rows=[],e.rst=[];const i=()=>{r.unpipe(n),r.destroy(new _errors.RequestError("Canceled.","ECANCEL")),n.ignore=!0,n.end(),e instanceof _request.default&&e.paused&&e.resume()};e.once("cancel",i),this.createRequestTimer();const n=new _message.default({type:t,resetConnection:this.resetConnectionOnNextRequest});this.messageIo.outgoingMessageStream.write(n),this.transitionTo(this.STATE.SENT_CLIENT_REQUEST),n.once("finish",(()=>{e.removeListener("cancel",i),e.once("cancel",this._cancelAfterRequestSent),this.resetConnectionOnNextRequest=!1,this.debug.payload((function(){return o.toString("  ")}))}));const r=_stream.Readable.from(o);r.once("error",(t=>{r.unpipe(n),e.error??=t,n.ignore=!0,n.end()})),r.pipe(n)}}cancel(){return!!this.request&&(!this.request.canceled&&(this.request.cancel(),!0))}reset(e){const t=new _request.default(this.getInitialSql(),(t=>{this.config.options.tdsVersion<"7_2"&&(this.inTransaction=!1),e(t)}));this.resetConnectionOnNextRequest=!0,this.execSqlBatch(t)}currentTransactionDescriptor(){return this.transactionDescriptors[this.transactionDescriptors.length-1]}getIsolationLevelText(e){switch(e){case _transaction.ISOLATION_LEVEL.READ_UNCOMMITTED:return"read uncommitted";case _transaction.ISOLATION_LEVEL.REPEATABLE_READ:return"repeatable read";case _transaction.ISOLATION_LEVEL.SERIALIZABLE:return"serializable";case _transaction.ISOLATION_LEVEL.SNAPSHOT:return"snapshot";default:return"read committed"}}}function isTransientError(e){return e instanceof AggregateError&&(e=e.errors[0]),e instanceof _errors.ConnectionError&&!!e.isTransient}var _default=exports.default=Connection;module.exports=Connection,Connection.prototype.STATE={INITIALIZED:{name:"Initialized",events:{}},CONNECTING:{name:"Connecting",enter:function(){this.initialiseConnection()},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_PRELOGIN:{name:"SentPrelogin",enter:function(){(async()=>{let e,t=Buffer.alloc(0);try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}for await(const o of e)t=Buffer.concat([t,o]);const o=new _preloginPayload.default(t);if(this.debug.payload((function(){return o.toString("  ")})),1===o.fedAuthRequired&&(this.fedAuthRequired=!0),"strict"!==this.config.options.encrypt&&("ON"===o.encryptionString||"REQ"===o.encryptionString)){if(!this.config.options.encrypt)return this.emit("connect",new _errors.ConnectionError("Server requires encryption, set 'encrypt' config option to true.","EENCRYPT")),this.close();try{this.transitionTo(this.STATE.SENT_TLSSSLNEGOTIATION),await this.messageIo.startTls(this.secureContextOptions,this.config.options.serverName?this.config.options.serverName:this.routingData?.server??this.config.server,this.config.options.trustServerCertificate)}catch(e){return this.socketError(e)}}this.sendLogin7Packet();const{authentication:i}=this.config;switch(i.type){case"token-credential":case"azure-active-directory-password":case"azure-active-directory-msi-vm":case"azure-active-directory-msi-app-service":case"azure-active-directory-service-principal-secret":case"azure-active-directory-default":this.transitionTo(this.STATE.SENT_LOGIN7_WITH_FEDAUTH);break;case"ntlm":this.transitionTo(this.STATE.SENT_LOGIN7_WITH_NTLM);break;default:this.transitionTo(this.STATE.SENT_LOGIN7_WITH_STANDARD_LOGIN)}})().catch((e=>{process.nextTick((()=>{throw e}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},REROUTING:{name:"ReRouting",enter:function(){this.cleanupConnection(CLEANUP_TYPE.REDIRECT)},events:{message:function(){},socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)},reconnect:function(){this.transitionTo(this.STATE.CONNECTING)}}},TRANSIENT_FAILURE_RETRY:{name:"TRANSIENT_FAILURE_RETRY",enter:function(){this.curTransientRetryCount++,this.cleanupConnection(CLEANUP_TYPE.RETRY)},events:{message:function(){},socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)},retry:function(){this.createRetryTimer()}}},SENT_TLSSSLNEGOTIATION:{name:"SentTLSSSLNegotiation",events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_LOGIN7_WITH_STANDARD_LOGIN:{name:"SentLogin7WithStandardLogin",enter:function(){(async()=>{let e;try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}const t=new _handler.Login7TokenHandler(this),o=this.createTokenStreamParser(e,t);await(0,_events.once)(o,"end"),t.loginAckReceived?t.routingData?(this.routingData=t.routingData,this.transitionTo(this.STATE.REROUTING)):this.transitionTo(this.STATE.LOGGED_IN_SENDING_INITIAL_SQL):this.loginError?isTransientError(this.loginError)?(this.debug.log("Initiating retry on transient error"),this.transitionTo(this.STATE.TRANSIENT_FAILURE_RETRY)):(this.emit("connect",this.loginError),this.transitionTo(this.STATE.FINAL)):(this.emit("connect",new _errors.ConnectionError("Login failed.","ELOGIN")),this.transitionTo(this.STATE.FINAL))})().catch((e=>{process.nextTick((()=>{throw e}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_LOGIN7_WITH_NTLM:{name:"SentLogin7WithNTLMLogin",enter:function(){(async()=>{for(;;){let e;try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}const t=new _handler.Login7TokenHandler(this),o=this.createTokenStreamParser(e,t);if(await(0,_events.once)(o,"end"),t.loginAckReceived)return t.routingData?(this.routingData=t.routingData,this.transitionTo(this.STATE.REROUTING)):this.transitionTo(this.STATE.LOGGED_IN_SENDING_INITIAL_SQL);if(!this.ntlmpacket)return this.loginError?isTransientError(this.loginError)?(this.debug.log("Initiating retry on transient error"),this.transitionTo(this.STATE.TRANSIENT_FAILURE_RETRY)):(this.emit("connect",this.loginError),this.transitionTo(this.STATE.FINAL)):(this.emit("connect",new _errors.ConnectionError("Login failed.","ELOGIN")),this.transitionTo(this.STATE.FINAL));{const e=this.config.authentication,t=new _ntlmPayload.default({domain:e.options.domain,userName:e.options.userName,password:e.options.password,ntlmpacket:this.ntlmpacket});this.messageIo.sendMessage(_packet.TYPE.NTLMAUTH_PKT,t.data),this.debug.payload((function(){return t.toString("  ")})),this.ntlmpacket=void 0}}})().catch((e=>{process.nextTick((()=>{throw e}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_LOGIN7_WITH_FEDAUTH:{name:"SentLogin7Withfedauth",enter:function(){(async()=>{let e;try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}const t=new _handler.Login7TokenHandler(this),o=this.createTokenStreamParser(e,t);if(await(0,_events.once)(o,"end"),t.loginAckReceived)return void(t.routingData?(this.routingData=t.routingData,this.transitionTo(this.STATE.REROUTING)):this.transitionTo(this.STATE.LOGGED_IN_SENDING_INITIAL_SQL));const i=t.fedAuthInfoToken;if(i&&i.stsurl&&i.spn){const e=this.config.authentication,t=new _url.URL("/.default",i.spn).toString();let o,n;switch(e.type){case"token-credential":o=e.options.credential;break;case"azure-active-directory-password":o=new _identity.UsernamePasswordCredential(e.options.tenantId??"common",e.options.clientId,e.options.userName,e.options.password);break;case"azure-active-directory-msi-vm":case"azure-active-directory-msi-app-service":const t=e.options.clientId?[e.options.clientId,{}]:[{}];o=new _identity.ManagedIdentityCredential(...t);break;case"azure-active-directory-default":const i=e.options.clientId?{managedIdentityClientId:e.options.clientId}:{};o=new _identity.DefaultAzureCredential(i);break;case"azure-active-directory-service-principal-secret":o=new _identity.ClientSecretCredential(e.options.tenantId,e.options.clientId,e.options.clientSecret)}try{n=await o.getToken(t)}catch(e){return this.loginError=new AggregateError([new _errors.ConnectionError("Security token could not be authenticated or authorized.","EFEDAUTH"),e]),this.emit("connect",this.loginError),void this.transitionTo(this.STATE.FINAL)}if(null===n)return this.loginError=new AggregateError([new _errors.ConnectionError("Security token could not be authenticated or authorized.","EFEDAUTH")]),this.emit("connect",this.loginError),void this.transitionTo(this.STATE.FINAL);this.sendFedAuthTokenMessage(n.token)}else this.loginError?isTransientError(this.loginError)?(this.debug.log("Initiating retry on transient error"),this.transitionTo(this.STATE.TRANSIENT_FAILURE_RETRY)):(this.emit("connect",this.loginError),this.transitionTo(this.STATE.FINAL)):(this.emit("connect",new _errors.ConnectionError("Login failed.","ELOGIN")),this.transitionTo(this.STATE.FINAL))})().catch((e=>{process.nextTick((()=>{throw e}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},LOGGED_IN_SENDING_INITIAL_SQL:{name:"LoggedInSendingInitialSql",enter:function(){(async()=>{let e;this.sendInitialSql();try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}const t=this.createTokenStreamParser(e,new _handler.InitialSqlTokenHandler(this));await(0,_events.once)(t,"end"),this.transitionTo(this.STATE.LOGGED_IN),this.processedInitialSql()})().catch((e=>{process.nextTick((()=>{throw e}))}))},events:{socketError:function(){this.transitionTo(this.STATE.FINAL)},connectTimeout:function(){this.transitionTo(this.STATE.FINAL)}}},LOGGED_IN:{name:"LoggedIn",events:{socketError:function(){this.transitionTo(this.STATE.FINAL)}}},SENT_CLIENT_REQUEST:{name:"SentClientRequest",enter:function(){(async()=>{let e;try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}this.clearRequestTimer();const t=this.createTokenStreamParser(e,new _handler.RequestTokenHandler(this,this.request));if(this.request?.canceled&&this.cancelTimer)return this.transitionTo(this.STATE.SENT_ATTENTION);const o=()=>{t.resume()},i=()=>{t.pause(),this.request?.once("resume",o)};this.request?.on("pause",i),this.request instanceof _request.default&&this.request.paused&&i();const n=()=>{t.removeListener("end",r),this.request instanceof _request.default&&this.request.paused&&this.request.resume(),this.request?.removeListener("pause",i),this.request?.removeListener("resume",o),this.transitionTo(this.STATE.SENT_ATTENTION)},r=()=>{this.request?.removeListener("cancel",this._cancelAfterRequestSent),this.request?.removeListener("cancel",n),this.request?.removeListener("pause",i),this.request?.removeListener("resume",o),this.transitionTo(this.STATE.LOGGED_IN);const e=this.request;this.request=void 0,this.config.options.tdsVersion<"7_2"&&e.error&&this.isSqlBatch&&(this.inTransaction=!1),e.callback(e.error,e.rowCount,e.rows)};t.once("end",r),this.request?.once("cancel",n)})()},exit:function(e){this.clearRequestTimer()},events:{socketError:function(e){const t=this.request;this.request=void 0,this.transitionTo(this.STATE.FINAL),t.callback(e)}}},SENT_ATTENTION:{name:"SentAttention",enter:function(){(async()=>{let e;try{e=await this.messageIo.readMessage()}catch(e){return this.socketError(e)}const t=new _handler.AttentionTokenHandler(this,this.request),o=this.createTokenStreamParser(e,t);if(await(0,_events.once)(o,"end"),t.attentionReceived){this.clearCancelTimer();const e=this.request;this.request=void 0,this.transitionTo(this.STATE.LOGGED_IN),e.error&&e.error instanceof _errors.RequestError&&"ETIMEOUT"===e.error.code?e.callback(e.error):e.callback(new _errors.RequestError("Canceled.","ECANCEL"))}})().catch((e=>{process.nextTick((()=>{throw e}))}))},events:{socketError:function(e){const t=this.request;this.request=void 0,this.transitionTo(this.STATE.FINAL),t.callback(e)}}},FINAL:{name:"Final",enter:function(){this.cleanupConnection(CLEANUP_TYPE.NORMAL)},events:{connectTimeout:function(){},message:function(){},socketError:function(){}}}};