"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0,exports.readCollation=readCollation,exports.readMetadata=readMetadata;var _collation=require("./collation"),_dataType=require("./data-type"),_sprintfJs=require("sprintf-js"),_helpers=require("./token/helpers");function readCollation(e,a){if(a=+a,e.length<a+5)throw new _helpers.NotEnoughDataError(a+5);const t=_collation.Collation.fromBuffer(e.slice(a,a+5));return new _helpers.Result(t,a+5)}function readSchema(e,a){let t,r,s,o;return a=+a,({offset:a,value:t}=(0,_helpers.readUInt8)(e,a)),1!==t?new _helpers.Result(void 0,a):(({offset:a,value:r}=(0,_helpers.readBVarChar)(e,a)),({offset:a,value:s}=(0,_helpers.readBVarChar)(e,a)),({offset:a,value:o}=(0,_helpers.readUsVarChar)(e,a)),new _helpers.Result({dbname:r,owningSchema:s,xmlSchemaCollection:o},a))}function readUDTInfo(e,a){let t,r,s,o,l;return({offset:a,value:t}=(0,_helpers.readUInt16LE)(e,a)),({offset:a,value:r}=(0,_helpers.readBVarChar)(e,a)),({offset:a,value:s}=(0,_helpers.readBVarChar)(e,a)),({offset:a,value:o}=(0,_helpers.readBVarChar)(e,a)),({offset:a,value:l}=(0,_helpers.readUsVarChar)(e,a)),new _helpers.Result({maxByteSize:t,dbname:r,owningSchema:s,typeName:o,assemblyName:l},a)}function readMetadata(e,a,t){let r,s,o;({offset:a,value:r}=(t.tdsVersion<"7_2"?_helpers.readUInt16LE:_helpers.readUInt32LE)(e,a)),({offset:a,value:s}=(0,_helpers.readUInt16LE)(e,a)),({offset:a,value:o}=(0,_helpers.readUInt8)(e,a));const l=_dataType.TYPE[o];if(!l)throw new Error((0,_sprintfJs.sprintf)("Unrecognised data type 0x%02X",o));switch(l.name){case"Null":case"TinyInt":case"SmallInt":case"Int":case"BigInt":case"Real":case"Float":case"SmallMoney":case"Money":case"Bit":case"SmallDateTime":case"DateTime":case"Date":return new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:void 0,dataLength:void 0,schema:void 0,udtInfo:void 0},a);case"IntN":case"FloatN":case"MoneyN":case"BitN":case"UniqueIdentifier":case"DateTimeN":{let t;return({offset:a,value:t}=(0,_helpers.readUInt8)(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:void 0,dataLength:t,schema:void 0,udtInfo:void 0},a)}case"Variant":case"Image":{let t;return({offset:a,value:t}=(0,_helpers.readUInt32LE)(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:void 0,dataLength:t,schema:void 0,udtInfo:void 0},a)}case"VarChar":case"Char":case"NVarChar":case"NChar":{let t,o;return({offset:a,value:t}=(0,_helpers.readUInt16LE)(e,a)),({offset:a,value:o}=readCollation(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:o,precision:void 0,scale:void 0,dataLength:t,schema:void 0,udtInfo:void 0},a)}case"Text":case"NText":{let t,o;return({offset:a,value:t}=(0,_helpers.readUInt32LE)(e,a)),({offset:a,value:o}=readCollation(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:o,precision:void 0,scale:void 0,dataLength:t,schema:void 0,udtInfo:void 0},a)}case"VarBinary":case"Binary":{let t;return({offset:a,value:t}=(0,_helpers.readUInt16LE)(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:void 0,dataLength:t,schema:void 0,udtInfo:void 0},a)}case"Xml":{let t;return({offset:a,value:t}=readSchema(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:void 0,dataLength:void 0,schema:t,udtInfo:void 0},a)}case"Time":case"DateTime2":case"DateTimeOffset":{let t;return({offset:a,value:t}=(0,_helpers.readUInt8)(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:t,dataLength:void 0,schema:void 0,udtInfo:void 0},a)}case"NumericN":case"DecimalN":{let t,o,n;return({offset:a,value:t}=(0,_helpers.readUInt8)(e,a)),({offset:a,value:o}=(0,_helpers.readUInt8)(e,a)),({offset:a,value:n}=(0,_helpers.readUInt8)(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:o,scale:n,dataLength:t,schema:void 0,udtInfo:void 0},a)}case"UDT":{let t;return({offset:a,value:t}=readUDTInfo(e,a)),new _helpers.Result({userType:r,flags:s,type:l,collation:void 0,precision:void 0,scale:void 0,dataLength:void 0,schema:void 0,udtInfo:t},a)}default:throw new Error((0,_sprintfJs.sprintf)("Unrecognised type %s",l.name))}}function metadataParse(e,a,t){(async()=>{for(;;){let r;try{r=readMetadata(e.buffer,e.position,a)}catch(a){if(a instanceof _helpers.NotEnoughDataError){await e.waitForChunk();continue}throw a}return e.position=r.offset,t(r.value)}})()}var _default=exports.default=metadataParse;module.exports=metadataParse,module.exports.readCollation=readCollation,module.exports.readMetadata=readMetadata;