"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.UnexpectedTokenError=exports.TokenHandler=exports.RequestTokenHandler=exports.Login7TokenHandler=exports.InitialSqlTokenHandler=exports.AttentionTokenHandler=void 0;var _request=_interopRequireDefault(require("../request")),_errors=require("../errors");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}class UnexpectedTokenError extends Error{constructor(e,n){super("Unexpected token `"+n.name+"` in `"+e.constructor.name+"`")}}exports.UnexpectedTokenError=UnexpectedTokenError;class TokenHandler{onInfoMessage(e){throw new UnexpectedTokenError(this,e)}onErrorMessage(e){throw new UnexpectedTokenError(this,e)}onSSPI(e){throw new UnexpectedTokenError(this,e)}onDatabaseChange(e){throw new UnexpectedTokenError(this,e)}onLanguageChange(e){throw new UnexpectedTokenError(this,e)}onCharsetChange(e){throw new UnexpectedTokenError(this,e)}onSqlCollationChange(e){throw new UnexpectedTokenError(this,e)}onRoutingChange(e){throw new UnexpectedTokenError(this,e)}onPacketSizeChange(e){throw new UnexpectedTokenError(this,e)}onResetConnection(e){throw new UnexpectedTokenError(this,e)}onBeginTransaction(e){throw new UnexpectedTokenError(this,e)}onCommitTransaction(e){throw new UnexpectedTokenError(this,e)}onRollbackTransaction(e){throw new UnexpectedTokenError(this,e)}onFedAuthInfo(e){throw new UnexpectedTokenError(this,e)}onFeatureExtAck(e){throw new UnexpectedTokenError(this,e)}onLoginAck(e){throw new UnexpectedTokenError(this,e)}onColMetadata(e){throw new UnexpectedTokenError(this,e)}onOrder(e){throw new UnexpectedTokenError(this,e)}onRow(e){throw new UnexpectedTokenError(this,e)}onReturnStatus(e){throw new UnexpectedTokenError(this,e)}onReturnValue(e){throw new UnexpectedTokenError(this,e)}onDoneProc(e){throw new UnexpectedTokenError(this,e)}onDoneInProc(e){throw new UnexpectedTokenError(this,e)}onDone(e){throw new UnexpectedTokenError(this,e)}onDatabaseMirroringPartner(e){throw new UnexpectedTokenError(this,e)}}exports.TokenHandler=TokenHandler;class InitialSqlTokenHandler extends TokenHandler{constructor(e){super(),this.connection=e}onInfoMessage(e){this.connection.emit("infoMessage",e)}onErrorMessage(e){this.connection.emit("errorMessage",e)}onDatabaseChange(e){this.connection.emit("databaseChange",e.newValue)}onLanguageChange(e){this.connection.emit("languageChange",e.newValue)}onCharsetChange(e){this.connection.emit("charsetChange",e.newValue)}onSqlCollationChange(e){this.connection.databaseCollation=e.newValue}onPacketSizeChange(e){this.connection.messageIo.packetSize(e.newValue)}onBeginTransaction(e){this.connection.transactionDescriptors.push(e.newValue),this.connection.inTransaction=!0}onCommitTransaction(e){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1}onRollbackTransaction(e){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1,this.connection.emit("rollbackTransaction")}onColMetadata(e){this.connection.emit("error",new Error("Received 'columnMetadata' when no sqlRequest is in progress")),this.connection.close()}onOrder(e){this.connection.emit("error",new Error("Received 'order' when no sqlRequest is in progress")),this.connection.close()}onRow(e){this.connection.emit("error",new Error("Received 'row' when no sqlRequest is in progress")),this.connection.close()}onReturnStatus(e){}onReturnValue(e){}onDoneProc(e){}onDoneInProc(e){}onDone(e){}onResetConnection(e){this.connection.emit("resetConnection")}}exports.InitialSqlTokenHandler=InitialSqlTokenHandler;class Login7TokenHandler extends TokenHandler{constructor(e){super(),this.loginAckReceived=!1,this.connection=e}onInfoMessage(e){this.connection.emit("infoMessage",e)}onErrorMessage(e){this.connection.emit("errorMessage",e);const n=new _errors.ConnectionError(e.message,"ELOGIN");this.connection.transientErrorLookup.isTransientError(e.number)&&this.connection.curTransientRetryCount!==this.connection.config.options.maxRetriesOnTransientErrors&&(n.isTransient=!0),this.connection.loginError=n}onSSPI(e){e.ntlmpacket&&(this.connection.ntlmpacket=e.ntlmpacket,this.connection.ntlmpacketBuffer=e.ntlmpacketBuffer)}onDatabaseChange(e){this.connection.emit("databaseChange",e.newValue)}onLanguageChange(e){this.connection.emit("languageChange",e.newValue)}onCharsetChange(e){this.connection.emit("charsetChange",e.newValue)}onSqlCollationChange(e){this.connection.databaseCollation=e.newValue}onFedAuthInfo(e){this.fedAuthInfoToken=e}onFeatureExtAck(e){const{authentication:n}=this.connection.config;"azure-active-directory-password"===n.type||"azure-active-directory-access-token"===n.type||"azure-active-directory-msi-vm"===n.type||"azure-active-directory-msi-app-service"===n.type||"azure-active-directory-service-principal-secret"===n.type||"azure-active-directory-default"===n.type?void 0===e.fedAuth?this.connection.loginError=new _errors.ConnectionError("Did not receive Active Directory authentication acknowledgement"):0!==e.fedAuth.length&&(this.connection.loginError=new _errors.ConnectionError(`Active Directory authentication acknowledgment for ${n.type} authentication method includes extra data`)):void 0===e.fedAuth&&void 0===e.utf8Support?this.connection.loginError=new _errors.ConnectionError("Received acknowledgement for unknown feature"):e.fedAuth&&(this.connection.loginError=new _errors.ConnectionError("Did not request Active Directory authentication, but received the acknowledgment"))}onLoginAck(e){e.tdsVersion?e.interface?(this.connection.config.options.tdsVersion=e.tdsVersion,this.loginAckReceived=!0):this.connection.loginError=new _errors.ConnectionError("Server responded with unsupported interface.","EINTERFACENOTSUPP"):this.connection.loginError=new _errors.ConnectionError("Server responded with unknown TDS version.","ETDS")}onRoutingChange(e){const[n]=e.newValue.server.split("\\");this.routingData={server:n,port:e.newValue.port}}onDoneInProc(e){}onDone(e){}onPacketSizeChange(e){this.connection.messageIo.packetSize(e.newValue)}onDatabaseMirroringPartner(e){}}exports.Login7TokenHandler=Login7TokenHandler;class RequestTokenHandler extends TokenHandler{constructor(e,n){super(),this.connection=e,this.request=n,this.errors=[]}onInfoMessage(e){this.connection.emit("infoMessage",e)}onErrorMessage(e){if(this.connection.emit("errorMessage",e),!this.request.canceled){const n=new _errors.RequestError(e.message,"EREQUEST");n.number=e.number,n.state=e.state,n.class=e.class,n.serverName=e.serverName,n.procName=e.procName,n.lineNumber=e.lineNumber,this.errors.push(n),this.request.error=n,this.request instanceof _request.default&&this.errors.length>1&&(this.request.error=new AggregateError(this.errors))}}onDatabaseChange(e){this.connection.emit("databaseChange",e.newValue)}onLanguageChange(e){this.connection.emit("languageChange",e.newValue)}onCharsetChange(e){this.connection.emit("charsetChange",e.newValue)}onSqlCollationChange(e){this.connection.databaseCollation=e.newValue}onPacketSizeChange(e){this.connection.messageIo.packetSize(e.newValue)}onBeginTransaction(e){this.connection.transactionDescriptors.push(e.newValue),this.connection.inTransaction=!0}onCommitTransaction(e){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1}onRollbackTransaction(e){this.connection.transactionDescriptors.length=1,this.connection.inTransaction=!1,this.connection.emit("rollbackTransaction")}onColMetadata(e){if(!this.request.canceled)if(this.connection.config.options.useColumnNames){const n=Object.create(null);for(let o=0,t=e.columns.length;o<t;o++){const t=e.columns[o];null==n[t.colName]&&(n[t.colName]=t)}this.request.emit("columnMetadata",n)}else this.request.emit("columnMetadata",e.columns)}onOrder(e){this.request.canceled||this.request.emit("order",e.orderColumns)}onRow(e){this.request.canceled||(this.connection.config.options.rowCollectionOnRequestCompletion&&this.request.rows.push(e.columns),this.connection.config.options.rowCollectionOnDone&&this.request.rst.push(e.columns),this.request.emit("row",e.columns))}onReturnStatus(e){this.request.canceled||(this.connection.procReturnStatusValue=e.value)}onReturnValue(e){this.request.canceled||this.request.emit("returnValue",e.paramName,e.value,e.metadata)}onDoneProc(e){this.request.canceled||(e.sqlError&&!this.request.error&&(this.request.error=new _errors.RequestError("An unknown error has occurred.","UNKNOWN")),this.request.emit("doneProc",e.rowCount,e.more,this.connection.procReturnStatusValue,this.request.rst),this.connection.procReturnStatusValue=void 0,void 0!==e.rowCount&&(this.request.rowCount+=e.rowCount),this.connection.config.options.rowCollectionOnDone&&(this.request.rst=[]))}onDoneInProc(e){this.request.canceled||(this.request.emit("doneInProc",e.rowCount,e.more,this.request.rst),void 0!==e.rowCount&&(this.request.rowCount+=e.rowCount),this.connection.config.options.rowCollectionOnDone&&(this.request.rst=[]))}onDone(e){this.request.canceled||(e.sqlError&&!this.request.error&&(this.request.error=new _errors.RequestError("An unknown error has occurred.","UNKNOWN")),this.request.emit("done",e.rowCount,e.more,this.request.rst),void 0!==e.rowCount&&(this.request.rowCount+=e.rowCount),this.connection.config.options.rowCollectionOnDone&&(this.request.rst=[]))}onResetConnection(e){this.connection.emit("resetConnection")}}exports.RequestTokenHandler=RequestTokenHandler;class AttentionTokenHandler extends TokenHandler{constructor(e,n){super(),this.connection=e,this.request=n,this.attentionReceived=!1}onDone(e){e.attention&&(this.attentionReceived=!0)}}exports.AttentionTokenHandler=AttentionTokenHandler;