"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _token=require("./token"),_colmetadataTokenParser=_interopRequireDefault(require("./colmetadata-token-parser")),_doneTokenParser=require("./done-token-parser"),_envChangeTokenParser=_interopRequireDefault(require("./env-change-token-parser")),_infoerrorTokenParser=require("./infoerror-token-parser"),_fedauthInfoParser=_interopRequireDefault(require("./fedauth-info-parser")),_featureExtAckParser=_interopRequireDefault(require("./feature-ext-ack-parser")),_loginackTokenParser=_interopRequireDefault(require("./loginack-token-parser")),_orderTokenParser=_interopRequireDefault(require("./order-token-parser")),_returnstatusTokenParser=_interopRequireDefault(require("./returnstatus-token-parser")),_returnvalueTokenParser=_interopRequireDefault(require("./returnvalue-token-parser")),_rowTokenParser=_interopRequireDefault(require("./row-token-parser")),_nbcrowTokenParser=_interopRequireDefault(require("./nbcrow-token-parser")),_sspiTokenParser=_interopRequireDefault(require("./sspi-token-parser")),_helpers=require("./helpers");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}class Parser{debug;colMetadata;options;iterator;buffer;position;static async*parseTokens(e,r,t,o=[]){const n=new Parser(e,r,t);for(n.colMetadata=o;;){try{await n.waitForChunk()}catch(e){if(n.position===n.buffer.length)return;throw e}for(;n.buffer.length>=n.position+1;){const e=n.buffer.readUInt8(n.position);n.position+=1;const r=n.readToken(e);void 0!==r&&(yield r)}}}readToken(e){switch(e){case _token.TYPE.DONE:return this.readDoneToken();case _token.TYPE.DONEPROC:return this.readDoneProcToken();case _token.TYPE.DONEINPROC:return this.readDoneInProcToken();case _token.TYPE.ERROR:return this.readErrorToken();case _token.TYPE.INFO:return this.readInfoToken();case _token.TYPE.ENVCHANGE:return this.readEnvChangeToken();case _token.TYPE.LOGINACK:return this.readLoginAckToken();case _token.TYPE.RETURNSTATUS:return this.readReturnStatusToken();case _token.TYPE.ORDER:return this.readOrderToken();case _token.TYPE.FEDAUTHINFO:return this.readFedAuthInfoToken();case _token.TYPE.SSPI:return this.readSSPIToken();case _token.TYPE.COLMETADATA:return this.readColMetadataToken();case _token.TYPE.RETURNVALUE:return this.readReturnValueToken();case _token.TYPE.ROW:return this.readRowToken();case _token.TYPE.NBCROW:return this.readNbcRowToken();case _token.TYPE.FEATUREEXTACK:return this.readFeatureExtAckToken();default:throw new Error("Unknown type: "+e)}}readFeatureExtAckToken(){let e;try{e=(0,_featureExtAckParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readFeatureExtAckToken()));throw e}return this.position=e.offset,e.value}async readNbcRowToken(){return await(0,_nbcrowTokenParser.default)(this)}async readReturnValueToken(){return await(0,_returnvalueTokenParser.default)(this)}async readColMetadataToken(){const e=await(0,_colmetadataTokenParser.default)(this);return this.colMetadata=e.columns,e}readSSPIToken(){let e;try{e=(0,_sspiTokenParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readSSPIToken()));throw e}return this.position=e.offset,e.value}readFedAuthInfoToken(){let e;try{e=(0,_fedauthInfoParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readFedAuthInfoToken()));throw e}return this.position=e.offset,e.value}readOrderToken(){let e;try{e=(0,_orderTokenParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readOrderToken()));throw e}return this.position=e.offset,e.value}readReturnStatusToken(){let e;try{e=(0,_returnstatusTokenParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readReturnStatusToken()));throw e}return this.position=e.offset,e.value}readLoginAckToken(){let e;try{e=(0,_loginackTokenParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readLoginAckToken()));throw e}return this.position=e.offset,e.value}readEnvChangeToken(){let e;try{e=(0,_envChangeTokenParser.default)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readEnvChangeToken()));throw e}return this.position=e.offset,e.value}readRowToken(){return(0,_rowTokenParser.default)(this)}readInfoToken(){let e;try{e=(0,_infoerrorTokenParser.infoParser)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readInfoToken()));throw e}return this.position=e.offset,e.value}readErrorToken(){let e;try{e=(0,_infoerrorTokenParser.errorParser)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readErrorToken()));throw e}return this.position=e.offset,e.value}readDoneInProcToken(){let e;try{e=(0,_doneTokenParser.doneInProcParser)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readDoneInProcToken()));throw e}return this.position=e.offset,e.value}readDoneProcToken(){let e;try{e=(0,_doneTokenParser.doneProcParser)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readDoneProcToken()));throw e}return this.position=e.offset,e.value}readDoneToken(){let e;try{e=(0,_doneTokenParser.doneParser)(this.buffer,this.position,this.options)}catch(e){if(e instanceof _helpers.NotEnoughDataError)return this.waitForChunk().then((()=>this.readDoneToken()));throw e}return this.position=e.offset,e.value}constructor(e,r,t){this.debug=r,this.colMetadata=[],this.options=t,this.iterator=(e[Symbol.asyncIterator]||e[Symbol.iterator]).call(e),this.buffer=Buffer.alloc(0),this.position=0}async waitForChunk(){const e=await this.iterator.next();if(e.done)throw new Error("unexpected end of data");this.position===this.buffer.length?this.buffer=e.value:this.buffer=Buffer.concat([this.buffer.slice(this.position),e.value]),this.position=0}}var _default=exports.default=Parser;module.exports=Parser;