"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Transaction=exports.OPERATION_TYPE=exports.ISOLATION_LEVEL=void 0,exports.assertValidIsolationLevel=assertValidIsolationLevel,exports.isolationLevelByValue=void 0;var _writableTrackingBuffer=_interopRequireDefault(require("./tracking-buffer/writable-tracking-buffer")),_allHeaders=require("./all-headers");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const OPERATION_TYPE=exports.OPERATION_TYPE={TM_GET_DTC_ADDRESS:0,TM_PROPAGATE_XACT:1,TM_BEGIN_XACT:5,TM_PROMOTE_XACT:6,TM_COMMIT_XACT:7,TM_ROLLBACK_XACT:8,TM_SAVE_XACT:9},ISOLATION_LEVEL=exports.ISOLATION_LEVEL={NO_CHANGE:0,READ_UNCOMMITTED:1,READ_COMMITTED:2,REPEATABLE_READ:3,SERIALIZABLE:4,SNAPSHOT:5},isolationLevelByValue=exports.isolationLevelByValue={};for(const e in ISOLATION_LEVEL){isolationLevelByValue[ISOLATION_LEVEL[e]]=e}function assertValidIsolationLevel(e,t){if("number"!=typeof e)throw new TypeError(`The "${t}" ${t.includes(".")?"property":"argument"} must be of type number. Received type ${typeof e} (${e})`);if(!Number.isInteger(e))throw new RangeError(`The value of "${t}" is out of range. It must be an integer. Received: ${e}`);if(!(e>=0&&e<=5))throw new RangeError(`The value of "${t}" is out of range. It must be >= 0 && <= 5. Received: ${e}`)}class Transaction{constructor(e,t=ISOLATION_LEVEL.NO_CHANGE){this.name=e,this.isolationLevel=t,this.outstandingRequestCount=1}beginPayload(e){const t=new _writableTrackingBuffer.default(100,"ucs2");return(0,_allHeaders.writeToTrackingBuffer)(t,e,this.outstandingRequestCount),t.writeUShort(OPERATION_TYPE.TM_BEGIN_XACT),t.writeUInt8(this.isolationLevel),t.writeUInt8(2*this.name.length),t.writeString(this.name,"ucs2"),{*[Symbol.iterator](){yield t.data},toString:()=>"Begin Transaction: name="+this.name+", isolationLevel="+isolationLevelByValue[this.isolationLevel]}}commitPayload(e){const t=new _writableTrackingBuffer.default(100,"ascii");return(0,_allHeaders.writeToTrackingBuffer)(t,e,this.outstandingRequestCount),t.writeUShort(OPERATION_TYPE.TM_COMMIT_XACT),t.writeUInt8(2*this.name.length),t.writeString(this.name,"ucs2"),t.writeUInt8(0),{*[Symbol.iterator](){yield t.data},toString:()=>"Commit Transaction: name="+this.name}}rollbackPayload(e){const t=new _writableTrackingBuffer.default(100,"ascii");return(0,_allHeaders.writeToTrackingBuffer)(t,e,this.outstandingRequestCount),t.writeUShort(OPERATION_TYPE.TM_ROLLBACK_XACT),t.writeUInt8(2*this.name.length),t.writeString(this.name,"ucs2"),t.writeUInt8(0),{*[Symbol.iterator](){yield t.data},toString:()=>"Rollback Transaction: name="+this.name}}savePayload(e){const t=new _writableTrackingBuffer.default(100,"ascii");return(0,_allHeaders.writeToTrackingBuffer)(t,e,this.outstandingRequestCount),t.writeUShort(OPERATION_TYPE.TM_SAVE_XACT),t.writeUInt8(2*this.name.length),t.writeString(this.name,"ucs2"),{*[Symbol.iterator](){yield t.data},toString:()=>"Save Transaction: name="+this.name}}isolationLevelToTSQL(){switch(this.isolationLevel){case ISOLATION_LEVEL.READ_UNCOMMITTED:return"READ UNCOMMITTED";case ISOLATION_LEVEL.READ_COMMITTED:return"READ COMMITTED";case ISOLATION_LEVEL.REPEATABLE_READ:return"REPEATABLE READ";case ISOLATION_LEVEL.SERIALIZABLE:return"SERIALIZABLE";case ISOLATION_LEVEL.SNAPSHOT:return"SNAPSHOT"}return""}}exports.Transaction=Transaction;