"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.isPLPStream=isPLPStream,exports.readPLPStream=readPLPStream,exports.readValue=readValue;var _metadataParser=require("./metadata-parser"),_dataType=require("./data-type"),_iconvLite=_interopRequireDefault(require("iconv-lite")),_sprintfJs=require("sprintf-js"),_guidParser=require("./guid-parser"),_helpers=require("./token/helpers");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const NULL=65535,MAX=65535,THREE_AND_A_THIRD=3+1/3,MONEY_DIVISOR=1e4,PLP_NULL=0xFFFFFFFFFFFFFFFFn,UNKNOWN_PLP_LEN=0xFFFFFFFFFFFFFFFEn,DEFAULT_ENCODING="utf8";function readTinyInt(e,r){return(0,_helpers.readUInt8)(e,r)}function readSmallInt(e,r){return(0,_helpers.readInt16LE)(e,r)}function readInt(e,r){return(0,_helpers.readInt32LE)(e,r)}function readBigInt(e,r){let t;return({offset:r,value:t}=(0,_helpers.readBigInt64LE)(e,r)),new _helpers.Result(t.toString(),r)}function readReal(e,r){return(0,_helpers.readFloatLE)(e,r)}function readFloat(e,r){return(0,_helpers.readDoubleLE)(e,r)}function readSmallMoney(e,r){let t;return({offset:r,value:t}=(0,_helpers.readInt32LE)(e,r)),new _helpers.Result(t/MONEY_DIVISOR,r)}function readMoney(e,r){let t,a;return({offset:r,value:t}=(0,_helpers.readInt32LE)(e,r)),({offset:r,value:a}=(0,_helpers.readUInt32LE)(e,r)),new _helpers.Result((a+4294967296*t)/MONEY_DIVISOR,r)}function readBit(e,r){let t;return({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),new _helpers.Result(!!t,r)}function readValue(e,r,t,a){switch(t.type.name){case"Null":return new _helpers.Result(null,r);case"TinyInt":return readTinyInt(e,r);case"SmallInt":return readSmallInt(e,r);case"Int":return readInt(e,r);case"BigInt":return readBigInt(e,r);case"IntN":{let t;switch(({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),t){case 0:return new _helpers.Result(null,r);case 1:return readTinyInt(e,r);case 2:return readSmallInt(e,r);case 4:return readInt(e,r);case 8:return readBigInt(e,r);default:throw new Error("Unsupported dataLength "+t+" for IntN")}}case"Real":return readReal(e,r);case"Float":return readFloat(e,r);case"FloatN":{let t;switch(({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),t){case 0:return new _helpers.Result(null,r);case 4:return readReal(e,r);case 8:return readFloat(e,r);default:throw new Error("Unsupported dataLength "+t+" for FloatN")}}case"SmallMoney":return readSmallMoney(e,r);case"Money":return readMoney(e,r);case"MoneyN":{let t;switch(({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),t){case 0:return new _helpers.Result(null,r);case 4:return readSmallMoney(e,r);case 8:return readMoney(e,r);default:throw new Error("Unsupported dataLength "+t+" for MoneyN")}}case"Bit":return readBit(e,r);case"BitN":{let t;switch(({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),t){case 0:return new _helpers.Result(null,r);case 1:return readBit(e,r);default:throw new Error("Unsupported dataLength "+t+" for BitN")}}case"VarChar":case"Char":{const a=t.collation.codepage;let n;return({offset:r,value:n}=(0,_helpers.readUInt16LE)(e,r)),n===NULL?new _helpers.Result(null,r):readChars(e,r,n,a)}case"NVarChar":case"NChar":{let t;return({offset:r,value:t}=(0,_helpers.readUInt16LE)(e,r)),t===NULL?new _helpers.Result(null,r):readNChars(e,r,t)}case"VarBinary":case"Binary":{let t;return({offset:r,value:t}=(0,_helpers.readUInt16LE)(e,r)),t===NULL?new _helpers.Result(null,r):readBinary(e,r,t)}case"Text":{let a,n;return({offset:r,value:a}=(0,_helpers.readUInt8)(e,r)),0===a?new _helpers.Result(null,r):(({offset:r}=readBinary(e,r,a)),({offset:r}=readBinary(e,r,8)),({offset:r,value:n}=(0,_helpers.readUInt32LE)(e,r)),readChars(e,r,n,t.collation.codepage))}case"NText":{let t,a;return({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),0===t?new _helpers.Result(null,r):(({offset:r}=readBinary(e,r,t)),({offset:r}=readBinary(e,r,8)),({offset:r,value:a}=(0,_helpers.readUInt32LE)(e,r)),readNChars(e,r,a))}case"Image":{let t,a;return({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),0===t?new _helpers.Result(null,r):(({offset:r}=readBinary(e,r,t)),({offset:r}=readBinary(e,r,8)),({offset:r,value:a}=(0,_helpers.readUInt32LE)(e,r)),readBinary(e,r,a))}case"SmallDateTime":return readSmallDateTime(e,r,a.useUTC);case"DateTime":return readDateTime(e,r,a.useUTC);case"DateTimeN":{let t;switch(({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),t){case 0:return new _helpers.Result(null,r);case 4:return readSmallDateTime(e,r,a.useUTC);case 8:return readDateTime(e,r,a.useUTC);default:throw new Error("Unsupported dataLength "+t+" for DateTimeN")}}case"Time":{let n;return({offset:r,value:n}=(0,_helpers.readUInt8)(e,r)),0===n?new _helpers.Result(null,r):readTime(e,r,n,t.scale,a.useUTC)}case"Date":{let t;return({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),0===t?new _helpers.Result(null,r):readDate(e,r,a.useUTC)}case"DateTime2":{let n;return({offset:r,value:n}=(0,_helpers.readUInt8)(e,r)),0===n?new _helpers.Result(null,r):readDateTime2(e,r,n,t.scale,a.useUTC)}case"DateTimeOffset":{let a;return({offset:r,value:a}=(0,_helpers.readUInt8)(e,r)),0===a?new _helpers.Result(null,r):readDateTimeOffset(e,r,a,t.scale)}case"NumericN":case"DecimalN":{let a;return({offset:r,value:a}=(0,_helpers.readUInt8)(e,r)),0===a?new _helpers.Result(null,r):readNumeric(e,r,a,t.precision,t.scale)}case"UniqueIdentifier":{let t;switch(({offset:r,value:t}=(0,_helpers.readUInt8)(e,r)),t){case 0:return new _helpers.Result(null,r);case 16:return readUniqueIdentifier(e,r,a);default:throw new Error((0,_sprintfJs.sprintf)("Unsupported guid size %d",t-1))}}case"Variant":{let t;return({offset:r,value:t}=(0,_helpers.readUInt32LE)(e,r)),0===t?new _helpers.Result(null,r):readVariant(e,r,a,t)}default:throw new Error("Invalid type!")}}function isPLPStream(e){switch(e.type.name){case"VarChar":case"NVarChar":case"VarBinary":return e.dataLength===MAX;case"Xml":case"UDT":return!0}}function readUniqueIdentifier(e,r,t){let a;return({value:a,offset:r}=readBinary(e,r,16)),new _helpers.Result(t.lowerCaseGuids?(0,_guidParser.bufferToLowerCaseGuid)(a):(0,_guidParser.bufferToUpperCaseGuid)(a),r)}function readNumeric(e,r,t,a,n){let s,l;if(({offset:r,value:s}=(0,_helpers.readUInt8)(e,r)),s=1===s?1:-1,5===t)({offset:r,value:l}=(0,_helpers.readUInt32LE)(e,r));else if(9===t)({offset:r,value:l}=(0,_helpers.readUNumeric64LE)(e,r));else if(13===t)({offset:r,value:l}=(0,_helpers.readUNumeric96LE)(e,r));else{if(17!==t)throw new Error((0,_sprintfJs.sprintf)("Unsupported numeric dataLength %d",t));({offset:r,value:l}=(0,_helpers.readUNumeric128LE)(e,r))}return new _helpers.Result(l*s/Math.pow(10,n),r)}function readVariant(e,r,t,a){let n;({value:n,offset:r}=(0,_helpers.readUInt8)(e,r));const s=_dataType.TYPE[n];let l;switch(({value:l,offset:r}=(0,_helpers.readUInt8)(e,r)),a=a-l-2,s.name){case"UniqueIdentifier":return readUniqueIdentifier(e,r,t);case"Bit":return readBit(e,r);case"TinyInt":return readTinyInt(e,r);case"SmallInt":return readSmallInt(e,r);case"Int":return readInt(e,r);case"BigInt":return readBigInt(e,r);case"SmallDateTime":return readSmallDateTime(e,r,t.useUTC);case"DateTime":return readDateTime(e,r,t.useUTC);case"Real":return readReal(e,r);case"Float":return readFloat(e,r);case"SmallMoney":return readSmallMoney(e,r);case"Money":return readMoney(e,r);case"Date":return readDate(e,r,t.useUTC);case"Time":{let n;return({value:n,offset:r}=(0,_helpers.readUInt8)(e,r)),readTime(e,r,a,n,t.useUTC)}case"DateTime2":{let n;return({value:n,offset:r}=(0,_helpers.readUInt8)(e,r)),readDateTime2(e,r,a,n,t.useUTC)}case"DateTimeOffset":{let t;return({value:t,offset:r}=(0,_helpers.readUInt8)(e,r)),readDateTimeOffset(e,r,a,t)}case"VarBinary":case"Binary":return({offset:r}=(0,_helpers.readUInt16LE)(e,r)),readBinary(e,r,a);case"NumericN":case"DecimalN":{let t,n;return({value:t,offset:r}=(0,_helpers.readUInt8)(e,r)),({value:n,offset:r}=(0,_helpers.readUInt8)(e,r)),readNumeric(e,r,a,t,n)}case"VarChar":case"Char":{let t;return({offset:r}=(0,_helpers.readUInt16LE)(e,r)),({value:t,offset:r}=(0,_metadataParser.readCollation)(e,r)),readChars(e,r,a,t.codepage)}case"NVarChar":case"NChar":return({offset:r}=(0,_helpers.readUInt16LE)(e,r)),({offset:r}=(0,_metadataParser.readCollation)(e,r)),readNChars(e,r,a);default:throw new Error("Invalid type!")}}function readBinary(e,r,t){if(e.length<r+t)throw new _helpers.NotEnoughDataError(r+t);return new _helpers.Result(e.slice(r,r+t),r+t)}function readChars(e,r,t,a){if(e.length<r+t)throw new _helpers.NotEnoughDataError(r+t);return new _helpers.Result(_iconvLite.default.decode(e.slice(r,r+t),a??DEFAULT_ENCODING),r+t)}function readNChars(e,r,t){if(e.length<r+t)throw new _helpers.NotEnoughDataError(r+t);return new _helpers.Result(e.toString("ucs2",r,r+t),r+t)}async function readPLPStream(e){for(;e.buffer.length<e.position+8;)await e.waitForChunk();const r=e.buffer.readBigUInt64LE(e.position);if(e.position+=8,r===PLP_NULL)return null;const t=[];let a=0;for(;;){for(;e.buffer.length<e.position+4;)await e.waitForChunk();const r=e.buffer.readUInt32LE(e.position);if(e.position+=4,!r)break;for(;e.buffer.length<e.position+r;)await e.waitForChunk();t.push(e.buffer.slice(e.position,e.position+r)),e.position+=r,a+=r}if(r!==UNKNOWN_PLP_LEN&&a!==Number(r))throw new Error("Partially Length-prefixed Bytes unmatched lengths : expected "+r+", but got "+a+" bytes");return t}function readSmallDateTime(e,r,t){let a,n,s;return({offset:r,value:a}=(0,_helpers.readUInt16LE)(e,r)),({offset:r,value:n}=(0,_helpers.readUInt16LE)(e,r)),s=t?new Date(Date.UTC(1900,0,1+a,0,n)):new Date(1900,0,1+a,0,n),new _helpers.Result(s,r)}function readDateTime(e,r,t){let a,n;({offset:r,value:a}=(0,_helpers.readInt32LE)(e,r)),({offset:r,value:n}=(0,_helpers.readInt32LE)(e,r));const s=Math.round(n*THREE_AND_A_THIRD);let l;return l=t?new Date(Date.UTC(1900,0,1+a,0,0,0,s)):new Date(1900,0,1+a,0,0,0,s),new _helpers.Result(l,r)}function readTime(e,r,t,a,n){let s,l;switch(t){case 3:({value:s,offset:r}=(0,_helpers.readUInt24LE)(e,r));break;case 4:({value:s,offset:r}=(0,_helpers.readUInt32LE)(e,r));break;case 5:({value:s,offset:r}=(0,_helpers.readUInt40LE)(e,r));break;default:throw new Error("unreachable")}if(a<7)for(let e=a;e<7;e++)s*=10;return l=n?new Date(Date.UTC(1970,0,1,0,0,0,s/1e4)):new Date(1970,0,1,0,0,0,s/1e4),Object.defineProperty(l,"nanosecondsDelta",{enumerable:!1,value:s%1e4/Math.pow(10,7)}),new _helpers.Result(l,r)}function readDate(e,r,t){let a;return({offset:r,value:a}=(0,_helpers.readUInt24LE)(e,r)),t?new _helpers.Result(new Date(Date.UTC(2e3,0,a-730118)),r):new _helpers.Result(new Date(2e3,0,a-730118),r)}function readDateTime2(e,r,t,a,n){let s,l,u;return({offset:r,value:s}=readTime(e,r,t-3,a,n)),({offset:r,value:l}=(0,_helpers.readUInt24LE)(e,r)),u=n?new Date(Date.UTC(2e3,0,l-730118,0,0,0,+s)):new Date(2e3,0,l-730118,s.getHours(),s.getMinutes(),s.getSeconds(),s.getMilliseconds()),Object.defineProperty(u,"nanosecondsDelta",{enumerable:!1,value:s.nanosecondsDelta}),new _helpers.Result(u,r)}function readDateTimeOffset(e,r,t,a){let n,s;({offset:r,value:n}=readTime(e,r,t-5,a,!0)),({offset:r,value:s}=(0,_helpers.readUInt24LE)(e,r)),({offset:r}=(0,_helpers.readUInt16LE)(e,r));const l=new Date(Date.UTC(2e3,0,s-730118,0,0,0,+n));return Object.defineProperty(l,"nanosecondsDelta",{enumerable:!1,value:n.nanosecondsDelta}),new _helpers.Result(l,r)}module.exports.readValue=readValue,module.exports.isPLPStream=isPLPStream,module.exports.readPLPStream=readPLPStream;