"use strict";const punycode=require("punycode"),tr46=require("tr46"),specialSchemes={ftp:21,file:null,gopher:70,http:80,https:443,ws:80,wss:443},failure=Symbol("failure");function countSymbols(t){return punycode.ucs2.decode(t).length}function at(t,e){const s=t[e];return isNaN(s)?void 0:String.fromCodePoint(s)}function isASCIIDigit(t){return t>=48&&t<=57}function isASCIIAlpha(t){return t>=65&&t<=90||t>=97&&t<=122}function isASCIIAlphanumeric(t){return isASCIIAlpha(t)||isASCIIDigit(t)}function isASCIIHex(t){return isASCIIDigit(t)||t>=65&&t<=70||t>=97&&t<=102}function isSingleDot(t){return"."===t||"%2e"===t.toLowerCase()}function isDoubleDot(t){return".."===(t=t.toLowerCase())||"%2e."===t||".%2e"===t||"%2e%2e"===t}function isWindowsDriveLetterCodePoints(t,e){return isASCIIAlpha(t)&&(58===e||124===e)}function isWindowsDriveLetterString(t){return 2===t.length&&isASCIIAlpha(t.codePointAt(0))&&(":"===t[1]||"|"===t[1])}function isNormalizedWindowsDriveLetterString(t){return 2===t.length&&isASCIIAlpha(t.codePointAt(0))&&":"===t[1]}function containsForbiddenHostCodePoint(t){return-1!==t.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|%|\/|:|\?|@|\[|\\|\]/)}function containsForbiddenHostCodePointExcludingPercent(t){return-1!==t.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|\/|:|\?|@|\[|\\|\]/)}function isSpecialScheme(t){return void 0!==specialSchemes[t]}function isSpecial(t){return isSpecialScheme(t.scheme)}function defaultPort(t){return specialSchemes[t]}function percentEncode(t){let e=t.toString(16).toUpperCase();return 1===e.length&&(e="0"+e),"%"+e}function utf8PercentEncode(t){const e=new Buffer(t);let s="";for(let t=0;t<e.length;++t)s+=percentEncode(e[t]);return s}function utf8PercentDecode(t){const e=new Buffer(t),s=[];for(let t=0;t<e.length;++t)37!==e[t]?s.push(e[t]):37===e[t]&&isASCIIHex(e[t+1])&&isASCIIHex(e[t+2])?(s.push(parseInt(e.slice(t+1,t+3).toString(),16)),t+=2):s.push(e[t]);return new Buffer(s).toString()}function isC0ControlPercentEncode(t){return t<=31||t>126}const extraPathPercentEncodeSet=new Set([32,34,35,60,62,63,96,123,125]);function isPathPercentEncode(t){return isC0ControlPercentEncode(t)||extraPathPercentEncodeSet.has(t)}const extraUserinfoPercentEncodeSet=new Set([47,58,59,61,64,91,92,93,94,124]);function isUserinfoPercentEncode(t){return isPathPercentEncode(t)||extraUserinfoPercentEncodeSet.has(t)}function percentEncodeChar(t,e){const s=String.fromCodePoint(t);return e(t)?utf8PercentEncode(s):s}function parseIPv4Number(t){let e=10;if(t.length>=2&&"0"===t.charAt(0)&&"x"===t.charAt(1).toLowerCase()?(t=t.substring(2),e=16):t.length>=2&&"0"===t.charAt(0)&&(t=t.substring(1),e=8),""===t)return 0;return(10===e?/[^0-9]/:16===e?/[^0-9A-Fa-f]/:/[^0-7]/).test(t)?failure:parseInt(t,e)}function parseIPv4(t){const e=t.split(".");if(""===e[e.length-1]&&e.length>1&&e.pop(),e.length>4)return t;const s=[];for(const r of e){if(""===r)return t;const e=parseIPv4Number(r);if(e===failure)return t;s.push(e)}for(let t=0;t<s.length-1;++t)if(s[t]>255)return failure;if(s[s.length-1]>=Math.pow(256,5-s.length))return failure;let r=s.pop(),i=0;for(const t of s)r+=t*Math.pow(256,3-i),++i;return r}function serializeIPv4(t){let e="",s=t;for(let t=1;t<=4;++t)e=String(s%256)+e,4!==t&&(e="."+e),s=Math.floor(s/256);return e}function parseIPv6(t){const e=[0,0,0,0,0,0,0,0];let s=0,r=null,i=0;if(58===(t=punycode.ucs2.decode(t))[i]){if(58!==t[i+1])return failure;i+=2,++s,r=s}for(;i<t.length;){if(8===s)return failure;if(58===t[i]){if(null!==r)return failure;++i,++s,r=s;continue}let n=0,h=0;for(;h<4&&isASCIIHex(t[i]);)n=16*n+parseInt(at(t,i),16),++i,++h;if(46===t[i]){if(0===h)return failure;if(i-=h,s>6)return failure;let r=0;for(;void 0!==t[i];){let n=null;if(r>0){if(!(46===t[i]&&r<4))return failure;++i}if(!isASCIIDigit(t[i]))return failure;for(;isASCIIDigit(t[i]);){const e=parseInt(at(t,i));if(null===n)n=e;else{if(0===n)return failure;n=10*n+e}if(n>255)return failure;++i}e[s]=256*e[s]+n,++r,2!==r&&4!==r||++s}if(4!==r)return failure;break}if(58===t[i]){if(++i,void 0===t[i])return failure}else if(void 0!==t[i])return failure;e[s]=n,++s}if(null!==r){let t=s-r;for(s=7;0!==s&&t>0;){const i=e[r+t-1];e[r+t-1]=e[s],e[s]=i,--s,--t}}else if(null===r&&8!==s)return failure;return e}function serializeIPv6(t){let e="";const s=findLongestZeroSequence(t).idx;let r=!1;for(let i=0;i<=7;++i)if(!r||0!==t[i])if(r&&(r=!1),s!==i)e+=t[i].toString(16),7!==i&&(e+=":");else{e+=0===i?"::":":",r=!0}return e}function parseHost(t,e){if("["===t[0])return"]"!==t[t.length-1]?failure:parseIPv6(t.substring(1,t.length-1));if(!e)return parseOpaqueHost(t);const s=utf8PercentDecode(t),r=tr46.toASCII(s,!1,tr46.PROCESSING_OPTIONS.NONTRANSITIONAL,!1);if(null===r)return failure;if(containsForbiddenHostCodePoint(r))return failure;const i=parseIPv4(r);return"number"==typeof i||i===failure?i:r}function parseOpaqueHost(t){if(containsForbiddenHostCodePointExcludingPercent(t))return failure;let e="";const s=punycode.ucs2.decode(t);for(let t=0;t<s.length;++t)e+=percentEncodeChar(s[t],isC0ControlPercentEncode);return e}function findLongestZeroSequence(t){let e=null,s=1,r=null,i=0;for(let n=0;n<t.length;++n)0!==t[n]?(i>s&&(e=r,s=i),r=null,i=0):(null===r&&(r=n),++i);return i>s&&(e=r,s=i),{idx:e,len:s}}function serializeHost(t){return"number"==typeof t?serializeIPv4(t):t instanceof Array?"["+serializeIPv6(t)+"]":t}function trimControlChars(t){return t.replace(/^[\u0000-\u001F\u0020]+|[\u0000-\u001F\u0020]+$/g,"")}function trimTabAndNewline(t){return t.replace(/\u0009|\u000A|\u000D/g,"")}function shortenPath(t){const e=t.path;0!==e.length&&("file"===t.scheme&&1===e.length&&isNormalizedWindowsDriveLetter(e[0])||e.pop())}function includesCredentials(t){return""!==t.username||""!==t.password}function cannotHaveAUsernamePasswordPort(t){return null===t.host||""===t.host||t.cannotBeABaseURL||"file"===t.scheme}function isNormalizedWindowsDriveLetter(t){return/^[A-Za-z]:$/.test(t)}function URLStateMachine(t,e,s,r,i){if(this.pointer=0,this.input=t,this.base=e||null,this.encodingOverride=s||"utf-8",this.stateOverride=i,this.url=r,this.failure=!1,this.parseError=!1,!this.url){this.url={scheme:"",username:"",password:"",host:null,port:null,path:[],query:null,fragment:null,cannotBeABaseURL:!1};const t=trimControlChars(this.input);t!==this.input&&(this.parseError=!0),this.input=t}const n=trimTabAndNewline(this.input);for(n!==this.input&&(this.parseError=!0),this.input=n,this.state=i||"scheme start",this.buffer="",this.atFlag=!1,this.arrFlag=!1,this.passwordTokenSeenFlag=!1,this.input=punycode.ucs2.decode(this.input);this.pointer<=this.input.length;++this.pointer){const t=this.input[this.pointer],e=isNaN(t)?void 0:String.fromCodePoint(t),s=this["parse "+this.state](t,e);if(!s)break;if(s===failure){this.failure=!0;break}}}URLStateMachine.prototype["parse scheme start"]=function(t,e){if(isASCIIAlpha(t))this.buffer+=e.toLowerCase(),this.state="scheme";else{if(this.stateOverride)return this.parseError=!0,failure;this.state="no scheme",--this.pointer}return!0},URLStateMachine.prototype["parse scheme"]=function(t,e){if(isASCIIAlphanumeric(t)||43===t||45===t||46===t)this.buffer+=e.toLowerCase();else if(58===t){if(this.stateOverride){if(isSpecial(this.url)&&!isSpecialScheme(this.buffer))return!1;if(!isSpecial(this.url)&&isSpecialScheme(this.buffer))return!1;if((includesCredentials(this.url)||null!==this.url.port)&&"file"===this.buffer)return!1;if("file"===this.url.scheme&&(""===this.url.host||null===this.url.host))return!1}if(this.url.scheme=this.buffer,this.buffer="",this.stateOverride)return!1;"file"===this.url.scheme?(47===this.input[this.pointer+1]&&47===this.input[this.pointer+2]||(this.parseError=!0),this.state="file"):isSpecial(this.url)&&null!==this.base&&this.base.scheme===this.url.scheme?this.state="special relative or authority":isSpecial(this.url)?this.state="special authority slashes":47===this.input[this.pointer+1]?(this.state="path or authority",++this.pointer):(this.url.cannotBeABaseURL=!0,this.url.path.push(""),this.state="cannot-be-a-base-URL path")}else{if(this.stateOverride)return this.parseError=!0,failure;this.buffer="",this.state="no scheme",this.pointer=-1}return!0},URLStateMachine.prototype["parse no scheme"]=function(t){return null===this.base||this.base.cannotBeABaseURL&&35!==t?failure:(this.base.cannotBeABaseURL&&35===t?(this.url.scheme=this.base.scheme,this.url.path=this.base.path.slice(),this.url.query=this.base.query,this.url.fragment="",this.url.cannotBeABaseURL=!0,this.state="fragment"):"file"===this.base.scheme?(this.state="file",--this.pointer):(this.state="relative",--this.pointer),!0)},URLStateMachine.prototype["parse special relative or authority"]=function(t){return 47===t&&47===this.input[this.pointer+1]?(this.state="special authority ignore slashes",++this.pointer):(this.parseError=!0,this.state="relative",--this.pointer),!0},URLStateMachine.prototype["parse path or authority"]=function(t){return 47===t?this.state="authority":(this.state="path",--this.pointer),!0},URLStateMachine.prototype["parse relative"]=function(t){return this.url.scheme=this.base.scheme,isNaN(t)?(this.url.username=this.base.username,this.url.password=this.base.password,this.url.host=this.base.host,this.url.port=this.base.port,this.url.path=this.base.path.slice(),this.url.query=this.base.query):47===t?this.state="relative slash":63===t?(this.url.username=this.base.username,this.url.password=this.base.password,this.url.host=this.base.host,this.url.port=this.base.port,this.url.path=this.base.path.slice(),this.url.query="",this.state="query"):35===t?(this.url.username=this.base.username,this.url.password=this.base.password,this.url.host=this.base.host,this.url.port=this.base.port,this.url.path=this.base.path.slice(),this.url.query=this.base.query,this.url.fragment="",this.state="fragment"):isSpecial(this.url)&&92===t?(this.parseError=!0,this.state="relative slash"):(this.url.username=this.base.username,this.url.password=this.base.password,this.url.host=this.base.host,this.url.port=this.base.port,this.url.path=this.base.path.slice(0,this.base.path.length-1),this.state="path",--this.pointer),!0},URLStateMachine.prototype["parse relative slash"]=function(t){return!isSpecial(this.url)||47!==t&&92!==t?47===t?this.state="authority":(this.url.username=this.base.username,this.url.password=this.base.password,this.url.host=this.base.host,this.url.port=this.base.port,this.state="path",--this.pointer):(92===t&&(this.parseError=!0),this.state="special authority ignore slashes"),!0},URLStateMachine.prototype["parse special authority slashes"]=function(t){return 47===t&&47===this.input[this.pointer+1]?(this.state="special authority ignore slashes",++this.pointer):(this.parseError=!0,this.state="special authority ignore slashes",--this.pointer),!0},URLStateMachine.prototype["parse special authority ignore slashes"]=function(t){return 47!==t&&92!==t?(this.state="authority",--this.pointer):this.parseError=!0,!0},URLStateMachine.prototype["parse authority"]=function(t,e){if(64===t){this.parseError=!0,this.atFlag&&(this.buffer="%40"+this.buffer),this.atFlag=!0;const t=countSymbols(this.buffer);for(let e=0;e<t;++e){const t=this.buffer.codePointAt(e);if(58===t&&!this.passwordTokenSeenFlag){this.passwordTokenSeenFlag=!0;continue}const s=percentEncodeChar(t,isUserinfoPercentEncode);this.passwordTokenSeenFlag?this.url.password+=s:this.url.username+=s}this.buffer=""}else if(isNaN(t)||47===t||63===t||35===t||isSpecial(this.url)&&92===t){if(this.atFlag&&""===this.buffer)return this.parseError=!0,failure;this.pointer-=countSymbols(this.buffer)+1,this.buffer="",this.state="host"}else this.buffer+=e;return!0},URLStateMachine.prototype["parse hostname"]=URLStateMachine.prototype["parse host"]=function(t,e){if(this.stateOverride&&"file"===this.url.scheme)--this.pointer,this.state="file host";else if(58!==t||this.arrFlag)if(isNaN(t)||47===t||63===t||35===t||isSpecial(this.url)&&92===t){if(--this.pointer,isSpecial(this.url)&&""===this.buffer)return this.parseError=!0,failure;if(this.stateOverride&&""===this.buffer&&(includesCredentials(this.url)||null!==this.url.port))return this.parseError=!0,!1;const t=parseHost(this.buffer,isSpecial(this.url));if(t===failure)return failure;if(this.url.host=t,this.buffer="",this.state="path start",this.stateOverride)return!1}else 91===t?this.arrFlag=!0:93===t&&(this.arrFlag=!1),this.buffer+=e;else{if(""===this.buffer)return this.parseError=!0,failure;const t=parseHost(this.buffer,isSpecial(this.url));if(t===failure)return failure;if(this.url.host=t,this.buffer="",this.state="port","hostname"===this.stateOverride)return!1}return!0},URLStateMachine.prototype["parse port"]=function(t,e){if(isASCIIDigit(t))this.buffer+=e;else{if(!(isNaN(t)||47===t||63===t||35===t||isSpecial(this.url)&&92===t||this.stateOverride))return this.parseError=!0,failure;if(""!==this.buffer){const t=parseInt(this.buffer);if(t>Math.pow(2,16)-1)return this.parseError=!0,failure;this.url.port=t===defaultPort(this.url.scheme)?null:t,this.buffer=""}if(this.stateOverride)return!1;this.state="path start",--this.pointer}return!0};const fileOtherwiseCodePoints=new Set([47,92,63,35]);function serializeURL(t,e){let s=t.scheme+":";if(null!==t.host?(s+="//",""===t.username&&""===t.password||(s+=t.username,""!==t.password&&(s+=":"+t.password),s+="@"),s+=serializeHost(t.host),null!==t.port&&(s+=":"+t.port)):null===t.host&&"file"===t.scheme&&(s+="//"),t.cannotBeABaseURL)s+=t.path[0];else for(const e of t.path)s+="/"+e;return null!==t.query&&(s+="?"+t.query),e||null===t.fragment||(s+="#"+t.fragment),s}function serializeOrigin(t){let e=t.scheme+"://";return e+=serializeHost(t.host),null!==t.port&&(e+=":"+t.port),e}URLStateMachine.prototype["parse file"]=function(t){return this.url.scheme="file",47===t||92===t?(92===t&&(this.parseError=!0),this.state="file slash"):null!==this.base&&"file"===this.base.scheme?isNaN(t)?(this.url.host=this.base.host,this.url.path=this.base.path.slice(),this.url.query=this.base.query):63===t?(this.url.host=this.base.host,this.url.path=this.base.path.slice(),this.url.query="",this.state="query"):35===t?(this.url.host=this.base.host,this.url.path=this.base.path.slice(),this.url.query=this.base.query,this.url.fragment="",this.state="fragment"):(this.input.length-this.pointer-1==0||!isWindowsDriveLetterCodePoints(t,this.input[this.pointer+1])||this.input.length-this.pointer-1>=2&&!fileOtherwiseCodePoints.has(this.input[this.pointer+2])?(this.url.host=this.base.host,this.url.path=this.base.path.slice(),shortenPath(this.url)):this.parseError=!0,this.state="path",--this.pointer):(this.state="path",--this.pointer),!0},URLStateMachine.prototype["parse file slash"]=function(t){return 47===t||92===t?(92===t&&(this.parseError=!0),this.state="file host"):(null!==this.base&&"file"===this.base.scheme&&(isNormalizedWindowsDriveLetterString(this.base.path[0])?this.url.path.push(this.base.path[0]):this.url.host=this.base.host),this.state="path",--this.pointer),!0},URLStateMachine.prototype["parse file host"]=function(t,e){if(isNaN(t)||47===t||92===t||63===t||35===t)if(--this.pointer,!this.stateOverride&&isWindowsDriveLetterString(this.buffer))this.parseError=!0,this.state="path";else if(""===this.buffer){if(this.url.host="",this.stateOverride)return!1;this.state="path start"}else{let t=parseHost(this.buffer,isSpecial(this.url));if(t===failure)return failure;if("localhost"===t&&(t=""),this.url.host=t,this.stateOverride)return!1;this.buffer="",this.state="path start"}else this.buffer+=e;return!0},URLStateMachine.prototype["parse path start"]=function(t){return isSpecial(this.url)?(92===t&&(this.parseError=!0),this.state="path",47!==t&&92!==t&&--this.pointer):this.stateOverride||63!==t?this.stateOverride||35!==t?void 0!==t&&(this.state="path",47!==t&&--this.pointer):(this.url.fragment="",this.state="fragment"):(this.url.query="",this.state="query"),!0},URLStateMachine.prototype["parse path"]=function(t){if(isNaN(t)||47===t||isSpecial(this.url)&&92===t||!this.stateOverride&&(63===t||35===t)){if(isSpecial(this.url)&&92===t&&(this.parseError=!0),isDoubleDot(this.buffer)?(shortenPath(this.url),47===t||isSpecial(this.url)&&92===t||this.url.path.push("")):!isSingleDot(this.buffer)||47===t||isSpecial(this.url)&&92===t?isSingleDot(this.buffer)||("file"===this.url.scheme&&0===this.url.path.length&&isWindowsDriveLetterString(this.buffer)&&(""!==this.url.host&&null!==this.url.host&&(this.parseError=!0,this.url.host=""),this.buffer=this.buffer[0]+":"),this.url.path.push(this.buffer)):this.url.path.push(""),this.buffer="","file"===this.url.scheme&&(void 0===t||63===t||35===t))for(;this.url.path.length>1&&""===this.url.path[0];)this.parseError=!0,this.url.path.shift();63===t&&(this.url.query="",this.state="query"),35===t&&(this.url.fragment="",this.state="fragment")}else 37!==t||isASCIIHex(this.input[this.pointer+1])&&isASCIIHex(this.input[this.pointer+2])||(this.parseError=!0),this.buffer+=percentEncodeChar(t,isPathPercentEncode);return!0},URLStateMachine.prototype["parse cannot-be-a-base-URL path"]=function(t){return 63===t?(this.url.query="",this.state="query"):35===t?(this.url.fragment="",this.state="fragment"):(isNaN(t)||37===t||(this.parseError=!0),37!==t||isASCIIHex(this.input[this.pointer+1])&&isASCIIHex(this.input[this.pointer+2])||(this.parseError=!0),isNaN(t)||(this.url.path[0]=this.url.path[0]+percentEncodeChar(t,isC0ControlPercentEncode))),!0},URLStateMachine.prototype["parse query"]=function(t,e){if(isNaN(t)||!this.stateOverride&&35===t){isSpecial(this.url)&&"ws"!==this.url.scheme&&"wss"!==this.url.scheme||(this.encodingOverride="utf-8");const e=new Buffer(this.buffer);for(let t=0;t<e.length;++t)e[t]<33||e[t]>126||34===e[t]||35===e[t]||60===e[t]||62===e[t]?this.url.query+=percentEncode(e[t]):this.url.query+=String.fromCodePoint(e[t]);this.buffer="",35===t&&(this.url.fragment="",this.state="fragment")}else 37!==t||isASCIIHex(this.input[this.pointer+1])&&isASCIIHex(this.input[this.pointer+2])||(this.parseError=!0),this.buffer+=e;return!0},URLStateMachine.prototype["parse fragment"]=function(t){return isNaN(t)||(0===t?this.parseError=!0:(37!==t||isASCIIHex(this.input[this.pointer+1])&&isASCIIHex(this.input[this.pointer+2])||(this.parseError=!0),this.url.fragment+=percentEncodeChar(t,isC0ControlPercentEncode))),!0},module.exports.serializeURL=serializeURL,module.exports.serializeURLOrigin=function(t){switch(t.scheme){case"blob":try{return module.exports.serializeURLOrigin(module.exports.parseURL(t.path[0]))}catch(t){return"null"}case"ftp":case"gopher":case"http":case"https":case"ws":case"wss":return serializeOrigin({scheme:t.scheme,host:t.host,port:t.port});case"file":return"file://";default:return"null"}},module.exports.basicURLParse=function(t,e){void 0===e&&(e={});const s=new URLStateMachine(t,e.baseURL,e.encodingOverride,e.url,e.stateOverride);return s.failure?"failure":s.url},module.exports.setTheUsername=function(t,e){t.username="";const s=punycode.ucs2.decode(e);for(let e=0;e<s.length;++e)t.username+=percentEncodeChar(s[e],isUserinfoPercentEncode)},module.exports.setThePassword=function(t,e){t.password="";const s=punycode.ucs2.decode(e);for(let e=0;e<s.length;++e)t.password+=percentEncodeChar(s[e],isUserinfoPercentEncode)},module.exports.serializeHost=serializeHost,module.exports.cannotHaveAUsernamePasswordPort=cannotHaveAUsernamePasswordPort,module.exports.serializeInteger=function(t){return String(t)},module.exports.parseURL=function(t,e){return void 0===e&&(e={}),module.exports.basicURLParse(t,{baseURL:e.baseURL,encodingOverride:e.encodingOverride})};