import{assertNotStrictEqual}from"./typings/common-types.js";import{isPromise}from"./utils/is-promise.js";import{applyMiddleware,commandMiddlewareFactory}from"./middleware.js";import{parseCommand}from"./parse-command.js";import{isYargsInstance}from"./yargs-factory.js";import{maybeAsyncResult}from"./utils/maybe-async-result.js";import whichModule from"./utils/which-module.js";const DEFAULT_MARKER=/(^\*)|(^\$0)/;export class CommandInstance{constructor(e,t,a,s){this.requireCache=new Set,this.handlers={},this.aliasMap={},this.frozens=[],this.shim=s,this.usage=e,this.globalMiddleware=a,this.validation=t}addDirectory(e,t,a,s){"boolean"!=typeof(s=s||{}).recurse&&(s.recurse=!1),Array.isArray(s.extensions)||(s.extensions=["js"]);const n="function"==typeof s.visit?s.visit:e=>e;s.visit=(e,t,a)=>{const s=n(e,t,a);if(s){if(this.requireCache.has(t))return s;this.requireCache.add(t),this.addHandler(s)}return s},this.shim.requireDirectory({require:t,filename:a},e,s)}addHandler(e,t,a,s,n,i){let r=[];const o=commandMiddlewareFactory(n);if(s=s||(()=>{}),Array.isArray(e))if(isCommandAndAliases(e))[e,...r]=e;else for(const t of e)this.addHandler(t);else{if(isCommandHandlerDefinition(e)){let t=Array.isArray(e.command)||"string"==typeof e.command?e.command:this.moduleName(e);return e.aliases&&(t=[].concat(t).concat(e.aliases)),void this.addHandler(t,this.extractDesc(e),e.builder,e.handler,e.middlewares,e.deprecated)}if(isCommandBuilderDefinition(a))return void this.addHandler([e].concat(r),t,a.builder,a.handler,a.middlewares,a.deprecated)}if("string"==typeof e){const n=parseCommand(e);r=r.map((e=>parseCommand(e).cmd));let d=!1;const l=[n.cmd].concat(r).filter((e=>!DEFAULT_MARKER.test(e)||(d=!0,!1)));0===l.length&&d&&l.push("$0"),d&&(n.cmd=l[0],r=l.slice(1),e=e.replace(DEFAULT_MARKER,n.cmd)),r.forEach((e=>{this.aliasMap[e]=n.cmd})),!1!==t&&this.usage.command(e,t,d,r,i),this.handlers[n.cmd]={original:e,description:t,handler:s,builder:a||{},middlewares:o,deprecated:i,demanded:n.demanded,optional:n.optional},d&&(this.defaultCommand=this.handlers[n.cmd])}}getCommandHandlers(){return this.handlers}getCommands(){return Object.keys(this.handlers).concat(Object.keys(this.aliasMap))}hasDefaultCommand(){return!!this.defaultCommand}runCommand(e,t,a,s,n,i){const r=this.handlers[e]||this.handlers[this.aliasMap[e]]||this.defaultCommand,o=t.getInternalMethods().getContext(),d=o.commands.slice(),l=!e;e&&(o.commands.push(e),o.fullCommands.push(r.original));const c=this.applyBuilderUpdateUsageAndParse(l,r,t,a.aliases,d,s,n,i);return isPromise(c)?c.then((e=>this.applyMiddlewareAndGetResult(l,r,e.innerArgv,o,n,e.aliases,t))):this.applyMiddlewareAndGetResult(l,r,c.innerArgv,o,n,c.aliases,t)}applyBuilderUpdateUsageAndParse(e,t,a,s,n,i,r,o){const d=t.builder;let l=a;if(isCommandBuilderCallback(d)){a.getInternalMethods().getUsageInstance().freeze();const c=d(a.getInternalMethods().reset(s),o);if(isPromise(c))return c.then((s=>(l=isYargsInstance(s)?s:a,this.parseAndUpdateUsage(e,t,l,n,i,r))))}else isCommandBuilderOptionDefinitions(d)&&(a.getInternalMethods().getUsageInstance().freeze(),l=a.getInternalMethods().reset(s),Object.keys(t.builder).forEach((e=>{l.option(e,d[e])})));return this.parseAndUpdateUsage(e,t,l,n,i,r)}parseAndUpdateUsage(e,t,a,s,n,i){e&&a.getInternalMethods().getUsageInstance().unfreeze(!0),this.shouldUpdateUsage(a)&&a.getInternalMethods().getUsageInstance().usage(this.usageFromParentCommandsCommandHandler(s,t),t.description);const r=a.getInternalMethods().runYargsParserAndExecuteCommands(null,void 0,!0,n,i);return isPromise(r)?r.then((e=>({aliases:a.parsed.aliases,innerArgv:e}))):{aliases:a.parsed.aliases,innerArgv:r}}shouldUpdateUsage(e){return!e.getInternalMethods().getUsageInstance().getUsageDisabled()&&0===e.getInternalMethods().getUsageInstance().getUsage().length}usageFromParentCommandsCommandHandler(e,t){const a=DEFAULT_MARKER.test(t.original)?t.original.replace(DEFAULT_MARKER,"").trim():t.original,s=e.filter((e=>!DEFAULT_MARKER.test(e)));return s.push(a),`$0 ${s.join(" ")}`}handleValidationAndGetResult(e,t,a,s,n,i,r,o){if(!i.getInternalMethods().getHasOutput()){const t=i.getInternalMethods().runValidation(n,o,i.parsed.error,e);a=maybeAsyncResult(a,(e=>(t(e),e)))}if(t.handler&&!i.getInternalMethods().getHasOutput()){i.getInternalMethods().setHasOutput();const s=!!i.getOptions().configuration["populate--"];i.getInternalMethods().postProcess(a,s,!1,!1),a=applyMiddleware(a,i,r,!1),a=maybeAsyncResult(a,(e=>{const a=t.handler(e);return isPromise(a)?a.then((()=>e)):e})),e||i.getInternalMethods().getUsageInstance().cacheHelpMessage(),isPromise(a)&&!i.getInternalMethods().hasParseCallback()&&a.catch((e=>{try{i.getInternalMethods().getUsageInstance().fail(null,e)}catch(e){}}))}return e||(s.commands.pop(),s.fullCommands.pop()),a}applyMiddlewareAndGetResult(e,t,a,s,n,i,r){let o={};if(n)return a;r.getInternalMethods().getHasOutput()||(o=this.populatePositionals(t,a,s,r));const d=this.globalMiddleware.getMiddleware().slice(0).concat(t.middlewares),l=applyMiddleware(a,r,d,!0);return isPromise(l)?l.then((a=>this.handleValidationAndGetResult(e,t,a,s,i,r,d,o))):this.handleValidationAndGetResult(e,t,l,s,i,r,d,o)}populatePositionals(e,t,a,s){t._=t._.slice(a.commands.length);const n=e.demanded.slice(0),i=e.optional.slice(0),r={};for(this.validation.positionalCount(n.length,t._.length);n.length;){const e=n.shift();this.populatePositional(e,t,r)}for(;i.length;){const e=i.shift();this.populatePositional(e,t,r)}return t._=a.commands.concat(t._.map((e=>""+e))),this.postProcessPositionals(t,r,this.cmdToParseOptions(e.original),s),r}populatePositional(e,t,a){const s=e.cmd[0];e.variadic?a[s]=t._.splice(0).map(String):t._.length&&(a[s]=[String(t._.shift())])}cmdToParseOptions(e){const t={array:[],default:{},alias:{},demand:{}},a=parseCommand(e);return a.demanded.forEach((e=>{const[a,...s]=e.cmd;e.variadic&&(t.array.push(a),t.default[a]=[]),t.alias[a]=s,t.demand[a]=!0})),a.optional.forEach((e=>{const[a,...s]=e.cmd;e.variadic&&(t.array.push(a),t.default[a]=[]),t.alias[a]=s})),t}postProcessPositionals(e,t,a,s){const n=Object.assign({},s.getOptions());n.default=Object.assign(a.default,n.default);for(const e of Object.keys(a.alias))n.alias[e]=(n.alias[e]||[]).concat(a.alias[e]);n.array=n.array.concat(a.array),n.config={};const i=[];if(Object.keys(t).forEach((e=>{t[e].map((t=>{n.configuration["unknown-options-as-args"]&&(n.key[e]=!0),i.push(`--${e}`),i.push(t)}))})),!i.length)return;const r=Object.assign({},n.configuration,{"populate--":!1}),o=this.shim.Parser.detailed(i,Object.assign({},n,{configuration:r}));if(o.error)s.getInternalMethods().getUsageInstance().fail(o.error.message,o.error);else{const a=Object.keys(t);Object.keys(t).forEach((e=>{a.push(...o.aliases[e])})),Object.keys(o.argv).forEach((n=>{a.includes(n)&&(t[n]||(t[n]=o.argv[n]),!this.isInConfigs(s,n)&&!this.isDefaulted(s,n)&&Object.prototype.hasOwnProperty.call(e,n)&&Object.prototype.hasOwnProperty.call(o.argv,n)&&(Array.isArray(e[n])||Array.isArray(o.argv[n]))?e[n]=[].concat(e[n],o.argv[n]):e[n]=o.argv[n])}))}}isDefaulted(e,t){const{default:a}=e.getOptions();return Object.prototype.hasOwnProperty.call(a,t)||Object.prototype.hasOwnProperty.call(a,this.shim.Parser.camelCase(t))}isInConfigs(e,t){const{configObjects:a}=e.getOptions();return a.some((e=>Object.prototype.hasOwnProperty.call(e,t)))||a.some((e=>Object.prototype.hasOwnProperty.call(e,this.shim.Parser.camelCase(t))))}runDefaultBuilderOn(e){if(!this.defaultCommand)return;if(this.shouldUpdateUsage(e)){const t=DEFAULT_MARKER.test(this.defaultCommand.original)?this.defaultCommand.original:this.defaultCommand.original.replace(/^[^[\]<>]*/,"$0 ");e.getInternalMethods().getUsageInstance().usage(t,this.defaultCommand.description)}const t=this.defaultCommand.builder;if(isCommandBuilderCallback(t))return t(e,!0);isCommandBuilderDefinition(t)||Object.keys(t).forEach((a=>{e.option(a,t[a])}))}moduleName(e){const t=whichModule(e);if(!t)throw new Error(`No command name given for module: ${this.shim.inspect(e)}`);return this.commandFromFilename(t.filename)}commandFromFilename(e){return this.shim.path.basename(e,this.shim.path.extname(e))}extractDesc({describe:e,description:t,desc:a}){for(const s of[e,t,a]){if("string"==typeof s||!1===s)return s;assertNotStrictEqual(s,!0,this.shim)}return!1}freeze(){this.frozens.push({handlers:this.handlers,aliasMap:this.aliasMap,defaultCommand:this.defaultCommand})}unfreeze(){const e=this.frozens.pop();assertNotStrictEqual(e,void 0,this.shim),({handlers:this.handlers,aliasMap:this.aliasMap,defaultCommand:this.defaultCommand}=e)}reset(){return this.handlers={},this.aliasMap={},this.defaultCommand=void 0,this.requireCache=new Set,this}}export function command(e,t,a,s){return new CommandInstance(e,t,a,s)}export function isCommandBuilderDefinition(e){return"object"==typeof e&&!!e.builder&&"function"==typeof e.handler}function isCommandAndAliases(e){return e.every((e=>"string"==typeof e))}export function isCommandBuilderCallback(e){return"function"==typeof e}function isCommandBuilderOptionDefinitions(e){return"object"==typeof e}export function isCommandHandlerDefinition(e){return"object"==typeof e&&!Array.isArray(e)}