import{isCommandBuilderCallback}from"./command.js";import{assertNotStrictEqual}from"./typings/common-types.js";import*as templates from"./completion-templates.js";import{isPromise}from"./utils/is-promise.js";import{parseCommand}from"./parse-command.js";export class Completion{constructor(t,s,e,o){var i,n,l;this.yargs=t,this.usage=s,this.command=e,this.shim=o,this.completionKey="get-yargs-completions",this.aliases=null,this.customCompletionFunction=null,this.indexAfterLastReset=0,this.zshShell=null!==(l=(null===(i=this.shim.getEnv("SHELL"))||void 0===i?void 0:i.includes("zsh"))||(null===(n=this.shim.getEnv("ZSH_NAME"))||void 0===n?void 0:n.includes("zsh")))&&void 0!==l&&l}defaultCompletion(t,s,e,o){const i=this.command.getCommandHandlers();for(let s=0,e=t.length;s<e;++s)if(i[t[s]]&&i[t[s]].builder){const e=i[t[s]].builder;if(isCommandBuilderCallback(e)){this.indexAfterLastReset=s+1;const t=this.yargs.getInternalMethods().reset();return e(t,!0),t.argv}}const n=[];this.commandCompletions(n,t,e),this.optionCompletions(n,t,s,e),this.choicesFromOptionsCompletions(n,t,s,e),this.choicesFromPositionalsCompletions(n,t,s,e),o(null,n)}commandCompletions(t,s,e){const o=this.yargs.getInternalMethods().getContext().commands;e.match(/^-/)||o[o.length-1]===e||this.previousArgHasChoices(s)||this.usage.getCommands().forEach((e=>{const o=parseCommand(e[0]).cmd;if(-1===s.indexOf(o))if(this.zshShell){const s=e[1]||"";t.push(o.replace(/:/g,"\\:")+":"+s)}else t.push(o)}))}optionCompletions(t,s,e,o){if((o.match(/^-/)||""===o&&0===t.length)&&!this.previousArgHasChoices(s)){const e=this.yargs.getOptions(),i=this.yargs.getGroups()[this.usage.getPositionalGroupName()]||[];Object.keys(e.key).forEach((n=>{const l=!!e.configuration["boolean-negation"]&&e.boolean.includes(n);i.includes(n)||e.hiddenOptions.includes(n)||this.argsContainKey(s,n,l)||this.completeOptionKey(n,t,o,l&&!!e.default[n])}))}}choicesFromOptionsCompletions(t,s,e,o){if(this.previousArgHasChoices(s)){const e=this.getPreviousArgChoices(s);e&&e.length>0&&t.push(...e.map((t=>t.replace(/:/g,"\\:"))))}}choicesFromPositionalsCompletions(t,s,e,o){if(""===o&&t.length>0&&this.previousArgHasChoices(s))return;const i=this.yargs.getGroups()[this.usage.getPositionalGroupName()]||[],n=Math.max(this.indexAfterLastReset,this.yargs.getInternalMethods().getContext().commands.length+1),l=i[e._.length-n-1];if(!l)return;const r=this.yargs.getOptions().choices[l]||[];for(const s of r)s.startsWith(o)&&t.push(s.replace(/:/g,"\\:"))}getPreviousArgChoices(t){if(t.length<1)return;let s=t[t.length-1],e="";if(!s.startsWith("-")&&t.length>1&&(e=s,s=t[t.length-2]),!s.startsWith("-"))return;const o=s.replace(/^-+/,""),i=this.yargs.getOptions(),n=[o,...this.yargs.getAliases()[o]||[]];let l;for(const t of n)if(Object.prototype.hasOwnProperty.call(i.key,t)&&Array.isArray(i.choices[t])){l=i.choices[t];break}return l?l.filter((t=>!e||t.startsWith(e))):void 0}previousArgHasChoices(t){const s=this.getPreviousArgChoices(t);return void 0!==s&&s.length>0}argsContainKey(t,s,e){const o=s=>-1!==t.indexOf((/^[^0-9]$/.test(s)?"-":"--")+s);if(o(s))return!0;if(e&&o(`no-${s}`))return!0;if(this.aliases)for(const t of this.aliases[s])if(o(t))return!0;return!1}completeOptionKey(t,s,e,o){var i,n,l,r;let a=t;if(this.zshShell){const s=this.usage.getDescriptions(),e=null===(n=null===(i=null==this?void 0:this.aliases)||void 0===i?void 0:i[t])||void 0===n?void 0:n.find((t=>{const e=s[t];return"string"==typeof e&&e.length>0})),o=e?s[e]:void 0,h=null!==(r=null!==(l=s[t])&&void 0!==l?l:o)&&void 0!==r?r:"";a=`${t.replace(/:/g,"\\:")}:${h.replace("__yargsString__:","").replace(/(\r\n|\n|\r)/gm," ")}`}const h=!/^--/.test(e)&&(t=>/^[^0-9]$/.test(t))(t)?"-":"--";s.push(h+a),o&&s.push(h+"no-"+a)}customCompletion(t,s,e,o){if(assertNotStrictEqual(this.customCompletionFunction,null,this.shim),isSyncCompletionFunction(this.customCompletionFunction)){const t=this.customCompletionFunction(e,s);return isPromise(t)?t.then((t=>{this.shim.process.nextTick((()=>{o(null,t)}))})).catch((t=>{this.shim.process.nextTick((()=>{o(t,void 0)}))})):o(null,t)}return isFallbackCompletionFunction(this.customCompletionFunction)?this.customCompletionFunction(e,s,((i=o)=>this.defaultCompletion(t,s,e,i)),(t=>{o(null,t)})):this.customCompletionFunction(e,s,(t=>{o(null,t)}))}getCompletion(t,s){const e=t.length?t[t.length-1]:"",o=this.yargs.parse(t,!0),i=this.customCompletionFunction?o=>this.customCompletion(t,o,e,s):o=>this.defaultCompletion(t,o,e,s);return isPromise(o)?o.then(i):i(o)}generateCompletionScript(t,s){let e=this.zshShell?templates.completionZshTemplate:templates.completionShTemplate;const o=this.shim.path.basename(t);return t.match(/\.js$/)&&(t=`./${t}`),e=e.replace(/{{app_name}}/g,o),e=e.replace(/{{completion_command}}/g,s),e.replace(/{{app_path}}/g,t)}registerFunction(t){this.customCompletionFunction=t}setParsed(t){this.aliases=t.aliases}}export function completion(t,s,e,o){return new Completion(t,s,e,o)}function isSyncCompletionFunction(t){return t.length<3}function isFallbackCompletionFunction(t){return t.length>3}