import{argsert}from"./argsert.js";import{assertNotStrictEqual}from"./typings/common-types.js";import{levenshtein as distance}from"./utils/levenshtein.js";import{objFilter}from"./utils/obj-filter.js";const specialKeys=["$0","--","_"];export function validation(t,n,e){const o=e.y18n.__,s=e.y18n.__n,i={nonOptionCount:function(e){const o=t.getDemandedCommands(),i=e._.length+(e["--"]?e["--"].length:0)-t.getInternalMethods().getContext().commands.length;o._&&(i<o._.min||i>o._.max)&&(i<o._.min?void 0!==o._.minMsg?n.fail(o._.minMsg?o._.minMsg.replace(/\$0/g,i.toString()).replace(/\$1/,o._.min.toString()):null):n.fail(s("Not enough non-option arguments: got %s, need at least %s","Not enough non-option arguments: got %s, need at least %s",i,i.toString(),o._.min.toString())):i>o._.max&&(void 0!==o._.maxMsg?n.fail(o._.maxMsg?o._.maxMsg.replace(/\$0/g,i.toString()).replace(/\$1/,o._.max.toString()):null):n.fail(s("Too many non-option arguments: got %s, maximum of %s","Too many non-option arguments: got %s, maximum of %s",i,i.toString(),o._.max.toString()))))},positionalCount:function(t,e){e<t&&n.fail(s("Not enough non-option arguments: got %s, need at least %s","Not enough non-option arguments: got %s, need at least %s",e,e+"",t+""))},requiredArguments:function(t,e){let o=null;for(const n of Object.keys(e))Object.prototype.hasOwnProperty.call(t,n)&&void 0!==t[n]||(o=o||{},o[n]=e[n]);if(o){const t=[];for(const n of Object.keys(o)){const e=o[n];e&&t.indexOf(e)<0&&t.push(e)}const e=t.length?`\n${t.join("\n")}`:"";n.fail(s("Missing required argument: %s","Missing required arguments: %s",Object.keys(o).length,Object.keys(o).join(", ")+e))}},unknownArguments:function(e,o,a,r,c=!0){var l;const m=t.getInternalMethods().getCommandInstance().getCommands(),g=[],u=t.getInternalMethods().getContext();if(Object.keys(e).forEach((n=>{specialKeys.includes(n)||Object.prototype.hasOwnProperty.call(a,n)||Object.prototype.hasOwnProperty.call(t.getInternalMethods().getParseContext(),n)||i.isValidAndSomeAliasIsNotNew(n,o)||g.push(n)})),c&&(u.commands.length>0||m.length>0||r)&&e._.slice(u.commands.length).forEach((t=>{m.includes(""+t)||g.push(""+t)})),c){const n=(null===(l=t.getDemandedCommands()._)||void 0===l?void 0:l.max)||0,o=u.commands.length+n;o<e._.length&&e._.slice(o).forEach((t=>{t=String(t),u.commands.includes(t)||g.includes(t)||g.push(t)}))}g.length&&n.fail(s("Unknown argument: %s","Unknown arguments: %s",g.length,g.map((t=>t.trim()?t:`"${t}"`)).join(", ")))},unknownCommands:function(e){const o=t.getInternalMethods().getCommandInstance().getCommands(),i=[],a=t.getInternalMethods().getContext();return(a.commands.length>0||o.length>0)&&e._.slice(a.commands.length).forEach((t=>{o.includes(""+t)||i.push(""+t)})),i.length>0&&(n.fail(s("Unknown command: %s","Unknown commands: %s",i.length,i.join(", "))),!0)},isValidAndSomeAliasIsNotNew:function(n,e){if(!Object.prototype.hasOwnProperty.call(e,n))return!1;const o=t.parsed.newAliases;return[n,...e[n]].some((t=>!Object.prototype.hasOwnProperty.call(o,t)||!o[n]))},limitedChoices:function(e){const s=t.getOptions(),i={};if(!Object.keys(s.choices).length)return;Object.keys(e).forEach((t=>{-1===specialKeys.indexOf(t)&&Object.prototype.hasOwnProperty.call(s.choices,t)&&[].concat(e[t]).forEach((n=>{-1===s.choices[t].indexOf(n)&&void 0!==n&&(i[t]=(i[t]||[]).concat(n))}))}));const a=Object.keys(i);if(!a.length)return;let r=o("Invalid values:");a.forEach((t=>{r+=`\n  ${o("Argument: %s, Given: %s, Choices: %s",t,n.stringifiedValues(i[t]),n.stringifiedValues(s.choices[t]))}`})),n.fail(r)}};let a={};function r(t,n){const e=Number(n);return"number"==typeof(n=isNaN(e)?n:e)?n=t._.length>=n:n.match(/^--no-.+/)?(n=n.match(/^--no-(.+)/)[1],n=!Object.prototype.hasOwnProperty.call(t,n)):n=Object.prototype.hasOwnProperty.call(t,n),n}i.implies=function(n,o){argsert("<string|object> [array|number|string]",[n,o],arguments.length),"object"==typeof n?Object.keys(n).forEach((t=>{i.implies(t,n[t])})):(t.global(n),a[n]||(a[n]=[]),Array.isArray(o)?o.forEach((t=>i.implies(n,t))):(assertNotStrictEqual(o,void 0,e),a[n].push(o)))},i.getImplied=function(){return a},i.implications=function(t){const e=[];if(Object.keys(a).forEach((n=>{const o=n;(a[n]||[]).forEach((n=>{let s=o;const i=n;s=r(t,s),n=r(t,n),s&&!n&&e.push(` ${o} -> ${i}`)}))})),e.length){let t=`${o("Implications failed:")}\n`;e.forEach((n=>{t+=n})),n.fail(t)}};let c={};i.conflicts=function(n,e){argsert("<string|object> [array|string]",[n,e],arguments.length),"object"==typeof n?Object.keys(n).forEach((t=>{i.conflicts(t,n[t])})):(t.global(n),c[n]||(c[n]=[]),Array.isArray(e)?e.forEach((t=>i.conflicts(n,t))):c[n].push(e))},i.getConflicting=()=>c,i.conflicting=function(s){Object.keys(s).forEach((t=>{c[t]&&c[t].forEach((e=>{e&&void 0!==s[t]&&void 0!==s[e]&&n.fail(o("Arguments %s and %s are mutually exclusive",t,e))}))})),t.getInternalMethods().getParserConfiguration()["strip-dashed"]&&Object.keys(c).forEach((t=>{c[t].forEach((i=>{i&&void 0!==s[e.Parser.camelCase(t)]&&void 0!==s[e.Parser.camelCase(i)]&&n.fail(o("Arguments %s and %s are mutually exclusive",t,i))}))}))},i.recommendCommands=function(t,e){e=e.sort(((t,n)=>n.length-t.length));let s=null,i=1/0;for(let n,o=0;void 0!==(n=e[o]);o++){const e=distance(t,n);e<=3&&e<i&&(i=e,s=n)}s&&n.fail(o("Did you mean %s?",s))},i.reset=function(t){return a=objFilter(a,(n=>!t[n])),c=objFilter(c,(n=>!t[n])),i};const l=[];return i.freeze=function(){l.push({implied:a,conflicting:c})},i.unfreeze=function(){const t=l.pop();assertNotStrictEqual(t,void 0,e),({implied:a,conflicting:c}=t)},i}